window.ColonyGame = {
    "meta": {
        "name":                 "My Village",
        "titleTheme":           "#000000",
        "theme":                "#000000",
        "buildVersion":         "0.1.0",
        "releaseCode":          1,
        "tmpDefaultMapType":    "Red Planet",
        "tmpDefaultRace":       "Human",
        "tmpDefaultCiv":        "United Earth",
        "gridSize":             100,
        "mapHeight":            50,
        "mapWidth":             50,
        "newGameMessage":       "new-game-message",
        "betaInfo":             "beta-info",
        "feedbackUrl":          null,
        "communityUrl":         "https://www.ape-apps.com/viewpage.php?p=4",
        "colonistIcon":         "ind-colonist.png",
        "touristIcon":          "ind-tourist.png",
        "unemploymentIcon":     "ind-unemployed.png",
        "medicalIcon":          "ind-medical.png",
        "giftIndicator":        "ind-gift.png",
        "jobsIcon":             "ind-jobs.png",
        "earthIcon":            "earth.png",
        "colonistsEat":         "Food",
        "colonistsDrink":       "Water",
        "constructionTile":     "construction",
        "colonistsHarvest":     "Ore",
        "tenderResource":       "Money",
        "findBuilderIcon":      "ind-construction-2.png",
        "techWindowIcon":       "ind-research.png",
        "centerMapIcon":        "lander.png",
        "transModeIcon":        "ind-trans.png",
        "civicsIcon":           "ind-civic.png",
        "zoomInIcon":           "zoom-in.png",
        "zoomOutIcon":          "zoom-out.png",
        "gameStageResource":    "Atmosphere",
        "transactionCostResource":"Civics",
        "gameStages": [
            { "threshold": 0, "message": null },
            { "threshold": 250000, "message": "stage-1-intro" },
            { "threshold": 1000000, "message": "stage-2-intro" },
            { "threshold": 5000000, "message": "stage-3-intro" },
            { "threshold": 15000000, "message": "stage-4-intro" }
        ],
        "setFpsIndicator":      "ind-fps.png",
        "setPopperIndicator":   "ind-popper.png",
        "keyboardIndicator":    "ind-keyboard.png",
        "sidebarIndicator":     "ind-sidebar.png",
        "baseIndependenceCost": { "resource":"Civics","amount":250000 },
        "defaultMotherland":    "general-united-earth",
        "colonyServerBase":     null",
        "colonyServerApi":      null,
        "colonyServerGameId":   "1",
        "foundingIndicator":    "ind-founding.png",
        "independenceIndicator":"ind-ind.png",
        "charterIndicator":     "ind-charter.png",
        "empireIndicator":      "ind-empire.png",
        "websiteIndicator":     "ind-website.png",
        "referenceLink":        null,
        "renameIndicator":      "ind-rename.png",
        "cloudIndicator":       "ind-cloud.png",
        "mailIndicator":        "ind-mail.png",
        "approvalIndicator":    "ind-approval.png",
        "soundIndicator":       "ind-sound.png",
        "dimensionIndicator":   "ind-dims.png",
        "homelessIndicator":    "ind-homeless.png",
        "housingIndicator":     "brickhouse.png",
        "backIndicator":        "ind-back.png",
        "polLaborInd":          "ind-labor.png",
        "polWorkPolicyInd":     "refinery2.png",
        "polFiredrillInd":      "ind-firedrill.png",
        "podImmigradionInd":    "landingpad.png",
        "wPolLightInd":         "ind-work-light.png",
        "wPolNormalInd":        "ind-labor.png",
        "wPolOTInd":            "ind-work-ot.png",
        "wPolXtremeInd":        "ind-work-xt.png",
        "totalWorkforceInd":    "ind-totalwf.png",
        "indRetired":           "ind-work-light.png",
        "moneyShowerInd":       "ind-moneyshower.png",
        "taxCollectionInd":     "ind-taxcollect.png",
        "ageIndicator":         "ind-cloning.png",
        "privateCharterInd":    "ind-nocharter.png",
        "onlineModeInd":        "ind-onlinemode.png",
        "offlineModeInd":       "ind-noonline.png",
        "resourcesInd":         "ind-resources.png",
        "autosaveInd":          "ind-save.png",
        "compressionInd":       "ind-compression.png",
        "backupOnInd":          "ind-backup-on.png",
        "backupOffInd":         "ind-backup-off.png",
        "rationingInd":         "ind-rations.png",
        "annexInd":             "ind-annex.png",
        "podcastURL":           null,
        "podcastName":          null,
        "fileShareUrlPrefix":   null,
        "nativeClientURL":      null,
        "retirementRequirements": [
            {"resource":"Food","amount":8},
            {"resource":"Water","amount":4},
            {"resource":"Rum","amount":2},
            {"resource":"Cloth","amount":1},
            {"resource":"Toy","amount":1}
        ],
        "annexTileCost": [
            {"resource":"Money","amount":450},
            {"resource":"Civics","amount":200}
        ],
        "showBuildSidebarIcon": "ind-buildmenu.png",
        "fileExtension":        "mcz",
        "backupExtension":      "mcb",
        "socketServer":         "https://www.my-colony.com:2728",
        "lotteryInd":           "ind-lottery.png",
        "rescindInd":           "ind-rescind.png",
        "denounceInd":          "ind-denounce.png",
        "visitInd":             "ind-visitcolony.png",
        "printInd":             "ind-print.png",
        "shortcutInd":          "ind-shortcut.png",
        "pinnedLinkIcon":       "logo_file_type_mcs.preleaseNotesServerng",
        "autobudgetInd":        "ind-autobudget.png",
        "indRRR":               "randium.jpeg",
        "allowConscription":    false,
        "conscriptionOptions":  null,
        "diplomacyIndicator":   "ind-diplomacy.png",
        "embassyCostPerSector": [
            {"resource":"Money","amount":3500},
            {"resource":"Civics","amount":4000}
        ],
        "extraReferenceName": null,
        "extraReferenceUrl": null,
        "extraReferenceIcon": null,
        "extraReferenceDisclaimer": null,
        "graphicsModFileFormat": "mct",
        "bulldozerToolIndicator": "ind-dozer.png",
        "sidebarBackgroundImage": null,
        "moddingCommunityUrl":  "https://www.ape-apps.com/viewpage.php?p=11365",
        "videoTutorialsIndicator": "ind-vidtut.png",
        "videoTutorialSubmissionUrl": "https://www.ape-apps.com/viewpage.php?p=285",
        "indAnimationSetting":  "ind-animation.png",
        "indLightingSetting":   "streetlight.png",
        "indDaynightSetting":   "ind-day-night.png",
        "indParticlesSetting":   "ind-particles.png",
        "releaseNotesServer":   "https://www.my-colony.com/releasenotes/",
        "indChainOn":           "ind-chain-on.png",
        "indChainOff":          "ind-chain-off.png",
        "indShowBuildList":     "ind-showbuildlist.png",
        "indPolicy":            "ind-civic.png",
        "indFlipBuilding":      "ind-rotate.png",
        "indMakeCenter":        "ind-makecenter.png",
        "indExportGoods":       "ind-export.png",
        "indImportGoods":       "ind-import.png",
        "indActivateBld":       "ind-power.png",
        "indDeactivateBld":     "ind-nopower.png",
        "indSell":              "ind-sell.png",
        "indRepair":            "ind-repair.png",
        "indTrade":             "ind-trade.png",
        "indUpgrade":           "ind-upgrade.png",
        "indMove":              "ind-move.png",
        "indHarvest":           "ind-harvest.png",
        "indPark":              "ind-park.png",
        "indDestroy":           "ind-destroy.png",
        "indDestruct":          "ind-destroy.png",
        "indDismiss":           "ind-dismiss.png",
        "indStats":             "ind-stats.png",
        "indDeployLoaded":      "ind-deployloaded.png",
        "customMapExtension":   "mcm",
        "mapEditorStartFlagAsset":"startflag",
        "localSocketPort":      2729,
        "localEventIcon":       "ind-networking.png",
        "onlineChatIcon":       "ind-chat.png",
        "onlineChatPrefix":     "mc-cw-",
        "indLowres":            "ind-lowres.png",
        "indDeport":            "ind-deportations.png",
        "indEducation":         "ind-education.png",
        "indSmallNumbers":      "ind-smallnumbers.png",
        "indStoreLimits":       "warehouse.png",
        "indCloneObject":       "ind-clone.png",
        "tokenScale":           0.4,
        "tokenTileHeight":      32,
        "indCheckbox":          "ind-checkbox.png",
        "subCityExtension":     "mcx"
    },
    "externalLink": {
        "name":                 "Colonial Tycoon",
        "icon":                 "colonial-tycoon-64.png",
        "default":              "http://apps.ape-apps.com/colonial-tycoon/",
        "gplay":                "market://details?id=com.ape.apps.colonial.tycoon",
        "amazon":               "amzn://apps/android?p=com.ape.apps.colonial.tycoon",
        "itunes":               "http://itunes.apple.com/us/app/colonial-tycoon/id1345508571?ls=1",
        "windows":              "https://www.microsoft.com/store/apps/9P9Z8TKVJ27X"
    },
    "videoTutorials": [],
    "messages": {
        "premiumNotice":        "premium-notice"
    },
    "sounds": {
        "defaultSelectSound":   "select",
        "explosion":            "explosion",
        "execution":            "execute",
        "contractBuy":          "snd-drop-coin-1",
        "buildOptionSelect":    "buildselect"
    },
    "soundtrack": [],
    "achievements": {
        "gainIndependence":         0,
        "onlineTrade":              0,
        "hundredColonists":         0,
        "thousandColonists":        0,
        "tenthousandColonists":     0,
        "tenthousandTender":        0,
        "hundredThousandTender":    0,
        "millionTender":            0,
        "thousandTourists":         0
    },
    "mapTypes": [
        {
            "name":         "Earthlike",
            "icon":         "earth.png",
            "description":  "earthlike-planet-desc",
            "groundTile":[
                "ground4",
                "ground4",
                "ground4",
                "ground4",
                "ground4"
            ],
            "terrainFeatures": [
                { "name": "Ore Deposit", "abundance": 30 },
                { "name": "Gold Deposit", "abundance": 14 },
                { "name": "Aluminum Deposit", "abundance": 14 },
                { "name": "Uranium Deposit", "abundance": 8 },
                { "name": "Oil Deposit", "abundance": 10 },
                { "name": "Fir Trees", "abundance": 450 }
            ],
            "difficulty":   "Beginner",
            "startingTechs": ["Forest World Base","Red Planet Base","Advanced Microbiology","Low Gravity Husbandry","Clay Production"],
            "startingResourceModifiers": [
                { "name": "Atmosphere", "modifier": 5000000 },
                { "name": "Ore", "modifier": 7500 },
                { "name": "Money", "modifier": 5000 },
                { "name": "Food", "modifier": 2000 },
                { "name": "Water", "modifier": 2000 }
            ],
            "startingBuildings": [],
            "welcomeOverride": null,
            "weatherEffect": null,
            "colorEffect": null,
            "colorStrength": null,
            "riverTile": "River",
            "explosionDisasters": null,
            "riverPosition": "bottom"
        }],
    "races": [
        {
            "name":         "Human",
            "defaultSprites": [
                ["colonist1"],
                ["colonist1"],
                ["colonist2"],
                ["colonist3"],"Compacted Snow Path",
                ["colonist3"]
            ],
            "touristSprites": [
                ["tourist3"],
                ["tourist3"],
                ["tourist3"],
                ["tourist3"],
                ["tourist3"]
            ],
            "startingTechs": ["Human Base"],
            "description":  "human-description",
            "narcotics":    ["Ant Paste"],
            "raceColor": "#0288D1"
        }
    ],
    "civilizations": [
        {
            "name":                 "United Earth",
            "description":          "ue-description",
            "race":                 "Human",
            "icon":                 "ind-ue.png",
            "startingColonists":    2,
            "startingBuilding":     "Lander",
            "startingVehicles":     ["Rover","Lunar Rover","Forest Rover"],
            "startingTechs":        ["United Earth Base"],
            "welcomeMessage":       "welcome-message",
            "availableMaps":        ["Earthlike","Red Planet","Lunar","Forest World"],
            "serverHomeworld":      "1",
            "startingResourceModifiers": [{ "name": "Wheel", "modifier": 25 }]
        }
    ],
    "tiles": [
        {
            "name":         "ground",
            "image":        "ground.png",
            "tileWidth":    100,
            "canFlip":      false
        }
    ],
    "resources": [
        {
            "name":         "Money",
            "color":        "#8BC34A",
            "max":          null,
            "indicator":    "$",
            "starting":     2500,
            "icon":         "ind-coin.png",
            "basePrice":    0,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        }
    ],
    "petitions": {},
    "utilities": [
        {
            "name":         "Power",
            "color":        "#FFA000",
            "indicator":    "p",
            "icon":         "ind-power.png",
            "isEssential":  false
        }  
    ],
    "occupations": [],
    "demands": [],
    "terrains": [
        {
            "name":             "Water Pool",
            "tile":             ["water1"],
            "provides":         null,
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "water1.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       "water1shore",
            "passableConnectors":["Pavement","Pavement Lit","Grass"],
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null
        }
    ],
    "technology": [
        {
            "name":             "Red Planet Base",
            "description":      "rpbase-desc",
            "icon":             "ind-redplanet.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        }
    ],
    "buildings": [
        {
            "name":             "Lander",
            "tile":             ["lander"],
            "cost":             null,
            "description":      "lander-description",
            "produces":         ["Rover","Lunar Rover","Forest Rover"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wheel","amount":25},{"resource":"Food","amount":50},{"resource":"Water","amount":400},{"resource":"Wood","amount":400},{"resource":"Ore","amount":1200},{"resource":"Regolith","amount":1200},{"resource":"Charcoal","amount":1200}],
            "sellValue":        [{"resource":"Steel","amount":10},{"resource":"Gold","amount":2},{"resource":"Microchip","amount":2},{"resource":"Uranium","amount":1}],
            "sellWarning":      "lander-sell-warning",
            "refines":          [{"input":"Ore","output":"Ore"},{"input":"Water","output":"Water"},{"input":"Regolith","output":"Regolith"},{"input":"Wood","output":"Wood"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":3}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  2,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["United Earth Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "lander.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  [],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    3,
                    "c":    "#FFF3E0",
                    "i":    0.25,
                    "nightonly": false
                }
            ],
            "packsTo":          "Airborne Lander",
            "canBuildOver":     null
        }
    ],
    "vehicles": [
        {
            "name":             "Airborne Lander",
            "cost":             null,
            "tile":             "landerairborne",
            "description":      "lander-description",
            "produces":         null,
            "sellValue":        [{"resource":"Steel","amount":10},{"resource":"Gold","amount":2},{"resource":"Microchip","amount":2},{"resource":"Uranium","amount":1}],
            "sellWarning":      "lander-sell-warning",
            "harvests":         null,
            "capacity":         0,
            "requiresTech":     ["United Earth Base"],
            "requiresStage":    0,
            "indicator":        "ind-airbornelander.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        "Lander",
            "isFlying":         true,
            "vehicleCarryCapacity": 1,
            "colonistCarryCapacity": 0,
            "canRaid":          null
        }
    ],
    "names": {
        "Human": {
            "first": [
                "PlatinumOre",
                "Hayenn",
                "Vyryn",
                "Liam",
                "Noah",
                "Ethan",
                "Lucas",
                "Mason",
                "Oliver",
                "Aiden",
                "Elijah",
                "James",
                "Benjamin",
                "Logan",
                "Jacob",
                "Jackson",
                "Alexander",
                "Michael",
                "Jack",
                "Carter",
                "Luke",
                "Owen",
                "William",
                "Gabriel",
                "Daniel",
                "Henry",
                "Matthew",
                "Wyatt",
                "Sebastian",
                "Caleb",
                "Grayson",
                "Ryan",
                "Isaac",
                "Nathan",
                "Dylan",
                "Levi",
                "Jayden",
                "Jaxon",
                "David",
                "Eli",
                "Andrew",
                "Samuel",
                "Joseph",
                "Emma",
                "Olivia",
                "Ava",
                "Sophia",
                "Isabella",
                "Mia",
                "Charlotte",
                "Harper",
                "Amelia",
                "Abigail",
                "Emily",
                "Madison",
                "Lily",
                "Ella",
                "Avery",
                "Aria",
                "Evelyn",
                "Chloe",
                "Scarlett",
                "Ellie",
                "Riley",
                "Addison",
                "Elizabeth",
                "Aubrey",
                "Layla",
                "Zoey",
                "Grace",
                "Hannah",
                "Mila",
                "Victoria",
                "Brooklyn",
                "Lucy"
            ],
            "last": [
                "Smith",
                "Johnson",
                "Williams",
                "Brown",
                "Jones",
                "Miller",
                "Davis",
                "Garcia",
                "Rodriguez",
                "Wilson",
                "Martinez",
                "Anderson",
                "Taylor",
                "Thomas",
                "Moore",
                "Martin",
                "Jackson",
                "Thompson",
                "White",
                "Lopez",
                "Lee",
                "Harris",
                "Clark",
                "Lewis",
                "Robinson",
                "Walker",
                "Perez",
                "Hall",
                "Young",
                "Allen",
                "Sanchez",
                "Wright",
                "King",
                "Scott",
                "Green",
                "Baker",
                "Adams",
                "Nelson",
                "Hill",
                "Ramirez",
                "Campbell",
                "Mitchell",
                "Roberts",
                "Carter",
                "Evans",
                "Stewart",
                "Flores",
                "Nguyen",
                "Jenkins"
            ]
        }
    }
};
