﻿(function(window, document){
	
	window.webAppCore = new webAppCore();
	
	window.addEventListener("load",function() {
	    notifyURL();
	    resetMenu();
        resetToolbar();
	},false);
	window.addEventListener("unload",function() {
        resetMenu();
        resetToolbar();
        parent.clearTitleOptions();
        parent.setTitleVisible(false);
    },false);
	window.addEventListener("load",setBaseURL,false);

	if('ondeviceorientation' in window) {
        window.addEventListener("deviceorientation",function(e){
            if(orientationListener) {
                orientationListener(event.beta,event.gamma,event.alpha);
            }
        });
    }

	var onChatListener = null;
	var orientationListener = null;
	
	var themeColor = "#5599ee";
	var themeFore = "#ffffff";

	var facebookStatusListener = null;

	var titleOptionListener = null;
    var nativeListListener = null;
    var premiumUpgradedListener = null;

    var tokensApi = "https://tokens.ape-apps.com/api.php";

    var newMenuHolder = {};
    var newToolbarHolder = {};

    var socket;

    var streamSocket;
    var streamSocketConnected = false;
    var pendingStartStream = null;
    var streamDoAudio = false;
    var streamDoCam = false;
    var streamIsActive = false;
    var streamPeers = {};
    var currentStreamChannel = null;
    var streamEventListener = null;
    var currentAVStream = null;
    var masterStream = null;
    var streamCanvas = null;
    var streamContext = null;
    var currentStreamCanvas = null;
    var streamWebcamHold = null;
    var preFilterVideoCanvas = null;
    var preFilterVideoContext = null;
    var theVidReady = false;
    var streamDoGreenScreen = false;
    var greenscreenTolerance = 150;
    var webcamDisplayWidth = 200;
    var doStreamBlackAndWhite = false;
    var doStreamGameboy = false;
    var watchingPeers = [];
    var streamWatchAccounceTimer = 0;
    var skipTick = false;

    var useIceServers = [
        {urls: "stun:stun.stunprotocol.org:3478"},
        {urls: "stun:stun.l.google.com:19302"},
        {urls: "stun:74.125.142.127:19302"},
        {
            urls: "turn:159.203.86.231:3478",
            username: "colonystream",
            credential: "lander"
        }
    ];
	
	function webAppCore() {

	    // Web App Core v3.7.3 Links
        this.supportsStreaming = supportsStreaming;
        this.startStreaming = startStreaming;
        this.stopStreaming = stopStreaming;
        this.setStreamEventListener = setStreamEventListener;
        this.setStreamWebcam = setStreamWebcam;
        this.removeFromArray = removeFromArray;
        this.setStreamWebcamGreenscreen = setStreamWebcamGreenscreen;
        this.setStreamWebcamGrayscale = setStreamWebcamGrayscale;
        this.setStreamWebcamGameboy = setStreamWebcamGameboy;
        this.getStreamOutputData = getStreamOutputData;
        this.getStreamWebcamOutputData = getStreamWebcamOutputData;
        this.setStreamAudio = setStreamAudio;
        this.broadcastExtraStreamData = broadcastExtraStreamData;
        this.getIsStreamActive = getIsStreamActive;

	    // Web App Core v3.7.2 Links
        this.sendKongregateStat = sendKongregateStat;

	    // Web App Core v3.7.1 Links
        this.setChatUsernameSelectedListener = setChatUsernameSelectedListener;
        this.onChatUsernameSelected = onChatUsernameSelected;
        this.stopTTS = stopTTS;
        this.onTTSdone = onTTSdone;
        this.getFriendsList = getFriendsList;
        this.onFriendsListReturn = onFriendsListReturn;
        this.addFriend = addFriend;
        this.onFriendAdded = onFriendAdded;
        this.isSystemThemeDark = isSystemThemeDark;
        this.getSystemAccentColor = getSystemAccentColor;

	    // Web App Core v3.7.0 Links
        this.isChatOpen = isChatOpen;
        this.setChatListener = setChatListener;
        this.onChatMessage = onChatMessage;
        this.sendChatMessage = sendChatMessage;
        this.getRandomToken = getRandomToken;
        this.randomIntFromInterval = randomIntFromInterval;
        this.isOrientationSupported = isOrientationSupported;
        this.setOrientationListener = setOrientationListener;
        this.fileDialogsSupported = fileDialogsSupported;
        this.openFileDialog = openFileDialog;
        this.filesystemFileSave = filesystemFileSave;
        this.notifySaveImportDataDone = notifySaveImportDataDone;
        this.notifySaveAsDone = notifySaveAsDone;
        this.wacSliderCallback = wacSliderCallback;

	    // Web App Core v3.6.3 Links
        this.checkAccountMail = checkAccountMail;
        this.getAccountMessage = getAccountMessage;
        this.sendAccountMessage = sendAccountMessage;
        this.deleteAccountMessage = deleteAccountMessage;
        this.getServerTime = getServerTime;
        this.supportsRawPrinting = supportsRawPrinting;
        this.printRaw = printRaw;
        this.getRawPrinterConfig = getRawPrinterConfig;

	    // Web App Core v3.6.2 Links
        this.setSidebarCategory = setSidebarCategory;
        this.supportsMusicPicker = supportsMusicPicker;
        this.pickSong = pickSong;
        this.stopSong = stopSong;
        this.presentApeLogin = presentApeLogin;
        this.onPickedCustomSong = onPickedCustomSong;
        this.getTokenById = getTokenById;

	    // Web App Core v3.6.1 Links
        this.allowOnline = allowOnline;
        this.supportsTransparency = supportsTransparency;
        this.didRecoverFromCrash = didRecoverFromCrash;

	    // Web App Core v3.6.0 Links
        this.loadChat = loadChat;
        this.closeChat = closeChat;
        this.isRewardedVideoAvailable = isRewardedVideoAvailable;
        this.isApeAppsLoggedIn = isApeAppsLoggedIn;
        this.getApeAppsProfile = getApeAppsProfile;
        this.updateApeAppsAvatar = updateApeAppsAvatar;
        this.setApeAppsStatusListener = setApeAppsStatusListener;
        this.onApeAppsStatusChanged = onApeAppsStatusChanged;
        this.supportsTcpSockets = supportsTcpSockets;
        this.getLocalIp = getLocalIp;
        this.getRemoteIp = getRemoteIp;
        this.createTcpSocket = createTcpSocket;
        this.connectTcpSocket = connectTcpSocket;
        this.scanLocalTcpSockets = scanLocalTcpSockets;
        this.closeTcpSocket = closeTcpSocket;
        this.sendTcpSocketMessage = sendTcpSocketMessage;
        this.setTcpSocketListener = setTcpSocketListener;
        this.showTcpExtensionMessage = showTcpExtensionMessage;
        this.isFlashSupported = isFlashSupported;
        this.isFlashOn = isFlashOn;
        this.setFlash = setFlash;
        this.getApeAppsLoginKeys = getApeAppsLoginKeys;
        this.getPrimaryToken = getPrimaryToken;
        this.getTokens = getTokens;
        this.getCustomToken = getCustomToken;
        this.addToken = addToken;
        this.updateToken = updateToken;
        this.removeToken = removeToken;
        this.setPrimaryToken = setPrimaryToken;
        this.setFullscreenListener = setFullscreenListener;
        this.getIsFullscreen = getIsFullscreen;
        this.toggleFullscreen = toggleFullscreen;
        this.onFullscreen = onFullscreen;
        this.getAppVersion = getAppVersion;
        this.locationSupported = locationSupported;
        this.getCurrentLocation = getCurrentLocation;
        this.setLocationListener = setLocationListener;
        this.showMap = showMap;
        this.centerMap = centerMap;
        this.dropMapPin = dropMapPin;
        this.clearPins = clearPins;
        this.setCirclePosition = setCirclePosition;
        this.isHexColorLight = isHexColorLight;
        this.isCameraSupported = isCameraSupported;
        this.loadCameraPreview = loadCameraPreview;
        this.takePictureFromPreview = takePictureFromPreview;
        this.setCameraFilter = setCameraFilter;
        this.supportsPhotoEditor = supportsPhotoEditor;
        this.editPhoto = editPhoto;
        this.onSocketConnected = onSocketConnected;
        this.onTcpSocketMessage = onTcpSocketMessage;
        this.onPortScanComplete = onPortScanComplete;
        this.onSocketCreated = onSocketCreated;
        this.onLocationBack = onLocationBack;
        this.onLocationIntervalBack = onLocationIntervalBack;
        this.onGotCameraPermission = onGotCameraPermission;
        this.onImageEdited = onImageEdited;
        this.onFileOpened = onFileOpened;
        this.onFileSaveComplete = onFileSaveComplete;

	    // Web App Core v3.5.0 Links
	    this.getWacVersion = getWacVersion;
	    this.playMidi = playMidi;
        this.stopMidi = stopMidi;
        this.midiCallbackListener = midiCallbackListener;
        this.setRelaunchListener = setRelaunchListener;
        this.setMenuPressedListener = setMenuPressedListener;
        this.revieveMenuPress = revieveMenuPress;
        this.supportsShortcut = supportsShortcut;
        this.createShortcut = createShortcut;
        this.supportsRingtone = supportsRingtone;
        this.setRingtone = setRingtone;
        this.playAudio = playAudio;
        this.stopAudio = stopAudio;
        this.audioInstanceCallbackListener = audioInstanceCallbackListener;
        this.playRewardedVideo = playRewardedVideo;
        this.rewardedVideoDone = rewardedVideoDone;
        this.nativeGetBack = nativeGetBack;

	    // Web App Core v3.4.0 Links
        this.showDialog = showDialog;
        this.showSplash = showSplash;
        this.toastBack = toastBack;
        this.socketConnect = socketConnect;
        this.addSocketListener = addSocketListener;
        this.getPlatform = getPlatform;
        this.setTitleSubtitle = setTitleSubtitle;
        this.setPremiumOptionText = setPremiumOptionText;
        this.setBrandingLogo = setBrandingLogo;
        this.fadeTitle = fadeTitle;
        this.socketEmit = socketEmit;
        this.getFacebookLoginStatus = getFacebookLoginStatus;
        this.getFacebookCredentials = getFacebookCredentials;
        this.requestFacebookLogin = requestFacebookLogin;
        this.setFacebookStatusListener = setFacebookStatusListener;
        this.onFacebookStatusChanged = onFacebookStatusChanged;
        this.buildCloudSharePathForFile = buildCloudSharePathForFile;
        this.loadSharedCloudFile = loadSharedCloudFile;

	    // Web App Core v3.3 Links
        this.setTitleVisible = parent.setTitleVisible;
        this.setTitleBackground = parent.setTitleBackground;
        this.setTitleLogo = parent.setTitleLogo;
        this.addTitleOption = parent.addTitleOption;
        this.setTitleOptionListener = setTitleOptionListener
        this.titleOptionSelected = titleOptionSelected;
        this.resetTitle = parent.clearTitleOptions;
        this.presentNativeList = presentNativeList;
        this.nativeListOptionSelected = nativeListOptionSelected;
        this.getIsPremium = getIsPremium;
        this.presentPremium = parent.goPremium;
        this.setOnPremiumListener = setOnPremiumListener;
        this.onPremiumUpgraded = onPremiumUpgraded;
        this.getForResult = getForResult;

		// Web App Core v3.2 Links
		this.setOnImageImportListener = handleImageImportFunction;
		this.importImage = importImage;
		this.sendImage = sendImage;
	
		// Web App Core v3.1 Links
		this.addToolbarOption = addToolbarOption;
		this.executeToolbarFunction = executeToolbarFunction;
		this.clearMenu = resetMenu;
		this.clearToolbar = resetToolbar;
		this.toggleToolbar = toggleToolbar;
		this.setTitle = setTitle;
		this.importFile = importFile;
		this.fileImportComplete = null;
		this.exportFile = exportFile;
		this.sendFile = sendFile;
		this.copyToClipboard = copyToClipboard;
		this.getInterface = getInterface;
		this.isTV = isTV;
		this.printText = printText;
		this.printHTML = printHTML;
		this.changeWorkspace = changeWorkspace;
		this.startApp = startApp;
		this.recieveVariablePackage = recieveVariablePackage;
		this.registerForShake = registerForShake;
		this.checkForLaunchFile = checkForLaunchFile;
		this.getLaunchFileName = getLaunchFileName;
		this.getLaunchFileContent = getLaunchFileContent;
		this.saveLaunchFile = saveLaunchFile;

		this.picImportCallbackHook = doImageCallback;
		
		this.say = doTTS;
			
		this.clearSplash = clearSplash;
		this.showAlert = showAlert;
		this.vibrate = vibrate;
		this.endVibrate = endVibrate;
		this.saveScreenshot = saveScreenshot;
		this.showChoice = showChoice;
		this.showToast = showToast;
		this.playSoundEffect = playSoundEffect;
		this.loopAudio = loopAudio;
		this.stopLoop = stopLoop;
		this.storeVar = storeVar;
		this.getVars = getVars;
		this.loadFeature = parent.fetchFeaturedImage;
		this.goBack = goBack;
		this.navigateTo = navigateTo;
		this.externalURL = externalURL;
		this.getVar = getVar;
		this.getString = getString;
		this.nativeShare = nativeShare;
		this.handleBackFunction = handleBackFunction;
		this.handlePauseFunction = handlePauseFunction;
		this.handleResumeFunction = handleResumeFunction;
		this.toggleMenu = toggleMenu;
		this.addMenuOption = addMenuOption;
		this.inputBox = inputBox;
		this.submitHighScore = submitHighScore;
		this.getHighScoresUsername = getHighScoresUsername;

		this.getDailyTopScore = getDailyTopScore;
		this.getNewsHeadline = parent.getNewsfeed;

		this.setGamepadFunctions = setGamepadFunctions;
		this.handleInput = handleInput;
		this.executeMenuFunction = executeMenuFunction;
		this.showInterstitial = showInterstitial;
		this.logEvent = logEvent;
		this.setTheme = setTheme;
		this.getExternalParm = getExternalParm;
		this.setMenuOpen = setMenuOpen;
		this.postForResult = postForResult;
		this.showAlertWithTitle = showAlertWithTitle;
		this.choice1 = null;
		this.choice2 = null;
		this.colorSelected = null;
		this.pickColor = pickColor;
		this.inputReturn = null;
		this.pendingScoreFunction = null;
		this.getDailyTopScore = getDailyTopScore;
		this.setDailyReadout = setDailyReadout;
		this.showScores = showScores;
		this.showAchievements = showAchievements;
		this.reportAchievement = reportAchievement;
		this.onPause = onPause;
		this.onResume = onResume;
		this.onBack = onBack;
		
		this.recieveGamepadDown = recieveGamepadDown;
		this.recieveGamepadUp = recieveGamepadUp;
		
		this.pauseFunction = null;
		this.resumeFunction = null;
		this.externalParm = null;
		this.backFunction = null;
		
		
		this.fileDeleted = null;
		this.listingLoaded = null;
		this.fileLoaded = null;
		this.fileSaveComplete = null;
		this.resultFunction = null;
		this.fileImported = null;
		this.workspaceChanged = null;
		this.appStarted = null;
		this.varPackage = null;
		this.shakeCallback = null;
		this.launchCheckCallback = null;
		this.launchNameCallback = null;
		this.launchContentCallback = null;
		this.imageImportFunction = null;
		
		this.openFile = openFile;
		this.openListing = openListing;
		this.deleteFile = deleteFile;
		this.saveFile = saveFile;
		
		this.placeholder = placeholder;
	}

	function buildCloudSharePathForFile(filename) {
	    var cloudURL = "share/" + Android.getFacebookLoggedId() + "/" + Android.getApeMarketId() + "/" + encodeURIComponent(filename);
        return cloudURL;
    }

    function loadSharedCloudFile(path,callback) {
        var cloudRequestUrl = "https://cloud.ape-apps.com:2728/" + path;
        dataRequest(cloudRequestUrl,callback,null,false);
    }

	function doImageCallback(data) {
	    tmpImageImportCallback(data);
	}

	var tmpImageImportCallback;

	function sendImage(element) {
        saveScreenshot(element,true);
    }

    function importImage(callback) {
        if(callback) {
            tmpImageImportCallback = callback;
        } else {
            if(imageImportFunction) {
                tmpImageImportCallback = imageImportFunction;
            } else {
                return;
            }
        }

        Android.pickImage();

    }

	function handleImageImportFunction(func) {
        imageImportFunction = func;
    }

	function notifyURL() {
		parent.notifyURL(window.location.href);

		document.body.style.webkitTapHighlightColor = "transparent";

		console.log("notified url");
	}
	
	function closeOrConfirmAlert(button) {
		return parent.closeOrConfirmAlert(button);
	}
	
	function placeholder() {
		//fsdf
	}
	
	var tmpSaveName;
	var tmpSaveContent;

	function openListing(retfun) {
		this.listingLoaded = retfun;
		parent.getFiles();
	}

	function doTTS(text,callback) {
	    if(callback) {
            onTTSCallback = callback;
        } else {
            onTTSCallback = null;
        }

		parent.doTTS(text);
	}
	
	var screenData;
	
	function showAchievements() {
		parent.showAchievements();
	}
	
	function reportAchievement(trophy,increment) {
		parent.reportAchievement(trophy,increment);
	}

	function postForResult(url,data,func) {
		if(func == null) {
		    func = placeholder;
		}

		dataRequest(url,func,data,true);
	}
	
	function setMenuOpen(status) {
		menuOpen = status;
	}
	
	function getExternalParm() {
		return Android.getExternalParameter();
	}
	
	function setTheme(color) {
		parent.setTheme(color);
		themeColor = color;
	}

	function logEvent(category,action,label) {
		parent.logEvent(category,action,label);
	}
	
	function showInterstitial() {
		Android.popInterstitial(false);
	}
	
	var menuNameArray = new Array();
	var menuFunctionArray = new Array();
	var menuTagArray = new Array();
	menuFunctionCount = 0;
	
	function resetMenu() {
		newMenuHolder = {};
		parent.resetCustomMenu();
	}

	var useTagId = 0;
	
	function addMenuOption(name,func,icon,color,tag,subMenu,isAd) {

	    if(!isAd) {
	        isAd = false;

	        if(name == "Colonial Tycoon") {
	            isAd = true;
	        }
	    }

		useTagId++;

		newMenuHolder[useTagId.toString()] = {
            name: name,
            tag: tag,
            func: func
        };

		parent.addMenuOption(name,icon,color,useTagId.toString(),isAd);
	}
	
	function executeMenuFunction(name,tag) {

	    if(newMenuHolder == null || newMenuHolder[tag] == null) {
	        return;
	    }

	    var item = newMenuHolder[tag];

	    console.log(item.func);

	    window[item.func](item.name,item.tag);
	}
	
	function toggleMenu() {
		parent.toggleMenu();
	}
	
	var gamepadDownFunction;
	var gamepadUpFunction;
	var menuOpen = false;
	
	function handleInput(object,downFunction,moveFunction,endFunction) {
		
		if (window.PointerEvent) {
            object.touchAction = "none";
            object.contentZooming = "none";
            object.msTouchAction = "none";
            object.msContentZooming = "none";

            object.style.touchAction = "none";

            object.addEventListener("pointerdown", function (event) {

                event.preventDefault();

                var pointerType = "mouse";
                var pointerId = event.pointerId;

                if (event.pointerType) {
                    pointerType = event.pointerType;
                }

                var pressure = 1;

                if (event.pressure) {
                    pressure = event.pressure;
                }

                if(pointerType == "touch" || pointerType == "mouse") {
                    pressure = 1;
                }

                downFunction(object, pointerId, event.pageX, event.pageY, pointerType, pressure);
                return false;
            },false);

            object.addEventListener("pointermove", function (event) {

                event.preventDefault();

                var pointerType = "mouse";
                var pointerId = event.pointerId;

                if (event.pointerType) {
                    pointerType = event.pointerType;
                }

                var pressure = 1;

                if (event.pressure) {
                    pressure = event.pressure;
                }

                if(pointerType == "touch" || pointerType == "mouse") {
                    pressure = 1;
                }

                moveFunction(object, pointerId, event.pageX, event.pageY, pointerType, pressure);
                return false;
            },false);


            object.addEventListener("pointerout", function (event) {

                event.preventDefault();

                var pointerType = "mouse";
                var pointerId = event.pointerId;

                if (event.pointerType) {
                    pointerType = event.pointerType;
                }

                endFunction(object, pointerId, pointerType);
                return false;
            },false);

            object.addEventListener("pointerup", function (event) {

                event.preventDefault();

                var pointerType = "mouse";
                var pointerId = event.pointerId;

                if (event.pointerType) {
                    pointerType = event.pointerType;
                }

                endFunction(object, pointerId, pointerType);
                return false;
            },false);
        } else {
            object.addEventListener("touchstart",function(event) {
                event.preventDefault();

                for(var i=0;i<event.changedTouches.length;i++) {
                    downFunction(object,event.changedTouches[i].identifier,event.changedTouches[i].pageX,event.changedTouches[i].pageY,"touch");
                }
                return false;
            },false);

            object.addEventListener("touchmove",function(event) {
                event.preventDefault();

                for(var i=0;i<event.changedTouches.length;i++) {
                    moveFunction(object,event.changedTouches[i].identifier,event.changedTouches[i].pageX,event.changedTouches[i].pageY,"touch");
                }

                return false;
            },false);

            object.addEventListener("touchend",function(event) {
                event.preventDefault();

                for(var i=0;i<event.changedTouches.length;i++) {
                    endFunction(object,event.changedTouches[i].identifier,"touch");
                }

                return false;
            },false);

            object.addEventListener("touchleave",function(event) {
                event.preventDefault();

                for(var i=0;i<event.changedTouches.length;i++) {
                    endFunction(object,event.changedTouches[i].identifier,"touch");
                }
                return false;
            },false);

            object.addEventListener("touchcancel",function(event) {
                event.preventDefault();

                for(var i=0;i<event.changedTouches.length;i++) {
                    endFunction(object,event.changedTouches[i].identifier,"touch");
                }
                return false;
            },false);
        }


	}

	function eventCancel(event) {
	    if(!event) {
	        if(window.event) {
	            event = window.event;
	        } else {
	            return false;
	        }
	    }

	    if(event.cancelBubble != null) {
	        event.cancelBubble = true;
	    }

	    if(event.stopPropagation) {
	        event.stopPropagation();
	    }

	    if(event.preventDefault) {
	        event.preventDefault();
	    }

	    if(window.event) {
	        event.returnValue = false;
	    }

	    if(event.cancel != null) {
	        event.cancel = true;
	    }

	    return false;
	}
	
	function setGamepadFunctions(down,up) {
		gamepadDownFunction = down;
		gamepadUpFunction = up;
	}
	
	function recieveGamepadDown(button,id) {
		
		if(!gamepadDownFunction) {
			return;
		}

		gamepadDownFunction(id,button);
	}
	
	function recieveGamepadUp(button,id) {
		
		if(!gamepadUpFunction) {
			return;
		}

		gamepadUpFunction(id,button);
	}
	
	function showScores(mode) {
		parent.toggleScores(mode);
	}


	/*
	function getNewsHeadline(outputDiv) {
		var xmlhttp = new XMLHttpRequest();

		xmlhttp.onreadystatechange=function() {

			if (xmlhttp.readyState==4 && xmlhttp.status==200) {
				var newsfeed = xmlhttp.responseText;
				
				if (newsfeed.indexOf("###") == -1) {
					outputDiv.innerHTML = newsfeed;
				} else {
					var newsParts = new Array();
					newsParts = newsfeed.split("###");
					outputDiv.innerHTML = newsParts[0];
					outputDiv.addEventListener("click",function(event) {
						event.preventDefault();
						externalURL(newsParts[1]);
					},false);
					outputDiv.style.cursor = "pointer";
				}
				
			}
		}
		
		xmlhttp.open("GET","http://www.ape-apps.com/highscores/newsfeed.txt",true);
		xmlhttp.send();
	}
	*/
	
	var dailyOutput = null;
	
	function getDailyTopScore(mode,outputDiv) {
		outputDiv.innerHTML = "";
		dailyOutput = outputDiv;
		parent.getDailyTopScore(mode);
	}
	
	function setDailyReadout(resultReadout) {
		if(dailyOutput) {
			dailyOutput.innerHTML = resultReadout;
		}
	}
	
	function getHighScoresUsername() {
		return parent.getHighScoresUsername();
	}
	
	function setHighScoresUsername() {
		parent.setHighScoresUsername();
	}

	function submitHighScore(modeid,score) {	
		parent.submitHighScore(modeid,score);		
	}
	
	function inputBox(options, func) {

        if (options.message) {

            var isPW = false;

            if(options.password) {
                isPW = true;
            }

            this.inputReturn = options.func;
            Android.inputBox(options.message, options.title, isPW);
        } else {
            this.inputReturn = func;
            Android.inputBox(options,null,false);
        }
    }
	
	function handlePauseFunction(func) {
		pauseFunction = func;
	}
	
	function handleResumeFunction(func) {
		resumeFunction = func;
	}
	
	function handleBackFunction(func) {
		backFunction = func;
	}
	
	function onResume() {
	
		parent.forceCloseMenu();
		
		if(typeof resumeFunction === 'undefined'){
			return "0";
		}
		
		if(!resumeFunction || resumeFunction == null) {
			return "0";
		}
	
		if(resumeFunction) {
			resumeFunction();
		}
	}
	
	function onPause() {
		if(typeof pauseFunction === 'undefined'){
			return "0";
		}
		
		if(!pauseFunction || pauseFunction == null) {
			return "0";
		}
		
		if(pauseFunction) {
			pauseFunction();
		}
	}
	
	function onBack() {
		if(typeof backFunction === 'undefined'){
			return "0";
		}
		
		if(!backFunction || backFunction == null) {
			return "0";
		}
		
		if(backFunction == "0") {
			return "0";
		}
		
		backFunction();
	}
	
	function clearSplash() {
	    console.log("CLEAR SPLASH!");
		parent.clearSplash();
	}
	
	var alertOpen = false;
	
	function showAlert(message) {
		Android.showAlert(message);
	}
	
	function showAlertWithTitle(message,title) {
	    if(!title) {
	        showAlert(message);
	        return;
	    }

		Android.showAlertWithTitle(message,title);
	}
	
	function showToast(options) {

	    if(options == null) {
	        return;
	    }

        this.toastFunction = null;

        if (options.message) {

            var sendMessage = options.message;
            var sendAction = null;
            var sendImage = null;

            if (options.action) {
                this.toastFunction = options.action.func;
                sendAction = { title: options.action.title, callback: parent.toastWacBack };
            }

            if(options.image) {
                sendImage = options.image;
            }

            parent.showToast(sendMessage, sendImage, sendAction);
        } else {
            parent.showToast(options);
        }
    }

    function toastBack() {
        if (this.toastFunction != null) {
            this.toastFunction();
        } else {
            console.log("NO TOAST FUNCTION!");
        }
    }

	var choiceOpen = false;

	function pickColor(retFun,def) {
		this.colorSelected = retFun;
		parent.showColorPicker(def);
	}
	
	function showChoice(message,op1,op2,f1,f2) {
		this.choice1 = f1;
		this.choice2 = f2;
		
		Android.showChoice(message,op1,op2);
	}

	function vibrate(length) {
		parent.vibrate(length);
	}
	
	function endVibrate() {
		parent.endVibrate();
	}

	var shareImageData;
	var shareAppId = 0;

	function saveScreenshot(element,send) {
		if(!send) {
            send = false;
        }

		if(!element) {
            element = document.body;
        }

        if(element.nodeName.toLowerCase() == "canvas") {
            parent.processScreenshot(element,send);
            return;
        }

        if (typeof html2canvas !== "undefined") {
            html2canvas(element, {
                removeContainer: false
            }).then(function(canvas) {
                parent.processScreenshot(canvas,send);
            });
        } else {
            var htc = document.createElement("script");
            htc.src = "../js/html2canvas.min.js";
            htc.type = "text/javascript";

            htc.onload = function () {

                html2canvas(element, {
                    removeContainer: false
                }).then(function(canvas) {
                    parent.processScreenshot(canvas,send);
                });
            };
            document.getElementsByTagName("head")[0].appendChild(htc);

        }
	}
	
	function playSoundEffect(soundName,volume) {

	    if(volume === undefined) {
	        volume = 1;
	    } else {
	        if(volume > 1) {
	            volume = volume / 100;
	        }
	    }

		Android.playSoundClip(soundName,volume);
		//parent.playAudio(soundName);
	}

	function loopAudio(soundName) {
		Android.loopAudio(soundName);
		//parent.loopAudio(soundName);
	}
	
	function stopLoop() {
		Android.stopLoop();
		//parent.killLoop();
	}
	
	function storeVar(varName,varValue) {
		if(!this.varPackage) {
			this.varPackage = new Object();
		}
		
		this.varPackage[varName] = varValue;

		parent.updateVarPackage(this.varPackage);
	}
	
	function getVars(varArray,backFunction) {
	
		for(var i=0;i<varArray.length;i++) {
			window[varArray[i]] = getVar(varArray[i]);
		}
		
		backFunction();
	}

	function goBack() {
		window.history.back();
	}
	
	function navigateTo(page) {
		window.location = pageBaseURL + page;
		return false;
	}
	
	function externalURL(url) {
		parent.loadURL(url);
	}
	
	function getVar(key,def) {
		
		var retValue = "0";
		
		if(def) {
			retValue = def;
		}
		
		if(this.varPackage && this.varPackage[key]) {
			retValue = this.varPackage[key];
		}
		
		return retValue;
	}
	
	function nativeShare(value) {
		parent.toggleShareBox(value);
	}
	
	function getString(key) {
		if(!appStrings) {
            return null;
        }

        var language = Android.getLanguageCode();

        if(!language) {
            language = "en";
        }

        if(!appStrings[language]) {
            language = "en";
        }

        if(!appStrings[language][key]) {
            language = "en";
        }

        return appStrings[language][key];
	}
	
	function setBaseURL() {
		var url = window.location.href;
		if(url.indexOf('.') > -1){
		   pageBaseURL = url.substring(0, url.lastIndexOf('/') + 1);
		}
	}
	
	// Web App Core v3.1 Functions
	var toolbarNameArray = new Array();
	var toolbarFunctionArray = new Array();
	var toolbarTagArray = new Array();
	toolbarFunctionCount = 0;
	
	function addToolbarOption(name,func,dropdown,icon,tag) {

        if(!tag) {
            tag = "0";
        }

        if(!dropdown) {
            dropdown = false;
        }

        if(!icon) {
            icon = null;
        }

        if(!newToolbarHolder[name]) {
            newToolbarHolder[name] = {};
        }

        newToolbarHolder[name][tag] = func;

        if(!icon && !dropdown) {
            parent.addToolbarItem(name,tag,null,null);
        } else {
            parent.addToolbarItem(name,tag,icon,dropdown);
        }

	}
	
	function resetToolbar() {
		newToolbarHolder = {};
		parent.resetCustomToolbar();
	}
	
	function executeToolbarFunction(name,tag) {
	    window[newToolbarHolder[name][tag]](name,tag);
	}
	
	function toggleToolbar() {
		parent.toggleToolbar();
	}
	
	function setTitle(title) {
		parent.setTitle(title);
	}
	
	function importFile(type,callback,asBinary) {
		this.fileImportComplete = callback;
		parent.importLocalFile(type,asBinary);
	}

	var tmpExportCallback;

	function notifySaveAsDone(id) {
        if(tmpExportCallback) {
            var tmpCallback = tmpExportCallback;
            tmpExportCallback = null;
            tmpCallback(id);
        }
    }
	
	function exportFile(filename,content,isXML,callback) {
	    if(callback) {
            tmpExportCallback = callback;
        }

		parent.exportTextFileAsDialog(filename,content,isXML);
	}
	
	function sendFile(filename) {
		parent.sendFile(filename);
	}
	
	function copyToClipboard(text) {
		parent.copyToClipboard(text);
	}
	
	function getInterface() {
		return parent.getInterface();
	}
	
	function isTV() {
		return parent.isTV();
	}

	function supportsRawPrinting() {
	    return Android.supportsRawPrinting();
	}

	function getRawPrinterConfig(margin) {

	    if(supportsRawPrinting()) {
	        var encoded = Android.getEncodedPrinterConfig();

	        if(!encoded) {
	            return {
                    printerLocation: null,
                    printerDriver: null,
                    paperSize: null,
                    printWidth: 0,
                    supports10cpi: false,
                    supports12cpi: false,
                    supports17cpi: false,
                    supports20cpi: false,
                    supports5cpi: false,
                    cpl5cpi: 0,
                    cpl10cpi: 0,
                    cpl12cpi: 0,
                    cpl17cpi: 0,
                    cpl20cpi: 0
                };
	        } else {
	            try {
	                var dec = atob(encoded);
	                var obj = JSON.parse(dec);
	                return obj;
	            } catch(ex) {
	                console.log(ex);

	                return {
                        printerLocation: null,
                        printerDriver: null,
                        paperSize: null,
                        printWidth: 0,
                        supports10cpi: false,
                        supports12cpi: false,
                        supports17cpi: false,
                        supports20cpi: false,
                        supports5cpi: false,
                        cpl5cpi: 0,
                        cpl10cpi: 0,
                        cpl12cpi: 0,
                        cpl17cpi: 0,
                        cpl20cpi: 0
                    };
	            }
	        }
	    } else {
	        return {
                printerLocation: null,
                printerDriver: null,
                paperSize: null,
                printWidth: 0,
                supports10cpi: false,
                supports12cpi: false,
                supports17cpi: false,
                supports20cpi: false,
                supports5cpi: false,
                cpl5cpi: 0,
                cpl10cpi: 0,
                cpl12cpi: 0,
                cpl17cpi: 0,
                cpl20cpi: 0
            };
	    }



	}

	function printRaw(options) {
	    //printText(options.text);

	    if(supportsRawPrinting()) {

            Android.printRaw(JSON.stringify(options),false,null,null);

        } else {
            printText(options.text);
        }
	}

	function replaceAll(str, find, replace) {

        if(!str) {
            return "";
        }

        if(str.indexOf(find) < 0) {
            return str;
        }

        return str.replace(new RegExp(escapeRegExp(find), "g"), replace);
    }

    function escapeRegExp(str) {
        return str.replace(/([.*+?^=!:${}()|[]\/\\])/g, "\\$1");
    }

	function printText(text,margin,noRaw) {

	    cleantext = replaceAll(text,"\n","<br />");
        var html = '<div style="font-family: \'Courier New\', Courier, monospace">' + cleantext + '</div>';

	    if(supportsRawPrinting() && !noRaw) {

	        var opts = {
               text: text,
               margin: 0.5
           }

           if(margin) {
                if(margin == "1in") {
                    opts.margin = 1;
                }
           } else {
                margin = "0.5in";
           }

	        Android.printRaw(JSON.stringify(opts),true,html,margin);

	        return;
	    }


		
		parent.printContent(html,margin);
	}
	
	function printHTML(html,margin) {
		parent.printContent(html,margin);
	}
	
	function changeWorkspace(callback) {
		this.workspaceChanged = callback;
		parent.changeWorkingDirectory();
	}
	
	function startApp(callback) {
		this.appStarted = callback;

		console.log("starting app!");

		onFacebookStatusChanged(Android.getFacebookLogged());

		// translate all in-document strings
        var translatables = document.getElementsByClassName("wac-translate");
        for(var i = 0; i < translatables.length; i++) {
            var stringName = translatables[i].innerHTML.trim();
            var stringValue = getString(stringName);

            if(stringValue && stringValue != null) {
                translatables[i].innerHTML = stringValue;
            }
        }

		parent.buildVarPackage();

		if(parent.isTV()) {
		    if(window.innerWidth == 1920) {
		        parent.force720();
		    } else {
		        console.log("tv width is " + window.innerWidth);
		    }

		    document.styleSheets[0].insertRule('*:focus { outline:none; }', 0);
            document.styleSheets[0].cssRules[0].style.outline= 'none';
		}

		Android.aleartAppIsRunning();
	}
	
	function recieveVariablePackage(varPack) {
		this.varPackage = varPack;
		this.appStarted();
	}
	
	function registerForShake(callback,sensitivity) {
		if(!sensitivity) {
			sensitivity = 3;
		}
		
		parent.setShakeSensitivity(sensitivity);
		
		this.shakeCallback = callback;
	}
	
	function checkForLaunchFile(callback) {
		this.launchCheckCallback = callback;
		parent.checkForLaunchFile();
	}
	
	function getLaunchFileName(callback) {
		this.launchNameCallback = callback;
		parent.getLaunchFileName();
	}
	
	function getLaunchFileContent(callback) {
		this.launchContentCallback = callback;
		parent.getLaunchFileContent();
	}
	
	function saveLaunchFile(content) {
		parent.saveLaunchFile(content);
	}

	// WAC 3.3

    function setTitleOptionListener(listener) {
        titleOptionListener = listener;
    }

    function titleOptionSelected(tag) {
        if(titleOptionListener == null) {
            return;
        }

        titleOptionListener(tag);
    }

    var nativeListReference;

    function presentNativeList(title,items,callback,dismiss) {

        if(!dismiss) {
            dismiss = "Dismiss";
        }

        nativeListListener = callback;

        nativeListReference = items;

        Android.beginNativeListDump();

        for(var i = 0; i < items.length; i++) {

            if(items[i]["icon"] == undefined) {
                items[i]["icon"] = null;
            }

            if(items[i]["description"] == undefined) {
                items[i]["description"] = null;
            }

            if(items[i]["title"] == undefined) {
                items[i]["title"] = null;
            }

            if(items[i]["title-color"] == undefined) {
                items[i]["title-color"] = null;
            }

            if(items[i]["status"] == undefined) {
                items[i]["status"] = null;
            }

            if(items[i]["status-color"] == undefined) {
                items[i]["status-color"] = null;
            }

            var progress = 0;

            if(items[i].progress) {
                progress = items[i].progress;
            }

            Android.addNativeListItemV4(items[i]["icon"], items[i]["title"], items[i]["title-color"], items[i]["description"], items[i]["status"], items[i]["status-color"], i.toString(),parseInt(progress));

            if(items[i].overflow != undefined && items[i].overflow != null) {
                for(var j = 0; j < items[i].overflow.length; j++) {

                    if(items[i].overflow[j].pre == undefined) {
                        items[i].overflow[j].pre = null;
                    }

                    if(items[i].overflow[j].post == undefined) {
                        items[i].overflow[j].post = null;
                    }

                    if(items[i].overflow[j].color == undefined) {
                        items[i].overflow[j].color = null;
                    }

                    if(items[i].overflow[j].icon == undefined) {
                        items[i].overflow[j].icon = null;
                    }

                    Android.addOverflowToLastListItem(items[i].overflow[j].pre,items[i].overflow[j].post,items[i].overflow[j].color,items[i].overflow[j].icon);
                }
            }
        }

        Android.showNativeList(title, dismiss);
    }

    function nativeListOptionSelected(tag) {

        if((tag == undefined || tag == -1) && nativeListListener) {
            nativeListListener();
        }


        if(nativeListListener == null || nativeListReference == null || nativeListReference[tag] == null) {
            return;
        }

        nativeListListener(nativeListReference[tag].tag);
    }

    function setOnPremiumListener(callback) {
        premiumUpgradedListener = callback;
    }

    function onPremiumUpgraded() {
        if(premiumUpgradedListener && premiumUpgradedListener != null) {
            premiumUpgradedListener();
        }
    }

    var nativeGetId = 0;
    var nativeGetHolders = {};

    function nativeGetBack(id,data) {
        nativeGetHolders[id](data);
        nativeGetHolders[id] = null;
    }

    function getForResult(url,data,func,forceProxy) {
        if(func == null) {
            func = placeholder;
        }

        dataRequest(url,func,data,false,forceProxy);
    }

    function getIsPremium() {
        var isPremium = parent.getIsPremium();
        return isPremium;
    }

    var dialogFunction1 = null;
    var dialogFunction2 = null;

    // begin WAC 3.4.0 functions

    function showDialog(options) {

        if(!options.buttons) {
            options.buttons = [];
        }

        if(options.op1) {



            options.buttons.push(options.op1);
        }

        if(options.op2) {

            if(!options.buttons) {
                options.buttons = [];
            }

            options.buttons.push(options.op2);
        }

        var c1 = null;
        var c2 = null;
        var t1 = null;
        var t2 = null;

        /*
        if (options.op1) {
            this.choice1 = options.op1.func;

            if(options.op1.color) {
                c1 = options.op1.color;
            }
        } else {
            options.op1 = {
               text: null
            };
        }

        if (options.op2) {
            this.choice2 = options.op2.func;

            if(options.op2.color) {
                c2 = options.op2.color;
            }
        } else {
             options.op2 = {
                text: null
             };
        }
        */

        if(!options.title) {
            options.title = null;
        }

        if(options.buttons.length >= 1) {
            t1 = options.buttons[0].text;

            if(options.buttons[0].func) {
                this.choice1 = options.buttons[0].func;
            }

            if(options.buttons[0].color) {
                c1 = options.buttons[0].color;
            }
        }

        if(options.buttons.length >= 2) {
            t2 = options.buttons[1].text;

            if(options.buttons[1].func) {
                this.choice2 = options.buttons[1].func;
            }

            if(options.buttons[1].color) {
                c2 = options.buttons[1].color;
            }
        }


        var sMin = 0;
        var sMax = 0;
        var sVal = 0;
        var sStat = null;
        var icon = null;

        if(options.sliderMin != undefined && options.sliderMax != undefined) {
            sMin = options.sliderMin;
            sMax = options.sliderMax;
            sVal = options.sliderValue;
            sStat = options.sliderStatusText;

            if(options.sliderCallback) {
                wasCallbackHolder = options.sliderCallback;
            } else {
                wasCallbackHolder = null;
            }
        }

        if(options.icon) {
            icon = options.icon;


            if (icon.indexOf("://") == -1 && icon.indexOf("data:image" == -1)) {
                icon = "assets://html5/app/" + icon;
            }

        }


        Android.showDialogV4(options.message, options.title, t1, t2, c1, c2,icon,sMin,sMax,sVal,sStat);

    }

    var wasCallbackHolder = null;

    function wacSliderCallback(val) {

        if(wasCallbackHolder) {
            wasCallbackHolder(val,function(text){
                if(text) {
                    Android.setDialogSliderText(text);
                }

            });
        }
    }

        function showSplash(text) {
            Android.showSplash(text);
        }

        function socketConnect(url) {
            console.log(url);


            var connectOptions = {
                rejectUnauthorized: false
            };

            if (url.indexOf("https") == 0 || url.indexOf("wss") == 0) {
                connectOptions.secure = true;
            }

            socket = parent.io(url,connectOptions);
        }

        function addSocketListener(evt, callback) {

            if (!socket || socket == null) {
                return;
            }

            socket.on(evt, callback);
        }

        function socketEmit(evt, data) {

            if (!socket || socket == null) {
                return;
            }

            socket.emit(evt, data);
        }

        function getPlatform() {

            var market = "apemarket";

            var platformCode = Android.getPlatform();

            if(platformCode == "2") {
                market = "gplay";
            }

            if(platformCode == "3") {
                market = "amazon";
            }

            if(platformCode == "7") {
                market = "slideme";
            }

            if(platformCode == "8") {
                market = "opera";
            }

            if(platformCode == "9") {
                market = "anzhi";
            }

            if(platformCode == "11") {
                market = "getjar";
            }

            if(platformCode == "12") {
                market = "aptoide";
            }

            return {
                platform: "android",
                market: market
            };
        }

        function setTitleSubtitle(text) {
            parent.setTitleSubtitle(text);
        }

        function setPremiumOptionText(text) {
            Android.setPremiumText(text);
        }

        function setBrandingLogo(logo) {
            parent.setBrandingLogo(logo);
        }

        this.titleFadeCallback = null;

        function fadeTitle(color, callback) {
            this.titleFadeCallback = callback;
            parent.fadeTitle(color);
        }

        function getFacebookLoginStatus() {
            return Android.getFacebookLogged();
        }

        function getFacebookCredentials() {

            if(!Android.getFacebookLogged()) {
                return null;
            }

            var username = Android.getFacebookLoggedName();
            var userid = Android.getFacebookLoggedId();

            var creds = {
                username:	username,
                userid:		userid
            };

            return creds;
        }

        function requestFacebookLogin() {
            Android.requestFacebookLogin();
        }

        function setFacebookStatusListener(listener) {
            facebookStatusListener = listener;
        }



        function onFacebookStatusChanged(status) {


        }

        var pendingLoadFileName;
        var pendingLoadFileCallback;

        var loadedLocal = false;

        function onFileOpened(content) {
            if(pendingLoadFileCallback) {
                var useCallback = pendingLoadFileCallback;
                pendingLoadFileCallback = null;
                useCallback(content);
                useCallback = null;
            }

        }

        function openFile(name,callback) {
            pendingLoadFileCallback = callback;
            parent.openFileFromWac(name);
        }

        var pendingWorkspaceMoveAfter = false;

        function cloudListingBack(data) {

            var cloudFiles = data.split("\n");
            var localFiles = Android.getFileListing().split("|");

            for (var i = 0; i < cloudFiles.length; i++) {
                var exists = false;

                for (var j = 0; j < localFiles.length; j++) {
                    if (cloudFiles[i] == localFiles[j]) {
                        exists = true;
                    }
                }

                if (exists) {
                } else {
                    saveFile(cloudFiles[i], "");
                }
            }


            if (pendingWorkspaceMoveAfter) {
                this.workspaceChanged(true);
            }

            pendingWorkspaceMoveAfter = false;

        }

        var tmpSaveCallback = null;

        var saveCallbacks = {};
        var saveCallbackIdNumber = 0;

        function saveFile(name,content,callback,blockCloud) {

            if(!blockCloud) {
                blockCloud = false;
            }

            //tmpSaveCallback = callback;

            saveCallbackIdNumber++;
            saveCallbacks[saveCallbackIdNumber] = callback;

            parent.saveFile(name,content,blockCloud,saveCallbackIdNumber);
        }

        function onFileSaveComplete(callbackid) {

            if(saveCallbacks[callbackid]) {
                var usecb = saveCallbacks[callbackid];
                saveCallbacks[callbackid] = null;
                usecb();
            }


        }

        function cloudSaveBack(data) {
            console.log(data);
        }

        function deleteFile(name,retfun) {
            this.fileDeleted = retfun;
            parent.deleteFile(name);

            if(getFacebookLoginStatus()) {
                var cloudRequestUrl = "https://cloud.ape-apps.com:2728/" + Android.getFacebookAccessToken() + "/" + Android.getFacebookLoggedId() + "/" + Android.getApeMarketId() + "/" + encodeURIComponent(name);
                var xmlhttp = new XMLHttpRequest();


                xmlhttp.addEventListener("load",function(e){
                    if(retfun) {
                        retfun();
                    }
                });

                xmlhttp.addEventListener("error",function() {
                    if(retfun) {
                        retfun();
                    }
                });

                xmlhttp.addEventListener("timeout",function() {
                    if(retfun) {
                        retfun();
                    }
                });

                xmlhttp.open("post",cloudRequestUrl,true);
                xmlhttp.timeout = 12000;
                xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
                xmlhttp.send("doDelete=1");
            } else {
                if(retfun) {
                    retfun();
                }
            }
        }

        function cloudDeleteBack(data) {
            //console.log(data);
        }

        function dataRequest(url,callback,data,post,forceProxy) {
            var xmlhttp = new XMLHttpRequest();
            xmlhttp.callbackFunction = callback;

            var m = "GET";

            if(post) {
                m = "POST";
            }

            var params = "";

            if(data && data != null) {
                if(Array.isArray(data)) {
                    for(var i = 0;i < data.length; i++) {
                        if(i > 0) {
                            params = params + "&";
                        }

                        if(post) {
                            params = params + data[i].key + "=" + data[i].value;
                        } else {
                            //params = params + data[i].key + "=" + encodeURIComponent(data[i].value);
                            params = params + data[i].key + "=" + data[i].value;
                        }
                    }
                } else {
                    if (typeof data === 'string' || data instanceof String) {
                        params = data;
                    } else {
                        if(post) {
                            params = data.key + "=" + data.value;
                        } else {
                            //params = data.key + "=" + encodeURIComponent(data.value);
                            params = data.key + "=" + data.value;
                        }
                    }
                }
            }

            xmlhttp.addEventListener("load",function(e) {
                this.callbackFunction(e.target.responseText);
            });

            xmlhttp.addEventListener("error",function(e) {
                this.callbackFunction(null);
            });

            xmlhttp.addEventListener("timeout",function(e) {
                this.callbackFunction(null);
            });

            if(!post && params.length > 0) {
                url = url + "?" + params;
            }

            var useURL = url;
            var useMethod = m;

            if(forceProxy) {
                useMethod = "POST";
                useURL = "https://www.apewebapps.com/awaproxy.php?m=" + m + "&url=" + encodeURIComponent(url);
            }
            console.log(useURL);
            xmlhttp.open(useMethod,useURL,true);


            xmlhttp.timeout = 14000;
            xmlhttp.setRequestHeader("Content-type", "application/x-www-form-urlencoded");


            if(post) {
                console.log("sending post");
                xmlhttp.send(params);
            } else {
                console.log("sending get");
                xmlhttp.send();
            }
        }

        var appMidiCallback = null;
        var appMidiLooping = false;
        var appMidiFile = null;

        function getWacVersion() {
            return Android.getWacVersion();
        }

        function midiCallbackListener() {
            if(appMidiLooping) {
                Android.playMidi(appMidiFile);
            } else {
                stopMidi(true);
            }
        }

        function playMidi(song,seconds,loop,callback) {
            appMidiCallback = callback;
            appMidiLooping = loop;
            appMidiFile = song;

            Android.playMidi(song);
        }

        function stopMidi(fromCallback) {
            if(!fromCallback) {
                Android.stopMidi();
            }

            var pendingCallback = appMidiCallback;

            appMidiCallback = null;
            appMidiLooping = false;
            appMidiFile = null;

            if(pendingCallback != null) {
                pendingCallback("done");
            }

            pendingCallback = null;
        }

        function setRelaunchListener() {
            // not really needed yet on Android
        }

        var menuPressedListener = null;

        function setMenuPressedListener(listener) {
            menuPressedListener = listener;
        }

        function revieveMenuPress() {
            if(menuPressedListener != null) {
                menuPressedListener();
            }
        }

        function supportsShortcut() {
            return true;
        }

        function createShortcut(title,launchParm,icon) {
            Android.createShortcut(title,launchParm,icon);
        }

        function supportsRingtone() {
            return true;
        }

        function setRingtone(filename) {
            Android.setRingtone(filename);
        }

        var audioInstanceRecords = {};

        function playAudio(soundName,callback) {
            audioInstanceRecords[soundName] = callback;

            Android.playAudio(soundName);
        }

        function stopAudio(soundName) {
            Android.stopAudio(soundName);
        }

        function audioInstanceCallbackListener(soundName) {

            var callbackReference = audioInstanceRecords[soundName];

            audioInstanceRecords[soundName] = null;

            if(callbackReference) {
                callbackReference();
            }
        }

        var rewardedVideoCallback = null;

        function playRewardedVideo(callback) {
            rewardedVideoCallback = callback;
            Android.showRewardedVideo();
        }

        function rewardedVideoDone(status) {
            if(rewardedVideoCallback) {
                var useCallback = rewardedVideoCallback;
                rewardedVideoCallback = null;
                useCallback(status);
            }


        }

    // WAC 3.6.0 Functions

    function loadChat(room,nametag,silent) {

        if(!nametag) {
            nametag = "";
        }

        if(!silent) {
            silent = false;
        }

        Android.loadChat(room,encodeURIComponent(nametag),silent);
    }

    function closeChat() {
        Android.closeChat();
    }

    function isRewardedVideoAvailable() {
        return Android.isRewardedReady();
    }

    function isApeAppsLoggedIn() {
        return Android.isApeAppsLoggedIn();
    }

    function getApeAppsProfile() {

        var profileString = Android.getApeAppsProfile();

        var proBack = null;

        if(profileString != null) {
            proBack = JSON.parse(profileString);
        }

        return proBack;

        //return parent.getApeAppsProfile();
    }



    function updateApeAppsAvatar(data,callback) {
        parent.updateApeAppsAvatar(data,callback);
    }

    var apeAppsStatusListener = null;

    function setApeAppsStatusListener(listener) {
        apeAppsStatusListener = listener;
    }

    function onApeAppsStatusChanged(status) {
        if(apeAppsStatusListener != null) {
            apeAppsStatusListener(status);
        }
    }

    function supportsTcpSockets() {
        return true;
    }

    function getLocalIp() {
        return Android.getLocalIp();
    }

    function getRemoteIp() {
        return parent.getRemoteIp();
    }

    var socketCreatedListener = null;

    function createTcpSocket(port,callback) {
        socketCreatedListener = callback;
        Android.createTcpSocket(port);
    }

    function onSocketCreated(id) {
        if(socketCreatedListener) {
            socketCreatedListener(id);
        }

        socketCreatedListener = null;
    }

    var socketConnectedListener = null;

    var socketConnectCallbacks = {};
    var socketConnectCallbackId = 0;

    function connectTcpSocket(ip,port,listener) {

        socketConnectCallbackId++;
        socketConnectCallbacks[socketConnectCallbackId] = listener;

        //socketConnectedListener = listener;
        Android.connectToTcpServer(ip,parseInt(port),socketConnectCallbackId);
    }

    function onSocketConnected(id,cbid) {

        console.log(id + " is connected!");

        if(socketConnectCallbacks[cbid]) {
            socketConnectCallbacks[cbid](id);
            socketConnectCallbacks[cbid] = null;
        }


    /*
        if(socketConnectedListener) {
            socketConnectedListener(id);
        }

        socketConnectedListener = null;
        */
    }

    var portScanListener = null;

    function scanLocalTcpSockets(port,listener) {
        portScanListener = listener;
        Android.scanLanForPorts(port);
    }

    function onPortScanComplete(ports) {
        if(portScanListener) {
            portScanListener(ports);
        }

        portScanListener = null;
    }

    function closeTcpSocket(id,callback) {
        Android.closeTcpSocket(id);

        if(callback) {
            callback(id);
        }

    }

    function sendTcpSocketMessage(id,message,target) {
        if(!target) {
            target = null;
        }

        Android.sendTcpSocketMessage(id,message,target);
    }

    var tcpSocketListeners = {};

    function setTcpSocketListener(id,listener) {
        tcpSocketListeners[id] = listener;
    }

    function onTcpSocketMessage(id,message,tag) {
        if(tcpSocketListeners[id]) {
            tcpSocketListeners[id](id,message,tag);
        }
    }

    function showTcpExtensionMessage() {
        // to someday implement, if support for a 3rd party socket extension can be done
    }

    function isFlashSupported() {
        return Android.isFlashSupported();
    }

    function isFlashOn() {
        return Android.isFlashOn();
    }

    function setFlash(value) {
        Android.setFlash(value);
    }

    var getPrimaryTokenCallback = null;
    var getTokensCallback = null;
    var addTokenCallback = null;
    var updateTokenCallback = null;
    var removeTokenCallback = null;
    var setPrimaryTokenCallback = null;
    var getTokenByIdCallback = null;

    var tmpPriTokenSize;
    var tmpPriTokenFrames;

    var tmpAllTokenSize;
    var tmpAllTokenFrames;

    var tmpIdTokenSize;
    var tmpIdTokenFrames;

    function getTokenById(id,size,frames,callback) {
        getTokenByIdCallback = callback;

        if(size) {
            tmpIdTokenSize = size;
        } else {
            tmpIdTokenSize = 48;
        }

        if(frames) {
            tmpIdTokenFrames = frames;
        } else {
            tmpIdTokenFrames = "37";
        }

        var url = tokensApi;

        var data = [];

        data.push({
            "key": "f",
            "value": "9"
        });

        data.push({
            "key": "id",
            "value": id
        });

        getForResult(url,data,onTokenByIdDataBack,false);
    }

    function onTokenByIdDataBack(data) {
        var resultObject = null;

        if(getTokenByIdCallback == null) {
            return;
        }

        try {
            var tmpResult = JSON.parse(data);
            resultObject = tmpResult[0];
        } catch(ex) {
            console.log(data);
            console.log(ex);
            resultObject = null;
        }

        if(resultObject == null) {
            getTokenByIdCallback(null);
            getTokenByIdCallback = null;
            return;
        }

        var urlBuild = "https://tokens.ape-apps.com/gettoken.php?s=" + tmpIdTokenSize + "&f=" + tmpIdTokenFrames + "&p=" + resultObject.token;

        resultObject.url = urlBuild;

        getTokenByIdCallback(resultObject);
        getTokenByIdCallback = null;
    }

    function onPrimaryTokenDataBack(data) {
        var resultObject = null;

        if(getPrimaryTokenCallback == null) {
            return;
        }

        try {
            var tmpResult = JSON.parse(data);
            resultObject = tmpResult[0];
        } catch(ex) {
            console.log(ex);
            resultObject = null;
        }

        if(resultObject == null) {
            getPrimaryTokenCallback(null);
            getPrimaryTokenCallback = null;
            return;
        }

        var urlBuild = "https://tokens.ape-apps.com/gettoken.php?s=" + tmpPriTokenSize + "&f=" + tmpPriTokenFrames + "&p=" + resultObject.token;

        resultObject.url = urlBuild;

        getPrimaryTokenCallback(resultObject);
        getPrimaryTokenCallback = null;
    }

    function getPrimaryToken(name,size,frames,callback) {
        getPrimaryTokenCallback = callback;

        if(size) {
            tmpPriTokenSize = size;
        } else {
            tmpPriTokenSize = 48;
        }

        if(frames) {
            tmpPriTokenFrames = frames;
        } else {
            tmpPriTokenFrames = "37";
        }

        var url = tokensApi;

        var data = [];

        data.push({
            "key": "f",
            "value": "3"
        });

        data.push({
            "key": "un",
            "value": name
        });

        getForResult(url,data,onPrimaryTokenDataBack,false);
    }

    function onAllTokenDataBack(data) {
        var resultObject = null;

        if(getTokensCallback == null) {
            return;
        }

        try {
            var tmpResult = JSON.parse(data);
            resultObject = tmpResult;
        } catch(ex) {
            console.log(ex);
            resultObject = null;
        }

        if(resultObject == null) {
            getTokensCallback(null);
            getTokensCallback = null;
            return;
        }

        for(var i = 0; i < resultObject.length; i++) {
            var urlBuild = "https://tokens.ape-apps.com/gettoken.php?s=" + tmpAllTokenSize + "&f=" + tmpAllTokenFrames + "&p=" + resultObject[i].token;
            resultObject[i].url = urlBuild;
        }

        getTokensCallback(resultObject);
        getTokensCallback = null;
    }

    function getTokens(name,size,frames,callback) {
        getTokensCallback = callback;

        if(size) {
            tmpAllTokenSize = size;
        } else {
            tmpAllTokenSize = 48;
        }

        if(frames) {
            tmpAllTokenFrames = frames;
        } else {
            tmpAllTokenFrames = "37";
        }

        var url = tokensApi;

        var data = [];

        data.push({
            "key": "f",
            "value": "2"
        });

        data.push({
            "key": "un",
            "value": name
        });

        getForResult(url,data,onAllTokenDataBack,false);
    }

    function getCustomToken(parts,size,frames) {
        var url = "https://tokens.ape-apps.com/gettoken.php?s=" + size + "&p=" + parts + "&f=" + frames;
        return url;
    }

    function addToken(partsString,tokenName,backgroundColor,canRoam,callback) {
        addTokenCallback = callback;

        if(!parent.isApeAppsLoggedIn()) {
            addTokenCallback(null);
            return;
        }

        var url = tokensApi;

        var data = [];

        var creds = getApeAppsLoginKeys();

        data.push({
            "key": "f",
            "value": "4"
        });

        data.push({
            "key": "a",
            "value": creds.a
        });

        data.push({
            "key": "b",
            "value": creds.b
        });

        data.push({
            "key": "c",
            "value": creds.c
        });

        data.push({
            "key": "d",
            "value": Android.getApeMarketId()
        });

        data.push({
            "key": "n",
            "value": tokenName
        });

        data.push({
            "key": "bg",
            "value": backgroundColor.replace("#","")
        });

        data.push({
            "key": "r",
            "value": canRoam
        });

        data.push({
            "key": "p",
            "value": partsString
        });

        getForResult(url,data,onNewTokenAdded,false);
    }

    function onNewTokenAdded(result) {

        if(addTokenCallback == null) {
            return;
        }

        if(!result || result == "fail") {
            addTokenCallback(null);
        } else {
            addTokenCallback(result);
        }

        addTokenCallback = null;
    }

    function updateToken(tokenId,partsString,tokenName,backgroundColor,canRoam,callback) {
        updateTokenCallback = callback;

        if(!parent.isApeAppsLoggedIn()) {
            updateTokenCallback(null);
            return;
        }

        var url = tokensApi;

        var data = [];

        var creds = getApeAppsLoginKeys();

        data.push({
            "key": "f",
            "value": "5"
        });

        data.push({
            "key": "a",
            "value": creds.a
        });

        data.push({
            "key": "b",
            "value": creds.b
        });

        data.push({
            "key": "c",
            "value": creds.c
        });

        data.push({
            "key": "d",
            "value": Android.getApeMarketId()
        });

        data.push({
            "key": "i",
            "value": tokenId
        });

        data.push({
            "key": "n",
            "value": tokenName
        });

        data.push({
            "key": "bg",
            "value": backgroundColor.replace("#","")
        });

        data.push({
            "key": "r",
            "value": canRoam
        });

        data.push({
            "key": "p",
            "value": partsString
        });

        getForResult(url,data,onTokenUpdated,false);
    }

    function onTokenUpdated() {
        if(updateTokenCallback) {
            updateTokenCallback();
        }

        updateTokenCallback = null;
    }

    function removeToken(id,callback) {
        removeTokenCallback = callback;

        if(!parent.isApeAppsLoggedIn()) {
            removeTokenCallback(null);
            return;
        }

        var url = tokensApi;

        var data = [];

        var creds = getApeAppsLoginKeys();

        data.push({
            "key": "f",
            "value": "6"
        });

        data.push({
            "key": "a",
            "value": creds.a
        });

        data.push({
            "key": "b",
            "value": creds.b
        });

        data.push({
            "key": "c",
            "value": creds.c
        });

        data.push({
            "key": "d",
            "value": Android.getApeMarketId()
        });

        data.push({
            "key": "i",
            "value": id
        });

        getForResult(url,data,onTokenRemoved,false);
    }

    function onTokenRemoved() {
        if(removeTokenCallback != null) {
            removeTokenCallback();
        }

        removeTokenCallback = null;
    }

    function setPrimaryToken(id,callback) {
        setPrimaryTokenCallback = callback;

        if(!parent.isApeAppsLoggedIn()) {
            setPrimaryTokenCallback(null);
            return;
        }

        var url = tokensApi;

        var data = [];

        var creds = getApeAppsLoginKeys();

        data.push({
            "key": "f",
            "value": "7"
        });

        data.push({
            "key": "a",
            "value": creds.a
        });

        data.push({
            "key": "b",
            "value": creds.b
        });

        data.push({
            "key": "c",
            "value": creds.c
        });

        data.push({
            "key": "d",
            "value": Android.getApeMarketId()
        });

        data.push({
            "key": "i",
            "value": id
        });

        getForResult(url,data,onPrimaryTokenSet,false);
    }

    function onPrimaryTokenSet() {
        if(setPrimaryTokenCallback != null) {
            setPrimaryTokenCallback();
        }

        setPrimaryTokenCallback = null;
    }

    function getApeAppsLoginKeys() {
        return JSON.parse(Android.getApeAppsCreds());
    }

    function setFullscreenListener(listener) {
        fullscreenListener = listener;
    }

    function getIsFullscreen() {
        // tmp, eventually check if pinned or whatnot
        return true;
    }

    function toggleFullscreen() {
        return parent.newToggleFullscreenWeb();
    }

    function onFullscreen(fullscreen) {
        if(fullscreenListener) {
            fullscreenListener(fullscreen);
        }
    }

    function getAppVersion() {
        return Android.getAppVersion();
    }

    function locationSupported() {
        return true;
    }

    var tmpLocationCallback = null;
    var tmpLocationListener = null;

    function onLocationBack(location) {
        if(tmpLocationCallback && tmpLocationCallback != null) {
            tmpLocationCallback(location);
        }

        tmpLocationCallback = null;
    }

    function getCurrentLocation(callback) {
        tmpLocationCallback = callback;
        Android.getCurrentLocation();
    }

    function onLocationIntervalBack(position) {
        if(tmpLocationListener && tmpLocationListener != null) {
            tmpLocationListener(position);
        }
    }

    function setLocationListener(listener) {
        tmpLocationListener = listener;

        Android.listenForLocation();
    }

    var tmpMapObject = null;
    var tmpMapLoadedCallback = null;

    function showMap(holder,callback) {

        if(!holder) {
            return;
        }

        if(tmpMapObject != null) {
            return;
        }

        if(callback) {
            tmpMapLoadedCallback = callback;
        }


        if (typeof L !== "undefined") {
            gooseUpMap(holder);
        } else {

            var htc = document.createElement("script");
            htc.src = "../js/leaflet/leaflet.js";
            htc.type = "text/javascript";

            htc.onload = function () {

                var lss = document.createElement("link");
                lss.href = "../js/leaflet/leaflet.css";
                lss.rel = "stylesheet";
                lss.type = "text/css";

                lss.onload = function () {

                    gooseUpMap(holder);
                };
                document.getElementsByTagName("head")[0].appendChild(lss);
            };
            document.getElementsByTagName("head")[0].appendChild(htc);

        }

    }

    function gooseUpMap(holder) {
        activeMapMarkers = [];
        currentMapCircle = null;
        tmpMapObject = L.map(holder, {
            zoomControl:false
        }).setView([0, 0], 13);
        L.tileLayer('http://{s}.tile.osm.org/{z}/{x}/{y}.png', {
            attribution: '&copy; <a href="http://osm.org/copyright">OpenStreetMap</a> contributors'
        }).addTo(tmpMapObject);

        if(tmpMapLoadedCallback != null) {
            tmpMapLoadedCallback();
        }

        tmpMapLoadedCallback = null;
    }

    function centerMap(lat,lon,zoom) {
        if(!tmpMapObject) {
            return;
        }

        if(!zoom) {
            zoom = 13;
        }

        tmpMapObject.setView([lat, lon], zoom);
    }

    var activeMapMarkers = [];

    function dropMapPin(lat,lon,text) {
        if(!tmpMapObject) {
            return;
        }

        var marker = L.marker([lat, lon]).addTo(tmpMapObject);

        if(text) {
            marker.bindPopup(text).openPopup();
        }

        activeMapMarkers.push(marker);
    }

    function clearPins() {
        if(!tmpMapObject) {
            return;
        }

        for(var i = 0; i < activeMapMarkers.length; i++) {
            activeMapMarkers[i].remove();
        }

        if(currentMapCircle != null) {
            currentMapCircle.remove();
        }

        activeMapMarkers = [];
        currentMapCircle = null;
    }

    var currentMapCircle = null;

    function setCirclePosition(lat,lon) {
        if(!tmpMapObject) {
            return;
        }

        if(currentMapCircle == null) {
            currentMapCircle = L.circle([lat, lon], {
                color: 'red',
                fillColor: '#f03',
                fillOpacity: 0.5,
                radius: 35
            }).addTo(tmpMapObject);
        } else {
            currentMapCircle.setLatLng([lat, lon]);
        }
    }

    function isHexColorLight(hex) {
        var color = hexToColor(hex);

        var colorValue = color.r + color.g + color.b;

        if (colorValue > 382) {
            return true;
        } else {
            return false;
        }
    }

    function hexToColor(hex) {
        var result;

        if (hex.length == 6 || hex.length == 7) {
            result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
            return result ? {
                a: 255,
                r: parseInt(result[1], 16),
                g: parseInt(result[2], 16),
                b: parseInt(result[3], 16)
            } : null;
        }

        if (hex.length == 8 || hex.length == 9) {
            result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
            return result ? {
                a: parseInt(result[1], 16),
                r: parseInt(result[2], 16),
                g: parseInt(result[3], 16),
                b: parseInt(result[4], 16)
            } : null;
        }

        return {
            a: 255,
            r: 0,
            g: 0,
            b: 0
        };
    }

    function isCameraSupported() {
        if(navigator.mediaDevices.getUserMedia) {
            return true;
        } else {
            return false;
        }
    }

    function onGotCameraPermission() {
        if(pendingCamHolder) {
            loadCameraPreview(pendingCamHolder,pendingCamFront);
        }
    }

    var pendingCamHolder = null;
    var pendingCamFront = null;

    function loadCameraPreview(holder,useFront) {

        if(!Android.checkCameraPermission()) {
            pendingCamHolder = holder;
            pendingCamFront = useFront;
            return;
        }

        pendingCamHolder = null;
        pendingCamFront = null;

        if(videoElement) {
            videoElement = null;
        }

        videoHolder = holder;
        videoHolder.innerHTML = "";
        videoHolder.style.overflow = "hidden";


        var facing = "environment";

        if(useFront) {
            facing = "user";
        }

        navigator.mediaDevices.getUserMedia(
            {
                audio: false,
                video: {
                    facingMode: facing,
                    frameRate: {
                        ideal: 30
                    }
                }
            })
        .then(gotMedia)
        .catch(function(error) {
            console.error('getUserMedia() error:', error);
        } );
    }

    var videoHolder;
    var videoElement;
    var streamWidth = 0;
    var streamHeight = 0;

    function gotMedia(mediaStream) {
        //workingStream = mediaStream.getTracks()[0];

        videoElement = document.createElement("video");
        videoElement.style.display = "block";
        videoElement.style.height = "100%";
        videoElement.style.width = "100%";
        videoElement.style.overflow = "hidden";
        videoElement.style.objectFit = "cover";
        videoElement.style.objectPosition = "center";
        videoElement.controls = false;
        videoElement.autoplay = true;

        videoElement.onloadedmetadata = function() {
            streamWidth = this.videoWidth;
            streamHeight = this.videoHeight;
            this.play();
        };

        videoElement.src = window.URL.createObjectURL(mediaStream);

        videoHolder.appendChild(videoElement);
    }

    var contextFilter = null;

    function takePictureFromPreview(callback) {
        if(streamWidth === 0 || streamHeight === 0) {
            return;
        }

        if(videoElement == null) {
            return;
        }

        var capturecanvas = document.createElement("canvas");

        capturecanvas.width = videoHolder.offsetWidth;
        capturecanvas.height = videoHolder.offsetHeight;

        var capturecontext = capturecanvas.getContext("2d");

        if(contextFilter != null) {
            capturecontext.filter = contextFilter;
        }

        var scale = 1;
        var drawWidth = streamWidth;
        var drawHeight = streamHeight;

        scale = videoHolder.offsetWidth / streamWidth;

        if(streamHeight * scale < videoHolder.offsetHeight) {
            scale = videoHolder.offsetHeight / streamHeight;
        }

        drawWidth = streamWidth * scale;
        drawHeight = streamHeight * scale;



        var drawX = (videoHolder.offsetWidth / 2) - (drawWidth / 2);

        capturecontext.drawImage(videoElement,drawX,0,drawWidth,drawHeight);
        var dataUrl = capturecanvas.toDataURL();

        callback(dataUrl);
    }

    function setCameraFilter(filter) {
        if(videoElement == null) {
            return;
        }

        var useFilter = filter + "()";

        if(filter == "blur") {
            useFilter = filter + "(20px)";
        }

        if(filter == "none") {
            useFilter = filter;
        }



        videoElement.style.filter = useFilter;
        contextFilter = useFilter;
    }

    function supportsPhotoEditor() {
        return Android.supportsPhotoEditor();
    }

    var photoEditorCallback = null;

    function editPhoto(data,callback) {
        photoEditorCallback = callback;
        Android.editImageFromData(data);
    }

    function onImageEdited(data) {
        if(photoEditorCallback) {
            photoEditorCallback(data);
        }

        photoEditorCallback = null;
    }

    function allowOnline() {
        return true;
    }

    function supportsTransparency() {
        return false;
    }

    function didRecoverFromCrash() {
        return Android.getDidRecoverFromCrash();
    }

    function setSidebarCategory(cat,icon) {
        Android.setCategoryText(cat,icon);
    }

    function supportsMusicPicker() {
        return true;
    }

    var customSongCallback = null;

    function onPickedCustomSong(name) {
        if(customSongCallback) {
            var tmpCBHGolder = customSongCallback;
            customSongCallback = null;
            tmpCBHGolder(name);
        }
    }


    function pickSong(callback) {

        if(callback) {
            customSongCallback = callback;
        } else {
            customSongCallback = null;
        }

        Android.pickSong();
    }

    function presentApeLogin() {
        Android.showApeLogin();
    }

    function stopSong() {
        customSongCallback = null;
        Android.stopLoop();
    }

    // start wac 3.6.3 functions
    function getServerTime(callback) {
        getForResult("https://www.apewebapps.com/servertime.php",null,callback,false);
    }

    function checkAccountMail(forApp,forTag,callback) {
        if(!isApeAppsLoggedIn()) {
            callback(null);
            return;
        }

        var creds = getBaseApeAppsServerCreds();

        if(!creds) {
            callback(null);
            return;
        }

        creds.push({
            "key": "f",
            "value": "20"
        });

        if(forApp) {
            creds.push({
                "key": "ap",
                "value": forApp
            });
        }

        if(forTag) {
            creds.push({
                "key": "tg",
                "value": forTag
            });
        }

        postForResult("https://www.ape-apps.com/api.php",creds,callback,false);
    }

    function getAccountMessage(messageId,callback) {
        if(!isApeAppsLoggedIn() || !messageId) {
            callback(null);
            return;
        }

        var creds = getBaseApeAppsServerCreds();

        if(!creds) {
            callback(null);
            return;
        }

        creds.push({
            "key": "f",
            "value": "21"
        });

        creds.push({
            "key": "mid",
            "value": messageId
        });

        postForResult("https://www.ape-apps.com/api.php",creds,callback,false);
    }

    function deleteAccountMessage(messageId,callback) {
        if(!isApeAppsLoggedIn() || !messageId) {
            callback(null);
            return;
        }

        var creds = getBaseApeAppsServerCreds();

        if(!creds) {
            callback(null);
            return;
        }

        creds.push({
            "key": "f",
            "value": "23"
        });

        creds.push({
            "key": "mid",
            "value": messageId
        });

        postForResult("https://www.ape-apps.com/api.php",creds,callback,false);
    }

    function sendAccountMessage(toArray,ccArray,bccArray,forApp,forTag,subject,content,callback) {
        if(!isApeAppsLoggedIn()) {
            callback(null);
            return;
        }

        if(!content) {
            return;
        }

        var creds = getBaseApeAppsServerCreds();

        if(!creds) {
            callback(null);
            return;
        }

        var toString = "";
        var ccString = "";
        var bccString = "";

        var i,added;

        if(toArray) {
            added = 0;

            for(i = 0; i < toArray.length; i++) {

                if(toArray[i].trim().length == 0) {
                    continue;
                }

                if(added > 0) {
                    toString += ",";
                }

                toString += toArray[i].trim();
                added++;
            }
        }

        if(ccArray) {
            added = 0;

            for(i = 0; i < ccArray.length; i++) {

                if(ccArray[i].trim().length == 0) {
                    continue;
                }

                if(added > 0) {
                    ccString += ",";
                }

                ccString += ccArray[i].trim();
                added++;
            }
        }

        if(bccArray) {
            added = 0;

            for(i = 0; i < bccArray.length; i++) {

                if(bccArray[i].trim().length == 0) {
                    continue;
                }

                if(added > 0) {
                    bccString += ",";
                }

                bccString += bccArray[i].trim();
                added++;
            }
        }

        if(!subject) {
            subject = "No Subject";
        }

        creds.push({
            "key": "f",
            "value": "22"
        });

        creds.push({
            "key": "sub",
            "value": subject
        });

        creds.push({
            "key": "con",
            "value": content
        });

        creds.push({
            "key": "to",
            "value": toString
        });

        creds.push({
            "key": "cc",
            "value": ccString
        });

        creds.push({
            "key": "bcc",
            "value": bccString
        });

        if(forApp) {
            creds.push({
                "key": "fa",
                "value": forApp
            });
        }

        if(forTag) {
            creds.push({
                "key": "ft",
                "value": forTag
            });
        }

        postForResult("https://www.ape-apps.com/api.php",creds,callback,false);
    }

    function getBaseApeAppsServerCreds() {
        if(!isApeAppsLoggedIn()) {
            return null;
        }

        var keys = getApeAppsLoginKeys();

        if(!keys) {
            return null;
        }

        var credData = [];

        credData.push({
            "key": "sida",
            "value": keys.a
        });

        credData.push({
            "key": "sidb",
            "value": keys.b
        });

        credData.push({
            "key": "ak",
            "value": keys.c
        });

        credData.push({
            "key": "am",
            "value": Android.getApeMarketId()
        });

        return credData;
    }

    //wac 3.7.0 functions

    function isChatOpen() {
        return Android.isChatOpen();
    }

    function setChatListener(listener) {
        onChatListener = listener;
    }

    function onChatMessage(data) {
        if(onChatListener) {
            onChatListener(data);
        }
    }

    function sendChatMessage(message) {
        Android.sendChatMessage(message.trim());
    }

    function randomIntFromInterval(min,max) {
        return Math.floor(Math.random()*(max-min+1)+min);
    }

    function isOrientationSupported() {
        return 'ondeviceorientation' in window;
    }

    function setOrientationListener(listener) {
        orientationListener = listener;
    }

    function getRandomToken(size,frames,callback) {
        var url = tokensApi;

        var data = [];

        data.push({
            "key": "f",
            "value": "8"
        });

        getForResult(url,data,function(res){
            console.log("token result: " + res);

            if(res) {
                try {
                    var tokDat = JSON.parse(res);
                    var theToken = tokDat[randomIntFromInterval(0,tokDat.length - 1)];

                    theToken.url = "https://tokens.ape-apps.com/gettoken.php?s=" + size + "&p=" + theToken.token + "&f=" + frames;

                    console.log(theToken);

                    callback(theToken);
                } catch(ex) {
                    console.log(ex);
                    callback(null);
                }
            } else {
                callback(null);
            }
        },false);
    }

    function fileDialogsSupported(withHeliosNag) {
        if(!withHeliosNag) {
            withHeliosNag = false;
        }

        return Android.fileDialogsSupported(withHeliosNag);
    }

    function openFileDialog(type,callback,asBinary) {

        if(!asBinary) {
            asBinary = false;
        }

        this.fileImportComplete = callback;
        Android.importFile(type,asBinary);
    }

    function filesystemFileSave(data,fileId,callback) {
        filesystemFileSaveCallback = callback;
        Android.saveImportFileData(data,fileId);
    }

    var filesystemFileSaveCallback = null;

    function notifySaveImportDataDone(result) {
        if(filesystemFileSaveCallback) {
            filesystemFileSaveCallback(result);
        }
    }

    // WAC 3.7.1 functions

    var chatUsernameSelectedListener = null;

    function setChatUsernameSelectedListener(listener) {
        if(listener) {
            chatUsernameSelectedListener = listener;
        } else {
            chatUsernameSelectedListener = null;
        }
    }

    function onChatUsernameSelected(username) {
        if(!username || !chatUsernameSelectedListener) {
            return;
        }

        chatUsernameSelectedListener(username);
    }


    function stopTTS() {
        parent.stopTTS();
    }

    var onTTSCallback = null;

    function onTTSdone(text) {
        if(onTTSCallback) {
            onTTSCallback(text);
        }

        onTTSCallback = null;
    }

    var onFriendsListCallback = null;

    function getFriendsList(callback) {
        onFriendsListCallback = callback;

        parent.getFriendsList();
    }

    function onFriendsListReturn(data) {
        if(onFriendsListCallback) {
            onFriendsListCallback(data);
        }

        onFriendsListCallback = null;
    }

    var friendAddedCallback;

    function addFriend(username,callback) {

        friendAddedCallback = callback;

        parent.addFriend(username);
    }

    function onFriendAdded(result) {
        if(friendAddedCallback) {
            var cb = friendAddedCallback;
            friendAddedCallback = null;

            cb(result);
        }
    }

    function isSystemThemeDark() {
        return Android.getSystemDark();
    }

    function getSystemAccentColor() {
        return null;
    }

    function sendKongregateStat() {
        // does not apply on android
    }

    // Web App Core v3.7.3
    function supportsStreaming() {
        // may be other checks at some point
        return true;
    }

    function startStreaming(canvas) {


        if(!isApeAppsLoggedIn() || streamIsActive) {

            if(!isApeAppsLoggedIn()) {
                showToast("You must be logged in!");
            }

            if(streamIsActive) {
                console.log("stream already active");

                if(canvas) {
                    currentStreamCanvas = canvas;
                    streamCanvas.height = currentStreamCanvas.height;
                    streamCanvas.width = currentStreamCanvas.width;
                }
            }

            return;
        }

        if(!streamCanvas) {
            streamCanvas = document.createElement("canvas");
            streamContext = streamCanvas.getContext("2d");
            animateStreamCanvas();
        }

        if(canvas) {
            currentStreamCanvas = canvas;
            streamCanvas.height = currentStreamCanvas.height;
            streamCanvas.width = currentStreamCanvas.width;
        }

        currentStreamChannel = "wac-global-streaming-" + getApeAppsProfile().un;

        if(streamSocket && streamSocketConnected) {
            doStartStream();
            return;
        }

        createStreamSocket();
    }
	
	function createStreamSocket() {
		streamSocket = parent.io("https://www.my-colony.com:2728");
        streamSocket.on("connect",onStreamSocketConnection);
        streamSocket.on("message",onStreamSocketMessage);
        streamSocket.on("disconnect",onStreamSocketDisconnect);
	}

    function stopStreaming() {

        if(!streamIsActive) {
            return;
        }

        streamSocket.emit("gamemessage",{
            "destination": currentStreamChannel,
            "msg": {
                "type": "streaming",
                "code": "endstream",
                "appid": Android.getApeMarketId()
            }
        });

        streamIsActive = false;
        pendingStartStream = null;
        currentStreamChannel = null;
        streamEventListener = null;

        streamDoAudio = false;
        streamDoCam = false;
        doStreamGameboy = false;
        doStreamBlackAndWhite = false;
        greenscreenTolerance = 150;
        streamDoGreenScreen = false;

        if(currentAVStream) {
            currentAVStream.getTracks().forEach(function(track) {
                track.enabled = false;
                track.stop();
            });
        }

        currentAVStream = null;

        disconnectAllPeers();
    }

    function setStreamEventListener(listener) {
        streamEventListener = listener;
    }

    function setStreamWebcam(value,camWidth) {
        if(!value) {
            value = false;
        }

        if(camWidth) {
            webcamDisplayWidth = camWidth;
        }

        streamDoCam = value;

        setupStreams();
    }

    function removeFromArray(arr, item, showarray) {

        if(arr == null || item == null) {
            if(showarray !== undefined) {
                console.log("COULDNT remove from: " + showarray);
            }
            return;
        }

        var wasRemoved = false;

        for(var i = arr.length; i--;) {
            if(arr[i] === item) {
                arr.splice(i, 1);
                wasRemoved = true;
            }
        }

        return wasRemoved;
    }

    function setStreamWebcamGreenscreen(value,tolerence) {

        if(!tolerence) {
            tolerence = 150;
        }

        if(!value) {
            value = false;
        }

        streamDoGreenScreen = value;
        greenscreenTolerance = tolerence;
    }

    function setStreamWebcamGrayscale(value) {
        if(!value) {
            value = false;
        }

        doStreamBlackAndWhite = value;
    }

    function setStreamWebcamGameboy(value) {
        if(!value) {
            value = false;
        }

        doStreamGameboy = value;
    }

    function getStreamOutputData() {
        if(!streamIsActive || !streamCanvas) {
            return null;
        }

        return streamContext.getImageData(0, 0, streamCanvas.width, streamCanvas.height);
    }

    function getStreamWebcamOutputData() {
        if(!streamIsActive || !preFilterVideoCanvas) {
            return null;
        }

        return preFilterVideoContext.getImageData(0, 0, preFilterVideoCanvas.width, preFilterVideoCanvas.height);
    }

    function setStreamAudio(value) {
        if(!value) {
            value = false;
        }

        if(streamDoAudio != value) {

            streamSocket.emit("gamemessage",{
                "destination": currentStreamChannel,
                "msg": {
                    "type": "streaming",
                    "code": "audioreboot",
                    "appid": Android.getApeMarketId()
                }
            });

            disconnectAllPeers();
        }

        streamDoAudio = value;

        setupStreams();
    }

    function broadcastExtraStreamData(data) {
        if(streamSocket && streamSocketConnected) {
            streamSocket.emit("gamemessage",{
                "destination": currentStreamChannel,
                "msg": {
                    "type": "streaming",
                    "code": "extradata",
                    "data": data,
                    "appid": Android.getApeMarketId()
                }
            });
        }
    }

    function getIsStreamActive() {
        return streamIsActive;
    }

    function setupStreams() {

        if(!streamDoAudio && !streamDoCam) {

            if(currentAVStream) {
                currentAVStream.getTracks().forEach(function(track) {
                    track.enabled = false;
                    track.stop();
                });
            }

            currentAVStream = null;

            return;
        }

        if(currentAVStream) {
            currentAVStream.getAudioTracks()[0].enabled = streamDoAudio;
            return;
        }

        navigator.mediaDevices.getUserMedia({ audio: true, video: true }).then(function(stream) {
            if(stream) {

                currentAVStream = stream;

                if(!streamWebcamHold) {
                    streamWebcamHold = document.createElement("video");

                }

                theVidReady = false;

                streamWebcamHold.muted = true;

                streamWebcamHold.onloadedmetadata = function() {
                    theVidReady = true;
                    streamWebcamHold.play();
                };

                streamWebcamHold.srcObject = currentAVStream;

                var audioTrack = currentAVStream.getAudioTracks()[0];

                audioTrack.enabled = streamDoAudio;
                masterStream.addTrack(audioTrack);

            } else {
                currentAVStream = null;
            }
        });

    }

    function disconnectAllPeers() {
        if(streamPeers) {
            for(var peer in streamPeers) {
                var thePeer = streamPeers[peer];

                shutDownStreamPeer(thePeer);
            }
        }

        streamPeers = {};
    }

    function shutDownStreamPeer(thePeer,andClose) {


        if(thePeer) {

            for(var j = 0; j < thePeer.tracksRef.length; j++) {

                var trk = thePeer.tracksRef[j];

                try {
                    thePeer.rtcConnection.removeTrack(trk);
                } catch(ex) {
                    logEvent("Caught Error",getPlatform().platform + ": webAppCore.shutDownStreamPeer",ex.message);
                }

            }

            if(andClose) {
                thePeer.rtcConnection.close();
            }

            thePeer = null;
        }
    }

    function doStartStream() {

        if(streamCanvas.captureStream) {
            masterStream = streamCanvas.captureStream(15);
        } else {
            if(streamCanvas.mozCaptureStream) {
                masterStream = streamCanvas.mozCaptureStream(15);
            }
        }


        streamIsActive = true;

        setTimeout(announceStreamOnline,500);
    }

    function announceStreamOnline() {
        var sndMsg = {
            "destination": currentStreamChannel,
            "msg": {
                "type": "streaming",
                "code": "iamonline",
                "streaming": streamIsActive,
                "appid": Android.getApeMarketId()
            }
        };

        streamSocket.emit("gamemessage",sndMsg);

    }

    function onStreamSocketConnection() {
		
		if(!streamSocket) {
			return;
		}
		
        streamSocketConnected = true;
        streamSocket.emit("joinroom",currentStreamChannel);

        doStartStream(pendingStartStream);
        pendingStartStream = null;
    }

    function onStreamSocketMessage(message) {

        if(!message || !message.type || message.type != "streaming") {
            return;
        }

        var peer;

        if(message.code == "clientice") {
            if(message.desc) {
                peer = streamPeers[message.from];
                peer.rtcConnection.addIceCandidate(message.desc).catch(onStreamIceError);
            }
        }

        if(message.code == "useriswatching") {

            watchingPeers.push({
                u: message.username,
                a: message.avatar
            });

            if(streamEventListener) {
                streamEventListener(message);
            }
        }

        if(message.code == "userhasjoined") {

            if(streamEventListener) {
                streamEventListener(message);
            }

            streamWatchAccounceTimer += 999999;
        }


        if(message.code == "areyouonline") {
            announceStreamOnline();


            if(streamEventListener) {
                streamEventListener(message);
            }

        }

        if(message.code == "watchreq") {
            createNewStreamPeer(message.from);
        }

        if(message.code == "answer") {

            if(message.desc) {
                try {
                    peer = streamPeers[message.from];
                    peer.rtcConnection.setRemoteDescription(message.desc);
                } catch(ex) {
                    console.log(ex);
                }
            }


            if(streamEventListener) {
                streamEventListener(message);
            }
        }

        if(message.code == "clientice") {
            if(message.desc) {
                peer = streamPeers[message.from];
                peer.rtcConnection.addIceCandidate(message.desc).catch(onStreamIceError);
            }

        }
    }

    function onStreamSocketDisconnect() {

        streamSocket = null;
        streamSocketConnected = false;
    }

    function onStreamIceError(e) {
        console.log(e);
    }

    function createNewStreamPeer(uid) {

        if(streamPeers[uid]) {
            shutDownStreamPeer(streamPeers[uid]);
            streamPeers[uid] = null;
        }

        if(!masterStream) {
            return;
        }

        var streamConnectionConfig = {
            iceServers: useIceServers,
            peerIdentity: uid
        };

        var sih = new StreamItemHolder();
        sih.rtcConnection = new RTCPeerConnection(streamConnectionConfig);
        sih.rtcConnection.onicecandidate = onStreamingIceCandidate;
        sih.rtcConnection.onnegotiationneeded = onStreamingNegotiationNeeded;
        sih.rtcConnection.onsignalingstatechange = onStreamSignalStateChange;

        sih.uidref = uid;
        sih.tracksRef = [];
        sih.inNegotiation = false;

        streamPeers[uid] = sih;


        addStreamToPeer(sih,masterStream);

    }

    function animateStreamCanvas() {

        requestAnimationFrame(animateStreamCanvas);

        if(!streamIsActive) {
            return;
        }

        streamWatchAccounceTimer++;

        if(streamWatchAccounceTimer >= 1500) {
            announceStreamWatchCount();
            streamWatchAccounceTimer = 0;
            watchingPeers = [];

            if(streamSocket) {
                streamSocket.emit("gamemessage",{
                    "destination": currentStreamChannel,
                    "msg": {
                        "type": "streaming",
                        "code": "areyouwatching",
                        "appid": Android.getApeMarketId()
                    }
                });
            }


        }

        skipTick = !skipTick;

        if(skipTick) {
            return;
        }

        streamContext.clearRect(0,0,streamCanvas.width,streamCanvas.height);

        if(currentStreamCanvas) {
            streamContext.drawImage(currentStreamCanvas,0,0);
        }


        if(streamWebcamHold && streamDoCam && theVidReady) {

            if(!preFilterVideoCanvas) {
                preFilterVideoCanvas = document.createElement("canvas");
                preFilterVideoContext = preFilterVideoCanvas.getContext("2d");

                var vcW = webcamDisplayWidth;
                var vScale = streamWebcamHold.videoWidth / vcW;

                var vcH = Math.round(streamWebcamHold.videoHeight / vScale);

                preFilterVideoCanvas.width = vcW;
                preFilterVideoCanvas.height = vcH;
            }

            preFilterVideoContext.drawImage(streamWebcamHold,0,0,preFilterVideoCanvas.width,preFilterVideoCanvas.height);

            if(streamDoGreenScreen || doStreamBlackAndWhite || doStreamGameboy) {
                var imageData = preFilterVideoContext.getImageData(0, 0, preFilterVideoCanvas.width, preFilterVideoCanvas.height);

                var webcamData = imageData.data;

                for(var i = 0, n = webcamData.length; i < n; i += 4) {

                    var _r = webcamData[i];
                    var _g = webcamData[i + 1];
                    var _b = webcamData[i + 2];

                    if(streamDoGreenScreen) {
                        var diff = Math.abs(_r - webcamData[0]) + Math.abs(_g - webcamData[1]) + Math.abs(_b - webcamData[2]);
                        webcamData[i + 3] = (diff * diff) / greenscreenTolerance;
                    }

                    if(doStreamBlackAndWhite) {
                        var luma = (_r * 0.2126) + (_g * 0.7152) + (_b * 0.0722);

                        webcamData[i] = luma;
                        webcamData[i + 1] = luma;
                        webcamData[i + 2] = luma;
                    }

                    if(doStreamGameboy) {
                        var totVal = _r + _g + _b;
                        var useVal = 0;

                        if(totVal > 190) {
                            useVal = 85;
                        }

                        if(totVal > 380) {
                            useVal = 170;
                        }

                        if(totVal > 570) {
                            useVal = 255;
                        }

                        webcamData[i] = useVal;
                        webcamData[i + 1] = useVal;
                        webcamData[i + 2] = useVal;
                    }
                }

                preFilterVideoContext.putImageData(imageData,0,0);
            }

            streamContext.drawImage(preFilterVideoCanvas,0,streamCanvas.height - preFilterVideoCanvas.height);
        }

    }

    function announceStreamWatchCount() {

        if(!streamSocket) {
            return;
        }

        streamSocket.emit("gamemessage",{
            "destination": currentStreamChannel,
            "msg": {
                "type": "streaming",
                "code": "currentwatchcount",
                "count": watchingPeers.length,
                "appid": Android.getApeMarketId()
            }
        });

        if(streamEventListener) {
            streamEventListener({
                "type": "streaming",
                "code": "currentwatchcount",
                "count": watchingPeers.length,
                "appid": Android.getApeMarketId()
            });
        }
    }

    function addStreamToPeer(peer,stream) {

        stream.getTracks().forEach(function(track) {
            peer.tracksRef.push(peer.rtcConnection.addTrack(track, stream));
        });
    }

    function StreamItemHolder() {
        this.rtcConnection = null;
        this.uidref = null;
        this.tracksRef = [];
        this.inNegotiation = false;
    }

    function onStreamingIceCandidate(e) {

        var peer = getStreamItemForPeer(e.target);

        if(!peer) {
            return;
        }

        if(peer && e.candidate && peer.uidref) {
            streamSocket.emit("gamemessage",{
                "destination": currentStreamChannel,
                "msg": {
                    "type": "streaming",
                    "code": "setice",
                    "for": peer.uidref,
                    "ice": e.candidate,
                    "appid": Android.getApeMarketId()
                }
            });
        }

    }

    function onStreamingNegotiationNeeded() {

        var peer = getStreamItemForPeer(this);

        if(!peer) {
            return;
        }

        if(peer.inNegotiation) {
            return;
        }

        peer.rtcConnection.createOffer().then(function(offer) {



            peer.rtcConnection.setLocalDescription(offer);

            var sndMsg = {
                "destination": currentStreamChannel,
                "msg": {
                    "type": "streaming",
                    "code": "watchapprove",
                    "for": peer.uidref,
                    "offer": offer,
                    "appid": Android.getApeMarketId()
                }
            };

            streamSocket.emit("gamemessage",sndMsg);

        });
    }

    function onStreamSignalStateChange() {
        var peer = getStreamItemForPeer(this);

        if(!peer) {
            return;
        }

        if(peer.rtcConnection.signalingState == "stable") {
            peer.inNegotiation = false;
        }
    }

    function getStreamItemForPeer(peer) {


        var comparePeer;

        for(var uid in streamPeers) {

            comparePeer = streamPeers[uid].rtcConnection;

            if(comparePeer == peer) {
                return streamPeers[uid];
            }
        }

        return null;
    }
})(window, document);

