window.ColonyGame = {
    "meta": {
        "name":                 "My Colony",
        "titleTheme":           "#000000",
        "theme":                "#000000",
        "buildVersion":         "1.1.0",
        "releaseCode":          101,
        "tmpDefaultMapType":    "Red Planet",
        "tmpDefaultRace":       "Human",
        "tmpDefaultCiv":        "United Earth",
        "gridSize":             64,
        "mapHeight":            100,
        "mapWidth":             100,
        "newGameMessage":       "new-game-message",
        "betaInfo":             null,
        "feedbackUrl":          null,
        "communityUrl":         "https://www.ape-apps.com/viewpage.php?p=20",
        "colonistIcon":         "ind-colonist.png",
        "touristIcon":          "ind-tourist.png",
        "unemploymentIcon":     "ind-unemployed.png",
        "medicalIcon":          "ind-medical.png",
        "giftIndicator":        "ind-gift.png",
        "jobsIcon":             "ind-jobs.png",
        "earthIcon":            "earth.png",
        "colonistsEat":         "Food",
        "colonistsDrink":       "Water",
        "constructionTile":     "construction",
        "colonistsHarvest":     "Ore",
        "tenderResource":       "Money",
        "findBuilderIcon":      "ind-construction-2.png",
        "techWindowIcon":       "ind-research.png",
        "centerMapIcon":        "lander.png",
        "transModeIcon":        "ind-trans.png",
        "civicsIcon":           "ind-civic.png",
        "zoomInIcon":           "zoom-in.png",
        "zoomOutIcon":          "zoom-out.png",
        "gameStageResource":    "Atmosphere",
        "transactionCostResource":"Civics",
        "gameStages": [
            { "threshold": 0, "message": null },
            { "threshold": 250000, "message": "stage-1-intro" },
            { "threshold": 1000000, "message": "stage-2-intro" },
            { "threshold": 5000000, "message": "stage-3-intro" },
            { "threshold": 15000000, "message": "stage-4-intro" }
        ],
        "setFpsIndicator":      "ind-fps.png",
        "setPopperIndicator":   "ind-popper.png",
        "keyboardIndicator":    "ind-keyboard.png",
        "sidebarIndicator":     "ind-sidebar.png",
        "baseIndependenceCost": { "resource":"Civics","amount":250000 },
        "defaultMotherland":    "general-united-earth",
        "colonyServerBase":     "https://www.my-colony.com/colonies/",
        "colonyServerApi":      "https://www.my-colony.com/api.php",
        "colonyServerGameId":   "1",
        "foundingIndicator":    "ind-founding.png",
        "independenceIndicator":"ind-ind.png",
        "charterIndicator":     "ind-charter.png",
        "empireIndicator":      "ind-empire.png",
        "websiteIndicator":     "ind-website.png",
        "referenceLink":        "https://coloniae.space/reference",
        "renameIndicator":      "ind-rename.png",
        "cloudIndicator":       "ind-cloud.png",
        "mailIndicator":        "ind-mail.png",
        "approvalIndicator":    "ind-approval.png",
        "soundIndicator":       "ind-sound.png",
        "dimensionIndicator":   "ind-dims.png",
        "homelessIndicator":    "ind-homeless.png",
        "housingIndicator":     "brickhouse.png",
        "backIndicator":        "ind-back.png",
        "polLaborInd":          "ind-labor.png",
        "polWorkPolicyInd":     "refinery2.png",
        "polFiredrillInd":      "ind-firedrill.png",
        "podImmigradionInd":    "landingpad.png",
        "wPolLightInd":         "ind-work-light.png",
        "wPolNormalInd":        "ind-labor.png",
        "wPolOTInd":            "ind-work-ot.png",
        "wPolXtremeInd":        "ind-work-xt.png",
        "totalWorkforceInd":    "ind-totalwf.png",
        "indRetired":           "ind-work-light.png",
        "moneyShowerInd":       "ind-moneyshower.png",
        "taxCollectionInd":     "ind-taxcollect.png",
        "ageIndicator":         "ind-cloning.png",
        "privateCharterInd":    "ind-nocharter.png",
        "onlineModeInd":        "ind-onlinemode.png",
        "offlineModeInd":       "ind-noonline.png",
        "resourcesInd":         "ind-resources.png",
        "autosaveInd":          "ind-save.png",
        "compressionInd":       "ind-compression.png",
        "backupOnInd":          "ind-backup-on.png",
        "backupOffInd":         "ind-backup-off.png",
        "rationingInd":         "ind-rations.png",
        "annexInd":             "ind-annex.png",
        "podcastURL":           "https://www.ape-apps.com/viewpage.php?p=2655",
        "podcastName":          "My Colony Podcast",
        "fileShareUrlPrefix":   "web+my-colony://",
        "nativeClientURL":      "https://market.ape-apps.com/my-colony.html",
        "retirementRequirements": [
            {"resource":"Food","amount":8},
            {"resource":"Water","amount":4},
            {"resource":"Rum","amount":2},
            {"resource":"Cloth","amount":1},
            {"resource":"Toy","amount":1}
        ],
        "annexTileCost": [
            {"resource":"Money","amount":450},
            {"resource":"Civics","amount":200}
        ],
        "showBuildSidebarIcon": "ind-buildmenu.png",
        "fileExtension":        "mcz",
        "backupExtension":      "mcb",
        "socketServer":         "https://www.my-colony.com:2728",
        "lotteryInd":           "ind-lottery.png",
        "rescindInd":           "ind-rescind.png",
        "denounceInd":          "ind-denounce.png",
        "visitInd":             "ind-visitcolony.png",
        "printInd":             "ind-print.png",
        "shortcutInd":          "ind-shortcut.png",
        "pinnedLinkIcon":       "logo_file_type_mcs.png",
        "autobudgetInd":        "ind-autobudget.png",
        "indRRR":               "randium.jpeg",
        "allowConscription":    false,
        "conscriptionOptions":  null,
        "diplomacyIndicator":   "ind-diplomacy.png",
        "embassyCostPerSector": [
            {"resource":"Money","amount":3500},
            {"resource":"Civics","amount":4000}
        ],
        "extraReferenceName": null,
        "extraReferenceUrl": null,
        "extraReferenceIcon": null,
        "extraReferenceDisclaimer": null,
        "graphicsModFileFormat": "mct",
        "bulldozerToolIndicator": "ind-dozer.png",
        "sidebarBackgroundImage": null,
        "moddingCommunityUrl":  "https://www.ape-apps.com/viewpage.php?p=11365",
        "videoTutorialsIndicator": "ind-vidtut.png",
        "videoTutorialSubmissionUrl": "https://www.ape-apps.com/viewpage.php?p=285",
        "indAnimationSetting":  "ind-animation.png",
        "indLightingSetting":   "streetlight.png",
        "indDaynightSetting":   "ind-day-night.png",
        "indParticlesSetting":   "ind-particles.png",
        "releaseNotesServer":   "https://www.my-colony.com/releasenotes/",
        "indChainOn":           "ind-chain-on.png",
        "indChainOff":          "ind-chain-off.png",
        "indShowBuildList":     "ind-showbuildlist.png",
        "indPolicy":            "ind-civic.png",
        "indFlipBuilding":      "ind-rotate.png",
        "indMakeCenter":        "ind-makecenter.png",
        "indExportGoods":       "ind-export.png",
        "indImportGoods":       "ind-import.png",
        "indActivateBld":       "ind-power.png",
        "indDeactivateBld":     "ind-nopower.png",
        "indSell":              "ind-sell.png",
        "indRepair":            "ind-repair.png",
        "indTrade":             "ind-trade.png",
        "indUpgrade":           "ind-upgrade.png",
        "indMove":              "ind-move.png",
        "indHarvest":           "ind-harvest.png",
        "indPark":              "ind-park.png",
        "indDestroy":           "ind-destroy.png",
        "indDestruct":          "ind-destroy.png",
        "indDismiss":           "ind-dismiss.png",
        "indStats":             "ind-stats.png",
        "indDeployLoaded":      "ind-deployloaded.png",
        "customMapExtension":   "mcm",
        "mapEditorStartFlagAsset":"startflag",
        "localSocketPort":      2729,
        "localEventIcon":       "ind-networking.png",
        "onlineChatIcon":       "ind-chat.png",
        "onlineChatPrefix":     "mc-cw-",
        "indLowres":            "ind-lowres.png",
        "indDeport":            "ind-deportations.png",
        "indEducation":         "ind-education.png",
        "indSmallNumbers":      "ind-smallnumbers.png",
        "indStoreLimits":       "warehouse.png",
        "indCloneObject":       "ind-clone.png",
        "tokenScale":           0.4,
        "tokenTileHeight":      32,
        "indCheckbox":          "ind-checkbox.png",
        "subCityExtension":     "mcx",
        "useIsometric":         true,
        "smallCityAsset":       "smallcity",
        "apeMarketId":          351,
        "federationsIndicator": "ind-federations.png",
        "federationFoundationCost": [
            {"resource":"Money","amount":500000000},
            {"resource":"Research","amount":500000000},
            {"resource":"Civics","amount":100000000}
        ],
        "streamingOffIndicator": "ind-sreaming-off.png",
        "streamingOnIndicator": "ind-sreaming-on.png",
        "joinFederationIndicator": "ind-rendercheck.png",
        "encyclopediaIndicator": "ind-encyclopedia.png",
        "capitolIndicator": "ind-capitol.png",
        "fileTypeIcon":         "logo_file_type_mcs.png",
        "supportsColoniae": true,
        "mediumCityAsset":      "mediumcity",
        "layoutFileExt":        "mcl",
        "templateLayerInd":     "ind-templatelayers.png",
        "gamepadInd":           "ind-gamepad.png",
        "mpRegionInd":          "ind-mpregion.png",
        "globalChatChannel":    "my-colony",
        "merchStoreLink":       "https://teespring.com/stores/my-colony-store",
        "merchStoreInd":        "ind-mc-store.png",
        "streamingChatPrefix":  "mc-stream-",
        "flagIndicator":        "ind-ind.png",
        "contactAmbassadorInd": "ind-lrc.png",
        "customCategory":       "My Colony Universe",
        "customCategoryIcon":   "my-colony-128.png",
        "friendIndicator":      "ind-friends.png",
        "addFriendIndicator":   "ind-addfriend.png",
        "groupUnitsIndicator":  "ind-group.png",
        "ungroupUnitsIndicator":"ind-ungroup.png",
        "webcamOffIndicator":   "ind-webcam-off.png",
        "webcamOnIndicator":    "ind-webcam-on.png",
        "micOnIndicator":       "ind-microphone-on.png",
        "micOffIndicator":      "ind-microphone-off.png",
        "streamViewersInd":     "ind-viewstream.png",
        "regionBackupExt":      "mcr",
        "gameDataIndicator":    "ez-database-64.png",
        "utilitiesInd":         "ind-utilities.png"
    },
    "externalLink": {
        "name":                 "Colonial Tycoon",
        "icon":                 "colonial-tycoon-64.png",
        "default":              "https://apps.ape-apps.com/colonial-tycoon/",
        "gplay":                "market://details?id=com.ape.apps.colonial.tycoon",
        "amazon":               "amzn://apps/android?p=com.ape.apps.colonial.tycoon",
        "itunes":               "http://itunes.apple.com/us/app/colonial-tycoon/id1345508571?ls=1",
        "windows":              "https://www.microsoft.com/store/apps/9P9Z8TKVJ27X"
    },
    "videoTutorials": [
        {
            "title": "Red Planet Guide",
            "author": "Grind This Game",
            "url": "Tfw_-RB6D-Q"
        },
        {
            "title": "Lunar Guide",
            "author": "Grind This Game",
            "url": "B4nUnt795sE"
        },
        {
            "title": "Forest World Guide",
            "author": "Grind This Game",
            "url": "ucSu_fNNIK0"
        },
        {
            "title": "Zolarg Race",
            "author": "Grind This Game",
            "url": "ZUa_m7p9_Rs"
        },
        {
            "title": "Alpha Draconian Tutorial",
            "author": "HANGAR Cooperative Gameplay",
            "url": "ZAEt7WzAiTY"
        },
        {
            "title": "Touch Screen Road Building",
            "author": "Ape Apps",
            "url": "AuraLnR7fPU"
        }
    ],
    "messages": {
        "premiumNotice":        "premium-notice"
    },
    "sounds": {
        "defaultSelectSound":   "select",
        "explosion":            "explosion",
        "execution":            "execute",
        "contractBuy":          "snd-drop-coin-1",
        "buildOptionSelect":    "buildselect"
    },
    "soundtrack": [
        {
            "title":	"deeper",
            "format":	"midi",
            "seconds":	258
        },
        {
            "title":	"drone3",
            "format":	"midi",
            "seconds":	73
        },
        {
            "title":	"ebe",
            "format":	"midi",
            "seconds":	124
        },
        {
            "title":	"memoryaway",
            "format":	"midi",
            "seconds":	124
        },
        {
            "title":	"messenger",
            "format":	"midi",
            "seconds":	204
        },
        {
            "title":	"squadron",
            "format":	"midi",
            "seconds":	91
        },
        {
            "title":	"storm80",
            "format":	"midi",
            "seconds":	224
        },
        {
            "title":	"surreptitious",
            "format":	"midi",
            "seconds":	72
        }
    ],
    "achievements": {
        "gainIndependence":         117,
        "onlineTrade":              118,
        "hundredColonists":         119,
        "thousandColonists":        120,
        "tenthousandColonists":     121,
        "tenthousandTender":        122,
        "hundredThousandTender":    123,
        "millionTender":            124,
        "thousandTourists":         125
    },
    "kongregateStats": {
        "touristCount":             "Tourists",
        "populationCount":          "Population",
        "independenceCounter":      "Independence",
        "onlineTradeCounter":       "OnlineTrade",
        "tenderResourceCount":      "Money"
    },
    "mapTypes": [
        {
            "name":         "Earthlike",
            "icon":         "earth.png",
            "description":  "earthlike-planet-desc",
            "groundTile":[
                "ground4",
                "ground4",
                "ground4",
                "ground4",
                "ground4"
            ],
            "terrainFeatures": [
                { "name": "Ore Deposit", "abundance": 30 },
                { "name": "Gold Deposit", "abundance": 14 },
                { "name": "Aluminum Deposit", "abundance": 14 },
                { "name": "Uranium Deposit", "abundance": 8 },
                { "name": "Oil Deposit", "abundance": 10 },
                { "name": "Fir Trees", "abundance": 450 }
            ],
            "difficulty":   "Beginner",
            "startingTechs": ["Forest World Base","Red Planet Base","Advanced Microbiology","Low Gravity Husbandry","Clay Production"],
            "startingResourceModifiers": [
                { "name": "Atmosphere", "modifier": 5000000 },
                { "name": "Ore", "modifier": 7500 },
                { "name": "Money", "modifier": 5000 },
                { "name": "Food", "modifier": 2000 },
                { "name": "Water", "modifier": 2000 }
            ],
            "startingBuildings": [],
            "welcomeOverride": null,
            "weatherEffect": null,
            "colorEffect": null,
            "colorStrength": null,
            "riverTile": "River",
            "explosionDisasters": null,
            "riverPosition": "bottom",
            "oceanTile": null,
            "regionGroundTile": null,
            "tenthousandColonistsMapAch": 147,
            "groundShoreSheet": null,
            "groundShoreConnectors": null,
            "mapRiverColor": "#0090d4"
        },
        {
            "name":         "Red Planet",
            "icon":         "ind-redplanet.png",
            "description":  "red-planet-desc",
            "groundTile":[
                "ground",
                "ground2",
                "ground3",
                "ground4",
                "ground4"
            ],
            "terrainFeatures": [
                { "name": "Ore Deposit", "abundance": 30 },
                { "name": "Gold Deposit", "abundance": 10 },
                { "name": "Aluminum Deposit", "abundance": 8 },
                { "name": "Uranium Deposit", "abundance": 5 },
                { "name": "Ice Deposit", "abundance": 12 }
            ],
            "difficulty":   "Easy",
            "startingTechs": ["Red Planet Base"],
            "startingResourceModifiers": [], // { "name": "Water", "modifier": 30 }
            "startingBuildings": [],
            "welcomeOverride": null,
            "weatherEffect": null,
            "colorEffect": null,
            "colorStrength": null,
            "riverTile": null,
            "explosionDisasters": null,
            "riverPosition": null,
            "oceanTile": null,
            "regionGroundTile": null,
            "tenthousandColonistsMapAch": 146,
            "groundShoreSheet": null,
            "groundShoreConnectors": null,
            "mapRiverColor": null
        },
        {
            "name":         "Lunar",
            "icon":         "ind-lunar.png",
            "description":  "lunar-planet-desc",
            "groundTile":[
                "ground5",
                "ground5",
                "ground6",
                "ground7",
                "ground7"
            ],
            "difficulty":   "Medium",
            "terrainFeatures": [
                { "name": "Regolith Deposit", "abundance": 50 },
                { "name": "Gold Deposit", "abundance": 3 },
                { "name": "Aluminum Deposit", "abundance": 12 },
                { "name": "Uranium Deposit", "abundance": 18 }
            ],
            "startingTechs": ["Lunar Base"],
            "startingResourceModifiers": [], // { "name": "Water", "modifier": 30 }
            "startingBuildings": [],
            "welcomeOverride": "lunar-welcome-message",
            "weatherEffect": null,
            "colorEffect": null,
            "colorStrength": null,
            "riverTile": null,
            "explosionDisasters": null,
            "riverPosition": null,
            "oceanTile": null,
            "regionGroundTile": null,
            "tenthousandColonistsMapAch": 148,
            "groundShoreSheet": null,
            "groundShoreConnectors": null,
            "mapRiverColor": null
        },
        {
            "name":         "Forest World",
            "icon":         "ind-forest.png",
            "description":  "forest-planet-desc",
            "groundTile":[
                "ground4",
                "ground4",
                "ground4",
                "ground4",
                "ground4"
            ],
            "difficulty":   "Hard",
            "terrainFeatures": [
                { "name": "Gold Deposit", "abundance": 2 },
                { "name": "Aluminum Deposit", "abundance": 3 },
                { "name": "Pond", "abundance": 12 },
                { "name": "Oil Deposit", "abundance": 12 },
                { "name": "Fir Trees", "abundance": 450 },
                { "name": "Megatree", "abundance": 50 }
            ],
            "startingTechs": ["Forest World Base","Advanced Microbiology","Low Gravity Husbandry","Clay Production"],
            "startingResourceModifiers": [{ "name": "Atmosphere", "modifier": 5000000 }], // { "name": "Water", "modifier": 30 }
            "startingBuildings": [],
            "welcomeOverride": "forest-welcome-message",
            "weatherEffect": null,
            "colorEffect": null,
            "colorStrength": null,
            "riverTile": "River",
            "explosionDisasters": null,
            "riverPosition": "top",
            "oceanTile": null,
            "regionGroundTile": null,
            "tenthousandColonistsMapAch": 149,
            "groundShoreSheet": null,
            "groundShoreConnectors": null,
            "mapRiverColor": "#0090d4"
        },
        {
            "name":         "Sugarland",
            "icon":         "ind-sugarland.png",
            "description":  "sugarland-desc",
            "groundTile":[
                "ground8",
                "ground8",
                "ground8",
                "ground8",
                "ground8"
            ],
            "difficulty":   "Medium",
            "terrainFeatures": [
                { "name": "Sugarcane", "abundance": 350 },
                { "name": "Ore Deposit", "abundance": 10 },
                { "name": "Gold Deposit", "abundance": 15 },
                { "name": "Aluminum Deposit", "abundance": 28 },
                { "name": "Pond", "abundance": 25 },
                { "name": "Fir Trees", "abundance": 80 }
            ],
            "startingTechs": ["Sugarland Base"],
            "startingResourceModifiers": [{ "name": "Atmosphere", "modifier": 5000000 }], // { "name": "Water", "modifier": 30 }
            "startingBuildings": [],
            "welcomeOverride": null,
            "weatherEffect": null,
            "colorEffect": null,
            "colorStrength": null,
            "riverTile": null,
            "explosionDisasters": null,
            "riverPosition": null,
            "oceanTile": null,
            "regionGroundTile": null,
            "tenthousandColonistsMapAch": 150,
            "groundShoreSheet": null,
            "groundShoreConnectors": null,
            "mapRiverColor": null
        },
        {
            "name":         "Asteroid",
            "icon":         "ind-asteroid.png",
            "description":  "asteroid-planet-desc",
            "groundTile":[
                "ground9",
                "ground10",
                "ground11",
                "ground12",
                "ground12"
            ],
            "difficulty":   "Hard",
            "terrainFeatures": [
                { "name": "Regolith Deposit", "abundance": 30 },
                { "name": "Gold Deposit", "abundance": 35 },
                { "name": "Ice Deposit", "abundance": 4 },
                { "name": "Diamond Deposit", "abundance": 15 }
            ],
            "startingTechs": ["Asteroid Base"],
            "startingResourceModifiers": [], // { "name": "Water", "modifier": 30 }
            "startingBuildings": [],
            "welcomeOverride": null,
            "weatherEffect": null,
            "colorEffect": null,
            "colorStrength": null,
            "riverTile": null,
            "explosionDisasters": null,
            "riverPosition": null,
            "oceanTile": null,
            "regionGroundTile": null,
            "tenthousandColonistsMapAch": 151,
            "groundShoreSheet": null,
            "groundShoreConnectors": null,
            "mapRiverColor": null
        },
        {
            "name":         "Abandoned World",
            "icon":         "ind-abandonedworld.png",
            "description":  "abandonedworld-planet-desc",
            "groundTile":[
                "ground8",
                "ground8",
                "ground8",
                "ground8",
                "ground8"
            ],
            "difficulty":   "Hard",
            "terrainFeatures": [
                { "name": "Regolith Deposit", "abundance": 20 },
                { "name": "Gold Deposit", "abundance": 15 },
                { "name": "Aluminum Deposit", "abundance": 5 },
                { "name": "Sugarcane", "abundance": 150 },
                { "name": "Fir Trees", "abundance": 350 },
                { "name": "Pond", "abundance": 8 }
            ],
            "startingTechs": ["Abandoned World Base"],
            "startingResourceModifiers": [{ "name": "Atmosphere", "modifier": 5000000 }], // { "name": "Water", "modifier": 30 }
            "startingBuildings": ["Ancient Statue","Ancient Statue","Ancient Statue","Ancient Temple","Ancient Temple"],
            "welcomeOverride": null,
            "weatherEffect": null,
            "colorEffect": "#D81B60",
            "colorStrength": 0.45,
            "riverTile": "Ether",
            "explosionDisasters": null,
            "riverPosition": "top",
            "oceanTile": null,
            "regionGroundTile": null,
            "tenthousandColonistsMapAch": 152,
            "groundShoreSheet": null,
            "groundShoreConnectors": null,
            "mapRiverColor": "#D81B60"
        },
        {
            "name":         "Ice World",
            "icon":         "ind-iceworld.png",
            "description":  "iceworld-planet-desc",
            "groundTile":[
                "ground14",
                "ground14",
                "ground14",
                "ground14",
                "ground14"
            ],
            "difficulty":   "Brutal",
            "terrainFeatures": [
                { "name": "Gold Deposit", "abundance": 3 },
                { "name": "Ice Deposit", "abundance": 40 },
                { "name": "Diamond Deposit", "abundance": 10 },
                { "name": "Crystalline Deposit", "abundance": 30 },
                { "name": "Uranium Deposit", "abundance": 6 },
                { "name": "Aluminum Deposit", "abundance": 6 }
            ],
            "startingTechs": ["Ice World Base"],
            "startingResourceModifiers": [], // { "name": "Water", "modifier": 30 }
            "startingBuildings": [],
            "welcomeOverride": null,
            "weatherEffect": "snowing",
            "colorEffect": "#050a38",
            "colorStrength": 0.65,
            "riverTile": null,
            "explosionDisasters": null,
            "riverPosition": null,
            "oceanTile": null,
            "regionGroundTile": null,
            "tenthousandColonistsMapAch": 153,
            "groundShoreSheet": null,
            "groundShoreConnectors": null,
            "mapRiverColor": null
        },
        {
            "name":         "Lava World",
            "icon":         "ind-lavaworld.png",
            "description":  "lavaworld-planet-desc",
            "groundTile":[
                "ground10",
                "ground15",
                "ground15",
                "ground16",
                "ground16"
            ],
            "difficulty":   "Death",
            "terrainFeatures": [
                { "name": "Ore Deposit", "abundance": 30 },
                { "name": "Diablo Crystalline", "abundance": 50 }
            ],
            "startingTechs": ["Lava World Base"],
            "startingResourceModifiers": [{ "name": "Atmosphere", "modifier": 500000000 }],
            "startingBuildings": [],
            "welcomeOverride": "lava-world-intro",
            "weatherEffect": "embers",
            "colorEffect": "#212121",
            "colorStrength":0.75,
            "riverTile": "Lava",
            "explosionDisasters": [
                {
                    "name": "Eruption",
                    "description": null,
                    "tip": "eurption-tip",
                    "vibrates": true,
                    "frequency": 100000,
                    "radius": 20,
                    "elements": [
                        { "terrain": "Lava", "abundance": 300 },
                        { "terrain": "Ore Deposit", "abundance": 5 },
                        { "terrain": "Gold Deposit", "abundance": 3 },
                        { "terrain": "Uranium Deposit", "abundance": 3 },
                        { "terrain": "Diamond Deposit", "abundance": 2 },
                        { "terrain": "Aluminum Deposit", "abundance": 1 },
                        { "terrain": "Cobalt Deposit", "abundance": 4 }
                    ]
                }
            ],
            "riverPosition": null,
            "oceanTile": null,
            "regionGroundTile": null,
            "tenthousandColonistsMapAch": 154,
            "groundShoreSheet": null,
            "groundShoreConnectors": null,
            "mapRiverColor": "#FF4B00"
        },
        {
            "name":         "Desert World",
            "icon":         "ind-desertworld.png",
            "description":  "desertworld-planet-desc",
            "groundTile":[
                "sand4",
                "sand4",
                "sand4",
                "sand4",
                "sand4"
            ],
            "difficulty":   "Medium",
            "terrainFeatures": [
                { "name": "Ore Deposit", "abundance": 3 },
                { "name": "Aluminum Deposit", "abundance": 12 },
                { "name": "Gold Deposit", "abundance": 25 },
                { "name": "Uranium Deposit", "abundance": 20 },
                { "name": "River", "abundance": 6 },
                { "name": "Diamond Deposit", "abundance": 6 },
                { "name": "Crystalline Deposit", "abundance": 2 },
                { "name": "Oil Deposit", "abundance": 8 },
                { "name": "Fir Trees", "abundance": 5 }
            ],
            "startingTechs": ["Desert World Base"],
            "startingResourceModifiers": [{ "name": "Atmosphere", "modifier": 5000000 }],
            "startingBuildings": [],
            "welcomeOverride": null,
            "weatherEffect": null,
            "colorEffect": null,
            "colorStrength":null,
            "riverTile": null,
            "explosionDisasters": null,
            "riverPosition": null,
            "oceanTile": null,
            "regionGroundTile": null,
            "tenthousandColonistsMapAch": 155,
            "groundShoreSheet": null,
            "groundShoreConnectors": null,
            "mapRiverColor": null
        },
        {
            "name":         "Water World",
            "icon":         "waterworld.png",
            "description":  "water-world-desc",
            "groundTile":[
                "ground17",
                "ground17",
                "ground17",
                "ground17",
                "ground17"
            ],
            "difficulty":   "Medium",
            "terrainFeatures": [
                { "name": "Ore Deposit", "abundance": 15 },
                { "name": "Aluminum Deposit", "abundance": 12 },
                { "name": "Gold Deposit", "abundance": 25 },
                { "name": "Uranium Deposit", "abundance": 20 },
                { "name": "Diamond Deposit", "abundance": 8 },
                { "name": "Oil Deposit", "abundance": 10 },
                { "name": "Palm Trees 1", "abundance": 220 },
                { "name": "Palm Trees 2", "abundance": 220 }
            ],
            "startingTechs": ["Water World Base","Advanced Microbiology"],
            "startingResourceModifiers": [{ "name": "Atmosphere", "modifier": 5000000 }],
            "startingBuildings": [],
            "welcomeOverride": null,
            "weatherEffect": null,
            "colorEffect": null,
            "colorStrength":null,
            "riverTile": null,
            "explosionDisasters": null,
            "riverPosition": null,
            "oceanTile": "Salt Water",
            "regionGroundTile":[
                "water2",
                "water2",
                "water2",
                "water2",
                "water2"
            ],
            "tenthousandColonistsMapAch": 156,
            "groundShoreSheet": [
                "grass17shore",
                "grass17shore",
                "grass17shore",
                "grass17shore",
                "grass17shore"
            ],
            "groundShoreConnectors": ["Salt Water","River","Water Pool"],
            "mapRiverColor": null
        }
    ],
    "races": [
        {
            "name":         "Human",
            "defaultSprites": [
                ["colonist1"],
                ["colonist1"],
                ["colonist2"],
                ["colonist3"],
                ["colonist3"]
            ],
            "touristSprites": [
                ["tourist3"],
                ["tourist3"],
                ["tourist3"],
                ["tourist3"],
                ["tourist3"]
            ],
            "startingTechs": ["Human Base"],
            "description":  "human-description",
            "narcotics":    ["Ant Paste"],
            "raceColor": "#0288D1"
        },
        {
            "name":         "Insectoids",
            "defaultSprites": [
                ["insectoid2"],
                ["insectoid2"],
                ["insectoid2"],
                ["insectoid2"],
                ["insectoid2"]
            ],
            "touristSprites": [
                ["insectoid2"],
                ["insectoid2"],
                ["insectoid2"],
                ["insectoid2"],
                ["insectoid2"]
            ],
            "startingTechs": ["Insectoid Base"],
            "description":  "insectoid-description",
            "narcotics":    ["Wood"],
            "raceColor": "#424242"
        },
        {
            "name":         "Reptilian",
            "defaultSprites": [
                ["reptilian1"],
                ["reptilian1"],
                ["reptilian2"],
                ["reptilian3"],
                ["reptilian3"]
            ],
            "touristSprites": [
                ["tourist3"],
                ["tourist3"],
                ["tourist3"],
                ["tourist3"],
                ["tourist3"]
            ],
            "startingTechs": ["Reptilian Base"],
            "description":  "reptilian-description",
            "narcotics":    ["Sugar"],
            "raceColor": "#311B92"
        }
    ],
    "civilizations": [
        {
            "name":                 "United Earth",
            "description":          "ue-description",
            "race":                 "Human",
            "icon":                 "ind-ue.png",
            "startingColonists":    2,
            "startingBuilding":     "Lander",
            "startingVehicles":     ["Rover","Lunar Rover","Forest Rover"],
            "startingTechs":        ["United Earth Base"],
            "welcomeMessage":       "welcome-message",
            "availableMaps":        ["Earthlike","Red Planet","Lunar","Water World","Forest World"],
            "serverHomeworld":      "1",
            "startingResourceModifiers": [{ "name": "Wheel", "modifier": 25 }],
            "backstory":            "ue-extended-backstory"
        },
        {
            "name":                 "Zolarg Empire",
            "description":          "zolargprime-description",
            "race":                 "Insectoids",
            "icon":                 "ind-zolarg.png",
            "startingColonists":    2,
            "startingBuilding":     null,
            "startingVehicles":     ["Queen","Worker Drone","Tundrabug","Extremeobug","Regobug"],
            "startingTechs":        ["Zolarg Base"],
            "welcomeMessage":       "insectoid-welcome-message",
            "availableMaps":        ["Sugarland","Water World","Abandoned World","Ice World","Lava World"],
            "serverHomeworld":      "2",
            "startingResourceModifiers": [],
            "backstory":            "zolarg-extended-backstory"
        },
        {
            "name":                 "League of Independent States",
            "description":          "lis-description",
            "race":                 "Human",
            "icon":                 "ind-lis.png",
            "startingColonists":    2,
            "startingBuilding":     "LIS Lander",
            "startingVehicles":     ["LIS Rover","LIS Rover","Tundra Rover","Used Ore Miner"],
            "startingTechs":        ["LIS Base"],
            "welcomeMessage":       "lunar-welcome-message",
            "availableMaps":        ["Water World","Asteroid","Abandoned World","Ice World"],
            "serverHomeworld":      "3",
            "startingResourceModifiers": [{ "name": "Microchip", "modifier": 10 },{ "name": "Aluminum", "modifier": 40 },{ "name": "Wheel", "modifier": 20 }],
            "backstory":            "lis-extended-backstory"
        },
        {
            "name":                 "Alpha Draconians",
            "description":          "draconians-description",
            "race":                 "Reptilian",
            "icon":                 "ind-reptilians.png",
            "startingColonists":    0,
            "startingBuilding":     null,
            "startingVehicles":     ["Construction Probe"],
            "startingTechs":        ["Draconian Base"],
            "welcomeMessage":       "draconians-welcome-message",
            "availableMaps":        ["Desert World","Water World","Abandoned World","Lava World"],
            "serverHomeworld":      "4",
            "startingResourceModifiers": [{ "name": "Money", "modifier": 500 },{ "name": "Food", "modifier": -50 },{ "name": "Water", "modifier": -350 },{ "name": "Gold", "modifier": 1500 },{ "name": "Aluminum", "modifier": 1500 },{ "name": "Antanium", "modifier": 1500 },{ "name": "Uranium", "modifier": 1500 }],
            "backstory":            "draconian-extended-backstory"
        }
    ],
    "tiles": [
        {
            "name":         "ground",
            "image":        "ground.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "startflag",
            "image":        "startflag.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "pond",
            "image":        "pond.png",
            "tileWidth":    192,
            "canFlip":      false
            
        },
        {
            "name":         "ground2",
            "image":        "ground2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ground3",
            "image":        "ground3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ground4",
            "image":        "ground4.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ground5",
            "image":        "ground5.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ground6",
            "image":        "ground6.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ground7",
            "image":        "ground7.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ground8",
            "image":        "ground8.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "lander",
            "image":        "lander.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "landerairborne",
            "image":        "lander-airborne.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "rover",
            "image":        "rover.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "spireknowledge",
            "image":        "spireknowledge.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "sphrad",
            "image":        "sphrad.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "mine",
            "image":        "mine.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "bloodletting",
            "image":        "bloodletting.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "oildeposit",
            "image":        "oildeposit.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "regmine",
            "image":        "regmine.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "pavement",
            "image":        "pavement.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "pavementlight",
            "image":        "pavement1light.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "greenhouse",
            "image":        "greenhouse.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "greenhouseworking",
            "image":        "greenhouseworking.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "silo",
            "image":        "silo.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "atmosgen",
            "image":        "atmosgen.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "atmosgen2",
            "image":        "atmosgen2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "atmosgen3",
            "image":        "atmosgen3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "factory",
            "image":        "factory.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "builder",
            "image":        "builder.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "deposit",
            "image":        "deposit.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "refinery",
            "image":        "refinery.png",
            "tileWidth":    160,
            "canFlip":      false
        },
        {
            "name":         "miner",
            "image":        "miner.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "panel1",
            "image":        "panel1.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "colonist1",
            "image":        "colonist1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "colonist2",
            "image":        "colonist2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "colonist3",
            "image":        "colonist3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "medic1",
            "image":        "medic1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "medic2",
            "image":        "medic2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "medic3",
            "image":        "medic3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "arbiter1",
            "image":        "arbiter1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "arbiter2",
            "image":        "arbiter2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "arbiter3",
            "image":        "arbiter3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "landingpad",
            "image":        "landingpad.png",
            "tileWidth":    192,
            "canFlip":      false
        },
        {
            "name":         "smallshelter",
            "image":        "smallshelter.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "construction",
            "image":        "construction.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "chopshop",
            "image":        "chopshop.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "golddeposit",
            "image":        "golddeposit.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "goldminer",
            "image":        "goldminer.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "goldrefinery",
            "image":        "goldrefinery.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "goldsmelter",
            "image":        "goldsmelter.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "smalllab",
            "image":        "smalllab.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "advancedhydro",
            "image":        "advancedhydro.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "solartower",
            "image":        "solartower.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "builder2",
            "image":        "builder2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "pavement2",
            "image":        "pavement2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "pavement2light",
            "image":        "pavement2light.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "largesilo",
            "image":        "largesilo.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "refinery2",
            "image":        "refinery2.png",
            "tileWidth":    160,
            "canFlip":      true
        },
        {
            "name":         "refinery3",
            "image":        "refinery3.png",
            "tileWidth":    160,
            "canFlip":      true
        },
        {
            "name":         "conferencehall",
            "image":        "conferencehall.png",
            "tileWidth":    160,
            "canFlip":      true
        },
        {
            "name":         "goldmine",
            "image":        "goldmine.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "rescomplex",
            "image":        "rescomplex.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "greendome",
            "image":        "greendome.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "massdriver",
            "image":        "massdriver.png",
            "tileWidth":    288,
            "canFlip":      true
        },
        {
            "name":         "chipfactory",
            "image":        "chipfactory.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "uecongress",
            "image":        "uecongress.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "bluecollar1",
            "image":        "bluecollar1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "bluecollar2",
            "image":        "bluecollar2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "bluecollar3",
            "image":        "bluecollar3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "botanist1",
            "image":        "botanist1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "botanist2",
            "image":        "botanist2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "botanist3",
            "image":        "botanist3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "civiccenter",
            "image":        "civiccenter.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "politician1",
            "image":        "politician1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "politician2",
            "image":        "politician2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "politician3",
            "image":        "politician3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "statue1",
            "image":        "statue1.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "orefracking",
            "image":        "orefracking.png",
            "tileWidth":    160,
            "canFlip":      true
        },
        {
            "name":         "gldsynth",
            "image":        "gldsynth.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "hatchery",
            "image":        "hatchery.png",
            "tileWidth":    224,
            "canFlip":      true
        },
        {
            "name":         "icedeposit",
            "image":        "icedeposit.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "uraniumdeposit",
            "image":        "uraniumdeposit.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "aluminumdeposit",
            "image":        "aluminumdeposit.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "icechipper",
            "image":        "icechipper.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "atmoscondensor",
            "image":        "atmoscondensor.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "smalltank",
            "image":        "smalltank.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "waterpump",
            "image":        "waterpump.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "aluminumrefinery",
            "image":        "aluminum-refinery.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "aluminumminer",
            "image":        "aluminumminer.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "watertower",
            "image":        "watertower.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "uraniumminer",
            "image":        "uraniumminer.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "nuclearplant",
            "image":        "nuclear-plant.png",
            "tileWidth":    256,
            "canFlip":      true
        },
        {
            "name":         "bacteriafarm",
            "image":        "bacteriafarm.png",
            "tileWidth":    160,
            "canFlip":      false
        },
        {
            "name":         "greenbot",
            "image":        "greenbot.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "firtrees",
            "image":        "firtrees.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "aspentree",
            "image":        "aspentree.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "firstaid",
            "image":        "firstaid.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "medicalclinic",
            "image":        "medical-clinic.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "lumbermill",
            "image":        "lumbermill.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "wall",
            "image":        "wall.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "lumberbot",
            "image":        "lumberbot.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "treefarm",
            "image":        "treefarm.png",
            "tileWidth":    320,
            "canFlip":      true
        },
        {
            "name":         "sfhouse",
            "image":        "sfhouse.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "brickhouse",
            "image":        "brickhouse.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "megabot",
            "image":        "megabot.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "lgwatertower",
            "image":        "lgwatertower.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "uraniumenrichment",
            "image":        "uraniumenrichment.png",
            "tileWidth":    256,
            "canFlip":      false
        },
        {
            "name":         "largeres",
            "image":        "largeres.png",
            "tileWidth":    160,
            "canFlip":      true
        },
        {
            "name":         "largerres",
            "image":        "largerres.png",
            "tileWidth":    160,
            "canFlip":      true
        },
        {
            "name":         "capitol",
            "image":        "capitol.png",
            "tileWidth":    416,
            "canFlip":      true
        },
        {
            "name":         "subtfood",
            "image":        "subtfood.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "bank",
            "image":        "bank.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "boardoftrade",
            "image":        "boardoftrade.png",
            "tileWidth":    256,
            "canFlip":      false
        },
        {
            "name":         "pyramideye",
            "image":        "pyramideye.svg",
            "tileWidth":    384,
            "canFlip":      true
        },
        {
            "name":         "digsite",
            "image":        "digsite.png",
            "tileWidth":    320,
            "canFlip":      false
        },
        {
            "name":         "digsite2",
            "image":        "digsite2.png",
            "tileWidth":    320,
            "canFlip":      true
        },
        {
            "name":         "landfill",
            "image":        "landfill.png",
            "tileWidth":    320,
            "canFlip":      false
        },
        {
            "name":         "aluminumgenerator",
            "image":        "aluminumgenerator.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "etbuilder",
            "image":        "etbuilder.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "giorgioinstitute",
            "image":        "giorgioinstitute.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "consulate",
            "image":        "consulate.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "distillery",
            "image":        "distillery.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "rumcellar",
            "image":        "rumcellar.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "relaybooth",
            "image":        "relaybooth.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "pub",
            "image":        "pub.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "decfirtrees",
            "image":        "decfirtrees.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "cloningfacility",
            "image":        "cloningfacility.png",
            "tileWidth":    224,
            "canFlip":      true
        },
        {
            "name":         "advcloning",
            "image":        "advcloning.png",
            "tileWidth":    224,
            "canFlip":      true
        },
        {
            "name":         "claymine",
            "image":        "claymine.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "claybot",
            "image":        "claybot.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "potteryworks",
            "image":        "potteryworks.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "warehouse",
            "image":        "warehouse.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "subhousing",
            "image":        "subhousing.png",
            "tileWidth":    256,
            "canFlip":      false
        },
        {
            "name":         "chipfactory2",
            "image":        "chipfactory2.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "supermarket",
            "image":        "supermarket.png",
            "tileWidth":    224,
            "canFlip":      true
        },
        {
            "name":         "megamart",
            "image":        "megamart.png",
            "tileWidth":    224,
            "canFlip":      true
        },
        {
            "name":         "chipfactory3",
            "image":        "chipfactory3.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "brickfactory",
            "image":        "brickfactory.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "pavement3",
            "image":        "pavement3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "pavement4",
            "image":        "pavement4.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "warehouse2",
            "image":        "warehouse2.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "sheepfarm",
            "image":        "sheepfarm.png",
            "tileWidth":    384,
            "canFlip":      true
        },
        {
            "name":         "textilemill",
            "image":        "textilemill.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "sweatshop",
            "image":        "sweatshop.png",
            "tileWidth":    256,
            "canFlip":      false
        },
        {
            "name":         "sweatshop4",
            "image":        "sweatshop4.png",
            "tileWidth":    256,
            "canFlip":      true
        },
        {
            "name":         "luxtower",
            "image":        "luxtower.png",
            "tileWidth":    224,
            "canFlip":      true
        },
        {
            "name":         "aliencondensor",
            "image":        "aliencondensor.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "hydropower",
            "image":        "hydropower.png",
            "tileWidth":    192,
            "canFlip":      false
        },
        {
            "name":         "largepark",
            "image":        "largepark.png",
            "tileWidth":    576,
            "canFlip":      false
        },
        {
            "name":         "water1",
            "image":        "water1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "water1shore",
            "image":        "water1-shore.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "lava1",
            "image":        "lava1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "lava1shore",
            "image":        "lava1-shore.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "lol",
            "image":        "lol.png",
            "tileWidth":    192,
            "canFlip":      true
        },
        {
            "name":         "statue2",
            "image":        "statue2.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "flowersred",
            "image":        "flowers-red.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "goldenshelter",
            "image":        "goldenshelter.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "largeclinic",
            "image":        "largeclinic.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "hipsterbar",
            "image":        "hipsterbar.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "warehouse3",
            "image":        "warehouse3.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "quantumwater",
            "image":        "quantumwater.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "brickwall",
            "image":        "brickwall.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "regolith",
            "image":        "regolith.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "lunarrover",
            "image":        "lunarrover.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "helextractor",
            "image":        "helextractor.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "regcompact",
            "image":        "regcompact.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "waterextract",
            "image":        "waterextract.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "regpath",
            "image":        "regpath.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "heltank",
            "image":        "heltank.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "regminer",
            "image":        "regminer.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "woodhut",
            "image":        "woodhut.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "forestrover",
            "image":        "forestrover.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "waterwell",
            "image":        "waterwell.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "potatopatch",
            "image":        "potatopatch.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "charcoalhut",
            "image":        "charcoalhut.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "coalcompact",
            "image":        "coalcompact.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "coalburn",
            "image":        "coalburn.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "charfactory",
            "image":        "charfactory.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "mulchpath",
            "image":        "mulchpath.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "oiltank",
            "image":        "oiltank.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "crudebot",
            "image":        "crudebot.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "flowerspurple",
            "image":        "flowers-purple.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "flowersblue",
            "image":        "flowers-blue.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "flowerswhite",
            "image":        "flowers-white.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "oilplant",
            "image":        "oilplant.png",
            "tileWidth":    192,
            "canFlip":      true
        },
        {
            "name":         "grass",
            "image":        "grass.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "quantumfood",
            "image":        "quantumfood.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "pavement5",
            "image":        "pavement5.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "oilsynthlab",
            "image":        "oilsynthlab.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "oilsynthlab2",
            "image":        "oilsynthlab2.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "plastfact",
            "image":        "plastfact.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "sweatshop2",
            "image":        "sweatshop2.png",
            "tileWidth":    256,
            "canFlip":      false
        },
        {
            "name":         "scientist1",
            "image":        "scientist1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "scientist2",
            "image":        "scientist2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "scientist3",
            "image":        "scientist3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "whitecollar1",
            "image":        "whitecollar1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "whitecollar2",
            "image":        "whitecollar2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "whitecollar3",
            "image":        "whitecollar3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "spaceport",
            "image":        "spaceport.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "motel",
            "image":        "motel.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "tourist3",
            "image":        "tourist3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "hotel",
            "image":        "hotel.png",
            "tileWidth":    160,
            "canFlip":      false
        },
        {
            "name":         "smcasino",
            "image":        "smcasino.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "giftshop",
            "image":        "giftshop.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "zoo",
            "image":        "zoo.png",
            "tileWidth":    512,
            "canFlip":      false
        },
        {
            "name":         "bluehouse",
            "image":        "bluehouse.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "pavement6",
            "image":        "pavement6.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "flowersyellow",
            "image":        "flowers-yellow.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "obeliskindependence",
            "image":        "obeliskindependence.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "restaurant",
            "image":        "restaurant.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "resort",
            "image":        "resort.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "mall",
            "image":        "mall.png",
            "tileWidth":    640,
            "canFlip":      false
        },
        {
            "name":         "museum",
            "image":        "musuem.png",
            "tileWidth":    192,
            "canFlip":      false
        },
        {
            "name":         "galfreight",
            "image":        "galfreight.png",
            "tileWidth":    288,
            "canFlip":      false
        },
        {
            "name":         "statue3",
            "image":        "statue3.png",
            "tileWidth":    192,
            "canFlip":      false
        },
        {
            "name":         "charcoalpile",
            "image":        "charcoalpile.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "alienpower",
            "image":        "alienpower.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "pavement7",
            "image":        "pavement7.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "mound",
            "image":        "mound.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "sugarcane",
            "image":        "sugarcane.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "insectoid1",
            "image":        "insectoid1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "insectoid2",
            "image":        "insectoid2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "waterbug",
            "image":        "waterbug.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "lumberbug",
            "image":        "lumberbug.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "orebug",
            "image":        "orebug.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "feastingarea",
            "image":        "feastingarea.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "watervats",
            "image":        "watervats.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "pastetank",
            "image":        "pastetank.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "pastepath",
            "image":        "pastepath.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "broodcenter",
            "image":        "broodcenter.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "goldburrow",
            "image":        "goldburrow.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "goldbug",
            "image":        "goldbug.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "sugarpower",
            "image":        "sugarpower.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "insectoidmint",
            "image":        "insectoidmint.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "antaniumsmelter",
            "image":        "antanium-smelter.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "eldersmound",
            "image":        "eldersmound.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "miningoperation",
            "image":        "miningoperation.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "zolargstatue",
            "image":        "zolargstatue.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "foodfortification",
            "image":        "foodfortification.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "capitol2",
            "image":        "capitol2.png",
            "tileWidth":    416,
            "canFlip":      true
        },
        {
            "name":         "capitol3",
            "image":        "capitol3.png",
            "tileWidth":    416,
            "canFlip":      true
        },
        {
            "name":         "consulate2",
            "image":        "consulate2b.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "consulate3",
            "image":        "consulate3b.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "sand",
            "image":        "sand.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "capitol4",
            "image":        "capitol4.svg",
            "tileWidth":    416,
            "canFlip":      true
        },
        {
            "name":         "flag0",
            "image":        "flag0.svg",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "flag1",
            "image":        "flag1.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "flag2",
            "image":        "flag2.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "flag3",
            "image":        "flag3.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "flag4",
            "image":        "flag4.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "capitol5",
            "image":        "capitol5.svg",
            "tileWidth":    416,
            "canFlip":      true
        },
        {
            "name":         "healingpods",
            "image":        "healingpods.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "sugarfarm",
            "image":        "sugarfarm.png",
            "tileWidth":    256,
            "canFlip":      true
        },
        {
            "name":         "brewpit",
            "image":        "brewpit.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "unholybrewpit",
            "image":        "unholybrewpit.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "gentelbugsclub",
            "image":        "gentelbugsclub.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "lghe3",
            "image":        "lghe3.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "plaque",
            "image":        "plaque.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "capitol6",
            "image":        "capitol6.svg",
            "tileWidth":    416,
            "canFlip":      true
        },
        {
            "name":         "elevator",
            "image":        "elevator.png",
            "tileWidth":    288,
            "canFlip":      false
        },
        {
            "name":         "condrone",
            "image":        "condrone.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "turbodrone",
            "image":        "turbodrone.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "robofactory",
            "image":        "robofactory.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "restower",
            "image":        "restower.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "restowerblue",
            "image":        "restowerblue.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "consulate4",
            "image":        "consulate4.svg",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "wetmound",
            "image":        "wetmound.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "wetcone",
            "image":        "wetcone.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "moneypit",
            "image":        "moneypit.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "exportcannon",
            "image":        "exportcannon.png",
            "tileWidth":    160,
            "canFlip":      false
        },
        {
            "name":         "lumberyard",
            "image":        "lumberyard.png",
            "tileWidth":    160,
            "canFlip":      false
        },
        {
            "name":         "horrorhouse",
            "image":        "horrorhouse.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "regolithextractor",
            "image":        "regolithextractor.png",
            "tileWidth":    192,
            "canFlip":      false
        },
        {
            "name":         "bank2",
            "image":        "bank2.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "steelyard",
            "image":        "steelyard.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "subtcharcoal",
            "image":        "subtcharcoal.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "altarofcommerce",
            "image":        "altarofcommerce.png",
            "tileWidth":    192,
            "canFlip":      true
        },
        {
            "name":         "highcommand",
            "image":        "highcommand.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "highercommand",
            "image":        "highercommand.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "unholycommand",
            "image":        "unholycommand.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "supplypile",
            "image":        "supplypile.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "commandpost",
            "image":        "commandpost.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "commandpost2",
            "image":        "commandpost2.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "consulate5",
            "image":        "consulate5.svg",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "smstadium",
            "image":        "smstadium.png",
            "tileWidth":    256,
            "canFlip":      false
        },
        {
            "name":         "synthetictextiles",
            "image":        "synthetictextiles.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "lislander",
            "image":        "lislander.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "ground9",
            "image":        "ground9.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ground10",
            "image":        "ground10.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ground11",
            "image":        "ground11.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ground12",
            "image":        "ground12.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "diamonddeposit",
            "image":        "diamonddeposit.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "lisrover",
            "image":        "lisrover.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "sugarrover",
            "image":        "sugarrover.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "crystalminer",
            "image":        "crystalminer.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "statue4",
            "image":        "statue4.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "ancienttemple",
            "image":        "ancienttemple.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "medstadium",
            "image":        "medstadium.png",
            "tileWidth":    256,
            "canFlip":      false
        },
        {
            "name":         "grass2",
            "image":        "grass2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "hoops",
            "image":        "hoops.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "mailbox",
            "image":        "mailbox.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "sand2",
            "image":        "sand2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "sand3",
            "image":        "sand3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "oiltank2",
            "image":        "oiltank2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "uraniumsilo",
            "image":        "uraniumsilo.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "flag5",
            "image":        "flag5.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "flag6",
            "image":        "flag6.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "flag7",
            "image":        "flag7.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "greenhome",
            "image":        "greenhome.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "sweatshop3",
            "image":        "sweatshop3.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "sweetnerfactory",
            "image":        "sweetnerfactory.png",
            "tileWidth":    224,
            "canFlip":      true
        },
        {
            "name":         "oreenrichmentfacility",
            "image":        "oreenrichmentfacility.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "goldsign",
            "image":        "goldsign.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "desertskull",
            "image":        "desertskull.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "deckchairs",
            "image":        "deckchairs.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "dune",
            "image":        "dune.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "palm2",
            "image":        "palm2.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "palm1",
            "image":        "palm1.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "cactus3",
            "image":        "cactus3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "cactus2",
            "image":        "cactus2.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "cactus1",
            "image":        "cactus1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "fountain",
            "image":        "fountain.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "vertfarm",
            "image":        "vertfarm.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "lumbercamp",
            "image":        "lumbercamp.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "powerspire",
            "image":        "powerspire.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "unholypowerspire",
            "image":        "unholypowerspire.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "statue5",
            "image":        "statue5.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "statue6",
            "image":        "statue6.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "diamondrefinery",
            "image":        "diamondrefinery.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "diamondminer",
            "image":        "diamondminer.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "colonialassembly",
            "image":        "colonialassembly.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "bmbazzar",
            "image":        "bmbazzar.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "aluminumhive",
            "image":        "aluminumhive.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "alumibug",
            "image":        "alumibug.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ancientbug",
            "image":        "ancientbug.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "jewelrystore",
            "image":        "jewelrystore.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "independencehall",
            "image":        "independencehall.png",
            "tileWidth":    256,
            "canFlip":      false
        },
        {
            "name":         "independencehall2",
            "image":        "independencehall2.png",
            "tileWidth":    256,
            "canFlip":      false
        },
        {
            "name":         "independencehall3",
            "image":        "independencehall3.svg",
            "tileWidth":    256,
            "canFlip":      true
        },
        {
            "name":         "leaguetrade",
            "image":        "leaguetrade.png",
            "tileWidth":    192,
            "canFlip":      true
        },
        {
            "name":         "antsynth",
            "image":        "antsynth.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "quantumdistillery",
            "image":        "quantumdistillery.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "yellowhouse",
            "image":        "yellowhouse.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "centerai",
            "image":        "centerai.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "smsugarprocessor",
            "image":        "smsugarprocessor.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "triantrefine",
            "image":        "triantrefine.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "theshanty",
            "image":        "theshanty.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "thefunctional",
            "image":        "thefunctional.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "thegoldman",
            "image":        "thegoldman.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "exomound",
            "image":        "exomound.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "thecrystalline",
            "image":        "thecrystalline.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "thesunrise",
            "image":        "thesunrise.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "diplomaticoutpost",
            "image":        "diplomaticoutpost.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "shrineoftruth",
            "image":        "shrineoftruth.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "transmissionhub",
            "image":        "transmissionhub.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "robofactory2",
            "image":        "robofactory2.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "alummine",
            "image":        "alummine.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "megatree",
            "image":        "megatree.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "deeptrans",
            "image":        "deeptrans.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "pavement8",
            "image":        "pavement8.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "plastfact2",
            "image":        "plastfact2.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "diplomat1",
            "image":        "diplomat1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "stargate",
            "image":        "stargate.png",
            "tileWidth":    192,
            "canFlip":      true
        },
        {
            "name":         "arcology",
            "image":        "arcology.png",
            "tileWidth":    256,
            "canFlip":      true
        },
        {
            "name":         "shrineofmystics",
            "image":        "shrineofmystics.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "crystaldeposit",
            "image":        "crystaldeposit.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "syncrystaldeposit",
            "image":        "syncrystaldeposit.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "diablocrystals",
            "image":        "diablocrystals.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ground14",
            "image":        "ground14.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "monumentheroes",
            "image":        "monumentheroes.svg",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "fantasyland",
            "image":        "fantasyland.png",
            "tileWidth":    256,
            "canFlip":      true
        },
        {
            "name":         "oresynth",
            "image":        "oresynth.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "rescomplexblue",
            "image":        "rescomplexblue.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "bigplayhouse",
            "image":        "bigplayhouse.png",
            "tileWidth":    194,
            "canFlip":      false
        },
        {
            "name":         "micromine",
            "image":        "micromine.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "regfurnace",
            "image":        "regfurnace.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "compactedsnow",
            "image":        "compactedsnow.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "diamondcrystalreactor",
            "image":        "diamondcrystalreactor.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "alienenrichment",
            "image":        "alienenrichment.png",
            "tileWidth":    256,
            "canFlip":      false
        },
        {
            "name":         "tundrabug",
            "image":        "snowbug.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "extremeobug",
            "image":        "extremeobug.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "quantumsugarcloner",
            "image":        "quantumsugarcloner.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "crystalmound",
            "image":        "crystalmound.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "oretunnel",
            "image":        "oretunnel.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "microincinerator",
            "image":        "microincinerator.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "smrecyclingcenter",
            "image":        "smrecyclingcenter.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "medrecyclingcenter",
            "image":        "medrecyclingcenter.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "smtrashpit",
            "image":        "smtrashpit.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "advancedmed",
            "image":        "advancedmed.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "incinerator",
            "image":        "incinerator.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "unholypit",
            "image":        "unholypit.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "unholymound",
            "image":        "unholymound.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "coremine",
            "image":        "coremine.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "smlightpost",
            "image":        "smlightpost.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "smredlightpost",
            "image":        "smredlightpost.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "smgreenlightpost",
            "image":        "smgreenlightpost.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "streetlight",
            "image":        "streetlight.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "glowgoo",
            "image":        "glowgoo.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "pasteboiler",
            "image":        "pasteboiler.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "atmosscrubber",
            "image":        "atmosscrubber.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "wall2",
            "image":        "wall2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "wall2light",
            "image":        "wall2light.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "diamondsolar",
            "image":        "diamondsolar.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "bureaucracy",
            "image":        "bureaucracy.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "clothfarm",
            "image":        "clothfarm.png",
            "tileWidth":    192,
            "canFlip":      true
        },
        {
            "name":         "cauldron",
            "image":        "cauldron.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "pastesynth",
            "image":        "pastesynth.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "rawmatdepot",
            "image":        "rawmatdepot.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "customsprocessing",
            "image":        "customsprocessing.png",
            "tileWidth":    256,
            "canFlip":      true
        },
        {
            "name":         "pastespa",
            "image":        "pastespa.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "ground15",
            "image":        "ground15.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ground16",
            "image":        "ground16.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "vaporizer",
            "image":        "vaporizer.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "queen",
            "image":        "queen.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "obsidiandeposit",
            "image":        "obsidiandeposit.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "rovertransport",
            "image":        "rovertransport.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "obsidiobug",
            "image":        "obsidiobug.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "reptilian1",
            "image":        "reptilian1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "reptilian2",
            "image":        "reptilian2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "reptilian3",
            "image":        "reptilian3.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "sand4",
            "image":        "sand4.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "constructionprobe",
            "image":        "constructionprobe.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "poweredmatsilo",
            "image":        "poweredmatsilo.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "microreactor",
            "image":        "microreactor.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "slavegate",
            "image":        "slavegate.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "antaniumimpactor",
            "image":        "antaniumimpactor.png",
            "tileWidth":    96,
            "canFlip":      true
        },
        {
            "name":         "microcondenser",
            "image":        "microcondenser.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "pavement9",
            "image":        "pavement9.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "fairwarning",
            "image":        "fairwarning.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "autohydro",
            "image":        "autohydro.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "basicden",
            "image":        "basicden.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "familyden",
            "image":        "familyden.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "medstargate",
            "image":        "medstargate.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "torturebooth",
            "image":        "torturebooth.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "dronepad",
            "image":        "dronepad.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "uraextract",
            "image":        "uraextract.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "goldgrower",
            "image":        "goldgrower.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "aluminumgrower",
            "image":        "aluminumgrower.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "trashtransporter",
            "image":        "trashtransporter.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "pasteextractor",
            "image":        "pasteextractor.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "arbsquare1",
            "image":        "arbsquare1.svg",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "arbsquare2",
            "image":        "arbsquare2.svg",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "oreevaporator",
            "image":        "oreevaporator.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "pebbles",
            "image":        "pebbles.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "prairieweed",
            "image":        "prairieweed.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "regenchamber",
            "image":        "regenchamber.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "coalconvert",
            "image":        "coalconvert.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "pillaroflight",
            "image":        "pillaroflight.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "crudeextract",
            "image":        "crudeextract.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "brewmasterden",
            "image":        "brewmasterden.png",
            "tileWidth":    96,
            "canFlip":      false
        },
        {
            "name":         "councilarb",
            "image":        "councilarb.svg",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "realnews",
            "image":        "realnews.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "relicstudies",
            "image":        "relicstudies.png",
            "tileWidth":    192,
            "canFlip":      true
        },
        {
            "name":         "adultdaycare",
            "image":        "adultdaycare.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "smschool",
            "image":        "smschool.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "smschool2",
            "image":        "smschool2.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "smschool3",
            "image":        "smschool3.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "transacademy",
            "image":        "transacademy.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "ancientinc",
            "image":        "ancientinc.png",
            "tileWidth":    224,
            "canFlip":      true
        },
        {
            "name":         "diamondsynth",
            "image":        "diamondsynth.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "unicomm",
            "image":        "unicomm.svg",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "obsidianfurnace",
            "image":        "obsidianfurnace.png",
            "tileWidth":    96,
            "canFlip":      true
        },
        {
            "name":         "cautionsign",
            "image":        "cautionsign.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "gravcompress",
            "image":        "gravcompress.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "galartsexpo",
            "image":        "galartsexpo.svg",
            "tileWidth":    192,
            "canFlip":      true
        },
        {
            "name":         "patriden",
            "image":        "patriden.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "obeliskofplenty",
            "image":        "obeliskofplenty.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "unholyobsidian",
            "image":        "unholyobsidian.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "crystalbot",
            "image":        "crystalbot.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "darkpavementlit",
            "image":        "darkpavementlit.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "solarroad",
            "image":        "solarroad.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "aliensolar",
            "image":        "aliensolar.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "wheelfactory",
            "image":        "wheelfactory.png",
            "tileWidth":    192,
            "canFlip":      false
        },
        {
            "name":         "statue7",
            "image":        "statue7.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "shipyard",
            "image":        "shipyard.svg",
            "tileWidth":    512,
            "canFlip":      true
        },
        {
            "name":         "starport",
            "image":        "starport.png",
            "tileWidth":    768,
            "canFlip":      true
        },
        {
            "name":         "taxcollection",
            "image":        "taxcollection.svg",
            "tileWidth":    192,
            "canFlip":      true
        },
        {
            "name":         "chiptransporter",
            "image":        "chiptransporter.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "advmicroreactor",
            "image":        "advmicroreactor.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "wheellodge",
            "image":        "wheellodge.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "constructionmech",
            "image":        "constructionmech.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "deployedconstruction",
            "image":        "deployedconstruction.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "hipsterlofts",
            "image":        "hipsterlofts.png",
            "tileWidth":    224,
            "canFlip":      false
        },
        {
            "name":         "crystallineenrichment",
            "image":        "crystallineenrichment.png",
            "tileWidth":    96,
            "canFlip":      true
        },
        {
            "name":         "diamondbot",
            "image":        "diamondbot.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "unholydiamondspawner",
            "image":        "unholydiamondspawner.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "unholydiamonds",
            "image":        "unholydiamonds.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "tilered",
            "image":        "tilered.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "tileorange",
            "image":        "tileorange.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "tileyellow",
            "image":        "tileyellow.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "tilegreen",
            "image":        "tilegreen.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "tileblue",
            "image":        "tileblue.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "tileindigo",
            "image":        "tileindigo.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "tilepurple",
            "image":        "tilepurple.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "tilemagenta",
            "image":        "tilemagenta.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "tileteal",
            "image":        "tileteal.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "tilebrown",
            "image":        "tilebrown.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "tilewhite",
            "image":        "tilewhite.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "tileblack",
            "image":        "tileblack.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "hedgewall",
            "image":        "hedgewall.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "footpath",
            "image":        "footpath.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "aagoldgen",
            "image":        "aagoldgen.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "turboet",
            "image":        "turboet.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "regzapper",
            "image":        "regzapper.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "obsgen",
            "image":        "obsgen.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "plastfact3",
            "image":        "plastfact3.png",
            "tileWidth":    224,
            "canFlip":      true
        },
        {
            "name":         "transtri",
            "image":        "transtri.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "rawmatextract",
            "image":        "rawmatextract.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "smallcity",
            "image":        "smallcity.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "mediumcity",
            "image":        "mediumcity.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "lawchamber",
            "image":        "lawchamber.svg",
            "tileWidth":    416,
            "canFlip":      true
        },
        {
            "name":         "dracemb",
            "image":        "dracemb.svg",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "clayden",
            "image":        "clayden.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "homelessshelter",
            "image":        "homelessshelter.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "crystallinedrill",
            "image":        "crystallinedrill.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "bugsaw",
            "image":        "bugsaw.png",
            "tileWidth":    96,
            "canFlip":      true
        },
        {
            "name":         "petropit",
            "image":        "petropit.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "petrocone",
            "image":        "petrocone.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "unholyuraniumgenerator",
            "image":        "unholyuraniumgenerator.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "chamberfathers",
            "image":        "chamberfathers.svg",
            "tileWidth":    416,
            "canFlip":      true
        },
        {
            "name":         "water2",
            "image":        "water2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "water2shore",
            "image":        "water2shore.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "palm1b",
            "image":        "palm1b.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "palm2b",
            "image":        "palm2b.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "bridge1",
            "image":        "bridge1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "bridge1b",
            "image":        "bridge1b.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "goldreducer",
            "image":        "goldreducer.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "embridge",
            "image":        "embridge.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "embridgens",
            "image":        "embridgens.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ground17",
            "image":        "ground17.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "grass17shore",
            "image":        "grass17shore.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "sandpath",
            "image":        "sandpath.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "fisherbothut",
            "image":        "fisherbothut.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "fisherbot",
            "image":        "fisherbot.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "steelbridge",
            "image":        "steelbridge.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "steelbridgeb",
            "image":        "steelbridgeb.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "alumbridge",
            "image":        "alumbridge.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "alumbridgeb",
            "image":        "alumbridgeb.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "goldbridge",
            "image":        "goldbridge.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "goldbridgeb",
            "image":        "goldbridgeb.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "fisherbug",
            "image":        "fisherbug.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "pastepontoon",
            "image":        "pastepontoon.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "shipworks",
            "image":        "shipworks.svg",
            "tileWidth":    352,
            "canFlip":      true
        },
        {
            "name":         "chamberofkings",
            "image":        "chamberofkings.svg",
            "tileWidth":    416,
            "canFlip":      true
        },
        {
            "name":         "scheepswerf",
            "image":        "scheepswerf.png",
            "tileWidth":    384,
            "canFlip":      false
        },
        {
            "name":         "usedminer",
            "image":        "usedminer.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "researchconvert",
            "image":        "researchconvert.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "ether1",
            "image":        "ether1.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ether1shore",
            "image":        "ether1shore.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "etherextractor",
            "image":        "etherextractor.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "etherprocessor",
            "image":        "etherprocessor.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "etherbath",
            "image":        "etherbath.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "petroboiler",
            "image":        "petroboiler.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "subsugar",
            "image":        "subsugar.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "smserverbld",
            "image":        "smserverbld.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "cybercoinmine",
            "image":        "cybercoinmine.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "smserverfarm",
            "image":        "smserverfarm.png",
            "tileWidth":    96,
            "canFlip":      true
        },
        {
            "name":         "galstockmarket",
            "image":        "galstockmarket.png",
            "tileWidth":    160,
            "canFlip":      true
        },
        {
            "name":         "lisdataintercept",
            "image":        "lisdataintercept.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "smsoftwarestudio",
            "image":        "smsoftwarestudio.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "netschool",
            "image":        "netschool.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "smalllab2",
            "image":        "smalllab2.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "onlineofficeofficebld",
            "image":        "onlineofficebld.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "arcade",
            "image":        "arcade.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "colonimulation",
            "image":        "colonimulation.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "civiccenter2",
            "image":        "civiccenter2.png",
            "tileWidth":    96,
            "canFlip":      true
        },
        {
            "name":         "hfnode",
            "image":        "hfnode.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "dsinterceptor",
            "image":        "dsinterceptor.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "slabofproc",
            "image":        "slabofproc.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "cirfoundry",
            "image":        "cirfoundry.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "intpadthought",
            "image":        "intpadthought.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "centerforautocoding",
            "image":        "centerforautocoding.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "thoughttower",
            "image":        "thoughttower.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "hallofelders",
            "image":        "hallofelders.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "moundonlinebus",
            "image":        "moundonlinebus.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "aipainting",
            "image":        "aipainting.svg",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "antaniumimpactor2",
            "image":        "antaniumimpactor2.png",
            "tileWidth":    96,
            "canFlip":      true
        },
        {
            "name":         "codersden",
            "image":        "codersden.png",
            "tileWidth":    96,
            "canFlip":      true
        },
        {
            "name":         "itstudiocomplex",
            "image":        "itstudiocomplex.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "megabotdeluxe",
            "image":        "megabotdeluxe.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "ethertreefarm",
            "image":        "ethertreefarm.png",
            "tileWidth":    320,
            "canFlip":      true
        },
        {
            "name":         "aliennuclearplant",
            "image":        "aliennuclearplant.png",
            "tileWidth":    256,
            "canFlip":      true
        },
        {
            "name":         "newsstation",
            "image":        "newsstation.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "imppropaganda",
            "image":        "imppropaganda.svg",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "onlinebmoffice",
            "image":        "onlinebmoffice.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "hackercamp",
            "image":        "hackercamp.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "largeserverbuilding",
            "image":        "largeserverbuilding.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "proxyserverbld",
            "image":        "proxyserverbld.png",
            "tileWidth":    96,
            "canFlip":      true
        },
        {
            "name":         "electronicschopshop",
            "image":        "electronicschopshop.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "moundofscholars",
            "image":        "moundofscholars.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "pastetank2",
            "image":        "pastetank2.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "autopsyslab",
            "image":        "autopsyslab.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "artwarehouse",
            "image":        "artwarehouse.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "counterfeitmarket",
            "image":        "counterfeitmarket.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "aluminumgenerator2",
            "image":        "aluminumgenerator2.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "shipyard2",
            "image":        "shipyard2.svg",
            "tileWidth":    512,
            "canFlip":      true
        },
        {
            "name":         "deptfishstudies",
            "image":        "deptfishstudies.png",
            "tileWidth":    192,
            "canFlip":      true
        },
        {
            "name":         "meshplatform",
            "image":        "meshplatform.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "saltwaterpump",
            "image":        "saltwaterpump.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "saltwatertank",
            "image":        "saltwatertank.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "desalinationfacility",
            "image":        "desalinationfacility.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "fishery",
            "image":        "fishery.png",
            "tileWidth":    224,
            "canFlip":      true
        },
        {
            "name":         "fishcannery",
            "image":        "fishcannery.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "aquaring",
            "image":        "aquaring.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "aquascrubber",
            "image":        "aquascrubber.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "seabeetfarm",
            "image":        "seabeetfarm.png",
            "tileWidth":    192,
            "canFlip":      true
        },
        {
            "name":         "aquamound",
            "image":        "aquamound.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "claypit",
            "image":        "claypit.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "smolderingpit",
            "image":        "smolderingpit.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "quantumsupplypile",
            "image":        "quantumsupplypile.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "quantumfoodfortification",
            "image":        "quantumfoodfortification.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "petroplant",
            "image":        "petroplant.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "microdistiller",
            "image":        "microdistiller.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "watervats2",
            "image":        "watervats2.png",
            "tileWidth":    96,
            "canFlip":      true
        },
        {
            "name":         "houserunningrum",
            "image":        "houserunningrum.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "laborcamp",
            "image":        "laborcamp.png",
            "tileWidth":    192,
            "canFlip":      true
        },
        {
            "name":         "megamound",
            "image":        "megamound.png",
            "tileWidth":    256,
            "canFlip":      true
        },
        {
            "name":         "potterbugmound",
            "image":        "potterbugmound.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "deluxecommand",
            "image":        "deluxecommand.png",
            "tileWidth":    224,
            "canFlip":      true
        },
        {
            "name":         "unholytower",
            "image":        "unholytower.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "glazedmound",
            "image":        "glazedmound.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "smartpowerspire",
            "image":        "smartpowerspire.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "quantumslabofproc",
            "image":        "quantumslabofproc.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "quantumwetcone",
            "image":        "quantumwetcone.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "quantumcirfoundry",
            "image":        "quantumcirfoundry.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "unholygoldgrower",
            "image":        "unholygoldgrower.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "crystalgenerationchamber",
            "image":        "crystalgenerationchamber.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "toweroftruth",
            "image":        "toweroftruth.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "antaniumblastfurnace",
            "image":        "antaniumblastfurnace.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "etherreactor",
            "image":        "etherreactor.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "designatedswimarea",
            "image":        "designatedswimarea.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "regobug",
            "image":        "regobug.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "regolithincinerator",
            "image":        "regolithincinerator.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "potofether",
            "image":        "potofether.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "etherbug",
            "image":        "etherbug.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "galacticstargate",
            "image":        "galacticstargate.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "radcrystalfarm",
            "image":        "radcrystalfarm.png",
            "tileWidth":    192,
            "canFlip":      false
        },
        {
            "name":         "advmatsilo",
            "image":        "advmatsilo.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "subslum",
            "image":        "subslum.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "rawfishdiner",
            "image":        "rawfishdiner.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "deepdrilling",
            "image":        "deepdrilling.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "coralradiator",
            "image":        "coralradiator.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "offshoreslum",
            "image":        "offshoreslum.png",
            "tileWidth":    192,
            "canFlip":      true
        },
        {
            "name":         "dracarus",
            "image":        "dracarus.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "diamondextractor",
            "image":        "diamondextractor.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "cobaltdeposit",
            "image":        "cobaltdeposit.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "cobaltextractor",
            "image":        "cobaltextractor.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "diamondcobaltreactor",
            "image":        "diamondcobaltreactor.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "basiccrystalfurnace",
            "image":        "basiccrystalfurnace.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "suppertimearena",
            "image":        "suppertimearena.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "turbomicroreactor",
            "image":        "turbomicroreactor.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "primativeroboticslab",
            "image":        "primativeroboticslab.png",
            "tileWidth":    128,
            "canFlip":      true
        },
        {
            "name":         "advchiptransporter",
            "image":        "advchiptransporter.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "autoswnode",
            "image":        "autoswnode.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "antradiator",
            "image":        "antradiator.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "uhfnode",
            "image":        "uhfnode.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "nimatsilo",
            "image":        "nimatsilo.png",
            "tileWidth":    128,
            "canFlip":      false
        },
        {
            "name":         "etherrover",
            "image":        "etherrover.png",
            "tileWidth":    64,
            "canFlip":      false
        },
        {
            "name":         "etherstorage",
            "image":        "etherstorage.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "intclinic",
            "image":        "intclinic.png",
            "tileWidth":    64,
            "canFlip":      true
        },
        {
            "name":         "hospital",
            "image":        "hospital.png",
            "tileWidth":    192,
            "canFlip":      true
        },
        {
            "name":         "university",
            "image":        "university.png",
            "tileWidth":    320,
            "canFlip":      true
        },
        {
            "name":         "pasteclinic",
            "image":        "pasteclinic.png",
            "tileWidth":    128,
            "canFlip":      true
        }
    ],
    "resources": [
        {
            "name":         "Money",
            "color":        "#8BC34A",
            "max":          null,
            "indicator":    "$",
            "starting":     2500,
            "icon":         "ind-coin.png",
            "basePrice":    0,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Sugar",
            "color":        "#eeeeff",
            "max":          -1,
            "indicator":    "s",
            "starting":     0,
            "icon":         "ind-sugar.png",
            "basePrice":    100,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Food",
            "color":        "#4CAF50",
            "max":          -1,
            "indicator":    "f",
            "starting":     50,
            "icon":         "ind-food.png",
            "basePrice":    100,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Fish",
            "color":        "#4CAF50",
            "max":          -1,
            "indicator":    "fi",
            "starting":     0,
            "icon":         "ind-zoology.png",
            "basePrice":    100,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      false
        },
        {
            "name":         "Salt Water",
            "color":        "#00BCD4",
            "max":          -1,
            "indicator":    "sa",
            "starting":     0,
            "icon":         "ind-saltwater.png",
            "basePrice":    1,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Water",
            "color":        "#2196F3",
            "max":          -1,
            "indicator":    "w",
            "starting":     350,
            "icon":         "ind-water.png",
            "basePrice":    20,
            "isEssential":  false,
            "catchupAmount":3000000,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Ant Paste",
            "color":        "#E6EE9C",
            "max":          -1,
            "indicator":    "ap",
            "starting":     0,
            "icon":         "ind-antpaste.png",
            "basePrice":    200,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Helium 3",
            "color":        "#cccccc",
            "max":          -1,
            "indicator":    "he",
            "starting":     0,
            "icon":         "ind-he3.png",
            "basePrice":    400,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Rum",
            "color":        "#b38600",
            "max":          -1,
            "indicator":    "ru",
            "starting":     0,
            "icon":         "ind-rum.png",
            "basePrice":    200,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Wheel",
            "color":        "#333333",
            "max":          -1,
            "indicator":    "wh",
            "starting":     0,
            "icon":         "ind-wheel.png",
            "basePrice":    200,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Wood",
            "color":        "#795548",
            "max":          -1,
            "indicator":    "wo",
            "starting":     0,
            "icon":         "ind-wood.png",
            "basePrice":    25,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Charcoal",
            "color":        "#333333",
            "max":          -1,
            "indicator":    "ch",
            "starting":     0,
            "icon":         "ind-charcoal.png",
            "basePrice":    200,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Ore",
            "color":        "#b34700",
            "max":          -1,
            "indicator":    "o",
            "starting":     0,
            "icon":         "ind-ore.png",
            "basePrice":    150,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Regolith",
            "color":        "#555555",
            "max":          -1,
            "indicator":    "re",
            "starting":     0,
            "icon":         "ind-regolith.png",
            "basePrice":    100,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Clay",
            "color":        "#deaa87",
            "max":          -1,
            "indicator":    "c",
            "starting":     0,
            "icon":         "ind-clay.png",
            "basePrice":    100,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Obsidian",
            "color":        "#1f1c24",
            "max":          -1,
            "indicator":    "ob",
            "starting":     0,
            "icon":         "ind-obsidian.png",
            "basePrice":    1000000,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Wool",
            "color":        "#deaa87",
            "max":          -1,
            "indicator":    "wl",
            "starting":     0,
            "icon":         "ind-wool.png",
            "basePrice":    200,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Steel",
            "color":        "#cccccc",
            "max":          -1,
            "indicator":    "s",
            "starting":     0,
            "icon":         "ind-steel.png",
            "basePrice":    350,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Antanium",
            "color":        "#844c0a",
            "max":          -1,
            "indicator":    "an",
            "starting":     0,
            "icon":         "ind-antanium.png",
            "basePrice":    350,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Oil",
            "color":        "#222222",
            "max":          -1,
            "indicator":    "oi",
            "starting":     0,
            "icon":         "ind-oil.png",
            "basePrice":    500,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Ether",
            "color":        "#D81B60",
            "max":          -1,
            "indicator":    "et",
            "starting":     0,
            "icon":         "ind-ether.png",
            "basePrice":    500,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Gold",
            "color":        "#ffcc00",
            "max":          -1,
            "indicator":    "g",
            "starting":     0,
            "icon":         "ind-gold.png",
            "basePrice":    950,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Aluminum",
            "color":        "#CFD8DC",
            "max":          -1,
            "indicator":    "al",
            "starting":     0,
            "icon":         "ind-aluminum.png",
            "basePrice":    1000,
            "isEssential":  false,
            "catchupAmount":3000,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Diamond",
            "color":        "#eeeeee",
            "max":          -1,
            "indicator":    "di",
            "starting":     0,
            "icon":         "ind-diamond.png",
            "basePrice":    1000,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Uranium",
            "color":        "#8BC34A",
            "max":          -1,
            "indicator":    "u",
            "starting":     0,
            "icon":         "ind-uranium.png",
            "basePrice":    3500,
            "isEssential":  false,
            "catchupAmount":3000,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Cobalt",
            "color":        "#0066ff",
            "max":          -1,
            "indicator":    "co",
            "starting":     0,
            "icon":         "ind-cobalt.png",
            "basePrice":    3500,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Crystalline",
            "color":        "#0277BD",
            "max":          -1,
            "indicator":    "cr",
            "starting":     0,
            "icon":         "ind-crystal.png",
            "basePrice":    4000,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Pottery",
            "color":        "#006064",
            "max":          -1,
            "indicator":    "p",
            "starting":     0,
            "icon":         "ind-pottery.png",
            "basePrice":    300,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Plastic",
            "color":        "#dbe2e3",
            "max":          -1,
            "indicator":    "p",
            "starting":     0,
            "icon":         "ind-plastic.png",
            "basePrice":    5000,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Bricks",
            "color":        "#ff3030",
            "max":          -1,
            "indicator":    "b",
            "starting":     0,
            "icon":         "ind-bricks.png",
            "basePrice":    450,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Cloth",
            "color":        "#ffffcc",
            "max":          -1,
            "indicator":    "cl",
            "starting":     0,
            "icon":         "ind-cloth.png",
            "basePrice":    400,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Toy",
            "color":        "#c83737",
            "max":          -1,
            "indicator":    "t",
            "starting":     0,
            "icon":         "ind-toy.png",
            "basePrice":    800,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Software",
            "color":        "#d7eef4",
            "max":          -1,
            "indicator":    "sw",
            "starting":     0,
            "icon":         "ind-software.png",
            "basePrice":    1000,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Microchip",
            "color":        "#558B2F",
            "max":          -1,
            "indicator":    "m",
            "starting":     0,
            "icon":         "ind-microchip.png",
            "basePrice":    4000,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Robot",
            "color":        "#999999",
            "max":          -1,
            "indicator":    "ro",
            "starting":     0,
            "icon":         "ind-robot.png",
            "basePrice":    5000,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Painting",
            "color":        "#64B5F6",
            "max":          -1,
            "indicator":    "pa",
            "starting":     0,
            "icon":         "ind-painting.png",
            "basePrice":    100000,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Alien Artifact",
            "color":        "#78909C",
            "max":          -1,
            "indicator":    "ar",
            "starting":     0,
            "icon":         "ind-artifact.png",
            "basePrice":    900000,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Ancient Instructions",
            "color":        "#37a6c8",
            "max":          -1,
            "indicator":    "in",
            "starting":     0,
            "icon":         "ind-instructions.png",
            "basePrice":    1000000,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Alien Relic",
            "color":        "#33691E",
            "max":          -1,
            "indicator":    "rl",
            "starting":     0,
            "icon":         "ind-relic.png",
            "basePrice":    900000,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Triantanium",
            "color":        "#bcd35f",
            "max":          -1,
            "indicator":    "ta",
            "starting":     0,
            "icon":         "ind-triantanium.png",
            "basePrice":    2500000,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Starship",
            "color":        "#E3F2FD",
            "max":          -1,
            "indicator":    "ss",
            "starting":     0,
            "icon":         "ind-starship.png",
            "basePrice":    5000000000,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      true
        },
        {
            "name":         "Atmosphere",
            "color":        "#81D4FA",
            "max":          null,
            "indicator":    "a",
            "starting":     0,
            "icon":         "ind-air.png",
            "basePrice":    0,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    15000000,
            "canGift":      false
        },
        {
            "name":         "Trash",
            "color":        "#827717",
            "max":          null,
            "indicator":    "tr",
            "starting":     0,
            "icon":         "ind-trash.png",
            "basePrice":    0,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    5000,
            "canGift":      false
        },
        {
            "name":         "Research",
            "color":        "#8d5fd3",
            "max":          null,
            "indicator":    "r",
            "starting":     0,
            "icon":         "ind-research.png",
            "basePrice":    0,
            "isEssential":  false,
            "catchupAmount":0,
            "toxicRate":    0,
            "canGift":      false
        },
        {
            "name":         "Antaura",
            "color":        "#E53935",
            "max":          null,
            "indicator":    "aa",
            "starting":     0,
            "icon":         "ind-antaura.png",
            "basePrice":    0,
            "isEssential":  false,
            "catchupAmount":0,
            "canGift":      false
        },
        {
            "name":         "Civics",
            "color":        "#dddddd",
            "max":          null,
            "indicator":    "c",
            "starting":     0,
            "icon":         "ind-civic.png",
            "basePrice":    0,
            "isEssential":  false,
            "catchupAmount":0,
            "canGift":      false
        }
    ],
    "petitions": {
        "landGrant": {
            "name":         "Purchase Land Grant",
            "description":  "pet-expansion-desc",
            "indicator":    "",
            "cost":         [{"resource":"Money","amount":150000},{"resource":"Civics","amount":1000}]
        },
        "landAnnex": {
            "name":         "Annex Land",
            "description":  "pet-annex-desc",
            "indicator":    "",
            "cost":         [{"resource":"Civics","amount":3000}]
        }
    },
    "utilities": [
        {
            "name":         "Power",
            "color":        "#FFA000",
            "indicator":    "p",
            "icon":         "ind-power.png",
            "isEssential":  false
        },
        {
            "name":         "Bandwidth",
            "color":        "#4CAF50",
            "indicator":    "bw",
            "icon":         "ind-networking.png",
            "isEssential":  false
        }
    ],
    "occupations": [
        {
            "name":     "Blue Collar",
            "tiles": {
                "Human": [
                    ["bluecollar1"],
                    ["bluecollar1"],
                    ["bluecollar2"],
                    ["bluecollar3"],
                    ["bluecollar3"]
                ]
            },
            "salary":   2,
            "indicator":"ind-labor.png"
        },
        {
            "name":     "Botanist",
            "tiles": {
                "Human": [
                    ["botanist1"],
                    ["botanist1"],
                    ["botanist2"],
                    ["botanist3"],
                    ["botanist3"]
                ]
            },
            "salary":   3,
            "indicator":"ind-botanist.png"
        },
        {
            "name":     "Teacher",
            "tiles": {
                "Human": [
                    ["teacher1"],
                    ["teacher1"],
                    ["teacher2"],
                    ["teacher3"],
                    ["teacher3"]
                ]
            },
            "salary":   3,
            "indicator":"ind-teacher.png"
        },
        {
            "name":     "Scientist",
            "tiles": {
                "Human": [
                    ["scientist1"],
                    ["scientist1"],
                    ["scientist2"],
                    ["scientist3"],
                    ["scientist3"]
                ]
            },
            "salary":   4,
            "indicator":"ind-scientist.png"
        },
        {
            "name":     "Medic",
            "tiles": {
                "Human": [
                    ["medic1"],
                    ["medic1"],
                    ["medic2"],
                    ["medic3"],
                    ["medic3"]
                ]
            },
            "salary":   4,
            "indicator":"ind-medical.png"
        },
        {
            "name":     "White Collar",
            "tiles": {
                "Human": [
                    ["whitecollar1"],
                    ["whitecollar1"],
                    ["whitecollar2"],
                    ["whitecollar3"],
                    ["whitecollar3"]
                ]
            },
            "salary":   8,
            "indicator":"ind-whitecollar.png"
        },
        {
            "name":     "Politician",
            "tiles": {
                "Human": [
                    ["politician1"],
                    ["politician1"],
                    ["politician2"],
                    ["politician3"],
                    ["politician3"]
                ]
            },
            "salary":   8,
            "indicator":"ind-politician.png"
        },
        {
            "name":     "Diplomat",
            "tiles": {
                "Human": [
                    ["diplomat1"],
                    ["diplomat1"],
                    ["diplomat1"],
                    ["diplomat1"],
                    ["diplomat1"]
                ]
            },
            "salary":   8,
            "indicator":"ind-politician.png"
        },
        {
            "name":     "Arbiter",
            "tiles": {
                "Reptilian": [
                    ["arbiter1"],
                    ["arbiter1"],
                    ["arbiter2"],
                    ["arbiter3"],
                    ["arbiter3"]
                ]
            },
            "salary":   50,
            "indicator":"ind-arbiter.png"
        },
        {
            "name":     "Brewmaster",
            "tiles": {
                "Reptilian": [
                    ["repbrewmaster1"],
                    ["repbrewmaster1"],
                    ["repbrewmaster2"],
                    ["repbrewmaster3"],
                    ["repbrewmaster3"]
                ]
            },
            "salary":   80,
            "indicator":"ind-brewmaster.png"
        }
    ],
    "demands": [
        {

        }
    ],
    "terrains": [
        {
            "name":             "Water Pool",
            "tile":             ["water1"],
            "provides":         null,
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "water1.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       "water1shore",
            "passableConnectors":["Pavement","Pavement Lit","Grass"],
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": ["River","Salt Water"]
        },
        {
            "name":             "River",
            "tile":             ["water1"],
            "provides":         "Water",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         -1,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "water1.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       "water1shore",
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": ["Water Pool","Salt Water"]
        },
        {
            "name":             "Salt Water",
            "tile":             ["water2"],
            "provides":         "Fish",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         -1,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "water2.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       "water2shore",
            "passableConnectors":null,
            "indestructable":   true,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": ["Water Pool","River"]
        },
        {
            "name":             "Lava",
            "tile":             ["lava1"],
            "provides":         null,
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         5000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "lava1.png",
            "spreadRate":       3000,
            "collectOnDestruction": false,
            "decayRate":        1,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1.5,
                    "c":    "#FFB74D",
                    "i":    0.4,
                    "nightonly": false
                }
            ],
            "shoreSheet":       "lava1shore",
            "passableConnectors":null,
            "indestructable":   true,
            "decaysTo":         { "terrain": "Obsidian Deposit", "chance": 10 },
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Ore Deposit",
            "tile":             ["deposit"],
            "provides":         "Ore",
            "tileWidth":        2,
            "tileHeight":       2,
            "capacity":         5000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "deposit.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Obsidian Deposit",
            "tile":             ["obsidiandeposit"],
            "provides":         "Obsidian",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         8,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "obsidiandeposit.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Diamond Deposit",
            "tile":             ["diamonddeposit"],
            "provides":         "Diamond",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         3500,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "diamonddeposit.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Regolith Deposit",
            "tile":             ["regolith"],
            "provides":         "Regolith",
            "tileWidth":        2,
            "tileHeight":       2,
            "capacity":         3500,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "deposit.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Oil Deposit",
            "tile":             ["oildeposit"],
            "provides":         "Oil",
            "tileWidth":        2,
            "tileHeight":       2,
            "capacity":         6000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "oildeposit.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Ore Mine",
            "tile":             ["mine"],
            "provides":         "Ore",
            "tileWidth":        2,
            "tileHeight":       2,
            "capacity":         10000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "mine.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Ore Tunnel",
            "tile":             ["oretunnel"],
            "provides":         "Ore",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         600,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "oretunnel.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Aluminum Mine",
            "tile":             ["alummine"],
            "provides":         "Aluminum",
            "tileWidth":        2,
            "tileHeight":       2,
            "capacity":         4000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "alummine.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Regolith Mine",
            "tile":             ["regmine"],
            "provides":         "Regolith",
            "tileWidth":        2,
            "tileHeight":       2,
            "capacity":         8000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "regmine.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Micromine",
            "tile":             ["micromine"],
            "provides":         "Regolith",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         600,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "micromine.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Gold Deposit",
            "tile":             ["golddeposit"],
            "provides":         "Gold",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         2000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "golddeposit.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Gold Mine",
            "tile":             ["goldmine"],
            "provides":         "Gold",
            "tileWidth":        2,
            "tileHeight":       2,
            "capacity":         4000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "goldmine.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Aluminum Deposit",
            "tile":             ["aluminumdeposit"],
            "provides":         "Aluminum",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         4500,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "aluminumdeposit.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Cobalt Deposit",
            "tile":             ["cobaltdeposit"],
            "provides":         "Cobalt",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         1500,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "cobaltdeposit.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Uranium Deposit",
            "tile":             ["uraniumdeposit"],
            "provides":         "Uranium",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         1500,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "uraniumdeposit.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Crystalline Deposit",
            "tile":             ["crystaldeposit"],
            "provides":         "Crystalline",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         1000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "crystaldeposit.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    2,
                    "c":    "#0066ff",
                    "i":    0.1,
                    "nightonly": false
                }
            ],
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Diablo Crystalline",
            "tile":             ["diablocrystals"],
            "provides":         "Crystalline",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         5000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "crystaldeposit.png",
            "spreadRate":       20000,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    2,
                    "c":    "#e68256",
                    "i":    0.25,
                    "nightonly": false
                }
            ],
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Synthetic Crystalline Deposit",
            "tile":             ["syncrystaldeposit"],
            "provides":         "Crystalline",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         400,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "syncrystaldeposit.png",
            "spreadRate":       5000,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    2,
                    "c":    "#00d40c",
                    "i":    0.1,
                    "nightonly": false
                }
            ],
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Ice Deposit",
            "tile":             ["icedeposit"],
            "provides":         "Water",
            "tileWidth":        2,
            "tileHeight":       2,
            "capacity":         35000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "icedeposit.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Pond",
            "tile":             ["pond"],
            "provides":         "Water",
            "tileWidth":        3,
            "tileHeight":       3,
            "capacity":         250000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "pond.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Fir Trees",
            "tile":             ["firtrees"],
            "provides":         "Wood",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         15,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "firtrees.png",
            "spreadRate":       100000,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Palm Trees 1",
            "tile":             ["palm1b"],
            "provides":         "Wood",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         8,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "palm1b.png",
            "spreadRate":       50000,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Palm Trees 2",
            "tile":             ["palm2b"],
            "provides":         "Wood",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         12,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "palm2b.png",
            "spreadRate":       80000,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Aspen Trees",
            "tile":             ["aspentree"],
            "provides":         "Wood",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         15,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "aspentree.png",
            "spreadRate":       100000,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Megatree",
            "tile":             ["megatree"],
            "provides":         "Wood",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         800,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "megatree.png",
            "spreadRate":       50000,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Clay Mine",
            "tile":             ["claymine"],
            "provides":         "Clay",
            "tileWidth":        2,
            "tileHeight":       2,
            "capacity":         1500,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "claymine.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Sugarcane",
            "tile":             ["sugarcane"],
            "provides":         "Sugar",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         600,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "sugarcane.png",
            "spreadRate":       60000,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Small Trash Pit",
            "tile":             ["smtrashpit"],
            "provides":         "Trash",
            "tileWidth":        2,
            "tileHeight":       1,
            "capacity":         10000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "smtrashpit.png",
            "spreadRate":       0,
            "collectOnDestruction": true,
            "decayRate":        20,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Landfill",
            "tile":             ["landfill"],
            "provides":         "Trash",
            "tileWidth":        5,
            "tileHeight":       5,
            "capacity":         250000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "landfill.png",
            "spreadRate":       0,
            "collectOnDestruction": true,
            "decayRate":        15,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Unholy Diamond Spawner",
            "tile":             ["unholydiamondspawner"],
            "provides":         null,
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "unholydiamondspawner.png",
            "spreadRate":       500,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    0.6,
                    "c":    "#E53935",
                    "i":    0.2,
                    "nightonly": true
                }
            ],
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   "Unholy Diamonds",
            "additionalConnectors": null
        },
        {
            "name":             "Unholy Diamonds",
            "tile":             ["unholydiamonds"],
            "provides":         "Diamond",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         1000,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "unholydiamonds.png",
            "spreadRate":       10000,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       null,
            "passableConnectors":null,
            "indestructable":   false,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        },
        {
            "name":             "Ether",
            "tile":             ["ether1"],
            "provides":         "Ether",
            "tileWidth":        1,
            "tileHeight":       1,
            "capacity":         -1,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "icon":             "ether1.png",
            "spreadRate":       0,
            "collectOnDestruction": false,
            "decayRate":        0,
            "lightEffects":     null,
            "shoreSheet":       "ether1shore",
            "passableConnectors":null,
            "indestructable":   true,
            "decaysTo":         null,
            "raidItems":        null,
            "spreadResource":   null,
            "additionalConnectors": null
        }
    ],
    "technology": [
        {
            "name":             "Red Planet Base",
            "description":      "rpbase-desc",
            "icon":             "ind-redplanet.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Forest World Base",
            "description":      "fwbase-desc",
            "icon":             "ind-forest.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Water World Base",
            "description":      "waterworld-base-tech",
            "icon":             "waterworld.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Human Base",
            "description":      "hbase-desc",
            "icon":             "earth.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Reptilian Base",
            "description":      "reptbase-desc",
            "icon":             "ind-reptilians.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "United Earth Base",
            "description":      "uebase-desc",
            "icon":             "earth.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "LIS Base",
            "description":      "lisbase-desc",
            "icon":             "ind-lis.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Lunar Base",
            "description":      "lunbase-desc",
            "icon":             "ind-lunar.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Asteroid Base",
            "description":      "asteroidbase-desc",
            "icon":             "ind-asteroid.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Sugarland Base",
            "description":      "sugarlandbase-desc",
            "icon":             "ind-sugarland.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Abandoned World Base",
            "description":      "abandonedbase-desc",
            "icon":             "ind-abandonedworld.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Ice World Base",
            "description":      "iceworldbase-desc",
            "icon":             "ind-iceworld.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Lava World Base",
            "description":      "lavaworldbase-desc",
            "icon":             "ind-lavaworld.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Desert World Base",
            "description":      "desertworldbase-desc",
            "icon":             "ind-desertworld.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Insectoid Base",
            "description":      "insectoidbase-desc",
            "icon":             "ind-zolarg.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Draconian Base",
            "description":      "draconianbase-desc",
            "icon":             "ind-reptilians.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Zolarg Base",
            "description":      "zolargbase-desc",
            "icon":             "ind-zolarg.png",
            "cost":             [{"resource":"Research","amount":0}],
            "requiresTech":     null,
            "requiresStage":    99,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Advanced Hydroponics",
            "description":      "adv-hydro-desc",
            "icon":             "ind-adv-hydro.png",
            "cost":             [{"resource":"Research","amount":25}],
            "requiresTech":     ["Human Base"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "High Density Solar Panels",
            "description":      "hd-solar-desc",
            "icon":             "ind-adv-solar.png",
            "cost":             [{"resource":"Research","amount":25}],
            "requiresTech":     ["Human Base"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Microgravity Brewing",
            "description":      "brewing-desc",
            "icon":             "ind-rum.png",
            "cost":             [{"resource":"Research","amount":25}],
            "requiresTech":     ["Human Base"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Basic Education",
            "description":      "basiced-desc",
            "icon":             "ind-education.png",
            "cost":             [{"resource":"Research","amount":40}],
            "requiresTech":     ["Human Base"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Advanced Ore Purification",
            "description":      "adv-ore-pur-desc",
            "icon":             "ind-ore.png",
            "cost":             [{"resource":"Research","amount":40}],
            "requiresTech":     ["Human Base"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Advanced Charcoal Production",
            "description":      "advcp-desc",
            "icon":             "ind-charcoal.png",
            "cost":             [{"resource":"Research","amount":50}],
            "requiresTech":     ["Human Base"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Crystalline Synthesis",
            "description":      "crysynth-desc",
            "icon":             "ind-crystal.png",
            "cost":             [{"resource":"Research","amount":50},{"resource":"Crystalline","amount":100}],
            "requiresTech":     ["Ice World Base|Xenomaterials Research|Plant Genetics","Microgravity Brewing|Insectoid Brewing","Antanium Production|Advanced Ore Purification"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Advanced Small Scale Construction",
            "description":      "construction-2-desc",
            "icon":             "ind-construction-2.png",
            "cost":             [{"resource":"Research","amount":60}],
            "requiresTech":     ["Human Base"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Colonial Finance Theory",
            "description":      "finance-theory-desc",
            "icon":             "ind-coin.png",
            "cost":             [{"resource":"Research","amount":100}],
            "requiresTech":     ["Human Base"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Black Markets",
            "description":      "blackmarkets-desc",
            "icon":             "ind-blackmarkets.png",
            "cost":             [{"resource":"Research","amount":100}],
            "requiresTech":     ["LIS Base","Colonial Finance Theory"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Advanced Gold Mining",
            "description":      "adv-gold-desc",
            "icon":             "ind-gold.png",
            "cost":             [{"resource":"Research","amount":200}],
            "requiresTech":     ["Advanced Small Scale Construction"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Diamond Mining",
            "description":      "diamondmining-desc",
            "icon":             "ind-diamond.png",
            "cost":             [{"resource":"Research","amount":200}],
            "requiresTech":     ["Human Base","Advanced Small Scale Construction"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Low Gravity Manufacturing",
            "description":      "lg-manufacturing-desc",
            "icon":             "ind-microchip.png",
            "cost":             [{"resource":"Research","amount":400}],
            "requiresTech":     ["Advanced Ore Purification","Advanced Small Scale Construction"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Basic Network Infrastructure",
            "description":      "bni-desc",
            "icon":             "ind-networking.png",
            "cost":             [{"resource":"Research","amount":500}],
            "requiresTech":     ["Low Gravity Manufacturing|Advanced Metallurgy"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Colonial Tourism",
            "description":      "coltour-desc",
            "icon":             "spaceport.png",
            "cost":             [{"resource":"Research","amount":500}],
            "requiresTech":     ["Low Gravity Manufacturing","Colonial Finance Theory","Colonial Civics"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Low Gravity Oil Production",
            "description":      "oilref-desc",
            "icon":             "ind-oil.png",
            "cost":             [{"resource":"Research","amount":400}],
            "requiresTech":     ["Low Gravity Manufacturing"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Colonial Civics",
            "description":      "col-civics-desc",
            "icon":             "civiccenter.png",
            "cost":             [{"resource":"Research","amount":400}],
            "requiresTech":     ["Colonial Finance Theory"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Long Range Communications",
            "description":      "lrc-desc",
            "icon":             "ind-lrc.png",
            "cost":             [{"resource":"Research","amount":500}],
            "requiresTech":     ["Colonial Civics"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Advanced Chemistry",
            "description":      "adv-chem-desc",
            "icon":             "ind-adv-chem.png",
            "cost":             [{"resource":"Research","amount":750}],
            "requiresTech":     ["Advanced Ore Purification","Low Gravity Manufacturing"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Advanced Microbiology",
            "description":      "adv-microbio-desc",
            "icon":             "ind-microbio.png",
            "cost":             [{"resource":"Research","amount":900}],
            "requiresTech":     ["Advanced Chemistry","Low Gravity Manufacturing"],
            "requiresStage":    1,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Tourist Essentials",
            "description":      "touress-desc",
            "icon":             "hotel.png",
            "cost":             [{"resource":"Research","amount":1000}],
            "requiresTech":     ["Colonial Tourism"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Clay Production",
            "description":      "clayprod-desc",
            "icon":             "ind-clay.png",
            "cost":             [{"resource":"Research","amount":1200}],
            "requiresTech":     ["Advanced Chemistry","Advanced Microbiology"],
            "requiresStage":    1,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Low Gravity Masonry",
            "description":      "masonry-desc",
            "icon":             "ind-bricks.png",
            "cost":             [{"resource":"Research","amount":1200}],
            "requiresTech":     ["Clay Production"],
            "requiresStage":    1,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Low Atmospheric Zoology",
            "description":      "la-zoology-desc",
            "icon":             "ind-zoology.png",
            "cost":             [{"resource":"Research","amount":1200}],
            "requiresTech":     ["Advanced Chemistry"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Advanced Nuclear Physics",
            "description":      "nuke-physics-desc",
            "icon":             "ind-uranium.png",
            "cost":             [{"resource":"Research","amount":1500}],
            "requiresTech":     ["Advanced Chemistry","Low Gravity Manufacturing"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Large Scale Construction",
            "description":      "lgcons-desc",
            "icon":             "ind-megabot.png",
            "cost":             [{"resource":"Research","amount":2500}],
            "requiresTech":     ["Low Gravity Manufacturing","Advanced Nuclear Physics","Advanced Small Scale Construction"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Self Governance",
            "description":      "selfgov-desc",
            "icon":             "ind-civic.png",
            "cost":             [{"resource":"Research","amount":3000}],
            "requiresTech":     ["Colonial Civics"],
            "requiresStage":    0,
            "reqIndependence":  true,
            "requiPremium":     false
        },
        {
            "name":             "Galactic Commerce",
            "description":      "galcom-desc",
            "icon":             "ind-galcom.png",
            "cost":             [{"resource":"Research","amount":5000}],
            "requiresTech":     ["Colonial Civics","Colonial Finance Theory"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Advanced Chemical Synthesis",
            "description":      "adv-chemsyn-desc",
            "icon":             "ind-adv-chemsyn.png",
            "cost":             [{"resource":"Research","amount":5500}],
            "requiresTech":     ["Advanced Chemistry","Low Gravity Oil Production","Low Gravity Manufacturing"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Multimedia Infrastructure",
            "description":      "multimediainf-desc",
            "icon":             "ind-multimediainf.png",
            "cost":             [{"resource":"Research","amount":6000}],
            "requiresTech":     ["Basic Network Infrastructure","Galactic Commerce"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Human Cloning",
            "description":      "cloning-desc",
            "icon":             "ind-cloning.png",
            "cost":             [{"resource":"Research","amount":6000}],
            "requiresTech":     ["Advanced Chemistry"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Low Gravity Husbandry",
            "description":      "husbandry-desc",
            "icon":             "ind-husbandry.png",
            "cost":             [{"resource":"Research","amount":6000}],
            "requiresTech":     ["Low Atmospheric Zoology"],
            "requiresStage":    3,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Tourist Traps",
            "description":      "tourtrap-desc",
            "icon":             "zoo.png",
            "cost":             [{"resource":"Research","amount":10000}],
            "requiresTech":     ["Low Gravity Husbandry","Low Gravity Masonry","Tourist Essentials"],
            "requiresStage":    3,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Proxy Servers",
            "description":      "proxyservers-desc",
            "icon":             "ind-proxyservers.png",
            "cost":             [{"resource":"Research","amount":15000}],
            "requiresTech":     ["Basic Network Infrastructure","LIS Base","Black Markets"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Advanced Networking Infrastructure",
            "description":      "adv-networking-desc",
            "icon":             "ind-adv-networking.png",
            "cost":             [{"resource":"Research","amount":15000}],
            "requiresTech":     ["Basic Network Infrastructure","Low Gravity Manufacturing","Advanced Chemical Synthesis","Advanced Nuclear Physics"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Advanced Robotics",
            "description":      "advrobo-desc",
            "icon":             "ind-condrone.png",
            "cost":             [{"resource":"Research","amount":15000}],
            "requiresTech":     ["Low Gravity Manufacturing","Advanced Chemical Synthesis","Advanced Nuclear Physics"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Tall Construction",
            "description":      "tallconst-desc",
            "icon":             "ind-tallconst.png",
            "cost":             [{"resource":"Research","amount":15000}],
            "requiresTech":     ["Low Gravity Manufacturing","Advanced Chemical Synthesis","Large Scale Construction"],
            "requiresStage":    1,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Deep Excavation",
            "description":      "deepexc-desc",
            "icon":             "ind-deepexc.png",
            "cost":             [{"resource":"Research","amount":15000}],
            "requiresTech":     ["Large Scale Construction"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Solar Governance",
            "description":      "solgov-desc",
            "icon":             "statue2.png",
            "cost":             [{"resource":"Research","amount":20000}],
            "requiresTech":     ["Galactic Commerce"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Ancient Alien Language",
            "description":      "aal-desc",
            "icon":             "ind-artifact.png",
            "cost":             [{"resource":"Research","amount":30000},{"resource":"Alien Artifact","amount":200}],
            "requiresTech":     ["Large Scale Construction|Insectoid Governance","Deep Excavation|Advanced Metallurgy"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Ancient Alien Manufacturing",
            "description":      "aam-desc",
            "icon":             "chipfactory3.png",
            "cost":             [{"resource":"Research","amount":35000},{"resource":"Alien Artifact","amount":350}],
            "requiresTech":     ["Human Base","Ancient Alien Language"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Xenomaterials Research",
            "description":      "xenomat-desc",
            "icon":             "ind-antpaste.png",
            "cost":             [{"resource":"Research","amount":40000},{"resource":"Alien Artifact","amount":400}],
            "requiresTech":     ["Human Base","Ancient Alien Language"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Climate Science Theory",
            "description":      "cst-desc",
            "icon":             "ind-air.png",
            "cost":             [{"resource":"Research","amount":50000}],
            "requiresTech":     ["Advanced Chemistry"],
            "requiresStage":    4,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Galactic Governance",
            "description":      "galgov-desc",
            "icon":             "capitol3.png",
            "cost":             [{"resource":"Research","amount":75000}],
            "requiresTech":     ["Solar Governance"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Galactic Finance Theory",
            "description":      "galfi-desc",
            "icon":             "ind-galcom.png",
            "cost":             [{"resource":"Research","amount":85000}],
            "requiresTech":     ["Galactic Commerce","Galactic Governance"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Alien Quantum Physics",
            "description":      "alienquantum-desc",
            "icon":             "alienquantum.png",
            "cost":             [{"resource":"Research","amount":75000},{"resource":"Alien Artifact","amount":1500}],
            "requiresTech":     ["Ancient Alien Language","Ancient Alien Manufacturing"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Artificial Intelligence",
            "description":      "resai-desc",
            "icon":             "ind-ai.png",
            "cost":             [{"resource":"Research","amount":85000},{"resource":"Alien Artifact","amount":3000}],
            "requiresTech":     ["Alien Quantum Physics","Advanced Robotics"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Mass Data Management",
            "description":      "massdata-desc",
            "icon":             "ind-massdata.png",
            "cost":             [{"resource":"Research","amount":50000000}],
            "requiresTech":     ["Advanced Networking Infrastructure","Artificial Intelligence"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Next Gen Power Production",
            "description":      "nexgenpow-desc",
            "icon":             "ind-crystal.png",
            "cost":             [{"resource":"Research","amount":50000000},{"resource":"Crystalline","amount":5000}],
            "requiresTech":     ["Artificial Intelligence"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Transcendence",
            "description":      "techtransce-desc",
            "icon":             "ind-transcendence.png",
            "cost":             [{"resource":"Research","amount":500000000},{"resource":"Civics","amount":100000000},{"resource":"Money","amount":100000000},{"resource":"Alien Artifact","amount":1000000},{"resource":"Alien Relic","amount":1000},{"resource":"Diamond","amount":10000},{"resource":"Robot","amount":150000}],
            "requiresTech":     ["Alien Quantum Physics","Advanced Robotics"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Faster Than Light Travel",
            "description":      "ftltravel-desc",
            "icon":             "ind-starship.png",
            "cost":             [{"resource":"Research","amount":750000000},{"resource":"Civics","amount":100000000},{"resource":"Money","amount":450000000},{"resource":"Alien Artifact","amount":1500000},{"resource":"Alien Relic","amount":5000},{"resource":"Diamond","amount":25000},{"resource":"Robot","amount":300000}],
            "requiresTech":     ["Transcendence"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Ultra Deep Excavation",
            "description":      "udexc-desc",
            "icon":             "ind-ultradeep.png",
            "cost":             [{"resource":"Research","amount":100000},{"resource":"Alien Artifact","amount":3000}],
            "requiresTech":     ["Alien Quantum Physics","Deep Excavation"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Antanium Synthesis",
            "description":      "antsynth-desc",
            "icon":             "ind-antanium.png",
            "cost":             [{"resource":"Research","amount":2000000},{"resource":"Alien Artifact","amount":1500}],
            "requiresTech":     ["Xenomaterials Research","Advanced Robotics"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Ant Paste Synthesis",
            "description":      "antpastesynth-desc",
            "icon":             "ind-antpaste.png",
            "cost":             [{"resource":"Research","amount":2000000},{"resource":"Alien Artifact","amount":1500}],
            "requiresTech":     ["Xenomaterials Research","Advanced Robotics"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Antanium Compounds",
            "description":      "antcompound-desc",
            "icon":             "ind-triantanium.png",
            "cost":             [{"resource":"Research","amount":5000000},{"resource":"Alien Artifact","amount":1000}],
            "requiresTech":     ["Antanium Synthesis"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Mega Habitats",
            "description":      "megahab-desc",
            "icon":             "arcology.png",
            "cost":             [{"resource":"Research","amount":20000000}],
            "requiresTech":     ["Artificial Intelligence"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Interdimensional Transportation",
            "description":      "interdimtrav-desc",
            "icon":             "ind-stargate.png",
            "cost":             [{"resource":"Research","amount":40000000},{"resource":"Alien Artifact","amount":15000}],
            "requiresTech":     ["Artificial Intelligence","Antanium Synthesis"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Nationalism",
            "description":      "nationalism-desc",
            "icon":             "flag1.png",
            "cost":             [{"resource":"Research","amount":100000},{"resource":"Civics","amount":25000}],
            "requiresTech":     ["Galactic Governance"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Imperialism",
            "description":      "imperialism-desc",
            "icon":             "capitol5.png",
            "cost":             [{"resource":"Research","amount":200000},{"resource":"Civics","amount":50000}],
            "requiresTech":     ["Nationalism"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Galactic Imperialism",
            "description":      "galimp-desc",
            "icon":             "capitol6.png",
            "cost":             [{"resource":"Research","amount":350000},{"resource":"Civics","amount":150000}],
            "requiresTech":     ["Imperialism"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Political Theater",
            "description":      "politheat-desc",
            "icon":             "uecongress.png",
            "cost":             [{"resource":"Research","amount":1000000},{"resource":"Civics","amount":500000}],
            "requiresTech":     ["Galactic Imperialism"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Gold Storage",
            "description":      "zgoldstorage-desc",
            "icon":             "goldburrow.png",
            "cost":             [{"resource":"Research","amount":25}],
            "requiresTech":     ["Zolarg Base"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Sugar Cultivation",
            "description":      "sugarcult-desc",
            "icon":             "ind-sugar.png",
            "cost":             [{"resource":"Research","amount":25}],
            "requiresTech":     ["Zolarg Base"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Insectoid Brewing",
            "description":      "brewing-desc",
            "icon":             "ind-rum.png",
            "cost":             [{"resource":"Research","amount":25}],
            "requiresTech":     ["Zolarg Base"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Sugarpower",
            "description":      "sugarpower-res-desc",
            "icon":             "sugarpower.png",
            "cost":             [{"resource":"Research","amount":50}],
            "requiresTech":     ["Zolarg Base","Gold Storage"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Communal Finance",
            "description":      "communialfin-desc",
            "icon":             "ind-insectcoin.png",
            "cost":             [{"resource":"Research","amount":75}],
            "requiresTech":     ["Zolarg Base","Gold Storage","Sugarpower"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Antanium Production",
            "description":      "antanium-prod-desc",
            "icon":             "ind-antanium.png",
            "cost":             [{"resource":"Research","amount":75}],
            "requiresTech":     ["Zolarg Base","Gold Storage"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Insectoid Regeneration",
            "description":      "insregen-desc",
            "icon":             "healingpods.png",
            "cost":             [{"resource":"Research","amount":100}],
            "requiresTech":     ["Communal Finance"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Advanced Digging",
            "description":      "advdig-desc",
            "icon":             "wetmound.png",
            "cost":             [{"resource":"Research","amount":100}],
            "requiresTech":     ["Antanium Production"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Wood Harvesting",
            "description":      "woodharvesting-desc",
            "icon":             "ind-wood.png",
            "cost":             [{"resource":"Research","amount":250}],
            "requiresTech":     ["Insectoid Regeneration"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Zolarg Communications",
            "description":      "zolargcomm-desc",
            "icon":             "ind-zolargcomm.png",
            "cost":             [{"resource":"Research","amount":500}],
            "requiresTech":     ["Antanium Production","Communal Finance"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Insectoid Governance",
            "description":      "zolgov-desc",
            "icon":             "zolargstatue.png",
            "cost":             [{"resource":"Research","amount":2000}],
            "requiresTech":     ["Zolarg Communications"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Ore Enrichment",
            "description":      "oreenrichtech-desc",
            "icon":             "oreenrichmentfacility.png",
            "cost":             [{"resource":"Research","amount":2500}],
            "requiresTech":     ["Advanced Digging"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Advanced Metallurgy",
            "description":      "advmetalurgy-desc",
            "icon":             "ind-aluminum.png",
            "cost":             [{"resource":"Research","amount":2500}],
            "requiresTech":     ["Advanced Digging"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Plant Genetics",
            "description":      "plantgen-desc",
            "icon":             "megatree.png",
            "cost":             [{"resource":"Research","amount":2500}],
            "requiresTech":     ["Wood Harvesting"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Insectoid Oil Production",
            "description":      "insctoil-desc",
            "icon":             "ind-oil.png",
            "cost":             [{"resource":"Research","amount":7500},{"resource":"Diamond","amount":100},{"resource":"Obsidian","amount":100}],
            "requiresTech":     ["Advanced Metallurgy"],
            "requiresStage":    2,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Mysticism",
            "description":      "mysticism-desc",
            "icon":             "ind-antaura.png",
            "cost":             [{"resource":"Research","amount":3000}],
            "requiresTech":     ["Insectoid Governance"],
            "requiresStage":    0,
            "reqIndependence":  true,
            "requiPremium":     false
        },
        {
            "name":             "Insectoid Bureaucracy",
            "description":      "insbeu-desc",
            "icon":             "highercommand.png",
            "cost":             [{"resource":"Research","amount":3000}],
            "requiresTech":     ["Insectoid Governance","Advanced Metallurgy"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Open Doors",
            "description":      "opendoors-desc",
            "icon":             "ind-tourist.png",
            "cost":             [{"resource":"Research","amount":10000}],
            "requiresTech":     ["Insectoid Bureaucracy"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Insectoid Mind Network",
            "description":      "mindnetwork-desc",
            "icon":             "ind-mindnetwork.png",
            "cost":             [{"resource":"Research","amount":15000}],
            "requiresTech":     ["Zolarg Base","Insectoid Bureaucracy","Basic Network Infrastructure"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "The Wheel",
            "description":      "thewheel-desc",
            "icon":             "ind-wheel.png",
            "cost":             [{"resource":"Research","amount":100000}],
            "requiresTech":     ["Plant Genetics","Insectoid Bureaucracy"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Mystic Uranium Generation",
            "description":      "bugnukes-desc",
            "icon":             "ind-uranium.png",
            "cost":             [{"resource":"Research","amount":100000}],
            "requiresTech":     ["Mysticism"],
            "requiresStage":    0,
            "reqIndependence":  false,
            "requiPremium":     false
        },
        {
            "name":             "Insectoid Shipbuilding",
            "description":      "bugships-desc",
            "icon":             "ind-bugships.png",
            "cost":             [{"resource":"Research","amount":5000000},{"resource":"Civics","amount":5000000},{"resource":"Money","amount":5000000}],
            "requiresTech":     ["Zolarg Base","The Wheel"],
            "requiresStage":    0,
            "reqIndependence":  true,
            "requiPremium":     false
        },
        {
            "name":             "Mega Construction",
            "description":      "megaconst-desc",
            "icon":             "megamound.png",
            "cost":             [{"resource":"Research","amount":7500000},{"resource":"Civics","amount":7500000},{"resource":"Money","amount":5000000}],
            "requiresTech":     ["Zolarg Base","Insectoid Mind Network","The Wheel"],
            "requiresStage":    0,
            "reqIndependence":  true,
            "requiPremium":     false
        },
        {
            "name":             "Insectoid Dominion",
            "description":      "insectdomin-desc",
            "icon":             "ind-queen.png",
            "cost":             [{"resource":"Research","amount":7500000},{"resource":"Civics","amount":7500000},{"resource":"Money","amount":5000000}],
            "requiresTech":     ["Zolarg Base","Insectoid Mind Network","Insectoid Shipbuilding"],
            "requiresStage":    0,
            "reqIndependence":  true,
            "requiPremium":     false
        },
        {
            "name":             "Hereditary Rule",
            "description":      "hereditaryrule-desc",
            "icon":             "ind-empire.png",
            "cost":             [{"resource":"Research","amount":10000000},{"resource":"Civics","amount":1000000},{"resource":"Money","amount":2000000}],
            "requiresTech":     ["Draconian Base"],
            "requiresStage":    0,
            "reqIndependence":  true,
            "requiPremium":     false
        },
        {
            "name":             "Shipbuilding",
            "description":      "shipbuilding-desc",
            "icon":             "ind-shipbuilding.png",
            "cost":             [{"resource":"Research","amount":15000000},{"resource":"Civics","amount":6000000},{"resource":"Money","amount":4000000}],
            "requiresTech":     ["Draconian Base"],
            "requiresStage":    0,
            "reqIndependence":  true,
            "requiPremium":     false
        }
        
    ],
    "buildings": [
        {
            "name":             "Lander",
            "tile":             ["lander"],
            "cost":             null,
            "description":      "lander-description",
            "produces":         ["Rover","Lunar Rover","Forest Rover"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wheel","amount":25},{"resource":"Food","amount":50},{"resource":"Water","amount":400},{"resource":"Wood","amount":400},{"resource":"Ore","amount":1200},{"resource":"Regolith","amount":1200},{"resource":"Charcoal","amount":1200}],
            "sellValue":        [{"resource":"Steel","amount":10},{"resource":"Gold","amount":2},{"resource":"Microchip","amount":2},{"resource":"Uranium","amount":1}],
            "sellWarning":      "lander-sell-warning",
            "refines":          [{"input":"Ore","output":"Ore"},{"input":"Water","output":"Water"},{"input":"Regolith","output":"Regolith"},{"input":"Wood","output":"Wood"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":3}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  2,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["United Earth Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "lander.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  [],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    3,
                    "c":    "#FFF3E0",
                    "i":    0.25,
                    "nightonly": false
                }
            ],
            "packsTo":          "Airborne Lander",
            "canBuildOver":     null
        },
        {
            "name":             "Foot Path",
            "tile":             ["footpath"],
            "cost":             [{"resource":"Ore","amount":1}],
            "description":      "footpath-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    1,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Paste Path",
            "tile":             ["pastepath"],
            "cost":             [{"resource":"Ore","amount":1},{"resource":"Ant Paste","amount":1}],
            "description":      "pastepath-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    3,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"pavement-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "pastepath.png",
            "canUpgradeTo":     "Aluminum Road",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Crushed Regolith Path",
            "tile":             ["regpath"],
            "cost":             [{"resource":"Regolith","amount":1}],
            "description":      "regpath-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    2,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Lunar Base|Asteroid Base|Abandoned World Base|Ice World Base"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "regpath.png",
            "canUpgradeTo":     "Hardened Pavement",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Mulched Wood Path",
            "tile":             ["mulchpath"],
            "cost":             [{"resource":"Wood","amount":1}],
            "description":      "mulchpath-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    2,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Forest World Base|Abandoned World Base"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "mulchpath.png",
            "canUpgradeTo":     "Hardened Pavement",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Compacted Snow Path",
            "tile":             ["compactedsnow"],
            "cost":             [{"resource":"Water","amount":1}],
            "description":      "compactedsnow-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    2,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Ice World Base"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Hardened Pavement",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Sand Path",
            "tile":             ["sandpath"],
            "cost":             [{"resource":"Ore","amount":1},{"resource":"Water","amount":1}],
            "description":      "sandpath-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    1,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Water World Base|Desert World Base"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "River Pebbles",
            "tile":             ["pebbles"],
            "cost":             [{"resource":"Ore","amount":1},{"resource":"Antanium","amount":1},{"resource":"Gold","amount":1}],
            "description":      "pebbles-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    1,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Pavement",
            "tile":             ["pavement"],
            "cost":             [{"resource":"Ore","amount":1}],
            "description":      "pavement-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    2,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"pavement-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Red Planet Base|Reptilian Base"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "pavement.png",
            "canUpgradeTo":     "Hardened Pavement",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Pavement Lit",
            "tile":             ["pavementlight"],
            "cost":             [{"resource":"Ore","amount":20}],
            "description":      "pavement1light-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    2,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Red Planet Base"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Hardened Pavement Lit",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.75,
                    "y":    0.0,
                    "r":    1.5,
                    "c":    "#fff6d5",
                    "i":    0.15,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Solar Road",
            "tile":             ["solarroad"],
            "cost":             [{"resource":"Ore","amount":20},{"resource":"Gold","amount":1}],
            "description":      "solarroad-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    2,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":3}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["High Density Solar Panels"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads","Power"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Draconian Pavement",
            "tile":             ["pavement9"],
            "cost":             [{"resource":"Ore","amount":4},{"resource":"Antanium","amount":1}],
            "description":      "pavement9-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    5,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Checkered Pavement",
            "tile":             ["pavement6"],
            "cost":             [{"resource":"Ore","amount":2}],
            "description":      "pavement6-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    2,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "pavement6.png",
            "canUpgradeTo":     "Hardened Pavement",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Hardened Pavement",
            "tile":             ["pavement2"],
            "cost":             [{"resource":"Ore","amount":4},{"resource":"Steel","amount":1}],
            "description":      "pavement2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    8,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Advanced Small Scale Construction"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "pavement2.png",
            "canUpgradeTo":     "Dark Pavement",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Hardened Pavement Lit",
            "tile":             ["pavement2light"],
            "cost":             [{"resource":"Ore","amount":24},{"resource":"Steel","amount":1}],
            "description":      "pavement2light-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    8,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Advanced Small Scale Construction"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Dark Pavement Lit",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.75,
                    "y":    0.0,
                    "r":    1.5,
                    "c":    "#fff6d5",
                    "i":    0.15,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Dark Pavement",
            "tile":             ["pavement5"],
            "cost":             [{"resource":"Ore","amount":2},{"resource":"Steel","amount":2},{"resource":"Charcoal","amount":2},{"resource":"Regolith","amount":2},{"resource":"Oil","amount":2}],
            "description":      "pavement5-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    12,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Advanced Charcoal Production"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "pavement5.png",
            "canUpgradeTo":     "Aluminum Road",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Dark Pavement Lit",
            "tile":             ["darkpavementlit"],
            "cost":             [{"resource":"Ore","amount":21},{"resource":"Steel","amount":2},{"resource":"Charcoal","amount":2},{"resource":"Regolith","amount":2},{"resource":"Oil","amount":2}],
            "description":      "darkpavementlit-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    12,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Advanced Charcoal Production"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.75,
                    "y":    0.0,
                    "r":    1.5,
                    "c":    "#fff6d5",
                    "i":    0.15,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Aluminum Road",
            "tile":             ["pavement8"],
            "cost":             [{"resource":"Aluminum","amount":30}],
            "description":      "pavement8-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    15,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "pavement8.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Brick Road",
            "tile":             ["pavement3"],
            "cost":             [{"resource":"Ore","amount":2},{"resource":"Bricks","amount":1}],
            "description":      "brickroad-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    4,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Low Gravity Masonry"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "pavement3.png",
            "canUpgradeTo":     ["Yellow Brick Road"],
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Yellow Brick Road",
            "tile":             ["pavement4"],
            "cost":             [{"resource":"Ore","amount":2},{"resource":"Bricks","amount":2},{"resource":"Gold","amount":2}],
            "description":      "ybrickroad-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    10,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Low Gravity Masonry","Advanced Gold Mining"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "pavement4.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Rainbow Road",
            "tile":             ["pavement7"],
            "cost":             [{"resource":"Toy","amount":20}],
            "description":      "pavement7-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    14,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "pavement7.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Paste Pontoon",
            "tile":             ["pastepontoon"],
            "cost":             [{"resource":"Wood","amount":20},{"resource":"Ant Paste","amount":20}],
            "description":      "pastepontoon-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    1,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Electromagnetic Bridge",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     ["Salt Water","River","Water Pool","Ether"]
        },
        {
            "name":             "Small Wooden Bridge",
            "tile":             ["bridge1"],
            "cost":             [{"resource":"Wood","amount":40},{"resource":"Ore","amount":20}],
            "description":      "bridge1-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    1,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Steel Bridge",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     ["Salt Water","River","Water Pool","Ether"]
        },
        {
            "name":             "Small Wooden Bridge NS",
            "tile":             ["bridge1b"],
            "cost":             [{"resource":"Wood","amount":40},{"resource":"Ore","amount":20}],
            "description":      "bridge1-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    1,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Steel Bridge NS",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     ["Salt Water","River","Water Pool","Ether"]
        },
        {
            "name":             "Steel Bridge",
            "tile":             ["steelbridge"],
            "cost":             [{"resource":"Ore","amount":20},{"resource":"Steel","amount":50}],
            "description":      "steelbridge-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    4,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Aluminum Bridge",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     ["Salt Water","River","Water Pool","Lava","Ether"]
        },
        {
            "name":             "Steel Bridge NS",
            "tile":             ["steelbridgeb"],
            "cost":             [{"resource":"Ore","amount":20},{"resource":"Steel","amount":50}],
            "description":      "steelbridge-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    4,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Aluminum Bridge NS",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     ["Salt Water","River","Water Pool","Lava","Ether"]
        },
        {
            "name":             "Aluminum Bridge",
            "tile":             ["alumbridge"],
            "cost":             [{"resource":"Ore","amount":20},{"resource":"Steel","amount":20},{"resource":"Aluminum","amount":55}],
            "description":      "alumbridge-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    8,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     ["Salt Water","River","Water Pool","Lava","Ether"]
        },
        {
            "name":             "Aluminum Bridge NS",
            "tile":             ["alumbridgeb"],
            "cost":             [{"resource":"Ore","amount":20},{"resource":"Steel","amount":20},{"resource":"Aluminum","amount":55}],
            "description":      "alumbridge-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    8,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     ["Salt Water","River","Water Pool","Lava","Ether"]
        },
        {
            "name":             "Golden Bridge",
            "tile":             ["goldbridge"],
            "cost":             [{"resource":"Ore","amount":20},{"resource":"Steel","amount":20},{"resource":"Gold","amount":55}],
            "description":      "goldbridge-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    9,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     ["Salt Water","River","Water Pool","Lava","Ether"]
        },
        {
            "name":             "Golden Bridge NS",
            "tile":             ["goldbridgeb"],
            "cost":             [{"resource":"Ore","amount":20},{"resource":"Steel","amount":20},{"resource":"Gold","amount":55}],
            "description":      "goldbridge-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    9,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     ["Salt Water","River","Water Pool","Lava","Ether"]
        },
        {
            "name":             "Electromagnetic Bridge",
            "tile":             ["embridge"],
            "cost":             [{"resource":"Gold","amount":40},{"resource":"Uranium","amount":20},{"resource":"Aluminum","amount":10}],
            "description":      "embridge-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    9,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1.0,
                    "c":    "#4800ff",
                    "i":    0.05,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     ["Salt Water","River","Water Pool","Lava","Ether"]
        },
        {
            "name":             "Electromagnetic Bridge NS",
            "tile":             ["embridgens"],
            "cost":             [{"resource":"Gold","amount":40},{"resource":"Uranium","amount":20},{"resource":"Aluminum","amount":10}],
            "description":      "embridge-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    9,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1.0,
                    "c":    "#4800ff",
                    "i":    0.05,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     ["Salt Water","River","Water Pool","Lava","Ether"]
        },
        {
            "name":             "Mesh Platform",
            "tile":             ["meshplatform"],
            "cost":             [{"resource":"Ore","amount":4},{"resource":"Steel","amount":6},{"resource":"Aluminum","amount":1}],
            "description":      "meshplatform-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    1,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     ["Salt Water","River","Water Pool"]
        },
        {
            "name":             "Small Solar Panel",
            "tile":             ["panel1"],
            "cost":             [{"resource":"Ore","amount":150}],
            "description":      "small-panel-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":70}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":8}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"solarpanel-firstbuild",
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["United Earth Base|Asteroid Base|Abandoned World Base|Water World Base"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "panel1.png",
            "canUpgradeTo":     "Solar Tower",
            "transModeColor":   "#FFA000",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Solar Tower",
            "tile":             ["solartower"],
            "cost":             [{"resource":"Ore","amount":400},{"resource":"Steel","amount":300},{"resource":"Gold","amount":300}],
            "description":      "solar-tower-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":150},{"resource":"Steel","amount":100},{"resource":"Gold","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":45}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    20,
            "requiresTech":     ["High Density Solar Panels","United Earth Base|Asteroid Base|Abandoned World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "solartower.png",
            "canUpgradeTo":     "Diamond Solar Tower",
            "transModeColor":   "#FFA000",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Diamond Solar Tower",
            "tile":             ["diamondsolar"],
            "cost":             [{"resource":"Ore","amount":400},{"resource":"Steel","amount":300},{"resource":"Gold","amount":100},{"resource":"Diamond","amount":200}],
            "description":      "diamondsolar-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":150},{"resource":"Steel","amount":100},{"resource":"Gold","amount":20},{"resource":"Diamond","amount":80}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":70}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    20,
            "requiresTech":     ["High Density Solar Panels","United Earth Base|Asteroid Base|Abandoned World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Alien Solar Tower",
            "transModeColor":   "#FFA000",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -1,
                    "y":    -1,
                    "r":    0.15,
                    "c":    "#ff0000",
                    "i":    0.3,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Alien Solar Tower",
            "tile":             ["aliensolar"],
            "cost":             [{"resource":"Steel","amount":800},{"resource":"Aluminum","amount":800},{"resource":"Gold","amount":800},{"resource":"Uranium","amount":50},{"resource":"Microchip","amount":200}],
            "description":      "aliensolar-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Steel","amount":80},{"resource":"Aluminum","amount":80},{"resource":"Gold","amount":80},{"resource":"Uranium","amount":5},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":250}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    20,
            "requiresTech":     ["Alien Quantum Physics","Ancient Alien Manufacturing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Charcoal Burner",
            "tile":             ["coalburn"],
            "cost":             [{"resource":"Wood","amount":150},{"resource":"Ore","amount":80},{"resource":"Charcoal","amount":10}],
            "description":      "coalburn-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     900,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Charcoal","amount":250}],
            "sellValue":        [{"resource":"Wood","amount":40},{"resource":"Ore","amount":20}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":50}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"charcoalburn-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "coalburn.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Charcoal","rate":1200},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Sugar Burner",
            "tile":             ["sugarpower"],
            "cost":             [{"resource":"Ore","amount":500},{"resource":"Ant Paste","amount":300},{"resource":"Gold","amount":200}],
            "description":      "sugarpower-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     9000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":100},{"resource":"Gold","amount":5}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":14}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   1,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Sugarpower"],
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "sugarpower.png",
            "canUpgradeTo":     "Power Spire",
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Sugar","rate":500},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1,
                    "c":    "#FFF3E0",
                    "i":    0.25,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Power Spire",
            "tile":             ["powerspire"],
            "cost":             [{"resource":"Wood","amount":500},{"resource":"Antanium","amount":1000},{"resource":"Ant Paste","amount":400},{"resource":"Gold","amount":250}],
            "description":      "powerspire-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Antanium","amount":400},{"resource":"Gold","amount":25}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":40}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   3,
            "requiresWorkers":  false,
            "smelts":           {"input":"Wood","output":"Atmosphere","time":2000,"ratio":2},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Sugarpower","Wood Harvesting","Antanium Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "powerspire.png",
            "canUpgradeTo":     "Unholy Power Spire",
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Sugar","rate":1500},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Unholy Power Spire",
            "tile":             ["unholypowerspire"],
            "cost":             [{"resource":"Wood","amount":500},{"resource":"Antanium","amount":600},{"resource":"Ant Paste","amount":400},{"resource":"Gold","amount":300},{"resource":"Aluminum","amount":1000}],
            "description":      "unholypowerspire-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Antanium","amount":50},{"resource":"Gold","amount":25},{"resource":"Aluminum","amount":300}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":800}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   5,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Mysticism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "unholypowerspire.png",
            "canUpgradeTo":     "Smart Power Spire",
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Antaura","rate":400},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -0.8,
                    "y":    -0.8,
                    "r":    0.6,
                    "c":    "#E53935",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Smart Power Spire",
            "tile":             ["smartpowerspire"],
            "cost":             [{"resource":"Wood","amount":500},{"resource":"Antanium","amount":600},{"resource":"Ant Paste","amount":400},{"resource":"Gold","amount":500},{"resource":"Aluminum","amount":2000},{"resource":"Microchip","amount":800},{"resource":"Software","amount":250}],
            "description":      "smartpowerspire-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Antanium","amount":50},{"resource":"Gold","amount":25},{"resource":"Aluminum","amount":300}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":3500}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   5,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Mysticism","Insectoid Mind Network"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Antaura,Software","rate":350},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -0.8,
                    "y":    -0.8,
                    "r":    0.6,
                    "c":    "#E53935",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Regolith Furnace",
            "tile":             ["regfurnace"],
            "cost":             [{"resource":"Regolith","amount":100},{"resource":"Crystalline","amount":100}],
            "description":      "regfurnace-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     2000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Crystalline","amount":150}],
            "sellValue":        [{"resource":"Crystalline","amount":90}],
            "sellWarning":      null,
            "refines":          [{"input":"Crystalline","output":"Crystalline"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":10}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Diamond Crystal Reactor",
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Regolith","rate":400},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1,
                    "c":    "#FFA000",
                    "i":    0.05,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Basic Crystal Furnace",
            "tile":             ["basiccrystalfurnace"],
            "cost":             [{"resource":"Ore","amount":150},{"resource":"Crystalline","amount":250}],
            "description":      "basiccrystalfurnace-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Crystalline","amount":2500}],
            "sellValue":        [{"resource":"Ore","amount":5},{"resource":"Gold","amount":7}],
            "sellWarning":      null,
            "refines":          [{"input":"Crystalline","output":"Crystalline"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":250}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    10,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Crystalline"],
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Microreactor",
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Crystalline","rate":2500},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Microreactor",
            "tile":             ["microreactor"],
            "cost":             [{"resource":"Antanium","amount":150},{"resource":"Gold","amount":350},{"resource":"Aluminum","amount":200},{"resource":"Uranium","amount":30}],
            "description":      "microreactor-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Uranium","amount":2500}],
            "sellValue":        [{"resource":"Antanium","amount":30},{"resource":"Gold","amount":35},{"resource":"Aluminum","amount":20},{"resource":"Uranium","amount":3}],
            "sellWarning":      null,
            "refines":          [{"input":"Uranium","output":"Uranium"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":1500}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    20,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Uranium"],
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Advanced Microreactor",
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Uranium","rate":2000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.2,
                    "r":    0.6,
                    "c":    "#00ccff",
                    "i":    0.1,
                    "nightonly": true
                },
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    0.35,
                    "c":    "#00d400",
                    "i":    0.1,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Advanced Microreactor",
            "tile":             ["advmicroreactor"],
            "cost":             [{"resource":"Antanium","amount":500},{"resource":"Gold","amount":550},{"resource":"Aluminum","amount":400},{"resource":"Uranium","amount":50},{"resource":"Ant Paste","amount":100},{"resource":"Oil","amount":200},{"resource":"Obsidian","amount":20}],
            "description":      "advmicroreactor-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Uranium","amount":2500}],
            "sellValue":        [{"resource":"Antanium","amount":40},{"resource":"Gold","amount":45},{"resource":"Aluminum","amount":30},{"resource":"Uranium","amount":4}],
            "sellWarning":      null,
            "refines":          [{"input":"Uranium","output":"Uranium"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":6000}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    40,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Uranium"],
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Turbo Microreactor",
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Uranium","rate":1800},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Turbo Microreactor",
            "tile":             ["turbomicroreactor"],
            "cost":             [{"resource":"Antanium","amount":1500},{"resource":"Gold","amount":1550},{"resource":"Aluminum","amount":1400},{"resource":"Uranium","amount":150},{"resource":"Ant Paste","amount":200},{"resource":"Oil","amount":400},{"resource":"Obsidian","amount":200},{"resource":"Clay","amount":500},{"resource":"Helium 3","amount":1500}],
            "description":      "turbomicroreactor-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Uranium","amount":5000}],
            "sellValue":        [{"resource":"Antanium","amount":40},{"resource":"Gold","amount":45},{"resource":"Aluminum","amount":30},{"resource":"Uranium","amount":4}],
            "sellWarning":      null,
            "refines":          [{"input":"Uranium","output":"Uranium"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":20000}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    60,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Uranium"],
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Diamond Cobalt Microreactor",
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Uranium,Helium 3","rate":1500},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Diamond Cobalt Microreactor",
            "tile":             ["diamondcobaltreactor"],
            "cost":             [{"resource":"Antanium","amount":750},{"resource":"Gold","amount":600},{"resource":"Aluminum","amount":450},{"resource":"Diamond","amount":150},{"resource":"Ant Paste","amount":100},{"resource":"Cobalt","amount":250},{"resource":"Obsidian","amount":20}],
            "description":      "diamondcobaltreactor-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Cobalt","amount":2500}],
            "sellValue":        [{"resource":"Antanium","amount":40},{"resource":"Gold","amount":45},{"resource":"Aluminum","amount":30},{"resource":"Cobalt","amount":4}],
            "sellWarning":      null,
            "refines":          [{"input":"Cobalt","output":"Cobalt"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":250000}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    140,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Cobalt,Diamond","rate":1000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Oil Plant",
            "tile":             ["oilplant"],
            "cost":             [{"resource":"Wood","amount":1500},{"resource":"Charcoal","amount":2000},{"resource":"Ore","amount":6000},{"resource":"Steel","amount":4500},{"resource":"Gold","amount":2500},{"resource":"Oil","amount":450},{"resource":"Microchip","amount":50}],
            "description":      "oilplant-description",
            "produces":         ["Crudebot"],
            "generates":        "Atmosphere",
            "generateTime":     1000,
            "generateAmount":   6,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Oil","amount":2000}],
            "sellValue":        [{"resource":"Wood","amount":40},{"resource":"Ore","amount":1200},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":600},{"resource":"Oil","amount":120},{"resource":"Microchip","amount":3}],
            "sellWarning":      null,
            "refines":          [{"input":"Oil","output":"Oil"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":700}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   24,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    90,
            "requiresTech":     ["Low Gravity Manufacturing","Low Gravity Oil Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Oil"],
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        "oilplant.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Oil","rate":200},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Nuclear Reactor",
            "tile":             ["nuclearplant"],
            "cost":             [{"resource":"Ore","amount":5000},{"resource":"Water","amount":2000},{"resource":"Steel","amount":5500},{"resource":"Gold","amount":2500},{"resource":"Aluminum","amount":1000},{"resource":"Microchip","amount":450}],
            "description":      "nuclearplant-description",
            "produces":         ["Uranium Miner"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        4,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Uranium","amount":10000}],
            "sellValue":        [{"resource":"Ore","amount":2000},{"resource":"Water","amount":800},{"resource":"Steel","amount":2200},{"resource":"Gold","amount":1100},{"resource":"Aluminum","amount":300},{"resource":"Microchip","amount":20}],
            "sellWarning":      null,
            "refines":          [{"input":"Uranium","output":"Uranium"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":4000}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   45,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    90,
            "requiresTech":     ["Advanced Nuclear Physics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Uranium"],
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        "nuclear-plant.png",
            "canUpgradeTo":     "Quantum Nuclear Reactor",
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Uranium","rate":800},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Quantum Nuclear Reactor",
            "tile":             ["aliennuclearplant"],
            "cost":             [{"resource":"Ore","amount":8000},{"resource":"Water","amount":5000},{"resource":"Steel","amount":11500},{"resource":"Gold","amount":6500},{"resource":"Aluminum","amount":4000},{"resource":"Microchip","amount":7000},{"resource":"Software","amount":40},{"resource":"Alien Artifact","amount":40}],
            "description":      "aliennuclearplant-description",
            "produces":         ["Uranium Miner"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        4,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Uranium","amount":15000}],
            "sellValue":        [{"resource":"Ore","amount":800},{"resource":"Steel","amount":1150},{"resource":"Gold","amount":650},{"resource":"Aluminum","amount":400},{"resource":"Microchip","amount":70},{"resource":"Alien Artifact","amount":4}],
            "sellWarning":      null,
            "refines":          [{"input":"Uranium","output":"Uranium"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":25000}],
            "requiresUtility":  [{"utility":"Bandwidth","amount":15}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   35,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    110,
            "requiresTech":     ["Advanced Nuclear Physics","Ancient Alien Manufacturing","Alien Quantum Physics","Basic Network Infrastructure"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Uranium"],
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Uranium","rate":750},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Hydrogen Reactor",
            "tile":             ["hydropower"],
            "cost":             [{"resource":"Ore","amount":6000},{"resource":"Water","amount":15000},{"resource":"Steel","amount":7000},{"resource":"Gold","amount":4000},{"resource":"Aluminum","amount":3500},{"resource":"Microchip","amount":6500}],
            "description":      "hydropower-description",
            "produces":         ["Waterbot"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":2000},{"resource":"Water","amount":800},{"resource":"Steel","amount":2200},{"resource":"Gold","amount":1100},{"resource":"Aluminum","amount":300},{"resource":"Microchip","amount":20}],
            "sellWarning":      null,
            "refines":          [{"input":"Water","output":"Water"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":5500}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   30,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    140,
            "requiresTech":     ["Advanced Nuclear Physics","Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Water"],
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       "Blue Collar",
            "indicator":        "hydropower.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Water","rate":2},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Alien Power Tower",
            "tile":             ["alienpower"],
            "cost":             [{"resource":"Water","amount":25000},{"resource":"Helium 3","amount":650},{"resource":"Steel","amount":45000},{"resource":"Gold","amount":60000},{"resource":"Aluminum","amount":4500},{"resource":"Uranium","amount":4500},{"resource":"Microchip","amount":40000},{"resource":"Alien Artifact","amount":950}],
            "description":      "alienpower-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Helium 3","amount":6000}],
            "sellValue":        [{"resource":"Water","amount":8000},{"resource":"Helium 3","amount":40},{"resource":"Steel","amount":6000},{"resource":"Gold","amount":2000},{"resource":"Aluminum","amount":800},{"resource":"Uranium","amount":100},{"resource":"Microchip","amount":6},{"resource":"Alien Artifact","amount":12}],
            "sellWarning":      null,
            "refines":          [{"input":"Helium 3","output":"Helium 3"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":45000}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   18,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    250,
            "requiresTech":     ["Alien Quantum Physics","Ancient Alien Manufacturing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Helium 3"],
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       "Blue Collar",
            "indicator":        "alienpower.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Helium 3","rate":200},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -4.2,
                    "y":    -4.2,
                    "r":    0.6,
                    "c":    "#9C27B0",
                    "i":    0.4,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Diamond Crystal Reactor",
            "tile":             ["diamondcrystalreactor"],
            "cost":             [{"resource":"Regolith","amount":70000},{"resource":"Steel","amount":60000},{"resource":"Aluminum","amount":5000},{"resource":"Uranium","amount":2000},{"resource":"Microchip","amount":50000},{"resource":"Diamond","amount":25000},{"resource":"Crystalline","amount":25000},{"resource":"Robot","amount":5000}],
            "description":      "diamondcrystalreactor-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Crystalline","amount":8000},{"resource":"Diamond","amount":8000}],
            "sellValue":        [{"resource":"Regolith","amount":800},{"resource":"Steel","amount":20000},{"resource":"Aluminum","amount":3000},{"resource":"Microchip","amount":20},{"resource":"Diamond","amount":20000},{"resource":"Crystalline","amount":20000}],
            "sellWarning":      null,
            "refines":          [{"input":"Crystalline","output":"Crystalline"},{"input":"Diamond","output":"Diamond"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":275000}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    500,
            "requiresTech":     ["Next Gen Power Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Crystalline","Diamond","Uranium"],
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Uranium,Diamond,Crystalline","rate":100},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0,
                    "y":    0,
                    "r":    3,
                    "c":    "#90CAF9",
                    "i":    .1,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Water Well",
            "tile":             ["waterwell"],
            "cost":             [{"resource":"Wood","amount":50}],
            "description":      "waterwell-description",
            "produces":         null,
            "generates":        "Water",
            "generateTime":     400,
            "generateAmount":   3,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Water","amount":200}],
            "sellValue":        [{"resource":"Wood","amount":16}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"waterwell-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "waterwell.png",
            "canUpgradeTo":     "Atmosphere Condenser",
            "transModeColor":   "#03A9F4",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Small Water Pump",
            "tile":             ["waterpump"],
            "cost":             [{"resource":"Ore","amount":45}],
            "description":      "waterpump-description",
            "produces":         null,
            "generates":        "Water",
            "generateTime":     300,
            "generateAmount":   3,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":16}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Red Planet Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "waterpump.png",
            "canUpgradeTo":     "Atmosphere Condenser",
            "transModeColor":   "#03A9F4",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Salt Water Pump",
            "tile":             ["saltwaterpump"],
            "cost":             [{"resource":"Ore","amount":45}],
            "description":      "saltwaterpump-description",
            "produces":         null,
            "generates":        "Salt Water",
            "generateTime":     200,
            "generateAmount":   6,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Salt Water","amount":30}],
            "sellValue":        [{"resource":"Ore","amount":16}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Water World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#03A9F4",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     ["Salt Water"]
        },
        {
            "name":             "Water Extractor",
            "tile":             ["waterextract"],
            "cost":             [{"resource":"Regolith","amount":100},{"resource":"Ore","amount":80}],
            "description":      "waterextract-description",
            "produces":         [],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Regolith","amount":200}],
            "sellValue":        [{"resource":"Regolith","amount":30},{"resource":"Ore","amount":20}],
            "sellWarning":      null,
            "refines":          [{"input":"Regolith","output":"Regolith"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Regolith","output":"Water","time":200,"ratio":2},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "waterextract.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Helium 3","rate":700},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Aqua Ring",
            "tile":             ["aquaring"],
            "cost":             [{"resource":"Ore","amount":50}],
            "description":      "aquaring-description",
            "produces":         null,
            "generates":        "Salt Water",
            "generateTime":     200,
            "generateAmount":   6,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Salt Water","amount":25}],
            "sellValue":        [{"resource":"Ore","amount":16}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Water World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#03A9F4",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     ["Salt Water"]
        },
        {
            "name":             "Aqua Scrubber",
            "tile":             ["aquascrubber"],
            "cost":             [{"resource":"Ore","amount":65},{"resource":"Salt Water","amount":15}],
            "description":      "aquascrubber-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Salt Water","amount":25},{"resource":"Water","amount":5}],
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Salt Water","output":"Water","time":100,"ratio":4},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Water World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#03A9F4",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Wet Mound",
            "tile":             ["wetmound"],
            "cost":             [{"resource":"Antanium","amount":45}],
            "description":      "wetmound-description",
            "produces":         null,
            "generates":        "Water",
            "generateTime":     300,
            "generateAmount":   5,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Antanium","amount":16}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Advanced Digging"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "wetmound.png",
            "canUpgradeTo":     "Wet Cone",
            "transModeColor":   "#03A9F4",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Atmosphere Condenser",
            "tile":             ["atmoscondensor"],
            "cost":             [{"resource":"Ore","amount":2000},{"resource":"Steel","amount":2500},{"resource":"Gold","amount":3000},{"resource":"Microchip","amount":50}],
            "description":      "atmoscondensor-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Water","amount":250}],
            "sellValue":        [{"resource":"Ore","amount":800},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":1400},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":30}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   4,
            "requiresWorkers":  true,
            "smelts":           {"input":"Atmosphere","output":"Water","time":600,"ratio":60},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Advanced Small Scale Construction","Advanced Chemistry"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        "atmoscondensor.png",
            "canUpgradeTo":     "Ancient Alien Condenser",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Potato Patch",
            "tile":             ["potatopatch"],
            "cost":             [{"resource":"Water","amount":10},{"resource":"Wood","amount":20}],
            "description":      "potatopatch-description",
            "produces":         null,
            "generates":        "Food",
            "generateTime":     750,
            "generateAmount":   20,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":50}],
            "sellValue":        [{"resource":"Wood","amount":16}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"potpatch-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Forest World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "potatopatch.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#4CAF50",
            "requiresFuel":     {"resource":"Water","rate":1000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Food","Farming"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Fisherbots Hut",
            "tile":             ["fisherbothut"],
            "cost":             [{"resource":"Water","amount":10},{"resource":"Wood","amount":30},{"resource":"Ore","amount":10}],
            "description":      "fisherbothut-description",
            "produces":         ["Fisherbot"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":100},{"resource":"Fish","amount":200}],
            "sellValue":        [{"resource":"Wood","amount":16}],
            "sellWarning":      null,
            "refines":          [{"input":"Fish","output":"Fish"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":2}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Fish,Fish","output":"Food","time":250,"ratio":6},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Water World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#4CAF50",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Food","Farming"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Feasting Area",
            "tile":             ["feastingarea"],
            "cost":             [{"resource":"Ore","amount":300},{"resource":"Sugar","amount":200}],
            "description":      "feastingarea-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Sugar","amount":1000},{"resource":"Food","amount":400}],
            "sellValue":        [{"resource":"Sugar","amount":100}],
            "sellWarning":      null,
            "refines":          [{"input":"Sugar","output":"Sugar"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       null,
            "providesShelter":  null,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  false,
            "smelts":           {"input":"Sugar","output":"Food","time":300,"ratio":8},
            "firstBuildMessage":"feastarea-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Insectoid Base"],
            "canRenderStatic":  false,
            "entertains":       10,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "feastingarea.png",
            "canUpgradeTo":     "Food Fortification Facility",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Entertainment","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Greenhouse",
            "tile":             ["greenhouseworking","greenhouse"],
            "cost":             [{"resource":"Ore","amount":35}],
            "description":      "greenhouse-description",
            "produces":         null,
            "generates":        "Food",
            "generateTime":     800,
            "generateAmount":   10,
            "tileWidth":        1,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":100}],
            "sellValue":        [{"resource":"Ore","amount":16}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   1,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"greenhouse-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Botanist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#4CAF50",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Advanced Hydroponics Center",
            "tile":             ["advancedhydro"],
            "cost":              [{"resource":"Ore","amount":2400},{"resource":"Steel","amount":120},{"resource":"Gold","amount":40}],
            "description":      "advancedhydro-description",
            "produces":         null,
            "generates":        "Food",
            "generateTime":     1000,
            "generateAmount":   75,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":150}],
            "sellValue":        [{"resource":"Ore","amount":1000},{"resource":"Steel","amount":40},{"resource":"Gold","amount":15}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":10}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   5,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    25,
            "requiresTech":     ["Advanced Hydroponics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Botanist",
            "indicator":        "advancedhydro.png",
            "canUpgradeTo":     "Vertical Warehouse Farm",
            "transModeColor":   "#4CAF50",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Fish Cannery",
            "tile":             ["fishcannery"],
            "cost":             [{"resource":"Ore","amount":2400},{"resource":"Steel","amount":120},{"resource":"Gold","amount":40},{"resource":"Fish","amount":100}],
            "description":      "fishcannery-description",
            "produces":         null,
            "generates":        "Food",
            "generateTime":     1400,
            "generateAmount":   80,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":200},{"resource":"Fish","amount":200}],
            "sellValue":        [{"resource":"Ore","amount":1000},{"resource":"Steel","amount":40},{"resource":"Gold","amount":15}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":14}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  false,
            "smelts":           {"input":"Fish","output":"Food","time":150,"ratio":8},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Low Atmospheric Zoology"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#4CAF50",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Automated Hydroponics Lab",
            "tile":             ["autohydro"],
            "cost":             [{"resource":"Water","amount":350},{"resource":"Ore","amount":1500},{"resource":"Antanium","amount":350},{"resource":"Gold","amount":120},{"resource":"Aluminum","amount":120}],
            "description":      "autohydro-description",
            "produces":         null,
            "generates":        "Food",
            "generateTime":     1000,
            "generateAmount":   60,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":350}],
            "sellValue":        [{"resource":"Ore","amount":150},{"resource":"Antanium","amount":35},{"resource":"Gold","amount":12},{"resource":"Aluminum","amount":12}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":35}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    25,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#4CAF50",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    1.0,
                    "y":    0.0,
                    "r":    0.75,
                    "c":    "#00ccff",
                    "i":    0.1,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Fish Hatchery",
            "tile":             ["hatchery"],
            "cost":             [{"resource":"Ore","amount":3000},{"resource":"Water","amount":800},{"resource":"Steel","amount":4000},{"resource":"Gold","amount":4500},{"resource":"Microchip","amount":250}],
            "description":      "hatchery-description",
            "produces":         null,
            "generates":        "Food",
            "generateTime":     1400,
            "generateAmount":   400,
            "tileWidth":        3,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":400}],
            "sellValue":        [{"resource":"Ore","amount":1300},{"resource":"Steel","amount":1600},{"resource":"Gold","amount":2100},{"resource":"Microchip","amount":40}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":36}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   14,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Low Atmospheric Zoology"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#4CAF50",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Fishery",
            "tile":             ["fishery"],
            "cost":             [{"resource":"Ore","amount":3400},{"resource":"Steel","amount":4400},{"resource":"Gold","amount":4500},{"resource":"Microchip","amount":250}],
            "description":      "fishery-description",
            "produces":         null,
            "generates":        "Fish",
            "generateTime":     1400,
            "generateAmount":   100,
            "tileWidth":        3,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Fish","amount":800}],
            "sellValue":        [{"resource":"Ore","amount":1300},{"resource":"Steel","amount":1600},{"resource":"Gold","amount":2100},{"resource":"Microchip","amount":40}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":40}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   14,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Low Atmospheric Zoology","Water World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#4CAF50",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     ["Salt Water"]
        },
        {
            "name":             "Food Fortification Facility",
            "tile":             ["foodfortification"],
            "cost":             [{"resource":"Antanium","amount":600},{"resource":"Ant Paste","amount":1800},{"resource":"Civics","amount":400}],
            "description":      "foodfortification-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":1500}],
            "sellValue":        [{"resource":"Antanium","amount":100},{"resource":"Ant Paste","amount":300}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":20}],
            "colGenRate":       null,
            "providesShelter":  null,
            "canChain":         false,
            "acceptsWorkers":   15,
            "requiresWorkers":  false,
            "smelts":           {"input":"Food","output":"Food","time":500,"ratio":20},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Antanium Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "foodfortification.png",
            "canUpgradeTo":     "Quantum Food Fortification",
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Ant Paste","rate":500},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Quantum Food Fortification",
            "tile":             ["quantumfoodfortification"],
            "cost":             [{"resource":"Antanium","amount":600},{"resource":"Ant Paste","amount":1800},{"resource":"Aluminum","amount":3000},{"resource":"Gold","amount":1000},{"resource":"Microchip","amount":100},{"resource":"Alien Relic","amount":150},{"resource":"Alien Artifact","amount":50}],
            "description":      "quantumfoodfortification-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":15000}],
            "sellValue":        [{"resource":"Antanium","amount":100},{"resource":"Ant Paste","amount":300}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":550}],
            "colGenRate":       null,
            "providesShelter":  null,
            "canChain":         false,
            "acceptsWorkers":   15,
            "requiresWorkers":  false,
            "smelts":           {"input":"Food","output":"Food","time":200,"ratio":250},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Antanium Production","Ancient Alien Language"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Ant Paste","rate":400},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Food","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Vertical Warehouse Farm",
            "tile":             ["vertfarm"],
            "cost":             [{"resource":"Money","amount":15000},{"resource":"Water","amount":2800},{"resource":"Ore","amount":6000},{"resource":"Steel","amount":10000},{"resource":"Gold","amount":7000},{"resource":"Wood","amount":1000},{"resource":"Microchip","amount":500},{"resource":"Alien Artifact","amount":100}],
            "description":      "vertfarm-description",
            "produces":         null,
            "generates":        "Food",
            "generateTime":     2500,
            "generateAmount":   500,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource": "Food","amount":10000}],
            "sellValue":        [{"resource":"Ore","amount":1000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":7000},{"resource":"Wood","amount":200},{"resource":"Microchip","amount":4},{"resource":"Alien Artifact","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":100}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   35,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    500,
            "requiresTech":     ["Tall Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       "Blue Collar",
            "indicator":        "vertfarm.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#8BC34A",
            "requiresFuel":     {"resource":"Water","rate":2000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Food Processing Sweatshop",
            "tile":             ["sweatshop3"],
            "cost":             [{"resource":"Food","amount":6000},{"resource":"Ore","amount":15000},{"resource":"Steel","amount":11000},{"resource":"Gold","amount":7000},{"resource":"Sugar","amount":2000},{"resource":"Aluminum","amount":2000},{"resource":"Microchip","amount":800}],
            "description":      "sweatshop3-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     25000,
            "generateAmount":   1,
            "tileWidth":        4,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":400},{"resource":"Sugar","amount":400}],
            "sellValue":        [{"resource":"Ore","amount":1300},{"resource":"Steel","amount":1600},{"resource":"Gold","amount":2100},{"resource":"Microchip","amount":40}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":160}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   225,
            "requiresWorkers":  true,
            "smelts":           {"input":"Sugar","output":"Food","time":1400,"ratio":2000},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Large Scale Construction","Low Gravity Manufacturing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        "sweatshop3.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#4CAF50",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Silo",
            "tile":             ["silo"],
            "cost":             [{"resource":"Ore","amount":20}],
            "description":      "silo-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":250},{"resource":"Sugar","amount":500}],
            "sellValue":        [{"resource":"Ore","amount":8}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "silo.png",
            "canUpgradeTo":     "Large Silo",
            "transModeColor":   "#4CAF50",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Food","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ore Mine",
            "tile":             ["mine"],
            "cost":             [{"resource":"Ore","amount":500}],
            "description":      "mine-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Ore Mine",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Red Planet Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "mine.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Gold Mine",
            "tile":             ["goldmine"],
            "cost":             [{"resource":"Ore","amount":1500},{"resource":"Steel","amount":150}],
            "description":      "goldmine-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Gold Mine",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Advanced Small Scale Construction","Advanced Gold Mining"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "goldmine.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Small Atmosphere Generator",
            "tile":             ["atmosgen"],
            "cost":             [{"resource":"Ore","amount":700},{"resource":"Steel","amount":20}],
            "description":      "atmosgen-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     750,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":280}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"atmosgen-firstbuild",
            "isChopShop":       false,
            "earthTaxValue":    10,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "atmosgen.png",
            "canUpgradeTo":     "Medium Atmosphere Generator",
            "transModeColor":   "#81D4FA",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Terraforming"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Medium Atmosphere Generator",
            "tile":             ["atmosgen2"],
            "cost":             [{"resource":"Ore","amount":6000},{"resource":"Steel","amount":2600},{"resource":"Gold","amount":1500}],
            "description":      "atmosgen2-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     750,
            "generateAmount":   45,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":2500},{"resource":"Steel","amount":1100},{"resource":"Gold","amount":500}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":30}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Advanced Small Scale Construction","Low Gravity Manufacturing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "atmosgen2.png",
            "canUpgradeTo":     "Large Atmosphere Generator",
            "transModeColor":   "#81D4FA",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Terraforming"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Large Atmosphere Generator",
            "tile":             ["atmosgen3"],
            "cost":             [{"resource":"Ore","amount":16000},{"resource":"Steel","amount":8000},{"resource":"Gold","amount":6000},{"resource":"Aluminum","amount":2000},{"resource":"Microchip","amount":200}],
            "description":      "atmosgen3-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     500,
            "generateAmount":   500,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Steel","amount":600},{"resource":"Gold","amount":400},{"resource":"Aluminum","amount":100},{"resource":"Microchip","amount":4}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":180}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    16,
            "requiresTech":     ["Large Scale Construction","Low Gravity Manufacturing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#81D4FA",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Terraforming"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Small Vehicle Factory",
            "tile":             ["factory"],
            "cost":             [{"resource":"Ore","amount":350}],
            "description":      "factory-description",
            "produces":         ["Rover","Lunar Rover","Ether Rover","Sugar Rover","Forest Rover","Waterbot","Fisherbot","Builder Bot","Advanced Builder Bot","Greenbot","Megabot","Megabot Deluxe","Extraterrestrial Builder","Turbo ET Builder","Lumberbot","Claybot","Ore Miner","Regolith Miner","Gold Miner","Diamond Miner","Crudebot","Small Rover Transport","Aluminum Miner","Uranium Miner","Crystalbot"],
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wheel","amount":250}],
            "sellValue":        [{"resource":"Ore","amount":160}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   1,
            "requiresWorkers":  false,
            "smelts":           {"input":"Ore","output":"Wheel","time":1500,"ratio":2},
            "firstBuildMessage":"smveh-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Wheel"],
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "factory.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ore Refinery",
            "tile":             ["refinery"],
            "cost":             [{"resource":"Ore","amount":1200}],
            "description":      "refinery-description",
            "produces":         ["Ore Miner","Used Ore Miner"],
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Steel","amount":8000},{"resource":"Ore","amount":16000}],
            "sellValue":        [{"resource":"Ore","amount":500}],
            "sellWarning":      null,
            "refines":          [{"input":"Ore","output":"Ore"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":6}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   3,
            "requiresWorkers":  false,
            "smelts":           {"input":"Ore","output":"Steel","time":1500,"ratio":5},
            "firstBuildMessage":"orerefinery-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        "refinery.png",
            "canUpgradeTo":     "Advanced Ore Refinery",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Landing Pad",
            "tile":             ["landingpad"],
            "cost":             [{"resource":"Ore","amount":1000}],
            "description":      "landing-pad-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":600}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       3000,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"landingpad-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    5,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Food"],
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "landingpad.png",
            "canUpgradeTo":     "Star Gate",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Immigration"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.4,
                    "y":    0.4,
                    "r":    0.3,
                    "c":    "#ff0000",
                    "i":    0.4,
                    "nightonly": true,
                    "oncycles": [0,4,8,9,10,11]
                },
                {
                    "x":    1.2,
                    "y":    0.1,
                    "r":    0.3,
                    "c":    "#0000ff",
                    "i":    0.4,
                    "nightonly": true,
                    "oncycles": [1,5,8,9,10,11]
                },
                {
                    "x":    2.18,
                    "y":    0.45,
                    "r":    0.3,
                    "c":    "#ff0000",
                    "i":    0.4,
                    "nightonly": true,
                    "oncycles": [2,6,8,9,10,11]
                },
                {
                    "x":    0,
                    "y":    1.2,
                    "r":    0.3,
                    "c":    "#0000ff",
                    "i":    0.4,
                    "nightonly": true,
                    "oncycles": [3,7,8,9,10,11]
                },
                {
                    "x":    2.5,
                    "y":    1.5,
                    "r":    0.3,
                    "c":    "#0000ff",
                    "i":    0.4,
                    "nightonly": true,
                    "oncycles": [3,7,8,9,10,11]
                },
                {
                    "x":    0.4,
                    "y":    2.2,
                    "r":    0.3,
                    "c":    "#ff0000",
                    "i":    0.4,
                    "nightonly": true,
                    "oncycles": [2,6,8,9,10,11]
                },
                {
                    "x":    1.5,
                    "y":    2.6,
                    "r":    0.3,
                    "c":    "#0000ff",
                    "i":    0.4,
                    "nightonly": true,
                    "oncycles": [1,5,8,9,10,11]
                },
                {
                    "x":    2.3,
                    "y":    2.3,
                    "r":    0.3,
                    "c":    "#ff0000",
                    "i":    0.4,
                    "nightonly": true,
                    "oncycles": [0,4,8,9,10,11]
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Small Shelter",
            "tile":             ["smallshelter"],
            "cost":             [{"resource":"Ore","amount":200}],
            "description":      "small-shelter-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Money","amount":25}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  3,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "smallshelter.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1.5,
                    "c":    "#E1F5FE",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Chop Shop",
            "tile":             ["chopshop"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Steel","amount":10}],
            "description":      "chop-shop-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Money","amount":25}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   1,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"chopshop-firstbuild-tut",
            "isChopShop":       true,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "chopshop.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Gold Refinery",
            "tile":             ["goldrefinery"],
            "cost":             [{"resource":"Ore","amount":2000},{"resource":"Steel","amount":80}],
            "description":      "goldrefinery-description",
            "produces":         ["Gold Miner"],
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Gold","amount":5000}],
            "sellValue":        [{"resource":"Money","amount":850},{"resource":"Steel","amount":30}],
            "sellWarning":      null,
            "refines":          [{"input":"Gold","output":"Gold"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":8}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   4,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":"goldrefin-firstbuild",
            "isChopShop":       false,
            "earthTaxValue":    20,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        "goldrefinery.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Gold Mint",
            "tile":             ["goldsmelter"],
            "cost":             [{"resource":"Ore","amount":2200},{"resource":"Steel","amount":100}],
            "description":      "goldsmelter-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Gold","amount":10000}],
            "sellValue":        [{"resource":"Ore","amount":900},{"resource":"Steel","amount":40}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":6}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   3,
            "requiresWorkers":  true,
            "smelts":           {"input":"Gold","output":"Money","time":2000,"ratio":14},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    25,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        "goldsmelter.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Small Research Lab",
            "tile":             ["smalllab"],
            "cost":             [{"resource":"Ore","amount":1800},{"resource":"Steel","amount":80},{"resource":"Gold","amount":25}],
            "description":      "smalllab-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     1500,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Steel","amount":30},{"resource":"Gold","amount":8}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":6}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   5,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":"smresearch-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        "smalllab.png",
            "canUpgradeTo":     "Advanced Small Research Lab",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Research"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       90,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Advanced Small Research Lab",
            "tile":             ["smalllab2"],
            "cost":             [{"resource":"Ore","amount":2200},{"resource":"Steel","amount":200},{"resource":"Gold","amount":65},{"resource":"Software","amount":20}],
            "description":      "smalllab2-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     1000,
            "generateAmount":   6,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Software","amount":50}],
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Steel","amount":30},{"resource":"Gold","amount":8}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":8},{"utility":"Bandwidth","amount":8}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    40,
            "requiresTech":     ["Basic Network Infrastructure"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Software","rate":6000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Research","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       90,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Small Server Building",
            "tile":             ["smserverbld"],
            "cost":             [{"resource":"Ore","amount":2000},{"resource":"Steel","amount":100},{"resource":"Gold","amount":35},{"resource":"Microchip","amount":10}],
            "description":      "smsrvbld-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Software","amount":150}],
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Steel","amount":30},{"resource":"Gold","amount":8}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Bandwidth","amount":50}],
            "requiresUtility":  [{"utility":"Power","amount":10}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Basic Network Infrastructure"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       90,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Large Server Building",
            "tile":             ["largeserverbuilding"],
            "cost":             [{"resource":"Ore","amount":50000},{"resource":"Steel","amount":10000},{"resource":"Gold","amount":10000},{"resource":"Microchip","amount":9000},{"resource":"Plastic","amount":12000},{"resource":"Aluminum","amount":8000},{"resource":"Software","amount":2000},{"resource":"Robot","amount":300}],
            "description":      "largeserverbuilding-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Software","amount":600}],
            "sellValue":        [{"resource":"Ore","amount":5000},{"resource":"Steel","amount":1000},{"resource":"Gold","amount":1000},{"resource":"Microchip","amount":9},{"resource":"Plastic","amount":1200},{"resource":"Aluminum","amount":800}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Bandwidth","amount":900}],
            "requiresUtility":  [{"utility":"Power","amount":350}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   35,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    90,
            "requiresTech":     ["United Earth Base","Mass Data Management"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       110,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Proxy Server Building",
            "tile":             ["proxyserverbld"],
            "cost":             [{"resource":"Ore","amount":40000},{"resource":"Steel","amount":9000},{"resource":"Gold","amount":10000},{"resource":"Microchip","amount":9000},{"resource":"Plastic","amount":12000},{"resource":"Aluminum","amount":8000},{"resource":"Software","amount":2000},{"resource":"Robot","amount":300}],
            "description":      "proxyserverbld-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Software","amount":600}],
            "sellValue":        [{"resource":"Ore","amount":5000},{"resource":"Steel","amount":1000},{"resource":"Gold","amount":1000},{"resource":"Microchip","amount":9},{"resource":"Plastic","amount":1200},{"resource":"Aluminum","amount":800}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Bandwidth","amount":700}],
            "requiresUtility":  [{"utility":"Power","amount":380}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   25,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    90,
            "requiresTech":     ["LIS Base","Mass Data Management","Proxy Servers"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       110,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Small Software Studio",
            "tile":             ["smsoftwarestudio"],
            "cost":             [{"resource":"Ore","amount":2400},{"resource":"Steel","amount":160},{"resource":"Gold","amount":45},{"resource":"Microchip","amount":25}],
            "description":      "smsoftwarestudio-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Software","amount":300}],
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Steel","amount":30},{"resource":"Gold","amount":8}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":14},{"utility":"Bandwidth","amount":8}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           {"input":"Microchip","output":"Software","time":9000,"ratio":3},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Basic Education","Basic Network Infrastructure"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       90,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "I.T. Studio Complex",
            "tile":             ["itstudiocomplex"],
            "cost":             [{"resource":"Ore","amount":9500},{"resource":"Steel","amount":7000},{"resource":"Gold","amount":6500},{"resource":"Aluminum","amount":5000},{"resource":"Microchip","amount":2500}],
            "description":      "itstudiocomplex-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Software","amount":1200}],
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Steel","amount":30},{"resource":"Aluminum","amount":30},{"resource":"Gold","amount":8}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":240},{"utility":"Bandwidth","amount":85}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   30,
            "requiresWorkers":  true,
            "smelts":           {"input":"Microchip,Microchip,Microchip,Microchip,Microchip,Microchip,Microchip","output":"Software","time":3500,"ratio":28},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     ["Basic Education","Advanced Networking Infrastructure"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       90,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Small Server Farm Operation",
            "tile":             ["smserverfarm"],
            "cost":             [{"resource":"Ore","amount":3000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":980},{"resource":"Microchip","amount":45}],
            "description":      "smserverfarm-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     2800,
            "generateAmount":   12,
            "tileWidth":        2,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":300},{"resource":"Steel","amount":2000},{"resource":"Gold","amount":98}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":40},{"utility":"Bandwidth","amount":25}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   5,
            "requiresWorkers":  true,
            "smelts":           {"input":"Microchip","output":"Money","time":2500,"ratio":60},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    80,
            "requiresTech":     ["Basic Network Infrastructure"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Economy","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Large Silo",
            "tile":             ["largesilo"],
            "cost":             [{"resource":"Ore","amount":120},{"resource":"Steel","amount":35}],
            "description":      "silo2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":1500},{"resource":"Sugar","amount":3000}],
            "sellValue":        [{"resource":"Ore","amount":50},{"resource":"Steel","amount":12}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    10,
            "requiresTech":     ["Advanced Small Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "largesilo.png",
            "canUpgradeTo":     "Subterranean Food Storage",
            "transModeColor":   "#4CAF50",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Food","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Green Dome",
            "tile":             ["greendome"],
            "cost":             [{"resource":"Ore","amount":600},{"resource":"Steel","amount":350}],
            "description":      "greendome-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":275},{"resource":"Steel","amount":120}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    10,
            "requiresTech":     ["Advanced Small Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       8,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "greendome.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Entertainment"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Advanced Ore Refinery",
            "tile":             ["refinery2"],
            "cost":             [{"resource":"Ore","amount":3000},{"resource":"Steel","amount":600},{"resource":"Gold","amount":200}],
            "description":      "refinery2-description",
            "produces":         ["Ore Miner","Used Ore Miner"],
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Steel","amount":50000},{"resource":"Ore","amount":100000}],
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Steel","amount":200},{"resource":"Gold","amount":75}],
            "sellWarning":      null,
            "refines":          [{"input":"Ore","output":"Ore"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":20}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           {"input":"Ore","output":"Steel","time":1200,"ratio":28},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    35,
            "requiresTech":     ["Advanced Small Scale Construction","Advanced Ore Purification"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        "refinery2.png",
            "canUpgradeTo":     "Ancient Alien Ore Refinery",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Residential Complex",
            "tile":             ["rescomplex"],
            "cost":             [{"resource":"Ore","amount":3200},{"resource":"Steel","amount":1000},{"resource":"Gold","amount":650}],
            "description":      "rescomplex-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2000,
            "generateAmount":   10,
            "tileWidth":        2,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":1500},{"resource":"Steel","amount":400},{"resource":"Gold","amount":300}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":30}],
            "colGenRate":       0,
            "providesShelter":  26,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    35,
            "requiresTech":     ["Advanced Small Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "rescomplex.png",
            "canUpgradeTo":     "Residential Tower",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Blue Residential Complex",
            "tile":             ["rescomplexblue"],
            "cost":             [{"resource":"Ore","amount":3200},{"resource":"Steel","amount":1000},{"resource":"Gold","amount":650}],
            "description":      "rescomplexblue-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2000,
            "generateAmount":   8,
            "tileWidth":        1,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":1500},{"resource":"Steel","amount":400},{"resource":"Gold","amount":300}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":30}],
            "colGenRate":       0,
            "providesShelter":  26,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    35,
            "requiresTech":     ["Advanced Small Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Blue Residential Tower",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Housing","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Mass Driver",
            "tile":             ["massdriver"],
            "cost":             [{"resource":"Ore","amount":6000},{"resource":"Steel","amount":4500},{"resource":"Gold","amount":2500}],
            "description":      "massdriver-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     3000,
            "generateAmount":   5,
            "tileWidth":        7,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":2600},{"resource":"Steel","amount":2000},{"resource":"Gold","amount":1100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":45}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   3,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    70,
            "requiresTech":     ["United Earth Base","Advanced Small Scale Construction","Colonial Finance Theory"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        ["Food","Water","Rum","Wool","Wood","Clay","Charcoal","Regolith","Ore","Steel","Gold","Aluminum","Oil","Helium 3","Toy","Uranium","Pottery","Bricks","Microchip","Robot","Alien Artifact"],
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        "massdriver.png",
            "canUpgradeTo":     "Galactic Freight",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    300,
            "upkeepCost":       0.0,
            "giftCapacity":     300,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Microchip Factory",
            "tile":             ["chipfactory"],
            "cost":             [{"resource":"Ore","amount":7000},{"resource":"Steel","amount":5000},{"resource":"Gold","amount":3000}],
            "description":      "chipfactory-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        3,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Microchip","amount":1000}],
            "sellValue":        [{"resource":"Ore","amount":3000},{"resource":"Steel","amount":2000},{"resource":"Gold","amount":1300}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":60}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   26,
            "requiresWorkers":  true,
            "smelts":           {"input":"Gold","output":"Microchip","time":20000,"ratio":3},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    85,
            "requiresTech":     ["Advanced Small Scale Construction","Colonial Finance Theory","Low Gravity Manufacturing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        "chipfactory.png",
            "canUpgradeTo":     "Advanced Microchip Factory",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Durable Goods"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Civic Center",
            "tile":             ["civiccenter"],
            "cost":             [{"resource":"Ore","amount":6000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":2000},{"resource":"Microchip","amount":5}],
            "description":      "civiccenter-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":2600},{"resource":"Steel","amount":1400},{"resource":"Gold","amount":800}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":25}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":15000,"ratio":5},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     ["Colonial Finance Theory","Colonial Civics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        "civiccenter.png",
            "canUpgradeTo":     "Integrated Civic Center",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Integrated Civic Center",
            "tile":             ["civiccenter2"],
            "cost":             [{"resource":"Ore","amount":8000},{"resource":"Steel","amount":4000},{"resource":"Gold","amount":3000},{"resource":"Microchip","amount":50},{"resource":"Software","amount":50}],
            "description":      "civiccenter2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":2600},{"resource":"Steel","amount":1400},{"resource":"Gold","amount":800}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":65},{"utility":"Bandwidth","amount":20}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money,Software","output":"Civics","time":10000,"ratio":25},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    25,
            "requiresTech":     ["Basic Network Infrastructure","Colonial Finance Theory","Colonial Civics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Official News Station",
            "tile":             ["newsstation"],
            "cost":             [{"resource":"Ore","amount":10000},{"resource":"Steel","amount":5000},{"resource":"Gold","amount":3500},{"resource":"Aluminum","amount":200},{"resource":"Rum","amount":75},{"resource":"Microchip","amount":150},{"resource":"Software","amount":75}],
            "description":      "newsstation-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     4000,
            "generateAmount":   2,
            "tileWidth":        1,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":1000},{"resource":"Steel","amount":500},{"resource":"Gold","amount":350},{"resource":"Aluminum","amount":20},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":75},{"utility":"Bandwidth","amount":30}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   10,
            "requiresWorkers":  true,
            "smelts":           {"input":"Software,Rum","output":"Civics","time":7000,"ratio":40},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Multimedia Infrastructure"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "White Collar",
            "indicator":        null,
            "canUpgradeTo":     "Imperial Propaganda Office",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Imperial Propaganda Office",
            "tile":             ["imppropaganda"],
            "cost":             [{"resource":"Ore","amount":15000},{"resource":"Steel","amount":9000},{"resource":"Gold","amount":5500},{"resource":"Aluminum","amount":600},{"resource":"Rum","amount":200},{"resource":"Microchip","amount":300},{"resource":"Software","amount":150},{"resource":"Helium 3","amount":150},{"resource":"Charcoal","amount":1000},{"resource":"Oil","amount":1500},{"resource":"Wood","amount":900},{"resource":"Plastic","amount":900}],
            "description":      "imppropaganda-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":1000},{"resource":"Steel","amount":500},{"resource":"Gold","amount":350},{"resource":"Aluminum","amount":20},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":180},{"utility":"Bandwidth","amount":150}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   18,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money,Money,Money,Money,Software,Microchip,Microchip,Microchip","output":"Civics","time":5000,"ratio":400},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["United Earth Base","Multimedia Infrastructure","Imperialism","Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "White Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government","Information Technology","Government"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Statue",
            "tile":             ["statue1"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200},{"resource":"Gold","amount":500}],
            "description":      "statue1-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Colonial Civics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "statue1.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ore Fracking Operation",
            "tile":             ["orefracking"],
            "cost":             [{"resource":"Ore","amount":7000},{"resource":"Water","amount":400},{"resource":"Steel","amount":3500},{"resource":"Gold","amount":2500},{"resource":"Microchip","amount":25}],
            "description":      "fracking-description",
            "produces":         null,
            "generates":        "Ore",
            "generateTime":     1000,
            "generateAmount":   50,
            "tileWidth":        2,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":3000},{"resource":"Steel","amount":1100},{"resource":"Gold","amount":1100},{"resource":"Microchip","amount":10}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":45}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   14,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    20,
            "requiresTech":     ["Red Planet Base|Water World Base","Advanced Ore Purification","Advanced Small Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Gold Synthesis Lab",
            "tile":             ["gldsynth"],
            "cost":             [{"resource":"Ore","amount":4500},{"resource":"Steel","amount":4000},{"resource":"Gold","amount":4500},{"resource":"Microchip","amount":60}],
            "description":      "gldsynth-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     1000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Gold","amount":15000}],
            "sellValue":        [{"resource":"Ore","amount":2200},{"resource":"Steel","amount":1400},{"resource":"Gold","amount":2100},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":55}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           {"input":"Ore","output":"Gold","time":1200,"ratio":15},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Advanced Ore Purification","Advanced Small Scale Construction","Advanced Chemistry"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        "gldsynth.png",
            "canUpgradeTo":     "Ancient Alien Gold Synthesis",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Water Tank",
            "tile":             ["smalltank"],
            "cost":             [{"resource":"Ore","amount":20}],
            "description":      "smalltank-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Water","amount":1500}],
            "sellValue":        [{"resource":"Ore","amount":8}],
            "sellWarning":      null,
            "refines":          [{"input":"Water","output":"Water"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "smalltank.png",
            "canUpgradeTo":     "Water Tower",
            "transModeColor":   "#03A9F4",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Food","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Salt Water Tank",
            "tile":             ["saltwatertank"],
            "cost":             [{"resource":"Ore","amount":20}],
            "description":      "saltwatertank-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Salt Water","amount":1750}],
            "sellValue":        [{"resource":"Ore","amount":8}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Water World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#03A9F4",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Desalination Factility",
            "tile":             ["desalinationfacility"],
            "cost":             [{"resource":"Ore","amount":2000},{"resource":"Steel","amount":150}],
            "description":      "desalinationfacility-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     8000,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Salt Water","amount":8000},{"resource":"Water","amount":8000}],
            "sellValue":        [{"resource":"Ore","amount":900},{"resource":"Steel","amount":40}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":40}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           {"input":"Salt Water","output":"Water","time":800,"ratio":150},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    25,
            "requiresTech":     ["Water World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Aluminum Refinery",
            "tile":             ["aluminumrefinery"],
            "cost":             [{"resource":"Ore","amount":1200},{"resource":"Water","amount":500},{"resource":"Steel","amount":4000},{"resource":"Gold","amount":850},{"resource":"Microchip","amount":200}],
            "description":      "aluminumrefinery-description",
            "produces":         ["Aluminum Miner"],
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Aluminum","amount":25000}],
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":300},{"resource":"Microchip","amount":4}],
            "sellWarning":      null,
            "refines":          [{"input":"Aluminum","output":"Aluminum"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":40}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   13,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Advanced Chemistry"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        "aluminum-refinery.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Water Tower",
            "tile":             ["watertower"],
            "cost":             [{"resource":"Ore","amount":120},{"resource":"Steel","amount":90}],
            "description":      "watertower-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Water","amount":7000}],
            "sellValue":        [{"resource":"Ore","amount":45},{"resource":"Steel","amount":30}],
            "sellWarning":      null,
            "refines":          [{"input":"Water","output":"Water"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Advanced Small Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "watertower.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#03A9F4",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Food","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Bacteria Farm",
            "tile":             ["bacteriafarm"],
            "cost":             [{"resource":"Ore","amount":8500},{"resource":"Water","amount":900},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":2000},{"resource":"Aluminum","amount":600},{"resource":"Microchip","amount":45}],
            "description":      "bacteriafarm-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     900,
            "generateAmount":   160,
            "tileWidth":        2,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":3000},{"resource":"Water","amount":350},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":800},{"resource":"Aluminum","amount":200},{"resource":"Microchip","amount":7}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":65}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   5,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Advanced Microbiology","Low Gravity Manufacturing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       "Botanist",
            "indicator":        "bacteriafarm.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#81D4FA",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Terraforming","Farming"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Fir Trees",
            "tile":             ["firtrees"],
            "cost":             [{"resource":"Water","amount":20}],
            "description":      "firtrees-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Fir Trees",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "firtrees.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Aspen Trees",
            "tile":             ["aspentree"],
            "cost":             [{"resource":"Water","amount":20}],
            "description":      "aspentree-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Aspen Trees",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "First Aid Station",
            "tile":             ["firstaid"],
            "cost":             [{"resource":"Ore","amount":900}],
            "description":      "firstaid-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":90}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   1,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    10,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Medic",
            "indicator":        null,
            "canUpgradeTo":     "Medical Clinic",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            2,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Medical"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Lumber Mill",
            "tile":             ["lumbermill"],
            "cost":             [{"resource":"Ore","amount":3000},{"resource":"Water","amount":600},{"resource":"Steel","amount":1000},{"resource":"Gold","amount":250},{"resource":"Aluminum","amount":250},{"resource":"Microchip","amount":5}],
            "description":      "lumbermill-description",
            "produces":         ["Lumberbot"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wood","amount":12500}],
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Water","amount":200},{"resource":"Steel","amount":400},{"resource":"Gold","amount":100},{"resource":"Aluminum","amount":100},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          [{"input":"Wood","output":"Wood"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":6}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    6,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        "lumbermill.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Lush Hedge Wall",
            "tile":             ["hedgewall"],
            "cost":             [{"resource":"Water","amount":250}],
            "description":      "hedgewall-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     [],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Wall",
            "tile":             ["wall"],
            "cost":             [{"resource":"Ore","amount":40},{"resource":"Steel","amount":5}],
            "description":      "wall-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     [],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "wall.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Tree Farm",
            "tile":             ["treefarm"],
            "cost":             [{"resource":"Ore","amount":120},{"resource":"Water","amount":6000},{"resource":"Wood","amount":850}],
            "description":      "treefarm-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     5000,
            "generateAmount":   1,
            "tileWidth":        5,
            "tileHeight":       5,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wood","amount":6000}],
            "sellValue":        [{"resource":"Ore","amount":12},{"resource":"Wood","amount":85}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":4}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   3,
            "requiresWorkers":  false,
            "smelts":           {"input":"Water","output":"Wood","time":1200,"ratio":5},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Advanced Small Scale Construction","Advanced Microbiology"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Botanist",
            "indicator":        null,
            "canUpgradeTo":     "Ether Tree Farm",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Farming"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ether Tree Farm",
            "tile":             ["ethertreefarm"],
            "cost":             [{"resource":"Ore","amount":300},{"resource":"Water","amount":6000},{"resource":"Wood","amount":1850},{"resource":"Microchip","amount":20},{"resource":"Software","amount":5},{"resource":"Ether","amount":600}],
            "description":      "ethertreefarm-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     3000,
            "generateAmount":   1,
            "tileWidth":        5,
            "tileHeight":       5,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wood","amount":7000}],
            "sellValue":        [{"resource":"Ore","amount":30},{"resource":"Wood","amount":185}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":8},{"utility":"Bandwidth","amount":2}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   5,
            "requiresWorkers":  false,
            "smelts":           {"input":"Water","output":"Wood","time":800,"ratio":50},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    40,
            "requiresTech":     ["Advanced Small Scale Construction","Advanced Microbiology","Basic Network Infrastructure"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Botanist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Ether","rate":1000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Farming"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Single Family Home",
            "tile":             ["sfhouse"],
            "cost":             [{"resource":"Wood","amount":250},{"resource":"Steel","amount":50},{"resource":"Microchip","amount":10},{"resource":"Pottery","amount":5}],
            "description":      "sfhouse-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2600,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Wood","amount":120},{"resource":"Steel","amount":20},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  6,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     ["Advanced Small Scale Construction","Advanced Microbiology"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        "sfhouse.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1.5,
                    "c":    "#FFF8E1",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Large Water Tower",
            "tile":             ["lgwatertower"],
            "cost":             [{"resource":"Ore","amount":600},{"resource":"Wood","amount":200},{"resource":"Steel","amount":900},{"resource":"Aluminum","amount":200}],
            "description":      "lgwatertower-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Water","amount":90000}],
            "sellValue":        [{"resource":"Ore","amount":200},{"resource":"Wood","amount":75},{"resource":"Steel","amount":400},{"resource":"Aluminum","amount":80}],
            "sellWarning":      null,
            "refines":          [{"input":"Water","output":"Water"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "lgwatertower.png",
            "canUpgradeTo":     "Quantum Water Tower",
            "transModeColor":   "#03A9F4",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Food","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -2.9,
                    "y":    -2.9,
                    "r":    0.15,
                    "c":    "#ff0000",
                    "i":    0.3,
                    "nightonly": true
                },
                {
                    "x":    -2.1,
                    "y":    -2.6,
                    "r":    0.15,
                    "c":    "#ff0000",
                    "i":    0.3,
                    "nightonly": true
                },
                {
                    "x":    -2.5,
                    "y":    -2.05,
                    "r":    0.15,
                    "c":    "#ff0000",
                    "i":    0.3,
                    "nightonly": true
                },
                {
                    "x":    -3.35,
                    "y":    -2.1,
                    "r":    0.15,
                    "c":    "#ff0000",
                    "i":    0.3,
                    "nightonly": true
                },
                {
                    "x":    -3.5,
                    "y":    -2.85,
                    "r":    0.15,
                    "c":    "#ff0000",
                    "i":    0.3,
                    "nightonly": true
                },
                {
                    "x":    -3.1,
                    "y":    -3.35,
                    "r":    0.15,
                    "c":    "#ff0000",
                    "i":    0.3,
                    "nightonly": true
                },
                {
                    "x":    -2.2,
                    "y":    -3.35,
                    "r":    0.15,
                    "c":    "#ff0000",
                    "i":    0.3,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Uranium Enrichment Facility",
            "tile":             ["uraniumenrichment"],
            "cost":             [{"resource":"Ore","amount":6000},{"resource":"Water","amount":1000},{"resource":"Steel","amount":6000},{"resource":"Gold","amount":3000},{"resource":"Aluminum","amount":2000},{"resource":"Microchip","amount":2000}],
            "description":      "urenrich-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        4,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Uranium","amount":3000}],
            "sellValue":        [{"resource":"Ore","amount":2200},{"resource":"Water","amount":400},{"resource":"Steel","amount":2400},{"resource":"Gold","amount":1100},{"resource":"Aluminum","amount":800},{"resource":"Microchip","amount":80}],
            "sellWarning":      null,
            "refines":          [{"input":"Uranium","output":"Uranium"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   70,
            "requiresWorkers":  true,
            "smelts":           {"input":"Uranium","output":"Uranium","time":12000,"ratio":2},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    120,
            "requiresTech":     ["Advanced Nuclear Physics","Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Aluminum"],
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        "uraniumenrichment.png",
            "canUpgradeTo":     "Alien Enrichment Facility",
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Aluminum","rate":800},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Large Residential Complex",
            "tile":             ["largeres"],
            "cost":             [{"resource":"Ore","amount":10000},{"resource":"Water","amount":600},{"resource":"Steel","amount":9000},{"resource":"Gold","amount":2000},{"resource":"Aluminum","amount":1000},{"resource":"Microchip","amount":320}],
            "description":      "largeres-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2000,
            "generateAmount":   50,
            "tileWidth":        2,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":4000},{"resource":"Water","amount":50},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":400},{"resource":"Aluminum","amount":200},{"resource":"Microchip","amount":30}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":120}],
            "colGenRate":       0,
            "providesShelter":  320,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    70,
            "requiresTech":     ["Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "largeres.png",
            "canUpgradeTo":     "Larger Residential Complex",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Capitol",
            "tile":             ["capitol"],
            "cost":             [{"resource":"Ore","amount":16000},{"resource":"Water","amount":1200},{"resource":"Wood","amount":1200},{"resource":"Steel","amount":14000},{"resource":"Gold","amount":9000},{"resource":"Aluminum","amount":2000},{"resource":"Microchip","amount":950},{"resource":"Civics","amount":3000}],
            "description":      "capitol-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        9,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":7000},{"resource":"Wood","amount":500},{"resource":"Steel","amount":5000},{"resource":"Gold","amount":2500},{"resource":"Aluminum","amount":750},{"resource":"Microchip","amount":40}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":60}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   80,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":14000,"ratio":65},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    60,
            "requiresTech":     ["United Earth Base","Colonial Finance Theory","Colonial Civics","Large Scale Construction","Self Governance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        "capitol.png",
            "canUpgradeTo":     "Capitol Level 2",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     500,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    1,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Subterranean Food Storage",
            "tile":             ["subtfood"],
            "cost":             [{"resource":"Ore","amount":600},{"resource":"Clay","amount":800},{"resource":"Wood","amount":200},{"resource":"Steel","amount":900},{"resource":"Aluminum","amount":200}],
            "description":      "subtfood-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":12000},{"resource":"Sugar","amount":12000}],
            "sellValue":        [{"resource":"Ore","amount":250},{"resource":"Wood","amount":80},{"resource":"Steel","amount":350},{"resource":"Aluminum","amount":90}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":4}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Large Scale Construction","Deep Excavation"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "subtfood.png",
            "canUpgradeTo":     "Quantum Food Storage",
            "transModeColor":   "#4CAF50",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Food","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Bank",
            "tile":             ["bank"],
            "cost":             [{"resource":"Money","amount":1500},{"resource":"Ore","amount":5500},{"resource":"Steel","amount":2900},{"resource":"Gold","amount":2200},{"resource":"Microchip","amount":15},{"resource":"Civics","amount":200}],
            "description":      "bank-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1500,
            "generateAmount":   2,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Gold","amount":40000}],
            "sellValue":        [{"resource":"Money","amount":1600},{"resource":"Ore","amount":2400},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":900},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":12}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Money","time":8000,"ratio":10},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     ["Colonial Finance Theory","Colonial Civics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "White Collar",
            "indicator":        "bank.png",
            "canUpgradeTo":     "Investment Bank",
            "transModeColor":   "#8BC34A",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Galactic Stock Exchange",
            "tile":             ["galstockmarket"],
            "cost":             [{"resource":"Money","amount":10000},{"resource":"Ore","amount":8000},{"resource":"Water","amount":100},{"resource":"Steel","amount":6000},{"resource":"Gold","amount":2000},{"resource":"Aluminum","amount":650},{"resource":"Microchip","amount":900},{"resource":"Civics","amount":1000}],
            "description":      "galstockmarket-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     2000,
            "generateAmount":   100,
            "tileWidth":        3,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":800},{"resource":"Steel","amount":600},{"resource":"Gold","amount":200},{"resource":"Aluminum","amount":65},{"resource":"Microchip","amount":9}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":75},{"utility":"Bandwidth","amount":65}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   35,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    90,
            "requiresTech":     ["Large Scale Construction","Galactic Commerce","Long Range Communications","Basic Network Infrastructure"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "White Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Economy","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    350,
            "upkeepCost":       0.0,
            "giftCapacity":     350,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Galactic Board of Trade",
            "tile":             ["boardoftrade"],
            "cost":             [{"resource":"Money","amount":15000},{"resource":"Ore","amount":10000},{"resource":"Water","amount":900},{"resource":"Wood","amount":400},{"resource":"Steel","amount":9000},{"resource":"Gold","amount":5000},{"resource":"Aluminum","amount":850},{"resource":"Microchip","amount":1400},{"resource":"Civics","amount":2000}],
            "description":      "boardoftrade-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     3000,
            "generateAmount":   25,
            "tileWidth":        3,
            "tileHeight":       5,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Money","amount":10000},{"resource":"Ore","amount":3500},{"resource":"Wood","amount":50},{"resource":"Steel","amount":1400},{"resource":"Gold","amount":900},{"resource":"Aluminum","amount":250},{"resource":"Microchip","amount":15}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":90}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   45,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    90,
            "requiresTech":     ["United Earth Base","Large Scale Construction","Galactic Commerce","Long Range Communications"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "White Collar",
            "indicator":        "boardoftrade.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": true,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    500,
            "upkeepCost":       0.0,
            "giftCapacity":     500,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Pyramid of the All Seeing Eye",
            "tile":             ["pyramideye"],
            "cost":             [{"resource":"Money","amount":10000},{"resource":"Ore","amount":50000},{"resource":"Water","amount":6000},{"resource":"Clay","amount":1500},{"resource":"Bricks","amount":4000},{"resource":"Steel","amount":20000},{"resource":"Gold","amount":15000},{"resource":"Aluminum","amount":1000},{"resource":"Civics","amount":9000}],
            "description":      "pyramideye-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        6,
            "tileHeight":       6,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":       [{"resource":"Ore","amount":8000},{"resource":"Steel","amount":1000},{"resource":"Gold","amount":1000},{"resource":"Aluminum","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    200,
            "requiresTech":     ["Colonial Tourism","Colonial Civics","Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       600,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Entertainment","Tourism"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":2,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    25,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Archaeological Dig Site",
            "tile":             ["digsite"],
            "cost":             [{"resource":"Money","amount":20000},{"resource":"Ore","amount":95000},{"resource":"Water","amount":10000},{"resource":"Wood","amount":10000},{"resource":"Steel","amount":60000},{"resource":"Gold","amount":30000},{"resource":"Aluminum","amount":2000},{"resource":"Microchip","amount":1500},{"resource":"Civics","amount":10000}],
            "description":      "digsite-description",
            "produces":         null,
            "generates":        "Alien Artifact",
            "generateTime":     150000,
            "generateAmount":   1,
            "tileWidth":        5,
            "tileHeight":       5,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Alien Artifact","amount":215}],
            "sellValue":        [{"resource":"Ore","amount":25000},{"resource":"Wood","amount":3000},{"resource":"Steel","amount":10000},{"resource":"Gold","amount":6000},{"resource":"Aluminum","amount":800},{"resource":"Microchip","amount":120}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":20}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   75,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    180,
            "requiresTech":     ["Large Scale Construction","Deep Excavation"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        "digsite.png",
            "canUpgradeTo":     "Ultra Deep Dig Site",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Aluminum Generator",
            "tile":             ["aluminumgenerator"],
            "cost":             [{"resource":"Ore","amount":45000},{"resource":"Steel","amount":45000},{"resource":"Gold","amount":80000},{"resource":"Microchip","amount":25000},{"resource":"Alien Artifact","amount":150}],
            "description":      "aluminumgenerator-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Aluminum","amount":30000}],
            "sellValue":        [{"resource":"Ore","amount":20000},{"resource":"Steel","amount":20000},{"resource":"Gold","amount":30000},{"resource":"Microchip","amount":200},{"resource":"Alien Artifact","amount":5}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":850}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  true,
            "smelts":           {"input":"Steel","output":"Aluminum","time":8000,"ratio":4},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Ancient Alien Language"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     "Integrated Aluminum Generator",
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Water","rate":450},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Integrated Aluminum Generator",
            "tile":             ["aluminumgenerator2"],
            "cost":             [{"resource":"Ore","amount":55000},{"resource":"Steel","amount":55000},{"resource":"Gold","amount":90000},{"resource":"Microchip","amount":65000},{"resource":"Alien Artifact","amount":250},{"resource":"Software","amount":5000}],
            "description":      "aluminumgenerator2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Aluminum","amount":30000}],
            "sellValue":        [{"resource":"Ore","amount":20000},{"resource":"Steel","amount":20000},{"resource":"Gold","amount":30000},{"resource":"Microchip","amount":200},{"resource":"Alien Artifact","amount":5}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":950},{"utility":"Bandwidth","amount":250}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  true,
            "smelts":           {"input":"Steel,Software","output":"Aluminum","time":4000,"ratio":20},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Advanced Networking Infrastructure","Ancient Alien Language"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Water","rate":450},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Alien Tech","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Giorgio Institute for Alien Research",
            "tile":             ["giorgioinstitute"],
            "cost":             [{"resource":"Ore","amount":4000},{"resource":"Wood","amount":1200},{"resource":"Steel","amount":6000},{"resource":"Gold","amount":150},{"resource":"Aluminum","amount":250},{"resource":"Uranium","amount":1},{"resource":"Microchip","amount":2000},{"resource":"Civics","amount":5000}],
            "description":      "giorgioinstitute-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     1800,
            "generateAmount":   16,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Alien Artifact","amount":750},{"resource":"Alien Relic","amount":750}],
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Wood","amount":300},{"resource":"Steel","amount":2000},{"resource":"Gold","amount":60},{"resource":"Aluminum","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":20}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    350,
            "requiresTech":     ["Ancient Alien Language"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Alien Artifact"],
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Scientist",
            "indicator":        "giorgioinstitute.png",
            "canUpgradeTo":     "Center for Artificial Learning",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Research"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       110,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Consulate",
            "tile":             ["consulate"],
            "cost":             [{"resource":"Ore","amount":6500},{"resource":"Steel","amount":3500},{"resource":"Gold","amount":2500},{"resource":"Microchip","amount":10},{"resource":"Civics","amount":150}],
            "description":      "consulate-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1500,
            "generateAmount":   3,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":3000},{"resource":"Steel","amount":1500},{"resource":"Gold","amount":1000},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   3,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    5,
            "requiresTech":     ["United Earth Base","Colonial Civics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        "consulate.png",
            "canUpgradeTo":     "Consulate Level 2",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      true,
            "isEmbassy":        false,
            "buildLimit":       1,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     300,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    1,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Distillery",
            "tile":             ["distillery"],
            "cost":             [{"resource":"Water","amount":120},{"resource":"Ore","amount":200},{"resource":"Steel","amount":20}],
            "description":      "distillery-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Rum","amount":50}],
            "sellValue":        [{"resource":"Water","amount":20},{"resource":"Ore","amount":80},{"resource":"Steel","amount":6}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   2,
            "requiresWorkers":  true,
            "smelts":           {"input":"Food","output":"Rum","time":1200,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    4,
            "requiresTech":     ["Microgravity Brewing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "distillery.png",
            "canUpgradeTo":     "Quantum Distillery",
            "transModeColor":   "#b38600",
            "requiresFuel":     {"resource":"Water","rate":1200},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Durable Goods"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Rum Cellar",
            "tile":             ["rumcellar"],
            "cost":             [{"resource":"Ore","amount":30},{"resource":"Steel","amount":5}],
            "description":      "rumcellar-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Rum","amount":350}],
            "sellValue":        [{"resource":"Ore","amount":12},{"resource":"Steel","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Microgravity Brewing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "rumcellar.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#b38600",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Durable Goods","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Internet Relay Booth",
            "tile":             ["relaybooth"],
            "cost":             [{"resource":"Ore","amount":180}],
            "description":      "relaybooth-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":60}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"internetbooth-firstbuild",
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       4,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "relaybooth.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Entertainment","Education"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       60,
            "educates":         2,
            "providesIQ":       100,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Pub",
            "tile":             ["pub"],
            "cost":             [{"resource":"Rum","amount":100},{"resource":"Ore","amount":450},{"resource":"Steel","amount":50}],
            "description":      "pub-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Rum","amount":10}],
            "sellValue":        [{"resource":"Ore","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   4,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    6,
            "requiresTech":     ["Microgravity Brewing"],
            "canRenderStatic":  false,
            "entertains":       12,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "pub.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#b38600",
            "requiresFuel":     {"resource":"Rum","rate":800},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Entertainment"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":1,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Arcade Center",
            "tile":             ["arcade"],
            "cost":             [{"resource":"Ore","amount":700},{"resource":"Steel","amount":150},{"resource":"Microchip","amount":30},{"resource":"Software","amount":30}],
            "description":      "arcade-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Software","amount":10}],
            "sellValue":        [{"resource":"Ore","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":6},{"utility":"Bandwidth","amount":3}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   3,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Basic Network Infrastructure","Colonial Tourism"],
            "canRenderStatic":  false,
            "entertains":       18,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Software","rate":8000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Entertainment","Information Technology","Tourism"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":12,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    18,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Decorative Fir Trees",
            "tile":             ["decfirtrees"],
            "cost":             [{"resource":"Water","amount":20},{"resource":"Wood","amount":3},{"resource":"Ore","amount":3}],
            "description":      "decfirtrees-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "decfirtrees.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Cloning Facility",
            "tile":             ["cloningfacility"],
            "cost":             [{"resource":"Water","amount":5000},{"resource":"Ore","amount":9500},{"resource":"Steel","amount":6000},{"resource":"Gold","amount":4000},{"resource":"Microchip","amount":500}],
            "description":      "cloningfacility-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       5,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":3500},{"resource":"Steel","amount":2000},{"resource":"Gold","amount":1200},{"resource":"Microchip","amount":6}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":120}],
            "colGenRate":       15000,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   40,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    35,
            "requiresTech":     ["Human Cloning"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     "Advanced Cloning Facility",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Immigration","Government","Research"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    true,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Advanced Cloning Facility",
            "tile":             ["advcloning"],
            "cost":             [{"resource":"Water","amount":50000},{"resource":"Ore","amount":95000},{"resource":"Steel","amount":60000},{"resource":"Gold","amount":40000},{"resource":"Microchip","amount":50000},{"resource":"Aluminum","amount":10000},{"resource":"Triantanium","amount":10000},{"resource":"Plastic","amount":10000},{"resource":"Obsidian","amount":10000},{"resource":"Crystalline","amount":2000},{"resource":"Ether","amount":2000},{"resource":"Robot","amount":10000},{"resource":"Alien Artifact","amount":1000}],
            "description":      "advcloning-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       5,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ether","amount":5000}],
            "sellValue":        [{"resource":"Ore","amount":3500},{"resource":"Steel","amount":2000},{"resource":"Gold","amount":1200},{"resource":"Microchip","amount":6}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":800}],
            "colGenRate":       1500,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   300,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    5000,
            "requiresTech":     ["Antanium Compounds","Human Cloning"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Ether","rate":300},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Immigration","Government","Research"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    true,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Clay Mine",
            "tile":             ["claymine"],
            "cost":             [{"resource":"Water","amount":5000},{"resource":"Ore","amount":2000},{"resource":"Steel","amount":1000}],
            "description":      "claymine-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Clay Mine",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Advanced Small Scale Construction","Clay Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "claymine.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Pottery Works",
            "tile":             ["potteryworks"],
            "cost":             [{"resource":"Ore","amount":3000},{"resource":"Water","amount":600},{"resource":"Steel","amount":1000},{"resource":"Gold","amount":250},{"resource":"Aluminum","amount":250},{"resource":"Microchip","amount":5}],
            "description":      "potteryworks-description",
            "produces":         ["Claybot"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Clay","amount":2500},{"resource":"Pottery","amount":500}],
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Water","amount":200},{"resource":"Steel","amount":400},{"resource":"Gold","amount":100},{"resource":"Aluminum","amount":100},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          [{"input":"Clay","output":"Clay"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":16}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  true,
            "smelts":           {"input":"Clay","output":"Pottery","time":2000,"ratio":2},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Clay Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       "Blue Collar",
            "indicator":        "potteryworks.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#deaa87",
            "requiresFuel":     {"resource":"Water","rate":1400},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Durable Goods"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Durable Goods Warehouse",
            "tile":             ["warehouse"],
            "cost":             [{"resource":"Ore","amount":2500},{"resource":"Steel","amount":500},{"resource":"Gold","amount":100}],
            "description":      "warehouse-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wheel","amount":3000},{"resource":"Steel","amount":3000},{"resource":"Wool","amount":3000},{"resource":"Diamond","amount":3000},{"resource":"Crystalline","amount":3000},{"resource":"Rum","amount":3000},{"resource":"Pottery","amount":3000},{"resource":"Bricks","amount":3000},{"resource":"Cloth","amount":3000},{"resource":"Plastic","amount":3000},{"resource":"Toy","amount":3000},{"resource":"Microchip","amount":3000},{"resource":"Alien Artifact","amount":3000},{"resource":"Robot","amount":3000},{"resource":"Ant Paste","amount":3000}],
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Steel","amount":200},{"resource":"Gold","amount":30}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Advanced Small Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "warehouse.png",
            "canUpgradeTo":     ["Tall Brick Warehouse"],
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Durable Goods","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Counterfeit Market",
            "tile":             ["counterfeitmarket"],
            "cost":             [{"resource":"Ore","amount":2500},{"resource":"Steel","amount":500},{"resource":"Gold","amount":100},{"resource":"Clay","amount":100}],
            "description":      "counterfeitmarket-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Pottery","amount":75000},{"resource":"Cloth","amount":75000},{"resource":"Painting","amount":75000},{"resource":"Diamond","amount":75000}],
            "sellValue":        [{"resource":"Ore","amount":250},{"resource":"Steel","amount":50},{"resource":"Gold","amount":10}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":12},{"utility":"Bandwidth","amount":6}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   4,
            "requiresWorkers":  false,
            "smelts":           {"input":"Pottery,Cloth,Painting,Diamond","output":"Money","time":2000,"ratio":3500},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    10,
            "requiresTech":     ["LIS Base","Advanced Small Scale Construction","Clay Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Durable Goods","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Fine Arts Warehouse",
            "tile":             ["artwarehouse"],
            "cost":             [{"resource":"Ore","amount":2500},{"resource":"Steel","amount":500},{"resource":"Gold","amount":100},{"resource":"Clay","amount":100}],
            "description":      "artwarehouse-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Pottery","amount":100000},{"resource":"Cloth","amount":150000},{"resource":"Painting","amount":100000}],
            "sellValue":        [{"resource":"Ore","amount":250},{"resource":"Steel","amount":50},{"resource":"Gold","amount":10}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":12}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    10,
            "requiresTech":     ["United Earth Base","Advanced Small Scale Construction","Clay Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Durable Goods","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Subterranean Housing Module",
            "tile":             ["subhousing"],
            "cost":             [{"resource":"Ore","amount":15000},{"resource":"Clay","amount":1500},{"resource":"Water","amount":7000},{"resource":"Steel","amount":14000},{"resource":"Gold","amount":8000},{"resource":"Aluminum","amount":2500},{"resource":"Uranium","amount":500},{"resource":"Pottery","amount":450},{"resource":"Microchip","amount":1200}],
            "description":      "subhousing-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     3000,
            "generateAmount":   450,
            "tileWidth":        4,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":6000},{"resource":"Water","amount":70},{"resource":"Steel","amount":5000},{"resource":"Gold","amount":2000},{"resource":"Aluminum","amount":600},{"resource":"Microchip","amount":60}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":400}],
            "colGenRate":       0,
            "providesShelter":  1000,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    90,
            "requiresTech":     ["Large Scale Construction","Deep Excavation"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "subhousing.png",
            "canUpgradeTo":     "Arcology",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Data Interceptor",
            "tile":             ["lisdataintercept"],
            "cost":             [{"resource":"Regolith","amount":5600},{"resource":"Ore","amount":2800},{"resource":"Steel","amount":4600},{"resource":"Gold","amount":2200},{"resource":"Aluminum","amount":1200},{"resource":"Microchip","amount":350}],
            "description":      "lisdataintercept-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     2000,
            "generateAmount":   30,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Regolith","amount":460},{"resource":"Ore","amount":180},{"resource":"Steel","amount":360},{"resource":"Gold","amount":120},{"resource":"Aluminum","amount":70},{"resource":"Microchip","amount":3}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":150},{"utility":"Bandwidth","amount":80}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           {"input":"Microchip,Microchip,Microchip,Microchip,Microchip,Microchip,Microchip","output":"Money","time":1400,"ratio":175},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    80,
            "requiresTech":     ["LIS Base","Black Markets","Basic Network Infrastructure"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Economy","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Hacker Camp",
            "tile":             ["hackercamp"],
            "cost":             [{"resource":"Money","amount":20000},{"resource":"Regolith","amount":15000},{"resource":"Ore","amount":16800},{"resource":"Steel","amount":5600},{"resource":"Gold","amount":5200},{"resource":"Aluminum","amount":5200},{"resource":"Microchip","amount":4500},{"resource":"Software","amount":300},{"resource":"Plastic","amount":200},{"resource":"Clay","amount":200},{"resource":"Bricks","amount":2000}],
            "description":      "hackercamp-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     1500,
            "generateAmount":   40,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Regolith","amount":460},{"resource":"Ore","amount":180},{"resource":"Steel","amount":360},{"resource":"Gold","amount":120},{"resource":"Aluminum","amount":70},{"resource":"Microchip","amount":3}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":160},{"utility":"Bandwidth","amount":90}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  true,
            "smelts":           {"input":"Microchip,Microchip,Microchip,Microchip,Microchip,Microchip,Microchip,Microchip,Microchip,Microchip,Microchip,Microchip,Microchip,Microchip,Microchip,Microchip,Microchip,Microchip,Microchip,Microchip,Microchip,Microchip","output":"Money|Software","time":1200,"ratio":180},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    80,
            "requiresTech":     ["LIS Base","Proxy Servers"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Economy","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Advanced Microchip Factory",
            "tile":             ["chipfactory2"],
            "cost":             [{"resource":"Ore","amount":15000},{"resource":"Steel","amount":11000},{"resource":"Gold","amount":7000},{"resource":"Aluminum","amount":2000},{"resource":"Microchip","amount":800}],
            "description":      "chipfactory2-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        3,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Microchip","amount":2500}],
            "sellValue":        [{"resource":"Ore","amount":7000},{"resource":"Steel","amount":5000},{"resource":"Gold","amount":3000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":115}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   40,
            "requiresWorkers":  true,
            "smelts":           {"input":"Gold","output":"Microchip","time":10000,"ratio":4},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    140,
            "requiresTech":     ["Large Scale Construction","Colonial Finance Theory","Low Gravity Manufacturing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        "chipfactory2.png",
            "canUpgradeTo":     "Ancient Alien Microchip Factory",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Durable Goods"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ancient Alien Microchip Factory",
            "tile":             ["chipfactory3"],
            "cost":             [{"resource":"Ore","amount":50000},{"resource":"Steel","amount":55000},{"resource":"Gold","amount":75000},{"resource":"Aluminum","amount":4500},{"resource":"Uranium","amount":10000},{"resource":"Microchip","amount":18000},{"resource":"Alien Artifact","amount":120}],
            "description":      "chipfactory3-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Microchip","amount":12000}],
            "sellValue":        [{"resource":"Ore","amount":15000},{"resource":"Steel","amount":11000},{"resource":"Gold","amount":7000},{"resource":"Aluminum","amount":2000},{"resource":"Microchip","amount":800}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1000}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   45,
            "requiresWorkers":  true,
            "smelts":           {"input":"Alien Artifact,Gold,Gold,Gold","output":"Microchip","time":25000,"ratio":1600},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    240,
            "requiresTech":     ["Ancient Alien Manufacturing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        "chipfactory3.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Water","rate":450},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Durable Goods","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Brick Factory",
            "tile":             ["brickfactory"],
            "cost":             [{"resource":"Ore","amount":3000},{"resource":"Water","amount":600},{"resource":"Steel","amount":1000},{"resource":"Gold","amount":250},{"resource":"Aluminum","amount":250},{"resource":"Microchip","amount":5}],
            "description":      "brickfactory-description",
            "produces":         ["Claybot"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Clay","amount":2500},{"resource":"Bricks","amount":500}],
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Water","amount":200},{"resource":"Steel","amount":400},{"resource":"Gold","amount":100},{"resource":"Aluminum","amount":100},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          [{"input":"Clay","output":"Clay"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":20}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   18,
            "requiresWorkers":  true,
            "smelts":           {"input":"Clay","output":"Bricks","time":2000,"ratio":3},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Advanced Small Scale Construction","Clay Production","Low Gravity Masonry"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       "Blue Collar",
            "indicator":        "brickfactory.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#deaa87",
            "requiresFuel":     {"resource":"Water","rate":1400},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Durable Goods"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Tall Brick Warehouse",
            "tile":             ["warehouse2"],
            "cost":             [{"resource":"Ore","amount":3000},{"resource":"Clay","amount":1500},{"resource":"Bricks","amount":5000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":1500}],
            "description":      "warehouse2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wheel","amount":10000},{"resource":"Obsidian","amount":10000},{"resource":"Steel","amount":10000},{"resource":"Wool","amount":10000},{"resource":"Diamond","amount":10000},{"resource":"Crystalline","amount":10000},{"resource":"Rum","amount":10000},{"resource":"Pottery","amount":10000},{"resource":"Bricks","amount":10000},{"resource":"Cloth","amount":10000},{"resource":"Plastic","amount":10000},{"resource":"Toy","amount":10000},{"resource":"Microchip","amount":10000},{"resource":"Alien Artifact","amount":10000},{"resource":"Robot","amount":10000},{"resource":"Ant Paste","amount":10000}],
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Clay","amount":600},{"resource":"Bricks","amount":2000},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":650}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":4}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Low Gravity Masonry","Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "warehouse2.png",
            "canUpgradeTo":     "Quantum Warehouse",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Durable Goods","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Brick House",
            "tile":             ["brickhouse"],
            "cost":             [{"resource":"Bricks","amount":250},{"resource":"Steel","amount":50},{"resource":"Microchip","amount":10},{"resource":"Pottery","amount":5}],
            "description":      "brickhouse-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Bricks","amount":120},{"resource":"Steel","amount":20},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  6,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     ["Advanced Small Scale Construction","Advanced Microbiology","Low Gravity Masonry"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        "brickhouse.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1.5,
                    "c":    "#FFF8E1",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Sheep Farm",
            "tile":             ["sheepfarm"],
            "cost":             [{"resource":"Ore","amount":120},{"resource":"Water","amount":6500},{"resource":"Clay","amount":400},{"resource":"Wood","amount":950},{"resource":"Steel","amount":500},{"resource":"Gold","amount":20},{"resource":"Microchip","amount":6}],
            "description":      "sheepfarm-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        6,
            "tileHeight":       6,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wool","amount":500}],
            "sellValue":        [{"resource":"Ore","amount":40},{"resource":"Water","amount":50},{"resource":"Wood","amount":400},{"resource":"Steel","amount":150},{"resource":"Gold","amount":6},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":5}],
            "colGenRate":       0,
            "providesShelter":  4,
            "canChain":         false,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           {"input":"Water","output":"Wool","time":2500,"ratio":3},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Low Gravity Husbandry"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       "Botanist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Farming"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Textile Mill",
            "tile":             ["textilemill"],
            "cost":             [{"resource":"Ore","amount":3000},{"resource":"Wood","amount":1000},{"resource":"Clay","amount":1000},{"resource":"Bricks","amount":4000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":1500},{"resource":"Microchip","amount":60}],
            "description":      "textilemill-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wool","amount":250},{"resource":"Cloth","amount":250}],
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Wood","amount":400},{"resource":"Clay","amount":250},{"resource":"Bricks","amount":1000},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":400},{"resource":"Microchip","amount":6}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":16}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  true,
            "smelts":           {"input":"Wool","output":"Cloth","time":7000,"ratio":2},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    18,
            "requiresTech":     ["Low Gravity Masonry","Low Gravity Husbandry"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Synthetic Textile Mill",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Durable Goods"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Clothing Sweatshop",
            "tile":             ["sweatshop"],
            "cost":             [{"resource":"Ore","amount":15000},{"resource":"Steel","amount":11000},{"resource":"Gold","amount":7000},{"resource":"Cloth","amount":2000},{"resource":"Aluminum","amount":2000},{"resource":"Microchip","amount":800}],
            "description":      "sweatshop-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     25000,
            "generateAmount":   1,
            "tileWidth":        3,
            "tileHeight":       5,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Cloth","amount":300}],
            "sellValue":        [{"resource":"Ore","amount":7000},{"resource":"Steel","amount":5000},{"resource":"Gold","amount":3000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":160}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   240,
            "requiresWorkers":  true,
            "smelts":           {"input":"Cloth","output":"Money","time":30000,"ratio":30},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    140,
            "requiresTech":     ["Large Scale Construction","Low Gravity Manufacturing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        "sweatshop.png",
            "canUpgradeTo":     "Advanced Clothing Sweatshop",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Durable Goods","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Tech Office Building",
            "tile":             ["onlineofficeofficebld"],
            "cost":             [{"resource":"Ore","amount":25000},{"resource":"Water","amount":3600},{"resource":"Wood","amount":11500},{"resource":"Clay","amount":5000},{"resource":"Bricks","amount":5500},{"resource":"Steel","amount":18000},{"resource":"Gold","amount":9000},{"resource":"Aluminum","amount":5200},{"resource":"Microchip","amount":2820},{"resource":"Software","amount":700},{"resource":"Plastic","amount":2500}],
            "description":      "onlineofficeofficebld-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     3000,
            "generateAmount":   20,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Software","amount":500}],
            "sellValue":        [{"resource":"Ore","amount":4000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":400},{"resource":"Aluminum","amount":200},{"resource":"Microchip","amount":30}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":280},{"utility":"Bandwidth","amount":560}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   190,
            "requiresWorkers":  false,
            "smelts":           {"input":"Money,Software,Software,Microchip","output":"Money","time":8500,"ratio":180},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    500,
            "requiresTech":     ["Large Scale Construction","Basic Network Infrastructure"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       "White Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Software","rate":6000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Information Technology","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       110,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Luxury Tower",
            "tile":             ["luxtower"],
            "cost":             [{"resource":"Ore","amount":10000},{"resource":"Water","amount":600},{"resource":"Wood","amount":6500},{"resource":"Clay","amount":2000},{"resource":"Bricks","amount":2500},{"resource":"Rum","amount":2000},{"resource":"Steel","amount":9000},{"resource":"Gold","amount":2000},{"resource":"Aluminum","amount":1000},{"resource":"Microchip","amount":320},{"resource":"Pottery","amount":1500},{"resource":"Cloth","amount":3000}],
            "description":      "luxtower-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2600,
            "generateAmount":   35,
            "tileWidth":        4,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":4000},{"resource":"Water","amount":50},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":400},{"resource":"Aluminum","amount":200},{"resource":"Microchip","amount":30}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":200}],
            "colGenRate":       0,
            "providesShelter":  200,
            "canChain":         false,
            "acceptsWorkers":   160,
            "requiresWorkers":  false,
            "smelts":           {"input":"Money","output":"Money","time":10000,"ratio":10},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    240,
            "requiresTech":     ["Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       80,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       "White Collar",
            "indicator":        "luxtower.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#8BC34A",
            "requiresFuel":     {"resource":"Rum","rate":1000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Housing","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":6,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ancient Alien Condenser",
            "tile":             ["aliencondensor"],
            "cost":             [{"resource":"Ore","amount":25000},{"resource":"Steel","amount":45000},{"resource":"Gold","amount":17000},{"resource":"Aluminum","amount":1500},{"resource":"Uranium","amount":6500},{"resource":"Microchip","amount":10000},{"resource":"Alien Artifact","amount":40}],
            "description":      "aliencondensor-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":800},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":1400},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":950}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Atmosphere","output":"Water","time":350,"ratio":1200},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    700,
            "requiresTech":     ["Ancient Alien Manufacturing","Climate Science Theory"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    4,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Atmosphere","rate":8},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Food","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Large Park",
            "tile":             ["largepark"],
            "cost":             [{"resource":"Water","amount":35000},{"resource":"Wood","amount":12000},{"resource":"Ore","amount":1500},{"resource":"Clay","amount":1600}],
            "description":      "largepark-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        9,
            "tileHeight":       9,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":275}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    70,
            "requiresTech":     ["Advanced Microbiology"],
            "canRenderStatic":  false,
            "entertains":       650,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        "largepark.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Entertainment"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Water Pool",
            "tile":             ["water1"],
            "cost":             [{"resource":"Water","amount":60}],
            "description":      "waterpool-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Water Pool",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "The Lander of Liberty",
            "tile":             ["lol"],
            "cost":             [{"resource":"Ore","amount":3000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":1500},{"resource":"Aluminum","amount":500}],
            "description":      "lol-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Colonial Tourism"],
            "canRenderStatic":  false,
            "entertains":       40,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "lol.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Tourism"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":1,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    10,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Statue of Domination",
            "tile":             ["statue2"],
            "cost":             [{"resource":"Ore","amount":300},{"resource":"Steel","amount":300},{"resource":"Gold","amount":600}],
            "description":      "statue2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Colonial Civics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "statue2.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Red Flower Garden",
            "tile":             ["flowersred"],
            "cost":             [{"resource":"Water","amount":20},{"resource":"Wood","amount":2},{"resource":"Ore","amount":3}],
            "description":      "flowersred-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "flowers-red.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Golden Shelter",
            "tile":             ["goldenshelter"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Gold","amount":150}],
            "description":      "goldenshelter-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2600,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":80},{"resource":"Gold","amount":60}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  4,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "goldenshelter.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1.5,
                    "c":    "#E1F5FE",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Medical Clinic",
            "tile":             ["medicalclinic"],
            "cost":             [{"resource":"Ore","amount":1900},{"resource":"Steel","amount":95},{"resource":"Gold","amount":30},{"resource":"Civics","amount":50}],
            "description":      "medicalclinic-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":550},{"resource":"Steel","amount":35},{"resource":"Gold","amount":12}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":6}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   4,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Colonial Civics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Medic",
            "indicator":        "medical-clinic.png",
            "canUpgradeTo":     "Large Medical Clinic",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            6,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Medical"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Large Medical Clinic",
            "tile":             ["largeclinic"],
            "cost":             [{"resource":"Ore","amount":2500},{"resource":"Steel","amount":500},{"resource":"Gold","amount":120},{"resource":"Aluminum","amount":120},{"resource":"Civics","amount":100},{"resource":"Microchip","amount":15}],
            "description":      "largeclinic-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":1000},{"resource":"Steel","amount":150},{"resource":"Gold","amount":20},{"resource":"Aluminum","amount":40},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":10}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   10,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     ["Colonial Civics","Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Medic",
            "indicator":        "largeclinic.png",
            "canUpgradeTo":     "Integrated Medical Clinic",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            24,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Medical"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Integrated Medical Clinic",
            "tile":             ["intclinic"],
            "cost":             [{"resource":"Ore","amount":4500},{"resource":"Steel","amount":2500},{"resource":"Gold","amount":1500},{"resource":"Aluminum","amount":2000},{"resource":"Civics","amount":200},{"resource":"Microchip","amount":300},{"resource":"Software","amount":300},{"resource":"Cloth","amount":150}],
            "description":      "intclinic-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":1000},{"resource":"Steel","amount":150},{"resource":"Gold","amount":20},{"resource":"Aluminum","amount":40},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":50},{"utility":"Bandwidth","amount":15}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   18,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     ["Basic Network Infrastructure","Colonial Civics","Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Medic",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Software","rate":2500},
            "heals":            60,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Medical"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Small Hospital",
            "tile":             ["hospital"],
            "cost":             [{"resource":"Ore","amount":45000},{"resource":"Steel","amount":18000},{"resource":"Gold","amount":12000},{"resource":"Aluminum","amount":15000},{"resource":"Civics","amount":2000},{"resource":"Microchip","amount":2500},{"resource":"Software","amount":2000},{"resource":"Cloth","amount":2000},{"resource":"Plastic","amount":2500},{"resource":"Bricks","amount":2500}],
            "description":      "hospital-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":4500},{"resource":"Steel","amount":1800},{"resource":"Gold","amount":1200},{"resource":"Aluminum","amount":1500},{"resource":"Microchip","amount":2},{"resource":"Cloth","amount":20},{"resource":"Plastic","amount":250},{"resource":"Bricks","amount":25}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":500},{"utility":"Bandwidth","amount":100}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   120,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    150,
            "requiresTech":     ["Basic Network Infrastructure","Colonial Civics","Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Medic",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Software,Money,Civics","rate":1500},
            "heals":            2500,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Medical"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Hipster Bar",
            "tile":             ["hipsterbar"],
            "cost":             [{"resource":"Rum","amount":250},{"resource":"Ore","amount":600},{"resource":"Steel","amount":120},{"resource":"Bricks","amount":850}],
            "description":      "hipsterbar-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Rum","amount":20}],
            "sellValue":        [{"resource":"Ore","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":7}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   10,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    12,
            "requiresTech":     ["Microgravity Brewing","Low Gravity Masonry"],
            "canRenderStatic":  false,
            "entertains":       36,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "hipsterbar.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#b38600",
            "requiresFuel":     {"resource":"Rum","rate":550},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Entertainment"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":20,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Quantum Warehouse",
            "tile":             ["warehouse3"],
            "cost":             [{"resource":"Ore","amount":30000},{"resource":"Steel","amount":60000},{"resource":"Gold","amount":35000},{"resource":"Aluminum","amount":2000},{"resource":"Uranium","amount":9000},{"resource":"Microchip","amount":16000},{"resource":"Alien Artifact","amount":200}],
            "description":      "warehouse3-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ether","amount":150000},{"resource":"Wheel","amount":150000},{"resource":"Obsidian","amount":150000},{"resource":"Steel","amount":150000},{"resource":"Wool","amount":150000},{"resource":"Diamond","amount":150000},{"resource":"Crystalline","amount":150000},{"resource":"Rum","amount":150000},{"resource":"Pottery","amount":150000},{"resource":"Bricks","amount":150000},{"resource":"Cloth","amount":150000},{"resource":"Plastic","amount":150000},{"resource":"Toy","amount":150000},{"resource":"Microchip","amount":150000},{"resource":"Alien Artifact","amount":150000},{"resource":"Robot","amount":150000},{"resource":"Ant Paste","amount":150000},{"resource":"Gold","amount":150000},{"resource":"Uranium","amount":150000},{"resource":"Aluminum","amount":150000},{"resource":"Clay","amount":150000},{"resource":"Ore","amount":150000},{"resource":"Regolith","amount":150000},{"resource":"Wood","amount":150000}],
            "sellValue":        [{"resource":"Ore","amount":3000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":900}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":400}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Ancient Alien Manufacturing","Alien Quantum Physics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "warehouse3.png",
            "canUpgradeTo":     "Gravitational Compression Warehouse",
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Water","rate":750},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Durable Goods","Storage","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Quantum Water Tower",
            "tile":             ["quantumwater"],
            "cost":             [{"resource":"Ore","amount":600},{"resource":"Steel","amount":1200},{"resource":"Aluminum","amount":2000},{"resource":"Uranium","amount":3000},{"resource":"Microchip","amount":9000},{"resource":"Alien Artifact","amount":100}],
            "description":      "quantumwater-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Water","amount":650000}],
            "sellValue":        [{"resource":"Ore","amount":300},{"resource":"Steel","amount":600},{"resource":"Aluminum","amount":200}],
            "sellWarning":      null,
            "refines":          [{"input":"Water","output":"Water"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":250}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    40,
            "requiresTech":     ["Ancient Alien Manufacturing","Alien Quantum Physics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "quantumwater.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#03A9F4",
            "requiresFuel":     {"resource":"Water","rate":950},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Food","Storage","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Brick Wall",
            "tile":             ["brickwall"],
            "cost":             [{"resource":"Ore","amount":35},{"resource":"Steel","amount":10},{"resource":"Bricks","amount":35}],
            "description":      "brickwall-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     [],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "brickwall.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Small Helium 3 Extractor",
            "tile":             ["helextractor"],
            "cost":             [{"resource":"Regolith","amount":100}],
            "description":      "helextractor-description",
            "produces":         [],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Helium 3","amount":150},{"resource":"Regolith","amount":200}],
            "sellValue":        [{"resource":"Regolith","amount":25}],
            "sellWarning":      null,
            "refines":          [{"input":"Regolith","output":"Regolith"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Regolith","output":"Helium 3","time":300,"ratio":2},
            "firstBuildMessage":"he3-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "helextractor.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.1,
                    "y":    0.1,
                    "r":    0.2,
                    "c":    "#ff0000",
                    "i":    0.3,
                    "nightonly": true
                },
                {
                    "x":    0.3,
                    "y":    0.1,
                    "r":    0.2,
                    "c":    "#0000ff",
                    "i":    0.3,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Regolith Compactor",
            "tile":             ["regcompact"],
            "cost":             [{"resource":"Regolith","amount":120},{"resource":"Helium 3","amount":20}],
            "description":      "regcompact-description",
            "produces":         [],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ore","amount":500},{"resource":"Regolith","amount":500}],
            "sellValue":        [{"resource":"Regolith","amount":50}],
            "sellWarning":      null,
            "refines":          [{"input":"Regolith","output":"Regolith"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Regolith","output":"Ore","time":75,"ratio":1},
            "firstBuildMessage":"reg-compactor-firstbuild",
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Ore Synthesis Lab",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Helium 3 Tank",
            "tile":             ["heltank"],
            "cost":             [{"resource":"Regolith","amount":60},{"resource":"Helium 3","amount":15}],
            "description":      "heltank-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Helium 3","amount":600}],
            "sellValue":        [{"resource":"Regolith","amount":15}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "heltank.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#cccccc",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Storage","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Regolith Mine",
            "tile":             ["regmine"],
            "cost":             [{"resource":"Regolith","amount":500}],
            "description":      "regmine-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Regolith Mine",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Lunar Base|Asteroid Base|Abandoned World Base|Ice World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "regmine.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Wood Hut",
            "tile":             ["woodhut"],
            "cost":             [{"resource":"Wood","amount":175}],
            "description":      "woodhut-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2600,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Wood","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  2,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "woodhut.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Charcoal Hut",
            "tile":             ["charcoalhut"],
            "cost":             [{"resource":"Wood","amount":300}],
            "description":      "charcoalhut-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wood","amount":400},{"resource":"Charcoal","amount":100}],
            "sellValue":        [{"resource":"Wood","amount":120}],
            "sellWarning":      null,
            "refines":          [{"input":"Wood","output":"Wood"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Wood","output":"Charcoal","time":800,"ratio":2},
            "firstBuildMessage":"charchut-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "charcoalhut.png",
            "canUpgradeTo":     "Charcoal Factory",
            "transModeColor":   "#333333",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Charcoal Compactor",
            "tile":             ["coalcompact"],
            "cost":             [{"resource":"Wood","amount":150},{"resource":"Charcoal","amount":5}],
            "description":      "coalcompact-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     1500,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ore","amount":300}],
            "sellValue":        [{"resource":"Wood","amount":50}],
            "sellWarning":      null,
            "refines":          [{"input":"Wood","output":"Wood"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Charcoal","output":"Ore","time":75,"ratio":1},
            "firstBuildMessage":"charccompact-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "coalcompact.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Charcoal Factory",
            "tile":             ["charfactory"],
            "cost":             [{"resource":"Wood","amount":250},{"resource":"Ore","amount":600},{"resource":"Steel","amount":500}],
            "description":      "charfactory-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     2000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wood","amount":1400},{"resource":"Charcoal","amount":350}],
            "sellValue":        [{"resource":"Wood","amount":120},{"resource":"Ore","amount":200},{"resource":"Steel","amount":130}],
            "sellWarning":      null,
            "refines":          [{"input":"Wood","output":"Wood"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":7}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   4,
            "requiresWorkers":  true,
            "smelts":           {"input":"Wood","output":"Charcoal","time":600,"ratio":8},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Advanced Charcoal Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "charfactory.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#333333",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Oil Tank",
            "tile":             ["oiltank"],
            "cost":             [{"resource":"Ore","amount":20},{"resource":"Charcoal","amount":40},{"resource":"Steel","amount":60}],
            "description":      "oiltank-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Oil","amount":900}],
            "sellValue":        [{"resource":"Ore","amount":6},{"resource":"Charcoal","amount":2},{"resource":"Steel","amount":15}],
            "sellWarning":      null,
            "refines":          [{"input":"Oil","output":"Oil"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Low Gravity Manufacturing","Low Gravity Oil Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "oiltank.png",
            "canUpgradeTo":     "Quantum Oil Tank",
            "transModeColor":   "#222222",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ether Storage",
            "tile":             ["etherstorage"],
            "cost":             [{"resource":"Ore","amount":20},{"resource":"Regolith","amount":40},{"resource":"Helium 3","amount":60},{"resource":"Ether","amount":20}],
            "description":      "etherstorage-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ether","amount":900}],
            "sellValue":        [{"resource":"Ore","amount":2},{"resource":"Regolith","amount":4},{"resource":"Helium 3","amount":1},{"resource":"Ether","amount":20}],
            "sellWarning":      null,
            "refines":          [{"input":"Ether","output":"Ether"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["LIS Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#222222",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Purple Flower Garden",
            "tile":             ["flowerspurple"],
            "cost":             [{"resource":"Water","amount":20},{"resource":"Wood","amount":2},{"resource":"Ore","amount":3}],
            "description":      "flowerspurple-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "flowers-purple.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Blue Flower Garden",
            "tile":             ["flowersblue"],
            "cost":             [{"resource":"Water","amount":20},{"resource":"Wood","amount":2},{"resource":"Ore","amount":3}],
            "description":      "flowersblue-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "flowers-blue.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "White Flower Garden",
            "tile":             ["flowerswhite"],
            "cost":             [{"resource":"Water","amount":20},{"resource":"Wood","amount":2},{"resource":"Ore","amount":3}],
            "description":      "flowerswhite-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "flowers-white.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Grass",
            "tile":             ["grass"],
            "cost":             [{"resource":"Water","amount":2}],
            "description":      "grass-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "grass.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Quantum Food Storage",
            "tile":             ["quantumfood"],
            "cost":             [{"resource":"Ore","amount":580},{"resource":"Steel","amount":1100},{"resource":"Aluminum","amount":1800},{"resource":"Uranium","amount":2800},{"resource":"Microchip","amount":8000},{"resource":"Alien Artifact","amount":85}],
            "description":      "quantumfood-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":300000},{"resource":"Sugar","amount":300000}],
            "sellValue":        [{"resource":"Ore","amount":300},{"resource":"Steel","amount":600},{"resource":"Aluminum","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    40,
            "requiresTech":     ["Ancient Alien Manufacturing","Alien Quantum Physics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#03A9F4",
            "requiresFuel":     {"resource":"Water","rate":1000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Food","Storage","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Synthetic Oil Lab",
            "tile":             ["oilsynthlab"],
            "cost":             [{"resource":"Wood","amount":1000},{"resource":"Charcoal","amount":2500},{"resource":"Ore","amount":7500},{"resource":"Steel","amount":6500},{"resource":"Gold","amount":4000},{"resource":"Microchip","amount":250}],
            "description":      "oilsynthlab-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Oil","amount":1000}],
            "sellValue":        [{"resource":"Wood","amount":15},{"resource":"Charcoal","amount":50},{"resource":"Ore","amount":3000},{"resource":"Steel","amount":2000},{"resource":"Gold","amount":1500},{"resource":"Microchip","amount":6}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":65}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  true,
            "smelts":           {"input":"Charcoal","output":"Oil","time":2000,"ratio":2},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Low Gravity Manufacturing","Low Gravity Oil Production","Advanced Chemical Synthesis"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        "oilsynthlab.png",
            "canUpgradeTo":     "Advanced Synthetic Oil Lab",
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Food","rate":250},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Plastic Factory",
            "tile":             ["plastfact"],
            "cost":             [{"resource":"Ore","amount":14500},{"resource":"Charcoal","amount":2000},{"resource":"Steel","amount":10000},{"resource":"Oil","amount":4000},{"resource":"Gold","amount":6500},{"resource":"Aluminum","amount":2200},{"resource":"Microchip","amount":1800}],
            "description":      "plastfact-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        4,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Plastic","amount":2000}],
            "sellValue":        [{"resource":"Ore","amount":6500},{"resource":"Steel","amount":4500},{"resource":"Gold","amount":2200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":100}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   30,
            "requiresWorkers":  true,
            "smelts":           {"input":"Oil","output":"Plastic","time":10000,"ratio":3},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    150,
            "requiresTech":     ["Large Scale Construction","Colonial Finance Theory","Low Gravity Manufacturing","Advanced Chemical Synthesis"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        "plastfact.png",
            "canUpgradeTo":     "Advanced Plastic Factory",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Durable Goods"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Old Electronics Chop Shop",
            "tile":             ["electronicschopshop"],
            "cost":             [{"resource":"Ore","amount":6500},{"resource":"Steel","amount":4000},{"resource":"Gold","amount":2000},{"resource":"Aluminum","amount":200},{"resource":"Microchip","amount":80},{"resource":"Plastic","amount":25},{"resource":"Toy","amount":5},{"resource":"Software","amount":60}],
            "description":      "electronicschopshop-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Toy","amount":50},{"resource":"Plastic","amount":50},{"resource":"Microchip","amount":250}],
            "sellValue":        [{"resource":"Ore","amount":650},{"resource":"Steel","amount":400},{"resource":"Gold","amount":200},{"resource":"Aluminum","amount":20},{"resource":"Microchip","amount":5},{"resource":"Plastic","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":30},{"utility":"Bandwidth","amount":10}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   4,
            "requiresWorkers":  true,
            "smelts":           {"input":"Plastic,Plastic,Toy,Toy,Toy","output":"Microchip","time":4000,"ratio":15},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    40,
            "requiresTech":     ["Advanced Chemical Synthesis","Basic Network Infrastructure"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Durable Goods","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Toy Sweatshop",
            "tile":             ["sweatshop2"],
            "cost":             [{"resource":"Ore","amount":15000},{"resource":"Steel","amount":11000},{"resource":"Gold","amount":7000},{"resource":"Aluminum","amount":2000},{"resource":"Microchip","amount":800},{"resource":"Plastic","amount":250}],
            "description":      "sweatshop2-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     25000,
            "generateAmount":   1,
            "tileWidth":        3,
            "tileHeight":       5,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Toy","amount":350}],
            "sellValue":        [{"resource":"Ore","amount":7000},{"resource":"Steel","amount":5000},{"resource":"Gold","amount":3000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":160}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   240,
            "requiresWorkers":  true,
            "smelts":           {"input":"Plastic","output":"Toy","time":30000,"ratio":75},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    140,
            "requiresTech":     ["Large Scale Construction","Low Gravity Manufacturing","Advanced Chemical Synthesis"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        "sweatshop2.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Durable Goods"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Space Port",
            "tile":             ["spaceport"],
            "cost":             [{"resource":"Ore","amount":1000},{"resource":"Steel","amount":750},{"resource":"Gold","amount":750},{"resource":"Microchip","amount":100},{"resource":"Civics","amount":50}],
            "description":      "spaceport-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":600},{"resource":"Steel","amount":300},{"resource":"Gold","amount":300},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":10}],
            "colGenRate":       9000,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   4,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    5,
            "requiresTech":     ["Colonial Tourism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "spaceport.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Civics","rate":1200},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Tourism"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   true,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Motel",
            "tile":             ["motel"],
            "cost":             [{"resource":"Ore","amount":500},{"resource":"Steel","amount":500},{"resource":"Microchip","amount":12}],
            "description":      "motel-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":12}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   4,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    7,
            "requiresTech":     ["Colonial Tourism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "motel.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Tourism"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":2,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    12,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -0.5,
                    "y":    0.15,
                    "r":    0.4,
                    "c":    "#FFEE58",
                    "i":    0.4,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Hotel",
            "tile":             ["hotel"],
            "cost":             [{"resource":"Ore","amount":900},{"resource":"Steel","amount":2000},{"resource":"Cloth","amount":120},{"resource":"Microchip","amount":120}],
            "description":      "hotel-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":350},{"resource":"Steel","amount":750},{"resource":"Microchip","amount":6}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":120}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   30,
            "requiresWorkers":  true,
            "smelts":           {"input":"Cloth","output":"Money","time":1200,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    7,
            "requiresTech":     ["Tourist Essentials"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "hotel.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Tourism"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":3,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    120,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Small Casino",
            "tile":             ["smcasino"],
            "cost":             [{"resource":"Money","amount":2000},{"resource":"Steel","amount":1500},{"resource":"Gold","amount":2000},{"resource":"Microchip","amount":2000}],
            "description":      "smcasino-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     8000,
            "generateAmount":   8,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Money","amount":1500},{"resource":"Steel","amount":600},{"resource":"Gold","amount":800},{"resource":"Microchip","amount":10}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":700}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   35,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Tourist Essentials"],
            "canRenderStatic":  false,
            "entertains":       10,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "smcasino.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Tourism"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":10,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    100,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Gift Shop",
            "tile":             ["giftshop"],
            "cost":             [{"resource":"Steel","amount":1200},{"resource":"Gold","amount":1000},{"resource":"Pottery","amount":100}],
            "description":      "giftshop-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Steel","amount":500},{"resource":"Gold","amount":350},{"resource":"Pottery","amount":15}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":10}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   2,
            "requiresWorkers":  true,
            "smelts":           {"input":"Pottery","output":"Money","time":2500,"ratio":3},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     ["Tourist Essentials"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "giftshop.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Tourism"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":10,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    5,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Zoo",
            "tile":             ["zoo"],
            "cost":             [{"resource":"Wood","amount":100000},{"resource":"Cloth","amount":25000},{"resource":"Steel","amount":50000},{"resource":"Bricks","amount":100000}],
            "description":      "zoo-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        8,
            "tileHeight":       8,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Wood","amount":12000},{"resource":"Cloth","amount":6000},{"resource":"Steel","amount":14000},{"resource":"Bricks","amount":15000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":425}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   70,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    150,
            "requiresTech":     ["Low Gravity Husbandry","Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       150,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        "zoo.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Pottery","rate":3000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Tourism"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":10,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    750,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Blue House",
            "tile":             ["bluehouse"],
            "cost":             [{"resource":"Wood","amount":250},{"resource":"Steel","amount":50},{"resource":"Microchip","amount":10},{"resource":"Pottery","amount":5}],
            "description":      "bluehouse-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2600,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Wood","amount":120},{"resource":"Steel","amount":20},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  7,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     ["Advanced Small Scale Construction","Advanced Microbiology"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        "bluehouse.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1.5,
                    "c":    "#FFF8E1",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Yellow Flower Garden",
            "tile":             ["flowersyellow"],
            "cost":             [{"resource":"Water","amount":20},{"resource":"Wood","amount":2},{"resource":"Ore","amount":3}],
            "description":      "flowersyellow-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "flowers-yellow.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Obelisk of Colonial Independence",
            "tile":             ["obeliskindependence"],
            "cost":             [{"resource":"Ore","amount":2500},{"resource":"Steel","amount":2500},{"resource":"Gold","amount":7500},{"resource":"Aluminum","amount":500}],
            "description":      "obelisk-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":3000},{"resource":"Aluminum","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Colonial Civics"],
            "canRenderStatic":  false,
            "entertains":       50,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "obeliskindependence.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Tourism"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":1,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    6,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Restaurant",
            "tile":             ["restaurant"],
            "cost":             [{"resource":"Ore","amount":500},{"resource":"Steel","amount":500},{"resource":"Cloth","amount":100}],
            "description":      "restaurant-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200},{"resource":"Cloth","amount":10}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":10}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  true,
            "smelts":           {"input":"Food","output":"Money","time":2500,"ratio":3},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     ["Tourist Essentials"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "restaurant.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Tourism"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":2,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    15,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Large Resort",
            "tile":             ["resort"],
            "cost":             [{"resource":"Ore","amount":10000},{"resource":"Steel","amount":50000},{"resource":"Cloth","amount":2000},{"resource":"Microchip","amount":1200}],
            "description":      "resort-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        4,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":2500},{"resource":"Steel","amount":10000},{"resource":"Cloth","amount":50},{"resource":"Microchip","amount":12}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   100,
            "requiresWorkers":  true,
            "smelts":           {"input":"Cloth","output":"Money","time":2500,"ratio":3},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     ["Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        "resort.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Tourism"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":5,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    1200,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Outdoor Shopping Mall",
            "tile":             ["mall"],
            "cost":             [{"resource":"Ore","amount":20000},{"resource":"Steel","amount":100000},{"resource":"Gold","amount":40000},{"resource":"Bricks","amount":75000},{"resource":"Microchip","amount":15000}],
            "description":      "mall-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        10,
            "tileHeight":       10,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":6000},{"resource":"Steel","amount":35000},{"resource":"Gold","amount":15000},{"resource":"Bricks","amount":10000},{"resource":"Microchip","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2000}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   500,
            "requiresWorkers":  true,
            "smelts":           {"input":"Cloth","output":"Money","time":18000,"ratio":3},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     ["Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       100,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        "mall.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Toy","rate":750},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Tourism"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":10,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    2000,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Museum",
            "tile":             ["museum"],
            "cost":             [{"resource":"Steel","amount":10000},{"resource":"Bricks","amount":10000},{"resource":"Aluminum","amount":2500}],
            "description":      "museum-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Steel","amount":3000},{"resource":"Bricks","amount":3000},{"resource":"Aluminum","amount":800}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":75}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     ["Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       100,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "musuem.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Pottery","rate":1500},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Tourism"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":3,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    50,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       100,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Galactic Freight",
            "tile":             ["galfreight"],
            "cost":             [{"resource":"Ore","amount":8000},{"resource":"Steel","amount":6000},{"resource":"Gold","amount":5000},{"resource":"Oil","amount":250},{"resource":"Microchip","amount":1000}],
            "description":      "galfreight-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     3500,
            "generateAmount":   8,
            "tileWidth":        7,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":3000},{"resource":"Steel","amount":2000},{"resource":"Gold","amount":2000},{"resource":"Oil","amount":40},{"resource":"Microchip","amount":8}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":220}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   18,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    140,
            "requiresTech":     ["United Earth Base","Large Scale Construction","Galactic Commerce","Advanced Chemical Synthesis"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Food","Water","Rum","Wool","Wood","Clay","Charcoal","Regolith","Ore","Steel","Gold","Aluminum","Oil","Helium 3","Toy","Uranium","Pottery","Bricks","Microchip","Robot","Alien Artifact"],
            "canExport":        ["Food","Water","Rum","Wool","Wood","Clay","Charcoal","Regolith","Ore","Steel","Gold","Aluminum","Oil","Helium 3","Toy","Uranium","Pottery","Bricks","Microchip","Robot","Alien Artifact"],
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        "galfreight.png",
            "canUpgradeTo":     "Space Elevator",
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Oil","rate":2000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    1000,
            "upkeepCost":       0.0,
            "giftCapacity":     1000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Statue of Unbridled Excess",
            "tile":             ["statue3"],
            "cost":             [{"resource":"Ore","amount":3000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":6000},{"resource":"Money","amount":175000000}],
            "description":      "statue3-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        4,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Colonial Civics","Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       10,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "statue3.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":50,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    10,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ultra Deep Dig Site",
            "tile":             ["digsite2"],
            "cost":             [{"resource":"Money","amount":30000},{"resource":"Ore","amount":115000},{"resource":"Water","amount":40000},{"resource":"Wood","amount":20000},{"resource":"Steel","amount":70000},{"resource":"Gold","amount":50000},{"resource":"Aluminum","amount":3000},{"resource":"Microchip","amount":100000},{"resource":"Civics","amount":20000},{"resource":"Alien Artifact","amount":500}],
            "description":      "digsite2-description",
            "produces":         null,
            "generates":        "Alien Artifact",
            "generateTime":     100000,
            "generateAmount":   2,
            "tileWidth":        5,
            "tileHeight":       5,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Alien Artifact","amount":250}],
            "sellValue":        [{"resource":"Ore","amount":25000},{"resource":"Wood","amount":3000},{"resource":"Steel","amount":10000},{"resource":"Gold","amount":6000},{"resource":"Aluminum","amount":800},{"resource":"Microchip","amount":120}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":500}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   60,
            "requiresWorkers":  true,
            "smelts":           {"input":"Water","output":"Clay","time":20000,"ratio":3},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    380,
            "requiresTech":     ["Ultra Deep Excavation"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Charcoal Pile",
            "tile":             ["charcoalpile"],
            "cost":             [{"resource":"Charcoal","amount":200}],
            "description":      "charcoalpile-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Charcoal","amount":10000}],
            "sellValue":        [{"resource":"Charcoal","amount":80}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    10,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "charcoalpile.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#333333",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Mound",
            "tile":             ["mound"],
            "cost":             null,
            "description":      "mound-description",
            "produces":         ["Queen","Worker Drone","Tundrabug","Extremeobug","Obsidiobug","Fisherbug","Waterbug","Orebug","Etherbug","Regobug","Goldbug","Lumberbug","Alumibug","Ancientbug"],
            "generates":        "Food",
            "generateTime":     600,
            "generateAmount":   5,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Fish","amount":200},{"resource":"Obsidian","amount":200},{"resource":"Sugar","amount":500},{"resource":"Food","amount":200},{"resource":"Water","amount":400},{"resource":"Crystalline","amount":2000},{"resource":"Ore","amount":8000},{"resource":"Regolith","amount":2500},{"resource":"Charcoal","amount":2500},{"resource":"Regolith","amount":700}],
            "sellValue":        [{"resource":"Money","amount":10}],
            "sellWarning":      null,
            "refines":          [{"input":"Regolith","output":"Regolith"},{"input":"Fish","output":"Food,Sugar"},{"input":"Obsidian","output":"Obsidian"},{"input":"Ore","output":"Ore"},{"input":"Water","output":"Water"},{"input":"Sugar","output":"Sugar"},{"input":"Crystalline","output":"Crystalline"},{"input":"Diamond","output":"Diamond"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       4000,
            "providesShelter":  200,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  false,
            "smelts":           {"input":"Sugar","output":"Food","time":300,"ratio":5},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Insectoid Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "mound.png",
            "canUpgradeTo":     "Unholy Mound of Worship",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            10,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Housing","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    true,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          "Queen",
            "canBuildOver":     null
        },
        {
            "name":             "Regolith Incinerator",
            "tile":             ["regolithincinerator"],
            "cost":             [{"resource":"Regolith","amount":120},{"resource":"Sugar","amount":20}],
            "description":      "regolithincinerator-description",
            "produces":         [],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ore","amount":500},{"resource":"Regolith","amount":500}],
            "sellValue":        [{"resource":"Regolith","amount":50}],
            "sellWarning":      null,
            "refines":          [{"input":"Regolith","output":"Regolith"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Regolith,Sugar","output":"Ore","time":60,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Communal Water Vats",
            "tile":             ["watervats"],
            "cost":             [{"resource":"Ore","amount":450},{"resource":"Water","amount":100}],
            "description":      "watervats-description",
            "produces":         ["Waterbug"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Water","amount":800}],
            "sellValue":        [{"resource":"Ore","amount":100}],
            "sellWarning":      null,
            "refines":          [{"input":"Water","output":"Water"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       null,
            "providesShelter":  null,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"communalvats-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Insectoid Base"],
            "canRenderStatic":  false,
            "entertains":       10,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "watervats.png",
            "canUpgradeTo":     "Polished Water Vats",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Entertainment","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Polished Water Vats",
            "tile":             ["watervats2"],
            "cost":             [{"resource":"Ore","amount":450},{"resource":"Clay","amount":500},{"resource":"Water","amount":100}],
            "description":      "watervats2-description",
            "produces":         ["Waterbug"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Water","amount":4000}],
            "sellValue":        [{"resource":"Ore","amount":100}],
            "sellWarning":      null,
            "refines":          [{"input":"Water","output":"Water"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       null,
            "providesShelter":  null,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Antanium Production","Communal Finance"],
            "canRenderStatic":  false,
            "entertains":       14,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Entertainment","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Paste Tank",
            "tile":             ["pastetank"],
            "cost":             [{"resource":"Ore","amount":300},{"resource":"Water","amount":300}],
            "description":      "pastetank-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ant Paste","amount":600}],
            "sellValue":        [{"resource":"Ore","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       null,
            "providesShelter":  null,
            "canChain":         true,
            "acceptsWorkers":   3,
            "requiresWorkers":  false,
            "smelts":           {"input":"Sugar","output":"Ant Paste","time":500,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Insectoid Base"],
            "canRenderStatic":  false,
            "entertains":       10,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "pastetank.png",
            "canUpgradeTo":     "Smart Paste Tank",
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Water","rate":500},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Smart Paste Tank",
            "tile":             ["pastetank2"],
            "cost":             [{"resource":"Ore","amount":300},{"resource":"Water","amount":300},{"resource":"Antanium","amount":300},{"resource":"Gold","amount":100},{"resource":"Microchip","amount":25}],
            "description":      "pastetank2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ant Paste","amount":1200}],
            "sellValue":        [{"resource":"Ore","amount":30},{"resource":"Antanium","amount":30},{"resource":"Gold","amount":10},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":1},{"utility":"Bandwidth","amount":2}],
            "requiresUtility":  null,
            "colGenRate":       null,
            "providesShelter":  null,
            "canChain":         true,
            "acceptsWorkers":   3,
            "requiresWorkers":  false,
            "smelts":           {"input":"Sugar","output":"Ant Paste","time":400,"ratio":9},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    9,
            "requiresTech":     ["Basic Network Infrastructure","Advanced Metallurgy"],
            "canRenderStatic":  false,
            "entertains":       10,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Water","rate":500},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Storage","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Subterranean Sugar Farm",
            "tile":             ["subsugar"],
            "cost":             [{"resource":"Ore","amount":300},{"resource":"Water","amount":300}],
            "description":      "subsugar-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Sugar","amount":600}],
            "sellValue":        [{"resource":"Ore","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       null,
            "providesShelter":  null,
            "canChain":         true,
            "acceptsWorkers":   3,
            "requiresWorkers":  false,
            "smelts":           {"input":"Water","output":"Sugar","time":200,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Insectoid Base"],
            "canRenderStatic":  false,
            "entertains":       10,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Water","rate":500},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Brood Training Center",
            "tile":             ["broodcenter"],
            "cost":             [{"resource":"Ore","amount":1500},{"resource":"Sugar","amount":300},{"resource":"Ant Paste","amount":300}],
            "description":      "broodcenter-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     2000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":500}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   5,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":"smresearch-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "broodcenter.png",
            "canUpgradeTo":     "Spire of Knowledge",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Research"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         5,
            "providesIQ":       90,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Gold Burrow",
            "tile":             ["goldburrow"],
            "cost":             [{"resource":"Ore","amount":1200},{"resource":"Ant Paste","amount":700}],
            "description":      "goldburrow-description",
            "produces":         ["Goldbug"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Gold","amount":4000}],
            "sellValue":        [{"resource":"Ore","amount":200}],
            "sellWarning":      null,
            "refines":          [{"input":"Gold","output":"Gold"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       null,
            "providesShelter":  null,
            "canChain":         false,
            "acceptsWorkers":   2,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Gold Storage"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "goldburrow.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Insectoid Mint",
            "tile":             ["insectoidmint"],
            "cost":             [{"resource":"Ore","amount":1500},{"resource":"Ant Paste","amount":800},{"resource":"Gold","amount":200}],
            "description":      "insectoidmint-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     9000,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Gold","amount":10000}],
            "sellValue":        [{"resource":"Ore","amount":400},{"resource":"Gold","amount":40}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":6}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           {"input":"Gold","output":"Money","time":2000,"ratio":10},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    25,
            "requiresTech":     ["Communal Finance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "insectoidmint.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    1,
                    "r":    1.4,
                    "c":    "#FFB300",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Sugarcane",
            "tile":             ["sugarcane"],
            "cost":             [{"resource":"Water","amount":30}],
            "description":      "sugarcane-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Sugarcane",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Sugar Cultivation|LIS Base|Draconian Base","Sugarland Base|Abandoned World Base|Water World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "sugarcane.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Antanium Smelter",
            "tile":             ["antaniumsmelter"],
            "cost":             [{"resource":"Ore","amount":1500},{"resource":"Ant Paste","amount":800},{"resource":"Gold","amount":200}],
            "description":      "antaniumsmelter-description",
            "produces":         ["Orebug","Goldbug"],
            "generates":        "Atmosphere",
            "generateTime":     7500,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Antanium","amount":1500},{"resource":"Ore","amount":2000},{"resource":"Gold","amount":2000}],
            "sellValue":        [{"resource":"Ore","amount":400},{"resource":"Gold","amount":40}],
            "sellWarning":      null,
            "refines":          [{"input":"Ore","output":"Ore"},{"input":"Gold","output":"Gold"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":7}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   6,
            "requiresWorkers":  false,
            "smelts":           {"input":"Ore","output":"Antanium","time":800,"ratio":5},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    25,
            "requiresTech":     ["Antanium Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "antanium-smelter.png",
            "canUpgradeTo":     "Antanium Blast Furnace",
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Gold","rate":1000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    1.8,
                    "r":    0.6,
                    "c":    "#FFB300",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Antanium Blast Furnace",
            "tile":             ["antaniumblastfurnace"],
            "cost":             [{"resource":"Ore","amount":18000},{"resource":"Ant Paste","amount":15000},{"resource":"Gold","amount":25000},{"resource":"Charcoal","amount":25000},{"resource":"Obsidian","amount":30500},{"resource":"Oil","amount":9000},{"resource":"Aluminum","amount":6000}],
            "description":      "antaniumblastfurnace-description",
            "produces":         ["Obsidiobug","Orebug","Goldbug"],
            "generates":        "Atmosphere",
            "generateTime":     7500,
            "generateAmount":   5,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Antanium","amount":9000},{"resource":"Ore","amount":7000},{"resource":"Gold","amount":7000}],
            "sellValue":        [{"resource":"Ore","amount":180},{"resource":"Gold","amount":250},{"resource":"Charcoal","amount":25},{"resource":"Obsidian","amount":1500},{"resource":"Oil","amount":3},{"resource":"Aluminum","amount":600}],
            "sellWarning":      null,
            "refines":          [{"input":"Ore","output":"Ore"},{"input":"Gold","output":"Gold"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":650}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  false,
            "smelts":           {"input":"Ore","output":"Antanium","time":400,"ratio":65},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    25,
            "requiresTech":     ["Antanium Production","Insectoid Oil Production","Insectoid Bureaucracy"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Gold,Charcoal,Oil,Gold,Charcoal,Oil,Gold,Charcoal,Oil","rate":500},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Aquamound",
            "tile":             ["aquamound"],
            "cost":             [{"resource":"Wood","amount":250},{"resource":"Antanium","amount":50},{"resource":"Ant Paste","amount":10},{"resource":"Rum","amount":5}],
            "description":      "aquamound-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Wood","amount":120},{"resource":"Antanium","amount":20}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  7,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     ["Wood Harvesting","Water World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     ["Salt Water"]
        },
        {
            "name":             "Elders Mound",
            "tile":             ["eldersmound"],
            "cost":             [{"resource":"Ore","amount":800},{"resource":"Gold","amount":800},{"resource":"Antanium","amount":800},{"resource":"Ant Paste","amount":1000}],
            "description":      "eldersmound-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     8500,
            "generateAmount":   2,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":200},{"resource":"Gold","amount":200},{"resource":"Antanium","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":20}],
            "colGenRate":       0,
            "providesShelter":  20,
            "canChain":         false,
            "acceptsWorkers":   16,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     ["Antanium Production","Communal Finance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "eldersmound.png",
            "canUpgradeTo":     "Hall of Elders",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Hall of Elders",
            "tile":             ["hallofelders"],
            "cost":             [{"resource":"Ore","amount":1400},{"resource":"Gold","amount":1800},{"resource":"Antanium","amount":1800},{"resource":"Ant Paste","amount":1800},{"resource":"Aluminum","amount":1800},{"resource":"Microchip","amount":120},{"resource":"Software","amount":100},{"resource":"Oil","amount":100},{"resource":"Cloth","amount":400}],
            "description":      "hallofelders-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     6500,
            "generateAmount":   6,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":200},{"resource":"Gold","amount":200},{"resource":"Antanium","amount":200},{"resource":"Aluminum","amount":1000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":50},{"utility":"Bandwidth","amount":55}],
            "colGenRate":       0,
            "providesShelter":  20,
            "canChain":         false,
            "acceptsWorkers":   26,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money,Software","output":"Civics","time":10000,"ratio":25},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     ["Insectoid Oil Production","Basic Network Infrastructure"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Mining Operation",
            "tile":             ["miningoperation"],
            "cost":             [{"resource":"Water","amount":1500},{"resource":"Antanium","amount":450},{"resource":"Ant Paste","amount":1500}],
            "description":      "miningoperation-description",
            "produces":         null,
            "generates":        "Gold",
            "generateTime":     5000,
            "generateAmount":   6,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ore","amount":3500},{"resource":"Gold","amount":3500}],
            "sellValue":        [{"resource":"Water","amount":500},{"resource":"Antanium","amount":100},{"resource":"Ant Paste","amount":500}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   10,
            "requiresWorkers":  true,
            "smelts":           {"input":"Water","output":"Ore","time":4500,"ratio":6},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     ["Antanium Production","Communal Finance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Unholy Core Mine",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Clay Pit",
            "tile":             ["claypit"],
            "cost":             [{"resource":"Water","amount":5000},{"resource":"Ore","amount":3500},{"resource":"Antanium","amount":1000},{"resource":"Ant Paste","amount":1500},{"resource":"Gold","amount":250}],
            "description":      "claypit-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Clay","amount":3500}],
            "sellValue":        [{"resource":"Ore","amount":350},{"resource":"Antanium","amount":100},{"resource":"Gold","amount":25}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   10,
            "requiresWorkers":  true,
            "smelts":           {"input":"Water","output":"Clay","time":4500,"ratio":6},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     ["Antanium Production","Communal Finance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Potterbug's Mound",
            "tile":             ["potterbugmound"],
            "cost":             [{"resource":"Ore","amount":3000},{"resource":"Water","amount":600},{"resource":"Antanium","amount":1000},{"resource":"Gold","amount":250},{"resource":"Aluminum","amount":250},{"resource":"Microchip","amount":5},{"resource":"Clay","amount":150}],
            "description":      "potterbugmound-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Clay","amount":2500},{"resource":"Pottery","amount":500}],
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Water","amount":200},{"resource":"Antanium","amount":400},{"resource":"Gold","amount":100},{"resource":"Aluminum","amount":100},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          [{"input":"Clay","output":"Clay"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":16}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  true,
            "smelts":           {"input":"Clay","output":"Pottery","time":2000,"ratio":2},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Antanium Production","Communal Finance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#deaa87",
            "requiresFuel":     {"resource":"Water","rate":1400},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Durable Goods"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Statue of Emperor Zolarg",
            "tile":             ["zolargstatue"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Antanium","amount":200},{"resource":"Gold","amount":500}],
            "description":      "zolargstatue-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "zolargstatue.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Capitol Level 2",
            "tile":             ["capitol2"],
            "cost":             [{"resource":"Ore","amount":30000},{"resource":"Water","amount":2000},{"resource":"Rum","amount":1500},{"resource":"Wood","amount":2000},{"resource":"Cloth","amount":2000},{"resource":"Bricks","amount":6000},{"resource":"Steel","amount":30000},{"resource":"Pottery","amount":2000},{"resource":"Gold","amount":20000},{"resource":"Aluminum","amount":3500},{"resource":"Microchip","amount":3000},{"resource":"Civics","amount":10000}],
            "description":      "capitol2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        9,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":10000},{"resource":"Wood","amount":300},{"resource":"Cloth","amount":300},{"resource":"Bricks","amount":650},{"resource":"Steel","amount":1000},{"resource":"Gold","amount":750},{"resource":"Aluminum","amount":200},{"resource":"Microchip","amount":6}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":100}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   110,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":14000,"ratio":75},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    120,
            "requiresTech":     ["United Earth Base","Solar Governance","Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        "capitol2.png",
            "canUpgradeTo":     "Capitol Level 3",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     5000,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    2,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Capitol Level 3",
            "tile":             ["capitol3"],
            "cost":             [{"resource":"Ore","amount":50000},{"resource":"Water","amount":4000},{"resource":"Rum","amount":6000},{"resource":"Wood","amount":6000},{"resource":"Cloth","amount":6000},{"resource":"Bricks","amount":12000},{"resource":"Steel","amount":60000},{"resource":"Pottery","amount":6000},{"resource":"Gold","amount":45000},{"resource":"Plastic","amount":8000},{"resource":"Aluminum","amount":7000},{"resource":"Microchip","amount":10000},{"resource":"Civics","amount":20000}],
            "description":      "capitol3-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        9,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":8000},{"resource":"Wood","amount":260},{"resource":"Cloth","amount":1000},{"resource":"Bricks","amount":900},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":6000},{"resource":"Aluminum","amount":300},{"resource":"Microchip","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":140}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   130,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":14000,"ratio":85},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    120,
            "requiresTech":     ["United Earth Base","Galactic Governance","Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        "capitol3.png",
            "canUpgradeTo":     "Capitol Level 4",
            "transModeColor":   "#dddddd",
            "requiresFuel":     {"resource":"Rum","rate":350},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     50000,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    3,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Consulate Level 2",
            "tile":             ["consulate2"],
            "cost":             [{"resource":"Ore","amount":16000},{"resource":"Steel","amount":16000},{"resource":"Gold","amount":6000},{"resource":"Pottery","amount":400},{"resource":"Microchip","amount":100},{"resource":"Civics","amount":400}],
            "description":      "consulate2-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1500,
            "generateAmount":   4,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":6000},{"resource":"Steel","amount":6000},{"resource":"Gold","amount":2000},{"resource":"Pottery","amount":4},{"resource":"Microchip","amount":3}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   5,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    5,
            "requiresTech":     ["United Earth Base","Solar Governance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        "consulate2b.png",
            "canUpgradeTo":     "Consulate Level 3",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      true,
            "isEmbassy":        false,
            "buildLimit":       1,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     3000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    2,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Consulate Level 3",
            "tile":             ["consulate3"],
            "cost":             [{"resource":"Ore","amount":25000},{"resource":"Steel","amount":25000},{"resource":"Gold","amount":12000},{"resource":"Pottery","amount":1200},{"resource":"Microchip","amount":500},{"resource":"Civics","amount":1000}],
            "description":      "consulate3-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1500,
            "generateAmount":   6,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":9000},{"resource":"Steel","amount":9000},{"resource":"Gold","amount":3000},{"resource":"Pottery","amount":10},{"resource":"Microchip","amount":4}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   7,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    10,
            "requiresTech":     ["United Earth Base","Galactic Governance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        "consulate3b.png",
            "canUpgradeTo":     "Consulate Level 4",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      true,
            "isEmbassy":        false,
            "buildLimit":       1,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     30000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    3,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Sand",
            "tile":             ["sand"],
            "cost":             [{"resource":"Ore","amount":1},{"resource":"Clay","amount":1}],
            "description":      "sand-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "sand.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Capitol Level 4",
            "tile":             ["capitol4"],
            "cost":             [{"resource":"Money","amount":100000},{"resource":"Ore","amount":90000},{"resource":"Water","amount":8000},{"resource":"Rum","amount":16000},{"resource":"Helium 3","amount":1000},{"resource":"Charcoal","amount":1000},{"resource":"Wood","amount":16000},{"resource":"Cloth","amount":10000},{"resource":"Bricks","amount":20000},{"resource":"Steel","amount":90000},{"resource":"Pottery","amount":14000},{"resource":"Gold","amount":90000},{"resource":"Plastic","amount":20000},{"resource":"Aluminum","amount":16000},{"resource":"Microchip","amount":25000},{"resource":"Civics","amount":40000}],
            "description":      "capitol4-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        9,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":9000},{"resource":"Water","amount":800},{"resource":"Helium 3","amount":10},{"resource":"Wood","amount":160},{"resource":"Cloth","amount":1000},{"resource":"Bricks","amount":2000},{"resource":"Steel","amount":9000},{"resource":"Gold","amount":9000},{"resource":"Aluminum","amount":1600},{"resource":"Microchip","amount":25}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   160,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":14000,"ratio":95},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    160,
            "requiresTech":     ["United Earth Base","Nationalism","Large Scale Construction","Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        null,
            "canUpgradeTo":     "Capitol Level 5",
            "transModeColor":   "#dddddd",
            "requiresFuel":     {"resource":"Rum","rate":100},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":20,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    30,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     500000,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    4,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "National Flag",
            "tile":             ["flag0"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200},{"resource":"Gold","amount":500},{"resource":"Cloth","amount":250}],
            "description":      "natflag-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["United Earth Base","Nationalism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Red Flag",
            "tile":             ["flag1"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200},{"resource":"Gold","amount":500},{"resource":"Cloth","amount":250}],
            "description":      "flag-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["United Earth Base","Nationalism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "flag1.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Blue Flag",
            "tile":             ["flag2"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200},{"resource":"Gold","amount":500},{"resource":"Cloth","amount":250}],
            "description":      "flag-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["United Earth Base","Nationalism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "flag2.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Green Flag",
            "tile":             ["flag3"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200},{"resource":"Gold","amount":500},{"resource":"Cloth","amount":250}],
            "description":      "flag-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["United Earth Base","Nationalism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "flag3.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Purple Flag",
            "tile":             ["flag4"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200},{"resource":"Gold","amount":500},{"resource":"Cloth","amount":250}],
            "description":      "flag-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["United Earth Base","Nationalism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "flag4.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "White Flag",
            "tile":             ["flag6"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200},{"resource":"Gold","amount":500},{"resource":"Cloth","amount":250}],
            "description":      "flag-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["United Earth Base","Nationalism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "flag6.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Black Flag",
            "tile":             ["flag7"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200},{"resource":"Gold","amount":500},{"resource":"Cloth","amount":250}],
            "description":      "flag-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["United Earth Base","Nationalism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "flag7.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Capitol Level 5",
            "tile":             ["capitol5"],
            "cost":             [{"resource":"Money","amount":200000},{"resource":"Ore","amount":200000},{"resource":"Water","amount":20000},{"resource":"Rum","amount":25000},{"resource":"Helium 3","amount":5000},{"resource":"Charcoal","amount":10000},{"resource":"Oil","amount":7500},{"resource":"Wood","amount":25000},{"resource":"Cloth","amount":30000},{"resource":"Bricks","amount":60000},{"resource":"Steel","amount":200000},{"resource":"Pottery","amount":30000},{"resource":"Gold","amount":200000},{"resource":"Plastic","amount":50000},{"resource":"Aluminum","amount":30000},{"resource":"Microchip","amount":50000},{"resource":"Civics","amount":100000}],
            "description":      "capitol5-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        9,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":9000},{"resource":"Water","amount":800},{"resource":"Helium 3","amount":10},{"resource":"Wood","amount":160},{"resource":"Cloth","amount":1000},{"resource":"Bricks","amount":2000},{"resource":"Steel","amount":9000},{"resource":"Gold","amount":9000},{"resource":"Aluminum","amount":1600},{"resource":"Microchip","amount":25}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":260}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   200,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":14000,"ratio":105},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    200,
            "requiresTech":     ["United Earth Base","Imperialism","Large Scale Construction","Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        null,
            "canUpgradeTo":     "Capitol Level 6",
            "transModeColor":   "#dddddd",
            "requiresFuel":     {"resource":"Rum","rate":50},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":30,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    40,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     5000000,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    5,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Healing Pods",
            "tile":             ["healingpods"],
            "cost":             [{"resource":"Ore","amount":600},{"resource":"Antanium","amount":200},{"resource":"Ant Paste","amount":200},{"resource":"Gold","amount":80},{"resource":"Civics","amount":50}],
            "description":      "healingpods-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":150},{"resource":"Antanium","amount":10},{"resource":"Gold","amount":10}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   1,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Insectoid Regeneration"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "healingpods.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            15,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Medical"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Designated Swim Area",
            "tile":             ["designatedswimarea"],
            "cost":             [{"resource":"Ore","amount":600},{"resource":"Wood","amount":350},{"resource":"Ant Paste","amount":150}],
            "description":      "designatedswimarea-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":275},{"resource":"Wood","amount":120}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    10,
            "requiresTech":     ["Water World Base"],
            "canRenderStatic":  false,
            "entertains":       12,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Entertainment"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     ["Salt Water"]
        },
        {
            "name":             "Seabeet Farm",
            "tile":             ["seabeetfarm"],
            "cost":             [{"resource":"Ore","amount":500},{"resource":"Ant Paste","amount":900},{"resource":"Sugar","amount":800},{"resource":"Gold","amount":500}],
            "description":      "seabeetfarm-description",
            "produces":         null,
            "generates":        "Sugar",
            "generateTime":     1700,
            "generateAmount":   14,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Sugar","amount":2000}],
            "sellValue":        [{"resource":"Ore","amount":50},{"resource":"Ant Paste","amount":9},{"resource":"Sugar","amount":8},{"resource":"Gold","amount":50}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   4,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Sugar Cultivation","Water World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     ["Salt Water"]
        },
        {
            "name":             "Sugar Farm",
            "tile":             ["sugarfarm"],
            "cost":             [{"resource":"Water","amount":2500},{"resource":"Ore","amount":1200},{"resource":"Antanium","amount":800},{"resource":"Ant Paste","amount":800},{"resource":"Sugar","amount":800},{"resource":"Civics","amount":15}],
            "description":      "sugarfarm-description",
            "produces":         null,
            "generates":        "Sugar",
            "generateTime":     1500,
            "generateAmount":   15,
            "tileWidth":        4,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Sugar","amount":2000}],
            "sellValue":        [{"resource":"Ore","amount":900},{"resource":"Antanium","amount":200},{"resource":"Ant Paste","amount":20},{"resource":"Sugar","amount":700}],
            "sellWarning":      null,
            "refines":          [{"input":"Water","output":"Water"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Sugar Cultivation","Antanium Production","Sugarpower"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "sugarfarm.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Water","rate":1500},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Brew Pit",
            "tile":             ["brewpit"],
            "cost":             [{"resource":"Water","amount":120},{"resource":"Ore","amount":200},{"resource":"Antanium","amount":20}],
            "description":      "distillery-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Rum","amount":50}],
            "sellValue":        [{"resource":"Water","amount":20},{"resource":"Ore","amount":80},{"resource":"Antanium","amount":6}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   2,
            "requiresWorkers":  true,
            "smelts":           {"input":"Food","output":"Rum","time":1200,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    4,
            "requiresTech":     ["Insectoid Brewing","Antanium Production","Sugarpower"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "brewpit.png",
            "canUpgradeTo":     "Unholy Brew Pit",
            "transModeColor":   "#b38600",
            "requiresFuel":     {"resource":"Water","rate":1200},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Durable Goods"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Gentelbugs Club",
            "tile":             ["gentelbugsclub"],
            "cost":             [{"resource":"Rum","amount":100},{"resource":"Ore","amount":450},{"resource":"Ant Paste","amount":250},{"resource":"Antanium","amount":50}],
            "description":      "gentelbugs-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Rum","amount":10}],
            "sellValue":        [{"resource":"Ore","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   10,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    6,
            "requiresTech":     ["Insectoid Brewing","Antanium Production","Sugarpower"],
            "canRenderStatic":  false,
            "entertains":       12,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "gentelbugsclub.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#b38600",
            "requiresFuel":     {"resource":"Rum","rate":800},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Entertainment"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":1,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -0.3,
                    "y":    0.1,
                    "r":    0.4,
                    "c":    "#E91E63",
                    "i":    0.35,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "House of Running Rum",
            "tile":             ["houserunningrum"],
            "cost":             [{"resource":"Rum","amount":300},{"resource":"Ore","amount":950},{"resource":"Ant Paste","amount":1250},{"resource":"Antanium","amount":650},{"resource":"Clay","amount":1000},{"resource":"Wood","amount":600},{"resource":"Gold","amount":350},{"resource":"Cloth","amount":250}],
            "description":      "houserunningrum-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Rum","amount":350}],
            "sellValue":        [{"resource":"Ore","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":12}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   16,
            "requiresWorkers":  true,
            "smelts":           {"input":"Rum,Food","output":"Money","time":500,"ratio":20},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    12,
            "requiresTech":     ["Insectoid Brewing","Antanium Production","Open Doors"],
            "canRenderStatic":  false,
            "entertains":       20,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#b38600",
            "requiresFuel":     {"resource":"Rum","rate":1200},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Entertainment","Tourism"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":6,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    20,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Large Helium 3 Tank",
            "tile":             ["lghe3"],
            "cost":             [{"resource":"Regolith","amount":1000},{"resource":"Ore","amount":500},{"resource":"Steel","amount":900},{"resource":"Aluminum","amount":120}],
            "description":      "lghe3-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Helium 3","amount":6800}],
            "sellValue":        [{"resource":"Regolith","amount":100},{"resource":"Ore","amount":75},{"resource":"Steel","amount":350}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "lghe3.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#cccccc",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Commemorative Plaque",
            "tile":             ["plaque"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200},{"resource":"Gold","amount":500}],
            "description":      "plaque-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Colonial Civics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "plaque.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           true,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Capitol Level 6",
            "tile":             ["capitol6"],
            "cost":             [{"resource":"Money","amount":500000},{"resource":"Ore","amount":450000},{"resource":"Water","amount":35000},{"resource":"Rum","amount":40000},{"resource":"Helium 3","amount":9500},{"resource":"Toy","amount":1000},{"resource":"Charcoal","amount":20000},{"resource":"Oil","amount":15000},{"resource":"Wood","amount":40000},{"resource":"Cloth","amount":55000},{"resource":"Bricks","amount":90000},{"resource":"Steel","amount":500000},{"resource":"Pottery","amount":55000},{"resource":"Gold","amount":400000},{"resource":"Plastic","amount":75000},{"resource":"Aluminum","amount":55000},{"resource":"Microchip","amount":80000},{"resource":"Robot","amount":100},{"resource":"Civics","amount":250000}],
            "description":      "capitol6-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        9,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":12000},{"resource":"Water","amount":900},{"resource":"Helium 3","amount":20},{"resource":"Wood","amount":200},{"resource":"Cloth","amount":2500},{"resource":"Bricks","amount":3000},{"resource":"Steel","amount":10000},{"resource":"Gold","amount":12000},{"resource":"Aluminum","amount":2500},{"resource":"Microchip","amount":30}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":300}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   280,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":14000,"ratio":130},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    280,
            "requiresTech":     ["United Earth Base","Galactic Imperialism","Tall Construction","Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       15,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     {"resource":"Rum","rate":30},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":35,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    50,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     50000000,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    6,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Space Elevator",
            "tile":             ["elevator"],
            "cost":             [{"resource":"Ore","amount":10000},{"resource":"Steel","amount":45000},{"resource":"Gold","amount":15000},{"resource":"Oil","amount":300},{"resource":"Plastic","amount":9000},{"resource":"Microchip","amount":5000},{"resource":"Robot","amount":50}],
            "description":      "elevator-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     3000,
            "generateAmount":   20,
            "tileWidth":        7,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":3000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":2500},{"resource":"Oil","amount":50},{"resource":"Microchip","amount":12}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":900}],
            "colGenRate":       4000,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   30,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    200,
            "requiresTech":     ["United Earth Base","Tall Construction","Galactic Commerce","Solar Governance","Advanced Robotics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Food","Water","Sugar","Rum","Wool","Wood","Clay","Charcoal","Regolith","Ore","Ant Paste","Steel","Antanium","Gold","Aluminum","Oil","Helium 3","Toy","Uranium","Cloth","Pottery","Bricks","Microchip","Robot","Alien Artifact","Plastic"],
            "canExport":        ["Food","Water","Sugar","Rum","Wool","Wood","Clay","Charcoal","Regolith","Ore","Ant Paste","Steel","Antanium","Gold","Aluminum","Oil","Helium 3","Toy","Uranium","Cloth","Pottery","Bricks","Microchip","Robot","Alien Artifact","Plastic"],
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        "elevator.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Oil","rate":6000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Economy","Immigration"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    10000,
            "upkeepCost":       0.0,
            "giftCapacity":     10000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Robot Factory",
            "tile":             ["robofactory"],
            "cost":             [{"resource":"Ore","amount":2000},{"resource":"Water","amount":800},{"resource":"Steel","amount":9000},{"resource":"Gold","amount":2000},{"resource":"Aluminum","amount":2000},{"resource":"Plastic","amount":2000},{"resource":"Microchip","amount":9000},{"resource":"Software","amount":1000}],
            "description":      "robofactory-description",
            "produces":         ["Construction Drone","Turbo Drone"],
            "generates":        "Atmosphere",
            "generateTime":     5000,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Robot","amount":1000}],
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":300},{"resource":"Microchip","amount":4}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":600}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   30,
            "requiresWorkers":  true,
            "smelts":           {"input":"Aluminum,Software","output":"Robot","time":9000,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    300,
            "requiresTech":     ["Advanced Robotics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       "Scientist",
            "indicator":        "robofactory.png",
            "canUpgradeTo":     "Advanced Robotics Inc.",
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Microchip","rate":2000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Residential Tower",
            "tile":             ["restower"],
            "cost":             [{"resource":"Ore","amount":18000},{"resource":"Steel","amount":85000},{"resource":"Gold","amount":10000},{"resource":"Aluminum","amount":2500},{"resource":"Pottery","amount":1500},{"resource":"Cloth","amount":1500},{"resource":"Plastic","amount":2500},{"resource":"Toy","amount":1100},{"resource":"Robot","amount":10},{"resource":"Microchip","amount":400}],
            "description":      "restower-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     3000,
            "generateAmount":   400,
            "tileWidth":        2,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":       [{"resource":"Ore","amount":5000},{"resource":"Steel","amount":8000},{"resource":"Gold","amount":800},{"resource":"Aluminum","amount":40},{"resource":"Pottery","amount":10},{"resource":"Cloth","amount":10},{"resource":"Plastic","amount":5},{"resource":"Toy","amount":6},{"resource":"Microchip","amount":4}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":390}],
            "colGenRate":       0,
            "providesShelter":  1100,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    350,
            "requiresTech":     ["Tall Construction","Advanced Robotics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "restower.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Consulate Level 4",
            "tile":             ["consulate4"],
            "cost":             [{"resource":"Ore","amount":45000},{"resource":"Steel","amount":45000},{"resource":"Gold","amount":20000},{"resource":"Wood","amount":1500},{"resource":"Pottery","amount":1800},{"resource":"Microchip","amount":700},{"resource":"Civics","amount":2500}],
            "description":      "consulate3-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1500,
            "generateAmount":   8,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":400},{"resource":"Steel","amount":450},{"resource":"Gold","amount":200},{"resource":"Wood","amount":15},{"resource":"Pottery","amount":18},{"resource":"Microchip","amount":7}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":4}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   9,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    18,
            "requiresTech":     ["United Earth Base","Nationalism","Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        null,
            "canUpgradeTo":     "Consulate Level 5",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      true,
            "isEmbassy":        false,
            "buildLimit":       1,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     300000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    4,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Money Pit",
            "tile":             ["moneypit"],
            "cost":             [{"resource":"Money","amount":1500},{"resource":"Ore","amount":1500},{"resource":"Antanium","amount":1800},{"resource":"Gold","amount":1800},{"resource":"Civics","amount":250}],
            "description":      "moneypit-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1800,
            "generateAmount":   2,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Gold","amount":5000}],
            "sellValue":        [{"resource":"Money","amount":200},{"resource":"Ore","amount":800},{"resource":"Antanium","amount":800},{"resource":"Gold","amount":900}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Money","time":8000,"ratio":7},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     ["Advanced Digging","Communal Finance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "moneypit.png",
            "canUpgradeTo":     "Obelisk of Plenty",
            "transModeColor":   "#8BC34A",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Export Cannon",
            "tile":             ["exportcannon"],
            "cost":             [{"resource":"Ore","amount":5000},{"resource":"Ant Paste","amount":1500},{"resource":"Antanium","amount":4000},{"resource":"Gold","amount":2000}],
            "description":      "exportcannon-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     3000,
            "generateAmount":   4,
            "tileWidth":        3,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":2600},{"resource":"Antanium","amount":1000},{"resource":"Gold","amount":1100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":30}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   3,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    70,
            "requiresTech":     ["Communal Finance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        ["Food","Water","Sugar","Rum","Ant Paste","Ore","Antanium","Gold"],
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "exportcannon.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    100,
            "upkeepCost":       0.0,
            "giftCapacity":     100,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Lumber Yard",
            "tile":             ["lumberyard"],
            "cost":             [{"resource":"Ore","amount":3200},{"resource":"Water","amount":500},{"resource":"Wood","amount":900},{"resource":"Steel","amount":1600},{"resource":"Gold","amount":300},{"resource":"Aluminum","amount":200},{"resource":"Microchip","amount":8}],
            "description":      "lumberyard-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     4000,
            "generateAmount":   2,
            "tileWidth":        2,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wood","amount":60000}],
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Water","amount":200},{"resource":"Wood","amount":800},{"resource":"Steel","amount":400},{"resource":"Gold","amount":100},{"resource":"Aluminum","amount":100},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          [{"input":"Wood","output":"Wood"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":5}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Colonial Finance Theory"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        "lumberyard.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "House of Horror",
            "tile":             ["horrorhouse"],
            "cost":             [{"resource":"Steel","amount":1750},{"resource":"Aluminum","amount":150},{"resource":"Ore","amount":4000},{"resource":"Plastic","amount":50},{"resource":"Gold","amount":2000},{"resource":"Microchip","amount":50},{"resource":"Toy","amount":50}],
            "description":      "horrorhouse-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wood","amount":60000}],
            "sellValue":        [{"resource":"Steel","amount":175},{"resource":"Aluminum","amount":15},{"resource":"Ore","amount":400},{"resource":"Plastic","amount":5},{"resource":"Gold","amount":200},{"resource":"Microchip","amount":5}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":8}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       10,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       "Blue Collar",
            "indicator":        "horrorhouse.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Toy","rate":600},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Tourism"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":2,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    5,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Regolith Extraction Inc",
            "tile":             ["regolithextractor"],
            "cost":             [{"resource":"Money","amount":3000},{"resource":"Ore","amount":2500},{"resource":"Steel","amount":4000},{"resource":"Aluminum","amount":2000},{"resource":"Water","amount":5000},{"resource":"Microchip","amount":150}],
            "description":      "regolithextractor-description",
            "produces":         null,
            "generates":        "Regolith",
            "generateTime":     1500,
            "generateAmount":   50,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Money","amount":1000},{"resource":"Ore","amount":1000},{"resource":"Steel","amount":200},{"resource":"Aluminum","amount":50},{"resource":"Microchip","amount":10}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   26,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    20,
            "requiresTech":     ["Lunar Base|Abandoned World Base|Asteroid Base","Advanced Ore Purification","Advanced Small Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       "Blue Collar",
            "indicator":        "regolithextractor.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Investment Bank",
            "tile":             ["bank2"],
            "cost":             [{"resource":"Money","amount":2500000},{"resource":"Water","amount":40000},{"resource":"Ore","amount":300000},{"resource":"Steel","amount":400000},{"resource":"Gold","amount":800000},{"resource":"Oil","amount":12000},{"resource":"Wood","amount":45000},{"resource":"Cloth","amount":32000},{"resource":"Bricks","amount":11000},{"resource":"Pottery","amount":60000},{"resource":"Plastic","amount":50000},{"resource":"Aluminum","amount":25000},{"resource":"Microchip","amount":75000},{"resource":"Civics","amount":10000}],
            "description":      "bank2-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1500,
            "generateAmount":   6,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Gold","amount":500000}],
            "sellValue":        [{"resource":"Money","amount":250000},{"resource":"Water","amount":1800},{"resource":"Ore","amount":16000},{"resource":"Steel","amount":12000},{"resource":"Gold","amount":50000},{"resource":"Cloth","amount":1500},{"resource":"Bricks","amount":2000},{"resource":"Aluminum","amount":1800},{"resource":"Microchip","amount":50}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":360}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   500,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Money","time":5000,"ratio":20},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    500,
            "requiresTech":     ["Galactic Finance Theory","Tall Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "White Collar",
            "indicator":        "bank2.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#8BC34A",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Steel Yard",
            "tile":             ["steelyard"],
            "cost":             [{"resource":"Ore","amount":5000},{"resource":"Steel","amount":1000},{"resource":"Gold","amount":500}],
            "description":      "steelyard-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     6000,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Steel","amount":100000},{"resource":"Antanium","amount":100000},{"resource":"Triantanium","amount":100000},{"resource":"Aluminum","amount":100000}],
            "sellValue":        [{"resource":"Ore","amount":1000},{"resource":"Steel","amount":400},{"resource":"Gold","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   2,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    40,
            "requiresTech":     ["Colonial Finance Theory","Advanced Ore Purification","Advanced Small Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        "steelyard.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Subterranean Charcoal Cavern",
            "tile":             ["subtcharcoal"],
            "cost":             [{"resource":"Money","amount":20000},{"resource":"Ore","amount":2000},{"resource":"Helium 3","amount":2000},{"resource":"Gold","amount":20000},{"resource":"Wood","amount":2500},{"resource":"Steel","amount":10000},{"resource":"Plastic","amount":500},{"resource":"Microchip","amount":1000},{"resource":"Robot","amount":4}],
            "description":      "subtcharcoal-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Charcoal","amount":25000}],
            "sellValue":        [{"resource":"Ore","amount":300},{"resource":"Gold","amount":6000},{"resource":"Steel","amount":800},{"resource":"Microchip","amount":4}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":30}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   3,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    90,
            "requiresTech":     ["Deep Excavation"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "subtcharcoal.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#333333",
            "requiresFuel":     {"resource":"Helium 3","rate":5000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Altar of Commerce",
            "tile":             ["altarofcommerce"],
            "cost":             [{"resource":"Money","amount":3000},{"resource":"Ore","amount":4000},{"resource":"Water","amount":2000},{"resource":"Ant Paste","amount":3000},{"resource":"Antanium","amount":8000},{"resource":"Gold","amount":5000},{"resource":"Civics","amount":600}],
            "description":      "altarofcommerce-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     6000,
            "generateAmount":   20,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":1000},{"resource":"Antanium","amount":3000},{"resource":"Gold","amount":1000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":45}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   25,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    90,
            "requiresTech":     ["Zolarg Communications","Communal Finance"],
            "canRenderStatic":  false,
            "entertains":       30,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "altarofcommerce.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": true,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":2,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    500,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "High Command",
            "tile":             ["highcommand"],
            "cost":             [{"resource":"Money","amount":3500},{"resource":"Ore","amount":5000},{"resource":"Water","amount":1800},{"resource":"Ant Paste","amount":1000},{"resource":"Antanium","amount":10000},{"resource":"Gold","amount":7000},{"resource":"Civics","amount":3500}],
            "description":      "highcommand-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":1000},{"resource":"Ant Paste","amount":40},{"resource":"Antanium","amount":6000},{"resource":"Gold","amount":3000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":35}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   30,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":16000,"ratio":50},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    60,
            "requiresTech":     ["Insectoid Governance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "highcommand.png",
            "canUpgradeTo":     "Higher Command",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     4000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    2,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Supply Pile",
            "tile":             ["supplypile"],
            "cost":             [{"resource":"Ore","amount":1000},{"resource":"Antanium","amount":400},{"resource":"Gold","amount":25}],
            "description":      "supplypile-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wheel","amount":800},{"resource":"Obsidian","amount":800},{"resource":"Sugar","amount":2000},{"resource":"Food","amount":800},{"resource":"Water","amount":800},{"resource":"Steel","amount":800},{"resource":"Wool","amount":800},{"resource":"Rum","amount":800},{"resource":"Pottery","amount":800},{"resource":"Bricks","amount":800},{"resource":"Cloth","amount":800},{"resource":"Plastic","amount":800},{"resource":"Toy","amount":800},{"resource":"Microchip","amount":800},{"resource":"Alien Artifact","amount":800},{"resource":"Alien Relic","amount":800},{"resource":"Robot","amount":800},{"resource":"Ant Paste","amount":800},{"resource":"Antanium","amount":800},{"resource":"Wood","amount":800},{"resource":"Crystalline","amount":800},{"resource":"Diamond","amount":800},{"resource":"Triantanium","amount":800},{"resource":"Aluminum","amount":800},{"resource":"Uranium","amount":800},{"resource":"Gold","amount":800},{"resource":"Clay","amount":800},{"resource":"Ore","amount":2000},{"resource":"Regolith","amount":2000}],
            "sellValue":        [{"resource":"Ore","amount":400},{"resource":"Antanium","amount":200},{"resource":"Gold","amount":5}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Communal Finance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "supplypile.png",
            "canUpgradeTo":     "Quantum Supply Pile",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Durable Goods","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Pot of Ether",
            "tile":             ["potofether"],
            "cost":             [{"resource":"Ore","amount":20},{"resource":"Regolith","amount":20},{"resource":"Gold","amount":160}],
            "description":      "potofether-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ether","amount":900}],
            "sellValue":        [{"resource":"Ore","amount":6},{"resource":"Charcoal","amount":2},{"resource":"Steel","amount":15}],
            "sellWarning":      null,
            "refines":          [{"input":"Ether","output":"Ether"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Gold Storage"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#222222",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Quantum Supply Pile",
            "tile":             ["quantumsupplypile"],
            "cost":             [{"resource":"Ore","amount":1000},{"resource":"Antanium","amount":1400},{"resource":"Gold","amount":350},{"resource":"Aluminum","amount":1500},{"resource":"Alien Relic","amount":150},{"resource":"Alien Artifact","amount":25}],
            "description":      "quantumsupplypile-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ether","amount":20000},{"resource":"Wheel","amount":20000},{"resource":"Obsidian","amount":20000},{"resource":"Sugar","amount":20000},{"resource":"Food","amount":20000},{"resource":"Water","amount":20000},{"resource":"Steel","amount":20000},{"resource":"Wool","amount":20000},{"resource":"Rum","amount":20000},{"resource":"Pottery","amount":20000},{"resource":"Bricks","amount":20000},{"resource":"Cloth","amount":20000},{"resource":"Plastic","amount":20000},{"resource":"Toy","amount":20000},{"resource":"Microchip","amount":20000},{"resource":"Alien Artifact","amount":20000},{"resource":"Alien Relic","amount":20000},{"resource":"Robot","amount":20000},{"resource":"Ant Paste","amount":20000},{"resource":"Antanium","amount":20000},{"resource":"Wood","amount":20000},{"resource":"Crystalline","amount":20000},{"resource":"Diamond","amount":20000},{"resource":"Triantanium","amount":20000},{"resource":"Aluminum","amount":20000},{"resource":"Uranium","amount":20000},{"resource":"Gold","amount":20000},{"resource":"Clay","amount":20000},{"resource":"Ore","amount":20000},{"resource":"Regolith","amount":20000},{"resource":"Charcoal","amount":20000},{"resource":"Oil","amount":20000},{"resource":"Software","amount":20000}],
            "sellValue":        [{"resource":"Ore","amount":100},{"resource":"Antanium","amount":140},{"resource":"Gold","amount":35},{"resource":"Aluminum","amount":150}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":150}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    80,
            "requiresTech":     ["Ancient Alien Language"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Durable Goods","Storage","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Command Post",
            "tile":             ["commandpost"],
            "cost":             [{"resource":"Money","amount":1000},{"resource":"Ore","amount":3000},{"resource":"Water","amount":1200},{"resource":"Ant Paste","amount":1000},{"resource":"Antanium","amount":3500},{"resource":"Gold","amount":4000},{"resource":"Civics","amount":200}],
            "description":      "commandpost-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1500,
            "generateAmount":   3,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Antanium","amount":800},{"resource":"Gold","amount":1000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":6}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   5,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    60,
            "requiresTech":     ["Insectoid Governance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "commandpost.png",
            "canUpgradeTo":     "Advanced Command Post",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      true,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     2500,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    2,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Consulate Level 5",
            "tile":             ["consulate5"],
            "cost":             [{"resource":"Ore","amount":60000},{"resource":"Rum","amount":6000},{"resource":"Helium 3","amount":1500},{"resource":"Charcoal","amount":5000},{"resource":"Steel","amount":60000},{"resource":"Gold","amount":35000},{"resource":"Wood","amount":3000},{"resource":"Pottery","amount":2500},{"resource":"Microchip","amount":900},{"resource":"Civics","amount":3000}],
            "description":      "consulate5-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1500,
            "generateAmount":   10,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":25000},{"resource":"Charcoal","amount":15},{"resource":"Steel","amount":9000},{"resource":"Gold","amount":10000},{"resource":"Pottery","amount":8},{"resource":"Microchip","amount":6}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":6}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    26,
            "requiresTech":     ["United Earth Base","Imperialism","Large Scale Construction","Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      true,
            "isEmbassy":        false,
            "buildLimit":       1,
            "isCapitol":        false,
            "entertainmentCost":25,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    15,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     3000000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    5,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Small Stadium",
            "tile":             ["smstadium"],
            "cost":             [{"resource":"Ore","amount":2000},{"resource":"Steel","amount":2000},{"resource":"Gold","amount":3500},{"resource":"Food","amount":6000},{"resource":"Money","amount":5000},{"resource":"Water","amount":3000},{"resource":"Plastic","amount":250},{"resource":"Microchip","amount":450}],
            "description":      "smstadium-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        4,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":1000}],
            "sellValue":        [{"resource":"Ore","amount":600},{"resource":"Steel","amount":800},{"resource":"Gold","amount":1000},{"resource":"Plastic","amount":6},{"resource":"Microchip","amount":5}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   25,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    150,
            "requiresTech":     ["Advanced Small Scale Construction","Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       200,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "smstadium.png",
            "canUpgradeTo":     "Medium Stadium",
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Food","rate":2000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Tourism","Entertainment"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":20,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    25,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Colonimulation Hub",
            "tile":             ["colonimulation"],
            "cost":             [{"resource":"Ore","amount":2800},{"resource":"Steel","amount":2000},{"resource":"Microchip","amount":300},{"resource":"Software","amount":90},{"resource":"Plastic","amount":1500},{"resource":"Gold","amount":500},{"resource":"Aluminum","amount":500}],
            "description":      "colonimulation-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Software","amount":10}],
            "sellValue":        [{"resource":"Ore","amount":300},{"resource":"Aluminum","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":80},{"utility":"Bandwidth","amount":120}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   12,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Basic Network Infrastructure","Advanced Small Scale Construction","Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       50,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Software","rate":6000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Entertainment","Information Technology","Tourism"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":18,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    50,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Synthetic Textile Mill",
            "tile":             ["synthetictextiles"],
            "cost":             [{"resource":"Ore","amount":4000},{"resource":"Wood","amount":2500},{"resource":"Ant Paste","amount":1000},{"resource":"Clay","amount":2500},{"resource":"Bricks","amount":5000},{"resource":"Steel","amount":400},{"resource":"Antanium","amount":3000},{"resource":"Gold","amount":2000},{"resource":"Microchip","amount":75}],
            "description":      "synthtext-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wool","amount":400},{"resource":"Cloth","amount":400},{"resource":"Ant Paste","amount":400}],
            "sellValue":        [{"resource":"Ore","amount":800},{"resource":"Bricks","amount":800},{"resource":"Steel","amount":20},{"resource":"Antanium","amount":600},{"resource":"Gold","amount":600},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":30}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   16,
            "requiresWorkers":  true,
            "smelts":           {"input":"Wool","output":"Cloth","time":4000,"ratio":18},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    20,
            "requiresTech":     ["Low Gravity Masonry","Low Gravity Husbandry","Xenomaterials Research"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        "synthetictextiles.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Ant Paste","rate":300},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Durable Goods"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "LIS Lander",
            "tile":             ["lislander"],
            "cost":             null,
            "description":      "lislander-description",
            "produces":         ["LIS Rover","Tundra Rover"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wheel","amount":20},{"resource":"Food","amount":40},{"resource":"Water","amount":300},{"resource":"Wood","amount":300},{"resource":"Crystalline","amount":300},{"resource":"Ore","amount":1200},{"resource":"Regolith","amount":1200},{"resource":"Charcoal","amount":1200},{"resource":"Ether","amount":100},{"resource":"Sugar","amount":150}],
            "sellValue":        [{"resource":"Steel","amount":10},{"resource":"Gold","amount":2},{"resource":"Microchip","amount":2},{"resource":"Uranium","amount":1}],
            "sellWarning":      "lander-sell-warning",
            "refines":          [{"input":"Ether","output":"Ether"},{"input":"Crystalline","output":"Crystalline"},{"input":"Ore","output":"Ore"},{"input":"Water","output":"Water"},{"input":"Regolith","output":"Regolith"},{"input":"Wood","output":"Wood"},{"input":"Sugar","output":"Sugar"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":2}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  2,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["LIS Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "lislander.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  [],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    3,
                    "c":    "#FFF3E0",
                    "i":    0.25,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ancient Statue",
            "tile":             ["statue4"],
            "cost":             [{"resource":"Gold","amount":500},{"resource":"Alien Artifact","amount":1000}],
            "description":      "statue4-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Abandoned World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "statue4.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ancient Temple",
            "tile":             ["ancienttemple"],
            "cost":             [{"resource":"Gold","amount":5000},{"resource":"Alien Artifact","amount":10000}],
            "description":      "ancienttemple-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Abandoned World Base"],
            "canRenderStatic":  false,
            "entertains":       20,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "ancienttemple.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    30,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         10,
            "providesIQ":       90,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Medium Stadium",
            "tile":             ["medstadium"],
            "cost":             [{"resource":"Ore","amount":20000},{"resource":"Rum","amount":1000},{"resource":"Steel","amount":20000},{"resource":"Gold","amount":15000},{"resource":"Food","amount":12000},{"resource":"Money","amount":15000},{"resource":"Water","amount":8000},{"resource":"Plastic","amount":600},{"resource":"Microchip","amount":1000}],
            "description":      "medstadium-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        4,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":2000},{"resource":"Rum","amount":2000}],
            "sellValue":        [{"resource":"Ore","amount":6000},{"resource":"Steel","amount":8000},{"resource":"Gold","amount":3000},{"resource":"Plastic","amount":8},{"resource":"Microchip","amount":7}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":500}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   125,
            "requiresWorkers":  true,
            "smelts":           {"input":"Rum","output":"Money","time":1600,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    150,
            "requiresTech":     ["Tall Construction","Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       1000,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "medstadium.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Food","rate":1200},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Tourism","Entertainment"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":40,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    500,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -1,
                    "y":    -1,
                    "r":    1.4,
                    "c":    "#FFFDE7",
                    "i":    0.5,
                    "nightonly": true
                },
                {
                    "x":    2,
                    "y":    -1,
                    "r":    1.4,
                    "c":    "#FFFDE7",
                    "i":    0.5,
                    "nightonly": true
                },
                {
                    "x":    1,
                    "y":    1,
                    "r":    1.6,
                    "c":    "#FFFDE7",
                    "i":    0.2,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Grass Scrub",
            "tile":             ["grass2"],
            "cost":             [{"resource":"Water","amount":125}],
            "description":      "grass2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "grass2.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Yellow Sand",
            "tile":             ["sand2"],
            "cost":             [{"resource":"Ore","amount":2},{"resource":"Clay","amount":1}],
            "description":      "sand2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "sand2.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Orange Sand",
            "tile":             ["sand3"],
            "cost":             [{"resource":"Ore","amount":2},{"resource":"Clay","amount":1}],
            "description":      "sand3-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "sand3.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Mail Box",
            "tile":             ["mailbox"],
            "cost":             [{"resource":"Water","amount":125},{"resource":"Steel","amount":125}],
            "description":      "mailbox-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "mailbox.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Basket Ball Hoop",
            "tile":             ["hoops"],
            "cost":             [{"resource":"Water","amount":125},{"resource":"Steel","amount":500},{"resource":"Plastic","amount":100}],
            "description":      "hoops-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "hoops.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Quantum Oil Tank",
            "tile":             ["oiltank2"],
            "cost":             [{"resource":"Ore","amount":60},{"resource":"Charcoal","amount":80},{"resource":"Steel","amount":90},{"resource":"Aluminum","amount":500},{"resource":"Uranium","amount":800},{"resource":"Microchip","amount":2000},{"resource":"Alien Artifact","amount":70}],
            "description":      "oiltank2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Oil","amount":45000}],
            "sellValue":        [{"resource":"Ore","amount":12},{"resource":"Charcoal","amount":14},{"resource":"Steel","amount":25},{"resource":"Aluminum","amount":80},{"resource":"Uranium","amount":7},{"resource":"Microchip","amount":5},{"resource":"Alien Artifact","amount":1}],
            "sellWarning":      null,
            "refines":          [{"input":"Oil","output":"Oil"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":60}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    40,
            "requiresTech":     ["Ancient Alien Manufacturing","Alien Quantum Physics","Low Gravity Oil Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "oiltank2.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#222222",
            "requiresFuel":     {"resource":"Water","rate":3000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Storage","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "League of Independent States Flag",
            "tile":             ["flag5"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200},{"resource":"Gold","amount":500},{"resource":"Cloth","amount":250}],
            "description":      "flag5-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["LIS Base","Nationalism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "flag5.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Green House",
            "tile":             ["greenhome"],
            "cost":             [{"resource":"Wood","amount":250},{"resource":"Steel","amount":50},{"resource":"Microchip","amount":10},{"resource":"Pottery","amount":5}],
            "description":      "greenhome-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2600,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Wood","amount":120},{"resource":"Steel","amount":20},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  7,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     ["Advanced Small Scale Construction","Advanced Microbiology"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        "greenhome.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1.5,
                    "c":    "#FFF8E1",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Artificial Sweetner Factory",
            "tile":             ["sweetnerfactory"],
            "cost":             [{"resource":"Ore","amount":14500},{"resource":"Charcoal","amount":2000},{"resource":"Steel","amount":10000},{"resource":"Oil","amount":4000},{"resource":"Gold","amount":6500},{"resource":"Aluminum","amount":2200},{"resource":"Microchip","amount":1800}],
            "description":      "sweetnerfactory-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        4,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Sugar","amount":9000}],
            "sellValue":        [{"resource":"Ore","amount":6500},{"resource":"Steel","amount":4500},{"resource":"Gold","amount":2200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":100}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   30,
            "requiresWorkers":  true,
            "smelts":           {"input":"Oil","output":"Sugar","time":10000,"ratio":12},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    150,
            "requiresTech":     ["Large Scale Construction","Colonial Finance Theory","Low Gravity Manufacturing","Advanced Chemical Synthesis"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        "sweetnerfactory.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Aluminum","rate":1600},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Durable Goods"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ore Enrichment Facility",
            "tile":             ["oreenrichmentfacility"],
            "cost":             [{"resource":"Water","amount":200},{"resource":"Antanium","amount":900},{"resource":"Ant Paste","amount":1200},{"resource":"Gold","amount":950}],
            "description":      "oreenrichmentfacility-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Antanium","amount":300},{"resource":"Gold","amount":500}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":8}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   1,
            "requiresWorkers":  false,
            "smelts":           {"input":"Ore","output":"Ore","time":1000,"ratio":10},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     ["Antanium Production","Ore Enrichment"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "oreenrichmentfacility.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Golden Sign",
            "tile":             ["goldsign"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Antanium","amount":200},{"resource":"Gold","amount":500}],
            "description":      "goldsign-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Insectoid Governance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "goldsign.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           true,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Cactus 1",
            "tile":             ["cactus1"],
            "cost":             [{"resource":"Water","amount":2000}],
            "description":      "cactus-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Water","amount":2500}],
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "cactus1.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Cactus 2",
            "tile":             ["cactus2"],
            "cost":             [{"resource":"Water","amount":5000}],
            "description":      "cactus-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Water","amount":5500}],
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "cactus2.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Cactus 3",
            "tile":             ["cactus3"],
            "cost":             [{"resource":"Water","amount":500}],
            "description":      "cactus3-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "cactus3.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Palm 1",
            "tile":             ["palm1"],
            "cost":             [{"resource":"Water","amount":75}],
            "description":      "palm-description",
            "produces":         null,
            "generates":        "Food",
            "generateTime":     7000,
            "generateAmount":   15,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Wood","amount":15}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "palm1.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Palm 2",
            "tile":             ["palm2"],
            "cost":             [{"resource":"Water","amount":100}],
            "description":      "palm-description",
            "produces":         null,
            "generates":        "Food",
            "generateTime":     7000,
            "generateAmount":   30,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Wood","amount":30}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "palm2.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Sand Dune",
            "tile":             ["dune"],
            "cost":             [{"resource":"Ore","amount":500}],
            "description":      "dune-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "dune.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Deck Chairs",
            "tile":             ["deckchairs"],
            "cost":             [{"resource":"Ore","amount":500},{"resource":"Wood","amount":500},{"resource":"Plastic","amount":50}],
            "description":      "deckchairs-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "deckchairs.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Desert Skull",
            "tile":             ["desertskull"],
            "cost":             [{"resource":"Ore","amount":1000}],
            "description":      "desertskull-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "desertskull.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Fountain",
            "tile":             ["fountain"],
            "cost":             [{"resource":"Ore","amount":1500},{"resource":"Steel","amount":2500},{"resource":"Water","amount":1000}],
            "description":      "fountain-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        "fountain.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Lumber Camp",
            "tile":             ["lumbercamp"],
            "cost":             [{"resource":"Ore","amount":1500},{"resource":"Antanium","amount":900},{"resource":"Gold","amount":1000},{"resource":"Ant Paste","amount":1200}],
            "description":      "lumbercamp-description",
            "produces":         ["Lumberbug"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wood","amount":1000}],
            "sellValue":        [{"resource":"Ore","amount":600},{"resource":"Antanium","amount":400},{"resource":"Gold","amount":400}],
            "sellWarning":      null,
            "refines":          [{"input":"Wood","output":"Wood"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":5}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Wood Harvesting"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "lumbercamp.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Smoldering Pit",
            "tile":             ["smolderingpit"],
            "cost":             [{"resource":"Ore","amount":100},{"resource":"Wood","amount":250},{"resource":"Sugar","amount":50}],
            "description":      "smolderingpit-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Sugar","amount":400},{"resource":"Wood","amount":400},{"resource":"Charcoal","amount":100}],
            "sellValue":        [{"resource":"Ore","amount":600},{"resource":"Antanium","amount":400},{"resource":"Gold","amount":400}],
            "sellWarning":      null,
            "refines":          [{"input":"Wood","output":"Wood"},{"input":"Sugar","output":"Sugar"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   2,
            "requiresWorkers":  false,
            "smelts":           {"input":"Wood,Sugar","output":"Charcoal","time":800,"ratio":2},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Wood Harvesting"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Presidential Statue",
            "tile":             ["statue5"],
            "cost":             [{"resource":"Ore","amount":400},{"resource":"Steel","amount":400},{"resource":"Aluminum","amount":200},{"resource":"Gold","amount":1800}],
            "description":      "statue5-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    3,
            "requiresTech":     ["United Earth Base","Nationalism","Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       5,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "statue5.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            1,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    8,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           true,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Diamond Refinery",
            "tile":             ["diamondrefinery"],
            "cost":             [{"resource":"Ore","amount":1200}],
            "description":      "diamondrefinery-description",
            "produces":         ["Diamond Miner"],
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Diamond","amount":3000}],
            "sellValue":        [{"resource":"Ore","amount":500}],
            "sellWarning":      null,
            "refines":          [{"input":"Diamond","output":"Diamond"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":8}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   3,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     ["Diamond Mining","Asteroid Base|Ice World Base|Lava World Base|Desert World Base|Water World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        "diamondrefinery.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Colonial Assembly",
            "tile":             ["colonialassembly"],
            "cost":             [{"resource":"Ore","amount":12000},{"resource":"Steel","amount":12000},{"resource":"Gold","amount":6000},{"resource":"Microchip","amount":100},{"resource":"Civics","amount":400}],
            "description":      "colonialassembly-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1500,
            "generateAmount":   4,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":6000},{"resource":"Steel","amount":6000},{"resource":"Gold","amount":2000},{"resource":"Microchip","amount":3}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":6}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    5,
            "requiresTech":     ["LIS Base","Colonial Civics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        "colonialassembly.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      true,
            "isEmbassy":        false,
            "buildLimit":       1,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     2500,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    2,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Cybercoin Mine",
            "tile":             ["cybercoinmine"],
            "cost":             [{"resource":"Regolith","amount":4000},{"resource":"Ore","amount":1000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":900},{"resource":"Microchip","amount":50}],
            "description":      "cybercoinmine-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     2000,
            "generateAmount":   18,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Regolith","amount":2600},{"resource":"Steel","amount":2000},{"resource":"Gold","amount":800}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":50},{"utility":"Bandwidth","amount":35}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   5,
            "requiresWorkers":  true,
            "smelts":           {"input":"Microchip","output":"Money","time":1500,"ratio":150},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    80,
            "requiresTech":     ["LIS Base","Black Markets","Basic Network Infrastructure"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Economy","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Black Market Bazzar",
            "tile":             ["bmbazzar"],
            "cost":             [{"resource":"Regolith","amount":6000},{"resource":"Ore","amount":1000},{"resource":"Steel","amount":4000},{"resource":"Gold","amount":2500}],
            "description":      "bmbazzar-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     3500,
            "generateAmount":   5,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Regolith","amount":2600},{"resource":"Steel","amount":2000},{"resource":"Gold","amount":1100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":20}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   5,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Wheel|Food|Water|Rum|Wool|Wood|Cloth|Clay|Sugar|Ant Paste|Charcoal|Regolith|Ore|Steel|Antanium|Diamond|Gold|Aluminum|Oil|Helium 3|Plastic|Toy|Uranium|Pottery|Bricks|Microchip|Robot|Alien Artifact|Crystalline|Alien Relic|Ancient Instructions|Obsidian|Painting","time":7000,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    80,
            "requiresTech":     ["LIS Base","Black Markets"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Food","Water","Rum","Wool","Wood","Cloth","Clay","Sugar","Ant Paste","Charcoal","Regolith","Ore","Steel","Antanium","Diamond","Gold","Aluminum","Oil","Helium 3","Plastic","Toy","Uranium","Pottery","Bricks","Microchip","Robot","Alien Artifact","Crystalline"],
            "canExport":        ["Food","Water","Rum","Wool","Wood","Cloth","Clay","Sugar","Ant Paste","Charcoal","Regolith","Ore","Steel","Antanium","Diamond","Gold","Aluminum","Oil","Helium 3","Plastic","Toy","Uranium","Pottery","Bricks","Microchip","Robot","Alien Artifact","Crystalline"],
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        "bmbazzar.png",
            "canUpgradeTo":     "Online Black Market Office",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    250,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Online Black Market Office",
            "tile":             ["onlinebmoffice"],
            "cost":             [{"resource":"Regolith","amount":15000},{"resource":"Ore","amount":9000},{"resource":"Steel","amount":11000},{"resource":"Gold","amount":12000},{"resource":"Diamond","amount":2500},{"resource":"Microchip","amount":1500},{"resource":"Software","amount":150}],
            "description":      "onlinebmoffice-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     2500,
            "generateAmount":   10,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Regolith","amount":2600},{"resource":"Steel","amount":2000},{"resource":"Gold","amount":1100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":80},{"utility":"Bandwidth","amount":50}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money,Money,Software,Software,Software,Software","output":"Wheel|Food|Water|Rum|Wool|Wood|Cloth|Clay|Sugar|Ant Paste|Charcoal|Regolith|Ore|Steel|Antanium|Diamond|Gold|Aluminum|Oil|Helium 3|Plastic|Toy|Uranium|Pottery|Bricks|Microchip|Robot|Alien Artifact|Crystalline|Alien Relic|Ancient Instructions|Obsidian|Painting|Software|Triantanium","time":5000,"ratio":2},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    110,
            "requiresTech":     ["LIS Base","Black Markets","Proxy Servers"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Food","Water","Rum","Wool","Wood","Cloth","Clay","Sugar","Ant Paste","Charcoal","Regolith","Ore","Steel","Antanium","Diamond","Gold","Aluminum","Oil","Helium 3","Plastic","Toy","Uranium","Pottery","Bricks","Microchip","Robot","Alien Artifact","Crystalline","Ether","Software"],
            "canExport":        ["Food","Water","Rum","Wool","Wood","Cloth","Clay","Sugar","Ant Paste","Charcoal","Regolith","Ore","Steel","Antanium","Diamond","Gold","Aluminum","Oil","Helium 3","Plastic","Toy","Uranium","Pottery","Bricks","Microchip","Robot","Alien Artifact","Crystalline","Ether","Software"],
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Economy","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    5000,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Circuit Foundry",
            "tile":             ["cirfoundry"],
            "cost":             [{"resource":"Ore","amount":6500},{"resource":"Antanium","amount":4500},{"resource":"Ant Paste","amount":1000},{"resource":"Gold","amount":1000},{"resource":"Aluminum","amount":1000},{"resource":"Crystalline","amount":1000}],
            "description":      "cirfoundry-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Microchip","amount":1000}],
            "sellValue":        [{"resource":"Ore","amount":3000},{"resource":"Antanium","amount":2000},{"resource":"Gold","amount":300}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":60}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   26,
            "requiresWorkers":  true,
            "smelts":           {"input":"Gold,Aluminum,Crystalline","output":"Microchip","time":21000,"ratio":4},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    85,
            "requiresTech":     ["Basic Network Infrastructure"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     "Quantum Circuit Foundry",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Durable Goods","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Quantum Circuit Foundry",
            "tile":             ["quantumcirfoundry"],
            "cost":             [{"resource":"Ore","amount":14500},{"resource":"Antanium","amount":13500},{"resource":"Ant Paste","amount":3000},{"resource":"Gold","amount":3000},{"resource":"Aluminum","amount":12000},{"resource":"Crystalline","amount":1900},{"resource":"Microchip","amount":550},{"resource":"Alien Relic","amount":150},{"resource":"Alien Artifact","amount":25}],
            "description":      "quantumcirfoundry-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Microchip","amount":5000}],
            "sellValue":        [{"resource":"Ore","amount":3000},{"resource":"Antanium","amount":2000},{"resource":"Gold","amount":300}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":400},{"utility":"Bandwidth","amount":40}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   28,
            "requiresWorkers":  true,
            "smelts":           {"input":"Gold,Aluminum,Crystalline","output":"Microchip","time":5000,"ratio":10},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    150,
            "requiresTech":     ["Insectoid Mind Network","Ancient Alien Language"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Durable Goods","Information Technology","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Aluminum Hive",
            "tile":             ["aluminumhive"],
            "cost":             [{"resource":"Ore","amount":1200},{"resource":"Wood","amount":500},{"resource":"Antanium","amount":4000},{"resource":"Gold","amount":850},{"resource":"Ant Paste","amount":1200}],
            "description":      "aluminumhive-description",
            "produces":         ["Alumibug"],
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Aluminum","amount":15000}],
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Antanium","amount":1200},{"resource":"Gold","amount":300}],
            "sellWarning":      null,
            "refines":          [{"input":"Aluminum","output":"Aluminum"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":40}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   13,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Advanced Metallurgy"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "aluminumhive.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Jewelry Store",
            "tile":             ["jewelrystore"],
            "cost":             [{"resource":"Steel","amount":1000},{"resource":"Gold","amount":1000},{"resource":"Diamond","amount":100}],
            "description":      "jewelrystore-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Steel","amount":500},{"resource":"Gold","amount":350},{"resource":"Diamond","amount":80}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":10}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   3,
            "requiresWorkers":  true,
            "smelts":           {"input":"Diamond","output":"Money","time":2500,"ratio":400},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    20,
            "requiresTech":     ["Colonial Finance Theory"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "jewelrystore.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Independence Hall",
            "tile":             ["independencehall"],
            "cost":             [{"resource":"Ore","amount":35000},{"resource":"Rum","amount":1500},{"resource":"Diamond","amount":1500},{"resource":"Water","amount":3000},{"resource":"Regolith","amount":25000},{"resource":"Steel","amount":16000},{"resource":"Gold","amount":12000},{"resource":"Aluminum","amount":3000},{"resource":"Microchip","amount":1200},{"resource":"Civics","amount":5000}],
            "description":      "independencehall-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        5,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":8000},{"resource":"Diamond","amount":1000},{"resource":"Regolith","amount":500},{"resource":"Steel","amount":7000},{"resource":"Gold","amount":6000},{"resource":"Aluminum","amount":600},{"resource":"Microchip","amount":12}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":55}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   60,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":14000,"ratio":65},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    60,
            "requiresTech":     ["LIS Base","Colonial Finance Theory","Colonial Civics","Large Scale Construction","Self Governance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        "independencehall.png",
            "canUpgradeTo":     "Independence Hall Level 2",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     15000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    3,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "League Trade Authority",
            "tile":             ["leaguetrade"],
            "cost":             [{"resource":"Money","amount":15000},{"resource":"Ore","amount":10000},{"resource":"Water","amount":900},{"resource":"Wood","amount":400},{"resource":"Steel","amount":9000},{"resource":"Gold","amount":5000},{"resource":"Aluminum","amount":850},{"resource":"Microchip","amount":1400},{"resource":"Civics","amount":2000}],
            "description":      "leaguetrade-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     3000,
            "generateAmount":   20,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Money","amount":10000},{"resource":"Ore","amount":3500},{"resource":"Wood","amount":50},{"resource":"Steel","amount":1400},{"resource":"Gold","amount":900},{"resource":"Aluminum","amount":250},{"resource":"Microchip","amount":15}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":80}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   35,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    90,
            "requiresTech":     ["LIS Base","Large Scale Construction","Galactic Commerce","Long Range Communications"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "White Collar",
            "indicator":        "leaguetrade.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": true,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    500,
            "upkeepCost":       0.0,
            "giftCapacity":     500,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Antanium Synthesis Lab",
            "tile":             ["antsynth"],
            "cost":             [{"resource":"Ore","amount":4500},{"resource":"Steel","amount":4000},{"resource":"Gold","amount":4500},{"resource":"Microchip","amount":60}],
            "description":      "antsynth-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     1000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Antanium","amount":100}],
            "sellValue":        [{"resource":"Ore","amount":2200},{"resource":"Steel","amount":1400},{"resource":"Gold","amount":2100},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1000}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   3,
            "requiresWorkers":  true,
            "smelts":           {"input":"Aluminum,Sugar","output":"Antanium","time":1200,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    600,
            "requiresTech":     ["Antanium Synthesis","Advanced Robotics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        "antsynth.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Robot","rate":600},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Quantum Distillery",
            "tile":             ["quantumdistillery"],
            "cost":             [{"resource":"Water","amount":200},{"resource":"Ore","amount":600},{"resource":"Steel","amount":200},{"resource":"Aluminum","amount":500},{"resource":"Uranium","amount":800},{"resource":"Microchip","amount":2000},{"resource":"Alien Artifact","amount":45}],
            "description":      "quantumdistillery-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Rum","amount":500}],
            "sellValue":        [{"resource":"Water","amount":20},{"resource":"Ore","amount":80},{"resource":"Steel","amount":6}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":900}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   2,
            "requiresWorkers":  true,
            "smelts":           {"input":"Food","output":"Rum","time":1000,"ratio":500},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    40,
            "requiresTech":     ["Microgravity Brewing","Ancient Alien Manufacturing","Alien Quantum Physics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "quantumdistillery.png",
            "canUpgradeTo":     null,
            "transModeColor":   "#b38600",
            "requiresFuel":     {"resource":"Water","rate":800},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Durable Goods","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Yellow House",
            "tile":             ["yellowhouse"],
            "cost":             [{"resource":"Wood","amount":250},{"resource":"Steel","amount":50},{"resource":"Microchip","amount":10},{"resource":"Pottery","amount":5}],
            "description":      "yellowhouse-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2600,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Wood","amount":120},{"resource":"Steel","amount":20},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  7,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     ["Advanced Small Scale Construction","Advanced Microbiology"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        "yellowhouse.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1.5,
                    "c":    "#FFF8E1",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Center for Artificial Learning",
            "tile":             ["centerai"],
            "cost":             [{"resource":"Ore","amount":10000},{"resource":"Charcoal","amount":10000},{"resource":"Regolith","amount":10000},{"resource":"Wood","amount":10000},{"resource":"Antanium","amount":2000},{"resource":"Steel","amount":20000},{"resource":"Gold","amount":6000},{"resource":"Aluminum","amount":6000},{"resource":"Plastic","amount":15000},{"resource":"Microchip","amount":60000},{"resource":"Robot","amount":10000},{"resource":"Alien Artifact","amount":2000}],
            "description":      "centerai-description",
            "produces":         null,
            "generates":        "Ancient Instructions",
            "generateTime":     50000,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Alien Artifact","amount":800},{"resource":"Microchip","amount":800},{"resource":"Robot","amount":800},{"resource":"Alien Relic","amount":800},{"resource":"Ancient Instructions","amount":1000}],
            "sellValue":        [{"resource":"Ore","amount":750},{"resource":"Regolith","amount":50},{"resource":"Antanium","amount":100},{"resource":"Steel","amount":600},{"resource":"Gold","amount":2000},{"resource":"Aluminum","amount":2000},{"resource":"Plastic","amount":20},{"resource":"Microchip","amount":600},{"resource":"Alien Artifact","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   250,
            "requiresWorkers":  true,
            "smelts":           {"input":"Robot","output":"Research","time":2000,"ratio":550},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2000,
            "requiresTech":     ["Artificial Intelligence","Tall Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Alien Artifact"],
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Scientist",
            "indicator":        "centerai.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Microchip,Alien Artifact","rate":800},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Research"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       110,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Triantanium Refinery",
            "tile":             ["triantrefine"],
            "cost":             [{"resource":"Ore","amount":5000},{"resource":"Steel","amount":6000},{"resource":"Antanium","amount":3000},{"resource":"Gold","amount":6000},{"resource":"Microchip","amount":8000},{"resource":"Plastic","amount":15000},{"resource":"Bricks","amount":1000},{"resource":"Robot","amount":2500},{"resource":"Alien Artifact","amount":2000}],
            "description":      "triantrefine-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Triantanium","amount":100}],
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Steel","amount":600},{"resource":"Antanium","amount":1000},{"resource":"Gold","amount":600},{"resource":"Microchip","amount":8},{"resource":"Plastic","amount":300},{"resource":"Bricks","amount":25},{"resource":"Robot","amount":3},{"resource":"Alien Artifact","amount":20}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1600}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Antanium,Uranium","output":"Triantanium","time":2000,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    600,
            "requiresTech":     ["Antanium Compounds","Advanced Robotics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Transcendent Triantanium Generator",
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Robot","rate":600},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Transcendent Triantanium Generator",
            "tile":             ["transtri"],
            "cost":             [{"resource":"Ore","amount":50000},{"resource":"Steel","amount":60000},{"resource":"Antanium","amount":30000},{"resource":"Gold","amount":60000},{"resource":"Uranium","amount":5000},{"resource":"Microchip","amount":80000},{"resource":"Plastic","amount":150000},{"resource":"Bricks","amount":2000},{"resource":"Robot","amount":5500},{"resource":"Alien Artifact","amount":2500},{"resource":"Alien Relic","amount":2500},{"resource":"Ancient Instructions","amount":2500}],
            "description":      "transtri-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Triantanium","amount":500}],
            "sellValue":        [{"resource":"Ore","amount":5000},{"resource":"Steel","amount":6000},{"resource":"Antanium","amount":3000},{"resource":"Ant Paste","amount":2000},{"resource":"Gold","amount":6000},{"resource":"Microchip","amount":80},{"resource":"Plastic","amount":15000},{"resource":"Bricks","amount":200},{"resource":"Robot","amount":55},{"resource":"Alien Artifact","amount":200},{"resource":"Alien Relic","amount":250},{"resource":"Ancient Instructions","amount":250}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":12000}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Antanium,Uranium","output":"Triantanium","time":2000,"ratio":25},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    600,
            "requiresTech":     ["Antanium Compounds","Transcendence"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "The Shanty",
            "tile":             ["theshanty"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Steel","amount":50},{"resource":"Gold","amount":20},{"resource":"Wood","amount":1000},{"resource":"Microchip","amount":20},{"resource":"Pottery","amount":20}],
            "description":      "theshanty-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":6}],
            "colGenRate":       0,
            "providesShelter":  3,
            "canChain":         false,
            "acceptsWorkers":   3,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["United Earth Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Diplomat",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        true,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "The Functional",
            "tile":             ["thefunctional"],
            "cost":             [{"resource":"Ore","amount":3500},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":1000},{"resource":"Wood","amount":100},{"resource":"Microchip","amount":80},{"resource":"Pottery","amount":30},{"resource":"Plastic","amount":900},{"resource":"Rum","amount":300}],
            "description":      "thefunctional-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":16}],
            "colGenRate":       0,
            "providesShelter":  18,
            "canChain":         false,
            "acceptsWorkers":   18,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["United Earth Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Diplomat",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        true,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "The Goldman",
            "tile":             ["thegoldman"],
            "cost":             [{"resource":"Ore","amount":3000},{"resource":"Charcoal","amount":3000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":6000},{"resource":"Wood","amount":100},{"resource":"Microchip","amount":100},{"resource":"Pottery","amount":50},{"resource":"Plastic","amount":1500},{"resource":"Rum","amount":1000}],
            "description":      "thegoldman-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":25}],
            "colGenRate":       0,
            "providesShelter":  25,
            "canChain":         false,
            "acceptsWorkers":   25,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["United Earth Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Diplomat",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        true,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Exomound",
            "tile":             ["exomound"],
            "cost":             [{"resource":"Ore","amount":300},{"resource":"Sugar","amount":300},{"resource":"Food","amount":30},{"resource":"Ant Paste","amount":60},{"resource":"Wood","amount":100}],
            "description":      "exomound-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":10}],
            "colGenRate":       0,
            "providesShelter":  25,
            "canChain":         false,
            "acceptsWorkers":   25,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Zolarg Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        true,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Diplomatic Outpost",
            "tile":             ["diplomaticoutpost"],
            "cost":             [{"resource":"Ore","amount":3500},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":1000},{"resource":"Wood","amount":100},{"resource":"Microchip","amount":80},{"resource":"Pottery","amount":30},{"resource":"Plastic","amount":900},{"resource":"Rum","amount":300}],
            "description":      "diplomaticoutpost-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":16}],
            "colGenRate":       0,
            "providesShelter":  18,
            "canChain":         false,
            "acceptsWorkers":   18,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["LIS Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Diplomat",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        true,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "The Crystalline",
            "tile":             ["thecrystalline"],
            "cost":             [{"resource":"Ore","amount":3500},{"resource":"Steel","amount":3500},{"resource":"Gold","amount":5000},{"resource":"Wood","amount":400},{"resource":"Microchip","amount":120},{"resource":"Pottery","amount":60},{"resource":"Plastic","amount":2000},{"resource":"Rum","amount":1200},{"resource":"Triantanium","amount":200}],
            "description":      "thecrystalline-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":40}],
            "colGenRate":       0,
            "providesShelter":  40,
            "canChain":         false,
            "acceptsWorkers":   40,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["United Earth Base|LIS Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Diplomat",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        true,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "The Sunrise",
            "tile":             ["thesunrise"],
            "cost":             [{"resource":"Ore","amount":4000},{"resource":"Steel","amount":4000},{"resource":"Gold","amount":9000},{"resource":"Wood","amount":600},{"resource":"Microchip","amount":180},{"resource":"Pottery","amount":100},{"resource":"Plastic","amount":5000},{"resource":"Rum","amount":1800},{"resource":"Antanium","amount":5000}],
            "description":      "thesunrise-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":50}],
            "colGenRate":       0,
            "providesShelter":  50,
            "canChain":         false,
            "acceptsWorkers":   50,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["United Earth Base|LIS Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Diplomat",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        true,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Shrine of Truth",
            "tile":             ["shrineoftruth"],
            "cost":             [{"resource":"Ore","amount":3500},{"resource":"Antanium","amount":3500},{"resource":"Gold","amount":5000},{"resource":"Wood","amount":400},{"resource":"Ant Paste","amount":120},{"resource":"Water","amount":60},{"resource":"Sugar","amount":2000},{"resource":"Rum","amount":1200}],
            "description":      "shrineoftruth-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":40}],
            "colGenRate":       0,
            "providesShelter":  40,
            "canChain":         false,
            "acceptsWorkers":   40,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Zolarg Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        true,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Transmission Hub",
            "tile":             ["transmissionhub"],
            "cost":             [{"resource":"Ore","amount":1500},{"resource":"Steel","amount":100},{"resource":"Gold","amount":100},{"resource":"Microchip","amount":3}],
            "description":      "transmissionhub-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     4000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":600},{"resource":"Steel","amount":20},{"resource":"Gold","amount":20}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":12}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Long Range Communications"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   true,
            "buildCategories":  ["All Buildings","Government","Research"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Advanced Robotics Inc.",
            "tile":             ["robofactory2"],
            "cost":             [{"resource":"Ore","amount":20000},{"resource":"Water","amount":8000},{"resource":"Steel","amount":30000},{"resource":"Gold","amount":20000},{"resource":"Aluminum","amount":8000},{"resource":"Plastic","amount":8000},{"resource":"Microchip","amount":45000},{"resource":"Triantanium","amount":3000},{"resource":"Software","amount":8000}],
            "description":      "robofactory2-description",
            "produces":         ["Construction Drone","Turbo Drone"],
            "generates":        "Money",
            "generateTime":     10000,
            "generateAmount":   25,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Robot","amount":10000}],
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":300},{"resource":"Microchip","amount":4}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3000}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   700,
            "requiresWorkers":  true,
            "smelts":           {"input":"Aluminum,Software","output":"Robot","time":6000,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    3000,
            "requiresTech":     ["Advanced Robotics","Antanium Compounds","Tall Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Microchip","rate":20},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Aluminum Mine",
            "tile":             ["alummine"],
            "cost":             [{"resource":"Ore","amount":800},{"resource":"Wood","amount":800},{"resource":"Ant Paste","amount":2000},{"resource":"Antanium","amount":2000}],
            "description":      "alummine-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Aluminum Mine",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Insectoid Base","Advanced Metallurgy"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "alummine.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Megatree",
            "tile":             ["megatree"],
            "cost":             [{"resource":"Water","amount":200},{"resource":"Ant Paste","amount":200},{"resource":"Sugar","amount":100}],
            "description":      "megatree-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Megatree",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Plant Genetics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        "megatree.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Deep Space Transceiver",
            "tile":             ["deeptrans"],
            "cost":             [{"resource":"Ore","amount":1500},{"resource":"Antanium","amount":100},{"resource":"Gold","amount":100},{"resource":"Ant Paste","amount":500}],
            "description":      "deeptrans-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     4000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":600},{"resource":"Antanium","amount":20},{"resource":"Gold","amount":20}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":12}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Zolarg Communications"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   true,
            "buildCategories":  ["All Buildings","Government","Research"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Tower of Truth",
            "tile":             ["toweroftruth"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Antanium","amount":200},{"resource":"Gold","amount":2500},{"resource":"Ant Paste","amount":500},{"resource":"Charcoal","amount":2000},{"resource":"Crystalline","amount":400}],
            "description":      "toweroftruth-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     15,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":60},{"resource":"Antanium","amount":20},{"resource":"Gold","amount":20}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":95}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Zolarg Communications","Insectoid Dominion","Wood Harvesting"],
            "canRenderStatic":  false,
            "entertains":       100,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   false,
            "buildCategories":  ["All Buildings","Government","Research"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Slab of Processing",
            "tile":             ["slabofproc"],
            "cost":             [{"resource":"Ore","amount":2000},{"resource":"Antanium","amount":100},{"resource":"Gold","amount":35},{"resource":"Ant Paste","amount":150},{"resource":"Microchip","amount":50}],
            "description":      "slabofproc-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Software","amount":150}],
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Antanium","amount":30},{"resource":"Gold","amount":8}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Bandwidth","amount":50}],
            "requiresUtility":  [{"utility":"Power","amount":10}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Basic Network Infrastructure"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     "Quantum Slab of Processing",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       90,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Quantum Slab of Processing",
            "tile":             ["quantumslabofproc"],
            "cost":             [{"resource":"Ore","amount":3000},{"resource":"Antanium","amount":600},{"resource":"Gold","amount":350},{"resource":"Ant Paste","amount":250},{"resource":"Aluminum","amount":2000},{"resource":"Microchip","amount":550},{"resource":"Alien Relic","amount":150},{"resource":"Alien Artifact","amount":25}],
            "description":      "quantumslabofproc-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Software","amount":150}],
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Antanium","amount":30},{"resource":"Gold","amount":8}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Bandwidth","amount":600}],
            "requiresUtility":  [{"utility":"Power","amount":150}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   5,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Insectoid Mind Network","Ancient Alien Language"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Information Technology","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       90,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Advanced Plastic Factory",
            "tile":             ["plastfact2"],
            "cost":             [{"resource":"Ore","amount":25000},{"resource":"Charcoal","amount":5000},{"resource":"Steel","amount":15000},{"resource":"Oil","amount":8000},{"resource":"Gold","amount":9000},{"resource":"Aluminum","amount":3500},{"resource":"Microchip","amount":2500},{"resource":"Robot","amount":250}],
            "description":      "plastfact2-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     2800,
            "generateAmount":   1,
            "tileWidth":        4,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Plastic","amount":8000}],
            "sellValue":        [{"resource":"Ore","amount":6500},{"resource":"Steel","amount":4500},{"resource":"Gold","amount":2200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":300}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   50,
            "requiresWorkers":  true,
            "smelts":           {"input":"Oil","output":"Plastic","time":8000,"ratio":9},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    150,
            "requiresTech":     ["Advanced Chemical Synthesis","Advanced Robotics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     "Alien Plastic Factory",
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Robot","rate":900},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Durable Goods"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Advanced Synthetic Oil Lab",
            "tile":             ["oilsynthlab2"],
            "cost":             [{"resource":"Wood","amount":1800},{"resource":"Charcoal","amount":4000},{"resource":"Ore","amount":20000},{"resource":"Steel","amount":20000},{"resource":"Gold","amount":6000},{"resource":"Microchip","amount":3000},{"resource":"Robot","amount":200}],
            "description":      "oilsynthlab2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Oil","amount":9000},{"resource":"Robot","amount":1000},{"resource":"Food","amount":1000}],
            "sellValue":        [{"resource":"Wood","amount":15},{"resource":"Charcoal","amount":50},{"resource":"Ore","amount":7000},{"resource":"Steel","amount":7000},{"resource":"Gold","amount":2000},{"resource":"Microchip","amount":8}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":120}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   25,
            "requiresWorkers":  true,
            "smelts":           {"input":"Charcoal,Regolith,Robot","output":"Oil","time":1500,"ratio":6},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     ["Advanced Chemical Synthesis","Advanced Robotics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Food","rate":100},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Wet Cone",
            "tile":             ["wetcone"],
            "cost":             [{"resource":"Antanium","amount":30},{"resource":"Gold","amount":80},{"resource":"Ant Paste","amount":80},{"resource":"Aluminum","amount":300}],
            "description":      "wetcone-description",
            "produces":         null,
            "generates":        "Water",
            "generateTime":     400,
            "generateAmount":   40,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":            [{"resource":"Water","amount":1500}],
            "sellValue":        [{"resource":"Antanium","amount":10},{"resource":"Gold","amount":20},{"resource":"Aluminum","amount":120}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    3,
            "requiresTech":     ["Advanced Metallurgy"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "wetcone.png",
            "canUpgradeTo":     "Quantum Wet Cone",
            "transModeColor":   "#03A9F4",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Food","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Quantum Wet Cone",
            "tile":             ["quantumwetcone"],
            "cost":             [{"resource":"Antanium","amount":50},{"resource":"Gold","amount":150},{"resource":"Ant Paste","amount":160},{"resource":"Aluminum","amount":1000},{"resource":"Alien Relic","amount":150},{"resource":"Alien Artifact","amount":50},{"resource":"Microchip","amount":10}],
            "description":      "quantumwetcone-description",
            "produces":         null,
            "generates":        "Water",
            "generateTime":     150,
            "generateAmount":   250,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":            [{"resource":"Water","amount":5500}],
            "sellValue":        [{"resource":"Antanium","amount":10},{"resource":"Gold","amount":20},{"resource":"Aluminum","amount":120}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":75}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    3,
            "requiresTech":     ["Advanced Metallurgy"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#03A9F4",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Food","Storage","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Star Gate",
            "tile":             ["stargate"],
            "cost":             [{"resource":"Ore","amount":20000},{"resource":"Steel","amount":40000},{"resource":"Gold","amount":20000},{"resource":"Aluminum","amount":12000},{"resource":"Plastic","amount":7000},{"resource":"Microchip","amount":90000},{"resource":"Triantanium","amount":6000},{"resource":"Robot","amount":10000},{"resource":"Alien Artifact","amount":1000}],
            "description":      "stargate-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     1800,
            "generateAmount":   20,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":2000},{"resource":"Steel","amount":7000},{"resource":"Gold","amount":6000},{"resource":"Aluminum","amount":8000},{"resource":"Plastic","amount":100},{"resource":"Microchip","amount":8},{"resource":"Triantanium","amount":2000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":20000}],
            "colGenRate":       6000,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    5000,
            "requiresTech":     ["Interdimensional Transportation"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Food","Water","Sugar","Rum","Wool","Wood","Clay","Charcoal","Regolith","Ore","Ant Paste","Steel","Antanium","Gold","Aluminum","Oil","Diamond","Helium 3","Toy","Uranium","Crystalline","Cloth","Pottery","Bricks","Microchip","Robot","Alien Artifact","Triantanium","Alien Relic","Obsidian","Plastic","Software"],
            "canExport":        ["Food","Water","Sugar","Rum","Wool","Wood","Clay","Charcoal","Regolith","Ore","Ant Paste","Steel","Antanium","Gold","Aluminum","Oil","Diamond","Helium 3","Toy","Uranium","Crystalline","Cloth","Pottery","Bricks","Microchip","Robot","Alien Artifact","Triantanium","Alien Relic","Obsidian","Plastic","Software"],
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Robot","rate":800},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Economy","Immigration","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   true,
            "tradeCapacity":    100000,
            "upkeepCost":       0.0,
            "giftCapacity":     100000000,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       true,
            "lightEffects":     [
                {
                    "x":    -0.2,
                    "y":    -0.2,
                    "r":    1.6,
                    "c":    "#1E88E5",
                    "i":    0.4,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Arcology",
            "tile":             ["arcology"],
            "cost":             [{"resource":"Ore","amount":60000},{"resource":"Clay","amount":8000},{"resource":"Water","amount":40000},{"resource":"Steel","amount":60000},{"resource":"Gold","amount":25000},{"resource":"Aluminum","amount":10000},{"resource":"Uranium","amount":4000},{"resource":"Pottery","amount":15000},{"resource":"Toy","amount":20000},{"resource":"Cloth","amount":10000},{"resource":"Microchip","amount":80000},{"resource":"Triantanium","amount":1000},{"resource":"Robot","amount":10000}],
            "description":      "arcology-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     50000,
            "generateAmount":   10,
            "tileWidth":        4,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":6000},{"resource":"Clay","amount":800},{"resource":"Steel","amount":6000},{"resource":"Gold","amount":250},{"resource":"Aluminum","amount":600},{"resource":"Microchip","amount":9},{"resource":"Triantanium","amount":600}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":10000}],
            "colGenRate":       0,
            "providesShelter":  10000,
            "canChain":         false,
            "acceptsWorkers":   7000,
            "requiresWorkers":  false,
            "smelts":           {"input":"Food","output":"Trash","time":100000,"ratio":5},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    900,
            "requiresTech":     ["Mega Habitats"],
            "canRenderStatic":  false,
            "entertains":       2000,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            500,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":4,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    500,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       100,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Shrine of Mystics",
            "tile":             ["shrineofmystics"],
            "cost":             [{"resource":"Ore","amount":1000},{"resource":"Ant Paste","amount":3000},{"resource":"Wood","amount":1000},{"resource":"Antanium","amount":3000},{"resource":"Aluminum","amount":3000}],
            "description":      "shrineofmystics-description",
            "produces":         null,
            "generates":        "Antaura",
            "generateTime":     2500,
            "generateAmount":   2,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":400},{"resource":"Antanium","amount":1000},{"resource":"Aluminum","amount":600}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     ["Mysticism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "shrineofmystics.png",
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Center for Automation Coding",
            "tile":             ["centerforautocoding"],
            "cost":             [{"resource":"Ore","amount":2500},{"resource":"Antanium","amount":400},{"resource":"Gold","amount":65},{"resource":"Microchip","amount":30}],
            "description":      "centerforautocoding-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Software","amount":500}],
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Antanium","amount":30},{"resource":"Gold","amount":8}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":16},{"utility":"Bandwidth","amount":12}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   16,
            "requiresWorkers":  true,
            "smelts":           {"input":"Microchip","output":"Software","time":7000,"ratio":3},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    40,
            "requiresTech":     ["Basic Network Infrastructure","Communal Finance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       90,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Higher Command",
            "tile":             ["highercommand"],
            "cost":             [{"resource":"Money","amount":4000},{"resource":"Wood","amount":2000},{"resource":"Ore","amount":8000},{"resource":"Water","amount":2000},{"resource":"Ant Paste","amount":2500},{"resource":"Antanium","amount":15000},{"resource":"Gold","amount":9000},{"resource":"Aluminum","amount":4000},{"resource":"Civics","amount":5000}],
            "description":      "highercommand-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":800},{"resource":"Antanium","amount":1500},{"resource":"Gold","amount":900},{"resource":"Aluminum","amount":2000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":50}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   40,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":16000,"ratio":65},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    60,
            "requiresTech":     ["Insectoid Bureaucracy"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        "highercommand.png",
            "canUpgradeTo":     "Unholy Command",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     80000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    4,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Monument of Heroes",
            "tile":             ["monumentheroes"],
            "cost":             [{"resource":"Ore","amount":350},{"resource":"Steel","amount":450},{"resource":"Aluminum","amount":150},{"resource":"Gold","amount":900},{"resource":"Civics","amount":500}],
            "description":      "monumentheroes-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    10,
            "requiresTech":     ["United Earth Base","Nationalism","Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       5,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    8,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           true,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Fantasy Land Arcology",
            "tile":             ["fantasyland"],
            "cost":             [{"resource":"Ore","amount":55000},{"resource":"Clay","amount":7000},{"resource":"Water","amount":45000},{"resource":"Steel","amount":55000},{"resource":"Gold","amount":30000},{"resource":"Aluminum","amount":12000},{"resource":"Uranium","amount":500},{"resource":"Pottery","amount":25000},{"resource":"Toy","amount":40000},{"resource":"Cloth","amount":15000},{"resource":"Microchip","amount":60000},{"resource":"Robot","amount":25000}],
            "description":      "fantasyland-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     3500,
            "generateAmount":   2000,
            "tileWidth":        4,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":6000},{"resource":"Clay","amount":800},{"resource":"Steel","amount":6000},{"resource":"Gold","amount":250},{"resource":"Aluminum","amount":600},{"resource":"Microchip","amount":9},{"resource":"Triantanium","amount":6000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":9500}],
            "colGenRate":       0,
            "providesShelter":  16000,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Toy,Rum,Cloth","output":"Money","time":100,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    800,
            "requiresTech":     ["Mega Habitats"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Robot","rate":100},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ore Synthesis Lab",
            "tile":             ["oresynth"],
            "cost":             [{"resource":"Regolith","amount":4500},{"resource":"Steel","amount":4000},{"resource":"Gold","amount":4500},{"resource":"Microchip","amount":60}],
            "description":      "oresynth-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     1000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Regolith","amount":2200},{"resource":"Steel","amount":1400},{"resource":"Gold","amount":2100},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":55}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           {"input":"Regolith","output":"Ore","time":80,"ratio":10},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Advanced Small Scale Construction","Advanced Chemistry"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Big Playhouse",
            "tile":             ["bigplayhouse"],
            "cost":             [{"resource":"Ore","amount":10000},{"resource":"Steel","amount":20000},{"resource":"Gold","amount":100},{"resource":"Wood","amount":500},{"resource":"Plastic","amount":2000},{"resource":"Cloth","amount":2000},{"resource":"Pottery","amount":2000},{"resource":"Robot","amount":5},{"resource":"Toy","amount":90000}],
            "description":      "bigplayhouse-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     2000,
            "generateAmount":   5,
            "tileWidth":        4,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":600},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":10},{"resource":"Wood","amount":2},{"resource":"Plastic","amount":100},{"resource":"Cloth","amount":4}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":250}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   200,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     ["Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       600,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Tourism"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":10,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    500,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Micromine",
            "tile":             ["micromine"],
            "cost":             [{"resource":"Crystalline","amount":200}],
            "description":      "micromine-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Micromine",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["LIS Base","Ice World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Alien Enrichment Facility",
            "tile":             ["alienenrichment"],
            "cost":             [{"resource":"Ore","amount":7000},{"resource":"Water","amount":1200},{"resource":"Steel","amount":8000},{"resource":"Gold","amount":5000},{"resource":"Aluminum","amount":5000},{"resource":"Microchip","amount":65000},{"resource":"Alien Artifact","amount":20000},{"resource":"Robot","amount":10000}],
            "description":      "alienenrichment-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        4,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Uranium","amount":50000}],
            "sellValue":        [{"resource":"Ore","amount":2200},{"resource":"Water","amount":400},{"resource":"Steel","amount":2400},{"resource":"Gold","amount":1100},{"resource":"Aluminum","amount":800},{"resource":"Microchip","amount":80},{"resource":"Alien Artifact","amount":6000}],
            "sellWarning":      null,
            "refines":          [{"input":"Uranium","output":"Uranium"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":15000}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   30,
            "requiresWorkers":  true,
            "smelts":           {"input":"Uranium","output":"Uranium","time":10000,"ratio":12},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    120,
            "requiresTech":     ["Ancient Alien Manufacturing","Alien Quantum Physics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Aluminum"],
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Aluminum,Alien Artifact","rate":350},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Crystalmound",
            "tile":             ["crystalmound"],
            "cost":             [{"resource":"Water","amount":300},{"resource":"Crystalline","amount":200}],
            "description":      "crystalmound-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Crystalline","amount":400},{"resource":"Sugar","amount":1800}],
            "sellValue":        [{"resource":"Crystalline","amount":180}],
            "sellWarning":      null,
            "refines":          [{"input":"Crystalline","output":"Crystalline"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       null,
            "providesShelter":  null,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  true,
            "smelts":           {"input":"Crystalline","output":"Sugar","time":500,"ratio":10},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Insectoid Base","Ice World Base|Lava World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ore Tunnel",
            "tile":             ["oretunnel"],
            "cost":             [{"resource":"Crystalline","amount":200}],
            "description":      "oretunnel-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Ore Tunnel",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Insectoid Base","Ice World Base|Lava World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Synthetic Crystalline Deposit",
            "tile":             ["syncrystaldeposit"],
            "cost":             [{"resource":"Crystalline","amount":20},{"resource":"Rum","amount":200}],
            "description":      "syncrystaldeposit-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Synthetic Crystalline Deposit",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Crystalline Synthesis|Reptilian Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Independence Hall Level 2",
            "tile":             ["independencehall2"],
            "cost":             [{"resource":"Ore","amount":40000},{"resource":"Rum","amount":3000},{"resource":"Diamond","amount":3000},{"resource":"Water","amount":4000},{"resource":"Regolith","amount":30000},{"resource":"Steel","amount":20000},{"resource":"Gold","amount":18000},{"resource":"Aluminum","amount":4000},{"resource":"Microchip","amount":4000},{"resource":"Civics","amount":10000},{"resource":"Pottery","amount":4000}],
            "description":      "independencehall2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        5,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":10000},{"resource":"Diamond","amount":1000},{"resource":"Regolith","amount":500},{"resource":"Steel","amount":7500},{"resource":"Gold","amount":6500},{"resource":"Aluminum","amount":700},{"resource":"Microchip","amount":15}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":70}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   75,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":13500,"ratio":75},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    65,
            "requiresTech":     ["LIS Base","Galactic Governance","Large Scale Construction","Self Governance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        null,
            "canUpgradeTo":     "Independence Hall Level 3",
            "transModeColor":   "#dddddd",
            "requiresFuel":     {"resource":"Rum","rate":350},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     150000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    4,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Microincinerator",
            "tile":             ["microincinerator"],
            "cost":             [{"resource":"Ore","amount":500}],
            "description":      "microincinerator-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     900,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":150}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":15}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"microincinerator-firstbuild-tut",
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Trash","rate":20},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power","Waste Management"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1,
                    "c":    "#FFA000",
                    "i":    0.1,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Incinerator",
            "tile":             ["incinerator"],
            "cost":             [{"resource":"Ore","amount":5000},{"resource":"Steel","amount":4500},{"resource":"Gold","amount":4500},{"resource":"Microchip","amount":80}],
            "description":      "incinerator-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     900,
            "generateAmount":   30,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":2000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":2500},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":600}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   25,
            "requiresWorkers":  false,
            "smelts":           {"input":"Trash","output":"Atmosphere","time":10,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Trash","rate":1},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power","Waste Management"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Small Recycling Center",
            "tile":             ["smrecyclingcenter"],
            "cost":             [{"resource":"Ore","amount":9000},{"resource":"Steel","amount":7000},{"resource":"Gold","amount":2500},{"resource":"Aluminum","amount":500},{"resource":"Microchip","amount":600}],
            "description":      "smrecyclingcenter-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Plastic","amount":500}],
            "sellValue":        [{"resource":"Ore","amount":2000},{"resource":"Steel","amount":1500},{"resource":"Gold","amount":900}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":80}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   25,
            "requiresWorkers":  true,
            "smelts":           {"input":"Trash","output":"Plastic","time":12000,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    150,
            "requiresTech":     ["Advanced Chemical Synthesis"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     "Medium Recycling Center",
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Trash","rate":8},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Waste Management"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Small Trash Pit",
            "tile":             ["smtrashpit"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Trash","amount":10000}],
            "description":      "smtrashpit-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Small Trash Pit",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Waste Management"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Conference Hall",
            "tile":             ["conferencehall"],
            "cost":             [{"resource":"Food","amount":1500},{"resource":"Rum","amount":1500},{"resource":"Microchip","amount":2500},{"resource":"Aluminum","amount":3000},{"resource":"Gold","amount":10000},{"resource":"Steel","amount":6000},{"resource":"Ore","amount":8000},{"resource":"Plastic","amount":2500}],
            "description":      "conferencehall-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     2500,
            "generateAmount":   30,
            "tileWidth":        2,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Microchip","amount":4},{"resource":"Aluminum","amount":2000},{"resource":"Gold","amount":4000},{"resource":"Steel","amount":3000},{"resource":"Ore","amount":1000},{"resource":"Plastic","amount":300}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":250}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   30,
            "requiresWorkers":  true,
            "smelts":           {"input":"Rum","output":"Money","time":2500,"ratio":50},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Solar Governance","Tourist Essentials"],
            "canRenderStatic":  false,
            "entertains":       100,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       "White Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Microchip,Food","rate":800},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Research"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    50,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Advanced Medical Research Center",
            "tile":             ["advancedmed"],
            "cost":             [{"resource":"Ore","amount":50000},{"resource":"Steel","amount":15000},{"resource":"Gold","amount":10000},{"resource":"Aluminum","amount":2500},{"resource":"Civics","amount":5000},{"resource":"Microchip","amount":10000},{"resource":"Uranium","amount":1000},{"resource":"Plastic","amount":2500},{"resource":"Money","amount":10000}],
            "description":      "advancedmed-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     2500,
            "generateAmount":   20,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":10000},{"resource":"Steel","amount":6000},{"resource":"Gold","amount":4000},{"resource":"Aluminum","amount":600},{"resource":"Microchip","amount":6},{"resource":"Uranium","amount":50},{"resource":"Plastic","amount":250}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   100,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    150,
            "requiresTech":     ["Human Cloning","Advanced Chemical Synthesis"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Medic",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            100,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Medical","Research"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Blue Residential Tower",
            "tile":             ["restowerblue"],
            "cost":             [{"resource":"Ore","amount":18000},{"resource":"Steel","amount":85000},{"resource":"Gold","amount":10000},{"resource":"Aluminum","amount":2500},{"resource":"Pottery","amount":1500},{"resource":"Cloth","amount":1500},{"resource":"Plastic","amount":2500},{"resource":"Toy","amount":1100},{"resource":"Robot","amount":10},{"resource":"Microchip","amount":400}],
            "description":      "restowerblue-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     3500,
            "generateAmount":   400,
            "tileWidth":        1,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":       [{"resource":"Ore","amount":5000},{"resource":"Steel","amount":8000},{"resource":"Gold","amount":800},{"resource":"Aluminum","amount":40},{"resource":"Pottery","amount":10},{"resource":"Cloth","amount":10},{"resource":"Plastic","amount":5},{"resource":"Toy","amount":6},{"resource":"Microchip","amount":4}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":380}],
            "colGenRate":       0,
            "providesShelter":  1150,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    350,
            "requiresTech":     ["Tall Construction","Advanced Robotics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Housing","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Medium Recycling Center",
            "tile":             ["medrecyclingcenter"],
            "cost":             [{"resource":"Ore","amount":14000},{"resource":"Steel","amount":18000},{"resource":"Gold","amount":5000},{"resource":"Aluminum","amount":1200},{"resource":"Microchip","amount":1500},{"resource":"Plastic","amount":1500}],
            "description":      "medrecyclingcenter-description",
            "produces":         null,
            "generates":        "Aluminum",
            "generateTime":     50000,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Plastic","amount":900},{"resource":"Aluminum","amount":900}],
            "sellValue":        [{"resource":"Ore","amount":3000},{"resource":"Steel","amount":4000},{"resource":"Gold","amount":1000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":350}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   65,
            "requiresWorkers":  true,
            "smelts":           {"input":"Trash","output":"Plastic","time":6000,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    300,
            "requiresTech":     ["Advanced Chemical Synthesis","Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Trash","rate":2},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Waste Management"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Landfill",
            "tile":             ["landfill"],
            "cost":             [{"resource":"Ore","amount":70000},{"resource":"Water","amount":8000},{"resource":"Trash","amount":250000}],
            "description":      "landfill-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        5,
            "tileHeight":       5,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Landfill",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    180,
            "requiresTech":     ["Large Scale Construction","Deep Excavation"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Waste Management"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Unholy Brew Pit",
            "tile":             ["unholybrewpit"],
            "cost":             [{"resource":"Water","amount":500},{"resource":"Ant Paste","amount":500},{"resource":"Wood","amount":500},{"resource":"Ore","amount":1000},{"resource":"Antanium","amount":200},{"resource":"Gold","amount":600},{"resource":"Aluminum","amount":1000}],
            "description":      "unholybrewpit-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Rum","amount":400}],
            "sellValue":        [{"resource":"Wood","amount":10},{"resource":"Ore","amount":300},{"resource":"Antanium","amount":80},{"resource":"Gold","amount":400},{"resource":"Aluminum","amount":600}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":30}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           {"input":"Food,Water","output":"Rum","time":800,"ratio":16},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    4,
            "requiresTech":     ["Insectoid Brewing","Mysticism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#b38600",
            "requiresFuel":     {"resource":"Antaura","rate":800},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Durable Goods"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -0.2,
                    "y":    -0.5,
                    "r":    0.6,
                    "c":    "#E53935",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Unholy Pit of Stuff",
            "tile":             ["unholypit"],
            "cost":             [{"resource":"Aluminum","amount":30000},{"resource":"Antanium","amount":40000},{"resource":"Gold","amount":50000},{"resource":"Antaura","amount":15000}],
            "description":      "unholypit-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ether","amount":100000},{"resource":"Wheel","amount":100000},{"resource":"Obsidian","amount":100000},{"resource":"Sugar","amount":100000},{"resource":"Food","amount":100000},{"resource":"Water","amount":100000},{"resource":"Steel","amount":100000},{"resource":"Wool","amount":100000},{"resource":"Rum","amount":100000},{"resource":"Pottery","amount":100000},{"resource":"Bricks","amount":100000},{"resource":"Cloth","amount":100000},{"resource":"Plastic","amount":100000},{"resource":"Toy","amount":100000},{"resource":"Microchip","amount":100000},{"resource":"Alien Artifact","amount":100000},{"resource":"Alien Relic","amount":100000},{"resource":"Robot","amount":100000},{"resource":"Ant Paste","amount":100000},{"resource":"Antanium","amount":100000},{"resource":"Wood","amount":100000},{"resource":"Crystalline","amount":100000},{"resource":"Diamond","amount":100000},{"resource":"Triantanium","amount":100000},{"resource":"Aluminum","amount":100000},{"resource":"Uranium","amount":100000},{"resource":"Gold","amount":100000},{"resource":"Clay","amount":100000},{"resource":"Ore","amount":100000},{"resource":"Regolith","amount":100000},{"resource":"Charcoal","amount":100000},{"resource":"Oil","amount":100000},{"resource":"Software","amount":100000}],
            "sellValue":        [{"resource":"Aluminum","amount":2000},{"resource":"Antanium","amount":500},{"resource":"Gold","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    35,
            "requiresTech":     ["Communal Finance","Mysticism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Unholy Tower of Stuff",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Durable Goods","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    1,
                    "y":    1,
                    "r":    2,
                    "c":    "#E53935",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Unholy Tower of Stuff",
            "tile":             ["unholytower"],
            "cost":             [{"resource":"Aluminum","amount":300000},{"resource":"Antanium","amount":400000},{"resource":"Gold","amount":500000},{"resource":"Antaura","amount":50000},{"resource":"Obsidian","amount":95000},{"resource":"Oil","amount":5000},{"resource":"Alien Relic","amount":9000}],
            "description":      "unholytower-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ether","amount":3500000},{"resource":"Wheel","amount":3500000},{"resource":"Obsidian","amount":3500000},{"resource":"Sugar","amount":3500000},{"resource":"Food","amount":3500000},{"resource":"Water","amount":3500000},{"resource":"Steel","amount":3500000},{"resource":"Wool","amount":3500000},{"resource":"Rum","amount":3500000},{"resource":"Pottery","amount":3500000},{"resource":"Bricks","amount":3500000},{"resource":"Cloth","amount":3500000},{"resource":"Plastic","amount":3500000},{"resource":"Toy","amount":3500000},{"resource":"Microchip","amount":3500000},{"resource":"Alien Artifact","amount":3500000},{"resource":"Alien Relic","amount":3500000},{"resource":"Robot","amount":3500000},{"resource":"Ant Paste","amount":3500000},{"resource":"Antanium","amount":3500000},{"resource":"Wood","amount":3500000},{"resource":"Crystalline","amount":3500000},{"resource":"Diamond","amount":3500000},{"resource":"Triantanium","amount":3500000},{"resource":"Aluminum","amount":3500000},{"resource":"Uranium","amount":3500000},{"resource":"Gold","amount":3500000},{"resource":"Clay","amount":3500000},{"resource":"Ore","amount":3500000},{"resource":"Regolith","amount":3500000},{"resource":"Charcoal","amount":3500000},{"resource":"Oil","amount":3500000},{"resource":"Software","amount":3500000}],
            "sellValue":        [{"resource":"Aluminum","amount":2000},{"resource":"Antanium","amount":500},{"resource":"Gold","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    35,
            "requiresTech":     ["Communal Finance","Mysticism","Mega Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Durable Goods","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Glazed Mound",
            "tile":             ["glazedmound"],
            "cost":             [{"resource":"Clay","amount":1500},{"resource":"Sugar","amount":1000},{"resource":"Food","amount":1500},{"resource":"Water","amount":50}],
            "description":      "glazedmound-description",
            "produces":         ["Queen","Worker Drone","Tundrabug","Extremeobug","Obsidiobug","Waterbug","Etherbug","Regobug","Orebug","Goldbug","Lumberbug","Alumibug","Ancientbug"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Sugar","amount":1000},{"resource":"Regolith","amount":700}],
            "sellValue":        [{"resource":"Clay","amount":180}],
            "sellWarning":      null,
            "refines":          [{"input":"Regolith","output":"Regolith"},{"input":"Obsidian","output":"Obsidian"},{"input":"Ore","output":"Ore"},{"input":"Water","output":"Water"},{"input":"Sugar","output":"Sugar"},{"input":"Crystalline","output":"Crystalline"},{"input":"Diamond","output":"Diamond"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       3800,
            "providesShelter":  400,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           false,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Antanium Production","Communal Finance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    true,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Unholy Mound of Worship",
            "tile":             ["unholymound"],
            "cost":             [{"resource":"Aluminum","amount":2000},{"resource":"Sugar","amount":1500},{"resource":"Food","amount":2000},{"resource":"Antaura","amount":500}],
            "description":      "unholymound-description",
            "produces":         ["Queen","Worker Drone","Tundrabug","Extremeobug","Obsidiobug","Waterbug","Etherbug","Regobug","Orebug","Goldbug","Lumberbug","Alumibug","Ancientbug"],
            "generates":        "Antaura",
            "generateTime":     300,
            "generateAmount":   6,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Sugar","amount":1000},{"resource":"Regolith","amount":700}],
            "sellValue":        [{"resource":"Aluminum","amount":200}],
            "sellWarning":      null,
            "refines":          [{"input":"Regolith","output":"Regolith"},{"input":"Obsidian","output":"Obsidian"},{"input":"Ore","output":"Ore"},{"input":"Water","output":"Water"},{"input":"Sugar","output":"Sugar"},{"input":"Crystalline","output":"Crystalline"},{"input":"Diamond","output":"Diamond"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       3800,
            "providesShelter":  600,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  false,
            "smelts":           false,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Mysticism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            15,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Housing","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    true,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Unholy Core Mine",
            "tile":             ["coremine"],
            "cost":             [{"resource":"Water","amount":6000},{"resource":"Antanium","amount":3000},{"resource":"Ant Paste","amount":5000},{"resource":"Wood","amount":5000},{"resource":"Aluminum","amount":5000},{"resource":"Antaura","amount":2000},{"resource":"Civics","amount":1000}],
            "description":      "coremine-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Water","amount":500},{"resource":"Antanium","amount":100},{"resource":"Ant Paste","amount":500}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   50,
            "requiresWorkers":  true,
            "smelts":           {"input":"Antaura","output":"Ore|Gold|Aluminum|Uranium|Diamond|Alien Relic|Clay|Obsidian","time":5000,"ratio":5},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Antanium Production","Communal Finance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -0.5,
                    "y":    0,
                    "r":    0.6,
                    "c":    "#E53935",
                    "i":    0.2,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Labor Camp",
            "tile":             ["laborcamp"],
            "cost":             [{"resource":"Water","amount":10000},{"resource":"Ore","amount":20000},{"resource":"Antanium","amount":14000},{"resource":"Ant Paste","amount":17000},{"resource":"Wood","amount":16000},{"resource":"Aluminum","amount":19000},{"resource":"Clay","amount":18500},{"resource":"Cloth","amount":5000}],
            "description":      "laborcamp-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wood","amount":8000},{"resource":"Water","amount":8000},{"resource":"Sugar","amount":8000},{"resource":"Food","amount":8000},{"resource":"Ore","amount":8000},{"resource":"Gold","amount":8000},{"resource":"Clay","amount":8000}],
            "sellValue":        [{"resource":"Ore","amount":200},{"resource":"Antanium","amount":400},{"resource":"Ant Paste","amount":7},{"resource":"Wood","amount":60},{"resource":"Aluminum","amount":900},{"resource":"Clay","amount":85}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  200,
            "canChain":         false,
            "acceptsWorkers":   340,
            "requiresWorkers":  true,
            "smelts":           {"input":"Water,Water,Water,Water,Water,Water,Water,Water,Money","output":"Sugar|Sugar|Sugar|Wood|Wood|Ore|Gold|Clay","time":6000,"ratio":35},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    80,
            "requiresTech":     ["Antanium Production","Communal Finance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Economy","Storage","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Small Light Post",
            "tile":             ["smlightpost"],
            "cost":             [{"resource":"Ore","amount":20}],
            "description":      "smlightpost-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    4,
                    "c":    "#E3F2FD",
                    "i":    .35,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Small Red Light Post",
            "tile":             ["smredlightpost"],
            "cost":             [{"resource":"Ore","amount":25}],
            "description":      "smredlightpost-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    4,
                    "c":    "#ff0000",
                    "i":    0.35,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Small Green Light Post",
            "tile":             ["smgreenlightpost"],
            "cost":             [{"resource":"Ore","amount":25}],
            "description":      "smgreenlightpost-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    4,
                    "c":    "#00ff00",
                    "i":    .35,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Street Light",
            "tile":             ["streetlight"],
            "cost":             [{"resource":"Ore","amount":30},{"resource":"Steel","amount":5},{"resource":"Gold","amount":1}],
            "description":      "streetlight-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    6,
                    "c":    "#FFF3E0",
                    "i":    0.45,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Glow Goo",
            "tile":             ["glowgoo"],
            "cost":             [{"resource":"Food","amount":10},{"resource":"Ant Paste","amount":14}],
            "description":      "glowgoo-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Orb of Radiance",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    5,
                    "c":    "#0edeb2",
                    "i":    0.3,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Paste Boiler",
            "tile":             ["pasteboiler"],
            "cost":             [{"resource":"Ant Paste","amount":500},{"resource":"Crystalline","amount":800}],
            "description":      "pasteboiler-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     800,
            "generateAmount":   30,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Crystalline","amount":600}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":15}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Sugarpower"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#81D4FA",
            "requiresFuel":     {"resource":"Ant Paste","rate":1000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Terraforming"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    1,
                    "c":    "#FFF3E0",
                    "i":    .25,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Atmosphere Scrubber",
            "tile":             ["atmosscrubber"],
            "cost":             [{"resource":"Ore","amount":5000},{"resource":"Steel","amount":10000},{"resource":"Gold","amount":10000},{"resource":"Aluminum","amount":6000},{"resource":"Uranium","amount":900},{"resource":"Microchip","amount":12000},{"resource":"Robot","amount":1500}],
            "description":      "atmosscrubber-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":800},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":1400},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1500}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Atmosphere","output":null,"time":1,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    750,
            "requiresTech":     ["Artificial Intelligence","Climate Science Theory"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    4,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Atmosphere","rate":1},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0,
                    "y":    -0.15,
                    "r":    0.3,
                    "c":    "#00aa44",
                    "i":    0.4,
                    "nightonly": true
                },
                {
                    "x":    -0.15,
                    "y":    -0.15,
                    "r":    0.3,
                    "c":    "#0055d4",
                    "i":    0.4,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Security Wall",
            "tile":             ["wall2"],
            "cost":             [{"resource":"Ore","amount":80},{"resource":"Steel","amount":25},{"resource":"Charcoal","amount":25},{"resource":"Regolith","amount":25},{"resource":"Oil","amount":40}],
            "description":      "wall2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     [],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Security Wall Light",
            "tile":             ["wall2light"],
            "cost":             [{"resource":"Ore","amount":100},{"resource":"Steel","amount":25},{"resource":"Charcoal","amount":25},{"resource":"Regolith","amount":25},{"resource":"Oil","amount":40}],
            "description":      "wall2light-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     [],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    4,
                    "c":    "#E3F2FD",
                    "i":    .35,
                    "nightonly": false
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Bureau of Bureaucracy",
            "tile":             ["bureaucracy"],
            "cost":             [{"resource":"Ore","amount":10000},{"resource":"Steel","amount":5500},{"resource":"Gold","amount":4000},{"resource":"Microchip","amount":60},{"resource":"Wood","amount":800},{"resource":"Bricks","amount":1000}],
            "description":      "bureaucracy-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":2800},{"resource":"Steel","amount":1800},{"resource":"Gold","amount":800}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":80}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   200,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":20000,"ratio":8},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     ["Colonial Finance Theory","Colonial Civics","Self Governance"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Department of Advanced Fish Mating Studies",
            "tile":             ["deptfishstudies"],
            "cost":             [{"resource":"Money","amount":1000000},{"resource":"Civics","amount":1000000},{"resource":"Research","amount":1000000},{"resource":"Ore","amount":1500000},{"resource":"Steel","amount":550000},{"resource":"Gold","amount":200000},{"resource":"Microchip","amount":60000},{"resource":"Wood","amount":80000},{"resource":"Bricks","amount":90000},{"resource":"Pottery","amount":17000},{"resource":"Painting","amount":500},{"resource":"Cloth","amount":15000},{"resource":"Software","amount":10000}],
            "description":      "deptfishstudies-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     500,
            "generateAmount":   1,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":2800},{"resource":"Steel","amount":1800},{"resource":"Gold","amount":800}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":950},{"utility":"Bandwidth","amount":150}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   5500,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money,Money,Money,Money,Software,Rum","output":"Research","time":20000,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     ["United Earth Base","Mass Data Management","Political Theater"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government","Research"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Cloth Farm",
            "tile":             ["clothfarm"],
            "cost":             [{"resource":"Ore","amount":1600},{"resource":"Antanium","amount":1600},{"resource":"Gold","amount":1000},{"resource":"Aluminum","amount":1000},{"resource":"Wood","amount":400},{"resource":"Ant Paste","amount":950}],
            "description":      "clothfarm-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":700},{"resource":"Antanium","amount":900},{"resource":"Gold","amount":600},{"resource":"Aluminum","amount":650}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":35}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   18,
            "requiresWorkers":  true,
            "smelts":           {"input":"Aluminum","output":"Cloth","time":1200,"ratio":10},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    20,
            "requiresTech":     ["Insectoid Base","Advanced Metallurgy"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Relic Cauldron",
            "tile":             ["cauldron"],
            "cost":             [{"resource":"Ore","amount":400},{"resource":"Water","amount":400},{"resource":"Aluminum","amount":300},{"resource":"Ant Paste","amount":1000},{"resource":"Alien Relic","amount":100}],
            "description":      "cauldron-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":350}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Ant Paste,Alien Relic","output":"Alien Artifact","time":2000,"ratio":2},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    40,
            "requiresTech":     ["Insectoid Base","Advanced Metallurgy"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    3,
                    "c":    "#C5E1A5",
                    "i":    0.3,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Supermarket",
            "tile":             ["supermarket"],
            "cost":             [{"resource":"Money","amount":2000},{"resource":"Food","amount":4000},{"resource":"Water","amount":4000},{"resource":"Ore","amount":10000},{"resource":"Steel","amount":10000},{"resource":"Gold","amount":8000},{"resource":"Microchip","amount":15}],
            "description":      "supermarket-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     4000,
            "generateAmount":   1,
            "tileWidth":        4,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":3000},{"resource":"Water","amount":3000}],
            "sellValue":        [{"resource":"Ore","amount":4000},{"resource":"Steel","amount":4000},{"resource":"Gold","amount":2000},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":30}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   40,
            "requiresWorkers":  true,
            "smelts":           {"input":"Food,Water","output":"Money","time":16000,"ratio":8},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     ["Colonial Finance Theory","Colonial Civics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     "Megamart",
            "transModeColor":   "#8BC34A",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Megamart",
            "tile":             ["megamart"],
            "cost":             [{"resource":"Money","amount":10000},{"resource":"Food","amount":15000},{"resource":"Water","amount":15000},{"resource":"Toy","amount":15000},{"resource":"Rum","amount":15000},{"resource":"Pottery","amount":15000},{"resource":"Cloth","amount":15000},{"resource":"Microchip","amount":15000},{"resource":"Ore","amount":30000},{"resource":"Steel","amount":30000},{"resource":"Gold","amount":25000},{"resource":"Bricks","amount":9000},{"resource":"Aluminum","amount":9000},{"resource":"Robot","amount":500}],
            "description":      "megamart-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     4000,
            "generateAmount":   1,
            "tileWidth":        4,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Food","amount":10000},{"resource":"Water","amount":10000},{"resource":"Rum","amount":10000},{"resource":"Toy","amount":10000},{"resource":"Pottery","amount":10000},{"resource":"Cloth","amount":10000}],
            "sellValue":        [{"resource":"Toy","amount":500},{"resource":"Pottery","amount":1},{"resource":"Cloth","amount":50},{"resource":"Microchip","amount":30},{"resource":"Ore","amount":10000},{"resource":"Steel","amount":10000},{"resource":"Gold","amount":15000},{"resource":"Bricks","amount":600},{"resource":"Aluminum","amount":5000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   180,
            "requiresWorkers":  true,
            "smelts":           {"input":"Food,Water,Rum,Toy,Pottery,Cloth","output":"Money","time":16000,"ratio":50},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    150,
            "requiresTech":     ["Advanced Robotics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#8BC34A",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Hall of Congress",
            "tile":             ["uecongress"],
            "cost":             [{"resource":"Money","amount":500000000},{"resource":"Rum","amount":100000},{"resource":"Water","amount":400000},{"resource":"Ore","amount":3000000},{"resource":"Steel","amount":4000000},{"resource":"Gold","amount":8000000},{"resource":"Oil","amount":200000},{"resource":"Wood","amount":120000},{"resource":"Cloth","amount":250000},{"resource":"Bricks","amount":175000},{"resource":"Pottery","amount":450000},{"resource":"Plastic","amount":2500000},{"resource":"Aluminum","amount":1800000},{"resource":"Microchip","amount":750000},{"resource":"Uranium","amount":1500000},{"resource":"Robot","amount":500000},{"resource":"Toy","amount":100000},{"resource":"Triantanium","amount":10000},{"resource":"Civics","amount":1000000}],
            "description":      "uecongress-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        4,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":200000},{"resource":"Steel","amount":300000},{"resource":"Gold","amount":100000},{"resource":"Wood","amount":600},{"resource":"Cloth","amount":1},{"resource":"Bricks","amount":20000},{"resource":"Plastic","amount":10000},{"resource":"Aluminum","amount":1000000},{"resource":"Microchip","amount":500},{"resource":"Uranium","amount":1000},{"resource":"Toy","amount":1000},{"resource":"Triantanium","amount":1000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":50000}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   400,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money,Food","output":"Civics","time":16000,"ratio":250},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    500,
            "requiresTech":     ["Human Base","Tall Construction","Tourist Traps","Political Theater"],
            "canRenderStatic":  false,
            "entertains":       1000,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     {"resource":"Rum","rate":20},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    1000,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     500000000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    7,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       100,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ancient Alien Ore Refinery",
            "tile":             ["refinery3"],
            "cost":             [{"resource":"Ore","amount":35000},{"resource":"Steel","amount":50000},{"resource":"Gold","amount":65000},{"resource":"Aluminum","amount":4000},{"resource":"Uranium","amount":8000},{"resource":"Microchip","amount":17000},{"resource":"Alien Artifact","amount":100}],
            "description":      "refinery3-description",
            "produces":         ["Ore Miner","Used Ore Miner","Uranium Miner"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Steel","amount":250000},{"resource":"Ore","amount":500000}],
            "sellValue":        [{"resource":"Ore","amount":10000},{"resource":"Steel","amount":40000},{"resource":"Gold","amount":30000},{"resource":"Aluminum","amount":2000},{"resource":"Uranium","amount":500},{"resource":"Microchip","amount":20},{"resource":"Alien Artifact","amount":20}],
            "sellWarning":      null,
            "refines":          [{"input":"Ore","output":"Ore"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":900}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   20,
            "requiresWorkers":  true,
            "smelts":           {"input":"Ore,Uranium,Alien Artifact","output":"Steel","time":15000,"ratio":1000},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    150,
            "requiresTech":     ["Ancient Alien Manufacturing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ant Paste Synthesizer",
            "tile":             ["pastesynth"],
            "cost":             [{"resource":"Trash","amount":1000},{"resource":"Ore","amount":6000},{"resource":"Steel","amount":9000},{"resource":"Gold","amount":1000},{"resource":"Microchip","amount":800},{"resource":"Aluminum","amount":2000},{"resource":"Uranium","amount":500},{"resource":"Plastic","amount":2000}],
            "description":      "pastesynth-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ant Paste","amount":500}],
            "sellValue":        [{"resource":"Trash","amount":1000},{"resource":"Ore","amount":2000},{"resource":"Steel","amount":3000},{"resource":"Gold","amount":400},{"resource":"Microchip","amount":8},{"resource":"Aluminum","amount":920},{"resource":"Uranium","amount":50},{"resource":"Plastic","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1500}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Trash,Atmosphere","output":"Ant Paste","time":40,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    600,
            "requiresTech":     ["Ant Paste Synthesis","Advanced Robotics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Robot","rate":1000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Waste Management"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0,
                    "y":    0,
                    "r":    2,
                    "c":    "#90CAF9",
                    "i":    .1,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Small Sugar Processor",
            "tile":             ["smsugarprocessor"],
            "cost":             [{"resource":"Ore","amount":900}],
            "description":      "smsugarprocessor-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Sugar","amount":3000}],
            "sellValue":        [{"resource":"Ore","amount":300}],
            "sellWarning":      null,
            "refines":          [{"input":"Sugar","output":"Sugar"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":6}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Sugar","output":"Food","time":1500,"ratio":5},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     ["Human Base","LIS Base","Abandoned World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -0.5,
                    "y":    -0.2,
                    "r":    1,
                    "c":    "#8dd35f",
                    "i":    .15,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Bloodletting Station",
            "tile":             ["bloodletting"],
            "cost":             [{"resource":"Ore","amount":700},{"resource":"Antanium","amount":600},{"resource":"Ant Paste","amount":500},{"resource":"Gold","amount":600},{"resource":"Civics","amount":100},{"resource":"Cloth","amount":400}],
            "description":      "bloodletting-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":200},{"resource":"Antanium","amount":20},{"resource":"Gold","amount":20}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   3,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     ["Insectoid Regeneration","Advanced Metallurgy"],
            "canRenderStatic":  false,
            "entertains":       10,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            80,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":5,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Spire of Knowledge",
            "tile":             ["spireknowledge"],
            "cost":             [{"resource":"Ore","amount":1000},{"resource":"Gold","amount":1500},{"resource":"Aluminum","amount":1500},{"resource":"Ant Paste","amount":700},{"resource":"Cloth","amount":400}],
            "description":      "spireknowledge-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     1400,
            "generateAmount":   20,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Gold","amount":500},{"resource":"Aluminum","amount":500}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":12}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   8,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    40,
            "requiresTech":     ["Advanced Metallurgy"],
            "canRenderStatic":  false,
            "entertains":       8,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Tower of Thoughts",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Research"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":5,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         8,
            "providesIQ":       100,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Tower of Thoughts",
            "tile":             ["thoughttower"],
            "cost":             [{"resource":"Ore","amount":2000},{"resource":"Gold","amount":2500},{"resource":"Aluminum","amount":1500},{"resource":"Ant Paste","amount":1200},{"resource":"Cloth","amount":600},{"resource":"Microchip","amount":60},{"resource":"Software","amount":200},{"resource":"Oil","amount":600}],
            "description":      "thoughttower-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     1200,
            "generateAmount":   40,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Gold","amount":500},{"resource":"Aluminum","amount":500}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":25},{"utility":"Bandwidth","amount":30}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   16,
            "requiresWorkers":  true,
            "smelts":           {"input":"Microchip,Software","output":"Research","time":8000,"ratio":25},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    60,
            "requiresTech":     ["Insectoid Oil Production","Basic Network Infrastructure"],
            "canRenderStatic":  false,
            "entertains":       10,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Research","Information Technology","Entertainment"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":6,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         10,
            "providesIQ":       115,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Orb of Radiance",
            "tile":             ["sphrad"],
            "cost":             [{"resource":"Ant Paste","amount":30},{"resource":"Aluminum","amount":250},{"resource":"Gold","amount":800}],
            "description":      "sphrad-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Aluminum","amount":25},{"resource":"Gold","amount":80}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":10}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Advanced Metallurgy"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    8,
                    "c":    "#d5f2ec",
                    "i":    0.5,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Uranium Silo",
            "tile":             ["uraniumsilo"],
            "cost":             [{"resource":"Ore","amount":20},{"resource":"Gold","amount":80},{"resource":"Steel","amount":80},{"resource":"Aluminum","amount":180}],
            "description":      "uraniumsilo-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Uranium","amount":2000}],
            "sellValue":        [{"resource":"Ore","amount":6},{"resource":"Gold","amount":2},{"resource":"Steel","amount":15}],
            "sellWarning":      null,
            "refines":          [{"input":"Uranium","output":"Uranium"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Advanced Nuclear Physics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#222222",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Quantum Sugar Cloner",
            "tile":             ["quantumsugarcloner"],
            "cost":             [{"resource":"Water","amount":4000},{"resource":"Sugar","amount":800},{"resource":"Ant Paste","amount":4000},{"resource":"Wood","amount":1000},{"resource":"Aluminum","amount":6000},{"resource":"Antaura","amount":2000},{"resource":"Gold","amount":4000},{"resource":"Alien Relic","amount":150},{"resource":"Alien Artifact","amount":50}],
            "description":      "quantumsugarcloner-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Sugar","amount":50000}],
            "sellValue":        [{"resource":"Water","amount":500},{"resource":"Antanium","amount":100},{"resource":"Ant Paste","amount":500}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":350}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   16,
            "requiresWorkers":  true,
            "smelts":           {"input":"Sugar,Water","output":"Sugar","time":2000,"ratio":400},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    80,
            "requiresTech":     ["Ancient Alien Language"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    0.6,
                    "c":    "#64B5F6",
                    "i":    0.2,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Interstellar Pad of Thought",
            "tile":             ["intpadthought"],
            "cost":             [{"resource":"Water","amount":4000},{"resource":"Sugar","amount":800},{"resource":"Ant Paste","amount":4000},{"resource":"Wood","amount":1000},{"resource":"Aluminum","amount":6000},{"resource":"Microchip","amount":2000},{"resource":"Gold","amount":4000},{"resource":"Crystalline","amount":150}],
            "description":      "intpadthought-description",
            "produces":         null,
            "generates":        "Antaura",
            "generateTime":     9000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Water","amount":500},{"resource":"Antanium","amount":100},{"resource":"Ant Paste","amount":500}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":300},{"utility":"Bandwidth","amount":100}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    80,
            "requiresTech":     ["Insectoid Governance","Basic Network Infrastructure"],
            "canRenderStatic":  false,
            "entertains":       10,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":6,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Raw Materials Depot",
            "tile":             ["rawmatdepot"],
            "cost":             [{"resource":"Ore","amount":25}],
            "description":      "rawmatdepot-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ore","amount":5000},{"resource":"Charcoal","amount":5000},{"resource":"Gold","amount":5000},{"resource":"Regolith","amount":5000},{"resource":"Aluminum","amount":5000},{"resource":"Wood","amount":100}],
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          [{"input":"Wood","output":"Wood"},{"input":"Ore","output":"Ore"},{"input":"Charcoal","output":"Charcoal"},{"input":"Gold","output":"Gold"},{"input":"Regolith","output":"Regolith"},{"input":"Aluminum","output":"Aluminum"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Gravitational Compression Warehouse",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -0.1,
                    "y":    -0.1,
                    "r":    0.4,
                    "c":    "#007bff",
                    "i":    0.2,
                    "nightonly": true
                },
                {
                    "x":    0,
                    "y":    1.8,
                    "r":    0.4,
                    "c":    "#007bff",
                    "i":    0.2,
                    "nightonly": true
                },
                {
                    "x":    1.8,
                    "y":    0,
                    "r":    0.4,
                    "c":    "#007bff",
                    "i":    0.2,
                    "nightonly": true
                },
                {
                    "x":    1.6,
                    "y":    1.7,
                    "r":    0.4,
                    "c":    "#007bff",
                    "i":    0.2,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Advanced Command Post",
            "tile":             ["commandpost2"],
            "cost":             [{"resource":"Money","amount":2000},{"resource":"Ore","amount":5500},{"resource":"Water","amount":1800},{"resource":"Ant Paste","amount":2000},{"resource":"Antanium","amount":4000},{"resource":"Gold","amount":5000},{"resource":"Aluminum","amount":3000},{"resource":"Wood","amount":1000},{"resource":"Civics","amount":400}],
            "description":      "commandpost2-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1300,
            "generateAmount":   6,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":1280},{"resource":"Antanium","amount":880},{"resource":"Gold","amount":1800}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":10}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    80,
            "requiresTech":     ["Insectoid Bureaucracy"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      true,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     25000,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    4,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Unholy Command",
            "tile":             ["unholycommand"],
            "cost":             [{"resource":"Money","amount":20000},{"resource":"Wood","amount":3000},{"resource":"Ore","amount":15000},{"resource":"Water","amount":3000},{"resource":"Ant Paste","amount":4000},{"resource":"Antanium","amount":25000},{"resource":"Gold","amount":15000},{"resource":"Aluminum","amount":16000},{"resource":"Civics","amount":10000},{"resource":"Antaura","amount":6000},{"resource":"Alien Relic","amount":1000}],
            "description":      "unholycommand-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":850},{"resource":"Antanium","amount":1550},{"resource":"Gold","amount":950},{"resource":"Aluminum","amount":2500}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   50,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":14000,"ratio":300},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    60,
            "requiresTech":     ["Ancient Alien Language","Insectoid Bureaucracy","Mysticism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Deluxe Command",
            "transModeColor":   "#dddddd",
            "requiresFuel":     {"resource":"Antaura","rate":800},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     1000000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    7,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Deluxe Command",
            "tile":             ["deluxecommand"],
            "cost":             [{"resource":"Money","amount":150000},{"resource":"Wood","amount":40000},{"resource":"Ore","amount":100000},{"resource":"Water","amount":80000},{"resource":"Ant Paste","amount":120000},{"resource":"Antanium","amount":350000},{"resource":"Gold","amount":150000},{"resource":"Aluminum","amount":70000},{"resource":"Microchip","amount":1500},{"resource":"Pottery","amount":6000},{"resource":"Cloth","amount":25000},{"resource":"Software","amount":500},{"resource":"Oil","amount":10000},{"resource":"Obsidian","amount":35000},{"resource":"Civics","amount":90000},{"resource":"Antaura","amount":30000},{"resource":"Alien Relic","amount":7000},{"resource":"Starship","amount":2}],
            "description":      "deluxecommand-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":850},{"resource":"Antanium","amount":1550},{"resource":"Gold","amount":950},{"resource":"Aluminum","amount":2500}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":800},{"utility":"Bandwidth","amount":650}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   90,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":10000,"ratio":400},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    80,
            "requiresTech":     ["Ancient Alien Language","Insectoid Dominion","Mega Construction","Mysticism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     {"resource":"Antaura","rate":700},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     500000000,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    8,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Customs Processing",
            "tile":             ["customsprocessing"],
            "cost":             [{"resource":"Ore","amount":5500},{"resource":"Ant Paste","amount":1500},{"resource":"Antanium","amount":4000},{"resource":"Gold","amount":1750},{"resource":"Aluminum","amount":800},{"resource":"Wood","amount":1200},{"resource":"Cloth","amount":800},{"resource":"Civics","amount":50}],
            "description":      "customsprocessing-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        4,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":600},{"resource":"Antanium","amount":300},{"resource":"Gold","amount":300},{"resource":"Aluminum","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":40}],
            "colGenRate":       4000,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    80,
            "requiresTech":     ["Open Doors"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Food","Water","Sugar","Rum","Ant Paste","Wool","Wood","Clay","Charcoal","Regolith","Ore","Antanium","Gold","Aluminum","Oil","Helium 3","Toy","Uranium","Pottery","Bricks","Microchip","Robot","Alien Relic","Cloth","Crystalline","Alien Artifact","Obsidian","Steel","Diamond","Software"],
            "canExport":        ["Food","Water","Sugar","Rum","Ant Paste","Wool","Wood","Clay","Charcoal","Regolith","Ore","Antanium","Gold","Aluminum","Oil","Helium 3","Toy","Uranium","Pottery","Bricks","Microchip","Robot","Alien Relic","Cloth","Crystalline","Alien Artifact","Obsidian","Steel","Diamond","Software"],
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Civics","rate":1200},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Tourism"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   true,
            "tradeCapacity":    1000,
            "upkeepCost":       0.0,
            "giftCapacity":     1000,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    1.3,
                    "y":    0.05,
                    "r":    0.3,
                    "c":    "#9C27B0",
                    "i":    0.4,
                    "nightonly": true
                },
                {
                    "x":    3.3,
                    "y":    2.0,
                    "r":    0.3,
                    "c":    "#9C27B0",
                    "i":    0.4,
                    "nightonly": true
                },
                {
                    "x":    3.55,
                    "y":    0.15,
                    "r":    0.3,
                    "c":    "#4CAF50",
                    "i":    0.4,
                    "nightonly": true
                },
                {
                    "x":    1.3,
                    "y":    1.9,
                    "r":    0.3,
                    "c":    "#4CAF50",
                    "i":    0.4,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Paste Treatment Spa",
            "tile":             ["pastespa"],
            "cost":             [{"resource":"Ore","amount":500},{"resource":"Antanium","amount":1000},{"resource":"Wood","amount":300},{"resource":"Gold","amount":100},{"resource":"Ant Paste","amount":600}],
            "description":      "pastespa-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":12}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   4,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    7,
            "requiresTech":     ["Open Doors"],
            "canRenderStatic":  false,
            "entertains":       30,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Ant Paste","rate":1000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Tourism"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":6,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    30,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Crystal Vaporizer",
            "tile":             ["vaporizer"],
            "cost":             [{"resource":"Ore","amount":100},{"resource":"Crystalline","amount":50}],
            "description":      "vaporizer-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Water","amount":250}],
            "sellValue":        [{"resource":"Ore","amount":20},{"resource":"Crystalline","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Atmosphere,Crystalline","output":"Water","time":500,"ratio":12},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Pillar of Light",
            "tile":             ["pillaroflight"],
            "cost":             [{"resource":"Ore","amount":35},{"resource":"Antanium","amount":5},{"resource":"Gold","amount":5}],
            "description":      "pillaroflight-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    6,
                    "c":    "#e0f8ff",
                    "i":    0.45,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Draconian Prairie Weed",
            "tile":             ["prairieweed"],
            "cost":             [{"resource":"Water","amount":5}],
            "description":      "prairieweed-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    0,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Powered Materials Silo",
            "tile":             ["poweredmatsilo"],
            "cost":             [{"resource":"Antanium","amount":250},{"resource":"Aluminum","amount":250},{"resource":"Gold","amount":150},{"resource":"Uranium","amount":25}],
            "description":      "poweredmatsilo-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Software","amount":25000},{"resource":"Cobalt","amount":25000},{"resource":"Ether","amount":25000},{"resource":"Fish","amount":25000},{"resource":"Oil","amount":25000},{"resource":"Obsidian","amount":25000},{"resource":"Sugar","amount":25000},{"resource":"Food","amount":25000},{"resource":"Water","amount":25000},{"resource":"Steel","amount":25000},{"resource":"Wool","amount":25000},{"resource":"Rum","amount":25000},{"resource":"Pottery","amount":25000},{"resource":"Bricks","amount":25000},{"resource":"Cloth","amount":25000},{"resource":"Plastic","amount":25000},{"resource":"Toy","amount":25000},{"resource":"Microchip","amount":25000},{"resource":"Alien Artifact","amount":25000},{"resource":"Alien Relic","amount":25000},{"resource":"Robot","amount":25000},{"resource":"Ant Paste","amount":25000},{"resource":"Antanium","amount":25000},{"resource":"Wood","amount":25000},{"resource":"Crystalline","amount":25000},{"resource":"Diamond","amount":25000},{"resource":"Triantanium","amount":25000},{"resource":"Aluminum","amount":25000},{"resource":"Uranium","amount":25000},{"resource":"Gold","amount":25000},{"resource":"Clay","amount":25000},{"resource":"Ore","amount":25000},{"resource":"Regolith","amount":25000},{"resource":"Wheel","amount":25000}],
            "sellValue":        [{"resource":"Aluminum","amount":25},{"resource":"Gold","amount":15},{"resource":"Uranium","amount":2}],
            "sellWarning":      null,
            "refines":          [{"input":"Cobalt","output":"Cobalt"},{"input":"Ether","output":"Ether"},{"input":"Fish","output":"Fish"},{"input":"Uranium","output":"Uranium"},{"input":"Food","output":"Food"},{"input":"Water","output":"Water"},{"input":"Gold","output":"Gold"},{"input":"Aluminum","output":"Aluminum"},{"input":"Ore","output":"Ore"},{"input":"Wood","output":"Wood"},{"input":"Crystalline","output":"Crystalline"},{"input":"Oil","output":"Oil"},{"input":"Obsidian","output":"Obsidian"},{"input":"Sugar","output":"Sugar"},{"input":"Diamond","output":"Diamond"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":100}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    10,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Advanced Materials Silo",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Durable Goods","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.4,
                    "y":    0.15,
                    "r":    0.8,
                    "c":    "#00ccff",
                    "i":    0.1,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Advanced Materials Silo",
            "tile":             ["advmatsilo"],
            "cost":             [{"resource":"Antanium","amount":4000},{"resource":"Aluminum","amount":8000},{"resource":"Gold","amount":7000},{"resource":"Uranium","amount":2000},{"resource":"Obsidian","amount":2000},{"resource":"Crystalline","amount":3000},{"resource":"Oil","amount":1500},{"resource":"Microchip","amount":500}],
            "description":      "advmatsilo-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Software","amount":250000},{"resource":"Cobalt","amount":250000},{"resource":"Ether","amount":250000},{"resource":"Fish","amount":250000},{"resource":"Oil","amount":250000},{"resource":"Obsidian","amount":250000},{"resource":"Sugar","amount":250000},{"resource":"Food","amount":250000},{"resource":"Water","amount":250000},{"resource":"Steel","amount":250000},{"resource":"Wool","amount":250000},{"resource":"Rum","amount":250000},{"resource":"Pottery","amount":250000},{"resource":"Bricks","amount":250000},{"resource":"Cloth","amount":250000},{"resource":"Plastic","amount":250000},{"resource":"Toy","amount":250000},{"resource":"Microchip","amount":250000},{"resource":"Alien Artifact","amount":250000},{"resource":"Alien Relic","amount":250000},{"resource":"Robot","amount":250000},{"resource":"Ant Paste","amount":250000},{"resource":"Antanium","amount":250000},{"resource":"Wood","amount":250000},{"resource":"Crystalline","amount":250000},{"resource":"Diamond","amount":250000},{"resource":"Triantanium","amount":250000},{"resource":"Aluminum","amount":250000},{"resource":"Uranium","amount":250000},{"resource":"Gold","amount":250000},{"resource":"Clay","amount":250000},{"resource":"Ore","amount":250000},{"resource":"Regolith","amount":250000},{"resource":"Wheel","amount":250000}],
            "sellValue":        [{"resource":"Antanium","amount":400},{"resource":"Aluminum","amount":800},{"resource":"Gold","amount":700},{"resource":"Uranium","amount":20},{"resource":"Obsidian","amount":200},{"resource":"Crystalline","amount":30},{"resource":"Microchip","amount":5}],
            "sellWarning":      null,
            "refines":          [{"input":"Cobalt","output":"Cobalt"},{"input":"Ether","output":"Ether"},{"input":"Fish","output":"Fish"},{"input":"Uranium","output":"Uranium"},{"input":"Food","output":"Food"},{"input":"Water","output":"Water"},{"input":"Gold","output":"Gold"},{"input":"Aluminum","output":"Aluminum"},{"input":"Ore","output":"Ore"},{"input":"Wood","output":"Wood"},{"input":"Crystalline","output":"Crystalline"},{"input":"Oil","output":"Oil"},{"input":"Obsidian","output":"Obsidian"},{"input":"Sugar","output":"Sugar"},{"input":"Diamond","output":"Diamond"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":500}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Near-Infinite Materials Silo",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Durable Goods","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.4,
                    "y":    0.15,
                    "r":    0.8,
                    "c":    "#00ccff",
                    "i":    0.1,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Near-Infinite Materials Silo",
            "tile":             ["nimatsilo"],
            "cost":             [{"resource":"Triantanium","amount":3000},{"resource":"Antanium","amount":6000},{"resource":"Aluminum","amount":10000},{"resource":"Gold","amount":9000},{"resource":"Uranium","amount":4000},{"resource":"Obsidian","amount":4000},{"resource":"Crystalline","amount":5000},{"resource":"Oil","amount":3500},{"resource":"Microchip","amount":2500},{"resource":"Software","amount":500},{"resource":"Robot","amount":350},{"resource":"Ether","amount":750},{"resource":"Cobalt","amount":1500},{"resource":"Diamond","amount":2000}],
            "description":      "nimatsilo-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Software","amount":10000000},{"resource":"Cobalt","amount":10000000},{"resource":"Ether","amount":10000000},{"resource":"Fish","amount":10000000},{"resource":"Oil","amount":10000000},{"resource":"Obsidian","amount":10000000},{"resource":"Sugar","amount":10000000},{"resource":"Food","amount":10000000},{"resource":"Water","amount":10000000},{"resource":"Steel","amount":10000000},{"resource":"Wool","amount":10000000},{"resource":"Rum","amount":10000000},{"resource":"Pottery","amount":10000000},{"resource":"Bricks","amount":10000000},{"resource":"Cloth","amount":10000000},{"resource":"Plastic","amount":10000000},{"resource":"Toy","amount":10000000},{"resource":"Microchip","amount":10000000},{"resource":"Alien Artifact","amount":10000000},{"resource":"Alien Relic","amount":10000000},{"resource":"Robot","amount":10000000},{"resource":"Ant Paste","amount":10000000},{"resource":"Antanium","amount":10000000},{"resource":"Wood","amount":10000000},{"resource":"Crystalline","amount":10000000},{"resource":"Diamond","amount":10000000},{"resource":"Triantanium","amount":10000000},{"resource":"Aluminum","amount":10000000},{"resource":"Uranium","amount":10000000},{"resource":"Gold","amount":10000000},{"resource":"Clay","amount":10000000},{"resource":"Ore","amount":10000000},{"resource":"Regolith","amount":10000000},{"resource":"Wheel","amount":10000000}],
            "sellValue":        [{"resource":"Antanium","amount":600},{"resource":"Aluminum","amount":1000},{"resource":"Gold","amount":900},{"resource":"Uranium","amount":40},{"resource":"Obsidian","amount":400},{"resource":"Crystalline","amount":5},{"resource":"Microchip","amount":25},{"resource":"Cobalt","amount":150}],
            "sellWarning":      null,
            "refines":          [{"input":"Cobalt","output":"Cobalt"},{"input":"Ether","output":"Ether"},{"input":"Fish","output":"Fish"},{"input":"Uranium","output":"Uranium"},{"input":"Food","output":"Food"},{"input":"Water","output":"Water"},{"input":"Gold","output":"Gold"},{"input":"Aluminum","output":"Aluminum"},{"input":"Ore","output":"Ore"},{"input":"Wood","output":"Wood"},{"input":"Crystalline","output":"Crystalline"},{"input":"Oil","output":"Oil"},{"input":"Obsidian","output":"Obsidian"},{"input":"Sugar","output":"Sugar"},{"input":"Diamond","output":"Diamond"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":600}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Robot,Ether,Software,Uranium","rate":900},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Durable Goods","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.4,
                    "y":    0.15,
                    "r":    0.8,
                    "c":    "#00ccff",
                    "i":    0.1,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "High Frequency Node",
            "tile":             ["hfnode"],
            "cost":             [{"resource":"Antanium","amount":250},{"resource":"Aluminum","amount":250},{"resource":"Gold","amount":150},{"resource":"Uranium","amount":25}],
            "description":      "hfnode-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Aluminum","amount":25},{"resource":"Gold","amount":15},{"resource":"Uranium","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Bandwidth","amount":60}],
            "requiresUtility":  [{"utility":"Power","amount":160}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    10,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   true,
            "buildCategories":  ["All Buildings","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ultra High Frequency Node",
            "tile":             ["uhfnode"],
            "cost":             [{"resource":"Antanium","amount":1500},{"resource":"Aluminum","amount":1500},{"resource":"Gold","amount":1250},{"resource":"Uranium","amount":250},{"resource":"Microchip","amount":300},{"resource":"Software","amount":200},{"resource":"Clay","amount":100},{"resource":"Obsidian","amount":100}],
            "description":      "uhfnode-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Aluminum","amount":25},{"resource":"Gold","amount":15},{"resource":"Uranium","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Bandwidth","amount":900}],
            "requiresUtility":  [{"utility":"Power","amount":500}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   true,
            "buildCategories":  ["All Buildings","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Microdistiller",
            "tile":             ["microdistiller"],
            "cost":             [{"resource":"Antanium","amount":25},{"resource":"Gold","amount":200},{"resource":"Aluminum","amount":200}],
            "description":      "microdistiller-description",
            "produces":         null,
            "generates":        "Salt Water",
            "generateTime":     300,
            "generateAmount":   25,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Salt Water","amount":150},{"resource":"Water","amount":150}],
            "sellValue":        [{"resource":"Antanium","amount":2},{"resource":"Gold","amount":20},{"resource":"Aluminum","amount":20}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":100}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Salt Water","output":"Water","time":500,"ratio":4},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Water World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#03A9F4",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     ["Salt Water"]
        },
        {
            "name":             "Coral Radiator",
            "tile":             ["coralradiator"],
            "cost":             [{"resource":"Antanium","amount":100},{"resource":"Gold","amount":250},{"resource":"Aluminum","amount":250}],
            "description":      "coralradiator-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Salt Water","amount":150},{"resource":"Water","amount":150}],
            "sellValue":        [{"resource":"Antanium","amount":2},{"resource":"Gold","amount":20},{"resource":"Aluminum","amount":20}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":600}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Uranium","output":"Ore|Ore|Gold|Gold|Aluminum","time":1000,"ratio":10},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Water World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#03A9F4",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     ["Salt Water"]
        },
        {
            "name":             "Gold Reducer",
            "tile":             ["goldreducer"],
            "cost":             [{"resource":"Antanium","amount":20},{"resource":"Aluminum","amount":100},{"resource":"Gold","amount":100},{"resource":"Wood","amount":300},{"resource":"Sugar","amount":100},{"resource":"Uranium","amount":25}],
            "description":      "goldreducer-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     5000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Gold","amount":400},{"resource":"Sugar","amount":400},{"resource":"Ore","amount":550}],
            "sellValue":        [{"resource":"Aluminum","amount":25},{"resource":"Gold","amount":15},{"resource":"Uranium","amount":2}],
            "sellWarning":      null,
            "refines":          [{"input":"Sugar","output":"Sugar"},{"input":"Gold","output":"Gold"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":80}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Gold","output":"Ore","time":8000,"ratio":120},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    10,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Sugar","rate":300},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Slave Gate",
            "tile":             ["slavegate"],
            "cost":             [{"resource":"Antanium","amount":300},{"resource":"Gold","amount":300},{"resource":"Aluminum","amount":300}],
            "description":      "slavegate-description",
            "produces":         ["Enslaved Worker Drone","Enslaved Waterbug","Enslaved Fisherbug","Enslaved Orebug","Enslaved Goldbug","Enslaved Lumberbug","Enslaved Alumibug","Enslaved Obsidiobug","Enslaved Extremeobug"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Antanium","amount":30},{"resource":"Gold","amount":30},{"resource":"Aluminum","amount":30}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":400}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    20,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -2.2,
                    "y":    -2.5,
                    "r":    0.45,
                    "c":    "#00ccff",
                    "i":    0.1,
                    "nightonly": true
                },
                {
                    "x":    -2.2,
                    "y":    -1.0,
                    "r":    0.45,
                    "c":    "#00ccff",
                    "i":    0.1,
                    "nightonly": true
                },
                {
                    "x":    -0.5,
                    "y":    -0.25,
                    "r":    1.2,
                    "c":    "#0066ff",
                    "i":    0.15,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Fair Warning",
            "tile":             ["fairwarning"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Antanium","amount":200},{"resource":"Gold","amount":150},{"resource":"Wood","amount":10}],
            "description":      "fairwarning-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           true,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Antanium Impactor",
            "tile":             ["antaniumimpactor"],
            "cost":             [{"resource":"Ore","amount":1300},{"resource":"Gold","amount":650},{"resource":"Aluminum","amount":400},{"resource":"Uranium","amount":40}],
            "description":      "antaniumimpactor-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Antanium","amount":1500},{"resource":"Ore","amount":2000},{"resource":"Gold","amount":2000}],
            "sellValue":        [{"resource":"Ore","amount":150},{"resource":"Gold","amount":40},{"resource":"Aluminum","amount":40},{"resource":"Uranium","amount":4}],
            "sellWarning":      null,
            "refines":          [{"input":"Ore","output":"Ore"},{"input":"Gold","output":"Gold"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":700}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Ore","output":"Antanium","time":500,"ratio":25},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    25,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Integrated Antanium Impactor",
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Gold","rate":250},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.4,
                    "y":    0.75,
                    "r":    0.65,
                    "c":    "#00ccff",
                    "i":    0.1,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Integrated Antanium Impactor",
            "tile":             ["antaniumimpactor2"],
            "cost":             [{"resource":"Ore","amount":2300},{"resource":"Gold","amount":1650},{"resource":"Aluminum","amount":1400},{"resource":"Uranium","amount":140},{"resource":"Microchip","amount":200},{"resource":"Obsidian","amount":200}],
            "description":      "antaniumimpactor2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Antanium","amount":1500},{"resource":"Ore","amount":2000},{"resource":"Gold","amount":2000}],
            "sellValue":        [{"resource":"Ore","amount":150},{"resource":"Gold","amount":40},{"resource":"Aluminum","amount":40},{"resource":"Uranium","amount":4}],
            "sellWarning":      null,
            "refines":          [{"input":"Ore","output":"Ore"},{"input":"Gold","output":"Gold"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":900},{"utility":"Bandwidth","amount":15}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Ore,Microchip","output":"Antanium","time":200,"ratio":45},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    35,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Gold","rate":250},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.4,
                    "y":    0.75,
                    "r":    0.65,
                    "c":    "#00ccff",
                    "i":    0.1,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Microcondenser",
            "tile":             ["microcondenser"],
            "cost":             [{"resource":"Ore","amount":2000},{"resource":"Antanium","amount":1000},{"resource":"Gold","amount":900},{"resource":"Aluminum","amount":800},{"resource":"Uranium","amount":200}],
            "description":      "microcondenser-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":200},{"resource":"Antanium","amount":100},{"resource":"Gold","amount":90},{"resource":"Aluminum","amount":80},{"resource":"Uranium","amount":20}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":250}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Atmosphere","output":"Water","time":750,"ratio":200},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    70,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.0,
                    "y":    0.0,
                    "r":    0.75,
                    "c":    "#00ccff",
                    "i":    0.1,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Basic Den",
            "tile":             ["basicden"],
            "cost":             [{"resource":"Ore","amount":100},{"resource":"Antanium","amount":50}],
            "description":      "basicden-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":10},{"resource":"Antanium","amount":5}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2}],
            "colGenRate":       0,
            "providesShelter":  1,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Family Den",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Family Den",
            "tile":             ["familyden"],
            "cost":             [{"resource":"Ore","amount":150},{"resource":"Antanium","amount":90},{"resource":"Aluminum","amount":10},{"resource":"Uranium","amount":2}],
            "description":      "familyden-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":15},{"resource":"Antanium","amount":9},{"resource":"Aluminum","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3}],
            "colGenRate":       0,
            "providesShelter":  3,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    5,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Patricians Den",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Patricians Den",
            "tile":             ["patriden"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Antanium","amount":200},{"resource":"Aluminum","amount":200},{"resource":"Uranium","amount":5},{"resource":"Obsidian","amount":15},{"resource":"Painting","amount":4}],
            "description":      "patriden-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":20},{"resource":"Antanium","amount":20},{"resource":"Aluminum","amount":20},{"resource":"Uranium","amount":1},{"resource":"Obsidian","amount":15},{"resource":"Painting","amount":4}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":5}],
            "colGenRate":       0,
            "providesShelter":  12,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 8,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Potters Den",
            "tile":             ["clayden"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Antanium","amount":200},{"resource":"Aluminum","amount":200},{"resource":"Uranium","amount":5},{"resource":"Obsidian","amount":15},{"resource":"Painting","amount":4},{"resource":"Clay","amount":250}],
            "description":      "clayden-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2000,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Clay","amount":500},{"resource":"Pottery","amount":500}],
            "sellValue":        [{"resource":"Ore","amount":20},{"resource":"Antanium","amount":20},{"resource":"Aluminum","amount":20},{"resource":"Uranium","amount":1},{"resource":"Obsidian","amount":15},{"resource":"Painting","amount":4}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":350}],
            "colGenRate":       0,
            "providesShelter":  6,
            "canChain":         true,
            "acceptsWorkers":   1,
            "requiresWorkers":  false,
            "smelts":           {"input":"Clay,Water","output":"Pottery","time":2000,"ratio":30},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 8,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Homeless Shelter",
            "tile":             ["homelessshelter"],
            "cost":             [{"resource":"Aluminum","amount":100},{"resource":"Antanium","amount":50},{"resource":"Ant Paste","amount":6},{"resource":"Oil","amount":40},{"resource":"Painting","amount":1},{"resource":"Pottery","amount":3}],
            "description":      "homelessshelter-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     4000,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Aluminum","amount":10},{"resource":"Antanium","amount":5}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  40,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Water,Food,Pottery,Ant Paste","rate":1200},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         40,
            "providesIQ":       85,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Subterranean Slum",
            "tile":             ["subslum"],
            "cost":             [{"resource":"Water","amount":4000},{"resource":"Aluminum","amount":2500},{"resource":"Antanium","amount":3000},{"resource":"Ant Paste","amount":1500},{"resource":"Oil","amount":450},{"resource":"Painting","amount":25},{"resource":"Pottery","amount":150},{"resource":"Clay","amount":1250}],
            "description":      "subslum-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2000,
            "generateAmount":   8,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Aluminum","amount":250},{"resource":"Antanium","amount":300},{"resource":"Ant Paste","amount":15},{"resource":"Oil","amount":4},{"resource":"Painting","amount":2},{"resource":"Pottery","amount":1},{"resource":"Clay","amount":12}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":350},{"utility":"Bandwidth","amount":150}],
            "colGenRate":       0,
            "providesShelter":  350,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    25,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Water,Food,Pottery,Ant Paste","rate":450},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Offshore Slum",
            "tile":             ["offshoreslum"],
            "cost":             [{"resource":"Aluminum","amount":200},{"resource":"Antanium","amount":150},{"resource":"Ant Paste","amount":60},{"resource":"Oil","amount":70},{"resource":"Painting","amount":1},{"resource":"Pottery","amount":8}],
            "description":      "offshoreslum-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     3500,
            "generateAmount":   1,
            "tileWidth":        4,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Aluminum","amount":10},{"resource":"Antanium","amount":5}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  90,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     ["Water World Base|Abandoned World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Water,Food,Pottery,Ant Paste","rate":1000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         40,
            "providesIQ":       85,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     ["Salt Water","Ether"]
        },
        {
            "name":             "Ether Baths",
            "tile":             ["etherbath"],
            "cost":             [{"resource":"Aluminum","amount":300},{"resource":"Antanium","amount":150},{"resource":"Ant Paste","amount":100},{"resource":"Ether","amount":500},{"resource":"Painting","amount":20},{"resource":"Pottery","amount":30}],
            "description":      "etherbath-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ether","amount":2000}],
            "sellValue":        [{"resource":"Aluminum","amount":10},{"resource":"Antanium","amount":5}],
            "sellWarning":      null,
            "refines":          [{"input":"Ether","output":"Ether"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":250}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    20,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       20,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Ether","rate":1200},
            "heals":            20,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Entertainment"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":10,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    20,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Raw Fish Diner",
            "tile":             ["rawfishdiner"],
            "cost":             [{"resource":"Money","amount":300},{"resource":"Rum","amount":60},{"resource":"Wood","amount":150},{"resource":"Ore","amount":600},{"resource":"Antanium","amount":700},{"resource":"Gold","amount":400},{"resource":"Aluminum","amount":200},{"resource":"Fish","amount":60},{"resource":"Microchip","amount":4}],
            "description":      "rawfishdiner-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Fish","amount":60},{"resource":"Fish","amount":60}],
            "sellValue":        [{"resource":"Ore","amount":200}],
            "sellWarning":      null,
            "refines":          [{"input":"Fish","output":"Fish"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":60},{"utility":"Bandwidth","amount":5}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   4,
            "requiresWorkers":  true,
            "smelts":           {"input":"Fish","output":"Money","time":800,"ratio":20},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    12,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       12,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#b38600",
            "requiresFuel":     {"resource":"Rum,Fish","rate":550},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Entertainment","Tourism"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":35,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    12,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Medium Range Star Gate",
            "tile":             ["medstargate"],
            "cost":             [{"resource":"Ore","amount":2000},{"resource":"Antanium","amount":2000},{"resource":"Gold","amount":1000},{"resource":"Aluminum","amount":1000},{"resource":"Uranium","amount":200}],
            "description":      "medstargate-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":200},{"resource":"Antanium","amount":200},{"resource":"Gold","amount":100},{"resource":"Aluminum","amount":100},{"resource":"Uranium","amount":20}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1000}],
            "colGenRate":       6000,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":"tut-medstargate",
            "isChopShop":       false,
            "earthTaxValue":    80,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Food","Water","Sugar","Rum","Wood","Ore","Antanium","Gold","Aluminum","Oil","Diamond","Uranium","Crystalline","Obsidian","Ant Paste","Pottery","Steel","Bricks","Plastic","Software"],
            "canExport":        ["Fish","Salt Water","Food","Water","Sugar","Rum","Wood","Ore","Antanium","Gold","Aluminum","Oil","Diamond","Uranium","Crystalline","Obsidian","Ant Paste","Pottery","Steel","Bricks","Ether","Plastic","Software"],
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Galactic Star Gate",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   true,
            "buildCategories":  ["All Buildings","Economy","Immigration","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   true,
            "tradeCapacity":    100,
            "upkeepCost":       0.0,
            "giftCapacity":     1000,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       true,
            "lightEffects":     [
                {
                    "x":    -0.5,
                    "y":    0.5,
                    "r":    1.6,
                    "c":    "#1E88E5",
                    "i":    0.2,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Galactic Star Gate",
            "tile":             ["galacticstargate"],
            "cost":             [{"resource":"Ore","amount":20000},{"resource":"Antanium","amount":20000},{"resource":"Gold","amount":10000},{"resource":"Aluminum","amount":10000},{"resource":"Uranium","amount":2000},{"resource":"Obsidian","amount":30000},{"resource":"Software","amount":400},{"resource":"Microchip","amount":9000},{"resource":"Diamond","amount":600}],
            "description":      "galacticstargate-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":2000},{"resource":"Antanium","amount":2000},{"resource":"Gold","amount":1000},{"resource":"Aluminum","amount":1000},{"resource":"Uranium","amount":20},{"resource":"Obsidian","amount":3000},{"resource":"Microchip","amount":90},{"resource":"Diamond","amount":60}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2000},{"utility":"Bandwidth","amount":250}],
            "colGenRate":       2000,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    180,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Food","Water","Sugar","Rum","Wood","Ore","Antanium","Gold","Aluminum","Oil","Diamond","Uranium","Crystalline","Obsidian","Ant Paste","Pottery","Steel","Bricks","Plastic","Software","Helium 3","Microchip","Painting","Cloth"],
            "canExport":        ["Fish","Salt Water","Food","Water","Sugar","Rum","Wood","Ore","Antanium","Gold","Aluminum","Oil","Diamond","Uranium","Crystalline","Obsidian","Ant Paste","Pottery","Steel","Bricks","Ether","Plastic","Software","Helium 3","Microchip","Painting","Cloth"],
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   true,
            "buildCategories":  ["All Buildings","Economy","Immigration","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   true,
            "tradeCapacity":    50000,
            "upkeepCost":       0.0,
            "giftCapacity":     50000,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       true,
            "lightEffects":     [
                {
                    "x":    -0.5,
                    "y":    0.5,
                    "r":    1.6,
                    "c":    "#1E88E5",
                    "i":    0.2,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Torture Booth",
            "tile":             ["torturebooth"],
            "cost":             [{"resource":"Money","amount":100},{"resource":"Ore","amount":250},{"resource":"Antanium","amount":250},{"resource":"Gold","amount":150}],
            "description":      "torturebooth-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":25},{"resource":"Antanium","amount":25},{"resource":"Gold","amount":15}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":400}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       6,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Entertainment"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Live Autopsy Slab",
            "tile":             ["autopsyslab"],
            "cost":             [{"resource":"Money","amount":150},{"resource":"Ore","amount":350},{"resource":"Antanium","amount":350},{"resource":"Microchip","amount":25}],
            "description":      "autopsyslab-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1000,
            "generateAmount":   10,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Money","amount":10},{"resource":"Ore","amount":35},{"resource":"Antanium","amount":35},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":250},{"utility":"Bandwidth","amount":15}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   1,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       25,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Entertainment","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         6,
            "providesIQ":       120,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Drone Pad",
            "tile":             ["dronepad"],
            "cost":             [{"resource":"Ore","amount":350},{"resource":"Antanium","amount":350},{"resource":"Gold","amount":350}],
            "description":      "dronepad-description",
            "produces":         ["Construction Probe","Uranium Extractor","Crude Extractor","Ether Extractor","Diamond Extractor","Cobalt Extractor"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":35},{"resource":"Antanium","amount":35},{"resource":"Gold","amount":35}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":500}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       true,
            "earthTaxValue":    30,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Gold Grower",
            "tile":             ["goldgrower"],
            "cost":             [{"resource":"Ore","amount":5000},{"resource":"Uranium","amount":250},{"resource":"Aluminum","amount":250},{"resource":"Crystalline","amount":1000}],
            "description":      "goldgrower-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Gold","amount":15000}],
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Uranium","amount":25},{"resource":"Aluminum","amount":25},{"resource":"Crystalline","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":700}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Ore,Crystalline","output":"Gold","time":1000,"ratio":35},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Aluminum Grower",
            "tile":             ["aluminumgrower"],
            "cost":             [{"resource":"Ore","amount":5000},{"resource":"Uranium","amount":250},{"resource":"Gold","amount":250},{"resource":"Crystalline","amount":1000}],
            "description":      "aluminumgrower-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Aluminum","amount":15000}],
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Uranium","amount":25},{"resource":"Gold","amount":25},{"resource":"Crystalline","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":700}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Ore,Crystalline,Uranium","output":"Aluminum","time":2000,"ratio":35},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ether Processor",
            "tile":             ["etherprocessor"],
            "cost":             [{"resource":"Ore","amount":5000},{"resource":"Antanium","amount":250},{"resource":"Gold","amount":250},{"resource":"Ant Paste","amount":1000},{"resource":"Ether","amount":1000}],
            "description":      "etherprocessor-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ether","amount":15000}],
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Uranium","amount":25},{"resource":"Gold","amount":25},{"resource":"Crystalline","amount":100}],
            "sellWarning":      null,
            "refines":          [{"input":"Ether","output":"Ether"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":700}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Ether","output":"Uranium|Water|Water|Water|Water|Water|Water","time":2000,"ratio":18},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Petroboiler",
            "tile":             ["petroboiler"],
            "cost":             [{"resource":"Ore","amount":5000},{"resource":"Antanium","amount":250},{"resource":"Gold","amount":250},{"resource":"Ant Paste","amount":1000},{"resource":"Ether","amount":1000}],
            "description":      "petroboiler-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ether","amount":500},{"resource":"Oil","amount":1500}],
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Uranium","amount":25},{"resource":"Gold","amount":25},{"resource":"Crystalline","amount":100}],
            "sellWarning":      null,
            "refines":          [{"input":"Ether","output":"Ether"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":700}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Ether","output":"Oil","time":1500,"ratio":6},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Trash Transporter",
            "tile":             ["trashtransporter"],
            "cost":             [{"resource":"Ore","amount":1000},{"resource":"Antanium","amount":300},{"resource":"Gold","amount":600},{"resource":"Aluminum","amount":600},{"resource":"Crystalline","amount":100}],
            "description":      "trashtransporter-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":100},{"resource":"Antanium","amount":30},{"resource":"Gold","amount":60},{"resource":"Aluminum","amount":60},{"resource":"Crystalline","amount":10}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":700}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    45,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Trash","rate":20},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Waste Management"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Paste Extractor",
            "tile":             ["pasteextractor"],
            "cost":             [{"resource":"Ore","amount":900},{"resource":"Antanium","amount":600},{"resource":"Gold","amount":600},{"resource":"Aluminum","amount":600},{"resource":"Uranium","amount":60}],
            "description":      "pasteextractor-description",
            "produces":         null,
            "generates":        "Ant Paste",
            "generateTime":     700,
            "generateAmount":   5,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ant Paste","amount":50}],
            "sellValue":        [{"resource":"Ore","amount":90},{"resource":"Antanium","amount":60},{"resource":"Gold","amount":60},{"resource":"Aluminum","amount":60},{"resource":"Uranium","amount":6}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":250}],
            "colGenRate":       null,
            "providesShelter":  null,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Square of Arbitration",
            "tile":             ["arbsquare1","arbsquare2"],
            "cost":             [{"resource":"Ore","amount":1200},{"resource":"Antanium","amount":300},{"resource":"Gold","amount":200},{"resource":"Aluminum","amount":200},{"resource":"Ant Paste","amount":100}],
            "description":      "arbsquare-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":2600},{"resource":"Steel","amount":1400},{"resource":"Gold","amount":800}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":25}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   1,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":1000,"ratio":5},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    55,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Arbiter",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Dracarus Mint",
            "tile":             ["dracarus"],
            "cost":             [{"resource":"Ore","amount":2200},{"resource":"Antanium","amount":100},{"resource":"Aluminum","amount":50}],
            "description":      "dracarus-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Gold","amount":10000}],
            "sellValue":        [{"resource":"Ore","amount":900},{"resource":"Antanium","amount":40}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":20}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   2,
            "requiresWorkers":  false,
            "smelts":           {"input":"Gold,Ore,Ore","output":"Money","time":700,"ratio":20},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    25,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Insectoid Mining Operation",
            "tile":             ["miningoperation"],
            "cost":             [{"resource":"Water","amount":1500},{"resource":"Antanium","amount":450},{"resource":"Ant Paste","amount":1500}],
            "description":      "miningoperation-description",
            "produces":         null,
            "generates":        "Gold",
            "generateTime":     2000,
            "generateAmount":   6,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ore","amount":3500},{"resource":"Gold","amount":3500}],
            "sellValue":        [{"resource":"Water","amount":500},{"resource":"Antanium","amount":100},{"resource":"Ant Paste","amount":500}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Water","output":"Ore","time":2000,"ratio":6},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    40,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Raw Materials Extractor",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Raw Materials Extractor",
            "tile":             ["rawmatextract"],
            "cost":             [{"resource":"Money","amount":5000},{"resource":"Water","amount":3000},{"resource":"Antanium","amount":15000},{"resource":"Ant Paste","amount":3000},{"resource":"Obsidian","amount":4000},{"resource":"Helium 3","amount":2500},{"resource":"Crystalline","amount":10000},{"resource":"Uranium","amount":2000},{"resource":"Microchip","amount":1000},{"resource":"Aluminum","amount":1000},{"resource":"Civics","amount":10000}],
            "description":      "rawmatextract-description",
            "produces":         null,
            "generates":        "Ore",
            "generateTime":     2000,
            "generateAmount":   10,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ore","amount":500},{"resource":"Gold","amount":500},{"resource":"Uranium","amount":500},{"resource":"Aluminum","amount":500}],
            "sellValue":        [{"resource":"Antanium","amount":1500},{"resource":"Ant Paste","amount":3},{"resource":"Obsidian","amount":400},{"resource":"Helium 3","amount":25},{"resource":"Crystalline","amount":100},{"resource":"Uranium","amount":200},{"resource":"Microchip","amount":10},{"resource":"Aluminum","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3000}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Crystalline","output":"Ore|Ore|Ore|Ore|Gold|Gold|Gold|Uranium|Uranium|Aluminum|Oil|Clay|Regolith|Diamond","time":200,"ratio":15},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    80,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Deep Sea Drilling Platform",
            "tile":             ["deepdrilling"],
            "cost":             [{"resource":"Wood","amount":1000},{"resource":"Ant Paste","amount":1000},{"resource":"Aluminum","amount":1500},{"resource":"Ore","amount":5500},{"resource":"Antanium","amount":5500},{"resource":"Gold","amount":4000},{"resource":"Uranium","amount":400}],
            "description":      "deepdrilling-description",
            "produces":         null,
            "generates":        "Oil",
            "generateTime":     1200,
            "generateAmount":   8,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Oil","amount":3000}],
            "sellValue":        [{"resource":"Aluminum","amount":150},{"resource":"Ore","amount":550},{"resource":"Antanium","amount":550},{"resource":"Gold","amount":400},{"resource":"Aluminum","amount":450}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":550}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Water World Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     ["Salt Water"]
        },
        {
            "name":             "Ore Evaporator",
            "tile":             ["oreevaporator"],
            "cost":             [{"resource":"Ore","amount":5000},{"resource":"Uranium","amount":250},{"resource":"Gold","amount":250},{"resource":"Aluminum","amount":250},{"resource":"Crystalline","amount":1000}],
            "description":      "oreevaporator-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Helium 3","amount":5000}],
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Uranium","amount":25},{"resource":"Gold","amount":25},{"resource":"Aluminum","amount":20},{"resource":"Crystalline","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":750}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Ore,Crystalline","output":"Helium 3","time":1500,"ratio":8},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Regeneration Chamber",
            "tile":             ["regenchamber"],
            "cost":             [{"resource":"Ore","amount":600},{"resource":"Antanium","amount":200},{"resource":"Ant Paste","amount":200},{"resource":"Gold","amount":80},{"resource":"Uranium","amount":30},{"resource":"Helium 3","amount":50},{"resource":"Civics","amount":50}],
            "description":      "regenchamber-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":60},{"resource":"Antanium","amount":20},{"resource":"Ant Paste","amount":20},{"resource":"Gold","amount":8},{"resource":"Uranium","amount":3}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":100}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            1,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Medical"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ant Paste Rejuvenation Clinic",
            "tile":             ["pasteclinic"],
            "cost":             [{"resource":"Ore","amount":4000},{"resource":"Antanium","amount":2500},{"resource":"Ant Paste","amount":6000},{"resource":"Gold","amount":2500},{"resource":"Uranium","amount":300},{"resource":"Helium 3","amount":1200},{"resource":"Civics","amount":4000},{"resource":"Software","amount":700},{"resource":"Pottery","amount":100}],
            "description":      "pasteclinic-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":60},{"resource":"Antanium","amount":20},{"resource":"Ant Paste","amount":20},{"resource":"Gold","amount":8},{"resource":"Uranium","amount":3}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":500},{"utility":"Bandwidth","amount":20}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   25,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    60,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Software,Ant Paste,Water","rate":1000},
            "heals":            150,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Medical"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Charcoal Converter",
            "tile":             ["coalconvert"],
            "cost":             [{"resource":"Ore","amount":500},{"resource":"Steel","amount":2000},{"resource":"Charcoal","amount":4000},{"resource":"Gold","amount":4500},{"resource":"Microchip","amount":9000},{"resource":"Aluminum","amount":400},{"resource":"Uranium","amount":40},{"resource":"Alien Artifact","amount":10}],
            "description":      "coalconvert-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ore","amount":500},{"resource":"Charcoal","amount":500}],
            "sellValue":        [{"resource":"Ore","amount":50},{"resource":"Steel","amount":200},{"resource":"Charcoal","amount":40},{"resource":"Gold","amount":450},{"resource":"Microchip","amount":9},{"resource":"Aluminum","amount":40},{"resource":"Uranium","amount":4},{"resource":"Alien Artifact","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":500}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Charcoal","output":"Ore","time":50,"ratio":250},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Ancient Alien Language"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Water,Uranium","rate":2500},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Brewmasters Den",
            "tile":             ["brewmasterden"],
            "cost":             [{"resource":"Water","amount":200},{"resource":"Ore","amount":600},{"resource":"Antanium","amount":200},{"resource":"Aluminum","amount":500},{"resource":"Uranium","amount":800},{"resource":"Oil","amount":400}],
            "description":      "brewmasterden-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Rum","amount":500}],
            "sellValue":        [{"resource":"Water","amount":20},{"resource":"Ore","amount":60},{"resource":"Antanium","amount":20},{"resource":"Aluminum","amount":50},{"resource":"Uranium","amount":80},{"resource":"Oil","amount":4}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":800}],
            "colGenRate":       0,
            "providesShelter":  1,
            "canChain":         true,
            "acceptsWorkers":   1,
            "requiresWorkers":  true,
            "smelts":           {"input":"Ant Paste,Oil,Water","output":"Rum","time":2000,"ratio":80},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    40,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Brewmaster",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#b38600",
            "requiresFuel":     {"resource":"Water","rate":800},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Durable Goods"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Coders Den",
            "tile":             ["codersden"],
            "cost":             [{"resource":"Water","amount":250},{"resource":"Ore","amount":650},{"resource":"Antanium","amount":250},{"resource":"Aluminum","amount":550},{"resource":"Uranium","amount":850},{"resource":"Helium 3","amount":950},{"resource":"Oil","amount":450},{"resource":"Crystalline","amount":200},{"resource":"Microchip","amount":20}],
            "description":      "codersden-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Software","amount":200}],
            "sellValue":        [{"resource":"Ore","amount":65},{"resource":"Antanium","amount":25},{"resource":"Aluminum","amount":55},{"resource":"Uranium","amount":85},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":850},{"utility":"Bandwidth","amount":15}],
            "colGenRate":       0,
            "providesShelter":  1,
            "canChain":         true,
            "acceptsWorkers":   1,
            "requiresWorkers":  true,
            "smelts":           {"input":"Microchip","output":"Software","time":2000,"ratio":4},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       90,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Automated Software Node",
            "tile":             ["autoswnode"],
            "cost":             [{"resource":"Regolith","amount":900},{"resource":"Ore","amount":900},{"resource":"Antanium","amount":1500},{"resource":"Aluminum","amount":900},{"resource":"Uranium","amount":800},{"resource":"Helium 3","amount":1500},{"resource":"Oil","amount":300},{"resource":"Crystalline","amount":150},{"resource":"Robot","amount":1},{"resource":"Obsidian","amount":1200}],
            "description":      "autoswnode-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Software","amount":1500}],
            "sellValue":        [{"resource":"Ore","amount":65},{"resource":"Antanium","amount":25},{"resource":"Aluminum","amount":55},{"resource":"Uranium","amount":85},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":950},{"utility":"Bandwidth","amount":55}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Microchip,Microchip,Microchip,Robot","output":"Software","time":1500,"ratio":75},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Council of Arbiters",
            "tile":             ["councilarb"],
            "cost":             [{"resource":"Ant Paste","amount":500},{"resource":"Ore","amount":6500},{"resource":"Antanium","amount":3500},{"resource":"Gold","amount":2500},{"resource":"Helium 3","amount":10},{"resource":"Civics","amount":150}],
            "description":      "councilarb-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1500,
            "generateAmount":   3,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":650},{"resource":"Antanium","amount":350},{"resource":"Gold","amount":250},{"resource":"Helium 3","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":300}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   3,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Arbiter",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   true,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      true,
            "isEmbassy":        false,
            "buildLimit":       1,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     300,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    1,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Chamber of Laws",
            "tile":             ["lawchamber"],
            "cost":             [{"resource":"Ant Paste","amount":1500},{"resource":"Ore","amount":16000},{"resource":"Water","amount":1200},{"resource":"Crystalline","amount":1200},{"resource":"Antanium","amount":14000},{"resource":"Gold","amount":9000},{"resource":"Aluminum","amount":2000},{"resource":"Microchip","amount":950},{"resource":"Painting","amount":100},{"resource":"Helium 3","amount":100},{"resource":"Obsidian","amount":1000},{"resource":"Civics","amount":3000}],
            "description":      "lawchamber-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        8,
            "tileHeight":       5,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":1600},{"resource":"Crystalline","amount":12},{"resource":"Antanium","amount":1400},{"resource":"Gold","amount":900},{"resource":"Aluminum","amount":200},{"resource":"Microchip","amount":9},{"resource":"Obsidian","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":900}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   60,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":14000,"ratio":65},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    60,
            "requiresTech":     [],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Arbiter",
            "indicator":        null,
            "canUpgradeTo":     "Chamber of our Fathers",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   true,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     3000,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    2,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Foreign Outpost",
            "tile":             ["dracemb"],
            "cost":             [{"resource":"Ore","amount":3500},{"resource":"Antanium","amount":3000},{"resource":"Gold","amount":1000},{"resource":"Ant Paste","amount":100},{"resource":"Microchip","amount":80},{"resource":"Painting","amount":30},{"resource":"Diamond","amount":900},{"resource":"Rum","amount":300}],
            "description":      "dracemb-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":16}],
            "colGenRate":       0,
            "providesShelter":  18,
            "canChain":         false,
            "acceptsWorkers":   18,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["Draconian Base"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Diplomat",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        true,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Real News Station",
            "tile":             ["realnews"],
            "cost":             [{"resource":"Money","amount":1500},{"resource":"Antanium","amount":1500},{"resource":"Aluminum","amount":400},{"resource":"Gold","amount":1500},{"resource":"Helium 3","amount":500},{"resource":"Oil","amount":200},{"resource":"Crystalline","amount":100}],
            "description":      "realnews-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     2000,
            "generateAmount":   30,
            "tileWidth":        3,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Money","amount":150},{"resource":"Antanium","amount":150},{"resource":"Aluminum","amount":40},{"resource":"Gold","amount":150},{"resource":"Helium 3","amount":50},{"resource":"Oil","amount":20},{"resource":"Crystalline","amount":10}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":100}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    40,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       20,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Money","rate":800},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         20,
            "providesIQ":       110,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Center for Relic Studies",
            "tile":             ["relicstudies"],
            "cost":             [{"resource":"Ore","amount":120000},{"resource":"Charcoal","amount":80000},{"resource":"Regolith","amount":80000},{"resource":"Wood","amount":120000},{"resource":"Triantanium","amount":9000},{"resource":"Steel","amount":90000},{"resource":"Gold","amount":80000},{"resource":"Aluminum","amount":40000},{"resource":"Plastic","amount":35000},{"resource":"Microchip","amount":90000},{"resource":"Robot","amount":14000},{"resource":"Alien Artifact","amount":5000},{"resource":"Alien Relic","amount":600}],
            "description":      "relicstudies-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Alien Artifact","amount":800},{"resource":"Alien Relic","amount":800}],
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Charcoal","amount":800},{"resource":"Regolith","amount":800},{"resource":"Wood","amount":120},{"resource":"Triantanium","amount":900},{"resource":"Steel","amount":200},{"resource":"Gold","amount":80},{"resource":"Aluminum","amount":120},{"resource":"Plastic","amount":350},{"resource":"Microchip","amount":90},{"resource":"Robot","amount":1},{"resource":"Alien Artifact","amount":20},{"resource":"Alien Relic","amount":6}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1250}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   250,
            "requiresWorkers":  true,
            "smelts":           {"input":"Robot,Alien Relic","output":"Research|Alien Artifact|Aluminum","time":50000,"ratio":400},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2000,
            "requiresTech":     ["Artificial Intelligence","Tall Construction","Xenomaterials Research"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Alien Artifact","Alien Relic"],
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       110,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Adult Daycare",
            "tile":             ["adultdaycare"],
            "cost":             [{"resource":"Ore","amount":200},{"resource":"Steel","amount":200},{"resource":"Toy","amount":200}],
            "description":      "adultdaycare-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":20},{"resource":"Steel","amount":20},{"resource":"Toy","amount":20}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":8}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   1,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Basic Education"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Teacher",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Education"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         5,
            "providesIQ":       65,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "NetSchool",
            "tile":             ["netschool"],
            "cost":             [{"resource":"Ore","amount":2000},{"resource":"Steel","amount":1200},{"resource":"Gold","amount":1000},{"resource":"Microchip","amount":35},{"resource":"Software","amount":12}],
            "description":      "netschool-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":400},{"resource":"Steel","amount":200},{"resource":"Gold","amount":120}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":14},{"utility":"Bandwidth","amount":8}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    14,
            "requiresTech":     ["Basic Education","Basic Network Infrastructure"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Software","rate":6000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Education","Government","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       50,
            "educates":         14,
            "providesIQ":       115,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Small Elementary School",
            "tile":             ["smschool"],
            "cost":             [{"resource":"Ore","amount":4000},{"resource":"Steel","amount":2000},{"resource":"Gold","amount":1200}],
            "description":      "smschool-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":400},{"resource":"Steel","amount":200},{"resource":"Gold","amount":120}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":12}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   4,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    8,
            "requiresTech":     ["Basic Education"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Teacher",
            "indicator":        null,
            "canUpgradeTo":     "Small High School",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Education","Government"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       50,
            "educates":         40,
            "providesIQ":       90,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Small High School",
            "tile":             ["smschool2"],
            "cost":             [{"resource":"Ore","amount":6500},{"resource":"Steel","amount":3500},{"resource":"Gold","amount":2500},{"resource":"Microchip","amount":15},{"resource":"Civics","amount":50}],
            "description":      "smschool2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":650},{"resource":"Steel","amount":350},{"resource":"Gold","amount":250}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":25}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   10,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    25,
            "requiresTech":     ["Colonial Finance Theory","Colonial Civics","Basic Education"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Teacher",
            "indicator":        null,
            "canUpgradeTo":     "Small Community College",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Education","Government"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       75,
            "educates":         100,
            "providesIQ":       115,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Small Community College",
            "tile":             ["smschool3"],
            "cost":             [{"resource":"Ore","amount":9500},{"resource":"Steel","amount":6500},{"resource":"Gold","amount":4500},{"resource":"Microchip","amount":50},{"resource":"Civics","amount":250},{"resource":"Aluminum","amount":120}],
            "description":      "smschool3-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":950},{"resource":"Steel","amount":650},{"resource":"Gold","amount":450},{"resource":"Microchip","amount":5},{"resource":"Aluminum","amount":12}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":40}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   25,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     ["Colonial Finance Theory","Colonial Civics","Basic Education","Large Scale Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Teacher",
            "indicator":        null,
            "canUpgradeTo":     "Transcendent Academy",
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Education","Government"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       90,
            "educates":         250,
            "providesIQ":       130,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "University",
            "tile":             ["university"],
            "cost":             [{"resource":"Money","amount":60000},{"resource":"Ore","amount":25000},{"resource":"Steel","amount":15000},{"resource":"Gold","amount":25000},{"resource":"Microchip","amount":1500},{"resource":"Civics","amount":2500},{"resource":"Aluminum","amount":6000},{"resource":"Wood","amount":5000},{"resource":"Software","amount":3500},{"resource":"Plastic","amount":6500},{"resource":"Bricks","amount":8500}],
            "description":      "university-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     1500,
            "generateAmount":   1,
            "tileWidth":        5,
            "tileHeight":       5,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":2500},{"resource":"Steel","amount":15000},{"resource":"Gold","amount":2500},{"resource":"Microchip","amount":15},{"resource":"Aluminum","amount":6000},{"resource":"Wood","amount":5},{"resource":"Plastic","amount":650},{"resource":"Bricks","amount":85}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":450},{"utility":"Bandwidth","amount":200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   100,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    200,
            "requiresTech":     ["Colonial Finance Theory","Colonial Civics","Basic Education","Large Scale Construction","Basic Network Infrastructure"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Teacher",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Software,Money,Money,Civics","rate":1000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Education","Government"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       90,
            "educates":         3500,
            "providesIQ":       140,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Mound of Scholars",
            "tile":             ["moundofscholars"],
            "cost":             [{"resource":"Ore","amount":9500},{"resource":"Antanium","amount":6500},{"resource":"Gold","amount":4500},{"resource":"Microchip","amount":50},{"resource":"Civics","amount":250},{"resource":"Aluminum","amount":120}],
            "description":      "moundofscholars-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":950},{"resource":"Antanium","amount":650},{"resource":"Gold","amount":450},{"resource":"Microchip","amount":5},{"resource":"Aluminum","amount":12}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":40},{"utility":"Bandwidth","amount":10}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   25,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     ["Basic Network Infrastructure","Insectoid Bureaucracy"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Teacher",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Education","Government"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       70,
            "educates":         500,
            "providesIQ":       130,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Advanced Clothing Sweatshop",
            "tile":             ["sweatshop4"],
            "cost":             [{"resource":"Ore","amount":90000},{"resource":"Steel","amount":120000},{"resource":"Bricks","amount":9000},{"resource":"Gold","amount":35000},{"resource":"Cloth","amount":20000},{"resource":"Aluminum","amount":45000},{"resource":"Microchip","amount":15000},{"resource":"Robot","amount":400}],
            "description":      "sweatshop4-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     20000,
            "generateAmount":   2,
            "tileWidth":        3,
            "tileHeight":       5,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Cloth","amount":5000}],
            "sellValue":        [{"resource":"Ore","amount":9000},{"resource":"Steel","amount":12000},{"resource":"Bricks","amount":90},{"resource":"Gold","amount":3500},{"resource":"Cloth","amount":200},{"resource":"Aluminum","amount":4500},{"resource":"Microchip","amount":15},{"resource":"Robot","amount":4}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":700}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   500,
            "requiresWorkers":  true,
            "smelts":           {"input":"Cloth","output":"Money","time":30000,"ratio":75},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    440,
            "requiresTech":     ["Advanced Robotics","Tall Construction"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Robot","rate":40000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Durable Goods","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Transcendent Academy",
            "tile":             ["transacademy"],
            "cost":             [{"resource":"Money","amount":2500000},{"resource":"Civics","amount":1000000},{"resource":"Ore","amount":500000},{"resource":"Steel","amount":500000},{"resource":"Gold","amount":500000},{"resource":"Plastic","amount":500000},{"resource":"Charcoal","amount":500000},{"resource":"Microchip","amount":500000},{"resource":"Aluminum","amount":500000},{"resource":"Alien Artifact","amount":100000},{"resource":"Alien Relic","amount":5000},{"resource":"Diamond","amount":5000},{"resource":"Robot","amount":10000}],
            "description":      "transacademy-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":5000},{"resource":"Steel","amount":5000},{"resource":"Gold","amount":5000},{"resource":"Plastic","amount":500},{"resource":"Charcoal","amount":500},{"resource":"Microchip","amount":50},{"resource":"Aluminum","amount":5000},{"resource":"Diamond","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":400}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   1,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    500,
            "requiresTech":     ["Basic Education","Transcendence"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Teacher",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Robot,Civics,Microchip","rate":100},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Education","Government"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       80,
            "educates":         500,
            "providesIQ":       300,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Auntie Belles Cupcake Factory",
            "tile":             ["ancientinc"],
            "cost":             [{"resource":"Money","amount":5000000},{"resource":"Civics","amount":2500000},{"resource":"Research","amount":2500000},{"resource":"Ore","amount":100000},{"resource":"Steel","amount":150000},{"resource":"Antanium","amount":25000},{"resource":"Gold","amount":60000},{"resource":"Microchip","amount":150000},{"resource":"Plastic","amount":150000},{"resource":"Bricks","amount":65000},{"resource":"Robot","amount":15000},{"resource":"Triantanium","amount":4000},{"resource":"Diamond","amount":4000},{"resource":"Alien Artifact","amount":20000},{"resource":"Ancient Instructions","amount":400}],
            "description":      "ancientinc-description",
            "produces":         null,
            "generates":        "Food",
            "generateTime":     2000,
            "generateAmount":   5,
            "tileWidth":        4,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Triantanium","amount":200},{"resource":"Alien Artifact","amount":200},{"resource":"Alien Relic","amount":200},{"resource":"Ancient Instructions","amount":200},{"resource":"Food","amount":200}],
            "sellValue":        [{"resource":"Ore","amount":10000},{"resource":"Steel","amount":15000},{"resource":"Antanium","amount":2500},{"resource":"Gold","amount":6000},{"resource":"Microchip","amount":150},{"resource":"Plastic","amount":15000},{"resource":"Bricks","amount":650},{"resource":"Triantanium","amount":400}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2500}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   25,
            "requiresWorkers":  true,
            "smelts":           {"input":"Triantanium,Alien Artifact,Ancient Instructions","output":"Alien Relic","time":600,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    600,
            "requiresTech":     ["Antanium Compounds","Advanced Robotics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Robot","rate":600},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       115,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Synthetic Diamond Laboratory",
            "tile":             ["diamondsynth"],
            "cost":             [{"resource":"Ore","amount":15000},{"resource":"Steel","amount":15000},{"resource":"Gold","amount":8000},{"resource":"Microchip","amount":2500},{"resource":"Charcoal","amount":1500},{"resource":"Aluminum","amount":1500}],
            "description":      "diamondsynth-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Diamond","amount":9000}],
            "sellValue":        [{"resource":"Ore","amount":1500},{"resource":"Steel","amount":1500},{"resource":"Gold","amount":800},{"resource":"Microchip","amount":25},{"resource":"Aluminum","amount":150}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":300}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   8,
            "requiresWorkers":  true,
            "smelts":           {"input":"Charcoal","output":"Diamond","time":6000,"ratio":5},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Advanced Chemistry","Diamond Mining"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Charcoal","rate":450},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       100,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Universal Commodities Exchange",
            "tile":             ["unicomm"],
            "cost":             [{"resource":"Money","amount":10000},{"resource":"Ore","amount":8000},{"resource":"Water","amount":900},{"resource":"Ant Paste","amount":400},{"resource":"Antanium","amount":18000},{"resource":"Gold","amount":7000},{"resource":"Aluminum","amount":2000},{"resource":"Crystalline","amount":2000},{"resource":"Oil","amount":2000},{"resource":"Uranium","amount":2000},{"resource":"Helium 3","amount":1100},{"resource":"Civics","amount":2000}],
            "description":      "unicomm-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     3000,
            "generateAmount":   25,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":800},{"resource":"Ant Paste","amount":4},{"resource":"Antanium","amount":1800},{"resource":"Gold","amount":700},{"resource":"Aluminum","amount":200},{"resource":"Crystalline","amount":20},{"resource":"Oil","amount":20},{"resource":"Uranium","amount":20}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":900}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   20,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Food|Water|Rum|Wool|Wood|Cloth|Clay|Sugar|Ant Paste|Charcoal|Regolith|Ore|Steel|Antanium|Diamond|Gold|Aluminum|Oil|Helium 3|Plastic|Toy|Uranium|Pottery|Bricks|Microchip|Robot|Alien Artifact|Crystalline|Alien Relic|Ancient Instructions|Obsidian|Painting","time":6000,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    90,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "White Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": true,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    500,
            "upkeepCost":       0.0,
            "giftCapacity":     500,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Independence Hall Level 3",
            "tile":             ["independencehall3"],
            "cost":             [{"resource":"Money","amount":200000},{"resource":"Ore","amount":200000},{"resource":"Water","amount":20000},{"resource":"Rum","amount":25000},{"resource":"Helium 3","amount":5000},{"resource":"Regolith","amount":10000},{"resource":"Diamond","amount":7500},{"resource":"Obsidian","amount":20},{"resource":"Wood","amount":25000},{"resource":"Cloth","amount":30000},{"resource":"Bricks","amount":60000},{"resource":"Steel","amount":200000},{"resource":"Pottery","amount":30000},{"resource":"Gold","amount":200000},{"resource":"Plastic","amount":50000},{"resource":"Aluminum","amount":30000},{"resource":"Microchip","amount":50000},{"resource":"Civics","amount":100000}],
            "description":      "independencehall3-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        5,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":2000},{"resource":"Helium 3","amount":50},{"resource":"Regolith","amount":1000},{"resource":"Diamond","amount":750},{"resource":"Obsidian","amount":2},{"resource":"Wood","amount":250},{"resource":"Cloth","amount":30},{"resource":"Bricks","amount":600},{"resource":"Steel","amount":20000},{"resource":"Pottery","amount":300},{"resource":"Gold","amount":20000},{"resource":"Plastic","amount":5000},{"resource":"Aluminum","amount":3000},{"resource":"Microchip","amount":50}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":170}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   150,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":13500,"ratio":100},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    65,
            "requiresTech":     ["LIS Base","Imperialism","Large Scale Construction","Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Politician",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     {"resource":"Rum","rate":150},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   "capitol",
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":30,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    40,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     5000000,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    5,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Statue of Admiral Tots",
            "tile":             ["statue6"],
            "cost":             [{"resource":"Ore","amount":400},{"resource":"Steel","amount":400},{"resource":"Aluminum","amount":200},{"resource":"Gold","amount":1800}],
            "description":      "statue6-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    3,
            "requiresTech":     ["LIS Base","Nationalism","Tourist Traps"],
            "canRenderStatic":  false,
            "entertains":       5,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            1,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    8,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           true,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Obsidian Furnace",
            "tile":             ["obsidianfurnace"],
            "cost":             [{"resource":"Ore","amount":12000},{"resource":"Helium 3","amount":2000},{"resource":"Steel","amount":9000},{"resource":"Gold","amount":900},{"resource":"Aluminum","amount":900},{"resource":"Microchip","amount":450}],
            "description":      "obsidianfurnace-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     900,
            "generateAmount":   30,
            "tileWidth":        2,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Obsidian","amount":1500},{"resource":"Helium 3","amount":1500}],
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Steel","amount":900},{"resource":"Gold","amount":90},{"resource":"Aluminum","amount":90},{"resource":"Microchip","amount":4}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":900}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   10,
            "requiresWorkers":  false,
            "smelts":           {"input":"Helium 3,Helium 3,Steel,Gold","output":"Obsidian","time":6000,"ratio":2},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Advanced Chemical Synthesis"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Ore","rate":100},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Larger Residential Complex",
            "tile":             ["largerres"],
            "cost":             [{"resource":"Ore","amount":50000},{"resource":"Water","amount":6000},{"resource":"Steel","amount":18000},{"resource":"Gold","amount":5000},{"resource":"Aluminum","amount":3000},{"resource":"Diamond","amount":150},{"resource":"Pottery","amount":1500},{"resource":"Cloth","amount":1500},{"resource":"Plastic","amount":2500},{"resource":"Toy","amount":1100},{"resource":"Robot","amount":10},{"resource":"Microchip","amount":900}],
            "description":      "largerres-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2000,
            "generateAmount":   120,
            "tileWidth":        2,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":50000},{"resource":"Steel","amount":1800},{"resource":"Gold","amount":500},{"resource":"Aluminum","amount":300},{"resource":"Diamond","amount":15},{"resource":"Pottery","amount":10},{"resource":"Cloth","amount":15},{"resource":"Plastic","amount":250},{"resource":"Toy","amount":10},{"resource":"Robot","amount":1},{"resource":"Microchip","amount":9}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":480}],
            "colGenRate":       0,
            "providesShelter":  3000,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    150,
            "requiresTech":     ["Tall Construction","Advanced Robotics"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Caution Sign",
            "tile":             ["cautionsign"],
            "cost":             [{"resource":"Ore","amount":20},{"resource":"Steel","amount":2}],
            "description":      "cautionsign-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     [],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -0.1,
                    "y":    -0.5,
                    "r":    0.15,
                    "c":    "#ffcc00",
                    "i":    0.4,
                    "nightonly": true,
                    "oncycles": [1,2,3,4,5,6]
                },
                {
                    "x":    -0.1,
                    "y":    0.3,
                    "r":    0.15,
                    "c":    "#ffcc00",
                    "i":    0.4,
                    "nightonly": true,
                    "oncycles": [1,2,3,4,5,6]
                },
                {
                    "x":    0.0,
                    "y":    0.0,
                    "r":    0.8,
                    "c":    "#ffcc00",
                    "i":    0.1,
                    "nightonly": true,
                    "oncycles": [1,2,3,4,5,6]
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Gravitational Compression Warehouse",
            "tile":             ["gravcompress"],
            "cost":             [{"resource":"Ore","amount":300000},{"resource":"Steel","amount":600000},{"resource":"Gold","amount":350000},{"resource":"Aluminum","amount":80000},{"resource":"Uranium","amount":30000},{"resource":"Microchip","amount":100000},{"resource":"Alien Artifact","amount":2000},{"resource":"Alien Relic","amount":1000},{"resource":"Ancient Instructions","amount":200},{"resource":"Diamond","amount":5000},{"resource":"Crystalline","amount":5000},{"resource":"Obsidian","amount":5000},{"resource":"Robot","amount":5000}],
            "description":      "gravcompress-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ether","amount":4000000},{"resource":"Water","amount":4000000},{"resource":"Food","amount":4000000},{"resource":"Triantanium","amount":4000000},{"resource":"Antanium","amount":4000000},{"resource":"Helium 3","amount":4000000},{"resource":"Obsidian","amount":4000000},{"resource":"Steel","amount":4000000},{"resource":"Wool","amount":4000000},{"resource":"Diamond","amount":4000000},{"resource":"Crystalline","amount":4000000},{"resource":"Rum","amount":4000000},{"resource":"Pottery","amount":4000000},{"resource":"Bricks","amount":4000000},{"resource":"Cloth","amount":4000000},{"resource":"Plastic","amount":4000000},{"resource":"Toy","amount":4000000},{"resource":"Microchip","amount":4000000},{"resource":"Alien Artifact","amount":4000000},{"resource":"Robot","amount":4000000},{"resource":"Ant Paste","amount":4000000},{"resource":"Gold","amount":4000000},{"resource":"Uranium","amount":4000000},{"resource":"Aluminum","amount":4000000},{"resource":"Clay","amount":4000000},{"resource":"Ore","amount":4000000},{"resource":"Regolith","amount":4000000},{"resource":"Alien Relic","amount":4000000},{"resource":"Ancient Instructions","amount":4000000},{"resource":"Charcoal","amount":4000000},{"resource":"Sugar","amount":4000000},{"resource":"Wheel","amount":4000000},{"resource":"Wood","amount":4000000},{"resource":"Software","amount":4000000},{"resource":"Oil","amount":4000000}],
            "sellValue":        [{"resource":"Ore","amount":30000},{"resource":"Steel","amount":60000},{"resource":"Gold","amount":35000},{"resource":"Aluminum","amount":8000},{"resource":"Uranium","amount":300},{"resource":"Microchip","amount":10},{"resource":"Alien Artifact","amount":200},{"resource":"Alien Relic","amount":100},{"resource":"Diamond","amount":2000},{"resource":"Crystalline","amount":50},{"resource":"Obsidian","amount":4000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":850}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   2,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    80,
            "requiresTech":     ["Transcendence"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Helium 3,Triantanium,Robot","rate":200},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Durable Goods","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       110,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Automated Art Display",
            "tile":             ["aipainting"],
            "cost":             [{"resource":"Money","amount":1500},{"resource":"Ore","amount":500},{"resource":"Antanium","amount":500},{"resource":"Ant Paste","amount":50},{"resource":"Aluminum","amount":50},{"resource":"Gold","amount":100},{"resource":"Microchip","amount":50}],
            "description":      "aipainting-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Painting","amount":5}],
            "sellValue":        [{"resource":"Ore","amount":50},{"resource":"Antanium","amount":50},{"resource":"Aluminum","amount":5},{"resource":"Gold","amount":10},{"resource":"Microchip","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":10},{"utility":"Bandwidth","amount":2}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Water,Microchip","output":"Painting","time":9000,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       5,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Tourism","Entertainment"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":10,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    5,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       110,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Galactic Fine Arts Exposition",
            "tile":             ["galartsexpo"],
            "cost":             [{"resource":"Money","amount":1000},{"resource":"Civics","amount":1000},{"resource":"Ore","amount":3000},{"resource":"Antanium","amount":3000},{"resource":"Ant Paste","amount":1000},{"resource":"Aluminum","amount":2000},{"resource":"Gold","amount":2000},{"resource":"Crystalline","amount":2000},{"resource":"Pottery","amount":100},{"resource":"Oil","amount":500}],
            "description":      "galartsexpo-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     2000,
            "generateAmount":   30,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Pottery","amount":5000},{"resource":"Painting","amount":5000}],
            "sellValue":        [{"resource":"Ore","amount":300},{"resource":"Antanium","amount":300},{"resource":"Aluminum","amount":200},{"resource":"Gold","amount":200},{"resource":"Crystalline","amount":20}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":400}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   6,
            "requiresWorkers":  true,
            "smelts":           {"input":"Rum","output":"Painting","time":20000,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    15,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       40,
            "canImport":        ["Pottery","Painting"],
            "canExport":        ["Pottery","Painting"],
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Pottery","rate":2000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Tourism"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":10,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    20,
            "touristDoorway":   false,
            "tradeCapacity":    100,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       110,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Suppertime Arena",
            "tile":             ["suppertimearena"],
            "cost":             [{"resource":"Money","amount":5000},{"resource":"Civics","amount":2000},{"resource":"Water","amount":3000},{"resource":"Ore","amount":9000},{"resource":"Antanium","amount":15000},{"resource":"Ant Paste","amount":2000},{"resource":"Aluminum","amount":3000},{"resource":"Gold","amount":3000},{"resource":"Crystalline","amount":6000},{"resource":"Rum","amount":6000}],
            "description":      "suppertimearena-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     2000,
            "generateAmount":   15,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":900},{"resource":"Antanium","amount":1500},{"resource":"Aluminum","amount":300},{"resource":"Gold","amount":300},{"resource":"Crystalline","amount":60}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   5,
            "requiresWorkers":  false,
            "smelts":           {"input":"Rum,Water,Food","output":"Money","time":600,"ratio":40},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    25,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       75,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Water","rate":2000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Entertainment","Tourism"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":20,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    50,
            "touristDoorway":   false,
            "tradeCapacity":    100,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Obelisk of Plenty",
            "tile":             ["obeliskofplenty"],
            "cost":             [{"resource":"Money","amount":5000},{"resource":"Civics","amount":2500},{"resource":"Ore","amount":3000},{"resource":"Antanium","amount":18000},{"resource":"Gold","amount":8000},{"resource":"Gold","amount":8000},{"resource":"Alien Relic","amount":100},{"resource":"Obsidian","amount":500},{"resource":"Cloth","amount":500}],
            "description":      "obeliskofplenty-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1200,
            "generateAmount":   15,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Gold","amount":50000}],
            "sellValue":        [{"resource":"Ore","amount":300},{"resource":"Antanium","amount":1800},{"resource":"Gold","amount":800},{"resource":"Gold","amount":800},{"resource":"Alien Relic","amount":10},{"resource":"Obsidian","amount":500}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":25}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   10,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Money","time":5000,"ratio":150},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     ["Insectoid Bureaucracy"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#8BC34A",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Mound of Online Business",
            "tile":             ["moundonlinebus"],
            "cost":             [{"resource":"Ore","amount":20000},{"resource":"Water","amount":1600},{"resource":"Wood","amount":9500},{"resource":"Ant Paste","amount":4000},{"resource":"Cloth","amount":3500},{"resource":"Antanium","amount":16000},{"resource":"Gold","amount":4000},{"resource":"Aluminum","amount":3200},{"resource":"Microchip","amount":1820},{"resource":"Software","amount":500},{"resource":"Oil","amount":1500}],
            "description":      "moundonlinebus-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     3000,
            "generateAmount":   20,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Software","amount":500}],
            "sellValue":        [{"resource":"Ore","amount":4000},{"resource":"Antanium","amount":3000},{"resource":"Gold","amount":400},{"resource":"Aluminum","amount":200},{"resource":"Microchip","amount":30}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":280},{"utility":"Bandwidth","amount":560}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   190,
            "requiresWorkers":  false,
            "smelts":           {"input":"Money,Software,Software,Microchip","output":"Money","time":8500,"ratio":180},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    500,
            "requiresTech":     ["Insectoid Bureaucracy","Basic Network Infrastructure"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       "White Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Software","rate":6000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Information Technology","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       110,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Unholy Obsidian Burner",
            "tile":             ["unholyobsidian"],
            "cost":             [{"resource":"Ore","amount":12000},{"resource":"Wood","amount":2000},{"resource":"Antanium","amount":9000},{"resource":"Gold","amount":900},{"resource":"Aluminum","amount":900},{"resource":"Cloth","amount":900},{"resource":"Alien Relic","amount":450},{"resource":"Alien Artifact","amount":200},{"resource":"Antaura","amount":450}],
            "description":      "unholyobsidian-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     900,
            "generateAmount":   30,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Obsidian","amount":1000},{"resource":"Gold","amount":1000}],
            "sellValue":        [{"resource":"Ore","amount":1200},{"resource":"Wood","amount":20},{"resource":"Antanium","amount":900},{"resource":"Gold","amount":90},{"resource":"Aluminum","amount":90},{"resource":"Cloth","amount":9},{"resource":"Alien Relic","amount":45}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":250}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   1,
            "requiresWorkers":  false,
            "smelts":           {"input":"Antanium,Gold,Ant Paste","output":"Obsidian","time":1000,"ratio":2},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     ["Ancient Alien Language"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#8BC34A",
            "requiresFuel":     {"resource":"Antaura","rate":400},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Government","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Wheel Factory",
            "tile":             ["wheelfactory"],
            "cost":             [{"resource":"Ore","amount":6500},{"resource":"Steel","amount":4500},{"resource":"Gold","amount":2500}],
            "description":      "wheelfactory-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     2500,
            "generateAmount":   1,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wheel","amount":1000}],
            "sellValue":        [{"resource":"Ore","amount":2000},{"resource":"Steel","amount":1400},{"resource":"Gold","amount":1000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":40}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   15,
            "requiresWorkers":  true,
            "smelts":           {"input":"Steel,Ore,Water","output":"Wheel","time":18000,"ratio":15},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    75,
            "requiresTech":     ["Advanced Small Scale Construction","Colonial Finance Theory","Low Gravity Manufacturing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Durable Goods"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Statue of Two",
            "tile":             ["statue7"],
            "cost":             [{"resource":"Steel","amount":400},{"resource":"Bricks","amount":1500},{"resource":"Gold","amount":2500}],
            "description":      "statue7-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Steel","amount":40},{"resource":"Bricks","amount":15},{"resource":"Gold","amount":250}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    2,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ship Yard",
            "tile":             ["shipyard"],
            "cost":             [{"resource":"Money","amount":15000000},{"resource":"Civics","amount":15000000},{"resource":"Research","amount":15000000},{"resource":"Steel","amount":7500000},{"resource":"Gold","amount":3000000},{"resource":"Diamond","amount":1000000},{"resource":"Obsidian","amount":30000},{"resource":"Microchip","amount":2500000},{"resource":"Robot","amount":75000},{"resource":"Triantanium","amount":35000},{"resource":"Ancient Instructions","amount":5000},{"resource":"Uranium","amount":750000},{"resource":"Crystalline","amount":400000},{"resource":"Charcoal","amount":400000},{"resource":"Wood","amount":300000},{"resource":"Clay","amount":400000},{"resource":"Ant Paste","amount":100000},{"resource":"Plastic","amount":800000},{"resource":"Bricks","amount":300000},{"resource":"Oil","amount":300000}],
            "description":      "shipyard-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        10,
            "tileHeight":       6,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Starship","amount":6}],
            "sellValue":        [{"resource":"Steel","amount":750000},{"resource":"Gold","amount":300000},{"resource":"Diamond","amount":100000},{"resource":"Obsidian","amount":3000},{"resource":"Microchip","amount":2500},{"resource":"Robot","amount":75},{"resource":"Triantanium","amount":3500},{"resource":"Ancient Instructions","amount":5},{"resource":"Uranium","amount":75000},{"resource":"Crystalline","amount":40000},{"resource":"Charcoal","amount":4000},{"resource":"Wood","amount":3000},{"resource":"Clay","amount":4000},{"resource":"Ant Paste","amount":100},{"resource":"Plastic","amount":80000},{"resource":"Bricks","amount":300}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":4000}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   50,
            "requiresWorkers":  true,
            "smelts":           {"input":"Steel,Ore,Gold,Diamond,Triantanium,Obsidian,Uranium,Microchip,Robot,Oil,Crystalline,Helium 3,Ant Paste,Wheel","output":"Starship","time":180000,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    400,
            "requiresTech":     ["Faster Than Light Travel"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        ["Starship"],
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Advanced Ship Yard",
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Uranium,Robot,Oil,Ant Paste,Diamond,Crystalline","rate":300},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Durable Goods","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Advanced Ship Yard",
            "tile":             ["shipyard2"],
            "cost":             [{"resource":"Money","amount":25000000},{"resource":"Civics","amount":25000000},{"resource":"Research","amount":25000000},{"resource":"Steel","amount":17500000},{"resource":"Gold","amount":6000000},{"resource":"Diamond","amount":1500000},{"resource":"Obsidian","amount":80000},{"resource":"Microchip","amount":4500000},{"resource":"Robot","amount":175000},{"resource":"Triantanium","amount":95000},{"resource":"Ancient Instructions","amount":15000},{"resource":"Uranium","amount":2000000},{"resource":"Crystalline","amount":600000},{"resource":"Charcoal","amount":600000},{"resource":"Wood","amount":600000},{"resource":"Clay","amount":600000},{"resource":"Ant Paste","amount":150000},{"resource":"Plastic","amount":1200000},{"resource":"Bricks","amount":600000},{"resource":"Oil","amount":600000},{"resource":"Software","amount":50000}],
            "description":      "shipyard2-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        10,
            "tileHeight":       6,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Starship","amount":20}],
            "sellValue":        [{"resource":"Steel","amount":750000},{"resource":"Gold","amount":300000},{"resource":"Diamond","amount":100000},{"resource":"Obsidian","amount":3000},{"resource":"Microchip","amount":2500},{"resource":"Robot","amount":75},{"resource":"Triantanium","amount":3500},{"resource":"Ancient Instructions","amount":5},{"resource":"Uranium","amount":75000},{"resource":"Crystalline","amount":40000},{"resource":"Charcoal","amount":4000},{"resource":"Wood","amount":3000},{"resource":"Clay","amount":4000},{"resource":"Ant Paste","amount":100},{"resource":"Plastic","amount":80000},{"resource":"Bricks","amount":300}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":7000},{"utility":"Bandwidth","amount":1500}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   90,
            "requiresWorkers":  true,
            "smelts":           {"input":"Software,Steel,Ore,Gold,Diamond,Triantanium,Obsidian,Uranium,Microchip,Robot,Oil,Crystalline,Helium 3,Ant Paste,Wheel","output":"Starship","time":60000,"ratio":2},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    800,
            "requiresTech":     ["Mass Data Management","Faster Than Light Travel"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        ["Starship"],
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Uranium,Robot,Oil,Ant Paste,Diamond,Crystalline,Software","rate":200},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Durable Goods","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Shipworks",
            "tile":             ["shipworks"],
            "cost":             [{"resource":"Money","amount":1000000},{"resource":"Civics","amount":1000000},{"resource":"Research","amount":2000000},{"resource":"Antanium","amount":200000},{"resource":"Gold","amount":3000000},{"resource":"Obsidian","amount":100000},{"resource":"Microchip","amount":35000},{"resource":"Robot","amount":50},{"resource":"Crystalline","amount":250000},{"resource":"Aluminum","amount":200000},{"resource":"Uranium","amount":200000},{"resource":"Oil","amount":150000},{"resource":"Diamond","amount":150000},{"resource":"Regolith","amount":150000},{"resource":"Clay","amount":150000},{"resource":"Ant Paste","amount":250000},{"resource":"Ore","amount":400000}],
            "description":      "shipworks-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        6,
            "tileHeight":       5,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Starship","amount":6}],
            "sellValue":        [{"resource":"Antanium","amount":20000},{"resource":"Gold","amount":300000},{"resource":"Obsidian","amount":10000},{"resource":"Microchip","amount":350},{"resource":"Crystalline","amount":250},{"resource":"Aluminum","amount":20000},{"resource":"Uranium","amount":20000},{"resource":"Diamond","amount":15000},{"resource":"Regolith","amount":15000},{"resource":"Clay","amount":1500},{"resource":"Ore","amount":40000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":10000}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   45,
            "requiresWorkers":  true,
            "smelts":           {"input":"Antanium,Ore,Gold,Diamond,Crystalline,Obsidian,Uranium,Microchip,Crystalline,Oil,Crystalline,Helium 3,Ant Paste,Crystalline","output":"Starship","time":180000,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    400,
            "requiresTech":     ["Shipbuilding"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        ["Starship"],
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Uranium,Crystalline,Oil,Ant Paste,Diamond,Crystalline","rate":300},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Durable Goods","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Scheepswerf",
            "tile":             ["scheepswerf"],
            "cost":             [{"resource":"Money","amount":1000000},{"resource":"Civics","amount":1000000},{"resource":"Research","amount":200000},{"resource":"Antanium","amount":150000},{"resource":"Gold","amount":650000},{"resource":"Obsidian","amount":50000},{"resource":"Cloth","amount":100000},{"resource":"Antaura","amount":150000},{"resource":"Crystalline","amount":120000},{"resource":"Aluminum","amount":100000},{"resource":"Uranium","amount":100000},{"resource":"Oil","amount":10000},{"resource":"Alien Relic","amount":25000},{"resource":"Wood","amount":20000},{"resource":"Clay","amount":90000},{"resource":"Ant Paste","amount":120000},{"resource":"Ore","amount":400000}],
            "description":      "scheepswerf-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        6,
            "tileHeight":       6,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Starship","amount":4}],
            "sellValue":        [{"resource":"Antanium","amount":15000},{"resource":"Gold","amount":6500},{"resource":"Obsidian","amount":5000},{"resource":"Cloth","amount":1000},{"resource":"Crystalline","amount":1200},{"resource":"Aluminum","amount":10000},{"resource":"Uranium","amount":1000},{"resource":"Oil","amount":10},{"resource":"Alien Relic","amount":250},{"resource":"Wood","amount":200},{"resource":"Clay","amount":900},{"resource":"Ant Paste","amount":120},{"resource":"Ore","amount":40000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3500}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   60,
            "requiresWorkers":  true,
            "smelts":           {"input":"Antanium,Ore,Gold,Antanium,Crystalline,Obsidian,Uranium,Antanium,Crystalline,Oil,Crystalline,Cloth,Ant Paste,Crystalline","output":"Starship","time":200000,"ratio":1},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    400,
            "requiresTech":     ["Insectoid Shipbuilding"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        ["Starship"],
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Wheel,Uranium,Crystalline,Oil,Ant Paste,Antaura,Crystalline,Antaura,Antaura,Antaura,Diamond,Alien Relic","rate":250},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Durable Goods","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Star Port",
            "tile":             ["starport"],
            "cost":             [{"resource":"Money","amount":2000000},{"resource":"Civics","amount":2000000},{"resource":"Ore","amount":2000000},{"resource":"Steel","amount":4000000},{"resource":"Gold","amount":2000000},{"resource":"Aluminum","amount":1200000},{"resource":"Plastic","amount":700000},{"resource":"Microchip","amount":900000},{"resource":"Triantanium","amount":25000},{"resource":"Robot","amount":100000},{"resource":"Pottery","amount":300000},{"resource":"Toy","amount":250000},{"resource":"Rum","amount":800000},{"resource":"Wood","amount":100000},{"resource":"Wool","amount":300000}],
            "description":      "starport-description",
            "produces":         null,
            "generates":        "Civics",
            "generateTime":     1400,
            "generateAmount":   25,
            "tileWidth":        12,
            "tileHeight":       12,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Starship","amount":200}],
            "sellValue":        [{"resource":"Ore","amount":200000},{"resource":"Steel","amount":400000},{"resource":"Gold","amount":200000},{"resource":"Aluminum","amount":120000},{"resource":"Plastic","amount":70000},{"resource":"Microchip","amount":900},{"resource":"Triantanium","amount":2500},{"resource":"Robot","amount":100},{"resource":"Pottery","amount":3000},{"resource":"Toy","amount":2500},{"resource":"Rum","amount":80},{"resource":"Wood","amount":1000},{"resource":"Wool","amount":3000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":9000}],
            "colGenRate":       5000,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   200,
            "requiresWorkers":  true,
            "smelts":           {"input":"Starship","output":"Money","time":100000,"ratio":200000},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    9000,
            "requiresTech":     ["Faster Than Light Travel"],
            "canRenderStatic":  false,
            "entertains":       500,
            "canImport":        ["Food","Water","Sugar","Rum","Wool","Wood","Clay","Charcoal","Regolith","Ore","Ant Paste","Steel","Antanium","Gold","Aluminum","Oil","Diamond","Helium 3","Toy","Uranium","Crystalline","Cloth","Pottery","Bricks","Microchip","Robot","Alien Artifact","Triantanium","Alien Relic","Obsidian","Starship","Plastic","Software"],
            "canExport":        ["Food","Water","Sugar","Rum","Wool","Wood","Clay","Charcoal","Regolith","Ore","Ant Paste","Steel","Antanium","Gold","Aluminum","Oil","Diamond","Helium 3","Toy","Uranium","Crystalline","Cloth","Pottery","Bricks","Microchip","Robot","Alien Artifact","Triantanium","Alien Relic","Obsidian","Starship","Plastic","Software"],
            "requiresStage":    0,
            "occupation":       "White Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Starship","rate":60000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Economy","Immigration","Economy","Tourism","Entertainment"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":80,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    300,
            "touristDoorway":   true,
            "tradeCapacity":    1000000,
            "upkeepCost":       0.0,
            "giftCapacity":     1000000000,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       110,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Tax Collection Agency",
            "tile":             ["taxcollection"],
            "cost":             [{"resource":"Civics","amount":10000},{"resource":"Ore","amount":9000},{"resource":"Water","amount":1500},{"resource":"Ant Paste","amount":800},{"resource":"Antanium","amount":20000},{"resource":"Gold","amount":8000},{"resource":"Aluminum","amount":2500},{"resource":"Crystalline","amount":2500},{"resource":"Oil","amount":2500},{"resource":"Uranium","amount":2500},{"resource":"Helium 3","amount":1500},{"resource":"Rum","amount":800}],
            "description":      "taxcollection-description",
            "produces":         null,
            "generates":        "Money",
            "generateTime":     3000,
            "generateAmount":   75,
            "tileWidth":        4,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":900},{"resource":"Antanium","amount":2000},{"resource":"Gold","amount":800},{"resource":"Aluminum","amount":200},{"resource":"Crystalline","amount":250},{"resource":"Oil","amount":250},{"resource":"Uranium","amount":250}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1600}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   30,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":6000,"ratio":100},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    120,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Arbiter",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Economy","Government"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Chip Transporter",
            "tile":             ["chiptransporter"],
            "cost":             [{"resource":"Ore","amount":1000},{"resource":"Antanium","amount":300},{"resource":"Gold","amount":600},{"resource":"Aluminum","amount":600},{"resource":"Crystalline","amount":100},{"resource":"Oil","amount":100},{"resource":"Uranium","amount":100},{"resource":"Obsidian","amount":10}],
            "description":      "chiptransporter-description",
            "produces":         null,
            "generates":        "Microchip",
            "generateTime":     500,
            "generateAmount":   1,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":100},{"resource":"Antanium","amount":30},{"resource":"Gold","amount":60},{"resource":"Aluminum","amount":60},{"resource":"Crystalline","amount":10},{"resource":"Uranium","amount":10},{"resource":"Obsidian","amount":8}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":800}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    45,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     "Advanced Chip Transporter",
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Food","rate":300},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Advanced Chip Transporter",
            "tile":             ["advchiptransporter"],
            "cost":             [{"resource":"Ore","amount":2500},{"resource":"Antanium","amount":1500},{"resource":"Gold","amount":1500},{"resource":"Aluminum","amount":1600},{"resource":"Crystalline","amount":500},{"resource":"Oil","amount":200},{"resource":"Uranium","amount":500},{"resource":"Obsidian","amount":50},{"resource":"Microchip","amount":50},{"resource":"Software","amount":150},{"resource":"Robot","amount":5}],
            "description":      "advchiptransporter-description",
            "produces":         null,
            "generates":        "Microchip",
            "generateTime":     500,
            "generateAmount":   30,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":100},{"resource":"Antanium","amount":30},{"resource":"Gold","amount":60},{"resource":"Aluminum","amount":60},{"resource":"Crystalline","amount":10},{"resource":"Uranium","amount":10},{"resource":"Obsidian","amount":8}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2000},{"utility":"Bandwidth","amount":50}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    45,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Food,Robot","rate":700},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Deep Space Interceptor",
            "tile":             ["dsinterceptor"],
            "cost":             [{"resource":"Ore","amount":2800},{"resource":"Antanium","amount":4600},{"resource":"Gold","amount":2200},{"resource":"Aluminum","amount":1200},{"resource":"Microchip","amount":350},{"resource":"Crystalline","amount":30},{"resource":"Uranium","amount":30},{"resource":"Obsidian","amount":30}],
            "description":      "dsinterceptor-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     2000,
            "generateAmount":   50,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":100},{"resource":"Antanium","amount":30},{"resource":"Gold","amount":60},{"resource":"Aluminum","amount":60},{"resource":"Crystalline","amount":10},{"resource":"Uranium","amount":10},{"resource":"Obsidian","amount":8}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":700},{"utility":"Bandwidth","amount":80}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Microchip,Microchip,Microchip,Microchip,Microchip,Microchip,Microchip","output":"Money","time":1400,"ratio":195},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    80,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Economy","Information Technology"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Wheelmakers Lodge",
            "tile":             ["wheellodge"],
            "cost":             [{"resource":"Ore","amount":6500},{"resource":"Antanium","amount":4500},{"resource":"Gold","amount":2500},{"resource":"Aluminum","amount":2500},{"resource":"Wood","amount":2500},{"resource":"Cloth","amount":2500},{"resource":"Ant Paste","amount":1500}],
            "description":      "wheellodge-description",
            "produces":         ["Mobile Construction Mech"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Wheel","amount":800}],
            "sellValue":        [{"resource":"Ore","amount":650},{"resource":"Antanium","amount":450},{"resource":"Gold","amount":250},{"resource":"Aluminum","amount":250},{"resource":"Wood","amount":25},{"resource":"Cloth","amount":25}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":25}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   10,
            "requiresWorkers":  true,
            "smelts":           {"input":"Antanium,Ore,Water","output":"Wheel","time":18000,"ratio":12},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    50,
            "requiresTech":     ["The Wheel"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Durable Goods"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Deployed Construction Mech",
            "tile":             ["deployedconstruction"],
            "cost":             [{"resource":"Gold","amount":300},{"resource":"Aluminum","amount":500},{"resource":"Antanium","amount":300},{"resource":"Wheel","amount":4}],
            "description":      "constructionmech-description",
            "produces":         ["Diamond Bot","Mobile Construction Mech"],
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Gold","amount":30},{"resource":"Aluminum","amount":50},{"resource":"Antanium","amount":30}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":3}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     ["The Wheel"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          "Mobile Construction Mech",
            "canBuildOver":     null
        },
        {
            "name":             "Hipster Lofts",
            "tile":             ["hipsterlofts"],
            "cost":             [{"resource":"Rum","amount":500},{"resource":"Bricks","amount":4850},{"resource":"Ore","amount":8000},{"resource":"Water","amount":600},{"resource":"Steel","amount":9000},{"resource":"Gold","amount":2000},{"resource":"Aluminum","amount":1000},{"resource":"Microchip","amount":320}],
            "description":      "hipsterlofts-description",
            "produces":         null,
            "generates":        "Trash",
            "generateTime":     2000,
            "generateAmount":   50,
            "tileWidth":        4,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Painting","amount":120}],
            "sellValue":        [{"resource":"Bricks","amount":100},{"resource":"Ore","amount":800},{"resource":"Steel","amount":900},{"resource":"Gold","amount":200},{"resource":"Aluminum","amount":100},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":140}],
            "colGenRate":       0,
            "providesShelter":  400,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Rum","output":"Painting","time":12000,"ratio":2},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    70,
            "requiresTech":     ["Low Gravity Masonry","Microgravity Brewing","Low Gravity Masonry"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Rum","rate":550},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Housing"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Crystalline Enrichment Station",
            "tile":             ["crystallineenrichment"],
            "cost":             [{"resource":"Ore","amount":6000},{"resource":"Water","amount":1000},{"resource":"Antanium","amount":6000},{"resource":"Gold","amount":3000},{"resource":"Aluminum","amount":2000},{"resource":"Microchip","amount":400},{"resource":"Crystalline","amount":400},{"resource":"Ant Paste","amount":1000},{"resource":"Helium 3","amount":800}],
            "description":      "crystallineenrichment-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Uranium","amount":3000},{"resource":"Crystalline","amount":1000},{"resource":"Helium 3","amount":1000}],
            "sellValue":        [{"resource":"Ore","amount":2200},{"resource":"Antanium","amount":2400},{"resource":"Gold","amount":1100},{"resource":"Aluminum","amount":800},{"resource":"Microchip","amount":80}],
            "sellWarning":      null,
            "refines":          [{"input":"Crystalline","output":"Crystalline"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Crystalline,Helium 3","output":"Uranium","time":4000,"ratio":2},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    120,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Helium 3","rate":1200},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Unholy Diamond Spawner",
            "tile":             ["unholydiamondspawner"],
            "cost":             [{"resource":"Water","amount":4000},{"resource":"Antanium","amount":1000},{"resource":"Ant Paste","amount":3000},{"resource":"Wood","amount":1000},{"resource":"Aluminum","amount":5000},{"resource":"Antaura","amount":2000},{"resource":"Civics","amount":600}],
            "description":      "unholydiamondspawner-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Water","amount":50},{"resource":"Antanium","amount":100},{"resource":"Ant Paste","amount":50}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   "Unholy Diamond Spawner",
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Antanium Production","Mysticism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    0.5,
                    "y":    0.5,
                    "r":    0.6,
                    "c":    "#E53935",
                    "i":    0.2,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Red Tile",
            "tile":             ["tilered"],
            "cost":             [{"resource":"Ore","amount":3},{"resource":"Clay","amount":2}],
            "description":      "coloredtile-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    8,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Orange Tile",
            "tile":             ["tileorange"],
            "cost":             [{"resource":"Ore","amount":3},{"resource":"Clay","amount":2}],
            "description":      "coloredtile-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    8,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Yellow Tile",
            "tile":             ["tileyellow"],
            "cost":             [{"resource":"Ore","amount":3},{"resource":"Clay","amount":2}],
            "description":      "coloredtile-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    8,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Green Tile",
            "tile":             ["tilegreen"],
            "cost":             [{"resource":"Ore","amount":3},{"resource":"Clay","amount":2}],
            "description":      "coloredtile-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    8,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Blue Tile",
            "tile":             ["tileblue"],
            "cost":             [{"resource":"Ore","amount":3},{"resource":"Clay","amount":2}],
            "description":      "coloredtile-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    8,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Indigo Tile",
            "tile":             ["tileindigo"],
            "cost":             [{"resource":"Ore","amount":3},{"resource":"Clay","amount":2}],
            "description":      "coloredtile-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    8,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Purple Tile",
            "tile":             ["tilepurple"],
            "cost":             [{"resource":"Ore","amount":3},{"resource":"Clay","amount":2}],
            "description":      "coloredtile-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    8,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Magenta Tile",
            "tile":             ["tilemagenta"],
            "cost":             [{"resource":"Ore","amount":3},{"resource":"Clay","amount":2}],
            "description":      "coloredtile-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    8,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Teal Tile",
            "tile":             ["tileteal"],
            "cost":             [{"resource":"Ore","amount":3},{"resource":"Clay","amount":2}],
            "description":      "coloredtile-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    8,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Brown Tile",
            "tile":             ["tilebrown"],
            "cost":             [{"resource":"Ore","amount":3},{"resource":"Clay","amount":2}],
            "description":      "coloredtile-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    8,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "White Tile",
            "tile":             ["tilewhite"],
            "cost":             [{"resource":"Ore","amount":3},{"resource":"Clay","amount":2}],
            "description":      "coloredtile-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    8,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Black Tile",
            "tile":             ["tileblack"],
            "cost":             [{"resource":"Ore","amount":3},{"resource":"Clay","amount":2}],
            "description":      "coloredtile-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         true,
            "driveSpeedMod":    8,
            "stores":           null,
            "sellValue":        null,
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    0,
            "requiresTech":     null,
            "canRenderStatic":  true,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Decorative","Roads"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     true,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ancient Alien Gold Synthesis",
            "tile":             ["aagoldgen"],
            "cost":             [{"resource":"Ore","amount":45000},{"resource":"Steel","amount":40000},{"resource":"Gold","amount":45000},{"resource":"Microchip","amount":9000},{"resource":"Alien Artifact","amount":100}],
            "description":      "aagoldgen-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Gold","amount":150000}],
            "sellValue":        [{"resource":"Ore","amount":4500},{"resource":"Steel","amount":4000},{"resource":"Gold","amount":4500},{"resource":"Microchip","amount":9},{"resource":"Alien Artifact","amount":1}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":550}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   4,
            "requiresWorkers":  true,
            "smelts":           {"input":"Ore,Steel,Uranium","output":"Gold","time":1200,"ratio":350},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    300,
            "requiresTech":     ["Ancient Alien Language"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ore Zapper",
            "tile":             ["regzapper"],
            "cost":             [{"resource":"Ore","amount":9500},{"resource":"Steel","amount":9500},{"resource":"Gold","amount":14500},{"resource":"Microchip","amount":9000},{"resource":"Aluminum","amount":2500},{"resource":"Uranium","amount":120},{"resource":"Alien Artifact","amount":150}],
            "description":      "regzapper-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ore","amount":500},{"resource":"Charcoal","amount":500}],
            "sellValue":        [{"resource":"Ore","amount":450},{"resource":"Steel","amount":650},{"resource":"Gold","amount":140},{"resource":"Microchip","amount":9},{"resource":"Aluminum","amount":150},{"resource":"Uranium","amount":12},{"resource":"Alien Artifact","amount":15}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Ore","output":"Regolith","time":250,"ratio":150},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    90,
            "requiresTech":     ["Ancient Alien Language"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Water,Uranium","rate":3500},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Obsidian Generator",
            "tile":             ["obsgen"],
            "cost":             [{"resource":"Ore","amount":5000},{"resource":"Ant Paste","amount":250},{"resource":"Uranium","amount":250},{"resource":"Aluminum","amount":250},{"resource":"Crystalline","amount":1000}],
            "description":      "obsgen-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Obsidian","amount":15000}],
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Uranium","amount":25},{"resource":"Aluminum","amount":25},{"resource":"Crystalline","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":700}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Ore,Crystalline,Ant Paste","output":"Obsidian","time":1000,"ratio":15},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Crystalline Laser Drill",
            "tile":             ["crystallinedrill"],
            "cost":             [{"resource":"Ore","amount":2000},{"resource":"Antanium","amount":2500},{"resource":"Gold","amount":3000},{"resource":"Microchip","amount":50},{"resource":"Diamond","amount":150},{"resource":"Crystalline","amount":350}],
            "description":      "crystallinedrill-description",
            "produces":         null,
            "generates":        "Water",
            "generateTime":     1000,
            "generateAmount":   130,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":800},{"resource":"Antanium","amount":1200},{"resource":"Gold","amount":1400},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":450}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Crystalline","output":"Water|Uranium|Clay|Diamond","time":600,"ratio":3},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Food"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Bug Saw",
            "tile":             ["bugsaw"],
            "cost":             [{"resource":"Water","amount":950},{"resource":"Ore","amount":1800},{"resource":"Antanium","amount":1750},{"resource":"Gold","amount":180},{"resource":"Aluminum","amount":180},{"resource":"Diamond","amount":120},{"resource":"Oil","amount":75},{"resource":"Clay","amount":120}],
            "description":      "bugsaw-description",
            "produces":         null,
            "generates":        "Food",
            "generateTime":     800,
            "generateAmount":   240,
            "tileWidth":        1,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":250},{"resource":"Antanium","amount":350},{"resource":"Gold","amount":25},{"resource":"Aluminum","amount":40}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Water","output":"Ant Paste","time":600,"ratio":15},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    35,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       1,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#4CAF50",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Food","Entertainment"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":1,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    1,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Radiated Crystal Farm",
            "tile":             ["radcrystalfarm"],
            "cost":             [{"resource":"Water","amount":2000},{"resource":"Ore","amount":14000},{"resource":"Antanium","amount":9000},{"resource":"Gold","amount":9500},{"resource":"Aluminum","amount":4000},{"resource":"Diamond","amount":9000},{"resource":"Oil","amount":3000},{"resource":"Clay","amount":3000},{"resource":"Rum","amount":2000},{"resource":"Software","amount":400},{"resource":"Microchip","amount":400}],
            "description":      "radcrystalfarm-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        3,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":1400},{"resource":"Antanium","amount":900},{"resource":"Gold","amount":950},{"resource":"Aluminum","amount":400},{"resource":"Diamond","amount":900},{"resource":"Oil","amount":30},{"resource":"Clay","amount":30},{"resource":"Microchip","amount":4}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1200},{"utility":"Bandwidth","amount":40}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   1,
            "requiresWorkers":  false,
            "smelts":           {"input":"Water,Uranium,Software,Rum,Rum,Rum","output":"Crystalline","time":600,"ratio":40},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    35,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#4CAF50",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Antanium Radiator",
            "tile":             ["antradiator"],
            "cost":             [{"resource":"Regolith","amount":1500},{"resource":"Ore","amount":5500},{"resource":"Antanium","amount":9000},{"resource":"Gold","amount":6000},{"resource":"Microchip","amount":8000},{"resource":"Obsidian","amount":15000},{"resource":"Helium 3","amount":1000},{"resource":"Robot","amount":2000},{"resource":"Alien Artifact","amount":100},{"resource":"Alien Relic","amount":100}],
            "description":      "antradiator-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Triantanium","amount":150}],
            "sellValue":        [{"resource":"Regolith","amount":100},{"resource":"Ore","amount":550},{"resource":"Antanium","amount":900},{"resource":"Gold","amount":600},{"resource":"Microchip","amount":80},{"resource":"Obsidian","amount":1500}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":3500},{"utility":"Bandwidth","amount":400}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           {"input":"Antanium,Uranium,Uranium","output":"Triantanium|Steel","time":550,"ratio":2},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    600,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Robot","rate":900},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Primitive Robotics Lab",
            "tile":             ["primativeroboticslab"],
            "cost":             [{"resource":"Ore","amount":4000},{"resource":"Water","amount":2500},{"resource":"Antanium","amount":9000},{"resource":"Gold","amount":3000},{"resource":"Aluminum","amount":3000},{"resource":"Obsidian","amount":2000},{"resource":"Microchip","amount":9000},{"resource":"Software","amount":1000}],
            "description":      "primativeroboticslab-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     5000,
            "generateAmount":   1,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Robot","amount":1000}],
            "sellValue":        [{"resource":"Ore","amount":500},{"resource":"Antanium","amount":1200},{"resource":"Gold","amount":300},{"resource":"Microchip","amount":4}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":900}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   25,
            "requiresWorkers":  true,
            "smelts":           {"input":"Aluminum,Software","output":"Robot","time":12000,"ratio":10},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    350,
            "requiresTech":     null,
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    1,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Microchip","rate":2000},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Alien Plastic Factory",
            "tile":             ["plastfact3"],
            "cost":             [{"resource":"Ore","amount":35000},{"resource":"Charcoal","amount":15000},{"resource":"Steel","amount":25000},{"resource":"Oil","amount":16000},{"resource":"Gold","amount":18000},{"resource":"Aluminum","amount":10000},{"resource":"Microchip","amount":25000},{"resource":"Robot","amount":250},{"resource":"Uranium","amount":10000},{"resource":"Alien Artifact","amount":120}],
            "description":      "plastfact3-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        4,
            "tileHeight":       3,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Plastic","amount":80000}],
            "sellValue":        [{"resource":"Ore","amount":3500},{"resource":"Charcoal","amount":1500},{"resource":"Steel","amount":2500},{"resource":"Oil","amount":160},{"resource":"Gold","amount":1800},{"resource":"Aluminum","amount":1000},{"resource":"Microchip","amount":25},{"resource":"Robot","amount":2},{"resource":"Uranium","amount":100},{"resource":"Alien Artifact","amount":12}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1400}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   40,
            "requiresWorkers":  false,
            "smelts":           {"input":"Oil,Water","output":"Plastic","time":7000,"ratio":60},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    150,
            "requiresTech":     ["Next Gen Power Production","Ancient Alien Manufacturing"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       "Blue Collar",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Robot,Water","rate":1200},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Durable Goods","Alien Tech"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Petropit",
            "tile":             ["petropit"],
            "cost":             [{"resource":"Wood","amount":1000},{"resource":"Ant Paste","amount":1000},{"resource":"Crystalline","amount":2500},{"resource":"Ore","amount":7500},{"resource":"Antanium","amount":6500},{"resource":"Gold","amount":4000},{"resource":"Aluminum","amount":2500},{"resource":"Diamond","amount":2500},{"resource":"Obsidian","amount":500}],
            "description":      "petropit-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Oil","amount":3000}],
            "sellValue":        [{"resource":"Crystalline","amount":25},{"resource":"Ore","amount":750},{"resource":"Antanium","amount":650},{"resource":"Gold","amount":400},{"resource":"Aluminum","amount":250},{"resource":"Diamond","amount":250},{"resource":"Obsidian","amount":50}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":80}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   12,
            "requiresWorkers":  true,
            "smelts":           {"input":"Ant Paste,Wood,Obsidian,Crystalline","output":"Oil","time":1600,"ratio":6},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    30,
            "requiresTech":     ["Insectoid Oil Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Food","rate":750},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Petrocone",
            "tile":             ["petrocone"],
            "cost":             [{"resource":"Antanium","amount":20},{"resource":"Aluminum","amount":250},{"resource":"Gold","amount":60}],
            "description":      "oiltank-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Oil","amount":900}],
            "sellValue":        [{"resource":"Antanium","amount":2},{"resource":"Aluminum","amount":25},{"resource":"Gold","amount":6}],
            "sellWarning":      null,
            "refines":          [{"input":"Oil","output":"Oil"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   0,
            "requiresWorkers":  false,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    1,
            "requiresTech":     ["Insectoid Oil Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#222222",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Storage"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Petroplant",
            "tile":             ["petroplant"],
            "cost":             [{"resource":"Wood","amount":1750},{"resource":"Charcoal","amount":200},{"resource":"Clay","amount":250},{"resource":"Ore","amount":4000},{"resource":"Aluminum","amount":4000},{"resource":"Antanium","amount":5500},{"resource":"Gold","amount":2500},{"resource":"Oil","amount":450},{"resource":"Microchip","amount":50}],
            "description":      "petroplant-description",
            "produces":         ["Crudebot"],
            "generates":        "Atmosphere",
            "generateTime":     1000,
            "generateAmount":   30,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Oil","amount":2000}],
            "sellValue":        [{"resource":"Wood","amount":40},{"resource":"Ore","amount":1200},{"resource":"Antanium","amount":1200},{"resource":"Gold","amount":600},{"resource":"Oil","amount":120},{"resource":"Microchip","amount":3}],
            "sellWarning":      null,
            "refines":          [{"input":"Oil","output":"Oil"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":1750}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   20,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    90,
            "requiresTech":     ["Insectoid Oil Production"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        ["Oil"],
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Oil","rate":175},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Unholy Uranium Generator",
            "tile":             ["unholyuraniumgenerator"],
            "cost":             [{"resource":"Ore","amount":2000},{"resource":"Water","amount":2000},{"resource":"Antanium","amount":5000},{"resource":"Gold","amount":3000},{"resource":"Aluminum","amount":4000},{"resource":"Diamond","amount":2000},{"resource":"Antaura","amount":2000}],
            "description":      "unholyuraniumgenerator-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Uranium","amount":1000}],
            "sellValue":        [{"resource":"Ore","amount":200},{"resource":"Antanium","amount":500},{"resource":"Gold","amount":300},{"resource":"Aluminum","amount":400},{"resource":"Diamond","amount":200}],
            "sellWarning":      null,
            "refines":          [{"input":"Uranium","output":"Uranium"}],
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":1200}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   2,
            "requiresWorkers":  true,
            "smelts":           {"input":"Aluminum","output":"Uranium","time":3000,"ratio":26},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    120,
            "requiresTech":     ["Mystic Uranium Generation"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Antaura","rate":800},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Unholy Gold Grower",
            "tile":             ["unholygoldgrower"],
            "cost":             [{"resource":"Ore","amount":15000},{"resource":"Antanium","amount":20000},{"resource":"Gold","amount":5000},{"resource":"Microchip","amount":900},{"resource":"Alien Relic","amount":200},{"resource":"Oil","amount":2500},{"resource":"Antaura","amount":4500}],
            "description":      "unholygoldgrower-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Gold","amount":100000}],
            "sellValue":        [{"resource":"Ore","amount":1500},{"resource":"Antanium","amount":2000},{"resource":"Gold","amount":500},{"resource":"Microchip","amount":9},{"resource":"Alien Relic","amount":2},{"resource":"Oil","amount":25}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":350}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   4,
            "requiresWorkers":  true,
            "smelts":           {"input":"Crystalline,Ore,Antanium,Antaura,Antaura","output":"Gold","time":1000,"ratio":150},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    300,
            "requiresTech":     ["Communal Finance","Mysticism"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Crystalline Growth Chamber",
            "tile":             ["crystalgenerationchamber"],
            "cost":             [{"resource":"Ore","amount":18000},{"resource":"Antanium","amount":15000},{"resource":"Gold","amount":9000},{"resource":"Microchip","amount":25},{"resource":"Cloth","amount":850},{"resource":"Oil","amount":15000},{"resource":"Ant Paste","amount":10000},{"resource":"Clay","amount":4000},{"resource":"Sugar","amount":2000},{"resource":"Uranium","amount":350}],
            "description":      "crystalgenerationchamber-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Crystalline","amount":100000}],
            "sellValue":        [{"resource":"Ore","amount":1800},{"resource":"Antanium","amount":1500},{"resource":"Gold","amount":900},{"resource":"Microchip","amount":2},{"resource":"Cloth","amount":80},{"resource":"Clay","amount":40}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":900}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   8,
            "requiresWorkers":  true,
            "smelts":           {"input":"Uranium,Oil,Oil,Oil,Oil,Sugar,Sugar,Sugar,Ant Paste,Ant Paste","output":"Crystalline","time":300,"ratio":7},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    300,
            "requiresTech":     ["Crystalline Synthesis"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Megamound",
            "tile":             ["megamound"],
            "cost":             [{"resource":"Ore","amount":16000},{"resource":"Antanium","amount":50000},{"resource":"Cloth","amount":2000},{"resource":"Microchip","amount":800},{"resource":"Ant Paste","amount":8000},{"resource":"Aluminum","amount":8000},{"resource":"Oil","amount":6000},{"resource":"Wood","amount":14000},{"resource":"Gold","amount":4000}],
            "description":      "megamound-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   null,
            "tileWidth":        4,
            "tileHeight":       4,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":1600},{"resource":"Antanium","amount":5000},{"resource":"Cloth","amount":200},{"resource":"Microchip","amount":80},{"resource":"Ant Paste","amount":80},{"resource":"Aluminum","amount":800},{"resource":"Oil","amount":60},{"resource":"Wood","amount":140},{"resource":"Gold","amount":400}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":600},{"utility":"Bandwidth","amount":600}],
            "colGenRate":       0,
            "providesShelter":  40,
            "canChain":         false,
            "acceptsWorkers":   100,
            "requiresWorkers":  true,
            "smelts":           {"input":"Cloth,Food,Water,Rum","output":"Money|Money|Civics|Civics|Research","time":1500,"ratio":35},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    25,
            "requiresTech":     ["Antanium Production","Open Doors","Mega Construction"],
            "canRenderStatic":  false,
            "entertains":       150,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    3,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     null,
            "heals":            40,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Tourism"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":6,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    1200,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Chamber of our Fathers",
            "tile":             ["chamberfathers"],
            "cost":             [{"resource":"Ant Paste","amount":15000},{"resource":"Ore","amount":160000},{"resource":"Water","amount":12000},{"resource":"Crystalline","amount":12000},{"resource":"Antanium","amount":140000},{"resource":"Gold","amount":90000},{"resource":"Aluminum","amount":20000},{"resource":"Microchip","amount":9500},{"resource":"Painting","amount":1000},{"resource":"Helium 3","amount":1000},{"resource":"Obsidian","amount":10000},{"resource":"Alien Artifact","amount":200},{"resource":"Civics","amount":300000},{"resource":"Money","amount":1000000}],
            "description":      "chamberfathers-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     200,
            "generateAmount":   225,
            "tileWidth":        8,
            "tileHeight":       5,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":1600},{"resource":"Crystalline","amount":12},{"resource":"Antanium","amount":1400},{"resource":"Gold","amount":900},{"resource":"Aluminum","amount":200},{"resource":"Microchip","amount":9},{"resource":"Obsidian","amount":100}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":25000}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   80,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":14000,"ratio":65},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    60,
            "requiresTech":     [],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Arbiter",
            "indicator":        null,
            "canUpgradeTo":     "Chamber of Kings",
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   true,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     3000000,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    6,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Chamber of Kings",
            "tile":             ["chamberofkings"],
            "cost":             [{"resource":"Ant Paste","amount":200000},{"resource":"Ore","amount":400000},{"resource":"Water","amount":120000},{"resource":"Crystalline","amount":120000},{"resource":"Antanium","amount":200000},{"resource":"Gold","amount":350000},{"resource":"Aluminum","amount":200000},{"resource":"Microchip","amount":35000},{"resource":"Painting","amount":7000},{"resource":"Helium 3","amount":50000},{"resource":"Obsidian","amount":100000},{"resource":"Alien Artifact","amount":300},{"resource":"Alien Relic","amount":300},{"resource":"Civics","amount":3000000},{"resource":"Money","amount":3000000}],
            "description":      "chamberofkings-description",
            "produces":         null,
            "generates":        "Research",
            "generateTime":     190,
            "generateAmount":   500,
            "tileWidth":        8,
            "tileHeight":       5,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":16000},{"resource":"Crystalline","amount":12},{"resource":"Antanium","amount":14000},{"resource":"Gold","amount":9000},{"resource":"Aluminum","amount":2000},{"resource":"Microchip","amount":9},{"resource":"Obsidian","amount":1000}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":50000}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   90,
            "requiresWorkers":  true,
            "smelts":           {"input":"Money","output":"Civics","time":10000,"ratio":350},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    60,
            "requiresTech":     ["Hereditary Rule"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Arbiter",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#dddddd",
            "requiresFuel":     null,
            "heals":            0,
            "isCommsHubBldg":   true,
            "buildCategories":  ["All Buildings","Government"],
            "reqIndependence":  true,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        true,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     500000000,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    7,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Research Converter",
            "tile":             ["researchconvert"],
            "cost":             [{"resource":"Money","amount":8000000},{"resource":"Civics","amount":1800000},{"resource":"Research","amount":7500000},{"resource":"Ore","amount":120000},{"resource":"Steel","amount":180000},{"resource":"Antanium","amount":18000},{"resource":"Gold","amount":100000},{"resource":"Microchip","amount":290000},{"resource":"Plastic","amount":170000},{"resource":"Bricks","amount":85000},{"resource":"Robot","amount":45000},{"resource":"Triantanium","amount":8000},{"resource":"Diamond","amount":8000},{"resource":"Alien Artifact","amount":35000},{"resource":"Ancient Instructions","amount":7000},{"resource":"Crystalline","amount":8000}],
            "description":      "researchconvert-description",
            "produces":         null,
            "generates":        null,
            "generateTime":     null,
            "generateAmount":   5,
            "tileWidth":        2,
            "tileHeight":       2,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           null,
            "sellValue":        [{"resource":"Ore","amount":9000},{"resource":"Steel","amount":14000},{"resource":"Antanium","amount":1500},{"resource":"Gold","amount":8000},{"resource":"Microchip","amount":25},{"resource":"Plastic","amount":1500},{"resource":"Bricks","amount":650},{"resource":"Robot","amount":250},{"resource":"Triantanium","amount":500},{"resource":"Diamond","amount":500},{"resource":"Alien Artifact","amount":250},{"resource":"Ancient Instructions","amount":60},{"resource":"Crystalline","amount":60}],
            "sellWarning":      null,
            "refines":          null,
            "becomesTerrain":   null,
            "providesUtility":  null,
            "requiresUtility":  [{"utility":"Power","amount":2500}],
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         true,
            "acceptsWorkers":   100,
            "requiresWorkers":  true,
            "smelts":           {"input":"Research,Research,Research,Research,Research","output":"Wheel|Food|Water|Rum|Wool|Wood|Cloth|Clay|Sugar|Ant Paste|Charcoal|Regolith|Ore|Steel|Antanium|Diamond|Gold|Aluminum|Oil|Helium 3|Plastic|Toy|Uranium|Pottery|Bricks|Microchip|Robot|Alien Artifact|Crystalline|Alien Relic|Ancient Instructions|Obsidian|Painting","time":175,"ratio":2},
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    650,
            "requiresTech":     ["Transcendence"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    0,
            "occupation":       "Scientist",
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   null,
            "requiresFuel":     {"resource":"Money,Money,Money,Money,Money,Research,Research,Research,Research,Research,Research,Research,Research,Research,Research,Research,Research","rate":18},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Resources","Economy"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          true,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       155,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     [
                {
                    "x":    -3.2,
                    "y":    -3.2,
                    "r":    0.6,
                    "c":    "#71c837",
                    "i":    0.2,
                    "nightonly": true
                }
            ],
            "packsTo":          null,
            "canBuildOver":     null
        },
        {
            "name":             "Ether Powertube",
            "tile":             ["etherreactor"],
            "cost":             [{"resource":"Obsidian","amount":5000},{"resource":"Charcoal","amount":1000},{"resource":"Clay","amount":200},{"resource":"Gold","amount":4000},{"resource":"Aluminum","amount":2000},{"resource":"Antanium","amount":200},{"resource":"Oil","amount":450},{"resource":"Microchip","amount":50},{"resource":"Ether","amount":950}],
            "description":      "etherreactor-description",
            "produces":         null,
            "generates":        "Atmosphere",
            "generateTime":     1000,
            "generateAmount":   10,
            "tileWidth":        1,
            "tileHeight":       1,
            "passable":         false,
            "driveSpeedMod":    null,
            "stores":           [{"resource":"Ether","amount":8000}],
            "sellValue":        [{"resource":"Obsidian","amount":500},{"resource":"Charcoal","amount":10},{"resource":"Clay","amount":2},{"resource":"Gold","amount":400},{"resource":"Aluminum","amount":200},{"resource":"Antanium","amount":20},{"resource":"Microchip","amount":5}],
            "sellWarning":      null,
            "refines":          [{"input":"Ether","output":"Ether"}],
            "becomesTerrain":   null,
            "providesUtility":  [{"utility":"Power","amount":12000}],
            "requiresUtility":  null,
            "colGenRate":       0,
            "providesShelter":  0,
            "canChain":         false,
            "acceptsWorkers":   2,
            "requiresWorkers":  true,
            "smelts":           null,
            "firstBuildMessage":null,
            "isChopShop":       false,
            "earthTaxValue":    90,
            "requiresTech":     ["Insectoid Oil Production","Insectoid Bureaucracy"],
            "canRenderStatic":  false,
            "entertains":       0,
            "canImport":        null,
            "canExport":        null,
            "requiresStage":    2,
            "occupation":       null,
            "indicator":        null,
            "canUpgradeTo":     null,
            "transModeColor":   "#FFA000",
            "requiresFuel":     {"resource":"Ether","rate":100},
            "heals":            0,
            "isCommsHubBldg":   null,
            "buildCategories":  ["All Buildings","Power"],
            "reqIndependence":  false,
            "onlineTradeDepot": false,             
            "selectionSound":   null,
            "isConsulate":      false,
            "isEmbassy":        false,
            "buildLimit":       0,
            "isCapitol":        false,
            "entertainmentCost":0,
            "requiPremium":     false,
            "embargoImmune":    false,
            "takesTourists":    0,
            "touristDoorway":   false,
            "tradeCapacity":    0,
            "upkeepCost":       0.0,
            "giftCapacity":     0,
            "canFlip":          false,
            "isSign":           false,
            "unlocksGovLvl":    0,
            "defaultHouseCost": 0,
            "requiresIQ":       0,
            "educates":         0,
            "providesIQ":       0,
            "isStargate":       false,
            "lightEffects":     null,
            "packsTo":          null,
            "canBuildOver":     null
        }
    ],
    "vehicles": [
        {
            "name":             "Airborne Lander",
            "cost":             null,
            "tile":             "landerairborne",
            "description":      "lander-description",
            "produces":         null,
            "sellValue":        [{"resource":"Steel","amount":10},{"resource":"Gold","amount":2},{"resource":"Microchip","amount":2},{"resource":"Uranium","amount":1}],
            "sellWarning":      "lander-sell-warning",
            "harvests":         null,
            "capacity":         0,
            "requiresTech":     ["United Earth Base"],
            "requiresStage":    0,
            "indicator":        "ind-airbornelander.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   ["lander-awaiting","lander-sir"],
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        "Lander",
            "isFlying":         true,
            "vehicleCarryCapacity": 1,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": ["lander-firing-thrusters","lander-manuver"],
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":["lander-deploy","lander-eagle-landed"],
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Rover",
            "cost":             [{"resource":"Ore","amount":5},{"resource":"Wheel","amount":6}],
            "tile":             "rover",
            "description":      "rover-description",
            "produces":         ["Raw Materials Depot","Greenhouse","Fisherbots Hut","Small Water Pump","Salt Water Pump","Salt Water Tank","Small Solar Panel","Small Vehicle Factory"],
            "sellValue":        [{"resource":"Ore","amount":2},{"resource":"Wheel","amount":3}],
            "sellWarning":      null,
            "harvests":         "Ore",
            "capacity":         10,
            "requiresTech":     ["United Earth Base","Red Planet Base|Sugarland Base|Asteroid Base|Abandoned World Base|Ice World Base|Lava World Base|Water World Base"],
            "requiresStage":    0,
            "indicator":        "ind-rover.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":"rover-firstbuild-tut",
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Lunar Rover",
            "cost":             [{"resource":"Regolith","amount":10},{"resource":"Wheel","amount":6}],
            "tile":             "lunarrover",
            "description":      "lunarrover-description",
            "produces":         ["Raw Materials Depot","Small Helium 3 Extractor","Regolith Compactor","Greenhouse","Water Extractor","Small Solar Panel","Small Vehicle Factory"],
            "sellValue":        [{"resource":"Regolith","amount":3},{"resource":"Wheel","amount":3}],
            "sellWarning":      null,
            "harvests":         "Regolith",
            "capacity":         10,
            "requiresTech":     ["Human Base","Lunar Base"],
            "requiresStage":    0,
            "indicator":        "ind-lunarrover.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":"lunar-rover-firstbuild-tut",
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Forest Rover",
            "cost":             [{"resource":"Wood","amount":40},{"resource":"Wheel","amount":6}],
            "tile":             "forestrover",
            "description":      "forestrover-description",
            "produces":         ["Fir Trees","Raw Materials Depot","Potato Patch","Fisherbots Hut","Water Well","Salt Water Pump","Salt Water Tank","Wood Hut","Charcoal Hut","Charcoal Compactor","Charcoal Burner","Charcoal Pile","Small Vehicle Factory","Tree Farm","Ether Tree Farm"],
            "sellValue":        [{"resource":"Wood","amount":10},{"resource":"Wheel","amount":3}],
            "sellWarning":      null,
            "harvests":         "Wood",
            "capacity":         2,
            "requiresTech":     ["Forest World Base|Water World Base"],
            "requiresStage":    2,
            "indicator":        "ind-forestrover.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":"forestrover-firstbuild-tut",
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Builder Bot",
            "cost":             [{"resource":"Ore","amount":15},{"resource":"Wheel","amount":6}],
            "tile":             "builder",
            "description":      "builder-description",
            "produces":         ["Sand Path","Pavement","Pavement Lit","Compacted Snow Path","Crushed Regolith Path","Mulched Wood Path","Foot Path","Small Wooden Bridge","Small Wooden Bridge NS","Sand","Checkered Pavement","Caution Sign","Wall","Raw Materials Depot","Ether Storage","Small Helium 3 Extractor","Small Light Post","Small Red Light Post","Small Green Light Post","Regolith Compactor","Charcoal Compactor","Microincinerator","Charcoal Burner","Silo","Water Tank","Helium 3 Tank","Greenhouse","Water Extractor","Small Water Pump","Salt Water Pump","Salt Water Tank","Regolith Furnace","Small Solar Panel","Internet Relay Booth","Small Shelter","Golden Shelter","First Aid Station","Distillery","Rum Cellar","Pub","Arcade Center","Jewelry Store","Single Family Home","Brick House","Gift Shop","Restaurant","Small Vehicle Factory","Landing Pad","Ore Refinery","Small Elementary School","Chop Shop","Small Atmosphere Generator","Gold Refinery","Gold Mint","Desalination Factility","Charcoal Factory","Statue of Two","Statue","Commemorative Plaque","Statue of Domination","National Flag","Red Flag","Blue Flag","Green Flag","Purple Flag","White Flag","Black Flag","League of Independent States Flag","Small Research Lab","Advanced Small Research Lab","Medical Clinic", "Advanced Hydroponics Center","Fish Cannery","Solar Road","Solar Tower","Diamond Solar Tower"],
            "sellValue":        [{"resource":"Ore","amount":5},{"resource":"Wheel","amount":3}],
            "sellWarning":      null,
            "harvests":         null,
            "capacity":         null,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "ind-builder.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":"builderbot-firstbuild-tut",
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Ore Miner",
            "cost":             [{"resource":"Ore","amount":30},{"resource":"Wheel","amount":8}],
            "tile":             "miner",
            "description":      "miner-description",
            "produces":         ["Ore Mine"],
            "sellValue":        [{"resource":"Ore","amount":10},{"resource":"Wheel","amount":4}],
            "sellWarning":      null,
            "harvests":         "Ore",
            "capacity":         30,
            "requiresTech":     ["United Earth Base","Red Planet Base|Water World Base"],
            "requiresStage":    0,
            "indicator":        "ind-miner.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Used Ore Miner",
            "cost":             [{"resource":"Ore","amount":15},{"resource":"Wheel","amount":8}],
            "tile":             "usedminer",
            "description":      "usedminer-description",
            "produces":         ["Ore Mine"],
            "sellValue":        [{"resource":"Ore","amount":5},{"resource":"Wheel","amount":4}],
            "sellWarning":      null,
            "harvests":         "Ore",
            "capacity":         15,
            "requiresTech":     ["LIS Base","Red Planet Base|Water World Base"],
            "requiresStage":    0,
            "indicator":        "ind-usedminer.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Regolith Miner",
            "cost":             [{"resource":"Ore","amount":15},{"resource":"Regolith","amount":20},{"resource":"Wheel","amount":8}],
            "tile":             "regminer",
            "description":      "regminer-description",
            "produces":         ["Regolith Mine"],
            "sellValue":        [{"resource":"Ore","amount":2},{"resource":"Regolith","amount":3},{"resource":"Wheel","amount":4}],
            "sellWarning":      null,
            "harvests":         "Regolith",
            "capacity":         30,
            "requiresTech":     ["Lunar Base|Asteroid Base|Abandoned World Base"],
            "requiresStage":    0,
            "indicator":        "ind-regminer.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Gold Miner",
            "cost":             [{"resource":"Ore","amount":50},{"resource":"Steel","amount":10},{"resource":"Wheel","amount":8}],
            "tile":             "goldminer",
            "description":      "goldminer-description",
            "produces":         ["Gold Mine","Golden Bridge","Golden Bridge NS"],
            "sellValue":        [{"resource":"Ore","amount":20},{"resource":"Steel","amount":3},{"resource":"Wheel","amount":4}],
            "sellWarning":      null,
            "harvests":         "Gold",
            "capacity":         6,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "ind-gold-miner.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":"goldmienr-firstbuild",
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Diamond Miner",
            "cost":             [{"resource":"Steel","amount":30},{"resource":"Wheel","amount":8}],
            "tile":             "diamondminer",
            "description":      "diamondminer-description",
            "produces":         ["Diamond Refinery"],
            "sellValue":        [{"resource":"Steel","amount":10},{"resource":"Wheel","amount":4}],
            "sellWarning":      null,
            "harvests":         "Diamond",
            "capacity":         15,
            "requiresTech":     ["Diamond Mining","Asteroid Base|Ice World Base|Lava World Base|Desert World Base|Water World Base"],
            "requiresStage":    0,
            "indicator":        "ind-diamondminer.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Advanced Builder Bot",
            "cost":             [{"resource":"Ore","amount":30},{"resource":"Steel","amount":35},{"resource":"Gold","amount":10},{"resource":"Wheel","amount":6}],
            "tile":             "builder2",
            "description":      "builder2-description",
            "produces":         ["Brick Road","Yellow Brick Road","Brick Wall","Hardened Pavement","Hardened Pavement Lit","Dark Pavement","Dark Pavement Lit","Rainbow Road","Aluminum Road","Steel Bridge","Steel Bridge NS","Mesh Platform","Security Wall","Security Wall Light","Small Trash Pit","Street Light","Single Family Home","Blue House","Green House","Yellow House","Brick House","Fountain","Adult Daycare","Small Elementary School","Large Silo","Charcoal Pile","Oil Tank","Water Tower","Green Dome","Statue of Two","Statue","Statue of Domination","Transmission Hub","Advanced Hydroponics Center","Fish Cannery","Solar Road","Solar Tower","Diamond Solar Tower","Steel Yard","Diamond Refinery","Uranium Silo","Advanced Ore Refinery","Durable Goods Warehouse","Counterfeit Market","Fine Arts Warehouse","Residential Complex","Blue Residential Complex","Hipster Bar","House of Horror","Atmosphere Condenser","Mass Driver","Cybercoin Mine","Data Interceptor","Hacker Camp","Black Market Bazzar","NetSchool","Small Server Building","Small Software Studio","Small Server Farm Operation","Space Port","Motel","Medium Atmosphere Generator","Hotel","Small Casino","Wheel Factory","Microchip Factory","Oil Plant","Cloning Facility","Small Recycling Center","Civic Center","Integrated Civic Center","Official News Station","Old Electronics Chop Shop","Small High School","Synthetic Diamond Laboratory","Consulate","Colonial Assembly","Consulate Level 2","Consulate Level 3","Supermarket","Bank","Pottery Works","Brick Factory","Textile Mill","Synthetic Textile Mill","Ore Fracking Operation","Regolith Extraction Inc","Gold Synthesis Lab","Ore Synthesis Lab","Synthetic Oil Lab","Aluminum Refinery","Robot Factory","Museum","Fish Hatchery","Fishery","Small Stadium","Colonimulation Hub","Bureau of Bureaucracy","Nuclear Reactor"],
            "sellValue":        [{"resource":"Ore","amount":12},{"resource":"Steel","amount":15},{"resource":"Gold","amount":4},{"resource":"Wheel","amount":3}],
            "sellWarning":      null,
            "harvests":         null,
            "capacity":         null,
            "requiresTech":     ["Advanced Small Scale Construction"],
            "requiresStage":    0,
            "indicator":        "ind-construction-2.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Ice Chipper",
            "cost":             [{"resource":"Ore","amount":3},{"resource":"Wheel","amount":6}],
            "tile":             "icechipper",
            "description":      "icechipper-description",
            "produces":         null,
            "sellValue":        [{"resource":"Ore","amount":1},{"resource":"Wheel","amount":3}],
            "sellWarning":      null,
            "harvests":         "Water",
            "capacity":         10,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "ind-icechipper.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Waterbot",
            "cost":             [{"resource":"Ore","amount":3},{"resource":"Wheel","amount":6}],
            "tile":             "icechipper",
            "description":      "waterbot-description",
            "produces":         null,
            "sellValue":        [{"resource":"Ore","amount":1},{"resource":"Wheel","amount":3}],
            "sellWarning":      null,
            "harvests":         "Water",
            "capacity":         10,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "ind-icechipper.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Fisherbot",
            "cost":             [{"resource":"Ore","amount":1},{"resource":"Wood","amount":4},{"resource":"Wheel","amount":6}],
            "tile":             "fisherbot",
            "description":      "fisherbot-description",
            "produces":         null,
            "sellValue":        [{"resource":"Ore","amount":1},{"resource":"Wheel","amount":3}],
            "sellWarning":      null,
            "harvests":         "Fish",
            "capacity":         2,
            "requiresTech":     ["Water World Base"],
            "requiresStage":    0,
            "indicator":        "ind-fisherbot.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Aluminum Miner",
            "cost":             [{"resource":"Ore","amount":80},{"resource":"Steel","amount":120},{"resource":"Microchip","amount":12},{"resource":"Wheel","amount":8}],
            "tile":             "aluminumminer",
            "description":      "aluminumminer-description",
            "produces":         ["Aluminum Bridge","Aluminum Bridge NS"],
            "sellValue":        [{"resource":"Ore","amount":30},{"resource":"Steel","amount":50},{"resource":"Wheel","amount":4}],
            "sellWarning":      null,
            "harvests":         "Aluminum",
            "capacity":         8,
            "requiresTech":     ["Advanced Chemistry"],
            "requiresStage":    0,
            "indicator":        "ind-aluminum-miner.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Small Rover Transport",
            "cost":             [{"resource":"Ore","amount":90},{"resource":"Aluminum","amount":120},{"resource":"Gold","amount":100},{"resource":"Oil","amount":60}],
            "tile":             "rovertransport",
            "description":      "rovertransport-description",
            "produces":         null,
            "sellValue":        [{"resource":"Ore","amount":12},{"resource":"Aluminum","amount":15},{"resource":"Gold","amount":4}],
            "sellWarning":      null,
            "harvests":         null,
            "capacity":         null,
            "requiresTech":     ["Advanced Chemistry","Advanced Small Scale Construction"],
            "requiresStage":    2,
            "indicator":        "ind-rovertransport.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         true,
            "vehicleCarryCapacity": 5,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Crudebot",
            "cost":             [{"resource":"Ore","amount":80},{"resource":"Steel","amount":120},{"resource":"Microchip","amount":12},{"resource":"Wheel","amount":8}],
            "tile":             "crudebot",
            "description":      "crudebot-description",
            "produces":         ["Oil Tank","Oil Plant"],
            "sellValue":        [{"resource":"Ore","amount":30},{"resource":"Steel","amount":50},{"resource":"Wheel","amount":4}],
            "sellWarning":      null,
            "harvests":         "Oil",
            "capacity":         12,
            "requiresTech":     ["Low Gravity Oil Production","Forest World Base|Water World Base|Desert World Base"],
            "requiresStage":    2,
            "indicator":        "ind-crudebot.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Uranium Miner",
            "cost":             [{"resource":"Ore","amount":120},{"resource":"Steel","amount":200},{"resource":"Microchip","amount":20},{"resource":"Aluminum","amount":40},{"resource":"Wheel","amount":8}],
            "tile":             "uraniumminer",
            "description":      "uraniumminer-description",
            "produces":         ["Uranium Silo"],
            "sellValue":        [{"resource":"Ore","amount":50},{"resource":"Steel","amount":80},{"resource":"Microchip","amount":2},{"resource":"Aluminum","amount":12},{"resource":"Wheel","amount":4}],
            "sellWarning":      null,
            "harvests":         "Uranium",
            "capacity":         8,
            "requiresTech":     ["Advanced Nuclear Physics"],
            "requiresStage":    0,
            "indicator":        "ind-uranium-miner.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Greenbot",
            "cost":             [{"resource":"Ore","amount":60},{"resource":"Steel","amount":45},{"resource":"Gold","amount":15},{"resource":"Aluminum","amount":20},{"resource":"Microchip","amount":5},{"resource":"Wheel","amount":6}],
            "tile":             "greenbot",
            "description":      "greenbot-description",
            "produces":         ["Grass","Grass Scrub","Mail Box","Basket Ball Hoop","Fir Trees","Fountain","Red Flower Garden","Purple Flower Garden","Blue Flower Garden","White Flower Garden","Yellow Flower Garden","Cactus 1","Cactus 2","Cactus 3","Palm 1","Palm 2","Lush Hedge Wall","Decorative Fir Trees","Potato Patch","Water Well","Wood Hut","Water Pool","Small Trash Pit","Lumber Mill","Lumber Yard","Bacteria Farm","Tree Farm","Ether Tree Farm","Sheep Farm","Large Park"],
            "sellValue":        [{"resource":"Ore","amount":25},{"resource":"Steel","amount":16},{"resource":"Gold","amount":6},{"resource":"Aluminum","amount":8},{"resource":"Microchip","amount":1},{"resource":"Wheel","amount":3}],
            "sellWarning":      null,
            "harvests":         null,
            "capacity":         null,
            "requiresTech":     ["Advanced Microbiology"],
            "requiresStage":    1,
            "indicator":        "ind-greenbot.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Lumberbot",
            "cost":             [{"resource":"Ore","amount":60},{"resource":"Steel","amount":45},{"resource":"Gold","amount":15},{"resource":"Aluminum","amount":20},{"resource":"Microchip","amount":5},{"resource":"Wheel","amount":6}],
            "tile":             "lumberbot",
            "description":      "lumberbot-description",
            "produces":         ["Fir Trees","Decorative Fir Trees","Wood Hut","Charcoal Hut","Lumber Yard"],
            "sellValue":        [{"resource":"Ore","amount":25},{"resource":"Steel","amount":16},{"resource":"Gold","amount":6},{"resource":"Aluminum","amount":8},{"resource":"Microchip","amount":1},{"resource":"Wheel","amount":3}],
            "sellWarning":      null,
            "harvests":         "Wood",
            "capacity":         6,
            "requiresTech":     ["Advanced Microbiology"],
            "requiresStage":    2,
            "indicator":        "ind-lumberbot.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Claybot",
            "cost":             [{"resource":"Ore","amount":60},{"resource":"Steel","amount":45},{"resource":"Gold","amount":15},{"resource":"Aluminum","amount":20},{"resource":"Microchip","amount":5},{"resource":"Wheel","amount":8}],
            "tile":             "claybot",
            "description":      "claybot-description",
            "produces":         ["Clay Mine","Pottery Works","Brick Factory","Sand","Yellow Sand","Orange Sand","Brick Road","Yellow Brick Road","Brick Wall","Cactus 1","Cactus 2","Cactus 3","Palm 1","Palm 2","Sand Dune","Deck Chairs","Desert Skull","Red Tile","Orange Tile","Yellow Tile","Green Tile","Blue Tile","Indigo Tile","Purple Tile","Magenta Tile","Teal Tile","Brown Tile","Black Tile","White Tile"],
            "sellValue":        [{"resource":"Ore","amount":25},{"resource":"Steel","amount":16},{"resource":"Gold","amount":6},{"resource":"Aluminum","amount":8},{"resource":"Microchip","amount":1},{"resource":"Wheel","amount":4}],
            "sellWarning":      null,
            "harvests":         "Clay",
            "capacity":         4,
            "requiresTech":     ["Clay Production"],
            "requiresStage":    1,
            "indicator":        "ind-claybot.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Megabot",
            "cost":             [{"resource":"Ore","amount":80},{"resource":"Steel","amount":70},{"resource":"Gold","amount":40},{"resource":"Aluminum","amount":40},{"resource":"Microchip","amount":10},{"resource":"Wheel","amount":6}],
            "tile":             "megabot",
            "description":      "megabot-description",
            "produces":         ["Aluminum Bridge","Aluminum Bridge NS","Golden Bridge","Golden Bridge NS","Large Water Tower","Large Helium 3 Tank","Subterranean Food Storage","Subterranean Charcoal Cavern","Large Atmosphere Generator","Large Medical Clinic","Integrated Medical Clinic","The Lander of Liberty","Official News Station","Imperial Propaganda Office","Online Black Market Office","Obelisk of Colonial Independence","Proxy Server Building","I.T. Studio Complex","Large Server Building","Small Hospital","Small Community College","University","Tall Brick Warehouse","Medium Recycling Center","Incinerator","Bureau of Bureaucracy","Hydrogen Reactor","Giorgio Institute for Alien Research","Hipster Lofts","Large Residential Complex","Uranium Enrichment Facility","Galactic Freight","Obsidian Furnace","Advanced Microchip Factory","Plastic Factory","Artificial Sweetner Factory","Conference Hall","Advanced Medical Research Center","Clothing Sweatshop","Toy Sweatshop","Food Processing Sweatshop","Tech Office Building","Luxury Tower","Large Resort","Galactic Stock Exchange","Galactic Board of Trade","League Trade Authority","Consulate Level 4","Consulate Level 5","Independence Hall","Independence Hall Level 2","Capitol","Capitol Level 2","Capitol Level 3","Capitol Level 4","Capitol Level 5","Independence Hall Level 3","Subterranean Housing Module","Zoo","Pyramid of the All Seeing Eye","Outdoor Shopping Mall","Statue of Admiral Tots","Presidential Statue","Monument of Heroes","Statue of Unbridled Excess","Landfill","Archaeological Dig Site"],
            "sellValue":        [{"resource":"Ore","amount":35},{"resource":"Steel","amount":30},{"resource":"Gold","amount":15},{"resource":"Aluminum","amount":15},{"resource":"Microchip","amount":2},{"resource":"Wheel","amount":3}],
            "sellWarning":      null,
            "harvests":         null,
            "capacity":         null,
            "requiresTech":     ["Large Scale Construction"],
            "requiresStage":    0,
            "indicator":        "ind-megabot.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Megabot Deluxe",
            "cost":             [{"resource":"Ore","amount":80},{"resource":"Steel","amount":70},{"resource":"Gold","amount":240},{"resource":"Aluminum","amount":40},{"resource":"Microchip","amount":20},{"resource":"Wheel","amount":6}],
            "tile":             "megabotdeluxe",
            "description":      "megabotdeluxe-description",
            "produces":         ["Aluminum Bridge","Aluminum Bridge NS","Golden Bridge","Golden Bridge NS","Large Water Tower","Large Helium 3 Tank","Subterranean Food Storage","Subterranean Charcoal Cavern","Large Atmosphere Generator","Large Medical Clinic","Integrated Medical Clinic","The Lander of Liberty","Official News Station","Imperial Propaganda Office","Online Black Market Office","Obelisk of Colonial Independence","Proxy Server Building","I.T. Studio Complex","Large Server Building","Small Hospital","Small Community College","University","Tall Brick Warehouse","Medium Recycling Center","Incinerator","Bureau of Bureaucracy","Hydrogen Reactor","Giorgio Institute for Alien Research","Hipster Lofts","Large Residential Complex","Uranium Enrichment Facility","Galactic Freight","Obsidian Furnace","Advanced Microchip Factory","Plastic Factory","Artificial Sweetner Factory","Conference Hall","Advanced Medical Research Center","Clothing Sweatshop","Toy Sweatshop","Food Processing Sweatshop","Tech Office Building","Luxury Tower","Large Resort","Galactic Stock Exchange","Galactic Board of Trade","League Trade Authority","Consulate Level 4","Consulate Level 5","Independence Hall","Independence Hall Level 2","Capitol","Capitol Level 2","Capitol Level 3","Capitol Level 4","Capitol Level 5","Independence Hall Level 3","Subterranean Housing Module","Zoo","Pyramid of the All Seeing Eye","Outdoor Shopping Mall","Statue of Admiral Tots","Presidential Statue","Monument of Heroes","Statue of Unbridled Excess","Landfill","Archaeological Dig Site"],
            "sellValue":        [{"resource":"Ore","amount":35},{"resource":"Steel","amount":30},{"resource":"Gold","amount":15},{"resource":"Aluminum","amount":15},{"resource":"Microchip","amount":2},{"resource":"Wheel","amount":3}],
            "sellWarning":      null,
            "harvests":         null,
            "capacity":         null,
            "requiresTech":     ["Large Scale Construction"],
            "requiresStage":    0,
            "indicator":        "ind-megabotdeluxe.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     true,
            "firstBuildMessage":null,
            "buildSpeed":       30,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Construction Drone",
            "cost":             [{"resource":"Gold","amount":50},{"resource":"Aluminum","amount":400},{"resource":"Uranium","amount":10},{"resource":"Microchip","amount":60},{"resource":"Robot","amount":2},{"resource":"Software","amount":5}],
            "tile":             "condrone",
            "description":      "condrone-description",
            "produces":         ["Antanium Synthesis Lab","Ant Paste Synthesizer","Advanced Synthetic Oil Lab","Advanced Plastic Factory","Megamart","Vertical Warehouse Farm","Space Elevator","Larger Residential Complex","Residential Tower","Blue Residential Tower","Medium Stadium","Big Playhouse","Capitol Level 6","Investment Bank","Triantanium Refinery","Auntie Belles Cupcake Factory","Center for Artificial Learning","Center for Relic Studies","Advanced Clothing Sweatshop","Advanced Robotics Inc.","Star Gate","Arcology","Fantasy Land Arcology","Diamond Crystal Reactor","Atmosphere Scrubber","Transcendent Academy","Hall of Congress","Gravitational Compression Warehouse","Research Converter","Department of Advanced Fish Mating Studies","Advanced Cloning Facility","Transcendent Triantanium Generator","Ship Yard","Advanced Ship Yard","Star Port"],
            "sellValue":        [{"resource":"Gold","amount":550},{"resource":"Aluminum","amount":40},{"resource":"Uranium","amount":1},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "harvests":         null,
            "capacity":         null,
            "requiresTech":     ["Tall Construction","Advanced Robotics"],
            "requiresStage":    1,
            "indicator":        "ind-condrone.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         true,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Turbo Drone",
            "cost":             [{"resource":"Gold","amount":75},{"resource":"Aluminum","amount":600},{"resource":"Uranium","amount":20},{"resource":"Microchip","amount":140},{"resource":"Robot","amount":10},{"resource":"Alien Artifact","amount":100},{"resource":"Software","amount":25}],
            "tile":             "turbodrone",
            "description":      "turbodrone-description",
            "produces":         ["Antanium Synthesis Lab","Ant Paste Synthesizer","Advanced Synthetic Oil Lab","Advanced Plastic Factory","Megamart","Vertical Warehouse Farm","Space Elevator","Larger Residential Complex","Residential Tower","Blue Residential Tower","Medium Stadium","Big Playhouse","Capitol Level 6","Investment Bank","Triantanium Refinery","Auntie Belles Cupcake Factory","Center for Artificial Learning","Center for Relic Studies","Advanced Clothing Sweatshop","Advanced Robotics Inc.","Star Gate","Arcology","Fantasy Land Arcology","Diamond Crystal Reactor","Atmosphere Scrubber","Transcendent Academy","Hall of Congress","Statue of Unbridled Excess","Gravitational Compression Warehouse","Research Converter","Department of Advanced Fish Mating Studies","Advanced Cloning Facility","Transcendent Triantanium Generator","Ship Yard","Advanced Ship Yard","Star Port"],
            "sellValue":        [{"resource":"Gold","amount":550},{"resource":"Aluminum","amount":40},{"resource":"Uranium","amount":1},{"resource":"Microchip","amount":2}],
            "sellWarning":      null,
            "harvests":         null,
            "capacity":         null,
            "requiresTech":     ["Tall Construction","Advanced Robotics"],
            "requiresStage":    1,
            "indicator":        "ind-turbodrone.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     true,
            "firstBuildMessage":null,
            "buildSpeed":       40,
            "deploysTo":        null,
            "isFlying":         true,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Extraterrestrial Builder",
            "cost":             [{"resource":"Ore","amount":300},{"resource":"Steel","amount":300},{"resource":"Gold","amount":750},{"resource":"Uranium","amount":200},{"resource":"Microchip","amount":950},{"resource":"Alien Artifact","amount":10},{"resource":"Wheel","amount":6}],
            "tile":             "etbuilder",
            "description":      "etbuilder-description",
            "produces":         ["Charcoal Converter","Ore Zapper","Ancient Alien Gold Synthesis","Aluminum Generator","Integrated Aluminum Generator","Ancient Alien Condenser","Quantum Warehouse","Quantum Food Storage","Quantum Water Tower","Quantum Oil Tank","Quantum Distillery","Ancient Alien Ore Refinery","Ancient Alien Microchip Factory","Ultra Deep Dig Site","Alien Solar Tower","Quantum Nuclear Reactor","Alien Power Tower","Alien Enrichment Facility","Alien Plastic Factory"],
            "sellValue":        [{"resource":"Ore","amount":120},{"resource":"Steel","amount":120},{"resource":"Gold","amount":300},{"resource":"Uranium","amount":20},{"resource":"Microchip","amount":6},{"resource":"Alien Artifact","amount":1},{"resource":"Wheel","amount":3}],
            "sellWarning":      null,
            "harvests":         null,
            "capacity":         null,
            "requiresTech":     ["Ancient Alien Language"],
            "requiresStage":    2,
            "indicator":        "ind-etbuilder.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Turbo ET Builder",
            "cost":             [{"resource":"Ore","amount":350},{"resource":"Steel","amount":350},{"resource":"Gold","amount":750},{"resource":"Uranium","amount":250},{"resource":"Microchip","amount":1050},{"resource":"Alien Artifact","amount":12},{"resource":"Wheel","amount":6}],
            "tile":             "turboet",
            "description":      "turboet-description",
            "produces":         ["Charcoal Converter","Ore Zapper","Ancient Alien Gold Synthesis","Aluminum Generator","Integrated Aluminum Generator","Ancient Alien Condenser","Quantum Warehouse","Quantum Food Storage","Quantum Water Tower","Quantum Oil Tank","Quantum Distillery","Ancient Alien Ore Refinery","Ancient Alien Microchip Factory","Ultra Deep Dig Site","Alien Solar Tower","Quantum Nuclear Reactor","Alien Power Tower","Alien Enrichment Facility","Alien Plastic Factory"],
            "sellValue":        [{"resource":"Ore","amount":120},{"resource":"Steel","amount":120},{"resource":"Gold","amount":300},{"resource":"Uranium","amount":20},{"resource":"Microchip","amount":6},{"resource":"Alien Artifact","amount":1},{"resource":"Wheel","amount":3}],
            "sellWarning":      null,
            "harvests":         null,
            "capacity":         null,
            "requiresTech":     ["Ancient Alien Language"],
            "requiresStage":    2,
            "indicator":        "ind-turboet.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     true,
            "firstBuildMessage":null,
            "buildSpeed":       40,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Crystalbot",
            "cost":             [{"resource":"Ore","amount":80},{"resource":"Steel","amount":70},{"resource":"Gold","amount":40},{"resource":"Aluminum","amount":40},{"resource":"Microchip","amount":10},{"resource":"Wheel","amount":6}],
            "tile":             "crystalbot",
            "description":      "crystalbot-description",
            "produces":         ["Synthetic Crystalline Deposit"],
            "sellValue":        [{"resource":"Ore","amount":8},{"resource":"Steel","amount":7},{"resource":"Gold","amount":4},{"resource":"Aluminum","amount":4},{"resource":"Microchip","amount":1},{"resource":"Wheel","amount":3}],
            "sellWarning":      null,
            "harvests":         "Crystalline",
            "capacity":         8,
            "requiresTech":     ["United Earth Base","Crystalline Synthesis"],
            "requiresStage":    0,
            "indicator":        "ind-crystalbot.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Waterbug",
            "cost":             [{"resource":"Food","amount":20}],
            "tile":             "waterbug",
            "description":      "waterbug-description",
            "produces":         ["Communal Water Vats","Water Pool","Aqua Ring","Aqua Scrubber","Aquamound","Designated Swim Area","Seabeet Farm","Wet Mound","Wet Cone"],
            "sellValue":        [{"resource":"Food","amount":1}],
            "sellWarning":      null,
            "harvests":         "Water",
            "capacity":         10,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "waterbug-ind.png",
            "buildCategories":  ["All Workers"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":"waterbug-firstbuild-tut",
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Fisherbug",
            "cost":             [{"resource":"Food","amount":20}],
            "tile":             "fisherbug",
            "description":      "fisherbug-description",
            "produces":         ["Aqua Ring","Aqua Scrubber","Aquamound","Designated Swim Area","Seabeet Farm"],
            "sellValue":        [{"resource":"Food","amount":1}],
            "sellWarning":      null,
            "harvests":         "Fish",
            "capacity":         5,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "ind-fisherbug.png",
            "buildCategories":  ["All Workers"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Queen",
            "cost":             [{"resource":"Food","amount":50},{"resource":"Sugar","amount":250}],
            "tile":             "queen",
            "description":      "queen-description",
            "produces":         null,
            "sellValue":        [{"resource":"Food","amount":1}],
            "sellWarning":      null,
            "harvests":         null,
            "capacity":         null,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "ind-queen.png",
            "buildCategories":  ["All Workers"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        "Mound",
            "isFlying":         true,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Worker Drone",
            "cost":             [{"resource":"Food","amount":20}],
            "tile":             "insectoid1",
            "description":      "workerdrone-description",
            "produces":         ["Sugarcane","Sand Path","Compacted Snow Path","Paste Path","Foot Path","Paste Pontoon","Glow Goo","Paste Boiler","Crystalmound","Aqua Ring","Aquamound","Aqua Scrubber","Designated Swim Area","Seabeet Farm","Wet Mound","Wet Cone","Feasting Area","Communal Water Vats","Polished Water Vats","Paste Tank","Smart Paste Tank","Subterranean Sugar Farm","Brood Training Center","Sugar Burner","Gold Burrow","Statue of Emperor Zolarg","Statue of Two","Brew Pit","Gentelbugs Club","Golden Sign","Deep Space Transceiver","Tower of Truth","Slab of Processing","Insectoid Mint","Antanium Smelter","Power Spire","Unholy Power Spire","Relic Cauldron","Interstellar Pad of Thought","Unholy Brew Pit","Unholy Mound of Worship","Unholy Core Mine","Labor Camp","Unholy Pit of Stuff","Elders Mound","Hall of Elders","Healing Pods","Supply Pile","Mining Operation","Clay Pit","Potterbug's Mound","Glazed Mound","Food Fortification Facility","Sugar Farm","Money Pit","Export Cannon","Customs Processing","Wheelmakers Lodge","Altar of Commerce","Center for Automation Coding","Command Post","Advanced Command Post","High Command","Higher Command","Ore Enrichment Facility","Aluminum Hive","Circuit Foundry","Paste Treatment Spa","House of Running Rum","Shrine of Mystics","Bloodletting Station","Cloth Farm","Petrocone","Petropit","Petroplant","Mound of Online Business","Mound of Scholars","Unholy Gold Grower","Unholy Uranium Generator","Crystalline Growth Chamber","Unholy Command"],
            "sellValue":        [{"resource":"Food","amount":1}],
            "sellWarning":      null,
            "harvests":         "Sugar",
            "capacity":         10,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "ind-workerdrone.png",
            "buildCategories":  ["All Workers"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Orebug",
            "cost":             [{"resource":"Food","amount":30}],
            "tile":             "orebug",
            "description":      "orebug-description",
            "produces":         ["Ore Tunnel","Pot of Ether","Mining Operation","Red Tile","Orange Tile","Yellow Tile","Green Tile","Blue Tile","Indigo Tile","Purple Tile","Magenta Tile","Teal Tile","Brown Tile","Black Tile","White Tile"],
            "sellValue":        [{"resource":"Ore","amount":10}],
            "sellWarning":      null,
            "harvests":         "Ore",
            "capacity":         30,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "ind-orebug.png",
            "buildCategories":  ["All Workers"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":"orebug-firstbuilt-tut",
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Goldbug",
            "cost":             [{"resource":"Food","amount":80}],
            "tile":             "goldbug",
            "description":      "goldbug-description",
            "produces":         ["Gold Burrow","Mining Operation","Pot of Ether","Statue of Emperor Zolarg","Spire of Knowledge","Tower of Thoughts","Orb of Radiance"],
            "sellValue":        [{"resource":"Food","amount":1}],
            "sellWarning":      null,
            "harvests":         "Gold",
            "capacity":         10,
            "requiresTech":     ["Gold Storage"],
            "requiresStage":    0,
            "indicator":        "ind-goldbug.png",
            "buildCategories":  ["All Workers"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Regobug",
            "cost":             [{"resource":"Food","amount":80}],
            "tile":             "regobug",
            "description":      "regobug-description",
            "produces":         ["Regolith Mine","Pot of Ether","Regolith Incinerator"],
            "sellValue":        [{"resource":"Food","amount":1}],
            "sellWarning":      null,
            "harvests":         "Regolith",
            "capacity":         10,
            "requiresTech":     ["Abandoned World Base"],
            "requiresStage":    0,
            "indicator":        "ind-regobug.png",
            "buildCategories":  ["All Workers"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Etherbug",
            "cost":             [{"resource":"Food","amount":80}],
            "tile":             "etherbug",
            "description":      "etherbug-description",
            "produces":         ["Pot of Ether"],
            "sellValue":        [{"resource":"Food","amount":1}],
            "sellWarning":      null,
            "harvests":         "Ether",
            "capacity":         10,
            "requiresTech":     ["Abandoned World Base","Gold Storage"],
            "requiresStage":    0,
            "indicator":        "ind-etherbug.png",
            "buildCategories":  ["All Workers"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Lumberbug",
            "cost":             [{"resource":"Food","amount":80}],
            "tile":             "lumberbug",
            "description":      "lumberbug-description",
            "produces":         ["Fir Trees","Megatree","Lush Hedge Wall","Small Wooden Bridge","Small Wooden Bridge NS","Lumber Camp","Smoldering Pit","Power Spire","Unholy Power Spire","Aquamound","Shrine of Mystics"],
            "sellValue":        [{"resource":"Food","amount":1}],
            "sellWarning":      null,
            "harvests":         "Wood",
            "capacity":         10,
            "requiresTech":     ["Wood Harvesting"],
            "requiresStage":    0,
            "indicator":        "ind-lumberbug.png",
            "buildCategories":  ["All Workers"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Alumibug",
            "cost":             [{"resource":"Food","amount":120}],
            "tile":             "alumibug",
            "description":      "alumibug-description",
            "produces":         ["Aluminum Road","Aluminum Mine","Aluminum Hive","Wet Cone","Unholy Power Spire","Relic Cauldron","Unholy Brew Pit","Shrine of Mystics","Unholy Mound of Worship","Unholy Core Mine","Unholy Pit of Stuff","Spire of Knowledge","Tower of Thoughts","Orb of Radiance","Advanced Command Post","Unholy Command","Petrocone","Petropit","Petroplant","Unholy Obsidian Burner","Mound of Online Business","Unholy Uranium Generator"],
            "sellValue":        [{"resource":"Food","amount":1}],
            "sellWarning":      null,
            "harvests":         "Aluminum",
            "capacity":         8,
            "requiresTech":     ["Advanced Metallurgy"],
            "requiresStage":    0,
            "indicator":        "ind-alumibug.png",
            "buildCategories":  ["All Workers"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Tundrabug",
            "cost":             [{"resource":"Food","amount":20}],
            "tile":             "tundrabug",
            "description":      "tundrabug-description",
            "produces":         ["Compacted Snow Path","Ore Tunnel","Paste Boiler","Crystalmound","Synthetic Crystalline Deposit"],
            "sellValue":        [{"resource":"Food","amount":1}],
            "sellWarning":      null,
            "harvests":         "Crystalline",
            "capacity":         8,
            "requiresTech":     ["Insectoid Base","Ice World Base"],
            "requiresStage":    0,
            "indicator":        "ind-tundrabug.png",
            "buildCategories":  ["All Workers"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Extremeobug",
            "cost":             [{"resource":"Food","amount":20}],
            "tile":             "extremeobug",
            "description":      "extremeobug-description",
            "produces":         ["Crystal Vaporizer","Ore Tunnel","Paste Boiler","Crystalmound","Synthetic Crystalline Deposit"],
            "sellValue":        [{"resource":"Food","amount":1}],
            "sellWarning":      null,
            "harvests":         "Crystalline",
            "capacity":         8,
            "requiresTech":     ["Insectoid Base","Lava World Base|Crystalline Synthesis"],
            "requiresStage":    0,
            "indicator":        "ind-tundrabug.png",
            "buildCategories":  ["All Workers"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Obsidiobug",
            "cost":             [{"resource":"Food","amount":25}],
            "tile":             "obsidiobug",
            "description":      "obsidiobug-description",
            "produces":         ["Obelisk of Plenty","Unholy Obsidian Burner","Petropit","Ether Powertube","Antanium Blast Furnace"],
            "sellValue":        [{"resource":"Food","amount":1}],
            "sellWarning":      null,
            "harvests":         "Obsidian",
            "capacity":         2,
            "requiresTech":     ["Insectoid Base"],
            "requiresStage":    0,
            "indicator":        "ind-obsidiobug.png",
            "buildCategories":  ["All Workers"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Ancientbug",
            "cost":             [{"resource":"Food","amount":200},{"resource":"Alien Relic","amount":5},{"resource":"Alien Artifact","amount":5}],
            "tile":             "ancientbug",
            "description":      "ancientbug-description",
            "produces":         ["Quantum Sugar Cloner","Quantum Wet Cone","Unholy Obsidian Burner","Quantum Supply Pile","Quantum Slab of Processing","Quantum Food Fortification","Quantum Circuit Foundry"],
            "sellValue":        [{"resource":"Food","amount":2}],
            "sellWarning":      null,
            "harvests":         null,
            "capacity":         8,
            "requiresTech":     ["Ancient Alien Language"],
            "requiresStage":    0,
            "indicator":        "ind-ancientbug.png",
            "buildCategories":  ["All Workers"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Mobile Construction Mech",
            "cost":             [{"resource":"Gold","amount":300},{"resource":"Aluminum","amount":500},{"resource":"Antanium","amount":300},{"resource":"Wheel","amount":4}],
            "tile":             "constructionmech",
            "description":      "constructionmech-description",
            "produces":         ["Labor Camp","Smart Power Spire","Scheepswerf","Megamound","Deluxe Command","Unholy Tower of Stuff"],
            "sellValue":        [{"resource":"Gold","amount":30},{"resource":"Aluminum","amount":50},{"resource":"Antanium","amount":30}],
            "sellWarning":      null,
            "harvests":         null,
            "capacity":         0,
            "requiresTech":     ["The Wheel"],
            "requiresStage":    0,
            "indicator":        "ind-constructionmech.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   ["mechreporting","whatorders"],
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       6,
            "deploysTo":        "Deployed Construction Mech",
            "isFlying":         false,
            "vehicleCarryCapacity": 8,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": ["mechmoving","mechbycommand"],
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Diamond Bot",
            "cost":             [{"resource":"Gold","amount":30},{"resource":"Aluminum","amount":50},{"resource":"Antanium","amount":30},{"resource":"Wheel","amount":4}],
            "tile":             "diamondbot",
            "description":      "diamondbot-description",
            "produces":         ["Unholy Diamond Spawner","Petropit"],
            "sellValue":        [{"resource":"Gold","amount":3},{"resource":"Aluminum","amount":0},{"resource":"Antanium","amount":3}],
            "sellWarning":      null,
            "harvests":         "Diamond",
            "capacity":         6,
            "requiresTech":     ["The Wheel"],
            "requiresStage":    0,
            "indicator":        "ind-diamondbot.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "LIS Rover",
            "cost":             [{"resource":"Regolith","amount":12}],
            "tile":             "lisrover",
            "description":      "lisrover-description",
            "produces":         ["Compacted Snow Path","Raw Materials Depot","Small Helium 3 Extractor","Regolith Compactor","Greenhouse","Water Extractor","Regolith Furnace","Small Solar Panel","Small Vehicle Factory"],
            "sellValue":        [{"resource":"Regolith","amount":3}],
            "sellWarning":      null,
            "harvests":         "Regolith",
            "capacity":         8,
            "requiresTech":     ["Human Base","LIS Base"],
            "requiresStage":    0,
            "indicator":        "ind-lisrover.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":"lunar-rover-firstbuild-tut",
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Sugar Rover",
            "cost":             [{"resource":"Ore","amount":5},{"resource":"Regolith","amount":15}],
            "tile":             "sugarrover",
            "description":      "sugarrover-description",
            "produces":         ["Sugarcane","Small Sugar Processor"],
            "sellValue":        [{"resource":"Regolith","amount":3}],
            "sellWarning":      null,
            "harvests":         "Sugar",
            "capacity":         8,
            "requiresTech":     ["Human Base","LIS Base","Abandoned World Base"],
            "requiresStage":    0,
            "indicator":        "ind-sugarrover.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Ether Rover",
            "cost":             [{"resource":"Ore","amount":5},{"resource":"Regolith","amount":15}],
            "tile":             "etherrover",
            "description":      "etherrover-description",
            "produces":         ["Ether Storage"],
            "sellValue":        [{"resource":"Regolith","amount":3}],
            "sellWarning":      null,
            "harvests":         "Ether",
            "capacity":         6,
            "requiresTech":     ["Human Base","LIS Base","Abandoned World Base"],
            "requiresStage":    0,
            "indicator":        "ind-etherrover.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Tundra Rover",
            "cost":             [{"resource":"Crystalline","amount":20}],
            "tile":             "crystalminer",
            "description":      "crystalminer-description",
            "produces":         ["Compacted Snow Path","Raw Materials Depot","Micromine","Regolith Furnace","Synthetic Crystalline Deposit"],
            "sellValue":        [{"resource":"Crystalline","amount":6}],
            "sellWarning":      null,
            "harvests":         "Crystalline",
            "capacity":         8,
            "requiresTech":     ["Human Base","LIS Base","Ice World Base"],
            "requiresStage":    0,
            "indicator":        "ind-tundrarover.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   "bot",
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Construction Probe",
            "cost":             [{"resource":"Money","amount":2000}],
            "tile":             "constructionprobe",
            "description":      "constructionprobe-description",
            "produces":         ["Sand Path","Pavement","Foot Path","Draconian Pavement","Electromagnetic Bridge","Electromagnetic Bridge NS","Pillar of Light","Microdistiller","Coral Radiator","River Pebbles","Water Pool","Draconian Prairie Weed","Statue of Two","Fair Warning","Torture Booth","Raw Fish Diner","Dracarus Mint","Live Autopsy Slab","Basic Crystal Furnace","Microreactor","Advanced Microreactor","Turbo Microreactor","Advanced Chip Transporter","Diamond Cobalt Microreactor","Gold Reducer","Obsidian Generator","Crystalline Laser Drill","Bug Saw","Gold Grower","Aluminum Grower","Ore Evaporator","Powered Materials Silo","High Frequency Node","Ultra High Frequency Node","Slave Gate","Antanium Impactor","Integrated Antanium Impactor","Microcondenser","Automated Hydroponics Lab","Basic Den","Family Den","Patricians Den","Offshore Slum","Medium Range Star Gate","Trash Transporter","Chip Transporter","Deep Space Interceptor","Paste Extractor","Square of Arbitration","Subterranean Slum","Regeneration Chamber","Ant Paste Rejuvenation Clinic","Potters Den","Homeless Shelter","Ether Baths","Brewmasters Den","Coders Den","Automated Software Node","Council of Arbiters","Automated Art Display","Real News Station","Deep Sea Drilling Platform","Universal Commodities Exchange","Galactic Star Gate","Suppertime Arena","Galactic Fine Arts Exposition","Tax Collection Agency","Ether Processor","Petroboiler","Crystalline Enrichment Station","Raw Materials Extractor","Red Tile","Orange Tile","Yellow Tile","Green Tile","Blue Tile","Indigo Tile","Purple Tile","Magenta Tile","Teal Tile","Brown Tile","Black Tile","White Tile","Lush Hedge Wall","Advanced Materials Silo","Near-Infinite Materials Silo","Primitive Robotics Lab","Radiated Crystal Farm","Antanium Radiator","Chamber of Laws","Chamber of our Fathers","Shipworks","Chamber of Kings"],
            "sellValue":        [{"resource":"Money","amount":1000}],
            "sellWarning":      null,
            "harvests":         null,
            "capacity":         null,
            "requiresTech":     ["Draconian Base"],
            "requiresStage":    0,
            "indicator":        "ind-constructionprobe.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       2,
            "deploysTo":        null,
            "isFlying":         true,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Uranium Extractor",
            "cost":             [{"resource":"Money","amount":3000}],
            "tile":             "uraextract",
            "description":      "uraextract-description",
            "produces":         ["Microreactor","Advanced Microreactor"],
            "sellValue":        [{"resource":"Money","amount":1500}],
            "sellWarning":      null,
            "harvests":         "Uranium",
            "capacity":         20,
            "requiresTech":     ["Draconian Base"],
            "requiresStage":    0,
            "indicator":        "ind-uraextract.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         true,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Crude Extractor",
            "cost":             [{"resource":"Money","amount":4000}],
            "tile":             "crudeextract",
            "description":      "crudeextract-description",
            "produces":         ["Microreactor","Advanced Microreactor","Deep Sea Drilling Platform"],
            "sellValue":        [{"resource":"Money","amount":2000}],
            "sellWarning":      null,
            "harvests":         "Oil",
            "capacity":         20,
            "requiresTech":     ["Draconian Base"],
            "requiresStage":    0,
            "indicator":        "ind-crudeextract.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         true,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Ether Extractor",
            "cost":             [{"resource":"Money","amount":4000}],
            "tile":             "etherextractor",
            "description":      "etherextractor-description",
            "produces":         ["Microreactor","Advanced Microreactor"],
            "sellValue":        [{"resource":"Money","amount":2000}],
            "sellWarning":      null,
            "harvests":         "Ether",
            "capacity":         20,
            "requiresTech":     ["Abandoned World Base","Draconian Base"],
            "requiresStage":    0,
            "indicator":        "ind-etherextractor.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         true,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Diamond Extractor",
            "cost":             [{"resource":"Money","amount":5000}],
            "tile":             "diamondextractor",
            "description":      "diamondextractor-description",
            "produces":         null,
            "sellValue":        [{"resource":"Money","amount":2000}],
            "sellWarning":      null,
            "harvests":         "Diamond",
            "capacity":         20,
            "requiresTech":     ["Water World Base|Desert World Base|Lava World Base","Draconian Base"],
            "requiresStage":    0,
            "indicator":        "ind-diamondextractor.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         true,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Cobalt Extractor",
            "cost":             [{"resource":"Money","amount":5500}],
            "tile":             "cobaltextractor",
            "description":      "cobaltextractor-description",
            "produces":         null,
            "sellValue":        [{"resource":"Money","amount":2000}],
            "sellWarning":      null,
            "harvests":         "Cobalt",
            "capacity":         20,
            "requiresTech":     ["Lava World Base","Draconian Base"],
            "requiresStage":    0,
            "indicator":        "ind-cobaltextractor.png",
            "buildCategories":  ["All Vehicles"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         true,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Enslaved Worker Drone",
            "cost":             [{"resource":"Money","amount":100}],
            "tile":             "insectoid1",
            "description":      "workerdrone-description",
            "produces":         ["Sugarcane","Compacted Snow Path","Paste Path","Foot Path","Paste Pontoon","Subterranean Sugar Farm","Glow Goo"],
            "sellValue":        [{"resource":"Money","amount":80}],
            "sellWarning":      null,
            "harvests":         "Sugar",
            "capacity":         10,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "ind-workerdrone.png",
            "buildCategories":  ["All Workers"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Enslaved Fisherbug",
            "cost":             [{"resource":"Money","amount":100}],
            "tile":             "fisherbug",
            "description":      "fisherbug-description",
            "produces":         null,
            "sellValue":        [{"resource":"Money","amount":80}],
            "sellWarning":      null,
            "harvests":         "Fish",
            "capacity":         5,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "ind-fisherbug.png",
            "buildCategories":  ["All Workers"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Enslaved Waterbug",
            "cost":             [{"resource":"Money","amount":100}],
            "tile":             "waterbug",
            "description":      "waterbug-description",
            "produces":         null,
            "sellValue":        [{"resource":"Money","amount":80}],
            "sellWarning":      null,
            "harvests":         "Water",
            "capacity":         10,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "waterbug-ind.png",
            "buildCategories":  ["All Workers"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Enslaved Orebug",
            "cost":             [{"resource":"Money","amount":100}],
            "tile":             "orebug",
            "description":      "orebug-description",
            "produces":         ["Drone Pad","Insectoid Mining Operation","Red Tile","Orange Tile","Yellow Tile","Green Tile","Blue Tile","Indigo Tile","Purple Tile","Magenta Tile","Teal Tile","Brown Tile","Black Tile","White Tile"],
            "sellValue":        [{"resource":"Money","amount":80}],
            "sellWarning":      null,
            "harvests":         "Ore",
            "capacity":         30,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "ind-orebug.png",
            "buildCategories":  ["All Workers"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Enslaved Goldbug",
            "cost":             [{"resource":"Money","amount":100}],
            "tile":             "goldbug",
            "description":      "goldbug-description",
            "produces":         ["Drone Pad","Insectoid Mining Operation"],
            "sellValue":        [{"resource":"Money","amount":80}],
            "sellWarning":      null,
            "harvests":         "Gold",
            "capacity":         10,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "ind-goldbug.png",
            "buildCategories":  ["All Workers"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Enslaved Lumberbug",
            "cost":             [{"resource":"Money","amount":100}],
            "tile":             "lumberbug",
            "description":      "lumberbug-description",
            "produces":         ["Fir Trees","Megatree","Small Wooden Bridge","Small Wooden Bridge NS"],
            "sellValue":        [{"resource":"Money","amount":80}],
            "sellWarning":      null,
            "harvests":         "Wood",
            "capacity":         10,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "ind-lumberbug.png",
            "buildCategories":  ["All Workers"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Enslaved Alumibug",
            "cost":             [{"resource":"Money","amount":100}],
            "tile":             "alumibug",
            "description":      "alumibug-description",
            "produces":         null,
            "sellValue":        [{"resource":"Money","amount":80}],
            "sellWarning":      null,
            "harvests":         "Aluminum",
            "capacity":         8,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "ind-alumibug.png",
            "buildCategories":  ["All Workers"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Enslaved Obsidiobug",
            "cost":             [{"resource":"Money","amount":100}],
            "tile":             "obsidiobug",
            "description":      "obsidiobug-description",
            "produces":         null,
            "sellValue":        [{"resource":"Money","amount":80}],
            "sellWarning":      null,
            "harvests":         "Obsidian",
            "capacity":         2,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "ind-obsidiobug.png",
            "buildCategories":  ["All Workers"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        },
        {
            "name":             "Enslaved Extremeobug",
            "cost":             [{"resource":"Money","amount":100}],
            "tile":             "extremeobug",
            "description":      "extremeobug-description",
            "produces":         ["Synthetic Crystalline Deposit"],
            "sellValue":        [{"resource":"Money","amount":80}],
            "sellWarning":      null,
            "harvests":         "Crystalline",
            "capacity":         8,
            "requiresTech":     null,
            "requiresStage":    0,
            "indicator":        "ind-tundrabug.png",
            "buildCategories":  ["All Workers"],
            "reqIndependence":  false,             
            "selectionSound":   null,
            "requiPremium":     false,
            "firstBuildMessage":null,
            "buildSpeed":       1,
            "deploysTo":        null,
            "isFlying":         false,
            "vehicleCarryCapacity": 0,
            "colonistCarryCapacity": 0,
            "canRaid":          null,
            "moveConfirmSound": null,
            "harvestConfirmSound":null,
            "attackConfirmSound":null,
            "deployConfirmSound":null,
            "buildConfirmSound":null,
            "creationSound":    null
        }
    ],
    "names": {
        "Human": {
            "first": [
                "Jova",
                "Patchdaddy",
                "PlatinumOre",
                "Hayenn",
                "Vyryn",
                "Liam",
                "Noah",
                "Ethan",
                "Lucas",
                "Mason",
                "Oliver",
                "Aiden",
                "Elijah",
                "James",
                "Benjamin",
                "Logan",
                "Jacob",
                "Jackson",
                "Alexander",
                "Michael",
                "Jack",
                "Carter",
                "Luke",
                "Owen",
                "William",
                "Gabriel",
                "Daniel",
                "Henry",
                "Matthew",
                "Wyatt",
                "Sebastian",
                "Caleb",
                "Grayson",
                "Ryan",
                "Isaac",
                "Nathan",
                "Dylan",
                "Levi",
                "Jayden",
                "Jaxon",
                "David",
                "Eli",
                "Andrew",
                "Samuel",
                "Joseph",
                "Emma",
                "Olivia",
                "Ava",
                "Sophia",
                "Isabella",
                "Mia",
                "Charlotte",
                "Harper",
                "Amelia",
                "Abigail",
                "Emily",
                "Madison",
                "Lily",
                "Ella",
                "Avery",
                "Aria",
                "Evelyn",
                "Chloe",
                "Scarlett",
                "Ellie",
                "Riley",
                "Addison",
                "Elizabeth",
                "Aubrey",
                "Layla",
                "Zoey",
                "Grace",
                "Hannah",
                "Mila",
                "Victoria",
                "Brooklyn",
                "Lucy"
            ],
            "last": [
                "Smith",
                "Johnson",
                "Williams",
                "Brown",
                "Jones",
                "Miller",
                "Davis",
                "Garcia",
                "Rodriguez",
                "Wilson",
                "Martinez",
                "Anderson",
                "Taylor",
                "Thomas",
                "Moore",
                "Martin",
                "Jackson",
                "Thompson",
                "White",
                "Lopez",
                "Lee",
                "Harris",
                "Clark",
                "Lewis",
                "Robinson",
                "Walker",
                "Perez",
                "Hall",
                "Young",
                "Allen",
                "Sanchez",
                "Wright",
                "King",
                "Scott",
                "Green",
                "Baker",
                "Adams",
                "Nelson",
                "Hill",
                "Ramirez",
                "Campbell",
                "Mitchell",
                "Roberts",
                "Carter",
                "Evans",
                "Stewart",
                "Flores",
                "Nguyen",
                "Jenkins"
            ]
        },
        "Insectoids": {
            "joint": [
                "Aarde",
                "Aardewerk",
                "Aardling",
                "Afschuw",
                "Afstel",
                "Anijs",
                "Apetrots",
                "Bakfiets",
                "Baksteen",
                "Ballon",
                "Belasting",
                "Bloemkool",
                "Boek",
                "Boterham",
                "Brandweer",
                "Broek",
                "Buitenaardse",
                "Bureau",
                "Chagrijn",
                "Dampkring",
                "Dans",
                "Deurwaarder",
                "Dienstklopper",
                "Dochter",
                "Eekhoorn",
                "Erts",
                "Ezel",
                "Fiets",
                "Gabber",
                "Gast",
                "Geld",
                "Gevaarlijk",
                "Goud",
                "Graaf",
                "Graan",
                "Grond",
                "Gruis",
                "Hagel",
                "Handschoen",
                "Heerlijk",
                "Heerser",
                "Hout",
                "Houtskool",
                "Ijsbeer",
                "Ijzer",
                "Kapsalon",
                "Kast",
                "Kikker",
                "Kledij",
                "Klei",
                "Klokhuis",
                "Koning",
                "Kramp",
                "Kroket",
                "Lekker",
                "Lieveheersbeestje",
                "Lucht",
                "Matthijs",
                "Merel",
                "Mier",
                "Moeder",
                "Muildier",
                "Neef",
                "Nicht",
                "Noord",
                "Oliebol",
                "Oma",
                "Onderbroek",
                "Onderzoek",
                "Oneerlijk",
                "Onhandig",
                "Oom",
                "Oorbel",
                "Oorlog",
                "Oost",
                "Opa",
                "Opmerkelijk",
                "Paard",
                "Pannenkoek",
                "Pindakaas",
                "Poppetje",
                "Potjes",
                "Rakelings",
                "Ruimtewezen",
                "Speelgoed",
                "Spiegelei",
                "Spijkerbroek",
                "Steen",
                "Steenkool",
                "Suiker",
                "Tandpasta",
                "Tante",
                "Tarwe",
                "Termiet",
                "Trui",
                "Uitstel",
                "Uitvreter",
                "Uitzicht",
                "Vader",
                "Verhaal",
                "Vierkant",
                "Vies",
                "Vleermuis",
                "Vliegtuig",
                "Vliegtuig",
                "Vlokken",
                "Voedsel",
                "Voorwerp",
                "Vriend",
                "Vriendin",
                "Vrijdag",
                "Vuur",
                "Vuurtoren",
                "Wasbeer",
                "Washandje",
                "Wasmand",
                "Wol",
                "Zakdoek",
                "Zakkenroller",
                "Zaklamp",
                "Zeehond",
                "Zeekoe",
                "Ziekenhuis",
                "Zoon",
                "Zuid"
            ]
        },
        "Reptilian": {
            "joint": [
                "Altan",
                "Altansarnai",
                "Altantsetseg",
                "Arban",
                "Bat Erdene",
                "Bataar",
                "Batbayar",
                "Batsaikhan",
                "Batu",
                "Batuhan",
                "Batukhan",
                "Batzorig",
                "Bayarmaa",
                "Bolormaa",
                "Chaghatai",
                "Chenghiz",
                "Chimeg",
                "Chingis",
                "Chinua",
                "Chuluun",
                "Chuluunbold",
                "Dzhambul",
                "Enkhjargal",
                "Erden",
                "Erdenechimeg",
                "Erhi",
                "Gan",
                "Ganbaater",
                "Gansukh",
                "Ganzorig",
                "Genghis",
                "Gerel",
                "Geriel",
                "Jochi",
                "Jullian",
                "Kahn",
                "Khenbish",
                "Khongordzol",
                "Khulan",
                "Khunbish",
                "Medekhgui",
                "Mongolekorniiugluu",
                "Monkh Erdene",
                "Monkhbat",
                "Munkhtsetseg",
                "Muunokhoi",
                "Naranbaater",
                "Nanangerel",
                "Nekhii",
                "Nugai",
                "Och",
                "Od",
                "Odgerel",
                "Odval",
                "Ogtbish",
                "Oktai",
                "Qara",
                "Sarnai",
                "Sukh",
                "Taban",
                "Tsolmon",
                "Tuya",
                "Ulagan",
                "Xanadu",
                "Yul"
            ]
        }
    },
    "flagParts": [
        "flag-1.svg",
        "flag-2.svg",
        "flag-3.svg",
        "flag-4.svg",
        "flag-5.svg",
        "flag-6.svg",
        "flag-7.svg",
        "flag-8.svg",
        "flag-9.svg",
        "flag-10.svg",
        "flag-11.svg",
        "flag-12.svg",
        "flag-13.svg",
        "flag-14.svg",
        "flag-15.svg",
        "flag-16.svg",
        "flag-17.svg",
        "flag-18.svg",
        "flag-19.svg",
        "flag-20.svg",
        "flag-21.svg",
        "flag-22.svg",
        "flag-23.svg",
        "flag-24.svg",
        "flag-25.svg",
        "flag-26.svg",
        "flag-27.svg",
        "flag-28.svg",
        "flag-29.svg",
        "flag-30.svg",
        "flag-31.svg",
        "flag-32.svg",
        "flag-33.svg",
        "flag-34.svg",
        "flag-35.svg",
        "flag-36.svg",
        "flag-37.svg",
        "flag-38.svg",
        "flag-39.svg"
    ],
    "flagLogos": [
        "logo-1.svg",
        "logo-2.svg",
        "logo-3.svg",
        "logo-4.svg",
        "logo-5.svg",
        "logo-6.svg",
        "logo-7.svg",
        "logo-8.svg",
        "logo-9.svg",
        "logo-10.svg",
        "logo-11.svg",
        "logo-12.svg",
        "logo-13.svg",
        "logo-14.svg",
        "logo-15.svg",
        "logo-16.svg",
        "logo-17.svg",
        "logo-18.svg",
        "logo-19.svg",
        "logo-20.svg",
        "logo-21.svg",
        "logo-22.svg",
        "logo-23.svg",
        "logo-24.svg",
        "logo-25.svg",
        "logo-26.svg",
        "logo-27.svg",
        "logo-28.svg",
        "logo-29.svg",
        "logo-30.svg",
        "logo-31.svg",
        "logo-32.svg",
        "logo-33.svg",
        "logo-34.svg",
        "logo-35.svg",
        "logo-36.svg",
        "logo-37.svg",
        "logo-38.svg",
        "logo-39.svg",
        "logo-40.svg",
        "logo-41.svg",
        "logo-42.svg",
        "logo-43.svg",
        "logo-44.svg",
        "logo-45.svg",
        "logo-46.svg",
        "logo-47.svg",
        "logo-48.svg",
        "logo-49.svg",
        "logo-50.svg",
        "logo-51.svg",
        "logo-52.svg",
        "logo-53.svg",
        "logo-54.svg",
        "logo-55.svg",
        "logo-56.svg",
        "logo-57.svg",
        "logo-58.svg",
        "logo-59.svg",
        "logo-60.svg",
        "logo-61.svg",
        "logo-62.svg",
        "logo-63.svg",
        "logo-64.svg",
        "logo-65.svg",
        "logo-66.svg",
        "logo-67.svg",
        "logo-68.svg",
        "logo-69.svg",
        "logo-70.svg",
        "logo-71.svg",
        "logo-72.svg",
        "logo-73.svg",
        "logo-74.svg",
        "logo-75.svg",
        "logo-76.svg",
        "logo-77.svg",
        "logo-78.svg",
        "logo-79.svg",
        "logo-80.svg",
        "logo-81.svg",
        "logo-82.svg",
        "logo-83.svg",
        "logo-84.svg",
        "logo-85.svg",
        "logo-86.svg",
        "logo-87.svg",
        "logo-88.svg",
        "logo-89.svg",
        "logo-90.svg"
    ]
};
