/* global webAppCore */
/* global Scroll2d */
/* global ColonyGame */
/* global Checksum */
/* global astar */
/* global Graph */
/* global textureManager */
(function() {
    "use strict";

    // Event Listeners
    window.addEventListener("load",startApp,false);
    window.addEventListener("resize",sizeElements,false);
    window.addEventListener("keydown",onKeydown,false);
    window.addEventListener("keyup",onKeyup,false);

    var KEY_DEFAULT_CLEAR = "Escape";
    var KEY_DEFAULT_IDLE = "w";
    var KEY_DEFAULT_SELL_NO_CONFIRM = "alt+s";
    var KEY_DEFAULT_UPGRADE_NO_CONFIRM = "alt+u";
    var KEY_DEFAULT_MOVE = "m";
    var KEY_DEFAULT_HARVEST = "h";
    var KEY_DEFAULT_BUILD = "b";
    var KEY_DEFAULT_EXPORT = "e";
    var KEY_DEFAULT_IMPORT = "i";
    var KEY_DEFAULT_SELL = "s";
    var KEY_DEFAULT_UPGRADE = "u";
    var KEY_DEFAULT_CANCEL = "c";
    var KEY_DEFAULT_CANCEL_NO_CONFIRM = "alt+c";
    var KEY_DEFAULT_FLIP = "f";
    var KEY_DEFAULT_ZOOM_OUT = "-";
    var KEY_DEFAULT_ZOOM_IN = "=";
    var KEY_DEFAULT_PARK = "p";
    var KEY_DEFAULT_STATS_WINDOW = "s";
    var KEY_DEFAULT_TECH_WINDOW = "t";
    var KEY_DEFAULT_ENCY_WINDOW = "e";
    var KEY_DEFAULT_UNEM_WINDOW = "u";
    var KEY_DEFAULT_PAN_UP = "ArrowUp";
    var KEY_DEFAULT_PAN_DOWN = "ArrowDown";
    var KEY_DEFAULT_PAN_LEFT = "ArrowLeft";
    var KEY_DEFAULT_PAN_RIGHT = "ArrowRight";
    var KEY_DEFAULT_RES_WINDOW = "r";
    var KEY_DEFAULT_RES_SEARCH = "ctrl+r";
    var KEY_DEFAULT_CHAT_INPUT = "Tab";

    var curRegRiverTemplateCanvas;
    var curRegRiverTemplateContext;
    var curRegPreviewWorkQueue = [];
    var curRegPreviewWorkItem = null;
    var autoloadSubcityAfterSave = null;
    

    var riotCount = 0;
    
    var userMultiplayerRegions = [];

    var isStreamingLive = false;

    var pendingMoveBuilding = null;

    var currentChatChannel = null;

    var ach10kReported = false;
    var ach100kReported = false;
    var ach1milReported = false;

    var desktopNotificationArea,notificationArea,desktopNotificationAreaReadout;

    var hasCommunicationsBuilding = false;

    var showCityNames = true;

    var allowGamepad = true;

    var hasGBTBuilding = false;

    var STAT_DATA_RETENTION_AMOUNT = 500;

    var theNeverLoadedTimeout = null;
    var readyToLoadSubcities = false;
    var useOnlineNotifications = true;
    var loresMode = true;
    var loresScale = 0.75;
    var renderScaleFactor = 1.0;
    var topLeftArea;
    var shortNumbers = true;
    var showCapacity = false;
    var tcpAvailable = false;
    var offlineGameServerId = "-1";
    var connectedLocals = [];
    var userTokenData = [];
    var shoreUpdateTurn = false;
    var serverMaxTradeSize = 500;
    var bulldozerMode = false;
    var allowLighting = true;
    var defaultCompressionSetting = true;
    var totalAvailableVehicles = 0;
    var exportPenalty = 0.1;
    var importPenalty = 0.05;
    var importPriceMod = 2;
    var exportPriceMod = 0.25;
    var lightCycle = 0;
    var lightCounter = 0;
    var gamepadInUse = false;
    var gotItMadePrice = 1000;
    var povertyLine = 10;
    var usingTouch = false;
    var runningHomelessCount = 0;
    var inMultiSelectionMode = false;
    var retainedPaths = {};
    var retainedUsage = {};
    var retainedPathsCounter = 0;
    var shouldUpdateCollissionMap = true;
    var titleShowing = false;
    var hasConsulate = false;
    var hasCapitol = false;
    var freeRefNukeTurn = false;

    var runningBuildingCounts = {};
    var runningVehicleCounts = {};
    var showZoomButtons = false;
    var selectedBuildCategory = null;

    var touchPossibleBuildPoints = [];
    var currentActiveTextureMod = [];
    var chainQueue = null;
    var constructionFromSidebar = false;
    var chainBuildMode = true;
    var sidebarModeWidth = 1000;

    var roamingClientId = null;

    var streamingIndicator = null;
    var templateLayerInd = null;
    var imCityNames = null;

    var currentHoverCity = null;

    var currentJobOpprotunities = [];

    var pendingAutosales = [];
    var autosellProcessCounter = 0;
    
    // Global Hooks
    window.wacMenuOptionSelected = onMenuOptionSelected;
    
    // Layout Elements
    var moneyReadout;
    var saveAndQuitting = false;
    
    // var variables
    var pendingSubcitySize = 0;
    var hoverX = 0;
    var hoverY = 0;
    var desktopMode = false;
    var saveCounterMax = 8000;
    var drawColonists = true;
    var fpsRate = 1;
    var useTextPoppers = true;
    var savedGameListing = [];
    var actualX;
    var actualY;
    var lowCapacityCounter = 2500;
    var storageCapCounter = 2500;
    var lowPowerNagLimit = 4000;
    var mailCheckLimit = 15000;
    var mailCheckTimer = 14900;
    var pauseDrawing = false;
    var resourceReadouts = {};
    var idleBuilderIndex = 0;
    var resourceDisplayMode = 0;
    var transparencyMode = 0;
    var allowAudio = true;
    var allowMusic = true;
    var zoomLevel = 1;
    var vehicleDefReference = {};
    var buildingDefReference = {};
    var terrainDefReference = {};
    var resourceDefReference = {};
    var occupationDefReference = {};
    var utilityDefReference = {};
    var passableTileRefs = {};
    var previouslyAvailableShelters = 0;
    var previouslyAvailableTourism = 0;
    var objectForSell = null;
    var objectForSellType = null;
    var allowParticleEffects = true;
    var utilityGridCounter = 0;

    var medicalCoveragePoints = [];
    var flipChainedStructures = false;
    var entertainmentCoveragePoints = [];
    var selectedBuilding = null;
    var selectedVehicle = [];
    var selectedResource = null;
    var selectedColonist = null;
    var selectedPassable = null;
    var hoverBuilding = null;
    var resourceKillArray = [];

    var vehicleKillArray = [];
    var pendingBuildX = null;
    var pendingBuildY = null;
    var queuedBuildings = null;
    var queuedBuilding = null;
    var queuedBuildingBlocked = false;
    var usingMouse = false;
    var queuedMove = null;
    var queuedPark = null;
    var hoverPassable = false;
    var collisionReference;
    var flyingCollisionReference;
    var usingSockets = false;
    var killSwitch = false;
    var currentFileName = "";
    var allowAnimation = true;
    var saveCounter = 0;
    var ourCapitolBuilding = null;
    var checkPreviousCounter = 400;
    var checkRenderDistance = true;
    var tokenScale = 0.4;
    var pathWorker1 = null;
    var vehiclePathOrders = {};
    var colonistPathOrders = {};
    var currentModData = null;
    var vitalCounter = 0;
    var allowDayNight = "1";
    var useSyncPathfinding = true;
    var syncColMap = null;

    var currentGame = null;
    var currentRegion = null;
    var currentSubcityRef = null;
    var regionFileName = null;
    var currentTemplate = null;
    var templateVisible = false;

    var gameDataChecksum = null;
    var scriptDataChecksum = null;

    var friendsList = {};

    // perhaps make an engine setting depending on how it performs
    var statUpdateRate = 65;

    var DEF_MEDICAL_RANGE = 50;
    var DEF_ENTERTAINMENT_RANGE = 25;
    var DEF_SCHOOL_RANGE = 35;
    var DEF_WORK_RANGE = 50;
    var DEF_TOURISM_RANGE = 30;

    var DEF_POP_PERCENT_MEDICAL = 0.05;
    var DEF_POP_PERCENT_ENTERTAINMENT = 0.15;
    var DEF_POP_PERCENT_EDUCATION = 0.20;

    var DEF_RETIREMENT_AGE = 840;
    var DEF_ADULT_AGE = 204;

    function startApp() {
        webAppCore.startApp(getChecksums);
    }

    var initAttempts = 0;

    function getChecksums() {
        var xhr = new XMLHttpRequest();
        xhr.onload = function() {
            var gameRaw = xhr.response;
            var ctx = new Checksum("fnv32", 0);
            ctx.updateStringly(gameRaw);
            gameDataChecksum = ctx.result.toString(16);

            checkScriptData();
        };
        xhr.addEventListener("error",function(){
            gameDataChecksum = null;
            checkScriptData();
        });
        xhr.open("GET", "game.js");
        xhr.send();
    }

    function checkScriptData() {
        var xhr = new XMLHttpRequest();
        xhr.onload = function() {
            var gameRaw = xhr.response;
            var ctx = new Checksum("fnv32", 0);
            ctx.updateStringly(gameRaw);
            scriptDataChecksum = ctx.result.toString(16);
            initApp();
        };
        xhr.addEventListener("error",function(){
            scriptDataChecksum = null;
            initApp();
        });
        xhr.open("GET", "script.js");
        xhr.send();
    }
    
    function initApp() {

        if(!ColonyGame) {
            initAttempts++;

            if(initAttempts < 5) {
                setTimeout(initApp,500);
            }

            return;
        }

        if(ColonyGame.meta.customCategory) {
            if(ColonyGame.meta.customCategoryIcon) {
                webAppCore.setSidebarCategory(ColonyGame.meta.customCategory,"images/" + ColonyGame.meta.customCategoryIcon);
            } else {
                webAppCore.setSidebarCategory(ColonyGame.meta.customCategory);
            }
        }

        webAppCore.setChatListener(onChatMessage);

        textureManager.setDefaultImageDirectory("images/");
        textureManager.setTileSize(ColonyGame.meta.gridSize);
        textureManager.initAssets();

        roamingClientId = guid();

        var gamepadAllowedOption = webAppCore.getVar("allow-gamepad","1");
        if(gamepadAllowedOption == "0") {
            allowGamepad = false;
        } else {
            allowGamepad = true;
        }

        var loResDef = "0";

        if(webAppCore.didRecoverFromCrash && webAppCore.didRecoverFromCrash()) {
            loResDef = "1";

            var preCrashWidth = webAppCore.getVar("crash-res-width","0");
            var preCrashHeight = webAppCore.getVar("crash-res-height","0");
            var preCrashPop = webAppCore.getVar("crash-res-pop","0");

            var crashVitalString = preCrashWidth + "x" + preCrashHeight + "x" + preCrashPop;

            webAppCore.logEvent("Post Crash Vitals",webAppCore.getPlatform().platform,crashVitalString);

            webAppCore.showDialog({
                "title": "Low Memory Crash",
                "message": ColonyGame.name + " recovered from a crash due to system memory constraints.  Please consider using smaller map sizes or reduced settings from the Engine Settings menu on this device."
            });
        }

        // check if there are non-zeroed vitals, meaning the game closed without returning to title 
        var vitalCrashWidth = webAppCore.getVar("vital-res-width","0");
        var vitalCrashHeight = webAppCore.getVar("vital-res-height","0");
        var vitalCrashPop = webAppCore.getVar("vital-res-pop","0");
        var vitalCrashOnline = webAppCore.getVar("vital-res-online","0");

        if(vitalCrashWidth != "0" && vitalCrashHeight != "0") {
            var vitalVitalString = vitalCrashWidth + "x" + vitalCrashHeight + "x" + vitalCrashPop + "x" + vitalCrashOnline;
            webAppCore.logEvent("Closed Without Title",webAppCore.getPlatform().platform,vitalVitalString);
        }
        
        if(webAppCore.getPlatform().platform == "android") {
            loResDef = "1";
        }

        var pathDefault = "0";

        /*
        if(webAppCore.getPlatform().platform == "web" || webAppCore.getPlatform().platform == "desktop") {
            pathDefault = "0";
        }
        */

        var useSynOpt = webAppCore.getVar("sync-pathfinding-opt",pathDefault);

        if(useSynOpt == "1") {
            useSyncPathfinding = true;
        } else {
            useSyncPathfinding = false;
        }

        webAppCore.setPremiumOptionText("Premium Upgrade");

        initResourceDefs();
        linkLayouts();

        renderScaleFactor = 1.0;

        var loResSetting = webAppCore.getVar("lo-res-setting",loResDef);

        if(loResSetting == "1") {
            loresMode = true;
        } else {
            loresMode = false;
        }

        if(loresMode) {
            renderScaleFactor = loresScale;
        }

        textureManager.setScaleFactor(renderScaleFactor);

        webAppCore.setGamepadFunctions(onPadDown,onPadUp);

        setAutosaveTimer();

        webAppCore.setApeAppsStatusListener(onFacebookStatusChange);

        setGovernorName();

        webAppCore.setTheme(ColonyGame.meta.theme);
        webAppCore.setTitle(ColonyGame.meta.name);

        var audioSaveOption = webAppCore.getVar("allow-audio","1");
        if(audioSaveOption == "1") {
            allowAudio = true;
        } else {
            allowAudio = false;
        }

        var manualFPSControl = webAppCore.getVar("use-manual-fps","0");

        if(manualFPSControl == "1") {
            monitoringFPS = false;
        } else {
            monitoringFPS = true;
        }


        var manualResControl = webAppCore.getVar("use-manual-res","0");

        if(manualResControl == "1") {
            monitoringRes = false;
        } else {
            monitoringRes = true;
        }

        if(ColonyGame.meta.tokenScale) {
            tokenScale = ColonyGame.meta.tokenScale;
        }


        var lightingDefault = "1";

        if(webAppCore.getPlatform().platform == "android" || webAppCore.getPlatform().platform == "windows") {
            lightingDefault = "0";
        }

        var lightingSaveOption = webAppCore.getVar("allow-lighting",lightingDefault);
        if(lightingSaveOption == "1") {
            allowLighting = true;
        } else {
            allowLighting = false;
        }

        var defaultRenderDistanceOption = "1";

        if(webAppCore.getPlatform().platform == "android" || webAppCore.getPlatform().platform == "windows") {
            defaultRenderDistanceOption = "0";
        }

        var renderDistanceCheckOption = webAppCore.getVar("check-render-distance",defaultRenderDistanceOption);
        if(renderDistanceCheckOption == "1") {
            checkRenderDistance = true;
        } else {
            checkRenderDistance = false;
        }

        var particleSaveOption = webAppCore.getVar("allow-particles","1");
        if(particleSaveOption == "1") {
            allowParticleEffects = true;
        } else {
            allowParticleEffects = false;
        }

        var animationSaveOption = webAppCore.getVar("allow-animation","1");
        if(animationSaveOption == "1") {
            allowAnimation = true;
        } else {
            allowAnimation = false;
        }

        allowDayNight = webAppCore.getVar("allow-daynight","1");

        var allowMusicDefault = "1";

        if(webAppCore.getPlatform().platform == "ios" || webAppCore.getPlatform().platform == "windows") {
            allowMusicDefault = "0";
        }
        
        var musicSaveOption = webAppCore.getVar("allow-music",allowMusicDefault);
        if(musicSaveOption == "1") {
            allowMusic = true;
        } else {
            allowMusic = false;
        }

        var textureModOption = webAppCore.getVar("active-texture-mod","0");

        if(textureModOption == "0") {
            currentActiveTextureMod = [];
        } else {
            currentActiveTextureMod = textureModOption.split(",");
        }
        
        if(!webAppCore.getIsPremium()) {
            currentActiveTextureMod = [];
        }

        var desktopModeDefault = "0";

        var defaultSimSpeed = "8";

        if(webAppCore.getPlatform().platform == "desktop" || (window.innerWidth > sidebarModeWidth && (webAppCore.getPlatform().platform == "web" || webAppCore.getPlatform().platform == "windows"))) {
            desktopModeDefault = "1";
        }

        if(webAppCore.getPlatform().platform == "android" || webAppCore.getPlatform().platform == "windows") {
            defaultSimSpeed = "12";
        }

        var simSpeedOption = webAppCore.getVar("sim-speed-setting",defaultSimSpeed);
        var simSpeedInt = parseInt(simSpeedOption);

        if(simSpeedInt > 0) {
            buildingUpdateCycles = simSpeedInt;
        }

        if(webAppCore.isTV()) {
            gamepadInUse = true;
        }

        if(webAppCore.getVar("desktop-mode",desktopModeDefault) == "1") {
            desktopMode = true;
        }

        if(webAppCore.getVar("draw-col-setting","1") == "1") {
            drawColonists = true;
        } else {
            drawColonists = false;
        }

        if(webAppCore.getVar("popper-setting","1") == "1") {
            useTextPoppers = true;
        } else {
            useTextPoppers = false;
        }

        if(webAppCore.getVar("online-noti-opt","1") == "1") {
            useOnlineNotifications = true;
        } else {
            useOnlineNotifications = false;
        }

        var resDisplayDefault = "1";

        var resDisplaySetting = parseInt(webAppCore.getVar("res-display-mode",resDisplayDefault));
        resourceDisplayMode = parseInt(resDisplaySetting);
        

        var shortNumSetting = parseInt(webAppCore.getVar("use-short-nums","1"));

        if(shortNumSetting == 1) {
            shortNumbers = true;
        } else {
            shortNumbers = false;
        }

        var showCapacityDefault = "0";

        if(webAppCore.getPlatform().platform == "android" || webAppCore.getPlatform().platform == "ios") {
            showCapacityDefault = "1";
        }

        var showCapacitySetting = parseInt(webAppCore.getVar("show-res-capacity",showCapacityDefault));

        if(showCapacitySetting == 1) {
            showCapacity = true;
        } else {
            showCapacity = false;
        }

        fpsRate = parseInt(webAppCore.getVar("fps-rate-setting","1"));
        
        webAppCore.handlePauseFunction(onPause);
        webAppCore.handleResumeFunction(onResume);
        webAppCore.setOnImageImportListener(onImageImport);

        
        if(resourceDisplayMode == 0) {
            moneyReadout.className = "marqueeReadout";
        } else {
            moneyReadout.className = "";
        }
        
        setBodyStyles();

        setupMenuOptions();

        sizeElements();

        initBuildCategories();
        initUtilityDefs();
        initOccupationDefs();
        
        initBuildingDefs();
        initVehicleDefs();
        initTerrainDefs();
        initResourceReadouts();
        loadPassableTileDefs();

        activeModFiles = {};
        
        if(currentActiveTextureMod.length == 0) {
            loadAssets();
        } else {
            loadAllTextureMods();
        }

        if(ColonyGame.meta.releaseNotesServer != null && !webAppCore.isTV()) {
            if(webAppCore.getVar("release-notes-" + ColonyGame.meta.releaseCode,"0") != "1") {
                fetchReleaseNotes();
            }
        }

        webAppCore.setChatUsernameSelectedListener(onChatUsernameSelected);

        

        sizeElements();
    }

    function guid() {
        function s4() {
            return Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1);
        }
        return s4() + s4() + "-" + s4() + "-" + s4() + "-" + s4() + "-" + s4() + s4() + s4();
    }

    var curPendingTexLoadName = null;

    function loadAllTextureMods() {
        activeModFiles = {};

        pendingLoadTextures = [];

        for(var i = 0; i < currentActiveTextureMod.length; i++) {
            pendingLoadTextures.push(currentActiveTextureMod[i]);
        }

        if(pendingLoadTextures.length > 0) {
            curPendingTexLoadName = pendingLoadTextures.shift();
            webAppCore.openFile(curPendingTexLoadName,onOpenTexturePackForActivation);
        }
        
    }

    var pendingLoadTextures = null;
    var activeModFiles = {};

    function changeResourceDisplayMode() {
        resourceDisplayMode++;

        if(resourceDisplayMode >= 3) {
            resourceDisplayMode = 0;
        }

        webAppCore.storeVar("res-display-mode",resourceDisplayMode.toString());

        if(resourceDisplayMode == 0) {
            moneyReadout.className = "marqueeReadout";
        } else {
            moneyReadout.className = "";
        }

        setBodyStyles();

    }

    function loadPassableTileDefs() {
        passableTileRefs = {};

        for(var i = 0; i < ColonyGame.buildings.length; i++) {
            if(ColonyGame.buildings[i].passable) {
                passableTileRefs[ColonyGame.buildings[i].name] = ColonyGame.buildings[i];
            }
        }

    }

    function onFacebookStatusChange(status) {
        setAutosaveTimer();

        if(webAppCore.isApeAppsLoggedIn() && currentGame) {
            if(!currentGame.playerNamesRef[getRegionOrCity().localPlayerId]) {
                currentGame.playerNamesRef[getRegionOrCity().localPlayerId] = {
                    name: webAppCore.getApeAppsProfile().un,
                    color: currentGame.themeColor,
                    resources: {},
                    utilities: {},
                    techs: {}
                };
            }
        }

        if(status) {
            getUserMultiplayerRegions();
            refreshFriendsList();
        } else {
            userMultiplayerRegions = [];
            friendsList = {};
        }

        setGovernorName();
    }
    
    function onPause() {

        inBackgroundMode = true;

        if(currentGame != null) {
            saveCounter = 0;

            if(saveCounterMax > -1) {
                generalSaveGame();
            }
        }

        stopSoundtrack();
    }
    
    function onResume() {

        inBackgroundMode = false;

        if(allowMusic) {
            initSoundtrack();
        } 
    }
    
    function onImageImport() {
        // do nothing
    }

    function isRestrictivePlatform() {
        if(webAppCore.getPlatform().platform == "ios") {
            return true;
        }

        if(webAppCore.getPlatform().platform == "windows") {
            return true;
        }

        if(webAppCore.getPlatform().platform == "android" && webAppCore.getPlatform().market  == "amazon") {
            return true;
        }

        if(webAppCore.getPlatform().platform == "android" && webAppCore.getPlatform().market  == "gplay") {
            return true;
        }

        return false;
    }

    var colonyNeverLoaded = false;

    function initOnlineColony() {

        if(!getRegionOrCity().colonyId || getRegionOrCity().colonyId == 0 || getRegionOrCity().colonyId == "0") {
            webAppCore.showSplash("Registering Colony With Server...");
            setTimeout(registerColonyId,500);
        } else {
            webAppCore.showSplash("Logging in to server...");
            colonyNeverLoaded = true;

            theNeverLoadedTimeout = setTimeout(function(){
                if(colonyNeverLoaded) {
                    theNeverLoadedTimeout = null;
                    lastColorFilter = null;
                    openJobsArray = [];
                    currentGame = null;
                    currentJobOpprotunities = [];
                    opprotunityRecycleBox = [];
                    curRegPreviewWorkQueue = [];
                    currentTemplate = null;
                    curRegPreviewWorkItem = null;
                    curRegRiverTemplateCanvas = null;
                    curRegRiverTemplateContext = null;
                    templateVisible = false;
                    currentRegion = null;
                    currentSubcityRef = null;
                    pendingAutosales = [];
                    webAppCore.clearSplash();
                    showTitle();
                    webAppCore.showAlertWithTitle(getString("connection-error-info"),getString("general-connection-error"));
                }
            },8000);


            postSecuredCallToApi([],49,onServerLoginData);
        }
    }

    function parseServerMailData(mail) {
        var payrollGroup = {};

        for(var i = 0; i < mail.length; i++) {
            var message = mail[i];

            message.message = message.message.trim().latinize();

            var code = "0";
            var from = "0";

            if(message.code) {
                code = message.code;
            } else {
                if(message.msgcode) {
                    code = message.msgcode;
                }
            }

            if(message.from) {
                from = message.from;
            } else {
                if(message.colonyname) {
                    from = message.colonyname;
                }
            }

            // regular mail or annex request
            if(code == "0" || code == "6" || code == "7" || code == "8") {
                getRegionOrCity().mail.push(new MailMessage(from,message.fromid,message.message,message.time,code,message.resource,message.amount));

                if(code == "8") {
                    completeParentSwitch(message);
                }
            }

            // this is a contract sale 
            if(message.code == "1") {
                getRegionOrCity().gifts.push(new Gift("Sold Contract","Your " + message.resource + " contract sold!",ColonyGame.meta.tenderResource,parseInt(message.amount),true));
            }

            // payroll obligation inform
            if(code == "2" || code == "5") {
                if(code == "2") {
                    if(!payrollGroup[message.fromid]) {
                        payrollGroup[message.fromid] = {
                            "from": from,
                            "fromid": message.fromid,
                            "message": message.message,
                            "time": message.time,
                            "code": code,
                            "resource": message.resource,
                            "amount": 0
                        };
                    }

                    payrollGroup[message.fromid].amount += parseInt(message.amount);
                } else {
                    getRegionOrCity().mail.push(new MailMessage(from,message.fromid,message.message,message.time,code,message.resource,message.amount));
                }
            }

            // payroll reciept
            if(code == "3") {
                getRegionOrCity().gifts.push(new Gift("Payroll Assistance from " + from,message.message,ColonyGame.meta.tenderResource,parseInt(message.amount)));
            }

            // gift reciept
            if(code == "4") {
                if(message.resource == null || message.resource == "NULL" || message.resource == "" || message.resource == "null") {
                    message.resource = ColonyGame.meta.tenderResource;
                }
                getRegionOrCity().gifts.push(new Gift("Gift from " + from,message.message,message.resource,parseInt(message.amount)));
            }
        }

        var totalAutoPaid = 0;

        for(var payee in payrollGroup) {

            if(getRegionOrCity().autoBudget && parseInt(payrollGroup[payee].amount) < getGameResources()[ColonyGame.meta.tenderResource].amount) {
                modifyResourceAmount(ColonyGame.meta.tenderResource,-parseInt(payrollGroup[payee].amount),false,"Commonwealth");
                sendMessage(payrollGroup[payee].fromid,3,parseInt(payrollGroup[payee].amount),"Shared payroll payment from " + getRegionOrCity().name + ".",placeholder);
                totalAutoPaid += parseInt(payrollGroup[payee].amount);
                getRegionOrCity().foreignPayrollTotals += parseInt(payrollGroup[payee].amount);
            } else {
                getRegionOrCity().mail.push(new MailMessage(payrollGroup[payee].from,payrollGroup[payee].fromid,payrollGroup[payee].message,payrollGroup[payee].time,payrollGroup[payee].code,payrollGroup[payee].resource,payrollGroup[payee].amount));
            }

            
        }

        if(totalAutoPaid > 0) {
            webAppCore.showToast("You paid " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(totalAutoPaid) + " in shared payroll obligations!");
        }

        if(getRegionOrCity().gifts.length > 0) {
            webAppCore.showToast("New gifts available!");
            document.getElementById("imGift").style.display = "inline-block";
        }

        alertNewMailIfNecessary();
    }

    function onServerLoginData(data) {
        if(!data || data.trim().length == 0) {
            webAppCore.clearSplash();
            showTitle();
            webAppCore.showAlertWithTitle(getString("connection-error-info"),getString("general-connection-error"));
            return;
        }

        colonyNeverLoaded = false;

        if(theNeverLoadedTimeout) {
            clearTimeout(theNeverLoadedTimeout);
            theNeverLoadedTimeout = null;
        }

        try {
            var serverLoginResponseData = JSON.parse(data);
            var gameData = getRegionOrCity();

            // see if the server has blacklisted this colony
            if(serverLoginResponseData.blockonline && serverLoginResponseData.blockonline == "1") {
                gameData.hasCheated = true;
                gameData.offlineMode = true;
                gameData.tradeNotifications = false;
                gameData.charter = 0;
                gameData.colonies = 0;
                gameData.colonyId = 0;

                webAppCore.showAlertWithTitle("Online access to your colony has been disabled by the server.","Colony Offline");

                turnOffStreaming();
                streamingIndicator.style.display = "none";

                colonyNeverLoaded = false;
                webAppCore.clearSplash();
                return;
            }

            if(serverLoginResponseData.success) {

                if(gameData.hasLoadedChat) {
                    loadChat(true);
                }

                // sync techs 
                if(serverLoginResponseData.techdata && serverLoginResponseData.techdata.trim().length > 2) {
                    var serverTechData = serverLoginResponseData.techdata;
                    var decodedTechdata = atob(serverTechData);
                    var serverTechjsondata = JSON.parse(decodedTechdata);

                    var get = getGameTechs();

                    for(var tech in serverTechjsondata) {
                        if(serverTechjsondata[tech]) {
                            get[tech] = true;
                        }
                    }
                }

                // sync resources
                if(serverLoginResponseData.resdata && serverLoginResponseData.resdata.trim().length > 2) {
                    var serverResData = serverLoginResponseData.resdata;
                    var decodedresdata = atob(serverResData);
                    var serverresjsondata = JSON.parse(decodedresdata);

                    var gameRes = getGameResources();

                    for(var sRes in serverresjsondata) {

                        var rDef = getResourceByDefName(sRes);

                        if(!rDef) {
                            continue;
                        }

                        if(!gameRes[sRes]) {
                            gameRes[sRes] = {};
                            gameRes[sRes].amount = 0;
                            gameRes[sRes].previous = 0;
                            gameRes[sRes].capacity = rDef.max;
                            gameRes[sRes].price = rDef.basePrice;
                            gameRes[sRes].storageCapacity = 0;
                            gameRes[sRes].unlocked = false;
                            gameRes[sRes].serverId = 0;
                            gameRes[sRes].domesticCapacity = 0;
                            gameRes[sRes].domesticAmount = 0;
                            gameRes[sRes].lastTrade = 0;
                            gameRes[sRes].autosell = false;
                        }

                        gameRes[sRes].amount = parseInt(serverresjsondata[sRes]);

                        for(var j = 0; j < serverLoginResponseData.resources.length; j++) {
                            var pRes = serverLoginResponseData.resources[j];

                            if(pRes.name == sRes) {
                                var gamePrice = rDef.basePrice;
                                var totalPrice = (gamePrice * 9) + parseInt(pRes.price);
                                var averageAmount = Math.round(totalPrice / 10);
                                var lastGamePrice = gameRes[sRes].price;
                                var newGamePrice =  Math.round((lastGamePrice + averageAmount) / 2);

                                if(newGamePrice > parseInt(pRes.emergency)) {
                                    newGamePrice = parseInt(pRes.emergency);
                                }

                                gameRes[sRes].price = newGamePrice;
                                gameRes[sRes].serverId = pRes.id;
                                gameRes[sRes].lastTrade = parseInt(pRes.last);

                                if(!gameRes[sRes].autosell) {
                                    gameRes[sRes].autosell = false;
                                }
                            }
                        }
                    }

                    if(currentGame.mpRegionPlanetCharter && currentRegion && currentRegion.isMpRegionHolder) {
                        currentGame.resources[ColonyGame.meta.gameStageResource].amount = parseInt(currentRegion.resources[ColonyGame.meta.gameStageResource].amount);
                    }
                }

                setTimeout(checkColonyMailFromServer,500);

                // sync other high level stats
                serverMaxTradeSize = parseInt(serverLoginResponseData.maxtrade);

                gameData.charter = serverLoginResponseData.charter;
                gameData.sX = serverLoginResponseData.sx;
                gameData.sY = serverLoginResponseData.sy;
                gameData.gX = serverLoginResponseData.gx;
                gameData.gY = serverLoginResponseData.gy;
                gameData.colonies = parseInt(serverLoginResponseData.chartercount);
                gameData.federationId = serverLoginResponseData.fedid;
                gameData.federationName = serverLoginResponseData.fedname;
                gameData.federationCharter = serverLoginResponseData.fedcharter;

                if(serverLoginResponseData.independent == "1") {
                    gameData.isIndependent = true;
                } else {
                    gameData.motherlandCharter = serverLoginResponseData.motherlandCharter;
                    gameData.motherland = serverLoginResponseData.motherland;
                    gameData.motherlandid = serverLoginResponseData.motherlandid;
                }



                if(gameData.colonies > 0) {
                    recieveTaxCollections();
                }

                parseContractData(serverLoginResponseData.contracts);
                parseServerMailData(serverLoginResponseData.messages);

                if(gameData.isRegion) {
                    readyToLoadSubcities = true;
                }

                setIndicatorCanStream();

                verifyAllEmbassies();
                
            } else {
                if(serverLoginResponseData.reason) {
                    if(!serverLoginResponseData.colexists) {
                        // if the colony does not exist, it was removed due to 
                        // in activity.  re-register it to a new charter

                        gameData.charter = 0;
                        gameData.colonies = 0;
                        gameData.colonyId = 0;

                        webAppCore.showSplash("Registering Colony With Server...");
                        setTimeout(registerColonyId,500);

                        return;

                    } else {
                        webAppCore.clearSplash();
                        showTitle();
                        webAppCore.showAlertWithTitle(serverLoginResponseData.reason,getString("general-connection-error"));
                        return;
                    }
                    
                } else {
                    webAppCore.clearSplash();
                    showTitle();
                    webAppCore.showAlertWithTitle("There was a fatal error parsing server login response!  Please try again later.",getString("general-connection-error"));
                    return;
                }
            }

            webAppCore.clearSplash();
        } catch(ex) {
            console.log(ex);

            var plat = "";

            if(webAppCore.getPlatform && webAppCore.getPlatform()) {
                plat = webAppCore.getPlatform().platform;
            }

            webAppCore.logEvent("Caught Error",plat + ": onServerLoginData",ex.message);
            webAppCore.clearSplash();
            showTitle();
            webAppCore.showAlertWithTitle("There was an error parsing server login response.  Please try again.",getString("general-connection-error"));
            return;
        }
    }

    function establishSocketConnection() {

        if(usingSockets) {
            return;
        }

        if(ColonyGame.meta.socketServer != null) {
            webAppCore.socketConnect(ColonyGame.meta.socketServer);
            webAppCore.addSocketListener("connect",onSocketConnect);
            webAppCore.addSocketListener("disconnect",onSocketDisconnect);
            webAppCore.addSocketListener("message",onSocketMessage);
        }
    }

    function setBodyStyles() {

        var className = "";

        var roc = getRegionOrCity();

        if(usingTouch) {
            if(desktopMode) {
                className = "desktopMode touchMode";
            } else {
                className = "touchMode";
            }
        } else {
            if(desktopMode) {
                className = "desktopMode";
            } else {
                className = "";
            }
        }

        if(gamepadInUse) {
            className = "gamepadMode";
        }

        if(!desktopMode && !gamepadInUse && resourceDisplayMode == 0) {
            className += " smallMarqueeMode";
            className = className.trim();
        }

        if(currentGame == null) {
            className = "";
        }

        if(document.body.className != className) {
            document.body.className = className.trim();

            setTimeout(function() {
                sizeElements();
                Scroll2d.sizeElements();
                setupMenuOptions();
            },100);
            
        }   

        var useTradeNotifyArea = "none";

        if(desktopMode && roc && roc.tradeNotifications) {
            useTradeNotifyArea = "block";
        }

        if(currentGame && currentGame.isRegion) {
            useTradeNotifyArea = "none";
        }

        if(document.getElementById("tradeNotificationArea").style.display != useTradeNotifyArea) {
            document.getElementById("tradeNotificationArea").style.display = useTradeNotifyArea;

            if(useTradeNotifyArea == "block") {
                document.getElementById("bottomRightArea").style.bottom = "30px";
                desktopNotificationArea.style.bottom = "38px";

                document.getElementById("streamControlsBar").style.bottom = "72px";
            } else {
                document.getElementById("bottomRightArea").style.bottom = null;
                desktopNotificationArea.style.bottom = null;
                document.getElementById("streamControlsBar").style.bottom = null;
            }
        }
        
        var topBarBackground = null;

        if(bulldozerMode) {
            topBarBackground = "rgba(255,0,0,0.6)";
        }

        if(moneyReadout.style.backgroundColor != topBarBackground) {
            moneyReadout.style.backgroundColor = topBarBackground;
        }
    }
    
    function sizeElements() {
        
        if(!moneyReadout) {
            return;
        }

        if(window.innerWidth > sidebarModeWidth && !webAppCore.isTV() && !gamepadInUse) {

            var desktopModeDefault = "0";

            if(webAppCore.getPlatform().platform == "desktop" || webAppCore.getPlatform().platform == "web" || webAppCore.getPlatform().platform == "windows") {
                desktopModeDefault = "1";
            }

            if(webAppCore.getVar("desktop-mode",desktopModeDefault) == "1") {
                desktopMode = true;
            } else {
                desktopMode = false;

                if(resourceDisplayMode > 0) {
                    moneyReadout.className = "";
                } else {
                    moneyReadout.className = "marqueeReadout";
                }
            }
        } else {
            desktopMode = false;

            if(resourceDisplayMode > 0) {
                moneyReadout.className = "";
            } else {
                moneyReadout.className = "marqueeReadout";
            }
        }

        if(currentGame && currentGame.readOnlyMode) {
            desktopMode = false;

            if(resourceDisplayMode > 0) {
                moneyReadout.className = "";
            } else {
                moneyReadout.className = "marqueeReadout";
            }
        }

        if(desktopMode && currentGame != null) {
            document.getElementById("sidebar").style.display = "block";
        }

        setBodyStyles();
        
        if(moneyReadout) {
            moneyReadout.useThisWidth = null;
            moneyReadout.style.minWidth = "initial";
        }

        setMinWidths();
    }

    function setMinWidths() {
        
        if (!moneyReadout) {
            return;
        }
        
        if(!gamepadInUse && window.innerWidth < 1000) {

            if(!moneyReadout.useThisWidth) {
                moneyReadout.useThisWidth = moneyReadout.offsetWidth - 1;
            }
            
            if(moneyReadout.offsetWidth - 1 > moneyReadout.useThisWidth) {
                moneyReadout.useThisWidth = moneyReadout.offsetWidth - 1;
                
            }

            moneyReadout.style.minWidth = moneyReadout.useThisWidth + "px";
        } else {
            moneyReadout.useThisWidth = null;
            moneyReadout.style.minWidth = "initial";
        }
    }

    var padTimeout = null;

    function clearGamepad() {
        padTimeout = null;
        cameFromGamepad = false;
    }

    function startPadTimeout() {
        if(padTimeout != null) {
            clearTimeout(padTimeout);
            padTimeout = null;
        }

        padTimeout = setTimeout(clearGamepad,300);
    }

    var gamepadSelectedSidebarOption = -1;
    var lastSidebarGamepadDirection = 0;
    var gamepadScrollRetrys = 0;

    function handleSidebarGamepadSelection() {

        var tmpItems = document.getElementById("sidebarBuildListing").querySelectorAll(".buildItem");

        var buildItems = [];
        var i;

        for(i = 0; i < tmpItems.length; i++) {
            if(tmpItems[i].style.display != "none") {
                buildItems.push(tmpItems[i]);
            }
        }

        if(gamepadScrollRetrys > buildItems.length) {
            return;
        }

        if(buildItems.length == 0) {
            return;
        }
        
        isCoolingDown = true;

        setTimeout(function() {
            isCoolingDown = false;
        },100);

        if(gamepadSelectedSidebarOption >= buildItems.length) {
            gamepadSelectedSidebarOption = 0;
        }

        if(gamepadSelectedSidebarOption < 0) {
            gamepadSelectedSidebarOption = buildItems.length - 1;
        }

        if(buildItems[gamepadSelectedSidebarOption].cantAffortThis) {
            gamepadScrollRetrys++;
            gamepadSelectedSidebarOption += lastSidebarGamepadDirection;
            handleSidebarGamepadSelection();
            return;
        }

        for(i = 0; i < buildItems.length; i++) {
            if(i == gamepadSelectedSidebarOption) {
                buildItems[i].className = buildItems[i].baseClassSave + " gamepadSelected";
                buildItems[i].scrollIntoView();
            } else {
                buildItems[i].className = buildItems[i].baseClassSave;
            }
        }
    }

    function handleSidebarGamepadSelectionClick() {
        document.getElementById("sidebar").style.display = "none";

        if(gamepadSelectedSidebarOption < 0) {
            return;
        }

        var buildItems = document.getElementById("sidebarBuildListing").querySelectorAll(".buildItem");

        var showingItems = [];

        for(var i = 0; i < buildItems.length; i++) {
            if(buildItems[i].style.display != "none") {
                showingItems.push(buildItems[i]);
            }
        }

        if(gamepadSelectedSidebarOption >= showingItems.length) {
            return;
        }

        showingItems[gamepadSelectedSidebarOption].click();

        cooldownGamepad();
    }

    var padReference = {};

    function onPadDown(id,button) {

        if(!allowGamepad) {
            gamepadInUse = false;
            return;
        }

        if(!gamepadInUse) {
            gamepadInUse = true;
            setBodyStyles();
        }

        if(isCoolingDown || inBackgroundMode) {
            return;
        }

        if(padReference[button] === undefined) {
            padReference[button] = false;
        }

        if(padReference[button]) {
            return;
        }

        padReference[button] = true;

        startPadTimeout();

        cameFromGamepad = true;


        if(tipsWindowOpen) {
            closeTipsPopup();
            return;
        }

        if(statsOpen) {

            if(button == "down") {
                gamepadStatOption++;
                highlightActiveStatSection();
            }

            if(button == "up") {
                gamepadStatOption--;
                highlightActiveStatSection();
            }

            if(button == "b" || button == "lb") {
                closeStatsMenu();
            }
            
            return;
        }


        if(gbtOpen) {

            if(button == "a") {
                engageContractPurchase();
            }
            
            if(button == "down") {
                gamepadGbtOption++;
                highlightNextGbtSidebarOption();
            }

            if(button == "up") {
                gamepadGbtOption--;
                highlightNextGbtSidebarOption();
            }

            if(button == "rup") {
                currentSelectedGamepadContract -= gamepadContractsPerLine;
                highlightSelectedContractGamepad();
            }

            if(button == "rdown") {
                currentSelectedGamepadContract += gamepadContractsPerLine;
                highlightSelectedContractGamepad();
            }

            if(button == "rleft") {
                currentSelectedGamepadContract--;
                highlightSelectedContractGamepad();
            }

            if(button == "rright") {
                currentSelectedGamepadContract++;
                highlightSelectedContractGamepad();
            }

            if(button == "b" || button == "lb") {
                closeGBT();
            }

            return;
        }


        if(document.getElementById("sidebar").style.display == "block") {
            if(button == "b" || button == "y") {
                document.getElementById("sidebar").style.display = "none";
            }

            if(button == "left" || button == "lb") {
                padCooldownTimer = -8;
                gamepadSelectedSidebarOption--;
                lastSidebarGamepadDirection = -1;
                gamepadScrollRetrys = 0;
                handleSidebarGamepadSelection();
            }

            if(button == "right" || button == "rb") {
                padCooldownTimer = -8;
                gamepadSelectedSidebarOption++;
                lastSidebarGamepadDirection = 1;
                gamepadScrollRetrys = 0;
                handleSidebarGamepadSelection();
            }

            if(button == "a") {
                handleSidebarGamepadSelectionClick();
            }

            if(button == "up" || button == "down") {
                if(button == "up") {
                    gamepadSelectedBuildCategory++;
                }

                if(button == "down") {
                    gamepadSelectedBuildCategory--;
                }

                if(gamepadSelectedBuildCategory < 0) {
                    gamepadSelectedBuildCategory = allBuildCategories.length - 1;
                }

                if(gamepadSelectedBuildCategory >= allBuildCategories.length) {
                    gamepadSelectedBuildCategory = 0;
                }
                

                selectedBuildCategory = allBuildCategories[gamepadSelectedBuildCategory];
                document.getElementById("gamepadFilterText").innerHTML = selectedBuildCategory;

                drawSidebar();

                gamepadSelectedSidebarOption = 0;
                handleSidebarGamepadSelection();
                lastSidebarGamepadDirection = 0;
            }

            return;
        }

        if(document.getElementById("touchBuildConfirm").style.display == "block" || document.getElementById("gamepadBuildConfirm").style.display == "block") {
            if(button == "x") {
                document.getElementById("tbcConfirm").click();
                return;
            }

            if(button == "b" || button == "start" || button == "lb") {
                document.getElementById("tbcCancel").click();
                return;
            }
        }

        if(document.getElementById("objectOptions").style.display == "block") {
            objectOptionsGamepadDown(button);
            return;
        }

        if(button == "start" || button == "lb") {
            cooldownGamepad();
            Scroll2d.gamepadAllStop();
            webAppCore.toggleMenu();
            padReference[button] = false;
            return;
        }

        if(button == "y") {
            if(document.getElementById("sidebar").style.display == "block") {
                document.getElementById("sidebar").style.display = "none";
            } else {
                document.getElementById("sidebar").style.display = "block";

                lastSidebarGamepadDirection = 0;
                gamepadScrollRetrys = 0;

                if(gamepadSelectedSidebarOption == -1) {
                    gamepadSelectedSidebarOption = 0;
                }

                handleSidebarGamepadSelection();
            }

            return;
        }

        if(button == "rb") {
            changeResourceDisplayMode();
            return;
        }

        if(button == "b") {

            if(colonyWindowOpen) {
                closeColonyWindow();
                return;
            }



            if(newObjectOptionsOpen) {
                closeObjectOptionsMenu();
                return;
            }
            

            selectIdleBuilder();
            return;
        }

        if(button == "x") {
            defaultOutZoomLevel();
            
            centerMap();
            return;
        }

        if(button == "rt") {
            if(!currentGame) {
                return;
            }

            if(getRegionOrCity().mail.length > 0) {
                showMail();
                cooldownGamepad();
                return;
            }

            if(getRegionOrCity().gifts.length > 0) {
                showGifts();
                cooldownGamepad();
                return;
            }
        }

        Scroll2d.gamepadDown(button);
    }

    function onPadUp(id,button) {

        if(!allowGamepad) {
            gamepadInUse = false;
            setBodyStyles();
            return;
        }

        if(!gamepadInUse) {
            gamepadInUse = true;
            setBodyStyles();
        }

        padReference[button] = false;

        if(isCoolingDown || inBackgroundMode) {
            return;
        }

        startPadTimeout();

        if(document.getElementById("objectOptions").style.display == "block") {

            return;
        }

        Scroll2d.gamepadUp(button);
    }

    var gamepadCooldown = null;
    var isCoolingDown = false;

    function cooldownGamepad() {
        isCoolingDown = true;

        if(gamepadCooldown != null) {
            clearTimeout(gamepadCooldown);
            gamepadCooldown = null;
        }

        gamepadCooldown = setTimeout(gamepadIsCool,150);
    } 

    function gamepadIsCool() {
        isCoolingDown = false;
        gamepadCooldown = null;
    }

    function objectOptionsGamepadDown(button) {
        var buttons = document.getElementById("objectOptions").querySelectorAll(".objectOptionIcon");
        var selectionChanged = false;

        if(button == "down" || button == "up" || button == "left" || button == "right") {

            if(button == "down" || button == "right") {
                while(!selectionChanged) {
                    gamepadSelectionButton++;

                    if(gamepadSelectionButton >= buttons.length) {
                        gamepadSelectionButton = 0;
                    }

                    if(buttons[gamepadSelectionButton].style.display == "inline-block") {
                        selectionChanged = true;
                    }
                }
            } else {
                while(!selectionChanged) {
                    gamepadSelectionButton--;

                    if(gamepadSelectionButton < 0) {
                        gamepadSelectionButton = buttons.length - 1;
                    }

                    if(buttons[gamepadSelectionButton].style.display == "inline-block") {
                        selectionChanged = true;
                    }
                }
            }


            highlightSelectedObjectButton();
        }

        if(button == "a") {
            cooldownGamepad();
            executeSelectedGamepadButton();
        }

        if(button == "b") {
            closeObjectOptionsAndClear();
        }
    }

    function drawLineChart(canvas,data,hardMin,hardMax,color) {


        var chartContext = canvas.getContext("2d");

        var startingPoint = 0;

        var min = 0;
        var max = 100;

        if(data.length > 400) {
            startingPoint = data.length - 400;
        }

        for(i = startingPoint; i < data.length; i++) {
            

            if(min == 0 || data[i] < min) {
                min = data[i];
            }

            if(data[i] > max) {
                max = data[i];
            }
        }

        if(hardMin != null) {
            min = hardMin;
        }

        if(hardMax != null) {
            max = hardMax;
        }

        var scale = 1;

        if((max - min) > 300) {
            scale = 300 / (max - min);
        }

        if((max - min) < 300) {
            scale = 300 / (max - min);
        }

        chartContext.beginPath();

        chartContext.save();

        chartContext.translate(0,300);

        chartContext.clearRect(0,-300,canvas.width,canvas.height);
        
        var drawX = 0;
        var i;

        for(i = startingPoint; i < data.length; i++) {
            
            var y = data[i] - min;
            y *= scale;
            y = y * -1;

            if(i == startingPoint) {
                chartContext.moveTo(drawX,y);
            } else {
                chartContext.lineTo(drawX,y);
            }

            drawX++;
        }

        chartContext.lineWidth = 3;
        chartContext.strokeStyle = color;

        chartContext.stroke();
        chartContext.restore();
    }

    function createStatBarGraph(amount,max,title,text,color) {

        if(!color) {
            color = getColorForPercentage((amount / max),[
                { pct: 0.0, color: { r: 0xf4, g: 0x43, b: 0x36 } },
                { pct: 0.5, color: { r: 0xff, g: 0xc1, b: 0x07 } },
                { pct: 1.0, color: { r: 0x4c, g: 0xaf, b: 0x50 } }
            ]);
        }

        var percent = Math.round((amount / max) * 100);

        var inflowItem = document.createElement("div");
        inflowItem.className = "flowItem";

        if(title) {
            var inflowName = document.createElement("span");
            inflowName.className = "flowItemName";
            inflowName.innerHTML = title;
            inflowItem.appendChild(inflowName);
        }
        

        var inflowBarHolder = document.createElement("div");
        inflowBarHolder.className = "flowItemBarHolder";

        var inflowBar = document.createElement("div");
        inflowBar.className = "flowItemBar";
        inflowBar.style.width = percent + "%";
        inflowBar.style.backgroundColor = color;

        inflowBarHolder.appendChild(inflowBar);

        var inflowAmount = document.createElement("span");
        inflowAmount.className = "flowAmount";

        if(text) {
            inflowAmount.innerHTML = text;
        } else {
            inflowAmount.innerHTML = numberWithCommas(amount);
        }
        
        inflowBarHolder.appendChild(inflowAmount);

        inflowItem.appendChild(inflowBarHolder);

        return inflowItem;
    }

    function updateUtilityStatDisplay() {

        if(!ColonyGame.utilities || ColonyGame.utilities.length == 0) {
            return;
        }

        //console.log(currentGame);

        var statUtilitiesHeader = document.getElementById("statUtilitiesHeader");
        statUtilitiesHeader.innerHTML = "";

        var j,sr,uProp;

        for(var i = 0; i < ColonyGame.utilities.length; i++) {
            var utilityDef = ColonyGame.utilities[i];
            var utilityName = utilityDef.name;

            var utilitySection = document.createElement("div");
            utilitySection.className = "statSubSection";

            var utilityNameHeader = document.createElement("p");
            utilityNameHeader.className = "statSubsectionCount";
            utilityNameHeader.innerHTML = utilityName;
            utilitySection.appendChild(utilityNameHeader);

            var allUtilityStats = {};

            if(currentGame.isSubregion && currentRegion) {
                for(j = 0; j < currentRegion.subRegions.length; j++) {
                    sr = currentRegion.subRegions[j];

                    if(sr.utilitySources && sr.utilitySources[utilityName]) {
                        for(uProp in sr.utilitySources[utilityName]) {
                            if(!allUtilityStats[uProp]) {
                                allUtilityStats[uProp] = 0;
                            }

                            allUtilityStats[uProp] += parseInt(sr.utilitySources[utilityName][uProp]);
                        }
                    }
                }
            } else {
                if(currentGame.isRegion) {
                    for(j = 0; j < currentGame.subRegions.length; j++) {
                        sr = currentGame.subRegions[j];
    
                        if(sr.utilitySources && sr.utilitySources[utilityName]) {
                            for(uProp in sr.utilitySources[utilityName]) {
                                if(!allUtilityStats[uProp]) {
                                    allUtilityStats[uProp] = 0;
                                }
    
                                allUtilityStats[uProp] += parseInt(sr.utilitySources[utilityName][uProp]);
                            }
                        }
                    }
                } else {
                    if(currentGame.utilitySources && currentGame.utilitySources[utilityName]) {
                        allUtilityStats = currentGame.utilitySources[utilityName];
                    }
                }
                
                
            }

            var allUtilsArray = [];

            var utilMax = 0;

            for(uProp in allUtilityStats) {
                allUtilsArray.push({
                    utility: uProp,
                    amount: allUtilityStats[uProp]
                });

                utilMax += parseInt(allUtilityStats[uProp]);
            }

            allUtilsArray.sort(sortFlows);

            for(j = 0; j < allUtilsArray.length; j++) {
                var ui = allUtilsArray[j];

                var utilSrc = createStatBarGraph(ui.amount,utilMax,ui.utility,null,utilityDef.color);
                utilitySection.appendChild(utilSrc);
            }

            statUtilitiesHeader.appendChild(utilitySection);
        }
    }

    function updateResourceStatDisplay() {
        document.getElementById("resourcesStatSection").innerHTML = "";

        for(var prop in getGameResources()) {

            if(prop == "statResSaveTimestamp") {
                continue;
            }


            if(!getGameResources()[prop].unlocked) {
                continue;
            }

            if(!getGameResources()[prop].inflows || !getGameResources()[prop].outflows) {
                continue;
            }

            var nets = getGameResources()[prop].inflows.allCurrent - getGameResources()[prop].outflows.allCurrent;

            var netColor = null;

            if(nets <= 0) {
                netColor = "#F44336";
            }

            var resourceStatCard = document.createElement("div");
            resourceStatCard.className = "resourceStatCard";

            var resourceIcon = document.createElement("img");
            resourceIcon.src = "images/" + getResourceByDefName(prop).icon;
            resourceIcon.className = "resourceStatCardIcon";
            resourceStatCard.appendChild(resourceIcon);

            var resourceName = document.createElement("p");
            resourceName.className = "resourceStatCardName";
            resourceName.innerHTML = prop;
            resourceStatCard.appendChild(resourceName);

            // inflows
            var resourceInflows = document.createElement("p");
            resourceInflows.className = "resourceStatCardFlows";

            var resourceInflowImage = document.createElement("img");
            resourceInflowImage.src = "images/res-trend-up.png";
            resourceInflows.appendChild(resourceInflowImage);

            var resourceInflowCounw = document.createElement("span");
            resourceInflowCounw.innerHTML = numberWithCommas(getGameResources()[prop].inflows.allCurrent);
            resourceInflows.appendChild(resourceInflowCounw);

            resourceStatCard.appendChild(resourceInflows);

            // outflows
            var resourceOutflows = document.createElement("p");
            resourceOutflows.className = "resourceStatCardFlows";

            var resourceOutflowImage = document.createElement("img");
            resourceOutflowImage.src = "images/res-trend-down.png";
            resourceOutflows.appendChild(resourceOutflowImage);

            var resourceOutflowCounw = document.createElement("span");
            resourceOutflowCounw.innerHTML = numberWithCommas(getGameResources()[prop].outflows.allCurrent);
            resourceOutflowCounw.style.color = netColor;
            resourceOutflows.appendChild(resourceOutflowCounw);

            resourceStatCard.appendChild(resourceOutflows);

            resourceStatCard.resourceRef = prop;
            resourceStatCard.onclick = onResourceStatCardClick;

            document.getElementById("resourcesStatSection").appendChild(resourceStatCard);
        }
    }

    function onResourceStatCardClick() {
        showChartsForResource(this.resourceRef);
    }

    function updateEconomicStatDisplay() {

        var currentGDPGrowth = 0.0;
        var currentGDPGrowthInfo = "The Bureau of Bureaucracy requires more data before they can finish calculating your GDP growth rate.  Please check back later.";
        var currentGDPGrowthColor = "#F44336";

        // HERE GET THE RATE BASED ON REGION OR CITY
        if(currentGame.isRegion) {

            if(!currentGame.regionalGDPAnuallyhQuarterlyAdjusted) {
                currentGame.regionalGDPAnuallyhQuarterlyAdjusted = [];
            }

            if(currentGame.regionalGDPAnuallyhQuarterlyAdjusted.length > 1 && currentGame.regionalGDPAnuallyhQuarterlyAdjusted[currentGame.regionalGDPAnuallyhQuarterlyAdjusted.length - 1]) {
                currentGDPGrowth = currentGame.regionalGDPAnuallyhQuarterlyAdjusted[currentGame.regionalGDPAnuallyhQuarterlyAdjusted.length - 1];
                currentGDPGrowthInfo = "";
            }
        } else {

            if(!currentGame.historicStats.gdpQuarterlyAdjusted) {
                currentGame.historicStats.gdpQuarterlyAdjusted = [];
            }

            if(currentGame.historicStats.gdpQuarterlyAdjusted.length > 1 && currentGame.historicStats.gdpQuarterlyAdjusted[currentGame.historicStats.gdpQuarterlyAdjusted.length - 1]) {
                currentGDPGrowth = currentGame.historicStats.gdpQuarterlyAdjusted[currentGame.historicStats.gdpQuarterlyAdjusted.length - 1];

                if(currentGame.historicStats.gdpAnuallyAdjusted.length > 1 && currentGame.historicStats.gdpAnuallyAdjusted[currentGame.historicStats.gdpAnuallyAdjusted.length - 1]) {
                    currentGDPGrowthInfo = "Annual rate: " + currentGame.historicStats.gdpAnuallyAdjusted[currentGame.historicStats.gdpAnuallyAdjusted.length - 1].toFixed(1) + "%";
                }
            }
        }

        if(currentGDPGrowth > 0) {
            currentGDPGrowthColor = "#E91E63";
        }

        if(currentGDPGrowth > 1) {
            currentGDPGrowthColor = "#9C27B0";
        }

        if(currentGDPGrowth > 2) {
            currentGDPGrowthColor = "#673AB7";
        }

        if(currentGDPGrowth > 3) {
            currentGDPGrowthColor = "#3F51B5";
        }

        if(currentGDPGrowth > 4) {
            currentGDPGrowthColor = "#2196F3";
        }

        if(currentGDPGrowth > 5) {
            currentGDPGrowthColor = "#03A9F4";
        }

        if(currentGDPGrowth > 6) {
            currentGDPGrowthColor = "#00BCD4";
        }

        if(currentGDPGrowth > 7) {
            currentGDPGrowthColor = "#009688";
        }

        if(currentGDPGrowth > 8) {
            currentGDPGrowthColor = "#4CAF50";
        }

        document.getElementById("statGDPGrowth").innerHTML = currentGDPGrowth.toFixed(1) + "%";
        document.getElementById("statGDPGrowth").style.color = currentGDPGrowthColor;
        document.getElementById("statGdpGrowthDesc").innerHTML = currentGDPGrowthInfo;
        

        var currentGDP = currentGame.historicStats.gdp[currentGame.historicStats.gdp.length - 1];

        if(currentGame.isRegion) {
            currentGDP = currentGame.regionalGDPTrend[currentGame.regionalGDPTrend.length - 1];
        }

        var currentUnemploymentRate = currentGame.historicStats.unemployment[currentGame.historicStats.unemployment.length - 1];
        var currentUnemploymentColor = "#546E7A";

        if(currentUnemploymentRate > 10) {
            currentUnemploymentColor = "#F44336";
        }

        if(currentUnemploymentRate < 4) {
            currentUnemploymentColor = "#4CAF50";
        }

        drawLineChart(document.getElementById("unemploymentTrendChart"),currentGame.historicStats.unemployment,0,100,currentUnemploymentColor);

        document.getElementById("statUnemploymentCount").innerHTML = currentUnemploymentRate + "%";
        document.getElementById("statUnemploymentCount").style.color = currentUnemploymentColor;

        document.getElementById("statGDPCount").innerHTML = getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(currentGDP);
        document.getElementById("statGDPCount").style.color = "#7CB342";

        if(currentGame.isRegion) {
            drawLineChart(document.getElementById("gdpTrendChart"),currentGame.regionalGDPTrend,null,null,"#7CB342");
        } else {
            drawLineChart(document.getElementById("gdpTrendChart"),currentGame.historicStats.gdp,null,null,"#7CB342");
        }
        

        document.getElementById("statGdpPerCapita").innerHTML = "Per Capita: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(Math.round(currentGDP / getTotalPopulation()));

        var totalJobs = currentGame.historicStats.jobs[currentGame.historicStats.jobs.length - 1];
        var totalWorkers = currentGame.historicStats.workforce[currentGame.historicStats.workforce.length - 1];

        if(totalWorkers > totalJobs) {
            totalWorkers = totalJobs;
        }

        if(!currentGame.historicStats.students) {
            currentGame.historicStats.students = [];
        }

        if(!currentGame.historicStats.retiredpop) {
            currentGame.historicStats.retiredpop = [];
        }

        var students = getMinorPopulation();
        var retired = getRetiredPop();

        var wf = getTotalPopulation();
        wf -= students;
        wf -= retired;

        if(wf < 0) {
            wf = 0;
        }

        var notworking = wf - totalWorkers;

        if(notworking < 0) {
            notworking = 0;
        }

        document.getElementById("statWorkforcePopulation").innerHTML = "Total Population: " + numberWithCommas(getTotalPopulation());
        document.getElementById("statWorkforceRetired").innerHTML = "Retired Population: " + numberWithCommas(retired);
        document.getElementById("statWorkforceStudents").innerHTML = "Minor Population: " + numberWithCommas(students);
        document.getElementById("statWorkforceTotal").innerHTML = "Total Workforce: " + numberWithCommas(wf);

        document.getElementById("statTotalUnemployed").innerHTML = numberWithCommas(notworking);

        var chartItems = {
            "Filled Jobs": totalWorkers,
            "Vacant Jobs": totalJobs - totalWorkers
        };
        var chartColors = ["#4CAF50","#F44336"];

        var myPiechart = new Piechart({
            canvas:document.getElementById("statJobsreportChart"),
            data:chartItems,
            colors:chartColors
        });
        myPiechart.draw();

        document.getElementById("jobsReportFlowBar").style.backgroundColor = "#4CAF50";
        document.getElementById("jobsReportFlowBar").style.width = ((totalWorkers / totalJobs) * 100) + "%";
        document.getElementById("jobsReportFlowAmount").innerHTML = numberWithCommas(totalWorkers) + "/" + numberWithCommas(totalJobs) + " Filled";

        
        document.getElementById("statTotalJobs").innerHTML = numberWithCommas(totalJobs);
        document.getElementById("statJobsreportBreakdown").innerHTML = "";

        var colIndex = 0;

        for(var prop in chartItems) {

            

            var item = document.createElement("p");

            var showpercentage = Math.round((chartItems[prop] / totalJobs) * 100);

            item.innerHTML = prop + ": " + showpercentage + "%";
            item.style.color = chartColors[colIndex];
            document.getElementById("statJobsreportBreakdown").appendChild(item);

            colIndex++;
        }

        var savingsColor = "#009688";

        var avgSavings = currentGame.historicStats.savings[currentGame.historicStats.savings.length - 1];

        if(avgSavings < 15) {
            savingsColor = "#F44336";
        }

        if(avgSavings > (gotItMadePrice / 2)) {
            savingsColor = "#4CAF50";
        }

        document.getElementById("statRetSavCutoff").innerHTML = getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(gotItMadePrice);
        document.getElementById("statRetSavCutoff").style.color = getResourceByDefName(ColonyGame.meta.tenderResource).color;

        document.getElementById("statPovertyLine").innerHTML = getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(povertyLine);
        document.getElementById("statPovertyLine").style.color = "#880E4F";


        document.getElementById("statAverageSavings").innerHTML = getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(avgSavings);
        document.getElementById("statAverageSavings").style.color = savingsColor;
        drawLineChart(document.getElementById("savingsTrendChart"),currentGame.historicStats.savings,null,null,savingsColor);

        document.getElementById("statTotalTourists").innerHTML = numberWithCommas(currentGame.totalTourists);
        document.getElementById("statTotalTouristIncome").innerHTML = getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(currentGame.totalTourismIncome);
        
        if(currentGame.deadTourists > 0) {
            document.getElementById("statTotalTouristDeaths").style.color = "#F44336";
        } else {
            document.getElementById("statTotalTouristDeaths").style.color = null;
        }

        document.getElementById("statTotalTouristDeaths").innerHTML = numberWithCommas(currentGame.deadTourists);
    }

    function updatePopulationStatDisplay() {

        var i;

        var totalPop = getTotalPopulation();

        document.getElementById("statPopulationCount").innerHTML = numberWithCommas(totalPop);

        document.getElementById("statTotalBirths").innerHTML = numberWithCommas(currentGame.totalBirths);
        document.getElementById("statTotalDeaths").innerHTML = numberWithCommas(currentGame.totalDeaths);

        document.getElementById("statTotalImmigration").innerHTML = numberWithCommas(currentGame.totalImmigration);
        document.getElementById("statTotalEmigration").innerHTML = numberWithCommas(currentGame.totalEmigration);

        document.getElementById("statIllegals").innerHTML = numberWithCommas(currentTotalIllegals);
        document.getElementById("statIllegals").style.color = "#F44336";

        var statTableAgeDist = document.getElementById("statTableAgeDist");
        statTableAgeDist.innerHTML = "";

        var ageGroups = {
            "1": 0,
            "2": 0,
            "3": 0,
            "4": 0,
            "5": 0,
            "6": 0,
            "7": 0,
            "8": 0,
            "9": 0,
            "10": 0,
            "11": 0,
            "12": 0,
            "13": 0,
            "14": 0,
            "15": 0,
            "16": 0,
            "17": 0
        };

        var group;

        for(var ageProp in currentGame.populationDistribution) {
            var ageYear = Math.floor(parseInt(ageProp) / 12);

            group = "1";

            if(ageYear > 5) {
                group = "2";
            }

            if(ageYear > 9) {
                group = "3";
            }

            if(ageYear > 14) {
                group = "4";
            }

            if(ageYear > 19) {
                group = "5";
            }

            if(ageYear > 24) {
                group = "6";
            }

            if(ageYear > 29) {
                group = "7";
            }

            if(ageYear > 34) {
                group = "8";
            }

            if(ageYear > 39) {
                group = "9";
            }

            if(ageYear > 44) {
                group = "10";
            }

            if(ageYear > 49) {
                group = "11";
            }

            if(ageYear > 54) {
                group = "12";
            }

            if(ageYear > 59) {
                group = "13";
            }

            if(ageYear > 64) {
                group = "14";
            }

            if(ageYear > 69) {
                group = "15";
            }

            if(ageYear > 74) {
                group = "16";
            }

            if(ageYear > 79) {
                group = "17";
            }

            ageGroups[group] += currentGame.populationDistribution[ageProp];
        }



        var highestGroup = 0;
        var dataRow = document.createElement("tr");
        var legendRow = document.createElement("tr");

        for(i = 1; i <= 17; i++) {
            if(ageGroups[i] > highestGroup) {
                highestGroup = ageGroups[i];
            }
        }

        var lastNum;
        var label;
        var thisnum;
        var percent;
        var hideLabel;

        for(i = 1; i <= 17; i++) {
            thisnum = i * 5;

            hideLabel = "";
            label = thisnum.toString();

            if(i == 1) {
                hideLabel = "<";
            }

            if(i == 17) {
                hideLabel = thisnum.toString();
                label = " >";
            }

            if(i > 1 && i < 17) {
                hideLabel = lastNum + "-";
            }

            

            percent = Math.round((ageGroups[i] / highestGroup) * 100);

            var labelItem = document.createElement("th");

            if(hideLabel.trim().length > 0) {
                var hidePart = document.createElement("span");
                hidePart.className = "statTableLabelHidePart";
                hidePart.innerHTML = hideLabel;
                labelItem.appendChild(hidePart);
            }
            
            if(label.trim().length > 0) {
                var labelPart = document.createElement("span");
                labelPart.className = "statTableLabelShowPart";
                labelPart.innerHTML = label;
                labelItem.appendChild(labelPart);
            }


            legendRow.appendChild(labelItem);

            var barItemCell = document.createElement("td");

            var barHolder = document.createElement("div");
            barHolder.className = "statTableAgeDistBarHolder";

            var barActual = document.createElement("div");
            barActual.className = "statTableAgeDistBar";
            barActual.style.height = percent + "%";
            barHolder.appendChild(barActual);

            barItemCell.appendChild(barHolder);

            dataRow.appendChild(barItemCell);

            lastNum = thisnum;
        }

        statTableAgeDist.appendChild(dataRow);
        statTableAgeDist.appendChild(legendRow);

        // immigration sources 
        var immigrationSourceItemsRaw = {};
        var totalRecentImmigrants = 0;

        for(i = 0; i < currentGame.immigrantSources.length; i++) {
            if(!immigrationSourceItemsRaw[currentGame.immigrantSources[i]]) {
                immigrationSourceItemsRaw[currentGame.immigrantSources[i]] = 0;
            }

            immigrationSourceItemsRaw[currentGame.immigrantSources[i]]++;
            totalRecentImmigrants++;
        }

        var immigrantSourceArray = [];

        for(var imsrc in immigrationSourceItemsRaw) {
            immigrantSourceArray.push({
                "source": imsrc,
                "count": immigrationSourceItemsRaw[imsrc]
            });
        }

        immigrantSourceArray.sort(sortImmigrantSources);

        document.getElementById("immigrationSourceTable").innerHTML = "";

        for(i = 0; i < immigrantSourceArray.length; i++) {

            if(Math.round((immigrantSourceArray[i].count / totalRecentImmigrants) * 100) == 0) {
                break;
            }

            var contactRef = getForeignContactByName(immigrantSourceArray[i].source);

            var immigrantRow = document.createElement("tr");

            var immigrantSourceName = document.createElement("td");
            immigrantSourceName.className = "immigrationSourceTableSource";

            if(contactRef != null) {
                immigrantSourceName.className += " immigrationSourceTableSourceWithLink";
                immigrantSourceName.onclick = onimmigrantSourceNameClick;
                immigrantSourceName.colrefid = contactRef.id;
            }

            immigrantSourceName.innerHTML = immigrantSourceArray[i].source;
            immigrantRow.appendChild(immigrantSourceName);

            var immigrantSourceCount = document.createElement("td");
            immigrantSourceCount.innerHTML = Math.round((immigrantSourceArray[i].count / totalRecentImmigrants) * 100) + "%";
            immigrantRow.appendChild(immigrantSourceCount);

            document.getElementById("immigrationSourceTable").appendChild(immigrantRow);
        }

        drawLineChart(document.getElementById("populationTrendChart"),currentGame.historicStats.population,null,null,"#0277BD");

        var chartItems = {};
        var chartColors = [];

        var totalItems = 0;

        var myPiechart;

        if(ColonyGame.races.length <= 1) {
            document.getElementById("statDemographicsSection").style.display = "none";
        } else {
            document.getElementById("statDemographicsSection").style.display = "block";

            for(i = 0; i < ColonyGame.races.length; i++) {

                if(!currentGame.populationStats) {
                    currentGame.populationStats = 0;
                }

                if(!currentGame.populationStats[ColonyGame.races[i].name] || isNaN(currentGame.populationStats[ColonyGame.races[i].name])) {
                    currentGame.populationStats[ColonyGame.races[i].name] = 0;
                }

                chartColors.push(ColonyGame.races[i].raceColor);
                chartItems[ColonyGame.races[i].name] = currentGame.populationStats[ColonyGame.races[i].name];
                totalItems += currentGame.populationStats[ColonyGame.races[i].name];
            }
    
            myPiechart = new Piechart({
                canvas:document.getElementById("statPopulationDemoChart"),
                data:chartItems,
                colors:chartColors
            });
            myPiechart.draw();
    
            document.getElementById("statPopDemoBreakdown").innerHTML = "";
    
            for(i = 0; i < ColonyGame.races.length; i++) {
    
                var rawpercent = currentGame.populationStats[ColonyGame.races[i].name] / totalItems;
                var rawNumber = Math.round(totalPop * rawpercent);
    
                percent = Math.round(rawpercent * 100);
    
                var item = document.createElement("p");
                item.innerHTML = ColonyGame.races[i].name + ": " + numberWithCommas(rawNumber) + " (" + percent + "%)";
                item.style.color = ColonyGame.races[i].raceColor;
                document.getElementById("statPopDemoBreakdown").appendChild(item);
            }
        }

        

        document.getElementById("statPAverageAgeCount").innerHTML = currentGame.historicStats.age[currentGame.historicStats.age.length - 1];

        drawLineChart(document.getElementById("ageTrendChart"),currentGame.historicStats.age,0,120,"#26A69A");

        var totalHomelessRate = currentGame.historicStats.homeless[currentGame.historicStats.homeless.length - 1];
        var homelessColor = "#AD1457";

        if(totalHomelessRate > 4) {
            homelessColor = "#F44336";
        }

        document.getElementById("statHomelessnessCount").innerHTML = totalHomelessRate + "%";
        document.getElementById("statHomelessnessCount").style.color = homelessColor;

        document.getElementById("statTotalHouses").innerHTML = numberWithCommas(currentGame.availableShelters);

        document.getElementById("statTotalHomeless").innerHTML = numberWithCommas(runningHomelessCount);

        drawLineChart(document.getElementById("homelessTrendChart"),currentGame.historicStats.homeless,0,100,homelessColor);

        var totalHealthRate = currentGame.historicStats.health[currentGame.historicStats.health.length - 1];
        var healthColor = "#42A5F5";

        if(totalHealthRate < 85) {
            healthColor = "#F44336";
        }

        document.getElementById("statHealthCount").innerHTML = totalHealthRate + "%";
        document.getElementById("statHealthCount").style.color = healthColor;

        drawLineChart(document.getElementById("healthTrendChart"),currentGame.historicStats.health,0,100,healthColor);

        var totaliqRate = currentGame.historicStats.iq[currentGame.historicStats.iq.length - 1];
        var iqColor = "#FBC02D";

        if(totaliqRate < 90) {
            iqColor = "#F44336";
        }

        document.getElementById("statIQCount").innerHTML = totaliqRate;
        document.getElementById("statIQCount").style.color = iqColor;

        drawLineChart(document.getElementById("iqTrendChart"),currentGame.historicStats.iq,50,150,iqColor);

        var totalEntAvailable = 0;
        var totalEntUsed = 0;

        for(i = 0; i < currentGame.buildings.length; i++) {

            if(!currentGame.buildings[i]) {
                continue;
            }

            var bdef = getBuildingDefByName(currentGame.buildings[i].def);

            if(!bdef.entertains) {
                continue;
            }

            totalEntAvailable += bdef.entertains;
            totalEntUsed += currentGame.buildings[i].buG;
        }


        var unusedEntertainment = totalEntAvailable - totalEntUsed;


        myPiechart = new Piechart({
            canvas:document.getElementById("statEntertainmentChart"),
            data:[unusedEntertainment,totalEntUsed],
            colors:["#00695C","#4DB6AC"]
        });
        myPiechart.draw();

        document.getElementById("statEntertainmentBreakdown").innerHTML = "";

        var entitem1 = document.createElement("p");
        entitem1.innerHTML = "Vacant Entertainment: " + numberWithCommas(unusedEntertainment);
        entitem1.style.color = "#00695C";
        document.getElementById("statEntertainmentBreakdown").appendChild(entitem1);

        var entitem2 = document.createElement("p");
        entitem2.innerHTML = "Utilized Entertainment: " + numberWithCommas(totalEntUsed);
        entitem2.style.color = "#4DB6AC";
        document.getElementById("statEntertainmentBreakdown").appendChild(entitem2);
    }

    var Piechart = function(options){
        this.options = options;
        this.canvas = options.canvas;
        this.ctx = this.canvas.getContext("2d");
        this.colors = options.colors;
    
        this.draw = function(){
            var total_value = 0;
            var color_index = 0;
            var val;

            for (var categ in this.options.data){
                val = this.options.data[categ];
                total_value += val;
            }
    
            var start_angle = 0;
            for (categ in this.options.data){
                val = this.options.data[categ];
                var slice_angle = 2 * Math.PI * val / total_value;
    
                drawPieSlice(
                    this.ctx,
                    this.canvas.width/2,
                    this.canvas.height/2,
                    Math.min(this.canvas.width/2,this.canvas.height/2),
                    start_angle,
                    start_angle+slice_angle,
                    this.colors[color_index%this.colors.length]
                );
    
                start_angle += slice_angle;
                color_index++;
            }
    
            //drawing a white circle over the chart
            //to create the doughnut chart
            if (this.options.doughnutHoleSize){
                drawPieSlice(
                    this.ctx,
                    this.canvas.width/2,
                    this.canvas.height/2,
                    this.options.doughnutHoleSize * Math.min(this.canvas.width/2,this.canvas.height/2),
                    0,
                    2 * Math.PI,
                    "#ff0000"
                );
            }
    
        };
    };

    function drawPieSlice(ctx,centerX, centerY, radius, startAngle, endAngle, color ){
        ctx.fillStyle = color;
        ctx.beginPath();
        ctx.moveTo(centerX,centerY);
        ctx.arc(centerX, centerY, radius, startAngle, endAngle);
        ctx.closePath();
        ctx.fill();
    }

    function updateApprovalStatDisplay() {

        var currentapproval = currentGame.historicStats.approval[currentGame.historicStats.approval.length - 1];

        document.getElementById("statApprovalRating").innerHTML = currentapproval + "%";

        document.getElementById("statApprovalRating").style.color = null;
        var chartColor = "#0277BD";

        if(currentapproval > 90) {
            document.getElementById("statApprovalRating").style.color = "#2E7D32";
            chartColor = "#2E7D32";
        }

        if(currentapproval < 50) {
            document.getElementById("statApprovalRating").style.color = "#C62828";
            chartColor = "#C62828";
        }

        drawLineChart(document.getElementById("approvalTrendChart"),currentGame.historicStats.approval,0,100,chartColor);

        var chartItems = currentGame.sadderReasons;

        var totalItems = 0;

        for(var sadProp in currentGame.sadderReasons) {
            totalItems += currentGame.sadderReasons[sadProp];
        }

        var chartColors = ["#3F51B5","#4CAF50","#9C27B0","#FF9800","#f44336","#009688","#795548","#FF5722"];

        var myPiechart = new Piechart({
            canvas:document.getElementById("statDisapprovalFactorsChart"),
            data:chartItems,
            colors:chartColors
        });
        myPiechart.draw();

        document.getElementById("motherlandpaymentsheading").innerHTML = getRegionOrCity().motherland;
        document.getElementById("statMotherlandPaymentsMade").innerHTML = getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(getRegionOrCity().motherlandTaxesPaid);
        document.getElementById("statMotherlandPaymentsMade").style.color = "#9E9D24";

        document.getElementById("statDisapprovalBreakdown").innerHTML = "";

        if(getRegionOrCity().colonies == 0) {
            document.getElementById("chartersIssuedSection").style.display = "none";
            document.getElementById("statForeignCOllections").style.display = "none";
            document.getElementById("statForeignPayroll").style.display = "none";
        } else {
            document.getElementById("chartersIssuedSection").style.display = "block";
            document.getElementById("statForeignCOllections").style.display = "block";
            document.getElementById("statForeignPayroll").style.display = "block";

            document.getElementById("statTotalChartersIssued").innerHTML = numberWithCommas(getRegionOrCity().colonies);
            
            document.getElementById("statForeignTaxCollections").innerHTML = getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(getRegionOrCity().colonialTaxCollected);
            document.getElementById("statForeignTaxCollections").style.color = "#7CB342";
    
            var payrollColor = null;
    
            if(getRegionOrCity().foreignPayrollTotals > getRegionOrCity().colonialTaxCollected) {
                payrollColor = "#F44336";
            }
    
            document.getElementById("statForeignPayrollPayments").innerHTML = getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(getRegionOrCity().foreignPayrollTotals);
            document.getElementById("statForeignPayrollPayments").style.color = payrollColor;
        }

        var colIndex = 0;

        var firstItem = true;

        for(var prop in chartItems) {

            var item = document.createElement("p");

            var showpercentage = Math.round((chartItems[prop] / totalItems) * 100);

            item.innerHTML = prop + ": " + showpercentage + "%";
            item.style.color = chartColors[colIndex];
            document.getElementById("statDisapprovalBreakdown").appendChild(item);

            if(firstItem) {
                firstItem = false;

                document.getElementById("statDisapprovalFactorsDisclaimerExample").innerHTML = showpercentage + "% of your citizens have " + prop;
                document.getElementById("statDisapprovalFactorsDisclaimerExample2").innerHTML = showpercentage + "% of your citizens <strong>who are mad</strong> are upset because of " + prop;
            }

            colIndex++;
        }
    }

    function updateOnlineOfflineStatButtions() {

        document.getElementById("cloudStatOnlineMode").style.display = "none";
        document.getElementById("cloudStatOfflineMode").style.display = "none";
        



        if(currentGame.cm || gamepadInUse) {
            return;
        }

        if(!webAppCore.allowOnline()) {
            return;
        }

        if(ColonyGame.meta.colonyServerApi != null) {
            if(!currentGame.mpRegionPlanetCharter) {
                if(getRegionOrCity().offlineMode && !getRegionOrCity().hasCheated) {
                    document.getElementById("cloudStatOnlineMode").style.display = "block";
                    document.getElementById("cloudStatOnlineMode").onclick = function() {
                        askSwitchToOnlineMode();
                    };
                }

                if(!getRegionOrCity().offlineMode) {
                    document.getElementById("cloudStatOfflineMode").style.display = "block";
                    document.getElementById("cloudStatOfflineMode").onclick = function() {
                        webAppCore.showDialog({
                            "title":    getString("offline-mode"),
                            "message":  getString("offline-mode-warning"),
                            "op1": {
                                "text":     getString("general-yes"),
                                "func":     function() {
                                    takeColonyOffline();
                                    updateOnlineOfflineStatButtions();
                                }
                            },
                            "op2": {
                                "text":     getString("general-no"),
                                "func":     placeholder
                            }
                        });
                    };
                }
            }
            

            

            
        }
    }

    function updateCloudAndCompressionDisplays() {
        var compressionStatus = "On";
        var compressionColor = "#4CAF50";

        var roc = getRegionOrCity();

        if(!roc.useCompression) {
            compressionStatus = "Off";
            compressionColor = "#F44336";
        }

        document.getElementById("statOverviewGameCompression").innerHTML = compressionStatus;
        document.getElementById("statOverviewGameCompression").style.color = compressionColor;

        document.getElementById("compressStatsSection").onclick = function() {
            roc.useCompression = !roc.useCompression;

            if(!roc.useCompression && roc.useCloud) {
                webAppCore.deleteFile(currentFileName,cloudSwitchPostDelete);
                webAppCore.showToast("Cloud Sync Disabled");
            }

            updateCloudAndCompressionDisplays();
        };

        if(webAppCore.isApeAppsLoggedIn()) {

            document.getElementById("cloudStatsSection").style.display = "block";

            document.getElementById("cloudStatsSection").onclick = function() {
                if(roc.useCloud) {
                    webAppCore.deleteFile(currentFileName,cloudSwitchPostDelete);
                } else {
                    roc.useCloud = true;
                    generalSaveGameWithDialog();
                }

                if(roc.useCloud && !roc.useCompression) {
                    roc.useCompression = true;
                    webAppCore.showToast("Save Compression Enabled");
                }

                updateCloudAndCompressionDisplays();
            };

            var cloudStatus = "On";

            if(!roc.useCloud) {
                cloudStatus = "Off";
            }


            document.getElementById("statOverviewGameCloudsync").innerHTML = cloudStatus;
        } else {
            document.getElementById("cloudStatsSection").style.display = "none";
        }
    }

    function showGameDataSection() {
        updateCloudAndCompressionDisplays();

        if(gamepadInUse) {
            document.getElementById("cloudStatsSection").style.display = "none";
            document.getElementById("compressStatsSection").style.display = "none";
        } else {
            document.getElementById("cloudStatsSection").style.display = "block";
            document.getElementById("compressStatsSection").style.display = "block";
        }

        if(currentGame.mpRegionPlanetCharter || currentGame.isMpRegionHolder) {
            document.getElementById("cloudStatsSection").style.display = "none";
            document.getElementById("compressStatsSection").style.display = "none";
        }

        document.getElementById("offlineCopySection").style.display = "none";

        if(!getRegionOrCity().offlineMode) {

            if(!currentGame.isRegion) {
                document.getElementById("offlineCopySection").style.display = "block";
                document.getElementById("offlineCopySection").onclick = function() {
                    doOfflineCopy();
                    closeStatsMenu();
                    setupMenuOptions();

                    webAppCore.showDialog({
                        "title":    getString("offline-copy-gen"),
                        "message":  getString("offline-copy-notice")
                    });
                };
            }
        }
    }

    function updateOverviewStatDisplay() {

        var roc = getRegionOrCity();

        if(!roc) {
            return;
        }

        if(roc.isIndependent) {
            document.getElementById("statOverviewNamePrefix").innerHTML = "The Nation of";
            document.getElementById("statOverviewColonyDisclaimer").innerHTML = "";
        } else {
            document.getElementById("statOverviewNamePrefix").innerHTML = "";
            document.getElementById("statOverviewColonyDisclaimer").innerHTML = "A Colony of " + roc.motherland;
        }

        if(currentGame.cm) {
            document.getElementById("statCreativeDisclaimer").style.display = "block";
            document.getElementById("statCreativeDisclaimer").innerHTML = "Creative Mode";
        } else {
            document.getElementById("statCreativeDisclaimer").style.display = "none";
        }

        document.getElementById("statMpRegionDistrictSetting").style.display = "none";
        document.getElementById("statMpRegionDistrictOpenSetting").style.display = "none";
        document.getElementById("statMpRegionDistrictSettingDistrictName").style.color = null;
        document.getElementById("statMpRegionDistrictSettingDistrictName").style.textDecoration = null;
        document.getElementById("statMpRegionDistrictSettingDistrictName").style.cursor = null;

        if(currentGame.isSubregion && currentRegion && currentRegion.isMpRegionHolder && currentSubcityRef) {
            

            var metroAreaId = currentSubcityRef.metroAreaDistrict;
            var metroAreaName = currentRegion.metroAreaNameRef[metroAreaId];

            if(metroAreaName) {
                document.getElementById("statMpRegionDistrictSetting").style.display = "block";

                document.getElementById("statMpRegionDistrictSettingDistrictName").innerHTML = metroAreaName.name;

                if(metroAreaName.owner == webAppCore.getApeAppsProfile().un) {
                    document.getElementById("statMpRegionDistrictOpenSetting").style.display = "block";
                    document.getElementById("statMpRegionDistrictSettingDistrictOwner").innerHTML = "You are the owner of this metro area.";

                    document.getElementById("statMpRegionDistrictSettingDistrictName").onclick = function() {
                        renameMetroArea();
                    };
                    document.getElementById("statMpRegionDistrictSettingDistrictName").style.color = "#2196F3";
                    document.getElementById("statMpRegionDistrictSettingDistrictName").style.textDecoration = "underline";
                    document.getElementById("statMpRegionDistrictSettingDistrictName").style.cursor = "pointer";

                    if(metroAreaName.open == 1) {
                        document.getElementById("statMpRegionDistrictOpenSettingCurrent").innerHTML = "Open";
                        document.getElementById("statMpRegionDistrictOpenSettingCurrent").style.color = "#4CAF50";
                    } else {
                        document.getElementById("statMpRegionDistrictOpenSettingCurrent").innerHTML = "Closed";
                        document.getElementById("statMpRegionDistrictOpenSettingCurrent").style.color = "#f44336";
                    }

                    document.getElementById("statMpRegionDistrictOpenSetting").onclick = function(){
                        var changeSetting = 0;

                        if(metroAreaName.open == 0) {
                            changeSetting = 1;
                        }

                        var data = [];

                        data.push({
                            "key":      "di",
                            "value":    metroAreaId
                        });

                        data.push({
                            "key":      "dop",
                            "value":    changeSetting
                        });

                        postSecuredCallToApi(data,69,function(){
                            metroAreaName.open = changeSetting;
                            updateOverviewStatDisplay();
                            webAppCore.showToast("Success!");
                        });
                    };
                } else {
                    document.getElementById("statMpRegionDistrictOpenSetting").onclick = null;
                    document.getElementById("statMpRegionDistrictSettingDistrictName").onclick = null;
                    document.getElementById("statMpRegionDistrictSettingDistrictOwner").innerHTML = "Area owner: " + metroAreaName.owner;
                }
            }
        }

        
        updateOnlineOfflineStatButtions();

        if(!currentGame.isRegion) {
            document.getElementById("layoutTemplateSection").style.display = "block";
            document.getElementById("layoutTemplateSection").onclick = function() {
                closeStatsMenu();
                showLayoutTemplateMenu();
            };
        } else {
            document.getElementById("layoutTemplateSection").style.display = "none";
        }

        document.getElementById("statOverviewColonyName").innerHTML = currentGame.name;
        document.getElementById("statOverviewColonyName").onclick = function() {
            renameColony();
        };

        document.getElementById("statoverviewcolorection").style.display = "block";
        document.getElementById("statoverviewcolorection").onclick = function() {
            webAppCore.pickColor(onColorBack,roc.themeColor);
        };
        document.getElementById("statOverviewColonialColor").innerHTML = roc.themeColor;
        document.getElementById("statOverviewColonialColor").style.color = roc.themeColor;

        if(roc.offlineMode) {
            document.getElementById("statoverviewwebsitesection").style.display = "none";
            document.getElementById("statOverviewScreenshotSection").style.display = "none";
            document.getElementById("statOverviewColoniae").style.display = "none";
        } else {
            document.getElementById("statoverviewwebsitesection").style.display = "block";
            
            document.getElementById("statOverviewScreenshotSection").style.display = "block";

            document.getElementById("statOverviewColonialWebsite").innerHTML = ColonyGame.meta.colonyServerBase + roc.charter + "/";
            document.getElementById("statoverviewwebsitesection").onclick = function() {
                webAppCore.externalURL(ColonyGame.meta.colonyServerBase + roc.charter + "/");
            };

            var sssrc = "url('" + ColonyGame.meta.colonyServerBase.replace("colonies","screenshots") + "/ss-" + roc.colonyId + ".jpg')";

            document.getElementById("statOverviewScreenshotSection").style.backgroundImage = sssrc;
            document.getElementById("statOverviewScreenshotSection").onclick = function() {
                document.getElementById("statOverviewScreenshotSection").style.backgroundImage = null;

                statsOpen = false;
                staticFrame = false;
                Scroll2d.forceSceneChange();

                setTimeout(function() {
                    Scroll2d.takeScreenshot(onScreenshotForWebsite);
                },500);

                
            };

            document.getElementById("statOverviewColoniae").style.display = "block";

            if(roc.allowColoniae) {
                document.getElementById("statOverviewColoniaeLink").innerHTML = "https://www.coloniae.space/colonies/" + getRegionOrCity().charter;
                document.getElementById("statOverviewColoniaeLink").onclick = function(){
                    webAppCore.externalURL("https://www.coloniae.space/colonies/" + roc.charter);
                };
                document.getElementById("statOverviewColoniaeIndicator").innerHTML = "On";
                document.getElementById("statOverviewColoniaeIndicator").style.color = "#4CAF50";
            } else {
                document.getElementById("statOverviewColoniaeLink").innerHTML = "";
                document.getElementById("statOverviewColoniaeIndicator").innerHTML = "Off";
                document.getElementById("statOverviewColoniaeIndicator").style.color = null;
            }

            document.getElementById("statOverviewColoniaeIndicator").onclick = function(){
                roc.allowColoniae = !roc.allowColoniae;
                updateOverviewStatDisplay();
            };
        }

        if(currentGame.isSubregion && currentSubcityRef) {
            if(!currentSubcityRef.description) {
                currentSubcityRef.description = "";
            }

            document.getElementById("subcityDescriptionInput").value = currentSubcityRef.description;
            document.getElementById("statOverviewSubcityDesc").style.display = "block";
        } else {
            document.getElementById("statOverviewSubcityDesc").style.display = "none";
        }

        var playtime = millisecondsToTimeReadout(currentGame.totalPlayTime);
        document.getElementById("statSectionPlayTimeReadout").innerHTML = playtime;

        document.getElementById("statSectionColonyAgeReadout").innerHTML = currentGame.year + "y " + Math.round(currentGame.period / 5) + "mo";

        if(roc.isIndependent) {
            document.getElementById("statSectionIndependence").style.display = "block";
            document.getElementById("statOverviewIndependence").innerHTML = dateToReadable(roc.independenceDay);
            document.getElementById("statOverviewIndependenceDisclaimer").innerHTML = "From " + roc.motherland;

            if(!roc.offlineMode) {
                document.getElementById("statCharterSection").style.display = "block";
                document.getElementById("statCharterSection").onclick = function() {
                    shareCharter();
                };
                document.getElementById("statOverviewCharter").innerHTML = roc.charter;


                document.getElementById("statCharterPrivacy").style.display = "block";
                document.getElementById("statCharterPrivacy").onclick = function() {
                    roc.privateCharter = !roc.privateCharter;
                    updateColonyStats();
                    updateOverviewStatDisplay();
                };

                if(roc.privateCharter) {
                    document.getElementById("statOverviewCharterPrivacy").innerHTML = getString("general-private");
                    document.getElementById("statOverviewCharterPrivacy").style.color = "#673AB7";
                } else {
                    document.getElementById("statOverviewCharterPrivacy").innerHTML = getString("general-public");
                    document.getElementById("statOverviewCharterPrivacy").style.color = "#2196F3";
                }


            } else {
                document.getElementById("statCharterSection").style.display = "none";
                document.getElementById("statCharterPrivacy").style.display = "none";
            }
        } else {
            document.getElementById("statSectionIndependence").style.display = "none";
            document.getElementById("statCharterSection").style.display = "none";
            document.getElementById("statCharterPrivacy").style.display = "none";
        }

        document.getElementById("statOverviewFounded").innerHTML = dateToReadable(currentGame.creationDate);

        if(roc.offlineMode) {
            document.getElementById("statSectionLocation").style.display = "none";
        } else {
            document.getElementById("statSectionLocation").style.display = "block";
            document.getElementById("statColonyLocatoin").innerHTML = "Sector " + roc.sX + ":" + roc.sY;
            document.getElementById("statColonyLocatoin").onclick = function() {
                webAppCore.externalURL(ColonyGame.meta.colonyServerBase.replace("colonies","map") + roc.charter + ".html");
            };
        }

        document.getElementById("statOverviewMapSize").innerHTML = numberWithCommas(currentGame.width) + "x" + numberWithCommas(currentGame.height);
        document.getElementById("statOverviewMapSizeTotal").innerHTML = numberWithCommas(currentGame.width * currentGame.height);
        
        
    }

    function newGameWithoutCharter(prename) {
        document.getElementById("titleBackdropHold").style.display = "none";

        var width = ColonyGame.meta.mapWidth;
        var height = ColonyGame.meta.mapHeight;
        var resourceMod = 1;

        var colname;

        if(prename) {
            colname = prename;
        } else {
            colname = document.getElementById("newGameColNameInput").value.trim();

            if(colname.length == 0) {
                colname = ColonyGame.meta.name;
            }
        }

        colname = colname.latinize();

        if(document.getElementById("mapSizeSmall").checked) {
            width = Math.round(width * 0.5);
            height = Math.round(height * 0.5);
            resourceMod = 0.5;
        }

        if(document.getElementById("mapSizeLarge").checked) {
            width = Math.round(width * 1.5);
            height = Math.round(height * 1.5);
            resourceMod = 1.5;
        }

        if(document.getElementById("mapSizeXLarge").checked) {
            width = Math.round(width * 2.25);
            height = Math.round(height * 2.25);
            resourceMod = 2.25;
        }

        if(document.getElementById("mapSizeMega").checked) {
            width = Math.round(width * 3);
            height = Math.round(height * 3);
            resourceMod = 3;
        }

        if(document.getElementById("resourcesScarce").checked) {
            resourceMod = resourceMod * 0.5;
        }

        if(document.getElementById("resourcesAbundant").checked) {
            resourceMod = resourceMod * 1.5;
        }

        if(tmpNewGameCustomMapData != null) {
            width = tmpNewGameCustomMapData.width;
            height = tmpNewGameCustomMapData.height;
        }

        createNewGame(colname,width,height,resourceMod);

        document.getElementById("titleBackdropHold").style.display = "none";
        document.getElementById("newGameMenu").style.display = "none";
        document.getElementById("newGameColNameInput").value = "";

        setupMenuOptions();
    }

    var statsOpen = false;
    var newObjectOptionsOpen = false;
    var sidebarTypeFilter = null;

    function closeStatsMenu() {
        document.getElementById("encyclopediaVideoPlayerVidHolderFrame").src = "about:blank";
        document.getElementById("encyclopediaOwnersManualContent").innerHTML = "";
        document.getElementById("statsScreen").style.display = "none";
        document.getElementById("chartScreen").style.display = "none";
        statsOpen = false;

        staticFrame = false;
        Scroll2d.forceSceneChange();
    }

    function closeObjectOptionsMenu() {
        document.getElementById("newObjectOptionsWindow").style.display = "none";
        newObjectOptionsOpen = false;
    }
    
    function linkLayouts() {


        desktopNotificationArea = document.getElementById("desktopNotificationArea");
        notificationArea = document.getElementById("notificationArea");
        desktopNotificationAreaReadout = document.getElementById("desktopNotificationAreaReadout");


        document.getElementById("userProfileWindowAddFriendButton").src = "images/" + ColonyGame.meta.addFriendIndicator;
        document.getElementById("userProfileWindowAddFriendButton").title = getString("gen-add-friend");


        document.getElementById("chartScreenTradeIcon").src = "images/" + ColonyGame.meta.indTrade;
        document.getElementById("chartScreenTradeIcon").title = getString("general-trade");

        document.getElementById("chatInputBoxInput").onkeydown = function(e){
            if(document.getElementById("chatInputBoxHolder").style.display == "block") {
                if(e.key == "Enter" || e.key == "Return") {
                    if(this.value.trim().length > 0) {
                        webAppCore.sendChatMessage(this.value.trim());
                    }

                    document.getElementById("chatInputBoxHolder").style.display = "none";
                }
            }
        };

        document.getElementById("allResourceSearchBox").oninput = function(){
            if(document.getElementById("allResourceSearchHolder").style.display == "block") {
                processResourceSearch(this.value);
            }
        };

        imCityNames = document.getElementById("imCityNames");
        imCityNames.onclick = function() {
            showCityNames = !showCityNames;
        };
        imCityNames.src = "images/" + ColonyGame.meta.renameIndicator;

        templateLayerInd = document.getElementById("templateLayerInd");
        templateLayerInd.onclick = function() {
            templateVisible = !templateVisible;
        };
        templateLayerInd.src = "images/" + ColonyGame.meta.templateLayerInd;

        document.getElementById("subcityDescriptionInput").oninput = function() {
            if(currentGame.isSubregion && currentSubcityRef) {
                currentSubcityRef.description = this.value.trim();
            }
        };

        document.getElementById("btnLeaveFederation").onclick = doLeaveFederationConfirm;
        document.getElementById("userProfileWindowTitleClose").onclick = closeUserProfileWindow;
        document.getElementById("titleBackdropHold").style.backgroundColor = ColonyGame.meta.titleTheme;
        document.getElementById("titleBackdropHold").style.backgroundImage = "url('images/background.jpg')";

        streamingIndicator = document.getElementById("imStreaming");
        streamingIndicator.onclick = function() {

            if(isStreamingLive) {
                turnOffStreaming();

                
            } else {
                webAppCore.showAlertWithTitle(getString("gen-streaming-on"),getString("gen-streaming"));
                turnOnStreaming();
            }

            
        };

        // remove poor performant map sizes on Android 
        if(webAppCore.getPlatform().platform == "android") {
            document.getElementById("mapSizeXLarge").style.display = "none";
            document.getElementById("mapSizeXLargeSpan").style.display = "none";
            document.getElementById("mapSizeMega").style.display = "none";
            document.getElementById("mapSizeMegaSpan").style.display = "none";
        }

        sidebarTypeFilter = document.getElementById("sidebarTypeFilter");
        sidebarTypeFilter.oninput = function() {
            drawSidebar();
        };

        topLeftArea = document.getElementById("topLeftArea");

        document.getElementById("encyclopediaOwnersManualHeaderPrint").onclick = function() {
            confirmBeforePrint();
        };

        document.getElementById("encyclopediaOwnersManualHeaderExport").onclick = function() {
            var printoutRawText = replaceAll(buildOwnersManualTextString(),"&nbsp;"," ");
            webAppCore.exportFile("owners-manual.txt",printoutRawText,false);
        };

        document.getElementById("showFilterItemsAsList").src = "images/" + ColonyGame.meta.indShowBuildList;
        document.getElementById("showFilterItemsAsList").onclick = function() {
            if(currentSidebarListType != null && currentSidebarListingStuff.length > 0) {
                showBuildingConstructionOptions(null,currentSidebarListType,currentSidebarListingStuff);
            }
            hideSidebarIfSmall();
        };

        document.getElementById("btnSaveMapMeta").onclick = function() {
            saveCustomMapMetaData();
            document.getElementById("customMapMetaDataEntry").style.display = "none";

            if(currentFileName == null) {
                currentFileName = cleanFileName(currentGame.mename) + "." + ColonyGame.meta.customMapExtension;
            }

            createMapEditorSideber();
        };

        document.getElementById("textBackupInstruction").innerHTML = getString("text-backup-instruction");

        var statButtons = document.querySelectorAll(".statMenuItem");

        for(var i = 0; i < statButtons.length; i++) {
            statButtons[i].addEventListener("click",onStatButtonClick);
        }

        document.getElementById("imgChainBuildToggleDesktop").src = "images/" + ColonyGame.meta.indChainOn;
        document.getElementById("imgChainBuildToggleDesktop").onclick = function() {
            chainBuildMode = !chainBuildMode;

            if(chainBuildMode) {
                document.getElementById("imgChainBuildToggleDesktop").src = "images/" + ColonyGame.meta.indChainOn;
            } else {
                document.getElementById("imgChainBuildToggleDesktop").src = "images/" + ColonyGame.meta.indChainOff;
            }
        };

        document.getElementById("imgFlipToggleDesktop").src = "images/" + ColonyGame.meta.indFlipBuilding;
        document.getElementById("imgFlipToggleDesktop").onclick = function() {
            flipChainedStructures = !flipChainedStructures;
        };


        // TO BE ADDED
        /*
        document.getElementById("imStreamSettings").src = "images/settings.png";
        document.getElementById("imStreamSettings").onclick = function() {
            console.log("show stream settings");
        };
        */

        document.getElementById("imStreamToggleCamera").src = "images/" + ColonyGame.meta.webcamOffIndicator;
        document.getElementById("imStreamToggleCamera").onclick = function() {
            var streamVid = false;

            var vidDef = webAppCore.getVar("stream-video-def","1");
    
            if(vidDef && vidDef == "1") {
                streamVid = true;
            }

            streamVid = !streamVid;

            if(streamVid) {
                webAppCore.storeVar("stream-video-def","1");
            } else {
                webAppCore.storeVar("stream-video-def","0");
            }
            
            if(isStreamingLive) {
                webAppCore.setStreamWebcam(streamVid);
            }

            updateStreamIndicatorStatusIcons();
        };

        document.getElementById("imStreamToggleMic").src = "images/" + ColonyGame.meta.micOffIndicator;
        document.getElementById("imStreamToggleMic").onclick = function() {

            var streamAud = false;

            var audDef = webAppCore.getVar("stream-audio-def","1");

            if(audDef && audDef == "1") {
                streamAud = true;
            }

            streamAud = !streamAud;

            if(streamAud) {
                webAppCore.storeVar("stream-audio-def","1");
            } else {
                webAppCore.storeVar("stream-audio-def","0");
            }
            
            if(isStreamingLive) {
                webAppCore.setStreamAudio(streamAud);
            }

            updateStreamIndicatorStatusIcons();
        };
        
        document.getElementById("imStreamViewersIndicator").src = "images/" + ColonyGame.meta.streamViewersInd;
        document.getElementById("objectBuildIcon").src = "images/" + ColonyGame.meta.showBuildSidebarIcon;
        document.getElementById("objectExportIcon").src = "images/" + ColonyGame.meta.indExportGoods;
        document.getElementById("objectImportIcon").src = "images/" + ColonyGame.meta.indImportGoods;
        document.getElementById("objectUpgradeIcon").src = "images/" + ColonyGame.meta.indUpgrade;
        document.getElementById("objectMoveIcon").src = "images/" + ColonyGame.meta.indMove;
        document.getElementById("objectHarvestIcon").src = "images/" + ColonyGame.meta.indHarvest;
        document.getElementById("objectParkIcon").src = "images/" + ColonyGame.meta.indPark;

        if(ColonyGame.utilities && ColonyGame.utilities.length > 0) {
            document.getElementById("statsIconUtilities").src = "images/" + ColonyGame.meta.utilitiesInd;
        } else {
            document.getElementById("statsUtilities").style.display = "none";
        }

        document.getElementById("statsIconGameData").src = "images/" + ColonyGame.meta.gameDataIndicator;
        document.getElementById("statIconEncyclopedia").src = "images/" + ColonyGame.meta.encyclopediaIndicator;
        document.getElementById("statIconFederation").src = "images/" + ColonyGame.meta.federationsIndicator;
        document.getElementById("statIconCommonwealth").src = "images/" + ColonyGame.meta.empireIndicator;
        document.getElementById("statIconDiplomacy").src = "images/" + ColonyGame.meta.diplomacyIndicator;
        document.getElementById("statIconFriends").src = "images/" + ColonyGame.meta.friendIndicator;

        document.getElementById("objectCloneIcon").src = "images/" + ColonyGame.meta.indCloneObject;
        document.getElementById("objectCloneIcon").title = getString("general-clone");

        document.getElementById("objectUngroupIcon").src = "images/" + ColonyGame.meta.ungroupUnitsIndicator;
        document.getElementById("objectUngroupIcon").title = getString("gen-ungroup-units");

        document.getElementById("objectGroupIcon").src = "images/" + ColonyGame.meta.groupUnitsIndicator;
        document.getElementById("objectGroupIcon").title = getString("gen-group-units");

        document.getElementById("objectStatsIcon").src = "images/" + ColonyGame.meta.indStats;
        document.getElementById("objectStatsIcon").title = getString("general-statistics");

        document.getElementById("objectDismissIcon").src = "images/" + ColonyGame.meta.indDismiss;
        document.getElementById("objectDismissIcon").title = getString("general-dismiss");

        document.getElementById("objectRepairIcon").src = "images/" + ColonyGame.meta.indRepair;
        document.getElementById("objectRepairIcon").title = getString("general-repair");
        

        document.getElementById("objectTradeIcon").src = "images/" + ColonyGame.meta.indTrade;
        document.getElementById("objectTradeIcon").title = getString("general-trade");

        document.getElementById("objectDestroyIcon").src = "images/" + ColonyGame.meta.indDestroy;
        document.getElementById("objectDestroyIcon").title = getString("general-destroy");

        document.getElementById("objectDestructIcon").src = "images/" + ColonyGame.meta.indDestruct;
        document.getElementById("objectDestructIcon").title = getString("general-destruct");


        document.getElementById("objectFlipIcon").src = "images/" + ColonyGame.meta.indFlipBuilding;
        

        document.getElementById("objectDeployLoadedIcon").src = "images/" + ColonyGame.meta.indDeployLoaded;
        document.getElementById("objectDeployLoadedIcon").title = getString("general-deploy-loaded");

        document.getElementById("objectMakeCenterIcon").src = "images/" + ColonyGame.meta.indMakeCenter;
        document.getElementById("objectMakeCenterIcon").title = getString("general-make-center");


        document.getElementById("objectCommunicationsIcon").src = "images/" + ColonyGame.meta.mailIndicator;
        document.getElementById("objectCommunicationsIcon").title = getString("comms-general");


        document.getElementById("statIconFlag").src = "images/" + ColonyGame.meta.flagIndicator;
        document.getElementById("statIconOverview").src = "images/" + ColonyGame.meta.websiteIndicator;
        document.getElementById("statIconPopulation").src = "images/" + ColonyGame.meta.totalWorkforceInd;
        document.getElementById("statIconGovernment").src = "images/" + ColonyGame.meta.empireIndicator;
        document.getElementById("statIconEconomy").src = "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon;
        document.getElementById("statIconResources").src = "images/" + ColonyGame.meta.resourcesInd;

        

        document.getElementById("helpfulTipsDismiss").addEventListener("click",function() {
            closeTipsPopup();
        });

        document.getElementById("statsMenuClose").addEventListener("click",function() {
            closeStatsMenu();
        });

        document.getElementById("tradeMenuClose").addEventListener("click",function() {
            closeGBT();
        });


        document.getElementById("colonyClose").addEventListener("click",function() {
            closeColonyWindow();
        });

        document.getElementById("objectMenuClose").addEventListener("click",function() {
            closeObjectOptionsMenu();
        });

        document.getElementById("leaveExportScreen").addEventListener("click",function() {

            document.getElementById("textBackupScreen").style.display = "none";
            document.getElementById("exportText").innerHTML = "";

            bulldozerMode = false;

            webAppCore.handleBackFunction(null);
            webAppCore.setTitleVisible(true);
            titleShowing = true;
        });


        document.getElementById("objectDiplomacyIcon").title = getString("diplomacy-general");
        document.getElementById("objectDiplomacyIcon").src = "images/" + ColonyGame.meta.diplomacyIndicator;

        document.getElementById("objectCommonwealthIcon").title = getString("empire-general");
        document.getElementById("objectCommonwealthIcon").src = "images/" + ColonyGame.meta.empireIndicator;
        document.getElementById("objectCommonwealthIcon").addEventListener("click",function() {
            document.getElementById("objectOptions").style.display = "none";
            showColonistsMenu("commonwealth");
        });

        document.getElementById("objectPolicyIcon").title = getString("general-policy");
        document.getElementById("objectPolicyIcon").src = "images/" + ColonyGame.meta.indPolicy;
        document.getElementById("objectPolicyIcon").addEventListener("click",function() {
            document.getElementById("objectOptions").style.display = "none";
            showPolicyMenu();
        });


        document.getElementById("btnNoNewGame").addEventListener("click",function() {
            document.getElementById("newGameMenu").style.display = "none";
            document.getElementById("titleBackdropHold").style.display = "none";
            showHiders();
            bulldozerMode = false;
            titleShowing = true;
            webAppCore.setTitleVisible(true);
            webAppCore.handleBackFunction(null);
        });

        document.getElementById("filterArea").addEventListener("change",function(e) {
            selectedBuildCategory = e.target.value;
            drawSidebar();
        });

        document.getElementById("btnBewGame").addEventListener("click",function() {

            if(document.getElementById("mapSizeLarge").checked || document.getElementById("mapSizeXLarge").checked || document.getElementById("mapSizeMega").checked) {
                webAppCore.showDialog({
                    title: getString("large-map-warn-header"),
                    message: getString("large-map-warn-desc"),
                    op1: {
                        text: getString("general-yes"),
                        func: newGameWithoutCharter,
                        color: "#f44336"
                    },
                    op2: {
                        text: getString("general-no"),
                        func: placeholder
                    }
                });
            } else {
                newGameWithoutCharter();
            }

        });

        document.getElementById("btnZoomIn").src = "images/" + ColonyGame.meta.zoomInIcon;
        document.getElementById("btnZoomIn").addEventListener("click",function() {
            if(zoomLevel < 2.6) {
                zoomLevel += 0.4;
                Scroll2d.setZoomLevel(zoomLevel / renderScaleFactor);
            }
        });

        document.getElementById("btnZoomOut").src = "images/" + ColonyGame.meta.zoomOutIcon;
        document.getElementById("btnZoomOut").addEventListener("click",function() {
            if(zoomLevel > 0.2) {
                zoomLevel -= 0.4;
                Scroll2d.setZoomLevel(zoomLevel / renderScaleFactor);
            }
        });

        var zoomOption = webAppCore.getVar("zoom-buttons","0");
        if(zoomOption == "0") {
            showZoomButtons = false;
            document.getElementById("zoomButtons").style.display = "none";
        } else {
            showZoomButtons = true;
            document.getElementById("zoomButtons").style.display = "inline-block";
        }

        document.getElementById("imMail").src = "images/" + ColonyGame.meta.mailIndicator;
        document.getElementById("imMail").addEventListener("click",function() {
            showMail();
        });
        document.getElementById("imMail").style.display = "none";

        document.getElementById("colonySendGift").src = "images/" + ColonyGame.meta.giftIndicator;
        document.getElementById("colonySendMessage").src = "images/" + ColonyGame.meta.mailIndicator;
        document.getElementById("colonyViewWebsite").src = "images/" + ColonyGame.meta.websiteIndicator;
        document.getElementById("colonyCoinShower").src = "images/" + ColonyGame.meta.moneyShowerInd;
        document.getElementById("colonyNukeCharter").src = "images/" + ColonyGame.meta.rescindInd;
        document.getElementById("colonyTribute").src = "images/" + ColonyGame.meta.taxCollectionInd;
        document.getElementById("colonyDenounce").src = "images/" + ColonyGame.meta.denounceInd;
        document.getElementById("colonyInspect").src = "images/" + ColonyGame.meta.visitInd;
        document.getElementById("colonyEstablishEmbassy").src = "images/" + ColonyGame.meta.diplomacyIndicator;

        document.getElementById("imDiplomacy").src = "images/" + ColonyGame.meta.diplomacyIndicator;
        document.getElementById("imDiplomacy").addEventListener("click",function() {
            showPendingEmbassyRequests();
        });
        document.getElementById("imDiplomacy").style.display = "none";

        document.getElementById("imClearNotifications").src = "images/" + ColonyGame.meta.indDismiss;
        document.getElementById("imClearNotifications").onclick = function(){
            desktopNotificationAreaReadout.innerHTML = "";
            document.getElementById("imClearNotifications").style.display = "none";
        };
        document.getElementById("imClearNotifications").style.display = "none";

        document.getElementById("imFriends").src = "images/" + ColonyGame.meta.addFriendIndicator;
        document.getElementById("imFriends").addEventListener("click",function() {
            showColonistsMenu("friends");
        });

        if(ColonyGame.meta.onlineChatPrefix != null) {
            document.getElementById("imChat").src = "images/" + ColonyGame.meta.onlineChatIcon;
            document.getElementById("imChat").addEventListener("click",function() {

                if(webAppCore.isChatOpen()) {
                    webAppCore.closeChat();

                    return;
                }

                if(!webAppCore.isApeAppsLoggedIn()) {
                    document.getElementById("imChat").style.display = "none";
                    return;
                }

                if(!getRegionOrCity()) {
                    document.getElementById("imChat").style.display = "none";
                    return;
                }

                if(getRegionOrCity().offlineMode && !ColonyGame.meta.globalChatChannel) {

                    document.getElementById("imChat").style.display = "none";
                    return;
                }

                if(webAppCore.isTV()) {
                    document.getElementById("imChat").style.display = "none";
                    return;
                }

                if(webAppCore.getPlatform().market == "kongregate") {
                    document.getElementById("imChat").style.display = "none";
                    return;
                }

                loadChat(false);
            });
        }
        
        document.getElementById("imChat").style.display = "none";



        document.getElementById("imGift").src = "images/" + ColonyGame.meta.giftIndicator;
        document.getElementById("imGift").addEventListener("click",function() {
            this.style.display = "none";
            showGifts();
        });
        document.getElementById("imGift").style.display = "none";



        document.getElementById("imIdleBuilder").src = "images/" + ColonyGame.meta.findBuilderIcon;
        document.getElementById("imIdleBuilder").addEventListener("click",function() {
            selectIdleBuilder();
        });

        document.getElementById("imBulldozer").src = "images/" + ColonyGame.meta.bulldozerToolIndicator;
        document.getElementById("imBulldozer").addEventListener("click",function() {
            bulldozerMode = !bulldozerMode;
        });

        document.getElementById("imTechTree").src = "images/" + ColonyGame.meta.techWindowIcon;
        document.getElementById("imTechTree").addEventListener("click",function() {
            showTechWindow();
        });

        setCenterMapIcon(); 
        document.getElementById("imCenterMap").addEventListener("click",function() {
            if(currentGame) {
                defaultOutZoomLevel();
    
                centerMap();
            }
            
        });

        document.getElementById("showSidebarToggle").src = "images/" + ColonyGame.meta.showBuildSidebarIcon;
        document.getElementById("showSidebarToggle").addEventListener("click",function() {

            if(!currentGame || currentGame.readOnlyMode) {
                return;
            }

            document.getElementById("sidebar").style.display = "block";
        });

        if(ColonyGame.meta.sidebarBackgroundImage && ColonyGame.meta.sidebarBackgroundImage != null) {
            document.getElementById("sidebar").style.backgroundImage = "url('images/" + ColonyGame.meta.sidebarBackgroundImage + "')";
        }

        document.getElementById("imTransparency").src = "images/" + ColonyGame.meta.transModeIcon;
        document.getElementById("imTransparency").addEventListener("click",function() {

            //selectDisplayMode();

            transparencyMode++;

            if(transparencyMode >= 3) {
                transparencyMode = 0;
            }

            staticFrame = false;
            Scroll2d.forceSceneChange();
        });
        document.getElementById("imTransparency").oncontextmenu = function(e){
            e.preventDefault();
            selectDisplayMode();
        };

        document.getElementById("hireWorkerCancel").addEventListener("click",function() {
            document.getElementById("hireWorkerConfirm").style.display = "none";
            selectedBuilding = null;
            selectedVehicle = [];
            selectedColonist = null;
            pendingBuildX = null;
            pendingBuildY = null;

            clearOutBuildMenu();
        },false);

        document.getElementById("btnDismissConstruction").addEventListener("click",function() {
            document.getElementById("constructionMenu").style.display = "none";
            selectedBuilding = null;
            selectedVehicle = [];
            selectedColonist = null;
            pendingBuildX = null;
            pendingBuildY = null;

            clearOutBuildMenu();
        },false);

        document.getElementById("btnDismissChart").addEventListener("click",function() {
            document.getElementById("chartScreen").style.display = "none";
            selectedBuilding = null;
            selectedVehicle = [];
            selectedColonist = null;
            pendingBuildX = null;
            pendingBuildY = null;

            clearOutBuildMenu();
            updateResourceStatDisplay();
        },false);
        
        document.getElementById("objectDismissIcon").addEventListener("click",function() {
            document.getElementById("objectOptions").style.display = "none";
            selectedBuilding = null;
            selectedVehicle = [];
            selectedColonist = null;
            queuedBuilding = null;
            queuedMove = null;
            pendingBuildX = null;
            pendingBuildY = null;
            queuedPark = null;

            clearOutBuildMenu();
        },false);
        
        document.getElementById("tbcCancel").addEventListener("click",function() {

            dismissBuildConfirm();
        },false);

        document.getElementById("tbcDesktopCancel").src = "images/" + ColonyGame.meta.indDismiss;
        document.getElementById("tbcDesktopCancel").title = getString("general-cancel");
        document.getElementById("tbcDesktopCancel").addEventListener("click",function() {
            
            dismissBuildConfirm();
        },false);
        
        
        document.getElementById("tbcConfirm").addEventListener("click",function() {

            touchPossibleBuildPoints = [];

            document.getElementById("touchBuildConfirm").style.display = "none";
            document.getElementById("gamepadBuildConfirm").style.display = "none";
            document.getElementById("desktopBuildConfirm").style.display = "none";

            engageBuildingQueue();
            
            selectedBuilding = null;
            selectedVehicle = [];
            selectedColonist = null;
            queuedBuilding = null;
            queuedMove = null;
            pendingBuildX = null;
            pendingBuildY = null;
            queuedPark = null;

            clearOutBuildMenu();
        },false);

        document.getElementById("tbcDesktopConfirm").src = "images/" + ColonyGame.meta.indCheckbox;
        document.getElementById("tbcDesktopConfirm").title = getString("general-confirm");
        document.getElementById("tbcDesktopConfirm").addEventListener("click",function() {
            
            touchPossibleBuildPoints = [];

            document.getElementById("touchBuildConfirm").style.display = "none";
            document.getElementById("gamepadBuildConfirm").style.display = "none";
            document.getElementById("desktopBuildConfirm").style.display = "none";

            engageBuildingQueue();
            
            selectedBuilding = null;
            selectedVehicle = [];
            selectedColonist = null;
            queuedBuilding = null;
            queuedMove = null;
            pendingBuildX = null;
            pendingBuildY = null;
            queuedPark = null;
            flipChainedStructures = false;

            clearOutBuildMenu();
        },false);

        moneyReadout = document.getElementById("moneyReadout");
        moneyReadout.addEventListener("click",function() {
            changeResourceDisplayMode();
        },false);
        
        document.getElementById("imSettings").addEventListener("click",function() {
            clearOutBuildMenu();
            webAppCore.toggleMenu();
        },false);
        
        document.getElementById("objectSelIcon").style.display = "none";
        document.getElementById("objectRename").style.display = "none";
    }

    function onStatButtonClick() {
        document.getElementById("chartScreen").style.display = "none";
        showColonistsMenu(this.dataset.statsection);
    }
    
    function setupMenuOptions() {

        webAppCore.clearMenu();

        if(titleShowing) {

            if(!webAppCore.isTV()) {
                webAppCore.addMenuOption(getString("side-menu-game-data"),"wacMenuOptionSelected","previewlink",null,"gamedata");
            }

            if(webAppCore.getInterface() != "ios") {
                if (ColonyGame.meta.betaInfo != null) {
                    webAppCore.addMenuOption("Beta Info","wacMenuOptionSelected","help",null,"betainfo");
                }
            }

            if(ColonyGame.meta.releaseNotesServer != null) {
                webAppCore.addMenuOption("Release Notes","wacMenuOptionSelected","showresults",null,"releasenotes");
            }

            if(webAppCore.isTV() || (webAppCore.getPlatform().platform == "android" && webAppCore.getPlatform().market  == "amazon")) {
                // dont do it
            } else {
                if(ColonyGame.meta.podcastURL != null && ColonyGame.meta.podcastName != null) {
                    webAppCore.addMenuOption(ColonyGame.meta.podcastName,"wacMenuOptionSelected","microphone",null,"podcast");
                }
            }

            var hasAchievements = false;

            for(var prop in ColonyGame.achievements) {
                if(ColonyGame.achievements[prop] != null) {
                    hasAchievements = true;
                    break;
                }
            }

            if(hasAchievements) {
                webAppCore.addMenuOption("Achievements","wacMenuOptionSelected","emoji",null,"achievements");
            }

            if(!webAppCore.isTV()) {
            

                if (ColonyGame.meta.feedbackUrl != null) {
                    webAppCore.addMenuOption("Send Feedback","wacMenuOptionSelected","send",null,"feedback");
                }

                if(webAppCore.getPlatform().platform == "ios") {
                    webAppCore.addMenuOption("Modding","wacMenuOptionSelected","",null,"modding");
                } else {
                    webAppCore.addMenuOption("Modding","wacMenuOptionSelected","personalize",null,"modding");
                }
            }

            if(ColonyGame.externalLink && ColonyGame.externalLink.name && webAppCore.getPlatform().market != "steam" && webAppCore.getPlatform().market != "kongregate") {
                if(!webAppCore.isTV()) {
                    webAppCore.addMenuOption(ColonyGame.externalLink.name,"wacMenuOptionSelected","images/" + ColonyGame.externalLink.icon,null,"externallink",null,true);
                }
            }
        } else {
            
            if(currentGame && currentGame.isSubregion) {
                webAppCore.addMenuOption("Return to Region","wacMenuOptionSelected","back",null,"saveandquit");
            } else {
                if(returnToFileName == null) {
                    webAppCore.addMenuOption("Return to Title","wacMenuOptionSelected","back",null,"saveandquit");
                } else {
                    webAppCore.addMenuOption("Return to Colony","wacMenuOptionSelected","back",null,"saveandquit");
                }
            }
            

            if(currentGame && !currentGame.readOnlyMode && !currentGame.isMpRegionHolder) {

                var saveText = "Save Colony";

                if(currentGame.mem) {
                    saveText = "Save Map";
                }

                webAppCore.addMenuOption(saveText,"wacMenuOptionSelected","save",null,"save");


                if(!currentGame.mem && !currentGame.isMpRegionHolder) {
                    if(webAppCore.isTV() || gamepadInUse) {
                        webAppCore.addMenuOption("Technology","wacMenuOptionSelected","library","#9C27B0","technology");
                    }
    
    
                    webAppCore.addMenuOption(getString("general-statistics"),"wacMenuOptionSelected","fourbars",null,"colonists");

                    if(!currentGame.isRegion && getRegionOrCity().governmentLevel > 0) {
                        webAppCore.addMenuOption(getString("general-policy"),"wacMenuOptionSelected","gavel",null,"policy");
                    }
                }

                
            }

            if(currentGame && currentGame.isMpRegionHolder) {
                webAppCore.addMenuOption(getString("share-region-charter"),"wacMenuOptionSelected","share",null,"regioncharter");
            }

            if(currentGame && currentGame.mem) {
                webAppCore.addMenuOption("Export","wacMenuOptionSelected","savelocal",null,"export");
                webAppCore.addMenuOption(getString("general-map-meta"),"wacMenuOptionSelected","accounts",null,"mapmeta");
            }

            if(!webAppCore.isTV() && !gamepadInUse && currentGame != null && !currentGame.mem) {
                webAppCore.addMenuOption("Take a Picture","wacMenuOptionSelected","camera",null,"picture");
            }
        }

        if (ColonyGame.meta.communityUrl != null && !webAppCore.isTV()) {
            
            if(webAppCore.getPlatform().platform == "android" && webAppCore.getPlatform().market  == "amazon") {
                // dont do it
            } else {
                webAppCore.addMenuOption(getString("support-community"),"wacMenuOptionSelected","people",null,"community");
            }

        }

        if(currentGame) {
            webAppCore.addMenuOption(getString("general-encyclopedia"),"wacMenuOptionSelected","library",null,"encyclopedia");
        }

        if(!currentGame || (currentGame && !currentGame.mem)) {
           
            
            webAppCore.addMenuOption("Engine Settings","wacMenuOptionSelected","settings",null,"settings");
        }
  
    }

    var tmpExportAfterSave = false;

    function onMenuOptionSelected(name,tag) {

        cooldownGamepad();
        clearOutBuildMenu();

        if(tag == "policy") {
            showPolicyMenu();
        }

        if(tag == "regioncharter" && currentGame && currentGame.isMpRegionHolder) {
            showShareRegionCharter();
        }

        if(tag == "externallink") {
            if(!ColonyGame.externalLink) {
                return;
            }

            var useURL = ColonyGame.externalLink.default;

            var plat = webAppCore.getPlatform();

            if(plat.platform == "android" && plat.market == "gplay") {
                if(ColonyGame.externalLink.gplay) {
                    useURL = ColonyGame.externalLink.gplay;
                }
            }

            if(plat.platform == "android" && plat.market == "amazon") {
                if(ColonyGame.externalLink.amazon) {
                    useURL = ColonyGame.externalLink.amazon;
                }
            }

            if(plat.platform == "windows") {
                if(ColonyGame.externalLink.windows) {
                    useURL = ColonyGame.externalLink.windows;
                }
            }

            if(plat.platform == "ios") {
                if(ColonyGame.externalLink.itunes) {
                    useURL = ColonyGame.externalLink.itunes;
                }
            }

            webAppCore.externalURL(useURL);
        }

        if(tag == "modding") {
            showModdingMenu();
        }

        if(tag == "export") {
            tmpExportAfterSave = true;
            
            generalSaveGameWithDialog(function(){
                saveCustomMapFile();
            });
        }

        if(tag == "releasenotes") {
            fetchReleaseNotes();
        }

        if(tag == "mapmeta") {
            editCustomMapMetaData();
        }

        if(tag == "podcast") {
            webAppCore.externalURL(ColonyGame.meta.podcastURL);
        }

        if(tag == "achievements") {
            webAppCore.showAchievements();
        }

        if(tag == "encyclopedia") {
            showColonistsMenu("encyclopedia");
        }

        if(tag == "picture") {
            Scroll2d.takeScreenshot(onScreenshotTaken);
        }

        if(tag == "technology") {
            if(currentGame.readOnlyMode) {
                return;
            }

            showTechWindow();
        }

        if(tag == "gamedata") {
            presentGameData();
        }

        if(tag == "colonists") {
            showColonistsMenu();

            if(gamepadInUse) {
                highlightActiveStatSection();
            }
        }

        if(tag == "betainfo") {
            webAppCore.showAlertWithTitle(getString(ColonyGame.meta.betaInfo),"Beta Information");
        }
        
        if(tag == "feedback") {
            webAppCore.externalURL(ColonyGame.meta.feedbackUrl);
        }
        
        if(tag == "community") {
            webAppCore.externalURL(ColonyGame.meta.communityUrl);
        }
        
        if(tag == "new") {
            generalSaveGameWithDialog();
            newGame();
        }
        
        if(tag == "save") {
            generalSaveGameWithDialog();
        }

        if(tag == "saveandquit") {
            autoloadSubcityAfterSave = null;
            standardSaveAndQuitRoutine();

            
        }

        if(tag == "settings") {
            showEngineSettings();
        }

    }

    var backToRegionAfter = false;

    function standardBack() {

        if(!currentGame) {
            showTitle();
            return;
        }

        var somethingOpen = closeSomethingIfOpen();

        if(somethingOpen) {
            hideSidebarIfSmall();
            return;
        }
        
        autoloadSubcityAfterSave = null;
        standardSaveAndQuitRoutine();
    }

    function standardSaveAndQuitRoutine() {
        currentTemplate = null;
        templateVisible = false;

        if(!currentGame) {
            showTitle();
        } else {
            leaveLocalNetwork();

            if(currentGame.isSubregion) {
                backToRegionAfter = true;

                if(isStreamingLive) {
                    shutDownStreamsForSwitch(true);
                }
            } else {
                backToRegionAfter = false;
                saveAndQuitting = true;
                autoloadSubcityAfterSave = null;

                if(isStreamingLive) {
                    turnOffStreaming();
                }


                if(usingSockets) {
                    var sndMsg = {
                        "destination": "streaming-" + getRegionOrCity().colonyId,
                        "msg": {
                            "type": "streaming",
                            "code": "iamgoingoffline",
                            "streaming": isStreamingLive
                        }
                    };
            
                    webAppCore.socketEmit("gamemessage",sndMsg);
                }
            }

            

            if(currentGame.offlineMode) {
                generalSaveGameWithDialog(function(){
                    if(backToRegionAfter) {
                        currentTemplate = null;
                        templateVisible = false;
                        Scroll2d.renderFullMap(onFullMapBeforeCloseBack);
                        returnToFileName = null;
                        killSwitch = false;
                    } else {
                        currentTemplate = null;
                        templateVisible = false;
                        currentGame = null;
                        openJobsArray = [];
                        curRegPreviewWorkQueue = [];
                        curRegPreviewWorkItem = null;
                        lastColorFilter = null;
                        currentJobOpprotunities = [];
                        curRegRiverTemplateCanvas = null;
                        curRegRiverTemplateContext = null;
                        opprotunityRecycleBox = [];
                        currentRegion = null;
                        currentSubcityRef = null;
                        retainedPaths = {};
                        pendingAutosales = [];
                        retainedUsage = {};
                        retainedPathsCounter = 0;
                        shouldUpdateCollissionMap = true;
                        showTitle();
                    }
                });
            } else {
                webAppCore.showSplash("Updating stats...");

                updateColonyStats(false,function(){
                    generalSaveGameWithDialog(function(){
                        if(backToRegionAfter) {
                            currentTemplate = null;
                            templateVisible = false;
                            Scroll2d.renderFullMap(onFullMapBeforeCloseBack);
                            returnToFileName = null;
                            killSwitch = false;
                        } else {
                            currentGame = null;
                            openJobsArray = [];
                            lastColorFilter = null;
                            curRegPreviewWorkQueue = [];
                            currentJobOpprotunities = [];
                            curRegPreviewWorkItem = null;
                            curRegRiverTemplateCanvas = null;
                            curRegRiverTemplateContext = null;
                            opprotunityRecycleBox = [];
                            currentTemplate = null;
                            templateVisible = false;
                            currentRegion = null;
                            currentSubcityRef = null;
                            retainedPaths = {};
                            pendingAutosales = [];
                            retainedUsage = {};
                            retainedPathsCounter = 0;
                            shouldUpdateCollissionMap = true;
                            showTitle();
                        }
                    },true);
                });
            }
      
        }
    }

    var tmpSSCanvas;

    function onScreenshotTaken(canvas) {

        if(!canvas) {
            return;
        }

        tmpSSCanvas = canvas;
        document.body.appendChild(tmpSSCanvas);
        webAppCore.sendImage(tmpSSCanvas);

        setTimeout(function() {
            document.body.removeChild(tmpSSCanvas);
        },1000);
    }

    var listingType;

    var tmpListingData = null;

    function showOpenGameListing(listing) {

        tmpListingData = listing;

        setTimeout(produceListingData,500);
    }
    
    function produceListingData() {

        if(tmpListingData == null) {
            return;
        }

        var listing = tmpListingData;

        var menuOptions = [];
        savedGameListing = [];

        var callback;
        var title;

        if(listingType == "load") {
            callback = onSaveGameSelected;
            title = getString("general-load");
        }

        if(listingType == "export") {
            callback = onExportFileSelected;
            title = "Export File";
        }

        if(listingType == "delete") {
            callback = confirmDelete;
            title = "Delete Files";
        }

        if(listingType == "textbackup") {
            callback = onTextBackupFileSelected;
            title = "Text Backup";
        }

        var i;

        if(listingType == "load" && webAppCore.isApeAppsLoggedIn() && webAppCore.getIsPremium() && userMultiplayerRegions) {
            for(i = 0; i < userMultiplayerRegions.length; i++) {
                var mpr = userMultiplayerRegions[i];

                menuOptions.push({
                    "title": mpr.colonyname,
                    "title-color": null,
                    "description": null,
                    "status": getString("mp-region"),
                    "status-color": null,
                    "icon": "images/" + ColonyGame.meta.mpRegionInd,
                    "tag": "##mp-r##" + mpr.charter
                });
            }
            
        }
        
        for (i = 0; i < listing.length; i++) {

            savedGameListing.push(listing[i]);

            if(endsWith(listing[i],"." + ColonyGame.meta.fileExtension)) {

                if(listingType == "load") {
                    var displayName = webAppCore.getVar("mc-ref-name-" + listing[i],listing[i]);
                    var displayPopulation = webAppCore.getVar("mc-ref-pop-" + listing[i],0);
                    var displayOnlineMode = webAppCore.getVar("mc-ref-online-" + listing[i],-1);
                    var displayOnlineType = webAppCore.getVar("mc-ref-type-" + listing[i],"none");
                    var displayOnlineRace = webAppCore.getVar("mc-ref-race-" + listing[i],"none");

                    var useIcon = "images/" + ColonyGame.meta.fileTypeIcon;

                    if(displayOnlineType && displayOnlineType != "none") {
                        var pdef = getPlanetDefByName(displayOnlineType);

                        if(pdef) {
                            useIcon = "images/" + pdef.icon;
                        }
                    }

                    var populationIcon = "images/" + ColonyGame.meta.colonistIcon;

                    if(displayOnlineRace != "none") {
                        // at some point here, add a race
                        // indicator item to the game file
                        // and use it for this load screen
                        // and on the population readout
                        // in-game
                    }

                    if(displayName == listing[i]) {
                        menuOptions.push({
                            "title": listing[i],
                            "title-color": null,
                            "description": null,
                            "status": ColonyGame.meta.name + " Save",
                            "status-color": null,
                            "icon": useIcon,
                            "tag": listing[i]
                        });
                    } else {

                        var menuData = {
                            "title": displayName,
                            "title-color": null,
                            "description": null,
                            "status": listing[i],
                            "status-color": null,
                            "icon": useIcon,
                            "tag": listing[i],
                            "overflow": [
                                {
                                    pre:    "Population: ",
                                    post:   numberWithCommas(parseInt(displayPopulation)),
                                    color:  null,
                                    icon:   populationIcon
                                }
                            ]
                        };

                        if(displayOnlineMode != -1) {
                            if(displayOnlineMode == "1") {
                                menuData.overflow.push({
                                    pre:    null,
                                    post:   "Online Game",
                                    color:  "#4CAF50",
                                    icon:   "images/" + ColonyGame.meta.onlineModeInd
                                });
                            } else {
                                menuData.overflow.push({
                                    pre:    null,
                                    post:   getString("gen-local-mode"),
                                    color:  "#2196F3",
                                    icon:   "images/" + ColonyGame.meta.offlineModeInd
                                });
                            }
                        }

                        menuOptions.push(menuData);
                    }

                } else {
                    menuOptions.push({
                        "title": listing[i],
                        "title-color": null,
                        "description": null,
                        "status": ColonyGame.meta.name + " Save",
                        "status-color": null,
                        "icon": null,
                        "tag": listing[i]
                    });
                }

            }

            if(listingType == "delete") {
                if(endsWith(listing[i],"." + ColonyGame.meta.backupExtension)) {
                    menuOptions.push({
                        "title": listing[i],
                        "title-color": null,
                        "description": null,
                        "status": ColonyGame.meta.name + " Recovery File",
                        "status-color": "#FF9800",
                        "icon": null,
                        "tag": listing[i]
                    });
                }
            }

        }
        
        if(menuOptions.length == 0) {
            webAppCore.showAlertWithTitle("There are no saved games!","No saves");
            return;
        }

        tmpListingData = null;
        
        showList(title,menuOptions,callback,getString("general-nevermind"));
    }
    
    function onSaveGameSelected(tag) {
        if(!tag) {
            return;
        }


        

        openGame(tag);
    }
    
    function endsWith(str, suffix) {

        if(!str || !suffix) {
            return false;
        }

        return str.indexOf(suffix, str.length - suffix.length) !== -1;
    }

    function loadAssets() {

        saveModData();

        textureManager.initAssets();

        showTitle();
    }

    function saveModData() {
        var activeModsString = "";

        for(var i = 0; i < currentActiveTextureMod.length; i++) {
            if(i > 0) {
                activeModsString += ",";
            }

            activeModsString += currentActiveTextureMod[i];
        }

        if(activeModsString == "") {
            activeModsString = "0";
        }

        webAppCore.storeVar("active-texture-mod",activeModsString);
    }

    function getImageAsset(name,flipped,frame,color,useTileWidth,outlineWidth,outlineColor) {

        if(!name) {
            return null;
        }

        var useImg = name;
        var tw = ColonyGame.meta.gridSize;
        var withData = null;

        if(useTileWidth) {
            tw = useTileWidth;
        }

        if(name.indexOf("http:") != 0 && name.indexOf("https:") != 0 && name.indexOf("data:") != 0) {
            var tiledef = getImageDefByName(name);

            if(!tiledef) {
                return null;
            }

            tw = tiledef.tileWidth;
            useImg = tiledef.image;

            if(useTileWidth) {
                tw = useTileWidth;
            }

            // check for mod 
            var mod = getModImage(name);

            if(mod) {
                withData = mod;
            }
        } else {
            if(name.indexOf("tokens.ape-apps.com") > -1) {
                tw = Math.ceil(ColonyGame.meta.gridSize * tokenScale);
            }
        }

        if(!color) {
            if(currentGame) {
                var roc = getRegionOrCity();

                if(roc) {
                    color = roc.themeColor;
                } else {
                    color = ColonyGame.meta.theme;
                }
                
            } else {
                color = ColonyGame.meta.theme;
            }
            
        }

        if(!outlineWidth) {
            outlineWidth = 0;
        }

        if(!outlineColor) {
            outlineColor = "#000000";
        }

        var img = textureManager.getAssetWithOptions({
            img: useImg,
            frame: frame,
            color: color,
            flipped: flipped,
            custTileSize: tw,
            outlineWidth: outlineWidth,
            outlineColor: outlineColor,
            withData: withData
        });

        if(!img && outlineWidth > 0) {
            img = textureManager.getAssetWithOptions({
                img: useImg,
                frame: frame,
                color: color,
                flipped: flipped,
                custTileSize: tw,
                outlineWidth: 0,
                outlineColor: "#000000",
                withData: withData
            });
        }

        return img;

    }

    var retainedAssetDefs = {};

    function getImageDefByName(name) {

        if(retainedAssetDefs[name]) {
            return retainedAssetDefs[name];
        }

        for(var i = 0; i < ColonyGame.tiles.length; i++) {
            if(ColonyGame.tiles[i].name == name) {
                retainedAssetDefs[name] = ColonyGame.tiles[i];
                return ColonyGame.tiles[i];
            }
        }

        return null;
    }

    var moneyReadoutPrimary;
    var moneyReadoutSecondary;
    var secondaryItemsAllHolder;

    function initResourceReadouts() {
        resourceReadouts = {};

        moneyReadout.innerHTML = "";

        moneyReadoutPrimary = document.createElement("div");
        moneyReadoutSecondary = document.createElement("div");
        secondaryItemsAllHolder = document.createElement("div");

        document.getElementById("allResourceSearch").innerHTML = "";

        moneyReadoutPrimary.className = "readoutSection";
        moneyReadoutSecondary.className = "readoutSection secondarySection";
        secondaryItemsAllHolder.className = "readoutSection secondaryHolder";

        moneyReadout.appendChild(moneyReadoutPrimary);
        moneyReadout.appendChild(secondaryItemsAllHolder);

        secondaryItemsAllHolder.appendChild(moneyReadoutSecondary);

        var i;

        createResourceReadout("population",ColonyGame.meta.colonistIcon,true);

        createResourceReadout("tourists",ColonyGame.meta.touristIcon,true);

        for(i = 0; i < ColonyGame.utilities.length; i++) {
            createResourceReadout(ColonyGame.utilities[i].name,ColonyGame.utilities[i].icon,true);
        }

        for(i = 0; i < ColonyGame.resources.length; i++) {

            var useSection = false;

            if(ColonyGame.resources[i].name == ColonyGame.meta.tenderResource) {
                useSection = true;
            }

            createResourceReadout(ColonyGame.resources[i].name,ColonyGame.resources[i].icon,useSection);

            var resopt = document.createElement("option");
            resopt.innerHTML = ColonyGame.resources[i].name;
            document.getElementById("allResourceSearch").appendChild(resopt);
        }
    }

    function createResourceReadout(name,icon,primarySection) {

        var resourceHolder = document.createElement("div");
        resourceHolder.className = "resourceHolder";

        var trendHolder = document.createElement("img");
        trendHolder.src = "images/res-trend-placeholder.png";
        trendHolder.className = "trendicator";
        resourceHolder.appendChild(trendHolder);

        var iconHolder = document.createElement("img");
        iconHolder.src = "images/" + icon;
        resourceHolder.appendChild(iconHolder);

        var readoutHolder = document.createElement("span");
        resourceHolder.appendChild(readoutHolder);

        var changeHolder = document.createElement("span");
        changeHolder.className = "changeHolder";
        resourceHolder.appendChild(changeHolder);

        resourceReadouts[name] = {
            trend:          trendHolder,
            readout:        readoutHolder,
            holder:         resourceHolder,
            changer:        changeHolder,
            isTrendingDown: false
        };

        resourceHolder.resourceRef = name;

        resourceHolder.onmouseover = function(e) {

            if(!currentGame) {
                return;
            }

            if(window.innerWidth < 600) {
                return;
            }

            var barPercent = null;
            var barColor = null;

            var hoverText = "";
            var title = this.resourceRef;

            var gameRes = getGameResources();

            if(gameRes[this.resourceRef]) {


                hoverText += numberWithCommas(gameRes[this.resourceRef].amount);

                if(gameRes[this.resourceRef].capacity == -1) {
                    hoverText += "<br />Max: " + numberWithCommas(gameRes[this.resourceRef].storageCapacity);

                    var capFull = gameRes[this.resourceRef].amount / gameRes[this.resourceRef].storageCapacity;

                    barColor = getColorForPercentage(capFull,[
                        { pct: 0.0, color: { r: 0xf4, g: 0x43, b: 0x36 } },
                        { pct: 0.5, color: { r: 0xff, g: 0xc1, b: 0x07 } },
                        { pct: 1.0, color: { r: 0x4c, g: 0xaf, b: 0x50 } }
                    ]);

                    barPercent = Math.round(capFull * 100);
                }

                if(gameRes[this.resourceRef].price && gameRes[this.resourceRef].serverId) {
                    var unitPrice = gameRes[this.resourceRef].price / 100;
                    var totalValue = Math.round(gameRes[this.resourceRef].amount * unitPrice);

                    hoverText += "<br />Est: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(totalValue);
                }
            } else {

                if(getGameUtilities()[this.resourceRef]) {
                    hoverText = "Usage: " + numberWithCommas(getGameUtilities()[this.resourceRef].usage);
                    hoverText += "<br />Capacity: " + numberWithCommas(getGameUtilities()[this.resourceRef].capacity);

                    var usagePercent = getGameUtilities()[this.resourceRef].usage / getGameUtilities()[this.resourceRef].capacity;
                    barPercent = Math.round(usagePercent * 100);
                } else {
                    if(this.resourceRef == "population") {
                        title = "Population";
    
                        var totalJobs = currentGame.historicStats.jobs[currentGame.historicStats.jobs.length - 1];
    
                        hoverText = numberWithCommas(getTotalPopulation());
                        hoverText += "<br />Capacity: " + numberWithCommas(currentGame.availableShelters);
                        hoverText += "<br />Jobs: " + numberWithCommas(totalJobs);
                    }
    
                    if(this.resourceRef == "tourists") {
                        title = "Tourism";
    
                        hoverText = numberWithCommas(currentGame.touristCount);
                        hoverText += "<br />Capacity: " + numberWithCommas(currentGame.availableTourism);
                    }
                }
  
            }

            var showY = moneyReadout.offsetHeight - 12;

            showHoverPopup(hoverText,e.pageX,showY,title,null,barPercent,barColor);
        };

        if(primarySection) {
            moneyReadoutPrimary.appendChild(resourceHolder);
        } else {
            moneyReadoutSecondary.appendChild(resourceHolder);
        }

    }

    function getColorForPercentage(pct,percentColors) {
        if(!percentColors) {
            percentColors = [
                { pct: 0.0, color: { r: 0xff, g: 0x00, b: 0 } },
                { pct: 0.5, color: { r: 0xff, g: 0xff, b: 0 } },
                { pct: 1.0, color: { r: 0x00, g: 0xff, b: 0 } } 
            ];
        }

        for (var i = 1; i < percentColors.length - 1; i++) {
            if (pct < percentColors[i].pct) {
                break;
            }
        }
        var lower = percentColors[i - 1];
        var upper = percentColors[i];
        var range = upper.pct - lower.pct;
        var rangePct = (pct - lower.pct) / range;
        var pctLower = 1 - rangePct;
        var pctUpper = rangePct;
        var color = {
            r: Math.floor(lower.color.r * pctLower + upper.color.r * pctUpper),
            g: Math.floor(lower.color.g * pctLower + upper.color.g * pctUpper),
            b: Math.floor(lower.color.b * pctLower + upper.color.b * pctUpper)
        };



        return rgbToHex(color.r, color.g, color.b);

    }

    function rgbToHex(r, g, b) {
        return "#" + componentToHex(r) + componentToHex(g) + componentToHex(b);
    }

    //var runningUnemployed = 0;
    var allPossibleBuildingConnectors = [];

    function initTerrainDefs() {
        terrainDefReference = {};
        allPossibleBuildingConnectors = [];

        for(var i = 0; i < ColonyGame.terrains.length; i++) {
            terrainDefReference[ColonyGame.terrains[i].name] = ColonyGame.terrains[i];

            if(ColonyGame.terrains[i].buildingConnectors) {
                for(var j = 0; j < ColonyGame.terrains[i].buildingConnectors.length; j++) {
                    var conn = ColonyGame.terrains[i].buildingConnectors[j];

                    if(allPossibleBuildingConnectors.indexOf(conn) == -1) {
                        allPossibleBuildingConnectors.push(conn);
                    }
                }
            }
        }
    }

    function getTerrainDefByName(name) {
        var def = null;
        
        if(terrainDefReference[name]) {
            return terrainDefReference[name];
        }
        
        return def;
    }

    function initOccupationDefs() {
        occupationDefReference = {};

        for(var i = 0; i < ColonyGame.occupations.length; i++) {
            occupationDefReference[ColonyGame.occupations[i].name] = ColonyGame.occupations[i];
        }
    }

    function getOccupationDefByName(name) {
        var def = null;
        
        if(occupationDefReference[name]) {
            return occupationDefReference[name];
        }
        
        return def;
    }

    function initBuildingDefs() {
        buildingDefReference = {};

        for(var i = 0; i < ColonyGame.buildings.length; i++) {
            buildingDefReference[ColonyGame.buildings[i].name] = ColonyGame.buildings[i];
        }
    }

    function getBuildingDefByName(name) {
        if(retainedDef != null && name == retainedDef.name) {
            return retainedDef;
        }

        return buildingDefReference[name];
    }

    function initUtilityDefs() {
        utilityDefReference = {};

        for(var i = 0; i < ColonyGame.utilities.length; i++) {
            utilityDefReference[ColonyGame.utilities[i].name] = ColonyGame.utilities[i];
        }

    }

    function getUtilityByDefName(name) {
        var def = null;
        
        if(utilityDefReference[name]) {
            return utilityDefReference[name];
        }
        
        return def;
    }

    function initResourceDefs() {
        resourceDefReference = {};

        for(var i = 0; i < ColonyGame.resources.length; i++) {
            resourceDefReference[ColonyGame.resources[i].name] = ColonyGame.resources[i];
        }
    }

    function getResourceByDefName(name) {
        var def = null;
        
        if(resourceDefReference[name]) {
            return resourceDefReference[name];
        }
        
        return def;
    }
    
    function initVehicleDefs() {
        vehicleDefReference = {};

        for(var i = 0; i < ColonyGame.vehicles.length; i++) {
            vehicleDefReference[ColonyGame.vehicles[i].name] = ColonyGame.vehicles[i];
        }

    }

    var lastVehicleDef = null;

    function getVehicleDefByName(name) {

        if(lastVehicleDef == null || lastVehicleDef.name != name) {
            lastVehicleDef = vehicleDefReference[name];
        }

        return lastVehicleDef;
    }
    
    function randomIntFromInterval(min,max) {
        return Math.floor(Math.random()*(max-min+1)+min);
    }
    
    function getIdNumber() {
        this.idCounter++;
        return this.idCounter;
    }

    function replaceAll(str, find, replace) {

        if(!str) {
            return "";
        }

        if(str.indexOf(find) < 0) {
            return str;
        }

        return str.replace(new RegExp(escapeRegExp(find), "g"), replace);
    }

    function escapeRegExp(str) {
        return str.replace(/([.*+?^=!:${}()|[]\/\\])/g, "\\$1");
    }

    function cleanUpGameFile(data) {
        if(!data) {
            return;
        }

        data.isCleaningForSave = true;

        var i;

        var killRes = [];

        // check if all resources are legit 
        for(var resource in data.resources) {
            var def = getResourceByDefName(resource);

            if(!def) {
                killRes.push(resource);
            }
        }

        while(killRes.length > 0) {
            delete data.resources[killRes.pop()];
        }

        for(i = 0; i < data.passableNonUpdatables.length; i++) {
            cleanUpUnneededPassableProperties(data.passableNonUpdatables[i]);
            data.passableNonUpdatables[i].occupiesTiles = null;
            data.passableNonUpdatables[i].md = null;
            data.passableNonUpdatables[i].fr = null;
        }

        for(i = 0; i < data.buildings.length; i++) {

            if(!data.buildings[i]) {
                continue;
            }

            delete data.buildings[i].miniDef;
            delete data.buildings[i].generatePercentage;
            delete data.buildings[i].generateCounter;
            delete data.buildings[i].howManyWorking;
            delete data.buildings[i].someoneWorking;
            delete data.buildings[i].consumptionCounter;
            delete data.buildings[i].freeRef;
            delete data.buildings[i].name;

            data.buildings[i].occupiesTiles = null;
            data.buildings[i].md = null;
            data.buildings[i].playDef = null;
            data.buildings[i].fr = null;
            buildingStatCompress(data.buildings[i]);
        }

        for(i = 0; i < data.mapResources.length; i++) {

            if(!data.mapResources[i]) {
                continue;
            }

            delete data.mapResources[i].miniDef;
            delete data.mapResources[i].freeRef;
            delete data.mapResources[i].name;

            data.mapResources[i].md = null;
            data.mapResources[i].fr = null;
            data.mapResources[i].playDef = null;
            data.mapResources[i].occupiesTiles = null;
        }

        for(i = 0; i < data.vehicles.length; i++) {
            delete data.vehicles[i].name;

            data.vehicles[i].mq = [];
            data.vehicles[i].pd = null;
            setAwaitingPath(data.vehicles[i],"vehicle",false);
        }
    }

    function unCleanGameFile(data) {

        if(!data.isCleaningForSave) {
            return;
        }

        var i;

        if(!data) {
            return;
        }

        data.isCleaningForSave = false;

        if(!data.buildings) {
            data.buildings = [];
        }

        for(i = 0; i < data.buildings.length; i++) {

            data.buildings[i] = rebuildBuildingObject(data.buildings[i]);
            restoreBuildingStats(data.buildings[i]);
            setUpMinidefForBuilding(data.buildings[i],false,false);
            reInitBuilding(data.buildings[i]);
        }

    }

    function refreshMarketPrices() {
        showOnlineResources("setprices");
    }

    var saveInProgress = false;

    function clonePathArray(arr) {

        if(!arr) {
            return [];
        }

        return JSON.parse(JSON.stringify(arr));
    }

    function checkSaveFileNameForDupes(callback) {

        if(!callback) {
            callback = placeholder;
        }

        currentGame.firstSave = false;

        webAppCore.openListing(function(list) {

            if(!currentGame) {
                return;
            }

            var namePicked = false;
            var tryCounter = 0;
            var originalFileName = currentFileName;

            var useExtension = ColonyGame.meta.fileExtension;
            
            if(currentGame.mem) {
                useExtension = ColonyGame.meta.customMapExtension;
            }

            while(!namePicked) {

                var washit = false;

                for(var i = 0; i < list.length; i++) {
                    if(list[i] == currentFileName) {
                        currentFileName = originalFileName.replace("." + useExtension,"-" + tryCounter + "." + useExtension);
                        tryCounter++;
                        washit = true;
                        break;
                    }
                    
                }

                if(!washit) {
                    namePicked = true;
                }
            }

            setTimeout(callback,100);
        });
 
    }

    function saveCustomMapMetaData() {
        currentGame.mename = document.getElementById("customMapMetaNameInput").value.latinize().trim();
        currentGame.meauthor = document.getElementById("customMapMetaAuthorInput").value.latinize().trim();
        currentGame.medescription = document.getElementById("customMapMetaDescriptionInput").value.latinize().trim();
    }

    function saveCustomMapFile(callback) {
        var customMapData = new CustomMap();

        currentGame.merevision++;

        customMapData.terrainData = currentGame.mapResources;
        customMapData.name = currentGame.mename;
        customMapData.revision = currentGame.merevision;
        customMapData.mapType = currentGame.mapType;
        customMapData.height = currentGame.height;
        customMapData.width = currentGame.width;
        customMapData.author = currentGame.meauthor;
        customMapData.url = currentGame.meurl;
        customMapData.description = currentGame.medescription;

        customMapData.gameVersion = ColonyGame.meta.releaseCode;

        customMapData.startX = currentGame.mestartx;
        customMapData.startY = currentGame.mestarty;

        var customMapJson = JSON.stringify(customMapData);

        document.getElementById("savingProgressReadout").innerHTML = "Compressing Data";

        var worker = new Worker("compression-worker.js");
        worker.addEventListener("message",function(e) {
            if(e.data.status == "complete") {

                webAppCore.saveFile(currentFileName, e.data.data, function(){
                    if(callback) {
                        callback(true);
                    }
                }, true);

                if(tmpExportAfterSave) {
                    tmpExportAfterSave = false;
                    webAppCore.exportFile(currentFileName,e.data.data,false);
                }

                
                
            } else {

                if(callback) {
                    callback(false);
                }
            }
            
        });
        worker.addEventListener("error",function(e) {
        
            if(e.filename) {
                var scrpt = e.filename.substr(e.filename.lastIndexOf("/") + 1);
                webAppCore.logEvent("Game Compression Error",scrpt + ":" + e.lineno,e.message);
            } else {
                webAppCore.logEvent("Game Compression Error","Unknown","Unknown");
            }

            if(callback) {
                callback(false);
            }

        });
        worker.postMessage({
            "method":   "compress",
            "data":     customMapJson
        });

        unCleanGameFile(currentGame);
        killSwitch = false;
        pauseDrawing = false;
    }

    function stripEmoji(string) {
        // eslint-disable-next-line no-control-regex
        return string.replace(/[^\x00-\x7F]/g, "");
    }

    var isBackupAttempt = false;

    function showOnlineRequirement(withPrefix) {

        if(webAppCore.isApeAppsLoggedIn()) {
            return;
        }

        if(webAppCore.getPlatform().platform == "web") {
            if(webAppCore.getPlatform().market == "kongregate") {
                webAppCore.presentApeLogin();
                return;
            }
        }

        var warningText = getString("online-play-req-not");

        if(withPrefix) {
            warningText = withPrefix + warningText;
        }

        webAppCore.showDialog({
            title: "Ape Apps Account",
            message: warningText,
            buttons: [
                {
                    text: "Sign In",
                    func: function() {
                        webAppCore.presentApeLogin();
                    }
                },
                {
                    text: getString("general-dismiss"),
                    func: placeholder
                }
            ]
        });
    }

    function openGame(filename) {

        if(filename == null) {
            return;
        }

        if(startsWith(filename,"##mp-r##")) {
            var regionCharter = filename.replace("##mp-r##","");

            if(webAppCore.isApeAppsLoggedIn()) {
                loadMultipleyerRegion(regionCharter);
            } else {
                showOnlineRequirement("You have selected an online save.  ");
            }
            
            return;
        }

        var displayOnlineMode = webAppCore.getVar("mc-ref-online-" + filename,-1);

        if(displayOnlineMode == "1") {
            if(!webAppCore.isApeAppsLoggedIn()) {
                showTitle();
                showOnlineRequirement("You have selected an online save.  ");
                return;
            }
        }

        isBackupAttempt = false;

        if(webAppCore.isApeAppsLoggedIn()) {
            webAppCore.showSplash("Syncing Data...");
        } else {
            webAppCore.showSplash("Loading Saved Game...");
        }

        currentFileName = filename;
        webAppCore.openFile(currentFileName, uncompressFile);
    }

    function startsWith(str,prefix) {
        if(!str || !prefix) {
            return false;
        }

        if(str.indexOf(prefix) == 0) {
            return true;
        }

        return false;
    }

    function uncompressFile(content) {

        var rawFileSize = content.length;

        if(content && startsWith(content,"{") && endsWith(content, "}")) {
            onFileOpened(content,rawFileSize);
            return;
        }

        try {
            var decodedContent = atob(content);
            onFileOpened(decodedContent,rawFileSize);
        } catch(ex) {
            webAppCore.showSplash("Decompressing Game...");

            var worker = new Worker("compression-worker.js");

            worker.addEventListener("message",function(e) {

                if(e.data.status == "complete") {
                    onFileOpened(e.data.data,rawFileSize);
                } else {
                    attemptBackup();
                }
                
            });
            worker.addEventListener("error",function(e) {

                attemptBackup();
                
                if(e && e.filename) {
                    var scrpt = e.filename.substr(e.filename.lastIndexOf("/") + 1);
                    webAppCore.logEvent("Game Compression Error",scrpt + ":" + e.lineno,e.message);
                }
                
            });
            worker.postMessage({
                "method":   "decompress",
                "data":     content
            });

        }
 
    }

    function attemptBackup() {
        isBackupAttempt = true;
        var backupName = currentFileName.replace("." + ColonyGame.meta.fileExtension,"." + ColonyGame.meta.backupExtension);
        backupName = currentFileName.replace("." + ColonyGame.meta.subCityExtension,"." + ColonyGame.meta.backupExtension);

        webAppCore.showSplash("Attempting to restore backup...");
        webAppCore.openFile(backupName, uncompressFile);
    }

    function createWaterTemplateDataImage(height,width,position) {
        var tmpRiverCanvas = document.createElement("canvas");
        var tmpRiverContext = tmpRiverCanvas.getContext("2d");

        tmpRiverCanvas.height = height;
        tmpRiverCanvas.width = width;

        tmpRiverContext.fillStyle = "#ffffff";
        tmpRiverContext.fillRect(0,0,width,height);

        tmpRiverContext.fillStyle = "#000000";

        var sX = randomIntFromInterval(0,1);
        var sY = randomIntFromInterval(20,height - 21);

        if(position != null) {
            if(position == "bottom") {
                sY = randomIntFromInterval(height - 15,height);
            }

            if(position == "top") {
                sY = randomIntFromInterval(0,15);
            }
        }

        var endX = width - 1;
        var direction = 1;
        var wantedDirection = 1;
        
        var i,j,transformChance;
        
        if(sX == 1) {
            sX = width - 1;
            endX = 0;
            direction = 3;
            wantedDirection = 3;
        }
        
        var riverPoints = [];
        riverPoints.push({
            "x": sX,
            "y": sY
        });

        var endReached = false;
        var maxPoints = Math.round(((width + height) / 2) * 10);

        while(!endReached && riverPoints.length < maxPoints) {
            
            var directionChange = randomIntFromInterval(0,8);
            
            if(directionChange == 1) {
                direction = randomIntFromInterval(0,4);
                
                if(direction == 4) {
                    direction = wantedDirection;
                }
            }
            
            var newPosition = {
                "x": riverPoints[riverPoints.length - 1].x,
                "y": riverPoints[riverPoints.length - 1].y
            };
            
            if(direction == 0 && newPosition.y > 0) {
                newPosition.y--;
            }
            
            if(direction == 1 && newPosition.x < width - 1) {
                newPosition.x++;
            }
            
            if(direction == 2 && newPosition.y < height - 1) {
                newPosition.y++;
            }
            
            if(direction == 3 && newPosition.x > 0) {
                newPosition.x--;
            }
            
            riverPoints.push(newPosition);
            
            if(newPosition.x == endX) {
                endReached = true;
            }
        }

        var randPointMax = Math.ceil(maxPoints / 50);
        var randomPointCount = randomIntFromInterval(0,randPointMax);

        while(randomPointCount > 0) {

            var rnX = randomIntFromInterval(0,width);
            var rnY = randomIntFromInterval(0,height);

            if(!checkIfTmpWaterPointExists(riverPoints,rnX,rnY)) {
                riverPoints.push({
                    x: rnX,
                    y: rnY
                });
            }

            randomPointCount--;
        }

        var finalWaterPoints = [];

        for(i = 0; i < riverPoints.length; i++) {

            finalWaterPoints.push({
                x: riverPoints[i].x,
                y: riverPoints[i].y
            });

        }

        for(i = 0; i < 30; i++) {

            var newPoints = [];

            for(j = 0; j < finalWaterPoints.length; j++) {

                

                var point = finalWaterPoints[j];

                var surrounding = getSurroundingTmpWaterPoints(finalWaterPoints,point.x,point.y);

                transformChance = randomIntFromInterval(1,15);

                if(transformChance == 2 && surrounding.top == null) {
                    newPoints.push({
                        x: point.x,
                        y: point.y - 1
                    });
                }

                if(transformChance == 3 && surrounding.down == null) {
                    newPoints.push({
                        x: point.x,
                        y: point.y + 1
                    });
                }

                if(transformChance == 4 && surrounding.left == null) {
                    newPoints.push({
                        x: point.x - 1,
                        y: point.y
                    });
                }

                if(transformChance == 5 && surrounding.right == null) {
                    newPoints.push({
                        x: point.x + 1,
                        y: point.y
                    });
                }

            }

            for(j = 0; j < newPoints.length; j++) {
                var freshPoint = newPoints[j];

                if(!checkIfTmpWaterPointExists(finalWaterPoints,freshPoint.x,freshPoint.y)) {
                    finalWaterPoints.push(freshPoint);
                }
            }
        }

        for(i = 0; i < finalWaterPoints.length; i++) {
            var point2 = finalWaterPoints[i];
            tmpRiverContext.fillRect(point2.x,point2.y,1,1);
        }

        return tmpRiverCanvas.toDataURL();
    }
    
    function onFileOpened(content,originalFileSize) {

        var i,j;

        totalAvailableVehicles = 0;

        tmpBuildingRefHolder = {};

        webAppCore.showSplash("Restoring Data...");

        document.getElementById("newGameMenu").style.display = "none";
        document.getElementById("titleBackdropHold").style.display = "none";
        showHiders();

        var rawGameData = null;

        var decodedContent;

        if(content && startsWith(content,"{") && endsWith(content, "}")) {
            decodedContent = content;
        } else {
            if(currentFileName == "shared" || ((endsWith(currentFileName, "." + ColonyGame.meta.fileExtension) || endsWith(currentFileName, "." + ColonyGame.meta.subCityExtension)) && !isBackupAttempt)) {
                decodedContent = content;
            } else {
                try {
                    decodedContent = atob(content);
                } catch(ex) {

                    webAppCore.logEvent("Error","Open File",ex);
                    webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onFileOpened",ex.message);
    
                    if(isBackupAttempt) {
                        isBackupAttempt = false;
                        webAppCore.showToast("Error opening saved file!");
                        webAppCore.clearSplash();
                        vehiclePathOrders = {};
                        colonistPathOrders = {};
                        window.focus();
    
                        showTitle();
    
                        return;
                    } else {
                        attemptBackup();
                        return;
                    }
      
                }
            }
        }

        if(!decodedContent || decodedContent.trim().length == 0) {
            if(isBackupAttempt || remoteCloudLoad) {
                isBackupAttempt = false;
                webAppCore.showToast("Save file corrupted!");
                webAppCore.clearSplash();
                vehiclePathOrders = {};
                colonistPathOrders = {};
                window.focus();

                showTitle();

                webAppCore.logEvent("Save File Corrupted","Blank Decoded Content (" + webAppCore.getPlatform().platform + ")",currentFileName);

                return;
            } else {
                attemptBackup();
                return;
            }
        }

        try {
            rawGameData = JSON.parse(decodedContent);
        } catch(ex) {
            

            if(isBackupAttempt || remoteCloudLoad) {

                webAppCore.logEvent("Error","Parse File",ex);
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onFileOpened B",ex.message);

                isBackupAttempt = false;
                webAppCore.showToast("Save file corrupted!!");
                webAppCore.clearSplash();
                vehiclePathOrders = {};
                colonistPathOrders = {};
                window.focus();

                showTitle();

                webAppCore.logEvent("Save File Corrupted","Bad JSON Parse (" + webAppCore.getPlatform().platform + ")",currentFileName);

                return;
            } else {
                attemptBackup();
                return;
            }

            
        }

        if(rawGameData == null) {
            if(isBackupAttempt) {
                isBackupAttempt = false;
                webAppCore.showToast("Save file corrupted!!!");
                vehiclePathOrders = {};
                colonistPathOrders = {};
                webAppCore.clearSplash();
                window.focus();

                showTitle();

                webAppCore.logEvent("Save File Corrupted","Null Game Data (" + webAppCore.getPlatform().platform + ")",currentFileName);

                return;
            } else {
                attemptBackup();
                return;
            }
        }

        if(rawGameData.isSubregion && !currentRegion) {

            if(rawGameData.parentRegionFile) {
                openGame(rawGameData.parentRegionFile);
            }

            return;
        }

        bulldozerMode = false;
        webAppCore.handleBackFunction(standardBack);
        webAppCore.setTitleVisible(false);
        titleShowing = false;
        
        window.focus(); 

        content = null;

        rawGameData.isCleaningForSave = true;
        unCleanGameFile(rawGameData);
        rawGameData.isSaving = false;

        if(!rawGameData.waterTemplateData) {
            rawGameData.waterTemplateData = null;
        }

        if(!rawGameData.regionSquareTemplateImages) {
            rawGameData.regionSquareTemplateImages = {};
        }

        for(var pX in rawGameData.regionSquareTemplateImages) {
            for(var pY in rawGameData.regionSquareTemplateImages[pX]) {
                rawGameData.regionSquareTemplateImages[pX][pY].loading = false;
            }
        }

        if(originalFileSize) {
            rawGameData.currentFileSize = parseInt(originalFileSize);
        } else {
            rawGameData.currentFileSize = 0;
        }

        if(!rawGameData.autosellCheckCounter) {
            rawGameData.autosellCheckCounter = 0;
        }

        if(!rawGameData.lastSaveTime) {
            rawGameData.lastSaveTime = 0;
        }

        if(!rawGameData.subcityGuid) {
            rawGameData.subcityGuid = 0;
        }

        if(!rawGameData.annualTradeIncome) {
            rawGameData.annualTradeIncome = 0;
        }

        if(!rawGameData.annualTradeLosses) {
            rawGameData.annualTradeLosses = 0;
        }

        if(!rawGameData.importExportTrend) {
            rawGameData.importExportTrend = [];
        }

        if(!rawGameData.year) {
            rawGameData.year = 0;
        }

        if(!rawGameData.period) {
            rawGameData.period = 0;
        }

        if(!rawGameData.simSyncCounter) {
            rawGameData.simSyncCounter = 0;
        }

        if(remoteCloudLoad) {
            rawGameData.readOnlyMode = true;
            rawGameData.offlineMode = true;
            rawGameData.tradeNotifications = false;
        }

        if(!rawGameData.rescs) {
            rawGameData.rescs = null;
        }

        var resourceHackingDetected = false;

        if(!rawGameData.isSubregion && rawGameData.rescs != null) {
            var oldResources = JSON.stringify(rawGameData.resources);

            var ctx = new Checksum("fnv32", 0);
            ctx.updateStringly(oldResources);
            var resourcesCheck = ctx.result.toString(16);

            if(rawGameData.rescs != resourcesCheck) {
                resourceHackingDetected = true;
                webAppCore.logEvent("Game File Hack","Detected",rawGameData.rescs + ":" + resourcesCheck);
            }
        }

        if(!rawGameData.offlineMode && rawGameData.colonyId && rawGameData.colonyId != "0") {
            var pndTrnSto = webAppCore.getVar("pnd-trns-" + rawGameData.colonyId + "-sve","0");

            if(pndTrnSto && pndTrnSto != "0") {
                var modRes = null;

                try {
                    modRes = JSON.parse(pndTrnSto);
                } catch(ex) {
                    webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onFileOpened C",ex.message);
                    modRes = null;
                }

                if(modRes != null) {
                    rawGameData.resources = modRes;
                }
            }
        }

        if(rawGameData.sX == undefined) {
            rawGameData.sX = 0;
            rawGameData.sY = 0;
            rawGameData.gX = 0;
            rawGameData.gY = 0;
        }


        if(rawGameData.regionalGDPGrowthQuarterlyAdjusted == undefined) {
            rawGameData.regionalGDPGrowthQuarterlyAdjusted = [];
        }

        if(rawGameData.regionalGDPAnuallyhQuarterlyAdjusted == undefined) {
            rawGameData.regionalGDPAnuallyhQuarterlyAdjusted = [];
        }

        if(rawGameData.regionalPriceIndex == undefined) {
            rawGameData.regionalPriceIndex = [];
        }

        if(rawGameData.votingHistory == undefined) {
            rawGameData.votingHistory = {};
        }
        
        if(rawGameData.stopTourism == undefined) {
            rawGameData.stopTourism = false;
        }

        if(rawGameData.hasLoadedChat == undefined) {
            rawGameData.hasLoadedChat = false;
        }

        
        if(rawGameData.allowColoniae == undefined) {
            rawGameData.allowColoniae = false;
        }

        if(rawGameData.isMpRegionHolder == undefined) {
            rawGameData.isMpRegionHolder = false;
        }

        if(rawGameData.mpRegionPlanetCharter == undefined) {
            rawGameData.mpRegionPlanetCharter = null;
        }

        if(rawGameData.regionalPriceIndexAnnual == undefined) {
            rawGameData.regionalPriceIndexAnnual = [];
        }

        if(rawGameData.regionDistrictData == undefined) {
            rawGameData.regionDistrictData = [];
        }

        if(rawGameData.regionalGDPGrowthQuarterly == undefined) {
            rawGameData.regionalGDPGrowthQuarterly = [];
        }

        if(rawGameData.regionalGDPGrowthAnnually == undefined) {
            rawGameData.regionalGDPGrowthAnnually = [];
        }


        

        if(rawGameData.regionalGDPGrowthTrend == undefined) {
            rawGameData.regionalGDPGrowthTrend = [];
        }

        if(rawGameData.regionalGDPTrend == undefined) {
            rawGameData.regionalGDPTrend = [];
        }

        if(rawGameData.regionalUnemploymentTrend == undefined) {
            rawGameData.regionalUnemploymentTrend = [];
        }
        

        if(rawGameData.isRegion == undefined) {
            rawGameData.isRegion = false;
        }

        if(rawGameData.isSubregion == undefined) {
            rawGameData.isSubregion = false;
        }

        if(rawGameData.parentRegionFile == undefined) {
            rawGameData.parentRegionFile = null;
        }

        if(rawGameData.subRegions == undefined) {
            rawGameData.subRegions = [];
        }


        if(rawGameData.tradeNotifications == undefined) {
            rawGameData.tradeNotifications = false;
        }

        if(rawGameData.motherlandCharter == undefined) {
            rawGameData.motherlandCharter = null;
        }

        if(rawGameData.immigrantSources == undefined) {
            rawGameData.immigrantSources = [];
        }

        if(rawGameData.apiKey == undefined) {
            rawGameData.apiKey = 0;
        }

        if(rawGameData.foreignPayrollTotals == undefined) {
            rawGameData.foreignPayrollTotals = 0;
        }

        if(rawGameData.motherlandTaxesPaid == undefined) {
            rawGameData.motherlandTaxesPaid = 0;
        }

        if(rawGameData.timeOfDay == undefined) {
            rawGameData.timeOfDay = 9;
        }

        if(rawGameData.cm == undefined) {
            rawGameData.cm = false;
        }

        if(rawGameData.totalImmigration == undefined) {
            rawGameData.totalImmigration = 0;
        }

        if(rawGameData.totalEmigration == undefined) {
            rawGameData.totalEmigration = 0;
        }

        if(rawGameData.finishedPassableNonUpdatables == undefined) {
            rawGameData.finishedPassableNonUpdatables = {};
        }

        if(rawGameData.firstSave == undefined) {
            rawGameData.firstSave = false;
        }

        if(rawGameData.foreignContactReference == undefined) {
            rawGameData.foreignContactReference = {};
        }

        if(rawGameData.sadReasons) {
            delete rawGameData.sadReasons;
        }

        if(rawGameData.sadderReasons == undefined) {
            rawGameData.sadderReasons = {};
        }

        if(rawGameData.payrollRate == undefined) {
            rawGameData.payrollRate = 0.25;
        }

        if(rawGameData.taxLevel == undefined) {
            rawGameData.taxLevel = 100;
        }

        if(rawGameData.salesPitch == undefined) {
            rawGameData.salesPitch = "";
        }

        if(!rawGameData.defaultRace) {
            rawGameData.defaultRace = ColonyGame.meta.tmpDefaultRace;
        }

        if(!rawGameData.mapType) {
            rawGameData.mapType = ColonyGame.meta.tmpDefaultMapType;
        }

        if(rawGameData.disasterCounters == undefined) {
            rawGameData.disasterCounters = {};

            var tmt;

            for(i = 0; i < ColonyGame.mapTypes.length; i++) {
                if(ColonyGame.mapTypes[i].name == rawGameData.mapType) {
                    tmt = ColonyGame.mapTypes[i];
                    break;
                }
            }

            if(tmt.explosionDisasters != null) {
                for(i = 0; i < tmt.explosionDisasters.length; i++) {
                    rawGameData.disasterCounters[tmt.explosionDisasters[i].name] = randomIntFromInterval(0,tmt.explosionDisasters[i].frequency);
                }
            }
        }

        if(!rawGameData.destroyedBuildings) {
            rawGameData.destroyedBuildings = 0;
        }

        if(!rawGameData.livingWageRate) {
            rawGameData.livingWageRate = 0;
        }

        if(!rawGameData.totalBirths) {
            rawGameData.totalBirths = 0;
        }

        if(!rawGameData.totalDeaths) {
            rawGameData.totalDeaths = 0;
        }

        if(!rawGameData.totalTourists) {
            rawGameData.totalTourists = 0;
        }

        if(!rawGameData.totalTourismIncome) {
            rawGameData.totalTourismIncome = 0;
        }

        if(!rawGameData.entertainmentTickPhase) {
            rawGameData.entertainmentTickPhase = 0;
        }

        if(!rawGameData.totalEntertainmentIncome) {
            rawGameData.totalEntertainmentIncome = 0;
        }


        if(!rawGameData.governmentLevel) {
            rawGameData.governmentLevel = 0;
        }

        if(!rawGameData.deadTourists) {
            rawGameData.deadTourists = 0;
        }

        if(!rawGameData.availableTourism) {
            rawGameData.availableTourism = 0;
        }

        if(!rawGameData.rewardCounter) {
            rawGameData.rewardCounter = 0;
        }

        if(rawGameData.autoBudget == undefined) {
            rawGameData.autoBudget = false;
        }

        if(rawGameData.historicStats == undefined) {
            rawGameData.historicStats = {
                "population": [],
                "age": [],
                "savings": [],
                "gdp": [],
                "unemployment": [],
                "jobs": [],
                "health": [],
                "iq": [],
                "homeless": [],
                "approval": [],
                "workforce": [],
                "mediansalary": [],
                "retiredpop": [],
                "students": [],
                "newGDP": [],
                "ndp": [],
                "gdpGrowth": [],
                "gdpGrowthQuarterly": [],
                "gdpGrowthAnnually": [],
                "priceIndex": [],
                "gdpQuarterlyAdjusted": [],
                "gdpAnuallyAdjusted": [],
                "priceIndexAnualBasis": []
            };
        }

        rawGameData.lastSaveTime = Date.now();

        if(rawGameData.populationStats == undefined) {
            rawGameData.populationStats = {};

            for(var r = 0; r < ColonyGame.races.length; r++) {
                rawGameData.populationStats[ColonyGame.races[r].name] = 0;
            }
        }

        if(rawGameData.statMods == undefined) {
            rawGameData.statMods = {};
        }

        if(rawGameData.createdRelCode == undefined) {
            rawGameData.createdRelCode = ColonyGame.meta.releaseCode;
        }

        if(rawGameData.saveRelCode == undefined) {
            rawGameData.saveRelCode = ColonyGame.meta.releaseCode;
        }

        if(rawGameData.createdBuildVer == undefined) {
            rawGameData.createdBuildVer = webAppCore.getAppVersion();
        }

        if(rawGameData.saveBuildVer == undefined) {
            rawGameData.saveBuildVer = webAppCore.getAppVersion();
        }

        if(rawGameData.totalPlayTime == undefined) {
            rawGameData.totalPlayTime = 0;
        }

        if(rawGameData.centerBuildingId == undefined) {
            rawGameData.centerBuildingId = 0;
        }

        if(rawGameData.giftCapacity == undefined) {
            rawGameData.giftCapacity = 0;
        }

        if(rawGameData.showRewardOption == undefined) {
            rawGameData.showRewardOption = false;
        }

        if(rawGameData.workerPolicy == undefined) {
            rawGameData.workerPolicy = 1;
        }

        if(rawGameData.paidWindfallTax == undefined) {
            rawGameData.paidWindfallTax = true;
        }

        if(rawGameData.paidWindfallTaxB == undefined) {
            rawGameData.paidWindfallTaxB = false;
        }

        if(rawGameData.paidWindfallTaxC == undefined) {
            rawGameData.paidWindfallTaxC = false;
        }

        if(rawGameData.paidWindfallTaxD == undefined) {
            rawGameData.paidWindfallTaxD = false;
        }

        if(rawGameData.foodRationing == undefined) {
            rawGameData.foodRationing = false;
        }

        if(rawGameData.offlineMode == undefined) {
            rawGameData.offlineMode = false;
        }

        if(rawGameData.metroAreaCounter == undefined) {
            rawGameData.metroAreaCounter = 0;
            rawGameData.metroAreaNameRef = {};
        }

        if(rawGameData.readOnlyMode == undefined) {
            rawGameData.readOnlyMode = false;
        }

        if(rawGameData.useCompression == undefined) {
            rawGameData.useCompression = true;
        }

        if(rawGameData.hasCheated == undefined) {
            rawGameData.hasCheated = false;
        }

        if(rawGameData.privateCharter == undefined) {
            rawGameData.privateCharter = false;
        }

        if(rawGameData.localPlayerId == undefined) {
            rawGameData.localPlayerId = guid();
            rawGameData.playerNamesRef = {};
        }

        if(webAppCore.isApeAppsLoggedIn()) {
            if(!rawGameData.playerNamesRef[rawGameData.localPlayerId]) {
                rawGameData.playerNamesRef[rawGameData.localPlayerId] = {
                    name: webAppCore.getApeAppsProfile().un,
                    color: rawGameData.themeColor,
                    resources: {},
                    utilities: {},
                    techs: {}
                };
            }
        }

        if(rawGameData.apeAppsUsername == undefined) {
            rawGameData.apeAppsUsername = null;

            if(!rawGameData.offlineMode) {
                if(webAppCore.isApeAppsLoggedIn()) {
                    rawGameData.apeAppsUsername = webAppCore.getApeAppsProfile().un;
                }
            }
        }

        if(!rawGameData.offlineMode && rawGameData.apeAppsUsername != null) {
            if(!webAppCore.isApeAppsLoggedIn() || rawGameData.apeAppsUsername != webAppCore.getApeAppsProfile().un) {

                if(webAppCore.isApeAppsLoggedIn()) {
                    doOfflineCopy(rawGameData);
                    webAppCore.showToast("Offline Copy");
                } else {
                    webAppCore.clearSplash();
                    showTitle();
    
                    webAppCore.showAlertWithTitle("The game file you are trying to open is tied to the Account " + rawGameData.apeAppsUsername + " and can only be played by that account holder.  Please log in and try again","Unauthorized Access");
                    return;
                }

                
            }
        }

        if(rawGameData.cm == true) {
            if(!webAppCore.getIsPremium()) {
                webAppCore.clearSplash();
                showTitle();

                webAppCore.showAlertWithTitle("Creative Mode games require premium access.","Premium Content");
                return;
            }
        }

        if(!rawGameData.flag) {
            rawGameData.flag = new ColonyFlag();
        }

        if(!rawGameData.salaries) {
            rawGameData.salaries = {};
        }

        if(!rawGameData.stopImmigration) {
            rawGameData.stopImmigration = false;
        }

        if(!rawGameData.themeColor) {
            rawGameData.themeColor = "#b35900";
        }

        if(rawGameData.useCloud == undefined) {
            if(webAppCore.isApeAppsLoggedIn()) {
                rawGameData.useCloud = true;
            } else {
                rawGameData.useCloud = false;
            }
        }

        if(!rawGameData.mail) {
            rawGameData.mail = [];
        }

        if(!rawGameData.colonialTaxCollected) {
            rawGameData.colonialTaxCollected = 0;
        }

        if(!rawGameData.colonies) {
            rawGameData.colonies = 0;
        }

        if(!rawGameData.currentOccupationStats) {
            rawGameData.currentOccupationStats = {};
        }

        if(!rawGameData.currentOccupationPercents) {
            rawGameData.currentOccupationPercents = {};
        }

        if(!rawGameData.charter) {
            rawGameData.charter = 0;
        }

        if(!rawGameData.colonyId) {
            rawGameData.colonyId = 0;
        }

        if(!rawGameData.motherlandid) {
            rawGameData.motherlandid = 0;
        }

        if(!rawGameData.buildingStatCycleCounter) {
            rawGameData.buildingStatCycleCounter = 30;
        }

        if(!rawGameData.creationDate) {
            rawGameData.creationDate = Date.now();
        }

        if(!rawGameData.motherland) {
            rawGameData.motherland = webAppCore.getString(ColonyGame.meta.defaultMotherland);
        }

        rawGameData.getId = getIdNumber;

        if(isNaN(rawGameData.width)) {
            rawGameData.width = ColonyGame.meta.mapWidth;
            rawGameData.height = ColonyGame.meta.mapHeight;
        }

        if(!rawGameData.unlockedTechs) {
            rawGameData.unlockedTechs = {};
        }

        var techItem;

        for( i = 0; i < ColonyGame.races.length; i++) {
            if(ColonyGame.races[i].name == rawGameData.defaultRace) {
                if(ColonyGame.races[i].startingTechs != null) {
                    for(j = 0; j < ColonyGame.races[i].startingTechs.length; j++) {
                        techItem = ColonyGame.races[i].startingTechs[j];

                        if(!rawGameData.unlockedTechs[techItem] || rawGameData.unlockedTechs[techItem] === true) {
                            rawGameData.unlockedTechs[techItem] = new Date().getTime();
                        }
                        
                    }
                }
            }
            
        }

        for( i = 0; i < ColonyGame.civilizations.length; i++) {
            if(ColonyGame.civilizations[i].name == rawGameData.civilization) {
                if(ColonyGame.civilizations[i].startingTechs != null) {
                    for(j = 0; j < ColonyGame.civilizations[i].startingTechs.length; j++) {
                        techItem = ColonyGame.civilizations[i].startingTechs[j];

                        if(!rawGameData.unlockedTechs[techItem] || rawGameData.unlockedTechs[techItem] === true) {
                            rawGameData.unlockedTechs[techItem] = new Date().getTime();
                        }
                    }
                }
            }
            
        }

        for( i = 0; i < ColonyGame.mapTypes.length; i++) {
            if(ColonyGame.mapTypes[i].name == rawGameData.mapType) {
                if(ColonyGame.mapTypes[i].startingTechs != null) {
                    for(j = 0; j < ColonyGame.mapTypes[i].startingTechs.length; j++) {
                        techItem = ColonyGame.mapTypes[i].startingTechs[j];

                        if(!rawGameData.unlockedTechs[techItem] || rawGameData.unlockedTechs[techItem] === true) {
                            rawGameData.unlockedTechs[techItem] = new Date().getTime();
                        }
                    }
                }
            }
            
        }

        for(techItem in rawGameData.unlockedTechs) {
            if(rawGameData.unlockedTechs[techItem] === true) {
                rawGameData.unlockedTechs[techItem] = new Date().getTime();
            }
        }

        var kb = [];

        for(i = 0; i < rawGameData.buildings.length; i++) {

            if(!rawGameData.buildings[i]) {
                kb.push(rawGameData.buildings[i]);
                continue;
            }

            if(rawGameData.buildings[i].def.name) {
                rawGameData.buildings[i].def = rawGameData.buildings[i].def.name;
            }

            if(rawGameData.buildings[i].genRef) {
                rawGameData.buildings[i].genRef = null;
            }

            if(ColonyGame.meta.name == "Antiquitas") {
                if(rawGameData.buildings[i].def == "Water") {
                    rawGameData.buildings[i].def = "Water Pool";
                }
            }

            if(rawGameData.buildings[i].def == "Atmosphere Condensor") {
                rawGameData.buildings[i].def = "Atmosphere Condenser";
            }

            if(rawGameData.buildings[i].def == "Unholy Mound of Whorship") {
                rawGameData.buildings[i].def = "Unholy Mound of Worship";
            }

            if(rawGameData.buildings[i].def == "Synthetic Crystalline") {
                rawGameData.buildings[i].def = "Synthetic Crystalline Deposit";
            }

            rawGameData.buildings[i] = rebuildBuildingObject(rawGameData.buildings[i]);



            restoreBuildingStats(rawGameData.buildings[i]);

            setUpMinidefForBuilding(rawGameData.buildings[i],false,false);


            reInitBuilding(rawGameData.buildings[i]);

        }


        while(kb.length > 0) {
            removeFromArray(rawGameData.buildings,kb.pop());
        }

        // resort buildings into def order
        rawGameData.buildings.sort(sortBuildings);
        
        // restore passable functions
        if(rawGameData.passableNonUpdatables) {
            for(i = 0; i < rawGameData.passableNonUpdatables.length; i++) {

                if(rawGameData.passableNonUpdatables[i].def.name) {
                    rawGameData.passableNonUpdatables[i].def = rawGameData.passableNonUpdatables[i].def.name;
                }
    
                rawGameData.passableNonUpdatables[i] = rebuildBuildingObject(rawGameData.passableNonUpdatables[i]);
                setUpMinidefForBuilding(rawGameData.passableNonUpdatables[i],false,false);
    
                cleanUpUnneededPassableProperties(rawGameData.passableNonUpdatables[i]);
    
            }
        }

        // convert old colonist data to new 
        if(rawGameData.colonists) {
            for(i = 0; i < rawGameData.colonists.length; i++) {
                createNewPerson(rawGameData.colonists[i].age,1,rawGameData);
            }

            delete rawGameData.colonists;
        }

        if(rawGameData.tourists) {
            delete rawGameData.tourists;
        }

        if(rawGameData.diplomats) {
            delete rawGameData.diplomats;
        }

        if(rawGameData.virtualAvatars) {
            for(var prop in rawGameData.virtualAvatars) {
                var theAvatar = rawGameData.virtualAvatars[prop];
                createNewPerson(null,parseInt(theAvatar.represents),rawGameData);
            }

            delete rawGameData.virtualAvatars;
        }
        

        // restore colonist functions

        
        if(!rawGameData.touristCount) {
            rawGameData.touristCount = 0;
        }

        whackedVehicleKillArray = [];

        if(!rawGameData.vehicles) {
            rawGameData.vehicles = [];
        }
        
        // restore vehicle functions
        for(i = 0; i < rawGameData.vehicles.length; i++) {


            if(rawGameData.vehicles[i].def.name) {
                rawGameData.vehicles[i].def = rawGameData.vehicles[i].def.name;
            }

            rawGameData.vehicles[i] = rebuildVehicleObject(rawGameData.vehicles[i]);

            rawGameData.vehicles[i].mq = [];

        }

        for(i = 0; i < whackedVehicleKillArray.length; i++) {
            removeFromArray(rawGameData.vehicles,whackedVehicleKillArray[i]);
        }

        whackedVehicleKillArray = null;

        if(!rawGameData.mapResources) {
            rawGameData.mapResources = [];
        }
        
        // restore terrain resource functions
        for(i = 0; i < rawGameData.mapResources.length; i++) {

            if(rawGameData.mapResources[i].def.name) {
                rawGameData.mapResources[i].def = rawGameData.mapResources[i].def.name;
            }

            rawGameData.mapResources[i] = rebuildMapResourceObject(rawGameData.mapResources[i]);
            setUpMinidefForBuilding(rawGameData.mapResources[i],true,false);

        }

        if(rawGameData.isRegion) {

            var uniqueFilenameRef = [];
            var newSubcityList = [];

            for(i = 0; i < rawGameData.subRegions.length; i++) {
                var tSR = rebuildSubcity(rawGameData.subRegions[i]);

                if(uniqueFilenameRef.indexOf(tSR.filename) > -1) {
                    continue;
                } else {
                    uniqueFilenameRef.push(tSR.filename);
                }

                if(!tSR.subcityGuid || tSR.subcityGuid == 0) {
                    tSR.subcityGuid = guid();
                }

                newSubcityList.push(tSR);
            }

            rawGameData.subRegions = newSubcityList;

        } else {
            if(rawGameData.isSubregion && currentSubcityRef) {
                if(!rawGameData.subcityGuid || rawGameData.subcityGuid == 0) {
                    rawGameData.subcityGuid = currentSubcityRef.subcityGuid;
                }

                if(originalFileSize) {
                    currentSubcityRef.fileSize = parseInt(originalFileSize);
                } else {
                    currentSubcityRef.fileSize = 0;
                }

                if(rawGameData.subcityGuid != currentSubcityRef.subcityGuid && rawGameData.apiKey != currentSubcityRef.subcityGuid) {
                    webAppCore.showDialog({
                        title: getString("gen-error"),
                        message: getString("subcity-mismatch")
                    });
                    closeBackToRegionFinal();
                    return;
                }
            }
        }


        for(var res in rawGameData.resources) {

            if(res == "statResSaveTimestamp") {
                continue;
            }

            var df = getResourceByDefName(res);

            if(df != null) {
                rawGameData.resources[res].capacity = df.max;
            }
        }

        if(!rawGameData.resources) {
            rawGameData.resources = {};
        }

        // reinit resources if new were added
        for(i = 0; i < ColonyGame.resources.length; i++) {

            var resItem = ColonyGame.resources[i];

            if(!rawGameData.resources[resItem.name]) {

                rawGameData.resources[resItem.name] = {};
                rawGameData.resources[resItem.name].amount = resItem.starting;
                rawGameData.resources[resItem.name].price = resItem.basePrice;
                rawGameData.resources[resItem.name].previous = 0;
                rawGameData.resources[resItem.name].storageCapacity = 0;
                rawGameData.resources[resItem.name].domesticCapacity = 0;
                rawGameData.resources[resItem.name].domesticAmount = 0;
                rawGameData.resources[resItem.name].unlocked = false;
                rawGameData.resources[resItem.name].serverId = 0;
                rawGameData.resources[resItem.name].lastTrade = 0;
                rawGameData.resources[resItem.name].autosell = false;

                if(resItem.catchupAmount > 0) {

                    if(!rawGameData.gifts) {
                        rawGameData.gifts = [];
                    }

                    rawGameData.gifts.push(new Gift("New Resource Catchup","New resource added bonus for existing colonies.",resItem.name,resItem.catchupAmount));
                }
 
            }

            rawGameData.resources[resItem.name].capacity = resItem.max;

            if(!rawGameData.resources[resItem.name].autosell) {
                rawGameData.resources[resItem.name].autosell = false;
            }

            if(!rawGameData.resources[resItem.name].domesticCapacity) {
                rawGameData.resources[resItem.name].domesticCapacity = 0;
            }

            if(!rawGameData.resources[resItem.name].domesticAmount) {
                rawGameData.resources[resItem.name].domesticAmount = 0;
            }
        }

        if(!rawGameData.gifts) {
            rawGameData.gifts = [];
        }

        if(!rawGameData.mail) {
            rawGameData.mail = [];
        }

        // clean up duplicate finished passables 
        var newPassableData = {};

        for(var uType in rawGameData.finishedPassableNonUpdatables) {
            for(var uX in rawGameData.finishedPassableNonUpdatables[uType]) {

                if(uX == null) {
                    continue;
                }

                for(i = 0; i < rawGameData.finishedPassableNonUpdatables[uType][uX].length; i++) {
                    var uY = rawGameData.finishedPassableNonUpdatables[uType][uX][i];

                    if(uY == null) {
                        continue;
                    }

                    if(!newPassableData[uType]) {
                        newPassableData[uType] = {};
                    }

                    if(!newPassableData[uType][uX]) {
                        newPassableData[uType][uX] = [];
                    }

                    if(newPassableData[uType][uX].indexOf(uY) == -1) {
                        newPassableData[uType][uX].push(parseInt(uY));
                    }
                }
            }
        }

        rawGameData.finishedPassableNonUpdatables = newPassableData;

        webAppCore.showSplash("Doing Cleanup...");



        initScroll2d();

        pendingAutosales = [];

        lastColorFilter = null;
        currentGame = rawGameData;
        openJobsArray = [];
        killSwitch = false;
        curRegPreviewWorkQueue = [];
        curRegPreviewWorkItem = null;
        curRegRiverTemplateCanvas = null;
        curRegRiverTemplateContext = null;

        sizeElements();

        readyToLoadSubcities = false;

        if(currentGame.isRegion) {
            //currentGame.colonists = [];
            currentGame.buildings = [];
            syncRegionMetroAreas();
        } else {
            readyToLoadSubcities = true;
        }


        tcpAvailable = webAppCore.supportsTcpSockets();

        setupMenuOptions();

        retainedPaths = {};
        retainedPathsCounter = 0;
        shouldUpdateCollissionMap = true;
        buildingUpdateCycle = true;
        shoreUpdateTurn = true;
        retainedUsage = {};

        riotingWarned = false;
        anarchyWarned = false;
        famineWarned = false;
        noWaterWarned = false;

        connectToSocketsIfNecessary();

        sizeElements();

        setupResourceLedger();

        mailCheckTimer = 14200;

        setMapType();

        if(!currentGame.readOnlyMode && getRegionOrCity().mail.length > 0) {
            document.getElementById("imMail").style.display = "inline-block";
        } else {
            document.getElementById("imMail").style.display = "none";
        }

        if(!currentGame.readOnlyMode && getRegionOrCity().gifts.length > 0) {
            document.getElementById("imGift").style.display = "inline-block";
        } else {
            document.getElementById("imGift").style.display = "none";
        }

        rawGameData = null;

        if(resourceHackingDetected) {
            blacklistColony();
        }

        Scroll2d.setMapDims(currentGame.width,currentGame.height);

        createCollisionReference();

        updateUtilityGrid();

        Scroll2d.forceSceneChange();
    
        defaultOutZoomLevel();
        

        centerMap();
        setCenterMapIcon();


        vehiclePathOrders = {};
        colonistPathOrders = {};

        window.focus();

        Scroll2d.forceSceneChange();

        createSidebar();
        drawSidebar();

        setWeather();

        //setMaxSimsForSession();

        remoteCloudLoad = false;

        if(!currentGame.readOnlyMode) {
            if(currentGame.mpRegionPlanetCharter && currentRegion) {
                webAppCore.storeVar("mc-last-saved-game-name",currentRegion.name);
                webAppCore.storeVar("mc-last-saved-game","##mp-r##" + currentGame.mpRegionPlanetCharter);
            } else {
                webAppCore.storeVar("mc-last-saved-game",currentFileName);
            }
            
            webAppCore.showToast(currentGame.name);
        }

        sizeElements();
        Scroll2d.sizeElements();
        setupMenuOptions();

        if(currentGame.readOnlyMode) {
            hideSidebarIfSmall();
        }
        
        initSoundtrack();

        if(isStreamingLive) {
            turnStreamingTracksBackOn();
        }

        if(!currentGame.readOnlyMode && !getRegionOrCity().offlineMode && ColonyGame.meta.colonyServerApi != null) {

            if(currentGame.isSubregion && !currentGame.mpRegionPlanetCharter) {
                updateColonyStats(true);

                
            } else {
                initOnlineColony();
            }

            
        } else {
            createLocalServer();
            joinLocalNetworks();

            if(currentGame.isRegion) {
                readyToLoadSubcities = true;
            }
            
            webAppCore.clearSplash();
        }


        if(!currentGame) {
            showTitle();
            webAppCore.showToast("Error opening file!");
            return;
        }

        if(currentGame.isSubregion) {
            fillOutConnectingEdges();
            handleIdleRegionalResourceConsumption();
            handleIncomingUnits();
        }

        chatSetupQuick();

        setTimeout(Scroll2d.forceSceneChange(),500);

        setColonyThemeColor();

    }

    function chatSetupQuick() {
        document.getElementById("imChat").style.display = "none";

        if(!webAppCore.isApeAppsLoggedIn()) {
            return;
        }

        if(webAppCore.isTV()) {
            return;
        }

        if(getRegionOrCity().offlineMode && !ColonyGame.meta.globalChatChannel) {
            return;
        }

        if(!getRegionOrCity().isIndependent && getRegionOrCity().motherlandid < 100 && !ColonyGame.meta.globalChatChannel) {
            return;
        }

        document.getElementById("imChat").style.display = "inline-block";
    }

    function CustomMap() {
        this.name = null;
        this.revision = 0;

        this.author = null;
        this.url = null;
        this.description = null;

        this.mapType = null;
        this.height = 100;
        this.width = 100;

        this.terrainData = [];

        this.gameVersion = 0;

        this.startX = 50;
        this.startY = 50;
    }

    function rebuildSubcity(oldSubcity) {
        var newSubcity = new SubCity();

        for(var prop in oldSubcity) {
            newSubcity[prop] = oldSubcity[prop];
        }

        return newSubcity;
    }

    function SubCity() {
        this.name = null;
        this.filename = null;
        this.fileSize = 0;
        this.population = 0;
        this.size = 0;
        this.previewImage = null;
        this.x = 0;
        this.y = 0;
        this.resourceCapacities = {};
        this.utilityCapacities = {};
        this.giftCapacity = 0;
        this.utilitySources = {};

        this.availableJobs = 0;
        this.incomingColonists = 0;

        this.incomingUnits = [];
        this.naturalResources = {};
        this.idleResourcesUsed = {};

        this.mpCharter = null;
        this.mpId = 0;
        this.mpParent = 0;

        this.description = "";

        this.subcityGuid = guid();

        this.metroAreaDistrict = 0;

        this.unemploymentRate = 0;
        this.totalGDP = 0;

        this.resourceHistory = {};

        this.hasCapitol = false;
        this.hasConsulate = false;
        this.statsColor = randomHexColor(255,120);

        this.edgeTiles = {
            "n": [],
            "s": [],
            "e": [],
            "w": []
        };

        this.apeAppsUsername = null;

    }

    function continueNewGameMapGeneration(civDef,width,height,resourceLevel) {
        tcpAvailable = webAppCore.supportsTcpSockets();

        if(creativeFlag) {
            creativeFlag = false;
            currentGame.cm = true;
            currentGame.offlineMode = true;
            currentGame.hasCheated = true;
            currentGame.tradeNotifications = false;
        }

        if(tmpNewGameCustomMapData != null) {
            currentGame.offlineMode = true;
            currentGame.hasCheated = true;
            currentGame.tradeNotifications = false;
        }

        retainedPaths = {};
        retainedPathsCounter = 0;
        shouldUpdateCollissionMap = true;
        buildingUpdateCycle = true;
        retainedUsage = {};

        riotingWarned = false;
        anarchyWarned = false;
        famineWarned = false;
        noWaterWarned = false;
        shoreUpdateTurn = true;

        if(!currentGame.offlineMode && !currentGame.isSubregion) {
            isCreatingNewOnlineGame = true;

            connectToSocketsIfNecessary();
            registerColonyId();
            
        }

        setupResourceLedger();

        setMapType();

        Scroll2d.setMapDims(width,height);

        selectedBuilding = null;
        selectedVehicle = [];
        selectedResource = null;
        selectedColonist = null;
        selectedPassable = null;

        pendingBuildX = null;
        pendingBuildY = null;
        queuedBuildings = undefined;
        queuedBuilding = null;
        queuedBuildingBlocked = false;
        
        createCollisionReference();
        
        var i;
        var firstBuilding = null;
        var buildingX = Math.floor(currentGame.width / 2);
        var buildingY = Math.floor(currentGame.height / 2);

        if(tmpNewGameCustomMapData != null) {
            buildingX = tmpNewGameCustomMapData.startX;
            buildingY = tmpNewGameCustomMapData.startY;
        }
    
        Scroll2d.setZoomLevel(1 / renderScaleFactor);
        Scroll2d.centerOnCoord(buildingX,buildingY);

        var buildingDef,rndX,rndY,randomBuilding;
        
        
        if(civDef.startingBuilding != null) {
            buildingDef = getBuildingDefByName(civDef.startingBuilding);

            if(buildingDef) {
                firstBuilding = new Building(buildingDef,buildingX,buildingY,getRegionOrCity().localPlayerId);

                updateBuildingCollisionPoints(firstBuilding,150);

                freeRefNukeTurn = true;

                currentGame.buildings.push(firstBuilding);
                shouldUpdateCollissionMap = true;

                currentGame.centerBuildingId = firstBuilding.id;
            }
            
            
        }

        if(!workingMapType) {
            setMapType();
        }

        if(!workingMapType) {
            workingMapType = ColonyGame.mapTypes[0];
        }

        if(workingMapType.explosionDisasters != null) {
            for(i = 0; i < workingMapType.explosionDisasters.length; i++) {
                currentGame.disasterCounters[workingMapType.explosionDisasters[i].name] = randomIntFromInterval(0,workingMapType.explosionDisasters[i].frequency);
            }
        }


        // random starting buildings 
        for(i = 0; i < workingMapType.startingBuildings.length; i++) {



            buildingDef = getBuildingDefByName(workingMapType.startingBuildings[i]);

            rndX = randomIntFromInterval(2,currentGame.width - 2);
            rndY = randomIntFromInterval(2,currentGame.height - 2);

            if(!buildingDef) {
                continue;
            }
            
            randomBuilding = new Building(buildingDef,rndX,rndY,getRegionOrCity().localPlayerId);

            if(firstBuilding == null) {
                firstBuilding = randomBuilding;
            }

            if(buildingDef.canFlip) {
                if(randomIntFromInterval(0,1) == 1) {
                    randomBuilding.flipped = true;
                }
            }

            updateBuildingCollisionPoints(randomBuilding,150);

            freeRefNukeTurn = true;

            currentGame.buildings.push(randomBuilding);
            shouldUpdateCollissionMap = true;

        }

        if(currentGame.isSubregion) {
            fillOutConnectingEdges();

        }

        // first see if map is an ocean/island map
        if(workingMapType.oceanTile && !tmpNewGameCustomMapData) {
            createOcean(workingMapType.oceanTile,buildingX,buildingY,8);
        }

        if(currentGame.isSubregion && currentSubcityRef && currentRegion && currentRegion.waterTemplateData) {
            createRiverFromTemplateData(workingMapType.riverTile,buildingX,buildingY,8,currentRegion.waterTemplateData,function(){
                setTimeout(function(){
                    keepContinuingNewGameMapGen(civDef,width,height,resourceLevel,buildingX,buildingY);
                },500);
            },currentSubcityRef.x * 50,currentSubcityRef.y * 50,currentSubcityRef.size,currentSubcityRef.size);

            return;
        } else {
            // then see if this map has a river 
            if(resourceLevel > 0 && workingMapType.riverTile && !tmpNewGameCustomMapData) {

                createRiver(workingMapType.riverTile,workingMapType.riverPosition,buildingX,buildingY,8);
                keepContinuingNewGameMapGen(civDef,width,height,resourceLevel,buildingX,buildingY);
                return;
            }
                
        }

        keepContinuingNewGameMapGen(civDef,width,height,resourceLevel,buildingX,buildingY);
    }

    function keepContinuingNewGameMapGen(civDef,width,height,resourceLevel,buildingX,buildingY) {
        var i,j,len;
        var rndX,rndY;
        buildingUpdateCycle = true;

        if(tmpNewGameCustomMapData == null) {

            resetCollisionReference();


            for(i = 0, len = currentGame.mapResources.length; i < len; i++) {
                updateMapResource(currentGame.mapResources[i]);
            }

            for(i = 0; i < workingMapType.terrainFeatures.length; i++) {

                var terrainCount = Math.ceil(workingMapType.terrainFeatures[i].abundance * resourceLevel);
                var terrainDef = getTerrainDefByName(workingMapType.terrainFeatures[i].name);

                for(j = 0; j < terrainCount; j++) {
                    
                    if(workingMapType.terrainFeatures[i].outterEdges && workingMapType.terrainFeatures[i].outterEdges == true) {
                        var useSide = randomIntFromInterval(0,3);

                        // top
                        if(useSide == 0) {
                            rndX = randomIntFromInterval(2,currentGame.width - 2);
                            rndY = randomIntFromInterval(2,12);
                        }

                        // right
                        if(useSide == 1) {
                            rndX = randomIntFromInterval(currentGame.width - 12,currentGame.width - 2);
                            rndY = randomIntFromInterval(2,currentGame.height - 2);
                        }

                        // bottom
                        if(useSide == 0) {
                            rndX = randomIntFromInterval(2,currentGame.width - 2);
                            rndY = randomIntFromInterval(currentGame.height - 12,currentGame.height - 2);
                        }

                        // left
                        if(useSide == 1) {
                            rndX = randomIntFromInterval(2,12);
                            rndY = randomIntFromInterval(2,currentGame.height - 2);
                        }
                    } else {
                        rndX = randomIntFromInterval(2,currentGame.width - 2);
                        rndY = randomIntFromInterval(2,currentGame.height - 2);
                    }

                    

                    if(!checkForGeneralBlockage(terrainDef,rndX,rndY)) {

                        var resourceItem = new MapResource(terrainDef,rndX,rndY);
                        freeRefNukeTurn = true;
                        updateBuildingCollisionPoints(resourceItem,150,true);
                        currentGame.mapResources.push(resourceItem);
                        shoreUpdateTurn = true;
                    } 
                }
            }

        } else {
            insertCustomMapTerrainIntoGame(currentGame,tmpNewGameCustomMapData);
        }

        // setup civilization resource level mods

        if(!currentGame.isSubregion || currentGame.mpRegionPlanetCharter) {
            if(civDef.startingResourceModifiers) {
                for(i = 0; i < civDef.startingResourceModifiers.length; i++) {

                    modifyResourceAmount(civDef.startingResourceModifiers[i].name,civDef.startingResourceModifiers[i].modifier,false,"Initial");
        
                    if(currentGame.resources[civDef.startingResourceModifiers[i].name].amount < 0) {
                        modifyResourceAmount(civDef.startingResourceModifiers[i].name,0,true,"Initial");
                    }
                }
            }
            

            // setup map resource level mods
            for(i = 0; i < workingMapType.startingResourceModifiers.length; i++) {

                modifyResourceAmount(workingMapType.startingResourceModifiers[i].name,workingMapType.startingResourceModifiers[i].modifier,false,"Initial");

                if(currentGame.resources[workingMapType.startingResourceModifiers[i].name].amount < 0) {
                    modifyResourceAmount(workingMapType.startingResourceModifiers[i].name,0,true,"Initial");
                }
            }
        }
        

        // goose up starting colonists 
        createNewPerson(null,civDef.startingColonists,currentGame);


        // goose up starting vehicles
        for(i = 0; i < civDef.startingVehicles.length; i++) {

            var freedomV = getFreeSpaceAroundTile(buildingX,buildingY,3);

            if(freedomV.length > 0) {
                var vDef = getVehicleDefByName(civDef.startingVehicles[i]);
                
                if(vDef.requiresTech != null) {
    
                    var notAvailable = false;
    
                    for(j = 0; j < vDef.requiresTech.length; j++) {
    
    
                        var techParts = vDef.requiresTech[j].split("|");
    
                        var hasThisOne = false;
    
                        for(var k = 0; k < techParts.length; k++) {
                            if(getGameTechs()[techParts[k]]) {
                                hasThisOne = true;
                            }
                        }
    
                        if(!hasThisOne) {
                            notAvailable = true;
                        }
    
                    }
    
                    if(notAvailable) {
                        continue;
                    }
                }
                
                var useIndex = randomIntFromInterval(0,freedomV.length - 1);
    
                var freshVehicle = new Vehicle(vDef,freedomV[useIndex][0],freedomV[useIndex][1],getRegionOrCity().localPlayerId);
                currentGame.vehicles.push(freshVehicle);
            }

            

        }
        
        if(!getRegionOrCity().offlineMode) {
            setTimeout(refreshMarketPrices,600);
        }
        

        createCollisionReference();
        
        updateUtilityGrid();

        Scroll2d.forceSceneChange();

        Scroll2d.setZoomLevel(1 / renderScaleFactor);

        Scroll2d.centerOnCoord(buildingX,buildingY);

        setCenterMapIcon();

        webAppCore.clearSplash();

        vehiclePathOrders = {};
        colonistPathOrders = {};

        window.focus();

        if(currentGame.isSubregion) {
            currentFileName = currentSubcityRef.filename;
        } else {
            currentFileName = cleanFileName(currentGame.name) + "." + ColonyGame.meta.fileExtension;
        }

        

        var welcomeMessageToUse = civDef.welcomeMessage;

        if(tmpNewGameCustomMapData == null) {
            var pdef = getPlanetDefByName(tmpNewMapType);

            if(!pdef) {
                pdef = ColonyGame.mapTypes[0];
                tmpNewMapType = pdef.name;
            }

            if(pdef.welcomeOverride) {
                welcomeMessageToUse = pdef.welcomeOverride;
            }
    
            webAppCore.showAlertWithTitle(getString(welcomeMessageToUse),name);
            
        } else {
            webAppCore.showAlertWithTitle(tmpNewGameCustomMapData.description,tmpNewGameCustomMapData.name);
        }
        

        generalSaveGame();

        createSidebar();
        drawSidebar();

        setupMenuOptions();
        
        initSoundtrack();

        Scroll2d.forceSceneChange();

        setWeather();

        tmpNewGameCustomMapData = null;

        createLocalServer();
        joinLocalNetworks();

        chatSetupQuick();

        setColonyThemeColor();

        setTimeout(Scroll2d.forceSceneChange(),500);
    }

    function unlockStartingTechsForGameData(gameData) {
        var i,j;

        for(i = 0; i < ColonyGame.races.length; i++) {
            if(ColonyGame.races[i].name == gameData.defaultRace) {
                if(ColonyGame.races[i].startingTechs != null) {
                    for(j = 0; j < ColonyGame.races[i].startingTechs.length; j++) {
                        gameData.unlockedTechs[ColonyGame.races[i].startingTechs[j]] = new Date().getTime();
                    }
                }
            }
            
        }

        for(i = 0; i < ColonyGame.civilizations.length; i++) {
            if(ColonyGame.civilizations[i].name == gameData.civilization) {
                if(ColonyGame.civilizations[i].startingTechs != null) {
                    for(j = 0; j < ColonyGame.civilizations[i].startingTechs.length; j++) {
                        gameData.unlockedTechs[ColonyGame.civilizations[i].startingTechs[j]] = new Date().getTime();
                    }
                }
            }
            
        }

        for(i = 0; i < ColonyGame.mapTypes.length; i++) {
            if(ColonyGame.mapTypes[i].name == gameData.mapType) {
                if(ColonyGame.mapTypes[i].startingTechs != null) {
                    for(j = 0; j < ColonyGame.mapTypes[i].startingTechs.length; j++) {
                        gameData.unlockedTechs[ColonyGame.mapTypes[i].startingTechs[j]] = new Date().getTime();
                    }
                }
            }
            
        }
    }

    function EdgeBuildTile(x,y,tile,type) {
        this.x = parseInt(x);
        this.y = parseInt(y);
        this.tile = tile;
        this.type = type;
    }

    function EdgeTile(tX,tY,subX,subY,tile,type) {
        this.regionX = parseInt(tX);
        this.regionY = parseInt(tY);
        this.subRegionX = parseInt(subX);
        this.subRegionY = parseInt(subY);
        
        if(this.regionX > 50) {
            this.regionX -= 50;
            this.subRegionX++;
        }

        if(this.regionY > 50) {
            this.regionY -= 50;
            this.subRegionY++;
        }

        this.tile = tile;
        this.type = type;
    }

    function syncRegionMetroAreas() {
        if(currentGame.isRegion) {
            for(var i = 0; i < currentGame.subRegions.length; i++) {
                var sr = currentGame.subRegions[i];

                if(!sr.metroAreaDistrict) {
                    sr.metroAreaDistrict = 0;
                }

                if(sr.metroAreaDistrict == 0) {
                    var touchingSubcities = getSurroundingSubcities(sr);

                    var useCity = null;

                    for(var j = 0; j < touchingSubcities.length; j++) {
                        var tc = touchingSubcities[j];

                        if(tc.metroAreaDistrict && tc.metroAreaDistrict > 0) {
                            if(!useCity) {
                                useCity = tc;
                            } else {
                                if(tc.population && tc.population > useCity.population) {
                                    useCity = tc;
                                }
                            }
                        }
                    }

                    if(useCity) {
                        sr.metroAreaDistrict = useCity.metroAreaDistrict;
                    } else {
                        currentGame.metroAreaCounter++;
                        sr.metroAreaDistrict = currentGame.metroAreaCounter;
                    }
                }
            }
        }
    }

    function getSurroundingSubcities(subcity) {
        var x1 = subcity.x;
        var y1 = subcity.y;
        var x2 = subcity.x;
        var y2 = subcity.y;

        if(subcity.size == 100) {
            x2 = subcity.x + 1;
            y2 = subcity.y + 1;
        }

        var useData = getRegionOrCity();
        var touchingCities = [];

        for(var i = 0; i < useData.subRegions.length; i++) {
            var sr = useData.subRegions[i];

            if(sr == subcity) {
                continue;
            }

            // check top edge 
            if(sr.size == 100) {
                if(sr.x >= x1 - 1 && sr.x <= x2) {
                    if(sr.y == y1 - 2) {
                        touchingCities.push(sr);
                        continue;
                    }
                }
            } else {
                if(sr.x >= x1 && sr.x <= x2) {
                    if(sr.y == y1 - 1) {
                        touchingCities.push(sr);
                        continue;
                    }
                }
            }

            // check bottom edge 
            if(sr.size == 100) {
                if(sr.x >= x1 - 1 && sr.x <= x2) {
                    if(sr.y == y2 + 1) {
                        touchingCities.push(sr);
                        continue;
                    }
                }
            } else {
                if(sr.x >= x1 && sr.x <= x2) {
                    if(sr.y == y2 + 1) {
                        touchingCities.push(sr);
                        continue;
                    }
                }
            }

            // check left edge 
            if(sr.size == 100) {
                if(sr.x == x1 - 2) {
                    if(sr.y >= y1 - 1 && sr.y <= y2) {
                        touchingCities.push(sr);
                        continue;
                    }
                }
            } else {
                if(sr.x == x1 - 1) {
                    if(sr.y >= y1 && sr.y <= y2) {
                        touchingCities.push(sr);
                        continue;
                    }
                }
            }

            // check right edge 
            if(sr.size == 100) {
                if(sr.x == x2 + 1) {
                    if(sr.y >= y1 - 1 && sr.y <= y2) {
                        touchingCities.push(sr);
                        continue;
                    }
                }
            } else {
                if(sr.x == x2 + 1) {
                    if(sr.y >= y1 && sr.y <= y2) {
                        touchingCities.push(sr);
                        continue;
                    }
                }
            }
        }

        return touchingCities;
    }

    function getEdgePartsForRegionCoordinate(x,y,side) {
        if(!currentGame.isSubregion || !currentSubcityRef) {
            return [];
        }

        var useThis = getRegionOrCity();

        if(!useThis) {
            return [];
        }

        var edges = [];

        for(var i = 0; i < useThis.subRegions.length; i++) {

            var sr = useThis.subRegions[i];

            if(!sr) {
                continue;
            }

            if(!sr.edgeTiles) {
                sr.edgeTiles = {
                    "n": [],
                    "s": [],
                    "e": [],
                    "w": []
                };
            }

            if(sr.edgeTiles && sr.edgeTiles[side]) {
                for(var j = 0; j < sr.edgeTiles[side].length; j++) {
                    var et = sr.edgeTiles[side][j];

                    if(et.regionX == null || et.regionY == null) {
                        continue;
                    }

                    if(et.subRegionX == x && et.subRegionY == y) {
                        edges.push(et);
                    }
                }
            }
        }

        return edges;
    }

    function handleIdleRegionalResourceConsumption() {
        if(!currentGame.isSubregion || !currentSubcityRef) {
            return;
        }

        if(!currentSubcityRef.idleResourcesUsed) {
            return;
        }

        for(var i = 0, len = currentGame.mapResources.length; i < len; i++) {
            var res = currentGame.mapResources[i];
            var def = res.playDef;

            if(!def) {
                res.playDef = getTerrainDefByName(res.def);
                def = res.playDef;
            }

            if(currentSubcityRef.idleResourcesUsed[def.provides] && currentSubcityRef.idleResourcesUsed[def.provides] > 0) {

                if(res.inventory > currentSubcityRef.idleResourcesUsed[def.provides]) {
                    res.inventory -= currentSubcityRef.idleResourcesUsed[def.provides];
                    currentSubcityRef.idleResourcesUsed[def.provides] = 0;
                } else {
                    currentSubcityRef.idleResourcesUsed[def.provides] -= res.inventory;
                    res.inventory = 0;
                }

            }

        }

    }

    function fillOutConnectingEdges() {
        if(!currentGame.isSubregion || !currentSubcityRef) {
            return;
        }

        var regX = currentSubcityRef.x;
        var regY = currentSubcityRef.y;

        var allEdgeTiles = [];
        var i;
        var curTiles = [];

        var sizeMod = 0;

        if(currentGame.width > 50) {
            sizeMod = 1;
        }

        // top side
        curTiles = getEdgePartsForRegionCoordinate(regX,regY - 1,"s");
        for(i = 0; i < curTiles.length; i++) {
            allEdgeTiles.push(new EdgeBuildTile(curTiles[i].regionX,0,curTiles[i].tile,curTiles[i].type));
        }

        if(sizeMod == 1) {
            curTiles = getEdgePartsForRegionCoordinate(regX + 1,regY - 1,"s");
            for(i = 0; i < curTiles.length; i++) {
                allEdgeTiles.push(new EdgeBuildTile(curTiles[i].regionX + 50,0,curTiles[i].tile,curTiles[i].type));
            }
        }

        // right side 
        curTiles = getEdgePartsForRegionCoordinate(regX + 1 + sizeMod,regY,"w");
        for(i = 0; i < curTiles.length; i++) {
            allEdgeTiles.push(new EdgeBuildTile(currentGame.width,curTiles[i].regionY,curTiles[i].tile,curTiles[i].type));
        }

        if(sizeMod == 1) {
            curTiles = getEdgePartsForRegionCoordinate(regX + 1 + sizeMod,regY + 1,"w");
            for(i = 0; i < curTiles.length; i++) {
                allEdgeTiles.push(new EdgeBuildTile(currentGame.width,curTiles[i].regionY + 50,curTiles[i].tile,curTiles[i].type));
            }
        }

        // bottom side
        curTiles = getEdgePartsForRegionCoordinate(regX,regY + 1 + sizeMod,"n");
        for(i = 0; i < curTiles.length; i++) {
            allEdgeTiles.push(new EdgeBuildTile(curTiles[i].regionX,currentGame.height,curTiles[i].tile,curTiles[i].type));
        }

        if(sizeMod == 1) {
            curTiles = getEdgePartsForRegionCoordinate(regX + 1,regY + 1 + sizeMod,"n");
            for(i = 0; i < curTiles.length; i++) {
                allEdgeTiles.push(new EdgeBuildTile(curTiles[i].regionX + 50,currentGame.height,curTiles[i].tile,curTiles[i].type));
            }
        }

        // left side
        curTiles = getEdgePartsForRegionCoordinate(regX - 1,regY,"e");
        for(i = 0; i < curTiles.length; i++) {
            allEdgeTiles.push(new EdgeBuildTile(0,curTiles[i].regionY,curTiles[i].tile,curTiles[i].type));
        }

        if(sizeMod == 1) {
            curTiles = getEdgePartsForRegionCoordinate(regX - 1,regY + 1,"e");
            for(i = 0; i < curTiles.length; i++) {
                allEdgeTiles.push(new EdgeBuildTile(0,curTiles[i].regionY + 50,curTiles[i].tile,curTiles[i].type));
            }
        }

        for(i = 0; i < allEdgeTiles.length; i++) {
            if(allEdgeTiles[i].type == "passable") {
                var uX = parseInt(allEdgeTiles[i].x);
                var uY = parseInt(allEdgeTiles[i].y);

                var uType = allEdgeTiles[i].tile;

                if(!currentGame.finishedPassableNonUpdatables[uType]) {
                    currentGame.finishedPassableNonUpdatables[uType] = {};
                }

                if(!currentGame.finishedPassableNonUpdatables[uType][uX]) {
                    currentGame.finishedPassableNonUpdatables[uType][uX] = [];
                }

                if(currentGame.finishedPassableNonUpdatables[uType][uX].indexOf(uY) > -1) {
                    continue;
                }

                if(isTilePassable(uX,uY,true)) {
                    currentGame.finishedPassableNonUpdatables[uType][uX].push(uY);
                    shouldUpdateCollissionMap = true;
                }
            }
        }

    }

    function getSubregionByCoord(x,y) {
        var useData = getRegionOrCity();

        if(!useData.isRegion) {
            return null;
        }

        var hoverCity = null;

        for(var i = 0; i < useData.subRegions.length; i++) {

            var sr = useData.subRegions[i];
            var size = 1;
            if(sr.size == 100) {
                size = 2;
            }

            for(var sX = 0; sX < size; sX++) {
                for(var sY = 0; sY < size; sY++) {
                    var usX = sr.x + sX;
                    var usY = sr.y + sY;

                    if(usX == x && usY == y) {
                        hoverCity = sr;
                        break;
                    }
                }

                if(hoverCity != null) {
                    break;
                }
            }

            if(hoverCity != null) {
                break;
            }
        }

        return hoverCity;
    }
    
    function Game(width,height,options) {

        var i;

        this.populationDistribution = {};

        this.statMods = {};

        this.createdRelCode = ColonyGame.meta.releaseCode;
        this.createdBuildVer = webAppCore.getAppVersion();
        this.saveRelCode = ColonyGame.meta.releaseCode;
        this.saveBuildVer = webAppCore.getAppVersion();

        this.currentFileSize = 0;
        this.buildingStatCycleCounter = 30;

        this.waterTemplateData = null;
        this.regionSquareTemplateImages = {};
        this.flag = new ColonyFlag();

        this.year = 0;
        this.period = 0;

        this.giftCapacity = 0;

        this.annualTradeIncome = 0;
        this.annualTradeLosses = 0;
        this.importExportTrend = [];
        this.utilitySources = {};

        this.simSyncCounter = 0;
        this.autosellCheckCounter = 0;

        this.mpRegionPlanetCharter = null;
        this.regionDistrictData = [];
        this.isMpRegionHolder = false;
        this.isRegion = false;
        this.isSubregion = false;
        this.hasLoadedChat = false;
        this.allowColoniae = false;

        this.isCleaningForSave = false;
        this.isSaving = false;

        this.regionalGDPTrend = [];
        this.regionalUnemploymentTrend = [];

        this.subcityGuid = 0;

        this.regionalGDPGrowthTrend = [];
        this.regionalGDPGrowthQuarterly = [];
        this.regionalGDPGrowthAnnually = [];

        this.regionalGDPGrowthQuarterlyAdjusted = [];
        this.regionalGDPAnuallyhQuarterlyAdjusted = [];
        this.regionalPriceIndex = [];
        this.regionalPriceIndexAnnual = [];

        this.metroAreaCounter = 0;
        this.metroAreaNameRef = {};

        // just for quick reference, also stored on server
        this.votingHistory = {};

        this.federationId = 0;
        this.federationName = null;
        this.federationCharter = null;

        this.parentRegionFile = null;
        this.subRegions = [];

        this.stage = 0;

        this.themeColor = "#b35900";

        this.localPlayerId = guid();
        this.playerNamesRef = {};

        if(webAppCore.isApeAppsLoggedIn()) {
            if(!this.playerNamesRef[this.localPlayerId]) {
                this.playerNamesRef[this.localPlayerId] = {
                    name: webAppCore.getApeAppsProfile().un,
                    color: this.themeColor,
                    resources: {},
                    utilities: {},
                    techs: {}
                };
            }
        }

        this.workerPolicy = 1;

        if(options) {
            this.mapType = options.mapType;
            this.defaultRace = options.defaultRace;
            this.civilization = options.civilization;
            this.offlineMode = options.offline;
            this.disableTax = options.disableTax;
            this.motherland = options.motherland;
            this.motherlandid = options.motherlandid;
            this.name = replaceAll(options.name, "\\", "");

            if(options.mapEditorDummy) {
                this.mem = true;
                this.mename = "New Map";
                this.meauthor = "";
                this.meurl = "";
                this.medescription = "";
            } else {
                this.mem = false;
                this.mename = null;
                this.meauthor = null;
                this.meurl = null;
                this.medescription = null;
            }
        } else {
            this.mapType = null;
            this.defaultRace = null;
            this.civilization = null;
            this.offlineMode = false;
            this.disableTax = true;
            this.motherland = null;
            this.motherlandid = 0;
            this.mem = false;
            this.mename = null;
            this.meauthor = null;
            this.meurl = null;
            this.medescription = null;
            this.name = null;
        }
        

        this.firstSave = true;
        this.cm = false;

        

        this.centerBuildingId = 0;

        this.sX = 0;
        this.sY = 0;
        this.gX = 0;
        this.gY = 0;

        this.livingWageRate = 0;

        this.timeOfDay = 9;

        //this.sadReasons = [];
        this.sadderReasons = {};

        this.totalBirths = 0;
        this.totalDeaths = 0;
        this.deadTourists = 0;
        this.totalTourists = 0;

        this.entertainmentTickPhase = 0;
        this.totalTourismIncome = 0;
        this.totalEntertainmentIncome = 0;
        
        this.monthTicker = 0;

        this.disasterCounters = {};

        this.immigrantSources = [];

        this.rewardCounter = 0;
        this.showRewardOption = false;

        this.paidWindfallTaxB = true;
        this.paidWindfallTaxC = true;
        this.paidWindfallTaxD = true;

        this.destroyedBuildings = 0;

        this.autoBudget = false;

        this.governmentLevel = 0;


        

        this.apeAppsUsername = null;

        if(this.offlineMode) {
            this.tradeNotifications = false; 
        } else {
            this.tradeNotifications = true;

            if(webAppCore.isApeAppsLoggedIn()) {
                this.apeAppsUsername = webAppCore.getApeAppsProfile().un;
            }
        }

        this.privateCharter = false;
        this.hasCheated = false;

        this.foodRationing = false;

        

        this.width = width;
        this.height = height;

        this.totalImmigration = 0;
        this.totalEmigration = 0;

        this.colonialTaxCollected = 0;
        this.colonies = 0;

        this.readOnlyMode = false;

        this.useCloud = false;

        if(webAppCore.isApeAppsLoggedIn() && webAppCore.getPlatform().market == "kongregate") {
            this.useCloud = true;
        }

        this.useCompression = defaultCompressionSetting;

        this.salaries = {};

        this.lastSaveTime = Date.now();

        this.creationDate = Date.now();
        this.isIndependent = false;
        this.independenceDay = null;
        this.motherlandCharter = null;
        
        this.colonyId = 0;
        this.stopImmigration = false;
        this.stopTourism = false;
        this.foreignPayrollTotals = 0;
        this.motherlandTaxesPaid = 0;

        this.totalPlayTime = 0;

        this.merevision = 0;
        this.mestartx = 50;
        this.mestarty = 50;

        this.apiKey = 0;

        this.rescs = null;

        this.monthEndCounter = 0;
        this.motherlandPendingPayroll = 0;

        this.charter = 0;

        this.buildings = [];
        this.vehicles = [];
        //this.colonists = [];
        this.passableNonUpdatables = [];
        this.mapResources = [];
        this.gifts = [];
        this.mail = [];
        //this.tourists = [];
        //this.diplomats = [];

        this.touristCount = 0;

        this.finishedPassableNonUpdatables = {};
        
        this.payrollRate = 0.25;
        this.taxLevel = 100;
        this.salesPitch = "";

        this.resources = {};
        this.utilities = {};

        this.foreignContactReference = {};
        this.pendingForeignEmbassies = [];

        this.tradeEmbargo = false;
        this.immigrationEmbargo = false;

        //resetVirtualAvatars(this);

        this.historicStats = {
            "population": [],
            "age": [],
            "savings": [],
            "gdp": [],
            "unemployment": [],
            "jobs": [],
            "health": [],
            "iq": [],
            "homeless": [],
            "approval": [],
            "workforce": [],
            "mediansalary": [],
            "retiredpop": [],
            "students": [],
            "newGDP": [],
            "ndp": [],
            "gdpGrowth": [],
            "gdpGrowthQuarterly": [],
            "gdpGrowthAnnually": [],
            "priceIndex": [],
            "gdpQuarterlyAdjusted": [],
            "gdpAnuallyAdjusted": [],
            "priceIndexAnualBasis": []
        };

        this.populationStats = {};

        for(var r = 0; r < ColonyGame.races.length; r++) {
            this.populationStats[ColonyGame.races[r].name] = 0;
        }

        for(i = 0; i < ColonyGame.utilities.length; i++) {
            this.utilities[ColonyGame.utilities[i].name] = {};
            this.utilities[ColonyGame.utilities[i].name].usage = 0;
            this.utilities[ColonyGame.utilities[i].name].capacity = 0;
            this.utilities[ColonyGame.utilities[i].name].domesticUsage = 0;
            this.utilities[ColonyGame.utilities[i].name].domesticCapacity = 0;
        }
        
        for(i = 0; i < ColonyGame.resources.length; i++) {
            this.resources[ColonyGame.resources[i].name] = {};
            this.resources[ColonyGame.resources[i].name].amount = ColonyGame.resources[i].starting;
            this.resources[ColonyGame.resources[i].name].capacity = ColonyGame.resources[i].max;
            this.resources[ColonyGame.resources[i].name].price = ColonyGame.resources[i].basePrice;
            this.resources[ColonyGame.resources[i].name].previous = 0;
            this.resources[ColonyGame.resources[i].name].storageCapacity = 0;
            this.resources[ColonyGame.resources[i].name].domesticCapacity = 0;
            this.resources[ColonyGame.resources[i].name].domesticAmount = 0;
            this.resources[ColonyGame.resources[i].name].unlocked = false;
            this.resources[ColonyGame.resources[i].name].serverId = 0;
            this.resources[ColonyGame.resources[i].name].lastTrade = 0;
            this.resources[ColonyGame.resources[i].name].autosell = false;
        }

        this.idCounter = 0;
        this.getId = getIdNumber;

        this.availableShelters = 0;
        this.availableTourism = 0;

        

        this.earthTaxCounter = 0;
        this.earthBackTax = 0;
        this.earthAssemblyRelations = 100;

        this.unlockedTechs = {};

        this.currentOccupationStats = {};
        this.currentOccupationPercents = {};

        unlockStartingTechsForGameData(this);
        
    }
    
    function rebuildMapResourceObject(dummy) {
        var freshResource = new MapResource(getTerrainDefByName(dummy.def),dummy.x,dummy.y,true);

        for(var prop in dummy) {
            freshResource[prop] = dummy[prop];
        }

        freshResource.name = freshResource.def;

        return freshResource;
    }
    
    function getResourceByServerId(id) {

        var gameRes = getGameResources();

        if(!gameRes) {
            return null;
        }

        for(var i = 0; i < ColonyGame.resources.length; i++) {
            if(!gameRes[ColonyGame.resources[i].name].serverId) {
                gameRes[ColonyGame.resources[i].name].serverId = 0;
            }

            if(!gameRes[ColonyGame.resources[i].name].lastTrade) {
                gameRes[ColonyGame.resources[i].name].lastTrade = 0;
            }

            if(gameRes[ColonyGame.resources[i].name].serverId == id) {
                return ColonyGame.resources[i];
            }
        }

        return null;
    }
    
    function MapResource(definition,x,y,isRebuild) {

        // properties
        this.dX = x;
        this.dY = y;
        this.def = definition.name;
        if(isRebuild) {
            this.id = 0;
        } else {
            this.id = parseInt(currentGame.getId());
        }
        this.inventory = definition.capacity;
        this.name = definition.name;
        this.occupiesTiles = [];
        this.x = x;
        this.y = y;

        this.spreadCounter = 0;
        this.spreadMax = 0;

        this.dc = 0;

        this.sf = -1;

        this.ul = false;

        if(definition.capacity == -1) {
            this.ul = true;
            this.inventory = 1;
        }

        this.fr = null;
        this.md = null;
        this.playDef = null;

        this.spriteFrame = 0;

        if(definition.spreadRate > 0) {
            this.spreadMax = randomIntFromInterval(1,definition.spreadRate);
        }

        // init
        if(definition.tileWidth > 1) {
            this.dX += (definition.tileWidth - 1);
        }
        
        if(definition.tileHeight > 1) {
            this.dY += (definition.tileHeight - 1);
        }
        
        this.occupiesTiles = getOccupiedTiles(this,true);
    }

    function setAwaitingPath(unit,type,value) {

        unit.a = 0;

        unit.isAwaitingPath = value;
        vehiclePathOrders[unit.id] = null;
    }

    function getAwaitingPath(unit) {
        return unit.isAwaitingPath;
    }

    var whackedVehicleKillArray;

    function rebuildVehicleObject(dummy) {
        var def = getVehicleDefByName(dummy.def);

        if(def == null) {
            whackedVehicleKillArray.push(dummy);
            return dummy;
        }

        var freshVehicle = new Vehicle(def,dummy.x,dummy.y,dummy.owner,true);

        var prop;

        for(prop in freshVehicle) {

            if(prop == "constructionQueue" || prop == "constructionCounter" || prop == "constructionPercentage" || prop == "constructionTotal" || prop == "constructionProgress") {
                
                continue;
            }

            if(dummy[prop] != undefined) {
                freshVehicle[prop] = dummy[prop];
            }
        }

        freshVehicle.name = freshVehicle.def +  " #" + freshVehicle.id;

        // renamed property fixer 5000
        if(dummy.inHarvestMode != undefined) {
            freshVehicle.iH = dummy.inHarvestMode;
        }

        return freshVehicle;
    }
    
    function Vehicle(definition,x,y,owner,isRebuild) {

        // properties
        this.breakCount = 0;
        this.breakThreshold = randomIntFromInterval(0,100);
        this.capacity = definition.capacity;
        this.choppingDestination = null;

        this.dX = x;
        this.dY = y;
        this.def = definition.name;
        this.destinationChanges = 0;
        this.faceFrame = 0;
        this.giveUpCount = 0;
        this.harvests = definition.harvests;
        if(isRebuild) {
            this.id = 0;
        } else {
            this.id = parseInt(currentGame.getId());
        }
        
        this.inBuildingMode = false;

        this.isCashed = false;
        this.isDepositing = false;
        this.isInjesting = 0;

        this.iH = false;

        this.lastX = x;
        this.lastY = y;
        this.mq = [];
        this.name = definition.name + " #" + this.id;
        this.onChoppingBlock = false;
        this.owner = owner;
        this.pX = null;
        this.pY = null;
        this.stepCount = 0;
        this.storage = 0;
        this.tX = x;
        this.tY = y;
        this.x = x;
        this.y = y;

        this.rdX = -1;
        this.rdY = -1;

        this.lv = [];
        this.lc = [];
        this.iv = 0;
        this.it = 0;

        // next construction cooldown
        this.ncc = 0;

        this.tc = 0;
        this.pd = null;
        this.ht = null;

        this.harvestAfterBuilding = false;
        
        this.blacklist = [];
        this.bBlacklist = [];

        this.isAwaitingPath = false;
        this.a = 0;

        this.brt = 0;

        this.grp = 1; // group count.  1 or 0 is 1
    }

    function rebuildBuildingObject(dummy) {

        if(!dummy) {
            return null;
        }

        var def = getBuildingDefByName(dummy.def);

        if(!def) {
            return null;
        }

        var freshBuilding = new Building(def,dummy.x,dummy.y,dummy.owner,true);

        var prop;

        for(prop in dummy) {

            if(prop == "generates" || prop == "generateTime" || prop == "generateAmount" || prop == "students" || prop == "patrons" || prop == "patients" || prop == "workers" || prop == "residents" || prop == "tourists" || prop == "prisoners" || prop == "nw") {
                continue;
            }

            if(prop == "cg") {
                if(dummy.cg != null) {
                    var cg = new ColGenItem();
                    cg.c = dummy.cg.c;
                    cg.m = dummy.cg.m;
                    cg.p = dummy.cg.p;

                    freshBuilding.cg = cg;

                    continue;
                }
                
            }

            if(prop == "isUnderConstruction") {
                freshBuilding.iuc = dummy.isUnderConstruction;
            }

            if(prop == "consumptionCounter") {
                freshBuilding.cc = dummy.consumptionCounter;
            }

            if(prop == "constructionQueue" || prop == "constructionCounter" || prop == "constructionPercentage" || prop == "constructionTotal" || prop == "constructionProgress") {

                if(prop == "constructionCounter") {

                    if(dummy.isUnderConstruction || dummy.iuc || dummy.constructionQueue != null) {
                        freshBuilding.c = new ConstructionItem();

                        freshBuilding.c.c = dummy.constructionCounter;
                        freshBuilding.c.p = dummy.constructionPercentage;
                        freshBuilding.c.t = dummy.constructionTotal;
                        freshBuilding.c.pr = dummy.constructionProgress;

                        if(dummy.constructionQueue != null) {
                            freshBuilding.c.q.push(dummy.constructionQueue.name);
                        }
                    }
                }

                continue;
            }

            var value = dummy[prop];

            if(prop == "x" || prop == "y") {
                value = parseInt(dummy[prop]);
            }

            freshBuilding[prop] = value;
        }

        return freshBuilding;
    }

    function flipBuilding(building) {
        var def = getBuildingDefByName(building.def);

        if(!def.canFlip) {
            building.flipped = false;
            setUpMinidefForBuilding(building,false,true);
            return;
        }

        building.flipped = !building.flipped;

        setUpMinidefForBuilding(building,false,true);
        building.occupiesTiles = getOccupiedTiles(building);
    }

    function ConstructionItem() {
        this.c = 0;
        this.p = 0;
        this.pr = null;
        this.q = [];
        this.t = 0;
    }

    function ColGenItem() {
        this.c = 0;
        this.m = 0;
        this.p = 0;
    }
    
    function ColonyFlag() {
        this.bg = "#0D47A1";
        this.parts = [];
        this.logos = [];

        // start with random parts
        this.parts.push(new ColonyFlagPart());
        this.logos.push(new ColonyFlagLogo());
    }

    function ColonyFlagPart() {
        this.img = ColonyGame.flagParts[randomIntFromInterval(0,ColonyGame.flagParts.length - 1)];
        this.color = "#f44336";
    }

    function ColonyFlagLogo() {
        this.img = ColonyGame.flagLogos[randomIntFromInterval(0,ColonyGame.flagLogos.length - 1)];
        this.color = "#FFCA28";
        this.scale = 1;
        this.pos = "C";
    }

    function Building(definition,x,y,owner,isRebuild) {

        // base properties
        this.availableHomes = 0;
        this.bedsAvailable = 0;
        this.os = 0;

        if(definition.colGenRate && definition.colGenRate != null && definition.colGenRate > 0) {
            this.cg = new ColGenItem();
        } else {
            this.cg = null;
        }

        this.c = null;

        this.sf = -1;

        this.cc = 0;
        this.dX = x;
        this.dY = y;
        this.def = definition.name;

        // generation counter
        this.gc = 0;

        // generation percentage
        this.gp = 0;

        // number currently working
        //this.nw = 0;

        this.embassyFor = 0;

        this.isBeingRemoved = false;

        if(isRebuild) {
            this.id = 0;
        } else {
            this.id = parseInt(currentGame.getId());
        }

        this.iuc = false;
        this.jobsAvailable = 0;
        this.lowPowerMode = false;
        this.name = definition.name + " #" + this.id;
        this.ncm = false;
        this.occupiesTiles = [];
        this.ofe = false;
        this.oft = false;
        this.ofm = false;
        this.owner = owner;
        //this.patients = [];
        //this.patrons = [];
        //this.tourists = [];
        //this.residents = [];
        //this.students = [];
        //this.prisoners = [];
        this.smeltCounter = 0;

        // someone working
        this.sw = false;

        this.wcc = 0;
        //this.workers = [];
        this.x = x;
        this.y = y;
        this.wc = null;

        this.spriteFrame = 0;

        this.condition = 100;

        this.deactivated = false;

        this.customText = "";


        // init 
        if(definition.requiresFuel != null) {
            this.cc = definition.requiresFuel.rate;
        }

        if(definition.tileWidth > 1) {
            this.dX += (definition.tileWidth - 1);
        }
        
        if(definition.tileHeight > 1) {
            this.dY += (definition.tileHeight - 1);
        }

        this.occupiesTiles = getOccupiedTiles(this);

        
        this.flipped = false;

        this.fr = null;
        this.md = null;

        // low power items
        this.lpiz = [];

        // new guest usage count
        this.buG = 0;

        // new student usage count
        this.buS = 0;

        // new medical usage count
        this.buM = 0;

        // building guest rating
        this.brE = 0;

        // building medical rating 
        this.brM = 0;

        // building school rating 
        this.brS = 0;

        // open medical count
        this.ocM = 0;

        // open school count 
        this.ocS = 0;

        // open entertainment count 
        this.ocE = 0;

        // has open side
        this.hOS = false;

        // overall building IQ rating
        this.orIQ = 0;

        // building workers count
        this.buW = 0;

        // building jobs available 
        this.ocJ = 0;

        // building employed residents
        this.bER = 0;

        // building average commute
        this.bAvC = 0;

        // building commute rating
        this.brCT = 0;

        // building residents count
        this.bRC = 0;

        // housing slots available
        this.osH = 0;

        // land value rating
        this.bRLV = 0;

        // open tourist count
        this.ocT = 0;

        // filled tourist count
        this.buT = 0;

        // tourists available
        this.bTA = 0;

        // total resident salary
        this.bsTS = 0;

        // average resident salary
        this.bsAS = 0;

        // structure safety rating
        this.brSAF = 0;

        // structure workforce rating
        this.brWF = 0;
    }

    var currentWorkingAgePercentage;

    function MiniRenderDef(width,height,tile,smeltTime,transModeColor,staticRender,refines,acceptsWorkers,offlineTile,lightEffects,requiresWorkers,generateTime,generates,generateAmount,rIQ,pIQ,bldOver,occupation) {
        this.width = width;
        this.height = height;
        this.tile = tile;
        this.smeltTime = smeltTime;
        this.transModeColor = transModeColor;
        this.staticRender = staticRender;
        this.refines = refines;
        this.offlineTile = offlineTile;
        this.lightEffects = lightEffects;

        this.acceptsWorkers = acceptsWorkers;
        this.requiresWorkers = requiresWorkers;
        this.generateTime = generateTime;
        this.generates = generates;
        this.generateAmount = generateAmount;

        this.canBuildOver = null;

        if(bldOver) {
            this.canBuildOver = bldOver;
        }

        this.rIQ = parseInt(rIQ);
        this.pIQ = parseInt(pIQ);

        this.occupation = occupation;
    }

    function Tile(x,y) {
        this.x = x;
        this.y = y;
    }

    function getOccupiedTiles(building,isTerrain) {
        var occupiedTiles = [];
        var def = null;

        var useWidth,useHeight;

        if(isTerrain) {
            def = getTerrainDefByName(building.def);
            useWidth = def.tileWidth;
            useHeight = def.tileHeight;
        } else {
            def = getBuildingDefByName(building.def);

            if(!def) {
                return [];
            }

            useWidth = def.tileWidth;
            useHeight = def.tileHeight;

            if(building.flipped) {
                useWidth = def.tileHeight;
                useHeight = def.tileWidth;
            }
        }

        if(def == null) {
            return [];
        }

        for(var oX = 0; oX < useWidth; oX++) {
            for(var oY = 0; oY < useHeight; oY++) {
                occupiedTiles.push(new Tile(building.x + oX,building.y + oY));
            }
        }

        return occupiedTiles;
    }

    function sendVehicleToChopShop(vehicle,building) {

        

        if(!getBuildingDefByName(building.def).isChopShop) {
            return;
        }

        var flying = false;

        var vdef = getVehicleDefByName(vehicle.def);

        if(vdef && vdef.isFlying) {
            flying = true;
        }

        var availableSpaces = getFreeSpacesAroundBuilding(building,1,false,false,flying);

        if(!availableSpaces || availableSpaces.length == 0) {
            return;
        }

        var destination = availableSpaces[randomIntFromInterval(0,availableSpaces.length - 1)];
        vehicle.onChoppingBlock = true;
        vehicle.dX = destination[0];
        vehicle.dY = destination[1];

        vehicle.choppingDestination = {x: destination[0],y: destination[1]};

        availableSpaces = null;
    }

    function hideSidebarIfSmall() {
        document.getElementById("sidebarCostInfoBox").style.display = "none";

        if(!desktopMode) {
            document.getElementById("sidebar").style.display = "none";
        }
    }
    
    function drawVehicle(vehicle,type) {

        if(!vehicle) {
            return;
        }

        if(currentViewBounds == null) {
            return;
        }

        if(gbtOpen || statsOpen) {
            return;
        }

        if(simulatedTileSize < 12) {
            return;
        }

        if(vehicle.tc > 0) {
            return;
        }


        if(vehicle.x < currentViewBounds.minX || vehicle.x > currentViewBounds.maxX) {
            if(vehicle.y < currentViewBounds.minY || vehicle.y > currentViewBounds.maxY) {
                if(vehicle != selectedColonist) {
                    return;
                }
            }
        }

        if(type == "vehicle" && vehicle.iv > 0) {

            return;
        }

        var useZ = 1;

        var drawAsset;
        var def = null;
        var i;

        if(vehicle.def && vehicle.def.tile != null) {
            drawAsset = vehicle.def.tile;
        } else {
            def = getVehicleDefByName(vehicle.def);

            if(!def) {
                return;
            }

            drawAsset = def.tile;
        }

        var assetToUse = getImageAsset(drawAsset,false,vehicle.faceFrame,null);

        if(!assetToUse) {
            return;
        }

        var cv = null;
        var chevColor;

        if(selectedVehicle != null && selectedVehicle.length > 0 && selectedVehicle.indexOf(vehicle) > -1) {
            if(def == null) {
                def = getVehicleDefByName(vehicle.def);
            }

            if(def.vehicleCarryCapacity > 0) {
                if(cv == null) {
                    cv = [];
                }

                for(i = 0; i < def.vehicleCarryCapacity; i++) {
                    chevColor = "#0D47A1";

                    if(i < vehicle.lv.length) {
                        chevColor = "#2196F3";
                    }

                    cv.push(new Scroll2d.Chevron(chevColor,null));
                }

            }

            if(def.colonistCarryCapacity > 0) {
                if(cv == null) {
                    cv = [];
                }

                for(i = 0; i < def.colonistCarryCapacity; i++) {
                    chevColor = "#1B5E20";

                    if(i < vehicle.lc.length) {
                        chevColor = "#4CAF50";
                    }

                    cv.push(new Scroll2d.Chevron(chevColor,null));
                }
            }
        }

        var useAsset = getImageAsset(drawAsset,null,vehicle.faceFrame,null);

        if(useAsset) {
            Scroll2d.drawSprite(useAsset,vehicle.x,vehicle.y,vehicle.tX,vehicle.tY,vehicle.stepCount,null,null,1,useZ,1,1,cv);
        }

        if(allowLighting && lastColorFilter != null) {
            if(type == "colonist") {
                Scroll2d.drawLight(vehicle.x,vehicle.y,0.5,"#ffffff",vehicle.tX,vehicle.tY,vehicle.stepCount,0.1);
            } else {
                Scroll2d.drawLight(vehicle.x,vehicle.y,1,"#ffffff",vehicle.tX,vehicle.tY,vehicle.stepCount);
            }
            
        }
    }

    function setUpMinidefForBuilding(building,isMapResource,forceRemake,useBldDef) {

        if(!building) {
            return;
        }

        if(forceRemake || building.md == null) {

            var tmpDef;
            
            var refines = null;

            var useLightEffect = null;

            var reqWorkers = null;
            var genTime = null;
            var genRate = null;
            var genAmt = null;

            if(isMapResource) {

                if(building.playDef == null) {
                    building.playDef = getTerrainDefByName(building.def.trim());
                }

                tmpDef = building.playDef;
            } else {
                if(useBldDef) {
                    tmpDef = useBldDef;
                } else {
                    tmpDef = getBuildingDefByName(building.def.trim());
                }
                
                if(tmpDef == null) {
                    return;
                }

                refines = tmpDef.refines;

                reqWorkers = tmpDef.requiresWorkers;
                genTime = tmpDef.generateTime;
                genRate = tmpDef.generates;
                genAmt = tmpDef.generateAmount;
            }

            if(tmpDef == null) {
                return;
            }

            var smeltTime = null;

            if(tmpDef.smelts != null) {
                smeltTime = tmpDef.smelts.time;
            }

            var useHeight = tmpDef.tileHeight;
            var useWidth = tmpDef.tileWidth;
            var useTile = tmpDef.tile[0];

            if(!isMapResource) {
                if(building.flipped) {
                    useHeight = tmpDef.tileWidth;
                    useWidth = tmpDef.tileHeight;
                    useTile = tmpDef.tile[0];
                }
            }

            var offlineTile = null;

            if(tmpDef.tile.length > 1) {
                offlineTile = tmpDef.tile[1];

                if(building.flipped) {
                    offlineTile = tmpDef.tile[1];
                }
            }

            if(tmpDef.lightEffects && tmpDef.lightEffects != null) {
                useLightEffect = tmpDef.lightEffects;
            }

            building.md = new MiniRenderDef(useWidth,useHeight,useTile,smeltTime,tmpDef.transModeColor,tmpDef.canRenderStatic,refines,tmpDef.acceptsWorkers,offlineTile,useLightEffect,reqWorkers,genTime,genRate,genAmt,tmpDef.requiresIQ,tmpDef.providesIQ,tmpDef.canBuildOver,tmpDef.occupation);
        }
    }

    function drawNewPassable(def,x,y,forceAlpha) {
        var useZ = 1;
        var passDef = passableTileRefs[def];
        var alpha = 1.0;
        var aniFrameToUse = 0;
        var tileToUse = passDef.tile[0];

        
        if(queuedBuilding != null) {
            alpha = 0.5;
        }

        if(transparencyMode == 1 || transparencyMode >= 3) {
            alpha = 0.25;
        }

        if(forceAlpha) {
            alpha = forceAlpha;
        }

        if(passDef.canRenderStatic && alpha == 1.0) {
            if(staticFrame) {
                
                var drawTileImage = getImageAsset(tileToUse,false,0,null);

                if(drawTileImage) {
                    Scroll2d.drawStaticTile(drawTileImage,x,y,useZ);
                }
                
            }
        } else {

            var spriteImage = getImageAsset(tileToUse,null,aniFrameToUse,null);

            if(spriteImage) {
                Scroll2d.drawSprite(spriteImage,x,y,null,null,undefined,undefined,undefined,alpha,useZ,passDef.tileWidth,passDef.tileHeight);
            }
        }

        if(allowLighting && passDef.lightEffects != null) {

            var isPowered = true;

            if(passDef.requiresUtility != null) {
                for(var j = 0; j < passDef.requiresUtility.length; j++) {
                    if(getGameUtilities()[passDef.requiresUtility[j].utility].usage > getGameUtilities()[passDef.requiresUtility[j].utility].capacity) {
                        isPowered = false;
                        break;
                    }  
                }
            }
            


            if(isPowered) {
                for(var i = 0; i < passDef.lightEffects.length; i++) {
                    var effect = passDef.lightEffects[i];

                    if(effect.nightonly && lastColorFilter == null) {
                        continue;
                    }

                    var lx = x + effect.x;
                    var ly = y + effect.y;

                    Scroll2d.drawLight(lx,ly,effect.r,effect.c,null,null,null,effect.i);
                }
            }
        }
    }
    
    function drawBuilding(building,isMapResource,type) {

        if(!building) {
            return;
        }

        if(building.isBeingRemoved) {
            return;
        }

        if(building.occupiesTiles == null) {
            return;
        }

        if(building.md == null) {
            setUpMinidefForBuilding(building,isMapResource,false);
            return;
        }

        if(currentViewBounds == null) {
            return;
        }

        if(!renderFullAtNextDraw) {
            if(building.x < currentViewBounds.minX || building.x > currentViewBounds.maxX) {
                if(building.y < currentViewBounds.minY || building.y > currentViewBounds.maxY) {
                    return;
                }
            }

        }

        
        var useZ = 1;

        if(building.md.canBuildOver) {
            useZ = 2;
        }
        
        var i;
        var alpha = 1.0;

        var ourDrawAsset = null;
        var drawFlipped = building.flipped;
        var theImageToUse = null;
        var isSelectedBuilding = false;

        var aniFrameToUse = 0;
        ourDrawAsset = building.md.tile;

        var outlineColor = null;
        var outlineSize = 0;

        if(!building.md.staticRender) {
            aniFrameToUse = building.spriteFrame;

            if(aniFrameToUse === undefined) {
                aniFrameToUse = 0;
                building.spriteFrame = 0;
            }
        }

        if(selectedBuilding != null || hoverBuilding != null) {
            if(building == selectedBuilding || building == hoverBuilding) {
                alpha = 0.6;
                isSelectedBuilding = true;
                outlineColor = "#ff0000";
                outlineSize = 2;
                useZ = 5;
            }
        }

        if(building == pendingMoveBuilding) {
            alpha = 0.6;
            outlineColor = "#4CAF50";
            outlineSize = 2;
            useZ = 5;
        }
        
        if(queuedBuilding != null) {
            alpha = 0.5;
        }

        if(building.lowPowerMode) {
            alpha = 0.35;
            

            if(building.md.offlineTile != null) {
                ourDrawAsset = building.md.offlineTile;
            } else {
                aniFrameToUse = 0;
            }
        }

        if(building.deactivated) {
            alpha = 0.35;
            

            if(building.md.offlineTile != null) {
                ourDrawAsset = building.md.offlineTile;
            } else {
                aniFrameToUse = 0;
            }
        }

        if(building.md.requiresWorkers && building.buW == 0) {
            
            if(building.md.offlineTile != null) {
                ourDrawAsset = building.md.offlineTile;
            } else {
                aniFrameToUse = 0;
            }
        }

        if(transparencyMode == 1) {
            alpha = 0.25;
        }

        if(transparencyMode >= 3) {
            alpha = 0.15;
        }

        if(!allowAnimation) {
            aniFrameToUse = 0;
        }

        if(gbtOpen || statsOpen) {
            aniFrameToUse = 0;
        }

        if(type == "resource" && building.sf >= 0 && building.playDef != null && building.playDef.shoreSheet != null) {
            ourDrawAsset = building.playDef.shoreSheet;
            aniFrameToUse = building.sf;
        }


        if(gbtOpen || statsOpen) {
            if(staticFrame) {
                theImageToUse = getImageAsset(ourDrawAsset,drawFlipped,aniFrameToUse,false,null,outlineSize,outlineColor);

                if(theImageToUse) {
                    Scroll2d.drawStaticTile(theImageToUse,building.dX,building.dY,useZ);
                }
                
            }
            return;
        }

        var squareColor,actPercent,sureColro,theme;

        // building colors mode
        if(type == "building" && transparencyMode == 2) {

            squareColor = "rgba(255,0,0,.4)";

            if(building.md.transModeColor != null) {
                var rawcolor = hexToColor(building.md.transModeColor);
                squareColor = "rgba(" + rawcolor.r + "," + rawcolor.g + "," + rawcolor.b + ",.4)";
            }

            for(i = 0; i < building.occupiesTiles.length; i++) {
                Scroll2d.drawSquare(squareColor,building.occupiesTiles[i].x,building.occupiesTiles[i].y,3);
            }

            return;
        }

        // entertainment coverage mode
        if(type == "building" && transparencyMode == 3) {
            

            if(building.bRC > 0) {
                actPercent = building.brE / 100;
                sureColro = getColorForPercentage(actPercent,[
                    { pct: 0.0, color: { r: 0xf4, g: 0x43, b: 0x36 } },
                    { pct: 0.5, color: { r: 0xff, g: 0xc1, b: 0x07 } },
                    { pct: 1.0, color: { r: 0x4c, g: 0xaf, b: 0x50 } }
                ]);

                theme = hexToColor(sureColro);
                squareColor = "rgba(" + theme.r + "," + theme.g + "," + theme.b + ",1)";
            } else {
                squareColor = "rgba(0,0,0,.2)";
            }

            if(building.buG > 0) {
                squareColor = "rgba(0,0,255,1)";
            }

            for(i = 0; i < building.occupiesTiles.length; i++) {
                Scroll2d.drawSquare(squareColor,building.occupiesTiles[i].x,building.occupiesTiles[i].y,3);
            }

        }

        // medical coverage mode
        if(type == "building" && transparencyMode == 4) {
            

            if(building.bRC > 0) {
                actPercent = building.brM / 100;
                sureColro = getColorForPercentage(actPercent,[
                    { pct: 0.0, color: { r: 0xf4, g: 0x43, b: 0x36 } },
                    { pct: 0.5, color: { r: 0xff, g: 0xc1, b: 0x07 } },
                    { pct: 1.0, color: { r: 0x4c, g: 0xaf, b: 0x50 } }
                ]);

                theme = hexToColor(sureColro);
                squareColor = "rgba(" + theme.r + "," + theme.g + "," + theme.b + ",1)";
            } else {
                squareColor = "rgba(0,0,0,.2)";
            }

            if(building.buM > 0) {
                squareColor = "rgba(0,0,255,1)";
            }

            for(i = 0; i < building.occupiesTiles.length; i++) {
                Scroll2d.drawSquare(squareColor,building.occupiesTiles[i].x,building.occupiesTiles[i].y,3);
            }

        }

        // education coverage mode
        if(type == "building" && transparencyMode == 5) {
            

            if(building.bRC > 0) {
                actPercent = building.brS / 100;
                sureColro = getColorForPercentage(actPercent,[
                    { pct: 0.0, color: { r: 0xf4, g: 0x43, b: 0x36 } },
                    { pct: 0.5, color: { r: 0xff, g: 0xc1, b: 0x07 } },
                    { pct: 1.0, color: { r: 0x4c, g: 0xaf, b: 0x50 } }
                ]);

                theme = hexToColor(sureColro);
                squareColor = "rgba(" + theme.r + "," + theme.g + "," + theme.b + ",1)";
            } else {
                squareColor = "rgba(0,0,0,.2)";
            }

            if(building.buS > 0) {
                squareColor = "rgba(0,0,255,1)";
            }

            for(i = 0; i < building.occupiesTiles.length; i++) {
                Scroll2d.drawSquare(squareColor,building.occupiesTiles[i].x,building.occupiesTiles[i].y,3);
            }

        }

        // crime heat map

        // land value
        if(type == "building" && transparencyMode == 7) {
            

            if(building.bRLV > 0) {
                actPercent = building.bRLV / 100;
                sureColro = getColorForPercentage(actPercent,[
                    { pct: 0.0, color: { r: 0xf4, g: 0x43, b: 0x36 } },
                    { pct: 0.5, color: { r: 0xff, g: 0xc1, b: 0x07 } },
                    { pct: 1.0, color: { r: 0x4c, g: 0xaf, b: 0x50 } }
                ]);

                theme = hexToColor(sureColro);
                squareColor = "rgba(" + theme.r + "," + theme.g + "," + theme.b + ",1)";
            } else {
                squareColor = "rgba(0,0,0,.2)";
            }

            if(building.buS > 0) {
                squareColor = "rgba(0,0,255,1)";
            }

            for(i = 0; i < building.occupiesTiles.length; i++) {
                Scroll2d.drawSquare(squareColor,building.occupiesTiles[i].x,building.occupiesTiles[i].y,3);
            }

        }

        // production capacity map
        if(type == "building" && transparencyMode == 8) {
            

            if(building.md.acceptsWorkers > 0) {
                actPercent = building.buW / building.md.acceptsWorkers;
                sureColro = getColorForPercentage(actPercent,[
                    { pct: 0.0, color: { r: 0xf4, g: 0x43, b: 0x36 } },
                    { pct: 0.5, color: { r: 0xff, g: 0xc1, b: 0x07 } },
                    { pct: 1.0, color: { r: 0x4c, g: 0xaf, b: 0x50 } }
                ]);

                theme = hexToColor(sureColro);
                squareColor = "rgba(" + theme.r + "," + theme.g + "," + theme.b + ",1)";
            } else {
                squareColor = "rgba(0,0,0,.2)";
            }


            for(i = 0; i < building.occupiesTiles.length; i++) {
                Scroll2d.drawSquare(squareColor,building.occupiesTiles[i].x,building.occupiesTiles[i].y,3);
            }

        }

        if(building.iuc) {

            if(!building.c) {

                var td = getBuildingDefByName(building.def);

                if(td) {
                    building.c = new ConstructionItem();


                    building.c.c = 0;
                    building.c.p = 0;
                    building.c.t = 0;
                    building.c.pr = {};

                    for(var res in td.cost) {
                        building.c.pr[res] = td.cost[res];
                        building.c.t += td.cost[res];
                    }
                } else {
                    building.iuc = false;
                    building.condition = 0;
                    return;
                }
                
            }

            theImageToUse = getImageAsset(ColonyGame.meta.constructionTile,false,0,false,null,outlineSize,outlineColor);

            if(theImageToUse) {
                for(i = 0; i < building.occupiesTiles.length; i++) {
                    
                    if(building.occupiesTiles[i].x == building.x && building.occupiesTiles[i].y == building.y) {
                        Scroll2d.drawSprite(theImageToUse,building.occupiesTiles[i].x,building.occupiesTiles[i].y,null,null,null,building.c.p,"#2196F3",1.0,useZ,1,1);
                    } else {
                        Scroll2d.drawSprite(theImageToUse,building.occupiesTiles[i].x,building.occupiesTiles[i].y,null,null,undefined,undefined,undefined,1.0,useZ,1,1);
                    }
                }
            }
        } else {

            theImageToUse = getImageAsset(ourDrawAsset,drawFlipped,aniFrameToUse,false,null,outlineSize,outlineColor);

            if(!theImageToUse) {
                return;
            }

            i = 8;

            if(building.c != null) {

                var cv = null;

                if(building.c.q != null && building.c.q.length > 0) {
                    cv = [];

                    var make = building.c.q.length - 1;

                    var useColor = "#2196F3";
                    var useImage = null;
                    var uDef;

                    if(building == hoverBuilding) {
                        for(i = 0; i < building.c.q.length; i++) {
                            useColor = "#2196F3";
                            useImage = null;

                            uDef = getVehicleDefByName(building.c.q[i]);

                            if(uDef) {
                                useImage = getImageAsset(uDef.tile,false,0,null);
                            }

                            cv.push(new Scroll2d.Chevron(useColor,useImage));
                        }
                    } else {
                        while(make > 0) {
                            cv.push(new Scroll2d.Chevron("#2196F3",null));
                            make--;
                        }
                    }

                    
                }

                

                Scroll2d.drawSprite(theImageToUse,building.x,building.y,null,null,null,building.c.p,"#2196F3",alpha,useZ,building.md.width,building.md.height,cv);
            } else {

                var showMeter = false;
                var generateColor = "#ffffff";
                var generatePercentage = 0;

                if(selectedBuilding != null || hoverBuilding != null) {
                    if(building == selectedBuilding || building == hoverBuilding) {
                        if(building.md.generates != null) {
                            showMeter = true;
                            generateColor = getResourceByDefName(building.md.generates).color;
                            generatePercentage = building.gp;
                        }

                        if(building.cg && building.cg.p > 0) {
                            showMeter = true;
                            generatePercentage = building.cg.p;
                            
                            generateColor = "#ffffff";
                        }

                        if(building.md.smeltTime != null) {
                            

                            if(getBuildingDefByName(building.def).smelts.output != null) {
                                showMeter = true;
                                generateColor = getResourceByDefName(getBuildingDefByName(building.def).smelts.output.split("|")[0]).color;
                                generatePercentage = building.smeltCounter / building.md.smeltTime;
                            }

                            
                        }

                        var surroundingFree = getFreeSpacesAroundBuilding(building,1,false);
                        if(surroundingFree) {
                            while(surroundingFree.length > 0) {
                                var square = surroundingFree.pop();
                                Scroll2d.drawSquare("rgba(0,255,0,.1)",square[0],square[1],2);
                            }
                        }
                    }
                }

                if(showMeter) {
                    if(generatePercentage > 1) {
                        generatePercentage = 1;
                    }

                    Scroll2d.drawSprite(theImageToUse,building.x,building.y,null,null,null,generatePercentage,generateColor,alpha,useZ,building.md.width,building.md.height);
                } else {
                    if(building.md.staticRender && alpha == 1.0) {
                        if(staticFrame) {

                            theImageToUse = getImageAsset(ourDrawAsset,drawFlipped,0,false,null,outlineSize,outlineColor);

                            if(theImageToUse) {
                                Scroll2d.drawStaticTile(theImageToUse,building.dX,building.dY,useZ);
                            }
                        }
                    } else {

                        Scroll2d.drawSprite(theImageToUse,building.x,building.y,null,null,undefined,undefined,undefined,alpha,useZ,building.md.width,building.md.height);


                    }
                }

            }

        }

        if(allowLighting && building.md.lightEffects != null) {
            if(!building.iuc && !building.lowPowerMode) {
                for(i = 0; i < building.md.lightEffects.length; i++) {
                    var effect = building.md.lightEffects[i];

                    if(effect.nightonly && lastColorFilter == null) {
                        continue;
                    }

                    if(effect.oncycles != undefined && effect.oncycles != null) {
                        if(effect.oncycles.indexOf(lightCycle) == -1) {
                            continue;
                        }
                    }

                    var lx = building.x + effect.x;
                    var ly = building.y + effect.y;

                    if(building.flipped) {
                        lx = building.x + effect.y;
                        ly = building.y + effect.x;
                    }

                    Scroll2d.drawLight(lx,ly,effect.r,effect.c,null,null,null,effect.i);
                }
            }
        }

        if(isSelectedBuilding) {

            var gridColor = "#4CAF50";

            if(building.md.transModeColor != null) {
                gridColor = building.md.transModeColor;
            }

            renderGrid(building.x,building.y,building.md.width,building.md.height,1,gridColor,2);
        }
    }

    function renderGrid(x,y,width,height,zindex,color,linewidth) {
        for(var dx = x; dx <= x + width; dx++) {
            Scroll2d.drawLine(color,dx,y,dx,y + height,zindex,false,linewidth);
        }

        for(var dy = y; dy <= y + height; dy++) {
            Scroll2d.drawLine(color,x,dy,x + width,dy,zindex,false,linewidth);
        }
    }

    function renderOutline(x,y,width,height,zindex,color,linewidth,dashed) {
        Scroll2d.drawLine(color,x,y,x + width,y,zindex,false,linewidth,dashed);
        Scroll2d.drawLine(color,x + width,y,x + width,y + height,zindex,false,linewidth,dashed);
        Scroll2d.drawLine(color,x + width,y + height,x,y + height,zindex,false,linewidth,dashed);
        Scroll2d.drawLine(color,x,y + height,x,y,zindex,false,linewidth,dashed);
    }

    function renderRegionalOutline(tilesArray,zindex,color,linewidth,dashed) {
        var linesToDraw = getGroupRegionLines(tilesArray);
        var ltd;

        for(var i = 0; i < linesToDraw.length; i++) {
            ltd = linesToDraw[i];
            Scroll2d.drawLine(color,ltd.x1,ltd.y1,ltd.x2,ltd.y2,zindex,false,linewidth,dashed);
        }
    }

    function getGroupRegionLines(tilesArray) {
        var i,j,ti,tj,dTop,dRight,dBottom,dLeft;

        var linesToDraw = [];

        for(i = 0; i < tilesArray.length; i++) {
            ti = tilesArray[i];

            dTop = true;
            dRight = true;
            dBottom = true;
            dLeft = true;

            for(j = 0; j < tilesArray.length; j++) {
                tj = tilesArray[j];

                if(ti == tj) {
                    continue;
                }

                if(ti.x == tj.x) {
                    if(tj.y == ti.y - 1) {
                        dTop = false;
                    }

                    if(tj.y == ti.y + 1) {
                        dBottom = false;
                    }
                }

                if(ti.y == tj.y) {
                    if(tj.x == ti.x - 1) {
                        dLeft = false;
                    }

                    if(tj.x == ti.x + 1) {
                        dRight = false;
                    }
                }
            }

            if(dTop) {
                linesToDraw.push({
                    x1: ti.x,
                    y1: ti.y,
                    x2: ti.x + 1,
                    y2: ti.y
                });
            }

            if(dRight) {
                linesToDraw.push({
                    x1: ti.x + 1,
                    y1: ti.y,
                    x2: ti.x + 1,
                    y2: ti.y + 1
                });
            }

            if(dBottom) {
                linesToDraw.push({
                    x1: ti.x,
                    y1: ti.y + 1,
                    x2: ti.x + 1,
                    y2: ti.y + 1
                });
            }

            if(dLeft) {
                linesToDraw.push({
                    x1: ti.x,
                    y1: ti.y,
                    x2: ti.x,
                    y2: ti.y + 1
                });
            }
        }

        return linesToDraw;
    }
    
    function moveVehicle(x,y,vehicle) {

        if(!vehicle) {
            return;
        }

        vehicle.mq = [];
        
        vehicle.breakCount = vehicle.breakThreshold;

        var def = getVehicleDefByName(vehicle.def);

        if(!def) {
            return;
        }

        if(def != null && def.moveConfirmSound && def.moveConfirmSound != null) {

            var soundToPlay = null;

            if(def.moveConfirmSound instanceof Array) {
                soundToPlay = def.moveConfirmSound[randomIntFromInterval(0,def.moveConfirmSound.length - 1)];
            } else {
                soundToPlay = def.moveConfirmSound;
            }

            playInterfaceSoundEffect(soundToPlay);
        }

        if(def.vehicleCarryCapacity == 0) {
            // see if we are moving into another vehicle

            for(var i = 0; i < currentGame.vehicles.length; i++) {
                if(currentGame.vehicles[i].x == x && currentGame.vehicles[i].y == y) {

                    var tDef = getVehicleDefByName(currentGame.vehicles[i].def);

                    if(tDef.vehicleCarryCapacity > 0 && tDef.vehicleCarryCapacity > currentGame.vehicles[i].lv.length) {
                        sendVehicleToVehicle(vehicle,currentGame.vehicles[i]);
                        break;
                    }

                }
            }
        }

        vehicle.rdX = x;
        vehicle.rdY = y;

        vehicle.dX = x;
        vehicle.dY = y;

    }

    var tmpBuildingRef;

    function showPremiumMessage(title) {
        var i;

        if(!title) {
            title = "Premium";
        }

        var premMsg = getString(ColonyGame.messages.premiumNotice);
            
        var totalPremiumItems = 0;

        for(i = 0; i < ColonyGame.buildings.length; i++) {
            if(ColonyGame.buildings[i].requiPremium) {
                totalPremiumItems++;
            }
        }

        for(i = 0; i < ColonyGame.vehicles.length; i++) {
            if(ColonyGame.vehicles[i].requiPremium) {
                totalPremiumItems++;
            }
        }

        for(i = 0; i < ColonyGame.technology.length; i++) {
            if(ColonyGame.technology[i].requiPremium) {
                totalPremiumItems++;
            }
        }

        premMsg = replaceAll(premMsg,"#premiumcount",totalPremiumItems.toString());


        webAppCore.showDialog({
            "title":    title,
            "message":  premMsg,
            "op1": {
                "text":     getString("general-yes"),
                "func":     presentPremiumUpgrade
            },
            "op2": {
                "text":     getString("general-no"),
                "func":     placeholder
            }
        });
    }

    function initConstruction(buildRef) {

        selectedBuilding = null;
        selectedVehicle = [];

        cooldownGamepad();

        if(currentGame == null || buildRef == null) {
            return;
        }

        if(buildRef.requiPremium && !webAppCore.getIsPremium()) {

            
            showPremiumMessage(buildRef.name);

            return;
        }

        var canAfford = true;
        var j;

        if(buildRef.cost) {
            for(j = 0; j < buildRef.cost.length; j++) {
                if(buildRef.cost[j].amount > getGameResources()[buildRef.cost[j].resource].amount) {
                    canAfford = false;
                }
            }
        }
        

        if(currentGame.cm) {
            canAfford = true;
        }

        if(!canAfford) {
            webAppCore.showAlertWithTitle(getString("general-cant-afford"),"Cannot Afford");
            return;
        }

        if(tmpBuildingRef != null) {
            doConstruction(buildRef,tmpBuildingRef);
        } else {
            
            buildingConstruction(buildRef);
            showBuildConfirm();
        }
    }

    function presentPremiumUpgrade() {
        webAppCore.presentPremium();
    }
    
    function doConstruction(buildRef,building) {

        

        tmpBuildingRef = null;

        if(buildRef.requiPremium && !webAppCore.getIsPremium()) {
            showPremiumMessage(buildRef.name);
            return;
        }

        if(building.c == null) {
            building.c = new ConstructionItem();
        }

        building.c.q.push(buildRef.name);

        
    }
    
    function buildingConstruction(buildRef) {
        queuedBuilding = buildRef;
    }

    function checkForPathSimulation(unit,type,x2,y2) {
        var sourceVisible = Scroll2d.checkVisibility(unit.x,unit.y);
        var destVisible = Scroll2d.checkVisibility(x2,y2);

        if(currentGame.width < 101) {
            return false;
        }
        
        if(gbtOpen || inBackgroundMode || statsOpen) {
            sourceVisible = false;
            destVisible = false;
        }

        var maxDistance = 15;

        if(currentGame.width >= 200 || currentGame.height >= 200) {
            maxDistance = 10;
            destVisible = false;
        }

        if(!sourceVisible) {
            var a = unit.x - x2;
            var b = unit.y - y2;
            var distance = Math.sqrt( a*a + b*b );

            if(destVisible && distance < maxDistance) {
                return false;
            }

            var driveSpeed = 0.5;

            if(type == "vehicle") {
                driveSpeed = 2;
            }

            var usetc = Math.round((distance * 20) / driveSpeed);

            unit.tc = usetc;

            return true;
        }

        return false;
    }

    function checkPathThreaded(unit,type,x2,y2) {

        if(isNaN(x2) || isNaN(y2)) {
            return;
        }


        if(checkForPathSimulation(unit,type,x2,y2)) {
            return;
        }

        var useCr = null;
        var isFlying = false;

        if(type == "vehicle") {
            vehiclePathOrders[unit.id] = null;

            

            var unitDef = getVehicleDefByName(unit.def);

            if(unitDef.isFlying) {
                isFlying = true;
                useCr = flyingCollisionReference;
            }

            

        } else {
            colonistPathOrders[unit.id] = null;
        }

        setAwaitingPath(unit,type,true);

        var retainedPath = getRetainedPath(unit.x,unit.y,x2,y2);

        if(retainedPath != null) {

            if(type == "vehicle") {
                vehiclePathOrders[unit.id] = retainedPath;
            } else {
                colonistPathOrders[unit.id] = retainedPath;
            }

            return;
        }

        if(!isTilePassable(x2,y2,false,isFlying,false,null)) {
            var alternateAreas = getFreeSpaceAroundTile(x2,y2,1,null);

            if(alternateAreas.length > 0) {
                var useThis = alternateAreas[randomIntFromInterval(0,alternateAreas.length - 1)];

                x2 = useThis[0];
                y2 = useThis[1];
            }

            while(alternateAreas.length) {
                freeSpaceItemRecycler.push(alternateAreas.pop());
            }
        }

        var pathMessage = {
            "method": "checkPath",
            "data": {
                "x1": unit.x,
                "y1": unit.y,
                "x2": x2,
                "y2": y2,
                "type": type,
                "id": unit.id,
                "cr": useCr
            }
        };

        pathWorker1.postMessage(pathMessage);

    }

    function checkPathsThreaded(unit,type,paths) {

        var useCr = null;

        setAwaitingPath(unit,type,true);

        var unitDef = null;

        if(type == "vehicle") {
            vehiclePathOrders[unit.id] = null;

            unitDef = getVehicleDefByName(unit.def);
            
            if(unitDef.isFlying) {
                useCr = flyingCollisionReference;
            }
        } else {
            colonistPathOrders[unit.id] = null;
            unitDef = {
                isFlying: false
            };
        }

        var wasretained = false;

        for(var i = 0; i < paths.length; i++) {

            if(checkForPathSimulation(unit,type,paths[i].x,paths[i].y)) {
                return;
            }

            var retainedPath = getRetainedPath(unit.x,unit.y,paths[i].x,paths[i].y);
            
            if(retainedPath != null) {

                wasretained = true;

                if(type == "vehicle") {
                    vehiclePathOrders[unit.id] = retainedPath;
                } else {
                    colonistPathOrders[unit.id] = retainedPath;
                }
    
                break;
            }
        }

        if(wasretained) {
            paths = null;
            return;
        }


        var sendData = [];

        while(paths.length > 0) {

            var dest = paths.shift();

            if(isNaN(dest.x) || isNaN(dest.y)) {
                continue;
            }

            if(!isTilePassable(dest.x,dest.y,false,unitDef.isFlying,false,null)) {

                var alternateAreas = getFreeSpaceAroundTile(dest.x,dest.y,1,null);
    
                if(alternateAreas.length > 0) {
                    var useThis = alternateAreas[randomIntFromInterval(0,alternateAreas.length - 1)];
    
                    dest.x = useThis[0];
                    dest.y = useThis[1];
                }

                while(alternateAreas.length) {
                    freeSpaceItemRecycler.push(alternateAreas.pop());
                }
            }

            sendData.push({
                "x1": unit.x,
                "y1": unit.y,
                "x2": dest.x,
                "y2": dest.y,
                "type": type,
                "id": unit.id,
                "cr": useCr
            });
        }

        pathWorker1.postMessage({
            "method": "checkPaths",
            "data": sendData
        });

    }

    function handleUnitMovement(unit,type) {


        if(collisionReference == null) {
            return;
        }

        if(type == "vehicle" && unit.iv > 0) {
            return;
        }

        if(unit.rdX == undefined) {
            unit.rdX = -1;
        }

        if(unit.rdY == undefined) {
            unit.rdY = -1;
        }

        var vdef = null;

        if(unit.x == unit.dX && unit.y == unit.dY) {
            setAwaitingPath(unit,type,false);
            unit.tX = unit.x;
            unit.tY = unit.y;
            unit.tc = 0;

            if(!isTilePassable(unit.x,unit.y,false)) {
                unstickUnit(unit);
            }

            unit.rdX = -1;
            unit.rdY = -1;

            return;
        }

        if(unit.tc > 0) {

            setAwaitingPath(unit,type,false);

            unit.tc--;

            if(unit.tc <= 0) {
                unit.x = unit.dX;
                unit.y = unit.dY;
                unit.tX = unit.x;
                unit.tY = unit.y;
                unit.stepCount = 0;
                unit.giveUpCount = 0;
                unit.tc = 0;

                if(type == "vehicle") {
                    unit.brt = 0;
                }
                
            }

            return;
        }

        var hasGivenUp = false;

        if(getAwaitingPath(unit,type)) {

            if(type == "vehicle") {
                if(!vehiclePathOrders[unit.id]) {

                    unit.a++;


                    if(unit.a < 10) {
                        return;
                    }
                    
                    hasGivenUp = true;
                    setAwaitingPath(unit,type,false);

                    
                    
                } else {

                    unit.mq = vehiclePathOrders[unit.id];
                    vehiclePathOrders[unit.id] = null;

                    if(unit.mq.length > 0) {
                        unit.dX = unit.mq[unit.mq.length - 1].x;
                        unit.dY = unit.mq[unit.mq.length - 1].y;

                        if(type == "vehicle") {
                            unit.brt = 0;
                            unit.ncc = 0;
                        }
                    } else {
                        hasGivenUp = true;

                    }

                    setAwaitingPath(unit,type,false);

                    if(unit.inBuildingMode) {
                        if(unit.mq.length == 0) {

                            unit.dX = unit.x;
                            unit.dY = unit.y;

                            if(unit.brt > 3) {
                                unit.brt = 0;
                                unit.inBuildingMode = false;

                                if(unit.harvestAfterBuilding) {
                                    unit.harvestAfterBuilding = false;
                                    unit.iH = true;
                                } else {
                                    parkVehicle(unit);
                                }
                            } else {
                                unit.ncc = 15;
                                unit.brt++;

                                if(unit.brt == 1) {
                                    shouldUpdateCollissionMap = true;
                                }

                                if(unit.brt == 2) {
                                    unit.blacklist = [];
                                    unit.bBlacklist = [];
                                }
                            }
                            
                        } else {
                            
                            unit.brt = 0;
                            unit.ncc = 0;
                        }
                    }
                }
            } else {
                if(colonistPathOrders[unit.id] == null) {
                    unit.a++;

                    if(unit.a < 30) {
                        return;
                    }

                    hasGivenUp = true;
                    setAwaitingPath(unit,type,false);

                } else {
                    unit.mq = colonistPathOrders[unit.id];
                    colonistPathOrders[unit.id] = null;

                    if(unit.mq.length > 0) {
                        unit.dX = unit.mq[unit.mq.length - 1].x;
                        unit.dY = unit.mq[unit.mq.length - 1].y;

                        if(type == "vehicle") {
                            unit.brt = 0;
                            unit.ncc = 0;
                        }
                    } else {
                        hasGivenUp = true;
                    }
                
                    setAwaitingPath(unit,type,false);
                }
            }

        }

        var needsToRebuildPath = false;

        var flyingUnit = false;

        if(type == "vehicle") {
            vdef = getVehicleDefByName(unit.def);

            if(vdef.isFlying) {
                flyingUnit = true;
            }
        }
        
        if(unit.mq && unit.mq.length > 0) {

            if(!needsToRebuildPath && (unit.mq[unit.mq.length - 1].x != unit.dX || unit.mq[unit.mq.length - 1].y != unit.dY)) {
                needsToRebuildPath = true;
            }

            if(!needsToRebuildPath && !isTilePassable(unit.mq[0].x,unit.mq[0].y,false,flyingUnit,false)) {

                unit.dX = unit.x;
                unit.dY = unit.y;

                if(type == "vehicle") {

                    unit.giveUpCount++;

                    

                    if(unit.giveUpCount > 4) {
                        unit.inBuildingMode = false;

                        if(unit.ht != null) {
                            unit.blacklist.push(unit.ht);
                        }

                        unit.ht = null;

                        unit.giveUpCount = 0;
                    } else {
                        needsToRebuildPath = true;
                    }

                }

                shouldUpdateCollissionMap = true;

            }
        
        } else {
            needsToRebuildPath = true;
        }

        if(needsToRebuildPath) {
            unit.tX = unit.x;
            unit.tY = unit.y;
            unit.mq = [];

            if(unit.ht != null) {
                unit.blacklist.push(unit.ht);
            }

            if(useSyncPathfinding) {
                unit.mq = checkPathSync(unit,type,unit.dX,unit.dY);
            } else {
                checkPathThreaded(unit,type,unit.dX,unit.dY);
            
                if(!hasGivenUp) {
                    return;
                }
            }
            
        }

        
        if(getAwaitingPath(unit,type) && !hasGivenUp) {
            return;
        }

        unstickUnit(unit);
        
        if(unit.mq.length > 0) {

            var destination = unit.mq.shift();
            
            if(unit.breakCount >= unit.breakThreshold || (destination.x != unit.lastX || destination.y != unit.lastY)) {
                unit.tX = destination.x;
                unit.tY = destination.y;
                
                if(unit.tX > unit.x) {
                    unit.faceFrame = 1;
                }
                
                if(unit.tX < unit.x) {
                    unit.faceFrame = 3;
                }
                
                if(unit.tY > unit.y) {
                    unit.faceFrame = 0;
                }
                
                if(unit.tY < unit.y) {
                    unit.faceFrame = 2;
                }
                
                unit.lastX = unit.x;
                unit.lastY = unit.y;
                unit.breakCount = 0;
            } else {
                unit.breakCount++;
            }

            if(useSyncPathfinding) {
                syncNodeRecycling.push(destination);
            } else {
                destination = null;
            }


        } else {

            if(isNaN(unit.giveUpCount)) {
                unit.giveUpCount = 0;
            }

            unit.giveUpCount++;

            if(unit.giveUpCount >= 25) {

                setAwaitingPath(unit,type,false);

                if(type == "vehicle") {
                    if(unit.pX != null && unit.pY != null) {
                        if(unit.dX == unit.pX && unit.dY == unit.pY) {
                            unit.pX = null;
                            unit.pY = null;
                        } else {
                            parkVehicle(unit);
                            return;
                        }
                    } 
                }

                var choices = getFreeSpaceAroundTile(unit.dX,unit.dY,2);

                if(choices.length > 0) {
                    var rndPosition = choices[randomIntFromInterval(0,choices.length - 1)];
                    unit.dX = rndPosition[0];
                    unit.dY = rndPosition[1];

                    if(isNaN(unit.destinationChanges)) {
                        unit.destinationChanges = 0;
                    }

                    unit.destinationChanges++;

                    // total abort!
                    if(unit.destinationChanges > 5) {
                        unit.dX = unit.x;
                        unit.dY = unit.y;
                        unit.destinationChanges = 0;

                    }

                } else {
                    unit.dX = unit.x;
                    unit.dY = unit.y;
                }

                while(choices.length) {
                    freeSpaceItemRecycler.push(choices.pop());
                }

                unit.giveUpCount = 0;

                
                unit.tX = unit.x;
                unit.tY = unit.y;
                unit.stepCount = 0;
            }
        }

    }

    function unstickUnit(unit) {

        if(isTilePassable(unit.x,unit.y,false)) {
            return false;
        }

        if(isTilePassable(unit.tX,unit.tY,false)) {
            return false;
        }

        // if the unit got stuck somehow, fix him
        var unitFree = false;
        var passRadius = 1;

        while(!unitFree) {
            var choices = getFreeSpaceAroundTile(unit.x,unit.y,passRadius);
            var rndPosition = choices[randomIntFromInterval(0,choices.length - 1)];

            while(choices.length) {
                freeSpaceItemRecycler.push(choices.pop());
            }

            if(!rndPosition) {
                passRadius++;

                if(passRadius > 25) {

                    return false;
                }

                continue;
            }

            if(isTilePassable(unit.tX,unit.tY,false)) {
                return false;
            }

            if(!isTilePassable(unit.dX,unit.dY,false)) {
                unit.dX = unit.x;
                unit.dY = unit.y;
                unit.tX = unit.x;
                unit.tY = unit.y;
            } else {
                unit.tX = rndPosition[0];
                unit.tY = rndPosition[1];
            }

            unitFree = true;
        }

        if(!unit.inBuildingMode) {
            parkVehicle(unit);
        }

        return true;
    }

    function getForeignContactByName(name) {

        for(var prop in getRegionOrCity().foreignContactReference) {
            if(getRegionOrCity().foreignContactReference[prop].name == name) {
                return getRegionOrCity().foreignContactReference[prop];
            }
        }

        return null;
    }

    function sendUnitToBuilding(unit,building,terrain) {

        if(building == null) {
            return -1;
        }

        var targetParameter = getFreeSpacesAroundBuilding(building,1,false,terrain);

        

        if(targetParameter.length == 0) {
            building.deactivated = true;
            return -1;
        }

        var a,b,distance;


        var targetPoints = [];

        for(var i = 0; i < targetParameter.length; i++) {
            a = unit.x - targetParameter[i][0];
            b = unit.y - targetParameter[i][1];
            distance = Math.sqrt( a*a + b*b );

            targetPoints.push({
                "x":    targetParameter[i][0],
                "y":    targetParameter[i][1],
                "d":    Math.round(distance)
            });
        }

        targetParameter = null;

        targetPoints.sort(sortTargetPoints);

        while(targetPoints.length > 0) {
            var target = targetPoints.shift();

            unit.dX = target.x;
            unit.dY = target.y;
            targetPoints = null;
            return target.d;

        }

        targetPoints = null;

        return -1;
    }

    function sortImmigrantSources(a,b) {
        if(a.count > b.count) {
            return -1;
        }

        if(a.count < b.count) {
            return 1;
        }

        return 0;
    }

    function sortBuildingsByLandValueReverse(a,b) {

        if(!a || !b) {
            return 0;
        }

        if(a.bRLV > b.bRLV) {
            return 1;
        }

        if(a.bRLV < b.bRLV) {
            return -1;
        }

        return 0;
    }

    function sortBuildings(a,b) {

        if(!a || !b) {
            return 0;
        }

        if(a.def > b.def) {
            return -1;
        }

        if(a.def < b.def) {
            return 1;
        }

        return 0;
    }
    
    function sortTargetPoints(a,b) {
        if(!a || !b) {
            return 0;
        }

        if(a.d < b.d) {
            return -1;
        }

        if(a.d > b.d) {
            return 1;
        }

        return 0;
    }

    var tmpBuildingRefHolder = {};

    function getBuildingById(id) {

        if(tmpBuildingRefHolder[id]) {
            return tmpBuildingRefHolder[id];
        }

        for(var i = 0; i < currentGame.buildings.length; i++) {

            var bld = currentGame.buildings[i];

            if(!bld) {
                continue;
            }

            tmpBuildingRefHolder[id] = bld;

            if(bld.id == id) {
                return bld;
            }
        }

        return null;
    }

    function shuffle(array) {
        var currentIndex = array.length, temporaryValue, randomIndex;

        // While there remain elements to shuffle...
        while (0 !== currentIndex) {

            // Pick a remaining element...
            randomIndex = Math.floor(Math.random() * currentIndex);
            currentIndex -= 1;

            // And swap it with the current element.
            temporaryValue = array[currentIndex];
            array[currentIndex] = array[randomIndex];
            array[randomIndex] = temporaryValue;
        }

        return array;
    }

    function handleVehicleChoppingBloc(vehicle,def) {
        var i;

        if(vehicle.x == vehicle.choppingDestination.x && vehicle.y == vehicle.choppingDestination.y) {
            if(def != null && def.sellValue != null) {
                for(i = 0; i < def.sellValue.length; i++) {

                    modifyResourceAmount(def.sellValue[i].resource,def.sellValue[i].amount,false,"Chop Shop");
                    if(useTextPoppers && lastZoomLevel > 0.5) {
                        Scroll2d.popText(vehicle.x,vehicle.y,getResourceByDefName(def.sellValue[i].resource).indicator + def.sellValue[i].amount,getResourceByDefName(def.sellValue[i].resource).color);
                    }
                }
            }

            vehicle.isCashed = true;
            return;
        }
    }

    function groupSelectedUnits() {
        if(!selectedVehicle || selectedVehicle.length < 2) {
            return;
        }

        var i,veh;
        var checkDef = selectedVehicle[0].def;

        var allSame = true;

        for(i = 0; i < selectedVehicle.length; i++) {
            veh = selectedVehicle[i];

            if(veh.def != checkDef) {
                allSame = false;
                break;
            }
        }

        if(!allSame) {
            return;
        }

        var killUNits = [];

        var mainUnit = selectedVehicle[0];

        for(i = 1; i < selectedVehicle.length; i++) {
            veh = selectedVehicle[i];

            mainUnit.grp += veh.grp;

            killUNits.push(veh);
        }

        while(killUNits.length) {
            var ku = killUNits.pop();

            removeFromArray(selectedVehicle,ku);
            removeFromArray(currentGame.vehicles,ku);
        }
    }

    function ungroupSelectedUnits() {

        if(!selectedVehicle) {
            return;
        }

        var dropPoints,freshVehicle;
        var roc = getRegionOrCity();

        if(!roc || !currentGame) {
            return;
        }

        for(var i = 0; i < selectedVehicle.length; i++) {

            var vehicle = selectedVehicle[i];


            if(vehicle.grp > 1) {
                dropPoints = getFreeSpaceAroundTile(vehicle.x,vehicle.y,1);

                if(dropPoints.length > 0) {

                    while(vehicle.grp > 1) {

                        var rndPt = dropPoints[randomIntFromInterval(0,dropPoints.length - 1)];

                        var option = getVehicleDefByName(vehicle.def);

                        freshVehicle = new Vehicle(option,rndPt[0],rndPt[1],roc.localPlayerId);
                        currentGame.vehicles.push(freshVehicle); 

                        vehicle.grp--;
                    }
                }
                
                while(dropPoints.length) {
                    freeSpaceItemRecycler.push(dropPoints.pop());
                }
            }

        }
    }

    function deployLoadedUnits(vehicle) {

        var dropPoints = getFreeSpaceAroundTile(vehicle.x,vehicle.y,1);

        if(dropPoints.length == 0) {
            webAppCore.showToast("Cannot Deploy Here");
            return false;
        }

        for(var i = 0; i < currentGame.vehicles.length; i++) {
            if(vehicle.lv.indexOf(currentGame.vehicles[i].id) > -1) {
                currentGame.vehicles[i].iv = 0;
                currentGame.vehicles[i].it = 0;

                var dest = dropPoints[randomIntFromInterval(0,dropPoints.length - 1)];

                currentGame.vehicles[i].x = dest[0];
                currentGame.vehicles[i].y = dest[1];
                currentGame.vehicles[i].dX = dest[0];
                currentGame.vehicles[i].dY = dest[1];
                currentGame.vehicles[i].tX = dest[0];
                currentGame.vehicles[i].tY = dest[1];
            }
        }

        while(dropPoints.length) {
            freeSpaceItemRecycler.push(dropPoints.pop());
        }

        vehicle.lv = [];

        return true;
    }

    function sendVehicleToVehicle(vehicle,target) {

        vehicle.it = target.id;
        vehicle.iv = 0;
    }

    function handleVehicleLoad(vehicle) {
        for(var i = 0; i < currentGame.vehicles.length; i++) {
            if(currentGame.vehicles[i].id == vehicle.it) {

                var tDef = getVehicleDefByName(currentGame.vehicles[i].def);

                if(tDef.vehicleCarryCapacity > 0 && tDef.vehicleCarryCapacity > currentGame.vehicles[i].lv.length) {
                    currentGame.vehicles[i].lv.push(vehicle.id);
                    vehicle.iv = currentGame.vehicles[i].id;

                    
                }
                
                break;
            }
        }

        vehicle.it = 0;

        closeObjectOptionsMenu();
    }

    function handleVehicleConstruction(vehicle,def) {

        if(getAwaitingPath(vehicle,"vehicle")) {
            return;
        }

        if(!vehicle.ncc) {
            vehicle.ncc = 0;
        }

        if(vehicle.ncc > 0) {
            vehicle.ncc--;

            if(vehicle.ncc == 0) {
                vehicle.blacklist = [];
                vehicle.bBlacklist = [];
                vehicle.mq = [];
            }

            return;
        }

        var i;
        var j;
        var availableSpaces;
        var nextTo;

        var canDoThis = false;

        // if we are standing still, see what we need to be doing
        if(vehicle.dX == vehicle.x && vehicle.dY == vehicle.y) {
            
            vehicle.lastX = vehicle.x;
            vehicle.lastY = vehicle.y;
            vehicle.breakCount = 0;

            // first check if we are near a building under construction 
            nextTo = null;



            var availableProjects = [];
            var found = false;

            if(!constructionProjectsArray) {
                constructionProjectsArray = [];
            }
            
            // get construction projects
            for(i = 0; i < constructionProjectsArray.length; i++) {

                if(!constructionProjectsArray[i].iuc) {
                    continue;
                }

                
                found = false;

                for(var l = 0, n = vehicle.bBlacklist.length; l < n; l++) {
                    
                    

                    if(vehicle.bBlacklist[l] === constructionProjectsArray[i].id) {
                        found = true;
                        break;
                    }

                    
                }

                if(found) {
                    continue;
                }
                

                
                canDoThis = false;

                if(def.produces != null) {
                    for(j = 0; j < def.produces.length; j++) {
                        if(def.produces[j].length > 0 && def.produces[j] == constructionProjectsArray[i].def) {
                            canDoThis = true;
                        }
                    }
                }

                if(!canDoThis) {
                    continue;
                }

                

                availableProjects.push(constructionProjectsArray[i]);
            }

            var sortedWorksites = sortBuildingsByDistanceFromUnit(availableProjects,vehicle,false,200,def.isFlying);
            var pathsToSort = [];

            while(sortedWorksites.length > 0) {
                var worksite = sortedWorksites.shift();


                if(worksite.d == 1) {
                    nextTo = worksite.b;
                    break;
                }

                var spaces = getFreeSpacesAroundBuilding(worksite.b,1,false,false,def.isFlying);

                availableSpaces = shuffle(spaces);

                for(j = 0; j < availableSpaces.length; j++) {

                    var a = vehicle.x - availableSpaces[j][0];
                    var b = vehicle.y - availableSpaces[j][1];
                    var distance = Math.sqrt( a*a + b*b );

                    pathsToSort.push({
                        "x": availableSpaces[j][0],
                        "y": availableSpaces[j][1],
                        "d": distance
                    });
                }
            }

            // if we are not by an under construction building, find the nearest one and set destination, otherwise, turn off building mode
            if(nextTo == null) {
                
                if(pathsToSort.length > 0) {


                    pathsToSort.sort(sortTargetPoints);

                    // slightly mix it up so everything isnt stuck together
                    if(vehicle.brt == 0 && pathsToSort.length > 4) {
                        if(randomIntFromInterval(0,3) == 1) {
                            pathsToSort.shift();
                        }
                    }

                    vehicle.dX = pathsToSort[0].x;
                    vehicle.dY = pathsToSort[0].y;
                    

                    if(useSyncPathfinding) {
                        vehicle.mq = checkPathsSync(vehicle,"vehicle",pathsToSort);

                        if(vehicle.mq.length > 0) {
                            vehicle.dX = vehicle.mq[vehicle.mq.length - 1].x;
                            vehicle.dY = vehicle.mq[vehicle.mq.length - 1].y;
                        }
                    } else {
                        checkPathsThreaded(vehicle,"vehicle",pathsToSort);
                    }

                } else {

                    vehicle.dX = vehicle.x;
                    vehicle.dY = vehicle.y;

                    if(vehicle.brt > 3) {
                        vehicle.brt = 0;
                        vehicle.inBuildingMode = false;
                        vehicle.ncc = 0;
                        
                        if(vehicle.harvestAfterBuilding) {
                            vehicle.harvestAfterBuilding = false;
                            vehicle.iH = true;
                        } else {
                            parkVehicle(vehicle);
                        }
                    } else {
                        vehicle.ncc = 15;
                        vehicle.brt++;

                        if(vehicle.brt == 2) {
                            vehicle.blacklist = [];
                            vehicle.bBlacklist = [];
                        }
                    }
                }

            } else {
                vehicle.brt = 0;
                vehicle.ncc = 0;
                vehicle.blacklist = [];
                vehicle.bBlacklist = [];
                workOnBuildingConstruction(nextTo,vehicle);
            }
        }

        availableSpaces = null;
    }

    function updateVehicle(vehicle) {

        

        
        if(!runningVehicleCounts[vehicle.def]) {
            runningVehicleCounts[vehicle.def] = 0;
        }

        runningVehicleCounts[vehicle.def]++;

        if(!vehicle.inBuildingMode && !vehicle.iH && !vehicle.onChoppingBlock && vehicle.x == vehicle.dX && vehicle.y == vehicle.dY) {
            vehicle.tX = vehicle.x;
            vehicle.tY = vehicle.y;
            vehicle.stepCount = 0;
            vehicle.giveUpCount = 0;
            vehicle.mq = [];
            return;
        }

        if(isNaN(vehicle.owner)) {
            vehicle.owner = 0;
        }

        var def = getVehicleDefByName(vehicle.def);

        if(def == null) {
            return;
        }

        if(vehicle.iv > 0) {
            return;
        }

        if(!vehicle.grp) {
            vehicle.grp = 1;
        }

        if(!vehicle.owner) {
            vehicle.owner = getRegionOrCity().localPlayerId;
        }

        if(vehicle.onChoppingBlock) {
            handleVehicleChoppingBloc(vehicle,def);
        }

        var driveSpeed = 2;
        

        if(vehicle.iH) {

            if(isNaN(vehicle.capacity)) {
                vehicle.capacity = def.capacity;
                vehicle.harvests = def.harvests;
            }

            handleUnitHarvest(vehicle,def);
        }
        
        if(vehicle.tX != vehicle.x || vehicle.tY != vehicle.y) {

            // clean out a glitched tx/ty if we are already at destination
            if(vehicle.x == vehicle.dX && vehicle.y == vehicle.dY) {
                vehicle.tX = vehicle.x;
                vehicle.tY = vehicle.y;
                vehicle.stepCount = 0;
                vehicle.giveUpCount = 0;
            } else {
                if(!def.isFlying) {
                    driveSpeed += getDriveSpeedMod(vehicle.x,vehicle.y);
                }
    
                if(!isTilePassable(vehicle.tX,vehicle.tY,false,def.isFlying)) {
                    vehicle.tX = vehicle.x;
                    vehicle.tY = vehicle.y;
                    vehicle.dX = vehicle.x;
                    vehicle.dY = vehicle.y;
                    vehicle.stepCount = 0;
                    vehicle.giveUpCount = 0;
                } else {
                    vehicle.stepCount += driveSpeed;
                    if(vehicle.stepCount >= 20) {
                        vehicle.stepCount = 0;
                        vehicle.x = vehicle.tX;
                        vehicle.y = vehicle.tY;
                        vehicle.giveUpCount = 0;

                        if(vehicle.dX == vehicle.x && vehicle.dY == vehicle.y) {
                            if(vehicle.rdX != vehicle.x || vehicle.rdY != vehicle.y) {
                                if(vehicle.rdX != -1 || vehicle.rdY != -1) {
                                    checkMoveUnitToAnotherMap(vehicle,vehicle.rdX,vehicle.rdY);
                                }
                            }

                            vehicle.rdX = -1;
                            vehicle.rdY = -1;
                        }
                    }
                }
            }

            

            
        } else {
            handleUnitMovement(vehicle,"vehicle");
        }

        if(vehicle.it > 0 && vehicle.x == vehicle.dX && vehicle.y == vehicle.dY) {
            handleVehicleLoad(vehicle);
            return;
        }

        // handle a vehicle in building mode
        if(vehicle.inBuildingMode || (vehicle.ncc && vehicle.ncc > 0)) {
            handleVehicleConstruction(vehicle,def);
        }

    }

    function parkVehicle(vehicle) {
        if(vehicle.pX == null || vehicle.pY == null) {
            return;
        }

        if(vehicle.x == vehicle.pX && vehicle.y == vehicle.pY) {
            return;
        }

        vehicle.dX = vehicle.pX;
        vehicle.dY = vehicle.pY;
    }

    function handleUnitHarvest(vehicle,def) {

        var gameRes = getGameResources();

        if(!gameRes) {
            return;
        }

        if(!gameRes[vehicle.harvests]) {

            vehicle.iH = false;
            vehicle.ht = null;
            vehicle.blacklist = [];
            vehicle.bBlacklist = [];
            return;
        }

        // if we are standing still, see what we need to be doing
        if(vehicle.dX == vehicle.x && vehicle.dY == vehicle.y) {
            
            vehicle.lastX = vehicle.x;
            vehicle.lastY = vehicle.y;
            vehicle.breakCount = 0;

            var vehCap = vehicle.capacity;

            if(vehicle.grp && vehicle.grp > 1) {
                vehCap *= vehicle.grp;
            }         

            // are we collecting resource
            if(vehicle.storage < vehCap && !vehicle.isDepositing) {
                if(handleHarvestCollection(vehicle)) {
                    return;
                }
            }

            // if we are still here, find a refinery if there is something in storage 
            vehicle.isInjesting = 0;
            vehicle.blacklist = [];

            if(vehicle.storage > 0) {

                var hasCapacity = false;

                if(gameRes[vehicle.harvests].capacity == null) {
                    hasCapacity = true;
                }

                if(!hasCapacity && gameRes[vehicle.harvests].capacity == 0) {
                    hasCapacity = true;
                }

                if(!hasCapacity && gameRes[vehicle.harvests].capacity == -1 && (gameRes[vehicle.harvests].amount <gameRes[vehicle.harvests].storageCapacity)) {
                    hasCapacity = true;
                }

                if(hasCapacity) {
                    handleHarvestDeposit(vehicle,def);
                } else {
                    vehicle.isDepositing = false;
                    notifySilosNeeded(vehicle.harvests,true);
                }

                
            } else {
                vehicle.isDepositing = false;
            }

            
        }

    }

    var shoreReferenceChart = {};

    function checkIfTmpWaterPointExists(arr,x,y) {
        for(var i = 0; i < arr.length; i++) {
            var point = arr[i];

            if(point.x == x && point.y == y) {
                return true;
            }
        }

        return false;
    }

    function getSurroundingTmpWaterPoints(arr,x,y) {
        var surrounding = {
            top: null,
            right: null,
            down: null,
            left: null
        };

        for(var i = 0; i < arr.length; i++) {
            var point = arr[i];

            if(point.x == x && point.y == y - 1) {
                surrounding.top = point;
            }

            if(point.x == x && point.y == y + 1) {
                surrounding.down = point;
            }

            if(point.x == x - 1 && point.y == y) {
                surrounding.left = point;
            }

            if(point.x == x + 1 && point.y == y) {
                surrounding.right = point;
            }
        }

        return surrounding;
    }

    function getSurroundingSameTerrains(terrain) {

        var tDef = getTerrainDefByName(terrain.def);

        var connectors = [terrain.def];
        var i,l,ty;

        if(tDef && tDef.additionalConnectors && tDef.additionalConnectors.length > 0) {
            for(i = 0; i < tDef.additionalConnectors.length; i++) {
                connectors.push(tDef.additionalConnectors[i]);
            }
        }

        if(tDef && tDef.buildingConnectors && tDef.buildingConnectors.length > 0) {
            for(i = 0; i < tDef.buildingConnectors.length; i++) {
                connectors.push(tDef.buildingConnectors[i]);
            }
        }

        var surrounding = {
            top: null,
            right: null,
            down: null,
            left: null
        };

        

        if(terrain) {

            if(terrain.x == 0) {
                surrounding.left = terrain.def;
            }

            if(terrain.y == 0) {
                surrounding.top = terrain.def;
            }

            if(terrain.x == currentGame.width) {
                surrounding.right = terrain.def;
            }

            if(terrain.y == currentGame.height) {
                surrounding.bottom = terrain.def;
            }

            // top check 
            if(shoreReferenceChart[terrain.x]) {
                if(shoreReferenceChart[terrain.x][terrain.y - 1]) {
                    if(connectors.indexOf(shoreReferenceChart[terrain.x][terrain.y - 1]) > -1) {
                        surrounding.top = terrain.def;
                    }
                }
            }

            // bottom check 
            if(shoreReferenceChart[terrain.x]) {
                if(shoreReferenceChart[terrain.x][terrain.y + 1]) {
                    if(connectors.indexOf(shoreReferenceChart[terrain.x][terrain.y + 1]) > -1) {
                        surrounding.down = terrain.def;
                    }
                }
            }

            // left check 
            if(shoreReferenceChart[terrain.x - 1]) {
                if(shoreReferenceChart[terrain.x - 1][terrain.y]) {
                    if(connectors.indexOf(shoreReferenceChart[terrain.x - 1][terrain.y]) > -1) {
                        surrounding.left = terrain.def;
                    }
                }
            }

            // right check 
            if(shoreReferenceChart[terrain.x + 1]) {
                if(shoreReferenceChart[terrain.x + 1][terrain.y]) {
                    if(connectors.indexOf(shoreReferenceChart[terrain.x + 1][terrain.y]) > -1) {
                        surrounding.right = terrain.def;
                    }
                }
            }

            // check passable connectors 
            if(surrounding.top == null || surrounding.down == null || surrounding.left == null || surrounding.right == null) {
                if(terrain.playDef != null && terrain.playDef.passableConnectors != null) {
                    for(i = 0, l = terrain.playDef.passableConnectors.length; i < l; i++) {
                        var td = currentGame.finishedPassableNonUpdatables[terrain.playDef.passableConnectors[i]];

                        if(td) {
                            // top and down
                            if(surrounding.top == null || surrounding.down == null) {
                                if(td[terrain.x]) {
                                    for(ty = 0; ty < td[terrain.x].length; ty++) {
                                        if(td[terrain.x][ty] == terrain.y - 1 && surrounding.top == null) {
                                            surrounding.top = terrain.playDef.passableConnectors[i];
                                        }

                                        if(td[terrain.x][ty] == terrain.y + 1 && surrounding.down == null) {
                                            surrounding.down = terrain.playDef.passableConnectors[i];
                                        }
                                    }
                                }
                            }

                            if(surrounding.left == null) {
                                if(td[terrain.x - 1]) {
                                    for(ty = 0; ty < td[terrain.x - 1].length; ty++) {
                                        if(td[terrain.x - 1][ty] == terrain.y) {
                                            surrounding.left = terrain.playDef.passableConnectors[i];
                                        }
                                    }
                                }
                            }

                            if(surrounding.right == null) {
                                if(td[terrain.x + 1]) {
                                    for(ty = 0; ty < td[terrain.x + 1].length; ty++) {
                                        if(td[terrain.x + 1][ty] == terrain.y) {
                                            surrounding.right = terrain.playDef.passableConnectors[i];
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        return surrounding;
    }

    function getTerrainAtPosition(x,y) {

        if(shoreReferenceChart[x] && shoreReferenceChart[x][y]) {
            return shoreReferenceChart[x][y];
        }

        return null;
    }

    var overallShoreMap = null;

    function setOverallShoreMap() {

        var x,y;

        if(!overallShoreMap) {
            overallShoreMap = [];

            
    
            for(x = 0; x <= currentGame.width; x++) {
                overallShoreMap[x] = new Array(currentGame.height);
    
                for(y = 0; y <= currentGame.height; y++) {
                    overallShoreMap[x][y] = -1;
                }
            }
        }
        

        if(!workingMapType || !workingMapType.groundShoreSheet || !workingMapType.groundShoreConnectors || workingMapType.groundShoreConnectors.length == 0) {
            return;
        }

        var top = false;
        var bottom = false;
        var left = false;
        var right = false;

        var topLeft = false;
        var topRight = false;
        var bottomLeft = false;
        var bottomRight = false;

        for(x = 0; x <= currentGame.width; x++) {

            if(!overallShoreMap[x]) {
                overallShoreMap[x] = new Array(currentGame.height);
            }
            

            for(y = 0; y <= currentGame.height; y++) {

                top = false;
                bottom = false;
                left = false;
                right = false;

                topLeft = false;
                topRight = false;
                bottomLeft = false;
                bottomRight = false;

                var terrainTop = getTerrainAtPosition(x,y - 1);
                var terrainBottom = getTerrainAtPosition(x,y + 1);
                var terrainLeft = getTerrainAtPosition(x - 1,y);
                var terrainRight = getTerrainAtPosition(x + 1,y);

                var terrainTopLeft = getTerrainAtPosition(x - 1,y - 1);
                var terrainTopRight = getTerrainAtPosition(x + 1,y - 1);
                var terrainBottomLeft = getTerrainAtPosition(x - 1,y + 1);
                var terrainBottomRight = getTerrainAtPosition(x + 1,y + 1);

                if(terrainTop && workingMapType.groundShoreConnectors.indexOf(terrainTop) > -1) {
                    top = true;
                }

                if(terrainBottom && workingMapType.groundShoreConnectors.indexOf(terrainBottom) > -1) {
                    bottom = true;
                }

                if(terrainLeft && workingMapType.groundShoreConnectors.indexOf(terrainLeft) > -1) {
                    left = true;
                }

                if(terrainRight && workingMapType.groundShoreConnectors.indexOf(terrainRight) > -1) {
                    right = true;
                }

                if(terrainTopLeft && workingMapType.groundShoreConnectors.indexOf(terrainTopLeft) > -1) {
                    topLeft = true;
                }

                if(terrainTopRight && workingMapType.groundShoreConnectors.indexOf(terrainTopRight) > -1) {
                    topRight = true;
                }

                if(terrainBottomLeft && workingMapType.groundShoreConnectors.indexOf(terrainBottomLeft) > -1) {
                    bottomLeft = true;
                }

                if(terrainBottomRight && workingMapType.groundShoreConnectors.indexOf(terrainBottomRight) > -1) {
                    bottomRight = true;
                }

                if(top && bottom && left && right) {
                    overallShoreMap[x][y] = 0;
                }

                if(top && !bottom && !left && !right) {
                    overallShoreMap[x][y] = 1;

                    if(bottomRight || bottomLeft) {
                        overallShoreMap[x][y] = 0;
                    }
                }

                if(!top && !bottom && !left && right) {
                    overallShoreMap[x][y] = 2;

                    if(topLeft || bottomLeft) {
                        overallShoreMap[x][y] = 0;
                    }
                }

                if(!top && bottom && !left && !right) {
                    overallShoreMap[x][y] = 3;

                    if(topRight || topLeft) {
                        overallShoreMap[x][y] = 0;
                    }
                }

                if(!top && !bottom && left && !right) {
                    overallShoreMap[x][y] = 4;

                    if(topRight || bottomRight) {
                        overallShoreMap[x][y] = 0;
                    }
                }

                if(top && !bottom && left && !right) {
                    overallShoreMap[x][y] = 5;
                }

                if(top && !bottom && !left && right) {
                    overallShoreMap[x][y] = 6;
                }

                if(!top && bottom && !left && right) {
                    overallShoreMap[x][y] = 7;
                }

                if(!top && bottom && left && !right) {
                    overallShoreMap[x][y] = 8;
                }

                if(top && bottom && !left && !right) {
                    overallShoreMap[x][y] = 9;
                }

                if(!top && !bottom && left && right) {
                    overallShoreMap[x][y] = 10;
                }

                if(top && !bottom && left && right) {
                    overallShoreMap[x][y] = 11;
                }

                if(top && bottom && !left && right) {
                    overallShoreMap[x][y] = 12;
                }

                if(!top && bottom && left && right) {
                    overallShoreMap[x][y] = 13;
                }

                if(top && bottom && left && !right) {
                    overallShoreMap[x][y] = 14;
                }

                // if it is touching nothing, but might be something close by 
                if(!top && !bottom && !left && !right) {
                    if(topLeft && topRight && bottomLeft && bottomRight) {
                        overallShoreMap[x][y] = 0;
                    }

                    if(!topLeft && topRight && bottomLeft && bottomRight) {
                        overallShoreMap[x][y] = 0;
                    }

                    if(topLeft && !topRight && bottomLeft && bottomRight) {
                        overallShoreMap[x][y] = 0;
                    }

                    if(topLeft && topRight && !bottomLeft && bottomRight) {
                        overallShoreMap[x][y] = 0;
                    }

                    if(topLeft && topRight && bottomLeft && !bottomRight) {
                        overallShoreMap[x][y] = 0;
                    }

                    if(topLeft && !topRight && !bottomLeft && bottomRight) {
                        overallShoreMap[x][y] = 0;
                    }

                    if(!topLeft && topRight && bottomLeft && !bottomRight) {
                        overallShoreMap[x][y] = 0;
                    }

                    if(topLeft && !topRight && !bottomLeft && !bottomRight) {
                        overallShoreMap[x][y] = 15;
                    }

                    if(topLeft && topRight && !bottomLeft && !bottomRight) {
                        overallShoreMap[x][y] = 1;
                    }

                    if(!topLeft && topRight && !bottomLeft && !bottomRight) {
                        overallShoreMap[x][y] = 16;
                    }

                    if(topLeft && !topRight && bottomLeft && !bottomRight) {
                        overallShoreMap[x][y] = 4;
                    }

                    if(!topLeft && topRight && !bottomLeft && bottomRight) {
                        overallShoreMap[x][y] = 2;
                    }

                    if(!topLeft && !topRight && bottomLeft && bottomRight) {
                        overallShoreMap[x][y] = 3;
                    }

                    if(!topLeft && !topRight && !bottomLeft && bottomRight) {
                        overallShoreMap[x][y] = 17;
                    }

                    if(!topLeft && !topRight && bottomLeft && !bottomRight) {
                        overallShoreMap[x][y] = 18;
                    }
                }

                //overallShoreMap[x][y] = -1;
            }
        }
    }

    function setTerrainShoreFrame(terrain) {
        if(terrain == null) {
            return;
        }

        terrain.sf = -1;

        if(terrain.playDef == null) {
            return;
        }

        if(terrain.playDef.shoreSheet == null) {
            return;
        }

        if(terrain.playDef.tileWidth > 1 || terrain.playDef.tileHeight > 1) {
            return;
        }

        var surroundingTiles = getSurroundingSameTerrains(terrain);

        if(surroundingTiles.top != null && surroundingTiles.right != null && surroundingTiles.down != null && surroundingTiles.left != null) {
            terrain.sf = -1;
            return;
        }

        if(surroundingTiles.top == null && surroundingTiles.right == null && surroundingTiles.down == null && surroundingTiles.left == null) {
            terrain.sf = 0;
            return;
        }

        if(surroundingTiles.top == null && surroundingTiles.right != null && surroundingTiles.down != null && surroundingTiles.left != null) {
            terrain.sf = 1;
            return;
        }

        if(surroundingTiles.top != null && surroundingTiles.right == null && surroundingTiles.down != null && surroundingTiles.left != null) {
            terrain.sf = 2;
            return;
        }

        if(surroundingTiles.top != null && surroundingTiles.right != null && surroundingTiles.down == null && surroundingTiles.left != null) {
            terrain.sf = 3;
            return;
        }

        if(surroundingTiles.top != null && surroundingTiles.right != null && surroundingTiles.down != null && surroundingTiles.left == null) {
            terrain.sf = 4;
            return;
        }

        if(surroundingTiles.top == null && surroundingTiles.right != null && surroundingTiles.down != null && surroundingTiles.left == null) {
            terrain.sf = 5;
            return;
        }

        if(surroundingTiles.top == null && surroundingTiles.right == null && surroundingTiles.down != null && surroundingTiles.left != null) {
            terrain.sf = 6;
            return;
        }

        if(surroundingTiles.top != null && surroundingTiles.right == null && surroundingTiles.down == null && surroundingTiles.left != null) {
            terrain.sf = 7;
            return;
        }

        if(surroundingTiles.top != null && surroundingTiles.right != null && surroundingTiles.down == null && surroundingTiles.left == null) {
            terrain.sf = 8;
            return;
        }

        if(surroundingTiles.top == null && surroundingTiles.right != null && surroundingTiles.down == null && surroundingTiles.left != null) {
            terrain.sf = 9;
            return;
        }

        if(surroundingTiles.top != null && surroundingTiles.right == null && surroundingTiles.down != null && surroundingTiles.left == null) {
            terrain.sf = 10;
            return;
        }

        if(surroundingTiles.top == null && surroundingTiles.right == null && surroundingTiles.down != null && surroundingTiles.left == null) {
            terrain.sf = 11;
            return;
        }

        if(surroundingTiles.top == null && surroundingTiles.right == null && surroundingTiles.down == null && surroundingTiles.left != null) {
            terrain.sf = 12;
            return;
        }

        if(surroundingTiles.top != null && surroundingTiles.right == null && surroundingTiles.down == null && surroundingTiles.left == null) {
            terrain.sf = 13;
            return;
        }

        if(surroundingTiles.top == null && surroundingTiles.right != null && surroundingTiles.down == null && surroundingTiles.left == null) {
            terrain.sf = 14;
            return;
        }

        
    }

    function handleHarvestCollection(vehicle) {
        var possibleResources = [];
        var i, j, nextTo, availableSpaces;
        var found = false;

        if(!vehicle.ncc) {
            vehicle.ncc = 0;
        }

        if(vehicle.ncc > 0) {
            vehicle.ncc--;

            if(vehicle.ncc == 0) {
                vehicle.blacklist = [];
                vehicle.bBlacklist = [];
                vehicle.mq = [];
            }

            return;
        }

        for(i = 0; i < currentGame.mapResources.length; i++) {
            if(vehicle.isInjesting > 0 && currentGame.mapResources[i].id != vehicle.isInjesting) {
                continue;
            }

            if(currentGame.mapResources[i].inventory <= 0 && !currentGame.mapResources[i].ul) {
                continue;
            }

            found = false;

            for(var l = 0, n = vehicle.blacklist.length; l < n; l++) {
                
                

                if(vehicle.blacklist[l] === currentGame.mapResources[i].id) {
                    found = true;

                    break;
                }

                
            }

            if(found) {
                continue;
            }

            if(currentGame.mapResources[i].playDef == null) {
                currentGame.mapResources[i].playDef = getTerrainDefByName(currentGame.mapResources[i].def);
            }

            if(currentGame.mapResources[i].playDef.provides == null) {

                

                continue;
            } else {
                if(currentGame.mapResources[i].playDef.provides != vehicle.harvests) {
                    continue;
                }
            }

            

            possibleResources.push(currentGame.mapResources[i]);
        }

        // there are no resources, stop harvesting 
        if(possibleResources.length == 0) {
            if(vehicle.storage == 0) {




                vehicle.dX = vehicle.x;
                vehicle.dY = vehicle.y;

                if(vehicle.brt > 3) {
                    vehicle.brt = 0;
                    vehicle.inBuildingMode = false;
                    vehicle.ncc = 0;

                    // at this point, if we are still here then we couldnt find a resource or a refinery.  pout.
                    vehicle.iH = false;
                    vehicle.ht = null;
                    vehicle.blacklist = [];
                    vehicle.bBlacklist = [];
                    parkVehicle(vehicle);
                } else {
                    vehicle.ncc = 15;
                    vehicle.brt++;

                    if(vehicle.brt == 2) {
                        vehicle.blacklist = [];
                        vehicle.bBlacklist = [];
                    }
                }

                return true;
            }
        }

        var sortedResources = sortBuildingsByDistanceFromUnit(possibleResources,vehicle,true,200);
        var pathsToSort = [];

        nextTo = null;

        while(sortedResources.length > 0) {
            var resource = sortedResources.shift();

            if(resource.d == 1) {
                nextTo = resource.b;
                break;
            }

            availableSpaces = shuffle(getFreeSpacesAroundBuilding(resource.b,1,false,true));

            if(availableSpaces.length > 0) {
                for(j = 0; j < availableSpaces.length; j++) {


                    pathsToSort.push({
                        "x": availableSpaces[j][0],
                        "y": availableSpaces[j][1],
                        "id": resource.b.id
                    });

                }

            }

            if(pathsToSort.length > 0) {
                break;
            }

        }

        // if we are right next to a resource, do our thing
        if(nextTo == null) {
            vehicle.isInjesting = 0;
        } else {
            
            vehicle.brt = 0;
            vehicle.ncc = 0;
            vehicle.blacklist = [];
            vehicle.bBlacklist = [];

            if(nextTo.inventory > 0 || nextTo.ul) {

                vehicle.isInjesting = nextTo.id;
                vehicle.storage++;

                if(!nextTo.ul) {
                    nextTo.inventory--;

                    if(nextTo.inventory < 0) {
                        nextTo.inventory = 0;
                    }
                }
            }

            
            return true;
        }

        // otherwise, ship off to the closest resource
        if(pathsToSort.length > 0) {

            vehicle.ht = pathsToSort[0].id;

            vehicle.dX = pathsToSort[0].x;
            vehicle.dY = pathsToSort[0].y;

            if(useSyncPathfinding) {
                vehicle.mq = checkPathsSync(vehicle,"vehicle",pathsToSort);

                if(vehicle.mq.length > 0) {
                    vehicle.dX = vehicle.mq[vehicle.mq.length - 1].x;
                    vehicle.dY = vehicle.mq[vehicle.mq.length - 1].y;
                }
            } else {
                checkPathsThreaded(vehicle,"vehicle",pathsToSort);
            }

            vehicle.brt = 0;
            vehicle.ncc = 0;
            vehicle.blacklist = [];
            vehicle.bBlacklist = [];

            return true;
        } else {
            vehicle.dX = vehicle.x;
            vehicle.dY = vehicle.y;

            if(vehicle.brt > 3) {
                vehicle.brt = 0;
                vehicle.inBuildingMode = false;
                vehicle.ncc = 0;

                // at this point, if we are still here then we couldnt find a resource or a refinery.  pout.
                vehicle.iH = false;
                vehicle.ht = null;
                vehicle.blacklist = [];
                vehicle.bBlacklist = [];
                parkVehicle(vehicle);
            } else {
                vehicle.ncc = 15;
                vehicle.brt++;

                if(vehicle.brt == 2) {
                    vehicle.blacklist = [];
                    vehicle.bBlacklist = [];
                }
            }
        }

        return false;
    }

    function handleHarvestDeposit(vehicle,def) {
        var possibleBuildings = [];
        var i, j, nextTo,availableSpaces;
        var found = false;

        if(!vehicle.ncc) {
            vehicle.ncc = 0;
        }

        if(vehicle.ncc > 0) {
            vehicle.ncc--;

            if(vehicle.ncc == 0) {
                vehicle.blacklist = [];
                vehicle.bBlacklist = [];
                vehicle.mq = [];
            }

            return;
        }

        for(i = 0; i < currentGame.buildings.length; i++) {

            if(!currentGame.buildings[i]) {
                continue;
            }

            if(currentGame.buildings[i].iuc) {
                continue;
            }

            if(currentGame.buildings[i].deactivated) {
                continue;
            }

            if(currentGame.buildings[i].lowPowerMode) {
                continue;
            }

            found = false;

            for(var l = 0, n = vehicle.bBlacklist.length; l < n; l++) {
                
                

                if(vehicle.bBlacklist[l] === currentGame.buildings[i].id) {
                    found = true;
                    break;
                }

                
            }

            if(found) {
                continue;
            }

            setUpMinidefForBuilding(currentGame.buildings[i],false,false);

            if(currentGame.buildings[i].md.refines == null) {
                continue;
            }

            var refines = false;

            for(j = 0; j < currentGame.buildings[i].md.refines.length; j++) {
                if(currentGame.buildings[i].md.refines[j].input == vehicle.harvests) {
                    refines = true;
                    break;
                }
            }

            if(refines) {
                possibleBuildings.push(currentGame.buildings[i]);
            }
        }

        // there are no refineries in the world.  just stop harvesting 
        if(possibleBuildings.length == 0) {

            vehicle.iH = false;
            vehicle.ht = null;
            parkVehicle(vehicle);
            notifySilosNeeded(vehicle.harvests,false);
            return;
        }

        var sortedBuildings = sortBuildingsByDistanceFromUnit(possibleBuildings,vehicle,false,200,def.isFlying);
        var pathsToSort = [];
        nextTo = null;

        while(sortedBuildings.length > 0) {
            var building = sortedBuildings.shift();

            if(building.d == 1) {
                nextTo = building.b;
                break;
            }

            availableSpaces = shuffle(getFreeSpacesAroundBuilding(building.b,1,false,false,def.isFlying));

            for(j = 0; j < availableSpaces.length; j++) {

                var a = vehicle.x - availableSpaces[j][0];
                var b = vehicle.y - availableSpaces[j][1];
                var distance = Math.sqrt( a*a + b*b );

                pathsToSort.push({
                    "x": availableSpaces[j][0],
                    "y": availableSpaces[j][1],
                    "d": distance
                });

            }

        }

        // if we are not by a building, we are probably not depositing
        if(nextTo == null) {
            vehicle.isDepositing = false;
        } else {
            vehicle.brt = 0;
            vehicle.ncc = 0;
            vehicle.blacklist = [];
            vehicle.bBlacklist = [];

            vehicle.isDepositing = true;
            vehicle.storage--;

            for(j = 0; j < nextTo.md.refines.length; j++) {
                if(nextTo.md.refines[j].input == vehicle.harvests) {

                    var allOutput = nextTo.md.refines[j].output.split(",");

                    for(var op = 0; op < allOutput.length; op++) {

                        if(getGameResources()[allOutput[op]].capacity == -1 && (getGameResources()[allOutput[op]].amount > getGameResources()[allOutput[op]].storageCapacity)) {
                            continue;
                        }

                        modifyResourceAmount(allOutput[op],1,false,"Harvesting");
                    }

                    
                }
            }
            
            if(vehicle.storage <= 0) {
                vehicle.storage = 0;
                vehicle.isDepositing = false;
            }

            return;
        }

        // otherwise, head off to the refinery (if available) for further instruction
        if(pathsToSort.length > 0) {

            pathsToSort.sort(sortTargetPoints);

            // slightly mix it up so everything isnt stuck together
            if(vehicle.brt == 0 && pathsToSort.length > 4) {
                if(randomIntFromInterval(0,3) == 1) {
                    pathsToSort.shift();
                }
            }

            vehicle.dX = pathsToSort[0].x;
            vehicle.dY = pathsToSort[0].y;

            if(useSyncPathfinding) {
                vehicle.mq = checkPathsSync(vehicle,"vehicle",pathsToSort);

                if(vehicle.mq.length > 0) {
                    vehicle.dX = vehicle.mq[vehicle.mq.length - 1].x;
                    vehicle.dY = vehicle.mq[vehicle.mq.length - 1].y;
                }
            } else {
                checkPathsThreaded(vehicle,"vehicle",pathsToSort);
            }

            vehicle.brt = 0;
            vehicle.ncc = 0;
            vehicle.blacklist = [];
            vehicle.bBlacklist = [];

            return;
        } else {
            vehicle.dX = vehicle.x;
            vehicle.dY = vehicle.y;

            if(vehicle.brt > 3) {
                vehicle.brt = 0;
                vehicle.inBuildingMode = false;
                vehicle.ncc = 0;

                // at this point, if we are still here then we couldnt find a resource or a refinery.  pout.
                vehicle.iH = false;
                vehicle.ht = null;
                vehicle.blacklist = [];
                vehicle.bBlacklist = [];
                parkVehicle(vehicle);
            } else {
                vehicle.ncc = 15;
                vehicle.brt++;

                if(vehicle.brt == 2) {
                    vehicle.blacklist = [];
                    vehicle.bBlacklist = [];
                }
            }
        }

    }

    function workOnBuildingConstruction(building,vehicle) {

        if(!building.iuc) {
            return;
        }

        if(building.c == null) {
            return;
        }

        var i;

        if(building.c.c < building.c.t) {

            var vehicleInfo = getVehicleDefByName(vehicle.def);

            var vehicleAble = false;

            if(vehicleInfo.produces != null) {
                for(i = 0; i < vehicleInfo.produces.length; i++) {

                    if(vehicleInfo.produces[i] == building.def) {
                        vehicleAble = true;
                    }
                }
            }

            if(!vehicleAble) {
                return;
            }

            var buildSpeed = 1;

            if(vehicleInfo.buildSpeed && vehicleInfo.buildSpeed > 1) {
                buildSpeed = vehicleInfo.buildSpeed;
            }

            if(vehicle.grp && vehicle.grp > 1) {
                buildSpeed *= vehicle.grp;
            }

            var wasAbleToBuild = false;

            var totalCOnstructionRemaining = 0;

            for(var resource in building.c.pr) {

                if(building.c.pr[resource] > 0) {
                    if(getGameResources()[resource].amount > 0) {


                        var amountToBuild = buildSpeed;

                        if(amountToBuild > getGameResources()[resource].amount) {
                            amountToBuild = getGameResources()[resource].amount;
                        }

                        if(amountToBuild > building.c.pr[resource]) {
                            amountToBuild = building.c.pr[resource];
                        }

                        modifyResourceAmount(resource,-amountToBuild,false,"Construction");
                        building.c.pr[resource] -= amountToBuild;
                        building.c.c += amountToBuild;
                        building.c.p = building.c.c / building.c.t;

                        wasAbleToBuild = true;

                        if(getGameResources()[resource].amount < 0) {
                            modifyResourceAmount(resource,0,true);
                        }
                    }
                }

                totalCOnstructionRemaining += building.c.pr[resource];

            }

            if(totalCOnstructionRemaining == 0) {
                building.c.c = building.c.t;
            }

            if(!wasAbleToBuild && vehicle.harvestAfterBuilding) {

                vehicle.inBuildingMode = false;

                vehicle.harvestAfterBuilding = false;
                vehicle.iH = true;
            }

        } else {
            vehicle.ncc = 15;
            vehicle.brt = 0;
            vehicle.blacklist = [];
            vehicle.bBlacklist = [];

            for(i = 0; i < currentGame.vehicles.length; i++) {
                if(currentGame.vehicles[i].x == vehicle.x && currentGame.vehicles[i].y == vehicle.y) {
                    currentGame.vehicles[i].ncc = 15;
                    vehicle.brt = 0;
                    currentGame.vehicles[i].blacklist = [];
                    currentGame.vehicles[i].bBlacklist = [];
                }
            }

            building.iuc = false;
            currentGame.buildingStatCycleCounter += 5;

            building.c = null;

            if(getBuildingDefByName(building.def).firstBuildMessage != null) {
                if(webAppCore.getVar("fbm-" + building.def,"0") == "0") {
                    
                    webAppCore.storeVar("fbm-" + building.def,"1");
                    
                    webAppCore.showDialog({
                        "title":    building.def,
                        "message":  getString(getBuildingDefByName(building.def).firstBuildMessage),
                        "op1": {
                            "text":     getString("general-dismiss"),
                            "func":     placeholder
                        }
                    });
                }
            }

            var bdefuse = getBuildingDefByName(building.def);
            

            if(bdefuse.becomesTerrain) {
                freeRefNukeTurn = true;
                var freshBuilding = new MapResource(getTerrainDefByName(bdefuse.becomesTerrain),building.x,building.y);
                currentGame.mapResources.push(freshBuilding);
                shoreUpdateTurn = true;
                building.isBeingRemoved = true;
                building = null;

            } else {

                updateUtilityGrid();

                if(!bdefuse.passable) {
                    drawSidebar();
                }
                

            }

            shouldUpdateCollissionMap = true;

            
        }
    }

    function updateBuildingCollisionPoints(building,value,flightOk) {

        if(!building || !building.occupiesTiles) {
            return;
        }

        

        for(var j = 0; j < building.occupiesTiles.length; j++) {
            // check if there is a valid passable on this tile 
            for(var passdef in currentGame.finishedPassableNonUpdatables) {
                var td = currentGame.finishedPassableNonUpdatables[passdef];

                var passDef = getBuildingDefByName(passdef);

                if(passDef && passDef.canBuildOver && passDef.canBuildOver.length > 0) {
                    if(passDef.canBuildOver.indexOf(building.def) > -1) {
                        if(td[building.occupiesTiles[j].x]) {
                            var tx = td[building.occupiesTiles[j].x];
        
                            for(var ty = 0; ty < tx.length; ty++) {
                                if(parseInt(tx[ty]) == building.occupiesTiles[j].y) {
                                    return;
                                }
                            }
                        }
                    }
                }

                
            }

            modifyCollisionWeight(building.occupiesTiles[j].x,building.occupiesTiles[j].y,value,flightOk);
        }
    }
    
    function updateVehicleCollisionPoints(vehicle,value) {
        modifyCollisionWeight(vehicle.x,vehicle.y,value);
    }

    var workingPassableDef = null;

    function updatePassable(passable) {
        if(passable.occupiesTiles == null) {
            passable.occupiesTiles = getOccupiedTiles(passable);
        }

        if(workingPassableDef == null || workingPassableDef.name != passable.def) {
            workingPassableDef = getBuildingDefByName(passable.def);
        }

        if(workingPassableDef.driveSpeedMod != null) {
            updateVehicleCollisionPoints(passable,-(workingPassableDef.driveSpeedMod));
        }
    }

    function updateNewPassable(def,x,y) {
        var driveSpeed = passableTileRefs[def].driveSpeedMod;
        modifyCollisionWeight(x,y,-driveSpeed,true);
    }

    function updateMapResource(mapresource) {

        if(mapresource == null) {
            return;
        }

        if(mapresource.occupiesTiles == null || mapresource.occupiesTiles.length == 0) {
            mapresource.occupiesTiles = getOccupiedTiles(mapresource,true);
        }

        updateBuildingCollisionPoints(mapresource,150,true);

        if(mapresource.playDef == null) {
            mapresource.playDef = getTerrainDefByName(mapresource.def);
        }

        if(shoreUpdateTurn) {
            if(mapresource.playDef.shoreSheet != null) {
                for(var i = 0; i < mapresource.occupiesTiles.length; i++) {

                    if(!shoreReferenceChart[mapresource.occupiesTiles[i].x]) {
                        shoreReferenceChart[mapresource.occupiesTiles[i].x] = {};
                    }
    
                    shoreReferenceChart[mapresource.occupiesTiles[i].x][mapresource.occupiesTiles[i].y] = mapresource.def;
                }
            }
        }

        if(mapresource.md != null) {
            if(spriteChangeTurn && mapresource.sf == -1) {
                mapresource.spriteFrame++;

                var tiledef = getImageDefByName(mapresource.md.tile);

                var col = null;

                if(currentGame) {
                    col = getRegionOrCity().themeColor;
                } else {
                    col = ColonyGame.meta.theme;
                }

                var frameCount = textureManager.getFrameCount(tiledef.image,col);

                if(mapresource.spriteFrame >= frameCount) {
                    mapresource.spriteFrame = 0;
                }

                
            }
        }

        if(currentGame.mem) {
            return;
        }

        if(mapresource.playDef.decayRate > 0) {
            mapresource.dc++;

            if(mapresource.dc >= mapresource.playDef.decayRate) {
                mapresource.inventory--;
            }
        }

        
    }

    function updateMapResourceSpreading(mapresource) {

        if(currentGame.mem) {
            return;
        }

        if(isNaN(mapresource.spreadCounter)) {
            
            
            mapresource.spreadCounter = 0;

            if(mapresource.playDef.spreadRate > 0) {
                mapresource.spreadMax = randomIntFromInterval(1,mapresource.playDef.spreadRate);
            } else {
                mapresource.spreadMax = 0;
            }
        }

        

        if(mapresource.spreadMax > 0) {
            mapresource.spreadCounter++;
        }

        if(mapresource.spreadMax > 0 && mapresource.spreadCounter > mapresource.spreadMax) {
            mapresource.spreadCounter = 0;


            if(mapresource.playDef.spreadRate > 0) {
                mapresource.spreadMax = randomIntFromInterval(1,mapresource.playDef.spreadRate);
            } else {
                mapresource.spreadMax = 0;
            }

            var freeSpaces = getFreeSpacesAroundBuilding(mapresource,1,true,true);

            if(freeSpaces != null && freeSpaces.length > 0) {
                var idx = randomIntFromInterval(0,freeSpaces.length - 1);
                var target = freeSpaces[idx];
                freeRefNukeTurn = true;

                if(isTilePassable(target[0],target[1],true)) {

                    var useDef = mapresource.playDef;

                    if(useDef.spreadResource && useDef.spreadResource != null) {
                        useDef = getTerrainDefByName(useDef.spreadResource);
                    }

                    var resourceItem = new MapResource(useDef,target[0],target[1]);
                    updateBuildingCollisionPoints(resourceItem,150,true);
                    currentGame.mapResources.push(resourceItem);
                    shoreUpdateTurn = true;
                }
            }

        }
    }

    function reInitBuilding(building) {

        if(!building) {
            return;
        }
        
        var bDef = getBuildingDefByName(building.def);

        if(building.occupiesTiles == null) {
            building.occupiesTiles = getOccupiedTiles(building);
        }

        if(isNaN(building.owner)) {
            building.owner = 0;
        }

        if(bDef.tileWidth > 1) {
            building.dX += (bDef.tileWidth - 1);
        }
        
        if(bDef.tileHeight > 1) {
            building.dY += (bDef.tileHeight - 1);
        }

        if(isNaN(building.wcc)) {
            building.wcc = 0;
        }

    }

    function updateBuilding(building,bDef) {

        if(building.isBeingRemoved) {
            return;
        }

        var doBuildingCleanup = false;

        building.dX = building.x;
        building.dY = building.y;

        var roc = getRegionOrCity();

        if(!roc) {
            return;
        }

        setUpMinidefForBuilding(building,false,false,bDef);

        if(!bDef) {
            bDef = getBuildingDefByName(building.def);
        }

        if(!bDef) {
            building.isBeingRemoved = true;
            building.condition = 0;
            return;
        }

        if(bDef.isCommsHubBldg || bDef.isCapitol || bDef.isConsulate || bDef.isEmbassy) {
            hasCommunicationsBuilding = true;
        }

        if(bDef.onlineTradeDepot && !roc.offlineMode && !building.isBeingRemoved && !building.iuc && !building.lowPowerMode) {
            hasGBTBuilding = true;
        }

        if(!building.owner) {
            building.owner = getRegionOrCity().localPlayerId;
        }

        if(bDef.becomesTerrain && !building.isBeingRemoved && !building.iuc) {
            freeRefNukeTurn = true;
            var freshBuilding = new MapResource(getTerrainDefByName(bDef.becomesTerrain),building.x,building.y);
            currentGame.mapResources.push(freshBuilding);
            shoreUpdateTurn = true;
            building.isBeingRemoved = true;
            building = null;
            return;
        }

        if(!bDef.canFlip) {
            if(building.flipped) {
                flipBuilding(building);
            }
        }

        if(spriteChangeTurn) {
            building.spriteFrame++;

            var checkTile = building.md.tile;

            if(building.md.offlineTile != null) {
                if(building.lowPowerMode || building.deactivated || (building.md.requiresWorkers && !building.sw)) {
                    checkTile = building.md.offlineTile;
                }
            }

            var col = null;

            if(currentGame) {
                col = roc.themeColor;
            } else {
                col = ColonyGame.meta.theme;
            }

            var tiledef = getImageDefByName(checkTile);
            var frameCount = textureManager.getFrameCount(tiledef.image,col);
            

            if(building.spriteFrame >= frameCount) {
                building.spriteFrame = 0;
            }

        }

        if(!building.deactivated && !building.iuc && building.embassyFor == 0) {
            currentGame.availableShelters += bDef.providesShelter;
            currentGame.availableTourism += bDef.takesTourists;

            if(building.bRC > bDef.providesShelter) {
                doBuildingCleanup = true;
            }
        }
        

        if(!building.iuc && bDef.unlocksGovLvl && bDef.unlocksGovLvl > roc.governmentLevel) {
            roc.governmentLevel = bDef.unlocksGovLvl;
        }

        if(bDef.isConsulate) {
            hasConsulate = true;
            ourCapitolBuilding = building;

            if(currentGame.isSubregion && currentSubcityRef) {
                currentSubcityRef.hasConsulate = true;
            }
        }

        if(bDef.isCapitol) {
            hasCapitol = true;
            ourCapitolBuilding = building;

            if(currentGame.isSubregion && currentSubcityRef) {
                currentSubcityRef.hasCapitol = true;
            }
        }


        if(bDef.acceptsWorkers > 0 && building.embassyFor == 0) {
            allJobsArray.push(building);
        }

        if(bDef.colGenRate && bDef.colGenRate != null && bDef.colGenRate > 0) {
            handleBuildingColonistGeneration(building);
        }

        if(bDef.passable) {
            updateBuildingCollisionPoints(building,-4,true);
        } else {
            updateBuildingCollisionPoints(building,150);
        }

        if(currentGame.readOnlyMode) {
            bDef = null;
            return;
        }
        
        if(building.iuc) {
            building.ofe = false;
            building.oft = false;
            building.jobsAvailable = 0;
            building.ofm = false;
            building.availableHomes = 0;
            bDef = null;
            return;
        }

        building.sw = false;
        //building.nw = 0;
        building.jobsAvailable = 0;
        building.availableHomes = 0;
        building.os = 0;

        if(bDef.providesShelter > 0) {
            building.availableHomes = bDef.providesShelter - building.bRC;

            if(building.embassyFor == 0) {
                allHomesArray.push(building);
            }

            if(building.availableHomes < 0) {
                building.availableHomes = 0;
                doBuildingCleanup = true;
            }
        }

        if(bDef.educates > 0 && !building.iuc) {
            building.os = bDef.educates - building.buS;

            if(building.os < 0) {
                building.os = 0;
            }
        }
        
        if(bDef.requiresUtility != null) {
            handleBuildingUtility(building);
        }

        if(bDef.requiresFuel != null) {
            handleBuildingConsumption(building);
        }
        
        if(!building.lowPowerMode && building.c != null) {
            handleBuildingConstruction(building);
        }

        if(!building.lowPowerMode && building.md.generates != null) {
            handleBuildingGeneration(building);
        }

        if(!building.lowPowerMode && bDef.smelts != null) {
            handleBuildingSmelting(building);
        }

        if(bDef.takesTourists > 0 || bDef.entertains > 0 || bDef.heals > 0) {
            updateBuildingEntertainmentAndMedical(bDef,building);
        } else {
            building.ofe = false;
            building.ofm = false;
        }

        if(!roc.offlineMode) {
            var buildingValue = getBuildingMarketValue(building,true,bDef);
            var maxRand = buildingValue / 2;

            if(maxRand < 180000) {
                maxRand = 180000;
            }

            var damagechance = randomIntFromInterval(1,maxRand);
            if(damagechance == 2) {
                building.condition--;
            }
        }

        if(!building.lowPowerMode) {
            if(bDef.giftCapacity > currentGame.giftCapacity) {
                currentGame.giftCapacity = bDef.giftCapacity;
            }
        }

        if(bDef.isEmbassy) {
            building.jobsAvailable = 0;
            building.availableHomes = 0;
            building.os = 0;
        }

        if(shoreUpdateTurn) {
            if(allPossibleBuildingConnectors.indexOf(building.def) > -1) {
                for(var i = 0; i < building.occupiesTiles.length; i++) {

                    if(!shoreReferenceChart[building.occupiesTiles[i].x]) {
                        shoreReferenceChart[building.occupiesTiles[i].x] = {};
                    }

                    shoreReferenceChart[building.occupiesTiles[i].x][building.occupiesTiles[i].y] = building.def;
                }
            }
        }

        if(doBuildingCleanup) {
            handleBuildingWorkerCleanup(building);

        }


    }

    function handleBuildingWorkerCleanup(building) {

        building.wcc = 0;

        if(!building.md) {
            setUpMinidefForBuilding(building,false);
        }


        var def = getBuildingDefByName(building.def);



        // disable buildings with no access
        if(def.touristDoorway || def.colGenRate > 0 || def.refines != null || def.isChopShop || def.entertains > 0 || def.providesShelter > 0 || def.acceptsWorkers > 0 || def.heals > 0 || def.educates > 0 || def.takesTourists) {
            
            var randomChanceToCheckThisTime = randomIntFromInterval(0,4);

            if(randomChanceToCheckThisTime == 2) {
                var freespace = getFreeSpacesAroundBuilding(building,1,false,false);
                if(freespace.length == 0) {
                    building.deactivated = true;
                }
            }
 
        }
    }

    function handleBuildingUtility(building) {

        if(currentGame.cm) {
            building.lowPowerMode = false;
            return;
        }

        if(building.deactivated || building.condition < 10) {
            building.lowPowerMode = true;
            return;
        }
    }

    function handleBuildingConsumption(building) {

        if(currentGame.cm) {
            building.ncm = false;
            return;
        }

        if(building.deactivated) {
            return;
        }

        var gameRes = getGameResources();

        if(!gameRes) {
            return;
        }

        var def = getBuildingDefByName(building.def);

        if(!def) {
            return;
        }

        if(def.requiresFuel == null) {
            return;
        }

        if(isNaN(building.cc)) {
            building.cc = 0;
            building.ncm = false;
        }

        building.cc += buildingUpdateCycles;

        
        building.ncm = false;
        var i;

        if(building.cc > def.requiresFuel.rate) {

            var consNeeded = Math.round(building.cc / def.requiresFuel.rate);

            if(consNeeded == 0) {
                consNeeded = 1;
            }

            if(consNeeded > def.requiresFuel.rate) {
                consNeeded = def.requiresFuel.rate;
            }

            var fuelRequirements = def.requiresFuel.resource.split(",");

            for(i = 0; i < fuelRequirements.length; i++) {
                if(gameRes[fuelRequirements[i]].amount < consNeeded) {
                    building.ncm = true;

                    if(storageCapCounter > lowPowerNagLimit) {
                        storageCapCounter = 0;
                        webAppCore.showToast({
                            message: getResourceByDefName(fuelRequirements[i]).name + " Depleted",
                            image:   "images/" + getResourceByDefName(fuelRequirements[i]).icon
                        });
                        updateUtilityGrid();
                    }
    
                    return;
                }
            }

            building.cc = 0;
            

            for(i = 0; i < fuelRequirements.length; i++) {
                modifyResourceAmount(fuelRequirements[i],-consNeeded,false,building.def);

                if(gameRes[fuelRequirements[i]].amount < 0) {
                    
                    modifyResourceAmount(fuelRequirements[i],0,true);
                }
            }

        }

    }

    function handleBuildingColonistGeneration(building) {

        if(building.deactivated) {
            return;
        }

        if(building.ncm) {
            return;
        }

        if(building.iuc) {
            return;
        }

        var roc = getRegionOrCity();
        var def = getBuildingDefByName(building.def);

        if(roc.stopImmigration && !def.embargoImmune) {
            if(!def.touristDoorway) {
                return;
            }
            
        }

        if(!building.cg) {
            building.cg = new ColGenItem();
        }

        if(building.cg.m == 0) {
            building.cg.c = 0;
            building.cg.m = randomIntFromInterval(1,def.colGenRate);
        }

        if(roc.immigrationEmbargo && !def.embargoImmune) {
            return;
        }

        if(def.requiresWorkers && building.buW == 0) {
            return;
        }

        var count = (building.buW * buildingUpdateCycles);

        if(building.buW == 0) {
            count = buildingUpdateCycles;
        }

        building.cg.c += count;

        building.cg.p = building.cg.c / building.cg.m;

        if(building.cg.c >= building.cg.m) {
            building.cg.m = 0;
            building.cg.c = 0;

            var bringTourist = false;
            var bringColonist = false;
            var thepop;

            if(def.touristDoorway) {
                if(previouslyAvailableTourism > currentGame.touristCount) {
                    bringTourist = true;
                }

                if(def.isStargate && previouslyAvailableShelters > getTotalPopulation()) {
                    bringColonist = true;
                }
            } else {
                if(previouslyAvailableShelters > getTotalPopulation()) {
                    bringColonist = true;
                }

                if(def.isStargate && previouslyAvailableTourism > currentGame.touristCount) {
                    bringTourist = true;
                }
            }

            if(roc.stopTourism) {
                bringTourist = false;
            }

            if(bringTourist || bringColonist) {

                var arrivals = 1;
                var availableSpaces = getFreeSpacesAroundBuilding(building,1,false);

                if(availableSpaces.length > 0) {

                    var maxArrivals = 1;

                    if(def.touristDoorway) {
                        maxArrivals = 10;
                    }

                    if(def.isStargate) {
                        maxArrivals = 18;
                    }

                    var approvalRate = currentGame.historicStats.approval[currentGame.historicStats.approval.length - 1] / 100;

                    

                    maxArrivals = Math.ceil(maxArrivals * approvalRate);

                    if(isNaN(maxArrivals) || maxArrivals < 1) {
                        maxArrivals = 1;
                    }

                    arrivals = randomIntFromInterval(1,maxArrivals);

                    if(arrivals < 1) {
                        arrivals = 1;
                    }

                    while(arrivals > 0) {

                        var useRace = roc.defaultRace;
                        var immagrantSource = roc.motherland;

                        var availableRaces = [{
                            "race": useRace,
                            "source": immagrantSource
                        }];
                        

                        var isImmigrant = false;

                        if(!def.embargoImmune) {
                            isImmigrant = true;

                            for(var prop in roc.foreignContactReference) {

                                for(var r = 0; r < ColonyGame.races.length; r++) {
                                    if(roc.foreignContactReference[prop].race == ColonyGame.races[r].name) {

                                        availableRaces.push({
                                            "race": roc.foreignContactReference[prop].race,
                                            "source": roc.foreignContactReference[prop].name
                                        });
                                    }
                                }

                                
                            }
                        }

                        var useTarget = availableRaces[randomIntFromInterval(0,availableRaces.length - 1)];

                        useRace = useTarget.race;
                        immagrantSource = useTarget.source;


                        var idx = randomIntFromInterval(0,availableSpaces.length - 1);
                        var target = availableSpaces[idx];

                        var dtx = target[0];
                        var dty = target[1];

                        var freshVehicle;

                        if(isNaN(dtx) || isNaN(dty)) {
                            dtx = building.x;
                            dty = building.y;
                        }

                        

                        if(bringTourist) {

                            building.bTA++;

                            currentGame.totalTourists++;

                            arrivals--;

                        }
                        
                        if(bringColonist) {

                            if(isImmigrant) {
                                currentGame.totalImmigration++;

                                currentGame.immigrantSources.push(immagrantSource);
                                
                                while(currentGame.immigrantSources.length > 400) {
                                    currentGame.immigrantSources.shift();
                                }
                            }

                            createNewPerson(null,1,currentGame);

                            if(currentGame.populationStats[useRace] === undefined) {
                                currentGame.populationStats[useRace] = 0;
                            }

                            currentGame.populationStats[useRace]++;

                            thepop = getTotalPopulation();


                            arrivals--;
                        }

                        if(freshVehicle) {
                            freshVehicle.def.tile = getColonistTile(freshVehicle);
                        }
                        

                        
                    }

                    thepop = getTotalPopulation();

                    if(!currentGame.cm && ColonyGame.achievements.thousandTourists > 0) {
                        if(currentGame.totalTourists > 1000) {
                            webAppCore.reportAchievement(ColonyGame.achievements.thousandTourists);
                        }
                    }

                    if(!currentGame.cm) {
                        if(ColonyGame.achievements.hundredColonists > 0) {
                            if(thepop > 100) {
                                webAppCore.reportAchievement(ColonyGame.achievements.hundredColonists);
                            }
                        }

                        if(ColonyGame.achievements.thousandColonists > 0) {
                            if(thepop > 1000) {
                                webAppCore.reportAchievement(ColonyGame.achievements.thousandColonists);
                            }
                        }

                        if(ColonyGame.achievements.tenthousandColonists > 0) {
                            if(thepop > 10000) {
                                webAppCore.reportAchievement(ColonyGame.achievements.tenthousandColonists);

                                if(workingMapType && workingMapType.tenthousandColonistsMapAch) {
                                    webAppCore.reportAchievement(workingMapType.tenthousandColonistsMapAch);
                                }
                            }
                        }
                    }

                    if(!currentGame.cm) {
                        checkDoKongStat("touristCount",currentGame.totalTourists);
                        checkDoKongStat("populationCount",thepop);
                    }

                }


                availableSpaces = null;
            }
        }
    }

    function handleBuildingConstruction(building) {

        if(building.deactivated) {
            return;
        }

        if(building.c == null) {
            return;
        }

        if(building.c.c < building.c.t && !currentGame.cm) {

            var vd = getVehicleDefByName(building.c.q[0]);

            if(!vd) {
                building.isBeingRemoved = true;
                return;
            }
                
            for(var i = 0; i < vd.cost.length; i++) {
                for(var j = 0; j < buildingUpdateCycles; j++) {
                    if(building.c.pr[vd.cost[i].resource] > 0) {
                        if(getGameResources()[vd.cost[i].resource].amount > 0) {

                            modifyResourceAmount(vd.cost[i].resource,-1,false,"Construction");

                            building.c.pr[vd.cost[i].resource]--;
                            building.c.c++;
                            building.c.p = building.c.c / building.c.t;

                            if(getGameResources()[vd.cost[i].resource].amount < 0) {
  
                                modifyResourceAmount(vd.cost[i].resource,0,true);
                            }
                        }
                    }
                }
            }

        } else {
            // job is done, build the vehicle or wait for free space

            if(building.c.t > 0) {
                var availableSpaces = getFreeSpacesAroundBuilding(building);

                if(availableSpaces.length > 0) {
                    
                    var idx = randomIntFromInterval(0,availableSpaces.length - 1);
                    var target = availableSpaces[idx];

                    var vd2 = getVehicleDefByName(building.c.q[0]);
                    
                    var freshVehicle = new Vehicle(vd2,target[0],target[1],getRegionOrCity().localPlayerId);
                    currentGame.vehicles.push(freshVehicle);

                    


                    if(vd2.firstBuildMessage != null) {
                        if(webAppCore.getVar("fbm-" + freshVehicle.def,"0") == "0") {
                            
                            webAppCore.storeVar("fbm-" + freshVehicle.def,"1");
                            
                            webAppCore.showDialog({
                                "title":    freshVehicle.def,
                                "message":  getString(vd2.firstBuildMessage),
                                "op1": {
                                    "text":     getString("general-dismiss"),
                                    "func":     placeholder
                                }
                            });
                        }
                    }

                    
                    
                    unstickUnit(freshVehicle);

                    building.c.q.shift();
                    

                    drawSidebar();
                } else {
                    // cry and wait for something to move
                } 

                availableSpaces = null;
            }

            if(building.c.q.length > 0) {
                building.c.c = 0;
                building.c.p = 0;
                building.c.pr = {};
                building.c.t = 0;

                var vd3 = getVehicleDefByName(building.c.q[0]);

                if(vd3) {
                    for(var l = 0; l < vd3.cost.length; l++) {
                        building.c.pr[vd3.cost[l].resource] = vd3.cost[l].amount;
                        building.c.t += vd3.cost[l].amount;
                    }
                } else {
                    building.c = null;
                }

                
            } else {
                building.c = null;
            }
        }
    }

    function handleBuildingGeneration(building) {

        if(building.deactivated) {
            return;
        }

        if(building.ncm) {
            return;
        }

        if(building.gc < building.md.generateTime) {

            if(!building.md.requiresWorkers) {
                building.gc += buildingUpdateCycles;
            }

            for(var i = 0; i < building.buW; i++) {
                building.gc += buildingUpdateCycles;
            }

        }

        if(building.gc >= building.md.generateTime) {

            var gensNeeded = Math.round(building.gc / building.md.generateTime);

            if(gensNeeded == 0) {
                gensNeeded = 1;
            }

            var genResourceRef = getGameResources()[building.md.generates];

            if(genResourceRef.capacity == null || (genResourceRef.capacity == -1 && genResourceRef.amount < genResourceRef.storageCapacity) || (genResourceRef.amount < genResourceRef.capacity)) {
                building.gc = 0;
                modifyResourceAmount(building.md.generates,(building.md.generateAmount * gensNeeded),false,building.def);

                if(useTextPoppers && Scroll2d.checkVisibility(building.x,building.y) && lastZoomLevel > 0.5) {
                    Scroll2d.popText(building.x,building.y,getResourceByDefName(building.md.generates).indicator + building.md.generateAmount,getResourceByDefName(building.md.generates).color);
                }
            }

            genResourceRef = null;
        }
        
        building.gp = building.gc / building.md.generateTime;
    }

    function handleBuildingSmelting(building) {

        if(building.deactivated) {
            return;
        }

        if(building.ncm) {
            return;
        }

        var gameRes = getGameResources();

        if(!gameRes) {
            return;
        }
        

        var genRate = buildingUpdateCycles;

        var bldDef = getBuildingDefByName(building.def);

        if(!bldDef) {
            return;
        }

        if(isNaN(building.smeltCounter)) {
            building.smeltCounter = 0;
        }

        var i;

        if(building.smeltCounter < bldDef.smelts.time) {

            genRate = buildingUpdateCycles;

            if(bldDef.requiresWorkers) {
                genRate = 0;
            }

            for(i = 0; i < building.buW; i++) {
                genRate += buildingUpdateCycles;
            }

            building.smeltCounter += genRate;
        }



        if(building.smeltCounter >= bldDef.smelts.time) {

            var smeltsNeeded = Math.round(building.smeltCounter / bldDef.smelts.time);

            if(smeltsNeeded == 0) {
                smeltsNeeded = 1;
            }

            var smeltItems = bldDef.smelts.input.split(",");

            var canAfford = true;

            for(i = 0; i < smeltItems.length; i++) {
                if(gameRes[smeltItems[i]].amount <= 0) {
                    canAfford = false;
                    break;
                }
            }

            if(!canAfford) {
                building.smeltCounter = bldDef.smelts.time;
                return;
            }

            var outputResource = null;

            if(bldDef.smelts.output != null) {
                var outputResourceAll = bldDef.smelts.output.split("|");
                outputResource = outputResourceAll[randomIntFromInterval(0,outputResourceAll.length - 1)];
            }

            // check for capacity
            if(outputResource == null || gameRes[outputResource].capacity == null || gameRes[outputResource].capacity == 0 || (gameRes[outputResource].capacity == -1 && (gameRes[outputResource].storageCapacity > gameRes[outputResource].amount))) {

                for(i = 0; i < smeltItems.length; i++) {

                    if(gameRes[smeltItems[i]].amount < 1) {

                        if(storageCapCounter > lowPowerNagLimit) {
                            storageCapCounter = 0;
                            webAppCore.showToast({
                                message: getResourceByDefName(smeltItems[i]).name + " Depleted",
                                image:   "images/" + getResourceByDefName(smeltItems[i]).icon
                            });
                            updateUtilityGrid();
                        }
        
                        return;
                    }

                    modifyResourceAmount(smeltItems[i],-smeltsNeeded,false,building.def);
                }



                if(outputResource != null) {
                    modifyResourceAmount(outputResource,(bldDef.smelts.ratio * smeltsNeeded),false,building.def);
                }

                building.smeltCounter = 0;

                if(outputResource != null && useTextPoppers && Scroll2d.checkVisibility(building.x,building.y) && lastZoomLevel > 0.5) {
                    Scroll2d.popText(building.x,building.y,getResourceByDefName(outputResource).indicator + "" +  bldDef.smelts.ratio,getResourceByDefName(outputResource).color);
                }

            } else {
                building.smeltCounter = bldDef.smelts.time;

                if(storageCapCounter > lowPowerNagLimit) {
                    storageCapCounter = 0;
                    webAppCore.showToast({
                        message: "Insufficient Storage",
                        image:   "images/" + getResourceByDefName(outputResource).icon
                    });
                }
            }

        }


    }

    var remoteCloudLoad = false;

    function initScroll2d() {

        Scroll2d.init(document.getElementById("canvasHolder"));

        var useIsometric = true;

        if(ColonyGame.meta.useIsometric != undefined) {
            useIsometric = ColonyGame.meta.useIsometric;
        }
        
        Scroll2d.setIsometric(useIsometric);
        Scroll2d.initParticleEngine();
        Scroll2d.setGridSize(ColonyGame.meta.gridSize * renderScaleFactor);
        Scroll2d.setMapDims(ColonyGame.meta.mapWidth,ColonyGame.meta.mapHeight);
        Scroll2d.setDrawFunction(draw);
        Scroll2d.setClickFunction(click);
        Scroll2d.setPaintFunction(paint);
        Scroll2d.setRightClickFunction(rightClick);
        Scroll2d.setHoverFunction(hover);
        Scroll2d.setHoldFunction(hold);
        Scroll2d.setUpdateFunction(update,40);
        Scroll2d.setZoomLevel(zoomLevel / renderScaleFactor);
        Scroll2d.setViewPadding(3);
        Scroll2d.setSelectionFunction(onSelectionDone,onSelectionChange);
        Scroll2d.setFastRenderMode(!checkRenderDistance);
        Scroll2d.setFPSLimiter(fpsRate);
        Scroll2d.setViewportChangeFunction(onViewportChange);
        
        Scroll2d.centerOnCoord(50,50);
        
        var parm = webAppCore.getExternalParm();

        if(parm != "0") {

            if(startsWith(parm,ColonyGame.fileShareUrlPrefix)) {

                parm = parm.replace(ColonyGame.fileShareUrlPrefix,"");

                if(startsWith(parm,"view_")) {
                    currentFileName = "shared";
                    remoteCloudLoad = true;
                    var rawishPath = parm.replace("view_","");
                    var cleanishPath = replaceAll(rawishPath,"_","/");
                    webAppCore.showSplash("Syncing Data...");
                    loadCloudReadOnly(cleanishPath);
                    return;
                } else {
                    remoteCloudLoad = false;
                }
            }

            if(startsWith(parm,"loadmap=")) {
                openGame(parm.replace("loadmap=",""));
                return;
            }
 
        }

    }

    var returnToFileName = null;

    function loadCloudReadOnly(path) {
        currentFileName = "shared";
        remoteCloudLoad = true;
        webAppCore.loadSharedCloudFile(path,onCloudShareFileReturn);
    }

    function onCloudShareFileReturn(data) {
        if(data && data != "fail" && data.length > 10) {
            uncompressFile(data);
        } else {
            webAppCore.showToast("Unable To Load Map");
            remoteCloudLoad = false;
            showTitle();
        }
    }

    function turnOffStreaming() {

        webAppCore.closeChat();

        postSecuredCallToApi([
            {
                "key":      "sdat",
                "value":    0
            }
        ],51,placeholder);

        webAppCore.stopStreaming();

        document.getElementById("streamControlsBar").style.display = null;

        isStreamingLive = false;

        if(!streamingIndicator) {
            streamingIndicator = document.getElementById("imStreaming");
        }

        streamingIndicator.src = "images/" + ColonyGame.meta.streamingOffIndicator;

        loadChat(true);
    }

    
    function shutDownStreamsForSwitch() {

        webAppCore.stopStreaming();

        document.getElementById("streamControlsBar").style.display = null;
    }
    


    function showTitle() {

        if(pendingFlagUploadTimer) {
            clearTimeout(pendingFlagUploadTimer);
        }

        pendingFlagUploadTimer = null;
        pendingUploadFlagData = null;
        currentChatChannel = null;

        getUserMultiplayerRegions();

        document.getElementById("titleBackdropHold").style.display = "none";
        desktopNotificationAreaReadout.innerHTML = "";
        document.getElementById("imClearNotifications").style.display = "none";

        document.getElementById("imFriends").style.display = "none";

        Scroll2d.deInit();

        if(theNeverLoadedTimeout) {
            clearTimeout(theNeverLoadedTimeout);
            theNeverLoadedTimeout = null;
        }

        colonyNeverLoaded = false;
        saveAndQuitting = false;

        tmpBuildingRefHolder = {};
        runningBuildingCounts = {};
        runningVehicleCounts = {};
        syncColMap = null;
        syncNodeRecycling = [];
        pendingAutosales = [];
        autosellProcessCounter = 0;
        killSwitch = false;

        turnOffStreaming();
        streamingIndicator.style.display = "none";

        getAccountHolderTokens();

        gooseUpPathWorker();
        clearDefaultColoredAssets();

        if(offlineGameServerId != "-1") {
            webAppCore.closeTcpSocket(offlineGameServerId,placeholder);
        }

        vitalCounter = 9500;
        webAppCore.storeVar("vital-res-width","0");
        webAppCore.storeVar("vital-res-height","0");
        webAppCore.storeVar("vital-res-pop","0");
        webAppCore.storeVar("vital-res-online","0");

        currentGame = null;
        openJobsArray = [];
        lastColorFilter = null;
        curRegPreviewWorkItem = null;
        curRegPreviewWorkQueue = [];
        curRegPreviewWorkItem = null;
        curRegRiverTemplateCanvas = null;
        curRegRiverTemplateContext = null;
        opprotunityRecycleBox = [];
        currentJobOpprotunities = [];
        currentTemplate = null;
        templateVisible = false;
        currentRegion = null;
        currentSubcityRef = null;

        webAppCore.closeChat();

        offlineGameServerId = "-1";
        connectedLocals = [];

        totalAvailableVehicles = 0;
        colonyNeverLoaded = false;

        returnToFileName = null;

        if(usingSockets) {
            webAppCore.socketEmit("closeconnection","");
        }

        closeGBT();
        closeStatsMenu();

        document.getElementById("allResourceSearchHolder").style.display = "none";
        document.getElementById("chatInputBoxHolder").style.display = "none";

        closeColonyWindow();
        closeObjectOptionsMenu();

        notificationArea.innerHTML = "";

        riotingWarned = false;
        anarchyWarned = false;
        famineWarned = false;
        noWaterWarned = false;



        resourceLedger = null;

        saveInProgress = false;

        titleShowing = true;
        
        stopSoundtrack();
        
        setupMenuOptions();

        webAppCore.setTheme(ColonyGame.meta.titleTheme);

        var lastGame = webAppCore.getVar("mc-last-saved-game","0");
        var lastColonyName = webAppCore.getVar("mc-last-saved-game-name","0");

        webAppCore.resetTitle();

        webAppCore.setTitleOptionListener(onTitleOptionSelected);


        

        webAppCore.setTitleBackground(ColonyGame.meta.titleTheme + " url('images/background.jpg') no-repeat fixed center/cover");

        webAppCore.setTitleLogo("images/logo.png");

        webAppCore.setTitleSubtitle("Build v" + webAppCore.getAppVersion());


        if(lastGame != null && lastGame != "0") {
            if(lastColonyName == null || lastColonyName == "0" || lastColonyName.trim().length == 0) {
                webAppCore.addTitleOption(getString("general-contine"),"continue");
            } else {
                webAppCore.addTitleOption(lastColonyName,"continue");
            }
        }

        webAppCore.addTitleOption(getString("general-new"),"new");
        webAppCore.addTitleOption(getString("general-load"),"load");

        if(webAppCore.getPlatform().platform == "web") {
            if(webAppCore.getPlatform().market == "apewebapps") {
                if(ColonyGame.meta.nativeClientURL != null) {
                    webAppCore.addTitleOption(getString("general-native-client"),"native");
                }
            }
        }

        webAppCore.addTitleOption(getString("general-options"),"options");

        bulldozerMode = false;

        webAppCore.setTitleVisible(true);
        webAppCore.handleBackFunction(null);

        webAppCore.clearSplash();
        vehiclePathOrders = {};
        colonistPathOrders = {};

        sizeElements();

        if(webAppCore.isApeAppsLoggedIn()) {
            refreshFriendsList();
        }
        
    }

    function downloadNativeClient() {
        webAppCore.externalURL(ColonyGame.meta.nativeClientURL);
    }

    function onTitleOptionSelected(tag) {

        if(tag == "native") {
            webAppCore.showDialog({
                "title":    getString("general-native-client"),
                "message":  getString("native-client-description"),
                "op1": {
                    "text":     getString("general-yes"),
                    "func":     downloadNativeClient
                },
                "op2": {
                    "text":     getString("general-no"),
                    "func":     placeholder
                }
            });
        }

        if(tag == "continue") {
            webAppCore.showSplash("Loading Data...");
            titleShowing = false;
            bulldozerMode = false;
            webAppCore.setTitleVisible(false);
            webAppCore.handleBackFunction(standardBack);
            continueToPlayMode();
        }

        if(tag == "new") {

            newGame();
        }

        if(tag == "options") {
            webAppCore.toggleMenu();
        }

        if(tag == "load") {
            listingType = "load";
            webAppCore.openListing(showOpenGameListing);
        }
    }

    function continueToPlayMode() {
        var lastGame = webAppCore.getVar("mc-last-saved-game","0");

        if(lastGame == "0") {
            newGame();
        } else {
            openGame(lastGame);
        }
    }

    function showHiders() {
        var hiders = document.querySelectorAll(".newGameHide");

        for(var i = 0; i < hiders.length; i++) {
            hiders[i].style.display = "block";
        }
    }
    
    function newGame() {

        var menuOptions = [];

        var isXbox = false;

        var signInColor = "#26C6DA";

        if(webAppCore.getPlatform().platform == "windows" && webAppCore.isTV()) {
            isXbox = true;
        }

        if(!isXbox && webAppCore.allowOnline() && ColonyGame.meta.colonyServerApi != null) {

            var reqString = getString("new-charter-req-online");

            if(webAppCore.getPlatform().platform == "web") {
                if(webAppCore.getPlatform().market == "kongregate") {
                    reqString = getString("gen-must-sign-in");
                }
            }


            if(webAppCore.isApeAppsLoggedIn()) {
                reqString = null;
                signInColor = null;
            }

            menuOptions.push({
                "title":        "Online Game",
                "description":  getString("new-charter-desc"),
                "icon":         "images/" + ColonyGame.meta.onlineModeInd,
                "status":       reqString,
                "status-color":  signInColor,
                "tag":          "charter"
            });

            var regionStatus = reqString;
            var regionColor = signInColor;

            if(!webAppCore.getIsPremium()) {
                regionStatus = "Requires Premium";
                regionColor = "#FFC107";
            }

            menuOptions.push({
                "title": getString("mp-region"),
                "description": getString("mp-region-desc"),
                "icon":         "images/" + ColonyGame.meta.mpRegionInd,
                "tag": "mpregion",
                "status":       regionStatus,
                "status-color":  regionColor,
                "overflow": [
                    {
                        "pre": "Experimental",
                        "color": "#ff0000"
                    }
                ]
            });

        }

        var offlineName = getString("gen-local-mode");

        menuOptions.push({
            "title":        offlineName,
            "description":  getString("offline-game-desc"),
            "icon":         "images/" + ColonyGame.meta.offlineModeInd,
            "status":       null,
            "status-color":  null,
            "overflow":     null,
            "tag":          "homeworld"
        });

        

        var creativeStatus = null;
        var creativeColor = null;

        if(!webAppCore.getIsPremium()) {
            creativeStatus = "Requires Premium";
            creativeColor = "#FFC107";
        }

        menuOptions.push({
            "title":        "Creative Mode",
            "description":  getString("creative-mode-desc"),
            "icon":         "images/" + ColonyGame.meta.showBuildSidebarIcon,
            "status":       creativeStatus,
            "status-color":  creativeColor,
            "overflow":     null,
            "tag":          "creative"
        });

        if(menuOptions.length == 1) {

            newCivSelected(menuOptions[0].tag);

            return;
        }


        showList("New Game",menuOptions,onNewGameTypeSelected,getString("general-dismiss"));


        webAppCore.clearSplash();
        vehiclePathOrders = {};
        colonistPathOrders = {};
    }

    var creativeFlag = false;

    function onNewGameTypeSelected(tag) {
        if(tag == null) {
            return;
        }

        if(tag == "charter") {
            if(webAppCore.isApeAppsLoggedIn()) {
                creativeFlag = false;
                setTimeout(function(){
                    showCharterMenu(standardCharterSelection);
                },750);
            } else {
                showTitle();
                showOnlineRequirement();
            }
            return;
        }

        if(tag == "homeworld") {
            creativeFlag = false;
            setTimeout(showHomeworldSelection,750);
            return;
        }

        if(tag == "creative") {

            if(!webAppCore.getIsPremium()) {
                showPremiumMessage();
                showTitle();
                return;
            }

            creativeFlag = true;
            setTimeout(showHomeworldSelection,750);
            return;
        }

        if(tag == "mpregion") {

            if(!webAppCore.getIsPremium()) {
                showPremiumMessage();
                showTitle();
                return;
            }

            creativeFlag = false;
            setTimeout(showMpRegionCharterMenu,750);
            return;
        }
    }

    function showHomeworldSelection() {
        var i;
        
        var menuOptions = [];

        for(i = 0; i < ColonyGame.civilizations.length; i++) {
            menuOptions.push({
                "title":        ColonyGame.civilizations[i].name,
                "description":  getString(ColonyGame.civilizations[i].description),
                "icon":         "images/" + ColonyGame.civilizations[i].icon,
                "overflow":     null,
                "tag":          ColonyGame.civilizations[i]
            });
        }


        


        if(menuOptions.length == 1) {

            newCivSelected(menuOptions[0].tag);

            return;
        }


        showList("Select Civilization",menuOptions,newCivSelected,getString("general-dismiss"));
    }

    var tmpNewCiv;
    var tmpNewMapType;
    var tmpNewMotherlandName;
    var tmpNewMotherlandId;

    function newCivSelected(tag) {

        if(tag == null) {
            return;
        }

        if(tag == "charter") {
            setTimeout(function(){
                showCharterMenu(standardCharterSelection);
            },750);
            return;
        }

        tmpNewCiv = tag;

        tmpNewMotherlandName = tmpNewCiv.name;
        tmpNewMotherlandId = 0;

        pauseThenShowMapChoices();
    }

    function pauseThenShowMapChoices() {
        
        setTimeout(showMapTypeChoices,750);
    }

    function showMpRegionCharterMenu() {
        var data = [];

        data.push({
            "key":      "f",
            "value":    61
        });

        data.push({
            "key":      "g",
            "value":    ColonyGame.meta.colonyServerGameId
        });

        data.push({
            "key":      "relcd",
            "value":    ColonyGame.meta.releaseCode
        });

        webAppCore.postForResult(ColonyGame.meta.colonyServerApi, data, onRandomMpRegionCharterListBack);
    }

    function onRandomMpRegionCharterListBack(result) {
        if(result == null) {
            return;
        }

        var charters = null;
        var i;

        try {
            charters = JSON.parse(result);
        } catch(ex) {
            pauseThenShowCharterInput(loadMultipleyerRegion);
            webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onRandomCharterListBack",ex.message);
            return;
        }

        if(charters == null) {
            charters = [];
            return;
        }

        var menuOptions = [];

        menuOptions.push({
            "title":        getString("new-mp-region"),
            "description":  getString("new-mp-region-desc"),
            "icon":         "images/" + ColonyGame.meta.independenceIndicator,
            "status":       null,
            "status-color":  null,
            "overflow":     null,
            "tag":          "newmpregion"
        });

        menuOptions.push({
            "title":        "Custom Charter Code",
            "description":  "If you already know what charter code you want to use, select this option to input your code.",
            "icon":         "images/" + ColonyGame.meta.charterIndicator,
            "status":       null,
            "status-color":  null,
            "overflow":     null,
            "tag":          "custom"
        });

        for(i = 0; i < charters.charters.length; i++) {

            var charter = charters.charters[i];
            var pDef = getPlanetDefByName(charter.maptype);

            if(!charter || !pDef) {
                continue;
            }

            var cost = [
                {
                    pre:    "Population: ",
                    post:   numberWithCommas(charter.population),
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.colonistIcon
                },
                {
                    pre:    "GDP: ",
                    post:   numberWithCommas(charter.totalgdp),
                    color:  null,
                    icon:   "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                },
                {
                    pre:    "Location: ",
                    post:   "Sector " + charter.sector + "; " + charter.location,
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.dimensionIndicator
                }
            ];

            var salesPitch = null;

            if(charter.info != "0" && charter.info.trim().length > 0) {
                salesPitch = charter.info;
            }

            menuOptions.push({
                "title":        charter.name,
                "description":  salesPitch,
                "icon":         "images/" + pDef.icon,
                "status":       null,
                "status-color": null,
                "overflow":     cost,
                "tag":          charter
            });
        }

        showList("Select Charter",menuOptions,onMpRegionCharterSelected,getString("general-dismiss"));
    }

    var pendingNewMpRegionType = null;
    var pendingNewMpRegionName = null;
    var pendingNewMpRegionPrivate = false;

    function onMpRegionCharterSelected(tag) {

        if(!tag) {
            return;
        }

        if(tag == "newmpregion") {
            pendingNewMpRegionType = null;
            pendingNewMpRegionName = null;
            pendingNewMpRegionPrivate = false;

            showSelectPlanetTypeForMpRegion();

            return;
        }

        if(tag == "custom") {
            var dialogOptions = {
                "title":    "Custom Charter Code",
                "message":  "If you already know what charter code you want to use, input your code below.",
                func: loadMultipleyerRegion
            };
    
            webAppCore.inputBox(dialogOptions);

            return;
        }

        if(tag.charter) {
            loadMultipleyerRegion(tag.charter);
        }
    }

    function showSelectPlanetTypeForMpRegion() {
        var menuOptions = [];

        for(var j = 0; j < ColonyGame.mapTypes.length; j++) {
            menuOptions.push({
                "title":        ColonyGame.mapTypes[j].name,
                "description":  getString(ColonyGame.mapTypes[j].description),
                "icon":         "images/" + ColonyGame.mapTypes[j].icon,
                "status":       "Difficulty: " + ColonyGame.mapTypes[j].difficulty,
                "overflow":     null,
                "tag":          ColonyGame.mapTypes[j].name
            });
        }

        showList("Select Map Type",menuOptions,onMapTypeSelectedForNewMpRegion,getString("general-dismiss"));
    }

    function onMapTypeSelectedForNewMpRegion(tag) {
        if(!tag) {
            return;
        }

        pendingNewMpRegionType = tag;

        var dialogOptions = {
            "title":    getString("region-name"),
            "message":  getString("region-name-desc"),
            func: onNewMpRegionNameSelected
        };

        webAppCore.inputBox(dialogOptions);
    }

    function onNewMpRegionNameSelected(text) {
        if(!text || text.trim().length == 0) {
            return;
        }

        pendingNewMpRegionName = text.trim();

        webAppCore.showDialog({
            title: getString("general-private-charter"),
            message: getString("region-charter-private"),
            icon: "images/" + ColonyGame.meta.charterIndicator,
            buttons: [
                {
                    text: getString("general-private"),
                    tag: "private",
                    func: function() {
                        onNewMpRegionCharterPrivacySelected(true);
                    }
                },
                {
                    text: getString("general-public"),
                    tag: "public",
                    func: function() {
                        onNewMpRegionCharterPrivacySelected(false);
                    }
                }
            ]
        });
    }

    function onNewMpRegionCharterPrivacySelected(isPrivate) {
        pendingNewMpRegionPrivate = isPrivate;

        if(!pendingNewMpRegionPrivate) {
            pendingNewMpRegionPrivate = false;
        }

        // register the new online region
        var data = [];

        data.push({
            "key":      "f",
            "value":    62
        });

        data.push({
            "key":      "g",
            "value":    ColonyGame.meta.colonyServerGameId
        });

        data.push({
            "key":      "n",
            "value":    pendingNewMpRegionName
        });

        data.push({
            "key":      "m",
            "value":    pendingNewMpRegionType
        });

        if(pendingNewMpRegionPrivate) {
            data.push({
                "key":      "p",
                "value":    "0"
            });
        } else {
            data.push({
                "key":      "p",
                "value":    "1"
            });
        }

        data.push({
            "key":      "relcd",
            "value":    ColonyGame.meta.releaseCode
        });

        webAppCore.postForResult(ColonyGame.meta.colonyServerApi, data, onMpRegionRegistered);
    }

    function onMpRegionRegistered(result) {

        if(!result || result.trim().length == 0) {
            return;
        }

        var resultData = null;

        try {
            resultData = JSON.parse(result);
        } catch(ex) {
            resultData = null;
        }

        if(!resultData) {
            return;
        }

        loadMultipleyerRegion(resultData.charter);
    }

    function loadMultipleyerRegion(charter) {
        currentGame = new Game(50,50);

        openJobsArray = [];
        currentGame.charter = charter;
        currentGame.isMpRegionHolder = true;
        currentGame.isRegion = true;
        curRegPreviewWorkQueue = [];
        curRegPreviewWorkItem = null;
        curRegRiverTemplateCanvas = null;
        curRegRiverTemplateContext = null;

        refreshMpRegionData();
    }

    function refreshMpRegionData() {
        var data = [];

        data.push({
            "key":      "f",
            "value":    63
        });

        data.push({
            "key":      "g",
            "value":    ColonyGame.meta.colonyServerGameId
        });

        data.push({
            "key":      "rc",
            "value":    currentGame.charter
        });

        data.push({
            "key":      "relcd",
            "value":    ColonyGame.meta.releaseCode
        });

        webAppCore.postForResult(ColonyGame.meta.colonyServerApi, data, onMpRegionDataBack);
    }

    function onMpRegionDataBack(data) {

        if(!data || data.trim().length == 0) {
            return;
        }

        var datObjh = null;

        try {
            datObjh = JSON.parse(data);
        } catch(ex) {
            datObjh = null;
        }

        if(!datObjh || !currentGame) {
            return;
        }

        currentGame.name = datObjh.name;
        currentGame.colonyId = parseInt(datObjh.id);
        currentGame.mapType = datObjh.map;
        currentGame.stage = parseInt(datObjh.stage);


        currentGame.resources[ColonyGame.meta.gameStageResource].amount = parseInt(datObjh.stageresource);

        currentGame.regionDistrictData = datObjh.districts;

        currentGame.metroAreaNameRef = {};
        currentGame.subRegions = [];

        var i;

        if(datObjh.districts) {
            for(i = 0; i < datObjh.districts.length; i++) {
                var dist = datObjh.districts[i];
                currentGame.metroAreaNameRef[dist.id] = {
                    name: dist.name,
                    color: dist.color,
                    owner: dist.owner,
                    open: parseInt(dist.open)
                };
            }
        }
        

        if(datObjh.subRegions) {
            for(i = 0; i < datObjh.subRegions.length; i++) {
                var subcity = new SubCity();
                var ref = datObjh.subRegions[i];
    
                subcity.metroAreaDistrict = ref.district;
                subcity.subcityGuid = ref.subcityguid;
                subcity.name = ref.name;
                subcity.mpCharter = ref.charter;
                subcity.mpId = parseInt(ref.id);
                subcity.mpParent = parseInt(ref.parent);
                subcity.apeAppsUsername = ref.owner;
                subcity.population = parseInt(ref.population);
                subcity.size = parseInt(ref.size);
                subcity.previewImage = ColonyGame.meta.colonyServerBase.replace("/colonies","/mpregthumbs") + ref.thumbnail;
                subcity.x = parseInt(ref.x);
                subcity.y = parseInt(ref.y);
                subcity.filename = "mp-reg-" + subcity.mpId + "-" + currentGame.colonyId + "." + ColonyGame.meta.subCityExtension;
    
                if(ref.hascapitol == "1") {
                    subcity.hasCapitol = true;
                } else {
                    subcity.hasCapitol = false;
                }
    
                if(ref.hasconsulate == "1") {
                    subcity.hasConsulate = true;
                } else {
                    subcity.hasConsulate = false;
                }
    
                try {
                    if(ref.capdata) {
                        var capDecode = atob(ref.capdata);
                        var capObj = JSON.parse(capDecode);
    
                        if(capObj.res) {
                            subcity.resourceCapacities = capObj.res;
                        }
    
                        if(capObj.utils) {
                            subcity.utilityCapacities = capObj.utils;
                        }
                    }
                } catch(ex) {
                    console.log(ex);
                }
    
                currentGame.subRegions.push(subcity);
            }
        }
        

        currentJobOpprotunities = [];
        overallShoreMap = null;
        currentSubcityRef = null;
        opprotunityRecycleBox = [];
        currentTemplate = null;
        templateVisible = false;
        pendingAutosales = [];

        getAccountHolderTokens();
        gooseUpPathWorker();
        clearDefaultColoredAssets();

        renderFullAtNextDraw = false;
        Scroll2d.deInit();

        runningBuildingCounts = {};
        syncColMap = null;
        syncNodeRecycling = [];

        initScroll2d();

        sizeElements();

        setupResourceLedger();

        createSidebar();
        drawSidebar();

        setupMenuOptions();
        
        initSoundtrack();

        Scroll2d.forceSceneChange();

        setWeather();

        tmpNewGameCustomMapData = null;

        setMapType();

        Scroll2d.setMapDims(50,50);

        selectedBuilding = null;
        selectedVehicle = [];
        selectedResource = null;
        selectedColonist = null;
        selectedPassable = null;

        pendingBuildX = null;
        pendingBuildY = null;
        queuedBuildings = undefined;
        queuedBuilding = null;
        queuedBuildingBlocked = false;
        
        createCollisionReference();

        updateUtilityGrid();

        Scroll2d.forceSceneChange();

        Scroll2d.setZoomLevel(2 / renderScaleFactor);

        Scroll2d.centerOnCoord(25,25);

        setCenterMapIcon();

        webAppCore.clearSplash();

        vehiclePathOrders = {};
        colonistPathOrders = {};

        window.focus();

        currentFileName = "onlineregion";
        regionFileName = null;
        readyToLoadSubcities = true;

        if(isStreamingLive) {
            turnStreamingTracksBackOn();
        }

        syncRegionMetroAreas();


        setTimeout(Scroll2d.forceSceneChange(),500);

        if(currentGame.hasLoadedChat) {
            loadChat(true);
        }

        setColonyThemeColor();

        webAppCore.setTitleVisible(false);
        titleShowing = false;

        setupMenuOptions();

        
    }

    function registerNewMultiplayerRegionCity(name) {

        if(!webAppCore.isApeAppsLoggedIn()) {
            webAppCore.showToast("You must be logged in!");
            showTitle();
            return;
        }

        tmpPendingNewmpName = name;

        var size = 50;
        
        if(pendingSubcitySize == 2) {
            size = 100;
        }

        tmpPendingNewmpSize = size;

        var data = [];

        data.push({
            "key":      "f",
            "value":    65
        });

        data.push({
            "key":      "g",
            "value":    ColonyGame.meta.colonyServerGameId
        });

        data.push({
            "key":      "n",
            "value":    name
        });

        data.push({
            "key":      "relcd",
            "value":    ColonyGame.meta.releaseCode
        });

        data.push({
            "key":      "c",
            "value":    currentGame.charter
        });

        data.push({
            "key":      "s",
            "value":    size
        });

        data.push({
            "key":      "mx",
            "value":    pendingSubCityX
        });

        data.push({
            "key":      "my",
            "value":    pendingSubCityY
        });

        data.push({
            "key":      "aun",
            "value":    webAppCore.getApeAppsProfile().un
        });

        webAppCore.postForResult(ColonyGame.meta.colonyServerApi, data, onRegisterNewMultiplayerRegionSubcity);
    }

    var tmpPendingNewMpData = null;
    var tmpPendingNewMpSubcityRef = null;
    var tmpPendingNewmpName = null;
    var tmpPendingNewmpSize = null;
    var tmpPendingNewMpRegData = null;

    function onRegisterNewMultiplayerRegionSubcity(data) {
        if(!data || data.trim().length == 0) {
            webAppCore.showDialog({
                message: "Error registering new city!"
            });
            return;
        }

        try {
            tmpPendingNewMpRegData = JSON.parse(data);

            tmpPendingNewMpSubcityRef = new SubCity();

            tmpPendingNewMpSubcityRef.name = tmpPendingNewmpName;
            tmpPendingNewMpSubcityRef.metroAreaDistrict = tmpPendingNewMpRegData.district;
            tmpPendingNewMpSubcityRef.mpCharter = tmpPendingNewMpRegData.charter;
            tmpPendingNewMpSubcityRef.mpId = parseInt(tmpPendingNewMpRegData.id);
            tmpPendingNewMpSubcityRef.mpParent = parseInt(tmpPendingNewMpRegData.parent);
            tmpPendingNewMpSubcityRef.apeAppsUsername = webAppCore.getApeAppsProfile().un;
            tmpPendingNewMpSubcityRef.population = 0;
            tmpPendingNewMpSubcityRef.size = parseInt(tmpPendingNewmpSize);
            tmpPendingNewMpSubcityRef.previewImage = null;
            tmpPendingNewMpSubcityRef.x = parseInt(pendingSubCityX);
            tmpPendingNewMpSubcityRef.y = parseInt(pendingSubCityY);
            tmpPendingNewMpSubcityRef.subcityGuid = tmpPendingNewMpRegData.guid;
            tmpPendingNewMpSubcityRef.filename = "mp-reg-" + tmpPendingNewMpSubcityRef.mpId + "-" + currentGame.colonyId + "." + ColonyGame.meta.subCityExtension;

            tmpPendingNewMpData = new Game(tmpPendingNewMpSubcityRef.size,tmpPendingNewMpSubcityRef.size,{
                "name":         tmpPendingNewmpName,
                "disableTax":   false,
                "motherland":   0,
                "motherlandid": 0,
                "mapType":      currentGame.mapType,
                "offline":      false
            });

            tmpPendingNewMpData.charter = tmpPendingNewMpRegData.charter;
            tmpPendingNewMpData.colonyId = tmpPendingNewMpRegData.id;
            tmpPendingNewMpData.apiKey = tmpPendingNewMpRegData.guid;
            tmpPendingNewMpData.subcityGuid = tmpPendingNewMpRegData.guid;
            tmpPendingNewMpData.mpRegionPlanetCharter = currentGame.charter;
            tmpPendingNewMpData.themeColor = tmpPendingNewMpRegData.color;
            tmpPendingNewMpData.useCloud = true;
            tmpPendingNewMpData.useCompression = true;

            if(parseInt(tmpPendingNewMpRegData.color) == 1) {
                tmpPendingNewMpData.isIndependent = true;
                tmpPendingNewMpData.independenceDay = tmpPendingNewMpRegData.independence;
            }

            tmpPendingNewMpData.isSubregion = true;

            if(parseInt(tmpPendingNewMpRegData.parent) == 0) {
                showCharterMenu(charterSelectionForNewMPCity);
            } else {
                tmpPendingNewMpData.motherlandid = parseInt(tmpPendingNewMpRegData.parent);
                tmpPendingNewMpData.motherland = tmpPendingNewMpRegData.parentname;
                tmpPendingNewMpData.motherlandCharter = tmpPendingNewMpRegData.parentcharter;
                tmpPendingNewMpData.civilization = tmpPendingNewMpRegData.civilization;
                tmpPendingNewMpData.defaultRace = tmpPendingNewMpRegData.race;
                finishCreateNewMpCity();
            }

        } catch(ex) {
            console.log(ex);
            webAppCore.showDialog({
                message: "Error registering new city!!"
            });
            tmpPendingNewMpRegData = null;
            return;
        }
    }

    function charterSelectionForNewMPCity(result) {
        if(!result || !result.charter) {
            showTitle();
            return;
        }

        var data = [];

        data.push({
            "key":      "f",
            "value":    66
        });

        data.push({
            "key":      "g",
            "value":    ColonyGame.meta.colonyServerGameId
        });

        data.push({
            "key":      "n",
            "value":    tmpPendingNewmpName
        });

        data.push({
            "key":      "relcd",
            "value":    ColonyGame.meta.releaseCode
        });

        data.push({
            "key":      "c",
            "value":    result.charter
        });

        data.push({
            "key":      "i",
            "value":    tmpPendingNewMpData.colonyId
        });

        data.push({
            "key":      "aun",
            "value":    webAppCore.getApeAppsProfile().un
        });

        webAppCore.postForResult(ColonyGame.meta.colonyServerApi, data, onAssignParentToNewMpColony);
    }

    function onAssignParentToNewMpColony(result) {
        if(!result || result.trim().length == 0) {
            return;
        }

        try {
            var resData = JSON.parse(result);

            tmpPendingNewMpData.motherlandid = parseInt(resData.parentid);
            tmpPendingNewMpData.motherland = resData.parentname;
            tmpPendingNewMpData.motherlandCharter = resData.parentcharter;
            tmpPendingNewMpData.civilization = resData.civilization;
            tmpPendingNewMpData.defaultRace = resData.race;
            finishCreateNewMpCity();
        } catch(ex) {
            console.log(ex);
            return;
        }
    }

    function finishCreateNewMpCity() {
        if(!tmpPendingNewMpData || !tmpPendingNewMpSubcityRef) {
            return;
        }

        unlockStartingTechsForGameData(tmpPendingNewMpData);

        if(tmpPendingNewMpRegData.disttech && tmpPendingNewMpRegData.disttech.trim().length > 2) {
            try {
                var decodedTechdata = atob(tmpPendingNewMpRegData.disttech);
                var serverTechjsondata = JSON.parse(decodedTechdata);
    
                var get = tmpPendingNewMpData.unlockedTechs;
    
                for(var tech in serverTechjsondata) {
                    if(serverTechjsondata[tech]) {
                        get[tech] = true;
                    }
                }
            } catch(ex) {
                // no biggie
                console.log(ex);
            }
        }

        if(tmpPendingNewMpRegData.distres && tmpPendingNewMpRegData.distres.trim().length > 2) {
            try {
                var decodedresdata = atob(tmpPendingNewMpRegData.distres);
                var serverresjsondata = JSON.parse(decodedresdata);
    
                var gameRes = tmpPendingNewMpData.resources;
    
                for(var sRes in serverresjsondata) {

                    var rDef = getResourceByDefName(sRes);

                    if(!rDef) {
                        continue;
                    }

                    if(!gameRes[sRes]) {
                        gameRes[sRes] = {};
                        gameRes[sRes].amount = 0;
                        gameRes[sRes].previous = 0;
                        gameRes[sRes].capacity = rDef.max;
                        gameRes[sRes].price = rDef.basePrice;
                        gameRes[sRes].storageCapacity = 0;
                        gameRes[sRes].unlocked = false;
                        gameRes[sRes].serverId = 0;
                        gameRes[sRes].lastTrade = 0;
                        gameRes[sRes].autosell = false;
                    }

                    gameRes[sRes].amount = parseInt(serverresjsondata[sRes]);
                }
            } catch(ex) {
                // no biggie
            }
        }

        currentFileName = tmpPendingNewMpSubcityRef.filename;
        readyToLoadSubcities = true;
        currentRegion = currentGame;
        regionFileName = "onlineregion";
        currentRegion.subRegions.push(tmpPendingNewMpSubcityRef);
        currentSubcityRef = tmpPendingNewMpSubcityRef;

        Scroll2d.deInit();

        currentGame = tmpPendingNewMpData;
        openJobsArray = [];
        curRegPreviewWorkQueue = [];
        curRegPreviewWorkItem = null;
        curRegRiverTemplateCanvas = null;
        curRegRiverTemplateContext = null;

        runningBuildingCounts = {};
        runningVehicleCounts = {};
        syncColMap = null;
        syncNodeRecycling = [];

        getAccountHolderTokens();

        gooseUpPathWorker();
        clearDefaultColoredAssets();

        retainedPaths = {};
        retainedPathsCounter = 0;
        shouldUpdateCollissionMap = true;
        buildingUpdateCycle = true;
        retainedUsage = {};

        riotingWarned = false;
        anarchyWarned = false;
        famineWarned = false;
        noWaterWarned = false;
        shoreUpdateTurn = true;

        webAppCore.closeChat();

        var resourceMod = 1;

        if(tmpPendingNewMpSubcityRef.size == 50) {
            resourceMod = 0.5;
        }

        tmpNewCiv = {
            race: tmpPendingNewMpData.race,
            name: tmpPendingNewMpData.civilization
        };

        tmpNewMotherlandName = currentRegion.motherland;
        tmpNewMotherlandId = currentRegion.motherlandid;
        tmpNewMapType = currentRegion.mapType;

        var civDef = getCivilizationByName(tmpNewCiv.name);

        if(!civDef) {
            civDef = ColonyGame.civilizations[0];
        }

        initScroll2d();
        killSwitch = false;

        sizeElements();

        syncLocalTechsToDistrict();

        continueNewGameMapGeneration(civDef,tmpPendingNewMpSubcityRef.size,tmpPendingNewMpSubcityRef.size,resourceMod);

        pendingSubcitySize = 0;

        tmpNewName = null;
        tmpNewSize = null;
        tmpNewResmod = null;

        
    }

    function showCharterMenu(callback) {
        var data = [];

        data.push({
            "key":      "f",
            "value":    23
        });

        data.push({
            "key":      "g",
            "value":    ColonyGame.meta.colonyServerGameId
        });

        data.push({
            "key":      "relcd",
            "value":    ColonyGame.meta.releaseCode
        });

        webAppCore.postForResult(ColonyGame.meta.colonyServerApi, data, function(data){
            onRandomCharterListBack(data,callback);
        });
    }

    function onRandomCharterListBack(result,callback) {
        if(result == null) {
            return;
        }

        var charters = null;
        var i;

        try {
            charters = JSON.parse(result);
        } catch(ex) {
            pauseThenShowCharterInput(callback);
            webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onRandomCharterListBack",ex.message);
            return;
        }

        if(charters == null) {
            pauseThenShowCharterInput(callback);
            return;
        }

        if(!charters.charters || charters.charters.length == 0) {
            pauseThenShowCharterInput(callback);
            return;
        }

        var menuOptions = [];

        menuOptions.push({
            "title":        "Custom Charter Code",
            "description":  "If you already know what charter code you want to use, select this option to input your code.",
            "icon":         "images/" + ColonyGame.meta.charterIndicator,
            "status":       null,
            "status-color":  null,
            "overflow":     null,
            "tag":          "custom"
        });

        for(i = 0; i < charters.charters.length; i++) {

            var cost = null;

            var taxString = "Normal";
            var taxColor = "#2196F3";

            if(charters.charters[i].taxes < 80) {
                taxString = "Below Normal";
                taxColor = "#00BCD4";
            }

            if(charters.charters[i].taxes < 50) {
                taxString = "Low";
                taxColor = "#26A69A";
            }

            if(charters.charters[i].taxes < 20) {
                taxString = "Very Low";
                taxColor = "#4CAF50";
            }

            if(charters.charters[i].taxes == 0) {
                taxString = "No Taxes";
            }

            if(charters.charters[i].taxes > 120) {
                taxString = "Above Normal";
                taxColor = "#3F51B5";
            }

            if(charters.charters[i].taxes > 150) {
                taxString = "High";
                taxColor = "#C2185B";
            }

            if(charters.charters[i].taxes > 180) {
                taxString = "Very High";
                taxColor = "#F44336";
            }

            if(charters.charters[i].taxes > 200) {
                taxString = "Extreme";
            }

            cost = [
                {
                    pre:    "Population: ",
                    post:   numberWithCommas(charters.charters[i].population),
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.colonistIcon
                },
                {
                    pre:    getString("empire-general") + " Population: ",
                    post:   numberWithCommas(charters.charters[i].cwpopulation),
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.empireIndicator
                },
                {
                    pre:    "GDP: ",
                    post:   numberWithCommas(charters.charters[i].totalgdp),
                    color:  null,
                    icon:   "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                },
                {
                    pre:    "Civilization: ",
                    post:   charters.charters[i].civilization,
                    color:  null,
                    icon:   "images/" + getCivilizationByName(charters.charters[i].civilization).icon
                },
                {
                    pre:    "RRR: ",
                    post:   charters.charters[i].rrr,
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.indRRR
                },
                {
                    pre:    "Location: ",
                    post:   "Sector " + charters.charters[i].sector + "; " + charters.charters[i].location,
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.dimensionIndicator
                },
                {
                    pre:    "Payroll Assistance Rate: ",
                    post:   charters.charters[i].payroll + "%",
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.polLaborInd
                },
                {
                    pre:    "Taxation: ",
                    post:   taxString,
                    color:  taxColor,
                    icon:   "images/" + ColonyGame.meta.taxCollectionInd
                }
            ];

            var salesPitch = null;

            if(charters.charters[i].info != "0" && charters.charters[i].info.trim().length > 0) {
                salesPitch = charters.charters[i].info;
            }

            menuOptions.push({
                "title":        charters.charters[i].name,
                "description":  salesPitch,
                "icon":         "images/" + getPlanetDefByName(charters.charters[i].maptype).icon,
                "status":       null,
                "status-color": null,
                "overflow":     cost,
                "tag":          charters.charters[i]
            });
        }

        showList("Select Charter",menuOptions,function(tag){
            charterSelected(tag,callback);
        },getString("general-dismiss"));
    }

    function charterSelected(tag,callback) {

        if(tag == null) {
            return;
        }

        if(tag == "custom") {
            pauseThenShowCharterInput(callback);
            return;
        }

        callback(tag);
        
    }

    function standardCharterSelection(data) {

        if(!data) {
            return;
        }

        tmpNewCiv = {
            "name": data.civilization,
            "race": data.race
        };

        tmpNewMotherlandName = data.name;
        tmpNewMotherlandId = data.id;

        setTimeout(confirmUseCharter,750);
    }

    function confirmUseCharter() {
        webAppCore.showDialog({
            "title":    getString("general-charter"),
            "message":  getString("charter-warning"),
            "op1": {
                "text":     getString("general-yes"),
                "func":     pauseThenShowMapChoices
            },
            "op2": {
                "text":     getString("general-no"),
                "func":     pauseThenNewGame
            }
        });
    }

    function pauseThenNewGame() {
        setTimeout(newGame,750);
    }

    function pauseThenShowCharterInput(callback) {
        setTimeout(function(){
            showCustomCharterInput(callback);
        },750);
    }

    function showCustomCharterInput(callback) {

        var dialogOptions = {
            "title":    "Custom Charter Code",
            "message":  "If you already know what charter code you want to use, input your code below.",
            func: function(input){
                onCharterCodeInput(input,callback);
            }
        };

        webAppCore.inputBox(dialogOptions);
    }

    function onCharterCodeInput(input,callback) {

        if(input == null || input.length == 0) {
            callback(null);
            return;
        }

        var charter = input.trim();

        if(charter.length == 0) {
            callback(null);
            return;
        }

        var data = [];

        data.push({
            "key":      "f",
            "value":    3
        });

        data.push({
            "key":      "g",
            "value":    ColonyGame.meta.colonyServerGameId
        });

        data.push({
            "key":      "c",
            "value":    charter
        });

        data.push({
            "key":      "relcd",
            "value":    ColonyGame.meta.releaseCode
        });

        webAppCore.postForResult(ColonyGame.meta.colonyServerApi, data, function(result){
            parseCharterReturnData(result,callback);
        });
    }

    function parseCharterReturnData(result,callback) {
        try {
            var charterInfo = JSON.parse(result);
            callback(charterInfo);
        } catch(ex) {
            webAppCore.showToast("Invalid Charter!");
            webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": parseCharterReturnData",ex.message);
            callback(null);
            return;
        }
    }

    function showMapTypeChoices() {
        tmpNewGameCustomMapData = null;

        if(tmpNewCiv == null) {
            return;
        }

        var choices,i,j;

        for(i = 0; i < ColonyGame.civilizations.length; i++) {
            if(ColonyGame.civilizations[i].name == tmpNewCiv.name) {
                choices = ColonyGame.civilizations[i].availableMaps;
                break;
            }
        }

        
        if(choices == null && tmpNewMotherlandId != 0) {
            return;
        }


        var menuOptions = [];

        if(choices != null) {
            for(i = 0; i < choices.length; i++) {

                for(j = 0; j < ColonyGame.mapTypes.length; j++) {
                    if(ColonyGame.mapTypes[j].name == choices[i]) {
                        menuOptions.push({
                            "title":        ColonyGame.mapTypes[j].name,
                            "description":  getString(ColonyGame.mapTypes[j].description),
                            "icon":         "images/" + ColonyGame.mapTypes[j].icon,
                            "status":       "Difficulty: " + ColonyGame.mapTypes[j].difficulty,
                            "overflow":     null,
                            "tag":          ColonyGame.mapTypes[j].name
                        });
                    }
                }
    
                
            }
        }

        var premiumText = null;
        var premiumColor = null;

        if(!webAppCore.getIsPremium()) {
            premiumText = "Requires Premium";
            premiumColor = "#FFC107";
        }
        

        // for offline games, allow custom maps
        if(tmpNewMotherlandId == 0) {
            menuOptions.push({
                "title":        getString("general-custom-map"),
                "description":  getString("general-custom-map-desc"),
                "icon":         null,
                "status":       premiumText,
                "status-color": premiumColor,
                "overflow":     null,
                "tag":          "custommap"
            });
        }

        showList("Select Map Type",menuOptions,onMapTypeSelected,getString("general-dismiss"));
    }

    var pendingSubCityX = 0;
    var pendingSubCityY = 0;

    function newSubregionNameReturn(data) {
        if(data == null || data.trim().length == 0) {


            pendingSubcitySize = 0;

            webAppCore.showToast("Invalid Name");

            return;
            
        }

        if(currentGame && currentGame.isMpRegionHolder) {
            registerNewMultiplayerRegionCity(data.trim());
            return;
        }

        var subcity = new SubCity();

        subcity.name = data.latinize().trim();

        var resourceMod = 1;

        if(pendingSubcitySize == 1) {
            subcity.size = 50;
            resourceMod = 0.5;
        }

        if(pendingSubcitySize == 2) {
            subcity.size = 100;
        }

        subcity.x = pendingSubCityX;
        subcity.y = pendingSubCityY;

        
        var date = new Date();
        var now = date.getTime();
        
        if(!currentGame || !subcity) {
            return;
        }

        var filename = cleanFileName(currentGame.name) + "-" + cleanFileName(subcity.name) + "-" + now + "." + ColonyGame.meta.subCityExtension;

        subcity.filename = filename;

        readyToLoadSubcities = true;
        currentRegion = currentGame;

        regionFileName = currentFileName;

        currentRegion.subRegions.push(subcity);

        currentSubcityRef = subcity;

        if(!currentSubcityRef.resourceCapacities) {
            currentSubcityRef.resourceCapacities = {};
        }

        if(!currentSubcityRef.utilityCapacities) {
            currentSubcityRef.utilityCapacities = {};
        }

        if(!currentSubcityRef.hasCapitol) {
            currentSubcityRef.hasCapitol = false;
        }

        if(!currentSubcityRef.description) {
            currentSubcityRef.description = "";
        }

        if(!currentSubcityRef.statsColor) {
            currentSubcityRef.statsColor = randomHexColor(255,120);
        }

        tmpNewName = subcity.name;
        tmpNewSize = subcity.size;
        tmpNewResmod = resourceMod;

        var items = [];

        items.push({
            title: "Normal Resource Levels",
            description: getString("norm-res-desc"),
            tag: resourceMod.toString()
        });

        items.push({
            title: "Blank Map",
            description: getString("blank-res-desc"),
            tag: "0.0"
        });

        showList(subcity.name,items,finalSubregionInit,"Ok");
    }

    function finalSubregionInit(tag) {

        if(!currentRegion) {
            return;
        }

        if(tag) {
            tmpNewResmod = parseFloat(tag);
        }

        

        tmpNewCiv = {
            race: currentRegion.defaultRace,
            name: currentRegion.civilization
        };

        tmpNewMotherlandName = currentRegion.motherland;
        tmpNewMotherlandId = currentRegion.motherlandid;
        tmpNewMapType = currentRegion.mapType;

        webAppCore.closeChat();

        offlineGameServerId = "-1";
        connectedLocals = [];

        generalSaveGameWithDialog(function(){
            Scroll2d.deInit();

            runningBuildingCounts = {};
            runningVehicleCounts = {};
            syncColMap = null;
            syncNodeRecycling = [];

            getAccountHolderTokens();

            gooseUpPathWorker();
            clearDefaultColoredAssets();

            webAppCore.closeChat();

            createNewGame(tmpNewName,tmpNewSize,tmpNewSize,tmpNewResmod,true);
            pendingSubcitySize = 0;

            tmpNewName = null;
            tmpNewSize = null;
            tmpNewResmod = null;
        });
    }

    var tmpNewName = null;
    var tmpNewSize = null;
    var tmpNewResmod = null;

    function tvDeviceMapNameReturn(data) {
        
        if(data == null || data.trim().length == 0) {


            showHiders();
            titleShowing = true;
            bulldozerMode = false;
            webAppCore.setTitleVisible(true);
            webAppCore.handleBackFunction(null);

            webAppCore.showToast("Invalid Name");

            return;
            
        }

        vehiclePathOrders = {};
        colonistPathOrders = {};

        bulldozerMode = false;
        titleShowing = false;
        webAppCore.setTitleVisible(false);
        webAppCore.handleBackFunction(standardBack);

        Scroll2d.forceSceneChange();


        newGameWithoutCharter(data.trim());

    }

    var tmpNewGameCustomMapData = null;
    
    function newGameCustomMapSelected(mapdata) {

        webAppCore.clearSplash();

        if(!mapdata) {
            return;
        }

        webAppCore.clearSplash();
        setupMenuOptions();
        window.focus();

        tmpNewGameCustomMapData = mapdata;

        var dialogOptions = {
            title: getString("new-game"),
            message: getString("new-game-col-name"),
            func: tvDeviceMapNameReturn
        };

        webAppCore.inputBox(dialogOptions);
        
    }

    function onMapTypeSelected(type) {

        if(type == "custommap") {

            if(!webAppCore.getIsPremium()) {
                showPremiumMessage();
                return;
            }

            loadCustomMap(newGameCustomMapSelected,"general-custom-map");
            return;
        }

        if(!type) {
            
            showHiders();
            titleShowing = true;
            bulldozerMode = false;
            webAppCore.setTitleVisible(true);
            webAppCore.handleBackFunction(null);


            return;
        }


        tmpNewMapType = type;


        var menuOptions = [];

        menuOptions.push({
            "title": getString("gen-single-city"),
            "description": getString("gen-single-city-desc"),
            "tag": "single"
        });

        var regionStatus = null;
        var regionColor = null;

        if(!webAppCore.getIsPremium()) {
            regionStatus = "Requires Premium";
            regionColor = "#FFC107";
        }

        if(webAppCore.getIsPremium()) {
            menuOptions.unshift({
                "title": getString("gen-region-city"),
                "description": getString("gen-region-city-desc"),
                "tag": "region",
                "status":       regionStatus,
                "status-color":  regionColor,
            });
        } else {
            menuOptions.push({
                "title": getString("gen-region-city"),
                "description": getString("gen-region-city-desc"),
                "tag": "region",
                "status":       regionStatus,
                "status-color":  regionColor,
            });
        }

        
        

        showList(getString("gen-sel-game-type"),menuOptions,onGameTypeSelected,getString("general-dismiss"));
    }

    function onGameTypeSelected(type) {
        if(!type) {
            return;
        }

        if(type == "single") {
            getNameForSingleMapCity();
        }

        if(type == "region") {
            webAppCore.logEvent("Region","created",webAppCore.getPlatform().platform);

            if(!webAppCore.getIsPremium()) {
                showPremiumMessage(getString("gen-region-city"));
            } else {
                webAppCore.clearSplash();
                setupMenuOptions();
                window.focus();

                var dialogOptions = {
                    "title":    getString("gen-region-city"),
                    "message":  getString("new-region-info"),
                    func: onRegionNameSelected
                };
        
                webAppCore.inputBox(dialogOptions);
            }

            
        }
    }

    function onRegionNameSelected(name) {
        if(!name) {
            showHiders();
            titleShowing = true;
            bulldozerMode = false;
            webAppCore.setTitleVisible(true);
            webAppCore.handleBackFunction(null);

            webAppCore.showToast("Invalid Name");
            
            return;
        }

        if(name.trim().length == 0) {
            name = "My Region";
        }

        if(tmpNewMapType) {

            var map = getPlanetDefByName(tmpNewMapType);

            if(map && map.riverTile) {

                webAppCore.showDialog({
                    title: getString("river-template"),
                    message: getString("river-template-desc"),
                    buttons: [
                        {
                            text: getString("river-template-auto"),
                            func: function() {
                                webAppCore.setTitleVisible(false);
                                document.getElementById("titleBackdropHold").style.display = "block";
                                document.getElementById("generatingMapReadoutHolder").style.display = "block";

                                setTimeout(function(){
                                    continueRegionalCreation(name,null);
                                },100) ;
                                
                            }
                        },
                        {
                            text: getString("river-template-image"),
                            func: function() {
                                webAppCore.importImage(function(imgDat){

                                    if(imgDat) {
                                        if(Array.isArray(imgDat) && imgDat.length > 0) {
                                            continueRegionalCreation(name,imgDat[0]);
                                            return;
                                        } else {
                                            if(imgDat && imgDat.length > 5) {
                                                continueRegionalCreation(name,imgDat);
                                                return;
                                            }
                                        }
                                    }
                                    
                                    webAppCore.setTitleVisible(false);
                                    document.getElementById("titleBackdropHold").style.display = "block";
                                    document.getElementById("generatingMapReadoutHolder").style.display = "block";

                                    setTimeout(function(){
                                        continueRegionalCreation(name,null);
                                    },100) ;
                
                                });
                            }
                        }
                    ]
                });

                return;
            }
        }

        continueRegionalCreation(name,null);
    }

    function continueRegionalCreation(name,waterTemplateData) {
        vehiclePathOrders = {};
        colonistPathOrders = {};

        bulldozerMode = false;
        titleShowing = false;
        webAppCore.setTitleVisible(false);
        webAppCore.handleBackFunction(standardBack);

        Scroll2d.forceSceneChange();

        var civDef = getCivilizationByName(tmpNewCiv.name);

        if(!civDef) {
            civDef = ColonyGame.civilizations[0];
            tmpNewCiv = ColonyGame.civilizations[0];
        }

        showHiders();

        webAppCore.setTheme(ColonyGame.meta.theme);

        webAppCore.storeVar("has-warned-has-played","1");

        tmpBuildingRefHolder = {};

        buildingUpdateCycle = true;

        var offline = false;

        if(tmpNewMotherlandId == 0) {
            offline = true;
        }



        if(tmpNewGameCustomMapData != null) {
            tmpNewMapType = tmpNewGameCustomMapData.mapType;
        }

        initScroll2d();

        pendingAutosales = [];
        tcpAvailable = false;
        readyToLoadSubcities = false;
        curRegPreviewWorkQueue = [];
        curRegRiverTemplateCanvas = null;
        curRegRiverTemplateContext = null;
        curRegPreviewWorkItem = null;
        openJobsArray = [];

        currentGame = new Game(50,50,{
            "name":         name,
            "disableTax":   false,
            "motherland":   tmpNewMotherlandName,
            "motherlandid": tmpNewMotherlandId,
            "mapType":      tmpNewMapType,
            "defaultRace":  tmpNewCiv.race,
            "civilization": civDef.name,
            "offline":      offline
        });

        killSwitch = false;

        sizeElements();

        if(creativeFlag) {
            creativeFlag = false;
            currentGame.cm = true;
            currentGame.offlineMode = true;
            currentGame.hasCheated = true;
            currentGame.tradeNotifications = false;
        }

        if(waterTemplateData && waterTemplateData.length > 5) {
            currentGame.waterTemplateData = waterTemplateData;
        } else {
            var map = getPlanetDefByName(tmpNewMapType);

            if(map && map.riverTile) {
                currentGame.waterTemplateData = createWaterTemplateDataImage(250,250,map.riverPosition);
            }
            
        }

        document.getElementById("generatingMapReadoutHolder").style.display = "none";
        document.getElementById("titleBackdropHold").style.display = "none";

        currentGame.isRegion = true;

        retainedPaths = {};
        retainedPathsCounter = 0;
        shouldUpdateCollissionMap = true;
        buildingUpdateCycle = true;
        retainedUsage = {};
        var i;

        

        riotingWarned = false;
        anarchyWarned = false;
        famineWarned = false;
        noWaterWarned = false;
        shoreUpdateTurn = true;

        if(!currentGame.offlineMode) {
            isCreatingNewOnlineGame = true;

            connectToSocketsIfNecessary();
            registerColonyId();
            
        }

        setupResourceLedger();

        setMapType();

        Scroll2d.setMapDims(50,50);

        selectedBuilding = null;
        selectedVehicle = [];
        selectedResource = null;
        selectedColonist = null;
        selectedPassable = null;

        pendingBuildX = null;
        pendingBuildY = null;
        queuedBuildings = undefined;
        queuedBuilding = null;
        queuedBuildingBlocked = false;

        // setup civilization resource level mods

        if(civDef.startingResourceModifiers) {
            for(i = 0; i < civDef.startingResourceModifiers.length; i++) {

                modifyResourceAmount(civDef.startingResourceModifiers[i].name,civDef.startingResourceModifiers[i].modifier,false,"Initial");
    
                if(currentGame.resources[civDef.startingResourceModifiers[i].name].amount < 0) {
                    modifyResourceAmount(civDef.startingResourceModifiers[i].name,0,true,"Initial");
                }
            }
        }

        if(!workingMapType) {
            setMapType();
        }

        if(!workingMapType) {
            workingMapType = ColonyGame.mapTypes[0];
        }

        // setup map resource level mods
        for(i = 0; i < workingMapType.startingResourceModifiers.length; i++) {

            modifyResourceAmount(workingMapType.startingResourceModifiers[i].name,workingMapType.startingResourceModifiers[i].modifier,false,"Initial");

            if(currentGame.resources[workingMapType.startingResourceModifiers[i].name].amount < 0) {
                modifyResourceAmount(workingMapType.startingResourceModifiers[i].name,0,true,"Initial");
            }
        }
        
        createCollisionReference();

        updateUtilityGrid();

        Scroll2d.forceSceneChange();

        Scroll2d.setZoomLevel(2 / renderScaleFactor);

        Scroll2d.centerOnCoord(25,25);

        setCenterMapIcon();

        webAppCore.clearSplash();

        vehiclePathOrders = {};
        colonistPathOrders = {};

        window.focus();

        currentFileName = cleanFileName(currentGame.name) + "." + ColonyGame.meta.fileExtension;

        generalSaveGame();

        createSidebar();
        drawSidebar();

        setupMenuOptions();
        
        initSoundtrack();

        Scroll2d.forceSceneChange();

        setWeather();

        tmpNewGameCustomMapData = null;

        createLocalServer();
        joinLocalNetworks();

        chatSetupQuick();

        setColonyThemeColor();

        setTimeout(Scroll2d.forceSceneChange(),500);

        if(!desktopMode || window.innerWidth < 1000) {
            webAppCore.showDialog({
                title: getString("gen-region-city"),
                message: getString("small-scr-new-reg-help"),
                icon: "images/" + ColonyGame.meta.showBuildSidebarIcon
            });
        }

    }

    function getRegionOrCity() {
        if(!currentGame) {
            return null;
        }

        if(currentGame.isSubregion) {

            if(currentRegion) {
                if(currentRegion.isMpRegionHolder) {
                    return currentGame;
                } else {
                    return currentRegion;
                }
                
            } else {
                return null;
            }
        } else {
            return currentGame;
        }
    }

    function getGameTechs() {
        if(!currentGame) {
            return null;
        }

        if(currentGame.mpRegionPlanetCharter) {
            return currentGame.unlockedTechs;
        }

        if(currentGame.isSubregion) {
            if(currentRegion) {
                return currentRegion.unlockedTechs;
                
            } else {
                return null;
            }
        } else {
            return currentGame.unlockedTechs;
        }
    }

    function syncLocalTechsToDistrict() {
        var districtTechs = getGameTechs();

        if(!districtTechs || districtTechs == currentGame.unlockedTechs) {
            return;
        }

        for(var ut in currentGame.unlockedTechs) {
            if(currentGame.unlockedTechs[ut]) {
                districtTechs[ut] = true;
            }
        }
    }

    function getGameUtilities() {
        if(!currentGame) {
            return null;
        }

        if(currentGame.mpRegionPlanetCharter) {
            return currentGame.utilities;
        }

        if(currentGame.isSubregion) {
            if(currentRegion) {
                return currentRegion.utilities;
            } else {
                return null;
            }
        } else {
            return currentGame.utilities;
        }
    }

    function getGameResources(data) {

        if(!data) {
            data = currentGame;
        }

        if(!data) {
            return null;
        }

        if(data.mpRegionPlanetCharter) {
            return data.resources;
        }

        if(data.isSubregion) {
            if(currentRegion) {
                return currentRegion.resources;
            } else {
                return null;
            }
        } else {
            return data.resources;
        }
    }

    function modifyGameUtilityCapacity(utility,amount,source) {
        if(currentGame.isSubregion && currentSubcityRef != null && !currentGame.mpRegionPlanetCharter) {
            if(!currentSubcityRef.utilityCapacities[utility]) {
                currentSubcityRef.utilityCapacities[utility] = {
                    "usage": 0,
                    "capacity": 0
                };
            }

            currentSubcityRef.utilityCapacities[utility].capacity += parseInt(amount);

            if(currentRegion) {
                currentRegion.utilities[utility].capacity += parseInt(amount);
            }
        } else {
            currentGame.utilities[utility].capacity += parseInt(amount);

            if(!currentGame.utilities[utility].domesticCapacity) {
                currentGame.utilities[utility].domesticCapacity = 0;
            }

            currentGame.utilities[utility].domesticCapacity += parseInt(amount);
        }

        if(source) {
            if(currentGame.isSubregion && currentSubcityRef != null) {
                if(!currentSubcityRef.utilitySources) {
                    currentSubcityRef.utilitySources = {};
                }

                if(!currentSubcityRef.utilitySources[utility]) {
                    currentSubcityRef.utilitySources[utility] = {};
                }

                if(!currentSubcityRef.utilitySources[utility][source]) {
                    currentSubcityRef.utilitySources[utility][source] = 0;
                }

                currentSubcityRef.utilitySources[utility][source] += parseInt(amount);
            }

            if(!currentGame.utilitySources) {
                currentGame.utilitySources = {};
            }

            if(!currentGame.utilitySources[utility]) {
                currentGame.utilitySources[utility] = {};
            }

            if(!currentGame.utilitySources[utility][source]) {
                currentGame.utilitySources[utility][source] = 0;
            }

            currentGame.utilitySources[utility][source] += parseInt(amount);
        }
    }

    function modifyGameUtilityUsage(utility,amount) {
        if(currentGame.isSubregion && currentSubcityRef != null && !currentGame.mpRegionPlanetCharter) {
            if(!currentSubcityRef.utilityCapacities[utility]) {
                currentSubcityRef.utilityCapacities[utility] = {
                    "usage": 0,
                    "capacity": 0
                };
            }

            currentSubcityRef.utilityCapacities[utility].usage += parseInt(amount);

            if(currentRegion) {
                currentRegion.utilities[utility].usage += parseInt(amount);
            }
        } else {
            currentGame.utilities[utility].usage += parseInt(amount);

            if(!currentGame.utilities[utility].domesticUsage) {
                currentGame.utilities[utility].domesticUsage = 0;
            }

            currentGame.utilities[utility].domesticUsage += parseInt(amount);
        }
    }

    function modifyGameResourceCapacity(resource,amount) {

        if(currentGame.isRegion) {
            return;
        }

        if(currentGame.isSubregion && currentSubcityRef != null && !currentGame.mpRegionPlanetCharter) {
            if(!currentSubcityRef.resourceCapacities[resource]) {
                currentSubcityRef.resourceCapacities[resource] = 0;
            }

            currentSubcityRef.resourceCapacities[resource] += parseInt(amount);

            if(currentRegion) {
                currentRegion.resources[resource].storageCapacity += parseInt(amount);
            }
        } else {
            currentGame.resources[resource].storageCapacity += parseInt(amount);
            currentGame.resources[resource].domesticCapacity += parseInt(amount);
        }
    }

    function getNameForSingleMapCity() {
        if(webAppCore.isTV()) {

            webAppCore.clearSplash();
            setupMenuOptions();
            window.focus();

            var dialogOptions = {
                title: getString("new-game"),
                message: getString("new-game-col-name"),
                func: tvDeviceMapNameReturn
            };

            webAppCore.inputBox(dialogOptions);

            return;
        }


        var hiders = document.querySelectorAll(".newGameHide");

        var i;

        for(i = 0; i < hiders.length; i++) {
            hiders[i].style.display = "none";
        }

        webAppCore.setTheme("#000000");

        document.getElementById("newGameMenu").style.display = "block";
        document.getElementById("titleBackdropHold").style.display = "block";

        if(window.innerWidth < 600) {
            document.getElementById("mapSizeSmall").checked = true;
            document.getElementById("mapSizeMedium").checked = false;
        } else {
            document.getElementById("mapSizeSmall").checked = false;
            document.getElementById("mapSizeMedium").checked = true;
        }

        document.getElementById("btnNoNewGame").style.display = "block";

        webAppCore.clearSplash();
        setupMenuOptions();
        window.focus();

        vehiclePathOrders = {};
        colonistPathOrders = {};

        titleShowing = false;
        bulldozerMode = false;
        webAppCore.setTitleVisible(false);
        webAppCore.handleBackFunction(standardBack);

        Scroll2d.forceSceneChange();
    }

    var isCreatingNewOnlineGame = false;

    function createNewGame(name,width,height,resourceLevel,isSubcity) {

        var civDef = getCivilizationByName(tmpNewCiv.name);

        if(!civDef) {
            civDef = ColonyGame.civilizations[0];
        }

        showHiders();

        webAppCore.setTheme(ColonyGame.meta.theme);

        webAppCore.storeVar("has-warned-has-played","1");

        tmpBuildingRefHolder = {};

        buildingUpdateCycle = true;

        var offline = false;
        pendingAutosales = [];

        if(tmpNewMotherlandId == 0) {
            offline = true;
        }



        if(tmpNewGameCustomMapData != null) {
            tmpNewMapType = tmpNewGameCustomMapData.mapType;
        }

        initScroll2d();

        currentGame = new Game(width,height,{
            "name":         name,
            "disableTax":   false,
            "motherland":   tmpNewMotherlandName,
            "motherlandid": tmpNewMotherlandId,
            "mapType":      tmpNewMapType,
            "defaultRace":  tmpNewCiv.race,
            "civilization": civDef.name,
            "offline":      offline
        });

        curRegPreviewWorkQueue = [];
        openJobsArray = [];
        curRegPreviewWorkItem = null;
        curRegRiverTemplateCanvas = null;
        curRegRiverTemplateContext = null;

        killSwitch = false;

        sizeElements();

        if(isSubcity && currentRegion) {
            currentGame.isSubregion = true;
            currentGame.parentRegionFile = currentFileName;

            creativeFlag = currentRegion.cm;

            if(currentSubcityRef) {
                currentGame.subcityGuid = currentSubcityRef.subcityGuid;
            }

            if(currentRegion) {
                createNewGame.useCloud = currentRegion.useCloud;
                createNewGame.useCompression = currentRegion.useCompression;
            }
        }

        continueNewGameMapGeneration(civDef,width,height,resourceLevel);
    }

    var mapfilter = null;
    var mapFilterStrength = 0;

    function setWeather() {

        if(!currentGame) {
            mapfilter = null;
            Scroll2d.setColorFilter(null);
            return;
        }

        var planetdef = getPlanetDefByName(currentGame.mapType);

        if(planetdef == null) {
            Scroll2d.setSnowing(false);
            Scroll2d.setEmbers(false);
            Scroll2d.setColorFilter(null);
            mapfilter = null;
        } else {

            if(planetdef.weatherEffect && allowParticleEffects) {
                if(planetdef.weatherEffect == "snowing") {
                    Scroll2d.setSnowing(true);
                } else {
                    Scroll2d.setSnowing(false);
                }

                if(planetdef.weatherEffect == "embers") {
                    Scroll2d.setEmbers(true);
                } else {
                    Scroll2d.setEmbers(false);
                }
                
            } else {
                Scroll2d.setSnowing(false);
                Scroll2d.setEmbers(false);
            }

            if(planetdef.colorEffect) {
                mapfilter = planetdef.colorEffect;
                mapFilterStrength = planetdef.colorStrength;
                Scroll2d.setColorFilter(planetdef.colorEffect,planetdef.colorStrength);
            } else {
                mapfilter = null;
                Scroll2d.setColorFilter(null);
            }

            
        }
    }

    function performAnnex() {
        var currentTiles = currentGame.width * currentGame.height;
        var newTiles = (currentGame.width + 20) * (currentGame.height + 20);

        var difference = newTiles - currentTiles;

        var canAfford = true;
        var i;

        for(i = 0; i < ColonyGame.meta.annexTileCost.length; i++) {
            if((difference * ColonyGame.meta.annexTileCost[i].amount) > getGameResources()[ColonyGame.meta.annexTileCost[i].resource].amount) {
                canAfford = false;
            }
        }

        if(!canAfford) {
            webAppCore.showToast(getString("general-cant-afford"));
            return;
        }

        for(i = 0; i < ColonyGame.meta.annexTileCost.length; i++) {
            modifyResourceAmount(ColonyGame.meta.annexTileCost[i].resource,-(ColonyGame.meta.annexTileCost[i].amount * difference),false,"Land");
        }

        currentGame.height += 20;
        currentGame.width += 20;

        Scroll2d.setMapDims(currentGame.width,currentGame.height);
        createCollisionReference();

        // setup terrains
        for(i = 0; i < workingMapType.terrainFeatures.length; i++) {

            var terrainCount = Math.ceil(workingMapType.terrainFeatures[i].abundance * 0.2);
            var terrainDef = getTerrainDefByName(workingMapType.terrainFeatures[i].name);

            for(var j = 0; j < terrainCount; j++) {

                var halfChance = randomIntFromInterval(0,1);
                var rndX,rndY;

                if(halfChance == 0) {
                    rndX = randomIntFromInterval(0,currentGame.width - 2);
                    rndY = randomIntFromInterval(currentGame.height - 18,currentGame.height - 2);
                } else {
                    rndX = randomIntFromInterval(currentGame.width - 18,currentGame.width - 2);
                    rndY = randomIntFromInterval(0,currentGame.height - 18);
                }

                if(!checkForGeneralBlockage(terrainDef,rndX,rndY)) {
                    var resourceItem = new MapResource(terrainDef,rndX,rndY);
                    freeRefNukeTurn = true;
                    updateBuildingCollisionPoints(resourceItem,150,true);
                    currentGame.mapResources.push(resourceItem);
                    shoreUpdateTurn = true;
                } 
            }
        }

        
        
    }

    function getPlanetDefByName(name) {
        for(var i = 0; i < ColonyGame.mapTypes.length; i++) {
            if(name == ColonyGame.mapTypes[i].name) {
                return ColonyGame.mapTypes[i];
            }
        }

        return null;
    }

    function getCivilizationByName(name) {
        for(var i = 0; i < ColonyGame.civilizations.length; i++) {
            if(name == ColonyGame.civilizations[i].name) {
                return ColonyGame.civilizations[i];
            }
        }

        return null;
    }
    
    function cleanFileName(name) {
        if(!name) {
            return "file-name";
        }

        var clean = name.replace(/([^a-z0-9]+)/gi, "-");
        return clean.toLowerCase();
    }
    
    function createUtilityGridIfNonexistant() {

        var utils = getGameUtilities();

        if(!utils) {
            getRegionOrCity().utilities = {};
        }
        
        for(var i = 0; i < ColonyGame.utilities.length; i++) {
            if(!utils[ColonyGame.utilities[i].name]) {
                utils[ColonyGame.utilities[i].name] = {};
                utils[ColonyGame.utilities[i].name].usage = 0;
                utils[ColonyGame.utilities[i].name].capacity = 0;
                utils[ColonyGame.utilities[i].name].domesticUsage = 0;
                utils[ColonyGame.utilities[i].name].domesticCapacity = 0;
            }
        }
        
        
    }
    
    function updateUtilityGrid() {
        
        if(!currentGame || currentGame.isRegion) {
            return;
        }

        freeSpaceItemRecycler.length = 0;

        var i,j,utr,prop,res,bdl,workingDef,sr;
        
        createUtilityGridIfNonexistant();

        var utils = getGameUtilities();
        var resz = getGameResources();

        for(prop in utils) {
            utils[prop].usage = 0;
            utils[prop].capacity = 0;
            utils[prop].domesticUsage = 0;
            utils[prop].domesticCapacity = 0;
        }

        for(res in resz) {
            if(res == "statResSaveTimestamp") {
                continue;
            }

            if(resz[res].capacity == -1) {
                resz[res].storageCapacity = 0;
                resz[res].domesticCapacity = 0;
            }
        }

        if(currentGame.isSubregion && currentSubcityRef != null) {
            for(prop in currentSubcityRef.utilityCapacities) {
                currentSubcityRef.utilityCapacities[prop].usage = 0;
                currentSubcityRef.utilityCapacities[prop].capacity = 0;
                currentSubcityRef.utilityCapacities[prop].domesticUsage = 0;
                currentSubcityRef.utilityCapacities[prop].domesticCapacity = 0;

                currentSubcityRef.utilitySources = {};
            }

            for(prop in currentSubcityRef.resourceCapacities) {
                currentSubcityRef.resourceCapacities[prop] = 0;
            }
        }

        currentGame.utilitySources = {};

        // first do all generation 
        for(i = 0; i < currentGame.buildings.length; i++) {
            bdl = currentGame.buildings[i];

            if(!bdl) {
                continue;
            }

            if(bdl.isBeingRemoved) {
                continue;
            }

            if(bdl.deactivated) {
                continue;
            }

            if(bdl.iuc) {
                continue;
            }

            workingDef = getBuildingDefByName(bdl.def);

            if(workingDef == null) {
                continue;
            }

            if(workingDef == null) {
                continue;
            }

            if(workingDef.providesUtility != null && !bdl.ncm) {   
                for(j = 0; j < workingDef.providesUtility.length; j++) {
                    utr = workingDef.providesUtility[j];
                    modifyGameUtilityCapacity(utr.utility,utr.amount,bdl.def);
                }
            }
        }

        // do the passables 
        var toNuke = [];

        for(var passdef in currentGame.finishedPassableNonUpdatables) {

            var pD = passableTileRefs[passdef];

            if(!pD) {
                toNuke.push(pD);
                continue;
            }

            if(!pD.requiresUtility && !pD.providesUtility) {
                continue;
            }

            var td = currentGame.finishedPassableNonUpdatables[passdef];
            for(var passX in td) {
                var tx = td[passX];
                for(var ty = 0; ty < tx.length; ty++) {

                    if(pD.requiresUtility != null) {
                        for(j = 0; j < pD.requiresUtility.length; j++) {
                            utr = pD.requiresUtility[j];
                            modifyGameUtilityUsage(utr.utility,utr.amount);
                        }
                    }

                    if(pD.providesUtility != null) {
                        for(j = 0; j < pD.providesUtility.length; j++) {
                            utr = pD.providesUtility[j];
                            modifyGameUtilityCapacity(utr.utility,utr.amount,passdef);
                        }
                    }
                }
            }
        }

        while(toNuke.length > 0) {
            var nukem = toNuke.pop();
            delete currentGame.finishedPassableNonUpdatables[nukem];
        }

        // first pass for foreign cities 
        if(currentGame.isSubregion && currentRegion != null) {
            for(i = 0; i < currentRegion.subRegions.length; i++) {
                sr = currentRegion.subRegions[i];

                

                if(currentGame.mpRegionPlanetCharter) {
                    
                    if(sr == currentSubcityRef) {
                        continue;
                    }

                    if(sr.metroAreaDistrict != currentSubcityRef.metroAreaDistrict) {
                        continue;
                    }
                }

                if(sr.resourceCapacities) {
                    for(res in sr.resourceCapacities) {
                        if(currentGame.mpRegionPlanetCharter) {
                            currentGame.resources[res].storageCapacity += parseInt(sr.resourceCapacities[res]);
                        } else {
                            currentRegion.resources[res].storageCapacity += parseInt(sr.resourceCapacities[res]);
                        }
                        
                    }
                }

                if(sr == currentSubcityRef) {
                    continue;
                }


                if(sr.utilityCapacities) {
                    for(prop in sr.utilityCapacities) {
                        utils[prop].usage += parseInt(sr.utilityCapacities[prop].usage);
                        utils[prop].capacity += parseInt(sr.utilityCapacities[prop].capacity);
                        
                    }
                }
            }
        }

        // finally do local consumption and storage
        for(i = 0; i < currentGame.buildings.length; i++) {

            bdl = currentGame.buildings[i];

            if(!bdl) {
                continue;
            }

            if(bdl.isBeingRemoved) {
                continue;
            }

            if(bdl.deactivated) {
                continue;
            }

            if(bdl.iuc) {
                continue;
            }

            workingDef = getBuildingDefByName(bdl.def);

            if(workingDef == null) {
                continue;
            }

            bdl.lowPowerMode = false;
            bdl.lpiz = [];

            if(workingDef.requiresUtility != null) {
                for(j = 0; j < workingDef.requiresUtility.length; j++) {
                    utr = workingDef.requiresUtility[j];
                    modifyGameUtilityUsage(utr.utility,utr.amount);

                    if(utils[utr.utility].usage > utils[utr.utility].capacity) {
                        bdl.lowPowerMode = true;
                        bdl.lpiz.push(utr.utility);
        
                        if(lowCapacityCounter > lowPowerNagLimit) {
                            lowCapacityCounter = 0;
                            webAppCore.showToast({
                                message: "Low " + getUtilityByDefName(utr.utility).name,
                                image:   "images/" + getUtilityByDefName(utr.utility).icon
                            });
                        }
                    }
                }
            }

            if(workingDef.stores != null && !bdl.lowPowerMode) {
                for(j = 0; j < workingDef.stores.length; j++) {
                    utr = workingDef.stores[j];
                    modifyGameResourceCapacity(utr.resource,utr.amount);
                }
            }
        }

    }

    var constructionProjectsArray;
    var openVenuesArray;
    var openJobsArray;
    var openMedicalArray;
    var openHomesArray;
    var openSpaceportArray;
    var openTourismArray;
    var openStargateArray;
    var openSchoolsArray;


    var simUpdateMax = 5;
    var simUpdateTicker = simUpdateMax;

    var buildingUpdateCycle = false;
    var buildingUpdateCycles = 8;
    var buildingUpdateTicker = buildingUpdateCycles;

    var tmpUsingTouch;

    var resourceLedger;

    var earthTaxTurn = false;
    var earthTaxAmount = 0;
    var payrollTurn = false;
    var hasStargate = false;


    function updateBuildings() {

        ticksPerMinuteCounter++;

        var i,j,len;

        var killArray = [];
        var passableKills = [];
        
        openHomesArray = [];
        
        constructionProjectsArray = [];
        openSpaceportArray = [];
        openTourismArray = [];
        
        hasGBTBuilding = false;
        hasCommunicationsBuilding = false;

        openSchoolsArray = [];
        openVenuesArray = [];
        openMedicalArray = [];
        
        var entertainmentTick = false;

        currentGame.entertainmentTickPhase++;

        if(currentGame.entertainmentTickPhase >= 500) {
            currentGame.entertainmentTickPhase = 0;
            entertainmentTick = true;
        }
        

        if(opprotunityRecycleBox.length > 200000) {
            currentJobOpprotunities.length = 0;
        } else {
            while(currentJobOpprotunities.length > 0) {
                opprotunityRecycleBox.push(currentJobOpprotunities.pop());
            }
        }

        if(coveragePointRecycler.length > 200000) {
            medicalCoveragePoints.length = 0;
        } else {
            while(medicalCoveragePoints.length > 0) {
                coveragePointRecycler.push(medicalCoveragePoints.pop());
            }
        }

        if(coveragePointRecycler.length > 200000) {
            entertainmentCoveragePoints.length = 0;
        } else {
            while(entertainmentCoveragePoints.length > 0) {
                coveragePointRecycler.push(entertainmentCoveragePoints.pop());
            }
        }



        runningBuildingCounts = {};

        shoreReferenceChart = {};

        allHomesArray = [];
        allJobsArray = [];
        
        var buildingsWithPeople = [];
        var availableHousingUnits = [];

        currentGame.availableShelters = 0;
        currentGame.availableTourism = 0;

        spriteChangeCounter++;

        if(spriteChangeCounter >= 1) {
            spriteChangeCounter = 0;
            spriteChangeTurn = true;
        } else {
            spriteChangeTurn = false;
        }

        var nonHousingUnits = [];

        var bdef = null;
        var muhBld = null;
        var myValid = false;

        var fullHousing = 0;
        var statUpdateCycle = false;
        var openForBusiness = true;

        var openSpots;

        currentGame.touristCount = 0;

        currentGame.buildingStatCycleCounter++;

        if(currentGame.buildingStatCycleCounter > statUpdateRate) {
            currentGame.buildingStatCycleCounter = 0;
            currentGame.currentOccupationStats = {};
            statUpdateCycle = true;
            openJobsArray = [];
        }

        for(i = 0, len = currentGame.buildings.length; i < len; i++) {

            muhBld = currentGame.buildings[i];
            myValid = false;

            if(!muhBld) {
                killArray.push(muhBld);
                continue;
            }

            if(muhBld.isBeingRemoved) {
                shouldUpdateCollissionMap = true;
            }

            bdef = getBuildingDefByName(muhBld.def);

            if(!bdef) {
                killArray.push(muhBld);
                continue;
            }

            
            if(!runningBuildingCounts[muhBld.def]) {
                runningBuildingCounts[muhBld.def] = 0;
            }

            currentGame.touristCount += muhBld.bTA;

            runningBuildingCounts[muhBld.def]++;

            if(entertainmentTick) {
                touristAndEntertainmentIncomePhase(muhBld,bdef);
            }

            if(muhBld.condition <= 0 || muhBld.isBeingRemoved) {
                killArray.push(muhBld);

                if(muhBld.isBeingRemoved && muhBld.iuc) {
                    if(bdef.cost) {
                        for(var c = 0; c < bdef.cost.length; c++) {
                            var toreimburse = bdef.cost[c].amount - muhBld.c.pr[bdef.cost[c].resource];
    
                            if(toreimburse > 0) {
                                modifyResourceAmount(bdef.cost[c].resource,toreimburse);
                            }
                        }
                    }
                    
                }

                continue;
            }

            if(freeRefNukeTurn) {
                muhBld.fr = null;
            }

            updateBuilding(muhBld,bdef);
            

            if(statUpdateCycle) {

 
                openSpots = getFreeSpacesAroundBuilding(muhBld);

                if(openSpots.length > 0) {
                    muhBld.hOS = true;
                    
                } else {
                    muhBld.hOS = false;
                }

                muhBld.buG = 0;
                muhBld.buS = 0;
                muhBld.buM = 0;

                muhBld.brE = 0;
                muhBld.brM = 0;
                muhBld.brS = 0;

                // only 100 for now, when crime is implemented, this must change
                muhBld.brSAF = 100;

                muhBld.bER = 0;
                muhBld.bRC = 0;

                muhBld.bsAS = 0;
                muhBld.bsTS = 0;

                openForBusiness = true;

                if(bdef.requiresWorkers && muhBld.buW == 0) {
                    openForBusiness = false;

                }

                if(bdef.touristDoorway) {
                    openSpaceportArray.push(muhBld);
                }

                if(muhBld.embassyFor == 0 && muhBld.hOS && !muhBld.iuc && !muhBld.deactivated && !muhBld.lowPowerMode) {


                    if(openForBusiness) {
                        if(bdef.entertains > 0) {
                            muhBld.ocE = bdef.entertains;
                            openVenuesArray.push(muhBld);
                        }
        
                        if(bdef.educates > 0) {
                            muhBld.ocS = bdef.educates;
                            openSchoolsArray.push(muhBld);
                        }
        
                        if(bdef.heals > 0) {
                            muhBld.ocM = bdef.heals;
                            openMedicalArray.push(muhBld);
                        }
        
                        var added = false;
                        
                        if(bdef.providesShelter > 0) {
                            muhBld.osH = Math.round(bdef.providesShelter * (muhBld.condition / 100));

                            if(muhBld.osH > 0) {
                                availableHousingUnits.push(muhBld);
                                added = true;


                            }

                            
                            
                        }
                        
                        if(!added) {
                            nonHousingUnits.push(muhBld);

                        }
                        

                        if(bdef.takesTourists > 0) {
                            muhBld.buT = 0;
                            muhBld.ocT = bdef.takesTourists;
                            openTourismArray.push(muhBld);
                        }
                    } else {
                        // even if they require workers, medical facilities can take 25% capacity if they are unstaffed
                        if(bdef.heals > 1) {
                            muhBld.ocM = Math.round(bdef.heals * 0.25);
                            openMedicalArray.push(muhBld);
                        }
                    }

                    if(bdef.acceptsWorkers) {
                        muhBld.ocJ = Math.round(bdef.acceptsWorkers * (muhBld.condition / 100));
                        openJobsArray.push(muhBld);


                    } else {
                        muhBld.ocJ = 0;


                    }
                    
                }

                muhBld.buW = 0;

            }

            

            if(muhBld.embassyFor == 0 && !muhBld.iuc && !muhBld.deactivated) {
                myValid = true;
            }

            if(myValid) {
                fullHousing += muhBld.bRC;
            }

            if(muhBld.iuc) {
                constructionProjectsArray.push(muhBld);
            }


            if(myValid && muhBld.availableHomes > 0) {
                openHomesArray.push(muhBld);
            }

            if(myValid && earthTaxTurn && bdef.earthTaxValue) {
                earthTaxAmount += bdef.earthTaxValue;
            }

        }

        if(statUpdateCycle) {


            availableHousingUnits.sort(sortBuildingsByLandValueReverse);


            var neededHousing = getTotalPopulation();
            var nextOpenHouse;

            while(neededHousing > 0 && availableHousingUnits.length > 0) {
                nextOpenHouse = availableHousingUnits.pop();


                while(nextOpenHouse.osH > 0 && neededHousing > 0) {
                    nextOpenHouse.osH--;
                    neededHousing--;
                    nextOpenHouse.bRC++;
                }

                if(nextOpenHouse.bRC > 0) {
                    buildingsWithPeople.push(nextOpenHouse);

                } else {
                    setBuildingLandValue(nextOpenHouse);

                }
            }

            while(availableHousingUnits.length > 0) {
                nextOpenHouse = availableHousingUnits.pop();

                setBuildingLandValue(nextOpenHouse);
            }

            buildingsWithPeople = shuffleArray(buildingsWithPeople);
            openSpaceportArray = shuffleArray(openSpaceportArray);

            currentWorkingAgePercentage = 1;

            var allWorkers = getTotalPopulation();

            var ofAgeWorkers = allWorkers - getMinorPopulation();
            ofAgeWorkers = ofAgeWorkers - getRetiredPop();

            currentWorkingAgePercentage = ofAgeWorkers / allWorkers;

            while(buildingsWithPeople.length > 0) {
                updateBuildingResidentialStats(buildingsWithPeople.pop());
            }

            // handle tourism
            while(openSpaceportArray.length > 0) {
                handleSpaceportTourismStats(openSpaceportArray.pop());
            }

            while(nonHousingUnits.length > 0) {
                setBuildingLandValue(nonHousingUnits.pop());
            }

            var setOccs = 0;
            var usedOcc;

            for(usedOcc in currentGame.currentOccupationStats) {
                setOccs += currentGame.currentOccupationStats[usedOcc];
            }

            var unOccs = getTotalPopulation() - setOccs;

            currentGame.currentOccupationStats.nooccupation = unOccs;

            for(usedOcc in currentGame.currentOccupationStats) {
                setOccs += currentGame.currentOccupationStats[usedOcc];
            }

            currentGame.currentOccupationPercents = {};

            for(usedOcc in currentGame.currentOccupationStats) {
                currentGame.currentOccupationPercents[usedOcc] = currentGame.currentOccupationStats[usedOcc] / setOccs;
            }
        }

        runningHomelessCount = getTotalPopulation() - fullHousing;

        if(runningHomelessCount < 0) {
            runningHomelessCount = 0;
        }

        muhBld = null;
        bdef = null;

        // under construction passables
        for(i = 0, len = currentGame.passableNonUpdatables.length; i < len; i++) {

            if(currentGame.passableNonUpdatables[i].isBeingRemoved) {
                passableKills.push(currentGame.passableNonUpdatables[i]);
                continue;
            }

            if(freeRefNukeTurn) {
                currentGame.passableNonUpdatables[i].fr = null;
            }

            updatePassable(currentGame.passableNonUpdatables[i]);

            if(currentGame.passableNonUpdatables[i].iuc) {
                constructionProjectsArray.push(currentGame.passableNonUpdatables[i]);
            } else {
                passableKills.push(currentGame.passableNonUpdatables[i]);

                if(!currentGame.finishedPassableNonUpdatables[currentGame.passableNonUpdatables[i].def]) {
                    currentGame.finishedPassableNonUpdatables[currentGame.passableNonUpdatables[i].def] = {};
                }

                if(!currentGame.finishedPassableNonUpdatables[currentGame.passableNonUpdatables[i].def][currentGame.passableNonUpdatables[i].x]) {
                    currentGame.finishedPassableNonUpdatables[currentGame.passableNonUpdatables[i].def][currentGame.passableNonUpdatables[i].x] = [];
                }

                if(collisionReference && collisionReference[currentGame.passableNonUpdatables[i].x][currentGame.passableNonUpdatables[i].y] > 15) {
                    collisionReference[currentGame.passableNonUpdatables[i].x][currentGame.passableNonUpdatables[i].y] = 1;   
                }

                currentGame.finishedPassableNonUpdatables[currentGame.passableNonUpdatables[i].def][currentGame.passableNonUpdatables[i].x].push(currentGame.passableNonUpdatables[i].y);

                shouldUpdateCollissionMap = true;
            }
        }

        // new, complete passables 
        for(var passdef in currentGame.finishedPassableNonUpdatables) {

            if(!runningBuildingCounts[passdef]) {
                runningBuildingCounts[passdef] = 0;
            }

            

            var td = currentGame.finishedPassableNonUpdatables[passdef];
            for(var passX in td) {
                var tx = td[passX];
                for(var ty = 0; ty < tx.length; ty++) {
                    var passY = tx[ty];
                    updateNewPassable(passdef,passX,passY);
                    runningBuildingCounts[passdef]++;
                }
            }
        }

        for(i = 0, len = currentGame.mapResources.length; i < len; i++) {

            if(freeRefNukeTurn) {
                currentGame.mapResources[i].fr = null;
            }

            updateMapResource(currentGame.mapResources[i]);

            
            

            if(currentGame.mapResources[i].inventory <= 0) {

                if(currentGame.mapResources[i].playDef != null && currentGame.mapResources[i].playDef.capacity != null && currentGame.mapResources[i].playDef.capacity != -1) {
                    resourceKillArray.push(currentGame.mapResources[i]);
                }

                
            }
        }

        if(shoreUpdateTurn) {

            for(i = 0, len = currentGame.mapResources.length; i < len; i++) {
                setTerrainShoreFrame(currentGame.mapResources[i]);
            }

            
            
            shoreUpdateTurn = false;

            setOverallShoreMap();

            shoreReferenceChart = {};
        }

        // go through second time to deal with spreading
        for(i = 0, len = currentGame.mapResources.length; i < len; i++) {
            updateMapResourceSpreading(currentGame.mapResources[i]);

        }

        while(passableKills.length > 0) {
            removeFromArray(currentGame.passableNonUpdatables,passableKills.pop());
        }


        while(killArray.length > 0) {
            var kill = killArray.pop();

            if(!kill) {
                removeFromArray(currentGame.buildings,kill);
                continue;
            }

            if(kill.condition <= 0) {
                shouldUpdateCollissionMap = true;
                currentGame.destroyedBuildings++;

                for(j = 0; j < kill.occupiesTiles.length; j++) {
                    if(allowParticleEffects) {
                        Scroll2d.playParticleEffect("explosion",kill.occupiesTiles[j].x,kill.occupiesTiles[j].y);
                    }

                    if(ColonyGame.sounds.explosion) {
                        playInterfaceSoundEffect(ColonyGame.sounds.explosion);
                    }
                }
            }


            removeFromArray(currentGame.buildings,kill);
        }

        freeRefNukeTurn = false;

    }

    function updateTickers() {

        if(currentGame == null || getGameResources() == null) {
            return;
        }

        var roc = getRegionOrCity();

        if(!roc) {
            return;
        }

        simUpdateMax = 5;

        var pop = getTotalPopulation();

        if(pop > 8000) {
            simUpdateMax = 6;

            if(pop > 16000) {
                simUpdateMax = 7;

                if(pop > 32000) {
                    simUpdateMax = 8;

                    if(pop > 64000) {
                        simUpdateMax = 9;

                        if(pop > 128000) {
                            simUpdateMax = 10;

                            if(pop > 256000) {
                                simUpdateMax = 11;

                                if(pop > 512000) {
                                    simUpdateMax = 12;
                                }
                            }
                        }
                    }
                }
            }
        }

        earthTaxTurn = false;
        earthTaxAmount = 0;

        gotItMadePrice = 0;
        povertyLine = 0;

        var i;

        for(i = 0; i < ColonyGame.meta.retirementRequirements.length; i++) {

            var res = ColonyGame.meta.retirementRequirements[i].resource;
            var amt = ColonyGame.meta.retirementRequirements[i].amount;

            gotItMadePrice += (getGameResources()[res].price * amt);
        }

        povertyLine = Math.round(gotItMadePrice * 0.005);

        simUpdateTicker++;

        if(simUpdateTicker >= simUpdateMax) {

            simUpdateTicker = 0;
            reconcileResources();
        }
        
        buildingUpdateTicker++;
        if(buildingUpdateTicker >= buildingUpdateCycles) {
            buildingUpdateCycle = true;
            buildingUpdateTicker = 0;
            hasConsulate = false;
            hasCapitol = false;
            ourCapitolBuilding = null;

            if(currentGame.isSubregion && currentSubcityRef) {
                currentSubcityRef.hasCapitol = false;
                currentSubcityRef.hasConsulate = false;
            }
        } else {
            buildingUpdateCycle = false;
        }

        
        if(!saveInProgress) {
            roc.earthTaxCounter++;
            roc.monthEndCounter++;
            roc.rewardCounter++;
            mailCheckTimer++;
        }

        if(roc.earthTaxCounter >= 50000) {
            earthTaxTurn = true;
            roc.earthTaxCounter = 0;
            buildingUpdateCycle = true;
            buildingUpdateTicker = 0;
        }

        if(roc.rewardCounter >= 210000) {

            if(!webAppCore.isRewardedVideoAvailable()) {
                roc.rewardCounter = 175000;
            }

            if(!roc.showRewardOption) {
                if(webAppCore.getIsPremium()) {
                    roc.showRewardOption = true;
                    completeRewardGiftFinal();
                } else {
                    roc.showRewardOption = true;
                    roc.mail.push(new MailMessage(getString("general-gift-giver"),0,getString("general-gift-message"),dateToReadable(Date.now()),"-1",null,null));
                }
                
            }

            if(roc.rewardCounter > 500000) {
                roc.rewardCounter = 0;
                roc.showRewardOption = false;
            }
        }

        if(mailCheckTimer == Math.round(mailCheckLimit / 2)) {
            getPendingEmbassyRequests();
        }

        if(mailCheckTimer >= mailCheckLimit) {
            mailCheckTimer = 0;
            checkMail();
        }



        retainedPathsCounter++;

        if(retainedPathsCounter >= 8500) {
            cleanRetainedPaths();
            shouldUpdateCollissionMap = true;
            retainedPathsCounter = 0;
        }
        

        lowCapacityCounter++;
        storageCapCounter++;

        utilityGridCounter++;
    }

    var lastZoomLevel = 0;
    var simulatedTileSize = 0;

    var riotingWarned = false;
    var anarchyWarned = false;
    var famineWarned = false;
    var noWaterWarned = false;

    var currentViewBounds;

    var inBackgroundMode = false;
    var backgroundUpdateCounter = 0;

    var spriteChangeCounter = 0;
    var spriteChangeTurn = false;

    var allHomesArray = [];
    var allJobsArray = [];

    var globalconsumptioncounter = 0;
    var currentTotalIllegals = 0;

    var minWidthSetTimer = 5;

    var lastBorderColor = null;
    var lastColorFilter = null;

    var timeOfDayCounter = 0;
    
    var monitoringRes = true;

    var monitoringFPS = true;
    var monitorFPSCount = 0;

    var contractPostTimeout = 0;
    var ticksPerMinuteCounter = 0;

    var tpmChecker = 0;

    var currentTicksPerMinute = 200;

    var lastTimestamp = 0;
    var padCooldownTimer = 0;

    var anarchyCooldown = 0;
    var deathShowCooldown = 0;
    var lastBullsozerMode = bulldozerMode;


    var mpRegionStatUpdateCounter = 0;

    function update(timestamp) {

        if(killSwitch || saveAndQuitting) {
            return;
        }
        
        if(lastTimestamp == 0) {
            lastTimestamp = timestamp;
        }

        var roc = getRegionOrCity();

        if(!roc) {
            return;
        }

        if(currentGame.isCleaningForSave) {
            return;
        }
        
        currentGame.autosellCheckCounter++;
        autosellProcessCounter++;

        if(currentGame.autosellCheckCounter > 14000) {
            checkAutosells();
            currentGame.autosellCheckCounter = 0;
        }

        if(autosellProcessCounter > 400) {
            processAutosells();
            autosellProcessCounter = 0;
        }

        if(inBackgroundMode) {
            backgroundUpdateCounter++;

            if(backgroundUpdateCounter < 10) {
                return;
            }

            backgroundUpdateCounter = 0;
        }

        if(lastTimestamp > 0) {
            tpmChecker += (timestamp - lastTimestamp);
            
            if(tpmChecker >= 60000) {
                currentTicksPerMinute = ticksPerMinuteCounter;
                ticksPerMinuteCounter = 0;
                tpmChecker = 0;
            }
        }

        //jobSeatchesThisTurn = 0;

        lastTimestamp = timestamp;

        if(monitoringFPS && fpsRate < 4 && !inBackgroundMode) {
            monitorFPSCount++;

            if(monitorFPSCount > 200) {

                monitorFPSCount = 0;

                var fps = Scroll2d.getFPS();

                if(fps < 50) {
                    incrementFPS();

                    if(fpsRate == 4 && !loresMode && monitoringRes) {
                        toggleLoresMode(true);
                    }
                }

            }
        }

        if(currentGame.isSubregion && currentRegion && currentRegion.isMpRegionHolder && currentSubcityRef) {
            mpRegionStatUpdateCounter++;

            if(mpRegionStatUpdateCounter > 2500) {
                mpRegionStatUpdateCounter = 0;
                updateColonyStats();
            }
        }

        var notificatioAreaVisibility = null;

        if(queuedBuilding != null) {
            notificatioAreaVisibility = "none";
        }

        if(desktopNotificationArea.style.display != notificatioAreaVisibility) {
            desktopNotificationArea.style.display = notificatioAreaVisibility;
        }

        if(notificationArea.style.display != notificatioAreaVisibility) {
            notificationArea.style.display = notificatioAreaVisibility;
        }

        var cityNameVisibility = "none";
        if(currentGame.isRegion) {
            cityNameVisibility = null;
        }

        if(imCityNames.style.display != cityNameVisibility) {
            imCityNames.style.display = cityNameVisibility;
        }

        var templateVisibiltyButton = "none";
        if(currentTemplate) {
            templateVisibiltyButton = null;
        }

        if(templateLayerInd.style.display != templateVisibiltyButton) {
            templateLayerInd.style.display = templateVisibiltyButton;
        }

        if(currentGame.isRegion) {
            currentViewBounds = Scroll2d.getViewBounds();
            
            doResourceStatTickStuff();
            updateResourceStuff(showDisplay);


            var regionPop = getTotalPopulation();

            if(resourceReadouts.population.readout.innerHTML != regionPop) {
                resourceReadouts.population.readout.innerHTML = regionPop;
            }

            if(resourceReadouts.population.holder.style.display != showDisplay) {
                resourceReadouts.population.holder.style.display = showDisplay;
            }

            resourceReadouts.tourists.holder.style.display = "none";

            return;
        }

        

        anarchyCooldown--;
        if(anarchyCooldown <= 0) {
            anarchyCooldown = 0;
            riotingWarned = false;
            anarchyWarned = false;
        }

        lightCounter++;
        if(lightCounter > 10) {
            lightCounter = 0;
            lightCycle++;

            if(lightCycle > 11) {
                lightCycle = 0;
            }
        }

        deathShowCooldown--;
        if(deathShowCooldown <= 0) {
            deathShowCooldown = 0;
        }

        if(silosNeededCooldown > 0) {
            silosNeededCooldown--;
        }

        if(silosNeededCooldown < 0) {
            silosNeededCooldown = 0;
        }

        if(contractPostTimeout > 0) {
            contractPostTimeout--;
        }

        if(contractPostTimeout < 0) {
            contractPostTimeout = 0;
        }

        if(!currentGame.mem) {
            for(var disaster in currentGame.disasterCounters) {
                currentGame.disasterCounters[disaster]--;
    
                if(currentGame.disasterCounters[disaster] <= 0) {
                    playDisaster(disaster);
                }
            }
        }
        

        var useColorFilter = null;
        var useBorderColor = null;
        var useStrength = 0.2;

        timeOfDayCounter++;

        if(timeOfDayCounter >= 1000) {
            roc.timeOfDay++;

            if(roc.timeOfDay > 24) {
                roc.timeOfDay = 0;
            }

            timeOfDayCounter = 0;
        }

        if(gamepadInUse) {

            padCooldownTimer++;
            if(padCooldownTimer == 5) {
                padCooldownTimer = 0;
            }

            if(padCooldownTimer == 4 && document.getElementById("sidebar").style.display == "block") {
                if(padReference.left) {
                    gamepadSelectedSidebarOption--;
                    lastSidebarGamepadDirection = -1;
                    gamepadScrollRetrys = 0;
                    handleSidebarGamepadSelection();
                }

                if(padReference.right) {
                    gamepadSelectedSidebarOption++;
                    lastSidebarGamepadDirection = 1;
                    gamepadScrollRetrys = 0;
                    handleSidebarGamepadSelection();
                }
            }

            if(statsOpen) {
                if(padReference.rup) {
                    document.getElementById("statsMain").scrollTop -= 45;
                }
    
                if(padReference.rdown) {
                    document.getElementById("statsMain").scrollTop += 45;
                }
            }
        }

        if(allowDayNight == "0") {
            roc.timeOfDay = 12;
        }

        if(allowDayNight == "2") {
            roc.timeOfDay = 0;
        }

        if(bulldozerMode) {
            useColorFilter = "#ff0000";
            useBorderColor = "#ff0000";
        } else {
            useColorFilter = mapfilter;
            useBorderColor = null;
            useStrength = mapFilterStrength;

            if(mapfilter == null) {
                if(roc.timeOfDay >= 21 || roc.timeOfDay <= 5) {
                    useColorFilter = "#000000";
                    useStrength = 0.8;
                }

                if(roc.timeOfDay == 20 || roc.timeOfDay == 6) {
                    useColorFilter = "#442a01";
                    useStrength = 0.7;
                }

                if(roc.timeOfDay == 19 || roc.timeOfDay == 7) {
                    useColorFilter = "#5e3c07";
                    useStrength = 0.5;
                }

                if(roc.timeOfDay == 18 || roc.timeOfDay == 8) {
                    useColorFilter = "#a57b3a";
                    useStrength = 0.3;
                }
            }
        }

        if(!allowLighting || currentGame.isRegion) {
            useColorFilter = null;
        }

        if(useColorFilter != lastColorFilter) {
            Scroll2d.setColorFilter(useColorFilter,useStrength);
            lastColorFilter = useColorFilter;
        }

        if(useBorderColor != lastBorderColor) {
            Scroll2d.setBorderColor(useBorderColor);
            lastBorderColor = useBorderColor;
        }

        minWidthSetTimer++;

        if(minWidthSetTimer >= 100) {
            setMinWidths();
            minWidthSetTimer = 0;
        }

        currentViewBounds = Scroll2d.getViewBounds();

        if(getRegionOrCity().offlineMode) {
            exportPenalty = 0.05;
            importPenalty = 0.02;
            importPriceMod = 1.10;
            exportPriceMod = 0.90;
        } else {
            exportPenalty = 0.75;
            importPenalty = 0.50;
            importPriceMod = 2;
            exportPriceMod = 0.25;
        }

        var curZoom = Scroll2d.getZoomLevel();

        if(curZoom != lastZoomLevel) {
            lastZoomLevel = curZoom;
            simulatedTileSize = ColonyGame.meta.gridSize * lastZoomLevel;
            staticFrame = false; 
        }

        tmpUsingTouch = Scroll2d.getUsingTouch();

        if(tmpUsingTouch != usingTouch || bulldozerMode != lastBullsozerMode) {
            usingTouch = tmpUsingTouch;

            setBodyStyles();

        }

        lastBullsozerMode = bulldozerMode;

        if(isNaN(getRegionOrCity().earthTaxCounter)) {
            getRegionOrCity().earthTaxCounter = 0;
        }

        if(isNaN(getRegionOrCity().stage)) {
            getRegionOrCity().stage = 0;
        }

        if(isNaN(getRegionOrCity().monthEndCounter)) {
            getRegionOrCity().monthEndCounter = 0;
        }

        updateTickers();

        resourceKillArray = [];

        vehicleKillArray = [];

        updateTicker();

        if(buildingUpdateCycle) {
            //openVenuesArray = [];
            //openJobsArray = [];
            //openMedicalArray = [];
            openHomesArray = [];
            //openSpaceportArray = [];
            openStargateArray = [];
            //openTourismArray = [];
            //openSchoolsArray = [];
            constructionProjectsArray = [];

            resetCollisionReference();
            previouslyAvailableShelters = currentGame.availableShelters;
            currentGame.availableShelters = 0;
            previouslyAvailableTourism = currentGame.availableTourism;
            currentGame.availableTourism = 0;
            currentGame.giftCapacity = 0;

            hasStargate = false;
        }

        var i;

        vitalCounter++;

        if(vitalCounter >= 10000) {
            vitalCounter = 0;
            webAppCore.storeVar("vital-res-width",currentGame.width.toString());
            webAppCore.storeVar("vital-res-height",currentGame.height.toString());
            webAppCore.storeVar("vital-res-pop",getTotalPopulation().toString());

            var onlineString = "online";

            if(getRegionOrCity().offlineMode) {
                onlineString = "offline";
            }

            webAppCore.storeVar("vital-res-online",onlineString);
        }

        if(utilityGridCounter >= 1600) {
            updateUtilityGrid();
            utilityGridCounter = 0;

            if(usingSockets) {
                postVitalsToStreaming();
            }
        }

        if(buildingUpdateCycle) {
            updateBuildings();
        }

        if(shouldUpdateCollissionMap) {
            updateCollisionMap();
        }

        runningVehicleCounts = {};

        for(i = 0; i < currentGame.vehicles.length; i++) {
            updateVehicle(currentGame.vehicles[i]);
            if(!currentGame.vehicles[i] || currentGame.vehicles[i].isCashed) {
                vehicleKillArray.push(currentGame.vehicles[i]);
            }
        }

        if(selectedBuilding != null) {
            updateCostRemainingArea();
        }


        riotCount = 0;


        currentTotalIllegals = 0;

        var len;

        var virtcol = getTotalPopulation();

        globalconsumptioncounter++;

        if(globalconsumptioncounter >= 500) {
            globalconsumptioncounter = 0;

            

            var res = getGameResources();

            var foodNeeded = virtcol;
            var waterNeeded = virtcol;

            if(getRegionOrCity().foodRationing) {
                foodNeeded = Math.round(foodNeeded * 0.3);
                waterNeeded = Math.round(foodNeeded * 0.3);
            }

            var starvation = false;
            var nowater = false;

            if(foodNeeded > res[ColonyGame.meta.colonistsEat].amount) {
                foodNeeded = res[ColonyGame.meta.colonistsEat].amount;
                starvation = true;
            }

            if(waterNeeded > res[ColonyGame.meta.colonistsDrink].amount) {
                waterNeeded = res[ColonyGame.meta.colonistsDrink].amount;
                nowater = true;
            }

            if(starvation) {
                if(!currentGame.statMods) {
                    currentGame.statMods = {};
                }

                if(!currentGame.statMods.health) {
                    currentGame.statMods.health = 0;
                }

                currentGame.statMods.health -= 25;
            }

            if(nowater) {
                if(!currentGame.statMods) {
                    currentGame.statMods = {};
                }

                if(!currentGame.statMods.health) {
                    currentGame.statMods.health = 0;
                }

                currentGame.statMods.health -= 45;
            }

            modifyResourceAmount(ColonyGame.meta.colonistsEat,-foodNeeded,false,"Colonist");
            modifyResourceAmount(ColonyGame.meta.colonistsDrink,-waterNeeded,false,"Colonist");
        }

        if(virtcol > 50) {
            if(riotCount > virtcol * 0.15) {
                if(!riotingWarned) {
                    riotingWarned = true;
                    anarchyCooldown += 4000;
    
                    if(!getRegionOrCity().offlineMode) {
                        postMessageToAllChannels("Mass rioting in " + getRegionOrCity().name + "!","#F44336");
                    }
                }
            }
    
            if(riotCount > virtcol * 0.5) {
                if(!anarchyWarned) {
                    riotingWarned = true;
                    anarchyWarned = true;
                    anarchyCooldown += 8000;
    
                    if(!getRegionOrCity().offlineMode) {
                        postMessageToAllChannels(getRegionOrCity().name + " has fallen under total anarchy!","#F44336");
                    }
                }
            }
        }
        
        createUtilityGridIfNonexistant();

        var showDisplay = "block";

        if(desktopMode || gamepadInUse || resourceDisplayMode == 0) {
            showDisplay = "inline-block";
        }

        updateUtilityDisplays(showDisplay);

        doResourceStatTickStuff();
        
        updateResourceStuff(showDisplay);

        // population readout 

        var curPopNum = numberWithCommas(getTotalPopulation());
        var curTourNum = numberWithCommas(currentGame.touristCount);

        if(shortNumbers) {
            if(getTotalPopulation() > 99999) {
                curPopNum = abbreviate(getTotalPopulation());
            }

            if(currentGame.touristCount > 99999) {
                curTourNum = abbreviate(currentGame.touristCount);
            }
        }

        if(showCapacity) {
            var totalShelters = numberWithCommas(currentGame.availableShelters);
            var totalTouris = numberWithCommas(currentGame.availableTourism);

            if(shortNumbers) {
                if(currentGame.availableShelters > 99999) {
                    totalShelters = abbreviate(currentGame.availableShelters);
                }

                if(currentGame.availableTourism > 99999) {
                    totalTouris = abbreviate(currentGame.availableTourism);
                }
            }

            curPopNum += ("/" + totalShelters);
            curTourNum += ("/" + totalTouris);
        }

        if(resourceReadouts.population.readout.innerHTML != curPopNum) {
            resourceReadouts.population.readout.innerHTML = curPopNum;
        }

        if(resourceReadouts.population.holder.style.display != showDisplay) {
            resourceReadouts.population.holder.style.display = showDisplay;
        }

        // tourist readout
        if(currentGame.availableTourism == 0) {
            if(resourceReadouts.tourists.holder.style.display != "none") {
                resourceReadouts.tourists.holder.style.display = "none";
            }
        } else {
            if(resourceReadouts.tourists.holder.style.display != showDisplay) {
                resourceReadouts.tourists.holder.style.display = showDisplay;
            }

            if(resourceReadouts.tourists.readout.innerHTML != curTourNum) {
                resourceReadouts.tourists.readout.innerHTML = curTourNum;
            }
        }
        
        if(!webAppCore.isTV() && !gamepadInUse) {
            if(resourceDisplayMode > 0) {
                if(resourceReadouts.population.trend.src != "images/res-contract.png") {
                    resourceReadouts.population.trend.src = "images/res-contract.png";
                }
            } else {
                if(resourceReadouts.population.trend.src != "images/res-expand.png") {
                    resourceReadouts.population.trend.src = "images/res-expand.png";
                }
            }
        }

        

        for(i = 0, len = resourceKillArray.length; i < len; i++) {
            removeFromArray(currentGame.mapResources,resourceKillArray[i],"resourceKillArray");

            if(resourceKillArray[i].inventory <= 0 && resourceKillArray[i].playDef != null && resourceKillArray[i].playDef.decaysTo != null) {
                
                var randChance = randomIntFromInterval(0,100);

                if(randChance <= resourceKillArray[i].playDef.decaysTo.chance) {
                    var newRes = getTerrainDefByName(resourceKillArray[i].playDef.decaysTo.terrain);
                    var resourceItem = new MapResource(newRes,resourceKillArray[i].x,resourceKillArray[i].y);
                    freeRefNukeTurn = true;
                    updateBuildingCollisionPoints(resourceItem,150,true);
                    currentGame.mapResources.push(resourceItem);
                    shoreUpdateTurn = true;
                }
                
                
            }
        }

        for(i = 0, len = vehicleKillArray.length; i < len; i++) {
            removeFromArray(currentGame.vehicles,vehicleKillArray[i],"vehicleKillArray");
        }

        resourceKillArray = null;

        vehicleKillArray = null;
        
        
        if(saveInProgress) {
            saveCounter = 0;
        } else {
            saveCounter++;
        }
        
        if(saveCounterMax > -1) {
            if(saveCounter >= saveCounterMax) {
                updateColonyStats();
                saveCounter = 0;
                generalSaveGame();
            }
        }

        if(earthTaxAmount > 0) {

            if(isNaN(getRegionOrCity().earthAssemblyRelations)) {
                getRegionOrCity().earthAssemblyRelations = 100;
            }

            if(isNaN(getRegionOrCity().earthBackTax)) {
                getRegionOrCity().earthBackTax = 0;
            }

            if(getRegionOrCity().isIndependent) {
                if(getRegionOrCity().earthAssemblyRelations < 100) {
                    getRegionOrCity().earthAssemblyRelations++;
                }
            } else {

                var earthTaxRate = getRegionOrCity().taxLevel / 100;
                var currentTaxPayment = earthTaxAmount * earthTaxRate;

                pendingEarthTax = currentTaxPayment + getRegionOrCity().earthBackTax;

                if(getRegionOrCity().autoBudget && pendingEarthTax < getGameResources()[ColonyGame.meta.tenderResource].amount) {
                    payTax();
                } else {
                    var taxMessage = getString("tax-window-content") + "\n\n" + getString("tax-window-owed-header") + " " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(pendingEarthTax);

                    webAppCore.showDialog({
                        "title":    getString("tax-window-header"),
                        "message":  taxMessage,
                        "op1": {
                            "text":     getString("tax-window-pay"),
                            "func":     payTax
                        },
                        "op2": {
                            "text":     getString("tax-window-reject"),
                            "func":     rejectTax,
                            "color":    "#F44336"
                        }
                    });
                }

                
            }

        }

        if(payrollTurn) {
            var livingWageTotalCost = currentGame.livingWageRate * getTotalPopulation();
            announcePayroll(livingWageTotalCost);
        }

        payrollTurn = false;
        pauseDrawing = false;
    }

    function updateResourceStuff(showDisplay) {

        var resourceUpdateTurn = false;

        checkPreviousCounter++;

        if(checkPreviousCounter >= 500) {
            checkPreviousCounter = 0;
            resourceUpdateTurn = true;
        }

        var visibleResources = 0;

        var gameRes = getGameResources();
        var roc = getRegionOrCity();

        for(var i = 0, len = ColonyGame.resources.length; i < len; i++) {

            var useColor = resourceReadouts[ColonyGame.resources[i].name].readout.style.color;
            var useDisplay = resourceReadouts[ColonyGame.resources[i].name].holder.style.display;
            var useInnerhtml = resourceReadouts[ColonyGame.resources[i].name].readout.innerHTML;
            var useTrend = resourceReadouts[ColonyGame.resources[i].name].trend.src;
            var changerColor = resourceReadouts[ColonyGame.resources[i].name].changer.style.color;

            if(currentGame.readOnlyMode) {
                if(useDisplay != "none") {
                    resourceReadouts[ColonyGame.resources[i].name].holder.style.display = "none";
                }

                continue;
            }

            

            if(!gameRes[ColonyGame.resources[i].name]) {
                gameRes[ColonyGame.resources[i].name] = {};
                gameRes[ColonyGame.resources[i].name].amount = 0;
                gameRes[ColonyGame.resources[i].name].previous = 0;
                gameRes[ColonyGame.resources[i].name].capacity = ColonyGame.resources[i].max;
                gameRes[ColonyGame.resources[i].name].price = ColonyGame.resources[i].basePrice;
                gameRes[ColonyGame.resources[i].name].storageCapacity = 0;
                gameRes[ColonyGame.resources[i].name].domesticCapacity = 0;
                gameRes[ColonyGame.resources[i].name].unlocked = false;
                gameRes[ColonyGame.resources[i].name].serverId = 0;
                gameRes[ColonyGame.resources[i].name].lastTrade = 0;
                gameRes[ColonyGame.resources[i].name].autosell = false;
                gameRes[ColonyGame.resources[i].name].domesticAmount = 0;
            }

            if(gameRes[ColonyGame.resources[i].name].domesticAmount == undefined) {
                gameRes[ColonyGame.resources[i].name].domesticAmount = 0;
            }

            if(gameRes[ColonyGame.resources[i].name].domesticCapacity == undefined) {
                gameRes[ColonyGame.resources[i].name].domesticCapacity = 0;
            }

            if(!gameRes[ColonyGame.resources[i].name].autosell) {
                gameRes[ColonyGame.resources[i].name].autosell = false;
            }

            if(gameRes[ColonyGame.resources[i].name].amount > 0) {
                gameRes[ColonyGame.resources[i].name].unlocked = true;
            }

            if(!gameRes[ColonyGame.resources[i].name].inflows) {
                gameRes[ColonyGame.resources[i].name].inflows = {};
                gameRes[ColonyGame.resources[i].name].inflows.allCurrent = 0;
                gameRes[ColonyGame.resources[i].name].inflows.allTime = 0;
            }

            if(!gameRes[ColonyGame.resources[i].name].outflows) {
                gameRes[ColonyGame.resources[i].name].outflows = {};
                gameRes[ColonyGame.resources[i].name].outflows.allCurrent = 0;
                gameRes[ColonyGame.resources[i].name].outflows.allTime = 0;
            }

            if(gameRes[ColonyGame.resources[i].name].amount < 0) {
                modifyResourceAmount(ColonyGame.resources[i].name,0,true);
            }

            if(isNaN(gameRes[ColonyGame.resources[i].name].price)) {
                gameRes[ColonyGame.resources[i].name].price = ColonyGame.resources[i].basePrice;
            }

            if(isNaN(gameRes[ColonyGame.resources[i].name].amount)) {
                modifyResourceAmount(ColonyGame.resources[i].name,0,true);
            }

            gameRes[ColonyGame.resources[i].name].amount = parseInt(gameRes[ColonyGame.resources[i].name].amount);

            if(ColonyGame.resources[i].name == ColonyGame.meta.colonistsEat) {
                if(gameRes[ColonyGame.resources[i].name].amount == 0) {
                    if(!famineWarned) {
                        famineWarned = true;

                        if(roc.offlineMode) {
                            broadcastLocalTcpMessage(new LocalSocketMessage("starvation",roc.name));
                        } else {
                            postMessageToAllChannels("Starvation in " + roc.name + "!","#F44336");
                        }
                    }
                }

                if(gameRes[ColonyGame.resources[i].name].amount > (gameRes[ColonyGame.resources[i].name].storageCapacity * 0.25)) {
                    famineWarned = false;
                }
            }

            // resource decay 
            if(!roc.offlineMode) {
                if(gameRes[ColonyGame.resources[i].name].capacity == -1 && gameRes[ColonyGame.resources[i].name].amount > gameRes[ColonyGame.resources[i].name].storageCapacity) {
                    var capacityDifference = gameRes[ColonyGame.resources[i].name].amount - gameRes[ColonyGame.resources[i].name].storageCapacity;
                    if(capacityDifference > 2) {
                        capacityDifference = 2;
                        
                        if(gameRes[ColonyGame.resources[i].name].amount < 100000) {
                            capacityDifference = 1;
                        }

                        if(gameRes[ColonyGame.resources[i].name].amount < 10000) {
                            capacityDifference = 0;
                        }

                    }

                    if(capacityDifference < 0) {
                        capacityDifference = 0;
                    }
                
                    if(capacityDifference > 0) {
                        modifyResourceAmount(ColonyGame.resources[i].name,-capacityDifference,false,"Decay");
                    }
                }
            }

            if(ColonyGame.resources[i].name == ColonyGame.meta.colonistsDrink) {
                if(gameRes[ColonyGame.resources[i].name].amount == 0) {
                    if(!noWaterWarned) {
                        noWaterWarned = true;

                        if(!roc.offlineMode) {
                            postMessageToAllChannels(roc.name + " needs " + ColonyGame.resources[i].name + "!","#F44336");
                        }
                    }
                }

                if(gameRes[ColonyGame.resources[i].name].amount > (gameRes[ColonyGame.resources[i].name].storageCapacity * 0.25)) {
                    noWaterWarned = false;
                }
            }

            //abbreviate

            if(shortNumbers && gameRes[ColonyGame.resources[i].name].amount > 9999) {
                var places = undefined;

                if(gameRes[ColonyGame.resources[i].name].amount > 999999) {
                    places = true;
                }

                useInnerhtml = abbreviate(gameRes[ColonyGame.resources[i].name].amount,1,places);
            } else {
                useInnerhtml = numberWithCommas(gameRes[ColonyGame.resources[i].name].amount);
            }

            if(showCapacity && gameRes[ColonyGame.resources[i].name].capacity == -1) {
                var dispCap = numberWithCommas(gameRes[ColonyGame.resources[i].name].storageCapacity);

                if(shortNumbers && gameRes[ColonyGame.resources[i].name].storageCapacity > 9999) {

                    var plc = undefined;

                    if(gameRes[ColonyGame.resources[i].name].storageCapacity > 999999) {
                        plc = true;
                    }

                    dispCap = abbreviate(gameRes[ColonyGame.resources[i].name].storageCapacity,1,plc);
                }

                useInnerhtml += ("/" + dispCap);
            }

            if(desktopMode) {
                useColor = ColonyGame.resources[i].color;
            }

            useDisplay = showDisplay;

            if(!gameRes[ColonyGame.resources[i].name].unlocked) {
                useDisplay = "none";
            }

            var changeReadout = resourceReadouts[ColonyGame.resources[i].name].changer.innerHTML;

            if(resourceUpdateTurn) {
                if(isNaN(gameRes[ColonyGame.resources[i].name].previous)) {
                    gameRes[ColonyGame.resources[i].name].previous = 0;
                } else {
                    changerColor = "#ffffff";

                    var diff = gameRes[ColonyGame.resources[i].name].amount - gameRes[ColonyGame.resources[i].name].previous;
                    if(diff > 0) {
                        useTrend = "images/res-trend-up.png";
                        resourceReadouts[ColonyGame.resources[i].name].isTrendingDown = false;

                        if(desktopMode) {
                            useColor = "#4CAF50";
                        }

                        changeReadout = "+" + diff;
                    }

                    if(diff < 0) {
                        useTrend = "images/res-trend-down.png";
                        resourceReadouts[ColonyGame.resources[i].name].isTrendingDown = true;

                        if(desktopMode) {
                            useColor = "#F44336";
                        }

                        changerColor = "#F44336";

                        changeReadout = diff;
                    }

                    if(diff == 0) {
                        useTrend = "images/res-trend-placeholder.png";
                        resourceReadouts[ColonyGame.resources[i].name].isTrendingDown = false;

                        if(desktopMode) {
                            useColor = "#ffffff";
                        }

                        changeReadout = "";
                    }

                    gameRes[ColonyGame.resources[i].name].previous = gameRes[ColonyGame.resources[i].name].amount;

                    if(ColonyGame.resources[i].max == -1) {
                        if(gameRes[ColonyGame.resources[i].name].amount >= gameRes[ColonyGame.resources[i].name].storageCapacity) {

                            useTrend = "images/res-trend-max.png";
                            resourceReadouts[ColonyGame.resources[i].name].isTrendingDown = false;

                            if(desktopMode) {
                                useColor = "#FFA726";
                            }
                        }
                    }

                    

                    if(ColonyGame.resources[i].name == ColonyGame.meta.gameStageResource) {

                        var justStage = 0;

                        for(var j = 0; j < ColonyGame.meta.gameStages.length; j++) {
                            if(gameRes[ColonyGame.resources[i].name].amount >= ColonyGame.meta.gameStages[j].threshold) {
                                justStage = j;
                            }
                        }

                        if(justStage > roc.stage) {
                            advanceToStage(justStage);
                        }
                    }

                    
                }

                var priceChange = randomIntFromInterval(0,2);
                priceChange--;
                gameRes[ColonyGame.resources[i].name].price += priceChange;

                var priceSwingChange = randomIntFromInterval(0,20);
                if(priceSwingChange == 5) {
                    priceChange = randomIntFromInterval(0,40);
                    priceChange -= 16;
                    gameRes[ColonyGame.resources[i].name].price += priceChange;
                }

                if(gameRes[ColonyGame.resources[i].name].price < 1) {
                    gameRes[ColonyGame.resources[i].name].price = 1;
                }

            }

            if(resourceDisplayMode == 2) {

                if(!resourceReadouts[ColonyGame.resources[i].name].isTrendingDown) {
                    useDisplay = "none";
                } else {
                    if(gameRes[ColonyGame.resources[i].name].amount > (gameRes[ColonyGame.resources[i].name].storageCapacity * 0.95)) {
                        useDisplay = "none";
                    }
                }

            }

            useColor = "#ffffff";

            var resDef = getResourceByDefName(ColonyGame.resources[i].name);

            if(resDef) {
                if(resDef.max == -1) {
                    var fullPercentage = gameRes[ColonyGame.resources[i].name].amount / gameRes[ColonyGame.resources[i].name].storageCapacity;

                    if(fullPercentage > 1) {
                        fullPercentage = 1;
                    }

                    if(fullPercentage < 0) {
                        fullPercentage = 0;
                    }

                    useColor = getColorForPercentage(fullPercentage,[
                        { pct: 0.0, color: { r: 0xf4, g: 0x43, b: 0x36 } },
                        { pct: 0.5, color: { r: 0xff, g: 0xc1, b: 0x07 } },
                        { pct: 1.0, color: { r: 0x4c, g: 0xaf, b: 0x50 } }
                    ]);
                } else {
                    if(resDef.toxicRate) {
                        var toxicPercentage = gameRes[ColonyGame.resources[i].name].amount / resDef.toxicRate;

                        if(toxicPercentage > 1) {
                            toxicPercentage = 1;
                        }
    
                        if(toxicPercentage < 0) {
                            toxicPercentage = 0;
                        }

                        useColor = getColorForPercentage(toxicPercentage,[
                            { pct: 1.0, color: { r: 0x4c, g: 0xaf, b: 0x50 } },
                            { pct: 0.5, color: { r: 0xff, g: 0xc1, b: 0x07 } },
                            { pct: 0.0, color: { r: 0xf4, g: 0x43, b: 0x36 } }
                        ]);
                    }
                }
            }

            if(desktopMode || resourceDisplayMode == 0) {
                //useColor = "#ffffff";
            } else {
                changeReadout = "";
            }

            if(resourceReadouts[ColonyGame.resources[i].name].changer.innerHTML != changeReadout) {
                resourceReadouts[ColonyGame.resources[i].name].changer.innerHTML = changeReadout;
            }

            if(resourceReadouts[ColonyGame.resources[i].name].changer.style.color != changerColor) {
                resourceReadouts[ColonyGame.resources[i].name].changer.style.color = changerColor;
            }

            if(resourceReadouts[ColonyGame.resources[i].name].readout.style.color != useColor) {
                resourceReadouts[ColonyGame.resources[i].name].readout.style.color = useColor;
            }

            if(resourceReadouts[ColonyGame.resources[i].name].holder.style.display != useDisplay) {
                resourceReadouts[ColonyGame.resources[i].name].holder.style.display = useDisplay;
            }

            if(resourceReadouts[ColonyGame.resources[i].name].readout.innerHTML != useInnerhtml) {
                resourceReadouts[ColonyGame.resources[i].name].readout.innerHTML = useInnerhtml;
            }

            if(resourceReadouts[ColonyGame.resources[i].name].trend.src != useTrend) {
                resourceReadouts[ColonyGame.resources[i].name].trend.src = useTrend;
            }


            if(useDisplay != "none") {
                visibleResources++;
            }
        }

        if(resourceUpdateTurn) {
            drawSidebar();
        }

        var useFull = null;
        var useTop = null;

        if(desktopMode && resourceDisplayMode == 0) {
            var useWidth = moneyReadoutPrimary.offsetWidth + 6;
            useFull = "calc(100% - " + useWidth + "px)";
        }

        if(!desktopMode && !gamepadInUse && resourceDisplayMode == 0) {
            useTop = moneyReadout.offsetHeight + "px";
        }

        if(resourceDisplayMode == 0) {

            var timeser = 2;

            if(desktopMode) {
                timeser = 1.5;
            }

            var animationTime = Math.ceil(visibleResources * timeser);

            if(animationTime < 3) {
                animationTime = 6;
            }

            var useAni = "marquee " + animationTime + "s linear infinite";
            
            if(moneyReadoutSecondary.style.animation != useAni) {
                moneyReadoutSecondary.style.animation = useAni;
            }
        }

        if(secondaryItemsAllHolder.style.width != useFull) {
            secondaryItemsAllHolder.style.width = useFull;
        }

        if(topLeftArea.style.top != useTop) {
            topLeftArea.style.top = useTop;
        }
    }

    function updateUtilityDisplays(showDisplay) {

        for(var i = 0; i < ColonyGame.utilities.length; i++) {

            var useDisplay = resourceReadouts[ColonyGame.utilities[i].name].holder.style.display;
            var useColor = resourceReadouts[ColonyGame.utilities[i].name].readout.style.color;
            var useInnerhtml = resourceReadouts[ColonyGame.utilities[i].name].readout.innerHTML;

            if(currentGame.readOnlyMode) {
                if(useDisplay != "none") {
                    resourceReadouts[ColonyGame.utilities[i].name].holder.style.display = "none";
                }

                continue;
            }

            var places = undefined;

            if(getGameUtilities()[ColonyGame.utilities[i].name].capacity > 999999) {
                places = true;
            }

            var dispUsage = numberWithCommas(getGameUtilities()[ColonyGame.utilities[i].name].usage);

            if(shortNumbers) {
                dispUsage = abbreviate(getGameUtilities()[ColonyGame.utilities[i].name].usage,1,places);
            }

            if(showCapacity) {
                var dispCap = numberWithCommas(getGameUtilities()[ColonyGame.utilities[i].name].capacity);

                if(shortNumbers) {
                    dispCap = abbreviate(getGameUtilities()[ColonyGame.utilities[i].name].capacity,1,places);
                }

                dispUsage += ("/" + dispCap);
            }

            useInnerhtml = dispUsage;
            
            if(getGameUtilities()[ColonyGame.utilities[i].name].usage >= getGameUtilities()[ColonyGame.utilities[i].name].capacity) {
                useColor = "#F44336";
            } else {
                useColor = ColonyGame.utilities[i].color;
            }

            
            if(resourceDisplayMode > 0) {
                useDisplay = showDisplay;
            } else {
                if(ColonyGame.resources[i].isEssential) {
                    useDisplay = showDisplay;
                } else {
                    if(getGameUtilities()[ColonyGame.utilities[i].name].usage >= getGameUtilities()[ColonyGame.utilities[i].name].capacity) {
                        useDisplay = showDisplay;
                    } else {
                        useDisplay = "none";
                    }
                }
            }
            

            useDisplay = showDisplay;

            if(resourceReadouts[ColonyGame.utilities[i].name].holder.style.display != useDisplay) {
                resourceReadouts[ColonyGame.utilities[i].name].holder.style.display = useDisplay;
            }

            if(resourceReadouts[ColonyGame.utilities[i].name].readout.style.color != useColor) {
                resourceReadouts[ColonyGame.utilities[i].name].readout.style.color = useColor;
            }

            if(resourceReadouts[ColonyGame.utilities[i].name].readout.innerHTML != useInnerhtml) {
                resourceReadouts[ColonyGame.utilities[i].name].readout.innerHTML = useInnerhtml;
            }

        }
    }

    var resourceStatTickCounter = 2000;

    function doResourceStatTickStuff() {
        resourceStatTickCounter++;

        

        if(resourceStatTickCounter >= 2000) {

            var res2,subRes,sr,subResource;

            resourceStatTickCounter = 0;

            var resources = getGameResources();

            // first, on Region games, calculate resource production/consumption for non-active colonies 
            if(currentGame.isRegion || (currentGame.isSubregion && currentRegion && currentSubcityRef)) {

                var regToUse = currentGame;

                if(currentGame.isSubregion) {
                    regToUse = currentRegion;
                }

                for(var i = 0; i < regToUse.subRegions.length; i++) {
                    sr = regToUse.subRegions[i];

                    if(currentGame.isSubregion && currentSubcityRef == sr) {
                        continue;
                    }

                    if(sr.resourceHistory) {
                        for(subRes in sr.resourceHistory) {
                            subResource = sr.resourceHistory[subRes];

                            if(subResource.avg > 0) {
                                if(resources[subRes].capacity == -1 && resources[subRes].amount > resources[subRes].storageCapacity) {
                                    continue;
                                }
                            }

                            if(sr.naturalResources && sr.naturalResources[subRes] && sr.idleResourcesUsed && sr.idleResourcesUsed[subRes] != undefined) {


                                if(sr.idleResourcesUsed[subRes] >= sr.naturalResources[subRes]) {
                                    continue;
                                }

                                sr.idleResourcesUsed[subRes] += subResource.avg;
                            }

                            modifyResourceAmount(subRes,subResource.avg,false,"Regional." + sr.name);

                            
                        }
                    }
                }
            }

            if(currentGame.isRegion) {
                return;
            }

            

            var totalInflowCost = 0;
            var totalOutflowCost = 0;

            for(var res in resources) {

                if(res == "statResSaveTimestamp") {
                    continue;
                }

                if (!resources[res].trend) {
                    resources[res].trend = [];
                }

                

                if(resources[res].trend.length > 5000) {
                    var newTrend = [];

                    for(var trx = resources[res].trend.length - 500; trx < resources[res].trend.length; trx++) {
                        newTrend.push(resources[res].trend[trx]);
                    }

                    resources[res].trend = newTrend;
                }

                resources[res].trend.push(resources[res].amount);

                while(resources[res].trend.length > 500) {
                    resources[res].trend.shift();
                }

                resources[res].historic = {};
                resources[res].historic.inflows = {};
                resources[res].historic.outflows = {};

                if(resources[res].inflows && resources[res].inflows.current) {

                    
                    

                    resources[res].inflows.allCurrent = 0;

                    for(res2 in resources[res].inflows.current) {

                        if(!resources[res].historic.inflows[res2]) {
                            resources[res].historic.inflows[res2] = 0;
                        }


                        if(res2 != "Trade" && res2 != "Gift" && res2 != "Colonist" && res2 != "Regional" && res2 != "Sale" && !startsWith(res2,"Regional.") && !startsWith(res2,"Research")) {
                            if(parseInt(resources[res].inflows.current[res2]) > 0) {
                                if(currentGame.offlineMode || resources[res].serverId != "0" || res == ColonyGame.meta.tenderResource) {
                                    totalInflowCost += (parseInt(resources[res].inflows.current[res2]) * Math.round(parseInt(resources[res].price) / 100));
                                }
                            }
                        }

                        

                        resources[res].historic.inflows[res2] += resources[res].inflows.current[res2];

                    }
                }

                if(resources[res].outflows && resources[res].outflows.current) {

                    if(parseInt(resources[res].outflows.allCurrent) > 0) {
                        if(currentGame.offlineMode || resources[res].serverId != "0") {
                            totalOutflowCost += (parseInt(resources[res].outflows.allCurrent) * Math.round(parseInt(resources[res].price) / 100));
                        }
                    }

                    resources[res].outflows.allCurrent = 0;

                    for(res2 in resources[res].outflows.current) {

                        if(!resources[res].historic.outflows[res2]) {
                            resources[res].historic.outflows[res2] = 0;
                        }

                        resources[res].historic.outflows[res2] += resources[res].outflows.current[res2];
                    }
                }

                if (!resources[res].inflows) {
                    resources[res].inflows = {};
                }

                if (!resources[res].outflows) {
                    resources[res].outflows = {};
                }

                resources[res].inflows.current = {};
                resources[res].outflows.current = {};

            }

            var netProduct = totalInflowCost - totalOutflowCost;

            if(currentGame.historicStats.priceIndex == undefined) {
                currentGame.historicStats.priceIndex = [];
            }

            if(currentGame.historicStats.newGDP == undefined) {
                currentGame.historicStats.newGDP = [];
            }
            currentGame.historicStats.newGDP.push(totalInflowCost);


            if(currentGame.historicStats.ndp == undefined) {
                currentGame.historicStats.ndp = [];
            }
            currentGame.historicStats.ndp.push(netProduct);


            payrollTurn = false;
            updateHistoricStatistics();

            if(currentGame.isSubregion && currentSubcityRef) {
                if(!currentSubcityRef.resourceHistory) {
                    currentSubcityRef.resourceHistory = {};
                }
    
                for(subRes in currentSubcityRef.resourceHistory) {
                    var trend = currentSubcityRef.resourceHistory[subRes].in - currentSubcityRef.resourceHistory[subRes].out;
                    var trendArray = currentSubcityRef.resourceHistory[subRes].trend;
    
                    trendArray.push(trend);
    
                    while(trendArray.length > 10) {
                        trendArray.shift();
                    }
    
                    currentSubcityRef.resourceHistory[subRes].in = 0;
                    currentSubcityRef.resourceHistory[subRes].out = 0;

                    var trendCount = trendArray.length;
                    var trendTotal = 0;

                    for(var t = 0; t < trendCount; t++) {
                        trendTotal += trendArray[t];
                    }

                    var avg = Math.round(trendTotal / trendCount);
                    currentSubcityRef.resourceHistory[subRes].avg = avg;
                }
            }
        }

        
        
    }

    function millisecondsToTimeReadout(ms) {
        var x = ms / 1000;
        var seconds = x % 60;
        x /= 60;
        var minutes = x % 60;
        x /= 60;
        var hours = x % 24;
        x /= 24;
        var days = x;

        var result = "";

        if(days > 0) {
            result += Math.floor(days) + " days, ";
        }

        if(hours > 0) {
            result += Math.floor(hours) + " hours, ";
        }

        if(minutes > 0) {
            result += Math.floor(minutes) + " minutes, ";
        }

        result += Math.floor(seconds) + " seconds.";

        return result;
    }

    function updateHistoricStatistics() {
        // important for stats!
        // Decided that one game year is 60 iterations of doResourceStatTickStuff() 
        // 120,000 game ticks.
        // Depending on CPU, this is roughly one hour of play time.

        if(currentGame.historicStats.newGDP == undefined) {
            currentGame.historicStats.newGDP = [];
        }

        if(currentGame.historicStats.priceIndex == undefined) {
            currentGame.historicStats.priceIndex = [];
        }

        if(currentGame.historicStats.ndp == undefined) {
            currentGame.historicStats.ndp = [];
        }

        if(currentGame.historicStats.gdpGrowth == undefined) {
            currentGame.historicStats.gdpGrowth = [];
        }

        if(currentGame.historicStats.gdpGrowthQuarterly == undefined) {
            currentGame.historicStats.gdpGrowthQuarterly = [];
        }

        if(currentGame.historicStats.gdpGrowthAnnually == undefined) {
            currentGame.historicStats.gdpGrowthAnnually = [];
        }

        if(currentGame.historicStats.gdpQuarterlyAdjusted == undefined) {
            currentGame.historicStats.gdpQuarterlyAdjusted = [];
        }

        if(currentGame.historicStats.gdpAnuallyAdjusted == undefined) {
            currentGame.historicStats.gdpAnuallyAdjusted = [];
        }

        if(currentGame.historicStats.priceIndexAnualBasis == undefined) {
            currentGame.historicStats.priceIndexAnualBasis = [];
        }

        var totalColonists = getTotalPopulation();
        var unemployed = 0;

        var i,def;

        var totalJobs = 0;
        var totalWorkforce = 0;


        var totalApproval = 0;
        var actualApproval = 0;

        var totalHealth = 0;

        var totalAge = 0;
        var totalSavings = 0;

        var totalIQ = 0;
        var iqPeople = 0;



        var bld;

        for(var age in currentGame.populationDistribution) {
            totalAge += (currentGame.populationDistribution[age] * parseInt(age));
        }

        totalAge = Math.round(totalAge / 12);



        var lastApproval = 100;


        if(currentGame.historicStats.approval && currentGame.historicStats.approval.length > 0) {
            lastApproval = currentGame.historicStats.approval[currentGame.historicStats.approval.length - 1] / 100;
        }

        currentGame.sadderReasons = {
            "Depression": 0,
            "Homelessness": 0,
            "Poverty": 0,
            "Fatigue": 0,
            "Health": 0,
            "Unemployment": 0,
            "Uneducated": 0,
            "Crime": 0
        };
        

        for(i = 0; i < currentGame.buildings.length; i++) {

            bld = currentGame.buildings[i];

            if(!bld) {
                continue;
            }

            def = getBuildingDefByName(bld.def);

            // possibly add to kill array
            if(!def) {
                continue;
            }

            if(!def.isEmbassy && !bld.iuc && def.acceptsWorkers && !bld.deactivated) {
                totalJobs += def.acceptsWorkers;


                totalWorkforce += bld.buW;
            }

            totalHealth += (bld.brM * bld.bRC);
            

            if(def.providesShelter > 0 && bld.bRC > 0) {
                if(!bld.orIQ) {
                    bld.orIQ = 75;
                }

                totalIQ += (bld.bRC * bld.orIQ);
                iqPeople += bld.bRC;

                actualApproval += (bld.bRC * bld.bRLV);
                totalApproval += (bld.bRC * 100);

                totalSavings += bld.bsTS;
 
                if(bld.brE < lastApproval) {
                    currentGame.sadderReasons.Depression += bld.bRC;
                }

                if(bld.brCT < lastApproval) {
                    currentGame.sadderReasons.Fatigue += bld.bRC;
                }

                if(bld.brM < lastApproval) {
                    currentGame.sadderReasons.Health += bld.bRC;
                }

                if(bld.brSAF < lastApproval) {
                    currentGame.sadderReasons.Crime += bld.bRC;
                }

                if(bld.brS < lastApproval) {
                    currentGame.sadderReasons.Uneducated += bld.bRC;
                }
            }

        }

        var approvalRating = Math.round((actualApproval / totalApproval) * 100);

        var workingPopulation = getTotalPopulation();

        var averageHealth = Math.round(totalHealth / workingPopulation);


        if(totalWorkforce > totalJobs) {
            totalWorkforce = totalJobs;
        }

        
        workingPopulation -= getMinorPopulation();
        workingPopulation -= getRetiredPop();

        if(totalWorkforce > workingPopulation) {
            totalWorkforce = workingPopulation;
        }

        unemployed = (workingPopulation - totalWorkforce);

        if(unemployed < 0) {
            unemployed = 0;
        }

        var unemployedPercent = ((unemployed / workingPopulation) * 100).toFixed(1);

        var totalHomeless = runningHomelessCount;

        if(totalHomeless < 0) {
            totalHomeless = 0;
        }

        if(totalHomeless > totalColonists) {
            totalHomeless = totalColonists;
        }

        var homelessPercent = Math.round((totalHomeless / totalColonists) * 100);



        var averageAge = Math.round(totalAge / totalColonists);

        totalSavings += currentGame.livingWageRate * totalColonists;

        var averageSavings = Math.round(totalSavings / totalColonists);

        averageSavings *= 12;


        var averageIQ = Math.round(totalIQ / iqPeople);




        var totalGDP = 0;

        var startingPoint = 0;

        // total gdp is now the sum of the last 60 industrial output measures
        if(currentGame.historicStats.newGDP.length > 60) {
            startingPoint = currentGame.historicStats.newGDP.length - 60;
        }

        for(i = startingPoint; i < currentGame.historicStats.newGDP.length; i++) {
            totalGDP += parseInt(currentGame.historicStats.newGDP[i]);
        }

        // if we do not have a full year of data compiled yet, just extrapolate it out
        if(currentGame.historicStats.newGDP.length < 60) {
            var whatPercentDone = currentGame.historicStats.newGDP.length / 60;
            totalGDP = Math.round(totalGDP / whatPercentDone);
        }

        

        currentGame.period++;

        if(currentGame.period >= 60) {
            currentGame.year++;
            currentGame.period = 0;
        }

        // at the beginning of a new year, print the previous years gdp growth
        if(currentGame.period == 0) {

            currentGame.historicStats.priceIndexAnualBasis.push(parseInt(gotItMadePrice));
            currentGame.historicStats.gdpGrowthAnnually.push(totalGDP);

            var priceDeflatorAnn = 0;

            if(currentGame.historicStats.priceIndexAnualBasis.length > 1) {
                var lastPriceAnn = currentGame.historicStats.priceIndexAnualBasis[currentGame.historicStats.priceIndexAnualBasis.length - 2];
                priceDeflatorAnn = findIncrease(lastPriceAnn,gotItMadePrice);
            }

            if(currentGame.historicStats.gdpGrowthAnnually.length > 1) {
                var lastPeriodAnn = currentGame.historicStats.gdpGrowthAnnually[currentGame.historicStats.gdpGrowthAnnually.length - 2];
                var annualChange = findIncrease(lastPeriodAnn,totalGDP);

                var adjustedGDPAnn = annualChange - priceDeflatorAnn;

                currentGame.historicStats.gdpAnuallyAdjusted.push(parseFloat(adjustedGDPAnn.toFixed(1)));
            }

        }

        var quarterlyGDP = 0;

        // durring the appropriate period times, get the quarterly gdp
        if(currentGame.period == 0 || currentGame.period == 15 || currentGame.period == 30 || currentGame.period == 45) {
            if(currentGame.historicStats.newGDP.length > 15) {
                // add up the last 15 GDP prints, which represents a quarter
                startingPoint = currentGame.historicStats.newGDP.length - 15;
                
                for(i = startingPoint; i < currentGame.historicStats.newGDP.length; i++) {
                    quarterlyGDP += parseInt(currentGame.historicStats.newGDP[i]);
                }
                currentGame.historicStats.gdpGrowthQuarterly.push(quarterlyGDP);
                currentGame.historicStats.priceIndex.push(parseInt(gotItMadePrice));

                var priceDeflator = 0;

                if(currentGame.historicStats.priceIndex.length > 1) {
                    var lastPrice = currentGame.historicStats.priceIndex[currentGame.historicStats.priceIndex.length - 2];

                    priceDeflator = findIncrease(lastPrice,gotItMadePrice);

                }

                if(currentGame.historicStats.gdpGrowthQuarterly.length > 1) {
                    var lastPeriod = currentGame.historicStats.gdpGrowthQuarterly[currentGame.historicStats.gdpGrowthQuarterly.length - 2];
                    var quarterlyChange = findIncrease(lastPeriod,quarterlyGDP);

                    var adjustedGDP = quarterlyChange - priceDeflator;

                    currentGame.historicStats.gdpQuarterlyAdjusted.push(parseFloat(adjustedGDP.toFixed(1)));

                    announceQuarterlyGDPPrint(adjustedGDP);
                }

                
            }
        }

        // work trade balances 
        getRegionOrCity().importExportTrend.push({
            profit: getRegionOrCity().annualTradeIncome,
            loss: getRegionOrCity().annualTradeLosses
        });

        getRegionOrCity().annualTradeIncome = 0;
        getRegionOrCity().annualTradeLosses = 0;

        // set stats for the subregion, if necessary
        if(currentGame.isSubregion && currentSubcityRef) {
            currentSubcityRef.unemploymentRate = unemployedPercent;
            currentSubcityRef.totalGDP = totalGDP;
        }

        // regional gdp calculations
        if(currentGame.isSubregion && currentRegion) {
            currentRegion.period++;

            if(currentRegion.period >= 60) {
                currentRegion.year++;
                currentRegion.period = 0;
            }

            var regionTotalGDP = 0;
            var totalPop = 0;
            var totalUnemployed = 0;

            for(i = 0; i < currentRegion.subRegions.length; i++) {
                if(currentRegion.subRegions[i].totalGDP) {
                    regionTotalGDP += parseInt(currentRegion.subRegions[i].totalGDP);
                }

                var citypop = parseInt(currentRegion.subRegions[i].population);

                if(currentRegion.subRegions[i].unemploymentRate) {
                    totalPop += citypop;
                    totalUnemployed += Math.round(citypop * (currentRegion.subRegions[i].unemploymentRate / 100));
                }
                
            }

            var unemRte = ((totalUnemployed / totalPop) * 100).toFixed(1);

            currentRegion.regionalGDPTrend.push(regionTotalGDP);
            currentRegion.regionalUnemploymentTrend.push(unemRte);

            // at the beginning of a new year, print the previous years gdp growth
            if(currentRegion.period == 0) {
                currentRegion.regionalGDPGrowthAnnually.push(regionTotalGDP);
                currentRegion.regionalPriceIndexAnnual.push(gotItMadePrice);

                var regPriceDeflator = 0;

                if(currentRegion.regionalPriceIndexAnnual.length > 1) {
                    var lastRegPrice = currentRegion.regionalPriceIndexAnnual[currentRegion.regionalPriceIndexAnnual.length - 2];
                    regPriceDeflator = findIncrease(lastRegPrice,gotItMadePrice);


                    if(currentRegion.regionalGDPGrowthAnnually.length > 1) {
                        var lastRegPeriod = currentRegion.regionalGDPGrowthAnnually[currentRegion.regionalGDPGrowthAnnually.length - 2];
                        var annRegChange = findIncrease(lastRegPeriod,quarterlyGDP);
    
                        var adjustedRegGDP = annRegChange - regPriceDeflator;

                        currentRegion.regionalGDPAnuallyhQuarterlyAdjusted.push(parseFloat(adjustedRegGDP.toFixed(1)));

                        announceRegionAnnualGDP(adjustedRegGDP);
                    }
                }
            }

            while(currentRegion.regionalGDPAnuallyhQuarterlyAdjusted.length > STAT_DATA_RETENTION_AMOUNT) {
                currentRegion.regionalGDPAnuallyhQuarterlyAdjusted.shift();
            }

            while(currentRegion.regionalGDPTrend.length > STAT_DATA_RETENTION_AMOUNT) {
                currentRegion.regionalGDPTrend.shift();
            }

            while(currentRegion.regionalUnemploymentTrend.length > STAT_DATA_RETENTION_AMOUNT) {
                currentRegion.regionalUnemploymentTrend.shift();
            }

            while(currentRegion.regionalGDPGrowthAnnually.length > STAT_DATA_RETENTION_AMOUNT) {
                currentRegion.regionalGDPGrowthAnnually.shift();
            }
        }

        while(getRegionOrCity().importExportTrend.length > STAT_DATA_RETENTION_AMOUNT) {
            getRegionOrCity().importExportTrend.shift();
        }

        while(currentGame.historicStats.newGDP.length > STAT_DATA_RETENTION_AMOUNT) {
            currentGame.historicStats.newGDP.shift();
        }

        while(currentGame.historicStats.priceIndex.length > STAT_DATA_RETENTION_AMOUNT) {
            currentGame.historicStats.priceIndex.shift();
        }

        while(currentGame.historicStats.ndp.length > STAT_DATA_RETENTION_AMOUNT) {
            currentGame.historicStats.ndp.shift();
        }

        while(currentGame.historicStats.gdpGrowth.length > STAT_DATA_RETENTION_AMOUNT) {
            currentGame.historicStats.gdpGrowth.shift();
        }

        while(currentGame.historicStats.gdpGrowthQuarterly.length > STAT_DATA_RETENTION_AMOUNT) {
            currentGame.historicStats.gdpGrowthQuarterly.shift();
        }

        while(currentGame.historicStats.gdpGrowthAnnually.length > STAT_DATA_RETENTION_AMOUNT) {
            currentGame.historicStats.gdpGrowthAnnually.shift();
        }

        while(currentGame.historicStats.gdpQuarterlyAdjusted.length > STAT_DATA_RETENTION_AMOUNT) {
            currentGame.historicStats.gdpQuarterlyAdjusted.shift();
        }

        while(currentGame.historicStats.gdpAnuallyAdjusted.length > STAT_DATA_RETENTION_AMOUNT) {
            currentGame.historicStats.gdpAnuallyAdjusted.shift();
        }

        while(currentGame.historicStats.priceIndexAnualBasis.length > STAT_DATA_RETENTION_AMOUNT) {
            currentGame.historicStats.priceIndexAnualBasis.shift();
        }

        currentGame.historicStats.population.push(totalColonists);
        currentGame.historicStats.age.push(averageAge);
        //currentGame.historicStats.savings.push(averageSavings);
        currentGame.historicStats.gdp.push(totalGDP);
        currentGame.historicStats.unemployment.push(unemployedPercent);
        currentGame.historicStats.jobs.push(totalJobs);


        // check for modifications on stats 
        if(currentGame.statMods) {
            if(currentGame.statMods.health) {
                averageHealth += currentGame.statMods.health;

                if(averageHealth > 100) {
                    averageHealth = 100;
                }

                if(averageHealth < 0) {
                    averageHealth = 0;
                }
            }

            if(currentGame.statMods.approval) {
                approvalRating += currentGame.statMods.approval;

                if(approvalRating > 100) {
                    approvalRating = 100;
                }

                if(approvalRating < 0) {
                    approvalRating = 0;
                }
            }
        }

        if(!isNaN(averageHealth)) {
            if(averageHealth > 0 || currentGame.historicStats.health.length == 0) {
                currentGame.historicStats.health.push(averageHealth);
            }
        }
        
        currentGame.historicStats.iq.push(averageIQ);
        currentGame.historicStats.homeless.push(homelessPercent);

        

        if(getTotalPopulation() == 0) {
            approvalRating = 100;
        }

        currentGame.historicStats.approval.push(approvalRating);

        if(currentGame.historicStats.workforce == undefined) {
            currentGame.historicStats.workforce = [];
        }

        if(currentGame.historicStats.mediansalary == undefined) {
            currentGame.historicStats.mediansalary = [];
        }

        if(currentGame.historicStats.retiredpop == undefined) {
            currentGame.historicStats.retiredpop = [];
        }

        if(currentGame.historicStats.students == undefined) {
            currentGame.historicStats.students = [];
        }

        currentGame.historicStats.mediansalary.push(Math.round(averageSavings));
        currentGame.historicStats.retiredpop.push(getRetiredPop());
        currentGame.historicStats.workforce.push(totalWorkforce);
        currentGame.historicStats.students.push(getMinorPopulation());

        if(!currentGame.monthTicker) {
            currentGame.monthTicker = 0;
        }

        currentGame.monthTicker++;

        if(currentGame.monthTicker >= 5) {
            ageAllColonists();
            currentGame.monthTicker = 0;
            payrollTurn = true;
        } else {
            payrollTurn = false;
        }

        if(averageHealth < 25 && totalColonists > 50) {
            var saySomethingChance = randomIntFromInterval(0,2);

            if(saySomethingChance == 1) {
                addItemToNewsTicker(getString("health-crisis-warning"),"#e53935",function() {
                    showColonistsMenu("population");
                },true,1,true);
            }
        }
        

        for(var stat in currentGame.historicStats) {
            if(Array.isArray(currentGame.historicStats[stat])) {
                while(currentGame.historicStats[stat].length > STAT_DATA_RETENTION_AMOUNT) {
                    currentGame.historicStats[stat].shift();
                }
            }
        }

        // emmigration chance
        var emmigrantChance = randomIntFromInterval(0,100);
        if(emmigrantChance > approvalRating) {
            var possibleAges = [];

            for(var ageitem in currentGame.populationDistribution) {
                if(currentGame.populationDistribution[ageitem] > 0) {
                    possibleAges.push(ageitem);
                } 
            }

            if(possibleAges.length > 0) {
                var ageItemToUse = possibleAges[randomIntFromInterval(0,possibleAges.length - 1)];
                putColonistIntoStargate(ageItemToUse);
            }
            
        }

        if (!currentGame.offlineMode) {
            gatherForColoniae();
        }
    }

    function announcePayroll(livingWage) {

        if(!livingWage) {
            livingWage = 0;
        }

        var roc = getRegionOrCity();

        if(!roc) {
            return;
        }

        var totalSalary = 0;
        var bld;

        var killBlds = [];

        for(var i = 0; i < currentGame.buildings.length; i++) {
            bld = currentGame.buildings[i];

            if(!bld) {
                killBlds.push(bld);
                continue;
            }

            totalSalary += bld.bsTS;
        }

        while(killBlds.length > 0) {
            removeFromArray(currentGame.buildings,killBlds.pop());
        }

        var salary = totalSalary + livingWage;

        if(roc.autoBudget && salary < getGameResources()[ColonyGame.meta.tenderResource].amount) {
            payPayroll(salary);
            return;
        }


        var readoutSalary = getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(salary);

        var taxMessage = getString("payroll-notice").replace("#payrollcost",readoutSalary);

        if(!roc.isIndependent) {

            var motherlandPortion = Math.round(salary * roc.payrollRate);
            var motherlandPortionString =  getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(motherlandPortion);

            var addition = getString("payroll-motherland").replace("#motheroffset",motherlandPortionString);
            taxMessage = taxMessage + "\n\n" + addition;
        }

        webAppCore.showDialog({
            "title":    getString("general-payroll"),
            "message":  taxMessage,
            "op1": {
                "text":     getString("tax-window-pay"),
                "func":     function(){
                    payPayroll(salary);
                }
            },
            "op2": {
                "text":     getString("tax-window-reject"),
                "func":     function() {
                    webAppCore.showDialog({
                        "title":    getString("general-payroll"),
                        "message":  getString("payroll-reject"),
                        "op1": {
                            "text":     getString("tax-window-pay"),
                            "func":     function(){
                                payPayroll(salary);
                            }
                        },
                        "op2": {
                            "text":     getString("general-dismiss"),
                            "func":     rejectPayrollFinal,
                            "color":    "#F44336"
                        }
                    });
                },
                "color":    "#F44336"
            }
        });
        
    }

    

    function rejectPayrollFinal() {

        if(currentGame == null) {
            return;
        }

        getRegionOrCity().monthEndCounter = 30000;



        if(!getRegionOrCity().offlineMode && usingSockets) {
            postMessageToAllChannels(getRegionOrCity().name + " is not paying workers!","#F44336");
        }
    }

    function payPayroll(totalsalary) {

        if(currentGame == null) {
            return;
        }

        var totalPaid = 0;
        var missedPayments = 0;

        if(!totalsalary) {
            totalsalary = 0;
        }

        var gameRes = getGameResources();
        var rOrS = getRegionOrCity();

        if(gameRes[ColonyGame.meta.tenderResource].amount > totalsalary) {
            modifyResourceAmount(ColonyGame.meta.tenderResource,-totalsalary,false,"Wages");
            totalPaid = totalsalary;
        } else {
            totalPaid = totalsalary - gameRes[ColonyGame.meta.tenderResource].amount;
            modifyResourceAmount(ColonyGame.meta.tenderResource,-totalPaid,false,"Wages");
        }

        missedPayments = totalsalary - totalPaid;

        var averageSavings = Math.round(totalPaid / getTotalPopulation());
        averageSavings *= 12;

        currentGame.historicStats.savings.push(averageSavings);

        if(missedPayments > 0) {
            webAppCore.showDialog({
                "title":    getString("general-payroll"),
                "message":  getString("payroll-insufficient"),
                "op1": {
                    "text":     getString("general-dismiss"),
                    "func":     placeholder
                }
            });
        } else {
            webAppCore.showToast("You paid " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(totalPaid) + " in payroll costs!");
        }

        if(!rOrS.isIndependent) {
            var motherlandAmount = Math.round(totalPaid * rOrS.payrollRate);

            if(motherlandAmount > 0) {
                if(parseInt(rOrS.motherlandid) < 100 || rOrS.offlineMode) {
                    rOrS.gifts.push(new Gift(getString("general-payroll"),getString("payroll-motherland-collect"),ColonyGame.meta.tenderResource,motherlandAmount));
                    webAppCore.showToast("New gifts available!");
                    document.getElementById("imGift").style.display = "inline-block";
                } else {
                    sendForMotherlandPayrollPayment(motherlandAmount);
                }
            }
        }

    }

    var pendingEarthTax;

    function payTax() {

        var rOrS = getRegionOrCity();
        var gRes = getGameResources();

        if(rOrS == null) {
            return;
        }

        rOrS.earthBackTax = 0;
        rOrS.earthAssemblyRelations += 2;

        if(rOrS.earthAssemblyRelations > 100) {
            rOrS.earthAssemblyRelations = 100;
        }

        if(pendingEarthTax > gRes[ColonyGame.meta.tenderResource].amount) {

            rOrS.motherlandTaxesPaid += gRes[ColonyGame.meta.tenderResource].amount;

            sendTaxPayment(gRes[ColonyGame.meta.tenderResource].amount);

            var difference = pendingEarthTax - gRes[ColonyGame.meta.tenderResource].amount;
            modifyResourceAmount(ColonyGame.meta.tenderResource,0,true,"Tax");

            rOrS.earthBackTax = difference;
            rOrS.earthAssemblyRelations -= 4;

            if(rOrS.earthAssemblyRelations < 0) {
                rOrS.earthAssemblyRelations = 0;
            }

            webAppCore.showDialog({
                "title":    getString("tax-window-header"),
                "message":  getString("tax-payment-insufficient")
            });

        } else {

            rOrS.earthAssemblyRelations += 23;
            rOrS.motherlandTaxesPaid += pendingEarthTax;

            sendTaxPayment(pendingEarthTax);


            modifyResourceAmount(ColonyGame.meta.tenderResource,-pendingEarthTax,false,"Tax");

            if(rOrS.earthAssemblyRelations >= 75 && rOrS.tradeEmbargo) {

                rOrS.tradeEmbargo = false;

                webAppCore.showDialog({
                    "title":    getString("tax-window-header"),
                    "message":  getString("tax-window-lift-embargo")
                });
                
                return;
            }

            if(rOrS.earthAssemblyRelations >= 50 && rOrS.immigrationEmbargo) {
                rOrS.immigrationEmbargo = false;

                webAppCore.showDialog({
                    "title":    getString("tax-window-header"),
                    "message":  getString("tax-window-img-lift")
                });

                return;
            }

            if(rOrS.autoBudget) {
                webAppCore.showToast("Paid " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(pendingEarthTax) + " in taxes.");
            } else {
                webAppCore.showDialog({
                    "title":    getString("tax-window-header"),
                    "message":  getString("tax-payment-thankyou")
                });
            }
        }
    }

    function rejectTax() {

        var rOrS = getRegionOrCity();

        if(rOrS == null) {
            return;
        }

        rOrS.earthBackTax = pendingEarthTax;
        rOrS.earthAssemblyRelations -= 6;

        if(rOrS.earthAssemblyRelations < 0) {
            rOrS.earthAssemblyRelations = 0;
        }

        if(rOrS.earthAssemblyRelations < 75 && !rOrS.tradeEmbargo) {
            rOrS.tradeEmbargo = true;

            webAppCore.showDialog({
                "title":    getString("tax-window-header"),
                "message":  getString("tax-window-trade-embargo")
            });

            return;
        }

        if(rOrS.earthAssemblyRelations < 50 && !rOrS.immigrationEmbargo) {
            rOrS.immigrationEmbargo = true;

            webAppCore.showDialog({
                "title":    getString("tax-window-header"),
                "message":  getString("tax-window-img-embargo")
            });

            return;
        }

        webAppCore.showDialog({
            "title":    getString("tax-window-header"),
            "message":  getString("tax-window-reject-response")
        });
    }

    var workingMapType = null;

    function setMapType() {
        if(getRegionOrCity() == null) {
            return;
        }

        for(var i = 0; i < ColonyGame.mapTypes.length; i++) {
            if(ColonyGame.mapTypes[i].name == getRegionOrCity().mapType) {
                workingMapType = ColonyGame.mapTypes[i];
            }
        }
    }

    function onViewportChange() {
        currentViewBounds = Scroll2d.getViewBounds();
    }

    var staticFrame = false;
    var renderFullAtNextDraw = false;

    function findIncrease(num1,num2) {
        return ((num2 - num1) / num1 * 100);
    }
    
    function draw(fullMapRender) {
        
        if(!currentGame) {
            return;
        }

        if(killSwitch || pauseDrawing || inBackgroundMode) {
            return;
        }

        if(currentViewBounds == null) {
            return;
        }

        var roc = getRegionOrCity();

        if(!roc) {
            return;
        }

        staticFrame = !staticFrame;

        var i,x,y;
        var msX = currentViewBounds.minX;
        var msY = currentViewBounds.minY;
        var masX = currentViewBounds.maxX;
        var masY = currentViewBounds.maxY;

        if(fullMapRender) {
            msX = 0;
            msY = 0;
            masX = currentGame.width;
            masY = currentGame.height;
            renderFullAtNextDraw = true;
            staticFrame = true;
        } else {
            renderFullAtNextDraw = false;
        }

        var useGround = workingMapType.groundTile[roc.stage];
        
        if(currentGame.isRegion && workingMapType.regionGroundTile) {
            useGround = workingMapType.regionGroundTile[roc.stage];
        }

        var shoreGround = null;

        if(!currentGame.isRegion && workingMapType && workingMapType.groundShoreSheet && workingMapType.groundShoreConnectors && workingMapType.groundShoreConnectors.length > 0) {
            shoreGround = workingMapType.groundShoreSheet[roc.stage];
        }

        var useSheet = useGround;
        var useFrame = 0;

        Scroll2d.drawLine("#01579B",0,0,currentGame.width + 1,0);
        Scroll2d.drawLine("#01579B",currentGame.width + 1,0,currentGame.width + 1,currentGame.height + 1);
        Scroll2d.drawLine("#01579B",currentGame.width + 1,currentGame.height + 1,0,currentGame.height + 1);
        Scroll2d.drawLine("#01579B",0,currentGame.height + 1,0,0);

        var ourGroundImage = getImageAsset(useSheet,false,useFrame,null);

        var shoreImage = null;

        if(ourGroundImage) {
            if(workingMapType != null) {
                for(x = msX; x <= masX; x++) {
                    for(y = msY; y <= masY; y++) {

                        if(shoreGround && overallShoreMap && overallShoreMap[x] && overallShoreMap[x][y] > -1) {
                            shoreImage = getImageAsset(shoreGround,false,overallShoreMap[x][y],null);

                            if(shoreImage) {
                                Scroll2d.drawStaticTile(shoreImage,x,y,0);
                            }
                        } else {
                            Scroll2d.drawStaticTile(ourGroundImage,x,y,0);
                        }

                        
                    }
                }
            }
        }

        if(currentGame.isSubregion) {
            for(x = 0; x < currentGame.width + 1; x++) {
                Scroll2d.drawSquare("rgba(0,255,0,.2)",x,-1);
                Scroll2d.drawSquare("rgba(0,255,0,.2)",x,currentGame.height + 1);
            }

            for(y = 0; y < currentGame.height + 1; y++) {
                Scroll2d.drawSquare("rgba(0,255,0,.2)",-1,y);
                Scroll2d.drawSquare("rgba(0,255,0,.2)",currentGame.width + 1,y);
            }

        }

        var nonUpdatableToDraw;

        for(i = 0; i < currentGame.passableNonUpdatables.length; i++) {

            nonUpdatableToDraw = currentGame.passableNonUpdatables[i];

            drawBuilding(nonUpdatableToDraw,false,"passable");
        }

        var mapResToDraw;
        
        
        for(i = 0; i < currentGame.mapResources.length; i++) {

            mapResToDraw = currentGame.mapResources[i];

            drawBuilding(mapResToDraw,true,"resource");
        }

        // finished passable items 
        for(var passdef in currentGame.finishedPassableNonUpdatables) {
            var td = currentGame.finishedPassableNonUpdatables[passdef];
            for(var passX in td) {
                var tx = td[passX];
                for(var ty = 0; ty < tx.length; ty++) {
                    var passY = tx[ty];
                    drawNewPassable(passdef,parseInt(passX),parseInt(passY));
                }
            }
        }
        
        if(queuedBuildings != null && queuedBuildings.length > 0 && queuedBuilding != null) {
            for(i = 0; i < queuedBuildings.length; i++) {
                drawPendingBuilding(queuedBuildings[i].x,queuedBuildings[i].y,"#2196F3",true);
            }
        }

        if(touchPossibleBuildPoints != null && queuedBuilding != null) {
            for(i = 0; i < touchPossibleBuildPoints.length; i++) {
                Scroll2d.drawSquare("rgba(0,255,0,.2)",touchPossibleBuildPoints[i].x,touchPossibleBuildPoints[i].y,2);
            }
        }

        if(chainQueue!= null && queuedBuilding != null) {
            for(i = 0; i < chainQueue.length; i++) {
                drawPendingBuilding(chainQueue[i].x,chainQueue[i].y,"#03A9F4",false);
            }
        }

        if(currentGame.mem && ColonyGame.meta.mapEditorStartFlagAsset != null) {

            var flapSprite = getImageAsset(ColonyGame.meta.mapEditorStartFlagAsset,false,0,false);

            if(flapSprite) {
                Scroll2d.drawSprite(flapSprite,currentGame.mestartx,currentGame.mestarty,null,null,0,null,null,1,10);
            }
        }
        
        

        if(usingMouse) {

            var hoverColor = "rgba(0,0,0,.4)";

            if(inMultiSelectionMode) {
                hoverColor = "rgba(0,255,0,.4)";
            } else {
                if(hoverPassable) {
                    if(queuedMove != null || queuedPark != null) {
                        hoverColor = "rgba(255,255,255,.4)";
                    } else {
                        hoverColor = "rgba(0,0,0,.4)";
                    }
                    
                } else {
                    hoverColor = "rgba(255,0,0,.4)";
                }
            }

            if(bulldozerMode) {
                hoverColor = "rgba(255,0,0,.6)";
            }

            if(currentGame.isRegion && currentHoverCity != null && pendingSubcitySize == 0) {

                if(bulldozerMode) {
                    hoverColor = "rgba(255,0,0,.4)";
                    Scroll2d.drawSquare(hoverColor,currentHoverCity.x,currentHoverCity.y,2);
                }

            } else {
                Scroll2d.drawSquare(hoverColor,hoverX,hoverY,2);
            }

            
        }
        
        if(selectedVehicle.length > 0) {
            for(i = 0; i < selectedVehicle.length; i++) {
                

                if(selectedVehicle[i].x != selectedVehicle[i].dX || selectedVehicle[i].y != selectedVehicle[i].dY) {
                    Scroll2d.drawLine("#4CAF50",selectedVehicle[i].x,selectedVehicle[i].y,selectedVehicle[i].dX,selectedVehicle[i].dY,1,true);
                }

                if(selectedVehicle[i].pd != null) {
                    for(var oX = 0; oX < selectedVehicle[i].pd.tileWidth; oX++) {
                        for(var oY = 0; oY < selectedVehicle[i].pd.tileHeight; oY++) {
                            var useX = selectedVehicle[i].x + oX;
                            var useY = selectedVehicle[i].y + oY;

                            if(isTilePassable(useX,useY,true,false)) {
                                Scroll2d.drawSquare("rgba(0,255,0,.6)",useX,useY,2);
                            } else {
                                Scroll2d.drawSquare("rgba(255,0,0,.6)",useX,useY,2);
                            }
                        }
                    }
                } else {
                    Scroll2d.drawSquare("rgba(0,0,255,.6)",selectedVehicle[i].x,selectedVehicle[i].y,2);
                }
            }
        }
        
        if (selectedBuilding != null) {

            if(selectedBuilding.occupiesTiles != null) {
                for(i = 0; i < selectedBuilding.occupiesTiles.length; i++) {
                    Scroll2d.drawSquare("rgba(0,0,255,.6)",selectedBuilding.occupiesTiles[i].x,selectedBuilding.occupiesTiles[i].y,2);
                }
            }

        }

        if(currentGame.isRegion) {

            var allRegionTiles = [];
            var theme = hexToColor(currentGame.themeColor);
            var themergba = "rgba(" + theme.r + "," + theme.g + "," + theme.b + ",.25)";
            var sX,sY,usX,usY;

            var filledRegionSpots = {};

            for(i = 0; i < currentGame.subRegions.length; i++) {
                var sr = currentGame.subRegions[i];

                var useSize = 1;
                var tileSize = ColonyGame.meta.gridSize;

                allRegionTiles.push({
                    x: sr.x,
                    y: sr.y
                });

                if(currentHoverCity && currentHoverCity.metroAreaDistrict == sr.metroAreaDistrict) {
                    Scroll2d.drawSquare(themergba,sr.x,sr.y,2);
                }
                

                if(sr.size == 100) {
                    useSize = 2;
                    tileSize = ColonyGame.meta.gridSize * 2;

                    allRegionTiles.push({
                        x: sr.x + 1,
                        y: sr.y
                    });

                    allRegionTiles.push({
                        x: sr.x + 1,
                        y: sr.y + 1
                    });

                    allRegionTiles.push({
                        x: sr.x,
                        y: sr.y + 1
                    });

                    if(currentHoverCity && currentHoverCity.metroAreaDistrict == sr.metroAreaDistrict) {
                        Scroll2d.drawSquare(themergba,sr.x + 1,sr.y,2);
                        Scroll2d.drawSquare(themergba,sr.x + 1,sr.y + 1,2);
                        Scroll2d.drawSquare(themergba,sr.x,sr.y + 1,2);
                    }
                }

                var previewAsset = null;

                if(sr.previewImage) {
                    if(!ColonyGame.meta.colonyServerBase || sr.previewImage != ColonyGame.meta.colonyServerBase.replace("/colonies","/mpregthumbs") + "null") {
                        previewAsset = getImageAsset(sr.previewImage,false,0,null,tileSize);
                    }
                }

                if(previewAsset) {

                    var drawChevs = [];
                    var chevAsset = null;

                    if(ColonyGame.meta.capitolIndicator) {
                        if(currentGame.isIndependent) {
                            if(sr.hasCapitol) {

                                chevAsset = getImageAsset("images/" + ColonyGame.meta.capitolIndicator,false,0,null,-1);

                                if(chevAsset) {
                                    drawChevs.push(new Scroll2d.Chevron(null,chevAsset));
                                }

                            }
                        } else {
                            if(sr.hasConsulate) {

                                chevAsset = getImageAsset("images/" + ColonyGame.meta.capitolIndicator,false,0,null,-1);

                                if(chevAsset) {
                                    drawChevs.push(new Scroll2d.Chevron(null,chevAsset));
                                }

                            }
                        }
                    }

                    if(drawChevs.length == 0) {
                        drawChevs = null;
                    }

                    var cityNameText = null;

                    if(showCityNames) {
                        cityNameText = sr.name;
                    }

                    var textSize = 8;

                    if(loresMode) {
                        textSize = 6;
                    }

                    if(!filledRegionSpots[sr.x]) {
                        filledRegionSpots[sr.x] = {};
                    }

                    filledRegionSpots[sr.x][sr.y] = true;

                    if(useSize == 2) {
                        if(!filledRegionSpots[sr.x + 1]) {
                            filledRegionSpots[sr.x + 1] = {};
                        }

                        filledRegionSpots[sr.x + 1][sr.y] = true;
                        filledRegionSpots[sr.x + 1][sr.y + 1] = true;
                        filledRegionSpots[sr.x][sr.y + 1] = true;
                    }

                    Scroll2d.drawSpriteWithOptions({
                        img: previewAsset,
                        x: sr.x,
                        y: sr.y,
                        zIndex: 1,
                        tileWidth: useSize,
                        tileHeight: useSize,
                        chevrons: drawChevs,
                        centerChevrons: true,
                        textLabel: cityNameText,
                        textSize: textSize
                    });
                } else {
                    for(sX = 0; sX < useSize; sX++) {
                        for(sY = 0; sY < useSize; sY++) {
                            usX = sr.x + sX;
                            usY = sr.y + sY;
        
                            Scroll2d.drawSquare("rgba(0,0,255,.6)",usX,usY,1);
                        }
                    }
                }

                if(currentHoverCity && sr == currentHoverCity) {
                    renderOutline(sr.x,sr.y,useSize,useSize,2,"#fdd835",3,true);
                } else {
                    renderOutline(sr.x,sr.y,useSize,useSize,1,"rgba(0,0,0,.6)",1,true);
                }
                

                
            }

            if(currentGame.waterTemplateData && !currentGame.isMpRegionHolder) {
                for(x = msX; x <= masX; x++) {
                    for(y = msY; y <= masY; y++) {

                        if(filledRegionSpots[x]) {
                            if(filledRegionSpots[x][y]) {
                                if(currentGame.regionSquareTemplateImages[x]) {
                                    currentGame.regionSquareTemplateImages[x][y] = {
                                        data: null,
                                        loading: false
                                    };
                                }
                                
                                continue;
                            }
                        }
    
                        if(!filledRegionSpots[x] || !filledRegionSpots[x][y]) {
    
                            if(!currentGame.regionSquareTemplateImages[x]) {
                                currentGame.regionSquareTemplateImages[x] = {};
                            }

                            if(!currentGame.regionSquareTemplateImages[x][y]) {
                                currentGame.regionSquareTemplateImages[x][y] = {
                                    loading: false,
                                    data: null
                                };
                            }

                            if(currentGame.regionSquareTemplateImages[x][y].data) {
                                var img = getImageAsset(currentGame.regionSquareTemplateImages[x][y].data,false,0,null,ColonyGame.meta.gridSize);

                                if(img) {
                                    Scroll2d.drawSpriteWithOptions({
                                        img: img,
                                        x: x,
                                        y: y,
                                        zIndex: 1,
                                        tileWidth: 1,
                                        tileHeight: 1
                                    });
                                }
                            } else {
                                if(!currentGame.regionSquareTemplateImages[x][y].loading) {
                                    currentGame.regionSquareTemplateImages[x][y].loading = true;
                                    curRegPreviewWorkQueue.push({
                                        x: x,
                                        y: y
                                    });
                                }
                            }
                        }
    
                        
                    }
                }

                if(curRegPreviewWorkQueue.length > 0) {
                    workOnRegionPreviewImageQueue();
                }
            }

            renderRegionalOutline(allRegionTiles,2,currentGame.themeColor,2,false);

            if(pendingSubcitySize > 0) {
                for(sX = 0; sX < pendingSubcitySize; sX++) {
                    for(sY = 0; sY < pendingSubcitySize; sY++) {
                        usX = hoverX + sX;
                        usY = hoverY + sY;

                        if(isTilePassable(usX,usY,true,false)) {
                            Scroll2d.drawSquare("rgba(0,255,0,.6)",usX,usY,2);
                        } else {
                            Scroll2d.drawSquare("rgba(255,0,0,.6)",usX,usY,2);
                        }
                    }
                }
            }
            
        }
        
        if(queuedBuilding != null && pendingBuildX != null && pendingBuildY != null) {
            drawPendingBuilding(pendingBuildX,pendingBuildY,"#8BC34A",false);
        } else {
            if(queuedBuilding != null) {
                drawPendingBuilding(hoverX,hoverY,"#8BC34A",false);
            }
        }

        if(pendingMoveBuilding && hoverX && hoverY) {
            drawPotentialMoveTarget(hoverX,hoverY,"#8BC34A");
        }

        var bldToDraw;

        for(i = 0; i < currentGame.buildings.length; i++) {

            bldToDraw = currentGame.buildings[i];

            drawBuilding(bldToDraw,false,"building");
        }
        
        for(i = 0; i < currentGame.vehicles.length; i++) {
            drawVehicle(currentGame.vehicles[i],"vehicle");
        }

        if(currentTemplate && templateVisible && !fullMapRender) {
            drawTemplate();
        }
    }

    function drawTemplate() {

        if(killSwitch) {
            return;
        }

        for(var passdef in currentTemplate.finishedPassableNonUpdatables) {
            var td = currentTemplate.finishedPassableNonUpdatables[passdef];
            for(var passX in td) {
                var tx = td[passX];
                for(var ty = 0; ty < tx.length; ty++) {
                    var passY = tx[ty];
                    drawNewPassable(passdef,parseInt(passX),parseInt(passY),0.25);
                }
            }
        }

        for(var i = 0; i < currentTemplate.buildings.length; i++) {
            var tempBuilding = currentTemplate.buildings[i];
            var def = getBuildingDefByName(tempBuilding.def);
            
            var flipped = false;

            if(tempBuilding.flipped) {
                flipped = tempBuilding.flipped;
            }

            var theImageToUse = getImageAsset(def.tile[0],flipped,0,false);

            if(theImageToUse) {
                Scroll2d.drawSprite(theImageToUse,tempBuilding.x,tempBuilding.y,null,null,null,null,null,0.25,2,def.tileWidth,def.tileHeight);
            }
            
        }
    }
    
    function drawPendingBuilding(x,y,color) {

        if(queuedBuilding == null) {
            return;
        }

        if(queuedBuildingBlocked) {
            color = "#F44336";
        }

        var gridWidth = queuedBuilding.tileWidth;
        var gridHeight = queuedBuilding.tileHeight;

        if(flipChainedStructures) {
            gridWidth = queuedBuilding.tileHeight;
            gridHeight = queuedBuilding.tileWidth;
        }

        renderGrid(x,y,gridWidth,gridHeight,3,color,1);

        var theImageToUse = getImageAsset(queuedBuilding.tile[0],flipChainedStructures,0,null);

        if(theImageToUse) {
            Scroll2d.drawSprite(theImageToUse,x,y,null,null,undefined,undefined,undefined,0.35,2,gridWidth,gridHeight);
        }
        
    }

    function drawPotentialMoveTarget(x,y,color) {
        if(pendingMoveBuilding == null) {
            return;
        }

        var moveDef = getBuildingDefByName(pendingMoveBuilding.def);

        var blocked = checkForGeneralBlockage(moveDef,x,y,pendingMoveBuilding.flipped);

        if(blocked) {
            color = "#F44336";
        }

        var gridWidth = moveDef.tileWidth;
        var gridHeight = moveDef.tileHeight;

        if(pendingMoveBuilding.flipped) {
            gridWidth = moveDef.tileHeight;
            gridHeight = moveDef.tileWidth;
        }

        renderGrid(x,y,gridWidth,gridHeight,3,color,1);

        var theImageToUse = getImageAsset(moveDef.tile[0],pendingMoveBuilding.flipped,0,null);

        if(theImageToUse) {
            Scroll2d.drawSprite(theImageToUse,x,y,null,null,undefined,undefined,undefined,0.35,2,gridWidth,gridHeight);
        }
    }
    
    function engageBuildingQueue() {
        if(!queuedBuildings || queuedBuildings == null || queuedBuildings.length == 0) {
            return;
        }

        if(currentGame.isRegion) {
            queuedBuildings = null;
            return;
        }

        var firstBuilding = null;
        constructionFromSidebar = false;

        for(var i = 0; i < queuedBuildings.length; i++) {
            var freshBuilding;

            if(!queuedBuildings[i].building) {
                continue;
            }

            var blocked = checkForGeneralBlockage(queuedBuildings[i].building,queuedBuildings[i].x,queuedBuildings[i].y,flipChainedStructures,null,true);

            if(blocked) {
                continue;
            }

            freshBuilding = new Building(queuedBuildings[i].building,queuedBuildings[i].x,queuedBuildings[i].y,getRegionOrCity().localPlayerId);

            freshBuilding.flipped = flipChainedStructures;

            if(freshBuilding.flipped) {
                freshBuilding.occupiesTiles = getOccupiedTiles(freshBuilding,false);
            }

            setUpMinidefForBuilding(freshBuilding,false,false);

            if(queuedBuildings[i].building.isEmbassy) {
                freshBuilding.embassyFor = parseInt(pendingEmbassyMission.foreigncolony);
                freshBuilding.name = pendingEmbassyMission.colonyname + " Embassy";
                currentGame.buildings.push(freshBuilding);
                updateBuildingCollisionPoints(freshBuilding,150);


                var diplomatsToMake = queuedBuildings[i].building.acceptsWorkers;

                while(diplomatsToMake > 0) {


                    diplomatsToMake--;
                }

                alertEmbassyBuilt(pendingEmbassyMission);

                pendingEmbassyMission = null;

                
            } else {
                if(currentGame.cm) {

                    var bd = getBuildingDefByName(freshBuilding.def);

                    if(bd && bd.becomesTerrain) {
                        freeRefNukeTurn = true;
                        var fresherBuilding = new MapResource(getTerrainDefByName(bd.becomesTerrain),freshBuilding.x,freshBuilding.y);
                        currentGame.mapResources.push(fresherBuilding);
                        shouldUpdateCollissionMap = true;
                        firstBuilding = null;
                        queuedBuilding = null;
                        selectedVehicle = [];
                        shoreUpdateTurn = true;
                        continue;
        
                    }
                } else {
                    freshBuilding.iuc = true;
                }

                if(!constructionProjectsArray) {
                    constructionProjectsArray = [];
                }

                constructionProjectsArray.push(freshBuilding);

                var isNonUpdatable = false;

                if(queuedBuildings[i].building.passable) {
                    if(queuedBuildings[i].building.tileWidth == 1 && queuedBuildings[i].building.tileHeight == 1) {
                        if(queuedBuildings[i].building.requiresFuel == null && queuedBuildings[i].building.stores == null) {
                            if(queuedBuildings[i].building.generates == null) {
                                if(queuedBuildings[i].building.smelts == null) {
                                    if(queuedBuildings[i].building.produces == null) {
                                        isNonUpdatable = true;
                                    }
                                }
                            }
                        }
                    }
                }

                freeRefNukeTurn = true;
                
                if(isNonUpdatable) {

                    currentGame.passableNonUpdatables.push(freshBuilding);

                } else {

                    currentGame.buildings.push(freshBuilding);
                    updateUtilityGrid();

                    updateBuildingCollisionPoints(freshBuilding,150);
                }

                freshBuilding.c = new ConstructionItem();
                
                
                freshBuilding.c.c = 0;
                freshBuilding.c.p = 0;
                freshBuilding.c.t = 0;
                freshBuilding.c.pr = {};
                
                if(!currentGame.cm) {
                    for(var k = 0; k < queuedBuildings[i].building.cost.length; k++) {
                        freshBuilding.c.pr[queuedBuildings[i].building.cost[k].resource] = queuedBuildings[i].building.cost[k].amount;
                        freshBuilding.c.t += queuedBuildings[i].building.cost[k].amount;
                    }
                }

                if(i == 0) {
                    firstBuilding = freshBuilding;
                }
            }

            
        }

        shouldUpdateCollissionMap = true;

        if(selectedVehicle.length > 0) {
            for(i = 0; i < selectedVehicle.length; i++) {
                sendVehicleToConstructionSite(selectedVehicle[i],firstBuilding);
            }
        }

        if(firstBuilding != null) {
            callNearbyBuilders(firstBuilding.x,firstBuilding.y,0,false,false,firstBuilding);
        }


        queuedBuildings = null;
        firstBuilding = null;
        queuedBuilding = null;
        selectedVehicle = [];

        clearOutBuildMenu();
    }

    function sendVehicleToConstructionSite(vehicle,site,forHarvest) {

        if(vehicle == null || site == null) {
            return;
        }

        var j;

        var flying = false;

        var vdef = getVehicleDefByName(vehicle.def);

        if(vdef && vdef.isFlying) {
            flying = true;
        }

        var availableSpaces = getFreeSpacesAroundBuilding(site,1,false,false,flying);

        if(!availableSpaces || availableSpaces.length == 0) {
            return;
        }

        if(availableSpaces.length > 0) {

            var pathsToSort = [];

            for(j = 0; j < availableSpaces.length; j++) {

                var a = vehicle.x - availableSpaces[j][0];
                var b = vehicle.y - availableSpaces[j][1];
                var distance = Math.sqrt( a*a + b*b );

                pathsToSort.push({
                    "x": availableSpaces[j][0],
                    "y": availableSpaces[j][1],
                    "d": distance
                });

            }

            if(pathsToSort.length > 0) {

                pathsToSort.sort(sortTargetPoints);

                // slightly mix it up so everything isnt stuck together
                if(vehicle.brt == 0 && pathsToSort.length > 4) {
                    if(randomIntFromInterval(0,3) == 1) {
                        pathsToSort.shift();
                    }
                }

                vehicle.dX = pathsToSort[0].x;
                vehicle.dY = pathsToSort[0].y;

                if(forHarvest) {
                    vehicle.inBuildingMode = false;
    
                    vehicle.iH = true;
                } else {

                    vehicle.inBuildingMode = true;
                    vehicle.iH = false;
                    vehicle.ht = null;
                }
            }
            
            vehicle.blacklist = [];
            vehicle.bBlacklist = [];
        }

        availableSpaces = null;
    }
    
    function startBuilding(x,y,dontShowBlock) {

        var blocked = checkForGeneralBlockage(queuedBuilding,x,y,flipChainedStructures);

        var i;
        
        if(queuedBuildingBlocked || blocked) {


            var killBuilding = null;

            for(i = 0; i < queuedBuildings.length; i++) {
                if(queuedBuildings[i].x == x && queuedBuildings[i].y == y) {
                    killBuilding = queuedBuildings[i];
                    break;
                }
            }

            if(killBuilding != null) {
                removeFromArray(queuedBuildings,killBuilding);
                showBuildConfirm();
                return;
            }

            if(!dontShowBlock) {
                webAppCore.showToast("Location Blocked");
            }
            

            if(usingMouse && queuedBuildings.length == 0) {
                queuedBuilding = null;
                selectedVehicle = [];
                dismissBuildConfirm();
            }

            

            return;
        }

        pendingBuildX = x;
        pendingBuildY = y;
        
        showBuildConfirm();

        cqX = x;
        cqY = y;

        if(!queuedBuildings || queuedBuildings == null || queuedBuilding.isEmbassy) {
            queuedBuildings = [];
        }

        var removeItem = null;

        for(i = 0; i < queuedBuildings.length; i++) {
            if(queuedBuildings[i].x == x && queuedBuildings[i].y == y) {
                removeItem = queuedBuildings[i];
                continue;
            }
        }

        if(removeItem != null) {
            removeFromArray(queuedBuildings,removeItem);
            showBuildConfirm();
            return;
        }
        
        pendingBuildX = null;
        pendingBuildY = null;

        queuedBuildings.push({
            x: x,
            y: y,
            building: queuedBuilding
        });

    }

    var cqX;
    var cqY;

    function onSelectionChange() {
        inMultiSelectionMode = true;
    }

    function onSelectionDone(topLeft,topRight,bottomLeft,bottomRight) {

        inMultiSelectionMode = false;

        selectedVehicle = [];

        for(var i = 0; i < currentGame.vehicles.length; i++) {

            var coord = { "x": currentGame.vehicles[i].x, "y": currentGame.vehicles[i].y };

            var selected = false;

            if(ptInTriangle(coord, topLeft,topRight,bottomRight)) {
                selected = true;
            } else {
                if(ptInTriangle(coord, topLeft,bottomLeft,bottomRight)) {
                    selected = true;
                }
            }

            if(selected) {
                selectedVehicle.push(currentGame.vehicles[i]);
            }

        }

        if(selectedVehicle.length > 0) {
            drawSidebar();
            showOptionsForObject(selectedVehicle,"vehicle");
        }
    }

    function ptInTriangle(p, p0, p1, p2) {
        var dX = p.x-p2.x;
        var dY = p.y-p2.y;
        var dX21 = p2.x-p1.x;
        var dY12 = p1.y-p2.y;
        var D = dY12*(p0.x-p2.x) + dX21*(p0.y-p2.y);
        var s = dY12*dX + dX21*dY;
        var t = (p2.y-p0.y)*dX + (p0.x-p2.x)*dY;
        if (D<0) return s<=0 && t<=0 && s+t>=D;
        return s>=0 && t>=0 && s+t<=D;
    }

    function closeGBT() {
        var roc = getRegionOrCity();

        if(usingSockets && (!roc || !roc.tradeNotifications)) {
            webAppCore.socketEmit("leaveroom","trades");
        }

        
        document.getElementById("gbtNewsData").innerHTML = "";
        document.getElementById("tradeNotificationAreaReadout").innerHTML = "";

        if(!roc || !roc.tradeNotifications) {
            tickerItems = [];
            showingLive = false;
        }

        document.getElementById("galBT").style.display = "none";
        gbtOpen = false;

        
        staticFrame = false;
        Scroll2d.forceSceneChange();
    }



    function extendTouchPointsFromPosition(x,y) {
        touchPossibleBuildPoints = [];


        if(queuedBuilding == null || !chainQueue) {
            return;
        }

        var buildOvers = null;

        if(queuedBuilding && queuedBuilding.canBuildOver && queuedBuilding.canBuildOver.length > 0) {
            buildOvers = queuedBuilding.canBuildOver;
        }

        var cX,cY,keepGoing,i;

        keepGoing = true;
        cX = x;
        cY = y;
        while(keepGoing) {
            cY--;

            for(i = 0; i < chainQueue.length; i++) {
                if(chainQueue[i].x == cX && chainQueue[i].y == cY) {
                    keepGoing = false;
                    break;
                }
            }

            if(keepGoing) {
                keepGoing = isTilePassable(cX,cY,true,false,false,buildOvers);
            }

            if(keepGoing) {
                touchPossibleBuildPoints.push({
                    "x": cX,
                    "y": cY
                });
            }
        }


        keepGoing = true;
        cX = x;
        cY = y;
        while(keepGoing) {
            cY++;

            for(i = 0; i < chainQueue.length; i++) {
                if(chainQueue[i].x == cX && chainQueue[i].y == cY) {
                    keepGoing = false;
                    break;
                }
            }

            if(keepGoing) {
                keepGoing = isTilePassable(cX,cY,true,false,false,buildOvers);
            }

            if(keepGoing) {
                touchPossibleBuildPoints.push({
                    "x": cX,
                    "y": cY
                });
            }
        }


        keepGoing = true;
        cX = x;
        cY = y;
        while(keepGoing) {
            cX--;

            for(i = 0; i < chainQueue.length; i++) {
                if(chainQueue[i].x == cX && chainQueue[i].y == cY) {
                    keepGoing = false;
                    break;
                }
            }

            if(keepGoing) {
                keepGoing = isTilePassable(cX,cY,true,false,false,buildOvers);
            }

            if(keepGoing) {
                touchPossibleBuildPoints.push({
                    "x": cX,
                    "y": cY
                });
            }
        }


        keepGoing = true;
        cX = x;
        cY = y;
        while(keepGoing) {
            cX++;

            for(i = 0; i < chainQueue.length; i++) {
                if(chainQueue[i].x == cX && chainQueue[i].y == cY) {
                    keepGoing = false;
                    break;
                }
            }

            if(keepGoing) {
                keepGoing = isTilePassable(cX,cY,true,false,false,buildOvers);
            }

            if(keepGoing) {
                touchPossibleBuildPoints.push({
                    "x": cX,
                    "y": cY
                });
            }
        }
    }

    function queueSelectedVehicleForMove() {
        queuedMove = selectedVehicle;
        
        for(var i = 0; i < selectedVehicle.length; i++) {

            selectedVehicle[i].iH = false;
            selectedVehicle[i].ht = null;
            selectedVehicle[i].inBuildingMode = false;
            selectedVehicle[i].blacklist = [];
            selectedVehicle[i].bBlacklist = [];
            setAwaitingPath(selectedVehicle[i],"vehicle",false);
        }
    }

    function rightClick(x,y,aX,aY,type) {

        if(killSwitch) {
            return;
        }

        var saveSelected = null;

        if(selectedVehicle.length > 0) {
            saveSelected = selectedVehicle;
            queueSelectedVehicleForMove();
        }

        click(x,y,aX,aY,type);

        queuedMove = null;

        if(saveSelected != null) {

            selectedVehicle = saveSelected;
            showOptionsForObject(saveSelected,"vehicle",true);
        }

        pendingMoveBuilding = null;
    }
    
    var lastPaintX = 0;
    var lastPaintY = 0;

    function paint(x,y) {

        if(killSwitch) {
            return;
        }

        if(x == lastPaintX && y == lastPaintY) {
            return;
        }

        lastPaintX = x;
        lastPaintY = y;

        if(currentGame == null) {
            return;
        }

        if(!bulldozerMode) {
            if(!currentGame.mem || selectedMapEditorTool == null) {
                return;
            }
        }
        

        click(x,y);
    }
    
    function click(x,y,aX,aY,type) {

        if(killSwitch) {

            return;
        }

        if(bulldozerMode) {
            Scroll2d.alertPainting();
        }

        var somethingWasOpen = closeSomethingIfOpen();
        
        hideSidebarIfSmall();

        if(somethingWasOpen) {
            selectedBuilding = null;
            drawSidebar();

            if(queuedBuilding == null || !constructionFromSidebar) {

                return;
            }
        }

        cooldownGamepad();

        var i;

        actualX = aX;
        actualY = aY;

        var sX, sY, usX, usY;

        if(currentGame == null) {

            return;
        }

        if(currentGame.isRegion) {
            if(pendingSubcitySize > 0) {

                var spaceOpen = true;

                for(sX = 0; sX < pendingSubcitySize; sX++) {
                    for(sY = 0; sY < pendingSubcitySize; sY++) {
                        usX = x + sX;
                        usY = y + sY;
    
                        if(!isTilePassable(usX,usY,true,false)) {
                            spaceOpen = false;
                            break;
                        }
                    }

                    if(!spaceOpen) {
                        break;
                    }
                }

                if(spaceOpen) {
                    pendingSubCityX = x;
                    pendingSubCityY = y;

                    var dialogOptions = {
                        title: getString("new-game"),
                        message: getString("new-game-col-name"),
                        func: newSubregionNameReturn
                    };
        
                    webAppCore.inputBox(dialogOptions);
                }
            } else {
                var clickedCity = null;

                for(i = 0; i < currentGame.subRegions.length; i++) {

                    var sr = currentGame.subRegions[i];
                    var size = 1;
                    if(sr.size == 100) {
                        size = 2;
                    }
    
                    for(sX = 0; sX < size; sX++) {
                        for(sY = 0; sY < size; sY++) {
                            usX = sr.x + sX;
                            usY = sr.y + sY;
        
                            if(usX == x && usY == y) {
                                clickedCity = sr;
                                break;
                            }
                        }

                        if(clickedCity != null) {
                            break;
                        }
                    }

                    if(clickedCity != null) {
                        break;
                    }
                }

                if(clickedCity != null) {
                    if(bulldozerMode) {
                        dozeSelectedCity(clickedCity);
                    } else {

                        if(!readyToLoadSubcities) {
                            webAppCore.showToast("Please wait, region still loading...");
                            return;
                        }

                        openSubCity(clickedCity);
                    }

                    return;
                }

            }
        }


        if(currentGame.mem) {
            Scroll2d.alertPainting();
        }

        if(currentGame.mem && !bulldozerMode && mapEditorPlacingStartFlag) {
            if(!isTilePassable(x,y,false,true)) {
                return;
            }

            currentGame.mestartx = x;
            currentGame.mestarty = y;

            return;
        }


        if(currentGame.mem && !bulldozerMode && selectedMapEditorTool != null) {

            if(!isTilePassable(x,y,false,true)) {
                return;
            }

            

            destroyAtTile(x,y,selectedMapEditorTool.tileWidth,selectedMapEditorTool.tileHeight,false);

            var resourceItem = new MapResource(selectedMapEditorTool,x,y);
            freeRefNukeTurn = true;
            updateBuildingCollisionPoints(resourceItem,150,true);
            currentGame.mapResources.push(resourceItem);
            shoreUpdateTurn = true;

            return;
        }

        var tmpChopVehicles = null;
        
        if(queuedMove != null || queuedPark != null) {

            if(isTilePassable(x,y)) {


                if(queuedMove != null) {
                    if(Array.isArray(queuedMove)) {
                        var choices = getFreeSpaceAroundTile(x,y,2,true);
                        
                        if(choices.length > 0) {
                            for(i = 0; i < queuedMove.length; i++) {
                                if(i == 0) {
                                    moveVehicle(x,y,queuedMove[i]);
                                } else {
                                    var rndPos = choices[randomIntFromInterval(0,choices.length - 1)];
                                    moveVehicle(rndPos[0],rndPos[1],queuedMove[i]);
                                }
                            }
                        }

                        while(choices.length) {
                            freeSpaceItemRecycler.push(choices.pop());
                        }

                    } else {
                        moveVehicle(x,y,queuedMove);
                    }

                    queuedMove = null;
                    
                    return;
                }



                if(queuedPark != null) {
                    for(i = 0; i < selectedVehicle.length; i++) {
                        selectedVehicle[i].pX = x;
                        selectedVehicle[i].pY = y;
                        parkVehicle(selectedVehicle[i]);
                    }
                    webAppCore.showToast(getString("general-park-confirm"));

                }

                for(i = 0; i < selectedVehicle.length; i++) {

                    selectedVehicle[i].iH = false;

                    selectedVehicle[i].inBuildingMode = false;

                    selectedVehicle[i].blacklist = [];
                    selectedVehicle[i].bBlacklist = [];
                }

                queuedPark = null;
                queuedMove = null;
                selectedVehicle = [];
                selectedColonist = null;
                
                document.getElementById("objectOptions").style.display = "none";
                drawSidebar();
                
                return;
            } else {
                if(currentGame.isSubregion && currentRegion && !currentRegion.isMpRegionHolder) {
                    if(x == -1 || x == (currentGame.width + 1) || y == -1 || y == (currentGame.height + 1)) {
                        if(Array.isArray(queuedMove)) {
                            for(i = 0; i < queuedMove.length; i++) {
                                moveVehicle(x,y,queuedMove[i]);
                            }
                        } else {
                            moveVehicle(x,y,queuedMove);
                        }

                        return;
                    }
                }
            }
        }

        if(queuedBuilding != null && (selectedVehicle != null || constructionFromSidebar)) {

            if(!queuedBuildings || queuedBuildings == null || queuedBuildings.isEmbassy) {
                queuedBuildings = [];
                chainQueue = [];
            }

            if(type == "touch") {

                for(i = 0; i < touchPossibleBuildPoints.length; i++) {
                    if(touchPossibleBuildPoints[i].x == x && touchPossibleBuildPoints[i].y == y) {
                        handleChain(x,y);
                        break;
                    }
                }
            }

            var l;

            if(chainQueue && chainQueue.length > 0) {
                for(i = 0, l = chainQueue.length; i < l; i++) {
                    if(chainQueue && chainQueue[i]) {
                        startBuilding(chainQueue[i].x,chainQueue[i].y,true);
                    } 
                }
            } else {
                startBuilding(x,y);
            }

            if(type == "touch") {
                extendTouchPointsFromPosition(x,y);
            }

            chainQueue = [];
            
            return;

        }

        tmpChopVehicles = selectedVehicle;

        selectedBuilding = null;
        selectedVehicle = [];
        selectedResource = null;
        selectedPassable = null;

        selectedColonist = null;
        
        var j;

        for(i = 0; i < currentGame.vehicles.length; i++) {

            if(currentGame.vehicles[i].iv > 0) {
                continue;
            }

            if(currentGame.vehicles[i].x == x && currentGame.vehicles[i].y == y) {
                selectedVehicle.push(currentGame.vehicles[i]);

                if(bulldozerMode) {
                    destroyVehicle(selectedVehicle);
                    return;
                }

            }
        }

        if(selectedVehicle.length > 0) {
            if(tmpChopVehicles && tmpChopVehicles.length == 1) {
                if(selectedVehicle[0] == tmpChopVehicles[0]) {
                    selectedVehicle = [];
                    var typ = tmpChopVehicles[0].def;

                    for(i = 0; i < currentGame.vehicles.length; i++) {
                        if(currentGame.vehicles[i].def == typ) {
                            selectedVehicle.push(currentGame.vehicles[i]);
                        }
                    }

                    drawSidebar();
                    showOptionsForObject(selectedVehicle,"vehicle");
                    return;
                }
            }

            drawSidebar();
            showOptionsForObject(selectedVehicle,"vehicle");
            return;
        }

        for(i = 0; i < currentGame.buildings.length; i++) {

            if(!currentGame.buildings[i]) {
                continue;
            }
            
            if(currentGame.buildings[i].occupiesTiles) {
                for(j = 0; j < currentGame.buildings[i].occupiesTiles.length; j++) {
                    if(currentGame.buildings[i].occupiesTiles[j].x == x && currentGame.buildings[i].occupiesTiles[j].y == y) {

                        if(bulldozerMode) {
                            if(currentGame.buildings[i].iuc) {
                                currentGame.buildings[i].isBeingRemoved = true;
                            } else {
                                currentGame.buildings[i].condition = -1;
                            }
                            
                            return;
                        } else {

                            selectedBuilding = currentGame.buildings[i];

                            if(!selectedBuilding.iuc) {
                                if(getBuildingDefByName(selectedBuilding.def).isChopShop && tmpChopVehicles != null && tmpChopVehicles.length > 0) {
                                    document.getElementById("objectOptions").style.display = "none";

                                    for(i = 0; i < tmpChopVehicles.length; i++) {
                                        sendVehicleToChopShop(tmpChopVehicles[i],selectedBuilding);
                                    }

                                    selectedBuilding = null;
                                    return;
                                }
                            }

                            if(selectedBuilding.iuc && tmpChopVehicles != null && tmpChopVehicles.length > 0) {
                                document.getElementById("objectOptions").style.display = "none";

                                for(i = 0; i < tmpChopVehicles.length; i++) {
                                    sendVehicleToConstructionSite(tmpChopVehicles[i],selectedBuilding);
                                }

                                selectedBuilding = null;
                                queuedMove = null;
                                selectedVehicle = [];
                                return;
                            }

                            drawSidebar();
                            showOptionsForObject(selectedBuilding,"building");
                            
                            return;
                        }
                    }
                }
            }

  
        }

        var killItem = null;
        

        for(var passdef in currentGame.finishedPassableNonUpdatables) {
            var td = currentGame.finishedPassableNonUpdatables[passdef];

            if(td[x]) {
                var tx = td[x];

                for(var ty = 0; ty < tx.length; ty++) {
                    if(parseInt(tx[ty]) == y) {
                        killItem = ty;
                        break;
                    }
                }

                if(killItem != null) {
                    if(bulldozerMode) {
                        tx.splice(ty,1);
                        if(allowParticleEffects) {
                            Scroll2d.playParticleEffect("explosion",x,y);
                        }
                        staticFrame = false;
                        Scroll2d.forceSceneChange();
                        return;
                    } else {
                        showOptionsForObject(passdef,"finishedpassable",false,x,y);
                        return;
                    }
                }
            }

        }
        
        for(i = 0; i < currentGame.passableNonUpdatables.length; i++) {
                
            if(currentGame.passableNonUpdatables[i].occupiesTiles == null) {
                continue;
            }

            for(j = 0; j < currentGame.passableNonUpdatables[i].occupiesTiles.length; j++) {
                if(currentGame.passableNonUpdatables[i].occupiesTiles[j].x == x && currentGame.passableNonUpdatables[i].occupiesTiles[j].y == y) {
                    selectedPassable = currentGame.passableNonUpdatables[i];

                }
            }
            
            if(currentGame.passableNonUpdatables[i].x == x && currentGame.passableNonUpdatables[i].y == y) {
                selectedPassable = currentGame.passableNonUpdatables[i];
                
            }

            if(selectedPassable && selectedPassable.iuc && tmpChopVehicles != null && tmpChopVehicles.length > 0) {
                document.getElementById("objectOptions").style.display = "none";

                for(i = 0; i < tmpChopVehicles.length; i++) {
                    sendVehicleToConstructionSite(tmpChopVehicles[i],selectedPassable);
                }

                selectedPassable = null;
                queuedMove = null;
                selectedVehicle = [];
                return;
            } else {
                if(selectedPassable) {
                    showOptionsForObject(selectedPassable,"passable");
                    return;
                }
            }
        }

        for(i = 0; i < currentGame.mapResources.length; i++) {

            if(currentGame.mapResources[i].occupiesTiles == null) {
                continue;
            }
            
            for(j = 0; j < currentGame.mapResources[i].occupiesTiles.length; j++) {
                if(currentGame.mapResources[i].occupiesTiles[j].x == x && currentGame.mapResources[i].occupiesTiles[j].y == y) {

                    
                    selectedResource = currentGame.mapResources[i];
                    var sentHarvester = false;

                    if(tmpChopVehicles != null && tmpChopVehicles.length > 0) {
                        for(var k = 0; k < tmpChopVehicles.length; k++) {

                            if(currentGame.mapResources[i].playDef.provides == tmpChopVehicles[k].harvests) {
                                sendVehicleToConstructionSite(tmpChopVehicles[k],selectedResource,true);
                                sentHarvester = true;
                            }

                            
                        }
                    }

                    if(sentHarvester) {
                        selectedResource = null;
                        selectedVehicle = [];
                        return;
                    }

                    if(bulldozerMode) {
                        if(destroyResource(selectedResource,true)) {
                            return;
                        }
                    } else {
                        showOptionsForObject(selectedResource,"resource");
                        return;
                    }
                    
                    
                }
            }
            
        }

        
        if(pendingMoveBuilding) {
            var moveDef = getBuildingDefByName(pendingMoveBuilding.def);
            var blocked = checkForGeneralBlockage(moveDef,x,y,pendingMoveBuilding.flipped);

            if(blocked) {
                webAppCore.showToast("Location Blocked!");
            } else {
                pendingMoveBuilding.x = x;
                pendingMoveBuilding.y = y;
                pendingMoveBuilding.occupiesTiles = getOccupiedTiles(pendingMoveBuilding,false);
                setUpMinidefForBuilding(pendingMoveBuilding,false,true);
                updateBuildingCollisionPoints(pendingMoveBuilding,150);
                shouldUpdateCollissionMap = true;
            }

            pendingMoveBuilding = null;
        }
        
        
        if(selectedVehicle.length == 0 && selectedBuilding == null) {
            clearOutBuildMenu();
            document.getElementById("objectOptions").style.display = "none";
        }

        selectedBuilding = null;

        if(currentGame.isSubregion && currentRegion && !currentRegion.isMpRegionHolder) {
            if(x == -1 || x == (currentGame.width + 1) || y == -1 || y == (currentGame.height + 1)) {
                if(currentSubcityRef) {
                    var useCitySize = 1;
                    var checkCity = null;

                    if(currentSubcityRef.size == 100) {
                        useCitySize = 2;
                    }

                    if(x == -1) {
                        if(y <= 50) {
                            checkCity = getSubregionByCoord(currentSubcityRef.x - 1,currentSubcityRef.y);
                        } else {
                            checkCity = getSubregionByCoord(currentSubcityRef.x - 1,currentSubcityRef.y + 1);
                        }
                    }

                    if(x == (currentGame.width + 1)) {
                        if(y <= 50) {
                            checkCity = getSubregionByCoord(currentSubcityRef.x + useCitySize,currentSubcityRef.y);
                        } else {
                            checkCity = getSubregionByCoord(currentSubcityRef.x + useCitySize,currentSubcityRef.y + 1);
                        }
                    }

                    if(y == -1) {
                        if(x <= 50) {
                            checkCity = getSubregionByCoord(currentSubcityRef.x,currentSubcityRef.y - 1);
                        } else {
                            checkCity = getSubregionByCoord(currentSubcityRef.x + 1,currentSubcityRef.y - 1);
                        }
                    }

                    if(y == (currentGame.height + 1)) {
                        if(x <= 50) {
                            checkCity = getSubregionByCoord(currentSubcityRef.x,currentSubcityRef.y + useCitySize);
                        } else {
                            checkCity = getSubregionByCoord(currentSubcityRef.x + 1,currentSubcityRef.y + useCitySize);
                        }
                    }

                    if(checkCity) {
                        
                        webAppCore.showDialog({
                            title: checkCity.name,
                            message: getString("save-switch-city-ask") + checkCity.name,
                            buttons: [
                                {
                                    text: getString("general-nevermind"),
                                    func: placeholder
                                },
                                {
                                    text: getString("gen-switch"),
                                    func: function(){
                                        autoloadSubcityAfterSave = checkCity;
                                        standardSaveAndQuitRoutine();
                                    }
                                }
                            ]
                        });

                        return;
                    }
                }
            }
        }
    }
    
    function showBuildConfirm() {
        webAppCore.handleBackFunction(clearOutBuildMenu);

        if(gamepadInUse) {
            document.getElementById("gamepadBuildConfirm").style.display = "block";
            return;
        } else {

            showDesktopBuildConfirm();
        }

    }


    function getFreeSpacesAroundBuilding(building,radius,decorationsBlock,isTerrain,flying) {

        if(!flying) {
            flying = false;
        }

        if(building.occupiesTiles == null) {
            building.occupiesTiles = getOccupiedTiles(building,isTerrain);
        }

        if(!radius) {
            radius = 1;
        }

        if(radius == 1 && building.fr != null && !decorationsBlock && building.fr.length > 0) {
            return building.fr;
        }
        


        var availableSpaces = [];
        var j,newSpaces;
                
        for(j = 0; j < building.occupiesTiles.length; j++) {
            newSpaces = getFreeSpaceAroundTile(building.occupiesTiles[j].x,building.occupiesTiles[j].y,radius,flying);
            availableSpaces = availableSpaces.concat(newSpaces);
        }

        var finalSpaces = [];

        while(availableSpaces.length > 0) {
            var space = availableSpaces.pop();

            var exists = false;

            for(j = 0; j < finalSpaces.length; j++) {
                if(finalSpaces[j][0] == space[0] && finalSpaces[j][1] == space[1]) {
                    exists = true;
                    break;
                }
            }

            if(!exists) {
                finalSpaces.push(space);
            } else {
                freeSpaceItemRecycler.push(space);
            }
        }

        if(radius == 1 && !decorationsBlock && !building.iuc) {
            building.fr = finalSpaces;
        }

        return finalSpaces;

    }

    var freeSpaceItemRecycler = [];

    function getFreeSpaceItemHolder(x,y) {
        if(freeSpaceItemRecycler.length > 0) {
            var item = freeSpaceItemRecycler.pop();
            item[0] = x;
            item[1] = y;
            return item;
        } else {
            return [x,y];
        }
    }

    function getFreeSpaceAroundTile(x,y,rad,include,flying) {
        var freeTiles = [];
        
        var radius = 1;
        
        if(rad) {
            radius = rad;
        }

        if(!flying) {
            flying = false;
        }

        for(var cx = x - radius; cx < x + (radius + 1); cx++) {
            for(var cy = y - radius; cy < y + (radius + 1); cy++) {
                if(cx >=0 && cy >= 0 && cx <= currentGame.width && cy <= currentGame.height) {
                    var passable = isTilePassable(cx,cy,false,flying);

                    if(passable || (include && (include.x == cx && include.y == cy))) {
                        freeTiles.push(getFreeSpaceItemHolder(cx,cy));
                    }
                }
            }
        }
        
        return freeTiles;
    }

    function getAllSpacesAroundTile(x,y,rad) {
        var freeTiles = [];
        
        var radius = 1;
        
        if(rad) {
            radius = rad;
        }

        for(var cx = x - radius; cx < x + (radius + 1); cx++) {
            for(var cy = y - radius; cy < y + (radius + 1); cy++) {
                if(cx >=0 && cy >= 0 && cx <= currentGame.width && cy <= currentGame.height) {
                    var a = x - cx;
                    var b = y - cy;
                    var distance = Math.sqrt( a*a + b*b );

                    if(distance < radius) {
                        freeTiles.push([cx,cy]);
                    }
                }
            }
        }
        
        return freeTiles;
    }

    function showBuildingConstructionOptionsNew(object,type,islist) {

        var availableOptions = 0;
        var i,j;
        var menuOptions = [];
        var buildOptionListing;

        var useType = type;

        if(islist) {
            tmpBuildingRef = null;
            buildOptionListing = islist;

            if(type == "building") {
                type = "vehicle";
            } else {
                type = "building";
            }
        } else {
            if(type == "building") {
                buildOptionListing = getBuildingDefByName(object.def).produces;
            }

            if(type == "vehicle") {
                buildOptionListing = getVehicleDefByName(object.def).produces;
            }

            if(type == "building" || type == "resource") {
                tmpBuildingRef = object;
            } else {
                tmpBuildingRef = null;
            }
        }

        for(i = 0; i < buildOptionListing.length; i++) {

            var buildOption;
            var opTyp;
            

            if(islist) {
                opTyp = useType;
                buildOption = buildOptionListing[i];
            } else {
                if(type == "building") {
                    buildOption = getVehicleDefByName(buildOptionListing[i]);
                    opTyp = "vehicle";
                } else {
                    buildOption = getBuildingDefByName(buildOptionListing[i]);
                    opTyp = "building";
                    if(!buildOption || buildOption.isEmbassy) {
                        continue;
                    }
                }
            }

            var canBuild = canIBuildThis(buildOption,opTyp);

            if(!canBuild) {
                continue;
            }

            availableOptions++;

            var cost = [];
            var def;
            var costColor;

            if(buildOption.tileWidth != null && buildOption.tileHeight != null) {
                cost.push({
                    pre:    "Size:",
                    post:   buildOption.tileWidth + "x" + buildOption.tileHeight,
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.dimensionIndicator
                });
            }

            if(buildOption.requiresUtility != null) {
                for(j = 0; j < buildOption.requiresUtility.length; j++) {
                    
                    def = getUtilityByDefName(buildOption.requiresUtility[j].utility);

                    costColor = null;

                    if(buildOption.requiresUtility[j].amount + getGameUtilities()[buildOption.requiresUtility[j].utility].usage > getGameUtilities()[buildOption.requiresUtility[j].utility].capacity) {
                        costColor = "#F44336";
                    }

                    cost.push({
                        pre:    "Requires:",
                        post:   numberWithCommas(buildOption.requiresUtility[j].amount),
                        color:  costColor,
                        icon:   "images/" + def.icon
                    });
                }
            }

            for(j = 0; j < buildOption.cost.length; j++) {
                
                def = getResourceByDefName(buildOption.cost[j].resource);

                costColor = null;

                if(buildOption.cost[j].amount > getGameResources()[buildOption.cost[j].resource].amount) {
                    costColor = "#F44336";
                }

                cost.push({
                    pre:    "Cost:",
                    post:   def.indicator + numberWithCommas(buildOption.cost[j].amount),
                    color:  costColor,
                    icon:   "images/" + def.icon
                });
            }

            

            if(buildOption.providesUtility != null) {
                for(j = 0; j < buildOption.providesUtility.length; j++) {
                    
                    def = getUtilityByDefName(buildOption.providesUtility[j].utility);

                    costColor = null;

                    cost.push({
                        pre:    "Generates:",
                        post:   buildOption.providesUtility[j].amount,
                        color:  costColor,
                        icon:   "images/" + def.icon
                    });
                }
            }

            if(buildOption.acceptsWorkers != null && buildOption.acceptsWorkers > 0) {
                cost.push({
                    pre:    "Workers:",
                    post:   buildOption.acceptsWorkers,
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.colonistIcon
                });
            }

            if(buildOption.entertains != null && buildOption.entertains > 0) {
                cost.push({
                    pre:    "Entertains:",
                    post:   buildOption.entertains,
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.indRetired
                });
            }

            if(buildOption.educates != null && buildOption.educates > 0) {
                cost.push({
                    pre:    "Educates:",
                    post:   buildOption.educates,
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.indEducation
                });
            }

            if(buildOption.heals != null && buildOption.heals > 0) {
                cost.push({
                    pre:    "Heals:",
                    post:   buildOption.heals,
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.medicalIcon
                });
            }

            if(buildOption.requiPremium && !webAppCore.getIsPremium()) {
                cost.push({
                    pre:    null,
                    post:   "Premium Content",
                    color:  "#F44336",
                    icon:   "images/" + ColonyGame.meta.giftIndicator
                });
            }

            var img = null;

            if(buildOption.indicator == null) {

                var tiledef = null;

                if(type == "vehicle") {
                    tiledef = buildOption.tile[0];
                } else {
                    tiledef = buildOption.tile;
                }

                if(tiledef) {
                    var image = getImageAsset(tiledef,false,0,null);

                    if(image) {
                        img = image.src;
                    }
                }


            } else {
                img = "images/" + buildOption.indicator;
            }

            menuOptions.push({
                "title":        buildOption.name,
                "description":  getString(buildOption.description),
                "icon":         img,
                "overflow":     cost,
                "tag":          buildOption
            });

        }

        if(availableOptions > 0) {
            showList("Build Options",menuOptions,initConstruction,getString("general-dismiss"));
        } else {
            webAppCore.showAlertWithTitle("Nothing to build at this time.","No Build Options");
        }

    }

    var tmpListTitle;
    var tmpListItems;
    var tmpListCallback;
    var tmpListDismiss;

    function showList(title,items,callback,dismiss) {

        var forceNative = false;

        if(webAppCore.getPlatform().platform == "desktop") {
            if(parent.document.fullscreenElement || parent.document.webkitFullscreenElement || parent.document.mozFullScreenElement || parent.document.msFullscreenElement) {
                forceNative = true;
            }
        }

        if(forceNative && !titleShowing) {
            showMockNativeList(title,items,callback);
        } else {
            tmpListTitle = title;
            tmpListItems = items;
            tmpListCallback = callback;
            tmpListDismiss = dismiss;

            setTimeout(function() {
                webAppCore.presentNativeList(tmpListTitle,tmpListItems,tmpListCallback,tmpListDismiss);
            },150);
        }
    }

    function showMockNativeList(title, items,callback) {
        webAppCore.handleBackFunction(clearOutBuildMenu);

        document.getElementById("menuListTitle").innerHTML = title;
        document.getElementById("constructionMenuItems").innerHTML = "";
        

        var i,j;

        for(i = 0; i < items.length; i++) {
            
            var buildOption = items[i];
            
            var buildOptionDiv = document.createElement("div");
            buildOptionDiv.className = "buildOption";

            if(webAppCore.getPlatform().platform == "desktop" || ((webAppCore.getPlatform().platform == "web" || webAppCore.getPlatform().platform == "windows") && window.innerWidth > 500) ) {
                buildOptionDiv.className = "buildOption buildOptionDesktop";
            }

            buildOptionDiv.buildRef = buildOption;
            buildOptionDiv.buildingRef = buildOption.tag;
            buildOptionDiv.callbackref = callback;
            
            if(buildOption.icon) {
                var optionImage = document.createElement("img");
                optionImage.className = "buildOptionImage";
                optionImage.src = buildOption.icon;
                buildOptionDiv.appendChild(optionImage);
            }
            
            if(buildOption.title) {
                var optionNameSpan = document.createElement("span");
                optionNameSpan.innerHTML = buildOption.title;
                if(buildOption["title-color"]) {
                    optionNameSpan.style.color = buildOption["title-color"];
                }
                optionNameSpan.className = "buildOptionName";
                buildOptionDiv.appendChild(optionNameSpan);
            }
            
            if(buildOption.description) {
                var optionDescriptionSpan = document.createElement("span");
                optionDescriptionSpan.innerHTML = buildOption.description;
                optionDescriptionSpan.className = "buildOptionDescription";
                buildOptionDiv.appendChild(optionDescriptionSpan);
            }

            if(buildOption.status) {
                var optionStatusSpan = document.createElement("span");
                optionStatusSpan.innerHTML = buildOption.status;
                if(buildOption["status-color"]) {
                    optionStatusSpan.style.color = buildOption["status-color"];
                }
                optionStatusSpan.className = "buildOptionCost";
                buildOptionDiv.appendChild(optionStatusSpan);
            }

            if(buildOption.overflow) {
                for(j = 0; j < buildOption.overflow.length; j++) {

                    var overflowItem = buildOption.overflow[j];
                    var innerOption = "";

                    if(overflowItem.pre != null) {
                        innerOption += overflowItem.pre;
                    }

                    if(overflowItem.icon != null) {
                        innerOption += " <img src=\"" + overflowItem.icon + "\" /> ";
                    }

                    if(overflowItem.post != null) {
                        innerOption += overflowItem.post;
                    }

                    var optionCostSpan = document.createElement("span");
                    optionCostSpan.innerHTML = innerOption;
                    optionCostSpan.className = "buildOptionCost";
                    if(overflowItem.color != null) {
                        optionCostSpan.style.color = overflowItem.color;
                    }
                    buildOptionDiv.appendChild(optionCostSpan);
                }
            }

            if(callback) {
                buildOptionDiv.onclick = buildOptionDivClicked;
            }
            
            document.getElementById("constructionMenuItems").appendChild(buildOptionDiv);
        }
        
        
        document.getElementById("constructionMenu").style.display = "block";

        document.getElementById("constructionMenuItems").scrollTop = 0;
    }

    function buildOptionDivClicked() {
        clearOutBuildMenu();

        if(this.callbackref) {
            this.callbackref(this.buildingRef);
        }
        
    }

    function showBuildingConstructionOptions(object,type,islist) {

        if(!currentGame) {
            return;
        }
        
        if(object && object.lowPowerMode) {
            webAppCore.showToast("Low Power");
            return;
        }

        if(!getGameTechs()) {
            getRegionOrCity().unlockedTechs = {};
        }

        queuedBuildings = [];

        showBuildingConstructionOptionsNew(object,type,islist);
        return;

    }

    function hover(x,y,aX,aY,type) {

        if(killSwitch) {
            return;
        }

        if(gamepadInUse && type != "gamepad") {
            gamepadInUse = false;
            setBodyStyles();
        }

        sidebarTypeFilter.blur();
        window.focus();

        document.getElementById("sidebarCostInfoBox").style.display = "none";

        actualX = aX;
        actualY = aY;

        if(currentViewBounds == null) {
            return;
        }

        if(currentGame == null) {
            return;
        }
        
        if(currentGame.isSubregion && currentRegion && !currentRegion.isMpRegionHolder) {
            if(x < -1 || x > currentGame.width + 1) {
                return;
            }
            
            if(y < -1 || y > currentGame.height + 1) {
                return;
            }
        } else {
            if(x < 0 || x > currentGame.width) {
                return;
            }
            
            if(y < 0 || y > currentGame.height) {
                return;
            }
        }
        
        
        usingMouse = true;

        if(x == hoverX && y == hoverY) {
            return;
        }

        document.getElementById("popupTooltip").style.display = "none";

        hoverX = x;
        hoverY = y;
        var i;

        var newHoverBuilding = null;


        if(!inMultiSelectionMode && selectedBuilding == null && queuedBuilding == null && selectedVehicle.length == 0) {
            for(i = 0; i < currentGame.buildings.length; i++) {

                if(!currentGame.buildings[i]) {
                    continue;
                }

                if(currentGame.buildings[i].x < currentViewBounds.minX || currentGame.buildings[i].x > currentViewBounds.maxX) {
                    continue;
                }

                if(currentGame.buildings[i].y < currentViewBounds.minY || currentGame.buildings[i].y > currentViewBounds.maxY) {
                    continue;
                }
                
                if(currentGame.buildings[i].occupiesTiles != null) {
                    for(var j = 0; j < currentGame.buildings[i].occupiesTiles.length; j++) {
                        if(currentGame.buildings[i].occupiesTiles[j].x == x && currentGame.buildings[i].occupiesTiles[j].y == y) {
                            newHoverBuilding = currentGame.buildings[i];
                            break;
                        }

                        if(newHoverBuilding != null) {
                            break;
                        }
                    }
                }
            }
        }

        if(newHoverBuilding != hoverBuilding) {
            hoverBuilding = newHoverBuilding;

            

            if(hoverBuilding == null || (!desktopMode && !gamepadInUse)) {
                document.getElementById("bottomHoverReadout").innerHTML = "";
                document.getElementById("bottomHoverReadout").style.display = "none";
                document.getElementById("popupTooltip").style.display = "none";
            } else {
                document.getElementById("bottomHoverReadout").innerHTML = hoverBuilding.name;
                document.getElementById("bottomHoverReadout").style.display = "inline-block";

                if(hoverBuilding.customText.trim().length > 0) {
                    showHoverPopup(hoverBuilding.customText.trim());
                }
            }
        }

        if(currentGame.isSubregion && currentRegion && !currentRegion.isMpRegionHolder) {

            

            if(x == -1 || x == (currentGame.width + 1) || y == -1 || y == (currentGame.height + 1)) {

                if(currentSubcityRef) {
                    var neighborName = getString("unexplored-territory");

                    var checkCity = null;
                    var useCitySize = 1;

                    if(currentSubcityRef.size == 100) {
                        useCitySize = 2;
                    }

                    if(x == -1) {
                        if(y <= 50) {
                            checkCity = getSubregionByCoord(currentSubcityRef.x - 1,currentSubcityRef.y);
                        } else {
                            checkCity = getSubregionByCoord(currentSubcityRef.x - 1,currentSubcityRef.y + 1);
                        }
                    }

                    if(x == (currentGame.width + 1)) {
                        if(y <= 50) {
                            checkCity = getSubregionByCoord(currentSubcityRef.x + useCitySize,currentSubcityRef.y);
                        } else {
                            checkCity = getSubregionByCoord(currentSubcityRef.x + useCitySize,currentSubcityRef.y + 1);
                        }
                    }

                    if(y == -1) {
                        if(x <= 50) {
                            checkCity = getSubregionByCoord(currentSubcityRef.x,currentSubcityRef.y - 1);
                        } else {
                            checkCity = getSubregionByCoord(currentSubcityRef.x + 1,currentSubcityRef.y - 1);
                        }
                    }

                    if(y == (currentGame.height + 1)) {
                        if(x <= 50) {
                            checkCity = getSubregionByCoord(currentSubcityRef.x,currentSubcityRef.y + useCitySize);
                        } else {
                            checkCity = getSubregionByCoord(currentSubcityRef.x + 1,currentSubcityRef.y + useCitySize);
                        }
                    }

                    if(checkCity) {
                        neighborName = checkCity.name;
                    }

                    var neighboringCityOptions = {
                        title: null,
                        text: neighborName,
                        extra: null,
                        iconsArray: null
                    };
    
                    showHoverPopupWithOptions(neighboringCityOptions);
                }

                
            }
        }

        if(currentGame.isRegion) {
            currentHoverCity = getSubregionByCoord(x,y);

            if(currentHoverCity != null) {

                var resIcons = [];
                var sortRes = [];

                for(var res in currentHoverCity.resourceHistory) {
                    if(currentHoverCity.resourceHistory[res].avg > 0) {
                        sortRes.push({
                            res: res,
                            amt: currentHoverCity.resourceHistory[res].avg
                        });
                    }
                }

                sortRes.sort(sortCityPopupResources);

                for(var ri = 0; ri < sortRes.length; ri++) {
                    var theres = sortRes[ri];
                    var rDef = getResourceByDefName(theres.res);

                    var src = "images/" + rDef.icon;

                    resIcons.push(src);

                    if(ri > 4) {
                        break;
                    }
                }

                if(type != "touch") {

                    var extraText = null;

                    if(currentHoverCity.description && currentHoverCity.description.trim().length > 0) {
                        extraText = replaceAll(currentHoverCity.description,"\n","<br />");
                    } else {
                        if(currentGame.isMpRegionHolder && currentHoverCity.apeAppsUsername) {
                            extraText = currentHoverCity.apeAppsUsername;

                            var metroAreaId = currentHoverCity.metroAreaDistrict;
                            var metroAreaName = currentGame.metroAreaNameRef[metroAreaId];

                            if(metroAreaName && metroAreaName.open == 1) {
                                extraText += "<br /><span class=\"openMetro\">Open Metro</span>";
                            }
                        }
                    }

                    var cityPopupOptions = {
                        title: currentHoverCity.name,
                        text: "Population: " + numberWithCommas(currentHoverCity.population),
                        extra: extraText,
                        iconsArray: resIcons
                    };

                    showHoverPopupWithOptions(cityPopupOptions);
                }

                var metInfo = null;

                if(currentHoverCity.metroAreaDistrict) {
                    metInfo = getMetroAreaStats(currentHoverCity.metroAreaDistrict);
                }

                if(metInfo) {
                    document.getElementById("bottomHoverReadout").innerHTML = metInfo.name + " (" + numberWithCommas(metInfo.population) + ")";
                } else {
                    document.getElementById("bottomHoverReadout").innerHTML = currentHoverCity.name + " (" + numberWithCommas(currentHoverCity.population) + ")";
                }
                
                
                document.getElementById("bottomHoverReadout").style.display = "inline-block";
            } else {
                document.getElementById("bottomHoverReadout").style.display = "none";
            }
        }
        
        hoverPassable = isTilePassable(hoverX,hoverY);
        
        if(queuedBuilding) {
            checkForQueueBlockage(hoverX,hoverY);

            handleChain(x,y);
        }
    }

    function getMetroAreaStats(area) {

        if(!currentGame.isRegion) {
            return null;
        }

        var metroStats = {
            name: "Metro Area #" + area,
            population: 0
        };

        for(var i = 0; i < currentGame.subRegions.length; i++) {
            var sr = currentGame.subRegions[i];

            if(parseInt(sr.metroAreaDistrict) == parseInt(area)) {
                if(!sr.population) {
                    sr.population = 0;
                }
    
                metroStats.population += parseInt(sr.population);
            }

            
        }

        if(currentGame.metroAreaNameRef[area]) {
            metroStats.name = currentGame.metroAreaNameRef[area].name + " Metro Area";
        }

        return metroStats;

    }

    function handleChain(x,y) {

        if(!chainBuildMode) {
            return;
        }

        var buildOvers = null;

        if(queuedBuilding && queuedBuilding.canBuildOver && queuedBuilding.canBuildOver.length > 0) {
            buildOvers = queuedBuilding.canBuildOver;
        }

        if(collisionReference != null && cqX != null && cqY != null) {

            var i;
            chainQueue = [];

            if(x == cqX) {
                if(y < cqY) {
                    for(i = cqY - 1; i >= y; i--) {
                        chainQueue.push({"x":x,"y":i});
                    }
                }

                if(y > cqY) {
                    for(i = cqY + 1; i <= y; i++) {
                        chainQueue.push({"x":x,"y":i});
                    }
                }
            }

            if(y == cqY) {
                if(x < cqX) {
                    for(i = cqX - 1; i >= x; i--) {
                        chainQueue.push({"x":i,"y":y});
                    }
                }

                if(x > cqX) {
                    for(i = cqX + 1; i <= x; i++) {
                        chainQueue.push({"x":i,"y":y});
                    }
                }
            }

            for(i = 0; i < chainQueue.length; i++) {
                if(!isTilePassable(chainQueue[i].x,chainQueue[i].y,true,false,false,buildOvers)) {
                    chainQueue = [];
                }
            }
        } else {
            chainQueue = [];
        }
    }
    
    function checkForQueueBlockage(x,y) {
        queuedBuildingBlocked = checkForGeneralBlockage(queuedBuilding,x,y,flipChainedStructures);

    }
    
    function checkForGeneralBlockage(building,x,y,flipped,excludeTiles,excludeQueue) {

        if(!flipped) {
            flipped = false;
        }

        if(!excludeTiles) {
            excludeTiles = [];
        }

        var useWidth = building.tileWidth;
        var useHeight = building.tileHeight;

        if(flipped) {
            useWidth = building.tileHeight;
            useHeight = building.tileWidth;
        }


        var qX,qY,buildOvers;

        if(building && building != null) {
            for(qX = 0; qX < useWidth; qX++) {
                for(qY = 0; qY < useHeight; qY++) {

                    var isExcluded = false;

                    for(var j = 0; j < excludeTiles.length; j++) {
                        if(excludeTiles[j].x == (x + qX) && excludeTiles[j].y == (y + qY)) {
                            isExcluded = true;
                            break;
                        }
                    }

                    if(isExcluded) {
                        continue;
                    }

                    buildOvers = null;

                    if(building.canBuildOver && building.canBuildOver.length > 0) {
                        buildOvers = building.canBuildOver;
                    }


                    if(!isTilePassable(x + qX,y + qY,true,false,false,buildOvers)) {
                        return true;
                    }

                    if(queuedBuildings != null && !excludeQueue) {
                        for(var i = 0; i < queuedBuildings.length; i++) {
                            for(var qXq = 0; qXq < useWidth; qXq++) {
                                for(var qYq = 0; qYq < useHeight; qYq++) {
                                    var blockedX = queuedBuildings[i].x + qXq;
                                    var blockedY = queuedBuildings[i].y + qYq;

                                    if(((x + qX) == blockedX) && ((y + qY) == blockedY)) {
                                        return true;
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }

        return false;
    }
    
    function hold() {
        
    }
    
    function isTilePassable(x,y,decorationsBlock,isFlying,sayWhyFailed,canBuildOverTypes) {

        if(x < 0 || y < 0) {
            if(sayWhyFailed) {
                //console.log("out of bounds low: " + x + ":" + y);
            }

            return false;
        }

        var i,passdef,decHere,td,tx,ty,isAbleToBuildOn;

        if(currentGame.isRegion) {
            if(x > 50 || y > 50) {
                if(sayWhyFailed) {
                    //console.log("out of bounds low: " + x + ":" + y);
                }
    
                return false;
            }

            for(i = 0; i < currentGame.subRegions.length; i++) {

                var sr = currentGame.subRegions[i];

                var useSize = 1;

                if(sr.size == 100) {
                    useSize = 2;
                }


                for(var sX = 0; sX < useSize; sX++) {
                    for(var sY = 0; sY < useSize; sY++) {
                        var usX = sr.x + sX;
                        var usY = sr.y + sY;
    
                        if(usX == x && usY == y) {
                            return false;
                        }
                    }
                }
            }

            return true;
        }
        
        if(!collisionReference || !collisionReference[0]) {
            createCollisionReference();
        }


        if(x >= collisionReference.length || y >= collisionReference[0].length) {

            return false;
        }

        var checkRef = collisionReference;

        if(isFlying) {
            checkRef = flyingCollisionReference;
        }
        
        var passable = true;
        
        
        var j;

        
        
        if(decorationsBlock) {
            for(i = 0; i < currentGame.passableNonUpdatables.length; i++) {
                if(currentGame.passableNonUpdatables[i].occupiesTiles != null) {
                    for(j = 0; j < currentGame.passableNonUpdatables[i].occupiesTiles.length; j++) {

                        if(currentGame.passableNonUpdatables[i].occupiesTiles[j].x == x && currentGame.passableNonUpdatables[i].occupiesTiles[j].y == y) {

                            if(sayWhyFailed) {
                                console.log("decoration occupies: " + x + ":" + y);
                            }

                            return false;
                        }
                    }
                }
            }

            // new, complete passables 
            for(passdef in currentGame.finishedPassableNonUpdatables) {
                td = currentGame.finishedPassableNonUpdatables[passdef];

                if(td[x]) {
                    tx = td[x];

                    for(ty = 0; ty < tx.length; ty++) {
                        if(parseInt(tx[ty]) == y) {

                            if(sayWhyFailed) {
                                console.log("new passable occupies: " + x + ":" + y);
                            }

                            return false;
                        }
                    }
                }


            }
        }

        if(checkRef[x] == null || checkRef[x][y] >= 15 || (decorationsBlock && checkRef[x][y] == 1)) {

            if(canBuildOverTypes && canBuildOverTypes.length > 0) {

                isAbleToBuildOn = false;

                for(i = 0; i < currentGame.mapResources.length; i++) {
                    if(currentGame.mapResources[i].occupiesTiles == null) {
                        continue;
                    }

                    if(canBuildOverTypes.indexOf(currentGame.mapResources[i].def) > -1) {
                        for(j = 0; j < currentGame.mapResources[i].occupiesTiles.length; j++) {
                            if(currentGame.mapResources[i].occupiesTiles[j].x == x && currentGame.mapResources[i].occupiesTiles[j].y == y) {
                                isAbleToBuildOn = true;
                                break;
                            }
                        }
                    }

                    if(isAbleToBuildOn) {
                        break;
                    }
                }

                if(!isAbleToBuildOn) {
                    return false;
                }
                
            } else {
                if(!decorationsBlock) {
                    decHere = false;

                    for(passdef in currentGame.finishedPassableNonUpdatables) {
                        td = currentGame.finishedPassableNonUpdatables[passdef];
        
                        if(td[x]) {
                            tx = td[x];
        
                            for(ty = 0; ty < tx.length; ty++) {
                                if(parseInt(tx[ty]) == y) {
                                    decHere = true;
                                }

                                if(decHere) {
                                    break;
                                }
                            }
                        }
        
                        if(decHere) {
                            break;
                        }
        
                    }

                    if(!decHere) {
                        return false;
                    }
                } else {
                    return false;
                }

                
            }

            
        } else {
            if(canBuildOverTypes && canBuildOverTypes.length > 0) {
                isAbleToBuildOn = false;

                for(i = 0; i < currentGame.mapResources.length; i++) {
                    if(currentGame.mapResources[i].occupiesTiles == null) {
                        continue;
                    }

                    if(canBuildOverTypes.indexOf(currentGame.mapResources[i].def) > -1) {
                        for(j = 0; j < currentGame.mapResources[i].occupiesTiles.length; j++) {
                            if(currentGame.mapResources[i].occupiesTiles[j].x == x && currentGame.mapResources[i].occupiesTiles[j].y == y) {
                                isAbleToBuildOn = true;
                                break;
                            }
                        }
                    }

                    if(isAbleToBuildOn) {
                        break;
                    }
                }

                if(!isAbleToBuildOn) {
                    return false;
                }
            }
        }

        return passable;
    }

    function createCollisionReference() {
        collisionReference = [];
        flyingCollisionReference = [];

        if(!currentGame || !currentGame.width) {
            return;
        }

        for(var x = 0; x <= currentGame.width; x++) {
            collisionReference[x] = new Array(currentGame.height);
            flyingCollisionReference[x] = new Array(currentGame.height);
        }

        resetCollisionReference();
    }

    function resetCollisionReference() {

        if(!collisionReference) {
            collisionReference = [];
        }

        for(var x = 0; x <= currentGame.width; x++) {

            if(!collisionReference[x]) {
                collisionReference[x] = [];
            }

            if(!flyingCollisionReference[x]) {
                flyingCollisionReference[x] = [];
            }

            for(var y = 0; y <= currentGame.height; y++) {
                collisionReference[x][y] = 5;
                flyingCollisionReference[x][y] = 5;
            }
        }
    }

    function modifyCollisionWeight(x,y,weight,flightOk) {

        if(!buildingUpdateCycle) {
            return;
        }

        if(collisionReference == null || collisionReference[x] == null) {
            return;
        }

        collisionReference[x][y] += parseInt(weight);

        if(!flightOk) {
            flyingCollisionReference[x][y] += parseInt(weight);
        }

        if(collisionReference[x][y] < 1) {
            collisionReference[x][y] = 1;   
        }

        if(flyingCollisionReference[x][y] < 1) {
            flyingCollisionReference[x][y] = 1;   
        }
    }
    
    function updateCollisionMap() {
        
        if(!currentGame) {
            return;
        }

        var i;

        for(i = 0; i < currentGame.buildings.length; i++) {

            if(!currentGame.buildings[i]) {
                continue;
            }

            currentGame.buildings[i].fr = null;
        }

        for(i = 0; i < currentGame.mapResources.length; i++) {
            if(!currentGame.mapResources[i]) {
                continue;
            }

            currentGame.mapResources[i].fr = null;
        }

        var sendMap = [];
        retainedPaths = {};

        for(var x = 0; x <= currentGame.width; x++) {
            sendMap[x] = new Array(currentGame.height);

            for(var y = 0; y <= currentGame.height; y++) {

                if(collisionReference && collisionReference[x] && collisionReference[x][y]) {
                    sendMap[x][y] = parseInt(collisionReference[x][y]);

                    if(sendMap[x][y] >= 15) {
                        sendMap[x][y] = 0;
                    }
                } else {
                    sendMap[x][y] = 0;
                }
                
            }
        }

        if(useSyncPathfinding) {
            syncColMap = new Graph(sendMap);
        } else {
            pathWorker1.postMessage({
                "method": "updateCollisionMap",
                "data": sendMap
            });
        }

        

        sendMap = null;

        shouldUpdateCollissionMap = false;

    }

    var gamepadSelectionButton = 0;
    var cameFromGamepad = false;

    function resetObjectOptions() {

        gamepadSelectionButton = 0;

        var buttons = document.getElementById("objectOptions").querySelectorAll(".objectOptionIcon");
        for(var i = 0; i < buttons.length; i++) {
            buttons[i].isGamepadSelectionButton = false;
            buttons[i].style.backgroundColor = null;
        }
    }

    function highlightSelectedObjectButton() {
        var buttons = document.getElementById("objectOptions").querySelectorAll(".objectOptionIcon");
        for(var i = 0; i < buttons.length; i++) {
            if(i == gamepadSelectionButton) {
                buttons[i].isGamepadSelectionButton = true;
                buttons[i].style.backgroundColor = "rgba(255,255,255,.5)";
                document.getElementById("objectGamepadHint").innerHTML = buttons[i].title;
                document.getElementById("objectGamepadHint").style.display = "block";
            } else {
                buttons[i].isGamepadSelectionButton = false;
                buttons[i].style.backgroundColor = null;
            }
            
        }
    }

    function executeSelectedGamepadButton() {
        var buttons = document.getElementById("objectOptions").querySelectorAll(".objectOptionIcon");
        buttons[gamepadSelectionButton].click();
    }

    function updateCostRemainingArea() {

        if(selectedBuilding == null) {
            return;
        }

        if(document.getElementById("objectOptions").style.display == "none") {
            return;
        }

        document.getElementById("costRemainingArea").innerHTML = "";

        if(!selectedBuilding.iuc) {
            return;
        }

        if(selectedBuilding.c == null) {
            return;
        }

        for(var prop in selectedBuilding.c.pr) {
            

            if(selectedBuilding.c.pr[prop] > 0) {
                var cItem = document.createElement("div");

                var cImg = document.createElement("img");
                cImg.src = "images/" + getResourceByDefName(prop).icon;
                cItem.appendChild(cImg);

                var cSpan = document.createElement("span");
                cSpan.innerHTML = selectedBuilding.c.pr[prop];
                cItem.appendChild(cSpan);

                document.getElementById("costRemainingArea").appendChild(cItem);
            }
        }
    }

    function showHoverPopupWithOptions(options) {
        var x = actualX;

        if(options.customX) {
            x = options.customX;
        }

        var y = actualY;

        if(options.customY) {
            y = options.customY;
        }

        if(!options.text || options.text.trim().length == 0) {
            document.getElementById("popupTooltip").style.display = "none";
            return;
        }

        if(!cameFromGamepad && usingMouse) {

            document.getElementById("popupTooltip").style.display = "block";

            var rightOffset = 0;

            if(desktopMode) {
                rightOffset = 220;
            }

            var useOffset = 36;

            if(y < 64) {
                useOffset = 16;
            }

            if(x > (window.innerWidth - rightOffset) / 2) {
                document.getElementById("popupTooltip").style.right = (((window.innerWidth - rightOffset) - x) + useOffset) + "px";
                document.getElementById("popupTooltip").style.left =  "initial";
            } else {
                document.getElementById("popupTooltip").style.left = (x + useOffset) + "px";
                document.getElementById("popupTooltip").style.right =  "initial";
            }

            if(y > window.innerHeight / 2) {
                document.getElementById("popupTooltip").style.bottom = ((window.innerHeight - y) + useOffset) + "px";
                document.getElementById("popupTooltip").style.top = "initial";
            } else {
                document.getElementById("popupTooltip").style.top = (y + useOffset) + "px";
                document.getElementById("popupTooltip").style.bottom = "initial";
            }

            var useExtra = "";

            if(options.extra) {
                useExtra = options.extra;
            }

            if(document.getElementById("popupTooltipExtra").innerHTML != useExtra) {
                document.getElementById("popupTooltipExtra").innerHTML = useExtra;
            }

            var useTitle = "";

            if(options.title) {
                useTitle = options.title;
            }

            if(document.getElementById("popupTooltipTitle").innerHTML != useTitle) {
                document.getElementById("popupTooltipTitle").innerHTML = useTitle;
            }

            var useText = "";

            if(options.text) {
                useText = options.text;
            }

            if(document.getElementById("popupTooltipText").innerHTML != useText) {
                document.getElementById("popupTooltipText").innerHTML = useText;
            }

            if(options.color) {
                document.getElementById("popupTooltipText").style.color = options.color;
            } else {
                document.getElementById("popupTooltipText").style.color = "#ffffff";
            }

            if(options.barPercent != null && options.barPercent != undefined && !isNaN(options.barPercent)) {
                document.getElementById("popupBarHolder").style.display = "block";
                document.getElementById("popupTooltipText").style.marginLeft = "8px";
                document.getElementById("popupTooltipIcons").style.marginLeft = "8px";
                document.getElementById("popupTooltipTitle").style.marginLeft = "8px";
                document.getElementById("popupTooltipExtra").style.marginLeft = "8px";

                if(options.barPercent > 100) {
                    options.barPercent = 100;
                }

                document.getElementById("popupBar").style.height = options.barPercent + "%";

                if(options.barColor) {
                    document.getElementById("popupBar").style.backgroundColor = options.barColor;

                    var bgc = hexToOffset(options.barColor,-90);

                    document.getElementById("popupBarHolder").style.backgroundColor = "rgb(" + bgc.r + "," + bgc.g + "," + bgc.b + ")";
                } else {
                    document.getElementById("popupBar").style.backgroundColor = "#4CAF50";
                    document.getElementById("popupBarHolder").style.backgroundColor = "#1B5E20";
                }
            } else {
                document.getElementById("popupBarHolder").style.display = "none";
                document.getElementById("popupTooltipText").style.marginLeft = "0px";
                document.getElementById("popupTooltipIcons").style.marginLeft = "0px";
                document.getElementById("popupTooltipTitle").style.marginLeft = "0px";
                document.getElementById("popupTooltipExtra").style.marginLeft = "0px";
            }
        }

        document.getElementById("popupTooltipIcons").innerHTML = "";

        if(options.iconsArray && options.iconsArray.length > 0) {

            for(var i = 0; i < options.iconsArray.length; i++) {
                var anIcon = document.createElement("img");
                anIcon.draggable = false;
                anIcon.src = options.iconsArray[i];
                document.getElementById("popupTooltipIcons").appendChild(anIcon);
            }

            
        }
    }

    function showHoverPopup(text,customX,customY,title,color,barPercent,barColor,iconsArray) {

        var options = {};

        if(text) {
            options.text = text;
        }

        if(customX) {
            options.customX = customX;
        }

        if(customY) {
            options.customY = customY;
        }

        if(title) {
            options.title = title;
        }

        if(color) {
            options.color = color;
        }

        if(barPercent) {
            options.barPercent = barPercent;
        }

        if(barColor) {
            options.barColor = barColor;
        }

        if(iconsArray) {
            options.iconsArray = iconsArray;
        }

        showHoverPopupWithOptions(options);
    }
    
    function showOptionsForObject(object,type,isRCReshow,passableX,passableY) {

        if(object == null || currentGame == null) {
            return;
        }

        if(currentGame.readOnlyMode) {
            return;
        }

        pendingMoveBuilding = null;

        Scroll2d.gamepadAllStop();

        var tipsToShow = [];


        if(type == "building") {
            handleBuildingWorkerCleanup(object);
        }

        var isMultiSelection = false;

        if(object == selectedVehicle) {
            if(selectedVehicle.length > 1) {
                isMultiSelection = true;
            }
            object = selectedVehicle[0];
        }

        var rightOffset = 0;
        var i;

        if(desktopMode) {
            rightOffset = 220;
        }

        if(!cameFromGamepad && selectedVehicle.length <= 1 && usingMouse && (window.innerWidth - rightOffset) >= 640 && type == "building") {

            if(actualX > (window.innerWidth - rightOffset) / 2) {
                document.getElementById("objectOptions").style.right = (((window.innerWidth - rightOffset) - actualX) + 32) + "px";
                document.getElementById("objectOptions").style.left =  "initial";
            } else {
                document.getElementById("objectOptions").style.left = (actualX + 32) + "px";
                document.getElementById("objectOptions").style.right =  "initial";
            }

            if(actualY > window.innerHeight / 2) {
                document.getElementById("objectOptions").style.bottom = ((window.innerHeight - actualY) + 32) + "px";
                document.getElementById("objectOptions").style.top = "initial";
            } else {
                document.getElementById("objectOptions").style.top = (actualY + 32) + "px";
                document.getElementById("objectOptions").style.bottom = "initial";
            }
        } else {
            document.getElementById("objectOptions").style.top = "initial";
            document.getElementById("objectOptions").style.right =  "initial";
            document.getElementById("objectOptions").style.left =  "initial";

            if(window.innerWidth <= 500) {
                document.getElementById("objectOptions").style.bottom = "0px";
                document.getElementById("objectOptions").style.right = "0px";
                document.getElementById("objectOptions").style.borderBottomLeftRadius = "0px";
                document.getElementById("objectOptions").style.borderTopLeftRadius = null;
                document.getElementById("objectOptions").style.borderBottomRightRadius = "0px";
                document.getElementById("objectOptions").style.borderTopRightRadius = "0px";
            } else {
                document.getElementById("objectOptions").style.bottom = "12px";
                document.getElementById("objectOptions").style.left = "12px";
                document.getElementById("objectOptions").style.borderBottomLeftRadius = null;
                document.getElementById("objectOptions").style.borderTopLeftRadius = null;
                document.getElementById("objectOptions").style.borderBottomRightRadius = null;
                document.getElementById("objectOptions").style.borderTopRightRadius = null;

                if(cameFromGamepad) {
                    document.getElementById("objectOptions").style.bottom = "48px";
                    document.getElementById("objectOptions").style.left = "48px";
                }
            }

            
        }



        document.getElementById("objectDismissIcon").title = getString("general-dismiss");
        appendShortcutTitleToButton(document.getElementById("objectDismissIcon"),"KEY_CLEAR",KEY_DEFAULT_CLEAR);
        document.getElementById("objectDismissIcon").style.display = "inline-block";

        tipsToShow.push({
            icon: "images/" + ColonyGame.meta.indDismiss,
            tip: "object-options-dismiss-tip"
        });

        if(isMultiSelection) {
            document.getElementById("objectName").innerHTML = getString("general-multiple") + " (x" + selectedVehicle.length + ")";
        } else {

            if(!object) {
                return;
            }

            if(type == "finishedpassable") {
                document.getElementById("objectName").innerHTML = object;
            } else {
                if(object) {
                    if(object.name) {
                        document.getElementById("objectName").innerHTML = object.name;
                    } else {
                        if(object.def && object.id) {
                            document.getElementById("objectName").innerHTML = object.def + " #" + object.id;
                        }
                    }
                }
                
            }

            if(type == "vehicle") {
                if(object.grp && object.grp > 1) {
                    document.getElementById("objectName").innerHTML += " (" + getString("gen-group") + " x" + object.grp + ")";
                }
            }
            
        }

        document.getElementById("objectCancel").style.display = "none";

        document.getElementById("costRemainingArea").innerHTML = "";
        document.getElementById("objectExtra").innerHTML = "";

        document.getElementById("objectCondition").innerHTML = "";
        document.getElementById("objectGamepadHint").style.display = "none";
        document.getElementById("objectExtra").style.color = null;
        document.getElementById("objectHire").style.display = "none";
        document.getElementById("objectImportIcon").style.display = "none";
        document.getElementById("objectExportIcon").style.display = "none";
        document.getElementById("objectUpgradeIcon").style.display = "none";
        document.getElementById("objectParkIcon").style.display = "none";
        document.getElementById("objectStatsIcon").style.display = "none";
        document.getElementById("objectPolicyIcon").style.display = "none";
        document.getElementById("objectDiplomacyIcon").style.display = "none";
        document.getElementById("objectCommunicationsIcon").style.display = "none";
        
        document.getElementById("objectDestructIcon").style.display = "none";
        document.getElementById("objectExecute").style.display = "none";
        document.getElementById("objectConscript").style.display = "none";
        document.getElementById("objectDestroyIcon").style.display = "none";
        document.getElementById("objectHarvestIcon").style.display = "none";
        document.getElementById("objectActivationIcon").style.display = "none";

        document.getElementById("objectRename").style.display = "none";
        document.getElementById("objectFlipIcon").style.display = "none";
        document.getElementById("objectSetText").style.display = "none";
        document.getElementById("objectRepairIcon").style.display = "none";
        document.getElementById("objectCommonwealthIcon").style.display = "none";
        document.getElementById("objectMakeCenterIcon").style.display = "none";
        document.getElementById("objectDeployLoadedIcon").style.display = "none";
        document.getElementById("objectTradeIcon").style.display = "none";
        document.getElementById("objectDeployIcon").style.display = "none";
        document.getElementById("objectCloneIcon").style.display = "none";
        document.getElementById("objectMoveIcon").style.display = "none";
        document.getElementById("objectGroupIcon").style.display = "none";
        document.getElementById("objectUngroupIcon").style.display = "none";

        var soundToPlay = null;

        soundToPlay = ColonyGame.sounds.defaultSelectSound;

        document.getElementById("objectOptions").style.display = "block";

        webAppCore.handleBackFunction(clearOutBuildMenu);
        
        
        if(type == "vehicle" || type == "building") {
            if(object.owner != getRegionOrCity().localPlayerId) {

                if(object.owner == currentGame.localPlayerId) {
                    object.owner = getRegionOrCity().localPlayerId;
                } else {
                    return;
                }

                return;
            }
        }
        


        if(!gamepadInUse) {
            if(type == "finishedpassable" || type == "passable" || type == "building" || type == "vehicle" || type == "colonist") {
                document.getElementById("objectStatsIcon").style.display = "inline-block";
                document.getElementById("objectStatsIcon").onclick = function() {
                    closeObjectOptionsAndClear();

                    if(type == "finishedpassable") {
                        showNewObjectOptionsMenu(object,"passable",passableX,passableY);
                    } else {
                        showNewObjectOptionsMenu(object,type,object.x,object.y);
                    }
                    
                };

                tipsToShow.push({
                    icon: "images/" + ColonyGame.meta.indStats,
                    tip: "object-options-stats-tip"
                });
            }
        }

        var muhDef;
        var upgradeOption;

        if(type == "finishedpassable") {
            muhDef = getBuildingDefByName(object);

            // check for build limit at some point

            if(canIAffordThis(muhDef.cost)) {
                document.getElementById("objectCloneIcon").style.display = "inline-block";

                tipsToShow.push({
                    icon: "images/" + ColonyGame.meta.indCloneObject,
                    tip: "object-options-clone-tip"
                });

                document.getElementById("objectCloneIcon").onclick = function() {
                    closeObjectOptionsAndClear();
                    initConstruction(muhDef);

                };
            }

            upgradeOption = isUpgradeAvailableForStructure(muhDef,true);

            if(upgradeOption != null) {
                if(canIBuildThis(upgradeOption.structure,"building",true)) {
                    if(altudown) {
                        doNewPassableUpgrade(object,upgradeOption,passableX,passableY);
                        selectedBuilding = null;
                        closeObjectOptionsAndClear();
                    } else {
                        document.getElementById("objectUpgradeIcon").style.display = "inline-block";
                        document.getElementById("objectUpgradeIcon").onclick = function() {
                            document.getElementById("objectOptions").style.display = "none";
                            doNewPassableUpgrade(object,upgradeOption,passableX,passableY);
                            closeObjectOptionsAndClear();
                        };
    
                        tipsToShow.push({
                            icon: "images/" + ColonyGame.meta.indUpgrade,
                            tip: "object-options-upgrade-tip"
                        });
                        
                        document.getElementById("objectUpgradeIcon").title = getString("general-upgrade");
                        appendShortcutTitleToButton(document.getElementById("objectUpgradeIcon"),"KEY_UPGRADE",KEY_DEFAULT_UPGRADE);
                    }
                }
            }
        }
        
        if(type == "building" || object.c != null || (type == "passable" && object.iuc)) {

            muhDef = getBuildingDefByName(object.def);

            if((!object.embassyFor || object.embassyFor == 0) && canIAffordThis(muhDef.cost)) {

                var canClone = true;
                var existingStructures = 0;

                if(muhDef.buildLimit > 0) {

                    var killList = [];

                    for(i = 0; i < currentGame.buildings.length; i++) {

                        if(!currentGame.buildings[i]) {
                            killList.push(currentGame.buildings[i]);
                            continue;
                        }

                        if(currentGame.buildings[i].def && currentGame.buildings[i].def == muhDef.name) {
                            existingStructures++;
    
                            if(existingStructures >= muhDef.buildLimit) {
                                canClone = false;
                                break;
                            }
                        }
                    }

                    while(killList.length > 0) {
                        removeFromArray(currentGame.buildings,killList.pop());
                    }
                }

                if(canClone) {
                    document.getElementById("objectCloneIcon").style.display = "inline-block";

                    tipsToShow.push({
                        icon: "images/" + ColonyGame.meta.indCloneObject,
                        tip: "object-options-clone-tip"
                    });
    
                    document.getElementById("objectCloneIcon").onclick = function() {
                        closeObjectOptionsAndClear();
                        initConstruction(muhDef);

                        if(object.flipped) {
                            flipChainedStructures = object.flipped;
                        }
                    };
                }
                
            }

            if(!object.iuc) {

                tipsToShow.push({
                    icon: "images/" + ColonyGame.meta.indActivateBld,
                    tip: "object-options-activation-tip"
                });

                document.getElementById("objectActivationIcon").style.display = "inline-block";
                if(object.deactivated) {
                    document.getElementById("objectActivationIcon").src = "images/" + ColonyGame.meta.indActivateBld;
                    document.getElementById("objectActivationIcon").title = getString("general-activate");
                } else {
                    document.getElementById("objectActivationIcon").src = "images/" + ColonyGame.meta.indDeactivateBld;
                    document.getElementById("objectActivationIcon").title = getString("general-deactivate");

                    if(muhDef.packsTo != null) {
                        
                        var packsToDef = getVehicleDefByName(muhDef.packsTo);

                        if(packsToDef != null) {
                            document.getElementById("objectDeployIcon").style.display = "inline-block";

                            document.getElementById("objectDeployIcon").src = "images/" + packsToDef.indicator;
                            document.getElementById("objectDeployIcon").title = "Pack to " +  packsToDef.name;

                            document.getElementById("objectDeployIcon").onclick = function() {
                                closeObjectOptionsAndClear();
                                packBuilding(object);
                            };
                        }
                    }

                }

                document.getElementById("objectActivationIcon").onclick = function() {
                    closeObjectOptionsAndClear();
                    object.deactivated = !object.deactivated;
                    updateUtilityGrid();
                };
            }

            document.getElementById("objectHarvestIcon").style.display = "none";
            document.getElementById("objectMoveIcon").style.display = "none";
            document.getElementById("objectParkIcon").style.display = "none";

            var alsoHasWorkers = false;
            

            if(muhDef.acceptsWorkers > 0) {

                alsoHasWorkers = true;



                var working = object.buW;



                var occ = "Unskilled";
                var occupationDef = getOccupationDefByName(muhDef.occupation);
                var occImage = "images/" + ColonyGame.meta.colonistIcon;

                if(occupationDef != null) {

                    occ = occupationDef.name;

                    if(occupationDef.indicator != null) {
                        occImage = "images/" + occupationDef.indicator;
                    }
                }

                addObjectReadoutBar(document.getElementById("objectExtra"),occImage,object.buW,working,"#0D47A1","#1E88E5","#D32F2F",object.md.acceptsWorkers,"Workers (" + occ + ")");

                document.getElementById("objectExtra").style.display = "block";

            }

            if(muhDef.isCommsHubBldg && !getRegionOrCity().offlineMode) {
                document.getElementById("objectCommunicationsIcon").style.display = "inline-block";
                document.getElementById("objectCommunicationsIcon").onclick = function() {
                    closeObjectOptionsAndClear();
                    showCommunicationsMenu();
                };

                tipsToShow.push({
                    icon: "images/" + ColonyGame.meta.mailIndicator,
                    tip: "object-options-comms-tip"
                });
            }

            if(getRegionOrCity().offlineMode && tcpAvailable) {
                if(muhDef.isCommsHubBldg || muhDef.isCapitol || muhDef.isConsulate || muhDef.isEmbassy) {
                    document.getElementById("objectCommunicationsIcon").style.display = "inline-block";
                    document.getElementById("objectCommunicationsIcon").onclick = function() {
                        closeObjectOptionsAndClear();
                        showOfflineCommunicationsMenu();
                    };

                    tipsToShow.push({
                        icon: "images/" + ColonyGame.meta.mailIndicator,
                        tip: "object-options-comms-tip"
                    });
                }
            }

            if(!object.iuc) {
                document.getElementById("objectMakeCenterIcon").style.display = "inline-block";
                document.getElementById("objectMakeCenterIcon").onclick = function() {
                    currentGame.centerBuildingId = object.id;
                    setCenterMapIcon();
                    centerMap();
                    webAppCore.showToast("Center Set");
                    closeObjectOptionsAndClear();
                };

                tipsToShow.push({
                    icon: "images/" + ColonyGame.meta.indMakeCenter,
                    tip: "object-options-mkcenter-tip"
                });
            }

            if(muhDef.isSign) {

                if(object.customText && object.customText != null && object.customText.trim().length > 0) {
                    if(allowAudio) {
                        webAppCore.say(object.customText);
                    }
                }

                document.getElementById("objectSetText").style.display = "block";
                document.getElementById("objectSetText").onclick = function() {
                    closeObjectOptionsAndClear();

                    setBuildingText(object);
                };
            }

            if(muhDef.canFlip) {

                var flipBlocked = checkForGeneralBlockage(muhDef,object.x,object.y,!object.flipped,object.occupiesTiles);

                if(!flipBlocked) {
                    document.getElementById("objectFlipIcon").style.display = "inline-block";
                    document.getElementById("objectFlipIcon").title = getString("general-flip");
                    document.getElementById("objectFlipIcon").onclick = function() {
                        closeObjectOptionsAndClear();

                        if(webAppCore.getIsPremium()) {
                            flipBuilding(object);
                        } else {
                            showPremiumMessage();
                        }
                    };
                    appendShortcutTitleToButton(document.getElementById("objectFlipIcon"),"KEY_FLIP",KEY_DEFAULT_FLIP);

                    tipsToShow.push({
                        icon: "images/" + ColonyGame.meta.indFlipBuilding,
                        tip: "object-options-flip-tip"
                    });
                }
                
            }

            if(muhDef.selectionSound != null) {
                if(muhDef.selectionSound instanceof Array) {
                    soundToPlay = muhDef.selectionSound[randomIntFromInterval(0,muhDef.selectionSound.length - 1)];
                } else {
                    soundToPlay = muhDef.selectionSound;
                }
            }


            if(muhDef.isCapitol || muhDef.isConsulate || muhDef.isEmbassy) {
                if(muhDef.isCapitol || muhDef.isConsulate) {
                    if(!getRegionOrCity().offlineMode) {
                        document.getElementById("objectCommonwealthIcon").style.display = "inline-block";

                        tipsToShow.push({
                            icon: "images/" + ColonyGame.meta.empireIndicator,
                            tip: "object-options-empire-tip"
                        });
                    }
                    document.getElementById("objectPolicyIcon").style.display = "inline-block";

                    tipsToShow.push({
                        icon: "images/" + ColonyGame.meta.indPolicy,
                        tip: "object-options-policy-tip"
                    });
                }

                if((muhDef.isCapitol || muhDef.isEmbassy) && !getRegionOrCity().offlineMode) {
                    document.getElementById("objectDiplomacyIcon").style.display = "inline-block";

                    tipsToShow.push({
                        icon: "images/" + ColonyGame.meta.diplomacyIndicator,
                        tip: "object-options-diplomacy-tip"
                    });

                    if(muhDef.isCapitol) {
                        document.getElementById("objectDiplomacyIcon").onclick = function() {
                            closeObjectOptionsAndClear();
                            showColonistsMenu("diplomacy");
                        };
                    } else {
                        document.getElementById("objectDiplomacyIcon").onclick = function() {
                            closeObjectOptionsAndClear();
                            contactEmbassyFor(object.embassyFor);
                        };
                    }
                }
            }

            if(muhDef.heals > 0) {

                if(!alsoHasWorkers) {
                    alsoHasWorkers = true;
                }

                addObjectReadoutBar(document.getElementById("objectExtra"),"images/" + ColonyGame.meta.medicalIcon,object.buM,null,"#7B1FA2",null,"#4A148C",muhDef.heals,"Patients");


            }

            if(muhDef.educates > 0) {
                addObjectReadoutBar(document.getElementById("objectExtra"),"images/" + ColonyGame.meta.indEducation,object.buS,null,"#607D8B",null,"#455A64",muhDef.educates,"Students");
            }



            if(muhDef.entertains > 0) {

                if(!alsoHasWorkers) {
                    alsoHasWorkers = true;
                }

                addObjectReadoutBar(document.getElementById("objectExtra"),"images/" + ColonyGame.meta.indRetired,object.buG,null,"#0097A7",null,"#006064",muhDef.entertains,"Guests");

            }


            if(muhDef.takesTourists > 0) {
                if(!alsoHasWorkers) {
                    alsoHasWorkers = true;
                }

                addObjectReadoutBar(document.getElementById("objectExtra"),"images/" + ColonyGame.meta.touristIcon,object.buT,null,"#303F9F",null,"#1A237E",muhDef.takesTourists,"Tourists");

            }

            if(muhDef.providesShelter > 0) {
                addObjectReadoutBar(document.getElementById("objectExtra"),"images/" + ColonyGame.meta.colonistIcon,object.bRC,null,"#388E3C",null,"#1B5E20",muhDef.providesShelter,"Residents");
            }

            if(object.iuc) {
                if(cancelIsDown) {
                    document.getElementById("objectOptions").style.display = "none";
                    object.isBeingRemoved = true;
                } else {
                    document.getElementById("objectCancel").style.display = "block";
                    document.getElementById("objectCancel").onclick = function() {
                        closeObjectOptionsAndClear();

                        if(type == "building") {
                            object.isBeingRemoved = true;
                        }

                        if(type == "passable") {
                            object.isBeingRemoved = true;
                        }
                    };

                    document.getElementById("objectCancel").innerHTML = getString("general-cancel");
                    appendShortcutToButton(document.getElementById("objectCancel"),"KEY_CANCEL",KEY_DEFAULT_CANCEL);
                }
            } else {
                document.getElementById("objectCancel").style.display = "none";
            }


        } else {

            if(type == "vehicle") {

                if(object.grp && object.grp > 1) {
                    document.getElementById("objectUngroupIcon").style.display = "inline-block";
                    document.getElementById("objectUngroupIcon").onclick = function() {
                        ungroupSelectedUnits();
                        showOptionsForObject(selectedVehicle,type,isRCReshow,passableX,passableY);
                    };

                    tipsToShow.push({
                        icon: "images/" + ColonyGame.meta.ungroupUnitsIndicator,
                        tip: "ungroup-units-tip"
                    });
                }

                if(selectedVehicle.length > 1) {
                    var allSame = true;
                    var checkDef = selectedVehicle[0].def;

                    for(i = 0; i < selectedVehicle.length; i++) {
                        var veh = selectedVehicle[i];

                        if(veh.def != checkDef) {
                            allSame = false;
                            break;
                        }
                    }

                    if(allSame) {
                        document.getElementById("objectGroupIcon").style.display = "inline-block";
                        document.getElementById("objectGroupIcon").onclick = function() {
                            groupSelectedUnits();
                            showOptionsForObject(selectedVehicle,type,isRCReshow,passableX,passableY);
                        };

                        tipsToShow.push({
                            icon: "images/" + ColonyGame.meta.groupUnitsIndicator,
                            tip: "group-units-tip"
                        });
                    }
                }

                document.getElementById("objectCancel").style.display = "none";

                document.getElementById("objectMoveIcon").style.display = "inline-block";
                document.getElementById("objectMoveIcon").onclick = function() {
                    queueSelectedVehicleForMove();
                    document.getElementById("objectOptions").style.display = "none";
                };

                tipsToShow.push({
                    icon: "images/" + ColonyGame.meta.indMove,
                    tip: "object-options-move-tip"
                });

                document.getElementById("objectMoveIcon").title = getString("general-move");
                appendShortcutTitleToButton(document.getElementById("objectMoveIcon"),"KEY_MOVE",KEY_DEFAULT_MOVE);

                var vDef = getVehicleDefByName(object.def);

                if(object.lv.length > 0) {
                    document.getElementById("objectDeployLoadedIcon").style.display = "inline-block";

                    document.getElementById("objectDeployLoadedIcon").onclick = function() {
                        document.getElementById("objectOptions").style.display = "none";

                        deployLoadedUnits(object);

                    };
                }

                if(vDef.deploysTo != null) {



                    var deploysToDef = getBuildingDefByName(vDef.deploysTo);

                    object.pd = deploysToDef;

                    document.getElementById("objectDeployIcon").style.display = "inline-block";

                    var im = getImageAsset(deploysToDef.tile, false, 0, null);

                    if (im) {
                        document.getElementById("objectDeployIcon").src = im.src;
                    } 

                    document.getElementById("objectDeployIcon").title = "Deploy " +  deploysToDef.name;

                    document.getElementById("objectDeployIcon").onclick = function() {
                        document.getElementById("objectOptions").style.display = "none";

                        deployBuilding(object);

                    };
                }
                
                if(vDef == null || vDef.harvests == null) {
                    document.getElementById("objectHarvestIcon").style.display = "none";
                } else {
                    document.getElementById("objectHarvestIcon").style.display = "inline-block";
                    document.getElementById("objectHarvestIcon").onclick = function() {
                        for(var i = 0; i < selectedVehicle.length; i++) {

                            selectedVehicle[i].blacklist = [];
                            selectedVehicle[i].bBlacklist = [];

                            selectedVehicle[i].iH = true;
                            selectedVehicle[i].harvestAfterBuilding = false;
                            selectedVehicle[i].inBuildingMode = false;
                        }
                        closeObjectOptionsAndClear();
                        selectedVehicle = [];
                        drawSidebar();
                    };

                    tipsToShow.push({
                        icon: "images/" + ColonyGame.meta.indHarvest,
                        tip: "object-options-harvest-tip"
                    });

                    document.getElementById("objectHarvestIcon").title = getString("general-harvest");
                    appendShortcutTitleToButton(document.getElementById("objectHarvestIcon"),"KEY_HARVEST",KEY_DEFAULT_HARVEST);

                }

                document.getElementById("objectParkIcon").title = getString("general-park-unit");
                appendShortcutTitleToButton(document.getElementById("objectParkIcon"),"KEY_PARK",KEY_DEFAULT_PARK);

                document.getElementById("objectParkIcon").style.display = "inline-block";
                document.getElementById("objectParkIcon").onclick = function() {

                    queuedPark = object;
   
                    document.getElementById("objectOptions").style.display = "none";
                };

                tipsToShow.push({
                    icon: "images/" + ColonyGame.meta.indPark,
                    tip: "object-options-park-tip"
                });
            }
            
            if(type == "resource") {
                document.getElementById("objectCancel").style.display = "none";
                document.getElementById("objectParkIcon").style.display = "none";
                document.getElementById("objectMoveIcon").style.display = "none";

                var rdef = getTerrainDefByName(object.def);

                if(rdef.provides) {
                    var resDef = getResourceByDefName(rdef.provides);

                    if(object.ul) {
                        addObjectReadoutBar(document.getElementById("objectExtra"),"images/" + resDef.icon,-1,null,resDef.color,null,null,-1,rdef.provides);                       
                    } else {
                        addObjectReadoutBar(document.getElementById("objectExtra"),"images/" + resDef.icon,object.inventory,null,resDef.color,null,null,rdef.capacity,rdef.provides);
                    }

                    document.getElementById("objectExtra").style.color = null;
                    document.getElementById("objectExtra").style.display = "block";
    
                }
                
                
            }

            if(type == "passable") {
                document.getElementById("objectHarvestIcon").style.display = "none";

                if(!object.iuc) {
                    document.getElementById("objectCancel").style.display = "none";
                }

                document.getElementById("objectParkIcon").style.display = "none";
                document.getElementById("objectMoveIcon").style.display = "none";
                document.getElementById("objectExtra").style.display = "none";
            }



            if(type == "vehicle") {
                document.getElementById("objectExtra").style.color = null;
                document.getElementById("objectExtra").style.display = "block";
                document.getElementById("objectExtra").innerHTML = "Idle";

                if(object.x != object.dX || object.y != object.dY) {
                    document.getElementById("objectExtra").innerHTML = "Moving";
                }

                if(type == "vehicle" && object.iH) {
                    document.getElementById("objectExtra").innerHTML = "Harvesting";
                }

                if(object.inBuildingMode) {
                    document.getElementById("objectExtra").innerHTML = "Building";
                }

            }

            
        }

        var canBuildStuff = false;

        if(type == "building") {
            if(getBuildingDefByName(object.def).produces!= null && getBuildingDefByName(object.def).produces.length > 0 && !object.iuc) {
                canBuildStuff = true;
            }

            if(!object.iuc && object.condition < 100) {

                document.getElementById("objectCondition").style.display = "block";
                document.getElementById("objectCondition").innerHTML = "Condition: " + object.condition + "%";
                document.getElementById("objectCondition").style.color = "#ffffff";

                if(object.condition < 100) {

                    document.getElementById("objectRepairIcon").style.display = "inline-block";
                    document.getElementById("objectRepairIcon").onclick = function() {
                        showRepairBuilding(object,true);
                        closeObjectOptionsAndClear();
                    };

                    tipsToShow.push({
                        icon: "images/" + ColonyGame.meta.indRepair,
                        tip: "object-options-repair-tip"
                    });

                    if(object.condition < 10) {
                        document.getElementById("objectCondition").style.color = "#F44336";
                    }
                }
            } else {
                document.getElementById("objectCondition").style.display = "none";
            }
        }

        if(type == "resource") {

            if(!getTerrainDefByName(object.def).indestructable) {
                document.getElementById("objectDestroyIcon").style.display = "inline-block";
                document.getElementById("objectDestroyIcon").onclick = function() {
                    destroyResource(object);
                    closeObjectOptionsAndClear();
                };
    
                tipsToShow.push({
                    icon: "images/" + ColonyGame.meta.indDestroy,
                    tip: "object-options-destroy-tip"
                });
            }

            
        }

        if(type == "vehicle") {
            
            var vd = getVehicleDefByName(object.def);

            if(vd != null && vd.selectionSound != null) {
                if(vd.selectionSound instanceof Array) {
                    soundToPlay = vd.selectionSound[randomIntFromInterval(0,vd.selectionSound.length - 1)];
                } else {
                    soundToPlay = vd.selectionSound;
                }
            }
            
            if(vd != null && vd.produces != null && vd.produces.length > 0) {
                canBuildStuff = true;
            }

            document.getElementById("objectDestructIcon").style.display = "inline-block";
            document.getElementById("objectDestructIcon").onclick = function() {
                destroyVehicle(selectedVehicle);
                closeObjectOptionsAndClear();
            };

            tipsToShow.push({
                icon: "images/" + ColonyGame.meta.indDestroy,
                tip: "object-options-destroy-tip"
            });
        }
        
        if(canBuildStuff && !object.iuc) {
            document.getElementById("objectBuildIcon").style.display = "inline-block";
            document.getElementById("objectBuildIcon").onclick = function() {
                showBuildingConstructionOptions(object,type);
                closeObjectOptionsAndClear();
            };

            tipsToShow.push({
                icon: "images/" + ColonyGame.meta.showBuildSidebarIcon,
                tip: "object-options-build-tip"
            });

            document.getElementById("objectBuildIcon").title = getString("general-build");
            appendShortcutTitleToButton(document.getElementById("objectBuildIcon"),"KEY_BUILD",KEY_DEFAULT_BUILD);
        } else {
            document.getElementById("objectBuildIcon").style.display = "none";
        }

        if((type == "building" || type == "passable") && !object.iuc) {

            if(altsdown) {
                document.getElementById("objectOptions").style.display = "none";
                objectForSell = object;
                objectForSellType = type;
                doSale();
                selectedBuilding = null;
            } else {
                document.getElementById("objectSelIcon").style.display = "inline-block";
                document.getElementById("objectSelIcon").onclick = function() {
                    showSellForObject(object,type);
                    closeObjectOptionsAndClear();
                };

                tipsToShow.push({
                    icon: "images/" + ColonyGame.meta.indSell,
                    tip: "object-options-sell-tip"
                });

                if(getBuildingDefByName(object.def).sellValue == null) {
                    document.getElementById("objectSelIcon").title = getString("object-remove");
                    document.getElementById("objectSelIcon").src = "images/" + ColonyGame.meta.bulldozerToolIndicator;
                } else {
                    document.getElementById("objectSelIcon").title = getString("object-sell");
                    document.getElementById("objectSelIcon").src = "images/" + ColonyGame.meta.indSell;
                }

                appendShortcutTitleToButton(document.getElementById("objectSelIcon"),"KEY_SELL",KEY_DEFAULT_SELL);
            }

            upgradeOption = isUpgradeAvailableForStructure(object);

            if(upgradeOption != null) {
                if(!canIBuildThis(upgradeOption.structure,"building",true)) {
                    upgradeOption = null;
                }
            }

            if(upgradeOption != null) {

                if(altudown) {
                    conductUpgrade(object,upgradeOption,type);
                    selectedBuilding = null;
                    closeObjectOptionsAndClear();
                } else {
                    document.getElementById("objectUpgradeIcon").style.display = "inline-block";
                    document.getElementById("objectUpgradeIcon").onclick = function() {
                        document.getElementById("objectOptions").style.display = "none";
                        conductUpgrade(object,upgradeOption,type);
                        closeObjectOptionsAndClear();
                    };

                    tipsToShow.push({
                        icon: "images/" + ColonyGame.meta.indUpgrade,
                        tip: "object-options-upgrade-tip"
                    });
                    
                    document.getElementById("objectUpgradeIcon").title = getString("general-upgrade");
                    appendShortcutTitleToButton(document.getElementById("objectUpgradeIcon"),"KEY_UPGRADE",KEY_DEFAULT_UPGRADE);
                }
            }
        } else {
            document.getElementById("objectSelIcon").style.display = "none";
        }

        if(type == "building" && !object.iuc && !object.deactivated) {



            if(!getBuildingDefByName(object.def).refines && !getBuildingDefByName(object.def).packsTo) {
                document.getElementById("objectMoveIcon").style.display = "inline-block";
                document.getElementById("objectMoveIcon").onclick = function() {
                    webAppCore.showToast(getString("gen-move-building"));
    
                    pendingMoveBuilding = object;
    
                    closeObjectOptionsAndClear();
                };
    
                tipsToShow.push({
                    icon: "images/" + ColonyGame.meta.indMove,
                    tip: "move-building-tip"
                });
    
                document.getElementById("objectMoveIcon").title = getString("gen-move-building");
                appendShortcutTitleToButton(document.getElementById("objectMoveIcon"),"KEY_MOVE",KEY_DEFAULT_MOVE);
            }


            





            if(getBuildingDefByName(object.def).canImport != null && !currentGame.tradeEmbargo) {
                document.getElementById("objectImportIcon").style.display = "inline-block";
                document.getElementById("objectImportIcon").onclick = function() {
                    showImportMenu(object);
                    closeObjectOptionsAndClear();
                };

                tipsToShow.push({
                    icon: "images/" + ColonyGame.meta.indImportGoods,
                    tip: "object-options-import-tip"
                });

                document.getElementById("objectImportIcon").title = getString("general-import");
                appendShortcutTitleToButton(document.getElementById("objectImportIcon"),"KEY_IMPORT",KEY_DEFAULT_IMPORT);
            }

            if(getBuildingDefByName(object.def).canExport != null && !currentGame.tradeEmbargo) {
                document.getElementById("objectExportIcon").style.display = "inline-block";
                document.getElementById("objectExportIcon").onclick = function() {
                    showExportMenu(object);
                    closeObjectOptionsAndClear();
                };

                tipsToShow.push({
                    icon: "images/" + ColonyGame.meta.indExportGoods,
                    tip: "object-options-export-tip"
                });

                document.getElementById("objectExportIcon").title = getString("general-export");
                appendShortcutTitleToButton(document.getElementById("objectExportIcon"),"KEY_EXPORT",KEY_DEFAULT_EXPORT);
            }

            if(!getRegionOrCity().offlineMode) {
                if(getBuildingDefByName(object.def).onlineTradeDepot) {

                    document.getElementById("objectTradeIcon").style.display = "inline-block";
                    document.getElementById("objectTradeIcon").onclick = function() {
                        selectedBuilding = object;
                        closeObjectOptionsAndClear();

                        if(object.lowPowerMode) {
                            webAppCore.showToast("Low Power");
                            return;
                        }

                        showNewTradeMenu(object.name);
                    };

                    tipsToShow.push({
                        icon: "images/" + ColonyGame.meta.indTrade,
                        tip: "object-options-trade-tip"
                    });
                }
            }
        }

        if(soundToPlay && !isRCReshow) {
            playInterfaceSoundEffect(soundToPlay);
        }

        resetObjectOptions();

        if(cameFromGamepad || gamepadInUse) {
            gamepadSelectionButton = 0;

            var buttons = document.getElementById("objectOptions").querySelectorAll(".objectOptionIcon");

            for(i = 0; i < buttons.length; i++) {
                if(buttons[i].style.display == "inline-block") {
                    gamepadSelectionButton = [i];
                    break;
                }
            }

            highlightSelectedObjectButton();
        }

        showTipsPopup(tipsToShow);
    }

    var tipsWindowOpen = false;

    function closeTipsPopup() {
        document.getElementById("helpfulTipsMenu").style.display = "none";
        tipsWindowOpen = false;
    }

    function showTipsPopup(tipsToShow) {
        var finalTipsToShow = [];
        var i;

        for(i = 0; i < tipsToShow.length; i++) {
            if(webAppCore.getVar(tipsToShow[i].tip,"0") == "1") {
                continue;
            }

            webAppCore.storeVar(tipsToShow[i].tip,"1");
            finalTipsToShow.push(tipsToShow[i]);
        }

        if(finalTipsToShow.length == 0) {
            return;
        }

        tipsWindowOpen = true;

        document.getElementById("helpfulTipsListing").innerHTML = "";

        for(i = 0; i < finalTipsToShow.length; i++) {
            var tipItem = document.createElement("div");
            tipItem.className = "helpfulTipItem";

            var tipIcon = document.createElement("img");
            tipIcon.className = "helpfulTipIcon";
            tipIcon.src = finalTipsToShow[i].icon;
            tipItem.appendChild(tipIcon);

            var tipText = document.createElement("p");
            tipText.className = "helpfulTipText";
            tipText.innerHTML = getString(finalTipsToShow[i].tip);
            tipItem.appendChild(tipText);

            document.getElementById("helpfulTipsListing").appendChild(tipItem);
        }

        if(gamepadInUse) {
            document.getElementById("helpfulTipsDismissGamepad").style.display = "block";
            document.getElementById("helpfulTipsDismiss").style.display = "none";
        } else {
            document.getElementById("helpfulTipsDismiss").style.display = "block";
            document.getElementById("helpfulTipsDismissGamepad").style.display = "none";
        }

        document.getElementById("helpfulTipsMenu").style.display = "block";
    }
    
    function getDriveSpeedMod(x,y) {
        
        // new passables 
        for(var passdef in currentGame.finishedPassableNonUpdatables) {
            var td = currentGame.finishedPassableNonUpdatables[passdef];
            
            if(td[x]) {
                
                var tx = td[x];
                
                for(var ty = 0; ty < tx.length; ty++) {
                    var passY = tx[ty];
                    
                    if(passY == y) {
                        return passableTileRefs[passdef].driveSpeedMod;
                    }

                }
            }

        }

        for(var i = 0; i < currentGame.passableNonUpdatables.length; i++) {
            if(currentGame.passableNonUpdatables[i].x == x &&  currentGame.passableNonUpdatables[i].y == y) {
                if(currentGame.passableNonUpdatables[i].iuc || getBuildingDefByName(currentGame.passableNonUpdatables[i].def).driveSpeedMod == null) {
                    return 0;
                }  else {
                    return getBuildingDefByName(currentGame.passableNonUpdatables[i].def).driveSpeedMod;
                }
            }
        }
        
        return 0;
    }

    function getBuildingMarketValue(building,useCost,useDef) {
        var buildingMarketValue = 0;
        var priceModifier = 1;

        var def;

        if(useDef) {
            def = useDef;
        } else {
            def = getBuildingDefByName(building.def);
        }

        var arrayToUse = def.sellValue;

        if(useCost || arrayToUse == null) {
            arrayToUse = def.cost;

            if(!useCost) {
                priceModifier = 0.35;
            }
        } 

        if(arrayToUse == null || arrayToUse.length == 0) {
            return 0;
        }

        var res = getGameResources();

        if(!res) {
            return 0;
        }

        for(var i = 0; i < arrayToUse.length; i++) {
            var resource = arrayToUse[i].resource;
            var amount = arrayToUse[i].amount;

            var currentUnitPrice = Math.round(res[resource].price / 100);
            var resourceValue = amount * currentUnitPrice;

            buildingMarketValue += resourceValue;
        }

        buildingMarketValue *= priceModifier;

        if(!useCost) {
            if(building.condition < 100) {
                var conditionPercent = building.condition / 100;
                buildingMarketValue *= conditionPercent;
            }
        }

        return buildingMarketValue;
    }

    function getBuildingRepairCost(building) {

        if(!building) {
            return 0;
        }

        if(building.condition == 100) {
            return 0;
        }

        var buildingValue = getBuildingMarketValue(building,true);
        var totalUpkeepValue = Math.ceil(buildingValue * 0.025);
        var damagePercent = (100 - building.condition) / 100;

        var repairCost = Math.ceil(totalUpkeepValue * damagePercent);

        return repairCost;
    }

    var pendingRepairJob = null;

    function repairAllBuildings() {

        if(!currentGame) {
            return;
        }

        var totalRepairCosts = 0;
        var i;

        for(i = 0; i < currentGame.buildings.length; i++) {
            totalRepairCosts += getBuildingRepairCost(currentGame.buildings[i]);
        }

        if(totalRepairCosts > getGameResources()[ColonyGame.meta.tenderResource].amount) {
            webAppCore.showToast(getString("general-cant-afford"));
            return;
        }

        for(i = 0; i < currentGame.buildings.length; i++) {
            showRepairBuilding(currentGame.buildings[i],false);
        }
    }

    function showRepairBuilding(building,askFirst) {
        pendingRepairJob = building;

        if(askFirst) {
            var repairCosts = getBuildingRepairCost(building);

            var repairMessage;

            if(repairCosts > getGameResources()[ColonyGame.meta.tenderResource].amount) {
                repairMessage = "This building costs " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(repairCosts) + " to repair.  " + getString("general-cant-afford");
                webAppCore.showToast(repairMessage);
            } else {
                repairMessage = "Repair this building for " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(repairCosts) + "?";

                webAppCore.showDialog({
                    "title":    getString("general-repair"),
                    "message":  repairMessage,
                    "op1": {
                        "text":     getString("general-yes"),
                        "func":     completeBuildingRepair
                    },
                    "op2": {
                        "text":     getString("general-no"),
                        "func":     placeholder
                    }
                });
            }
        } else {
            completeBuildingRepair();
        }
    }

    function completeBuildingRepair() {

        if(pendingRepairJob == null) {
            return;
        }

        var repairCosts = getBuildingRepairCost(pendingRepairJob);
        
        if(repairCosts > getGameResources()[ColonyGame.meta.tenderResource].amount) {
            return;
        }

        modifyResourceAmount(ColonyGame.meta.tenderResource,-repairCosts,false,"Repairs");
        pendingRepairJob.condition = 100;

        pendingRepairJob = null;
    }

    function showSellForObject(object,type) {
        objectForSell = object;
        objectForSellType = type;
        
        var theDef;

        if(type == "building" || type == "passable") {
            theDef = getBuildingDefByName(object.def);
        }

        if(type == "vehicle") {
            theDef = getVehicleDefByName(object.def);
        }

        if(!theDef || theDef == null) {
            return;
        }

        if(theDef.sellValue == null) {
            doSale(theDef);
            return;
        }

        var sellWarning = "Sell " + object.name + " for";

        for(var i = 0; i < theDef.sellValue.length; i++) {
            if(i == 0) {
                sellWarning += " ";
            } else {
                sellWarning += ", ";
            }
            
            sellWarning += getResourceByDefName(theDef.sellValue[i].resource).indicator + theDef.sellValue[i].amount;
        }
        
        sellWarning += "?";
        
        if(theDef.sellWarning != null) {
            sellWarning += "  ";
            sellWarning += getString(theDef.sellWarning);
        }

        webAppCore.showDialog({
            "title":    object.name,
            "message":  sellWarning,
            "op1": {
                "text":     "Sell",
                "func":     doSale
            },
            "op2": {
                "text":     "Keep",
                "func":     placeholder
            }
        });
    }
    
    function placeholder() {
        //whatevs
    }
    
    function doSale() {

        if(objectForSell == null || objectForSellType == null) {
            return;
        }

        var theDef;

        if(objectForSellType == "building" || objectForSellType == "passable") {
            theDef = getBuildingDefByName(objectForSell.def);
        }

        if(objectForSellType == "vehicle") {
            theDef = getVehicleDefByName(objectForSell.def);
        }

        if(!theDef || theDef == null) {
            return;
        }

        var i;
        
        if(theDef.sellValue != null) {
            for(i = 0; i < theDef.sellValue.length; i++) {

                modifyResourceAmount(theDef.sellValue[i].resource,theDef.sellValue[i].amount,false,"Sale");
            }
        }

        if(objectForSellType == "passable") {
            objectForSell.isBeingRemoved = true;
            updateUtilityGrid();
            staticFrame = false;
            Scroll2d.forceSceneChange();
        }
        
        
        if(objectForSellType == "building") {


            objectForSell.isBeingRemoved = true;

            updateUtilityGrid();
            staticFrame = false;
            Scroll2d.forceSceneChange();

            if(theDef.isEmbassy) {
                alertSoldEmbassy(objectForSell.embassyFor);
            }
        }
        
        if(objectForSellType == "vehicle") {
            removeFromArray(currentGame.vehicles,objectForSell);

        }
        
        objectForSell = null;
        objectForSellType = null;
    }
    
    function removeFromArray(arr, item, showarray) {

        if(arr == null || item == null) {
            if(showarray !== undefined) {
                console.log("COULDNT remove from: " + showarray);
            }
            return;
        }

        var wasRemoved = false;

        for(var i = arr.length; i--;) {
            if(arr[i] === item) {
                arr.splice(i, 1);
                wasRemoved = true;
            }
        }

        return wasRemoved;
    }

    function presentGameData() {

        document.getElementById("newGameMenu").style.display = "none";
        document.getElementById("titleBackdropHold").style.display = "none";

        var menuOptions = [];

        var dialogTitle = "Game Data";

        menuOptions.push({
            "title":        "Backup Game File",
            "status":       "Export a save to filesystem",
            "tag":          "export"
        });

        menuOptions.push({
            "title":        "Restore a Game File (*." + ColonyGame.meta.fileExtension + ")",
            "status":       "Import a backed up game",
            "tag":          "importnew"
        });

        menuOptions.push({
            "title":        "Delete Files",
            "status":       "Delete single or multiple game files",
            "status-color": null,
            "tag":          "delete"
        });

        if(webAppCore.getPlatform().platform == "web") {
            menuOptions.push({
                "title":        "Text Backup",
                "status":       "Copy game data in raw text format for manual backup.",
                "overflow": [
                    {
                        "pre":  null,
                        "post": "Expert",
                        "color":"#F44336"
                    }
                ],
                "tag":          "textbackup"
            });

        }


        menuOptions.push({
            "title":        "Restore a Recovery File (*." + ColonyGame.meta.backupExtension + ")",
            "status":       "For emergency situations",
            "status-color":  "#FF9800",
            "tag":          "importmcb"
        });

        var platform = webAppCore.getInterface();

        if(platform == "windows" || platform == "desktop") {
            menuOptions.push({
                "title":        getString("save-file-loc"),
                "description":  getString("save-file-loc-desc"),
                "status":       getString("save-file-loc-warn"),
                "status-color": "#f44336",
                "tag":          "workspaceloc"
            });
        }

        

        showList(dialogTitle,menuOptions,onGameDataOptionSelected,getString("general-dismiss"));
    }

    function onGameDataOptionSelected(tag) {

        if(tag == null) {
            return;
        }

        if(tag == "workspaceloc") {
            webAppCore.showDialog({
                title: getString("save-file-loc"),
                message: getString("save-file-loc-confirm"),
                buttons: [
                    {
                        text: getString("general-yes"),
                        color: "#f44336",
                        func: function(){
                            webAppCore.changeWorkspace(function(){
                                webAppCore.storeVar("mc-last-saved-game","0");
                                webAppCore.storeVar("mc-last-saved-game-name","0");
                                showTitle();
                            });
                        }
                    },
                    {
                        text: getString("general-no"),
                        func: placeholder
                    }
                ]
            });
        }

        if(tag == "delete") {
            listingType = "delete";
            webAppCore.openListing(showOpenGameListing);
        }

        if(tag == "export") {
            listingType = "export";
            webAppCore.openListing(showOpenGameListing);
        }

        if(tag == "textbackup") {
            listingType = "textbackup";
            webAppCore.openListing(showOpenGameListing);
        }

        if(tag == "importmcb") {
            webAppCore.importFile(ColonyGame.meta.backupExtension,onGameFileImport);
        }

        if(tag == "importnew") {
            webAppCore.importFile(ColonyGame.meta.fileExtension,onGameFileImportNew);
        }
    }

    var pendingExportFile;

    function onTextBackupFileSelected(file) {
        if(!file) {
            return;
        }

        webAppCore.openFile(file, completeTextBackup);
    }

    function onExportFileSelected(file) {
        if(!file) {
            return;
        }

        pendingExportFile = file;
        webAppCore.openFile(pendingExportFile, completeExport);
    }

    function completeExport(data) {
        if(pendingExportFile == null) {
            return;
        }

        webAppCore.exportFile(pendingExportFile,data,false);
    }

    function completeTextBackup(data) {

        if(data == null || data.length == 0) {
            webAppCore.showToast("Error");
            return;
        }

        bulldozerMode = false;
        webAppCore.handleBackFunction(standardBack);
        webAppCore.setTitleVisible(false);
        titleShowing = false;

        document.getElementById("textBackupScreen").style.display = "block";
        document.getElementById("exportText").innerHTML = data;
    }

    var pendingDeleteFile;

    function confirmDelete(file) {

        if(!file) {
            return;
        }

        pendingDeleteFile = file;

        webAppCore.showDialog({
            "title":    getString("header-delete-colony"),
            "message":  "Delete " + pendingDeleteFile,
            "op1": {
                "text":     getString("general-delete"),
                "func":     deleteGameFile,
                "color":    "#F44336"
            },
            "op2": {
                "text":     getString("general-cancel"),
                "func":     placeholder
            }
        });
    }

    function deleteGameFile() {
        webAppCore.deleteFile(pendingDeleteFile,onGameDeleted);
    }

    function onGameDeleted() {
        webAppCore.showToast("Deleted");
        listingType = "delete";
        webAppCore.openListing(showOpenGameListing);
    }

    function onGameFileImportNew(name,content) {
        currentFileName = name;

        uncompressFile(content);

    }

    function onGameFileImport(name,content) {
        currentFileName = name;
        uncompressFile(content);
        generalSaveGame();
    }

    var retainedDef;

    function handleColonistRioting(colonist) {

        if(ourCapitolBuilding == null) {
            return;
        }

        if(colonist.x != colonist.dX && colonist.y != colonist.dY) {
            return;
        }


        var randomSpaces = getFreeSpacesAroundBuilding(ourCapitolBuilding);

        if(randomSpaces.length == 0) {
            //setColonistMask(colonist,"IS_PROTESTING",false);
            return;
        }

        
        var randomTarget = randomSpaces[randomIntFromInterval(0,randomSpaces.length - 1)];

        if(randomTarget) {
            colonist.dX = randomTarget[0];
            colonist.dY = randomTarget[1];
        }
        

        while(randomSpaces.length) {
            freeSpaceItemRecycler.push(randomSpaces.pop());
        }
    }

    function SortedBuildingItem(building,distance) {
        this.b = building;
        this.d = distance;
    }

    function sortBuildingsByDistanceFromBuilding(buildingArray,cBld,range) {

        if(buildingArray == null || cBld == null) {
            return [];
        }

        var sortedBuildings = [];
        var bld;

        for(var i = 0,l=buildingArray.length; i < l; i++) {

            bld = buildingArray[i];

            if(!bld) {
                continue;
            }

            var a = cBld.x - bld.x;
            var b = cBld.y - bld.y;
            var distance = Math.sqrt( a*a + b*b );

            if(distance > range) {
                continue;
            }

            sortedBuildings.push(new SortedBuildingItem(bld,Math.round(distance)));

        }


        sortedBuildings.sort(sortTargetPoints);

        return sortedBuildings;
    }

    function sortBuildingsByDistanceFromUnit(buildingArray,unit,isTerrain,range,isFlying) {

        if(buildingArray == null || unit == null) {
            return [];
        }

        var flying = false;


        if(isFlying) {
            flying = isFlying;
        }

        

        var sortedBuildings = [];
        var internalBlacklist = [];

        var maxDistance = 120;

        if(range) {
            maxDistance = range;
        }
        
        var useRange = 10;
        
        if(maxDistance < useRange) {
            useRange = maxDistance;
        }
        
        var minNumberToSort = Math.ceil(buildingArray.length * 0.2);

        if(minNumberToSort > 40) {
            minNumberToSort = 40;
        }

        var bld;
        var closeOnesCount = 0;
        var closeOnes = [];
        
        while(sortedBuildings.length < minNumberToSort && useRange <= maxDistance) {
            if(closeOnesCount > 20) {
                break;
            }

            for(var i = 0,l=buildingArray.length; i < l; i++) {

                if(closeOnesCount > 20) {
                    break;
                }

                bld = buildingArray[i];

                if(!bld) {
                    continue;
                }

                if(internalBlacklist.indexOf(bld.id) > -1) {
                    continue;
                }
                
                var a = unit.x - bld.x;
                var b = unit.y - bld.y;
                var distance = Math.sqrt( a*a + b*b );

                if(distance > useRange) {
                    continue;
                }

                

                var openSpots = getFreeSpacesAroundBuilding(bld,1,false,isTerrain,flying);
                
                if(openSpots.length == 0) {
                    internalBlacklist.push(bld.id);
                    continue;
                }

                for(var j = 0; j < openSpots.length; j++) {

                    if(!openSpots[j]) {
                        continue;
                    }

                    if(unit.x == openSpots[j][0] && unit.y == openSpots[j][1]) {
                        distance = 1;
                        break;
                    }
                }

                while(openSpots.length) {
                    freeSpaceItemRecycler.push(openSpots.pop());
                }

                sortedBuildings.push(new SortedBuildingItem(bld,Math.round(distance)));
                internalBlacklist.push(bld.id);

                if(distance < 8) {
                    closeOnesCount++;
                    closeOnes.push(new SortedBuildingItem(bld,Math.round(distance)));
                }

            }
            
            useRange += 10;
        }

        if(closeOnesCount > 6) {
            closeOnes.sort(sortTargetPoints);
            return closeOnes;
        }

        sortedBuildings.sort(sortTargetPoints);

        return sortedBuildings;
    }

    function shuffleArray(array) {

        if (array == null) {
            return [];
        }

        for (var i = array.length - 1; i > 0; i--) {
            var j = Math.floor(Math.random() * (i + 1));
            var temp = array[i];
            array[i] = array[j];
            array[j] = temp;
        }
        return array;
    }


    function showTechWindowNew() {

        if(currentGame.readOnlyMode) {
            return;
        }

        Scroll2d.gamepadAllStop();

        var availableTechs = 0;

        var j,k;

        var menuOptions = [];

        for(var i = 0; i < ColonyGame.technology.length; i++) {
            if(!getGameTechs()[ColonyGame.technology[i].name]) {

                if(ColonyGame.technology[i].requiresTech != null) {

                    var hasRequirements = true;

                    for(j = 0; j < ColonyGame.technology[i].requiresTech.length; j++) {

                        var techParts = ColonyGame.technology[i].requiresTech[j].split("|");

                        var hasThisOne = false;

                        for(k = 0; k < techParts.length; k++) {
                            if(getGameTechs()[techParts[k]]) {
                                hasThisOne = true;
                            }
                        }

                        if(!hasThisOne) {
                            hasRequirements = false;
                        }


                    }

                    if(ColonyGame.technology[i].reqIndependence && !getRegionOrCity().isIndependent) {
                        hasRequirements = false;
                    }

                    if(!hasRequirements) {
                        continue;
                    }
                }
                
                if(ColonyGame.technology[i].requiresStage > getRegionOrCity().stage) {
                    continue;
                }

                availableTechs++;

                var cost = [];

                if(ColonyGame.technology[i].cost) {
                    for(j = 0; j < ColonyGame.technology[i].cost.length; j++) {
                        var def = getResourceByDefName(ColonyGame.technology[i].cost[j].resource);

                        var costColor = null;

                        if(ColonyGame.technology[i].cost[j].amount > getGameResources()[ColonyGame.technology[i].cost[j].resource].amount) {
                            costColor = "#F44336";
                        }

                        cost.push({
                            pre:    "Cost:",
                            post:   def.indicator + numberWithCommas(ColonyGame.technology[i].cost[j].amount),
                            color:  costColor,
                            icon:   "images/" + def.icon
                        });

                        
                    }
                }

                for(k = 0; k < ColonyGame.buildings.length; k++) {
                    
                    if(ColonyGame.buildings[k].requiresTech == null || ColonyGame.buildings[k].requiresTech.length == 0) {
                        continue;
                    }

                    var bTechs = ColonyGame.buildings[k].requiresTech;

                    var techsNeeded = 0;
                    var needsThis = false;

                    for(var l = 0; l < bTechs.length; l++) {
                        if(getGameTechs()[bTechs[l]]) {
                            continue;
                        }

                        techsNeeded++;

                        if(bTechs[l] == ColonyGame.technology[i].name) {
                            needsThis = true;
                        }
                    }

                    if(needsThis) {

                        var bldImg;
                        
                        if(ColonyGame.buildings[k].indicator == null) {

                            var mi = getImageAsset(ColonyGame.buildings[k].tile[0],false,0,null);

                            if(mi) {
                                bldImg = mi.src;
                            } 

                        } else {
                            bldImg = "images/" + ColonyGame.buildings[k].indicator;
                        }

                        if(techsNeeded == 1) {
                            cost.push({
                                pre:    "Unlocks:",
                                post:   ColonyGame.buildings[k].name,
                                color:  "#43A047",
                                icon:   bldImg
                            });
                        } else {
                            cost.push({
                                pre:    "Needed By:",
                                post:   ColonyGame.buildings[k].name,
                                color:  "#00796B",
                                icon:   bldImg
                            });
                        }
                    }
                }

                menuOptions.push({
                    "title":        ColonyGame.technology[i].name,
                    "description":  getString(ColonyGame.technology[i].description),
                    "icon":         "images/" + ColonyGame.technology[i].icon,
                    "overflow":     cost,
                    "tag":          ColonyGame.technology[i]
                });
            }
        }

        if(availableTechs > 0) {
            showList("Technology",menuOptions,unlockTech,getString("general-dismiss"));
        } else {
            webAppCore.showAlertWithTitle("There are no available techs at this time.","No Technology");
        }
    }

    function showTechWindow() {
        if(!getGameTechs()) {

            var roc = getRegionOrCity();

            if(roc) {
                roc.unlockedTechs = {};
            } else {
                return;
            }
            
        }

        showTechWindowNew();
        return;
    }

    function unlockTech(tech) {

        cooldownGamepad();

        if(currentGame == null || tech == null) {
            return;
        }

        // double check that we can afford 
        var canAfford = true;
        var j;

        if(tech.cost) {
            for(j = 0; j < tech.cost.length; j++) {
                if(tech.cost[j].amount > getGameResources()[tech.cost[j].resource].amount) {
                    canAfford = false;
                }
            }
        }
        

        if(!canAfford) {
            webAppCore.showAlertWithTitle(getString("general-cant-afford"),"Cannot Afford");
            return;
        }

        if(tech.cost) {
            for(j = 0; j < tech.cost.length; j++) {
                modifyResourceAmount(tech.cost[j].resource,-tech.cost[j].amount,false,"Research");
            }
        }

        webAppCore.showToast({
            "message":      "Unlocked " + tech.name,
            "image":        "images/" + tech.icon
        });

        getGameTechs()[tech.name] = new Date().getTime();

        if(usingSockets && currentGame.isSubregion && currentRegion && currentRegion.isMpRegionHolder && currentSubcityRef) {
            postToOnlineMetroArea({
                "type": "metro",
                "data": {
                    "type": "unlocktech",
                    "city": currentGame.name,
                    "charter": currentGame.charter,
                    "id": currentGame.colonyId,
                    "color": currentGame.themeColor,
                    "tech": tech.name
                }
            });

            updateColonyStats();
        }

        if(!getRegionOrCity().offlineMode && !getRegionOrCity().privateCharter) {
            var announceChance = randomIntFromInterval(1,20);

            if(announceChance == 5) {
                postGlobalSocketNewsItem({
                    "code": "techbreakthrough",
                    "tech": tech.name
                });
            }
        }

        drawSidebar();
    }

    function clearOutBuildMenu() {
        document.getElementById("constructionMenuItems").innerHTML = "";
        document.getElementById("constructionMenu").style.display = "none";
        document.getElementById("objectOptions").style.display = "none";
        document.getElementById("touchBuildConfirm").style.display = "none";
        document.getElementById("gamepadBuildConfirm").style.display = "none";

        touchPossibleBuildPoints = [];

        idleBuilderIndex = 0;

        chainQueue = null;
        flipChainedStructures = false;
        cqX = null;
        cqY = null;

        drawSidebar();

        webAppCore.handleBackFunction(standardBack);
    }

    function selectIdleBuilder() {

        if(!currentGame) {
            return;
        }

        var availableBuilders = [];

        for(var i = 0; i < currentGame.vehicles.length; i++) {
            if(!currentGame.vehicles[i].inBuildingMode && !currentGame.vehicles[i].iH) {
                availableBuilders.push(currentGame.vehicles[i]);
            }
        }

        if(availableBuilders.length == 0) {
            webAppCore.showToast("No idle builders");
            return;
        }

        if(idleBuilderIndex > availableBuilders.length - 1) {
            idleBuilderIndex = 0;
        }

        selectedVehicle = [];
        selectedVehicle.push(availableBuilders[idleBuilderIndex]);
        
        Scroll2d.setZoomLevel(1 / renderScaleFactor);
        Scroll2d.centerOnCoord(selectedVehicle[0].x,selectedVehicle[0].y);
        
        drawSidebar();

        showOptionsForObject(selectedVehicle[0],"vehicle");

        idleBuilderIndex++;
    }
    
    function buildingStatCompress(building) {

        if(!building) {
            return;
        }

        delete building.acceptsWorkers;
        delete building.generateAmount;
        delete building.generateTime;
        delete building.generates;
        delete building.requiresWorkers;
        delete building.openForEntertainment;
        delete building.openForTourism;
        delete building.openForMedical;
        delete building.workerCheckCounter;
        delete building.colGenCounter;
        delete building.colGenMax;
        delete building.colGenPercentage;
        delete building.noConsumptionMode;
        delete building.isUnderConstruction;
        delete building.name;

    }

    function restoreBuildingStats(building) {

        if(!building) {
            return;
        }


        building.name = building.def + " #" + building.id;

        building.wc = null;
    }

    function cleanUpUnneededPassableProperties() {
        // should have passable parm
    }

    function showImportMenu(building) {

        if(currentGame == null) {
            return;
        }

        pendingImportExportItem = building;

        clearOutBuildMenu();

        var def = getBuildingDefByName(building.def);

        tmpTradeCapacity = def.tradeCapacity;

        if(tmpTradeCapacity == 0) {
            tmpTradeCapacity = 100;
        }

        if(def.canImport == null) {
            webAppCore.showAlertWithTitle("There is nothing to import!","No Options");
            return;
        }

        var menuOptions = [];
        
        for (var i = 0; i < def.canImport.length; i++) {

            var statusColor = null;

            var unitPriace = (parseInt(getGameResources()[def.canImport[i]].price) / 100.0) * tmpTradeCapacity;

            var importPrice = Math.round(unitPriace * importPriceMod);
            var transactionFee = Math.ceil(importPrice * importPenalty);

            var net = importPrice + transactionFee;


            if(net > getGameResources()[ColonyGame.meta.tenderResource].amount) {
                statusColor = "#F44336";
            }

            var resName = def.canImport[i];

            var optionItem = {
                "title": resName,
                "title-color": null,
                "description": null,
                "status": "Price: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(importPrice) + " per " + numberWithCommas(tmpTradeCapacity) ,
                "status-color": statusColor,
                "overflow": [
                    {
                        "pre":      "Transaction Fee (" + (importPenalty * 100) + "%):",
                        "post":     numberWithCommas(parseInt(transactionFee)),
                        "color":    "#FFB300",
                        "icon":     "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                    },
                    {
                        "pre":      "Total:",
                        "post":     numberWithCommas(parseInt(net)) + " per " + numberWithCommas(tmpTradeCapacity),
                        "color":    statusColor,
                        "icon":     "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                    }
                ],
                "icon": "images/" + getResourceByDefName(resName).icon,
                "tag": resName
            };

            if(!isThereResourceCapacity(resName,tmpTradeCapacity)) {
                optionItem.overflow.push({
                    "pre":      null,
                    "post":     "Storage Full",
                    "color":    "#FFB300",
                    "icon":     "images/res-trend-max.png"
                });
            }

            menuOptions.push(optionItem);
        }
        
        if(menuOptions.length == 0) {
            webAppCore.showAlertWithTitle("There is nothing to import!","No Options");
            return;
        }

        if(menuOptions.length == 1) {
            onImportDelected(menuOptions[0].tag);
            return;
        }
        
        showList(getString("import-goods"),menuOptions,onImportDelected,"Nevermind");
    }

    function isThereResourceCapacity(resName,tryingToAdd) {
        var hascapacity = false;

        var modifier = 0;

        if(tryingToAdd) {
            modifier = parseInt(tryingToAdd);
        }

        if(getGameResources()[resName].capacity == null || getGameResources()[resName].capacity == 0 || (getGameResources()[resName].capacity == -1 && (getGameResources()[resName].storageCapacity > (getGameResources()[resName].amount + modifier)))) {
            hascapacity = true;
        }

        return hascapacity;
    }

    var tmpImportExportCapCustom = 0;
    var tmpTradingGoodSingleUnitPrice = 0;

    function showTaxRateWindow() {
        var existingRate = getRegionOrCity().taxLevel;

        webAppCore.showDialog({
            title: getString("tax-rate"),
            message: getString("tax-rate-desc"),
            icon: "images/" + ColonyGame.meta.taxCollectionInd,
            sliderMin: 0,
            sliderMax: 500,
            sliderValue: parseInt(getRegionOrCity().taxLevel),
            sliderStatusText: getRegionOrCity().taxLevel + "%",
            sliderCallback: function(val,fun) {
                getRegionOrCity().taxLevel = parseInt(val);
                fun(getRegionOrCity().taxLevel + "%");
            },
            buttons: [
                {
                    text: getString("general-confirm"),
                    func: function(){
                        showColonistsMenu("commonwealth");
                        updateColonyStats();
                    },
                    color: "#4CAF50"
                },
                {
                    text: getString("general-cancel"),
                    func: function(){
                        getRegionOrCity().taxLevel = parseInt(existingRate);
                    }
                }
            ]
        });
    }

    function doImportFromAI(good) {
        var gr = getGameResources();

        if(!gr || !gr[good]) {
            return;
        }

        var baseUnitPer100Price = importPriceMod * gr[good].price;

        var goodDef = getResourceByDefName(good);

        tmpImportExportCapCustom = tmpTradeCapacity;
        tmpTradingGoodSingleUnitPrice = Math.ceil(parseInt(baseUnitPer100Price) / 100.0);

        var trnprice = tmpTradingGoodSingleUnitPrice * tmpImportExportCapCustom;
        var transactionFee = Math.ceil(trnprice * importPenalty);
        var total = trnprice + transactionFee;

        var totalPer100Price = baseUnitPer100Price + (baseUnitPer100Price * importPenalty);

        webAppCore.showDialog({
            title: getString("import-goods"),
            message: getString("gen-importing") + " " + good + " @ " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(baseUnitPer100Price) + " per 100<br /><br />Transaction Fee (" + (importPenalty * 100) + "%)<br />Total: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(totalPer100Price) + " per 100",
            icon: "images/" + goodDef.icon,
            sliderMin: 0,
            sliderMax: tmpTradeCapacity,
            sliderValue: tmpTradeCapacity,
            sliderStatusText: tmpImportExportCapCustom + "/" + tmpTradeCapacity + " -> " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(total),
            sliderCallback: function(val,fun) {

                var gameRes = getGameResources();

                if(!gameRes) {
                    return;
                }

                tmpImportExportCapCustom = parseInt(val);

                var trnprice = tmpTradingGoodSingleUnitPrice * tmpImportExportCapCustom;
                var transactionFee = Math.ceil(trnprice * importPenalty);
                var total = trnprice + transactionFee;
                
                var impAmntWarning = "";
                
                if(total > gameRes[ColonyGame.meta.tenderResource].amount) {
                    // at some point, make the text red when it is supported
                    impAmntWarning = " (!)";
                }

                fun(tmpImportExportCapCustom + "/" + tmpTradeCapacity + " -> " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(total) + impAmntWarning);
            },
            buttons: [
                {
                    text: getString("general-confirm"),
                    func: function() {
                        if(tmpImportExportCapCustom > 0) {

                            var gameRes = getGameResources();

                            if(!gameRes) {
                                return;
                            }

                            var trnprice = tmpTradingGoodSingleUnitPrice * tmpImportExportCapCustom;
                            var transactionFee = Math.ceil(trnprice * importPenalty);
                            var total = trnprice + transactionFee;
                            

                            if(total > gameRes[ColonyGame.meta.tenderResource].amount) {
                                webAppCore.showAlertWithTitle(getString("general-cant-afford"),"Insufficient Funds");
                                return;
                            }
                    
                            if(!isThereResourceCapacity(good)) {
                                webAppCore.showAlertWithTitle("You do not have enough storage to make this transaction.","Storage Full");
                                return;
                            }

                            modifyResourceAmount(good,tmpImportExportCapCustom,false,"Trade");
                            modifyResourceAmount(ColonyGame.meta.tenderResource,-total,false,"Trade");
                    
                    
                            var priceGain = Math.round(gameRes[good].price * 0.006);
                            gameRes[good].price += priceGain;
                    
                            webAppCore.showToast({
                                message: "Purchased " + tmpImportExportCapCustom + " " + good,
                                image:   "images/" + getResourceByDefName(good).icon
                            }); 
                    
                            if(ColonyGame.sounds.contractBuy != null) {
                                playInterfaceSoundEffect(ColonyGame.sounds.contractBuy);
                            }
                    
                            if(pendingImportExportItem != null) {
                                showImportMenu(pendingImportExportItem);
                            }
                        }
                    },
                    color: "#4CAF50"
                },
                {
                    text: getString("general-cancel"),
                    func: placeholder
                }
            ]
        });
    }

    function onImportDelected(good) {

        if(good == null || currentGame == null) {
            return;
        }

        if(getRegionOrCity().offlineMode) {
            doImportFromAI(good);
            return;
        }

        var gameRes = getGameResources();

        if(!gameRes) {
            doImportFromAI(good);
            return;
        }
        
        var resItem = gameRes[good];

        if(!resItem) {
            doImportFromAI(good);
            return;
        }

        var data = [];

        data.push({
            "key":      "r",
            "value":    resItem.serverId
        });

        var i;

        postSecuredCallToApi(data,58,function(result){
            if(result != null && result.trim().length > 0) {

                gameRes = getGameResources();

                var currentContracts = null;

                try {
                    currentContracts = JSON.parse(result);
                } catch(ex) {
                    webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onImportDelected",ex.message);
                    doImportFromAI(good);
                    return;
                }

                if(!currentContracts || !gameRes) {
                    doImportFromAI(good);
                    return;
                }

                var acceptableContracts = [];
                var thisCon,perCap,perUnit;

                var unitPriace = (parseInt(gameRes[good].price) / 100.0) * tmpTradeCapacity;

                var importPrice = Math.round(unitPriace * importPriceMod);
                var transactionFee = Math.ceil(importPrice * importPenalty);

                var net = importPrice + transactionFee;

                var auUnitPriace = parseInt(net) / tmpTradeCapacity;

                for(i = 0; i < currentContracts.contracts.length; i ++) {
                    thisCon = currentContracts.contracts[i];

                    if(thisCon.sellerid == getRegionOrCity().colonyId) {
                        continue;
                    }

                    if(thisCon.isoffer == "1") {
                        continue;
                    }

                    perUnit = parseFloat(thisCon.perunit);
                    perCap = Math.round(perUnit * tmpTradeCapacity);

                    if(perUnit > auUnitPriace) {
                        continue;
                    }

                    if(parseInt(thisCon.price > gameRes[ColonyGame.meta.tenderResource].amount)) {
                        continue;
                    }

                    if(parseInt(thisCon.quantity) <= tmpTradeCapacity) {
                        acceptableContracts.push(thisCon);
                    }
                }

                if(acceptableContracts.length == 0) {
                    doImportFromAI(good);
                    return;
                }

                var theImportOptions = [];

                

                theImportOptions.push({
                    title: pendingImportExportItem.name,
                    icon: "images/" + getResourceByDefName(good).icon,
                    overflow: [
                        {
                            "pre":      "Price:",
                            "post":     numberWithCommas(parseInt(net)) + " per " + numberWithCommas(tmpTradeCapacity),
                            "icon":     "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                        }
                    ],
                    tag: "fromai"
                });

                for(i = 0; i < acceptableContracts.length; i++) {
                    if(i > 30) {
                        break;
                    }

                    thisCon = acceptableContracts[i];

                    perUnit = parseFloat(thisCon.perunit);
                    perCap = Math.round(perUnit * tmpTradeCapacity);

                    theImportOptions.push({
                        title: thisCon.sellername,
                        description: numberWithCommas(parseInt(thisCon.quantity)) + " units for " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(parseInt(thisCon.price)),
                        icon: "images/" + getResourceByDefName(good).icon,
                        overflow: [
                            {
                                "pre":      "Price:",
                                "post":     numberWithCommas(parseInt(perCap)) + " per " + numberWithCommas(tmpTradeCapacity),
                                "icon":     "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                            }
                        ],
                        tag: thisCon
                    });

                    
                }

                webAppCore.presentNativeList(good,theImportOptions,function(tag) {

                    if(!tag) {
                        return;
                    }

                    if(tag == "fromai") {
                        doImportFromAI(good);
                        return;
                    }

                    purchaseNewGBTContract({
                        "fromTicker": false,
                        "silentTrade": false,
                        "resourceName": good,
                        "contractRef": tag
                    });

                },"Dismiss");

            }
        });
    }

    var pendingImportExportItem = null;

    var tmpTradeCapacity = 100;

    function showExportMenu(building) {

        pendingImportExportItem = building;

        clearOutBuildMenu();

        var def = getBuildingDefByName(building.def);

        tmpTradeCapacity = def.tradeCapacity;

        if(tmpTradeCapacity == 0) {
            tmpTradeCapacity = 100;
        }

        if(def.canExport == null) {
            webAppCore.showAlertWithTitle("There is nothing to export!","No Options");
            return;
        }

        var menuOptions = [];

        
        
        for (var i = 0; i < def.canExport.length; i++) {

            var statusColor = null;

            if(getGameResources()[def.canExport[i]].amount < tmpTradeCapacity) {
                statusColor = "#F44336";
            }

            var unitPriace = (parseInt(getGameResources()[def.canExport[i]].price) / 100.0) * tmpTradeCapacity;

            var exportPrice = Math.round(unitPriace * exportPriceMod);
            var transactionFee = Math.ceil(exportPrice * exportPenalty);

            var net = exportPrice - transactionFee;

            menuOptions.push({
                "title": def.canExport[i],
                "title-color": null,
                "description": null,
                "status": "Price: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(exportPrice) + " per " + numberWithCommas(tmpTradeCapacity) ,
                "status-color": statusColor,
                "overflow": [
                    {
                        "pre":      "Transaction Fee (" + (exportPenalty * 100) + "%):",
                        "post":     numberWithCommas(parseInt(transactionFee)),
                        "color":    "#FFB300",
                        "icon":     "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                    },
                    {
                        "pre":      "Net:",
                        "post":     numberWithCommas(parseInt(net)) + " per " + numberWithCommas(tmpTradeCapacity),
                        "color":    null,
                        "icon":     "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                    }
                ],
                "icon": "images/" + getResourceByDefName(def.canExport[i]).icon,
                "tag": def.canExport[i]
            });
        }
        
        if(menuOptions.length == 0) {
            webAppCore.showAlertWithTitle("There is nothing to export!","No Options");
            return;
        }
        
        showList("Export Goods",menuOptions,onExportGoodSelected,"Nevermind");
    }

    function onExportGoodSelected(good) {

        if(good == null || currentGame == null) {
            return;
        }

        var gameRes = getGameResources();

        if(!gameRes) {
            return;
        }

        var baseUnitPer100Price = exportPriceMod * gameRes[good].price;

        var goodDef = getResourceByDefName(good);

        tmpImportExportCapCustom = parseInt(tmpTradeCapacity);
        tmpTradingGoodSingleUnitPrice = Math.ceil(parseInt(baseUnitPer100Price) / 100.0);

        var trnprice = tmpTradingGoodSingleUnitPrice * tmpImportExportCapCustom;
        var transactionFee = Math.ceil(trnprice * exportPenalty);
        var total = trnprice - transactionFee;

        var totalPer100Price = baseUnitPer100Price - (baseUnitPer100Price * exportPenalty);

        if(tmpImportExportCapCustom > gameRes[good].amount) {
            tmpImportExportCapCustom = gameRes[good].amount;
        }


        webAppCore.showDialog({
            title: getString("export-goods"),
            message: getString("gen-exporting") + " " + good + " @ " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(baseUnitPer100Price) + " per 100<br /><br />Transaction Fee (" + (exportPenalty * 100) + "%)<br />Total: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(totalPer100Price) + " per 100",
            icon: "images/" + goodDef.icon,
            sliderMin: 0,
            sliderMax: tmpTradeCapacity,
            sliderValue: tmpTradeCapacity,
            sliderStatusText: tmpImportExportCapCustom + "/" + tmpTradeCapacity + " -> " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(total),
            sliderCallback: function(val,fun) {

                tmpImportExportCapCustom = val;

                var trnprice = tmpTradingGoodSingleUnitPrice * tmpImportExportCapCustom;
                var transactionFee = Math.ceil(trnprice * exportPenalty);
                var total = trnprice - transactionFee;

                var expAmntWarning = "";
                
                if(tmpImportExportCapCustom > gameRes[good].amount) {
                    // at some point, make the text red when it is supported
                    expAmntWarning = " (!)";
                }

                fun(tmpImportExportCapCustom + "/" + tmpTradeCapacity + expAmntWarning + " -> " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(total));
            },
            buttons: [
                {
                    text: getString("general-confirm"),
                    func: function() {
                        if(tmpImportExportCapCustom > 0) {
                            var trnprice = tmpTradingGoodSingleUnitPrice * tmpImportExportCapCustom;
                            var transactionFee = Math.ceil(trnprice * exportPenalty);
                            var total = trnprice - transactionFee;

                            if(tmpImportExportCapCustom > gameRes[good].amount) {
                                webAppCore.showAlertWithTitle("You do not have enough " + good + " to make this transaction.","Insufficient " + good);
                                return;
                            }



                            modifyResourceAmount(good,-tmpImportExportCapCustom,false,"Trade");
                            modifyResourceAmount(ColonyGame.meta.tenderResource,total,false,"Trade");

                            var priceLoss = Math.round(gameRes[good].price * 0.008);
                            gameRes[good].price -= priceLoss;

                            if(gameRes[good].price < 1) {
                                gameRes[good].price = 1;
                            }

                            webAppCore.showToast({
                                message: "Sold " + tmpImportExportCapCustom + " " + good,
                                image:   "images/" + getResourceByDefName(good).icon
                            });

                            if(ColonyGame.sounds.contractBuy) {
                                playInterfaceSoundEffect(ColonyGame.sounds.contractBuy);
                            }

                            if(pendingImportExportItem != null) {
                                showExportMenu(pendingImportExportItem);
                            }

                        }
                    },
                    color: "#4CAF50"
                },
                {
                    text: getString("general-cancel"),
                    func: placeholder
                }
            ]
        });
    }

    function getRaceByName(name) {
        for(var i = 0; i < ColonyGame.races.length; i++) {
            if(ColonyGame.races[i].name == name) {
                return ColonyGame.races[i];
            }
        }

        return null;
    }

    function getColonistTile(colonist) {

        if(colonist.tkn && colonist.tkn != null) {
            return colonist.tkn;
        }

        var raceCard = getRaceByName(colonist.race);

        if(raceCard == null) {
            colonist.race = currentGame.defaultRace;
            raceCard = getRaceByName(colonist.race);
        }

        if(raceCard == null) {
            colonist.race = ColonyGame.races[0].name;
            raceCard = getRaceByName(colonist.race);
        }

        var tile = raceCard.defaultSprites[getRegionOrCity().stage][randomIntFromInterval(0,raceCard.defaultSprites[getRegionOrCity().stage].length - 1)];


        return tile;
    }

    function advanceToStage(stage) {
        var stageInfo = ColonyGame.meta.gameStages[stage];

        if(getGameResources()[ColonyGame.meta.gameStageResource].amount < stageInfo.threshold) {
            return;
        }

        getRegionOrCity().stage = stage;

        if(stageInfo.message != null) {
            webAppCore.showAlert(getString(stageInfo.message));
        }


    }


    function cleanRetainedPaths() {
        var killas = [];

        for(var prop in retainedPaths) {
            if(!retainedUsage[prop] || retainedUsage[prop] <= 0) {
                killas.push(prop);
            } else {
                retainedUsage[prop]--;

                if(retainedUsage[prop] <= 0) {
                    killas.push(prop);
                }
            }
        }

        while(killas.length > 0) {
            var kill = killas.pop();

            delete retainedPaths[kill];
            delete retainedUsage[kill];
        }
    }

    function isUpgradeAvailableForStructure(structur,isDef) {

        var i,def;

        if(isDef) {
            def = structur;
        } else {
            def = getBuildingDefByName(structur.def);
        }

        var upgradeCost = {};

        if(def.canUpgradeTo == null) {
            return null;
        }

        var newStructureDef = getBuildingDefByName(def.canUpgradeTo);

        if(newStructureDef.requiresStage > getRegionOrCity().stage) {
            return null;
        }

        if(newStructureDef.requiPremium) {
            if(!webAppCore.getIsPremium()) {
                return null;
            }
        }

        if(!canIBuildThis(def,"building",true)) {
            return null;
        }

        if(newStructureDef.requiresTech != null) {
            for(i = 0; i < newStructureDef.requiresTech.length; i++) {


                var techParts = newStructureDef.requiresTech[i].split("|");

                var hasThisOne = false;

                for(var k = 0; k < techParts.length; k++) {
                    if(getGameTechs()[techParts[k]]) {
                        hasThisOne = true;
                    }
                }

                if(!hasThisOne) {
                    return null;
                }

            }
        }

        for(i = 0; i < newStructureDef.cost.length; i++) {
            var cst = newStructureDef.cost[i].amount;

            if(def.cost) {
                for(var j = 0; j < def.cost.length; j++) {
                    if(def.cost[j].resource == newStructureDef.cost[i].resource) {
                        cst -= def.cost[j].amount;
                    }
                }
            }
            
            if(cst < 0) {
                cst = 0;
            }

            if(getGameResources()[newStructureDef.cost[i].resource].amount < cst) {
                return null;
            }

            upgradeCost[newStructureDef.cost[i].resource] = cst;
        }

        return {
            "structure":    newStructureDef,
            "cost":         upgradeCost
        };

    }

    function conductUpgrade(frm,to,type) {

        var arrayToUse = currentGame.buildings;

        if(type == "passable") {
            arrayToUse = currentGame.passableNonUpdatables;
        }

        frm.isBeingRemoved = true;


        conductBuildingUpgradeEngage(to,frm.x,frm.y,type,arrayToUse,frm.flipped);

    }

    function showEngineSettings() {
        var menuOptions = [];


        /*
        *   Colonist Option
        */

        var colCurrent = "Off";
        var colColor = "#E53935";

        if(drawColonists) {
            colCurrent = "On";
            colColor = "#43A047";
        }

        menuOptions.push({
            "title": "Render Colonists",
            "title-color": null,
            "description": null,
            "status": colCurrent,
            "status-color": colColor,
            "icon": "images/" + ColonyGame.meta.colonistIcon,
            "tag": "drawcol"
        });



        /*
        *   Text Poppers Option
        */

        var textPopperCurrent = "Off";
        var textPopperColor = "#E53935";

        if(useTextPoppers) {
            textPopperCurrent = "On";
            textPopperColor = "#43A047";
        }

        menuOptions.push({
            "title": "Resource Text Poppers",
            "title-color": null,
            "description": null,
            "status": textPopperCurrent,
            "status-color": textPopperColor,
            "icon": "images/" + ColonyGame.meta.setPopperIndicator,
            "tag": "poppers"
        });



        /*
        *   Animations Option
        */

        var animationsCurrent = "Off";
        var animationsColor = "#E53935";

        if(allowAnimation) {
            animationsCurrent = "On";
            animationsColor = "#43A047";
        }

        menuOptions.push({
            "title": "Building Animations",
            "title-color": null,
            "description": null,
            "status": animationsCurrent,
            "status-color": animationsColor,
            "icon": "images/" + ColonyGame.meta.indAnimationSetting,
            "tag": "animations"
        });



        /*
        *   Short Numbers Option
        */
        var shortNumbersCurrent = "Off";
        var shortNumbersColor = "#E53935";

        if(shortNumbers) {
            shortNumbersCurrent = "On";
            shortNumbersColor = "#43A047";
        }

        menuOptions.push({
            "title": getString("engine-short-numbers"),
            "title-color": null,
            "description": getString("engine-short-numbers-desc"),
            "status": shortNumbersCurrent,
            "status-color": shortNumbersColor,
            "icon": "images/" + ColonyGame.meta.indSmallNumbers,
            "tag": "shortnums"
        });



        /*
        *   Storage Limits Option
        */
        var storeLimitCurrent = "Off";
        var storeLimitColor = "#E53935";

        if(showCapacity) {
            storeLimitCurrent = "On";
            storeLimitColor = "#43A047";
        }

        menuOptions.push({
            "title": getString("engine-storage-limits"),
            "title-color": null,
            "description": getString("engine-storage-limits-desc"),
            "status": storeLimitCurrent,
            "status-color": storeLimitColor,
            "icon": "images/" + ColonyGame.meta.indStoreLimits,
            "tag": "storelimits"
        });



        /*
        *   Lighting Option
        */

        var lightingCurrent = "Off";
        var lightingColor = "#E53935";

        if(allowLighting) {
            lightingCurrent = "On";
            lightingColor = "#43A047";
        }

        menuOptions.push({
            "title": "Lighting Effects",
            "title-color": null,
            "description": null,
            "status": lightingCurrent,
            "status-color": lightingColor,
            "icon": "images/" + ColonyGame.meta.indLightingSetting,
            "tag": "lighting"
        });


        /*
        *   Day/Night Option
        */

        var daynightCurrent = "Always Day";
        var daynightColor = "#FFCA28";

        if(allowDayNight == "1") {
            daynightCurrent = "Normal";
            daynightColor = "#43A047";
        }

        if(allowDayNight == "2") {
            daynightCurrent = "Always Night";
            daynightColor = "#283593";
        }

        menuOptions.push({
            "title": "Day/Night Cycle",
            "title-color": null,
            "description": null,
            "status": daynightCurrent,
            "status-color": daynightColor,
            "icon": "images/" + ColonyGame.meta.indDaynightSetting,
            "tag": "daynight"
        });

        /*
        *   Particle Effects Option
        */

        var particleCurrent = "Off";
        var particleColor = "#E53935";

        if(allowParticleEffects) {
            particleCurrent = "On";
            particleColor = "#43A047";
        }

        menuOptions.push({
            "title": "Particle Effects",
            "title-color": null,
            "description": null,
            "status": particleCurrent,
            "status-color": particleColor,
            "icon": "images/" + ColonyGame.meta.indParticlesSetting,
            "tag": "particleeffects"
        });


        /*
        *   Render Distance Check
        */

        var renderCheckCurrent = "Off";
        var renderCheckColor = "#E53935";

        if(checkRenderDistance) {
            renderCheckCurrent = "On";
            renderCheckColor = "#43A047";
        }
        menuOptions.push({
            "title": getString("check-render-distance"),
            "title-color": null,
            "description": getString("check-render-dist-desc"),
            "status": renderCheckCurrent,
            "status-color": renderCheckColor,
            "icon": "images/ind-rendercheck.png",
            "tag": "renderdistcheck"
        });


        /*
        *   FPS Option
        */
        var fpsCapCurrent = "No Cap";
        var fpxCapColor = "#43A047";

        if(fpsRate == 2) {
            fpsCapCurrent = "Small Cap";
            fpxCapColor = "#7CB342";
        }

        if(fpsRate == 3) {
            fpsCapCurrent = "Medium Cap";
            fpxCapColor = "#FDD835";
        }

        if(fpsRate == 4) {
            fpsCapCurrent = "High Cap";
            fpxCapColor = "#FB8C00";
        }

        if(fpsRate == 5) {
            fpsCapCurrent = "Extreme Cap";
            fpxCapColor = "#E53935";
        }

        menuOptions.push({
            "title": "Render FPS Cap",
            "title-color": null,
            "description": "Capping Render FPS will make the game appear more choppy, but will increase simulation speed and reduce power consumption.",
            "status": fpsCapCurrent,
            "status-color": fpxCapColor,
            "icon": "images/" + ColonyGame.meta.setFpsIndicator,
            "tag": "fps"
        });


        /*
            Update Frequency
        */

        var updateOption = getString("bld-update-freq-def");
        var updateColor = "#2196F3";

        if(buildingUpdateCycles == 12) {
            updateOption = getString("bld-update-freq-12");
            updateColor = "#009688";
        }

        if(buildingUpdateCycles == 5) {
            updateOption = getString("bld-update-freq-5");
            updateColor = "#009688";
        }

        if(buildingUpdateCycles == 1) {
            updateOption = getString("bld-update-freq-1");
            updateColor = "#4CAF50";
        }

        if(buildingUpdateCycles == 15) {
            updateOption = getString("bld-update-freq-15");
            updateColor = "#FF9800";
        }

        if(buildingUpdateCycles == 30) {
            updateOption = getString("bld-update-freq-30");
            updateColor = "#F44336";
        }

        //buildingUpdateCycles
        menuOptions.push({
            "title": getString("bld-update-freq"),
            "title-color": null,
            "description": getString("bld-update-freq-desc"),
            "status": updateOption,
            "status-color": updateColor,
            "icon": "images/" + ColonyGame.meta.indLowres,
            "tag": "simspeed"
        });



        var loresOptionText = "Off";
        var loresOptionColor = "#4CAF50";

        if(loresMode) {
            loresOptionText = "On";
            loresOptionColor = "#2196F3";
        }

        menuOptions.push({
            "title": "Low Res Mode",
            "title-color": null,
            "description": "Reduce memory consumption and increase rendering performance by using lower resolution textures.",
            "status": loresOptionText,
            "status-color": loresOptionColor,
            "icon": "images/" + ColonyGame.meta.indLowres,
            "tag": "lowres"
        });

        if(!webAppCore.isTV()) {

            if(webAppCore.getPlatform().platform != "ios") {
                menuOptions.push({
                    "title": getString("engine-keyboard"),
                    "title-color": null,
                    "description": getString("engine-keyboard-meta"),
                    "status": null,
                    "status-color": null,
                    "icon": "images/" + ColonyGame.meta.keyboardIndicator,
                    "tag": "keyboard"
                });
            }

            if(window.innerWidth > sidebarModeWidth) {

                var sidebarOption = "Disabled";

                if(desktopMode) {
                    sidebarOption = "Enabled";
                }


                menuOptions.push({
                    "title": getString("engine-sidebar"),
                    "title-color": null,
                    "description": null,
                    "status": sidebarOption,
                    "status-color": null,
                    "icon": "images/" + ColonyGame.meta.sidebarIndicator,
                    "tag": "sidebar"
                });
            }

            var zoomButtonsCurrent = "Off";

            if(showZoomButtons) {
                zoomButtonsCurrent = "On";
            }

            menuOptions.push({
                "title": getString("engine-zoom-buttons"),
                "title-color": null,
                "description": null,
                "status": zoomButtonsCurrent,
                "status-color": null,
                "icon": "images/" + ColonyGame.meta.zoomInIcon,
                "tag": "zoombuttons"
            });
        }

        var volDefault = "100";
        var soundVolColor = null;

        if(!allowAudio) {
            volDefault = "0";
        }

        var soundEffectVolume = parseInt(webAppCore.getVar("effect-volume",volDefault));

        var soundEffectStatus = getString("gen-volume") + ": " + soundEffectVolume + "%";

        if(soundEffectVolume == 0) {
            soundEffectStatus = getString("gen-disabled");
            soundVolColor = "#f44336";
        }

        menuOptions.push({
            "title": getString("general-sound-xf"),
            "title-color": null,
            "description": null,
            "status": soundEffectStatus,
            "status-color": soundVolColor,
            "icon": "images/" + ColonyGame.meta.soundIndicator,
            "progress": soundEffectVolume,
            "tag": "soundxf"
        });
        


        if(ColonyGame.soundtrack.length > 0) {
            var musicoption = "Off";
            
            if(allowMusic) {
                musicoption = "On";
            }
    
            menuOptions.push({
                "title": "Music",
                "title-color": null,
                "description": null,
                "status": musicoption,
                "status-color": null,
                "icon": "images/" + ColonyGame.meta.soundIndicator,
                "tag": "musicsetting"
            });
        }

        var autosaveOption = getString("autosave-freq-normal");
        var autosaveColor = null;

        var currentSetting = webAppCore.getVar("mc-autosave-freq","1");

        if(currentSetting == "0") {
            autosaveOption = getString("autosave-freq-often");
            autosaveColor = "#F44336";
        }

        if(currentSetting == "2") {
            autosaveOption = getString("autosave-freq-rare");
        }

        if(currentSetting == "3") {
            autosaveOption = getString("autosave-freq-never");
            autosaveColor = "#F44336";
        }

        menuOptions.push({
            "title": getString("autosave-freq"),
            "title-color": null,
            "description": getString("autosave-freq-desc"),
            "status": autosaveOption,
            "status-color": autosaveColor,
            "icon": "images/" + ColonyGame.meta.autosaveInd,
            "tag": "autosave"
        });

        var backupOption = webAppCore.getVar("mc-backup-option","1");
        var backupStatus = "On";
        var backupColor = "#4CAF50";
        var backupIcon = ColonyGame.meta.backupOnInd;

        if(backupOption == "0") {
            backupStatus = "Off";
            backupColor = "#F44336";
            backupIcon = ColonyGame.meta.backupOffInd;
        }

        menuOptions.push({
            "title": getString("backupOption"),
            "title-color": null,
            "description": getString("backupOptionDesc"),
            "status": backupStatus,
            "status-color": backupColor,
            "icon": "images/" + backupIcon,
            "tag": "backup"
        });

        var pathfindingColor = "#2196F3";
        var pathfindingText = "On";

        if(useSyncPathfinding) {
            pathfindingColor = "#FF9800";
            pathfindingText = "Off";
        }

        // pathfinding setting 
        menuOptions.push({
            "title": getString("multithreaded-pathfinding"),
            "title-color": null,
            "description": getString("multithreaded-pathfinding-desc"),
            "status": pathfindingText,
            "status-color": pathfindingColor,
            "icon": "images/" + ColonyGame.meta.annexInd,
            "tag": "pathfinding"
        });


        // online notifications setting 
        var onlineNotiColor = "#2196F3";
        var onlineNotiSetting = "On";

        if(!useOnlineNotifications) {
            onlineNotiColor = "#FF9800";
            onlineNotiSetting = "Off";
        }

        menuOptions.push({
            "title": "Multiplayer Notifications",
            "title-color": null,
            "description": "Toggle Multiplayer notifications on or off.",
            "status": onlineNotiSetting,
            "status-color": onlineNotiColor,
            "icon": "images/" + ColonyGame.meta.localEventIcon,
            "tag": "onlinenoti"
        });


        // gamepad settings
        if(webAppCore.getInterface() != "ios") {
            var gamepadSettingColor = "#4CAF50";
            var gamepadSettingOption = "Enabled";
    
            if(!allowGamepad) {
                gamepadSettingColor = "#f44336";
                gamepadSettingOption = "Disabled";
            }
    
            menuOptions.push({
                "title": "Gamepad",
                "title-color": null,
                "description": getString("gamepad-setting-desc"),
                "status": gamepadSettingOption,
                "status-color": gamepadSettingColor,
                "icon": "images/" + ColonyGame.meta.gamepadInd,
                "tag": "gamepad"
            });
        }
        


        showList("Engine Settings",menuOptions,onEngineSettingSelected,getString("general-dismiss"));

    }

    function onEngineSettingSelected(tag) {

        if(!tag || tag == null) {
            return;
        }

        if(tag == "gamepad") {
            allowGamepad = !allowGamepad;

            if(allowGamepad) {
                webAppCore.storeVar("allow-gamepad","1");
                webAppCore.showToast("Gamepad Enabled");
            } else {
                webAppCore.storeVar("allow-gamepad","0");
                webAppCore.showToast("Gamepad Disabled");
            }
        }

        if(tag == "onlinenoti") {
            useOnlineNotifications = !useOnlineNotifications;

            if(useOnlineNotifications) {
                webAppCore.showToast("Online Notifications On");
                webAppCore.storeVar("online-noti-opt","1");
            } else {
                webAppCore.showToast("Online Notifications Off");
                webAppCore.storeVar("online-noti-opt","0");
            }

            showEngineSettings();
        }

        if(tag == "pathfinding") {
            useSyncPathfinding = !useSyncPathfinding;

            if(useSyncPathfinding) {
                webAppCore.showToast(getString("multithreaded-pathfinding") + " Off");
                webAppCore.storeVar("sync-pathfinding-opt","1");
            } else {
                webAppCore.showToast(getString("multithreaded-pathfinding") + " On");
                webAppCore.storeVar("sync-pathfinding-opt","0");
            }

            gooseUpPathWorker();

            syncColMap = null;
            syncNodeRecycling = [];

            updateCollisionMap();
        }

        if(tag == "shortnums") {
            toggleShortNumbers();
            showEngineSettings();
        }

        if(tag == "storelimits") {
            toggleResourceCapacity();
            showEngineSettings();
        }

        if(tag == "simspeed") {
            showSimSpeedMenu();
        }

        if(tag == "lowres") {
            toggleLoresMode(false);
            monitoringRes = false;
            showEngineSettings();
        }

        if(tag == "renderdistcheck") {
            checkRenderDistance = !checkRenderDistance;

            if(checkRenderDistance) {
                webAppCore.storeVar("check-render-distance","1");
            } else {
                webAppCore.storeVar("check-render-distance","0");
            }

            Scroll2d.setFastRenderMode(!checkRenderDistance);

            showEngineSettings();
        }

        if(tag == "backup") {
            var backupOption = webAppCore.getVar("mc-backup-option","1");

            if(backupOption == "0") {
                webAppCore.storeVar("mc-backup-option","1");
            } else {
                webAppCore.storeVar("mc-backup-option","0");
            }

            showEngineSettings();
        }

        if(tag == "daynight") {

            if(allowDayNight == "0") {
                allowDayNight = "1";
                webAppCore.storeVar("allow-daynight",allowDayNight);
                showEngineSettings();
                return;
            }

            if(allowDayNight == "1") {
                allowDayNight = "2";
                webAppCore.storeVar("allow-daynight",allowDayNight);
                showEngineSettings();
                return;
            }

            if(allowDayNight == "2") {
                allowDayNight = "0";
                webAppCore.storeVar("allow-daynight",allowDayNight);
                showEngineSettings();
                return;
            }

            
        }

        if(tag == "lighting") {

            allowLighting = !allowLighting;

            if(allowLighting) {
                webAppCore.storeVar("allow-lighting","1");
            } else {
                webAppCore.storeVar("allow-lighting","0");
            }

            showEngineSettings();
        }

        if(tag == "particleeffects") {
            
            allowParticleEffects = !allowParticleEffects;

            if(allowParticleEffects) {
                webAppCore.storeVar("allow-particles","1");
            } else {
                webAppCore.storeVar("allow-particles","0");
            }

            setWeather();
            showEngineSettings();
        }


        if(tag == "animations") {
            
            allowAnimation = !allowAnimation;

            if(allowAnimation) {
                webAppCore.storeVar("allow-animation","1");
            } else {
                webAppCore.storeVar("allow-animation","0");
            }

            showEngineSettings();
        }


        if(tag == "autosave") {
            showAutosaveOptions();
        }

        if(tag == "musicsetting") {
            var musicSetting;
            allowMusic = !allowMusic;

            if(allowMusic) {
                musicSetting = "1";
                initSoundtrack();
            } else {
                musicSetting = "0";
                stopSoundtrack();
            }
            webAppCore.storeVar("allow-music",musicSetting);

            showEngineSettings();
        }

        if(tag == "soundxf") {
            adjustSoundEffectsVolume();
        }

        if(tag == "zoombuttons") {
            showZoomButtons = !showZoomButtons;

            if(showZoomButtons) {
                webAppCore.storeVar("zoom-buttons","1");
                document.getElementById("zoomButtons").style.display = "inline-block";
            } else {
                webAppCore.storeVar("zoom-buttons","0");
                document.getElementById("zoomButtons").style.display = "none";
            }

            showEngineSettings();
        }

        if(tag == "sidebar") {
            desktopMode = !desktopMode;

            if(desktopMode) {
                webAppCore.storeVar("desktop-mode","1");
            } else {
                webAppCore.storeVar("desktop-mode","0");
            }
            
            sizeElements();
            Scroll2d.sizeElements();
            Scroll2d.forceSceneChange();
            showEngineSettings();
        }

        if(tag == "keyboard") {
            showKeyboardEditor();
        }

        if(tag == "drawcol") {
            drawColonists = !drawColonists;

            if(drawColonists) {
                webAppCore.storeVar("draw-col-setting","1");
            } else {
                webAppCore.storeVar("draw-col-setting","0");
            }

            showEngineSettings();
        }

        if(tag == "fps") {

            incrementFPS();

            monitoringFPS = false;

            showEngineSettings();
        }

        if(tag == "poppers") {
            useTextPoppers = !useTextPoppers;

            if(useTextPoppers) {
                webAppCore.storeVar("popper-setting","1");
            } else {
                webAppCore.storeVar("popper-setting","0");
            }

            showEngineSettings();
        }
    }

    function showAutosaveOptions() {

        var menuOptions = [];

        menuOptions.push({
            "title": getString("autosave-freq-often"),
            "title-color": null,
            "description": getString("autosave-often-warn"),
            "status": null,
            "status-color": null,
            "icon": null,
            "tag": "0"
        });

        menuOptions.push({
            "title": getString("autosave-freq-normal"),
            "title-color": null,
            "description": null,
            "status": null,
            "status-color": null,
            "icon": null,
            "tag": "1"
        });

        menuOptions.push({
            "title": getString("autosave-freq-rare"),
            "title-color": null,
            "description": null,
            "status": null,
            "status-color": null,
            "icon": null,
            "tag": "2"
        });

        menuOptions.push({
            "title": getString("autosave-freq-never"),
            "title-color": null,
            "description": getString("autosave-never-warn"),
            "status": null,
            "status-color": null,
            "icon": null,
            "tag": "3"
        });

        showList(getString("autosave-freq"),menuOptions,onSetAutosaveFreq,getString("general-dismiss"));
    }

    function showSimSpeedMenu() {

        var menuOptions = [];


        menuOptions.push({
            "title": getString("bld-update-freq-30"),
            "title-color": null,
            "description": getString("bld-update-freq-30-desc"),
            "status": null,
            "status-color": null,
            "icon": null,
            "tag": "30"
        });

        menuOptions.push({
            "title": getString("bld-update-freq-15"),
            "title-color": null,
            "description": getString("bld-update-freq-15-desc"),
            "status": null,
            "status-color": null,
            "icon": null,
            "tag": "15"
        });

        menuOptions.push({
            "title": getString("bld-update-freq-12"),
            "title-color": null,
            "description": getString("bld-update-freq-12-desc"),
            "status": null,
            "status-color": null,
            "icon": null,
            "tag": "12"
        });

        menuOptions.push({
            "title": getString("bld-update-freq-def"),
            "title-color": null,
            "description": getString("bld-update-freq-def-desc"),
            "status": null,
            "status-color": null,
            "icon": null,
            "tag": "8"
        });

        menuOptions.push({
            "title": getString("bld-update-freq-5"),
            "title-color": null,
            "description": getString("bld-update-freq-5-desc"),
            "status": null,
            "status-color": null,
            "icon": null,
            "tag": "5"
        });

        menuOptions.push({
            "title": getString("bld-update-freq-1"),
            "title-color": null,
            "description": getString("bld-update-freq-1-desc"),
            "status": null,
            "status-color": null,
            "icon": null,
            "tag": "1"
        });


        menuOptions.push({
            "title": getString("general-go-back"),
            "title-color": null,
            "description": getString("general-go-back-desc"),
            "status": null,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.backIndicator,
            "tag": "back"
        });



        showList(getString("bld-update-freq"),menuOptions,onSimSpeedOptionChange,getString("general-dismiss"));
    }

    function onSimSpeedOptionChange(tag) {
        if(!tag) {
            return;
        }

        if(tag == "back") {
            showEngineSettings();
            return;
        }

        var newSetting = parseInt(tag);

        if(newSetting > 0) {
            buildingUpdateCycles = newSetting;
            showEngineSettings();
            webAppCore.storeVar("sim-speed-setting",tag);
        }
    }

    function toggleLoresMode(dontSwitchDuringPlay) {
        loresMode = !loresMode;

        if(loresMode) {
            webAppCore.storeVar("lo-res-setting","1");
        } else {
            webAppCore.storeVar("lo-res-setting","0");
        }

        if(dontSwitchDuringPlay && currentGame != null) {
            return;
        }

        if(loresMode) {
            renderScaleFactor = loresScale;
        } else {
            renderScaleFactor = 1.0;
        }

        textureManager.setScaleFactor(renderScaleFactor);

        Scroll2d.setGridSize(ColonyGame.meta.gridSize * renderScaleFactor);
        Scroll2d.setZoomLevel(zoomLevel / renderScaleFactor);
        centerMap();

        webAppCore.storeVar("use-manual-res","1");
        textureManager.initAssets();
    }

    function incrementFPS() {
        fpsRate++;
        
        if(fpsRate == 6) {
            fpsRate = 1;
        }

        webAppCore.storeVar("fps-rate-setting",fpsRate.toString());
        webAppCore.storeVar("use-manual-fps","1");

        Scroll2d.setFPSLimiter(fpsRate);
    }

    function onSetAutosaveFreq(tag) {
        webAppCore.storeVar("mc-autosave-freq",tag);
        setAutosaveTimer();
        showEngineSettings();
    }

    function setAutosaveTimer() {
        var currentSetting = webAppCore.getVar("mc-autosave-freq","1");

        if(currentSetting == "0") {
            saveCounterMax = 6000;
        }

        if(currentSetting == "1") {
            saveCounterMax = 10000;
        }

        if(currentSetting == "2") {
            saveCounterMax = 30000;
        }

        if(currentSetting == "3") {
            saveCounterMax = -1;
        } else {
            if(webAppCore.isApeAppsLoggedIn()) {
                saveCounterMax += 5000;
            }
        }

    }

    function hexToColor(hex) {

        var result;

        if (hex.length == 6 || hex.length == 7) {
            result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
            return result ? {
                a: 255,
                r: parseInt(result[1], 16),
                g: parseInt(result[2], 16),
                b: parseInt(result[3], 16)
            } : null;
        }

        if (hex.length == 8 || hex.length == 9) {
            result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
            return result ? {
                a: parseInt(result[1], 16),
                r: parseInt(result[2], 16),
                g: parseInt(result[3], 16),
                b: parseInt(result[4], 16)
            } : null;
        }

        return {
            a: 255,
            r: 0,
            g: 0,
            b: 0
        };
    }

    function dateToReadable(dte) {
        var monthNames = [
            "January", "February", "March",
            "April", "May", "June", "July",
            "August", "September", "October",
            "November", "December"
        ];

        var date = new Date(dte);
        var day = date.getDate();
        var monthIndex = date.getMonth();
        var year = date.getFullYear();

        return monthNames[monthIndex] + " " + day + ", " + year;
    }

    function numberWithCommas(x) {

        if(!x) {
            x = 0;
        }

        x = parseFloat(x);

        var formattedNumber = x.toFixed(2).replace(/[.,]00$/, "");

        return formattedNumber.replace(/\B(?=(\d{3})+(?!\d))/g, ",");
    }


    var gamepadStatOption = 0;

    function showColonistsMenu(section) {
        if(currentGame == null || currentGame.isMpRegionHolder) {
            return;
        }

        if(statsOpen && !section) {
            closeStatsMenu();
            return;
        }

        Scroll2d.gamepadAllStop();

        if(!section) {
            gamepadStatOption = 0;
            section = "overview";
        }

        setTimeout(checkMyContracts,2500);
        setTimeout(recieveTaxCollections,4500);

        var roc = getRegionOrCity();

        document.getElementById("statsScreen").style.display = "block"; 
        
        if(roc.offlineMode || roc.federationId == 0 || roc.governmentLevel < 7) {
            document.getElementById("statsFederation").style.display = "none";
        } else {
            document.getElementById("statsFederation").style.display = "block";
        }

        if(roc.offlineMode || !roc.isIndependent) {
            document.getElementById("statsDiplomacy").style.display = "none";
        } else {
            document.getElementById("statsDiplomacy").style.display = "block";
        }

        if(roc.offlineMode || roc.governmentLevel < 1) {
            document.getElementById("statsCommonwealth").style.display = "none";
        } else {
            document.getElementById("statsCommonwealth").style.display = "block";
        }

        if(roc.offlineMode || !webAppCore.isApeAppsLoggedIn()) {
            document.getElementById("statsFriends").style.display = "none";
        } else {
            document.getElementById("statsFriends").style.display = "block";
        }

        statsOpen = true;

        document.getElementById("statsMain").scrollTop = 0;

        var statSections = document.querySelectorAll(".statSection");

        for(var i = 0; i < statSections.length; i++) {
            if(statSections[i].dataset.statsection == section) {
                statSections[i].style.display = "block";
            } else {
                statSections[i].style.display = "none";
            }
        }

        if(section == "flag") {
            updateFlagStatSection();
        }

        if(section == "utilities") {
            updateUtilityStatDisplay();
        }

        if(section == "gamedata") {
            showGameDataSection();
        }

        if(section == "encyclopedia") {
            showEncyclopedia();
        }

        if(section == "federation") {
            loadFederationData();
        }

        if(section == "diplomacy") {
            loadDiplomaticData();
        }

        if(section == "commonwealth") {
            loadCommonwealthData();
        }

        if(section == "overview") {
            updateOverviewStatDisplay();
        }

        if(section == "government") {
            updateApprovalStatDisplay();
        }

        if(section == "resources") {
            updateResourceStatDisplay();
        }

        if(section == "population") {
            updatePopulationStatDisplay();
        }

        if(section == "economy") {
            updateEconomicStatDisplay();
        }

        if(section == "friends") {
            refreshFriendsList(updateFriendsListDisplay);
        }

        updateColonyStats();

    }

    function highlightActiveStatSection() {
        var statItems = document.getElementById("statsSidebar").querySelectorAll(".statMenuItem");

        if(gamepadStatOption < 0) {
            gamepadStatOption = statItems.length - 1;
        }

        if(gamepadStatOption >= statItems.length) {
            gamepadStatOption = 0;
        }

        for(var i = 0; i < statItems.length; i++) {
            if(i == gamepadStatOption) {
                statItems[i].className = "gabBTSidebarItem statMenuItem gamepadSelected";

                showColonistsMenu(statItems[i].dataset.statsection);
            } else {
                statItems[i].className = "gabBTSidebarItem statMenuItem";
            }
        }
    }

    function cloudSwitchPostDelete() {
        getRegionOrCity().useCloud = false;
        generalSaveGameWithDialog();
    }

    function askForIndependence() {

        var roc = getRegionOrCity();

        if(!roc) {
            return;
        }

        if(roc.isIndependent) {
            webAppCore.showAlertWithTitle(getString("independence-final"),getString("independence-general"));
        } else {
            var baseIndependenceCost = ColonyGame.meta.baseIndependenceCost;
            var relationsPenalty = baseIndependenceCost.amount - (baseIndependenceCost.amount * (roc.earthAssemblyRelations / 100));
            var totalIndependenceCost = baseIndependenceCost.amount + relationsPenalty;

            var costString = getResourceByDefName(baseIndependenceCost.resource).indicator + numberWithCommas(totalIndependenceCost);

            if(roc.earthBackTax > 0) {
                costString = costString + " " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(roc.earthBackTax);
            }

            if(totalIndependenceCost > getGameResources()[baseIndependenceCost.resource].amount || getGameResources()[ColonyGame.meta.tenderResource].amount < roc.earthBackTax) {
                webAppCore.showAlertWithTitle(getString("indepence-noafford"),getString("independence-general"));
            } else {
                var taxMessage = getString("independence-ask");
                taxMessage = replaceAll(taxMessage,"#cost",costString);

                webAppCore.showDialog({
                    "title":    getString("independence-general"),
                    "message":  taxMessage,
                    "icon": "images/" + getResourceByDefName(baseIndependenceCost.resource).icon,
                    "op1": {
                        "text":     getString("independence-declare"),
                        "func":     declareIndependence,
                        "color":    "#f44336"
                    },
                    "op2": {
                        "text":     getString("general-nevermind"),
                        "func":     placeholder
                    }
                });
            }
        }
    }
    

    function shareCharter() {
        webAppCore.nativeShare(getString("charter-share"));
    }

    function declareIndependence() {

        var roc = getRegionOrCity();
        var res = getGameResources();

        if(!roc) {
            return;
        }

        if(roc.isIndependent) {
            return;
        }

        var baseIndependenceCost = ColonyGame.meta.baseIndependenceCost;
        var relationsPenalty = baseIndependenceCost.amount - (baseIndependenceCost.amount * (roc.earthAssemblyRelations / 100));
        var totalIndependenceCost = baseIndependenceCost.amount + relationsPenalty;

        if(totalIndependenceCost > res[baseIndependenceCost.resource].amount || res[ColonyGame.meta.tenderResource].amount < roc.earthBackTax) {
            webAppCore.showAlertWithTitle(getString("indepence-noafford"),getString("independence-general"));
            return;
        }


        modifyResourceAmount(baseIndependenceCost.resource,-totalIndependenceCost,false,"Independence");

        if(roc.earthBackTax > 0) {

            modifyResourceAmount(ColonyGame.meta.tenderResource,-roc.earthBackTax,false,"Independence");
            roc.earthBackTax = 0;
        }

        roc.isIndependent = true;
        roc.tradeEmbargo = false;
        roc.immigrationEmbargo = false;

        roc.independenceDay = Date.now();
        webAppCore.showAlertWithTitle(getString("independence-final"),getString("independence-general"));

        postGlobalSocketNewsItem({
            "code": "independence",
            "platformcode": getRegionOrCity().motherland
        });

        if(!currentGame.cm) {

            if(ColonyGame.achievements.gainIndependence > 0) {
                webAppCore.reportAchievement(ColonyGame.achievements.gainIndependence);
            }
            
            checkDoKongStat("independenceCounter",1);
        }

        getColonyInfoFromServer();
    }

    var altsdown = false;
    var altudown = false;
    var cancelIsDown = false;

    function buildKeyComparer(e) {
        var negotiateKey = "";

        if(e.altKey && e.key != "Alt") {
            negotiateKey += "alt+";
        }

        if(e.ctrlKey && e.key != "Control") {
            negotiateKey += "ctrl+";
        }

        if(e.shiftKey && e.key != "Shift") {
            negotiateKey += "shift+";
        }

        if(e.metaKey && e.key != "Meta") {
            negotiateKey += "meta+";
        }

        negotiateKey += e.key;

        return negotiateKey;
    }

    function onKeydown(e) {

        var key = buildKeyComparer(e);


        if(key == webAppCore.getVar("KEY_CLEAR",KEY_DEFAULT_CLEAR)) {

            var somethingOpen = closeSomethingIfOpen();

            if(!somethingOpen) {
                webAppCore.toggleMenu();
            }

            e.preventDefault();

            return;
        }

        if(document.getElementById("allResourceSearchHolder").style.display == "block" && key == webAppCore.getVar("KEY_RES_SEARCH",KEY_DEFAULT_RES_SEARCH)) {
            document.getElementById("chatInputBoxHolder").style.display = "none";
            e.preventDefault();
            return;
        }

        if(document.getElementById("chatInputBoxHolder").style.display == "block" && key == webAppCore.getVar("KEY_CHAT_INPUT",KEY_DEFAULT_CHAT_INPUT)) {
            document.getElementById("chatInputBoxHolder").style.display = "none";
            e.preventDefault();
            return;
        }

        if(titleShowing || statsOpen || document.getElementById("customMapMetaDataEntry").style.display == "block" || document.getElementById("newGameMenu").style.display == "block" || document.getElementById("resourceContractMenu").style.display == "block" || document.activeElement == sidebarTypeFilter || document.getElementById("allResourceSearchHolder").style.display == "block" || document.getElementById("chatInputBoxHolder").style.display == "block") {
            return;
        }

        e.preventDefault();

        

        if(keyboardEditMode) {
            if(desktopMode) {
                document.getElementById("bottomHoverReadout").style.display = "inline-block";
                document.getElementById("bottomHoverReadout").innerHTML = key;
            }
            return;
        }

        if(key == webAppCore.getVar("KEY_PAN_UP",KEY_DEFAULT_PAN_UP)) {
            Scroll2d.startPan("up");
        }

        if(key == webAppCore.getVar("KEY_PAN_DOWN",KEY_DEFAULT_PAN_DOWN)) {
            Scroll2d.startPan("down");
        }

        if(key == webAppCore.getVar("KEY_PAN_LEFT",KEY_DEFAULT_PAN_LEFT)) {
            Scroll2d.startPan("left");
        }

        if(key == webAppCore.getVar("KEY_PAN_RIGHT",KEY_DEFAULT_PAN_RIGHT)) {
            Scroll2d.startPan("right");
        }

        if(key == webAppCore.getVar("KEY_ZOOM_OUT",KEY_DEFAULT_ZOOM_OUT)) {
            Scroll2d.doZoom(false);
        }

        if(key == webAppCore.getVar("KEY_ZOOM_IN",KEY_DEFAULT_ZOOM_IN)) {
            Scroll2d.doZoom(true);
        }

        

        if(key == webAppCore.getVar("KEY_IDLE",KEY_DEFAULT_IDLE)) {
            selectIdleBuilder();
        }

        if(key == webAppCore.getVar("KEY_SELL_NO_CONFIRM",KEY_DEFAULT_SELL_NO_CONFIRM)) {
            altsdown = true;
        }

        if(key == webAppCore.getVar("KEY_UPGRADE_NO_CONFIRM",KEY_DEFAULT_UPGRADE_NO_CONFIRM)) {
            altudown = true;
        }

        if(key == webAppCore.getVar("KEY_CANCEL_NO_CONFIRM",KEY_DEFAULT_CANCEL_NO_CONFIRM)) {
            cancelIsDown = true;
        }

        if(key == webAppCore.getVar("KEY_FLIP",KEY_DEFAULT_FLIP)) {
            if(queuedBuilding != null) {
                if(webAppCore.getIsPremium() && queuedBuilding.canFlip) {
                    flipChainedStructures = !flipChainedStructures;
                    return;
                }
            }
        }

        // object options 
        if(document.getElementById("objectOptions").style.display == "block") {

            if(key == webAppCore.getVar("KEY_MOVE",KEY_DEFAULT_MOVE)) {
                if(document.getElementById("objectMoveIcon").style.display == "inline-block") {
                    document.getElementById("objectMoveIcon").click();
                }
            }

            if(key == webAppCore.getVar("KEY_FLIP",KEY_DEFAULT_FLIP)) {
                if(document.getElementById("objectFlipIcon").style.display == "inline-block") {
                    document.getElementById("objectFlipIcon").click();
                }
            }

            if(key == webAppCore.getVar("KEY_PARK",KEY_DEFAULT_PARK)) {
                if(document.getElementById("objectParkIcon").style.display == "inline-block") {
                    document.getElementById("objectParkIcon").click();
                }
            }

            if(key == webAppCore.getVar("KEY_HARVEST",KEY_DEFAULT_HARVEST)) {
                if(document.getElementById("objectHarvestIcon").style.display == "inline-block") {
                    document.getElementById("objectHarvestIcon").click();
                }
            }

            if(key == webAppCore.getVar("KEY_BUILD",KEY_DEFAULT_BUILD)) {
                if(document.getElementById("objectBuildIcon").style.display == "inline-block") {
                    document.getElementById("objectBuildIcon").click();
                }
            }

            if(key == webAppCore.getVar("KEY_EXPORT",KEY_DEFAULT_EXPORT)) {
                if(document.getElementById("objectExportIcon").style.display == "inline-block") {
                    document.getElementById("objectExportIcon").click();
                }
            }

            if(key == webAppCore.getVar("KEY_IMPORT",KEY_DEFAULT_IMPORT)) {
                if(document.getElementById("objectImportIcon").style.display == "inline-block") {
                    document.getElementById("objectImportIcon").click();
                }
            }

            if(key == webAppCore.getVar("KEY_SELL",KEY_DEFAULT_SELL)) {
                if(document.getElementById("objectSelIcon").style.display == "inline-block") {
                    document.getElementById("objectSelIcon").click();
                }
            }

            if(key == webAppCore.getVar("KEY_UPGRADE",KEY_DEFAULT_UPGRADE)) {
                if(document.getElementById("objectUpgradeIcon").style.display == "inline-block") {
                    document.getElementById("objectUpgradeIcon").click();
                }
            }

            if(key == webAppCore.getVar("KEY_CANCEL",KEY_DEFAULT_CANCEL)) {
                if(document.getElementById("objectCancel").style.display == "inline-block") {
                    document.getElementById("objectCancel").click();
                }
            }
        } else {
            // these commands only work when object options is NOT open
            if(key == webAppCore.getVar("KEY_STATS_WINDOW",KEY_DEFAULT_STATS_WINDOW)) {
                showColonistsMenu();
            }

            if(key == webAppCore.getVar("KEY_TECH_WINDOW",KEY_DEFAULT_TECH_WINDOW)) {
                showTechWindow();
            }

            if(key == webAppCore.getVar("KEY_ENCY_WINDOW",KEY_DEFAULT_ENCY_WINDOW)) {
                showColonistsMenu("encyclopedia");
            }


            if(key == webAppCore.getVar("KEY_RES_WINDOW",KEY_DEFAULT_RES_WINDOW)) {
                showColonistsMenu("resources");
            }

            if(key == webAppCore.getVar("KEY_RES_SEARCH",KEY_DEFAULT_RES_SEARCH)) {
                openResourceSearchBox();
            }

            if(key == webAppCore.getVar("KEY_CHAT_INPUT",KEY_DEFAULT_CHAT_INPUT)) {
                openChatInputWindow();
            }
        }
    }

    function onKeyup(e) {

        if(titleShowing || statsOpen || document.getElementById("customMapMetaDataEntry").style.display == "block" || document.getElementById("newGameMenu").style.display == "block" || document.getElementById("resourceContractMenu").style.display == "block" || document.activeElement == sidebarTypeFilter) {
            return;
        }

        altsdown = false;
        altudown = false;
        cancelIsDown = false;

        e.preventDefault();

        var key = buildKeyComparer(e);

        if(keyboardEditMode) {

            document.getElementById("bottomHoverReadout").innerHTML = "";

            if(pendingEditKey != null) {
                webAppCore.storeVar(pendingEditKey,key);
            }

            cancelKeyboardEdit();
            showKeyboardEditor();

            return;
        }


        if(key == webAppCore.getVar("KEY_PAN_UP",KEY_DEFAULT_PAN_UP)) {
            Scroll2d.endPan("up");
        }

        if(key == webAppCore.getVar("KEY_PAN_DOWN",KEY_DEFAULT_PAN_DOWN)) {
            Scroll2d.endPan("down");
        }

        if(key == webAppCore.getVar("KEY_PAN_LEFT",KEY_DEFAULT_PAN_LEFT)) {
            Scroll2d.endPan("left");
        }

        if(key == webAppCore.getVar("KEY_PAN_RIGHT",KEY_DEFAULT_PAN_RIGHT)) {
            Scroll2d.endPan("right");
        }
    }

    function showKeyboardEditor() {

        var menuOptions = [];

        menuOptions.push({
            "title": getString("keyboard-clear-menus"),
            "title-color": null,
            "description": null,
            "status": webAppCore.getVar("KEY_CLEAR",KEY_DEFAULT_CLEAR),
            "status-color": null,
            "icon": null,
            "tag": "KEY_CLEAR"
        });

        menuOptions.push({
            "title": getString("keyboard-idle-unit"),
            "title-color": null,
            "description": null,
            "status": webAppCore.getVar("KEY_IDLE",KEY_DEFAULT_IDLE),
            "status-color": null,
            "icon": null,
            "tag": "KEY_IDLE"
        });

        menuOptions.push({
            "title": getString("keyboard-open-stats"),
            "title-color": null,
            "description": null,
            "status": webAppCore.getVar("KEY_STATS_WINDOW",KEY_DEFAULT_STATS_WINDOW),
            "status-color": null,
            "icon": null,
            "tag": "KEY_STATS_WINDOW"
        });

        menuOptions.push({
            "title": getString("keyboard-open-res"),
            "title-color": null,
            "description": null,
            "status": webAppCore.getVar("KEY_RES_WINDOW",KEY_DEFAULT_RES_WINDOW),
            "status-color": null,
            "icon": null,
            "tag": "KEY_RES_WINDOW"
        });

        menuOptions.push({
            "title": getString("keyboard-search-res"),
            "title-color": null,
            "description": null,
            "status": webAppCore.getVar("KEY_RES_SEARCH",KEY_DEFAULT_RES_SEARCH),
            "status-color": null,
            "icon": null,
            "tag": "KEY_RES_SEARCH"
        });

        menuOptions.push({
            "title": getString("keyboard-open-tech"),
            "title-color": null,
            "description": null,
            "status": webAppCore.getVar("KEY_TECH_WINDOW",KEY_DEFAULT_TECH_WINDOW),
            "status-color": null,
            "icon": null,
            "tag": "KEY_TECH_WINDOW"
        });

        menuOptions.push({
            "title": getString("keyboard-chat-input"),
            "title-color": null,
            "description": null,
            "status": webAppCore.getVar("KEY_CHAT_INPUT",KEY_DEFAULT_CHAT_INPUT),
            "status-color": null,
            "icon": null,
            "tag": "KEY_CHAT_INPUT"
        });

        menuOptions.push({
            "title": getString("keyboard-open-encyclopedia"),
            "title-color": null,
            "description": null,
            "status": webAppCore.getVar("KEY_ENCY_WINDOW",KEY_DEFAULT_ENCY_WINDOW),
            "status-color": null,
            "icon": null,
            "tag": "KEY_ENCY_WINDOW"
        });

        menuOptions.push({
            "title": getString("keyboard-open-unemployment"),
            "title-color": null,
            "description": null,
            "status": webAppCore.getVar("KEY_UNEM_WINDOW",KEY_DEFAULT_UNEM_WINDOW),
            "status-color": null,
            "icon": null,
            "tag": "KEY_UNEM_WINDOW"
        });

        menuOptions.push({
            "title": getString("keyboard-zoom-in"),
            "title-color": null,
            "description": null,
            "status": webAppCore.getVar("KEY_ZOOM_IN",KEY_DEFAULT_ZOOM_IN),
            "status-color": null,
            "icon": null,
            "tag": "KEY_ZOOM_IN"
        });

        menuOptions.push({
            "title": getString("keyboard-zoom-out"),
            "title-color": null,
            "description": null,
            "status": webAppCore.getVar("KEY_ZOOM_OUT",KEY_DEFAULT_ZOOM_OUT),
            "status-color": null,
            "icon": null,
            "tag": "KEY_ZOOM_OUT"
        });

        menuOptions.push({
            "title": getString("keyboard-sell-noconf"),
            "title-color": null,
            "description": getString("hold-and-click-tip"),
            "status": webAppCore.getVar("KEY_SELL_NO_CONFIRM",KEY_DEFAULT_SELL_NO_CONFIRM),
            "status-color": null,
            "icon": null,
            "tag": "KEY_SELL_NO_CONFIRM"
        });

        menuOptions.push({
            "title": getString("keyboard-upgrade-noconf"),
            "title-color": null,
            "description": getString("hold-and-click-tip"),
            "status": webAppCore.getVar("KEY_UPGRADE_NO_CONFIRM",KEY_DEFAULT_UPGRADE_NO_CONFIRM),
            "status-color": null,
            "icon": null,
            "tag": "KEY_UPGRADE_NO_CONFIRM"
        });

        menuOptions.push({
            "title": getString("keyboard-cancel-nocon"),
            "title-color": null,
            "description": getString("hold-and-click-tip"),
            "status": webAppCore.getVar("KEY_CANCEL_NO_CONFIRM",KEY_DEFAULT_CANCEL_NO_CONFIRM),
            "status-color": null,
            "icon": null,
            "tag": "KEY_CANCEL_NO_CONFIRM"
        });

        menuOptions.push({
            "title": getString("keyboard-move-unit"),
            "title-color": null,
            "description": getString("when-object-selected"),
            "status": webAppCore.getVar("KEY_MOVE",KEY_DEFAULT_MOVE),
            "status-color": null,
            "icon": null,
            "tag": "KEY_MOVE"
        });

        menuOptions.push({
            "title": getString("keyboard-harvest-mode"),
            "title-color": null,
            "description": getString("when-object-selected"),
            "status": webAppCore.getVar("KEY_HARVEST",KEY_DEFAULT_HARVEST),
            "status-color": null,
            "icon": null,
            "tag": "KEY_HARVEST"
        });

        menuOptions.push({
            "title": getString("keyboard-show-build"),
            "title-color": null,
            "description": getString("when-object-selected"),
            "status": webAppCore.getVar("KEY_BUILD",KEY_DEFAULT_BUILD),
            "status-color": null,
            "icon": null,
            "tag": "KEY_BUILD"
        });

        menuOptions.push({
            "title": getString("keyboard-show-export"),
            "title-color": null,
            "description": getString("when-object-selected"),
            "status": webAppCore.getVar("KEY_EXPORT",KEY_DEFAULT_EXPORT),
            "status-color": null,
            "icon": null,
            "tag": "KEY_EXPORT"
        });

        menuOptions.push({
            "title": getString("keyboard-show-import"),
            "title-color": null,
            "description": getString("when-object-selected"),
            "status": webAppCore.getVar("KEY_IMPORT",KEY_DEFAULT_IMPORT),
            "status-color": null,
            "icon": null,
            "tag": "KEY_IMPORT"
        });

        menuOptions.push({
            "title": getString("keyboard-sell"),
            "title-color": null,
            "description": getString("when-object-selected"),
            "status": webAppCore.getVar("KEY_SELL",KEY_DEFAULT_SELL),
            "status-color": null,
            "icon": null,
            "tag": "KEY_SELL"
        });

        menuOptions.push({
            "title": getString("keyboard-flip"),
            "title-color": null,
            "description": getString("when-object-selected"),
            "status": webAppCore.getVar("KEY_FLIP",KEY_DEFAULT_FLIP),
            "status-color": null,
            "icon": null,
            "tag": "KEY_FLIP"
        });

        menuOptions.push({
            "title": getString("keyboard-upgrade"),
            "title-color": null,
            "description": getString("when-object-selected"),
            "status": webAppCore.getVar("KEY_UPGRADE",KEY_DEFAULT_UPGRADE),
            "status-color": null,
            "icon": null,
            "tag": "KEY_UPGRADE"
        });

        menuOptions.push({
            "title": getString("keyboard-park"),
            "title-color": null,
            "description": getString("when-object-selected"),
            "status": webAppCore.getVar("KEY_PARK",KEY_DEFAULT_PARK),
            "status-color": null,
            "icon": null,
            "tag": "KEY_PARK"
        });

        menuOptions.push({
            "title": getString("keyboard-cancel"),
            "title-color": null,
            "description": getString("when-object-selected"),
            "status": webAppCore.getVar("KEY_CANCEL",KEY_DEFAULT_CANCEL),
            "status-color": null,
            "icon": null,
            "tag": "KEY_CANCEL"
        });

        menuOptions.push({
            "title": getString("keyboard-defaults"),
            "title-color": null,
            "description": null,
            "status": getString("keyboard-defaults-warn"),
            "status-color": "#F44336",
            "icon": null,
            "tag": "defaults"
        });

        showList(getString("engine-keyboard"),menuOptions,onKeyboardEditSelected,getString("general-dismiss"));
    }

    var keyboardEditMode = false;
    var pendingEditKey = null;

    function onKeyboardEditSelected(tag) {

        if(!tag) {
            return;
        }

        if(tag == "defaults") {

            webAppCore.storeVar("KEY_CLEAR",KEY_DEFAULT_CLEAR);
            webAppCore.storeVar("KEY_IDLE",KEY_DEFAULT_IDLE);
            webAppCore.storeVar("KEY_SELL_NO_CONFIRM",KEY_DEFAULT_SELL_NO_CONFIRM);
            webAppCore.storeVar("KEY_UPGRADE_NO_CONFIRM",KEY_DEFAULT_UPGRADE_NO_CONFIRM);
            webAppCore.storeVar("KEY_MOVE",KEY_DEFAULT_MOVE);
            webAppCore.storeVar("KEY_HARVEST",KEY_DEFAULT_HARVEST);
            webAppCore.storeVar("KEY_BUILD",KEY_DEFAULT_BUILD);
            webAppCore.storeVar("KEY_EXPORT",KEY_DEFAULT_EXPORT);
            webAppCore.storeVar("KEY_IMPORT",KEY_DEFAULT_IMPORT);
            webAppCore.storeVar("KEY_SELL",KEY_DEFAULT_SELL);
            webAppCore.storeVar("KEY_UPGRADE",KEY_DEFAULT_UPGRADE);
            webAppCore.storeVar("KEY_FLIP",KEY_DEFAULT_FLIP);

            webAppCore.storeVar("KEY_CANCEL",KEY_DEFAULT_CANCEL);
            webAppCore.storeVar("KEY_CANCEL_NO_CONFIRM",KEY_DEFAULT_CANCEL_NO_CONFIRM);

            showKeyboardEditor();

            return;
        }

        keyboardEditMode = true;
        pendingEditKey = tag;

        webAppCore.showToast({
            message: "Choose Key For " + tag,
            image:   "images/" + ColonyGame.meta.keyboardIndicator,
            action: {
                "title": getString("general-cancel"),
                "func": cancelKeyboardEdit
            }
        });
    }

    function cancelKeyboardEdit() {
        keyboardEditMode = false;
        pendingEditKey = null;
        showKeyboardEditor();
    }

    function appendShortcutTitleToButton(btn,sc,def) {
        
        if(!usingMouse || webAppCore.isTV() || gamepadInUse) {
            return;
        }



        var current = btn.title;

        var appendor = webAppCore.getVar(sc,def);

        appendor = appendor.toUpperCase();

        if(appendor == "ESCAPE") {
            appendor = "Esc";
        }

        current += (" (" + appendor + ")");

        btn.title = current;
    }

    function appendShortcutToButton(btn,sc,def) {

        if(!usingMouse || webAppCore.isTV() || gamepadInUse) {
            return;
        }



        var current = btn.innerHTML;

        var appendor = webAppCore.getVar(sc,def);

        appendor = appendor.toUpperCase();

        if(appendor == "ESCAPE") {
            appendor = "Esc";
        }

        current += (" (" + appendor + ")");

        btn.innerHTML = current;
    }

    function callNearbyBuilders(x,y,radius,forHarvest,forceHarvesters,whichBuilding) {

        var buildersCalled = 0;
        
        

        for(var i = 0; i < currentGame.vehicles.length; i++) {

            if(currentGame.vehicles[i].inBuildingMode) {
                buildersCalled++;
                continue;
            }

            if(!currentGame.vehicles[i].inBuildingMode) {
                
                if(currentGame.vehicles[i].iH && !forceHarvesters) {
                    continue;
                }

                if(whichBuilding) {
                    var vd = getVehicleDefByName(currentGame.vehicles[i].def);

                    if(!vd.produces) {
                        continue;
                    }

                    if(vd.produces.indexOf(whichBuilding.def) < 0) {
                        continue;
                    }
                }

                var isAvailable = true;

                if(radius > 0) {
                    var a = x - currentGame.vehicles[i].x;
                    var b = y - currentGame.vehicles[i].y;
                    var distance = Math.round(Math.sqrt( a*a + b*b ));

                    if(distance > radius) {
                        isAvailable = false;
                    }
                }

                if(isAvailable) {
                    if(forHarvest) {
                        //currentGame.vehicles[i].inHarvestMode = true;
                    } else {
                        currentGame.vehicles[i].inBuildingMode = true;

                        buildersCalled++;
                        
                        if(currentGame.vehicles[i].iH) {

                            currentGame.vehicles[i].iH = false;
                            currentGame.vehicles[i].harvestAfterBuilding = true;
                        }
                    }
                    
                }
            }
        }
        
        if(buildersCalled == 0 && !forceHarvesters) {
            callNearbyBuilders(x,y,radius,forHarvest,true);
        }
    }

    function changeMapEditorMapType() {
        var menuOptions = [];

        for(var i = 0; i < ColonyGame.mapTypes.length; i++) {
            
            menuOptions.push({
                "title":        ColonyGame.mapTypes[i].name,
                "description":  getString(ColonyGame.mapTypes[i].description),
                "icon":         "images/" + ColonyGame.mapTypes[i].icon,
                "status":       null,
                "overflow":     null,
                "tag":          ColonyGame.mapTypes[i].name
            });
        }

        showList("Select Map Type",menuOptions,onMapEditorTypeChange,getString("general-dismiss"));
    }

    function onMapEditorTypeChange(type) {
        if(!type || !currentGame) {
            return;
        }

        currentGame.mapType = type;

        setMapType();
        setWeather();
        createMapEditorSideber();
    }

    var tmpCustomMapLoadedCallback = null;
    var tmpCustomMapLoadTitle = null;

    function loadCustomMap(callback,title) {
        tmpCustomMapLoadedCallback = callback;
        tmpCustomMapLoadTitle = getString(title);

        webAppCore.openListing(onCustomMapListingLoaded);
    }

    function insertCustomMapTerrainIntoGame(game,mapData) {

        game.mapResources = [];

        if(!mapData.terrainData) {
            mapData.terrainData = [];
        }

        // restore terrain resource functions
        for(var i = 0; i < mapData.terrainData.length; i++) {
            
            if(mapData.terrainData[i].def.name) {
                mapData.terrainData[i].def = mapData.terrainData[i].def.name;
            }

            game.mapResources[i] = rebuildMapResourceObject(mapData.terrainData[i]);
            setUpMinidefForBuilding(game.mapResources[i],true,false);

        }

        game.mapType = mapData.mapType;
        game.height = mapData.height;
        game.width = mapData.width;

        game.mename = mapData.name;
        game.merevision = mapData.revision;
        game.meauthor = mapData.author;
        game.meurl = mapData.url;
        game.medescription = mapData.description;
        game.mestartx = mapData.startX;
        game.mestarty = mapData.startY;
    }

    var tmpSelectedCustomMapFilename = null;

    function onCustomMapListingLoaded(data) {

        if(tmpCustomMapLoadedCallback == null) {
            return;
        }

        var menuOptions = [];

        menuOptions.push({
            "title": getString("general-import-map"),
            "description": getString("general-import-map-desc"),
            "tag": "importmap"
        });
        
        for(var i = 0; i < data.length; i++) {
            if(endsWith(data[i],"." + ColonyGame.meta.customMapExtension)) {
                menuOptions.push({
                    "title": data[i],
                    "tag": data[i]
                });
            }
        }


        

        if(menuOptions.length == 0) {
            webAppCore.showToast("No installed maps!");
        } else {
            webAppCore.presentNativeList(tmpCustomMapLoadTitle,menuOptions,function(tag) {

                if(!tag) {
                    return;
                }

                if(!webAppCore.getIsPremium()) {
                    showPremiumMessage(getString("general-custom-map"));
                    return;
                }

                if(tag == "importmap") {
                    webAppCore.importFile(ColonyGame.meta.customMapExtension,onCustomMapImport);
                    return;
                }

                tmpSelectedCustomMapFilename = tag;

                webAppCore.openFile(tag,onCustomMapOpened);
            },webAppCore.getString("general-dismiss"));
        }
    }

    function onCustomMapImport(name,content) {
        if(!webAppCore.getIsPremium()) {
            showPremiumMessage(getString("general-custom-map"));
            return;
        }

        if(!name || !content) {
            return;
        }

        tmpSelectedCustomMapFilename = name;
        onCustomMapOpened(content);
    }

    function onCustomMapOpened(data) {

        webAppCore.showSplash("Decompressing Data...");
        
        var worker = new Worker("compression-worker.js");

        worker.addEventListener("message",function(e) {
            if(e.data.status == "complete") {
                
                if(tmpCustomMapLoadedCallback == null) {
                    return;
                }

                var mapJson = JSON.parse(e.data.data);


                tmpCustomMapLoadedCallback(mapJson);
            }
            
        });
        worker.addEventListener("error",function(e) {
            var scrpt = e.filename.substr(e.filename.lastIndexOf("/") + 1);
            webAppCore.logEvent("Game Compression Error",scrpt + ":" + e.lineno,e.message);
        });
        worker.postMessage({
            "method":   "decompress",
            "data":     data
        });
    }

    var selectedMapEditorTool = null;

    var mapEditorPlacingStartFlag = false;

    function createMapEditorSideber() {
        document.getElementById("sidebarBuildListing").innerHTML = "";

        var buildItem,label,img;

        // map type option 
        buildItem = document.createElement("div");
        buildItem.className = "buildItem";
        buildItem.buildType = "terrain";

        buildItem.style.backgroundImage = "url('images/" + workingMapType.icon + "')";

        buildItem.onclick = function() {
            changeMapEditorMapType();
            mapEditorPlacingStartFlag = false;
        };

        label = document.createElement("p");
        label.innerHTML = appreviateTitle(workingMapType.name);
        label.className = "sidebarBuildLabel";
        buildItem.appendChild(label);

        document.getElementById("sidebarBuildListing").appendChild(buildItem);

        // start location flag
        buildItem = document.createElement("div");
        buildItem.className = "buildItem";
        buildItem.buildType = "terrain";

        var ig = getImageAsset(ColonyGame.meta.mapEditorStartFlagAsset, false, 0, null);

        if (ig) {
            img = ig.src;
        }


        buildItem.style.backgroundImage = "url('" + img + "')";

        buildItem.onclick = function() {
            mapEditorPlacingStartFlag = true;
        };

        label = document.createElement("p");
        label.innerHTML = "Start Location";
        label.className = "sidebarBuildLabel";
        buildItem.appendChild(label);

        document.getElementById("sidebarBuildListing").appendChild(buildItem);

        for(var i = 0; i < ColonyGame.terrains.length; i++) {
            buildItem = document.createElement("div");
            buildItem.className = "buildItem";
            buildItem.buildType = "terrain";

            var td = getImageAsset(ColonyGame.terrains[i].tile[0], false, 0, null);

            if (td) {
                img = td.src;
            } 


            buildItem.style.backgroundImage = "url('" + img + "')";
            buildItem.ref = ColonyGame.terrains[i];

            buildItem.onclick = onBuildItemClick;

            label = document.createElement("p");
            label.innerHTML = appreviateTitle(ColonyGame.terrains[i].name);
            label.className = "sidebarBuildLabel";
            buildItem.appendChild(label);

            document.getElementById("sidebarBuildListing").appendChild(buildItem);
        }
    }

    function onBuildItemClick() {
        mapEditorPlacingStartFlag = false;
        selectedMapEditorTool = this.ref;
        bulldozerMode = false;
    }

    function createSidebar() {

        if(!currentGame) {
            return;
        }

        if(currentGame.mem) {
            createMapEditorSideber();
            return;
        }

        var i,buildItem,label,countind;

        document.getElementById("sidebarBuildListing").innerHTML = "";

        if(currentGame.isRegion) {
            buildItem = document.createElement("div");
            buildItem.className = "buildItem";
            buildItem.buildType = "city";

            // come up with an image file at some point
            buildItem.imageLoaded = false;
            buildItem.imageToUse = ColonyGame.meta.smallCityAsset;

            buildItem.onclick = function() {
                pendingSubcitySize = 1;
                hideSidebarIfSmall();
                webAppCore.showToast(getString("new-city-dest"));
            };

            label = document.createElement("p");
            label.innerHTML = getString("gen-small-city");
            label.className = "sidebarBuildLabel";
            buildItem.appendChild(label);

            buildItem.style.display = "inline-block";
            buildItem.baseClassSave = buildItem.className;

            buildItem.onmouseover = function(e) {
                showCustomSidebarInfobox(getString("gen-small-city"),getString("small-city-desc"),e.y);
            };

            buildItem.onmouseout = function() {
                hideInfobox();
            };

            document.getElementById("sidebarBuildListing").appendChild(buildItem);



            buildItem = document.createElement("div");
            buildItem.className = "buildItem";
            buildItem.buildType = "city";

            // come up with an image file at some point
            buildItem.imageLoaded = false;
            buildItem.imageToUse = ColonyGame.meta.mediumCityAsset;

            buildItem.onclick = function() {
                pendingSubcitySize = 2;
                hideSidebarIfSmall();
                webAppCore.showToast(getString("new-city-dest"));
            };

            label = document.createElement("p");
            label.innerHTML = getString("gen-medium-city");
            label.className = "sidebarBuildLabel";
            buildItem.appendChild(label);

            buildItem.style.display = "inline-block";
            buildItem.baseClassSave = buildItem.className;

            buildItem.onmouseover = function(e) {
                showCustomSidebarInfobox(getString("gen-medium-city"),getString("medium-city-desc"),e.y);
            };

            buildItem.onmouseout = function() {
                hideInfobox();
            };

            document.getElementById("sidebarBuildListing").appendChild(buildItem);

            return;
        }

        // buildings
        for(i = 0; i < ColonyGame.buildings.length; i++) {

            if(ColonyGame.buildings[i].cost == null) {
                continue;
            }

            if(ColonyGame.buildings[i].isEmbassy) {
                continue;
            }

            buildItem = document.createElement("div");
            buildItem.className = "buildItem";
            buildItem.buildType = "building";

            buildItem.imageLoaded = false;
            buildItem.imageToUse = ColonyGame.buildings[i].tile[0];

            buildItem.ref = ColonyGame.buildings[i];


            buildItem.oncontextmenu = onBuildingBuildItemContext;

            buildItem.onclick = onBuildingBuildItemClick;

            label = document.createElement("p");
            label.innerHTML = appreviateTitle(ColonyGame.buildings[i].name);
            label.className = "sidebarBuildLabel";
            buildItem.appendChild(label);

            countind = document.createElement("p");
            countind.innerHTML = "";
            countind.className = "sidebarCountIndicator";
            buildItem.appendChild(countind);

            buildItem.baseClassSave = buildItem.className;

            buildItem.onmouseover = function(e) {
                showInfoboxForSidebarItem(this.ref,e.y,this);
            };

            buildItem.onmouseout = function() {
                hideInfobox();
            };

            document.getElementById("sidebarBuildListing").appendChild(buildItem);
        }

        // vehicles
        for(i = 0; i < ColonyGame.vehicles.length; i++) {

            if(ColonyGame.vehicles[i].cost == null) {
                continue;
            }

            buildItem = document.createElement("div");
            buildItem.className = "buildItem";
            buildItem.buildType = "vehicle";

            buildItem.imageLoaded = false;
            buildItem.imageToUse = ColonyGame.vehicles[i].tile;

            buildItem.ref = ColonyGame.vehicles[i];


            buildItem.onclick = onVehicleBuildItemClick;
            buildItem.oncontextmenu = onVehicleBuildItemContext;

            label = document.createElement("p");
            label.innerHTML = appreviateTitle(ColonyGame.vehicles[i].name);
            label.className = "sidebarBuildLabel";
            buildItem.appendChild(label);

            countind = document.createElement("p");
            countind.innerHTML = "";
            countind.className = "sidebarCountIndicatorVeh";
            buildItem.appendChild(countind);

            buildItem.onmouseover = function(e) {
                showInfoboxForSidebarItem(this.ref,e.y,this);
            };

            buildItem.onmouseout = function() {
                hideInfobox();
            };

            buildItem.baseClassSave = buildItem.className;
            

            document.getElementById("sidebarBuildListing").appendChild(buildItem);
        }

    }

    var currentSidebarListType = null;
    var currentSidebarListingStuff = [];

    function drawSidebar() {

        if(currentGame == null) {
            return;
        }

        if(currentGame.mem) {
            return;
        }

        var filterText = null;

        if(desktopMode) {
            filterText = sidebarTypeFilter.value.trim();

            if(filterText.length == 0) {
                filterText = null;
            } else {
                filterText = filterText.toLowerCase();
            }
        }

        currentSidebarListType = null;
        currentSidebarListingStuff = [];

        if(selectedBuildCategory == null) {
            selectedBuildCategory = "All Buildings";
        }

        var hasOption,j,i,oi;
        var currentAvailableVehicles = 0;

        var addedItems = 0;

        var selBulRef = null;
        var selVehRef = null;

        if(selectedBuilding != null) {
            selBulRef = getBuildingDefByName(selectedBuilding.def);
        }

        if(selBulRef != null) {
            if(selBulRef.produces == null || selBulRef.produces.length == 0) {
                selBulRef = null;
            }
        }

        if(selBulRef == null) {
            if(selectedVehicle.length > 0) {
                selVehRef = getVehicleDefByName(selectedVehicle[0].def);
            }
        }

        if(selVehRef != null) {
            if(selVehRef.produces == null || selVehRef.produces.length == 0) {
                selVehRef = null;
            }
        }

        var sbl = document.getElementById("sidebarBuildListing");

        var visibleElements = 0;

        var buildOptions = sbl.querySelectorAll(".buildItem");

        for(i = 0; i < buildOptions.length; i++) {

            var opt = buildOptions[i];


            if(currentGame.isRegion) {
                opt.style.display = "inline-block";

                if(!opt.imageLoaded) {
                    oi = getImageAsset(opt.imageToUse,false,0,null);
    
                    if(oi) {
                        opt.imageLoaded = true;
                        opt.style.backgroundImage = "url('" + oi.src + "')";
                    }
                }

                continue;
            }

            

            if(filterText != null) {
                if(opt.ref.name.toLowerCase().indexOf(filterText) == -1) {
                    if(opt.style.display != "none") {
                        opt.style.display = "none";
                    }

                    continue;
                }
            }

            if(!canIBuildThis(opt.ref,opt.buildType)) {
                if(opt.style.display != "none") {
                    opt.style.display = "none";
                }

                continue;
            }

            hasOption = false;

            if(selectedBuilding != null && selBulRef != null) {
                for(j = 0; j < selBulRef.produces.length; j++) {
                    if(selBulRef.produces[j] == opt.ref.name) {
                        hasOption = true;
                        break;
                    }
                }
            } else {
                if(selectedVehicle.length > 0 != null && selVehRef != null) {
                    for(j = 0; j < selVehRef.produces.length; j++) {
                        if(selVehRef.produces[j] == opt.ref.name) {
                            hasOption = true;
                            break;
                        }
                    }
                } else {
                    if(opt.ref.buildCategories) {
                        for(j = 0; j < opt.ref.buildCategories.length; j++) {
                            if(opt.ref.buildCategories[j] == selectedBuildCategory) {
                                hasOption = true;
                                break;
                            }
                        }
                    }
                    
                }
            }

            // Automatic build categories for specific types 
            if(selectedBuildCategory == "Entertainment") {
                if(opt.ref.entertains && opt.ref.entertains > 0) {
                    hasOption = true;
                }
            }

            if(selectedBuildCategory == "Education") {
                if(opt.ref.educates && opt.ref.educates > 0) {
                    hasOption = true;
                }
            }

            if(selectedBuildCategory == "Medical") {
                if(opt.ref.heals && opt.ref.heals > 0) {
                    hasOption = true;
                }
            }

            if(selectedBuildCategory == "Housing") {
                if(opt.ref.heals && opt.ref.providesShelter > 0) {
                    hasOption = true;
                }
            }

            if(!hasOption) {

                if(opt.style.display != "none") {
                    opt.style.display = "none";
                }

                continue;
            }

            // building counts 
            var countDef = opt.querySelector(".sidebarCountIndicator");
            var useCountDisplay = "none";
            var useCountInnerhtml = "";

            if(countDef != null) {
                if(runningBuildingCounts[opt.ref.name] && runningBuildingCounts[opt.ref.name] > 0) {
                    useCountInnerhtml = runningBuildingCounts[opt.ref.name].toString();

                    if(runningBuildingCounts[opt.ref.name] > 999) {
                        useCountInnerhtml = "999+";
                    }

                    useCountDisplay = "block";
                }

                if(countDef.style.display != useCountDisplay) {
                    countDef.style.display = useCountDisplay;
                }

                if(countDef.innerHTML != useCountInnerhtml) {
                    countDef.innerHTML = useCountInnerhtml;
                }
            }

            // vehicle counts
            countDef = opt.querySelector(".sidebarCountIndicatorVeh");
            useCountDisplay = "none";
            useCountInnerhtml = "";

            if(countDef != null) {
                if(runningVehicleCounts[opt.ref.name] && runningVehicleCounts[opt.ref.name] > 0) {
                    useCountInnerhtml = runningVehicleCounts[opt.ref.name].toString();

                    if(runningVehicleCounts[opt.ref.name] > 999) {
                        useCountInnerhtml = "999+";
                    }

                    useCountDisplay = "block";
                }

                if(countDef.style.display != useCountDisplay) {
                    countDef.style.display = useCountDisplay;
                }

                if(countDef.innerHTML != useCountInnerhtml) {
                    countDef.innerHTML = useCountInnerhtml;
                }
            }

            currentSidebarListingStuff.push(opt.ref);

            if(addedItems == 0) {
                currentSidebarListType = buildOptions[i].buildType;
            }

            addedItems++;

            if(opt.style.display != "inline-block") {
                opt.style.display = "inline-block";
            }

            visibleElements++;

            if(!opt.imageLoaded) {
                oi = getImageAsset(opt.imageToUse,false,0,null);

                if(oi) {
                    opt.imageLoaded = true;
                    opt.style.backgroundImage = "url('" + oi.src + "')";
                }
            }

            if(!canIAffordThis(opt.ref.cost)) {
                opt.cantAffortThis = true;
                opt.style.backgroundColor = "rgba(255, 0, 0, 0.3)";
            } else {
                opt.style.backgroundColor = null;
            }

            if(opt.ref.requiPremium && !webAppCore.getIsPremium()) {
                opt.className = "buildItem premiumLocked";
            } else {
                opt.className = "buildItem";
            }

            if(opt.buildType == "vehicle") {
                currentAvailableVehicles++;
            }

            
            
        }

        if(totalAvailableVehicles > 0 && currentAvailableVehicles > totalAvailableVehicles) {
            webAppCore.showToast("New Units Available!");
        }

        totalAvailableVehicles = currentAvailableVehicles;

        var useHeight = "calc(100% - 112px)";
        var useBottom = "0px";
        var typeFilterDisplay = "none";
        var useBorderBottom = "none";

        if(desktopMode) {
            if(visibleElements > 18 || filterText != null) {
                useHeight = "calc(100% - 148px)";
                typeFilterDisplay = "block";
                useBottom = "36px";
                useBorderBottom = "1px solid rgba(255,255,255,0.2)";
            }
        }

        if(sbl.style.height != useHeight) {
            sbl.style.height = useHeight;
        }

        if(sbl.style.bottom != useBottom) {
            sbl.style.bottom = useBottom;
        }

        if(sbl.style.borderBottom != useBorderBottom) {
            sbl.style.borderBottom = useBorderBottom;
        }
   
        if(sidebarTypeFilter.style.display != typeFilterDisplay) {
            sidebarTypeFilter.style.display = typeFilterDisplay;
        }
    }

    function showCustomSidebarInfobox(title,text,y) {
        if(document.getElementById("sidebarCostInfoBox").style.display == "none") {
            document.getElementById("sidebarCostInfoBox").style.display = "block";
            document.getElementById("sidebarObjectName").innerHTML = title;
            document.getElementById("sidebarObjectDescribtion").innerHTML = text;
            document.getElementById("infoBoxCostArea").innerHTML = "";
        }

        positionInfobox(y);
    }

    function showInfoboxForSidebarItem(buildOption,y,sender) {

        var rOrC = getRegionOrCity();

        if(!rOrC) {
            return;
        }

        if(!buildOption || !sender) {
            document.getElementById("sidebarCostInfoBox").style.display = "none";
            return;
        }

        if(canIAffordThis(buildOption.cost)) {
            sender.cantAffortThis = false;
            sender.style.backgroundColor = null;
        }

        if(document.getElementById("sidebarCostInfoBox").style.display == "none") {
            
            document.getElementById("sidebarCostInfoBox").style.display = "block";
            document.getElementById("sidebarObjectName").innerHTML = buildOption.name;
            document.getElementById("sidebarObjectDescribtion").innerHTML = getString(buildOption.description);

            document.getElementById("infoBoxCostArea").innerHTML = "";

            var cost = [];
            var costColor,j,def;

            if(buildOption.tileWidth != null && buildOption.tileHeight != null) {
                cost.push({
                    pre:    "Size:",
                    post:   buildOption.tileWidth + "x" + buildOption.tileHeight,
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.dimensionIndicator
                });
            }

            if(buildOption.requiresUtility != null) {
                for(j = 0; j < buildOption.requiresUtility.length; j++) {
                    
                    def = getUtilityByDefName(buildOption.requiresUtility[j].utility);

                    costColor = null;

                    if(buildOption.requiresUtility[j].amount + getGameUtilities()[buildOption.requiresUtility[j].utility].usage > getGameUtilities()[buildOption.requiresUtility[j].utility].capacity) {
                        costColor = "#F44336";
                    }

                    cost.push({
                        pre:    "Requires:",
                        post:   numberWithCommas(buildOption.requiresUtility[j].amount),
                        color:  costColor,
                        icon:   "images/" + def.icon
                    });
                }
            }

            var defaultCiviliznIcon = "images/" + ColonyGame.meta.colonistIcon;
            var civ = getRaceByName(rOrC.defaultRace);

            if(civ) {
                var spriteImage = civ.defaultSprites[rOrC.stage];
                var spriteItem = getImageAsset(spriteImage,false,0);

                if(spriteItem) {
                    defaultCiviliznIcon = spriteItem.src;
                }
            }

            if(buildOption.acceptsWorkers > 0) {
                costColor = null;

                var occImage = defaultCiviliznIcon;

                var occupationDef = getOccupationDefByName(buildOption.occupation);
                

                

                if(occupationDef != null) {
                    if(occupationDef.indicator != null) {
                        occImage = "images/" + occupationDef.indicator;
                    }
                }

                cost.push({
                    pre:    "Workers:",
                    post:   numberWithCommas(buildOption.acceptsWorkers),
                    color:  costColor,
                    icon:   occImage
                });
            }

            if(buildOption.providesShelter > 0) {


                cost.push({
                    pre:    "Housing:",
                    post:   numberWithCommas(buildOption.providesShelter),
                    color:  null,
                    icon:   defaultCiviliznIcon
                });
            }

            if(buildOption.entertains != null && buildOption.entertains > 0) {
                cost.push({
                    pre:    "Entertains:",
                    post:   buildOption.entertains,
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.indRetired
                });
            }

            if(buildOption.educates != null && buildOption.educates > 0) {
                cost.push({
                    pre:    "Educates:",
                    post:   buildOption.educates,
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.indEducation
                });
            }

            if(buildOption.heals != null && buildOption.heals > 0) {
                cost.push({
                    pre:    "Heals:",
                    post:   buildOption.heals,
                    color:  null,
                    icon:   "images/" + ColonyGame.meta.medicalIcon
                });
            }

            for(j = 0; j < buildOption.cost.length; j++) {
                
                def = getResourceByDefName(buildOption.cost[j].resource);

                costColor = null;

                var costString = def.indicator + numberWithCommas(buildOption.cost[j].amount);

                if(buildOption.cost[j].amount > getGameResources()[buildOption.cost[j].resource].amount) {
                    costColor = "#F44336";

                    var cDiff = buildOption.cost[j].amount - getGameResources()[buildOption.cost[j].resource].amount;

                    costString += (" (-" + numberWithCommas(cDiff) + ")" );
                }

                cost.push({
                    pre:    "Cost:",
                    post:   costString,
                    color:  costColor,
                    icon:   "images/" + def.icon
                });
            }

            if(buildOption.providesUtility != null) {
                for(j = 0; j < buildOption.providesUtility.length; j++) {
                    
                    def = getUtilityByDefName(buildOption.providesUtility[j].utility);

                    costColor = null;

                    cost.push({
                        pre:    "Generates:",
                        post:   numberWithCommas(buildOption.providesUtility[j].amount),
                        color:  costColor,
                        icon:   "images/" + def.icon
                    });
                }
            }

            for(j = 0; j < cost.length; j++) {
                    
                var overflowItem = cost[j];
                
                var optionCostSpan = document.createElement("span");
                optionCostSpan.innerHTML = overflowItem.pre + " <div class=\"sbIndOptIcn\" style=\"background-image: url('" + overflowItem.icon + "');\"></div> " + overflowItem.post;
                optionCostSpan.className = "infoboxOptionCost";
                if(overflowItem.color != null) {
                    optionCostSpan.style.color = overflowItem.color;
                }
                document.getElementById("infoBoxCostArea").appendChild(optionCostSpan);
            }
        }

        positionInfobox(y);
    }

    function positionInfobox(y) {
        if(y > window.innerHeight / 2) {
            document.getElementById("sidebarCostInfoBox").style.top = "initial";
            document.getElementById("sidebarCostInfoBox").style.bottom = (window.innerHeight - y) + "px";
        } else {
            document.getElementById("sidebarCostInfoBox").style.top = y + "px";
            document.getElementById("sidebarCostInfoBox").style.bottom = "initial";
        }
    }

    function hideInfobox() {
        document.getElementById("sidebarCostInfoBox").style.display = "none";
    }

    function canIAffordThis(cost) {

        if(!currentGame) {
            return false;
        }

        if(currentGame.cm) {
            return true;
        }

        if(!cost) {
            return false;
        }

        for(var j = 0; j < cost.length; j++) {

            if(cost[j].amount > getGameResources()[cost[j].resource].amount) {
                return false;
            }
        }

        return true;
    }

    function getAvailableBuildingsForVehicleConstruction(vehicle) {

        var avail = [];

        if(!currentGame) {
            return avail;
        }

        for(var i = 0; i < currentGame.buildings.length; i++) {

            if(!currentGame.buildings[i]) {
                continue;
            }

            var def = getBuildingDefByName(currentGame.buildings[i].def);

            if(!def) {
                continue;
            }

            if(def.produces == null) {
                continue;
            }

            for(var j = 0; j < def.produces.length; j++) {
                if(def.produces[j] == vehicle.name) {
                    avail.push(currentGame.buildings[i]);
                }
            }
        }

        return avail;
    }

    function canIBuildThis(object,type,forUpgrade) {

        if(!currentGame || !object) {
            return false;
        }

        if(currentGame.cm) {
            return true;
        }

        if(object.requiresStage > getRegionOrCity().stage) {
            return false;
        }

        if(object.reqIndependence && !getRegionOrCity().isIndependent) {
            return false;
        }

        if(!forUpgrade) {
            forUpgrade = false;
        }

        if(object.isConsulate) {

            if(getRegionOrCity().isIndependent) {
                return false;
            }

        }

        var i,j,def;

        if(!getGameTechs()) {
            getRegionOrCity().unlockedTechs = {};
        }

        if(object.requiresTech != null) {


            for(j = 0; j < object.requiresTech.length; j++) {

                var techParts = object.requiresTech[j].split("|");

                var hasThisOne = false;

                for(var k = 0; k < techParts.length; k++) {
                    if(getGameTechs()[techParts[k]]) {
                        hasThisOne = true;
                    }
                }

                if(!hasThisOne) {
                    return false;
                }

            }
        }

        if(object.cost != null) {
            for(j = 0; j < object.cost.length; j++) {
                if(!getGameResources()[object.cost[j].resource].unlocked) {
                    return false;
                }
            }
        }



        // see if we have a vehicle available
        if(type == "building") {

            if(object.isEmbassy) {
                return true;
            }

            if(object.buildLimit > 0) {
                var existingStructures = 0;
    
                for(i = 0; i < currentGame.buildings.length; i++) {

                    if(!currentGame.buildings[i]) {
                        continue;
                    }

                    if(currentGame.buildings[i].def && currentGame.buildings[i].def == object.name) {
                        existingStructures++;

                        if(existingStructures >= object.buildLimit && !forUpgrade) {
                            break;
                        }
                    }
                }

                if(existingStructures >= object.buildLimit && !forUpgrade) {
                    return false;
                }
            }

            // if this can only be built on a certain terrain, see if map has the terrain
            if(object.canBuildOver && object.canBuildOver.length > 0) {
                var hasterrain = false;

                for(i = 0; i < currentGame.mapResources.length; i++) {
                    if(object.canBuildOver.indexOf(currentGame.mapResources[i].def) > -1) {
                        hasterrain = true;
                        break;
                    }
                }

                if(!hasterrain) {
                    return false;
                }
            }

            for(i = 0; i < currentGame.vehicles.length; i++) {

                def = getVehicleDefByName(currentGame.vehicles[i].def);

                if(def == null) {
                    continue;
                }

                if(def.produces == null) {
                    continue;
                }

                

                for(j = 0; j < def.produces.length; j++) {
                    if(def.produces[j] == object.name) {
                        
                        return true;
                    }
                }
            }

            
        }

        // see if a building is available 
        if(type == "vehicle") {
            for(i = 0; i < currentGame.buildings.length; i++) {

                if(currentGame.buildings[i] == null) {
                    continue;
                }

                def = getBuildingDefByName(currentGame.buildings[i].def);

                if(!def || def.produces == null) {
                    continue;
                }

                

                for(j = 0; j < def.produces.length; j++) {
                    if(def.produces[j] == object.name) {
                        return true;
                    }
                }
            }
        }

        return false;
    }

    function appreviateTitle(title) {

        title = title.replace("Advanced","Adv.");
        title = title.replace("Small","Sm.");
        title = title.replace("Generator","Gen.");
        title = title.replace("Independence","Ind.");
        title = title.replace("Colonial","Col.");
        title = title.replace("Medium","Med.");

        return title;
    }

    var allBuildCategories = [];
    var gamepadSelectedBuildCategory = 0;

    function initBuildCategories() {
        document.getElementById("filterArea").innerHTML = "";

        var categories = [];
        var i,j,cat;

        var allItems = [];

        for(i = 0; i < ColonyGame.buildings.length; i++) {
            for(j = 0; j < ColonyGame.buildings[i].buildCategories.length; j++) {

                cat = ColonyGame.buildings[i].buildCategories[j];

                if(cat.indexOf("All ") == 0) {
                    allItems.push(cat);
                } else {
                    categories.push(cat);
                }

                
            }
        }

        for(i = 0; i < ColonyGame.vehicles.length; i++) {
            for(j = 0; j < ColonyGame.vehicles[i].buildCategories.length; j++) {

                cat = ColonyGame.vehicles[i].buildCategories[j];

                if(cat.indexOf("All ") == 0) {
                    allItems.push(cat);
                } else {
                    categories.push(cat);
                }

            }
        }

        // Default categories that should be there no matter what
        if(categories.indexOf("Entertainment") == -1) {
            categories.push("Entertainment");
        }

        if(categories.indexOf("Education") == -1) {
            categories.push("Education");
        }

        if(categories.indexOf("Medical") == -1) {
            categories.push("Medical");
        }

        if(categories.indexOf("Housing") == -1) {
            categories.push("Housing");
        }


        allItems = allItems.reduce(function(a,b){
            if (a.indexOf(b) < 0 ) a.push(b);
            return a;
        },[]);

        allItems.sort();

        categories = categories.reduce(function(a,b){
            if (a.indexOf(b) < 0 ) a.push(b);
            return a;
        },[]);

        categories.sort();

        for(i = 0; i < allItems.length; i++) {
            allBuildCategories.push(allItems[i]);
        }

        for(i = 0; i < categories.length; i++) {
            allBuildCategories.push(categories[i]);
        }

        

        for(i = 0; i < allBuildCategories.length; i++) {
            cat = document.createElement("option");
            cat.value = allBuildCategories[i];
            cat.innerHTML = allBuildCategories[i];
            document.getElementById("filterArea").appendChild(cat);
        }

        selectedBuildCategory = allBuildCategories[0];

        document.getElementById("gamepadFilterText").innerHTML = allBuildCategories[0];
        gamepadSelectedBuildCategory = 0;
    }

    function showGifts() {
        var rOrC = getRegionOrCity();

        if(!rOrC) {
            return;
        }

        if(rOrC.gifts == null || rOrC.gifts.length == 0) {
            webAppCore.showToast("No gifts available!");
            return;
        }

        var menuOptions = [];

        if(rOrC.gifts.length > 1) {
            menuOptions.push({
                "title": getString("general-collect-all"),
                "title-color": null,
                "description": getString("general-collect-all-desc"),
                "status": null,
                "status-color": null,
                "icon": "images/" + ColonyGame.meta.giftIndicator,
                "tag": "collectall"
            });
        }

        var kg = [];

        for(var i = 0; i < rOrC.gifts.length; i++) {

            if(!rOrC.gifts[i]) {
                kg.push(rOrC.gifts[i]);
                continue;
            }

            if(rOrC.gifts[i].resource == null) {
                rOrC.gifts[i].resource = ColonyGame.meta.tenderResource;
            }

            var giftDesc = null;

            if(rOrC.gifts[i].message != null) {
                giftDesc = rOrC.gifts[i].message;
            }

            var giftStatus = numberWithCommas(rOrC.gifts[i].amount) + " " + rOrC.gifts[i].resource;

            menuOptions.push({
                "title": rOrC.gifts[i].name,
                "title-color": null,
                "description": giftDesc,
                "status": giftStatus,
                "status-color": null,
                "icon": "images/" + getResourceByDefName(rOrC.gifts[i].resource).icon,
                "tag": rOrC.gifts[i]
            });
        }

        var max = 0;

        while(kg.length > 0) {
            max++;

            if(max >= 1000) {
                break;
            }

            var kill = kg.pop();
            removeFromArray(rOrC.gifts,kill);
        }

        if(menuOptions.length == 0) {
            return;
        }

        showList("Gifts",menuOptions,onGiftSelected,"Nevermind");
    }

    function onGiftSelected(gift) {

        if(!currentGame) {
            return;
        }

        var rOrC = getRegionOrCity();

        if(!rOrC) {
            return;
        }

        if(!gift) {
            if(rOrC.gifts.length > 0) {
                document.getElementById("imGift").style.display = "inline-block";
            }

            return;
        }

        var resourceType = "Gift";

        if(gift == "collectall") {

            var maxLoop = 0;

            while(rOrC.gifts.length > 0) {
                maxLoop++;

                if(maxLoop >= 1000) {
                    break;
                }

                var mygift = rOrC.gifts.pop();

                resourceType = "Gift";

                if(mygift) {
                    if(mygift.isTrade) {
                        resourceType = "Trade";
                    }

                    modifyResourceAmount(mygift.resource,parseInt(mygift.amount),false,resourceType);
                }
                
            }

            webAppCore.showToast("Gifts Redeemed");
        } else {

            if(rOrC.gifts.indexOf(gift) == -1) {
                return;
            }

            if(gift.isTrade) {
                resourceType = "Trade";
            }
            
            removeFromArray(rOrC.gifts,gift);
            modifyResourceAmount(gift.resource,parseInt(gift.amount),false,resourceType);
            webAppCore.showToast("Gift Redeemed");
        }

        if(ColonyGame.sounds.contractBuy) {
            playInterfaceSoundEffect(ColonyGame.sounds.contractBuy);
        }
        

        setTimeout(showGiftIfNeeded,200);

    }

    function showGiftIfNeeded() {
        if(!currentGame) {
            return;
        }

        if(getRegionOrCity().gifts.length == 0) {
            document.getElementById("imGift").style.display = "none";
        } else {
            showGifts();
        }
    }

    function Gift(name,message,resource,amount,isTrade) {
        this.name = name;
        this.message = message;
        this.resource = resource;
        this.amount = amount;

        if(isTrade) {
            this.isTrade = true;
        } else {
            this.isTrade = false;
        }
    }

    function getString(string) {

        var baseString = webAppCore.getString(string);

        if(!baseString || baseString.trim().length == 0) {
            console.log("Missing String: " + string);
            webAppCore.logEvent("Game Error","Missing String",string);
            return string;
        }

        var roc = getRegionOrCity();

        baseString = replaceAll(baseString,"#governorname",currentGovernorName);

        baseString = replaceAll(baseString,"#gamebuildingcount",ColonyGame.buildings.length);

        if(!roc) {
            return baseString;
        }

        

        baseString = replaceAll(baseString,"#motherland",roc.motherland);

        if(roc.independenceDay == null) {
            baseString = replaceAll(baseString,"#independenceday","(n/a)");
        } else {
            baseString = replaceAll(baseString,"#independenceday",dateToReadable(roc.independenceDay));
        }

        if(roc.charter && roc.charter != 0) {
            baseString = replaceAll(baseString,"#charterid",roc.charter);
        }

        if(currentGame.name && currentGame.name != 0) {
            baseString = replaceAll(baseString,"#cityname",currentGame.name);
        }

        

        return baseString;
    }

    var currentGovernorName = null;

    function setGovernorName() {
        currentGovernorName = webAppCore.getString("gen-city-leader-name");

        if(webAppCore.isApeAppsLoggedIn()) {
            currentGovernorName = webAppCore.getApeAppsProfile().un;
        }
    }

    function recieveTaxCollections() {
        if(!currentGame || currentGame == null) {
            return;
        }

        if(!getRegionOrCity().colonyId || getRegionOrCity().colonyId == 0) {
            return;
        }

        var data = [];

        postSecuredCallToApi(data,6,onTaxesCollected);
    }

    function onTaxesCollected(result) {

        if(result != null && result.trim().length > 0) {
            try {
                var taxCollections = JSON.parse(result);
                var totalTaxes = parseInt(taxCollections.taxes);

                if(!isNaN(totalTaxes) && totalTaxes > 0) {
                    if(!getRegionOrCity().gifts) {
                        getRegionOrCity().gifts = [];
                    }

                    if(isNaN(getRegionOrCity().colonialTaxCollected)) {
                        getRegionOrCity().colonialTaxCollected = 0;
                    }

                    getRegionOrCity().colonialTaxCollected += totalTaxes;

                    if(getRegionOrCity().autoBudget) {
                        modifyResourceAmount(ColonyGame.meta.tenderResource,totalTaxes,false,"Commonwealth");

                        webAppCore.showToast({
                            "message":      getString("empire-general") + " Tax Collection: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(totalTaxes),
                            "image":        "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                        });

                        if(ColonyGame.sounds.contractBuy) {
                            playInterfaceSoundEffect(ColonyGame.sounds.contractBuy);
                        }

                    } else {
                        getRegionOrCity().gifts.push(new Gift(getString("tax-collection-header"),getString("tax-collection-message"),ColonyGame.meta.tenderResource,totalTaxes));
                        webAppCore.showToast("New gifts available!");
                        document.getElementById("imGift").style.display = "inline-block";
                    }

                    
                }
            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onTaxesCollected",ex.message);
            }
        }
    }

    function registerColonyId() {

        if(!currentGame || getRegionOrCity() == null || currentGame.isSubregion) {
            return;
        }

        var data = [];

        data.push({
            "key":      "f",
            "value":    32
        });

        data.push({
            "key":      "g",
            "value":    ColonyGame.meta.colonyServerGameId
        });

        data.push({
            "key":      "n",
            "value":    getRegionOrCity().name
        });

        var useMotherland = getRegionOrCity().motherlandid;

        if(!useMotherland || useMotherland == 0 || useMotherland == "0") {
            var civDef = getCivilizationByName(currentGame.civilization);
            useMotherland = civDef.serverHomeworld;
        }

        data.push({
            "key":      "p",
            "value":    useMotherland
        });

        data.push({
            "key":      "relcd",
            "value":    ColonyGame.meta.releaseCode
        });

        webAppCore.postForResult(ColonyGame.meta.colonyServerApi, data, onColonyRegistered);
    }

    function onColonyRegistered(result) {

        if(result == null || result.trim().length == 0) {
            return;
        }

        if(!currentGame || currentGame == null) {
            return;
        }

        try {
            var regInfo = JSON.parse(result);

            getRegionOrCity().colonyId = regInfo.id;
            getRegionOrCity().apiKey = regInfo.guid;
            getRegionOrCity().charter = regInfo.charter;

        } catch(ex) {

            takeColonyOffline();

            webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onColonyRegistered",ex.message);

            return;
        }

        generalSaveGame();

        getColonyInfoFromServer();
    }

    function sendTaxPayment(amount) {
        if(!currentGame || currentGame == null) {
            return;
        }

        if(getRegionOrCity().motherlandid == 0 || getRegionOrCity().offlineMode) {
            return;
        }

        var data = [];

        data.push({
            "key":      "mid",
            "value":    getRegionOrCity().motherlandid
        });

        data.push({
            "key":      "a",
            "value":    amount
        });

        postSecuredCallToApi(data,40,placeholder);
    }
    
    function updateResourcePrices(resources) {

        var gameRes = getGameResources();

        if(!gameRes) {
            return;
        }

        for(var i = 0; i < resources.resources.length; i++) {
            var gamePrice = getResourceByDefName(resources.resources[i].name).basePrice;

            var totalPrice = gamePrice + (parseInt(resources.resources[i].detailed.rolling) * 3);

            var averageAmount = Math.round(totalPrice / 4);

            var newGamePrice =  Math.round(averageAmount);

            if(newGamePrice > parseInt(resources.resources[i].detailed.emergency)) {
                newGamePrice =  parseInt(resources.resources[i].detailed.emergency);
            }


            gameRes[resources.resources[i].name].price = newGamePrice;
            gameRes[resources.resources[i].name].serverId = resources.resources[i].id;
            gameRes[resources.resources[i].name].lastTrade = parseInt(resources.resources[i].detailed.last);

            if(showingLive) {
                updateLivePrice(resources.resources[i].id,parseInt(resources.resources[i].detailed.last));
            }
        }

        serverMaxTradeSize = parseInt(resources.maxtrade);
    }

    function loadCommonwealthData() {
        if(!currentGame || currentGame == null) {
            return;
        }

        var roc = getRegionOrCity();

        if(!roc) {
            return;
        }

        var commonwealthStatsFunctionsArea = document.getElementById("commonwealthStatsFunctionsArea");
        commonwealthStatsFunctionsArea.innerHTML = "";

        var commonwealthLeader = roc.motherlandid;

        if(roc.isIndependent) {
            commonwealthLeader = roc.colonyId;
            document.getElementById("commonwealthListingCommonwealthName").innerHTML = roc.name;

            document.getElementById("commonwealthListingCommonwealthWebsite").innerHTML = ColonyGame.meta.colonyServerBase + roc.charter + "/";
            document.getElementById("commonwealthListingCommonwealthWebsite").onclick = function() {
                webAppCore.externalURL(ColonyGame.meta.colonyServerBase + roc.charter + "/");
            };

            if(roc.salesPitch && roc.salesPitch != "0") {
                document.getElementById("commonwealthSalespitch").innerHTML = roc.salesPitch;
            } else {
                document.getElementById("commonwealthSalespitch").innerHTML = "";
            }
        } else {
            document.getElementById("commonwealthListingCommonwealthName").innerHTML = roc.motherland;

            document.getElementById("commonwealthListingCommonwealthWebsite").innerHTML = ColonyGame.meta.colonyServerBase + roc.motherlandCharter + "/";
            document.getElementById("commonwealthListingCommonwealthWebsite").onclick = function() {
                webAppCore.externalURL(ColonyGame.meta.colonyServerBase + roc.motherlandCharter + "/");
            };

            document.getElementById("commonwealthSalespitch").innerHTML = "";
        }

        if(roc.isIndependent && !roc.offlineMode) {
            createEncyclopediaCard(commonwealthStatsFunctionsArea,"images/" + ColonyGame.meta.mailIndicator,getString("general-mass-message"),webAppCore.getString("edict-short-desc"),sendCommonwealthEdict);
            createEncyclopediaCard(commonwealthStatsFunctionsArea,"images/" + ColonyGame.meta.polLaborInd,getString("general-online-pay-assis"),"Current: " + numberWithCommas(Math.round(roc.payrollRate * 100)) + "%",showPayrollAssistanceWindow);
            createEncyclopediaCard(commonwealthStatsFunctionsArea,"images/" + ColonyGame.meta.taxCollectionInd,getString("tax-rate"),"Current: " + numberWithCommas(roc.taxLevel) + "%",showTaxRateWindow);
            createEncyclopediaCard(commonwealthStatsFunctionsArea,"images/" + ColonyGame.meta.empireIndicator,getString("pol-salespitch-header"),getString("salepitch-info-short"),setSalesPitch);
        }


        if(roc.governmentLevel >= 1 && !roc.isIndependent) {
            var baseIndependenceCost = ColonyGame.meta.baseIndependenceCost;
            var relationsPenalty = baseIndependenceCost.amount - (baseIndependenceCost.amount * (getRegionOrCity().earthAssemblyRelations / 100));
            var totalIndependenceCost = baseIndependenceCost.amount + relationsPenalty;

            createEncyclopediaCard(commonwealthStatsFunctionsArea,"images/" + getResourceByDefName(baseIndependenceCost.resource).icon,getString("general-declare-ind"),"Cost: " + getResourceByDefName(baseIndependenceCost.resource).indicator + numberWithCommas(totalIndependenceCost),askForIndependence);
        }




        


        if(!commonwealthLeader || commonwealthLeader == 0) {
            return;
        }

        var data = [];

        data.push({
            "key":      "cid",
            "value":    commonwealthLeader
        });

        postSecuredCallToApi(data,39,parseCommonwealthLeaderData);

        
    }

    var pendingLoadColonyIdFromServer = 0;

    function getColonyInfoAndLaunchInfo(id) {

        pendingLoadColonyIdFromServer = id;

        var data = [];

        data.push({
            "key":      "cid",
            "value":    id
        });

        postSecuredCallToApi(data,39,parseColonyInfoAndLaunchIn);
    }

    function parseColonyInfoAndLaunchIn(result) {

        if(result != null && result.trim().length > 0) {
            try {
                var colonyInfo = JSON.parse(result)[0];

                if(colonyInfo == null) {
                    if(pendingLoadColonyIdFromServer != 0) {
                        delete getRegionOrCity().foreignContactReference[pendingLoadColonyIdFromServer];
                    }
                    pendingLoadColonyIdFromServer = 0;
                    return;
                }

                launchColonyInfoScreen(colonyInfo);

            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": parseColonyInfoAndLaunchIn",ex.message);
            }
        }

        pendingLoadColonyIdFromServer = 0;
    }

    function parseCommonwealthLeaderData(result) {
        if(result != null && result.trim().length > 0) {
            try {
                var colonyInfo = JSON.parse(result)[0];

                if(colonyInfo == null) {
                    return;
                }


                document.getElementById("actualCommonwealthReadoutArea").innerHTML = "";

                addColonyCardToListing(colonyInfo);

                var commonwealthLeader = getRegionOrCity().motherlandid;
                
                if(getRegionOrCity().isIndependent) {
                    commonwealthLeader = getRegionOrCity().colonyId;
                }

                var data = [];

                data.push({
                    "key":      "cid",
                    "value":    commonwealthLeader
                });

                postSecuredCallToApi(data,30,parseNewCommonwealthListing);

            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": parseCommonwealthLeaderData",ex.message);
            }
        }
    }

    function commonwealthPongFrom(id) {
        if(!statsOpen) {
            return;
        }

        var commonwealthCards = document.getElementById("statsMain").querySelectorAll(".colonyCard");

        for(var i = 0; i < commonwealthCards.length; i++) {

            if(!commonwealthCards[i].colonyRef) {
                continue;
            }

            if(commonwealthCards[i].colonyRef.colonyid == id) {
                commonwealthCards[i].querySelector(".colonyCardActive").innerHTML = "Online";
                commonwealthCards[i].className += " online";
                commonwealthCards[i].colonyOnline = true;
                break;
            }
        }
    }

    var commonwealthOnlineColonies = 0;

    function parseNewCommonwealthListing(result) {
        if(result != null && result.trim().length > 0) {
            try {
                var colonyInfo = JSON.parse(result);

                if(colonyInfo == null) {
                    return;
                }

                for(var i = 0; i < colonyInfo.length; i++) {
                    addColonyCardToListing(colonyInfo[i]);
                }

                commonwealthOnlineColonies = 0;

                postInGameMessageToCommonwealth("onlineping");

            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": parseNewCommonwealthListing",ex.message);
            }
        }
    }

    function createEncyclopediaCard(section,icon,title,desc,callback,tag,descColor) {
        var colonyCard = document.createElement("div");
        colonyCard.className = "colonyCard";

        var colonyIcon = document.createElement("img");
        colonyIcon.draggable = false;
        colonyIcon.className = "colonyCardIcon";
        colonyIcon.src = icon;
        
        colonyCard.appendChild(colonyIcon);

        var colonyName = document.createElement("span");
        colonyName.className = "colonyCardName";
        colonyName.innerHTML = title;
        colonyCard.appendChild(colonyName);

        var colonyActive = document.createElement("span");
        colonyActive.className = "colonyCardActive";
        colonyActive.innerHTML = desc;

        if(descColor) {
            colonyActive.style.color = descColor;
        }

        colonyCard.appendChild(colonyActive);

        colonyCard.onclick = callback;

        if(tag) {
            colonyCard.tagObj = tag;
        }

        section.appendChild(colonyCard);
    }

    function addColonyCardToListing(colonyInfo,fromDiplomatic,useListing) {
        if(!fromDiplomatic && colonyInfo.colonyid == getRegionOrCity().colonyId) {
            return;
        }

        var listing = "actualCommonwealthReadoutArea";

        if(fromDiplomatic) {
            listing = "diplomaticListing";
        }

        if(useListing) {
            listing = useListing;
        }

        var colonyCard = document.createElement("div");
        colonyCard.className = "colonyCard";
        colonyCard.colonyRef = colonyInfo;
        colonyCard.colonyOnline = false;

        if(fromDiplomatic) {
            colonyCard.diplomaticCard = fromDiplomatic;
        } else {
            colonyCard.diplomaticCard = false;
        }

        if(colonyInfo.relations < 80) {
            colonyCard.className = "colonyCard badrelations";
        }

        var colonyIcon = document.createElement("img");
        colonyIcon.draggable = false;
        colonyIcon.className = "colonyCardIcon";
        var hasIcon = false;

        if(colonyInfo.isindependent == "1" && !fromDiplomatic) {
            hasIcon = true;
            colonyIcon.src = "images/" + ColonyGame.meta.empireIndicator;
        } else {

            for(var i = 0; i < ColonyGame.mapTypes.length; i++) {
                if(ColonyGame.mapTypes[i].name == colonyInfo.maptype) {
                    colonyIcon.src = "images/" + ColonyGame.mapTypes[i].icon;

                    hasIcon = true;
                }
            }
        }

        if(!hasIcon) {
            colonyIcon.src = "images/" + ColonyGame.meta.charterIndicator;
        }
        
        colonyCard.appendChild(colonyIcon);

        var colonyName = document.createElement("span");
        colonyName.className = "colonyCardName";
        colonyName.innerHTML = colonyInfo.colonyname;
        colonyCard.appendChild(colonyName);

        var colonyActive = document.createElement("span");
        colonyActive.className = "colonyCardActive";
        colonyActive.innerHTML = "Last Active: " + colonyInfo.lastactive;
        colonyCard.appendChild(colonyActive);

        colonyCard.onclick = function() {
            launchColonyInfoScreen(this.colonyRef,this.diplomaticCard,this.colonyOnline);
        };

        document.getElementById(listing).appendChild(colonyCard);
    }

    function closeColonyWindow() {
        colonyWindowOpen = false;
        tmpNegoiationColony = null;
        document.getElementById("colonyWindow").style.display = "none";
    }

    var colonyWindowOpen = false;

    function launchColonyInfoScreen(colonyInfo,fromDiplomatic) {

        if(getRegionOrCity().colonyId == colonyInfo.colonyid) {
            return;
        }

        tmpNegoiationColony = {"id":colonyInfo.colonyid,"name":colonyInfo.colonyname,"charter":colonyInfo.charter,"population":colonyInfo.population};

        colonyWindowOpen = true;

        var hasIcon = false;

        for(var i = 0; i < ColonyGame.mapTypes.length; i++) {
            if(ColonyGame.mapTypes[i].name == colonyInfo.maptype) {
                document.getElementById("colonyIcon").src = "images/" + ColonyGame.mapTypes[i].icon;

                hasIcon = true;
            }
        }


        if(!hasIcon) {
            document.getElementById("colonyIcon").src = "images/" + ColonyGame.meta.charterIndicator;
        }

        postInGameMessageToColony("checkvitals",null,colonyInfo.colonyid);

        document.getElementById("colonyWindow").style.display = "block";

        document.getElementById("colonyCoinShower").style.display = "none";

        document.getElementById("colonyEstablishEmbassy").style.display = "none";
        document.getElementById("colonyContactAmbassador").style.display = "none";
        

        document.getElementById("colonyViewWebsite").style.display = "initial";
        document.getElementById("colonyViewWebsite").onclick = function() {
            webAppCore.externalURL(ColonyGame.meta.colonyServerBase + colonyInfo.charter + "/");
        };

        if(currentGame.isMpRegionHolder) {
            document.getElementById("colonySendMessage").style.display = "none";
        } else {
            if(hasCommunicationsBuilding) {
                document.getElementById("colonySendMessage").style.display = null;
                document.getElementById("colonySendMessage").onclick = function() {
                    tmpHoldingMessage = null;
                    sendACustomMessage(colonyInfo.colonyid);
                };
            } else {
                document.getElementById("colonySendMessage").style.display = "none";
            }
            
        }

        

        if(getRegionOrCity().isIndependent && colonyInfo.isindependent == "0" && !currentGame.isMpRegionHolder && parseInt(colonyInfo.parentcolony) == parseInt(getRegionOrCity().colonyId)) {
            document.getElementById("colonyTribute").style.display = "initial";
            document.getElementById("colonyTribute").onclick = function() {
                var dialogOptions = {
                    title: "Demand Tribute",
                    message: "What percent of their " + ColonyGame.meta.tenderResource + " do you want " + tmpNegoiationColony.name + " to pay you?",
                    func: demandTribute
                };

                webAppCore.inputBox(dialogOptions);
            };
        } else {
            document.getElementById("colonyTribute").style.display = "none";
        }

        if(webAppCore.isApeAppsLoggedIn()) {
            webAppCore.socketEmit("joinroom","apeuser-" + colonyInfo.aausername);
            postToUserChannel("areyouonline",colonyInfo.aausername,null);
        }

        document.getElementById("colonyInfoUserAreaName").innerHTML = colonyInfo.aausername;
        var ownerAvatar = "https://accounts.ape-apps.com/getavatar.php?u=" + colonyInfo.aausername;
        document.getElementById("colonyInfoUserAreaAvatar").src = ownerAvatar;

        document.getElementById("colonyInfoUserAreaHolder").onclick = function(){
            showUserProfile(colonyInfo.aausername);
        };

        
        if(fromDiplomatic && colonyInfo.buildingid) {

            var embassyDef = getBuildingDefByName(colonyInfo.buildingid);

            var img = null;

            if(embassyDef.indicator == null) {

                var ed = getImageAsset(embassyDef.tile[0],false,0,null);

                if(ed) {
                    img = ed.src;
                } 


            } else {
                img = "images/" + embassyDef.indicator;
            }

            if(!img || img == null) {
                img = "images/" + ColonyGame.meta.contactAmbassadorInd;
            }

            document.getElementById("colonyContactAmbassador").style.display = "initial";
            document.getElementById("colonyContactAmbassador").src = img;
            document.getElementById("colonyContactAmbassador").onclick = function() {
                //lookupNewEMbassyTarget(colonyInfo.charter);
            };
        }
        

        if(getRegionOrCity().isIndependent && colonyInfo.isindependent == "1" && !fromDiplomatic) {
            document.getElementById("colonyEstablishEmbassy").style.display = "initial";
            document.getElementById("colonyEstablishEmbassy").onclick = function() {
                lookupNewEMbassyTarget(colonyInfo.charter);
            };
        }

        if(getRegionOrCity().isIndependent && colonyInfo.isindependent == "0" && parseInt(colonyInfo.parentcolony) == parseInt(getRegionOrCity().colonyId)) {
            document.getElementById("colonyNukeCharter").style.display = "initial";
            document.getElementById("colonyNukeCharter").onclick = function() {
                webAppCore.showDialog({
                    "title":    "Rescind Charter",
                    "message":  "Are you sure you want to kick " + tmpNegoiationColony.name + " out of the Commonwealth?  This cannot be undone.",
                    "op1": {
                        "text":     "Rescind Charter",
                        "func":     rescindCharter,
                        "color":    "#F44336"
                    },
                    "op2": {
                        "text":     getString("general-nevermind"),
                        "func":     placeholder
                    }
                });
            };
        } else {
            document.getElementById("colonyNukeCharter").style.display = "none";
        }

        if(getGiftCapacity() > 0 && !currentGame.isMpRegionHolder) {
            document.getElementById("colonySendGift").style.display = "initial";
            document.getElementById("colonySendGift").onclick = function() {
                tmpHoldingMessage = null;
                showOnlineResources("send");
            };
        } else {
            document.getElementById("colonySendGift").style.display = "none";
        }

        if(commonwealthOnlineColonies > 0 && !currentGame.isMpRegionHolder) {
            document.getElementById("colonyDenounce").style.display = "initial";
            document.getElementById("colonyDenounce").onclick = function() {
                postMessageToAllChannels(getRegionOrCity().name + " denounces " + tmpNegoiationColony.name + "!");
                webAppCore.showToast("You publicly denounce " + tmpNegoiationColony.name + "!");
            };
        } else {
            document.getElementById("colonyDenounce").style.display = "none";
        }

        if(colonyInfo.cloudlocation == "0" && !currentGame.isMpRegionHolder) {
            document.getElementById("colonyInspect").style.display = "none";
        } else {
            // for now, disable this since its not working anyway!
            // perhaps instead, use it to watch streaming in-game
            document.getElementById("colonyInspect").style.display = "none";
        }

        document.getElementById("colonyName").innerHTML = colonyInfo.colonyname + " (" + colonyInfo.race + ")";

        document.getElementById("colonyScreenshot").style.display = "block";
        document.getElementById("colonyInfoUserAreaHolder").style.display = "block";

        if(colonyInfo.screenshot == "0") {
            document.getElementById("colonyScreenshot").style.backgroundImage = null;
            document.getElementById("colonyScreenshot").style.backgroundColor = "#000000";
        } else {
            
            document.getElementById("colonyScreenshot").style.backgroundImage = "url('" + ColonyGame.meta.colonyServerBase.replace("/colonies","/screenshots") + colonyInfo.screenshot + "')";
        }

        var withFlag = false;
        var flagObj = null;

        if(colonyInfo.rawflagdat && colonyInfo.rawflagdat.trim().length > 6) {
            

            try {
                var flagDec = atob(colonyInfo.rawflagdat);
                flagObj = JSON.parse(flagDec);
            } catch(ex) {
                flagObj = null;
            }

            if(flagObj) {
                withFlag = true;
            }
        }
        
        if(flagObj && withFlag) {
            document.getElementById("colonyInfoFlagDisplay").style.display = "block";
            renderFlagIntoCanvas(flagObj,document.getElementById("colonyInfoFlagDisplay"),false);
        } else {
            document.getElementById("colonyInfoFlagDisplay").style.display = "none";
        }

        document.getElementById("concernsListing").innerHTML = "";
        document.getElementById("colonyConcernsHeader").style.display = "none";

        document.getElementById("colonyFounded").innerHTML = "Founded: " + colonyInfo.founded;

        if(colonyInfo.isindependent == "0") {
            document.getElementById("colonyIndependence").style.display = "none";
        } else {
            document.getElementById("colonyIndependence").style.display = "block";
            document.getElementById("colonyIndependence").innerHTML = "Independence Day: " + colonyInfo.independent;
        }

        document.getElementById("colonyLastActive").innerHTML = "Last Active: " + colonyInfo.lastactive;
        document.getElementById("colonyPopulation").innerHTML = "Population: " + numberWithCommas(colonyInfo.population);
        document.getElementById("colonyGDP").innerHTML = "GDP: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(colonyInfo.totalgdp);
        document.getElementById("colonyUnemployment").innerHTML = "Unemployment Rate: " + colonyInfo.unemployment + "%";
        document.getElementById("colonyRelations").innerHTML = "Commonwealth Relations: " + colonyInfo.relations + "%";
        document.getElementById("colonyLocation").innerHTML = "Location: Sector " + colonyInfo.sectorx + ":" + colonyInfo.sectory + " - Grid " + colonyInfo.gridx + ":" + colonyInfo.gridy;
        
        if(isRestrictivePlatform() || colonyInfo.lastplatform == "Unknown") {
            document.getElementById("colonyPlaysOnSection").style.display = "none";
        } else {

            document.getElementById("colonyPlaysOnSection").style.display = "block";

            var platformData = getNameAndColorByPlatformCode(colonyInfo.lastplatform);

            var showPlatform = platformData.name;
            var showColor = platformData.color;

            document.getElementById("colonyPlaysOn").innerHTML = showPlatform;
            document.getElementById("colonyPlaysOn").style.color = showColor;
        }
    }

    var gamepadGbtOption = 0;
    
    function showNewTradeMenu(title) {

        var roc = getRegionOrCity();

        if(currentTimeoutForSidebar != null) {
            clearTimeout(currentTimeoutForSidebar);
            currentTimeoutForSidebar = null;
        }

        if(usingSockets && !roc.tradeNotifications) {
            webAppCore.socketEmit("joinroom","trades");
        }

        document.getElementById("galBT").style.display = "block";
        gbtOpen = true;

        showLivePrices();

        tickerItems = [];

        if(!title) {
            for(var i = 0; i < currentGame.buildings.length; i++) {
                var bld = currentGame.buildings[i];

                if(!bld) {
                    continue;
                }

                var bdef = getBuildingDefByName(bld.def);

                if(bdef) {
                    if(bdef.onlineTradeDepot) {
                        title = bld.name;
                        break;
                    }
                }
            }
        }

        document.getElementById("tradeMenuName").innerHTML = title;

        initSidebarPopulation();

    }

    function initSidebarPopulation() {
        var data = [];
        postSecuredCallToApi(data,9,populateGBTSidebar);
    }

    var tickerItems = [];

    function updateTicker() {

        var roc = getRegionOrCity();

        if(!gbtOpen && !roc.tradeNotifications) {
            return;
        }

        var tickerArea = "gbtNewsData";
        var tickerHolder = "gabBTTicker";

        if(!gbtOpen) {
            tickerArea = "tradeNotificationAreaReadout";
            tickerHolder = "tradeNotificationArea";
        }

        var showingTickers = document.getElementById(tickerArea).querySelectorAll("span");

        var lastItem = null;
        var readyForNewItem = true;

        var tickerSpeed = 4;

        if(window.innerWidth < 800) {
            tickerSpeed = 3;
        }

        if(window.innerWidth < 500) {
            tickerSpeed = 2;
        }

        for(var i = 0; i < showingTickers.length; i++) {
            showingTickers[i].style.left = (parseInt(showingTickers[i].style.left.replace("px","")) - tickerSpeed) + "px";
            lastItem = showingTickers[i];

            if(parseInt(showingTickers[i].style.left.replace("px","")) < -showingTickers[i].offsetWidth) {
                document.getElementById(tickerArea).removeChild(showingTickers[i]);
                lastItem = null;
            }

            
        }

        if(lastItem != null) {

            var lastItemLeft = parseInt(lastItem.style.left.replace("px",""));
            var ticketWidth = document.getElementById(tickerHolder).offsetWidth;
            var lastItemWidth = lastItem.clientWidth;

            if(lastItemLeft > (ticketWidth - lastItemWidth)) {
                readyForNewItem = false;
            }
        }

        if(readyForNewItem && tickerItems.length > 0) {
            var nextItem = tickerItems.shift();
            nextItem.style.left = document.getElementById(tickerHolder).offsetWidth + "px";
            document.getElementById(tickerArea).appendChild(nextItem);
        }

        if(desktopMode && tickerItems.length == 0 && !gettingPrices) {
            gettingPrices = true;
            showOnlineResources("setprices");
        }
    }

    var gettingPrices = false;

    function announceRegionAnnualGDP(adjustedGDP) {
        if(!currentRegion) {
            return;
        }

        var alertMessage = "BREAKING NEWS - The greater " + currentRegion.name + " regional annual GDP came in at " + adjustedGDP.toFixed(1) + "%, last year.";

        addItemToNewsTicker(alertMessage,"#FFC107",function() {
            showColonistsMenu("economy");
        },true,1,true);
    }

    function announceQuarterlyGDPPrint(quarterlyChange) {

        // for fun, come up with an "analyst" expectation for the current quarter for news release

        var expectation = quarterlyChange;
        var expectationMessage = "in line with";

        if(currentGame.historicStats.gdpQuarterlyAdjusted.length > 5) {
            var runningTotal = 0.0;
            var startPos = currentGame.historicStats.gdpQuarterlyAdjusted.length - 5;

            for(var i = startPos; i < currentGame.historicStats.gdpQuarterlyAdjusted.length - 1; i++) {
                runningTotal += parseFloat(currentGame.historicStats.gdpQuarterlyAdjusted[i]);
            }

            expectation = runningTotal / 4;

            if(parseFloat(currentGame.historicStats.gdpQuarterlyAdjusted[startPos]) < parseFloat(currentGame.historicStats.gdpQuarterlyAdjusted[currentGame.historicStats.gdpQuarterlyAdjusted.length - 2])) {
                expectation += 0.5;
            } else {
                expectation -= 0.5;
            }
        }

        var diff = quarterlyChange - expectation;

        

        if(diff > 0.2) {
            expectationMessage = "edging out";
        }

        if(diff > 1) {
            expectationMessage = "beating";
        }

        if(diff > 5) {
            expectationMessage = "crushing";
        }

        if(diff < -0.2) {
            expectationMessage = "falling just short of";
        }

        if(diff < -1) {
            expectationMessage = "missing";
        }

        if(diff < -5) {
            expectationMessage = "coming in well below";
        }

        var alertMessage = "BREAKING NEWS - Quarterly GDP comes in at " + quarterlyChange.toFixed(1) + "%, " + expectationMessage + " analyts expectations.";

        addItemToNewsTicker(alertMessage,"#FFC107",function() {
            showColonistsMenu("economy");
        },true,1,true);
    }

    function addItemToNewsTicker(text,color,callback,onTop,opacity,bold) {

        var roc = getRegionOrCity();

        if(!gbtOpen && !roc.tradeNotifications) {
            return;
        }

        var tickerItem = document.createElement("span");
        tickerItem.innerHTML = text;

        if(color) {
            tickerItem.style.color = color;
        }

        if(callback) {
            tickerItem.onclick = callback;
        }

        if(bold) {
            tickerItem.style.fontWeight = "bold";
        }

        if(opacity) {
            tickerItem.style.opacity = opacity;
        }

        if(onTop) {
            tickerItems.unshift(tickerItem);
        } else {
            tickerItems.push(tickerItem);
        }

    }

    function highlightNextGbtSidebarOption() {
        var sidebarOptions = document.getElementById("gabBTSidebar").querySelectorAll(".gabBTSidebarItem");

        if(sidebarOptions.length == 0) {
            return;
        }

        if(gamepadGbtOption < 0) {
            gamepadGbtOption = sidebarOptions.length - 1;
        }

        if(gamepadGbtOption >= sidebarOptions.length) {
            gamepadGbtOption = 0;
        }

        for(var i = 0; i < sidebarOptions.length; i++) {

            if(i == gamepadGbtOption) {
                sidebarOptions[i].className = "gabBTSidebarItem gabBTSidebarItemSelected";
                sidebarOptions[i].scrollIntoView();
                sidebarOptions[i].click();
            } else {
                sidebarOptions[i].className = "gabBTSidebarItem";
            }
        }
    }
    
    function populateGBTSidebar(result) {
        var resources;
        var roc = getRegionOrCity();

        if(currentGame == null) {
            return;
        }

        if(result != null && result.trim().length > 0) {
            try {
                resources = JSON.parse(result);
            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": populateGBTSidebar",ex.message);
                return;
            }
        }

        if(resources == null) {
            return;
        }

        document.getElementById("gabBTSidebar").innerHTML = "";
        var newItem;

        if(desktopMode) {
            var tradenotifyicon = ColonyGame.meta.indDismiss;

            if(roc.tradeNotifications) {
                tradenotifyicon = ColonyGame.meta.indCheckbox;
            }

            newItem = createSidebarItem("images/" + tradenotifyicon,getString("general-trade-notifications"),"tradenotifications");
            document.getElementById("gabBTSidebar").appendChild(newItem);
        }


        newItem = createSidebarItem("images/" + ColonyGame.meta.resourcesInd,getString("general-live-prices"),"liveprices");
        document.getElementById("gabBTSidebar").appendChild(newItem);

        
        addGbtPricesToTicker(resources);
        
        updateResourcePrices(resources);

        currentTimeoutForSidebar = setTimeout(repopulareSidebarIfNeeded,95000);

        if(gamepadInUse) {
            highlightNextGbtSidebarOption();
        }
    }

    function addGbtPricesToTicker(resources) {
        var newItem;
        gettingPrices = false;

        for(var i = 0; i < resources.resources.length; i++) {

            var resource = resources.resources[i];

            newItem = createSidebarItem("images/" + getResourceByDefName(resource.name).icon,resource.name,resource);
            document.getElementById("gabBTSidebar").appendChild(newItem);

            var tickerText = resource.name + ". Last Price: " + numberWithCommas(parseInt(resource.detailed.last)) + ". Range: " + numberWithCommas(parseInt(resource.detailed.min)) + "-" + numberWithCommas(parseInt(resource.detailed.max)) + ". Average: " + numberWithCommas(parseInt(resource.detailed.rolling));

            addItemToNewsTicker(tickerText);
        }
    }

    function createSidebarItem(icon,name,reference) {
        var resItem = document.createElement("div");
        resItem.className = "gabBTSidebarItem";

        var resImage = document.createElement("img");
        resImage.src = icon;
        resImage.className = "gabBTSidebarItemIcon";
        resItem.appendChild(resImage);
        
        var resName = document.createElement("span");
        resName.innerHTML = name;
        resName.className = "gabBTSidebarItemName";
        resItem.appendChild(resName);

        resItem.resRef = reference;
        
        resItem.onclick = function() {
            populateNewGbtResources(this.resRef);
        };

        return resItem;
    }

    var currentTimeoutForSidebar = null;

    var gbtOpen = false;

    function repopulareSidebarIfNeeded() {
        currentTimeoutForSidebar = null;

        if(gbtOpen) {
            initSidebarPopulation();
        }
    }

    var showingLive = false;

    function updateLivePrice(serverid,price) {

        var gameitem = getResourceByServerId(serverid);

        getGameResources()[gameitem.name].lastTrade = parseInt(price);

        if(!showingLive) {
            return;
        }

        var priceItems = document.getElementById("gabBTMain").querySelectorAll(".livePriceCard");

        for(var i = 0; i < priceItems.length; i++) {
            if(priceItems[i].serverId == serverid) {
                var priceColor = "initial";
                var indicatorSource = "images/res-trend-placeholder.png";

                if(price > priceItems[i].price) {
                    priceColor = "#33691E";
                    indicatorSource = "images/res-trend-up.png";
                }

                if(price < priceItems[i].price) {
                    priceColor = "#B71C1C";
                    indicatorSource = "images/res-trend-down.png";
                }

                priceItems[i].querySelector(".livePricePrice").innerHTML = numberWithCommas(price);
                priceItems[i].querySelector(".livePricePrice").style.color = priceColor;
                priceItems[i].querySelector(".livePriceIndicator").src = indicatorSource;

                priceItems[i].price = price;
            }
        }
    }

    function showLivePrices() {

        document.getElementById("gabBTMain").innerHTML = "";

        var maxTradeSize = serverMaxTradeSize;
        
        if(maxTradeSize > getGiftCapacity()) {
            maxTradeSize = getGiftCapacity();
        }

        var commaCapacity = numberWithCommas(maxTradeSize);

        document.getElementById("gbtCurResStat").innerHTML = "Trade capacity: " + commaCapacity;


        for(var i = 0; i < ColonyGame.resources.length; i++) {
            if(getGameResources()[ColonyGame.resources[i].name].serverId && getGameResources()[ColonyGame.resources[i].name].serverId != 0) {
                var livePriceCard = document.createElement("div");

                livePriceCard.className = "livePriceCard";
                livePriceCard.serverId = getGameResources()[ColonyGame.resources[i].name].serverId;
                livePriceCard.price = parseInt(getGameResources()[ColonyGame.resources[i].name].lastTrade);

                var livePriceImage = document.createElement("img");
                livePriceImage.src = "images/" + ColonyGame.resources[i].icon;
                livePriceImage.className = "livePriceImage";
                livePriceCard.appendChild(livePriceImage);

                var livePriceName = document.createElement("span");
                livePriceName.className = "livePriceName";
                livePriceName.innerHTML = ColonyGame.resources[i].name;
                livePriceCard.appendChild(livePriceName);

                var livePriceIndicator = document.createElement("img");
                livePriceIndicator.className = "livePriceIndicator";
                livePriceIndicator.src = "images/res-trend-placeholder.png";
                livePriceCard.appendChild(livePriceIndicator);

                var livePricePrice = document.createElement("span");
                livePricePrice.className = "livePricePrice";
                livePricePrice.innerHTML = numberWithCommas(parseInt(getGameResources()[ColonyGame.resources[i].name].lastTrade));
                livePriceCard.appendChild(livePricePrice);

                livePriceCard.resourceReference = ColonyGame.resources[i];

                livePriceCard.onclick = function() {
                    populateNewGbtResources({
                        "id": getGameResources()[this.resourceReference.name].serverId,
                        "name": this.resourceReference.name,
                        "price": getGameResources()[this.resourceReference.name].price,
                        "detailed": {
                            "last": getGameResources()[this.resourceReference.name].lastTrade
                        }
                    });
                };

                document.getElementById("gabBTMain").appendChild(livePriceCard);
            }
        }

        showingLive = true;
    }
    
    function populateNewGbtResources(resource) {
        
        if(resource == "commonwealth") {

            return;
        }

        if(resource == "liveprices") {
            showLivePrices();
            return;
        }

        if(resource == "tradenotifications") {
            var roc = getRegionOrCity();

            roc.tradeNotifications = !roc.tradeNotifications;
            initSidebarPopulation();
            setBodyStyles();
            return;
        }

        if(document.getElementById("galBT").style.display != "block") {
            closeSomethingIfOpen();
            showNewTradeMenu();
        }

        pendingTradeResource = resource;

        var data = [];

        data.push({
            "key":      "r",
            "value":    pendingTradeResource.id
        });

        postSecuredCallToApi(data,58,parseNewGbtContracts);
    }

    var currentSelectedGamepadContract = 0;
    var gamepadContractsPerLine = 0;
    
    function parseNewGbtContracts(result) {
        if(currentGame == null) {
            return;
        }

        var gameRes = getGameResources();

        if(!gameRes) {
            return;
        }

        

        showingLive = false;

        document.getElementById("gabBTMain").innerHTML = "";

        var maxTradeSize = serverMaxTradeSize;
        
        if(maxTradeSize > getGiftCapacity()) {
            maxTradeSize = getGiftCapacity();
        }

        var resources;

        currentSelectedGamepadContract = 0;
        
        if(result != null && result.trim().length > 0) {
            try {
                resources = JSON.parse(result);
            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": parseNewGbtContracts",ex.message);
                webAppCore.showToast(getString("no-contracts"));
                return;
            }
        }
        
        if(resources == null || pendingTradeResource == null || !pendingTradeResource.detailed) {
            webAppCore.showToast(getString("no-contracts"));
            return;
        }

        var currentAmt = numberWithCommas(gameRes[pendingTradeResource.name].amount);
        var commaCapacity = numberWithCommas(maxTradeSize);

        document.getElementById("gbtCurResStat").innerHTML = "You have: " + currentAmt + ".  Trade capacity: " + commaCapacity;

        if(window.innerWidth > 500) {
            document.getElementById("gbtCurResStat").innerHTML += ".  Max lot price: " +numberWithCommas(Math.floor(resources.maxprice)) + ".  Min lot price: " + numberWithCommas(Math.ceil(resources.minprice));
        }

        if(!gamepadInUse) {
            // new sale button
            if(gameRes[pendingTradeResource.name].amount >= 100) {

                var btnNewSale = document.createElement("div");
                btnNewSale.className = "gabBTContractItem";
                btnNewSale.resourceRef = pendingTradeResource;

                var newSaleeHeader = document.createElement("span");
                newSaleeHeader.innerHTML = "SELL";
                newSaleeHeader.className = "contractHeader";
                btnNewSale.appendChild(newSaleeHeader);
                
                
                var newSaleIcon = document.createElement("img");
                newSaleIcon.className = "gabBTContractItemImage";
                newSaleIcon.src = "images/" + getResourceByDefName(pendingTradeResource.name).icon;

                btnNewSale.onclick = function() {
                    onSellSelectedResourceType(this.resourceRef,0,Math.ceil(resources.minprice),Math.floor(resources.maxprice));
                };
                
                btnNewSale.appendChild(newSaleIcon);

                var newSaleDescriipoion = document.createElement("span");
                newSaleDescriipoion.innerHTML = "Post a new " + pendingTradeResource.name + " trade to the market.  Choose quantity and price, and see if anybody buys.";
                newSaleDescriipoion.className = "contractPrice";
                
                btnNewSale.appendChild(newSaleDescriipoion);

                btnNewSale.defaultClass = btnNewSale.className;

                document.getElementById("gabBTMain").appendChild(btnNewSale);
            }

            // new offer button 
            var btnNewOffer = document.createElement("div");
            btnNewOffer.className = "gabBTContractItem";
            btnNewOffer.resourceRef = pendingTradeResource;

            var newOfferHeader = document.createElement("span");
            newOfferHeader.innerHTML = "REQUEST";
            newOfferHeader.className = "contractHeader";
            btnNewOffer.appendChild(newOfferHeader);
            
            
            var newOfferIcon = document.createElement("img");
            newOfferIcon.className = "gabBTContractItemImage";
            newOfferIcon.src = "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon;
            

            btnNewOffer.appendChild(newOfferIcon);

            var newOfferDescriptoin = document.createElement("span");
            newOfferDescriptoin.innerHTML = "Offer to buy " + pendingTradeResource.name + " at a given price.  Choose quantity and see if anybody sells to you.";
            newOfferDescriptoin.className = "contractPrice";
            
            btnNewOffer.appendChild(newOfferDescriptoin);

            btnNewOffer.onclick = function() {
                onSellSelectedResourceType(this.resourceRef,1,Math.ceil(resources.minprice),Math.floor(resources.maxprice));
            };

            btnNewOffer.defaultClass = btnNewOffer.className;


            document.getElementById("gabBTMain").appendChild(btnNewOffer);


            // auto sell option 
            if(getRegionOrCity().governmentLevel >= 2) {
                var btnAutoSale = document.createElement("div");
                btnAutoSale.className = "gabBTContractItem";
                btnAutoSale.resourceRef = pendingTradeResource;

                var btnAutoSaleHeader = document.createElement("span");
                btnAutoSaleHeader.innerHTML = "AUTO-TRADE";
                btnAutoSaleHeader.className = "contractHeader";
                btnAutoSale.appendChild(btnAutoSaleHeader);
                
                
                var btnAutoSaleHeaderIcon = document.createElement("img");
                btnAutoSaleHeaderIcon.className = "gabBTContractItemImage";
                btnAutoSaleHeaderIcon.src = "images/" + ColonyGame.meta.indSell;

                btnAutoSale.onclick = function() {
                    getGameResources()[this.resourceRef.name].autosell = !getGameResources()[this.resourceRef.name].autosell;
                    
                    if(getGameResources()[this.resourceRef.name].autosell) {
                        this.statusRef.innerHTML = "Enabled";
                        this.statusRef.style.color = "#4CAF50";
                        currentGame.autosellCheckCounter += 1000;
                    } else {
                        this.statusRef.innerHTML = "Disabled";
                        this.statusRef.style.color = "#f44336";
                    }

                    updateColonyStats();
                };
                
                btnAutoSale.appendChild(btnAutoSaleHeaderIcon);

                var btnAutoSaleDesc = document.createElement("span");
                btnAutoSaleDesc.innerHTML = "Automatically trade " + pendingTradeResource.name + " contracts when inventories are low or full.";
                btnAutoSaleDesc.className = "contractPrice";
                
                btnAutoSale.appendChild(btnAutoSaleDesc);

                var autoselStatus = document.createElement("span");
                autoselStatus.className = "contractPrice";
                btnAutoSale.statusRef = autoselStatus;

                if(gameRes[pendingTradeResource.name].autosell) {
                    autoselStatus.innerHTML = "Enabled";
                    autoselStatus.style.color = "#4CAF50";
                } else {
                    autoselStatus.innerHTML = "Disabled";
                    autoselStatus.style.color = "#f44336";
                }

                btnAutoSale.appendChild(autoselStatus);

                btnAutoSale.defaultClass = btnAutoSale.className;

                document.getElementById("gabBTMain").appendChild(btnAutoSale);
            }

        }


        var currentGoodDeals = 0;

        
        var addedContracts = 0;

        for(var i = 0; i < resources.contracts.length; i++) {
            var contract = resources.contracts[i];

            if(contract.quantity > maxTradeSize) {
                continue;
            }

            if(addedContracts > 100) {
                break;
            }

            var unitPrice = parseInt(contract.price) / parseInt(contract.quantity);
            var hundredPrice = Math.round(unitPrice * 100);

            var priceColor = null;
            var hundredColor = null;

            if(contract.isoffer == "1") {
                if(contract.quantity > gameRes[pendingTradeResource.name].amount) {
                    priceColor = "#F44336";
                }

                if(hundredPrice < parseInt(pendingTradeResource.detailed.last)) {
                    hundredColor = "#F44336";
                }

                if(hundredPrice > parseInt(pendingTradeResource.detailed.last)) {
                    hundredColor = "#4CAF50";
                }
            } else {
                if(contract.price > gameRes[ColonyGame.meta.tenderResource].amount) {
                    priceColor = "#F44336";
                }

                if(hundredPrice > parseInt(pendingTradeResource.detailed.last)) {
                    hundredColor = "#F44336";
                }

                if(hundredPrice < parseInt(pendingTradeResource.detailed.last)) {
                    hundredColor = "#4CAF50";
                }
            }

            var contractItem = document.createElement("div");
            contractItem.className = "gabBTContractItem";

            if(priceColor != null && contract.sellerid == getRegionOrCity().colonyId) {
                contractItem.className = "gabBTContractItem noafford";
                contractItem.canBuy = false;
            } else {
                contractItem.canBuy = true;
            }

            if(!contractItem.canBuy && addedContracts > 15) {
                continue;
            }

            contractItem.contractRef = contract;
            contractItem.badDeal = false;

            if(contract.isoffer == "0") {
                if(hundredPrice > (gameRes[pendingTradeResource.name].price * 6)) {
                    contractItem.className += " baddeal";
                    contractItem.badDeal = true;
                }
            } else {
                if(hundredPrice < (gameRes[pendingTradeResource.name].price / 6)) {
                    contractItem.className += " baddeal";
                    contractItem.badDeal = true;
                }
            }

            if(contractItem.badDeal && addedContracts > 20) {
                continue;
            }

            var contractHeader = document.createElement("span");
            contractHeader.innerHTML = "YOU GET";
            contractHeader.className = "contractHeader";
            contractItem.appendChild(contractHeader);

            var contractIcon = document.createElement("img");
            contractIcon.className = "gabBTContractItemImage";
            
            if(contract.isoffer == "1") {
                contractIcon.src = "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon;
            } else {
                contractIcon.src = "images/" + getResourceByDefName(pendingTradeResource.name).icon;
            }
            
            contractItem.appendChild(contractIcon);

            var contractQuantity = document.createElement("span");


            if(contract.isoffer == "1") {
                contractQuantity.innerHTML = numberWithCommas(parseInt(contract.price));
            } else {
                contractQuantity.innerHTML = numberWithCommas(parseInt(contract.quantity));
            }
            
            contractQuantity.className = "contractQuantity";
            contractItem.appendChild(contractQuantity);

            var priceHeader = document.createElement("span");
            priceHeader.innerHTML = "YOU PAY";
            priceHeader.className = "priceHeader";
            contractItem.appendChild(priceHeader);


            var priceIcon = document.createElement("img");
            priceIcon.className = "gabBTContractItemImage";
            
            if(contract.isoffer == "1") {
                priceIcon.src = "images/" + getResourceByDefName(pendingTradeResource.name).icon;
            } else {
                priceIcon.src = "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon;
            }
            
            contractItem.appendChild(priceIcon);

            var contractPrice = document.createElement("span");

            if(contract.isoffer == "1") {
                contractPrice.innerHTML = numberWithCommas(parseInt(contract.quantity));
            } else {
                contractPrice.innerHTML = numberWithCommas(parseInt(contract.price));
            }
            
            contractPrice.className = "contractPrice";
            contractPrice.style.color = priceColor;
            contractItem.appendChild(contractPrice);

            var hundoPrico = document.createElement("span");
            hundoPrico.innerHTML = numberWithCommas(parseInt(hundredPrice)) + " per 100";
            hundoPrico.className = "hundredPrice";
            hundoPrico.style.color = hundredColor;
            contractItem.appendChild(hundoPrico);

            var offeredBy = document.createElement("span");
            offeredBy.innerHTML = "Offered By";
            offeredBy.className = "offeredBy";
            offeredBy.charterRef = contract.sellercharter;
            contractItem.appendChild(offeredBy);

            offeredBy.onclick = function(e) {
                e.stopPropagation();
                webAppCore.externalURL(ColonyGame.meta.colonyServerBase + this.charterRef + "/");
            };

            var offeredByName = document.createElement("span");
            offeredByName.innerHTML = contract.sellername;
            offeredByName.className = "offeredByName";
            offeredByName.charterRef = contract.sellercharter;
            contractItem.appendChild(offeredByName);

            offeredByName.onclick = function(e) {
                e.stopPropagation();
                webAppCore.externalURL(ColonyGame.meta.colonyServerBase + this.charterRef + "/");
            };

            contractItem.onclick = onContractItemClick;

            contractItem.defaultClass = contractItem.className;

            if(contractItem.canBuy && i > 0) {

                var putIndex = 2;

                if(getRegionOrCity().governmentLevel >= 2) {
                    putIndex = 3;
                }

                if(contractItem.badDeal) {
                    putIndex += currentGoodDeals;
                } else {
                    currentGoodDeals++;
                }

                addedContracts++;
                document.getElementById("gabBTMain").insertBefore(contractItem,document.getElementById("gabBTMain").children[putIndex]);
            } else {
                addedContracts++;
                document.getElementById("gabBTMain").appendChild(contractItem);
            }

        }
        
        document.getElementById("gabBTMain").scrollTop = 0;

        if(gamepadInUse) {
            highlightSelectedContractGamepad();
        }
    }

    function engageContractPurchase() {
        var totalContracts = document.getElementById("gabBTMain").querySelectorAll(".gabBTContractItem");
        
        if(totalContracts.length == 0) {
            return;
        }

        if(currentSelectedGamepadContract < 0) {
            return;
        }

        if(currentSelectedGamepadContract >= totalContracts.length) {
            return;
        }

        totalContracts[currentSelectedGamepadContract].click();
    }


    function highlightSelectedContractGamepad() {

        gamepadContractsPerLine = 0;


        var totalContracts = document.getElementById("gabBTMain").querySelectorAll(".gabBTContractItem");

        if(totalContracts.length == 0) {
            return;
        }

        if(currentSelectedGamepadContract < 0) {
            currentSelectedGamepadContract = totalContracts.length - 1;
        }

        if(currentSelectedGamepadContract >= totalContracts.length) {
            currentSelectedGamepadContract = 0;
        }


        var topLine = totalContracts[0].getBoundingClientRect().top;

        for(var i = 0; i < totalContracts.length; i++) {


            if(totalContracts[i].getBoundingClientRect().top == topLine) {
                gamepadContractsPerLine++;
            }


            if(i == currentSelectedGamepadContract) {
                totalContracts[i].className = totalContracts[i].defaultClass + " gabBTContractItemSelectedGamepad";
                totalContracts[i].scrollIntoView();
            } else {
                totalContracts[i].className = totalContracts[i].defaultClass;
            }

        }

    }


    function showOnlineResources(method) {

        var data = [];

        var callback = onBuyResource;

        if(method == "sell") {
            callback = onSellResource;
        }

        if(method == "send") {
            callback = onSendResource;
        }

        if(method == "request") {
            callback = onRequestResource;
        }

        if(method == "offers") {
            callback = onSeeOffers;
        }

        if(method == "newoffer") {
            callback = onOfferResource;
        }

        if(method == "setprices") {
            callback = setGameResourcePrices;
        }
        
        postSecuredCallToApi(data,9,callback);
    }

    function onOfferResource(result) {
        setGameResourcePrices(result);
        showTradeListing(result,"newoffer");
    }

    function onSeeOffers(result) {
        setGameResourcePrices(result);
        showTradeListing(result,"offers");
    }

    function onRequestResource(result) {
        setGameResourcePrices(result);
        showTradeListing(result,"request");
    }

    function onBuyResource(result) {
        setGameResourcePrices(result);
        showTradeListing(result,"buy");
    }

    function onSellResource(result) {
        setGameResourcePrices(result);
        showTradeListing(result,"sell");
    }

    function onSendResource(result) {
        setGameResourcePrices(result);
        showTradeListing(result,"send");
    }

    function setGameResourcePrices(result) {

        if(currentGame == null) {
            return;
        }

        var roc = getRegionOrCity();

        var resources;

        if(result != null && result.trim().length > 0) {
            try {
                resources = JSON.parse(result);
            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": setGameResourcePrices",ex.message);
                return;
            }
        }

        if(resources == null || resources.resources == null) {
            return;
        }


        if(!gbtOpen && roc.tradeNotifications) {
            addGbtPricesToTicker(resources);
        }

        updateResourcePrices(resources);
    }

    function showTradeListing(result,method) {
        var resources;

        if(result != null && result.trim().length > 0) {
            try {
                resources = JSON.parse(result);
            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": showTradeListing",ex.message);
                return;
            }
        }

        if(resources == null) {
            return;
        }

        var menuOptions = [];

        if(method == "send" || method == "request") {
            menuOptions.push({
                "title": ColonyGame.meta.tenderResource,
                "title-color": null,
                "description": null,
                "status": "You Have: " + numberWithCommas(getGameResources()[ColonyGame.meta.tenderResource].amount),
                "status-color": null,
                "icon": "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon,
                "tag": "money"
            });
        }

        for(var i = 0; i < resources.resources.length; i++) {

            if(method == "send") {
                if(getGameResources()[resources.resources[i].name].amount == 0) {
                    continue;
                }
            }

            if(resources.resources[i].price == 0) {
                resources.resources[i].price = getGameResources()[resources.resources[i].name].price;
            }

            var status = "Last Price: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(resources.resources[i].price) + " per 100";
            var statusColor = null;

            if(method == "send" || method == "request") {
                status = "You Have: " + numberWithCommas(getGameResources()[resources.resources[i].name].amount);
            }

            menuOptions.push({
                "title": resources.resources[i].name,
                "title-color": null,
                "description": null,
                "status": status,
                "status-color": statusColor,
                "icon": "images/" + getResourceByDefName(resources.resources[i].name).icon,
                "tag": resources.resources[i]
            });
        }

        var callback = onBuySelectedResourceType;

        if(method == "sell") {
            callback = doResourceContract;
        }

        if(method == "newoffer") {
            callback = doOfferContract;
        }

        if(method == "send") {
            callback = onSendResourceType;
        }

        if(method == "request") {
            callback = onRequestResourceType;
        }

        showList(getString("select-resource"),menuOptions,callback,getString("general-nevermind"));
    }

    var pendingTradeResource = null;

    function tmpSaveResources() {

        if(getRegionOrCity().colonyId != 0) {
            var resHold = JSON.stringify(getGameResources());
            webAppCore.storeVar("pnd-trns-" + getRegionOrCity().colonyId + "-sve",resHold);
        }
    }
    
    function onOffersSelectedResourceType(resource) {
        pendingTradeResource = resource;

        var data = [];

        data.push({
            "key":      "r",
            "value":    pendingTradeResource.id
        });

        postSecuredCallToApi(data,22,showResourcesOnOffer);
    }

    function onBuySelectedResourceType(resource) {
        pendingTradeResource = resource;

        var data = [];

        data.push({
            "key":      "r",
            "value":    pendingTradeResource.id
        });

        postSecuredCallToApi(data,10,showResourcesForSale);
    }

    function showResourcesOnOffer(result) {

        if(currentGame == null) {
            return;
        }

        var resources;

        if(result != null && result.trim().length > 0) {
            try {
                resources = JSON.parse(result);
            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": showResourcesOnOffer",ex.message);
                webAppCore.showToast(getString("no-contracts"));
                return;
            }
        }

        if(resources == null || pendingTradeResource == null) {
            webAppCore.showToast(getString("no-contracts"));
            return;
        }

        if(resources.contracts.length == 0) {
            webAppCore.showToast(getString("no-contracts"));
            return;
        }

        var menuOptions = [];

        for(var i = 0; i < resources.contracts.length; i++) {
            var contract = resources.contracts[i];

            var unitPrice = parseInt(contract.price) / parseInt(contract.quantity);
            var hundredPrice = Math.round(unitPrice * 100);

            var priceColor = null;

            if(contract.quantity > getGameResources()[pendingTradeResource.name].amount) {
                priceColor = "#F44336";
            }

            menuOptions.push({
                "title": getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(parseInt(contract.price)),
                "title-color": null,
                "description": "Per 100: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(hundredPrice),
                "status": null,
                "status-color": null,
                "overflow": [
                    {
                        "pre":      "Total Price:",
                        "post":     numberWithCommas(parseInt(contract.quantity)),
                        "color":    priceColor,
                        "icon":     "images/" + getResourceByDefName(pendingTradeResource.name).icon
                    }
                ],
                "icon": "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon,
                "tag": contract
            });
        }

        showList(getString("available-contracts"),menuOptions,purchaseOffer,getString("general-nevermind"));
    }

    function showResourcesForSale(result) {
        var resources;

        if(result != null && result.trim().length > 0) {
            try {
                resources = JSON.parse(result);
            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": showResourcesForSale",ex.message);
                webAppCore.showToast(getString("no-contracts"));
                return;
            }
        }

        if(resources == null || pendingTradeResource == null) {
            webAppCore.showToast(getString("no-contracts"));
            return;
        }

        if(resources.contracts.length == 0) {
            webAppCore.showToast(getString("no-contracts"));
            return;
        }

        var menuOptions = [];

        for(var i = 0; i < resources.contracts.length; i++) {
            var contract = resources.contracts[i];

            var unitPrice = parseInt(contract.price) / parseInt(contract.quantity);
            var hundredPrice = Math.round(unitPrice * 100);

            var priceColor = null;

            if(contract.price > getGameResources()[ColonyGame.meta.tenderResource].amount) {
                priceColor = "#F44336";
            }

            menuOptions.push({
                "title": numberWithCommas(parseInt(contract.quantity)) + " " + pendingTradeResource.name,
                "title-color": null,
                "description": "Per 100: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(hundredPrice),
                "status": "Total Price: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(parseInt(contract.price)),
                "status-color": priceColor,
                "icon": "images/" + getResourceByDefName(pendingTradeResource.name).icon,
                "tag": contract
            });
        }

        showList(getString("available-contracts"),menuOptions,purchaseContract,getString("general-nevermind"));
    }

    var pendingContract = null;

    function purchaseOffer(contract) {
        if(contract.quantity > getGameResources()[pendingTradeResource.name].amount) {
            webAppCore.showToast("Insufficient " + pendingTradeResource.name + "!");
            return;
        }

        pendingContract = contract;

        var data = [];

        data.push({
            "key":      "a",
            "value":    pendingContract.id
        });

        data.push({
            "key":      "c",
            "value":    "1"
        });

        postSecuredCallToApi(data,41,onOfferPurchaseResult);
    }

    var pendingBadDealCard = null;

    function showBadDealAlert(tradeCard) {
        pendingBadDealCard = tradeCard;

        if(currentGame == null) {
            return;
        }

        webAppCore.showDialog({
            "title":    getString("general-bad-trade-header"),
            "message":  getString("general-bad-trade-notice"),
            "op1": {
                "text":     getString("general-yes"),
                "func":     continueWithStupidTrade
            },
            "op2": {
                "text":     getString("general-no"),
                "func":     placeholder
            }
        });
    }

    function continueWithStupidTrade() {
        if(pendingBadDealCard == null) {
            return;
        }

        //var disapproval = randomIntFromInterval(0,3);
        //doGlobalMoodModification(-disapproval);

        purchaseNewGBTContract(pendingBadDealCard);

        pendingBadDealCard = null;
    }

    var tickerTradeConfirmation = false;

    function tickerTradeConfirmGo() {
        purchaseNewGBTContract(pendingContract);
    }

    function purchaseNewGBTContract(tradeCard) {
        if(currentGame == null) {
            return;
        }

        var maxTradeSize = serverMaxTradeSize;
        
        if(maxTradeSize > getGiftCapacity()) {
            maxTradeSize = getGiftCapacity();
        }

        if(contractPostTimeout > 0) {
            if(!tradeCard.silentTrade) {
                webAppCore.showAlertWithTitle(getString("general-trade-too-recent"),getString("general-trade-authority"));
            }
            return;
        }
        

        pendingTradeResource = getResourceByServerId(tradeCard.contractRef.resourceid);

        if(!pendingTradeResource) {
            return;
        }

        if(tradeCard.contractRef.sellerid == getRegionOrCity().colonyId) {
            if(!tradeCard.silentTrade) {
                webAppCore.showToast("You cannot purchase your own contract.");
            }
            
            return;
        }

        if(parseInt(tradeCard.contractRef.quantity) > maxTradeSize) {
            return;
        }

        if(tradeCard.contractRef.isoffer == "1") {
            if(parseInt(tradeCard.contractRef.quantity) > getGameResources()[pendingTradeResource.name].amount) {
                if(!tradeCard.silentTrade) {
                    webAppCore.showToast("You do not have enough " + pendingTradeResource.name + " to fill this contract.");
                }
                return;
            }
        } else {
            if(parseInt(tradeCard.contractRef.price) > getGameResources()[ColonyGame.meta.tenderResource].amount) {
                if(!tradeCard.silentTrade) {
                    webAppCore.showToast("You do not have enough " + ColonyGame.meta.tenderResource + " to buy this contract.");
                }
                return;
            }

            if(!isThereResourceCapacity(pendingTradeResource.name,parseInt(tradeCard.contractRef.quantity))) {
                if(!tradeCard.silentTrade) {
                    webAppCore.showAlertWithTitle("You do not have enough storage to buy this contract.","Storage Full");
                }
                return;
            }
        }


        pendingContract = tradeCard;

        if(pendingContract.fromTicker && !tickerTradeConfirmation) {
            var hasConfirmedOption = webAppCore.getVar("knows-about-ticker-trades","0");

            if(hasConfirmedOption == "1") {
                tickerTradeConfirmation = true;
            } else {
                webAppCore.storeVar("knows-about-ticker-trades","1");

                webAppCore.showDialog({
                    "title":    getString("general-ticker-warn-head"),
                    "message":  getString("general-ticker-warn-info"),
                    "op1": {
                        "text":     getString("general-trade"),
                        "func":     tickerTradeConfirmGo
                    },
                    "op2": {
                        "text":     getString("general-cancel"),
                        "func":     placeholder
                    }
                });

                return;
            }
        }

        isASilentContractBuy = false;

        if(tradeCard.silentTrade) {
            isASilentContractBuy = true;
        }



        var data = [];

        data.push({
            "key":      "a",
            "value":    pendingContract.contractRef.id
        });

        data.push({
            "key":      "c",
            "value":    pendingContract.contractRef.isoffer
        });

        postSecuredCallToApi(data,41,onNewGBTContractPurchase);
    }

    var isASilentContractBuy = false;

    function onNewGBTContractPurchase(result) {

        if(!pendingContract.fromTicker && pendingContract.style) {
            pendingContract.style.display = "none";
        }

        if(result == null || result.trim().length == 0) {
            if(!isASilentContractBuy) {
                webAppCore.showToast("This contract is no longer available.");

                if(!pendingContract.fromTicker) {
                    populateNewGbtResources(pendingTradeResource);
                }
            }
            
            return;
        }

        try {
            JSON.parse(result);
        } catch(ex) {
            webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onNewGBTContractPurchase",ex.message);
            return;
        }

        contractPostTimeout = 20;

        if(pendingContract.contractRef.isoffer == "1") {
            modifyResourceAmount(pendingTradeResource.name,-(parseInt(pendingContract.contractRef.quantity)),false,"Trade");
            modifyResourceAmount(ColonyGame.meta.tenderResource,parseInt(pendingContract.contractRef.price),false,"Trade");
        } else {
            modifyResourceAmount(pendingTradeResource.name,parseInt(pendingContract.contractRef.quantity),false,"Trade");
            modifyResourceAmount(ColonyGame.meta.tenderResource,-(parseInt(pendingContract.contractRef.price)),false,"Trade");
        }

        webAppCore.showToast("Contract Purchased.");

        if(ColonyGame.sounds.contractBuy) {
            playInterfaceSoundEffect(ColonyGame.sounds.contractBuy);
        }

        if(!currentGame.cm) {
            if(ColonyGame.achievements.onlineTrade > 0) {
                webAppCore.reportAchievement(ColonyGame.achievements.onlineTrade);
            }

            checkDoKongStat("onlineTradeCounter",1);
        }



        checkMyContracts();
        tmpSaveResources();

    }

    function purchaseContract(contract) {

        if(currentGame == null) {
            return;
        }

        if(contract.price > getGameResources()[ColonyGame.meta.tenderResource].amount) {
            webAppCore.showToast("Insufficient Funds!");
            return;
        }

        pendingContract = contract;

        var data = [];

        data.push({
            "key":      "a",
            "value":    pendingContract.id
        });

        postSecuredCallToApi(data,41,onContractPurchaseResult);
    }

    function onOfferPurchaseResult(result) {

        if(result == null || result.trim().length == 0) {
            webAppCore.showToast("This contract is no longer available.");
            return;
        }

        try {
            JSON.parse(result);
        } catch(ex) {
            webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onOfferPurchaseResult",ex.message);
            return;
        }

        modifyResourceAmount(pendingTradeResource.name,-(parseInt(pendingContract.quantity)),false,"Trade");
        modifyResourceAmount(ColonyGame.meta.tenderResource,parseInt(pendingContract.price),false,"Trade");

        webAppCore.showToast("Contract Purchased.");

        if(!currentGame.cm) {
            if(ColonyGame.achievements.onlineTrade > 0) {
                webAppCore.reportAchievement(ColonyGame.achievements.onlineTrade);
            }

            checkDoKongStat("onlineTradeCounter",1);
        }

        checkMyContracts();
        
        onOffersSelectedResourceType(pendingTradeResource);

        tmpSaveResources();
    }

    function onContractPurchaseResult(result) {

        if(result == null || result.trim().length == 0) {
            webAppCore.showToast("This contract is no longer available.");
            return;
        }

        try {
            JSON.parse(result);
        } catch(ex) {
            webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onContractPurchaseResult",ex.message);
            return;
        }

        modifyResourceAmount(pendingTradeResource.name,parseInt(pendingContract.quantity),false,"Trade");
        modifyResourceAmount(ColonyGame.meta.tenderResource,-(parseInt(pendingContract.price)),false,"Trade");

        webAppCore.showToast("Contract Purchased.");

        if(currentGame.isSubregion && currentRegion && currentRegion.isMpRegionHolder && currentSubcityRef) {
        
            postToOnlineMetroArea({
                "type": "metro",
                "data": {
                    "type": "contractpurchase",
                    "res": [
                        {
                            res: ColonyGame.meta.tenderResource,
                            amt: getGameResources()[ColonyGame.meta.tenderResource].amount
                        },
                        {
                            res: pendingTradeResource.name,
                            amt: getGameResources()[pendingTradeResource.name].amount
                        }
                    ],
                    "id": currentGame.colonyId,
                    "charter": currentGame.charter,
                    "guid": currentSubcityRef.subcityGuid,
                    "name": currentGame.name
                }
            });
        }

        if(!currentGame.cm) {
            if(ColonyGame.achievements.onlineTrade > 0) {
                webAppCore.reportAchievement(ColonyGame.achievements.onlineTrade);
            }

            checkDoKongStat("onlineTradeCounter",1);
        }

        checkMyContracts();
        
        onBuySelectedResourceType(pendingTradeResource);

        tmpSaveResources();
    }

    function doResourceContract(resource) {
        onSellSelectedResourceType(resource,0);
    }

    function doOfferContract(resource) {
        onSellSelectedResourceType(resource,1);
    }

    var tmpAdditionalMax = 0;

    function onSellSelectedResourceType(resource,type,minPrice,maxPrice) {

        if(minPrice && minPrice < 10) {
            minPrice = 10;
        }

        tmpAdditionalMax = serverMaxTradeSize;

        if(type == 0) {
            document.getElementById("contractSubheading").innerHTML = getString("sell-amount");
        }

        if(type == 1) {
            document.getElementById("contractSubheading").innerHTML = getString("buy-amount");


            if(getGameResources()[resource.name].capacity == -1) {
                tmpAdditionalMax = getGameResources()[resource.name].storageCapacity - getGameResources()[resource.name].amount;

                if(tmpAdditionalMax < 100) {
                    tmpAdditionalMax = 100;
                }
            }
        }

        pendingTradeResource = resource;

        document.getElementById("resourceContractTransactionCost").innerHTML = "";
        document.getElementById("resourceContractTransactionCost").style.color = null;

        if(ColonyGame.meta.transactionCostResource != null) {
            var theTimes = parseInt(document.getElementById("resourceContractQuantity").value) / 10;

            if(theTimes < 100) {
                theTimes = 100;
            }

            document.getElementById("resourceContractTransactionCost").innerHTML = "Transaction Fee: " + numberWithCommas(theTimes) + " " + ColonyGame.meta.transactionCostResource;

            if(theTimes > getGameResources()[ColonyGame.meta.transactionCostResource].amount) {
                document.getElementById("resourceContractTransactionCost").style.color = "#F44336";
            } else {
                document.getElementById("resourceContractTransactionCost").style.color = null;
            }
        }

        document.getElementById("resourceContractMenu").style.display = "block";
        document.getElementById("multiplesNotice").style.color = "#ffffff";
        document.getElementById("resourceContractHeader").innerHTML = "New " + pendingTradeResource.name + " Contract";

        document.getElementById("resourceContractQuantity").onchange = function() {

            var maxTradeSize = serverMaxTradeSize;
            
            if(maxTradeSize > getGiftCapacity()) {
                maxTradeSize = getGiftCapacity();
            }


            if(maxTradeSize > tmpAdditionalMax) {
                maxTradeSize = tmpAdditionalMax;
            }
            

            var tradeQuantity = parseInt(document.getElementById("resourceContractQuantity").value);

            if(tradeQuantity < 100) {
                tradeQuantity = 100;
                document.getElementById("resourceContractQuantity").value = 100;
            }

            if(tradeQuantity > maxTradeSize) {
                tradeQuantity = maxTradeSize;
                document.getElementById("resourceContractQuantity").value = maxTradeSize;
            }

            var remainder = tradeQuantity % 100;
            if(remainder == 0) {
                document.getElementById("multiplesNotice").style.color = "#ffffff";


                var unitPrice = document.getElementById("resourceContractPrice").value / 100;
                var totalPrice = Math.round(unitPrice * tradeQuantity);

                if(ColonyGame.meta.transactionCostResource != null) {
                    var theTimes = tradeQuantity / 10;

                    if(theTimes < 100) {
                        theTimes = 100;
                    }

                    document.getElementById("resourceContractTransactionCost").innerHTML = "Transaction Fee: " + numberWithCommas(theTimes) + " " + ColonyGame.meta.transactionCostResource;

                    if(theTimes > getGameResources()[ColonyGame.meta.transactionCostResource].amount) {
                        document.getElementById("resourceContractTransactionCost").style.color = "#F44336";
                    } else {
                        document.getElementById("resourceContractTransactionCost").style.color = null;
                    }
                }

                document.getElementById("resourceContractPer100").innerHTML = "Total Price: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(totalPrice);

                
            } else {
                document.getElementById("multiplesNotice").style.color = "#F44336";
            }
        };
        
        document.getElementById("resourceContractPrice").onchange = function() {
            var unitPrice = document.getElementById("resourceContractPrice").value / 100;
            var totalPrice = Math.round(unitPrice * document.getElementById("resourceContractQuantity").value);

            

            document.getElementById("resourceContractPer100").innerHTML = "Total Price: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(totalPrice);
        };

        document.getElementById("btnResourceContractSumbit").onclick = function() {

            var ec;

            if(contractPostTimeout > 0) {
                
                webAppCore.showAlertWithTitle(getString("general-trade-too-recent"),getString("general-trade-authority"));

                return;
            }


            if(isNaN(document.getElementById("resourceContractPrice").value)) {
                return;
            }

            if(isNaN(document.getElementById("resourceContractQuantity").value)) {
                return;
            }

            var remainder = document.getElementById("resourceContractQuantity").value % 100;

            if(remainder != 0) {
                return;
            }

            if(document.getElementById("resourceContractPrice").value <= 0) {
                return;
            }

            if(document.getElementById("resourceContractQuantity").value <= 0) {
                return;
            }

            var maxTradeSize = serverMaxTradeSize;

            if(maxTradeSize > getGiftCapacity()) {
                maxTradeSize = getGiftCapacity();
            }

            var tradeQuantity = parseInt(document.getElementById("resourceContractQuantity").value);

            if(tradeQuantity < 1) {
                webAppCore.showToast("Invalid Trade!");
                return;
            }

            if(tradeQuantity > maxTradeSize) {
                var errorcode = getString("general-trade-too-big");
                errorcode = replaceAll(errorcode,"#maxlotsize",numberWithCommas(maxTradeSize));
                webAppCore.showAlertWithTitle(errorcode,getString("general-trade-authority"));
                return;
            }

            

            var lotPrice = parseInt(document.getElementById("resourceContractPrice").value);

            if(minPrice) {
                if(lotPrice < minPrice) {
                    ec = getString("general-trade-too-cheap");
                    ec = replaceAll(ec,"#minlotprice",numberWithCommas(minPrice));
                    webAppCore.showAlertWithTitle(ec,getString("general-trade-authority"));
                    return;
                }
            }

            if(maxPrice) {
                if(lotPrice > maxPrice) {
                    ec = getString("general-trade-too-expensive");
                    ec = replaceAll(ec,"#maxlotprice",numberWithCommas(maxPrice));
                    webAppCore.showAlertWithTitle(ec,getString("general-trade-authority"));
                    return;
                }
            }

            var unitPrice = lotPrice / 100;
            var totalPrice = Math.round(unitPrice * tradeQuantity);

            if(type == 0) {
                if(getGameResources()[pendingTradeResource.name].amount < tradeQuantity) {
                    webAppCore.showToast("Not enough resource!");
                    return;
                }
            } else {
                if(getGameResources()[ColonyGame.meta.tenderResource].amount < totalPrice) {
                    webAppCore.showToast("Not enough money!");
                    return;
                }
            }
            
            
            postTradeToGBT(pendingTradeResource.name,pendingTradeResource.id,tradeQuantity,totalPrice,type,false,onGBTTradePosted);
            

            document.getElementById("resourceContractMenu").style.display = "none";
            
            tmpSaveResources();

        };
        

        document.getElementById("btnResourceContractDismiss").onclick = function() {
            document.getElementById("resourceContractMenu").style.display = "none";
        };

        document.getElementById("resourceContractQuantity").value = 100;
        document.getElementById("resourceContractPrice").value = pendingTradeResource.price;

        document.getElementById("resourceContractPer100").innerHTML = "Total Price: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(pendingTradeResource.price);
    }

    function reverseBadTrade() {
        if(pendTradeTmpRevRes != null && pendTradeTmpRevAmn != null) {
            modifyResourceAmount(pendTradeTmpRevRes,-pendTradeTmpRevAmn,false,"Trade");
        }
    }

    var pendTradeTmpRevRes = null;
    var pendTradeTmpRevAmn = null;

    function onGBTTradePosted(result) {

        if(result != null && result.trim().length > 0) {
            try {
                var resultData = JSON.parse(result);

                var errorcode;

                if(resultData.result && resultData.result == "fail") {
                    if(resultData.reason && resultData.reason == "toobig") {
                        errorcode = getString("general-trade-too-big");
                        errorcode = replaceAll(errorcode,"#maxlotsize",numberWithCommas(parseInt(resultData.max)));
                        webAppCore.showAlertWithTitle(errorcode,getString("general-trade-authority"));
                        serverMaxTradeSize = parseInt(resultData.max);
                        reverseBadTrade();
                    }

                    if(resultData.reason && resultData.reason == "pricegouge") {
                        errorcode = getString("general-trade-gouging");
                        errorcode = replaceAll(errorcode,"#maxlotsize",numberWithCommas(parseInt(resultData.max)));
                        webAppCore.showAlertWithTitle(errorcode,getString("general-trade-authority"));
                        reverseBadTrade();
                    }

                    if(resultData.reason && resultData.reason == "undercut") {
                        errorcode = getString("general-trade-undercut");
                        errorcode = replaceAll(errorcode,"#maxlotsize",numberWithCommas(parseInt(resultData.max)));
                        webAppCore.showAlertWithTitle(errorcode,getString("general-trade-authority"));
                        reverseBadTrade();
                    }
                }


            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onGBTTradePosted",ex.message);
                return;
            }
        }

        pendTradeTmpRevRes = null;
        pendTradeTmpRevAmn = null;

        populateNewGbtResources(pendingTradeResource);
        checkMyContracts();
    }

    function checkMyContracts() {

        if(currentGame == null || !getRegionOrCity().colonyId || getRegionOrCity().colonyId == 0) {
            return;
        }

        var data = [];

        postSecuredCallToApi(data,14,onContractReturn);
    }

    function onContractReturn(result) {

        if(currentGame == null) {
            return;
        }

        var contracts;
       

        if(result != null && result.trim().length > 0) {
            try {
                contracts = JSON.parse(result);
            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onContractReturn",ex.message);
                return;
            }
        }

        if(!contracts || !contracts.contracts) {
            return;
        }

        if(!getRegionOrCity().gifts) {
            getRegionOrCity().gifts = [];
        }
        

        parseContractData(contracts.contracts);
    }

    function parseContractData(contracts) {

        var rOrC = getRegionOrCity();

        for(var i = 0; i < contracts.length; i++) {
            var contract = contracts[i];

            if(contract.type == 0) {
                if(contract.sold == "1") {
                    rOrC.gifts.push(new Gift("Sold Contract","Your " + contract.resource + " contract sold!",ColonyGame.meta.tenderResource,parseInt(contract.price),true));
                } else {
                    rOrC.gifts.push(new Gift("Expired Contract","Your " + contract.resource + " contract did not sell.",contract.resource,parseInt(contract.quantity)));
                }
            }

            if(contract.type == 1) {
                if(contract.sold == "1") {
                    rOrC.gifts.push(new Gift("Sold Offer","Your " + contract.resource + " offer sold!",contract.resource,parseInt(contract.quantity),true));
                } else {
                    rOrC.gifts.push(new Gift("Expired Offer","Your " + contract.resource + " offer did not sell.",ColonyGame.meta.tenderResource,parseInt(contract.price)));
                }
            }
        }

        if(rOrC.gifts.length > 0) {
            webAppCore.showToast("New gifts available!");
            document.getElementById("imGift").style.display = "inline-block";
        }
    }

    var aboutVersionData = null;

    function fetchLatestAboutAppInfo() {
        webAppCore.getForResult("https://market.ape-apps.com/app_resources/get-app-info.php?app=" + ColonyGame.meta.apeMarketId,[],onAboutDataBack);
    }

    function onAboutDataBack(data) {
        if(data && data.trim().length > 0) {
            try {
                aboutVersionData = JSON.parse(data);
                webAppCore.storeVar("ver-" + ColonyGame.meta.releaseCode + "-about-info",data);
            } catch(ex) {
                webAppCore.storeVar("ver-" + ColonyGame.meta.releaseCode + "-about-info","0");
                aboutVersionData = null;
            }
        } else {
            webAppCore.storeVar("ver-" + ColonyGame.meta.releaseCode + "-about-info","0");
            aboutVersionData = null;
        }
    }

    function playVideoTutorial(tag) {
        if(!tag.author || !tag.title || !tag.url) {
            return;
        }

        var mainSection = document.getElementById("encyclopediaMainSection");
        
        mainSection.style.display = "none";
        document.getElementById("encyclopediaSubSection").style.display = "none";
        document.getElementById("encyclopediaOwnersManual").style.display = "none";
        document.getElementById("encyclopediaVideoPlayer").style.display = "block";

        document.getElementById("encyclopediaVideoPlayerTitle").innerHTML = tag.title;

        if(webAppCore.isTV()) {
            document.getElementById("encyclopediaVideoPlayerVidHolderFrame").src = "https://www.youtube.com/embed/" + tag.url + "?autoplay=1";
        } else {
            document.getElementById("encyclopediaVideoPlayerVidHolderFrame").src = "https://www.youtube.com/embed/" + tag.url;
        }

        var vidlink = "https://www.youtube.com/watch?v=" + tag.url;

        

        if(webAppCore.isTV()) {
            document.getElementById("encyclopediaVideoPlayerLink").innerHTML = "";
        } else {
            document.getElementById("encyclopediaVideoPlayerLink").innerHTML = vidlink;
            document.getElementById("encyclopediaVideoPlayerLink").onclick = function() {
                closeStatsMenu();
                webAppCore.externalURL(vidlink);
            };
        }
        
    }

    function loadEncyclopediaArticleLoader() {
        loadEncyclopediaArticle(this.sectionref,this.articleref);
    }

    function loadEncyclopediaArticle(section,article) {

        document.getElementById("encyclopediaSubSectionLinks").innerHTML = "";
        document.getElementById("encyclopediaSubSectionHeader").innerHTML = article;
        document.getElementById("encyclopediaSubSectionDescription").innerHTML = "";
        document.getElementById("encyclopediaSubSectionImage").style.display = "none";
        document.getElementById("encyclopediaSubSectionImage").style.backgroundImage = null;
        document.getElementById("encyclopediaSubSectionRefbackLink").style.display = "block";
        document.getElementById("encyclopediaSubSectionBullets").innerHTML = "";

        var articleContent = "";
        var articleBullets = [];
        var i,j,k;
        var sublist;

        if(section == "civilizations") {
            var civ = getCivilizationByName(article);

            articleContent += getString(civ.description);

            if(civ.backstory) {
                articleContent += "<br /><br />" + replaceAll(getString(civ.backstory),"\n","<br />");
            }

            if(civ.icon) {
                document.getElementById("encyclopediaSubSectionImage").style.display = null;
                document.getElementById("encyclopediaSubSectionImage").style.backgroundImage = "url('images/" + civ.icon + "')";
                document.getElementById("encyclopediaSubSectionImage").style.backgroundPosition = "center";
                document.getElementById("encyclopediaSubSectionImage").style.backgroundSize = "cover";
            }

            if(civ.startingBuilding) {
                articleBullets.push(new EncyclopediaBulletItem(getString("general-starting-building"),null,[
                    new EncyclopediaBulletItemLink("buildings",civ.startingBuilding)
                ],null));
            }

            if(civ.startingVehicles && civ.startingVehicles.length > 0) {
                sublist = [];

                for(i = 0; i < civ.startingVehicles.length; i++) {
                    sublist.push(new EncyclopediaBulletItemLink("vehicles",civ.startingVehicles[i]));
                }

                articleBullets.push(new EncyclopediaBulletItem("Starting Units",null,sublist,null));
            }

            if(civ.startingTechs && civ.startingTechs.length > 0) {
                sublist = [];

                for(i = 0; i < civ.startingTechs.length; i++) {
                    sublist.push(new EncyclopediaBulletItemLink("techs",civ.startingTechs[i]));
                }

                articleBullets.push(new EncyclopediaBulletItem(getString("general-starting-techs"),null,sublist,null));
            }

            if(civ.availableMaps && civ.availableMaps.length > 0) {
                sublist = [];

                for(i = 0; i < civ.availableMaps.length; i++) {
                    sublist.push(new EncyclopediaBulletItemLink("maps",civ.availableMaps[i]));
                }

                articleBullets.push(new EncyclopediaBulletItem(getString("general-maps-available"),null,sublist,null));
            }

            if(civ.startingResourceModifiers && civ.startingResourceModifiers.length > 0) {
                sublist = [];

                for(i = 0; i < civ.startingResourceModifiers.length; i++) {
                    sublist.push(new EncyclopediaBulletItemLink("resources",civ.startingResourceModifiers[i].name,civ.startingResourceModifiers[i].modifier));
                }

                articleBullets.push(new EncyclopediaBulletItem("Resource Bonuses",null,sublist,null));
            }

            document.getElementById("encyclopediaSubSectionRefbackLink").innerHTML = "&lt;- " + getString("general-civs");
            document.getElementById("encyclopediaSubSectionRefbackLink").onclick = function() {
                showEncyclopediaSubsection("civilizations");
            };
        }

        if(section == "maps") {
            var map = getPlanetDefByName(article);

            articleContent += getString(map.description);

            if(map.icon) {
                document.getElementById("encyclopediaSubSectionImage").style.display = null;
                document.getElementById("encyclopediaSubSectionImage").style.backgroundImage = "url('images/" + map.icon + "')";
                document.getElementById("encyclopediaSubSectionImage").style.backgroundPosition = "center";
                document.getElementById("encyclopediaSubSectionImage").style.backgroundSize = "cover";
            }

            if(map.difficulty) {
                articleBullets.push(new EncyclopediaBulletItem("Difficulty",map.difficulty,null,null));
            }

            if(map.startingTechs && map.startingTechs.length > 0) {
                sublist = [];

                for(i = 0; i < map.startingTechs.length; i++) {
                    sublist.push(new EncyclopediaBulletItemLink("techs",map.startingTechs[i]));
                }

                articleBullets.push(new EncyclopediaBulletItem(getString("general-starting-techs"),null,sublist,null));
            }

            if(map.startingResourceModifiers && map.startingResourceModifiers.length > 0) {
                sublist = [];

                for(i = 0; i < map.startingResourceModifiers.length; i++) {
                    sublist.push(new EncyclopediaBulletItemLink("resources",map.startingResourceModifiers[i].name,map.startingResourceModifiers[i].modifier));
                }

                articleBullets.push(new EncyclopediaBulletItem("Resource Bonuses",null,sublist,null));
            }

            if(map.startingBuildings && map.startingBuildings.length > 0) {
                sublist = [];

                for(i = 0; i < map.startingBuildings.length; i++) {
                    sublist.push(new EncyclopediaBulletItemLink("buildings",map.startingBuildings[i]));
                }

                articleBullets.push(new EncyclopediaBulletItem(getString("general-starting-building"),null,sublist,null));
            }

            if(map.terrainFeatures && map.terrainFeatures.length > 0) {
                sublist = [];

                for(i = 0; i < map.terrainFeatures.length; i++) {
                    sublist.push(new EncyclopediaBulletItemLink("terrains",map.terrainFeatures[i].name,map.terrainFeatures[i].abundance));
                }

                articleBullets.push(new EncyclopediaBulletItem("Terrain Features",null,sublist,null));
            }

            if(map.riverTile) {
                articleBullets.push(new EncyclopediaBulletItem("River",null,[
                    new EncyclopediaBulletItemLink("terrains",map.riverTile)
                ],null));
            }

            document.getElementById("encyclopediaSubSectionRefbackLink").innerHTML = "&lt;- " + getString("gen-map-types");
            document.getElementById("encyclopediaSubSectionRefbackLink").onclick = function() {
                showEncyclopediaSubsection("maps");
            };
        }

        if(section == "resources") {
            var res = getResourceByDefName(article);

            if(res.icon) {
                document.getElementById("encyclopediaSubSectionImage").style.display = null;
                document.getElementById("encyclopediaSubSectionImage").style.backgroundImage = "url('images/" + res.icon + "')";
                document.getElementById("encyclopediaSubSectionImage").style.backgroundPosition = "center";
                document.getElementById("encyclopediaSubSectionImage").style.backgroundSize = "cover";
            }

            if(res.indicator) {
                articleBullets.push(new EncyclopediaBulletItem("Indicator",res.indicator,null,null));
            }

            if(res.starting && res.starting > 0) {
                articleBullets.push(new EncyclopediaBulletItem("Starting Amount",numberWithCommas(res.starting),null,null));
            }

            if(res.basePrice && res.basePrice > 0) {
                articleBullets.push(new EncyclopediaBulletItem("Base Price $",numberWithCommas(res.basePrice),null,null));
            }

            if(res.toxicRate && res.toxicRate > 0) {
                articleBullets.push(new EncyclopediaBulletItem("Toxic Level",numberWithCommas(res.toxicRate),null,null));
            }

            if(!res.canGift) {
                articleBullets.push(new EncyclopediaBulletItem(null,"* Can not be gifted *",null,null));
            }

            sublist = [];

            for(j = 0; j < ColonyGame.terrains.length; j++) {
                if(ColonyGame.terrains[j].provides == res.name) {
                    sublist.push(new EncyclopediaBulletItemLink("terrains",ColonyGame.terrains[j].name));
                }
            }

            for(j = 0; j < ColonyGame.buildings.length; j++) {

                if(ColonyGame.buildings[j].generates == res.name) {
                    sublist.push(new EncyclopediaBulletItemLink("buildings",ColonyGame.buildings[j].name));
                } else {
                    if(ColonyGame.buildings[j].smelts && ColonyGame.buildings[j].smelts.output && ColonyGame.buildings[j].smelts.output.indexOf(res.name) > -1) {
                        sublist.push(new EncyclopediaBulletItemLink("buildings",ColonyGame.buildings[j].name));
                    }
                }
            }

            if(sublist.length > 0) {
                articleBullets.push(new EncyclopediaBulletItem("Comes From",null,sublist,null));
            }

            document.getElementById("encyclopediaSubSectionRefbackLink").innerHTML = "&lt;- " + getString("resources-header");
            document.getElementById("encyclopediaSubSectionRefbackLink").onclick = function() {
                showEncyclopediaSubsection("resources");
            };
        }


        if(section == "techs") {
            var tech = null;

            for(i = 0; i < ColonyGame.technology.length; i++) {

                if(ColonyGame.technology[i].name == article) {
                    tech = ColonyGame.technology[i];
                    break;
                }
            }

            if(!tech) {
                return;
            }

            articleContent += getString(tech.description);

            if(tech.icon) {
                document.getElementById("encyclopediaSubSectionImage").style.display = null;
                document.getElementById("encyclopediaSubSectionImage").style.backgroundImage = "url('images/" + tech.icon + "')";
                document.getElementById("encyclopediaSubSectionImage").style.backgroundPosition = "center";
                document.getElementById("encyclopediaSubSectionImage").style.backgroundSize = "cover";
            }

            if(tech.requiresStage && tech.requiresStage > 0 && tech.requiresStage != 99) {
                articleBullets.push(new EncyclopediaBulletItem("Stage Requirement",tech.requiresStage,null,null));
            }

            if(tech.cost && tech.cost.length > 0) {
                sublist = [];

                for(i = 0; i < tech.cost.length; i++) {
                    sublist.push(new EncyclopediaBulletItemLink("resources",tech.cost[i].resource,tech.cost[i].amount));
                }

                articleBullets.push(new EncyclopediaBulletItem("Cost",null,sublist,null));
            }

            if(tech.requiresTech && tech.requiresTech.length > 0) {
                sublist = [];

                for(i = 0; i < tech.requiresTech.length; i++) {
                    sublist.push(new EncyclopediaBulletItemLink("techs",tech.requiresTech[i]));
                }

                articleBullets.push(new EncyclopediaBulletItem("Tech Requirement",null,sublist,null));
            }


            sublist = [];

            for(j = 0; j < ColonyGame.buildings.length; j++) {
                var bTechs = ColonyGame.buildings[j].requiresTech;

                if(!bTechs) {
                    continue;
                }

                for(k = 0; k < bTechs.length; k++) {
                    if(bTechs[k].indexOf(article) > -1) {
                        sublist.push(new EncyclopediaBulletItemLink("buildings",ColonyGame.buildings[j].name));
                    }
                }
            }

            for(j = 0; j < ColonyGame.vehicles.length; j++) {
                var vTechs = ColonyGame.vehicles[j].requiresTech;

                if(!vTechs) {
                    continue;
                }

                for(k = 0; k < vTechs.length; k++) {
                    if(vTechs[k].indexOf(article) > -1) {
                        sublist.push(new EncyclopediaBulletItemLink("vehicles",ColonyGame.vehicles[j].name));
                    }
                }
            }

            for(j = 0; j < ColonyGame.technology.length; j++) {
                var tTechs = ColonyGame.technology[j].requiresTech;

                if(!tTechs) {
                    continue;
                }

                for(k = 0; k < tTechs.length; k++) {
                    if(tTechs[k].indexOf(article) > -1) {
                        sublist.push(new EncyclopediaBulletItemLink("techs",ColonyGame.technology[j].name));
                    }
                }
            }

            if(sublist.length > 0) {
                articleBullets.push(new EncyclopediaBulletItem("Needed By",null,sublist,null));
            }

            if(tech.reqIndependence) {
                articleBullets.push(new EncyclopediaBulletItem(null,"* Requires Independence *",null,null));
            }

            document.getElementById("encyclopediaSubSectionRefbackLink").innerHTML = "&lt;- " + getString("enc-tech-header");
            document.getElementById("encyclopediaSubSectionRefbackLink").onclick = function() {
                showEncyclopediaSubsection("techs");
            };
        }

        

        if(section == "buildings") {

            var bld = getBuildingDefByName(article);

            articleContent += getString(bld.description);

            if(bld.indicator) {
                document.getElementById("encyclopediaSubSectionImage").style.display = null;
                document.getElementById("encyclopediaSubSectionImage").style.backgroundImage = "url('images/" + bld.indicator + "')";
                document.getElementById("encyclopediaSubSectionImage").style.backgroundPosition = "center";
                document.getElementById("encyclopediaSubSectionImage").style.backgroundSize = "contain";
            } else {
                if(bld.tile) {
                    var bTile = bld.tile[0];
                    var bImg = getImageAsset(bTile,false,0);

                    if(bImg) {
                        document.getElementById("encyclopediaSubSectionImage").style.display = null;
                        document.getElementById("encyclopediaSubSectionImage").style.backgroundImage = "url('" + bImg.src + "')";
                        document.getElementById("encyclopediaSubSectionImage").style.backgroundPosition = "center";
                        document.getElementById("encyclopediaSubSectionImage").style.backgroundSize = "contain";
                    } else {
                        setTimeout(function(){
                            loadEncyclopediaArticle(section,article);
                        },500);
                    }
                }
            }

            if(bld.requiresStage && bld.requiresStage > 0 && bld.requiresStage != 99) {
                articleBullets.push(new EncyclopediaBulletItem("Stage Requirement",bld.requiresStage,null,null));
            }

            if(bld.cost && bld.cost.length > 0) {
                sublist = [];

                for(i = 0; i < bld.cost.length; i++) {
                    sublist.push(new EncyclopediaBulletItemLink("resources",bld.cost[i].resource,bld.cost[i].amount));
                }

                articleBullets.push(new EncyclopediaBulletItem("Cost",null,sublist,null));
            }

            if(bld.requiresTech && bld.requiresTech.length > 0) {
                sublist = [];

                for(i = 0; i < bld.requiresTech.length; i++) {

                    sublist.push(new EncyclopediaBulletItemLink("techs",bld.requiresTech[i]));
                }

                articleBullets.push(new EncyclopediaBulletItem("Tech Requirement",null,sublist,null));
            }

            if(bld.requiresUtility && bld.requiresUtility.length > 0) {
                sublist = [];

                for(i = 0; i < bld.requiresUtility.length; i++) {

                    sublist.push(new EncyclopediaBulletItemLink(null,bld.requiresUtility[i].utility,bld.requiresUtility[i].amount));
                }

                articleBullets.push(new EncyclopediaBulletItem("Requires",null,sublist,null));
            }

            if(bld.providesUtility && bld.providesUtility.length > 0) {
                sublist = [];

                for(i = 0; i < bld.providesUtility.length; i++) {

                    sublist.push(new EncyclopediaBulletItemLink(null,bld.providesUtility[i].utility,bld.providesUtility[i].amount));
                }

                articleBullets.push(new EncyclopediaBulletItem("Provides",null,sublist,null));
            }

            sublist = [];

            for(j = 0; j < ColonyGame.vehicles.length; j++) {
                if(ColonyGame.vehicles[j].produces != null && ColonyGame.vehicles[j].produces.indexOf(bld.name) > -1) {
                    sublist.push(new EncyclopediaBulletItemLink("vehicles",ColonyGame.vehicles[j].name));
                }
            }

            if(sublist.length > 0) {
                articleBullets.push(new EncyclopediaBulletItem("Built By",null,sublist,null));
            }


            if(bld.produces && bld.produces.length > 0) {
                sublist = [];

                for(i = 0; i < bld.produces.length; i++) {

                    sublist.push(new EncyclopediaBulletItemLink("vehicles",bld.produces[i]));
                }

                articleBullets.push(new EncyclopediaBulletItem("Can Build",null,sublist,null));
            }


            if(bld.stores && bld.stores.length > 0) {
                sublist = [];

                for(i = 0; i < bld.stores.length; i++) {

                    sublist.push(new EncyclopediaBulletItemLink("resources",bld.stores[i].resource,bld.stores[i].amount));
                }

                articleBullets.push(new EncyclopediaBulletItem("Stores",null,sublist,null));
            }

            document.getElementById("encyclopediaSubSectionRefbackLink").innerHTML = "&lt;- " + getString("general-buildings");
            document.getElementById("encyclopediaSubSectionRefbackLink").onclick = function() {
                showEncyclopediaSubsection("buildings");
            };

            if(bld.refines && bld.refines.length > 0) {
                sublist = [];

                for(i = 0; i < bld.refines.length; i++) {

                    sublist.push(new EncyclopediaBulletItemLink("resources",bld.refines[i].input));
                }

                articleBullets.push(new EncyclopediaBulletItem("Harvest Drop Off For",null,sublist,null));
            }

            if(bld.acceptsWorkers && bld.acceptsWorkers > 0) {
                articleBullets.push(new EncyclopediaBulletItem("Workers",numberWithCommas(bld.acceptsWorkers),null,null));
            }

            if(bld.requiresIQ && bld.requiresIQ > 0) {
                articleBullets.push(new EncyclopediaBulletItem("Requires IQ",numberWithCommas(bld.requiresIQ),null,null));
            }

            if(bld.occupation) {
                articleBullets.push(new EncyclopediaBulletItem("Job Occupation",bld.occupation,null,null));
            }

            if(bld.providesShelter && bld.providesShelter > 0) {
                articleBullets.push(new EncyclopediaBulletItem("Residents",numberWithCommas(bld.providesShelter),null,null));
            }

            if(bld.heals && bld.heals > 0) {
                articleBullets.push(new EncyclopediaBulletItem("Heals",numberWithCommas(bld.heals),null,null));
            }

            if(bld.entertains && bld.entertains > 0) {
                articleBullets.push(new EncyclopediaBulletItem("Guests",numberWithCommas(bld.entertains),null,null));
            }

            if(bld.takesTourists && bld.takesTourists > 0) {
                articleBullets.push(new EncyclopediaBulletItem("Tourists",numberWithCommas(bld.takesTourists),null,null));
            }

            if(bld.entertainmentCost && bld.entertainmentCost > 0) {
                articleBullets.push(new EncyclopediaBulletItem("Entertainment Cost $",numberWithCommas(bld.entertainmentCost),null,null));
            }

            if(bld.educates && bld.educates > 0) {
                articleBullets.push(new EncyclopediaBulletItem("Educates",numberWithCommas(bld.educates),null,null));
            }

            if(bld.providesIQ && bld.providesIQ > 0) {
                articleBullets.push(new EncyclopediaBulletItem("Provides IQ",numberWithCommas(bld.providesIQ),null,null));
            }

            if(bld.generates && bld.generateAmount > 0) {
                articleBullets.push(new EncyclopediaBulletItem("Generates",null,null,[
                    new EncyclopediaBulletItem("Output",null,[
                        new EncyclopediaBulletItemLink("resources",bld.generates,bld.generateAmount)
                    ],null),
                    new EncyclopediaBulletItem("Time (ticks)",numberWithCommas(bld.generateTime),null,null)
                ]));
            }

            if(bld.requiresFuel) {
                articleBullets.push(new EncyclopediaBulletItem("Consumes",null,null,[
                    new EncyclopediaBulletItem("Input",null,[
                        new EncyclopediaBulletItemLink("resources",bld.requiresFuel.resource)
                    ],null),
                    new EncyclopediaBulletItem("Time (ticks)",numberWithCommas(bld.requiresFuel.rate),null,null)
                ]));
            }

            if(bld.smelts) {
                articleBullets.push(new EncyclopediaBulletItem("Converts",null,null,[
                    new EncyclopediaBulletItem("Input",null,[
                        new EncyclopediaBulletItemLink("resources",bld.smelts.input,bld.generateAmount)
                    ],null),
                    new EncyclopediaBulletItem("Output",null,[
                        new EncyclopediaBulletItemLink("resources",bld.smelts.output,bld.smelts.ratio)
                    ],null),
                    new EncyclopediaBulletItem("Time (ticks)",numberWithCommas(bld.generateTime),null,null)
                ]));
            }

            if(bld.earthTaxValue && bld.earthTaxValue > 0) {
                articleBullets.push(new EncyclopediaBulletItem("Tax Value $",numberWithCommas(bld.earthTaxValue),null,null));
            }

            if(bld.unlocksGovLvl && bld.unlocksGovLvl > 0) {
                articleBullets.push(new EncyclopediaBulletItem("Unlocks Government Level",bld.unlocksGovLvl,null,null));
            }

            if(bld.reqIndependence) {
                articleBullets.push(new EncyclopediaBulletItem(null,"* Requires Independence *",null,null));
            }

            if(bld.packsTo) {
                articleBullets.push(new EncyclopediaBulletItem("Packs To",null,[
                    new EncyclopediaBulletItemLink("vehicles",bld.packsTo)
                ],null));
            }

            if(bld.canUpgradeTo) {
                articleBullets.push(new EncyclopediaBulletItem("Upgrades To",null,[
                    new EncyclopediaBulletItemLink("buildings",bld.canUpgradeTo)
                ],null));
            }

            document.getElementById("encyclopediaSubSectionRefbackLink").innerHTML = "&lt;- " + getString("general-buildings");
            document.getElementById("encyclopediaSubSectionRefbackLink").onclick = function() {
                showEncyclopediaSubsection("buildings");
            };
        }

        if(section == "terrains") {
            var ter = getTerrainDefByName(article);

            if(ter.icon) {
                document.getElementById("encyclopediaSubSectionImage").style.display = null;
                document.getElementById("encyclopediaSubSectionImage").style.backgroundImage = "url('images/" + ter.icon + "')";
                document.getElementById("encyclopediaSubSectionImage").style.backgroundPosition = "center";
                document.getElementById("encyclopediaSubSectionImage").style.backgroundSize = "contain";
            } else {
                if(ter.tile) {
                    var terTile = ter.tile[0];
                    var terImg = getImageAsset(terTile,false,0);

                    if(terImg) {
                        document.getElementById("encyclopediaSubSectionImage").style.display = null;
                        document.getElementById("encyclopediaSubSectionImage").style.backgroundImage = "url('" + terImg.src + "')";
                        document.getElementById("encyclopediaSubSectionImage").style.backgroundPosition = "center";
                        document.getElementById("encyclopediaSubSectionImage").style.backgroundSize = "contain";
                    } else {
                        setTimeout(function(){
                            loadEncyclopediaArticle(section,article);
                        },500);
                    }
                }
            }

            if(ter.provides) {
                articleBullets.push(new EncyclopediaBulletItem("Provides",null,[
                    new EncyclopediaBulletItemLink("resources",ter.provides)
                ],null));
            }

            document.getElementById("encyclopediaSubSectionRefbackLink").innerHTML = "&lt;- Terrains";
            document.getElementById("encyclopediaSubSectionRefbackLink").onclick = function() {
                showEncyclopediaSubsection("terrains");
            };
        }

        if(section == "vehicles") {
            var vah = getVehicleDefByName(article);

            articleContent += getString(vah.description);

            if(vah.indicator) {
                document.getElementById("encyclopediaSubSectionImage").style.display = null;
                document.getElementById("encyclopediaSubSectionImage").style.backgroundImage = "url('images/" + vah.indicator + "')";
                document.getElementById("encyclopediaSubSectionImage").style.backgroundPosition = "center";
                document.getElementById("encyclopediaSubSectionImage").style.backgroundSize = "contain";
            } else {
                if(vah.tile) {
                    var vTile = vah.tile[0];
                    var vImg = getImageAsset(vTile,false,0);

                    if(vImg) {
                        document.getElementById("encyclopediaSubSectionImage").style.display = null;
                        document.getElementById("encyclopediaSubSectionImage").style.backgroundImage = "url('" + vImg.src + "')";
                        document.getElementById("encyclopediaSubSectionImage").style.backgroundPosition = "center";
                        document.getElementById("encyclopediaSubSectionImage").style.backgroundSize = "contain";
                    } else {
                        setTimeout(function(){
                            loadEncyclopediaArticle(section,article);
                        },500);
                    }
                }
            }

            if(vah.requiresStage && vah.requiresStage > 0 && vah.requiresStage != 99) {
                articleBullets.push(new EncyclopediaBulletItem("Stage Requirement",vah.requiresStage,null,null));
            }

            if(vah.cost && vah.cost.length > 0) {
                sublist = [];

                for(i = 0; i < vah.cost.length; i++) {
                    sublist.push(new EncyclopediaBulletItemLink("resources",vah.cost[i].resource,vah.cost[i].amount));
                }

                articleBullets.push(new EncyclopediaBulletItem("Cost",null,sublist,null));
            }

            if(vah.requiresTech && vah.requiresTech.length > 0) {
                sublist = [];

                for(i = 0; i < vah.requiresTech.length; i++) {

                    sublist.push(new EncyclopediaBulletItemLink("techs",vah.requiresTech[i]));
                }

                articleBullets.push(new EncyclopediaBulletItem("Tech Requirement",null,sublist,null));
            }

            sublist = [];

            for(j = 0; j < ColonyGame.buildings.length; j++) {
                if(ColonyGame.buildings[j].produces != null && ColonyGame.buildings[j].produces.indexOf(vah.name) > -1) {
                    sublist.push(new EncyclopediaBulletItemLink("buildings",ColonyGame.buildings[j].name));
                }
            }

            if(sublist.length > 0) {
                articleBullets.push(new EncyclopediaBulletItem("Built By",null,sublist,null));
            }

            if(vah.produces && vah.produces.length > 0) {
                sublist = [];

                for(j = 0; j < vah.produces.length; j++) {
                    sublist.push(new EncyclopediaBulletItemLink("buildings",vah.produces[j]));
                }

                if(sublist.length > 0) {
                    articleBullets.push(new EncyclopediaBulletItem("Can Build",null,sublist,null));
                }
            }




            if(vah.harvests) {
                articleBullets.push(new EncyclopediaBulletItem("Can Harvest",null,[
                    new EncyclopediaBulletItemLink("resources",vah.harvests)
                ],null));
            }

            if(vah.capacity && vah.capacity > 0) {
                articleBullets.push(new EncyclopediaBulletItem("Harvest Capacity",numberWithCommas(vah.capacity),null,null));
            }

            if(vah.buildSpeed && vah.buildSpeed > 1) {
                articleBullets.push(new EncyclopediaBulletItem("Build Speed",numberWithCommas(vah.buildSpeed),null,null));
            }

            if(vah.vehicleCarryCapacity && vah.vehicleCarryCapacity > 0) {
                articleBullets.push(new EncyclopediaBulletItem("Unit Transport Capacity",numberWithCommas(vah.vehicleCarryCapacity),null,null));
            }

            if(vah.isFlying) {
                articleBullets.push(new EncyclopediaBulletItem(null,"* Can Fly *",null,null));
            }

            if(vah.reqIndependence) {
                articleBullets.push(new EncyclopediaBulletItem(null,"* Requires Independence *",null,null));
            }

            if(vah.deploysTo) {
                articleBullets.push(new EncyclopediaBulletItem("Deploys To",null,[
                    new EncyclopediaBulletItemLink("buildings",vah.deploysTo)
                ],null));
            }

            document.getElementById("encyclopediaSubSectionRefbackLink").innerHTML = "&lt;- " + getString("general-vehicles");
            document.getElementById("encyclopediaSubSectionRefbackLink").onclick = function() {
                showEncyclopediaSubsection("vehicles");
            };
        }

        if(articleBullets.length > 0) {

            var theBullets = document.createElement("ul");

            for(i = 0; i < articleBullets.length; i++) {
                theBullets.appendChild(makeEncyclopediaBulletElement(articleBullets[i]));
            }

            document.getElementById("encyclopediaSubSectionBullets").appendChild(theBullets);
        }


        

        document.getElementById("encyclopediaSubSectionDescription").innerHTML = articleContent;
    }

    function EncyclopediaBulletItem(title,value,links,bullets) {
        this.title = title;
        this.links = links;
        this.value = value;
        this.bullets = bullets;
    }

    function EncyclopediaBulletItemLink(section,article,modifier) {
        this.article = article;
        this.modifier = modifier;
        this.section = section;
    }

    function makeEncyclopediaBulletElement(bulletItem) {
        var element = document.createElement("li");
        var i,spacer,j;

        if(bulletItem.title) {
            var titleItem = document.createElement("strong");
            titleItem.innerHTML = bulletItem.title + ": ";
            element.appendChild(titleItem);
        }

        if(bulletItem.value) {
            element.innerHTML += bulletItem.value;
        }

        if(bulletItem.links && bulletItem.links.length > 0) {

            var useAnd = false;

            for(i = 0; i < bulletItem.links.length; i++) {

                var link = bulletItem.links[i];

                if(!link) {
                    continue;
                }

                var actualLinks = [];

                if(link.article) {
                    if(typeof link.article === "string" || link.article instanceof String) {
                        actualLinks = link.article.split("|");
                    }
                }

                if(actualLinks.length == 1) {
                    useAnd = true;
                    actualLinks = actualLinks[0].split(",");
                }

                for(j = 0; j < actualLinks.length; j++) {

                    if(j > 0) {
                        spacer = document.createElement("span");

                        if(useAnd) {
                            spacer.innerHTML += ", ";
                        } else {
                            spacer.innerHTML += " or ";
                        }
                        
                        element.appendChild(spacer);
                    }

                    var linkItem = document.createElement("span");
                    
                    linkItem.articleref = actualLinks[j];

                    

                    linkItem.innerHTML = actualLinks[j];
    
                    
                    if(link.section) {
                        linkItem.className = "encsectionlinkitem";
                        linkItem.sectionref = link.section;
                        linkItem.onclick = loadEncyclopediaArticleLoader;
                    }
                    
    
                    element.appendChild(linkItem);
    
                    if(link.modifier && link.modifier != 0) {
    
                        spacer = document.createElement("span");
                        spacer.innerHTML += ": ";
                        element.appendChild(spacer);
                        
    
                        var linkMod = document.createElement("span");
    
                        if(link.modifier > 0) {
                            linkMod.innerHTML += "+";
                            linkMod.className = "encLinkModPositive";
                        } else {
                            linkMod.className = "encLinkModNEgative";
                        }
    
                        linkMod.innerHTML += numberWithCommas(link.modifier);
                        element.appendChild(linkMod);
                    }
    
                    
                }

                if(i < bulletItem.links.length - 1) {
                    spacer = document.createElement("span");
                    spacer.innerHTML += ", ";
                    element.appendChild(spacer);
                }

                
            }

            
        }

        if(bulletItem.bullets && bulletItem.bullets.length > 0) {

            var subList = document.createElement("ul");

            for(i = 0; i < bulletItem.bullets.length; i++) {
                subList.appendChild(makeEncyclopediaBulletElement(bulletItem.bullets[i]));
            }

            element.appendChild(subList);
        }

        return element;
    }

    

    function showEncyclopediaSubsection(subsection) {

        var i,sectionLink;

        document.getElementById("encyclopediaMainSection").style.display = "none";
        document.getElementById("encyclopediaVideoPlayerVidHolderFrame").src = "about:blank";
        document.getElementById("encyclopediaSubSection").style.display = "block";
        document.getElementById("encyclopediaOwnersManual").style.display = "none";
        document.getElementById("encyclopediaVideoPlayer").style.display = "none";
        document.getElementById("encyclopediaSubSectionImage").style.display = "none";

        document.getElementById("encyclopediaSubSectionBullets").innerHTML = "";
        document.getElementById("encyclopediaSubSectionLinks").innerHTML = "";
        document.getElementById("encyclopediaSubSectionRefbackLink").innerHTML = "";
        document.getElementById("encyclopediaSubSectionRefbackLink").style.display = "none";

        if(subsection == "civilizations") {
            document.getElementById("encyclopediaSubSectionHeader").innerHTML = getString("general-civs");
            document.getElementById("encyclopediaSubSectionDescription").innerHTML = replaceAll(getString("manual-civs-intro"),"\n","<br />");

            for(i = 0; i < ColonyGame.civilizations.length; i++) {
                sectionLink = document.createElement("div");
                sectionLink.className = "encsectionlinkitem";
                sectionLink.sectionref = "civilizations";
                sectionLink.articleref = ColonyGame.civilizations[i].name;
                sectionLink.innerHTML = ColonyGame.civilizations[i].name;
                sectionLink.onclick = loadEncyclopediaArticleLoader;
                document.getElementById("encyclopediaSubSectionLinks").appendChild(sectionLink);
            }
        }


        if(subsection == "maps") {
            document.getElementById("encyclopediaSubSectionHeader").innerHTML = getString("gen-map-types");
            document.getElementById("encyclopediaSubSectionDescription").innerHTML = replaceAll(getString("manual-map-types"),"\n","<br />");

            for(i = 0; i < ColonyGame.mapTypes.length; i++) {
                sectionLink = document.createElement("div");
                sectionLink.className = "encsectionlinkitem";
                sectionLink.sectionref = "maps";
                sectionLink.articleref = ColonyGame.mapTypes[i].name;
                sectionLink.innerHTML = ColonyGame.mapTypes[i].name;
                sectionLink.onclick = loadEncyclopediaArticleLoader;
                document.getElementById("encyclopediaSubSectionLinks").appendChild(sectionLink);
            }
        }

        if(subsection == "resources") {
            var sortedResources = [];

            for(i = 0; i < ColonyGame.resources.length; i++) {
                sortedResources.push(ColonyGame.resources[i]);
            }

            sortedResources.sort(sortResourcesForManual);

            document.getElementById("encyclopediaSubSectionHeader").innerHTML = getString("resources-header");
            document.getElementById("encyclopediaSubSectionDescription").innerHTML = replaceAll(getString("manual-res-desc"),"\n","<br />");

            for(i = 0; i < sortedResources.length; i++) {
                sectionLink = document.createElement("div");
                sectionLink.className = "encsectionlinkitem";
                sectionLink.sectionref = "resources";
                sectionLink.articleref = sortedResources[i].name;
                sectionLink.innerHTML = sortedResources[i].name;
                sectionLink.onclick = loadEncyclopediaArticleLoader;
                document.getElementById("encyclopediaSubSectionLinks").appendChild(sectionLink);
            }
        }

        if(subsection == "techs") {
            var sortedTechs = [];


            for(i = 0; i < ColonyGame.technology.length; i++) {
                sortedTechs.push(ColonyGame.technology[i]);

            }

            sortedTechs.sort(sortTechsForManual);

            document.getElementById("encyclopediaSubSectionHeader").innerHTML = getString("enc-tech-header");
            document.getElementById("encyclopediaSubSectionDescription").innerHTML = replaceAll(getString("manual-tech-header"),"\n","<br />");

            for(i = 0; i < sortedTechs.length; i++) {
                sectionLink = document.createElement("div");
                sectionLink.className = "encsectionlinkitem";
                sectionLink.sectionref = "techs";
                sectionLink.articleref = sortedTechs[i].name;
                sectionLink.innerHTML = sortedTechs[i].name;
                sectionLink.onclick = loadEncyclopediaArticleLoader;
                document.getElementById("encyclopediaSubSectionLinks").appendChild(sectionLink);
            }
        }

        if(subsection == "buildings") {
            var sortedBuildings = [];

            for(i = 0; i < ColonyGame.buildings.length; i++) {
                sortedBuildings.push(ColonyGame.buildings[i]);
            }

            sortedBuildings.sort(sortTechsForManual);

            document.getElementById("encyclopediaSubSectionHeader").innerHTML = getString("general-buildings");
            document.getElementById("encyclopediaSubSectionDescription").innerHTML = replaceAll(getString("manual-buildings-desc"),"\n","<br />");

            for(i = 0; i < sortedBuildings.length; i++) {
                sectionLink = document.createElement("div");
                sectionLink.className = "encsectionlinkitem";
                sectionLink.sectionref = "buildings";
                sectionLink.articleref = sortedBuildings[i].name;
                sectionLink.innerHTML = sortedBuildings[i].name;
                sectionLink.onclick = loadEncyclopediaArticleLoader;
                document.getElementById("encyclopediaSubSectionLinks").appendChild(sectionLink);
            }
        }

        if(subsection == "terrains") {

            document.getElementById("encyclopediaSubSectionHeader").innerHTML = "Terrains";

            for(i = 0; i < ColonyGame.terrains.length; i++) {
                sectionLink = document.createElement("div");
                sectionLink.className = "encsectionlinkitem";
                sectionLink.sectionref = "terrains";
                sectionLink.articleref = ColonyGame.terrains[i].name;
                sectionLink.innerHTML = ColonyGame.terrains[i].name;
                sectionLink.onclick = loadEncyclopediaArticleLoader;
                document.getElementById("encyclopediaSubSectionLinks").appendChild(sectionLink);
            }
        }

        if(subsection == "vehicles") {
            var sortedVehicles = [];

            for(i = 0; i < ColonyGame.vehicles.length; i++) {
                sortedVehicles.push(ColonyGame.vehicles[i]);
            }

            sortedVehicles.sort(sortTechsForManual);

            document.getElementById("encyclopediaSubSectionHeader").innerHTML = getString("general-vehicles");
            document.getElementById("encyclopediaSubSectionDescription").innerHTML = replaceAll(getString("manual-vehicles-desc"),"\n","<br />");

            for(i = 0; i < sortedVehicles.length; i++) {
                sectionLink = document.createElement("div");
                sectionLink.className = "encsectionlinkitem";
                sectionLink.sectionref = "vehicles";
                sectionLink.articleref = sortedVehicles[i].name;
                sectionLink.innerHTML = sortedVehicles[i].name;
                sectionLink.onclick = loadEncyclopediaArticleLoader;
                document.getElementById("encyclopediaSubSectionLinks").appendChild(sectionLink);
            }
        }
    }

    function showEncyclopedia() {

        // refresh the about data for the users manual
        if(ColonyGame.meta.apeMarketId) {
            var abtDataText = webAppCore.getVar("ver-" + ColonyGame.meta.releaseCode + "-about-info","0");

            if(!abtDataText || abtDataText == "0") {
                aboutVersionData = null;
                fetchLatestAboutAppInfo();
            } else {
                try {
                    aboutVersionData = JSON.parse(abtDataText);
                } catch(ex) {
                    webAppCore.storeVar("ver-" + ColonyGame.meta.releaseCode + "-about-info","0");
                    aboutVersionData = null;
                    fetchLatestAboutAppInfo();
                }
                
            }
        } else {
            aboutVersionData = null;
        }

        var mainSection = document.getElementById("encyclopediaMainSection");
        
        mainSection.style.display = "block";
        document.getElementById("encyclopediaVideoPlayerVidHolderFrame").src = "about:blank";
        document.getElementById("encyclopediaSubSection").style.display = "none";
        document.getElementById("encyclopediaOwnersManual").style.display = "none";
        document.getElementById("encyclopediaVideoPlayer").style.display = "none";

        mainSection.innerHTML = "";
        document.getElementById("encyclopediaOwnersManualContent").innerHTML = "";


        createEncyclopediaCard(mainSection,"images/" + ColonyGame.meta.encyclopediaIndicator,getString("owners-manual-header"),getString("owners-manual-short-desc"),showOwnersManual);



        if(!webAppCore.isTV()) {
            if(ColonyGame.meta.extraReferenceUrl != null) {
                createEncyclopediaCard(mainSection,"images/" + ColonyGame.meta.extraReferenceIcon,ColonyGame.meta.extraReferenceName,ColonyGame.meta.extraReferenceDisclaimer,function() {
                    webAppCore.externalURL(ColonyGame.meta.extraReferenceUrl);
                });
            }

            if(ColonyGame.meta.referenceLink != null) {
                createEncyclopediaCard(mainSection,"images/" + ColonyGame.meta.websiteIndicator,getString("enc-online-header"),getString("enc-online-desc"),function() {
                    webAppCore.externalURL(ColonyGame.meta.referenceLink);
                });
            }

        }

        

        if(ColonyGame.meta.videoTutorialsIndicator != null && ColonyGame.videoTutorials.length > 0) {
            createEncyclopediaCard(mainSection,"images/" + ColonyGame.meta.videoTutorialsIndicator,getString("general-vidtut-header"),getString("general-vidtut-desc"),loadVideoTutorials);
        }

        if(!webAppCore.isTV() && ColonyGame.meta.mpRegionInd && ColonyGame.meta.communityUrl) {
            createEncyclopediaCard(mainSection,"images/" + ColonyGame.meta.mpRegionInd,getString("support-community"),getString("support-community-desc"),function(){
                webAppCore.externalURL(ColonyGame.meta.communityUrl);
            });
        }

        if(!webAppCore.isTV() && ColonyGame.meta.merchStoreInd && ColonyGame.meta.merchStoreLink) {
            createEncyclopediaCard(mainSection,"images/" + ColonyGame.meta.merchStoreInd,getString("merch-store-header"),getString("merch-store-desc"),function(){
                webAppCore.externalURL(ColonyGame.meta.merchStoreLink);
            });
        }

        createEncyclopediaCard(mainSection,"images/" + ColonyGame.meta.encyclopediaIndicator,getString("general-civs"),ColonyGame.civilizations.length + " in game",function() {
            showEncyclopediaSubsection("civilizations");
        });

        createEncyclopediaCard(mainSection,"images/" + ColonyGame.meta.encyclopediaIndicator,getString("gen-map-types"),ColonyGame.mapTypes.length + " in game",function() {
            showEncyclopediaSubsection("maps");
        });

        createEncyclopediaCard(mainSection,"images/" + ColonyGame.meta.encyclopediaIndicator,getString("resources-header"),ColonyGame.resources.length + " in game",function() {
            showEncyclopediaSubsection("resources");
        });

        createEncyclopediaCard(mainSection,"images/" + ColonyGame.meta.encyclopediaIndicator,getString("enc-tech-header"),ColonyGame.technology.length + " in game",function() {
            showEncyclopediaSubsection("techs");
        });

        createEncyclopediaCard(mainSection,"images/" + ColonyGame.meta.encyclopediaIndicator,getString("general-buildings"),ColonyGame.buildings.length + " in game",function() {
            showEncyclopediaSubsection("buildings");
        });

        createEncyclopediaCard(mainSection,"images/" + ColonyGame.meta.encyclopediaIndicator,getString("general-vehicles"),ColonyGame.vehicles.length + " in game",function() {
            showEncyclopediaSubsection("vehicles");
        });

        createEncyclopediaCard(mainSection,"images/" + ColonyGame.meta.encyclopediaIndicator,"Terrains",ColonyGame.terrains.length + " in game",function() {
            showEncyclopediaSubsection("terrains");
        });

    }

    var getKeyClearAfter = false;

    function getKeyThenUpdateStats(clearSplashAfter) {
        if(!currentGame || currentGame == null) {
            return;
        }

        if(getRegionOrCity().offlineMode) {
            webAppCore.clearSplash();
            return;
        }

        if(getRegionOrCity().colonyId == 0) {
            webAppCore.clearSplash();
            return;
        }

        if(!clearSplashAfter) {
            clearSplashAfter = false;
        }

        getKeyClearAfter = clearSplashAfter;

        var data = [];

        data.push({
            "key":      "f",
            "value":    33
        });

        data.push({
            "key":      "i",
            "value":    getRegionOrCity().colonyId
        });

        data.push({
            "key":      "relcd",
            "value":    ColonyGame.meta.releaseCode
        });

        webAppCore.postForResult(ColonyGame.meta.colonyServerApi, data, setApiKeyThenUpdate);
    }

    function setApiKeyThenUpdate(result) {
        if(result != null && result.trim().length > 0) {
            getRegionOrCity().apiKey = result;
            updateColonyStats(getKeyClearAfter);
        }
    }

    var updateStatsClearAfter = false;
    var statUpdateCooldownTimer = null;

    function updateColonyStats(clearSplashAfter,customCallback) {
        if(!currentGame || currentGame == null) {
            return;
        }

        if(statUpdateCooldownTimer || currentGame.isMpRegionHolder) {
            if(clearSplashAfter) {
                webAppCore.clearSplash();
            }

            if(customCallback) {
                customCallback();
            }

            return;
        }

        var useCallback = getParentIfNeeded;

        if(customCallback) {
            useCallback = customCallback;
        }

        if(!clearSplashAfter) {
            clearSplashAfter = false;
        }

        var regionOrCity = getRegionOrCity();

        if(clearSplashAfter && regionOrCity.offlineMode) {
            webAppCore.clearSplash();
            readyToLoadSubcities = true;

            if(customCallback) {
                customCallback();
            }

            return;
        }

        if(clearSplashAfter && regionOrCity.colonyId == 0) {
            webAppCore.clearSplash();
            readyToLoadSubcities = true;

            if(customCallback) {
                customCallback();
            }

            return;
        }

        

        if(regionOrCity.apiKey == 0) {
            if(customCallback) {
                customCallback();
            } else {
                getKeyThenUpdateStats(clearSplashAfter);
            }

            readyToLoadSubcities = true;

            return;
        }

        updateStatsClearAfter = clearSplashAfter;

        var totalGDP = getTotalGDP(true);

        var gdpPercapita = Math.round(totalGDP / getTotalPopulation(true));

        if(isNaN(gdpPercapita)) {
            gdpPercapita = 0;
        }

        webAppCore.storeVar("pnd-trns-" + getRegionOrCity().colonyId + "-sve","0");

        var unemployedPercent = getUnemploymentPercent(true);

        if(!unemployedPercent || isNaN(unemployedPercent)) {
            unemployedPercent = 0;
        }

        var indOpt = "0";

        var charterOption = "1";

        if(regionOrCity.privateCharter) {
            charterOption = "0";
        }

        if(regionOrCity.isIndependent) {
            indOpt = "1";
        }

        var data = [];

        data.push({
            "key":      "gdp",
            "value":    totalGDP
        });

        data.push({
            "key":      "percap",
            "value":    gdpPercapita
        });

        data.push({
            "key":      "pop",
            "value":    getTotalPopulation(true)
        });

        data.push({
            "key":      "isInd",
            "value":    indOpt
        });

        data.push({
            "key":      "unem",
            "value":    unemployedPercent
        });

        data.push({
            "key":      "stage",
            "value":    regionOrCity.stage
        });

        data.push({
            "key":      "relations",
            "value":    regionOrCity.earthAssemblyRelations
        });

        data.push({
            "key":      "founding",
            "value":    dateToReadable(regionOrCity.creationDate)
        });

        if(regionOrCity.isIndependent) {
            data.push({
                "key":      "independence",
                "value":    dateToReadable(regionOrCity.independenceDay)
            });
        } else {
            data.push({
                "key":      "independence",
                "value":    "0"
            });
        }

        data.push({
            "key":      "color",
            "value":    regionOrCity.themeColor
        });

        data.push({
            "key":      "colname",
            "value":    replaceAll(regionOrCity.name, "'", "")
        });

        data.push({
            "key":      "platform",
            "value":    getPlaysonCode()
        });

        if(regionOrCity.civilization === undefined) {
            regionOrCity.civilization = ColonyGame.civilizations[0].name;
        }

        data.push({
            "key":      "civ",
            "value":    regionOrCity.civilization
        });

        data.push({
            "key":      "race",
            "value":    regionOrCity.defaultRace
        });

        data.push({
            "key":      "map",
            "value":    regionOrCity.mapType
        });

        data.push({
            "key":      "pc",
            "value":    charterOption
        });

        data.push({
            "key":      "pay",
            "value":    Math.round(regionOrCity.payrollRate * 100)
        });

        data.push({
            "key":      "tl",
            "value":    regionOrCity.taxLevel
        });

        data.push({
            "key":      "sr",
            "value":    getGameResources()[ColonyGame.meta.gameStageResource].domesticAmount
        });

        var gdpq = "0.0";
        var gdpa = "0.0";

        var useGame = currentGame;

        if(currentGame.isSubregion && currentRegion) {
            useGame = currentRegion;
        }

        if(useGame.isRegion) {
            if(useGame.regionalGDPAnuallyhQuarterlyAdjusted.length > 1) {
                if(useGame.regionalGDPAnuallyhQuarterlyAdjusted[useGame.regionalGDPAnuallyhQuarterlyAdjusted.length - 1]) {
                    gdpq = useGame.regionalGDPAnuallyhQuarterlyAdjusted[useGame.regionalGDPAnuallyhQuarterlyAdjusted.length - 1].toFixed(1);
                    gdpa = gdpq;
                }
                
            }
        } else {

            if(!useGame.historicStats.gdpQuarterlyAdjusted) {
                useGame.historicStats.gdpQuarterlyAdjusted = [];
            }

            if(useGame.historicStats.gdpQuarterlyAdjusted.length > 1) {
                if(useGame.historicStats.gdpQuarterlyAdjusted[useGame.historicStats.gdpQuarterlyAdjusted.length - 1]) {
                    gdpq = useGame.historicStats.gdpQuarterlyAdjusted[useGame.historicStats.gdpQuarterlyAdjusted.length - 1].toFixed(1);
                }
                
                if(useGame.historicStats.gdpAnuallyAdjusted[useGame.historicStats.gdpAnuallyAdjusted.length - 1]) {
                    if(useGame.historicStats.gdpAnuallyAdjusted.length > 1) {
                        gdpa = useGame.historicStats.gdpAnuallyAdjusted[useGame.historicStats.gdpAnuallyAdjusted.length - 1].toFixed(1);
                    } else {
                        gdpa = gdpq;
                    }
                }
                
            }
        }

        data.push({
            "key":      "gdpq",
            "value":    gdpq
        });

        data.push({
            "key":      "gdpa",
            "value":    gdpa
        });

        
        var resObj = {};

        var gameRes = getGameResources();

        for(var prop in gameRes) {

            if(prop == "statResSaveTimestamp") {
                continue;
            }

            resObj[prop] = gameRes[prop].amount;
        }

        var resHold = btoa(stripEmoji(JSON.stringify(resObj)));

        data.push({
            "key":      "svres",
            "value":    resHold
        });

        var cloudSaveLocation = "0";

        if(regionOrCity.useCloud && currentFileName) {
            cloudSaveLocation = replaceAll(webAppCore.buildCloudSharePathForFile(currentFileName),"/","_") + "/";
        }

        data.push({
            "key":      "cp",
            "value":    cloudSaveLocation
        });

        data.push({
            "key":      "sp",
            "value":    regionOrCity.salesPitch
        });

        var regionStat = 0;

        if(useGame.isRegion) {
            regionStat = 1;
        }

        if(isStreamingLive) {
            data.push({
                "key":      "sdat",
                "value":    1
            });
        } else {
            data.push({
                "key":      "sdat",
                "value":    0
            });
        }

        data.push({
            "key":      "reg",
            "value":    regionStat
        });

        var flagString = JSON.stringify(useGame.flag);
        

        data.push({
            "key":      "flag",
            "value":    btoa(flagString)
        });

        // mp-region specific stats 
        if(currentGame.isSubregion && currentRegion && currentRegion.isMpRegionHolder && currentSubcityRef) {
            data.push({
                "key":      "mprs",
                "value":    1
            });

            data.push({
                "key":      "mprt",
                "value":    btoa(stripEmoji(JSON.stringify(getGameTechs())))
            });

            var sCaps = {};

            for(var res in currentGame.resources) {
                sCaps[res] = currentGame.resources[res].domesticCapacity;
            }

            var uCaps = {};

            for(var ut in currentGame.utilities) {
                uCaps[ut] = {
                    usage: currentGame.utilities[ut].domesticUsage,
                    capacity: currentGame.utilities[ut].domesticCapacity
                };

                if(!uCaps[ut].usage) {
                    uCaps[ut].usage = 0;
                }

                if(!uCaps[ut].capacity) {
                    uCaps[ut].capacity = 0;
                }
            }

            var capacityData = {
                res: sCaps,
                utils: uCaps
            };

            data.push({
                "key":      "mpcaps",
                "value":    btoa(stripEmoji(JSON.stringify(capacityData)))
            });

            postToOnlineMetroArea({
                "type": "metro",
                "data": {
                    "type": "capdata",
                    "caps": capacityData,
                    "res": resObj,
                    "id": currentGame.colonyId,
                    "charter": currentGame.charter,
                    "guid": currentSubcityRef.subcityGuid,
                    "name": currentGame.name
                }
            });
        }

        statUpdateCooldownTimer = setTimeout(uploadStatsCooltownHandler,5000);

        postSecuredCallToApi(data,15,useCallback);
    }



    function uploadStatsCooltownHandler() {
        statUpdateCooldownTimer = null;
    }

    function getParentIfNeeded() {

        if(!currentGame) {
            return;
        }

        if(getRegionOrCity() == null || getRegionOrCity().isIndependent || getRegionOrCity().motherlandid == 0 || getRegionOrCity().offlineMode) {

            if(updateStatsClearAfter) {
                updateStatsClearAfter = false;

                if(currentGame != null) {
                    webAppCore.clearSplash();
                }

                colonyNeverLoaded = false;
            }

            if(currentGame.isRegion) {
                readyToLoadSubcities = true;
            }

            if(theNeverLoadedTimeout) {
                clearTimeout(theNeverLoadedTimeout);
                theNeverLoadedTimeout = null;
            }

            return;
        }

        var data = [];

        data.push({
            "key":      "f",
            "value":    24
        });

        data.push({
            "key":      "i",
            "value":    getRegionOrCity().motherlandid
        });

        data.push({
            "key":      "g",
            "value":    ColonyGame.meta.colonyServerGameId
        });

        data.push({
            "key":      "relcd",
            "value":    ColonyGame.meta.releaseCode
        });

        webAppCore.postForResult(ColonyGame.meta.colonyServerApi, data, setNeededParentStats);
    }

    function setNeededParentStats(result) {

        if(currentGame == null) {
            colonyNeverLoaded = false;
            return;
        }

        if(updateStatsClearAfter) {
            updateStatsClearAfter = false;
            colonyNeverLoaded = false;
            webAppCore.clearSplash();
        }

        if(theNeverLoadedTimeout) {
            clearTimeout(theNeverLoadedTimeout);
            theNeverLoadedTimeout = null;
        }

        if(currentGame.isRegion) {
            readyToLoadSubcities = true;
        }

        if(result != null && result.trim().length > 0) {
            try {
                var colonyInfo = JSON.parse(result)[0];

                if(colonyInfo == null) {
                    return;
                }

                var payRateWhole = parseInt(colonyInfo.payrolllevel);
                getRegionOrCity().payrollRate = payRateWhole / 100;

                var taxRateWhole = parseInt(colonyInfo.taxlevel);
                getRegionOrCity().taxLevel = taxRateWhole;

                if(colonyInfo.federationid) {
                    getRegionOrCity().federationId = parseInt(colonyInfo.federationid);
                }

            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": setNeededParentStats",ex.message);
            }
        }
    }

    function onScreenshotForWebsite(canvas) {

        if(!canvas) {
            statsOpen = true;
            return;
        }

        var imgData = canvas.toDataURL("image/jpeg",0.75);
        var sendData = imgData.replace("data:image/jpeg;base64,","");

        if(currentGame == null || !getRegionOrCity().colonyId || getRegionOrCity().colonyId == 0) {
            statsOpen = true;
            return;
        }

        var data = [];

        data.push({
            "key":      "img",
            "value":    sendData
        });


        postSecuredCallToApi(data,16,onScreenshotUploadBack);

        setTimeout(function() {
            statsOpen = true;
        },300);
    }

    function onScreenshotUploadBack() {

        webAppCore.showToast("Screenshot Saved");

        var roc = getRegionOrCity();

        if(!roc) {
            return;
        }

        var sssrc = "url('" + ColonyGame.meta.colonyServerBase.replace("colonies","screenshots") + "/ss-" + roc.colonyId + ".jpg?z=" + randomIntFromInterval(0,5000) + "')";
        document.getElementById("statOverviewScreenshotSection").style.backgroundImage = sssrc;

    }

    function onColorBack(color) {

        if(color == null) {
            return;
        }

        document.getElementById("statOverviewColonialColor").style.color = color;
        document.getElementById("statOverviewColonialColor").innerHTML = color;

        getRegionOrCity().themeColor = color;

        if(currentGame.playerNamesRef[getRegionOrCity().localPlayerId]) {
            currentGame.playerNamesRef[getRegionOrCity().localPlayerId].color = color;
        }

        clearDefaultColoredAssets();

        updateColonyStats();

        setColonyThemeColor();

        webAppCore.showToast("Color Updated");
    }

    function setColonyThemeColor() {
        var useTheme = "#b35900";

        if(getRegionOrCity().themeColor) {
            useTheme = getRegionOrCity().themeColor;
        }

        var rawcolor = hexToColor(useTheme);

        if(!rawcolor) {
            return;
        }

        var hoverColor = "rgba(" + rawcolor.r + "," + rawcolor.g + "," + rawcolor.b + ",.4)";

        var customColonyStyles = document.getElementById("customColonyStyles");
        customColonyStyles.innerHTML = "";

        customColonyStyles.innerHTML = "*::-webkit-scrollbar-thumb { background-color: " + useTheme + "; } #newObjectOptionsWindow,#colonyWindow,#galBT,#commonwealthWindow,#statsScreen,#chartScreen { border-color: " + useTheme + "; } .gabBTSidebarItem:hover, .gabBTSidebarItemSelected, .gamepadMode #statsSidebar .gamepadSelected .gabBTContractItem:hover, .livePriceCard:hover, .colonyCard:hover, .gabBTContractItem:hover, .gabBTContractItemSelectedGamepad, .resourceStatCard:hover { background-color: " + hoverColor + "; }";
    }

    function clearDefaultColoredAssets() {
        textureManager.initAssets();
    }

    var pendingTextBuilding = null;

    function setBuildingText(building) {
        pendingTextBuilding = building;

        var dialogOptions = {
            title: building.name,
            message: "Current: " + building.customText,
            func: onBuildingTextBack
        };

        webAppCore.inputBox(dialogOptions);
    }

    function onBuildingTextBack(text) {
        if(text == null) {
            return;
        }

        if(pendingTextBuilding == null) {
            return;
        }

        pendingTextBuilding.customText = text.trim().latinize();
        pendingTextBuilding = null;

        if(allowAudio) {
            webAppCore.say(text);
        }
    }

    function renameColony() {

        var dialogOptions = {
            title: getString("rename-colony"),
            message: getString("rename-desc"),
            func: onRenameBack
        };

        webAppCore.inputBox(dialogOptions);
    }

    function onRenameBack(result) {
        if(result == null || result.trim().length == 0) {
            return;
        }

        var oldName = currentGame.name;
        var newName = result.trim().latinize();
        newName = replaceAll(newName, "\\", "");

        if(oldName == newName) {
            return;
        }

        var charter = null;

        if(currentGame.isSubregion){
            charter = currentRegion.charter;
        } else{
            charter = currentGame.charter;
        }

        postToColoniae({
            "event": "namechanged", 
            "oldname": oldName, 
            "newname": newName, 
            "charter": charter
        });

        currentGame.name = newName;

        postMessageToAllChannels(oldName + " was renamed to " + newName);

        document.getElementById("statOverviewColonyName").innerHTML = currentGame.name;

        updateColonyStats();
    }

    function showMail() {

        if(currentGame.readOnlyMode) {
            return;
        }

        tmpHoldingMessage = null;

        var rOrC = getRegionOrCity();

        if(rOrC.mail == null || rOrC.mail.length == 0) {
            webAppCore.showToast("No mail!");
            document.getElementById("imMail").style.display = "none";
            return;
        }

        var menuOptions = [];

        for(var i = 0; i < rOrC.mail.length; i++) {

            var thisMessage = rOrC.mail[i];

            if(!thisMessage.from && thisMessage.accountLevelMessage && thisMessage.accountMessageFromCharter) {

                var charterInfo = getKnownInfoAboutCharter(thisMessage.accountMessageFromCharter);

                if(charterInfo) {
                    thisMessage.from = charterInfo.name;
                    thisMessage.fromid = charterInfo.id;

                } else {

                    postSecuredCallToApi([{
                        "key":      "c",
                        "value":    thisMessage.accountMessageFromCharter
                    }],25,addDataToKnownCharters);
                }
            }

            var read = "Unread";
            var unreadColor = "";

            if(thisMessage.read) {
                read = "Read";
                unreadColor = null; 
            }

            var mailImage = "images/" + ColonyGame.meta.mailIndicator;

            if(thisMessage.code == "7" || thisMessage.code == "8") {
                mailImage = "images/" + ColonyGame.meta.empireIndicator;
            }

            if(thisMessage.fromid == "-15") {
                mailImage = "images/" + ColonyGame.meta.capitolIndicator;
            }

            menuOptions.push({
                "title": "From: " + thisMessage.from,
                "title-color": null,
                "description": thisMessage.time,
                "status": read,
                "status-color": unreadColor,
                "icon": mailImage,
                "tag": thisMessage
            });
        }

        if(menuOptions.length == 0) {
            return;
        }

        showList("Inbox",menuOptions,onMailMessageOpened,"Nevermind");
    }

    function alertNewMailIfNecessary() {
        var hasUnread = false;
        var hasMail = false;

        var roc = getRegionOrCity();

        if(!roc) {
            return;
        }

        for(var i = 0; i < roc.mail.length; i++) {
            hasMail = true;

            if(!roc.mail[i].read) {
                hasUnread = true;
                break;
            }
        }

        if(hasUnread) {
            webAppCore.showToast({
                "message":      "New Mail!",
                "image":        "images/" + ColonyGame.meta.mailIndicator,
                "action": {
                    "title":    "Inbox",
                    "func":     showMail
                }
            });
        }

        if(hasMail) {
            document.getElementById("imMail").style.display = "inline-block";
        }
    }

    function checkMail() {

        if(getRegionOrCity() == null || !getRegionOrCity().colonyId || getRegionOrCity().colonyId == 0) {
            return;
        }

        if(currentGame.readOnlyMode) {
            return;
        }

        var data = [];

        postSecuredCallToApi(data,18,onMailReturn);

    }

    function MailMessage(from,fromid,message,time,code,resource,amount) {
        this.from = from;
        this.fromid = fromid;
        this.message = message;
        this.time = time;
        this.code = code;
        this.resource = resource;
        this.amount = amount;
        this.read = false;
        this.reported = false;

        this.accountLevelMessage = false;
        this.accountMessageId = 0;
        this.accountMessageFromUser = null;
        this.accountMessageFromCharter = null;

        if(this.fromid == -15) {
            this.from = ColonyGame.meta.name + " Server Admin";
        }
    }

    function reopenMailIfAny() {

        if(currentGame == null) {
            return;
        }

        if(getRegionOrCity().mail.length > 0) {
            showMail();
        }
    }

    function onMailReturn(result) {

        if(currentGame == null) {
            return;
        }

        if(currentGame.readOnlyMode) {
            return;
        }

        var contracts;
       
        setTimeout(checkColonyMailFromServer,100);

        if(result != null && result.trim().length > 0) {
            try {
                contracts = JSON.parse(result);
            } catch(ex) {
                console.log(ex);
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onMailReturn",ex.message);
                return;
            }
        }

        if(!contracts || !contracts.mail) {
            return;
        }

        if(!getRegionOrCity().mail) {
            getRegionOrCity().mail = [];
        }

        parseServerMailData(contracts.mail);
    }

    var tmpHoldingMessage;

    function onServerMessageBack(data) {

        if(!tmpHoldingMessage || !data) {
            
            if(!data) {

                webAppCore.showDialog({
                    title: getString("mail-not-available"),
                    message: getString("mail-not-available-info"),
                    icon: "images/" + ColonyGame.meta.mailIndicator
                });
    
                deleteMail();
            }

            return;
        }

        

        try {
            var msgData = JSON.parse(data);
            tmpHoldingMessage.message = msgData.content;
            showStandardMessage(tmpHoldingMessage);
        } catch(ex) {
            webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onServerMessageBack",ex.message);
        }
    }

    function showStandardMessage(message) {

        tmpHoldingMessage = message;

        if(tmpHoldingMessage.accountLevelMessage && tmpHoldingMessage.message == null) {
            webAppCore.getAccountMessage(tmpHoldingMessage.accountMessageId,onServerMessageBack);
            return;
        }

        var menuOptions = [];

        menuOptions.push({
            "title": message.time,
            "title-color": null,
            "description": message.message,
            "status": null,
            "status-color": null,
            "icon": null,
            "tag": null
        });

        menuOptions.push({
            "title": getString("general-delete"),
            "title-color": "#F44336",
            "description": null,
            "status": null,
            "status-color": null,
            "icon": null,
            "tag": "delete"
        });

        if(message.code == "0" && message.fromid && message.fromid != "0") {

            var sendText = "Send Message";

            if(message.fromid == "-15") {
                sendText = "Reply to Admin";
            }

            menuOptions.push({
                "title": sendText,
                "title-color": null,
                "description": null,
                "status": null,
                "status-color": null,
                "icon": null,
                "tag": "reply"
            });
        }

        if(message.code == "0" && message.fromid && message.fromid != "0" && getGiftCapacity() > 0 && message.fromid != "-15") {
            menuOptions.push({
                "title": "Send Gift",
                "title-color": null,
                "description": null,
                "status": null,
                "status-color": null,
                "icon": null,
                "tag": "gift"
            });
        }

        if(!message.reported && !getRegionOrCity().offlineMode && message.fromid != "-15") {
            menuOptions.push({
                "title": "Report Message",
                "title-color": null,
                "description": "Report this inappropriate message to the game moderators.",
                "status": "False reports are also tracked!",
                "status-color": "#F44336",
                "icon": null,
                "tag": "report"
            });
        }

        showList("From: " + message.from,menuOptions,onMailMessageResponse,"Nevermind");
    }

    function onMailMessageResponse(tag) {

        if(tmpHoldingMessage == null) {
            return;
        }

        var roc = getRegionOrCity();

        if(!roc) {
            return;
        }

        if(tag == "report") {
            var data = [];
            
            data.push({
                "key":      "rs",
                "value":    tmpHoldingMessage.fromid
            });
    
            data.push({
                "key":      "rm",
                "value":    tmpHoldingMessage.message
            });
    
            data.push({
                "key":      "rt",
                "value":    tmpHoldingMessage.time
            });

            tmpHoldingMessage.reported = true;            

            postSecuredCallToApi(data,43,function() {
                webAppCore.showToast("Message Reported.");
            });
        }

        if(tag == "gift") {
            tmpNegoiationColony = {"id":tmpHoldingMessage.fromid};

            if(roc.offlineMode) {
                if(tcpAvailable) {
                    tmpNegoiationColony = getLocalColonyInfoFromName(tmpHoldingMessage.from);

                    if(tmpNegoiationColony == null) {
                        tmpNegoiationColony = getColonyInfoFromIdAndTag(tmpHoldingMessage.fromid.id,tmpHoldingMessage.fromid.tag);

                        if(tmpNegoiationColony == null) {
                            webAppCore.showToast("Unable to reply!  Recipient not online.");
                        } else {
                            offlineResourceSendMenu();
                        }
                    } else {
                        offlineResourceSendMenu();
                    }
                } else {
                    webAppCore.showToast("Unable to reply!  Recipient not online.");
                }
            } else {
                showOnlineResources("send");
            }

        }

        if(tag == "delete") {
            deleteMail();
        }

        if(tag == "reply") {
            if(roc.offlineMode) {
                if(tcpAvailable) {
                    var target = getLocalColonyInfoFromName(tmpHoldingMessage.from);

                    if(target == null) {
                        target = getColonyInfoFromIdAndTag(tmpHoldingMessage.fromid.id,tmpHoldingMessage.fromid.tag);

                        if(target == null) {
                            webAppCore.showToast("Unable to reply!  Recipient not online.");
                        } else {
                            sendACustomMessage(target.sid,target.tag);
                        }
                    } else {
                        sendACustomMessage(target.sid,target.tag);
                    }
                } else {
                    webAppCore.showToast("Unable to reply!  Recipient not online.");
                }
            } else {
                sendACustomMessage(tmpHoldingMessage.fromid);
            }
            
        }
    }

    function openGiftVideo() {

        webAppCore.playRewardedVideo(onRewardedVideoBack);
    }

    function onRewardedVideoBack(status) {
        if(currentGame == null) {
            return;
        }

        if(status) {
            completeRewardGiftFinal();
        } else {
            webAppCore.showAlertWithTitle(getString("general-gift-not-watched"),getString("general-gift-giver"));
        }
    }

    function completeRewardGiftFinal() {
        getRegionOrCity().rewardCounter = 0;
        getRegionOrCity().showRewardOption = false;
        deleteMail();

        var randomResource = null;

        while(randomResource == null) {
            var tmp = ColonyGame.resources[randomIntFromInterval(0,ColonyGame.resources.length - 1)];

            if(tmp.canGift) {
                randomResource = tmp;
            }
        }

        var randomAmount = randomIntFromInterval(500,6000);

        getRegionOrCity().gifts.push(new Gift(getString("general-gift-giver"),getString("general-reward-complete"),randomResource.name,randomAmount));

        webAppCore.showToast("New gifts available!");
        document.getElementById("imGift").style.display = "inline-block";
    }

    function rejectGiftVid() {
        deleteMail();

        var roc = getRegionOrCity();

        if(!roc) {
            return;
        }

        roc.rewardCounter = 0;
        roc.showRewardOption = false;
    }

    function onMailMessageOpened(message) {

        if(currentGame == null || !message) {
            return;
        }

        if(!message.from && message.accountLevelMessage && message.accountMessageFromCharter) {
            var charterInfo = getKnownInfoAboutCharter(message.accountMessageFromCharter);

            if(charterInfo) {
                message.from = charterInfo.name;
                message.fromid = charterInfo.id;
            }
        }

        tmpHoldingMessage = message;
        
        // rewarded video offer 
        if(message.code == "-1") {
            webAppCore.showDialog({
                "title":    message.from,
                "message":  message.message,
                "op1": {
                    "text":     getString("general-delete"),
                    "func":     rejectGiftVid,
                    "color":    "#F44336"
                },
                "op2": {
                    "text":     getString("general-watch-gift-vid"),
                    "func":     openGiftVideo
                }
            });
        }

        // standard message
        if(message.code == "0" || message.code == "8") {

            showStandardMessage(message);

        }

        // payroll
        if(message.code == "2") {
            webAppCore.showDialog({
                "title":    message.from,
                "message":  message.message + "\n\n" + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(message.amount),
                "op1": {
                    "text":     getString("tax-pay"),
                    "func":     payCommonwealthPayroll,
                    "color":    "#4CAF50"
                },
                "op2": {
                    "text":     getString("tax-window-reject"),
                    "func":     rejectCommonwealthPayroll,
                    "color":    "#F44336"
                }
            });
        }

        // tribute
        if(message.code == "5") {

            tmpTributeAmount = Math.round(getGameResources()[ColonyGame.meta.tenderResource].amount * (message.amount / 100));

            webAppCore.showDialog({
                "title":    message.from,
                "message":  message.message + "\n\n" + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(tmpTributeAmount),
                "op1": {
                    "text":     getString("tax-pay"),
                    "func":     payTribute
                },
                "op2": {
                    "text":     getString("tax-window-reject"),
                    "func":     rejectTribute
                }
            });
        }

        // independence 
        if(message.code == "6") {

            getRegionOrCity().isIndependent = true;
            getRegionOrCity().tradeEmbargo = false;
            getRegionOrCity().immigrationEmbargo = false;

            getRegionOrCity().independenceDay = Date.now();

            getColonyInfoFromServer();

            webAppCore.showDialog({
                "title":    message.from,
                "message":  message.message,
                "op1": {
                    "text":     getString("general-dismiss"),
                    "func":     reopenMailIfAny
                },
                "op2": {
                    "text":     getString("general-delete"),
                    "func":     deleteMail,
                    "color":    "#F44336"
                }
            });
        }

        if(message.code == "7") {
            getAnnexRequestInfo(message);
        }
        

        if(getRegionOrCity().mail.length > 0) {
            document.getElementById("imMail").style.display = "inline-block";
        } else {
            document.getElementById("imMail").style.display = "none";
        }

        if(typeof message !== "string") {
            message.read = true;
        }

        
    }

    var tmpTributeAmount = 0;

    function payTribute() {
        if(tmpHoldingMessage == null || currentGame == null) {
            return;
        }

        if(tmpTributeAmount > getGameResources()[ColonyGame.meta.tenderResource].amount) {

            modifyResourceAmount(ColonyGame.meta.tenderResource,0,true,"Commonwealth");
        } else {

            modifyResourceAmount(ColonyGame.meta.tenderResource,-tmpTributeAmount,false,"Commonwealth");
        }

        getRegionOrCity().earthAssemblyRelations += 5;

        if(getRegionOrCity().earthAssemblyRelations > 100) {
            getRegionOrCity().earthAssemblyRelations = 100;
        }

        removeFromArray(getRegionOrCity().mail,tmpHoldingMessage);

        sendMessage(tmpHoldingMessage.fromid,4,tmpTributeAmount,getRegionOrCity().name + " has agreed to your demand for " + tmpHoldingMessage.amount + "% tribute.",placeholder);

        if(getRegionOrCity().mail.length > 0) {
            document.getElementById("imMail").style.display = "inline-block";
        } else {
            document.getElementById("imMail").style.display = "none";
        }

        webAppCore.showToast(getString("tax-payment-thankyou"));

        reopenMailIfAny();
    }

    function rejectTribute() {
        if(tmpHoldingMessage == null || currentGame == null) {
            return;
        }

        getRegionOrCity().earthBackTax += tmpTributeAmount;

        getRegionOrCity().earthAssemblyRelations -= 8;

        if(getRegionOrCity().earthAssemblyRelations < 0) {
            getRegionOrCity().earthAssemblyRelations = 0;
        }

        removeFromArray(getRegionOrCity().mail,tmpHoldingMessage);

        sendMessage(tmpHoldingMessage.fromid,0,0,getRegionOrCity().name + " has rejected your demand for " + tmpHoldingMessage.amount + "% tribute.",placeholder);

        if(getRegionOrCity().mail.length > 0) {
            document.getElementById("imMail").style.display = "inline-block";
        } else {
            document.getElementById("imMail").style.display = "none";
        }

        reopenMailIfAny();
    }

    function payCommonwealthPayroll() {
        if(tmpHoldingMessage == null || currentGame == null) {
            return;
        }

        removeFromArray(getRegionOrCity().mail,tmpHoldingMessage);

        var amount = parseInt(tmpHoldingMessage.amount);

        if(amount > getGameResources()[ColonyGame.meta.tenderResource].amount) {
            amount = getGameResources()[ColonyGame.meta.tenderResource].amount;

            modifyResourceAmount(ColonyGame.meta.tenderResource,0,true,"Commonwealth");
        } else {
            modifyResourceAmount(ColonyGame.meta.tenderResource,-amount,false,"Commonwealth");
        }

        getRegionOrCity().foreignPayrollTotals += amount;

        sendMessage(tmpHoldingMessage.fromid,3,amount,"Shared payroll payment from " + getRegionOrCity().name + ".",placeholder);

        if(getRegionOrCity().mail.length > 0) {
            document.getElementById("imMail").style.display = "inline-block";
        } else {
            document.getElementById("imMail").style.display = "none";
        }

        reopenMailIfAny();
    }

    function rejectCommonwealthPayroll() {
        if(tmpHoldingMessage == null || currentGame == null) {
            return;
        }

        removeFromArray(getRegionOrCity().mail,tmpHoldingMessage);

        sendMessage(tmpHoldingMessage.fromid,0,0,getRegionOrCity().name + " has rejected your request for payroll assistance.",placeholder);

        if(getRegionOrCity().mail.length > 0) {
            document.getElementById("imMail").style.display = "inline-block";
        } else {
            document.getElementById("imMail").style.display = "none";
        }

        reopenMailIfAny();
    }

    function deleteMail() {
        if(tmpHoldingMessage == null || currentGame == null) {
            return;
        }

        removeFromArray(getRegionOrCity().mail,tmpHoldingMessage);

        if(getRegionOrCity().mail.length > 0) {
            document.getElementById("imMail").style.display = "inline-block";
        } else {
            document.getElementById("imMail").style.display = "none";
        }

        if(tmpHoldingMessage.accountLevelMessage && tmpHoldingMessage.accountMessageId > 0) {
            webAppCore.deleteAccountMessage(tmpHoldingMessage.accountMessageId,placeholder);
        }

        tmpHoldingMessage = null;

        reopenMailIfAny();
    }

    var tmpNegoiationColony = null;

    function demandTribute(amount) {

        if(tmpNegoiationColony == null) {
            return;
        }

        if(amount == null || isNaN(amount) || amount.trim().length == 0) {
            webAppCore.showToast("Invalid amount");
            return;
        }

        var amt = parseInt(amount);

        if(amt < 0) {
            webAppCore.showToast("Invalid amount");
            return;
        }

        if(amt > 100) {
            webAppCore.showToast("Invalid amount");
            return;
        }

        sendMessage(tmpNegoiationColony.id,5,amt,"The " + getRegionOrCity().name + " General Assembly demands that you pay " + amt + "% of your " + ColonyGame.meta.tenderResource + " to help fund the Commonwealth." ,placeholder);
    }

    function rescindCharter() {
        if(tmpNegoiationColony == null) {
            return;
        }

        postMessageToAllChannels(tmpNegoiationColony.name + " has been kicked out of the Commonwealth of " + getRegionOrCity().name,"#F44336");

        sendMessage(tmpNegoiationColony.id,6,0,"You have been granted independence by the " + getRegionOrCity().name + " General Assembly.  Your rights in the Commonwealth of " + getRegionOrCity().name + " have been rescinded." ,placeholder);

        closeColonyWindow();

        showColonistsMenu("commonwealth");
    }

    var tmpResourceTag = null;

    function onRequestResourceType(tag) {
        if(tmpNegoiationColony == null) {
            return;
        }

        var resName = ColonyGame.meta.tenderResource;

        if(tag != "money") {
            resName = tag.name;
        }

        var message = "Times are bad in your chartered colony of " + getRegionOrCity().name + ".  The people are requesting a gift of " + resName + " to help them get by.";

        sendMessage(tmpNegoiationColony.id,0,0,message,placeholder);
        
        webAppCore.showToast("Request Sent");
    }

    function onSendResourceType(tag) {

        if(tag == null || tmpNegoiationColony == null || currentGame == null) {
            return;
        }
        
        
        tmpResourceTag = tag;

        var resName = ColonyGame.meta.tenderResource;

        if(tag != "money") {
            resName = tag.name;
        }
        
        if(!getGameResources()[resName]) {
            return;
        }

        var max = getGiftCapacity();

        if(max == 0) {
            webAppCore.showToast("Cannot send resources!");
            return;
        }

        var dialogOptions = {
            title: "Send Resource",
            message: "How much " + resName + " do you want to send (Max " + numberWithCommas(max) + ")?  You have " + numberWithCommas(getGameResources()[resName].amount) + ".",
            func: onInitResourceSend
        };

        webAppCore.inputBox(dialogOptions);

    }

    function onInitResourceSend(amount) {
        if(amount == null || isNaN(amount) || amount.trim().length == 0) {
            webAppCore.showToast("Invalid amount");
            return;
        }

        if(tmpNegoiationColony == null) {
            return;
        }

        if(tmpResourceTag == null) {
            return;
        }

        var max = getGiftCapacity();

        if(max == 0) {
            return;
        }

        var resName = ColonyGame.meta.tenderResource;

        if(tmpResourceTag != "money") {
            resName = tmpResourceTag.name;
        }

        var amt = parseInt(amount);

        if(isNaN(amt)) {
            webAppCore.showToast("Invalid amount");
            return;
        }

        if(amt > max) {
            webAppCore.showToast("Invalid amount");
            return;
        }

        if(amt <= 0) {
            webAppCore.showToast("Invalid amount");
            return;
        }

        if(amt > getGameResources()[resName].amount) {
            webAppCore.showToast("Invalid amount");
            return;
        }


        modifyResourceAmount(resName,-amt,false,"Commonwealth");

        var message = "A gift from " + getRegionOrCity().name + ".";

        if(getRegionOrCity().offlineMode) {

            

            if(tcpAvailable) {
                sendLocalTcpMessageObject(tmpNegoiationColony.sid,tmpNegoiationColony.tag,new LocalSocketMessage("resourcegift",{"resource":resName,"amount":amt}));

                tmpNegoiationColony = null;
                tmpResourceTag = null;

                webAppCore.showToast("Resources sent");

                webAppCore.logEvent("Local Multiplayer","Resources sent",resName);
            }

            return;
        }

        if(tmpResourceTag == "money") {
            sendMessage(tmpNegoiationColony.id,4,amt,message,postResourceSend);
        } else {
            sendMessage(tmpNegoiationColony.id,4,amt,message,postResourceSend,tmpResourceTag.id);
        }

        webAppCore.showToast("Resources sent");

        if(tmpHoldingMessage != null) {
            showStandardMessage(tmpHoldingMessage);
        }

        tmpSaveResources();
    }

    function postResourceSend() {
        if(tmpNegoiationColony == null) {
            return;
        }
  
    }

    function showPolicyMenu() {
        var menuOptions = [];
        var i;

        var roc = getRegionOrCity();

        if(!roc) {
            return;
        }

        if(roc.isIndependent && !roc.offlineMode && roc.governmentLevel >= 7) {

            var fedName = null;
            var fedColor = null;

            if(roc.federationId > 0 && roc.federationName) {
                fedName = roc.federationName;
                fedColor = "#4CAF50";
            }

            menuOptions.push({
                "title": getString("gen-federation"),
                "title-color": null,
                "description": getString("federation-desc"),
                "status": fedName,
                "status-color": fedColor,
                "icon": "images/" + ColonyGame.meta.federationsIndicator,
                "tag": "federation",
                "overflow": null
            });
        }


        if(roc.isIndependent && !roc.offlineMode) {
            var edictOption = {
                "title": getString("general-mass-message"),
                "title-color": null,
                "description": getString("general-mass-msg-desc"),
                "status": null,
                "status-color": null,
                "icon": "images/" + ColonyGame.meta.mailIndicator,
                "tag": "edict"
            };

            menuOptions.push(edictOption);

            if(!roc.privateCharter) {
                var salesOption = {
                    "title": getString("pol-salespitch-header"),
                    "title-color": null,
                    "description": getString("pol-salespitch-desc"),
                    "status": roc.salesPitch,
                    "status-color": null,
                    "icon": "images/" + ColonyGame.meta.empireIndicator,
                    "tag": "salespitch"
                };

                menuOptions.push(salesOption);
            }
        }

        if(roc.governmentLevel >= 1) {

            var autobudgetStatus = "Off";
            var autobudgetColor = "#F44336";

            if(roc.autoBudget) {
                autobudgetStatus = "On";
                autobudgetColor = "#4CAF50";
            }

            menuOptions.push({
                "title": getString("general-autobudget"),
                "title-color": null,
                "description": getString("general-autobudget-desc"),
                "status": autobudgetStatus,
                "status-color": autobudgetColor,
                "icon": "images/" + ColonyGame.meta.autobudgetInd,
                "tag": "autobudget"
            });
        }
        


        if(roc.governmentLevel >= 1 && !roc.isIndependent) {
            var baseIndependenceCost = ColonyGame.meta.baseIndependenceCost;
            var relationsPenalty = baseIndependenceCost.amount - (baseIndependenceCost.amount * (roc.earthAssemblyRelations / 100));
            var totalIndependenceCost = baseIndependenceCost.amount + relationsPenalty;

            var independenceColor = null;

            if(totalIndependenceCost > getGameResources()[baseIndependenceCost.resource].amount) {
                independenceColor = "#F44336";
            }

            var indOption = {
                "title": getString("general-declare-ind"),
                "title-color": null,
                "description": getString("general-declare-ind-desc"),
                "status": null,
                "status-color": null,
                "icon": "images/" + ColonyGame.meta.empireIndicator,
                "overflow": [
                    {
                        "pre":      "Cost",
                        "post":     numberWithCommas(totalIndependenceCost),
                        "color":    independenceColor,
                        "icon":     "images/" + getResourceByDefName(baseIndependenceCost.resource).icon
                    }
                ],
                "tag": "independence"
            };

            if(roc.earthBackTax > 0) {

                var supplementColor = null;

                if(getGameResources()[ColonyGame.meta.tenderResource].amount < roc.earthBackTax) {
                    supplementColor = "#F44336";
                }

                indOption.overflow.push({
                    "pre":      "Cost",
                    "post":     numberWithCommas(roc.earthBackTax),
                    "color":    supplementColor,
                    "icon":     "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                });
            }

            menuOptions.push(indOption);
        }

        var immigrationSetting = getString("general-allowed");
        var immigrationColor = "#4CAF50";

        if(roc.stopImmigration) {
            immigrationSetting = getString("general-blocked");
            immigrationColor = "#F44336";
        }
        
        if(roc.governmentLevel >= 1) {
            menuOptions.push({
                "title": "Immigration",
                "title-color": null,
                "description": "Whether or not to allow new immigrants to your colony.",
                "status": immigrationSetting,
                "status-color": immigrationColor,
                "icon": "images/" + ColonyGame.meta.podImmigradionInd,
                "tag": "immigration"
            });
        }

        var tourismSetting = getString("general-allowed");
        var tourismColor = "#4CAF50";

        if(roc.stopTourism) {
            tourismSetting = getString("general-blocked");
            tourismColor = "#F44336";
        }

        if(roc.governmentLevel >= 3) {
            menuOptions.push({
                "title": getString("general-tourism"),
                "title-color": null,
                "description": getString("policy-tourism-desc"),
                "status": tourismSetting,
                "status-color": tourismColor,
                "icon": "images/" + ColonyGame.meta.touristIcon,
                "tag": "tourism"
            });
        }
        
        if(roc.governmentLevel >= 2) {
            menuOptions.push({
                "title": getString("general-labor"),
                "title-color": null,
                "description": getString("labor-desc"),
                "status": null,
                "status-color": null,
                "icon": "images/" + ColonyGame.meta.polLaborInd,
                "tag": "labor"
            });
        }

        if(roc.governmentLevel >= 2) {

            var totalRepairCosts = 0;

            for(i = 0; i < currentGame.buildings.length; i++) {
                totalRepairCosts += getBuildingRepairCost(currentGame.buildings[i]);
            }

            var repairCostColor = null;

            if(totalRepairCosts > getGameResources()[ColonyGame.meta.tenderResource].amount) {
                repairCostColor = "#F44336";
            }

            if(!roc.offlineMode) {
                menuOptions.push({
                    "title": "Infrastructure Repair",
                    "title-color": null,
                    "description": "Repair all buildings in the colony at once.",
                    "status": null,
                    "status-color": null,
                    "icon": "images/" + ColonyGame.meta.showBuildSidebarIcon,
                    "overflow": [
                        {
                            "pre":  "Cost:",
                            "post": getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(totalRepairCosts),
                            color:  repairCostColor,
                            icon:   "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                        }
                    ],
                    "tag": "repairs"
                });
            }
        }

        if(roc.governmentLevel >= 1) {
            var livingWageTotalCost = currentGame.livingWageRate * getTotalPopulation();

            menuOptions.push({
                "title": getString("livingwage-header"),
                "title-color": null,
                "description": getString("livingwage-desc"),
                "status": null,
                "status-color": null,
                "overflow": [
                    {
                        "pre":  "Current:",
                        "post": getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(currentGame.livingWageRate),
                        color:  null,
                        icon:   "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                    },
                    {
                        "pre":  "Total:",
                        "post": getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(livingWageTotalCost),
                        color:  null,
                        icon:   "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                    }
                ],
                "icon": "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon,
                "tag": "livingwage"
            });
        }

        if(roc.governmentLevel >= 3) {
            var curRationsOption = "Disabled";
            var curRationsColor = "#4CAF50";

            if(roc.foodRationing) {
                curRationsOption = "Enabled";
                curRationsColor = "#F44336";
            }

            menuOptions.push({
                "title": getString("rationing-header"),
                "title-color": null,
                "description": getString("rationing-desc"),
                "status": curRationsOption,
                "status-color": curRationsColor,
                "icon": "images/" + ColonyGame.meta.rationingInd,
                "tag": "rations"
            });
        }

        if(roc.governmentLevel >= 4) {
            var currentTiles = currentGame.width * currentGame.height;
            var newTiles = (currentGame.width + 20) * (currentGame.height + 20);

            var difference = newTiles - currentTiles;

            var costs = [];

            for(i = 0; i < ColonyGame.meta.annexTileCost.length; i++) {

                var annexCostColor = null;

                if((difference * ColonyGame.meta.annexTileCost[i].amount) > getGameResources()[ColonyGame.meta.annexTileCost[i].resource].amount) {
                    annexCostColor = "#F44336";
                }

                costs.push({
                    "pre": "Cost:",
                    "post": numberWithCommas(difference * ColonyGame.meta.annexTileCost[i].amount),
                    "icon": "images/" + getResourceByDefName(ColonyGame.meta.annexTileCost[i].resource).icon,
                    "color": annexCostColor
                });
            }

            if(!currentGame.isSubregion) {
                menuOptions.push({
                    "title": getString("general-annex-land"),
                    "title-color": null,
                    "description": getString("general-annex-desc"),
                    "status": "Warning: Increasing map size MAY degrade performance.",
                    "status-color": "#F44336",
                    "icon": "images/" + ColonyGame.meta.annexInd,
                    "tag": "annex",
                    "overflow": costs
                });
            }
            
        }

        if(roc.governmentLevel >= 7) {
            menuOptions.push({
                "title": getString("general-deportations"),
                "title-color": null,
                "description": getString("gen-deportations-desc"),
                "status": getString("deportation-warning"),
                "status-color": "#F44336",
                "icon": "images/" + ColonyGame.meta.indDeport,
                "tag": "deportations",
                "overflow": null
            });
        }


        if(menuOptions.length == 0) {
            return;
        }

        showList(getString("general-policy"),menuOptions,onPolicyItemSelected,getString("general-nevermind"));
    }

    function onPolicyItemSelected(tag) {

        if(tag == null) {
            return;
        }

        var roc = getRegionOrCity();

        if(!roc) {
            return;
        }

        if(tag == "federation") {
            showFederationMenu();
        }

        if(tag == "salespitch") {
            setSalesPitch();
        }

        if(tag == "autobudget") {
            roc.autoBudget = !roc.autoBudget;
            showPolicyMenu();
        }

        if(tag == "edict") {
            sendCommonwealthEdict();
        }

        if(tag == "repairs") {
            repairAllBuildings();
            showPolicyMenu();
        }

        if(tag == "independence") {
            askForIndependence();
        }

        if(tag == "annex") {
            performAnnex();
            showPolicyMenu();
        }

        if(tag == "rations") {
            roc.foodRationing = !roc.foodRationing;
            showPolicyMenu();
        }

        if(tag == "tourism") {
            roc.stopTourism = !roc.stopTourism;
            showPolicyMenu();
        }

        if(tag == "immigration") {
            roc.stopImmigration = !roc.stopImmigration;
            showPolicyMenu();
        }

        if(tag == "workpolicy") {
            showWorkPolicyOptions();
        }

        if(tag == "labor") {
            manageLabor();
        }

        if(tag == "livingwage") {
            setTimeout(showLivingWageInput,500);
        }

        if(tag == "deportations") {
            showDeportationsMenu();
        }
    }

    function showDeportationsMenu() {

        var menuOptions = [];

        menuOptions.push({
            "title": getString("deport-arbitrary"),
            "title-color": null,
            "description": getString("deport-arbitrary-desc"),
            "status": null,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.homelessIndicator,
            "tag": "deportarbitrary"
        });

        menuOptions.push({
            "title": getString("deport-homeless"),
            "title-color": null,
            "description": getString("deport-homeless-desc"),
            "status": null,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.homelessIndicator,
            "tag": "deporthomeless"
        });

        menuOptions.push({
            "title": getString("deport-young"),
            "title-color": null,
            "description": getString("deport-young-desc"),
            "status": null,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.homelessIndicator,
            "tag": "deportpoor"
        });

        menuOptions.push({
            "title": getString("deport-elderly"),
            "title-color": null,
            "description": getString("deport-elderly-desc"),
            "status": null,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.homelessIndicator,
            "tag": "deportelderly"
        });

        menuOptions.push({
            "title": getString("general-go-back"),
            "title-color": null,
            "description": getString("general-go-back-desc"),
            "status": null,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.backIndicator,
            "tag": "back"
        });

        showList(getString("general-deportations"),menuOptions,onDeportationOptionSelected,getString("general-dismiss"));
    }

    function onDeportationOptionSelected(tag) {
        if(!tag) {
            return;
        }

        if(tag == "deportarbitrary") {
            var dialogOptions = {
                "title":    getString("deport-arbitrary"),
                "message":  getString("deport-arbitrary-ask"),
                func: onarbitraryDeport
            };
    
            webAppCore.inputBox(dialogOptions);
        }

        if(tag == "back") {
            showPolicyMenu();
        }

        if(tag == "deporthomeless") {
            deportTheHomeless();
        }

        if(tag == "deportpoor") {
            deportThePoor();
        }

        if(tag == "deportpoor") {
            deportElderly();
        }
    }

    function showLivingWageInput() {
        var dialogOptions = {
            title: getString("livingwage-header"),
            message: getString("livingwage-desc"),
            func: onLivingWageBack
        };

        webAppCore.inputBox(dialogOptions);
    }

    function onLivingWageBack(salary) {

        if(salary == null || salary.length == 0 || isNaN(salary) || parseInt(salary) < 0 || salary.trim().length == 0) {
            webAppCore.showToast("Invalid wage!");
            showPolicyMenu();
            return;
        }
        
        if(!currentGame) {
            return;
        }

        currentGame.livingWageRate = parseInt(salary);

        showPolicyMenu();

        webAppCore.showToast("Wage set!");
    }

    function checkColonyMailFromServer() {
        if(getRegionOrCity() == null || !getRegionOrCity().colonyId || getRegionOrCity().colonyId == 0) {
            return;
        }

        webAppCore.checkAccountMail(ColonyGame.meta.apeMarketId,getRegionOrCity().charter,onColonyServerMailBack);
    }

    function onColonyServerMailBack(data) {
        if(!data || data.trim().length == 0) {
            return;
        }

        if(startsWith(data,"login failed")) {
            webAppCore.logEvent("Server Mail Login Failed",webAppCore.getPlatform().platform,webAppCore.isApeAppsLoggedIn());
            return;
        }

        try {
            var serverMailData = JSON.parse(data);

            for(var i = 0; i < serverMailData.length; i++) {

                var newMsg = serverMailData[i];

                var itExists = false;

                for(var j = 0; j < getRegionOrCity().mail.length; j++) {
                    var oldmsg = getRegionOrCity().mail[j];

                    if(oldmsg.accountLevelMessage && parseInt(oldmsg.accountMessageId) == parseInt(newMsg.id)) {
                        itExists = true;
                        break;
                    }

                }

                if(!itExists) {
                    var fromCharter = newMsg.subject;
                    var fromColonyId = null;
                    var fromColonyName = null;

                    var charterInfo = getKnownInfoAboutCharter(fromCharter);

                    if(charterInfo) {
                        fromColonyId = charterInfo.id;
                        fromColonyName = charterInfo.name;

                        if(!charterInfo.apeAccount) {
                            postSecuredCallToApi([{
                                "key":      "c",
                                "value":    fromCharter
                            }],25,addDataToKnownCharters);
                        }
                    } else {
                        postSecuredCallToApi([{
                            "key":      "c",
                            "value":    fromCharter
                        }],25,addDataToKnownCharters);
                    }

                    var freshMessage = new MailMessage(fromColonyName,fromColonyId,null,newMsg.timestamp,"0",null,0);

                    if(newMsg.readflag == "1" || newMsg.viewed == "1") {
                        freshMessage.read = true;
                    }

                    freshMessage.accountLevelMessage = true;
                    freshMessage.accountMessageId = newMsg.id;
                    freshMessage.accountMessageFromUser = newMsg.fromname;
                    freshMessage.accountMessageFromCharter = fromCharter;

                    getRegionOrCity().mail.unshift(freshMessage);
                }

            }

        } catch(ex) {
            webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onColonyServerMailBack",ex.message);
            webAppCore.logEvent("Server Mail Parse Failure",webAppCore.getPlatform().platform,data);
        }

        alertNewMailIfNecessary();
    }

    function getKnownInfoAboutCharter(charter) {

        var ros = getRegionOrCity();

        if(ros == null || !ros.colonyId || ros.colonyId == 0) {
            return null;
        }

        for(var cid in ros.foreignContactReference) {
            var colInfo = ros.foreignContactReference[cid];

            if(colInfo.charter == charter) {
                return colInfo;
            }
        }

        postSecuredCallToApi([{
            "key":      "c",
            "value":    charter
        }],25,addDataToKnownCharters);

        return null;
    }

    function addDataToKnownCharters(result) {

        var roc = getRegionOrCity();

        if(!roc || !roc.colonyId || roc.colonyId == 0) {
            return;
        }

        var charterInfo = null;

        if(result != null && result.trim().length > 0) {
            try {
                charterInfo = JSON.parse(result)[0];
            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": addDataToKnownCharters",ex.message);
                return;
            }
        }

        if(charterInfo) {
            var immigrants = 0;
            var emHere = false;
            var emThere = false;

            if(roc.foreignContactReference[charterInfo.colonyid]) {
                if(roc.foreignContactReference[charterInfo.colonyid].immigrants) {
                    immigrants = parseInt(roc.foreignContactReference[charterInfo.colonyid].immigrants);
                }
                
                if(roc.foreignContactReference[charterInfo.colonyid].embassyhere) {
                    emHere = parseInt(roc.foreignContactReference[charterInfo.colonyid].embassyhere);
                }

                if(roc.foreignContactReference[charterInfo.colonyid].embassythere) {
                    emThere = parseInt(roc.foreignContactReference[charterInfo.colonyid].embassythere);
                }
            }

            roc.foreignContactReference[charterInfo.colonyid] = {
                "id": charterInfo.colonyid,
                "charter": charterInfo.charter,
                "name": charterInfo.colonyname,
                "race": charterInfo.race,
                "maptype": charterInfo.maptype,
                "sx": charterInfo.sectorx,
                "sy": charterInfo.sectory,
                "gx": charterInfo.gridx,
                "gy": charterInfo.gridy,
                "embassyhere": emHere,
                "embassythere": emThere,
                "immigrants": immigrants,
                "apeAccount": charterInfo.aausername
            };

        } 

    }

    function sendMessage(to,code,amount,message,callback,resourceId) {
        if(getRegionOrCity() == null || !getRegionOrCity().colonyId || getRegionOrCity().colonyId == 0) {
            return;
        }

        code = code.toString();

        if(code == "0" && to != "-15") {
            postSecuredCallToApi([{
                "key":      "cid",
                "value":    to
            }],39,function(result) {
                
                try {
                    var colonyInfo = JSON.parse(result)[0];
    
                    if(colonyInfo == null) {
                        return;
                    }
    
                    webAppCore.sendAccountMessage([colonyInfo.aausername],null,null,ColonyGame.meta.apeMarketId,colonyInfo.charter,getRegionOrCity().charter,message,function() {
                        informCharterOfNewMail(colonyInfo.charter);
                    });
    
                } catch(ex) {
                    webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": parseColonyInfoAndLaunchIn",ex.message);
                }

            });

            return;
        }

        if(to == "-15") {
            if(tmpHoldingMessage) {
                message = "RE: " + tmpHoldingMessage.message + "\n\n" + message;
            }
        }

        var data = [];

        data.push({
            "key":      "m",
            "value":    to
        });

        data.push({
            "key":      "c",
            "value":    code
        });

        data.push({
            "key":      "a",
            "value":    amount
        });

        data.push({
            "key":      "t",
            "value":    message
        });

        if(resourceId) {
            data.push({
                "key":      "r",
                "value":    resourceId
            });
        }

        postSecuredCallToApi(data,19,callback);


        if(usingSockets) {
            postInGameMessageToColony("checkmail",null,to);
        }   
    }

    function sendForMotherlandPayrollPayment(motherlandAmount) {
        if(currentGame == null || !getRegionOrCity().colonyId || getRegionOrCity().colonyId == 0 || getRegionOrCity().motherlandid == 0 || getRegionOrCity().offlineMode) {
            return;
        }

        sendMessage(getRegionOrCity().motherlandid,2,motherlandAmount,"Your shared payroll responsibility from " + getRegionOrCity().name + ".",placeholder);
    }

    

    function manageLabor() {

        if(!currentGame) {
            return;
        }

        var i,bDef;
        var totalSalary = 0;
        var totalWorkers = 0;

        var occupations = {};

        var unskilledSalary = 1;

        if(currentGame.salaries.Unskilled != null) {
            unskilledSalary = currentGame.salaries.Unskilled;
        }

        occupations.unskilled = {
            "name":     "Unskilled",
            "salary":   unskilledSalary,
            "workers":  0,
            "totalPay": 0,
            "icon":     ColonyGame.meta.colonistIcon
        };

        for(i = 0; i < ColonyGame.occupations.length; i++) {

            var salary = ColonyGame.occupations[i].salary;

            if(currentGame.salaries[ColonyGame.occupations[i].name] != null) {
                salary = currentGame.salaries[ColonyGame.occupations[i].name];
            }

            var icn = ColonyGame.meta.colonistIcon;

            if(ColonyGame.occupations[i].indicator != null) {
                icn = ColonyGame.occupations[i].indicator;
            }

            occupations[ColonyGame.occupations[i].name] = {
                "name":     ColonyGame.occupations[i].name,
                "salary":   salary,
                "workers":  0,
                "totalPay": 0,
                "icon":     icn
            };
        }

        var bld;

        for(i = 0; i < currentGame.buildings.length; i++) {

            bld = currentGame.buildings[i];

            if(!bld) {
                continue;
            }


            if(bld.buW > 0) {
                bDef = getBuildingDefByName(bld.def);

                if(occupations[bDef.occupation] != null) {
                    occupations[bDef.occupation].workers += bld.buW;
                    occupations[bDef.occupation].totalPay += (bld.buW * occupations[bDef.occupation].salary);
                    totalSalary += (bld.buW * occupations[bDef.occupation].salary);
                } else {
                    occupations.unskilled.workers += bld.buW;
                    occupations.unskilled.totalPay += (bld.buW * occupations.unskilled.salary);
                    totalSalary += (bld.buW * occupations.unskilled.salary);
                }

                totalWorkers += bld.buW;
            }
        }

        var menuOptions = [];

        if(getRegionOrCity().isIndependent && !getRegionOrCity().offlineMode) {
            menuOptions.push({
                "title": getString("general-online-pay-assis"),
                "title-color": null,
                "description": getString("online-payass-desc"),
                "status": "Current: " + numberWithCommas(Math.round(getRegionOrCity().payrollRate * 100)) + "%",
                "status-color": null,
                "icon": "images/" + ColonyGame.meta.empireIndicator,
                "tag":  "payassist"
            });
        }
        
        menuOptions.push({
            "title": "Total Workforce Estimate",
            "title-color": null,
            "description": null,
            "status": "Workers: " + numberWithCommas(totalWorkers),
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.totalWorkforceInd,
            "overflow": [
                {
                    pre:    "Total Salary: ",
                    post:   getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(totalSalary),
                    color:  null,
                    icon:   "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                }
            ],
            "tag": "total"
        });
        
        for(var prop in occupations) {
            menuOptions.push({
                "title": occupations[prop].name,
                "title-color": null,
                "description": null,
                "status": "Workers: " + numberWithCommas(occupations[prop].workers),
                "status-color": null,
                "icon": "images/" + occupations[prop].icon,
                "overflow": [
                    {
                        pre:    "Occupation Salary: ",
                        post:   getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(occupations[prop].salary),
                        color:  null,
                        icon:   "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                    },
                    {
                        pre:    "Total Salary: ",
                        post:   getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(occupations[prop].totalPay),
                        color:  null,
                        icon:   "images/" + getResourceByDefName(ColonyGame.meta.tenderResource).icon
                    }
                ],
                "tag": occupations[prop].name
            });
        }

        menuOptions.push({
            "title": getString("general-go-back"),
            "title-color": null,
            "description": getString("general-go-back-desc"),
            "status": null,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.backIndicator,
            "tag": "back"
        });

        if(menuOptions.length == 0) {
            return;
        }

        showList(getString("general-labor"),menuOptions,onOccupationSelected,getString("general-nevermind"));
    }

    var pendingOccupationSalary;

    function showPayrollAssistanceWindow() {

        var existingRate = getRegionOrCity().payrollRate;

        webAppCore.showDialog({
            title: getString("general-online-pay-assis"),
            message: getString("online-payass-desc"),
            icon: "images/" + ColonyGame.meta.polLaborInd,
            sliderMin: 0,
            sliderMax: 500,
            sliderValue: parseInt(getRegionOrCity().payrollRate * 100),
            sliderStatusText: parseInt(getRegionOrCity().payrollRate * 100) + "%",
            sliderCallback: function(val,fun) {
                getRegionOrCity().payrollRate = parseInt(val) / 100;
                fun(parseInt(getRegionOrCity().payrollRate * 100) + "%");
            },
            buttons: [
                {
                    text: getString("general-confirm"),
                    func: function(){
                        showColonistsMenu("commonwealth");
                        updateColonyStats();
                    },
                    color: "#4CAF50"
                },
                {
                    text: getString("general-cancel"),
                    func: function(){
                        getRegionOrCity().payrollRate = parseFloat(existingRate);
                    }
                }
            ]
        });
    }

    function onOccupationSelected(tag) {

        if(tag == null || tag == "back" || tag == "total") {
            showPolicyMenu();
            return;
        }

        var dialogOptions;

        if(tag == "payassist") {
            showPayrollAssistanceWindow();

            return;
        }

        pendingOccupationSalary = tag;

        dialogOptions = {
            title: "Salary",
            message: "Enter a new salary for the " + tag + " occupation.",
            func: onNewSalaryBack
        };

        webAppCore.inputBox(dialogOptions);
    }

    function onNewSalaryBack(salary) {
        if(salary == null || salary.length == 0 || isNaN(salary) || parseInt(salary) < 0 || salary.trim().length == 0) {
            webAppCore.showToast("Invalid salary!");
            return;
        }

        currentGame.salaries[pendingOccupationSalary] = parseInt(salary);
        manageLabor();
    }

    function getColonyInfoFromServer() {
        if(!currentGame || currentGame == null) {
            return;
        }

        if(!getRegionOrCity().colonyId || getRegionOrCity().colonyId == 0) {
            colonyNeverLoaded = false;
            webAppCore.clearSplash();
            return;
        }

        var data = [];

        postSecuredCallToApi(data,24,onColonyInfoReturned);
    }

    function postInGameMessageToColony(message,color,colonyid) {
        if(!usingSockets) {
            return;
        }

        if(!color) {
            color = getRegionOrCity().themeColor;
        }

        var targetRoom = "colony-" + colonyid;

        var sender = getRegionOrCity().colonyId;
        var charter = getRegionOrCity().charter;

        webAppCore.socketEmit("gamemessage",{
            "destination": targetRoom,
            "msg": {
                "type": "colony",
                "message": message,
                "senderid": sender,
                "sendercharter": charter,
                "sendercolor": color,
                "senderName": getRegionOrCity().name
            }
            
        });
    }

    function postMessageToAllChannels(message,color,customSenderId,customCharterId) {
        postToDiplomaticChannel(message,color,customSenderId,customCharterId);
        postInGameMessageToCommonwealth(message,color,customSenderId,customCharterId);
    }

    function postStargateMessage(message,color,customSenderId,customCharterId) {
        if(!usingSockets) {
            return;
        }

        if(!color) {
            color = getRegionOrCity().themeColor;
        }

        var sender = getRegionOrCity().colonyId;
        var charter = getRegionOrCity().charter;

        if(customSenderId) {
            sender = customSenderId;
        }

        if(customCharterId) {
            charter = customCharterId;
        }

        webAppCore.socketEmit("gamemessage",{
            "destination": "global-stargate",
            "msg": {
                "type": "stargate",
                "message": message,
                "senderid": sender,
                "sendercharter": charter,
                "sendercolor": color,
                "senderName": getRegionOrCity().name
            }
            
        });
    }

    function postToOnlineMetroArea(data) {
        if(!data) {
            return;
        }

        if(currentGame.isSubregion && currentRegion && currentRegion.isMpRegionHolder && currentSubcityRef) {
            var metroAreaId = currentSubcityRef.metroAreaDistrict;
            var targetRoom = "metro-area-" + metroAreaId;

            webAppCore.socketEmit("gamemessage",{
                "destination": targetRoom,
                "msg": data
                
            });
        }

        
    }

    function postToUserChannel(message,targetUser,extraData) {
        if(!usingSockets) {
            return;
        }

        if(!webAppCore.isApeAppsLoggedIn()) {
            return;
        }

        if(!extraData) {
            extraData = null;
        }

        var targetRoom = "apeuser-" + webAppCore.getApeAppsProfile().un;

        if(targetUser) {
            targetRoom = "apeuser-" + targetUser;
        }

        webAppCore.socketEmit("gamemessage",{
            "destination": targetRoom,
            "msg": {
                "type": "apeuser",
                "code": message,
                "data": extraData
            }
            
        });
    }

    function postToDiplomaticChannel(message,color,customSenderId,customCharterId) {
        if(!usingSockets) {
            return;
        }

        if(!color) {
            color = getRegionOrCity().themeColor;
        }

        var targetRoom = "diplomatic-" + getRegionOrCity().colonyId;

        if(targetRoom == 0) {
            return;
        }

        var sender = getRegionOrCity().colonyId;
        var charter = getRegionOrCity().charter;

        if(customSenderId) {
            sender = customSenderId;
        }

        if(customCharterId) {
            charter = customCharterId;
        }

        webAppCore.socketEmit("gamemessage",{
            "destination": targetRoom,
            "msg": {
                "type": "diplomatic",
                "message": message,
                "senderid": sender,
                "sendercharter": charter,
                "sendercolor": color,
                "senderName": getRegionOrCity().name
            }
            
        });
    }

    function postGlobalSocketNewsItem(messagedata) {
        if(!usingSockets) {
            return;
        }

        var color = getRegionOrCity().themeColor;

        var sender = getRegionOrCity().colonyId;
        var charter = getRegionOrCity().charter;

        var msgToSend = {
            "type": "globalnews",
            "data": messagedata,
            "senderid": sender,
            "sendercharter": charter,
            "sendercolor": color,
            "senderName": getRegionOrCity().name
        };

        webAppCore.socketEmit("gamemessage",{
            "destination": "globalnews",
            "msg": msgToSend
            
        });
    }

    function postInGameMessageToCommonwealth(message,color,customSenderId,customCharterId) {
        if(!usingSockets) {
            return;
        }

        if(!color) {
            color = getRegionOrCity().themeColor;
        }

        var targetRoom = 0;

        if(getRegionOrCity().isIndependent) {
            targetRoom = "commonwealth-" + getRegionOrCity().colonyId;
        } else {
            if(getRegionOrCity().motherlandid != 0) {
                targetRoom =  "commonwealth-" + getRegionOrCity().motherlandid;
            }
        }

        if(targetRoom == 0) {
            return;
        }

        var sender = getRegionOrCity().colonyId;
        var charter = getRegionOrCity().charter;

        if(customSenderId) {
            sender = customSenderId;
        }

        if(customCharterId) {
            charter = customCharterId;
        }

        webAppCore.socketEmit("gamemessage",{
            "destination": targetRoom,
            "msg": {
                "type": "commonwealth",
                "message": message,
                "senderid": sender,
                "sendercharter": charter,
                "sendercolor": color,
                "senderName": getRegionOrCity().name
            }
            
        });
    }

    function onColonyInfoReturned(result) {

        if(result != null && result.trim().length > 0) {
            try {
                var colonyInfo = JSON.parse(result)[0];

                if(colonyInfo == null) {
                    return;
                }

                var roc = getRegionOrCity();

                if(colonyInfo.blockonline == "1") {
                    roc.offlineMode = true;
                    roc.tradeNotifications = false;
                }

                roc.sX = colonyInfo.sectorx;
                roc.sY = colonyInfo.sectory;
                roc.gX = colonyInfo.gridx;
                roc.gY = colonyInfo.gridy;

                roc.charter = colonyInfo.charter;

                if(roc.isIndependent) {
                    setTimeout(getPendingEmbassyRequests,500);
                }

                if(colonyInfo.parentcolony && colonyInfo.parentcolony > 20) {
                    if(colonyInfo.parentcharter) {
                        roc.motherlandCharter = colonyInfo.parentcharter;
                    }
                }

                if(isCreatingNewOnlineGame) {
                    isCreatingNewOnlineGame = false;

                    if(usingSockets && !roc.isIndependent) {
                        if(parseInt(roc.motherlandid) > 20) {

                            setTimeout(function(){
                                webAppCore.socketEmit("joinroom","globalnews");
                                webAppCore.socketEmit("joinroom","commonwealth-" + roc.motherlandid);

                                postInGameMessageToCommonwealth(roc.name + " has joined the Commonwealth of " + roc.motherland);
                                postGlobalSocketNewsItem({
                                    "code": "newcolony",
                                    "platformcode": getPlaysonCode(),
                                    "sectorX": roc.sX,
                                    "sectorY": roc.sY
                                });
                            },5000);
                            
                            
                        }
                    }

                    setTimeout(updateColonyStats,150);
                } else {

                    setTimeout(function() {
                        updateColonyStats(true);
                    },150);
                }

                chatSetupQuick();

                if(roc.isRegion) {
                    readyToLoadSubcities = true;
                }

                setIndicatorCanStream();
                

            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onColonyInfoReturned",ex.message);
            }
        }
    }

    function setIndicatorCanStream() {
        var canStream = true;

        // it's dumb because iOS WOULD work, except the object comparison in getStreamItemForPeer always fails, and
        // you cannot add custom properties to the RTCPeerConnection on iOS. 
        if(webAppCore.getPlatform().platform == "windows" || webAppCore.getPlatform().platform == "ios") {
            canStream = false;
        }

        if(canStream) {
            streamingIndicator.style.display = "inline-block";
        } else {
            streamingIndicator.style.display = "none";
        }
    }

    function takeColonyOffline() {

        var roc = getRegionOrCity();

        if(!roc) {
            return;
        }

        if(!roc.colonyId || roc.colonyId == 0) {
            return;
        }

        var data = [];

        postSecuredCallToApi(data,26,placeholder);

        roc.offlineMode = true;
        roc.tradeNotifications = false;
        roc.charter = 0;
        roc.colonies = 0;
        roc.colonyId = 0;
        roc.apiKey = 0;

        turnOffStreaming();
        streamingIndicator.style.display = "none";

        webAppCore.showToast({
            message: "Online Mode Disabled",
            image:   "images/" + ColonyGame.meta.offlineModeInd
        });

        generalSaveGame();
    }

    function blacklistColony() {

        var ros = getRegionOrCity();

        if(!ros) {
            return;
        }

        if(ros.hasCheated) {
            return;
        }

        if(ros.offlineMode) {
            ros.hasCheated = true;
        }
    }

    function setupResourceLedger() {
        resourceLedger = {};

        for(var prop in getGameResources()) {
            if(prop == "statResSaveTimestamp") {
                continue;
            }

            resourceLedger[prop] = getGameResources()[prop].amount;
        }
    }

    function modifyResourceAmount(resource,amount,zeroOut,source) {

        if(currentGame == null) {
            return;
        }

        if(!resource) {
            return;
        }

        amount = Math.floor(amount);

        if(resourceLedger == null) {
            setupResourceLedger();
        }

        var rOrC = getRegionOrCity();

        if(getGameResources() == null) {
            rOrC.resources = {};
        }

        var res = getGameResources();

        if(!res[resource]) {
            webAppCore.logEvent("Resource Error","Invalid",resource);
            return;
        }

        if((res[resource].amount + amount) < 0) {
            zeroOut = true;
        }

        if(zeroOut) {
            resourceLedger[resource] = 0;
            res[resource].amount = 0;
            res[resource].domesticAmount = 0;
        } else {
            resourceLedger[resource] += amount;
            res[resource].amount += amount;
            res[resource].domesticAmount += amount;

            if(source) {
                if(amount > 0) {
                    if(!res[resource].inflows) {
                        res[resource].inflows = {};
                    }

                    if(!res[resource].inflows.current) {
                        res[resource].inflows.current = {};
                    }

                    if(!res[resource].inflows.total) {
                        res[resource].inflows.total = {};
                    }

                    if(!res[resource].inflows.allTime) {
                        res[resource].inflows.allTime = 0;
                    }

                    if(!res[resource].inflows.allCurrent) {
                        res[resource].inflows.allCurrent = 0;
                    }

                    if(!res[resource].inflows.current[source]) {
                        res[resource].inflows.current[source] = 0;
                    }

                    if(!res[resource].inflows.total[source]) {
                        res[resource].inflows.total[source] = 0;
                    }

                    res[resource].inflows.current[source] += amount;
                    res[resource].inflows.total[source] += amount;
                    res[resource].inflows.allTime += amount;
                    res[resource].inflows.allCurrent += amount;
                } else {
                    if(!res[resource].outflows) {
                        res[resource].outflows = {};
                    }

                    if(!res[resource].outflows.current) {
                        res[resource].outflows.current = {};
                    }

                    if(!res[resource].outflows.total) {
                        res[resource].outflows.total = {};
                    }

                    if(!res[resource].outflows.allTime) {
                        res[resource].outflows.allTime = 0;
                    }

                    if(!res[resource].outflows.allCurrent) {
                        res[resource].outflows.allCurrent = 0;
                    }

                    if(!res[resource].outflows.current[source]) {
                        res[resource].outflows.current[source] = 0;
                    }

                    if(!res[resource].outflows.total[source]) {
                        res[resource].outflows.total[source] = 0;
                    }

                    res[resource].outflows.current[source] += -amount;
                    res[resource].outflows.total[source] += -amount;
                    res[resource].outflows.allTime += -amount;
                    res[resource].outflows.allCurrent += -amount;
                }
            }
        }

        if(!currentGame.cm && resource == ColonyGame.meta.tenderResource && !zeroOut && source == "Trade") {
            if(amount > 0) {
                rOrC.annualTradeIncome += amount;
            } else {
                rOrC.annualTradeLosses += -amount;
            }
        }

        if(!currentGame.cm && resource == ColonyGame.meta.tenderResource) {
            if(res[resource].amount > 10000) {
                if(!ach10kReported && ColonyGame.achievements.tenthousandTender > 0) {
                    ach10kReported = true;
                    webAppCore.reportAchievement(ColonyGame.achievements.tenthousandTender);
                }
            }

            if(res[resource].amount > 100000) {
                if(!ach100kReported && ColonyGame.achievements.hundredThousandTender > 0) {
                    ach10kReported = true;
                    webAppCore.reportAchievement(ColonyGame.achievements.hundredThousandTender);
                }
            }

            if(res[resource].amount > 1000000) {
                if(!ach1milReported && ColonyGame.achievements.millionTender > 0) {
                    ach10kReported = true;
                    webAppCore.reportAchievement(ColonyGame.achievements.millionTender);
                }
            }

            // a random chance to report to Kongregate, so we are not constantly reporting
            var change = randomIntFromInterval(0,1000);

            if(change == 5) {
                checkDoKongStat("tenderResourceCount",res[resource].amount);
            }
        }

        // add to subregion stats if applicable 
        if(currentGame.isSubregion && currentSubcityRef && source) {
            if(source != "Wages" && source != "Welfare" && source != "Research" && source != "Construction" && source != "Trade" && source != "Gift" && source != "Commonwealth" && source != "Colonist" && source != "Tax" && source.indexOf("Regional.") != 0 && source != "Regional" && source != "Decay" && source != "Sale") {
                if(!currentSubcityRef.resourceHistory) {
                    currentSubcityRef.resourceHistory = {};
                }

                if(!currentSubcityRef.resourceHistory[resource]) {
                    currentSubcityRef.resourceHistory[resource] = {
                        in: 0,
                        out: 0,
                        avg: 0,
                        trend: []
                    };
                }

                if(amount > 0) {
                    currentSubcityRef.resourceHistory[resource].in += amount;
                }

                if(amount < 0) {
                    currentSubcityRef.resourceHistory[resource].out += -amount;
                }
            }
        }
        
    }

    function reconcileResources() {
        if(getRegionOrCity().hasCheated) {
            return;
        }

        if(resourceLedger == null) {
            return;
        }

        for(var prop in getGameResources()) {
            if(prop == "statResSaveTimestamp") {
                continue;
            }

            if(resourceLedger[prop] != getGameResources()[prop].amount) {
                blacklistColony();
                return;
            }
        }
    }

    function sortCityPopupResources(a,b) {
        if(a.amt > b.amt) {
            return -1;
        }

        if(a.amt < b.amt) {
            return 1;
        }

        return 0;
    }

    function sortFlows(a,b) {
        if(a.amount > b.amount) {
            return -1;
        }

        if(a.amount < b.amount) {
            return 1;
        }

        return 0;
    }

    function showChartsForResource(resource) {

        if(currentGame == null) {
            return;
        }

        var gameRes = getGameResources();

        if(gameRes[resource] == null || gameRes[resource].historic == null) {
            return;
        }

        var prop,i;

        document.getElementById("chartScreen").style.display = "block";
        document.getElementById("chartScreenTitle").innerHTML = resource;

        document.getElementById("resourceInflows").innerHTML = "";
        document.getElementById("resourceInflowsRegionalChartBreakdown").innerHTML = "";
        document.getElementById("resourceOutflows").innerHTML = "";
        document.getElementById("resourceOutflowsRegionalChartBreakdown").innerHTML = "";
        
        if(hasGBTBuilding && gameRes[resource].serverId) {
            document.getElementById("chartScreenTradeIcon").style.display = null;
            document.getElementById("chartScreenTradeIcon").onclick = function(){
                populateNewGbtResources({
                    "id": gameRes[resource].serverId,
                    "name": resource,
                    "price": gameRes[resource].price,
                    "detailed": {
                        "last": gameRes[resource].lastTrade
                    }
                });
            };
        } else {
            document.getElementById("chartScreenTradeIcon").style.display = "none";
        }

        var inflowArray = [];

        if(gameRes[resource].historic.inflows != null) {

            for(prop in gameRes[resource].historic.inflows) {

                inflowArray.push({
                    "source":   prop,
                    "amount":   gameRes[resource].historic.inflows[prop]
                });
            }
        }

        var inflowTotal = 0;
        var topValue,title;

        if(inflowArray.length > 0) {

            inflowArray.sort(sortFlows);

            topValue = inflowArray[0].amount;

            for(i = 0; i < inflowArray.length; i++) {

                inflowTotal += inflowArray[i].amount;

                if(!currentGame.isRegion) {

                    title = inflowArray[i].source;

                    if(startsWith(inflowArray[i].source,"Regional.")) {
                        title = "Regional (" + inflowArray[i].source.split(".")[1] + ")";
                    } 

                    document.getElementById("resourceInflows").appendChild(createStatBarGraph(inflowArray[i].amount,topValue,title,null,"#4CAF50"));

                }
            }
        }

        var sr,chartItems,chartColors,myPiechart,colIndex,item,pct,regTot,inflowTotalSpan;

        if(currentGame.isRegion) {
            
            chartItems = {};
            chartColors = [];
            regTot = 0;

            document.getElementById("resourceInflows").style.display = "none";
            document.getElementById("resourceInflowsRegionalChartBreakdown").style.display = "block";
            document.getElementById("resourceInflowsRegionalChart").style.display = "block";


            for(i = 0; i < currentGame.subRegions.length; i++) {
                sr = currentGame.subRegions[i];

                if(!sr.resourceHistory[resource] || sr.resourceHistory[resource].avg <= 0) {
                    continue;
                }

                if(!sr.statsColor) {
                    sr.statsColor = randomHexColor(255,120);
                }

                regTot += sr.resourceHistory[resource].avg; 

                chartItems[sr.name] = sr.resourceHistory[resource].avg;
                chartColors.push(sr.statsColor);
            }

            myPiechart = new Piechart({
                canvas:document.getElementById("resourceInflowsRegionalChart"),
                data:chartItems,
                colors:chartColors
            });
            myPiechart.draw();

            colIndex = 0;

            for(prop in chartItems) {


                if(chartItems[prop] == 0) {
                    colIndex++;
                    continue;
                }
 
                item = document.createElement("p");

                pct = ((chartItems[prop] / regTot) * 100).toFixed(1) + "%";

                item.innerHTML = prop + ": " + pct;
                item.style.color = chartColors[colIndex];
                document.getElementById("resourceInflowsRegionalChartBreakdown").appendChild(item);
    
                colIndex++;
            }

            inflowTotalSpan = document.createElement("span");
            inflowTotalSpan.innerHTML = "Total Inflows: " + numberWithCommas(inflowTotal);
            inflowTotalSpan.className = "flowTotalItem";
            document.getElementById("resourceInflowsRegionalChartBreakdown").appendChild(inflowTotalSpan);
        } else {
            document.getElementById("resourceInflows").style.display = "block";
            document.getElementById("resourceInflowsRegionalChartBreakdown").style.display = "none";
            document.getElementById("resourceInflowsRegionalChart").style.display = "none";

            inflowTotalSpan = document.createElement("span");
            inflowTotalSpan.innerHTML = "Total Inflows: " + numberWithCommas(inflowTotal);
            inflowTotalSpan.className = "flowTotalItem";
            document.getElementById("resourceInflows").appendChild(inflowTotalSpan);
        }

        document.getElementById("resourceOutflows").innerHTML = "";

        var outflowArray = [];

        if(gameRes[resource].historic.outflows != null) {

            for(prop in gameRes[resource].historic.outflows) {

                outflowArray.push({
                    "source":   prop,
                    "amount":   gameRes[resource].historic.outflows[prop]
                });
            }
        }

        var totalOutflow = 0;
        var ioutflowTotalSpan;

        if(outflowArray.length > 0) {

            outflowArray.sort(sortFlows);
            

            topValue = outflowArray[0].amount;

            for(i = 0; i < outflowArray.length; i++) {

                totalOutflow += outflowArray[i].amount;

                if(!currentGame.isRegion) {

                    title = outflowArray[i].source;

                    if(startsWith(outflowArray[i].source,"Regional.")) {
                        title = "Regional (" + outflowArray[i].source.split(".")[1] + ")";
                    } 

                    document.getElementById("resourceOutflows").appendChild(createStatBarGraph(outflowArray[i].amount,topValue,title,null,"#f44336"));
                }
            }

            
        }

        if(currentGame.isRegion) {

            chartItems = {};
            chartColors = [];
            regTot = 0;

            document.getElementById("resourceOutflows").style.display = "none";
            document.getElementById("resourceOutflowsRegionalChart").style.display = "block";
            document.getElementById("resourceOutflowsRegionalChartBreakdown").style.display = "block";


            for(i = 0; i < currentGame.subRegions.length; i++) {
                sr = currentGame.subRegions[i];

                if(!sr.resourceHistory[resource] || sr.resourceHistory[resource].avg >= 0) {
                    continue;
                }

                if(!sr.statsColor) {
                    sr.statsColor = randomHexColor(255,120);
                }

                regTot += sr.resourceHistory[resource].avg; 

                chartItems[sr.name] = sr.resourceHistory[resource].avg;
                chartColors.push(sr.statsColor);
            }

            myPiechart = new Piechart({
                canvas:document.getElementById("resourceOutflowsRegionalChart"),
                data:chartItems,
                colors:chartColors
            });
            myPiechart.draw();

            colIndex = 0;

            for(prop in chartItems) {


                if(chartItems[prop] == 0) {
                    colIndex++;
                    continue;
                }
 
                item = document.createElement("p");

                pct = ((chartItems[prop] / regTot) * 100).toFixed(1) + "%";

                item.innerHTML = prop + ": " + pct;
                item.style.color = chartColors[colIndex];
                document.getElementById("resourceOutflowsRegionalChartBreakdown").appendChild(item);
    
                colIndex++;
            }

            ioutflowTotalSpan = document.createElement("span");
            ioutflowTotalSpan.innerHTML = "Total Outflows: " + numberWithCommas(totalOutflow);
            ioutflowTotalSpan.className = "flowTotalItem";
            document.getElementById("resourceOutflowsRegionalChartBreakdown").appendChild(ioutflowTotalSpan);
        } else {
            document.getElementById("resourceOutflows").style.display = "block";
            document.getElementById("resourceOutflowsRegionalChart").style.display = "none";
            document.getElementById("resourceOutflowsRegionalChartBreakdown").style.display = "none";

            ioutflowTotalSpan = document.createElement("span");
            ioutflowTotalSpan.innerHTML = "Total Outflows: " + numberWithCommas(totalOutflow);
            ioutflowTotalSpan.className = "flowTotalItem";
            document.getElementById("resourceOutflows").appendChild(ioutflowTotalSpan);
        }

        var resourceTrendChart = document.getElementById("resourceTrendChart");

        var trendColor = "#689F38";

        if(totalOutflow > inflowTotal) {
            trendColor = "#F44336";
        }

        if(totalOutflow == inflowTotal) {
            trendColor = "#2196F3";
        }

        drawLineChart(resourceTrendChart,gameRes[resource].trend,null,null,trendColor);

    }


    function setSalesPitch() {
        var dialogOptions = {
            title: getString("pol-salespitch-header"),
            message: getString("pol-salespitch-desc") + "<br /><br />Current: " + getRegionOrCity().salesPitch,
            func: onSalesPitchSet
        };

        webAppCore.inputBox(dialogOptions);
    }
    
    function onSalesPitchSet(message) {
        if(message == null) {
            return;
        }

        if(message.trim().length > 100) {
            webAppCore.showToast("Too many characters (" + message.trim().length + ")");
            return;
        }

        if(message.trim().length == 0) {
            getRegionOrCity().salesPitch = "0";
        } else {
            getRegionOrCity().salesPitch = message.trim();
        }

        updateColonyStats();

        showColonistsMenu("commonewalth");
    }

    var tmpNewMsgTo = null;

    function sendCommonwealthEdict() {
        var dialogOptions = {
            title: getString("general-mass-message"),
            message: getString("general-mass-msg-desc"),
            func: onEdictSend
        };

        webAppCore.inputBox(dialogOptions);
        
    }

    function onEdictSend(message) {
        if(message == null || message.trim().length < 2 || message.trim().length > 120) {
            webAppCore.showToast("Invalid message length!");
            return;
        }

        var roc = getRegionOrCity();

        if(!roc) {
            return;
        }

        message = replaceAll(message,"\"","");
        message = replaceAll(message,"'","");

        var data = [];

        data.push({
            "key":      "c",
            "value":    roc.charter
        });

        data.push({
            "key":      "m",
            "value":    message
        });

        postSecuredCallToApi(data,31,function() {
            webAppCore.showToast("Message Sent");
        });

    }

    var lantag = null;

    function sendACustomMessage(to,lt) {

        tmpNewMsgTo = to;
        lantag = lt;

        var dialogOptions = {
            title: getString("general-send-custom-msg"),
            message: getString("general-send-msg-warn"),
            func: onCWMessageSend
        };

        webAppCore.inputBox(dialogOptions);
    }

    function onCWMessageSend(message) {

        if(message == null || message.trim().length < 2 || message.trim().length > 120) {
            webAppCore.showToast("Invalid message length!");
            return;
        }

        if(tmpNewMsgTo == null || tmpNewMsgTo == 0) {
            return;
        }

        if(getRegionOrCity().offlineMode) {

            if(tcpAvailable) {
                sendLocalTcpMessageObject(tmpNewMsgTo,lantag,new LocalSocketMessage("privateMessage",message));

                webAppCore.logEvent("Local Multiplayer","Message sent",tmpNewMsgTo);

                tmpNewMsgTo = null;
                lantag = null;

                
            }

            return;
        }

        message = replaceAll(message,"\"","");
        message = replaceAll(message,"'","");

        sendMessage(tmpNewMsgTo,0,0,message.trim().latinize(),sendMsgConfirm);

        if(tmpHoldingMessage != null) {
            showStandardMessage(tmpHoldingMessage);
        }
    }

    function connectToSocketsIfNecessary() {
        if(!currentGame.offlineMode) {
            if(!currentGame.isSubregion || (currentGame.isSubregion && currentRegion && currentRegion.isMpRegionHolder && currentSubcityRef)) {
                establishSocketConnection();
            }
        }
    }

    function sendMsgConfirm() {
        webAppCore.showToast("Message Sent");

        if(tmpNewMsgTo == null) {
            return;
        }

        if(usingSockets) {
            postInGameMessageToColony("checkmail",null,tmpNewMsgTo);
        }  
    }

    function onSocketConnect() {
        usingSockets = true;

        setTimeout(announceOnlineToSockets,500);
    }

    function announceOnlineToSockets() {

        var roc = getRegionOrCity();

        var i;

        if(roc && roc.colonyId != 0) {

            if(roc.tradeNotifications) {
                webAppCore.socketEmit("joinroom","trades");
            }

            webAppCore.socketEmit("joinroom","globalnews");
            webAppCore.socketEmit("joinroom","notification-" + roc.charter);
            webAppCore.socketEmit("joinroom","colony-" + roc.colonyId);
            webAppCore.socketEmit("joinroom","diplomatic-" + roc.colonyId);
            webAppCore.socketEmit("joinroom","streaming-" + roc.colonyId);

            if(webAppCore.isApeAppsLoggedIn()) {
                webAppCore.socketEmit("joinroom","apeuser-" + webAppCore.getApeAppsProfile().un);

                if(friendsList.confirmed && friendsList.confirmed.length > 0) {
                    for(i = 0; i < friendsList.confirmed.length; i++) {
                        var friend = friendsList.confirmed[i];

                        if(!friend) {
                            continue;
                        }

                        webAppCore.socketEmit("joinroom","apeuser-" + friend.un);
                    }
                    
                }
            }

            if(currentGame.isSubregion && currentRegion && currentRegion.isMpRegionHolder && currentSubcityRef) {
                var metroAreaId = currentSubcityRef.metroAreaDistrict;
                webAppCore.socketEmit("joinroom","metro-area-" + metroAreaId);

                postToOnlineMetroArea({
                    "type": "metro",
                    "data": {
                        "type": "isonline",
                        "city": currentGame.name,
                        "charter": currentGame.charter,
                        "id": currentGame.colonyId,
                        "color": currentGame.themeColor
                    }
                });
            }

            postToDiplomaticChannel(roc.name + " is online");

            if(roc.isIndependent) {
                webAppCore.socketEmit("joinroom","commonwealth-" + roc.colonyId);
                postInGameMessageToCommonwealth(roc.name + " is online");
            } else {
                if(parseInt(roc.motherlandid) > 20) {
                    webAppCore.socketEmit("joinroom","commonwealth-" + roc.motherlandid);
                    postInGameMessageToCommonwealth(roc.name + " is online");
                }
            }

            // join embassy diplomatic channels 
            for(i = 0; i < currentGame.buildings.length; i++) {
                if(!currentGame.buildings[i]) {
                    continue;
                }

                var def = getBuildingDefByName(currentGame.buildings[i].def);

                // perhaps nuke this building if needed?  But this is probably because they opened game on a newer version
                if(!def) {
                    continue;
                }

                if(def.isEmbassy) {
                    webAppCore.socketEmit("joinroom","diplomatic-" + currentGame.buildings[i].embassyFor);
                }
            }

            // join stargate channel 
            if(hasStargate) {
                webAppCore.socketEmit("joinroom","global-stargate");
                postStargateMessage(getRegionOrCity().name + " has entered stargate channel");
            }
        }

        if(webAppCore.isApeAppsLoggedIn()) {
            postToUserChannel("notification",null,{
                "message": webAppCore.getApeAppsProfile().un + " is online",
                "color": "#4CAF50",
                "username": webAppCore.getApeAppsProfile().un
            });
        }
    }

    function onSocketDisconnect() {
        usingSockets = false;
    }

    function informCharterOfNewMail(charter) {
        if(!charter) {
            return;
        }

        var regionOrCity = getRegionOrCity();

        if(!regionOrCity) {
            return;
        }

        var data = [];

        data.push({
            "key":      "from",
            "value":    regionOrCity.charter
        });

        data.push({
            "key":      "to",
            "value":    charter
        });

        postSecuredCallToApi(data,59,placeholder);
    }

    function createNotification(icon,text,color,callback,tag,noTimeout,circleIcon) {


        var notification = document.createElement("div");
        notification.className = "notification";

        if(tag) {
            notification.tag = tag;
        }

        var notificationIcon = document.createElement("img");
        notificationIcon.src = icon;
        notificationIcon.className = "notificationIcon";

        if(circleIcon) {
            notificationIcon.className = "notificationIcon notificationIconCircular";
        }

        notification.appendChild(notificationIcon);

        var notificationText = document.createElement("span");
        notificationText.className = "notificationText";

        if(callback) {
            notificationText.onclick = callback;
        }

        if(color) {
            notificationText.style.color = color;
        }

        notificationText.innerHTML = text;
        notification.appendChild(notificationText);

        if(!noTimeout) {
            var notificationX = document.createElement("span");
            notificationX.className = "notificationX";
            notificationX.innerHTML = "X";
            notificationX.notifRef = notification;
            notificationX.onclick = function() {

                if(!this.notifRef) {
                    return;
                }
    
                if(this.notifRef.timerRef) {
                    clearTimeout(this.notifRef.timerRef);
                }
    
                if(this.notifRef.parentNode == null) {
                    return;
                }
    
                this.notifRef.parentNode.removeChild(this.notifRef);
            };
            notification.appendChild(notificationX);
        }
        

        if(!noTimeout) {
            if(text.indexOf(" is online") > 0 || text.indexOf(" has gone offline") > 0) {
                notification.timerRef = setTimeout(function() {
                    if(notification.parentElement) {
                        notification.parentElement.removeChild(notification);
                    }
                },6000);
            } else {
                notification.timerRef = setTimeout(function() {
                    if(notification.parentElement) {
                        notification.parentElement.removeChild(notification);
                    }
                },12000);
            }
        }
        

        return notification;
    }

    function handleMatroSocketMessage(data) {

        if(!currentRegion) {
            return;
        }

        var i,diff,res;
        var gameRes = getGameResources();

        if(data && data.type) {

            if(data.type == "contractpurchase") {
                for(i = 0; i < data.res.length; i++) {
                    var resAmt = data.res[i];
                    res = resAmt.res;
                    var amt = resAmt.amt;

                    diff = parseInt(amt) - gameRes[res].amount;
                    modifyResourceAmount(res,diff,false,"Regional." + data.name);
                }
            }

            if(data.type == "capdata") {
                var subcityRef = null;

                for(i = 0; i < currentRegion.subRegions.length; i++) {
                    if(currentRegion.subRegions[i].subcityGuid == data.guid) {
                        subcityRef = currentRegion.subRegions[i];
                        break;
                    }
                }

                if(subcityRef) {
                    

                    subcityRef.resourceCapacities = data.caps.res;
                    subcityRef.utilityCapacities = data.caps.utils;

                    for(res in data.res) {

                        diff = parseInt(data.res[res]) - gameRes[res].amount;

                        if(diff > 0) {
                            modifyResourceAmount(res,diff,false,"Regional." + data.name);
                        } else {
                            var useDiff = Math.round(-diff * 0.75);
                            if(useDiff > gameRes[res].amount) {
                                useDiff = gameRes[res].amount;
                            }

                            modifyResourceAmount(res,-useDiff,false,"Regional." + data.name);
                        }


                    }
                }
            }

            if(data.type == "isonline") {
                displayInGameNotification("images/" + ColonyGame.meta.mpRegionInd,data.city + " is online",data.color,function(){
                    getColonyInfoAndLaunchInfo(data.id);
                },data);
            }

            if(data.type == "unlocktech") {
                var techName = data.tech;
                var tech = getTechByName(techName);

                if(tech) {
                    webAppCore.showToast({
                        "message":      "Unlocked " + tech.name,
                        "image":        "images/" + tech.icon
                    });
            
                    getGameTechs()[tech.name] = true;

                    displayInGameNotification("images/" + tech.icon,data.city + " has unlocked " + tech.name,data.color,function(){
                        getColonyInfoAndLaunchInfo(data.id);
                    },data);
                }
            }
        }
    }

    function getTechByName(name) {
        for(var i = 0; i < ColonyGame.technology.length; i++) {
            var tech = ColonyGame.technology[i];

            if(tech.name == name) {
                return tech;
            }
        }

        return null;
    }

    function onSocketMessage(message) {

        if(currentGame == null) {
            return;
        }

        var roc = getRegionOrCity();

        var notifyicon = "images/" + ColonyGame.meta.empireIndicator;

        var callback;

        if(message.type == "globalnews") {
            handleGlobalNewsMessage(message);
            return;
        }

        if(message.type == "adminaction") {
            handleAdministrativeAction(message);
            return;
        }

        if(message.type == "metro") {
            handleMatroSocketMessage(message.data);
            return;
        }

        var i;

        if(message.type == "notification") {
            if(message.message == "newmail") {
                checkMail();
            }
        }

        if(message.type == "apeuser") {
            if(message.code == "areyouonline") {
                var profile = webAppCore.getApeAppsProfile();

                if(profile) {
                    postToUserChannel("yesimonline",null,profile.un);
                }
                
            }

            if(message.code == "yesimonline") {

                var statusCardsClass = ".userNameCardStatus" + message.data;

                var cards = document.querySelectorAll(statusCardsClass);

                for(i = 0; i < cards.length; i++) {
                    cards[i].innerHTML = "Online";
                    cards[i].className += " online";
                }
            }

            if(message.code == "notification") {

                var icon = "https://accounts.ape-apps.com/getavatar.php?u=" + message.data.username;

                displayInGameNotification(icon,message.data.message,message.data.color,function(){
                    showUserProfile(message.data.username);
                },message.data.username,true);
            }
        }

        if(message.type == "stargate") {
            

            if(message.message.immigrant) {
                // a 5% chance to take this immigrant 
                var immigrantchance = randomIntFromInterval(0,100);

                if(immigrantchance < 5) {

                    if(openStargateArray.length > 0) {

                        currentGame.immigrantSources.push(message.senderName);

                        var immigrantAge = parseInt(message.message.immigrant.age);

                        if(!immigrantAge || isNaN(immigrantAge)) {
                            immigrantAge = null;
                        }

                        currentGame.totalImmigration++;

                        while(currentGame.immigrantSources.length > 400) {
                            currentGame.immigrantSources.shift();
                        }

                        createNewPerson(immigrantAge,1,currentGame);

                        if(currentGame.populationStats[message.message.immigrant.race] === undefined) {
                            currentGame.populationStats[message.message.immigrant.race] = 0;
                        }

                        currentGame.populationStats[message.message.immigrant.race]++;
                    }
                }
            }

        }

        if(message.type == "colony") {

            if(message.message == "checkmail") {
                checkMail();
                return;
            }

            if(message.message.aid) {
                if(message.message.aid.info == "aidpackage") {

                    webAppCore.showDialog({
                        "title":    "Humanitarian Aid",
                        "message":  message.message.aid.from + " has dropped " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(parseInt((message.message.aid.amount))) + " onto your colony."
                    });
                    
                }
            }

            if(message.message == "checkvitals") {

                var response = {
                    "vitals": {
                        "info": "sendvitals",
                        "anarchy": anarchyWarned,
                        "rioting": riotingWarned,
                        "famine": famineWarned,
                        "dehydration": noWaterWarned,
                        "charter": roc.charter
                    }
                };

                postInGameMessageToColony(response,null,message.senderid);
                return;
            }

            if(tmpNegoiationColony != null && message.message.vitals && message.message.vitals.info == "sendvitals") {

                if(message.message.vitals.charter && message.message.vitals.charter == tmpNegoiationColony.charter) {
                    if(message.message.vitals.anarchy || message.message.vitals.rioting) {
                        if(getGameResources()[ColonyGame.meta.tenderResource].amount > (tmpNegoiationColony.population * 100)) {
                            document.getElementById("colonyCoinShower").style.display = "initial";
                            document.getElementById("colonyCoinShower").onclick = function() {
                                webAppCore.showDialog({
                                    "title":    "Humanitarian Aid",
                                    "message":  tmpNegoiationColony.name + " has fallen into chaos.  Would you like to send a humanitarian aid package worth " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(parseInt((tmpNegoiationColony.population * 100))) + "?  The money will go straight to the colonists, not the colony owner.",
                                    "op1": {
                                        "text":     getString("general-yes"),
                                        "func":     function() {
                                            if(tmpNegoiationColony == null) {
                                                return;
                                            }

                                            var response = {
                                                "aid": {
                                                    "info": "aidpackage",
                                                    "resource": anarchyWarned,
                                                    "amount": parseInt(tmpNegoiationColony.population) * 100,
                                                    "from": roc.name
                                                }
                                            };

                                            postInGameMessageToColony(response,roc.themeColor,tmpNegoiationColony.id);

                                            modifyResourceAmount(ColonyGame.meta.tenderResource,-(parseInt(tmpNegoiationColony.population) * 100),false,"Humanitarian Aid");
                                        }
                                    },
                                    "op2": {
                                        "text":     getString("general-no"),
                                        "func":     placeholder
                                    }
                                });
                            };
                        }
                    }
                }

                return;
            }
        }

        if(message.type == "commonwealth" || message.type == "diplomatic") {

            if(message.type == "diplomatic") {
                notifyicon = "images/" + ColonyGame.meta.diplomacyIndicator;
            }

            if(message.message == "onlineping") {
                if(message.type == "diplomatic") {
                    postToDiplomaticChannel("onlinepong");
                } else {
                    postInGameMessageToCommonwealth("onlinepong");
                }
                
                return;
            }

            if(message.message == "onlinepong") {
                commonwealthOnlineColonies++;
                
                commonwealthPongFrom(message.senderid);
                return;
            }

            callback = function() {
                getColonyInfoAndLaunchInfo(message.senderid);
            };

            // on executions, lower colony happiness 
            if(message.message.indexOf(" has executed ") > -1) {
                //doGlobalMoodModification(-3);

                if(message.senderName && getGameResources()[ColonyGame.meta.transactionCostResource].amount >= 5) {
                    callback = function() {
                        

                        var msg = message.senderName + ", a member of our " + getString("empire-general") + ", has publicly executed one of its citizens.  For 5 " + ColonyGame.meta.transactionCostResource + ", you may publicly condemn their action across the Commonwealth.  Your people will approve of your leadership.";

                        webAppCore.showDialog({
                            "title":    getString("general-condemn") + " " + message.senderName,
                            "message":  msg,
                            "op1": {
                                "text":     getString("general-condemn"),
                                "func":     function() {
                                    //doGlobalMoodModification(2);

                                    if(message.type == "diplomatic") {
                                        postToDiplomaticChannel(getRegionOrCity().name + " condemns " + message.senderName + "'s execution.");
                                    } else {
                                        postInGameMessageToCommonwealth(getRegionOrCity().name + " condemns " + message.senderName + "'s execution.");
                                    }

                                    
                                }
                            },
                            "op2": {
                                "text":     getString("general-no"),
                                "func":     placeholder
                            }
                        });

                    };
                }
            }

            displayInGameNotification(notifyicon,message.message,message.sendercolor,callback,message);

        }

        if(message.type == "trade") {

            if(gbtOpen || roc.tradeNotifications) {

                var resource = getResourceByServerId(message.resource);

                if(resource == null) {
                    return;
                }

                var unitPrice = parseInt(message.price) / parseInt(message.amount);
                var hundoPrice = Math.round(unitPrice * 100);

                var tradeColor = null;

                if(hundoPrice > getGameResources()[resource.name].lastTrade) {
                    tradeColor = "#33691E";
                }

                if(hundoPrice < getGameResources()[resource.name].lastTrade) {
                    tradeColor = "#B71C1C";
                }

                if(resource != null) {
                    if(message.action == "purchased") {

                        if(showingLive) {
                            updateLivePrice(message.resource,hundoPrice);
                        }


                        if(hundoPrice > getGameResources()[resource.name].lastTrade) {
                            tradeColor = "#33691E";
                        }

                        if(hundoPrice < getGameResources()[resource.name].lastTrade) {
                            tradeColor = "#B71C1C";
                        }


                        addItemToNewsTicker("Sold: " + numberWithCommas(parseInt(message.amount)) + " " + resource.name + " @ " + numberWithCommas(hundoPrice) + " per 100",tradeColor,function() {
                            populateNewGbtResources({
                                "id": message.resource,
                                "name": resource.name,
                                "price": getGameResources()[resource.name].price,
                                "detailed": {
                                    "last": getGameResources()[resource.name].lastTrade
                                }
                            });
                        },true);
                    }

                    if(message.action == "posted") {

                        var opacity = 1;
                        callback = undefined;
                        var contractItem;

                        if(message.contract == "1") {
                            if(hundoPrice > getGameResources()[resource.name].lastTrade) {
                                tradeColor = "#33691E";
                            }

                            if(hundoPrice < getGameResources()[resource.name].lastTrade) {
                                tradeColor = "#B71C1C";
                            }

                            if(parseInt(message.amount) > getGameResources()[resource.name].amount) {
                                opacity = 0.4;
                            }

                            if(!isThereResourceCapacity(resource.name,parseInt(message.amount))) {
                                opacity = 0.4;
                            }
                            
                            if(opacity == 1) {
                                callback = function() {
                                    contractItem = {
                                        "fromTicker": true,
                                        "resourceName": resource.name,
                                        "contractRef": {
                                            "id": message.id,
                                            "isoffer": message.contract,
                                            "quantity": message.amount,
                                            "price": message.price,
                                            "resourceid": parseInt(message.resource),
                                            "sellerid": parseInt(message.trader)
                                        }
                                    };

                                    purchaseNewGBTContract(contractItem);
                                };
                            }


                            addItemToNewsTicker("Will Buy: " + numberWithCommas(parseInt(message.amount)) + " " + resource.name + " for " + numberWithCommas(parseInt(message.price)) + " @ " + numberWithCommas(hundoPrice) + " per 100",tradeColor,callback,true,opacity);
                        } else {

                            if(hundoPrice > getGameResources()[resource.name].lastTrade) {
                                tradeColor = "#B71C1C";
                            }

                            if(hundoPrice < getGameResources()[resource.name].lastTrade) {
                                tradeColor = "#33691E";
                            }

                            

                            if(parseInt(message.price) > getGameResources()[ColonyGame.meta.tenderResource].amount) {
                                opacity = 0.4;
                            }

                            if(opacity == 1) {
                                callback = function() {
                                    contractItem = {
                                        "fromTicker": true,
                                        "resourceName": resource.name,
                                        "contractRef": {
                                            "id": message.id,
                                            "isoffer": message.contract,
                                            "quantity": message.amount,
                                            "price": message.price,
                                            "resourceid": parseInt(message.resource),
                                            "sellerid": parseInt(message.trader)
                                        }
                                    };

                                    purchaseNewGBTContract(contractItem);
                                };
                            }

                            addItemToNewsTicker("For Sale: " + numberWithCommas(message.amount) + " " + resource.name + " @ " + numberWithCommas(hundoPrice) + " per 100 for " + numberWithCommas(parseInt(message.price)),tradeColor,callback,true,opacity);
                        }
                        
                    }
                }
                
            }
        }
    }
    
    var musicPlaying = false;
    var musicLineup = [];
    
    function initSoundtrack() {
        if(!allowMusic) {
            return;
        }
        
        if(!ColonyGame.soundtrack || ColonyGame.soundtrack.length == 0) {
            return;
        }
        
        if(musicPlaying) {
            return;
        }
        
        if(titleShowing) {
            return;
        }
        
        musicLineup = [];
        
        playNextSong();
    }
    
    function playNextSong() {
        
        if(titleShowing) {
            musicLineup = [];
            return;
        }
        
        if(!allowMusic) {
            return;
        }
        
        if(musicLineup.length == 0) {
            
            musicLineup = [];
            
            for(var i = 0; i < ColonyGame.soundtrack.length; i++) {
                musicLineup.push({
                    "title":	ColonyGame.soundtrack[i].title,
                    "format":	ColonyGame.soundtrack[i].format,
                    "seconds":	ColonyGame.soundtrack[i].seconds
                });
            }
            
            musicLineup = shuffle(musicLineup);
        }
        
        var songToPlay = musicLineup.shift();

        if(songToPlay.format == "midi") {
            webAppCore.playMidi(songToPlay.title,songToPlay.seconds,false,playNextSong);
        }
        
        if(songToPlay.format == "mp3") {
            // will handle eventually
        }
        
        musicPlaying = true;
    }
    
    function stopSoundtrack() {
        try {
            webAppCore.stopMidi();
        } catch(ex) {
            console.log(ex);
        }
        
        musicPlaying = false;
    }

    var printoutRawText = "";
    var curSection = 0;
    var curSubA = 0;
    var curSubB = 0;

    function nextSection(subA,subB) {
        var ret = "";

        if(!subA) {
            curSection++;
        }

        ret = curSection.toString();

        if(subA) {
            if(!subB) {
                curSubA++;
            }

            ret = "&nbsp;" + ret + "." + curSubA.toString();
        } else {
            curSubA = 0;
        }

        if(subB) {
            curSubB++;
            ret = "&nbsp;" + ret + "." + curSubB.toString();
        } else {
            curSubB = 0;
        }

        ret += ".";

        if(curSection <= 9) {
            ret += " ";
        }

        return ret;
    }

    function getManualSectionHeader(text,symbol,ulOnly) {
        var len = text.length + 4;
        var i;

        var str = "\n";

        if(ulOnly) {
            len = text.length;
            str += text;
            str += "\n";
            for(i = 0; i < len; i++) {
                str += symbol;
            }
            return str;
        }

        

        for(i = 0; i < len; i++) {
            str += symbol;
        }

        str += "\n" + symbol + " " + text + " " + symbol;

        str += "\n";

        for(i = 0; i < len; i++) {
            str += symbol;
        }

        return str;
    }

    function buildOwnersManualTextString() {
        var i,j;

        printoutRawText = "";
        curSection = 0;
        curSubA = 0;
        curSubB = 0;

        printoutRawText += ColonyGame.meta.name + " - " + getString("owners-manual-header") + " v" + ColonyGame.meta.buildVersion + " (" + webAppCore.getPlatform().platform + ")";

        printoutRawText += "\n";

        printoutRawText += getManualSectionHeader("Table of Contents","#",false);

        printoutRawText += "\n" + nextSection(false,false) + "Table of Contents";
        printoutRawText += "\n" + nextSection(false,false) + "Introduction";

        if(aboutVersionData) {
            printoutRawText += "\n" + nextSection(false,false) + "About " + ColonyGame.meta.name;
        }

        printoutRawText += "\n" + nextSection(false,false) + "Gameplay Modes";
        printoutRawText += "\n" + nextSection(true,false) + getString("gen-local-mode");
        if(ColonyGame.meta.colonyServerApi) {
            printoutRawText += "\n" + nextSection(true,false) + "Online Game";
            printoutRawText += "\n" + nextSection(true,true) + getString("empire-general");
            printoutRawText += "\n" + nextSection(true,true) + "Embassy";
            printoutRawText += "\n" + nextSection(true,true) + getString("gen-federation");
            printoutRawText += "\n" + nextSection(true,true) + getString("manual-online-trade-hdr");
        }
        printoutRawText += "\n" + nextSection(true,false) + "Creative Mode";
        printoutRawText += "\n" + nextSection(true,false) + getString("gen-single-city");
        printoutRawText += "\n" + nextSection(true,false) + getString("gen-region-city");

        printoutRawText += "\n" + nextSection(false,false) + "Basic Controls";
        printoutRawText += "\n" + nextSection(true,false) + "Keyboard/Mouse";
        printoutRawText += "\n" + nextSection(true,false) + "Touchscreen";
        if(webAppCore.getPlatform().platform != "ios") {
            printoutRawText += "\n" + nextSection(true,false) + "Gamepad";
        }

        printoutRawText += "\n" + nextSection(false,false) + getString("manual-terms-header");
        printoutRawText += "\n" + nextSection(false,false) + getString("manual-concepts-header");

        printoutRawText += "\n" + nextSection(false,false) + getString("gen-races");

        printoutRawText += "\n" + nextSection(false,false) + getString("general-civs");

        
        printoutRawText += "\n" + nextSection(false,false) + getString("gen-map-types");
        printoutRawText += "\n" + nextSection(false,false) + getString("resources-header");
        printoutRawText += "\n" + nextSection(false,false) + getString("enc-tech-header");
        printoutRawText += "\n" + nextSection(false,false) + getString("general-buildings");
        printoutRawText += "\n" + nextSection(false,false) + getString("general-vehicles");

        printoutRawText += "\n";
        printoutRawText += getManualSectionHeader("Introduction","#",false);
        printoutRawText += "\n" + getString("owners-manual-intro");

        if(aboutVersionData) {
            printoutRawText += "\n";
            printoutRawText += getManualSectionHeader("About " + ColonyGame.meta.name,"#",false);
            printoutRawText += "\n" + replaceAll(aboutVersionData.description,"<br />","\n");
        }

        /*
            Gameplay Modes
        */

        printoutRawText += "\n";
        printoutRawText += getManualSectionHeader("Gameplay Modes","#",false);
        printoutRawText += "\n" + getString("manual-play-modes-desc");

        printoutRawText += "\n";
        printoutRawText += getManualSectionHeader(getString("gen-local-mode"),"*",false);
        printoutRawText += "\n" + getString("manual-local-mode");

        if(ColonyGame.meta.colonyServerApi) {
            printoutRawText += "\n";
            printoutRawText += getManualSectionHeader("Online Game","*",false);
            printoutRawText += "\n" + getString("manual-online-mode");
            printoutRawText += "\n";
            printoutRawText += getManualSectionHeader(getString("empire-general"),"-",true);
            printoutRawText += "\n" + getString("manual-online-commonwealth");
            printoutRawText += "\n";
            printoutRawText += getManualSectionHeader("Embassy","-",true);
            printoutRawText += "\n" + getString("manual-online-embassy");
            printoutRawText += "\n";
            printoutRawText += getManualSectionHeader(getString("gen-federation"),"-",true);
            printoutRawText += "\n" + getString("manual-online-fererations");
            printoutRawText += "\n";
            printoutRawText += getManualSectionHeader(getString("manual-online-trade-hdr"),"-",true);
            printoutRawText += "\n" + getString("manual-online-trade-desc");
        }

        printoutRawText += "\n";
        printoutRawText += getManualSectionHeader("Creative Mode","*",false);
        printoutRawText += "\n" + getString("manual-creative-mode");

        printoutRawText += "\n";
        printoutRawText += getManualSectionHeader(getString("gen-single-city"),"*",false);
        printoutRawText += "\n" + getString("manual-single-city");

        printoutRawText += "\n";
        printoutRawText += getManualSectionHeader(getString("gen-region-city"),"*",false);
        printoutRawText += "\n" + getString("manual-regions");

        /*
            Basic Controls 
        */

        printoutRawText += "\n";
        printoutRawText += getManualSectionHeader("Basic Controls","#",false);
        printoutRawText += "\n" + getString("manual-controls-intro");

        printoutRawText += "\n";
        printoutRawText += getManualSectionHeader("Keyboard/Mouse","*",false);
        printoutRawText += "\n" + getString("manual-keyboard-intro");
        printoutRawText += "\n";
        printoutRawText += "\n[" + webAppCore.getVar("KEY_CLEAR",KEY_DEFAULT_CLEAR) + "]: " + getString("keyboard-clear-menus");
        printoutRawText += "\n[" + webAppCore.getVar("KEY_IDLE",KEY_DEFAULT_IDLE) + "]: " + getString("keyboard-idle-unit");
        printoutRawText += "\n[" + webAppCore.getVar("KEY_STATS_WINDOW",KEY_DEFAULT_STATS_WINDOW) + "]: " + getString("keyboard-open-stats");
        printoutRawText += "\n[" + webAppCore.getVar("KEY_RES_WINDOW",KEY_DEFAULT_RES_WINDOW) + "]: " + getString("keyboard-open-res");
        printoutRawText += "\n[" + webAppCore.getVar("KEY_RES_SEARCH",KEY_DEFAULT_RES_SEARCH) + "]: " + getString("keyboard-search-res");
        printoutRawText += "\n[" + webAppCore.getVar("KEY_TECH_WINDOW",KEY_DEFAULT_TECH_WINDOW) + "]: " + getString("keyboard-open-tech");
        printoutRawText += "\n[" + webAppCore.getVar("KEY_CHAT_INPUT",KEY_DEFAULT_CHAT_INPUT) + "]: " + getString("keyboard-chat-input");
        printoutRawText += "\n[" + webAppCore.getVar("KEY_ENCY_WINDOW",KEY_DEFAULT_ENCY_WINDOW) + "]: " + getString("keyboard-open-encyclopedia");
        printoutRawText += "\n[" + webAppCore.getVar("KEY_UNEM_WINDOW",KEY_DEFAULT_ENCY_WINDOW) + "]: " + getString("keyboard-open-unemployment");
        printoutRawText += "\n[" + webAppCore.getVar("KEY_ZOOM_IN",KEY_DEFAULT_ZOOM_IN) + "]: " + getString("keyboard-zoom-in");
        printoutRawText += "\n[" + webAppCore.getVar("KEY_ZOOM_OUT",KEY_DEFAULT_ZOOM_OUT) + "]: " + getString("keyboard-zoom-out");
        printoutRawText += "\n[" + webAppCore.getVar("KEY_SELL_NO_CONFIRM",KEY_DEFAULT_SELL_NO_CONFIRM) + "]: " + getString("keyboard-sell-noconf");
        printoutRawText += "\n[" + webAppCore.getVar("KEY_UPGRADE_NO_CONFIRM",KEY_DEFAULT_UPGRADE_NO_CONFIRM) + "]: " + getString("keyboard-upgrade-noconf");
        printoutRawText += "\n[" + webAppCore.getVar("KEY_CANCEL_NO_CONFIRM",KEY_DEFAULT_CANCEL_NO_CONFIRM) + "]: " + getString("keyboard-cancel-nocon");
        printoutRawText += "\n[" + webAppCore.getVar("KEY_MOVE",KEY_DEFAULT_MOVE) + "]: " + getString("keyboard-move-unit");
        printoutRawText += "\n[" + webAppCore.getVar("KEY_HARVEST",KEY_DEFAULT_HARVEST) + "]: " + getString("keyboard-harvest-mode");
        printoutRawText += "\n[" + webAppCore.getVar("KEY_BUILD",KEY_DEFAULT_BUILD) + "]: " + getString("keyboard-show-build");
        printoutRawText += "\n[" + webAppCore.getVar("KEY_EXPORT",KEY_DEFAULT_EXPORT) + "]: " + getString("keyboard-show-export");
        printoutRawText += "\n[" + webAppCore.getVar("KEY_IMPORT",KEY_DEFAULT_IMPORT) + "]: " + getString("keyboard-show-import");
        printoutRawText += "\n[" + webAppCore.getVar("KEY_SELL",KEY_DEFAULT_SELL) + "]: " + getString("keyboard-sell");
        printoutRawText += "\n[" + webAppCore.getVar("KEY_FLIP",KEY_DEFAULT_FLIP) + "]: " + getString("keyboard-flip");
        printoutRawText += "\n[" + webAppCore.getVar("KEY_UPGRADE",KEY_DEFAULT_UPGRADE) + "]: " + getString("keyboard-upgrade");
        printoutRawText += "\n[" + webAppCore.getVar("KEY_PARK",KEY_DEFAULT_PARK) + "]: " + getString("keyboard-park");
        printoutRawText += "\n[" + webAppCore.getVar("KEY_CANCEL",KEY_DEFAULT_CANCEL) + "]: " + getString("keyboard-cancel");

        printoutRawText += "\n";
        printoutRawText += getManualSectionHeader("Touchscreen","*",false);
        printoutRawText += "\n" + getString("manual-touch-intro");

        if(webAppCore.getPlatform().platform != "ios") {
            printoutRawText += "\n";
            printoutRawText += getManualSectionHeader("Gamepad","*",false);
            printoutRawText += "\n" + getString("manual-gamepad-intro");
            printoutRawText += "\n";
            printoutRawText += "\n[DPad/Left Thumbstick]: " + "Move selection cursor";
            printoutRawText += "\n[Right Thumbstick]: " + "Scroll viewport";
            printoutRawText += "\n[LT]: " + "Zoom out";
            printoutRawText += "\n[RT]: " + "Zoom in";
            printoutRawText += "\n[LB] or [Start]: " + "Toggle menu";
            printoutRawText += "\n[RB]: " + "Toggle resource display mode";
            printoutRawText += "\n[A]: " + "Select ('click')";
            printoutRawText += "\n[B]: " + "Find idle builder";
            printoutRawText += "\n[X]: " + "Center map";
            printoutRawText += "\n[Y]: " + "Open build menu";
        }

        /*
            Terms
        */

        printoutRawText += "\n";
        printoutRawText += getManualSectionHeader(getString("manual-terms-header"),"#",false);
        printoutRawText += "\n" + getString("manual-terms-desc");



        /*
            Concepts
        */

        printoutRawText += "\n";
        printoutRawText += getManualSectionHeader(getString("manual-concepts-header"),"#",false);
        printoutRawText += "\n" + getString("manual-concepts-desc");


        /*
            Races
        */
        
        printoutRawText += "\n";
        printoutRawText += getManualSectionHeader(getString("gen-races"),"#",false);
        printoutRawText += "\n" + getString("manual-races-desc");

        for(i = 0; i < ColonyGame.races.length; i++) {
            printoutRawText += "\n";
            printoutRawText += getManualSectionHeader(ColonyGame.races[i].name,"-",true);
            printoutRawText += "\n" + getString(ColonyGame.races[i].description);
            printoutRawText += "\n";

            if(ColonyGame.races[i].startingTechs && ColonyGame.races[i].startingTechs.length > 0) {
                printoutRawText += "\n" + getString("general-starting-techs") + ": " + stringArrayToCommaList(ColonyGame.races[i].startingTechs);
            }

            if(ColonyGame.races[i].narcotics && ColonyGame.races[i].narcotics.length > 0) {
                printoutRawText += "\nNarcotics: " + stringArrayToCommaList(ColonyGame.races[i].narcotics);
            }
        }

        /*
            Civilizations
        */

        printoutRawText += "\n";
        printoutRawText += getManualSectionHeader(getString("general-civs"),"#",false);
        printoutRawText += "\n" + getString("manual-civs-intro");

        for(i = 0; i < ColonyGame.civilizations.length; i++) {
            printoutRawText += "\n";
            printoutRawText += getManualSectionHeader(ColonyGame.civilizations[i].name,"-",true);
            printoutRawText += "\n" + getString(ColonyGame.civilizations[i].description);

            if(ColonyGame.civilizations[i].backstory) {
                printoutRawText += "\n\n" + getString(ColonyGame.civilizations[i].backstory);
            }

            printoutRawText += "\n";
            printoutRawText += "\nRace: " + ColonyGame.civilizations[i].race;

            if(ColonyGame.civilizations[i].startingBuilding) {
                printoutRawText += "\n" + getString("general-starting-building") + ": " + ColonyGame.civilizations[i].startingBuilding;
            }

            if(ColonyGame.civilizations[i].startingVehicles && ColonyGame.civilizations[i].startingVehicles.length > 0) {
                printoutRawText += "\nStarting Units: " + stringArrayToCommaList(ColonyGame.civilizations[i].startingVehicles);
            }

            if(ColonyGame.civilizations[i].startingTechs && ColonyGame.civilizations[i].startingTechs.length > 0) {
                printoutRawText += "\n" + getString("general-starting-techs") + ": " + stringArrayToCommaList(ColonyGame.civilizations[i].startingTechs);
            }

            if(ColonyGame.civilizations[i].availableMaps && ColonyGame.civilizations[i].availableMaps.length > 0) {
                printoutRawText += "\n" + getString("general-maps-available") + ": " + stringArrayToCommaList(ColonyGame.civilizations[i].availableMaps);
            }
            
            if(ColonyGame.civilizations[i].startingResourceModifiers && ColonyGame.civilizations[i].startingResourceModifiers.length > 0) {
                printoutRawText += "\nResource Bonuses: " + resModsToCommaList(ColonyGame.civilizations[i].startingResourceModifiers);
            }
        }

        /*
            Map Types
        */
        
        printoutRawText += "\n";
        printoutRawText += getManualSectionHeader(getString("gen-map-types"),"#",false);
        printoutRawText += "\n" + getString("manual-map-types");

        for(i = 0; i < ColonyGame.mapTypes.length; i++) {
            printoutRawText += "\n";
            printoutRawText += getManualSectionHeader(ColonyGame.mapTypes[i].name,"-",true);
            printoutRawText += "\n" + getString(ColonyGame.mapTypes[i].description);

            printoutRawText += "\n";
            printoutRawText += "\nDifficulty: " + ColonyGame.mapTypes[i].difficulty;

            if(ColonyGame.mapTypes[i].startingTechs && ColonyGame.mapTypes[i].startingTechs.length > 0) {
                printoutRawText += "\n" + getString("general-starting-techs") + ": " + stringArrayToCommaList(ColonyGame.mapTypes[i].startingTechs);
            }

            if(ColonyGame.mapTypes[i].startingResourceModifiers && ColonyGame.mapTypes[i].startingResourceModifiers.length > 0) {
                printoutRawText += "\nResource Bonuses: " + resModsToCommaList(ColonyGame.mapTypes[i].startingResourceModifiers);
            }

            if(ColonyGame.mapTypes[i].startingBuildings && ColonyGame.mapTypes[i].startingBuildings.length > 0) {
                printoutRawText += "\n" + getString("general-starting-building") + ": " + stringArrayToCommaList(ColonyGame.mapTypes[i].startingBuildings);
            }

            if(ColonyGame.mapTypes[i].terrainFeatures && ColonyGame.mapTypes[i].terrainFeatures.length > 0) {
                printoutRawText += "\nTerrain Features: " + natResourcesToCommaList(ColonyGame.mapTypes[i].terrainFeatures);
            }

            if(ColonyGame.mapTypes[i].riverTile) {
                printoutRawText += "\nRiver: " + ColonyGame.mapTypes[i].riverTile;

                if(ColonyGame.mapTypes[i].riverPosition) {
                    printoutRawText += " (" + ColonyGame.mapTypes[i].riverPosition + ")";
                }
            }

            if(ColonyGame.mapTypes[i].explosionDisasters && ColonyGame.mapTypes[i].explosionDisasters.length > 0) {
                printoutRawText += "\nNatural Disasters: " + natDisastersToCommaList(ColonyGame.mapTypes[i].explosionDisasters);
            }
        }

        /*
            Resources 
        */
        
        var sortedResources = [];

        for(i = 0; i < ColonyGame.resources.length; i++) {
            sortedResources.push(ColonyGame.resources[i]);
        }

        sortedResources.sort(sortResourcesForManual);

        printoutRawText += "\n";
        printoutRawText += getManualSectionHeader(getString("resources-header"),"#",false);
        printoutRawText += "\n" + getString("manual-res-desc");

        for(i = 0; i < sortedResources.length; i++) {
            printoutRawText += "\n";
            printoutRawText += getManualSectionHeader(sortedResources[i].name,"-",true);
            printoutRawText += "\nIndicator: " + sortedResources[i].indicator;

            if(sortedResources[i].starting && sortedResources[i].starting > 0) {
                printoutRawText += "\nStarting Amount: " + numberWithCommas(sortedResources[i].starting);
            }

            if(sortedResources[i].basePrice && sortedResources[i].basePrice > 0) {
                printoutRawText += "\nBase Price: $" + numberWithCommas(sortedResources[i].basePrice);
            }
            
            if(sortedResources[i].toxicRate && sortedResources[i].toxicRate > 0) {
                printoutRawText += "\nToxic Level: " + numberWithCommas(sortedResources[i].toxicRate);
            }

            if(!sortedResources[i].canGift) {
                printoutRawText += "\n* Can not be gifted *";
            }
        }

        /*
            Technology
        */
        
        var sortedTechs = [];

        for(i = 0; i < ColonyGame.technology.length; i++) {
            sortedTechs.push(ColonyGame.technology[i]);
        }

        sortedTechs.sort(sortTechsForManual);

        printoutRawText += "\n";
        printoutRawText += getManualSectionHeader(getString("enc-tech-header"),"#",false);
        printoutRawText += "\n" + getString("manual-tech-header");

        for(i = 0; i < sortedTechs.length; i++) {
            printoutRawText += "\n";
            printoutRawText += getManualSectionHeader(sortedTechs[i].name,"-",true);
            printoutRawText += "\n" + getString(sortedTechs[i].description);
            printoutRawText += "\n";

            if(sortedTechs[i].requiresStage && sortedTechs[i].requiresStage > 0 && sortedTechs[i].requiresStage != 99) {
                printoutRawText += "\nStage Requirement: " + sortedTechs[i].requiresStage;
            }

            if(sortedTechs[i].cost && sortedTechs[i].cost.length > 0) {
                printoutRawText += "\nCost: " + costsToCommaList(sortedTechs[i].cost);
            }

            if(sortedTechs[i].requiresTech && sortedTechs[i].requiresTech.length > 0) {
                var techString = stringArrayToCommaList(sortedTechs[i].requiresTech);
                var replaced = techString.replace(/\|/g, " or ");

                printoutRawText += "\nTech Requirement: " + replaced;
            }
        }

        /*
            Buildings
        */

        var sortedBuildings = [];

        for(i = 0; i < ColonyGame.buildings.length; i++) {
            sortedBuildings.push(ColonyGame.buildings[i]);
        }

        sortedBuildings.sort(sortTechsForManual);

        printoutRawText += "\n";
        printoutRawText += getManualSectionHeader(getString("general-buildings"),"#",false);
        printoutRawText += "\n" + getString("manual-buildings-desc");

        for(i = 0; i < sortedBuildings.length; i++) {
            printoutRawText += "\n";
            printoutRawText += getManualSectionHeader(sortedBuildings[i].name,"-",true);
            printoutRawText += "\n" + getString(sortedBuildings[i].description);
            printoutRawText += "\n";

            if(sortedBuildings[i].requiresStage && sortedBuildings[i].requiresStage > 0 && sortedBuildings[i].requiresStage != 99) {
                printoutRawText += "\nStage Requirement: " + sortedBuildings[i].requiresStage;
            }

            if(sortedBuildings[i].cost && sortedBuildings[i].cost.length > 0) {
                printoutRawText += "\nCost: " + costsToCommaList(sortedBuildings[i].cost);
            }

            if(sortedBuildings[i].requiresTech && sortedBuildings[i].requiresTech.length > 0) {
                var bldString = stringArrayToCommaList(sortedBuildings[i].requiresTech);
                var replacedBld = bldString.replace(/\|/g, " or ");

                printoutRawText += "\nTech Requirement: " + replacedBld;
            }

            if(sortedBuildings[i].requiresUtility && sortedBuildings[i].requiresUtility.length > 0) {
                printoutRawText += "\nRequires: " + utilitiesToCommaList(sortedBuildings[i].requiresUtility);
            }

            if(sortedBuildings[i].providesUtility && sortedBuildings[i].providesUtility.length > 0) {
                printoutRawText += "\nProvides: " + utilitiesToCommaList(sortedBuildings[i].providesUtility);
            }

            var buildByBldListing = [];

            for(j = 0; j < ColonyGame.vehicles.length; j++) {
                if(ColonyGame.vehicles[j].produces != null && ColonyGame.vehicles[j].produces.indexOf(sortedBuildings[i].name) > -1) {
                    buildByBldListing.push(ColonyGame.vehicles[j].name);
                }
            }
            

            if(buildByBldListing.length > 0) {
                printoutRawText += "\nBuilt By: " + stringArrayToCommaList(buildByBldListing);
            }

            if(sortedBuildings[i].produces && sortedBuildings[i].produces.length > 0) {
                printoutRawText += "\nCan Build: " + stringArrayToCommaList(sortedBuildings[i].produces);
            }

            if(sortedBuildings[i].stores && sortedBuildings[i].stores.length > 0) {
                printoutRawText += "\nStores: " + costsToCommaList(sortedBuildings[i].stores);
            }

            if(sortedBuildings[i].refines) {
                printoutRawText += "\nHarvest Drop Off For: " + refinesToCommaList(sortedBuildings[i].refines);
            }

            if(sortedBuildings[i].acceptsWorkers && sortedBuildings[i].acceptsWorkers > 0) {
                printoutRawText += "\nWorkers: " + numberWithCommas(sortedBuildings[i].acceptsWorkers);
            }

            if(sortedBuildings[i].requiresIQ && sortedBuildings[i].requiresIQ > 0) {
                printoutRawText += "\nRequires IQ: " + numberWithCommas(sortedBuildings[i].requiresIQ);
            }

            if(sortedBuildings[i].occupation) {
                printoutRawText += "\nJob Occupation: " + sortedBuildings[i].occupation;
            }

            if(sortedBuildings[i].providesShelter && sortedBuildings[i].providesShelter > 0) {
                printoutRawText += "\nResidents: " + numberWithCommas(sortedBuildings[i].providesShelter);
            }

            if(sortedBuildings[i].heals && sortedBuildings[i].heals > 0) {
                printoutRawText += "\nHeals: " + numberWithCommas(sortedBuildings[i].heals);
            }

            if(sortedBuildings[i].entertains && sortedBuildings[i].entertains > 0) {
                printoutRawText += "\nGuests: " + numberWithCommas(sortedBuildings[i].entertains);
            }

            if(sortedBuildings[i].takesTourists && sortedBuildings[i].takesTourists > 0) {
                printoutRawText += "\nTourists: " + numberWithCommas(sortedBuildings[i].takesTourists);
            }

            if(sortedBuildings[i].entertainmentCost && sortedBuildings[i].entertainmentCost > 0) {
                printoutRawText += "\nEntertainment Cost: $" + numberWithCommas(sortedBuildings[i].entertainmentCost);
            }

            if(sortedBuildings[i].educates && sortedBuildings[i].educates > 0) {
                printoutRawText += "\nEducates: " + numberWithCommas(sortedBuildings[i].educates);
            }

            if(sortedBuildings[i].providesIQ && sortedBuildings[i].providesIQ > 0) {
                printoutRawText += "\nProvides IQ: " + numberWithCommas(sortedBuildings[i].providesIQ);
            }

            if(sortedBuildings[i].generates) {
                printoutRawText += "\nGenerates:";
                printoutRawText += "\n&nbsp;Output: " + sortedBuildings[i].generates + " x" + numberWithCommas(sortedBuildings[i].generateAmount);
                printoutRawText += "\n&nbsp;Time (ticks): " + numberWithCommas(sortedBuildings[i].generateTime);
            }

            if(sortedBuildings[i].requiresFuel) {
                printoutRawText += "\nConsumes:";
                printoutRawText += "\n&nbsp;Input: " + replaceAll(sortedBuildings[i].requiresFuel.resource,",",", ");
                printoutRawText += "\n&nbsp;Time (ticks): " + numberWithCommas(sortedBuildings[i].requiresFuel.rate);
            }

            if(sortedBuildings[i].smelts) {
                printoutRawText += "\nConverts:";
                printoutRawText += "\n&nbsp;Input: " + replaceAll(sortedBuildings[i].smelts.input,",",", ");

                if(sortedBuildings[i].smelts.output) {
                    printoutRawText += "\n&nbsp;Output: " + sortedBuildings[i].smelts.output.replace(/\|/g, " or ") + " x" + numberWithCommas(sortedBuildings[i].smelts.ratio);
                }
                
                printoutRawText += "\n&nbsp;Time (ticks): " + numberWithCommas(sortedBuildings[i].smelts.time);
            }

            if(sortedBuildings[i].earthTaxValue && sortedBuildings[i].earthTaxValue > 0) {
                printoutRawText += "\nTax Value: $" + numberWithCommas(sortedBuildings[i].earthTaxValue);
            }

            if(sortedBuildings[i].unlocksGovLvl && sortedBuildings[i].unlocksGovLvl > 0) {
                printoutRawText += "\nUnlocks Government Level: " + sortedBuildings[i].unlocksGovLvl;
            }

            if(sortedBuildings[i].reqIndependence) {
                printoutRawText += "\n* Requires Independence *";
            }

            if(sortedBuildings[i].packsTo) {
                printoutRawText += "\nPacks To: " + sortedBuildings[i].packsTo;
            }

            if(sortedBuildings[i].canUpgradeTo) {
                printoutRawText += "\nUpgrades To: " + sortedBuildings[i].canUpgradeTo;
            }

            
        }

        /*
            Vehicles 
        */
        
        var sortedVehicles = [];

        for(i = 0; i < ColonyGame.vehicles.length; i++) {
            sortedVehicles.push(ColonyGame.vehicles[i]);
        }

        sortedVehicles.sort(sortTechsForManual);

        printoutRawText += "\n";
        printoutRawText += getManualSectionHeader(getString("general-vehicles"),"#",false);
        printoutRawText += "\n" + getString("manual-vehicles-desc");

        for(i = 0; i < sortedVehicles.length; i++) {
            printoutRawText += "\n";
            printoutRawText += getManualSectionHeader(sortedVehicles[i].name,"-",true);
            printoutRawText += "\n" + getString(sortedVehicles[i].description);
            printoutRawText += "\n";

            if(sortedVehicles[i].requiresStage && sortedVehicles[i].requiresStage > 0 && sortedVehicles[i].requiresStage != 99) {
                printoutRawText += "\nStage Requirement: " + sortedVehicles[i].requiresStage;
            }

            if(sortedVehicles[i].cost && sortedVehicles[i].cost.length > 0) {
                printoutRawText += "\nCost: " + costsToCommaList(sortedVehicles[i].cost);
            }

            if(sortedVehicles[i].requiresTech && sortedVehicles[i].requiresTech.length > 0) {
                var vehString = stringArrayToCommaList(sortedVehicles[i].requiresTech);
                var replacedVeh = vehString.replace(/\|/g, " or ");

                printoutRawText += "\nTech Requirement: " + replacedVeh;
            }

            var buildByVehListing = [];

            for(j = 0; j < ColonyGame.buildings.length; j++) {
                if(ColonyGame.buildings[j].produces != null && ColonyGame.buildings[j].produces.indexOf(sortedVehicles[i].name) > -1) {
                    buildByVehListing.push(ColonyGame.buildings[j].name);
                }
            }

            if(buildByVehListing.length > 0) {
                printoutRawText += "\nBuilt By: " + stringArrayToCommaList(buildByVehListing);
            }

            if(sortedVehicles[i].produces && sortedVehicles[i].produces.length > 0) {
                printoutRawText += "\nCan Build: " + stringArrayToCommaList(sortedVehicles[i].produces);
            }

            if(sortedVehicles[i].harvests) {
                printoutRawText += "\nCan Harvest: " + sortedVehicles[i].harvests;
            }

            if(sortedVehicles[i].capacity && sortedVehicles[i].capacity > 0) {
                printoutRawText += "\nHarvest Capacity: " + numberWithCommas(sortedVehicles[i].capacity);
            }

            if(sortedVehicles[i].buildSpeed && sortedVehicles[i].buildSpeed > 1) {
                printoutRawText += "\nBuild Speed: " + numberWithCommas(sortedVehicles[i].buildSpeed);
            }

            if(sortedVehicles[i].vehicleCarryCapacity && sortedVehicles[i].vehicleCarryCapacity > 0) {
                printoutRawText += "\nUnit Transport Capacity: " + numberWithCommas(sortedVehicles[i].vehicleCarryCapacity);
            }

            if(sortedVehicles[i].isFlying) {
                printoutRawText += "\n* Can Fly *";
            }

            if(sortedVehicles[i].reqIndependence) {
                printoutRawText += "\n* Requires Independence *";
            }

            if(sortedVehicles[i].deploysTo) {
                printoutRawText += "\nDeploys To: " + sortedVehicles[i].deploysTo;
            }
        }

        return printoutRawText;
    }

    function confirmBeforePrint() {
        webAppCore.showDialog({
            title: getString("enc-print-header"),
            message: getString("enc-print-desc"),
            icon: "images/" + ColonyGame.meta.printInd,
            op1: {
                text: getString("general-yes"),
                func: generatePrintoutEncyclopedia
            },
            op2: {
                text: getString("general-no"),
                func: placeholder
            }
        });
    }

    function generatePrintoutEncyclopedia() {
        
        var printoutRawText = buildOwnersManualTextString();

        webAppCore.printText(printoutRawText);

        webAppCore.logEvent("Printout Manual","Printed",webAppCore.getPlatform().platform);
    }

    function showOwnersManual() {
        var printoutRawText = buildOwnersManualTextString();

        document.getElementById("encyclopediaMainSection").style.display = "none";
        document.getElementById("encyclopediaSubSection").style.display = "none";
        document.getElementById("encyclopediaOwnersManual").style.display = "block";


        document.getElementById("encyclopediaOwnersManualContent").innerHTML = replaceAll(printoutRawText,"\n","<br />");
    }
    
    function sortTechsForManual(a,b) {
        if(a.name > b.name) {
            return 1;
        }

        if(a.name < b.name) {
            return -1;
        }

        return 0;
    }

    function sortResourcesForManual(a,b) {
        if(a.basePrice > b.basePrice) {
            return 1;
        }

        if(a.basePrice < b.basePrice) {
            return -1;
        }

        return 0;
    }

    function refinesToCommaList(arr) {
        var ret = "";

        for(var i = 0; i < arr.length; i++) {
            if(i > 0) {
                ret += ", ";
            }
            ret += arr[i].input;
        }

        return ret;
    }

    function utilitiesToCommaList(arr) {
        var ret = "";

        for(var i = 0; i < arr.length; i++) {
            if(i > 0) {
                ret += ", ";
            }

            var plus = "";

            if(arr[i].amount < 0) {
                plus = "-";
            }

            ret += arr[i].utility + ": " + plus + numberWithCommas(arr[i].amount);
        }

        return ret;
    }

    function costsToCommaList(arr) {
        var ret = "";

        for(var i = 0; i < arr.length; i++) {
            if(i > 0) {
                ret += ", ";
            }

            var plus = "";

            if(arr[i].amount < 0) {
                plus = "-";
            }

            ret += arr[i].resource + ": " + plus + numberWithCommas(arr[i].amount);
        }

        return ret;
    }

    function natDisastersToCommaList(arr) {
        var ret = "";

        for(var i = 0; i < arr.length; i++) {
            if(i > 0) {
                ret += ", ";
            }
            ret += arr[i].name;
        }

        return ret;
    }

    function natResourcesToCommaList(arr) {
        var ret = "";

        for(var i = 0; i < arr.length; i++) {
            if(i > 0) {
                ret += ", ";
            }
            ret += arr[i].name + ": x" + numberWithCommas(arr[i].abundance);
        }

        return ret;
    }

    function resModsToCommaList(arr) {
        var ret = "";

        for(var i = 0; i < arr.length; i++) {
            if(i > 0) {
                ret += ", ";
            }

            var plus = "";

            if(arr[i].modifier > 0) {
                plus = "+";
            }

            ret += arr[i].name + ": " + plus + numberWithCommas(arr[i].modifier);
        }

        return ret;
    }

    function stringArrayToCommaList(arr) {
        var ret = "";

        for(var i = 0; i < arr.length; i++) {
            if(i > 0) {
                ret += ", ";
            }

            ret += arr[i];
        }

        return ret;
    }

    function loadFederationData() {
        var roc = getRegionOrCity();

        if(roc.offlineMode || roc.federationId == 0 || roc.governmentLevel < 7) {
            return;
        }

        document.getElementById("fedBallotingSectionListing").innerHTML = "";

        var data = [];

        data.push({
            "key":      "fedid",
            "value":    roc.federationId
        });

        postSecuredCallToApi(data,52,parseFederationData);
    }

    function parseFederationMemberStatesForKick(result) {
        var roc = getRegionOrCity();

        if(result != null && result.trim().length > 0) {
            try {
                var colonyInfo = JSON.parse(result);

                if(colonyInfo == null) {
                    return;
                }

                var kickInfo = [];

                for(var i = 0; i < colonyInfo.length; i++) {

                    var ci = colonyInfo[i];

                    if(ci.colonyid == roc.colonyId) {
                        continue;
                    }


                    kickInfo.push({
                        title: ci.colonyname,
                        description: "Last Active: " + ci.lastactive,
                        tag: ci,
                        overflow: [
                            {
                                pre: "Owner",
                                post: ci.aausername,
                                icon: "https://accounts.ape-apps.com/getavatar.php?u=" + ci.aausername
                            }
                        ]
                    });

                }

                if(kickInfo.length == 0) {
                    webAppCore.showToast("Nobody to kick!");
                } else {
                    webAppCore.presentNativeList(getString("gen-kick-member"),kickInfo,onKickSomeoneFromFed,getString("general-dismiss"));
                }

            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": parseFederationMemberStatesForKick",ex.message);
            }
        }
    }

    function onKickSomeoneFromFed(tag) {
        if(!tag) {
            return;
        }

        postSecuredCallToApi([
            {
                "key":      "fedid",
                "value":    getRegionOrCity().federationId
            },
            {
                "key":      "kickid",
                "value":    tag.colonyid
            }
        ],72,function(){
            showColonistsMenu("federation");

            webAppCore.showToast(tag.colonyname + " has been removed from the federation.");
        });
    }

    function parseFederationMemberStates(result) {
        document.getElementById("fedMembersListingHolder").innerHTML = "";

        if(result != null && result.trim().length > 0) {
            try {
                var colonyInfo = JSON.parse(result);

                if(colonyInfo == null) {
                    return;
                }

                for(var i = 0; i < colonyInfo.length; i++) {

                    var ci = colonyInfo[i];

                    addColonyCardToListing(ci,true,"fedMembersListingHolder");

                    getKnownInfoAboutCharter(ci.charter);
                }

            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": parseFederationMemberStates",ex.message);
            }
        }
    }

    function parseFederationData(data) {
        if(!data || data.trim().length == 0) {
            document.getElementById("fedBallotingSectionListing").innerHTML = "";
            document.getElementById("fedMembersListingHolder").innerHTML = "";
            return;
        }

        var ros = getRegionOrCity();

        try {
            var fedData = JSON.parse(data)[0];

            document.getElementById("fedStatfedName").innerHTML = fedData.name;
            document.getElementById("fedStatFounded").innerHTML = "Founded: " + fedData.created;

            document.getElementById("fedBallotingSectionListing").innerHTML = "";
            document.getElementById("fedBallotingSection").style.display = "none";

            document.getElementById("fedMembersListingHolder").innerHTML = "";

            var presidentHtml = "";

            if(ros.foreignContactReference[fedData.president]) {
                presidentHtml = "President: " + ros.foreignContactReference[fedData.president].name;
            }
            
            document.getElementById("fedStatPresident").innerHTML = presidentHtml;


            if(fedData.president == ros.colonyId) {
                document.getElementById("btnKickMember").style.display = null;
                document.getElementById("btnKickMember").onclick = function(){
                    var memdata = [];

                    memdata.push({
                        "key":      "fedid",
                        "value":    fedData.id
                    });

                    postSecuredCallToApi(memdata,57,parseFederationMemberStatesForKick);
                };
            } else {
                document.getElementById("btnKickMember").style.display = "none";
                document.getElementById("btnKickMember").onclick = null;
            }

            var freshData = [];

            freshData.push({
                "key":      "fedid",
                "value":    fedData.id
            });

            postSecuredCallToApi(freshData,55,parseTheBallots);
        } catch(ex) {
            webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": parseFederationData",ex.message);
        }
    }

    function parseTheBallots(data) {
        if(!data || data.trim().length == 0) {
            return;
        }

        var roc = getRegionOrCity();

        try {
            var ballotData = JSON.parse(data);

            document.getElementById("fedBallotingSectionListing").innerHTML = "";

            if(ballotData.length > 0) {
                document.getElementById("fedBallotingSection").style.display = "block";
                

                var added = 0;

                for(var i = 0; i < ballotData.length; i++) {
                    var ballot = ballotData[i];

                    if(ballot.result != null) {
                        continue;
                    }

                    if(roc.votingHistory[ballot.id]) {
                        continue;
                    }

                    added++;

                    var newPetition = document.createElement("div");
                    newPetition.className = "federationBallot";

                    // request to join federation
                    if(ballot.code == "1") {
                        var voteTitle = document.createElement("div");
                        voteTitle.className = "federationBallotTitle";
                        voteTitle.innerHTML = ballot.f2 + " (" + ballot.f3 + ") wishes to join the federation.";
                        newPetition.appendChild(voteTitle);

                        var voteView = document.createElement("div");
                        voteView.className = "federationBallotViewPetitioner";
                        voteView.innerHTML = "View Colony";
                        voteView.colonyref = ballot.f1;
                        voteView.onclick = onViewPetitionColony;
                        newPetition.appendChild(voteView);


                        var votesHolder = document.createElement("div");
                        votesHolder.className = "federationBallotVotesHolder";

                        var voteYay = document.createElement("div");
                        voteYay.className = "federationBallotVoteButton federationBallotVoteButtonYay";
                        voteYay.innerHTML = "Yay";
                        voteYay.ballotIdRef = ballot.id;
                        voteYay.voteRef = "yay";
                        voteYay.onclick = castFedBallot;
                        votesHolder.appendChild(voteYay);

                        var voteNay = document.createElement("div");
                        voteNay.className = "federationBallotVoteButton federationBallotVoteButtonNay";
                        voteNay.innerHTML = "Nay";
                        voteNay.ballotIdRef = ballot.id;
                        voteNay.voteRef = "nay";
                        voteNay.onclick = castFedBallot;
                        votesHolder.appendChild(voteNay);


                        newPetition.appendChild(votesHolder);

                    }


                    document.getElementById("fedBallotingSectionListing").appendChild(newPetition);
                }

                if(added == 0) {
                    document.getElementById("fedBallotingSection").style.display = "none";
                }
            }
        } catch(ex) {
            console.log(ex);
            webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": parseTheBallots",ex.message);
        }

        var memdata = [];

        memdata.push({
            "key":      "fedid",
            "value":    roc.federationId
        });

        postSecuredCallToApi(memdata,57,parseFederationMemberStates);
    }

    function onViewPetitionColony() {
        getColonyInfoAndLaunchInfo(this.colonyref);
    }

    function castFedBallot() {

        getRegionOrCity().votingHistory[this.ballotIdRef] = this.voteRef;

        var data = [];

        data.push({
            "key":      "ballot",
            "value":    this.ballotIdRef
        });

        data.push({
            "key":      "vote",
            "value":    this.voteRef
        });

        postSecuredCallToApi(data,56,onVoteCastDone);
    }

    function onVoteCastDone(result) {
        if(result != "success") {

            var resJSON = JSON.parse(result);

            webAppCore.showDialog({
                title: getString("gen-balloting"),
                message: resJSON.reason
            });
        }

        showColonistsMenu("federation");
    }

    function loadDiplomaticData() {

        if(getRegionOrCity().offlineMode) {
            return;
        }

        if(!currentGame || getRegionOrCity() == null) {
            return;
        }

        document.getElementById("diplomaticListing").innerHTML = "";

        var data = [];


        postSecuredCallToApi(data,38,parseForeignOffices);

    }

    function parseForeignOffices(result) {
        if(result != null && result.trim().length > 0) {
            try {
                var colonyInfo = JSON.parse(result);

                if(colonyInfo == null) {
                    return;
                }

                var colonyCard = document.createElement("div");
                colonyCard.className = "colonyCard";
                colonyCard.colonyRef = colonyInfo;

                var colonyIcon = document.createElement("img");
                colonyIcon.draggable = false;
                colonyIcon.className = "colonyCardIcon";
                colonyIcon.src = "images/" + ColonyGame.meta.diplomacyIndicator;
                colonyCard.appendChild(colonyIcon);

                var colonyName = document.createElement("span");
                colonyName.className = "colonyCardName";
                colonyName.innerHTML = getString("new-embassy-header");
                colonyCard.appendChild(colonyName);

                var colonyActive = document.createElement("span");
                colonyActive.className = "colonyCardActive";
                colonyActive.innerHTML = getString("new-embassy-desc-short");
                colonyCard.appendChild(colonyActive);

                colonyCard.onclick = function() {
                    var dialogOptions = {
                        title: getString("new-embassy-header"),
                        message: getString("new-embassy-desc"),
                        func: lookupNewEMbassyTarget
                    };

                    webAppCore.inputBox(dialogOptions);
                };

                document.getElementById("diplomaticListing").appendChild(colonyCard);


                for(var i = 0; i < colonyInfo.length; i++) {
                    addColonyCardToListing(colonyInfo[i],true);
                }

                commonwealthOnlineColonies = 0;

                postToDiplomaticChannel("onlineping");

            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": parseForeignOffices",ex.message);
            }
        }
    }

    function lookupNewEMbassyTarget(charter) {
        if(!charter || charter.trim().length == 0) {
            return;
        }

        var data = [];

        data.push({
            "key":      "c",
            "value":    charter
        });

        postSecuredCallToApi(data,25,onCheckCharterBack);

    }

    var pendingEmbassyTargetId;
    var pendingEmbassyColonyName;

    function onCheckCharterBack(result) {
        var charterInfo = null;

        if(result != null && result.trim().length > 0) {
            try {
                charterInfo = JSON.parse(result)[0];
            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onCheckCharterBack",ex.message);
                return;
            }
        }

        if(charterInfo == null) {
            webAppCore.showToast("Invalid Charter");
            return;
        }

        if(charterInfo.isindependent == "0") {
            webAppCore.showToast(charterInfo.colonyname + " is not independent!");
            return;
        }

        var immigrants = 0;
        var emHere = false;
        var emThere = false;

        if(getRegionOrCity().foreignContactReference[charterInfo.colonyid]) {
            if(getRegionOrCity().foreignContactReference[charterInfo.colonyid].immigrants) {
                immigrants = parseInt(getRegionOrCity().foreignContactReference[charterInfo.colonyid].immigrants);
            }
            
            if(getRegionOrCity().foreignContactReference[charterInfo.colonyid].embassyhere) {
                emHere = parseInt(getRegionOrCity().foreignContactReference[charterInfo.colonyid].embassyhere);
            }

            if(getRegionOrCity().foreignContactReference[charterInfo.colonyid].embassythere) {
                emThere = parseInt(getRegionOrCity().foreignContactReference[charterInfo.colonyid].embassythere);
            }
        }

        getRegionOrCity().foreignContactReference[charterInfo.colonyid] = {
            "id": charterInfo.colonyid,
            "charter": charterInfo.charter,
            "name": charterInfo.colonyname,
            "race": charterInfo.race,
            "maptype": charterInfo.maptype,
            "sx": charterInfo.sectorx,
            "sy": charterInfo.sectory,
            "gx": charterInfo.gridx,
            "gy": charterInfo.gridy,
            "embassyhere": emHere,
            "embassythere": emThere,
            "immigrants": immigrants,
            "apeAccount": charterInfo.aausername
        };

        pendingEmbassyTargetId = charterInfo.colonyid;
        pendingEmbassyColonyName = charterInfo.colonyname;

        var a = parseInt(currentGame.sX) - parseInt(charterInfo.sectorx);
        var b = parseInt(currentGame.sY) - parseInt(charterInfo.sectory);

        var c = Math.round(Math.sqrt( a*a + b*b ));

        c++;

        embassyCostTotal = {};

        var costString = charterInfo.colonyname + " is located " + (c - 1) + " sectors away from us.  A diplomatic mission will cost ";

        for(var i = 0; i < ColonyGame.meta.embassyCostPerSector.length; i++) {
            if(i == 0) {
                costString += " ";
            } else {
                costString += ", ";
            }

            embassyCostTotal[ColonyGame.meta.embassyCostPerSector[i].resource] = ColonyGame.meta.embassyCostPerSector[i].amount * c;
            
            costString += getResourceByDefName(ColonyGame.meta.embassyCostPerSector[i].resource).indicator + numberWithCommas(ColonyGame.meta.embassyCostPerSector[i].amount * c);
        }

        costString += ", in addition to the building costs of the actual embassy.  You will also need to send over a certain number of citizens to staff your embassy, dependent on the type of embassy you build.";


        webAppCore.showDialog({
            "title":    getString("new-embassy-header"),
            "message":  costString,
            "op1": {
                "text":     getString("general-pick-embassy"),
                "func":     selectEmbassyToBuild
            },
            "op2": {
                "text":     getString("general-dismiss"),
                "func":     placeholder
            }
        });
    }

    var embassyCostTotal = {};

    function selectEmbassyToBuild() {
        var menuOptions = [];

        for(var i = 0; i < ColonyGame.buildings.length; i++) {
            if(!ColonyGame.buildings[i].isEmbassy) {
                continue;
            }

            if(!canIBuildThis(ColonyGame.buildings[i],"building")) {
                continue;
            }

            var tagToUse = ColonyGame.buildings[i];
            var status = null;
            var statusColor = null;

            if(ColonyGame.buildings[i].requiPremium && !webAppCore.getIsPremium()) {
                tagToUse = "premium";
                status = "Premium Content";
                statusColor = "#FFC107";
            }

            var costColor = null;
            var def;

            var costStructure = [];

            if(ColonyGame.buildings[i].acceptsWorkers > getTotalPopulation()) {
                costColor = "#F44336";
                tagToUse = "cantafford";
            }

            costStructure.push({
                pre:    "Staff:",
                post:   numberWithCommas(ColonyGame.buildings[i].acceptsWorkers),
                color:  costColor,
                icon:   "images/" + ColonyGame.meta.colonistIcon
            });

            var j;

            for(j = 0; j < ColonyGame.meta.embassyCostPerSector.length; j++) {
                costColor = null;

                if(embassyCostTotal[ColonyGame.meta.embassyCostPerSector[j].resource] > getGameResources()[ColonyGame.meta.embassyCostPerSector[j].resource].amount) {
                    costColor = "#F44336";
                    tagToUse = "cantafford";
                }

                def = getResourceByDefName(ColonyGame.meta.embassyCostPerSector[j].resource);

                costStructure.push({
                    pre:    "Cost:",
                    post:   def.indicator + numberWithCommas(embassyCostTotal[ColonyGame.meta.embassyCostPerSector[j].resource]),
                    color:  costColor,
                    icon:   "images/" + def.icon
                });
            }

            for(j = 0; j < ColonyGame.buildings[i].cost.length; j++) {
                
                def = getResourceByDefName(ColonyGame.buildings[i].cost[j].resource);

                costColor = null;

                if(ColonyGame.buildings[i].cost[j].amount > getGameResources()[ColonyGame.buildings[i].cost[j].resource].amount) {
                    costColor = "#F44336";
                    tagToUse = "cantafford";
                }

                costStructure.push({
                    pre:    "Cost:",
                    post:   def.indicator + numberWithCommas(ColonyGame.buildings[i].cost[j].amount),
                    color:  costColor,
                    icon:   "images/" + def.icon
                });

                embassyCostTotal[ColonyGame.buildings[i].cost[j].resource] = ColonyGame.buildings[i].cost[j].amount;
            }

            var img = null;

            if(ColonyGame.buildings[i].indicator == null) {
                var bb = getImageAsset(ColonyGame.buildings[i].tile[0],false,0,null);
                if(bb) {
                    img = bb.src;
                } 

            } else {
                img = "images/" + ColonyGame.buildings[i].indicator;
            }

            menuOptions.push({
                "title": ColonyGame.buildings[i].name,
                "title-color": null,
                "description": getString(ColonyGame.buildings[i].description),
                "status": status,
                "status-color": statusColor,
                "icon": img,
                "overflow": costStructure,
                "tag": tagToUse
            });
        }

        showList(getString("general-pick-embassy"),menuOptions,onEMbassyToBuildSelected,getString("general-nevermind"));
    }

    var pendingEmbassyColonistCount = 0;

    function onEMbassyToBuildSelected(embassy) {

        if(!embassy) {
            return;
        }

        if(embassy == "premium") {
            showPremiumMessage();
            return;
        }

        if(embassy == "cantafford") {
            webAppCore.showToast(getString("general-cant-afford"));
            return;
        }

        if(pendingEmbassyTargetId == null) {
            return;
        }

        pendingEmbassyColonistCount = parseInt(embassy.acceptsWorkers);

        // check with the server if this request is still valid
        var data = [];

        data.push({
            "key":      "t",
            "value":    pendingEmbassyTargetId
        });

        data.push({
            "key":      "b",
            "value":    embassy.name
        });

        postSecuredCallToApi(data,34,onServerEmbassyCheckBack);
    }

    function onServerEmbassyCheckBack(result) {
        

        if(!result || result.trim().length == "") {
            // general error
            webAppCore.showToast("Unable to establish embassy.");
            return;
        }

        if(result.trim() == "ok") {
            // all was good

            for(var cost in embassyCostTotal) {
                modifyResourceAmount(cost,-embassyCostTotal[cost],false,"Diplomacy");
            }

            var totalDiplomats = pendingEmbassyColonistCount;

            webAppCore.showAlertWithTitle("A diplomatic mission has been dispatched to " + pendingEmbassyColonyName + " with " + totalDiplomats + " diplomats.",getString("diplomacy-general"));

            return;
        }

        // otherwise, a custom error message from the server
        webAppCore.showAlertWithTitle(result.trim(),"Error");
    }

    function getPendingEmbassyRequests() {

        if(!currentGame || getRegionOrCity().offlineMode) {
            colonyNeverLoaded = false;
            webAppCore.clearSplash();
            return;
        }

        var data = [];

        postSecuredCallToApi(data,35,onPendingEmbassyRequestsBack);
    }

    function onPendingEmbassyRequestsBack(result) {

        var embassyRequests = null;

        if(currentGame == null) {
            return;
        }

        if(result != null && result.trim().length > 0) {
            try {
                embassyRequests = JSON.parse(result);
            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onPendingEmbassyRequestsBack",ex.message);
                return;
            }
        }

        if(embassyRequests == null) {
            return;
        }

        getRegionOrCity().pendingForeignEmbassies = embassyRequests;

        for(var i = 0; i < getRegionOrCity().pendingForeignEmbassies.length; i++) {
            getRegionOrCity().foreignContactReference[getRegionOrCity().pendingForeignEmbassies[i].foreigncolony] = {
                "id": getRegionOrCity().pendingForeignEmbassies[i].foreigncolony,
                "charter": getRegionOrCity().pendingForeignEmbassies[i].charter,
                "name": getRegionOrCity().pendingForeignEmbassies[i].colonyname,
                "race": getRegionOrCity().pendingForeignEmbassies[i].race,
                "maptype": getRegionOrCity().pendingForeignEmbassies[i].maptype,
                "sx": getRegionOrCity().pendingForeignEmbassies[i].sectorx,
                "sy": getRegionOrCity().pendingForeignEmbassies[i].sectory,
                "gx": getRegionOrCity().pendingForeignEmbassies[i].gridx,
                "gy": getRegionOrCity().pendingForeignEmbassies[i].gridy,
                "embassyhere": false,
                "embassythere": false,
                "immigrants": 0
            };
        }

        if(getRegionOrCity().pendingForeignEmbassies.length > 0) {
            document.getElementById("imDiplomacy").style.display = "inline-block";
        } else {
            document.getElementById("imDiplomacy").style.display = "none";
        }
    }

    function showPendingEmbassyRequests() {

        if(getRegionOrCity().pendingForeignEmbassies.length == 0) {
            return;
        }

        var menuOptions = [];

        for(var i = 0; i < getRegionOrCity().pendingForeignEmbassies.length; i++) {

            var building = getBuildingDefByName(getRegionOrCity().pendingForeignEmbassies[i].buildingid);

            var img = null;

            if(building.indicator == null) {
                var em = getImageAsset(building.tile[0],false,0,null);
                if(em) {
                    img = em.src;
                }

                
            } else {
                img = "images/" + building.indicator;
            }

            menuOptions.push({
                "title": getRegionOrCity().pendingForeignEmbassies[i].colonyname,
                "title-color": null,
                "description": "The government of " + getRegionOrCity().pendingForeignEmbassies[i].colonyname + " wishes to establish a diplomatic mission in our colony.",
                "status": "Diplomats: " + building.acceptsWorkers + " (" + getRegionOrCity().pendingForeignEmbassies[i].race + ")",
                "status-color": null,
                "icon": img,
                "overflow": null,
                "tag": getRegionOrCity().pendingForeignEmbassies[i]
            });
        }   

        showList(getString("general-embassy-requests"),menuOptions,queueUpPendingEmbassyConstruction,getString("general-nevermind"));
    }

    var pendingEmbassyMission;

    function queueUpPendingEmbassyConstruction(embassy) {
        if(!embassy) {
            return;
        }

        pendingEmbassyMission = embassy;

        var building = getBuildingDefByName(embassy.buildingid);

        showBuildConfirm();
        buildingConstruction(building);
    }

    function alertEmbassyBuilt(mission) {

        if(mission == null) {
            return;
        }

        var data = [];

        data.push({
            "key":      "t",
            "value":    mission.foreigncolony
        });

        postSecuredCallToApi(data,36,getPendingEmbassyRequests);
    }

    function onimmigrantSourceNameClick() {
        getColonyInfoAndLaunchInfo(this.colrefid);
    }

    function alertSoldEmbassy(foreigncolony) {

        var data = [];

        data.push({
            "key":      "t",
            "value":    foreigncolony
        });

        postSecuredCallToApi(data,37,getPendingEmbassyRequests);
    }

    function contactEmbassyFor(embassy) {
        getColonyInfoAndLaunchInfo(embassy);
    }

    function hexToOffset(hex, offset) {
        var color = hexToColor(hex);

        if(!color) {
            return {
                r: 0,
                g: 0,
                b: 0
            };
        }

        color.r += offset;
        color.g += offset;
        color.b += offset;

        if (offset > 0) {
            if (color.r > 255) {
                color.r = 255;
            }

            if (color.g > 255) {
                color.g = 255;
            }

            if (color.b > 255) {
                color.b = 255;
            }
        } else {
            if (color.r < 0) {
                color.r = 0;
            }

            if (color.g < 0) {
                color.g = 0;
            }

            if (color.b < 0) {
                color.b = 0;
            }
        }

        return color;
    }

    function addObjectReadoutBar(holder,icon,currenta,currentb,colora,colorb,background,max,title) {
        
        var readoutText = "";
        var readoutTextColor = "#ffffff";
        
        var readoutHolder = document.createElement("div");
        readoutHolder.className = "objOptReadoutHolder";

        if(title) {
            readoutHolder.title = title;
        }

        if(!background) {
            var offsetr = hexToOffset(colora, -60);
            background = "rgb(" + offsetr.r + "," + offsetr.g + "," + offsetr.b + ")";

            if((offsetr.r + offsetr.g + offsetr.b) > 320) {
                readoutTextColor = "#000000";
            }
        }

        var readoutIcon = document.createElement("img");
        readoutIcon.className = "objOptReadouIcon";
        readoutIcon.src = icon;
        readoutHolder.appendChild(readoutIcon);

        var readoutBarHolder = document.createElement("div");
        readoutBarHolder.className = "objObtReadoutBarholder";

        // bar a 
        var barAPercent = Math.round((currenta / max) * 100);
        readoutText = currenta;

        if(currenta == -1 && max == -1) {
            barAPercent = 100;
            readoutText = "Infinite";
        }

        var barA = document.createElement("div");
        barA.className = "objOptReadoutBarA";
        barA.style.backgroundColor = colora;
        barA.style.width = "calc(" + barAPercent + "%";
        readoutBarHolder.appendChild(barA);

        // bar b 
        if(currentb != null) {

            readoutText = currentb + "/" + readoutText;

            var barBPercent = Math.round((currentb / max) * 100);
            
            var barB = document.createElement("div");
            barB.className = "objOptReadoutBarA";
            barB.style.backgroundColor = colorb;
            barB.style.width = "calc(" + barBPercent + "%";
            readoutBarHolder.appendChild(barB);
        }

        if(background) {
            readoutBarHolder.style.backgroundColor = background;
        }

        if(max != -1) {
            readoutText = readoutText + "/" + max;
        }
        

        var readoutTextSpan = document.createElement("span");
        readoutTextSpan.innerHTML = readoutText;
        readoutTextSpan.style.color = readoutTextColor;
        readoutTextSpan.className = "objOptReadoutText";
        readoutBarHolder.appendChild(readoutTextSpan);

        readoutHolder.appendChild(readoutBarHolder);

        holder.appendChild(readoutHolder);
    }

    function showCommunicationsMenu() {
        if(getRegionOrCity().offlineMode) {
            return;
        }

        var menuOptions = [];

        menuOptions.push({
            "title": getString("general-send-custom-msg"),
            "title-color": null,
            "description": getString("general-send-msg-warn"),
            "status": null,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.mailIndicator,
            "overflow": null,
            "tag": "sendmail"
        });  


        if(!getRegionOrCity().isIndependent) {
            menuOptions.push({
                "title": getString("general-req-annex"),
                "title-color": null,
                "description": getString("req-anenx-desc"),
                "status": null,
                "status-color": null,
                "icon": "images/" + ColonyGame.meta.empireIndicator,
                "overflow": null,
                "tag": "reqannex"
            });  
        }
        

        showList(getString("comms-general"),menuOptions,onCommOptionSelected,getString("general-nevermind"));
    }

    function onCommOptionSelected(tag) {
        if(!tag) {
            return;
        }

        if(tag == "sendmail") {
            sendCommMessage();
        }

        if(tag == "reqannex") {
            enterAnnexCharter();
        }
    }

    function enterAnnexCharter() {
        var dialogOptions = {
            title: getString("general-req-annex"),
            message: getString("req-annex-enter-charter"),
            func: onChangeCharterInput
        };

        webAppCore.inputBox(dialogOptions);
    }

    function onChangeCharterInput(charter) {
        if(!charter || charter.trim().length == 0) {
            return;
        }

        var data = [];

        data.push({
            "key":      "c",
            "value":    charter
        });

        postSecuredCallToApi(data,25,onCheckCharterBackForAnnex);
    }

    function onCheckCharterBackForAnnex(result) {
        var charterInfo = null;

        if(result != null && result.trim().length > 0) {
            try {
                charterInfo = JSON.parse(result)[0];
            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onCheckCharterBackForAnnex",ex.message);
                return;
            }
        }

        if(charterInfo == null) {
            webAppCore.showToast("Invalid Charter");
            return;
        }

        if(charterInfo.isindependent == "0") {
            webAppCore.showToast(charterInfo.colonyname + " is not independent!");
            return;
        }

        if(getRegionOrCity().foreignContactReference[charterInfo.colonyid] === undefined) {
            getRegionOrCity().foreignContactReference[charterInfo.colonyid] = {
                "id": charterInfo.colonyid,
                "charter": charterInfo.charter,
                "name": charterInfo.colonyname,
                "race": charterInfo.race,
                "maptype": charterInfo.maptype,
                "sx": charterInfo.sectorx,
                "sy": charterInfo.sectory,
                "gx": charterInfo.gridx,
                "gy": charterInfo.gridy,
                "embassyhere": false,
                "embassythere": false,
                "immigrants": 0
            };
        }

        var annexMessage = getRegionOrCity().name  + " wishes to join our Commonwealth.";

        sendMessage(charterInfo.colonyid,"7",getRegionOrCity().earthBackTax,annexMessage,placeholder,null);

        webAppCore.showAlertWithTitle("Your request has been sent to " + charterInfo.colonyname + ".  " + getString("req-annex-final"),getString("general-req-annex"));
    }

    function sendCommMessage() {
        if(getRegionOrCity().foreignContactReference === undefined) {
            getRegionOrCity().foreignContactReference = {};
        }

        var menuOptions = [];

        menuOptions.push({
            "title": "Charter Code",
            "title-color": null,
            "description": "You can send a message to any colony if you know their charter code.",
            "status": null,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.charterIndicator,
            "overflow": null,
            "tag": "charter"
        }); 

        for(var colony in getRegionOrCity().foreignContactReference) {
            if(getRegionOrCity().foreignContactReference[colony].charter) {

                var pDef = getPlanetDefByName(getRegionOrCity().foreignContactReference[colony].maptype);

                if(pDef == null) {
                    continue;
                }

                menuOptions.push({
                    "title": getRegionOrCity().foreignContactReference[colony].name,
                    "title-color": null,
                    "description": getRegionOrCity().foreignContactReference[colony].race + ".  Charter: " + getRegionOrCity().foreignContactReference[colony].charter,
                    "status": null,
                    "status-color": null,
                    "icon": "images/" + pDef.icon,
                    "overflow": null,
                    "tag": getRegionOrCity().foreignContactReference[colony]
                }); 
            }
        }

        showList(getString("general-send-custom-msg"),menuOptions,onMessageTarget,getString("general-nevermind"));
    }

    function onMessageTarget(tag) {
        if(!tag) {
            return;
        }

        if(tag == "charter") {
            var dialogOptions = {
                title: "Charter Code",
                message: "Enter the charter code of a colony you wish to communicate with.",
                func: onMessagingCharterEntered
            };

            webAppCore.inputBox(dialogOptions);
            return;
        }


        sendACustomMessage(tag.id);
    }

    function onMessagingCharterEntered(charter) {
        if(!charter || charter.trim().length == 0) {
            return;
        }

        var data = [];

        data.push({
            "key":      "c",
            "value":    charter
        });

        postSecuredCallToApi(data,25,onCheckCharterBackForMessaging);
    }

    function closeSomethingIfOpen() {
        var somethingWasOpen = false;
        
        if(gbtOpen) {
            somethingWasOpen = true;
            closeGBT();
        }

        if(tipsWindowOpen) {
            somethingWasOpen = true;
            closeTipsPopup();
        }


        if(colonyWindowOpen) {
            somethingWasOpen = true;
            closeColonyWindow();
        }

        if(statsOpen) {
            somethingWasOpen = true;
            closeStatsMenu();
        }

        if(userProfileWindowOpen) {
            somethingWasOpen = true;
            closeUserProfileWindow();
        }

        if(document.getElementById("allResourceSearchHolder").style.display == "block") {
            document.getElementById("allResourceSearchHolder").style.display = "none";
            somethingWasOpen = true;
        }

        if(document.getElementById("chatInputBoxHolder").style.display == "block") {
            document.getElementById("chatInputBoxHolder").style.display = "none";
            somethingWasOpen = true;
        }

        if(selectedBuilding != null) {
            somethingWasOpen = true;
        }

        if(!desktopMode && document.getElementById("sidebar").style.display != "none") {
            somethingWasOpen = true;
        }

        if(document.getElementById("objectOptions").style.display == "block" && selectedVehicle.length == 0 && queuedMove == null) {
            somethingWasOpen = true;
            document.getElementById("objectOptions").style.display = "none";
        }

        if(newObjectOptionsOpen) {
            closeObjectOptionsMenu();
            somethingWasOpen = true;
        }

        return somethingWasOpen;
    }

    function onCheckCharterBackForMessaging(result) {
        var charterInfo = null;

        if(result != null && result.trim().length > 0) {
            try {
                charterInfo = JSON.parse(result)[0];
            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onCheckCharterBackForMessaging",ex.message);
                return;
            }
        }

        if(charterInfo == null) {
            webAppCore.showToast("Invalid Charter");
            return;
        }

        if(getRegionOrCity().foreignContactReference[charterInfo.colonyid] === undefined) {
            getRegionOrCity().foreignContactReference[charterInfo.colonyid] = {
                "id": charterInfo.colonyid,
                "charter": charterInfo.charter,
                "name": charterInfo.colonyname,
                "race": charterInfo.race,
                "maptype": charterInfo.maptype,
                "sx": charterInfo.sectorx,
                "sy": charterInfo.sectory,
                "gx": charterInfo.gridx,
                "gy": charterInfo.gridy,
                "embassyhere": false,
                "embassythere": false,
                "immigrants": 0
            };
        }

        sendACustomMessage(charterInfo.colonyid);
    }

    function getAnnexRequestInfo(message) {
        tmpHoldingMessage = message;

        var data = [];

        data.push({
            "key":      "cid",
            "value":    message.fromid
        });

        postSecuredCallToApi(data,39,onAnnexRequestInfoCheck);
    }

    function onAnnexRequestInfoCheck(result) {

        if(tmpHoldingMessage == null) {
            return;
        }

        var charterInfo = null;

        if(result != null && result.trim().length > 0) {
            try {
                charterInfo = JSON.parse(result)[0];
            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onAnnexRequestInfoCheck",ex.message);
                return;
            }
        }

        if(charterInfo == null) {
            webAppCore.showToast("Invalid Charter");
            return;
        }

        if(charterInfo.isindependent == "1") {
            deleteMail();
            webAppCore.showToast(charterInfo.colonyname + " is already independent!");
            return;
        }

        if(getRegionOrCity().foreignContactReference[charterInfo.colonyid] === undefined) {
            getRegionOrCity().foreignContactReference[charterInfo.colonyid] = {
                "id": charterInfo.colonyid,
                "charter": charterInfo.charter,
                "name": charterInfo.colonyname,
                "race": charterInfo.race,
                "maptype": charterInfo.maptype,
                "sx": charterInfo.sectorx,
                "sy": charterInfo.sectory,
                "gx": charterInfo.gridx,
                "gy": charterInfo.gridy,
                "embassyhere": false,
                "embassythere": false,
                "immigrants": 0
            };
        }

        pendingEmbassyTargetId = charterInfo.colonyid;
        pendingEmbassyColonyName = charterInfo.colonyname;

        var a = parseInt(currentGame.sX) - parseInt(charterInfo.sectorx);
        var b = parseInt(currentGame.sY) - parseInt(charterInfo.sectory);

        var c = Math.round(Math.sqrt( a*a + b*b ));

        c++;

        embassyCostTotal = {};

        var costString = tmpHoldingMessage.message + "  " + charterInfo.colonyname + " is located " + (c - 1) + " sectors away from us.  Annexing them into our Commonwealth will cost ";

        for(var i = 0; i < ColonyGame.meta.embassyCostPerSector.length; i++) {
            if(i == 0) {
                costString += " ";
            } else {
                costString += ", ";
            }

            embassyCostTotal[ColonyGame.meta.embassyCostPerSector[i].resource] = Math.ceil((ColonyGame.meta.embassyCostPerSector[i].amount * c) / 5);
            
            costString += getResourceByDefName(ColonyGame.meta.embassyCostPerSector[i].resource).indicator + numberWithCommas(ColonyGame.meta.embassyCostPerSector[i].amount * c);
        }

        costString += ".";

        if(parseInt(tmpHoldingMessage.amount) > 0) {

            if(embassyCostTotal[ColonyGame.meta.tenderResource] === undefined) {
                embassyCostTotal[ColonyGame.meta.tenderResource] = 0;
            }

            embassyCostTotal[ColonyGame.meta.tenderResource] += parseInt(tmpHoldingMessage.amount);

            costString += "  In addition, " + charterInfo.colonyname + " currently owes " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(parseInt(tmpHoldingMessage.amount)) + " in back taxes, which you will also be required to pay.";
        }

        webAppCore.showDialog({
            "title":    charterInfo.colonyname,
            "message":  costString,
            "op1": {
                "text":     getString("general-annex"),
                "func":     childAnnexYes
            },
            "op2": {
                "text":     getString("tax-window-reject"),
                "func":     childAnnexReject
            }
        });
    }

    var tmpAnexName;

    function childAnnexYes() {

        if(!tmpHoldingMessage) {
            return;
        }

        var canAfford = true;

        for(var cost1 in embassyCostTotal) {
            if(getGameResources()[cost1].amount < parseInt(embassyCostTotal[cost1])) {
                canAfford = false;
                break;
            }
        }

        if(!canAfford) {
            webAppCore.showToast("You cannot afford to annex " + tmpHoldingMessage.from + " right now");
        }

        for(var cost in embassyCostTotal) {
            modifyResourceAmount(cost,-embassyCostTotal[cost],false,"Diplomacy");
        }

        var annexMessage = "We have been annexed into the Commonwealth of " + getRegionOrCity().name;

        tmpAnexName = tmpHoldingMessage.from;

        sendMessage(tmpHoldingMessage.fromid,"8",0,annexMessage,showAnnexCompleteParent,null);

        deleteMail();
    }
    
    function showAnnexCompleteParent() {
        webAppCore.showAlertWithTitle("We have added " + tmpAnexName + " to our Commonwealth.",tmpAnexName);
    }

    function childAnnexReject() {
        tmpNewMsgTo = tmpHoldingMessage.fromid;
        deleteMail();
        onCWMessageSend(getRegionOrCity().name + " has rejected your request for annexation.");
    }

    function getNameAndColorByPlatformCode(platformCode) {
        var result = {
            name: platformCode,
            color: "#000000"
        };

        if(platformCode == "android" || platformCode == "android.gplay" || platformCode == "android.apemarket" || platformCode == "android.opera") {
            result.name = "Android";
            result.color = "#3DDB86";
        }

        if(platformCode == "android.amazon") {
            result.name = "Kindle Fire";
            result.color = "#FFB300";
        }

        if(platformCode == "ios" || platformCode == "ios.appstore") {
            result.name = "iOS";
            result.color = "#757575";
        }

        if(platformCode == "windows" || platformCode == "windows.windowsstore") {
            result.name = "Windows 10";
            result.color = "#1976D2";
        }

        if(platformCode == "web" || platformCode == "web.apewebapps") {
            result.name = "Ape Web Apps";
            result.color = "#FF9800";
        }

        if(platformCode == "web.kongregate") {
            result.name = "Kongregate";
            result.color = "#990000";
        }

        if(platformCode == "web.facebook") {
            result.name = "Facebook";
            result.color = "#3B5998";
        }

        if(platformCode == "web.chrome") {
            result.name = "Chrome";
            result.color = "#F44336";
        }

        if(platformCode == "desktop" || platformCode == "desktop.apemarket") {
            result.name = "Desktop";
            result.color = "#8E24AA";
        }

        if(platformCode == "desktop.windows") {
            result.name = "Windows";
            result.color = "#2196F3";
        }

        if(platformCode == "desktop.mac") {
            result.name = "macOS";
            result.color = "#7E57C2";
        }

        if(platformCode == "desktop.linux") {
            result.name = "Linux";
            result.color = "#FDD835";
        }

        if(platformCode == "steam.linux") {
            result.name = "Steam (Linux)";
            result.color = "#546E7A";
        }

        if(platformCode == "steam.mac") {
            result.name = "Steam (macOS)";
            result.color = "#546E7A";
        }

        if(platformCode == "steam.windows") {
            result.name = "Steam (Windows)";
            result.color = "#546E7A";
        }

        return result;
    }

    function completeParentSwitch(message) {
        getRegionOrCity().motherland = message.from;
        getRegionOrCity().motherlandid = message.fromid;
        getRegionOrCity().earthBackTax = 0;
    }

    function getRetainedPath(x,y,x2,y2) {

        if(!x || !y || !x2 || !y2) {
            return null;
        }

        var retainerName = x.toString();
        retainerName += y.toString();
        retainerName += x2.toString();
        retainerName += y2.toString();

        if(!retainedPaths[retainerName]) {
            return null;
        }

        var blocked = false;

        for(var i = 0; i < retainedPaths[retainerName].length; i++) {
            if(!isTilePassable(retainedPaths[retainerName][i].x,retainedPaths[retainerName][i].y,false)) {
                blocked = true;
                break;
            }
        }

        if(blocked) {
            delete retainedPaths[retainerName];
            delete retainedUsage[retainerName];
            return null;
        }

        if(retainedUsage[retainerName]) {
            retainedUsage[retainerName]++;
        } else {
            retainedUsage[retainerName] = 1;
        }
        
        return clonePathArray(retainedPaths[retainerName]);
    }

    function addPathWorkerListeener(pathWorker) {
        pathWorker.addEventListener("message",function(e) {
            var result = e.data;

            if(result.method == "checkPath") {

                if(result.data.data.length > 0 && result.data.type == "vehicle") {
                    var retainerName = result.data.data[0].x.toString();
                    retainerName += result.data.data[0].y.toString();
                    retainerName += result.data.data[result.data.data.length - 1].x.toString();
                    retainerName += result.data.data[result.data.data.length - 1].y.toString();

                    retainedPaths[retainerName] = clonePathArray(result.data.data);

                    retainedUsage[retainerName] = 0;
                }

                if(result.data.type == "colonist") {
                    colonistPathOrders[result.data.id] = result.data.data;
                } else {
                    vehiclePathOrders[result.data.id] = result.data.data;
                }
            }
        });
        
        pathWorker.addEventListener("error",function(e) {

            if(e && e.filename) {
                var scrpt = e.filename.substr(e.filename.lastIndexOf("/") + 1);
                webAppCore.logEvent("Path Worker Error",scrpt + ":" + e.lineno,e.message);
            }
            
        });
    }

    function gooseUpPathWorker() {

        if(useSyncPathfinding) {
            return;
        }

        if(pathWorker1 != null) {

            try {
                pathWorker1.terminate();
            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": gooseUpPathWorker",ex.message);
            }

            pathWorker1 = null;
        }

        pathWorker1 = new Worker("path-worker.js");

        addPathWorkerListeener(pathWorker1);
    }

    function getUnemploymentPercent(forStats) {
        if(currentGame == null) {
            return 0;
        }

        var useGame = currentGame;

        if(forStats) {
            if(currentGame.isSubregion && currentRegion) {
                useGame = currentRegion;
            }
        }

        if(useGame.isRegion) {
            var totalPop = 0;
            var totalUnemployed = 0;

            for(var i = 0; i < useGame.subRegions.length; i++) {

                var citypop = parseInt(useGame.subRegions[i].population);

                if(useGame.subRegions[i].unemploymentRate) {
                    totalPop += citypop;
                    totalUnemployed += Math.round(citypop * (useGame.subRegions[i].unemploymentRate / 100));
                }
                
            }

            var unemRte = ((totalUnemployed / totalPop) * 100).toFixed(1);

            return unemRte;
        } else {
            var unemployedPercent = useGame.historicStats.unemployment[useGame.historicStats.unemployment.length - 1];

            if(!unemployedPercent || isNaN(unemployedPercent)) {
                unemployedPercent = 0;
            }

            return unemployedPercent;
        }
    }

    function getTotalGDP(forStats) {
        if(currentGame == null) {
            return 0;
        }

        var useGame = currentGame;

        if(forStats) {
            if(currentGame.isSubregion && currentRegion) {
                useGame = currentRegion;
            }
        }

        if(useGame.isRegion) {
            var runningGDP = 0;

            for(var i = 0; i < useGame.subRegions.length; i++) {
                if(useGame.subRegions[i].totalGDP) {
                    runningGDP += parseInt(useGame.subRegions[i].totalGDP);
                }
                
            }

            return runningGDP;
        } else {
            var totalGDP = useGame.historicStats.gdp[useGame.historicStats.gdp.length - 1];

            if(!totalGDP || isNaN(totalGDP)) {
                totalGDP = 0;
            }

            return totalGDP;
        }
    }

    function getRetiredPop() {
        var retiredPop = 0;

        for(var age in currentGame.populationDistribution) {
            var checkAge = parseInt(age);

            if(isNaN(checkAge)) {
                continue;
            }

            if(checkAge > DEF_RETIREMENT_AGE) {
                retiredPop += currentGame.populationDistribution[age];
            }
        }

        return retiredPop;
    }

    function getMinorPopulation() {
        var minorPop = 0;

        for(var age in currentGame.populationDistribution) {
            var checkAge = parseInt(age);

            if(isNaN(checkAge)) {
                continue;
            }

            if(checkAge < DEF_ADULT_AGE) {
                minorPop += currentGame.populationDistribution[age];
            }
        }

        return minorPop;
    }

    function getTotalPopulation(forStats) {

        if(currentGame == null) {
            return 0;
        }

        var useGame = currentGame;

        if(forStats) {
            if(currentGame.isSubregion && currentRegion && !currentRegion.isMpRegionHolder) {
                useGame = currentRegion;
            }
        }

        if(useGame.isRegion) {
            var runningPop = 0;

            for(var i = 0; i < useGame.subRegions.length; i++) {
                runningPop += parseInt(useGame.subRegions[i].population);
            }

            return runningPop;
        } else {

            var totalPop = 0;

            if(!currentGame.populationDistribution) {
                currentGame.populationDistribution = {};
            }

            for(var age in currentGame.populationDistribution) {
                totalPop += parseInt(currentGame.populationDistribution[age]);
            }

            return totalPop;
        }

        
    }

    function destroyVehicle(object) {
        for(var i = 0; i < object.length; i++) {

            if(allowParticleEffects) {
                Scroll2d.playParticleEffect("explosion",object[i].x,object[i].y);
            }

            if(ColonyGame.sounds.explosion) {
                playInterfaceSoundEffect(ColonyGame.sounds.explosion);
            }

            removeFromArray(currentGame.vehicles,object[i]);

        }

        object = [];
        document.getElementById("objectOptions").style.display = "none";
    }

    function destroyResource(object,fromDozer,explode) {

        var resourcedef = getTerrainDefByName(object.def);

        if(fromDozer && resourcedef.indestructable && !currentGame.mem) {
            return false;
        }

        if(explode === "undefined") {
            explode = true;
        }

        if(explode) {

            for(var i = 0; i < object.occupiesTiles.length; i++) {
                if(allowParticleEffects) {
                    Scroll2d.playParticleEffect("explosion",object.occupiesTiles[i].x,object.occupiesTiles[i].y);
                }

                if(ColonyGame.sounds.explosion) {
                    playInterfaceSoundEffect(ColonyGame.sounds.explosion);
                }
            }

        }

        

        if(resourcedef.collectOnDestruction) {
            if(object.inventory > 0) {
                modifyResourceAmount(resourcedef.provides,object.inventory);
            }
        }

        removeFromArray(currentGame.mapResources,object);

        selectedResource = null;
        document.getElementById("objectOptions").style.display = "none";

        shoreUpdateTurn = true;
        shouldUpdateCollissionMap = true;

        return true;
    }

    function putColonistIntoStargate(age) {

        if(!hasStargate) {
            return;
        }

        currentGame.totalEmigration++;

        if(age == null || age == undefined || isNaN(age)) {
            age = randomIntFromInterval(DEF_ADULT_AGE,360);
        }

        if(currentGame.populationDistribution[age] && currentGame.populationDistribution[age] > 0) {
            currentGame.populationDistribution[age]--;
        }

        var stargateMessage = {
            "immigrant": {
                "name": "colonist",
                "race": getRegionOrCity().defaultRace,
                "age": parseInt(age),
                "money": currentGame.historicStats.savings[currentGame.historicStats.savings.length - 1],
                "iq": currentGame.historicStats.iq[currentGame.historicStats.iq.length - 1]
            }
        };

        postStargateMessage(stargateMessage);
    }

    function showModdingMenu() {
        var menuOptions = [];

        menuOptions.push({
            "title":        getString("general-texture-mods"),
            "description":  getString("text-mods-desc"),
            "icon":         null,
            "status":       null,
            "overflow":     null,
            "tag":          "texmod"
        });

        menuOptions.push({
            "title":        getString("general-map-editor"),
            "description":  getString("general-map-editor-desc"),
            "icon":         null,
            "status":       null,
            "overflow":     null,
            "tag":          "mapedit"
        });

        if(!webAppCore.isTV() && ColonyGame.meta.moddingCommunityUrl != null) {
            menuOptions.push({
                "title":        getString("general-modding-community"),
                "description":  getString("general-mod-comm-desc"),
                "icon":         null,
                "status":       ColonyGame.meta.moddingCommunityUrl,
                "status-color": "#2196F3",
                "overflow":     null,
                "tag":          "modcommunity"
            });
        }

        showList(getString("general-modding"),menuOptions,onModOptionSelected,getString("general-dismiss"));
    }

    function onModOptionSelected(tag) {
        if(!tag) {
            return;
        }

        if(tag == "texmod") {
            showTextureModMenu();
        }

        if(tag == "mapedit") {
            if(!webAppCore.getIsPremium()) {
                showPremiumMessage(getString("general-map-editor"));
                return;
            }

            
            mapEditorMenu();
        }

        if(tag == "modcommunity") {
            webAppCore.externalURL(ColonyGame.meta.moddingCommunityUrl);
        }
    }

    function mapEditorMenu() {
        var menuOptions = [];

        menuOptions.push({
            "title":        getString("general-new-map"),
            "description":  getString("general-new-map-desc"),
            "icon":         null,
            "status":       null,
            "overflow":     null,
            "tag":          "newmap"
        });

        menuOptions.push({
            "title":        getString("general-edit-existing"),
            "description":  getString("general-edit-existing-desc"),
            "icon":         null,
            "status":       null,
            "overflow":     null,
            "tag":          "exisintgmap"
        });

        menuOptions.push({
            "title": getString("general-go-back"),
            "title-color": null,
            "description": getString("general-go-back-desc"),
            "status": null,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.backIndicator,
            "tag": "back"
        });

        showList(getString("general-map-editor"),menuOptions,onMapEditorOptionChosen,getString("general-dismiss"));
    }

    function onMapEditorOptionChosen(tag) {
        if(!tag) {
            return;
        }

        if(tag == "back") {
            showModdingMenu();
        }

        if(tag == "newmap") {
            startMapEditor();
            editCustomMapMetaData();
        }

        if(tag == "exisintgmap") {
            loadCustomMap(onCustomMapOpenedForEditing,"general-edit-existing");
        }
    }

    function onCustomMapOpenedForEditing(mapObject) {

        startMapEditor();

        currentFileName = tmpSelectedCustomMapFilename;

        insertCustomMapTerrainIntoGame(currentGame,mapObject);

        currentGame.firstSave = false;

        Scroll2d.forceSceneChange();
        
        setWeather();

        setMapType();
        createMapEditorSideber();
    }

    function startMapEditor() {
        initScroll2d();

        currentGame = new Game(100,100,{
            "name":         "Map Editor",
            "disableTax":   false,
            "motherland":   "Map Editor",
            "motherlandid": 0,
            "mapType":      ColonyGame.mapTypes[0].name,
            "defaultRace":  ColonyGame.races[0].name,
            "civilization": ColonyGame.civilizations[0].name,
            "offline":      true,
            "mapEditorDummy": true
        });

        openJobsArray = [];
        killSwitch = false;
        curRegPreviewWorkQueue = [];
        lastColorFilter = null;
        curRegRiverTemplateCanvas = null;
        curRegRiverTemplateContext = null;
        curRegPreviewWorkItem = null;
        sizeElements();

        currentGame.cm = true;
        currentGame.offlineMode = true;
        currentGame.tradeNotifications = false;
        currentGame.hasCheated = true;
        

        pendingAutosales = [];
        retainedPaths = {};
        retainedPathsCounter = 0;
        shouldUpdateCollissionMap = true;
        buildingUpdateCycle = true;
        retainedUsage = {};

        riotingWarned = false;
        anarchyWarned = false;
        famineWarned = false;
        noWaterWarned = false;
        shoreUpdateTurn = true;


        setupResourceLedger();

        setMapType();

        Scroll2d.setMapDims(100,100);

        selectedBuilding = null;
        selectedVehicle = [];
        selectedResource = null;
        selectedColonist = null;
        selectedPassable = null;

        pendingBuildX = null;
        pendingBuildY = null;
        queuedBuildings = undefined;
        queuedBuilding = null;
        queuedBuildingBlocked = false;
        
        createCollisionReference();

        var buildingX = Math.floor(currentGame.width / 2);
        var buildingY = Math.floor(currentGame.height / 2);
    
        Scroll2d.setZoomLevel(1 / renderScaleFactor);
        Scroll2d.centerOnCoord(buildingX,buildingY);

        webAppCore.setTitleVisible(false);

        createCollisionReference();
        
        updateUtilityGrid();

        Scroll2d.forceSceneChange();

        Scroll2d.setZoomLevel(1 / renderScaleFactor);

        centerMap();
        setCenterMapIcon();

        titleShowing = false;

        setupMenuOptions();

        webAppCore.clearSplash();

        vehiclePathOrders = {};
        colonistPathOrders = {};

        window.focus();

        createSidebar();
        drawSidebar();
        
        initSoundtrack();

        Scroll2d.forceSceneChange();

        setWeather();

        currentFileName = null;

        setColonyThemeColor();
        
        setTimeout(Scroll2d.forceSceneChange(),500);
    }

    function showTextureModMenu() {
        var menuOptions = [];
        
        menuOptions.push({
            "title":        getString("general-tex-mod-activate"),
            "description":  getString("tex-mod-activate-desc"),
            "icon":         null,
            "status":       null,
            "overflow":     null,
            "tag":          "activate"
        });

        if(currentActiveTextureMod.length > 0) {
            menuOptions.push({
                "title":        getString("general-tex-mod-deactivate"),
                "description":  getString("tex-mod-deactivate-desc"),
                "icon":         null,
                "status":       "Current Active Mods: " + currentActiveTextureMod.length,
                "tag":          "deactivate"
            });
        }

        if(ColonyGame.meta.colonyServerApi != null) {
            menuOptions.push({
                "title":        getString("gen-dl-tex-mod"),
                "description":  getString("gen-dl-mod-desc"),
                "icon":         null,
                "status":       null,
                "overflow":     null,
                "tag":          "download"
            });
        }

        menuOptions.push({
            "title":        getString("general-tex-mod-import"),
            "description":  getString("tex-mod-import-desc"),
            "icon":         null,
            "status":       null,
            "overflow":     null,
            "tag":          "import"
        });

        if(window.innerWidth > 500 && !webAppCore.isTV()) {
            menuOptions.push({
                "title":        getString("general-tex-mod-create"),
                "description":  getString("tex-mod-editor-desc"),
                "icon":         null,
                "status":       null,
                "overflow":     null,
                "tag":          "create"
            });
        }

        menuOptions.push({
            "title": getString("general-go-back"),
            "title-color": null,
            "description": getString("general-go-back-desc"),
            "status": null,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.backIndicator,
            "tag": "back"
        });

        showList(getString("general-texture-mods"),menuOptions,onTexModOptionSelected,getString("general-dismiss"));
    }

    function onTexModOptionSelected(result) {
        if(!result) {
            return;
        }

        if(result == "download") {
            webAppCore.postForResult(ColonyGame.meta.colonyServerApi, [
                {
                    "key":      "f",
                    "value":    46
                },
                {
                    "key":      "relcd",
                    "value":    ColonyGame.meta.releaseCode
                },
                {
                    "key":      "g",
                    "value":    ColonyGame.meta.colonyServerGameId
                }
            ], onTexModListingBack);
        }

        if(result == "back") {
            showModdingMenu();
        }

        if(result == "import") {
            webAppCore.importFile(ColonyGame.meta.graphicsModFileFormat,onTexturePackImport);
        }

        if(result == "activate") {
            webAppCore.openListing(function(data) {
                onTextureListingBack(data,doActivateTextureCallback,getString("general-tex-mod-activate"));
            });
        }

        if(result == "deactivate") {
            webAppCore.openListing(function(data) {
                onTextureListingBack(data,doDeactivateTextureCallback,getString("general-tex-mod-deactivate"));
            });

            
        }

        if(result == "create") {
            webAppCore.showSplash("Loading Texture Editor...");
            webAppCore.navigateTo("texteditor.html");
        }
    }

    function onTexModListingBack(result) {
        if(result == null || result.trim().length == 0) {
            return;
        }

        var mods = null;
        
        try {
            mods = JSON.parse(result);
        } catch(ex) {
            webAppCore.showToast("No Mods Found!");
            webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onTexModListingBack",ex.message);
            return;
        }

        var menuOptions = [];

        for(var i = 0; i < mods.length; i++) {

            var currentRevision = parseInt(webAppCore.getVar("mod-meta-" + mods[i].texmodid + "." + ColonyGame.meta.graphicsModFileFormat + "-revision","0"));

            var modRevItem = null;
            var modRevCol = null;

            if(currentRevision > 0) {
                modRevItem = "Already Installed";
                modRevCol = "#4CAF50";

                if(parseInt(mods[i].modrevision) > currentRevision) {
                    modRevItem = "Update Available";
                    modRevCol = "#F44336";
                }
            }

            var modOption = {
                "title":        mods[i].modname,
                "description":  mods[i].moddescription,
                "status":       "Created by " + mods[i].author,
                "tag":          mods[i].texmodid,
                "overflow":     []
            };

            if(modRevItem != null) {
                modOption.overflow.push({
                    "post":     modRevItem,
                    "color":    modRevCol
                });
            }


            menuOptions.push(modOption);
        }

        showList(getString("gen-dl-tex-mod"),menuOptions,onTexModDownloadSelected,getString("general-dismiss"));
    }

    var pendingModDownloadTagId = null;

    function onTexModDownloadSelected(tag) {
        if(tag) {
            pendingModDownloadTagId = tag;

            webAppCore.postForResult(ColonyGame.meta.colonyServerApi, [
                {
                    "key":      "f",
                    "value":    47
                },
                {
                    "key":      "relcd",
                    "value":    ColonyGame.meta.releaseCode
                },
                {
                    "key":      "g",
                    "value":    ColonyGame.meta.colonyServerGameId
                },
                {
                    "key":      "mid",
                    "value":    tag
                }
            ], onTexModDownloadedFromServer);
        }
    }

    function onTexModDownloadedFromServer(result) {
        if(result == null || result.trim().length == 0) {
            return;
        }

        onTexturePackImport(pendingModDownloadTagId + "." + ColonyGame.meta.graphicsModFileFormat,result);
    }

    function onTexturePackImport(name,content) {
        if(!webAppCore.getIsPremium()) {
            showPremiumMessage(getString("general-texture-mods"));
            return;
        }

        try {
            JSON.stringify(content);
            pendingOpenTextureFileName = name;
            webAppCore.saveFile(name,content,function() {
                if(currentActiveTextureMod.indexOf(pendingOpenTextureFileName) == -1) {
                    currentActiveTextureMod.push(pendingOpenTextureFileName);
                }
                
                loadAllTextureMods();

                webAppCore.showToast("Mod Installed!");
            },true);
        } catch(ex) {
            webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onTexturePackImport",ex.message);
            webAppCore.showToast("Invalid mod!");
        }
    }

    function doActivateTextureCallback(tag) {
        if(!tag) {
            showTextureModMenu();
            return;
        }

        if(!webAppCore.getIsPremium()) {
            showPremiumMessage(getString("general-texture-mods"));
            return;
        }

        if(currentActiveTextureMod.indexOf(tag) == -1) {
            currentActiveTextureMod.push(tag);
        }

        saveModData();

        loadAllTextureMods();
    }

    function doDeactivateTextureCallback(tag) {
        if(!tag) {
            showTextureModMenu();
            return;
        }

        if(!webAppCore.getIsPremium()) {
            showPremiumMessage(getString("general-texture-mods"));
            return;
        }

        if(currentActiveTextureMod.indexOf(tag) == -1) {
            webAppCore.showDialog({
                "title":    getString("general-delete"),
                "message":  getString("gen-delete-mod-q"),
                "op1": {
                    "text": getString("general-yes"),
                    "func": function() {
                        webAppCore.deleteFile(tag,function() {
                            webAppCore.openListing(function(data) {
                                onTextureListingBack(data,doDeactivateTextureCallback,getString("general-tex-mod-deactivate"));
                                loadAssets();
                            });
                        });
                    },
                    "color": "#F44336"
                },
                "op2": {
                    "text": getString("general-no"),
                    "func": function() {
                        webAppCore.openListing(function(data) {
                            onTextureListingBack(data,doDeactivateTextureCallback,getString("general-tex-mod-deactivate"));
                        });
                    },
                    "color": "#2196F3"
                }
            });
        } else {
            removeFromArray(currentActiveTextureMod,tag);
            saveModData();
            loadAllTextureMods();

            webAppCore.openListing(function(data) {
                onTextureListingBack(data,doDeactivateTextureCallback,getString("general-tex-mod-deactivate"));
            });
        }

    }

    function onTextureListingBack(data,callback,title) {
        var menuOptions = [];
        
        for(var i = 0; i < data.length; i++) {
            if(endsWith(data[i],"." + ColonyGame.meta.graphicsModFileFormat)) {

                var useStatus = "Disabled";
                var useStatusColor = "#FF9800";
                var useTitle = data[i];
                var useDescription = null;

                if(currentActiveTextureMod.indexOf(data[i]) > -1) {
                    useStatus = "Active";
                    useStatusColor = "#4CAF50";
                }

                var des = webAppCore.getVar("mod-meta-" + data[i] + "-description","0");

                if(des != "0") {
                    useDescription = des;
                }

                var tit = webAppCore.getVar("mod-meta-" + data[i] + "-name","0");

                if(tit != "0") {
                    useTitle = tit;
                }

                var modOption = {
                    "title": useTitle,
                    "description": useDescription,
                    "tag": data[i],
                    "status": useStatus,
                    "status-color": useStatusColor,
                    "overflow": []
                };

                var author = webAppCore.getVar("mod-meta-" + data[i] + "-author","0");

                if(author != "0") {
                    modOption.overflow.push({
                        "post": "Created by " + author
                    });
                }

                menuOptions.push(modOption);
            }
        }

        if(menuOptions.length == 0) {
            webAppCore.showToast("No installed mods!");
        } else {
            webAppCore.presentNativeList(title,menuOptions,callback,webAppCore.getString("general-dismiss"));
        }
    }

    function onOpenTexturePackForActivation(data) {

        if(!data || data.length == 0) {

            if(curPendingTexLoadName) {
                removeFromArray(currentActiveTextureMod,curPendingTexLoadName);
            }

            checkForMoreModsToLoad();

            return;
        }

        if(!webAppCore.getIsPremium()) {
            currentActiveTextureMod = [];

            showPremiumMessage(getString("general-texture-mods"));

            curPendingTexLoadName = null;

            loadAssets();

            return;
        }


        try {
            currentModData = JSON.parse(data);

            if(curPendingTexLoadName) {
                webAppCore.storeVar("mod-meta-" + curPendingTexLoadName + "-name",currentModData.meta.name);
                webAppCore.storeVar("mod-meta-" + curPendingTexLoadName + "-author",currentModData.meta.author);
                webAppCore.storeVar("mod-meta-" + curPendingTexLoadName + "-description",currentModData.meta.description);
                webAppCore.storeVar("mod-meta-" + curPendingTexLoadName + "-revision",currentModData.meta.revision.toString());
                webAppCore.storeVar("mod-meta-" + curPendingTexLoadName + "-serverId",currentModData.meta.serverId.toString());
                webAppCore.storeVar("mod-meta-" + curPendingTexLoadName + "-url",currentModData.meta.url);
            }

            activeModFiles[currentModData.meta.name.trim()] = currentModData;
        } catch(ex) {
            webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onOpenTexturePackForActivation",ex.message);

        }

        

        checkForMoreModsToLoad();
        
    }

    function getModImage(name) {
        var modImage = null;

        if(activeModFiles) {
            for(var mod in activeModFiles) {
                var modDat = activeModFiles[mod];

                if(modDat.overrides && modDat.overrides[name]) {
                    modImage = modDat.overrides[name];
                }
            }
        }

        return modImage;
    }

    function checkForMoreModsToLoad() {
        if(pendingLoadTextures.length == 0) {

            curPendingTexLoadName = null;

            loadAssets();


        } else {
            curPendingTexLoadName = pendingLoadTextures.shift();
            webAppCore.openFile(curPendingTexLoadName,onOpenTexturePackForActivation);
        }
    }

    var pendingOpenTextureFileName = null;

    function centerMap() {

        if(!currentGame) {
            return;
        }

        if(currentGame.centerBuildingId == 0) {
            Scroll2d.centerOnCoord(Math.round(currentGame.width / 2),Math.round(currentGame.height / 2));
        } else {
            var centerbuilding = getBuildingById(currentGame.centerBuildingId);

            if(centerbuilding == null) {
                currentGame.centerBuildingId = 0;
                Scroll2d.centerOnCoord(Math.round(currentGame.width / 2),Math.round(currentGame.height / 2));
            } else {
                Scroll2d.centerOnCoord(centerbuilding.x,centerbuilding.y);
            }
        }

        
    }

    function setCenterMapIcon() {
        if(currentGame == null || currentGame.buildings.length == 0) {
            document.getElementById("imCenterMap").src = "images/" + ColonyGame.meta.centerMapIcon;
        } else {

            if(currentGame.centerBuildingId == 0 && currentGame.buildings.length > 0 && currentGame.buildings[0] != null) {
                currentGame.centerBuildingId = currentGame.buildings[0].id;
            }

            var centerbuilding = getBuildingById(currentGame.centerBuildingId);

            if(centerbuilding == null) {
                currentGame.centerBuildingId = 0;
                document.getElementById("imCenterMap").src = "images/" + ColonyGame.meta.centerMapIcon;
            } else {
                var centerDef = getBuildingDefByName(centerbuilding.def);

                var useAsset = getImageAsset(centerDef.tile[0],false,0,null);

                if(useAsset) {
                    var img = useAsset.src;
                    document.getElementById("imCenterMap").src = img;
                } else {
                    setTimeout(setCenterMapIcon,500);
                }

                
            }

            
        }
    }

    function loadVideoTutorials() {

        var mainSection = document.getElementById("encyclopediaMainSection");
        
        mainSection.style.display = "block";
        document.getElementById("encyclopediaSubSection").style.display = "none";
        document.getElementById("encyclopediaOwnersManual").style.display = "none";
        document.getElementById("encyclopediaVideoPlayer").style.display = "none";
        document.getElementById("encyclopediaVideoPlayerVidHolderFrame").src = "about:blank";

        mainSection.innerHTML = "";
        document.getElementById("encyclopediaOwnersManualContent").innerHTML = "";

        if(!webAppCore.isTV() && ColonyGame.meta.videoTutorialSubmissionUrl != null) {
            createEncyclopediaCard(mainSection,"images/" + ColonyGame.meta.mailIndicator,getString("general-vid-sumbit"),getString("general-vid-submit-desc"),function() {
                webAppCore.externalURL(ColonyGame.meta.videoTutorialSubmissionUrl);
            });
        }

        for(var i = 0; i < ColonyGame.videoTutorials.length; i++) {

            createEncyclopediaCard(mainSection,"images/" + ColonyGame.meta.videoTutorialsIndicator,ColonyGame.videoTutorials[i].title,"by " + ColonyGame.videoTutorials[i].author,function() {
                playVideoTutorial(this.tagObj);
            },ColonyGame.videoTutorials[i]);
        }


    }

    function showNewObjectOptionsMenu(object,type,newPassableX,newPassableY) {

        if(!object) {
            return;
        }


        document.getElementById("newObjectOptionsWindow").style.display = "block";
        newObjectOptionsOpen = true;

        var prop;

        document.getElementById("newObjectUpgradeOneSection").style.display = "none";
        document.getElementById("newObjectUpgradeAllSection").style.display = "none";
        document.getElementById("newObjectConsumptionSection").style.display = "none";
        document.getElementById("newObjectStorageSection").style.display = "none";
        document.getElementById("newObjectDeleteAllSection").style.display = "none";
        document.getElementById("newObjectResidentsSection").style.display = "none";
        document.getElementById("newObjectPatientsSection").style.display = "none";
        document.getElementById("newObjectTouristsSection").style.display = "none";
        document.getElementById("newObjectPrisonersSection").style.display = "none";
        document.getElementById("newObjectPassablePropertiesMainStat").innerHTML = "";
        document.getElementById("newObjectUpgradeCostHolder").innerHTML = "";
        document.getElementById("newObjectUpgradeChangesHolder").innerHTML = "";
        document.getElementById("newObjectUpgradeAllCostHolder").innerHTML = "";

        var newObjectValueSectionItems = document.getElementById("newObjectValueSectionItems");
        newObjectValueSectionItems.innerHTML = "";

        var thisDef = null;
        var totalcount = 0;
        var i,l,utilcstitem,ticksUntilConsumption,consumptionPerMinute;
        var upgrade = null;

        if(type == "passable") {
            thisDef = passableTileRefs[object];
            
            var td = currentGame.finishedPassableNonUpdatables[object];
            for(i in td) {
                totalcount += td[i].length;
            }
        }

        if(type == "building") {
            thisDef = getBuildingDefByName(object.def);
            var blds = currentGame.buildings;

            for(i = 0, l = blds.length; i< l; i++) {

                if(!blds[i]) {
                    continue;
                }

                if(blds[i].def == object.def) {
                    totalcount++;
                }
            }
        }

        if(type == "vehicle") {
            thisDef = getVehicleDefByName(object.def);
            var vhcs = currentGame.vehicles;

            for(i = 0, l = vhcs.length; i< l; i++) {
                if(vhcs[i].def == object.def) {
                    totalcount++;
                }
            }
        }

        if(!thisDef) {
            return;
        }

        document.getElementById("objectwindowName").innerHTML = thisDef.name;
        document.getElementById("newObjectPassablePropertiesName").innerHTML = thisDef.name;
        document.getElementById("newObjectPassablePropertiesMainStat").innerHTML = getString(thisDef.description);

        var useSpeed = 0;

        if(thisDef.driveSpeedMod != null) {
            useSpeed = thisDef.driveSpeedMod;
        }
        
        if(useSpeed > 0) {
            document.getElementById("newObjectPassablePropertiesMainStat").innerHTML += "<br />+" + useSpeed + " Movement Speed";
        }

        document.getElementById("newObjectPassablePropertiesMainCount").innerHTML = "Built: " + numberWithCommas(totalcount);

        if(type == "passable" || type == "building") {
            document.getElementById("newObjectShowEncyclopedia").style.display = null;
            document.getElementById("newObjectShowEncyclopedia").onclick = function() {
                closeObjectOptionsMenu();
                showColonistsMenu("encyclopedia");
                showEncyclopediaSubsection("buildings");
                loadEncyclopediaArticle("buildings",thisDef.name);
            };
        } else {
            document.getElementById("newObjectShowEncyclopedia").style.display = "none";
        }
        

        if(type == "passable" || type == "building") {

            var useobj = object;

            if(type == "passable") {
                useobj = {"def":object};
            }

            upgrade = isUpgradeAvailableForStructure(useobj);

            if(upgrade != null) {
                if(!canIBuildThis(upgrade.structure,"building",true)) {
                    upgrade = null;
                }
            }

            document.getElementById("newObjectDeleteAllSection").style.display = "block";
            document.getElementById("newObjectDeleteAllCostHolder").innerHTML = "Remove all " + numberWithCommas(totalcount) + " " + thisDef.name + " from the map.  This cannot be undone!" ;

            document.getElementById("newObjectDoDeleteAllEngage").delAllDefRef = thisDef.name;
            document.getElementById("newObjectDoDeleteAllEngage").delAllTypeRef = type;

            document.getElementById("newObjectDoDeleteAllEngage").onclick = function() {

                tmpDelAllTypeRef = this.delAllTypeRef;
                tmpDelAllDefRef = this.delAllDefRef;

                webAppCore.showDialog({
                    title:      getString("general-delete-all"),
                    message:    getString("gen-delete-all-confirm"),
                    "op1": {
                        "text": getString("general-yes"),
                        "func": function() {
                            conductDeleteAllEngage();
                            closeObjectOptionsMenu();
                        },
                        "color": "#F44336"
                    },
                    "op2": {
                        "text": getString("general-no"),
                        "func": placeholder,
                        "color": "#2196F3"
                    }
                });
            };
        }

        if(type == "building" && thisDef.stores != null && thisDef.stores.length > 0) {
            document.getElementById("newObjectStorageSection").style.display = "block";
            document.getElementById("newObjectStorageHolder").innerHTML = "";

            for(i = 0; i < thisDef.stores.length; i++) {

                var resName = thisDef.stores[i].resource;
                var resAmount = parseInt(thisDef.stores[i].amount);

                var curResAmount = parseInt(getGameResources()[resName].amount);
                var curResCapacity = parseInt(getGameResources()[resName].storageCapacity);

                var fullPercentRaw = curResAmount / curResCapacity;
                var fullPercent = Math.round(fullPercentRaw * 100);

                var readoutColor = "#ffffff";

                if(fullPercent > 100) {
                    fullPercent = 100;
                }

                if(fullPercent < 0) {
                    fullPercent = 0;
                }

                var resDef = getResourceByDefName(resName);

                if(!resDef) {
                    continue;
                }

                var displayFullLevel = "Empty";

                if(fullPercent == 100) {
                    displayFullLevel = "Full/" + resAmount;
                    readoutColor = "#F44336";
                } else {
                    if(fullPercent > 0) {
                        displayFullLevel = Math.round(resAmount * fullPercentRaw) + "/" + resAmount;
                    }
                }
                
                var storageResourceItem = document.createElement("div");
                storageResourceItem.className = "storageResourceItem";
                storageResourceItem.title = resName;

                var storageResoureItemIcon = document.createElement("img");
                storageResoureItemIcon.className = "storageResoureItemIcon";
                storageResoureItemIcon.src = "images/" + resDef.icon;
                storageResoureItemIcon.draggable = false;
                storageResourceItem.appendChild(storageResoureItemIcon);

                var storageResourceItemBarHolder = document.createElement("div");
                storageResourceItemBarHolder.className = "storageResourceItemBarHolder";

                var storageResourceItemBar = document.createElement("div");
                storageResourceItemBar.className = "storageResourceItemBar";
                storageResourceItemBar.style.width = fullPercent + "%";
                storageResourceItemBar.style.backgroundColor = resDef.color;
                storageResourceItemBarHolder.appendChild(storageResourceItemBar);

                var storageResourceItemResdout = document.createElement("div");
                storageResourceItemResdout.className = "storageResourceItemResdout";
                storageResourceItemResdout.innerHTML = displayFullLevel;
                storageResourceItemResdout.style.color = readoutColor;
                storageResourceItemBarHolder.appendChild(storageResourceItemResdout);

                storageResourceItem.appendChild(storageResourceItemBarHolder);

                document.getElementById("newObjectStorageHolder").appendChild(storageResourceItem);
            }
        }

        var costColor,upgradeCostItem,upgradeCostImage,upgradeCostCost,upgradeCostName;


        if(upgrade != null) {
            document.getElementById("newPassableUpgradeTo").innerHTML = "to " + upgrade.structure.name;
            
            document.getElementById("newObjectUpgradeOneSection").style.display = "block";
            document.getElementById("newObjectUpgradeAllSection").style.display = "block";

            var ujo = getImageAsset(thisDef.tile[0],false,0,null);

            if(ujo) {
                document.getElementById("newObjectDoUpgradeOldItem").src = ujo.src;
            } 

            var uni = getImageAsset(upgrade.structure.tile[0],false,0,null);

            if(uni) {
                document.getElementById("newObjectDoUpgradeNewItem").src = uni.src;
            }

            var canAfford = true;
            var canAffordAll = true;

            for(prop in upgrade.cost) {

                if(upgrade.cost[prop] <= 0) {
                    continue;
                }

                // single
                costColor = null;

                if(upgrade.cost[prop] > getGameResources()[prop].amount) {
                    canAfford = false;
                    costColor = "#F44336";
                }

                upgradeCostItem = document.createElement("div");
                upgradeCostItem.className = "upgradeCostItem";

                upgradeCostImage = document.createElement("img");
                upgradeCostImage.src = "images/" + getResourceByDefName(prop).icon;
                upgradeCostImage.className = "upgradeCostImage";
                upgradeCostItem.appendChild(upgradeCostImage);

                upgradeCostName = document.createElement("span");
                upgradeCostName.innerHTML = prop + ": ";
                upgradeCostName.className = "upgradeCostName";
                upgradeCostItem.appendChild(upgradeCostName);

                upgradeCostCost = document.createElement("span");
                upgradeCostCost.innerHTML = numberWithCommas(upgrade.cost[prop]);
                upgradeCostCost.className = "upgradeCostCost";
                upgradeCostCost.style.color = costColor;
                upgradeCostItem.appendChild(upgradeCostCost);

                document.getElementById("newObjectUpgradeCostHolder").appendChild(upgradeCostItem);


                // all 
                costColor = null;
                
                if(upgrade.cost[prop] * totalcount > getGameResources()[prop].amount) {
                    canAffordAll = false;
                    costColor = "#F44336";
                }

                upgradeCostItem = document.createElement("div");
                upgradeCostItem.className = "upgradeCostItem";

                upgradeCostImage = document.createElement("img");
                upgradeCostImage.src = "images/" + getResourceByDefName(prop).icon;
                upgradeCostImage.className = "upgradeCostImage";
                upgradeCostItem.appendChild(upgradeCostImage);

                upgradeCostName = document.createElement("span");
                upgradeCostName.innerHTML = prop + ": ";
                upgradeCostName.className = "upgradeCostName";
                upgradeCostItem.appendChild(upgradeCostName);

                upgradeCostCost = document.createElement("span");
                upgradeCostCost.innerHTML = numberWithCommas(upgrade.cost[prop] * totalcount);
                upgradeCostCost.className = "upgradeCostCost";
                upgradeCostCost.style.color = costColor;
                upgradeCostItem.appendChild(upgradeCostCost);

                document.getElementById("newObjectUpgradeAllCostHolder").appendChild(upgradeCostItem);
                
            }

            if(canAfford) {
                document.getElementById("newObjectDoUpgradeEngage").onclick = function() {

                    if(type == "passable") {
                        doNewPassableUpgrade(object,upgrade,newPassableX,newPassableY);

                    } else {
                        conductUpgrade(object,upgrade,type);
                    }

                    

                    closeObjectOptionsMenu();
                };

                document.getElementById("newObjectDoUpgradeEngage").enabled = true;
            } else {
                document.getElementById("newObjectDoUpgradeEngage").onclick = null;
                document.getElementById("newObjectDoUpgradeEngage").enabled = false;
            }

            if(canAffordAll) {

                document.getElementById("newObjectDoUpgradeAllEngage").onclick = function() {

                    if(type == "passable") {
                        for(var dieX in td) {
                            while(td[dieX].length > 0) {
                                var dieY = td[dieX].pop();

                                conductBuildingUpgradeEngage(upgrade,parseInt(dieX),parseInt(dieY),"passable",currentGame.passableNonUpdatables);
                                
                            }
                        }
                    } else {
                        var doneUpgrading = false;
                        
                        while(!doneUpgrading) {
                            var useArray = currentGame.buildings;

                            if(useArray) {
                                for(var i = 0; i < useArray.length; i++) {

                                    if(!useArray[i]) {
                                        continue;
                                    }

                                    if(useArray[i].def == object.def) {
                                        upgrade = isUpgradeAvailableForStructure(useArray[i]);
    
                                        if(upgrade == null) {
                                            webAppCore.showToast("Insufficient Funds");
                                            doneUpgrading = true;
                                            break;
                                        } else {
    
                                            conductUpgrade(useArray[i],upgrade,type,true);
                                        }
                                    }
                                }
                            }
                            

                            doneUpgrading = true;

                        }

                        clearOutBuildMenu();

                        //callForHireFlag = true;

                        updateUtilityGrid();
                    }

                    staticFrame = false;
                    Scroll2d.forceSceneChange();

                    closeObjectOptionsMenu();
                };

                

                document.getElementById("newObjectDoUpgradeAllEngage").enabled = true;
            } else {
                document.getElementById("newObjectDoUpgradeAllEngage").onclick = null;
                document.getElementById("newObjectDoUpgradeAllEngage").enabled = false;
            }
        }

        if(currentTicksPerMinute < 20) {
            currentTicksPerMinute = 200;
        }

        // consumption
        if(type == "building") {

            var consumptionItems = {
                consumption: {},
                production: {}
            };

            document.getElementById("newObjectConsumptionSection").style.display = "block";

            if(object.deactivated) {
                document.getElementById("newObjectActiveIndication").innerHTML = "Deactivated";
                document.getElementById("newObjectActiveIndication").style.color = "#F44336";
            } else {
                document.getElementById("newObjectActiveIndication").innerHTML = "Activated";
                document.getElementById("newObjectActiveIndication").style.color = "#4CAF50";
            }

            document.getElementById("newObjectConsumptionSectionConsumptionDeets").innerHTML = "";
            document.getElementById("newObjectConsumptionSectionProductionDeets").innerHTML = "";


            if(thisDef.requiresUtility != null) {
                for(i = 0; i < thisDef.requiresUtility.length; i++) {

                    

                    utilcstitem = thisDef.requiresUtility[i];

                    if(!consumptionItems.consumption[utilcstitem.utility]) {
                        consumptionItems.consumption[utilcstitem.utility] = {
                            amount: 0,
                            append: null,
                            type: "util"
                        };
                    }


                    consumptionItems.consumption[utilcstitem.utility].amount += utilcstitem.amount;

                }
            }

            if(thisDef.providesUtility != null) {
                for(i = 0; i < thisDef.providesUtility.length; i++) {
                    

                    utilcstitem = thisDef.providesUtility[i];

                    if(!consumptionItems.production[utilcstitem.utility]) {
                        consumptionItems.production[utilcstitem.utility] = {
                            amount: 0,
                            append: null,
                            type: "util"
                        };
                    }

                    consumptionItems.production[utilcstitem.utility].amount += utilcstitem.amount;

                }
            }

            if(thisDef.smelts != null) {
                var countsPerTick = buildingUpdateCycles;

                if(thisDef.requiresWorkers) {
                    countsPerTick = 0;
                }

                for(i = 0; i < object.buW; i++) {
                    countsPerTick += buildingUpdateCycles;
                }

                var ticksUntilSmelt = thisDef.smelts.time / countsPerTick;
                var smeltsPerMinute = currentTicksPerMinute / ticksUntilSmelt;

                var smeltItems = [];

                if(thisDef.smelts.input) {
                    smeltItems = thisDef.smelts.input.split(",");
                }

                for(i = 0; i < smeltItems.length; i++) {

                    if(!consumptionItems.consumption[smeltItems[i]]) {
                        consumptionItems.consumption[smeltItems[i]] = {
                            amount: 0,
                            append: " / minute",
                            type: "res"
                        };
                    }

                    consumptionItems.consumption[smeltItems[i]].amount += smeltsPerMinute;

                }

                if(thisDef.smelts.output != null) {
                    var outputResourceAll = thisDef.smelts.output.split("|");
                    var totalOutputPerMinute = thisDef.smelts.ratio * smeltsPerMinute;
                    var smeltPerItemChance = totalOutputPerMinute / outputResourceAll.length;
                    
                    for(i = 0; i < outputResourceAll.length; i++) {


                        if(!consumptionItems.production[outputResourceAll[i]]) {
                            consumptionItems.production[outputResourceAll[i]] = {
                                amount: 0,
                                append: " / minute",
                                type: "res"
                            };
                        }
    
                        consumptionItems.production[outputResourceAll[i]].amount += smeltPerItemChance;

                    }
                }
            }

            if(thisDef.requiresFuel != null) {
                ticksUntilConsumption = thisDef.requiresFuel.rate / buildingUpdateCycles;
                consumptionPerMinute = currentTicksPerMinute / ticksUntilConsumption;

                var fuelRequirements = thisDef.requiresFuel.resource.split(",");

                for(i = 0; i < fuelRequirements.length; i++) {

                    if(!consumptionItems.consumption[fuelRequirements[i]]) {
                        consumptionItems.consumption[fuelRequirements[i]] = {
                            amount: 0,
                            append: " / minute",
                            type: "res"
                        };
                    }

                    consumptionItems.consumption[fuelRequirements[i]].amount += consumptionPerMinute;

                }
            }

            if(thisDef.generates != null) {

                var genCyclesToUse = buildingUpdateCycles;

                if(thisDef.requiresWorkers > 0) {
                    genCyclesToUse = buildingUpdateCycles * object.buW;
                }

                ticksUntilConsumption = object.gc / genCyclesToUse;
                consumptionPerMinute = currentTicksPerMinute / ticksUntilConsumption;

                if(!consumptionItems.production[thisDef.generates]) {
                    consumptionItems.production[thisDef.generates] = {
                        amount: 0,
                        append: " / minute",
                        type: "res"
                    };
                }

                consumptionItems.production[thisDef.generates].amount += consumptionPerMinute;
            }

            for(var ci in consumptionItems.consumption) {

                if(object.deactivated) {
                    consumptionItems.consumption[ci].amount = 0;
                }

                upgradeCostItem = document.createElement("div");
                upgradeCostItem.className = "upgradeCostItem";

                
    
                upgradeCostImage = document.createElement("img");

                if(consumptionItems.consumption[ci].type == "util") {
                    upgradeCostImage.src = "images/" + getUtilityByDefName(ci).icon;
                } else {
                    upgradeCostImage.src = "images/" + getResourceByDefName(ci).icon;
                }

                
                upgradeCostImage.className = "upgradeCostImage";
                upgradeCostItem.appendChild(upgradeCostImage);
    
                upgradeCostName = document.createElement("span");
                upgradeCostName.innerHTML = ci + ": ";
                upgradeCostName.className = "upgradeCostName";
                upgradeCostItem.appendChild(upgradeCostName);
    
                upgradeCostCost = document.createElement("span");
                upgradeCostCost.innerHTML = numberWithCommas(consumptionItems.consumption[ci].amount);

                if(consumptionItems.consumption[ci].append != null) {
                    upgradeCostCost.innerHTML += consumptionItems.consumption[ci].append;
                }

                upgradeCostCost.className = "upgradeCostCost";
                upgradeCostItem.appendChild(upgradeCostCost);
    
                document.getElementById("newObjectConsumptionSectionConsumptionDeets").appendChild(upgradeCostItem);
            }

            for(var pi in consumptionItems.production) {

                if(object.deactivated) {
                    consumptionItems.production[pi].amount = 0;
                }

                upgradeCostItem = document.createElement("div");
                upgradeCostItem.className = "upgradeCostItem";

                
    
                upgradeCostImage = document.createElement("img");
                
                if(consumptionItems.production[pi].type == "util") {
                    upgradeCostImage.src = "images/" + getUtilityByDefName(pi).icon;
                } else {
                    upgradeCostImage.src = "images/" + getResourceByDefName(pi).icon;
                }

                upgradeCostImage.className = "upgradeCostImage";
                upgradeCostItem.appendChild(upgradeCostImage);
    
                upgradeCostName = document.createElement("span");
                upgradeCostName.innerHTML = pi + ": ";
                upgradeCostName.className = "upgradeCostName";
                upgradeCostItem.appendChild(upgradeCostName);
    
                upgradeCostCost = document.createElement("span");
                upgradeCostCost.innerHTML = numberWithCommas(consumptionItems.production[pi].amount);

                if(consumptionItems.production[pi].append != null) {
                    upgradeCostCost.innerHTML += consumptionItems.production[pi].append;
                }

                upgradeCostCost.className = "upgradeCostCost";
                upgradeCostItem.appendChild(upgradeCostCost);
    
                document.getElementById("newObjectConsumptionSectionProductionDeets").appendChild(upgradeCostItem);
            }


            if(object.deactivated) {
                document.getElementById("objectActivationAll").className = null;
                document.getElementById("objectActivationAll").innerHTML = getString("general-activate-all");
            } else {
                document.getElementById("objectActivationAll").className = "dismiss";
                document.getElementById("objectActivationAll").innerHTML = getString("general-deactivate-all");
            }

            document.getElementById("objectActivationAll").onclick = function() {
                document.getElementById("objectOptions").style.display = "none";
                var setStatus = !object.deactivated;

                var killList = [];

                for(var i = 0; i < currentGame.buildings.length; i++) {
                    if(!currentGame.buildings[i]) {
                        killList.push(currentGame.buildings[i]);
                        continue;
                    }

                    if(currentGame.buildings[i].def == object.def) {
                        currentGame.buildings[i].deactivated = setStatus;
                    }
                }

                while(killList.length > 0) {
                    removeFromArray(currentGame.buildings,killList.pop());
                }
                
                updateUtilityGrid();

                staticFrame = false;
                Scroll2d.forceSceneChange();

                closeObjectOptionsMenu();
            };
        }

        if(type == "building") {
            document.getElementById("newObjectValueSection").style.display = null;

            // overall land value 
            newObjectValueSectionItems.appendChild(createStatBarGraph(object.bRLV,100,null,getString("gen-overall-value"),null));

            // condition rating
            newObjectValueSectionItems.appendChild(createStatBarGraph(object.condition,100,getString("gen-factors"),getString("gen-building-condition"),null));

            // accessability rating
            var access = 0;
            if(object.hOS) {
                access = 100;
            }
            newObjectValueSectionItems.appendChild(createStatBarGraph(access,100,null,getString("gen-accessability-rating"),null));

            // for residential structures 
            if(thisDef.providesShelter > 0) {
                // entertainment rating
                newObjectValueSectionItems.appendChild(createStatBarGraph(object.brE,100,null,getString("gen-entertainment-avail"),null));

                // education rating
                newObjectValueSectionItems.appendChild(createStatBarGraph(object.brS,100,null,getString("gen-education-avail"),null));

                // medical rating
                newObjectValueSectionItems.appendChild(createStatBarGraph(object.brM,100,null,getString("gen-medical-avail"),null));

                // commute rating
                newObjectValueSectionItems.appendChild(createStatBarGraph(object.brCT,100,null,getString("gen-commute-rating"),null));
            }

            // safety rating
            newObjectValueSectionItems.appendChild(createStatBarGraph(object.brSAF,100,null,getString("gen-safety-rating"),null));

            // occupation rating 
            if(thisDef.acceptsWorkers > 0) {
                newObjectValueSectionItems.appendChild(createStatBarGraph(object.brWF,100,null,getString("gen-workforce-rating"),null));
            }
        } else {
            document.getElementById("newObjectValueSection").style.display = "none";
        }
    }

    var tmpDelAllTypeRef = null;
    var tmpDelAllDefRef = null;

    function conductDeleteAllEngage() {

        if(!currentGame) {
            return;
        }

        if(tmpDelAllTypeRef == "passable") {
            currentGame.finishedPassableNonUpdatables[tmpDelAllDefRef] = {};
        }

        if(tmpDelAllTypeRef == "building") {
            var killList = [];

            for(var i = 0; i < currentGame.buildings.length; i++) {

                if(!currentGame.buildings[i]) {
                    killList.push(currentGame.buildings[i]);
                    continue;
                }

                if(currentGame.buildings[i].def == tmpDelAllDefRef) {
                    killList.push(currentGame.buildings[i]);
                }
            }


            while(killList.length > 0) {
                removeFromArray(currentGame.buildings,killList.pop());
            }

        }

        buildingUpdateTicker = buildingUpdateCycles;
        updateUtilityGrid();
        staticFrame = false;
        Scroll2d.forceSceneChange();
    }

    function doNewPassableUpgrade(def,upgrade,x,y) {
        var killItem = null;
        var td = currentGame.finishedPassableNonUpdatables[def];
                        
        for(var ty = 0; ty < td[x].length; ty++) {
            if(parseInt(td[x][ty]) == y) {
                killItem = ty;
                break;
            }
        }

        if(killItem != null) {
            td[x].splice(ty,1);
            staticFrame = false;
            Scroll2d.forceSceneChange();
        }

        conductBuildingUpgradeEngage(upgrade,parseInt(x),parseInt(y),"passable",currentGame.passableNonUpdatables);
    }

    function conductBuildingUpgradeEngage(to,x,y,type,arrayToUse,flipped) {
        if(!to.structure) {
            return;
        }

        var firstBuilding = new Building(to.structure,x,y,getRegionOrCity().localPlayerId);
        firstBuilding.iuc = true;

        if(flipped) {
            firstBuilding.flipped = flipped;
        }

        firstBuilding.occupiesTiles = getOccupiedTiles(firstBuilding);

        constructionProjectsArray.push(firstBuilding);

        arrayToUse.push(firstBuilding);

        if(type == "building") {
            updateUtilityGrid();
            updateBuildingCollisionPoints(firstBuilding,150);
        }

        firstBuilding.c = new ConstructionItem();


        firstBuilding.c.c = 0;
        firstBuilding.c.p = 0;
        firstBuilding.c.t = 0;
        firstBuilding.c.pr = {};

        for(var res in to.cost) {

            firstBuilding.c.pr[res] = to.cost[res];
            firstBuilding.c.t += to.cost[res];

        }

        callNearbyBuilders(firstBuilding.x,firstBuilding.y,0);

        staticFrame = false;
        Scroll2d.forceSceneChange();
    }

    function fetchReleaseNotes() {

        if(ColonyGame.meta.releaseNotesServer == null) {
            return;
        }

        var notesUrl = ColonyGame.meta.releaseNotesServer + ColonyGame.meta.releaseCode + ".php";

        webAppCore.getForResult(notesUrl, null, onReleaseNotes);
    }

    function onReleaseNotes(data) {
        if(!data || data.trim().length == 0 || data.indexOf("###") == -1) {
            return;
        }

        webAppCore.storeVar("release-notes-" + ColonyGame.meta.releaseCode,"1");

        var noteParts = data.trim().split("###");

        var releaseObject = {
            "title":    ColonyGame.meta.name + " v" + ColonyGame.meta.buildVersion,
            "message":  noteParts[0]
        };

        if(webAppCore.isTV()) {
            releaseObject.op1 = {
                "text":     getString("general-dismiss"),
                "func":     placeholder
            };
        } else {

            releaseObject.op1 = {
                "text":     "Release Notes",
                "func":     function() {
                    webAppCore.externalURL(noteParts[1]);
                }
            };

            releaseObject.op2 = {
                "text":     getString("general-dismiss"),
                "func":     placeholder
            };
        }



        webAppCore.showDialog(releaseObject);
    }

    function showDesktopBuildConfirm() {

        if(queuedBuilding == null) {
            return;
        }

        if(webAppCore.getIsPremium() && queuedBuilding.canFlip) {
            document.getElementById("imgFlipToggleDesktop").style.display = "block";
        } else {
            document.getElementById("imgFlipToggleDesktop").style.display = "none";
        }

        document.getElementById("touchBuildConfirm").style.display = "none";
        document.getElementById("desktopBuildConfirm").style.display = "block";

        document.getElementById("desktopBuildConfirmHeader").innerHTML = queuedBuilding.name;

        var buildCount = 0;

        if(queuedBuildings) {
            buildCount = queuedBuildings.length + 1;
        }

        if(buildCount > 1) {
            document.getElementById("desktopBuildConfirmHeader").innerHTML += " x" + buildCount;
        }

        document.getElementById("desktopBuildConfirmCosts").innerHTML = "";
        var cost = [];
        var costColor,j,def;

        if(queuedBuilding) {

            if(queuedBuilding.requiresUtility) {
                for(j = 0; j < queuedBuilding.requiresUtility.length; j++) {
                    
                    def = getUtilityByDefName(queuedBuilding.requiresUtility[j].utility);

                    costColor = null;

                    if((queuedBuilding.requiresUtility[j].amount * buildCount) + getGameUtilities()[queuedBuilding.requiresUtility[j].utility].usage > getGameUtilities()[queuedBuilding.requiresUtility[j].utility].capacity) {
                        costColor = "#F44336";
                    }

                    cost.push({
                        pre:    "Requires:",
                        post:   numberWithCommas((queuedBuilding.requiresUtility[j].amount * buildCount)),
                        color:  costColor,
                        icon:   "images/" + def.icon
                    });
                }
            }


            if(queuedBuilding.providesUtility) {
                for(j = 0; j < queuedBuilding.providesUtility.length; j++) {
                    
                    def = getUtilityByDefName(queuedBuilding.providesUtility[j].utility);

                    costColor = null;


                    cost.push({
                        pre:    "Generates:",
                        post:   numberWithCommas((queuedBuilding.providesUtility[j].amount * buildCount)),
                        color:  null,
                        icon:   "images/" + def.icon
                    });
                }
            }


            if(queuedBuilding.cost) {
                for(j = 0; j < queuedBuilding.cost.length; j++) {
                
                    def = getResourceByDefName(queuedBuilding.cost[j].resource);
        
                    costColor = null;
        
                    if((queuedBuilding.cost[j].amount * buildCount) > getGameResources()[queuedBuilding.cost[j].resource].amount) {
                        costColor = "#F44336";
                    }
        
                    cost.push({
                        pre:    "Cost:",
                        post:   def.indicator + numberWithCommas((queuedBuilding.cost[j].amount * buildCount)),
                        color:  costColor,
                        icon:   "images/" + def.icon
                    });
                }
            }
        }
        
        


        for(j = 0; j < cost.length; j++) {
            
            var overflowItem = cost[j];
            
            var optionCostSpan = document.createElement("span");
            optionCostSpan.innerHTML = overflowItem.pre + " <img src=\"" + overflowItem.icon + "\" /> " + overflowItem.post;
            optionCostSpan.className = "infoboxOptionCost";
            if(overflowItem.color != null) {
                optionCostSpan.style.color = overflowItem.color;
            }
            document.getElementById("desktopBuildConfirmCosts").appendChild(optionCostSpan);
        }

    }

    function closeObjectOptionsAndClear() {
        selectedBuilding = null;

        selectedColonist = null;

        drawSidebar();

        selectedVehicle = [];
        document.getElementById("objectOptions").style.display = "none";
    }

    var silosNeededCooldown = 0;
    
    function notifySilosNeeded(resource,forCapacity) {

        if(silosNeededCooldown > 0) {
            return;
        }

        silosNeededCooldown = 1500;

        var highestOption = null;
        var refines = false;
        var j;

        for(var i = 0, len = ColonyGame.buildings.length; i < len; i++) {

            refines = false;

            if(forCapacity) {

                if(ColonyGame.buildings[i].stores == null) {
                    continue;
                }

                for(j = 0; j < ColonyGame.buildings[i].stores.length; j++) {
                    if(ColonyGame.buildings[i].stores[j].resource == resource) {
                        refines = true;
                        break;
                    }
                }
            } else {

                if(ColonyGame.buildings[i].refines == null) {
                    continue;
                }

                for(j = 0; j < ColonyGame.buildings[i].refines.length; j++) {
                    if(ColonyGame.buildings[i].refines[j].input == resource) {
                        refines = true;
                        break;
                    }
                }
            }

            if(!refines) {
                continue;
            }

            if(canIBuildThis(ColonyGame.buildings[i],"building")) {
                highestOption = ColonyGame.buildings[i];
            }
        }

        if(highestOption != null) {

            var hio = getImageAsset(highestOption.tile[0],false,0,null);

            if(hio) {
                var img = hio.src;

                webAppCore.showToast({
                    "message":      highestOption.name + " needed!",
                    "image":        img
                });
            }
        }
    }

    function postSecuredCallToApi(data,func,callback) {
        var roc = getRegionOrCity();
        
        if(roc == null || !roc.colonyId || roc.colonyId == 0) {
            return;
        }

        var keys = webAppCore.getApeAppsLoginKeys();

        if(!keys) {
            return;
        }

        data.push({
            "key":      "f",
            "value":    func
        });

        data.push({
            "key":      "g",
            "value":    ColonyGame.meta.colonyServerGameId
        });

        data.push({
            "key":      "i",
            "value":    roc.colonyId
        });

        data.push({
            "key":      "k",
            "value":    roc.apiKey
        });

        data.push({
            "key":      "relcd",
            "value":    ColonyGame.meta.releaseCode
        });

        data.push({
            "key":      "aun",
            "value":    roc.apeAppsUsername
        });

        data.push({
            "key":      "sa",
            "value":    keys.a
        });

        data.push({
            "key":      "sb",
            "value":    keys.b
        });

        data.push({
            "key":      "sc",
            "value":    keys.c
        });

        data.push({
            "key":      "gdcs",
            "value":    gameDataChecksum
        });

        data.push({
            "key":      "sdcs",
            "value":    scriptDataChecksum
        });

        data.push({
            "key":      "vplat",
            "value":    webAppCore.getPlatform().market
        });

        webAppCore.postForResult(ColonyGame.meta.colonyServerApi, data, callback);
    }

    function createOcean(type,avX,avY,avD) {
        var oceanData = [];
        var i,j,cur;

        for(i = 0; i <= currentGame.width; i++) {
            oceanData[i] = [];
            for(j = 0; j <= currentGame.height; j++) {
                oceanData[i][j] = 1;
            }
        }

        for(var x = avX - avD; x < avX + avD; x++) {
            for(var y = avY - avD; y < avY + avD; y++) {
                if(x < 0 || y < 0 || x > currentGame.width || y > currentGame.height) {
                    continue;
                }

                oceanData[x][y] = 0;
            }
        }

        var useScale = currentGame.width / 100;

        var randomStartlets = Math.ceil(useScale * 10);

        while(randomStartlets > 0) {
            randomStartlets--;

            var rx = randomIntFromInterval(0,currentGame.width);
            var ry = randomIntFromInterval(0,currentGame.height);

            oceanData[rx][ry] = 0;
        }

        var islandPasses = Math.ceil(useScale * 35);
        var doChance = 0;

        while(islandPasses > 0) {
            islandPasses--;

            for(i = 0; i <= currentGame.width; i++) {
                for(j = 0; j <= currentGame.height; j++) {
                    cur = oceanData[i][j];

                    if(cur == 0) {
                        if(i > 0) {
                            doChance = randomIntFromInterval(0,8);

                            if(doChance == 2) {
                                oceanData[i - 1][j] = 0;
                            }
                        }

                        if(i < currentGame.width) {
                            doChance = randomIntFromInterval(0,8);

                            if(doChance == 2) {
                                oceanData[i + 1][j] = 0;
                            }
                        }

                        if(j > 0) {
                            doChance = randomIntFromInterval(0,8);

                            if(doChance == 2) {
                                oceanData[i][j - 1] = 0;
                            }
                        }

                        if(j < currentGame.height) {
                            doChance = randomIntFromInterval(0,8);

                            if(doChance == 2) {
                                oceanData[i][j + 1] = 0;
                            }
                        }
                    }
                }
            }
        }

        var terrainDef = getTerrainDefByName(type);
        var resourceItem;

        for(i = 0; i <= currentGame.width; i++) {
            for(j = 0; j <= currentGame.height; j++) {
                cur = oceanData[i][j];

                if(cur == 1) {
                    if(isTilePassable(i,j,true)) {
                        resourceItem = new MapResource(terrainDef,i,j);
                        freeRefNukeTurn = true;
                        updateBuildingCollisionPoints(resourceItem,150,true);
                        currentGame.mapResources.push(resourceItem);
                        shoreUpdateTurn = true;
                    }
                }
            }
        }
    }

    function workOnRegionPreviewImageQueue() {
        if(curRegPreviewWorkItem || !curRegPreviewWorkQueue || curRegPreviewWorkQueue.length == 0) {
            return;
        }

        curRegPreviewWorkItem = curRegPreviewWorkQueue.shift();

        var templateData = currentGame.waterTemplateData;

        if(!templateData) {
            curRegRiverTemplateCanvas = null;
            curRegRiverTemplateContext = null;
            return;
        }

        if(!curRegRiverTemplateCanvas || !curRegRiverTemplateContext) {
            curRegRiverTemplateCanvas = document.createElement("canvas");
            curRegRiverTemplateContext = curRegRiverTemplateCanvas.getContext("2d");

            curRegRiverTemplateCanvas.height = 2601;
            curRegRiverTemplateCanvas.width = 2601;

            var img = new Image();
            img.onload = function() {
                curRegRiverTemplateContext.drawImage(this,0,0,2601,2601);
                processWOrkRegionPreviewImage();
            };
            img.src = templateData;
        } else {
            processWOrkRegionPreviewImage();
        }
    }

    function processWOrkRegionPreviewImage() {
        if(!curRegPreviewWorkItem || !curRegRiverTemplateCanvas || !curRegRiverTemplateContext) {
            return;
        }

        var sX = curRegPreviewWorkItem.x * 50;
        var sY = curRegPreviewWorkItem.y * 50;

        var dx,dy;

        var resultCanvas = document.createElement("canvas");
        var resultContext = resultCanvas.getContext("2d");

        resultCanvas.width = ColonyGame.meta.gridSize;
        resultCanvas.height = Math.ceil(ColonyGame.meta.gridSize / 2);

        dx = 0;

        // river color
        resultContext.fillStyle = "#2196F3";

        var mapType = currentGame.mapType;

        var planetDef = getPlanetDefByName(mapType);

        if(planetDef && planetDef.mapRiverColor) {
            resultContext.fillStyle = planetDef.mapRiverColor;
        }

        var scale = ColonyGame.meta.gridSize / 50;

        for(var x = sX; x <= sX + 50; x++) {
            dy = 0;

            for(var y = sY; y <= sY + 50; y++) {
                var imgData = curRegRiverTemplateContext.getImageData(x,y,1,1);
                var data = imgData.data;

                var red = data[0];
                var green = data[1];
                var blue = data[2];

                var weight = red + green + blue;

                if(weight < 380) {
                    //resultContext.fillStyle = "#2196F3";
                } else {
                    dy++;
                    continue;
                }

                var isoX = Math.round((dx - dy) * 0.5);
                var isoY = Math.round((dx + dy) * 0.25);

                

                isoX *= scale;
                isoY *= scale;

                isoX += Math.round(ColonyGame.meta.gridSize / 2);

                resultContext.fillRect(isoX,isoY,scale,scale);

                dy++;
            }

            dx++;
        }

        var rawData = resultCanvas.toDataURL();



        if(currentGame && currentGame.regionSquareTemplateImages[curRegPreviewWorkItem.x] && currentGame.regionSquareTemplateImages[curRegPreviewWorkItem.x][curRegPreviewWorkItem.y]) {
            currentGame.regionSquareTemplateImages[curRegPreviewWorkItem.x][curRegPreviewWorkItem.y].data = rawData;
            currentGame.regionSquareTemplateImages[curRegPreviewWorkItem.x][curRegPreviewWorkItem.y].loading = false;
        }

        

        curRegPreviewWorkItem = null;
    }

    function createRiverFromTemplateData(type,avX,avY,avD,templateData,callback,sX,sY,sW,sH) {

        var terrainDef = getTerrainDefByName(type);

        var a,b,travelDistance,resourceItem;

        var img = new Image();
        img.onload = function(){
            buildingUpdateCycle = true;

            var fullCanvas = document.createElement("canvas");
            var fullContext = fullCanvas.getContext("2d");

            fullCanvas.height = 2601;
            fullCanvas.width = 2601;

            fullContext.drawImage(this,0,0,2601,2601);

            var dx = 0;
            var dy = 0;

            for(var x = sX; x <= sX + sW; x++) {
                dy = 0;

                for(var y = sY; y <= sY + sH; y++) {
                    var imgData = fullContext.getImageData(x,y,1,1);
                    var data = imgData.data;

                    var red = data[0];
                    var green = data[1];
                    var blue = data[2];

                    var weight = red + green + blue;

                    if(weight < 380) {
                        if(avX && avY && avD) {
                            a = avX - dx;
                            b = avY - dy;
                            travelDistance = Math.round(Math.sqrt( a*a + b*b ));
            
                            if(travelDistance < avD) {
                                dy++;
                                continue;
                            }
                        }

                        if(isTilePassable(dx,dy,true)) {
                            resourceItem = new MapResource(terrainDef,dx,dy);
                            freeRefNukeTurn = true;
                            updateBuildingCollisionPoints(resourceItem,150,true);
                            currentGame.mapResources.push(resourceItem);
                            shoreUpdateTurn = true;
                        }
                    }

                    dy++;
                }

                dx++;
            }

            callback();
        };
        img.src = templateData;
    }

    function createRiver(type,position,avX,avY,avD) {
        var terrainDef = getTerrainDefByName(type);

        var sX = randomIntFromInterval(0,1);
        var sY = randomIntFromInterval(20,currentGame.height - 21);

        if(position != null) {
            if(position == "bottom") {
                sY = randomIntFromInterval(currentGame.height - 15,currentGame.height);
            }

            if(position == "top") {
                sY = randomIntFromInterval(0,15);
            }
        }

        var endX = currentGame.width - 1;
        var direction = 1;
        var wantedDirection = 1;
        
        var i,j,resourceItem,transformChance,a,b,travelDistance;
        
        if(sX == 1) {
            sX = currentGame.width - 1;
            endX = 0;
            direction = 3;
            wantedDirection = 3;
        }
        
        var riverPoints = [];
        riverPoints.push({
            "x": sX,
            "y": sY
        });

        var endReached = false;
        
        while(!endReached && riverPoints.length < 500) {
            
            var directionChange = randomIntFromInterval(0,8);
            
            if(directionChange == 1) {
                direction = randomIntFromInterval(0,4);
                
                if(direction == 4) {
                    direction = wantedDirection;
                }
            }
            
            var newPosition = {
                "x": riverPoints[riverPoints.length - 1].x,
                "y": riverPoints[riverPoints.length - 1].y
            };
            
            if(direction == 0 && newPosition.y > 0) {
                newPosition.y--;
            }
            
            if(direction == 1 && newPosition.x < currentGame.width - 1) {
                newPosition.x++;
            }
            
            if(direction == 2 && newPosition.y < currentGame.height - 1) {
                newPosition.y++;
            }
            
            if(direction == 3 && newPosition.x > 0) {
                newPosition.x--;
            }
            
            riverPoints.push(newPosition);
            
            if(newPosition.x == endX) {
                endReached = true;
            }
        }

        for(i = 0; i < riverPoints.length; i++) {

            if(avX && avY && avD) {
                a = avX - riverPoints[i].x;
                b = avY - riverPoints[i].y;
                travelDistance = Math.round(Math.sqrt( a*a + b*b ));

                if(travelDistance < avD) {
                    continue;
                }
            }

            if(isTilePassable(riverPoints[i].x,riverPoints[i].y,true)) {
                resourceItem = new MapResource(terrainDef,riverPoints[i].x,riverPoints[i].y);
                freeRefNukeTurn = true;
                updateBuildingCollisionPoints(resourceItem,150,true);
                currentGame.mapResources.push(resourceItem);
                shoreUpdateTurn = true;
            }

        }

        for(i = 0; i < 30; i++) {
            for(j = 0; j < currentGame.mapResources.length; j++) {

                if(avX && avY && avD) {
                    a = avX - currentGame.mapResources[j].x;
                    b = avY - currentGame.mapResources[j].y;
                    travelDistance = Math.round(Math.sqrt( a*a + b*b ));
    
                    if(travelDistance < avD) {
                        continue;
                    }
                }

                if(currentGame.mapResources[j].def == type) {
                    var surrounding = getSurroundingSameTerrains(currentGame.mapResources[j]);

                    transformChance = randomIntFromInterval(1,15);

                    if(transformChance == 2 && surrounding.top == null) {
                        if(isTilePassable(currentGame.mapResources[j].x,currentGame.mapResources[j].y - 1,true)) {
                            resourceItem = new MapResource(terrainDef,currentGame.mapResources[j].x,currentGame.mapResources[j].y - 1);
                            freeRefNukeTurn = true;
                            updateBuildingCollisionPoints(resourceItem,150,true);
                            currentGame.mapResources.push(resourceItem);
                            shoreUpdateTurn = true;
                        }
                    }

                    if(transformChance == 3 && surrounding.down == null) {
                        if(isTilePassable(currentGame.mapResources[j].x,currentGame.mapResources[j].y + 1,true)) {
                            resourceItem = new MapResource(terrainDef,currentGame.mapResources[j].x,currentGame.mapResources[j].y + 1);
                            freeRefNukeTurn = true;
                            updateBuildingCollisionPoints(resourceItem,150,true);
                            currentGame.mapResources.push(resourceItem);
                            shoreUpdateTurn = true;
                        }
                    }

                    if(transformChance == 4 && surrounding.left == null) {
                        if(isTilePassable(currentGame.mapResources[j].x - 1,currentGame.mapResources[j].y,true)) {
                            resourceItem = new MapResource(terrainDef,currentGame.mapResources[j].x - 1,currentGame.mapResources[j].y);
                            freeRefNukeTurn = true;
                            updateBuildingCollisionPoints(resourceItem,150,true);
                            currentGame.mapResources.push(resourceItem);
                            shoreUpdateTurn = true;
                        }
                    }

                    if(transformChance == 5 && surrounding.right == null) {
                        if(isTilePassable(currentGame.mapResources[j].x + 1,currentGame.mapResources[j].y,true)) {
                            resourceItem = new MapResource(terrainDef,currentGame.mapResources[j].x + 1,currentGame.mapResources[j].y);
                            freeRefNukeTurn = true;
                            updateBuildingCollisionPoints(resourceItem,150,true);
                            currentGame.mapResources.push(resourceItem);
                            shoreUpdateTurn = true;
                        }
                    }
                }
            }
        }
    }

    function packBuilding(building) {
        var muhDef = getBuildingDefByName(building.def);

        if(muhDef.packsTo != null) {
            var packsToDef = getVehicleDefByName(muhDef.packsTo);

            building.isBeingRemoved = true;

            var freshVehicle = new Vehicle(packsToDef,building.x,building.y,getRegionOrCity().localPlayerId);
            currentGame.vehicles.push(freshVehicle); 


            updateUtilityGrid();

            selectedBuilding = null;
            selectedVehicle = [freshVehicle];
            showOptionsForObject(selectedVehicle,"vehicle",true);
        }
    }

    function deployBuilding(unit) {

        if(!unit) {
            return;
        }

        var vDef = getVehicleDefByName(unit.def);
        var building = getBuildingDefByName(vDef.deploysTo);

        if(!building) {
            return;
        }

        if(unit.lv.length > 0) {
            if(!deployLoadedUnits(unit)) {
                return;
            }
        }

        selectedVehicle = [];

        var spaceClear = true;

        if(!unit.pd) {
            unit.pd = building;
        }

        for(var oX = 0; oX < unit.pd.tileWidth; oX++) {
            for(var oY = 0; oY < unit.pd.tileHeight; oY++) {
                var useX = unit.x + oX;
                var useY = unit.y + oY;

                if(!isTilePassable(useX,useY,true,false)) {
                    spaceClear = false;
                }
            }
        }

        if(!spaceClear) {
            webAppCore.showToast("Cannot deploy here.");
            return;
        }

        var freshBuilding = new Building(building,unit.x,unit.y,getRegionOrCity().localPlayerId);
        currentGame.buildings.push(freshBuilding);
        updateBuildingCollisionPoints(freshBuilding,150);

        removeFromArray(currentGame.vehicles,unit);

        document.getElementById("objectOptions").style.display = "none";

        if (!freshBuilding.md) {
            setUpMinidefForBuilding(freshBuilding, false, false);
        }

        selectedBuilding = freshBuilding;


        updateUtilityGrid();

        if(!building.passable) {
            drawSidebar();
        }

        showOptionsForObject(freshBuilding,"building",true);
    }

    function destroyAtTile(bx,by,w,h,explode) {

        var i,j,x,y;

        for(x = bx; x < bx + w; x++) {

            for(y = by; y < by + h; y++) {

                // vehicles 
                for(i = 0; i < currentGame.vehicles.length; i++) {
                    if(currentGame.vehicles[i].x == x && currentGame.vehicles[i].y == y) {
                        destroyVehicle(currentGame.vehicles[i]);
                    }
                }



                // buildings 
                for(i = 0; i < currentGame.buildings.length; i++) {
                    if(currentGame.buildings[i].condition > 0 && currentGame.buildings[i].occupiesTiles) {
                        for(j = 0; j < currentGame.buildings[i].occupiesTiles.length; j++) {
                            if(currentGame.buildings[i].occupiesTiles[j].x == x && currentGame.buildings[i].occupiesTiles[j].y == y) {
                                currentGame.buildings[i].condition = -1;
                                break;
                            }
                        }
                    }
                }

                var killItem = null;

                // passables 
                for(var passdef in currentGame.finishedPassableNonUpdatables) {
                    var td = currentGame.finishedPassableNonUpdatables[passdef];

                    if(td[x]) {
                        var tx = td[x];

                        for(var ty = 0; ty < tx.length; ty++) {
                            if(parseInt(tx[ty]) == y) {
                                killItem = ty;
                                break;
                            }
                        }

                        if(killItem != null) {
                            tx.splice(ty,1);
                            if(explode && allowParticleEffects) {
                                Scroll2d.playParticleEffect("explosion",x,y);
                            }
                            staticFrame = false;
                            Scroll2d.forceSceneChange();
                        }
                    }

                }

                // resources 
                for(i = 0; i < currentGame.mapResources.length; i++) {
                    
                    if(currentGame.mapResources[i].occupiesTiles == null) {
                        continue;
                    }
                    
                    for(j = 0; j < currentGame.mapResources[i].occupiesTiles.length; j++) {
                        if(currentGame.mapResources[i].occupiesTiles[j].x == x && currentGame.mapResources[i].occupiesTiles[j].y == y) {
                            destroyResource(currentGame.mapResources[i],false,explode);
                            break;
                        }
                    }
                    
                }
            }
        }
    }

    function playDisaster(dName) {

        if(!currentGame) {
            return;
        }

        var i;

        var disaster = null;


        if(workingMapType == null) {
            return;
        }

        for(i = 0; i < workingMapType.explosionDisasters.length; i++) {
            if(workingMapType.explosionDisasters[i].name == dName) {
                disaster = workingMapType.explosionDisasters[i];
                break;
            }
        }


        if(disaster == null) {
            return;
        }

        currentGame.disasterCounters[dName] = randomIntFromInterval(0,disaster.frequency);

        var epicenterX = randomIntFromInterval(2,currentGame.width - 2);
        var epicenterY = randomIntFromInterval(2,currentGame.height - 2);

        var blastRadius = shuffleArray(getAllSpacesAroundTile(epicenterX,epicenterY,disaster.radius));

        var resourceItem;

        for(i = 0; i < disaster.elements.length; i++) {

            if(blastRadius.length == 0) {
                break;
            }

            var newterrain = getTerrainDefByName(disaster.elements[i].terrain);

            if(newterrain == null) {
                continue;
            }

            for(var j = 0; j < disaster.elements[i].abundance; j++) {

                if(blastRadius.length == 0) {
                    break;
                }

                var epicenter = blastRadius.pop();

                destroyAtTile(epicenter[0],epicenter[1],newterrain.tileWidth,newterrain.tileHeight,true);

                resourceItem = new MapResource(newterrain,epicenter[0],epicenter[1]);
                freeRefNukeTurn = true;
                updateBuildingCollisionPoints(resourceItem,150,true);
                currentGame.mapResources.push(resourceItem);
                shoreUpdateTurn = true;
            }
        }
    }

    function editCustomMapMetaData() {

        document.getElementById("customMapMetaDataEntry").style.display = "block";

        document.getElementById("customMapMetaNameInput").value = currentGame.mename;

        document.getElementById("customMapMetaAuthorInput").value = currentGame.meauthor;
        document.getElementById("customMapMetaDescriptionInput").value = currentGame.medescription;

    }

    function createLocalServer() {
        if(!tcpAvailable || offlineGameServerId != "-1") {
            return;
        }

        if(getRegionOrCity() == null) {
            return;
        }

        if(!getRegionOrCity().offlineMode) {
            return;
        }

        if(currentGame.isSubregion) {
            return;
        }

        if(ColonyGame.meta.localSocketPort == null || ColonyGame.meta.localSocketPort == 0) {
            return;
        }


        webAppCore.createTcpSocket(ColonyGame.meta.localSocketPort,onLocalServerCreated);
    }

    function onLocalServerCreated(id) {

        offlineGameServerId = id;
        webAppCore.setTcpSocketListener(offlineGameServerId,onLocalSocketMessage);
    }

    function joinLocalNetworks() {
        if(!tcpAvailable) {
            return;
        }

        if(currentGame == null) {
            return;
        }

        if(!getRegionOrCity().offlineMode) {
            return;
        }

        if(currentGame.isSubregion) {
            return;
        }

        if(ColonyGame.meta.localSocketPort == null || ColonyGame.meta.localSocketPort == 0) {
            return;
        }

        webAppCore.scanLocalTcpSockets(ColonyGame.meta.localSocketPort,onLocalGamesBack);
    }

    function onLocalGamesBack(games) {

        if(!games) {
            return;
        }

        var myip = webAppCore.getLocalIp();

        for(var i = 0; i < games.length; i++) {

            if(games[i] == myip) {
                continue;
            }

            webAppCore.connectTcpSocket(games[i],ColonyGame.meta.localSocketPort,onLocalGameConnected);
        }
    }

    function onLocalGameConnected(id) {

        if(!id) {
            return;
        }

        webAppCore.setTcpSocketListener(id,onLocalSocketMessage);

        setTimeout(function() {
            webAppCore.sendTcpSocketMessage(id,"joinreq");
        },200);
    }

    function LocalConnectionHolder(socketid,tag) {
        this.id = socketid;

        if(tag && tag != "0" && tag.trim().length > 0) {
            this.tag = tag;
        } else {
            this.tag = null;
        }

        this.colonyInfo = null;
    }

    function LocalColonyInfo() {
        this.name = null;
        this.founded = null;
        this.independent = null;
        this.population = 0;
        this.gdp = 0;
        this.unemployment = 0;
        this.maptype = null;
        this.race = null;
        this.isindependent = "0";
        this.sid = null;
        this.tag = null;
        this.rc = null;
    }

    function LocalSocketMessage(heading,data) {
        this.heading = heading;

        this.data = data;
        
    }

    function broadcastLocalTcpMessage(lsm) {
        if(!tcpAvailable) {
            return;
        }

        if(currentGame == null) {
            return;
        }

        if(!getRegionOrCity().offlineMode) {
            return;
        }

        if(!lsm) {
            return;
        }

        if(ColonyGame.meta.localSocketPort == null || ColonyGame.meta.localSocketPort == 0) {
            return;
        }

        for(var i = 0; i < connectedLocals.length; i++) {
            var lch = connectedLocals[i];
            sendLocalTcpMessageObject(lch.id,lch.tag,lsm);
        }
    }

    function sendLocalTcpMessageObject(id,tag,lsm) {

        if(!lsm) {
            return;
        }

        var lsmString = null;

        try {
            lsmString = JSON.stringify(lsm);
        } catch(ex) {
            webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": sendLocalTcpMessageObject",ex.message);
            lsmString = null;
        }
        

        if(!lsmString || lsmString.trim().length == 0) {
            return;
        }

        var lsmBase = btoa(stripEmoji(lsmString));

        webAppCore.sendTcpSocketMessage(id,lsmBase,tag);
    }

    function getLocalColonyInfo() {

        if(!currentGame) {
            return null;
        }

        var lci = new LocalColonyInfo();
        lci.name = currentGame.name;
        lci.founded = dateToReadable(currentGame.creationDate);
        lci.independent = dateToReadable(currentGame.independenceDay);
        lci.population = getTotalPopulation();
        lci.unemployment = currentGame.historicStats.unemployment[currentGame.historicStats.unemployment.length - 1];
        lci.gdp = currentGame.historicStats.gdp[currentGame.historicStats.gdp.length - 1];
        lci.maptype = currentGame.mapType;
        lci.race = currentGame.defaultRace;
        lci.rc = roamingClientId;

        if(webAppCore.isApeAppsLoggedIn()) {
            lci.aausername = webAppCore.getApeAppsProfile().un;
        }

        if(getRegionOrCity().flag) {
            var rawflag = JSON.stringify(getRegionOrCity().flag);
            var baseFlag = btoa(rawflag);
            lci.rawflagdat = baseFlag;
        }

        lci.lastplatform = getPlaysonCode();

        return lci;
    }

    function leaveLocalNetwork() {
        if(!tcpAvailable) {
            return;
        }

        if(currentGame == null) {
            return;
        }

        var roc = getRegionOrCity();

        if(!roc) {
            return;
        }

        if(!roc.offlineMode) {
            return;
        }

        if(ColonyGame.meta.localSocketPort == null || ColonyGame.meta.localSocketPort == 0) {
            return;
        }

        for(var i = 0; i < connectedLocals.length; i++) {
            var lch = connectedLocals[i];
            webAppCore.sendTcpSocketMessage(lch.id,"goodbye");
            webAppCore.closeTcpSocket(lch.id,placeholder);
        }
    }

    function sayGoodbyeToLocalSocket(id,tag) {

        var sktKillARry = [];

        for(var i = 0; i < connectedLocals.length; i++) {
            var lch = connectedLocals[i];

            if(lch.id != id) {
                continue;
            }

            if(tag && tag != "0" && tag.trim().length > 0) {
                if(lch.tag != tag) {
                    continue;
                }
            }

            var msg = lch.colonyInfo.name + " has gone offline";
            showLocalColonyNotification(msg,lch.colonyInfo,"#F44336");

            var tmpid = lch.id;

            lch.id = "-1";
            lch.tag = "-1";
            lch.colonyInfo = null;

            if(id == offlineGameServerId) {
                continue;
            }

            webAppCore.closeTcpSocket(tmpid,placeholder);

            sktKillARry.push(lch);
        }

        while(sktKillARry.length > 0) {
            var skt = sktKillARry.pop();
            removeFromArray(connectedLocals,skt);
        }

        
    }

    function onLocalSocketMessage(id,message,tag) {

        if(!message || message.trim().length == 0) {
            return;
        }

        message = message.trim();

        if(message == "joinreq") {
            webAppCore.sendTcpSocketMessage(id,"joinallow",tag);
            return;
        }

        if(message == "joinallow") {
            sendLocalTcpMessageObject(id,tag,new LocalSocketMessage("sendConnection",getLocalColonyInfo()));
            return;
        }

        if(message == "goodbye") {
            sayGoodbyeToLocalSocket(id,tag);
            return;
        }

        try {
            var gotData = atob(message);

            if(!gotData || gotData.trim().length == 0) {
                return;
            }

            

            var msgObject = JSON.parse(gotData);
            var colonyInfo = null;

            if(msgObject.heading == "sendConnection") {
                var lch = new LocalConnectionHolder(id,tag);
                lch.colonyInfo = msgObject.data;

                lch.colonyInfo.sid = id;
                lch.colonyInfo.tag = tag;

                // for devices with multiple network interfaces, do not let them join themselves
                if(lch.colonyInfo.rc && lch.colonyInfo.rc == roamingClientId) {
                    return;
                }

                connectedLocals.push(lch);

                if(id == offlineGameServerId) {
                    sendLocalTcpMessageObject(id,tag,new LocalSocketMessage("sendConnection",getLocalColonyInfo()));
                }

                var msg = lch.colonyInfo.name + " is online";
                showLocalColonyNotification(msg,lch.colonyInfo,"#4CAF50");

            }

            if(msgObject.heading == "starvation") {
                colonyInfo = getColonyInfoFromIdAndTag(id,tag);
                showLocalColonyNotification("Starvation in " + msgObject.data,colonyInfo,"#F44336");
            }

            if(msgObject.heading == "denounce") {
                colonyInfo = getColonyInfoFromIdAndTag(id,tag);
                showLocalColonyNotification(colonyInfo.name + " denounces " + msgObject.data + "!",colonyInfo,"#F44336");
            }

            if(msgObject.heading == "privateMessage") {
                colonyInfo = getColonyInfoFromIdAndTag(id,tag);
                
                getRegionOrCity().mail.push(new MailMessage(colonyInfo.name,{ "id": id, "tag": tag },msgObject.data,dateToReadable(Date.now()),"0",null,0));

                alertNewMailIfNecessary();
            }

            if(msgObject.heading == "resourcegift") {
                colonyInfo = getColonyInfoFromIdAndTag(id,tag);

                getRegionOrCity().gifts.push(new Gift("Gift from " + colonyInfo.name,"A gift of " + msgObject.data.resource + " from " + colonyInfo.name,msgObject.data.resource,parseInt(msgObject.data.amount)));

                if(getRegionOrCity().gifts.length > 0) {
                    webAppCore.showToast("New gifts available!");
                    document.getElementById("imGift").style.display = "inline-block";
                }
            }
        } catch(ex) {
            webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onLocalSocketMessage",ex.message);
        }
    }

    function getLocalColonyInfoFromName(name) {
        var ourRet = null;

        for(var i = 0; i < connectedLocals.length; i++) {
            var cl = connectedLocals[i];

            if(cl.colonyInfo == null) {
                continue;
            }

            if(cl.colonyInfo.name == name) {
                ourRet = cl;
                break;
            }
        }

        if(ourRet == null) {
            return null;
        }

        return ourRet.colonyInfo;
    }

    function getColonyInfoFromIdAndTag(id,tag) {

        var ourRet = null;

        for(var i = 0; i < connectedLocals.length; i++) {
            var cl = connectedLocals[i];

            if(cl.id != id) {
                continue;
            }

            if(cl.colonyInfo == null) {
                continue;
            }

            if(tag && tag != null && tag != "0" && tag.trim().length > 0) {
                if(tag != cl.tag) {
                    continue;
                }
            }

            ourRet = cl;
        }

        if(ourRet == null) {
            return null;
        }

        return ourRet.colonyInfo;
    }

    function showLocalColonyNotification(message,colonyInfo,color) {
        displayInGameNotification("images/" + ColonyGame.meta.localEventIcon,message,color,onLocalColonyNotificationHit,colonyInfo);
    }

    function onLocalColonyNotificationHit(info) {
        if(info.target.parentElement.tag && info.target.parentElement.tag != null) {
            var colonyInfo = info.target.parentElement.tag;
            launchLocalColonyInfoScreen(colonyInfo);
        }

        
    }

    function launchLocalColonyInfoScreen(colonyInfo) {

        colonyWindowOpen = true;

        var hasIcon = false;

        for(var i = 0; i < ColonyGame.mapTypes.length; i++) {
            if(ColonyGame.mapTypes[i].name == colonyInfo.maptype) {
                document.getElementById("colonyIcon").src = "images/" + ColonyGame.mapTypes[i].icon;

                hasIcon = true;
            }
        }

        if(!hasIcon) {
            document.getElementById("colonyIcon").src = "images/" + ColonyGame.meta.localEventIcon;
        }

        document.getElementById("colonyWindow").style.display = "block";

        document.getElementById("colonyCoinShower").style.display = "none";

        document.getElementById("colonyEstablishEmbassy").style.display = "none";
        document.getElementById("colonyContactAmbassador").style.display = "none";
        

        document.getElementById("colonyViewWebsite").style.display = "none";

        document.getElementById("colonySendMessage").onclick = function() {
            sendACustomMessage(colonyInfo.sid,colonyInfo.tag);
        };

        document.getElementById("colonyTribute").style.display = "none";



        document.getElementById("colonyNukeCharter").style.display = "none";

        if(getGiftCapacity() > 0) {
            document.getElementById("colonySendGift").style.display = "initial";
            document.getElementById("colonySendGift").onclick = function() {
                tmpNegoiationColony = colonyInfo;
                offlineResourceSendMenu();
            };
        } else {
            document.getElementById("colonySendGift").style.display = "none";
        }

        document.getElementById("colonyDenounce").style.display = "initial";
        document.getElementById("colonyDenounce").onclick = function() {

            broadcastLocalTcpMessage(new LocalSocketMessage("denounce",colonyInfo.name));

            webAppCore.showToast("We have denounced " + colonyInfo.name + " to the galaxy!");
        };

        document.getElementById("colonyInspect").style.display = "none";

        document.getElementById("colonyName").innerHTML = colonyInfo.name + " (" + colonyInfo.race + ")";

        document.getElementById("colonyScreenshot").style.display = "block";

        document.getElementById("colonyScreenshot").style.backgroundImage = null;
        document.getElementById("colonyScreenshot").style.backgroundColor = "#000000";

        if(colonyInfo.aausername) {
            document.getElementById("colonyInfoUserAreaHolder").style.display = "block";

            document.getElementById("colonyInfoUserAreaName").innerHTML = colonyInfo.aausername;
            var ownerAvatar = "https://accounts.ape-apps.com/getavatar.php?u=" + colonyInfo.aausername;
            document.getElementById("colonyInfoUserAreaAvatar").src = ownerAvatar;

            document.getElementById("colonyInfoUserAreaHolder").onclick = function(){
                showUserProfile(colonyInfo.aausername);
            };
        } else {
            document.getElementById("colonyInfoUserAreaHolder").style.display = "none";
        }

        var withFlag = false;
        var flagObj = null;

        if(colonyInfo.rawflagdat && colonyInfo.rawflagdat.trim().length > 6) {
            

            try {
                var flagDec = atob(colonyInfo.rawflagdat);
                flagObj = JSON.parse(flagDec);
            } catch(ex) {
                flagObj = null;
            }

            if(flagObj) {
                withFlag = true;
            }
        }
        
        if(flagObj && withFlag) {
            document.getElementById("colonyInfoFlagDisplay").style.display = "block";
            renderFlagIntoCanvas(flagObj,document.getElementById("colonyInfoFlagDisplay"),false);
        } else {
            document.getElementById("colonyInfoFlagDisplay").style.display = "none";
        }
        

        document.getElementById("concernsListing").innerHTML = "";
        document.getElementById("colonyConcernsHeader").style.display = "none";

        document.getElementById("colonyFounded").innerHTML = "Founded: " + colonyInfo.founded;

        if(colonyInfo.isindependent == "0") {
            document.getElementById("colonyIndependence").style.display = "none";
        } else {
            document.getElementById("colonyIndependence").style.display = "block";
            document.getElementById("colonyIndependence").innerHTML = "Independence Day: " + colonyInfo.independent;
        }

        document.getElementById("colonyLastActive").innerHTML = "";
        document.getElementById("colonyPopulation").innerHTML = "Population: " + numberWithCommas(colonyInfo.population);
        document.getElementById("colonyGDP").innerHTML = "GDP: " + getResourceByDefName(ColonyGame.meta.tenderResource).indicator + numberWithCommas(colonyInfo.gdp);
        document.getElementById("colonyUnemployment").innerHTML = "Unemployment Rate: " + colonyInfo.unemployment + "%";
        document.getElementById("colonyRelations").innerHTML = "";
        document.getElementById("colonyLocation").innerHTML = "";

        if(isRestrictivePlatform() || !colonyInfo.lastplatform || colonyInfo.lastplatform == "Unknown") {
            document.getElementById("colonyPlaysOnSection").style.display = "none";
        } else {

            document.getElementById("colonyPlaysOnSection").style.display = "block";

            var showPlatform = colonyInfo.lastplatform;
            var showColor = "#000000";

            if(colonyInfo.lastplatform == "android" || colonyInfo.lastplatform == "android.gplay" || colonyInfo.lastplatform == "android.apemarket" || colonyInfo.lastplatform == "android.opera") {
                showPlatform = "Android";
                showColor = "#3DDB86";
            }

            if(colonyInfo.lastplatform == "android.amazon") {
                showPlatform = "Kindle Fire";
                showColor = "#FFB300";
            }

            if(colonyInfo.lastplatform == "ios" || colonyInfo.lastplatform == "ios.appstore") {
                showPlatform = "iOS";
                showColor = "#424242";
            }

            if(colonyInfo.lastplatform == "windows" || colonyInfo.lastplatform == "windows.windowsstore") {
                showPlatform = "Windows 10";
                showColor = "#1976D2";
            }

            if(colonyInfo.lastplatform == "web" || colonyInfo.lastplatform == "web.apewebapps") {
                showPlatform = "Ape Web Apps";
                showColor = "#FF9800";
            }

            if(colonyInfo.lastplatform == "web.facebook") {
                showPlatform = "Facebook";
                showColor = "#3B5998";
            }

            if(colonyInfo.lastplatform == "web.chrome") {
                showPlatform = "Chrome";
                showColor = "#F44336";
            }

            if(colonyInfo.lastplatform == "desktop" || colonyInfo.lastplatform == "desktop.apemarket") {
                showPlatform = "Desktop";
                showColor = "#8E24AA";
            }

            if(colonyInfo.lastplatform == "desktop.windows") {
                showPlatform = "Windows";
                showColor = "#2196F3";
            }

            if(colonyInfo.lastplatform == "desktop.mac") {
                showPlatform = "macOS";
                showColor = "#7E57C2";
            }

            if(colonyInfo.lastplatform == "desktop.linux") {
                showPlatform = "Linux";
                showColor = "#FDD835";
            }

            if(colonyInfo.lastplatform == "steam.linux") {
                showPlatform = "Steam (Linux)";
                showColor = "#333333";
            }

            if(colonyInfo.lastplatform == "steam.mac") {
                showPlatform = "Steam (macOS)";
                showColor = "#333333";
            }

            if(colonyInfo.lastplatform == "steam.windows") {
                showPlatform = "Steam (Windows)";
                showColor = "#333333";
            }

            document.getElementById("colonyPlaysOn").innerHTML = showPlatform;
            document.getElementById("colonyPlaysOn").style.color = showColor;
        }
    }

    function offlineResourceSendMenu() {
        var menuOptions = [];

        for(var i = 0; i < ColonyGame.resources.length; i++) {
            var res = ColonyGame.resources[i];

            if(!res.canGift) {
                continue;
            }

            var status = "You Have: " + numberWithCommas(getGameResources()[res.name].amount);

            menuOptions.push({
                "title": res.name,
                "title-color": null,
                "description": null,
                "status": status,
                "status-color": null,
                "icon": "images/" + getResourceByDefName(res.name).icon,
                "tag": res
            });
        }

        showList(getString("select-resource"),menuOptions,onSendResourceType,getString("general-nevermind"));
    }

    function showOfflineCommunicationsMenu() {
        if(!tcpAvailable) {
            return;
        }

        if(currentGame == null) {
            return;
        }

        if(!getRegionOrCity().offlineMode) {
            return;
        }

        if(ColonyGame.meta.localSocketPort == null || ColonyGame.meta.localSocketPort == 0) {
            return;
        }

        var menuOptions = [];

        for(var i = 0; i < connectedLocals.length; i++) {
            var lch = connectedLocals[i];
            var info = lch.colonyInfo;

            if(info == null) {
                continue;
            }

            var pDef = getPlanetDefByName(info.maptype);

            if(pDef == null) {
                continue;
            }

            menuOptions.push({
                "title": info.name,
                "title-color": null,
                "description": info.race,
                "status": null,
                "status-color": null,
                "icon": "images/" + pDef.icon,
                "overflow": null,
                "tag": info
            });
        }


        if(menuOptions.length == 0) {
            webAppCore.showAlertWithTitle("No nearby players found.  If your friends are playing on the same network as you, you can exchange resources and message here.","No Players");
            return;
        }


        showList(getString("general-send-custom-msg"),menuOptions,onLocalColonyPicked,getString("general-nevermind"));

    }

    function onLocalColonyPicked(tag) {
        if(!tag) {
            return;
        }

        launchLocalColonyInfoScreen(tag);
    }

    function onarbitraryDeport(amount) {

        if(amount == null || isNaN(amount) || amount.trim().length == 0) {
            webAppCore.showToast("Invalid amount");
            return;
        }

        var amt = parseInt(amount);

        if(amt == 0 || amt > getTotalPopulation()) {
            webAppCore.showToast("Invalid amount");
            return;
        }

        conductDeportation(amount,null,null);
    }

    function deportTheHomeless() {
        var totalHomeless = runningHomelessCount;

        if(totalHomeless < 0) {
            totalHomeless = 0;
        }

        if(totalHomeless > 0) {
            conductDeportation(totalHomeless,null,null);
        }
    }

    function deportElderly() {
        conductDeportation(null,DEF_RETIREMENT_AGE,99999999);
    }

    function deportThePoor() {
        conductDeportation(null,0,DEF_ADULT_AGE);
    }

    function conductDeportation(amount,minAge,maxAge) {

        if(amount) {
            amount = parseInt(amount);
        } else {
            amount = null;
        }
        

        var totalDeported = 0;
        var propsWithPops = [];
        var ageGroup;

        for(ageGroup in currentGame.populationDistribution) {

            if(minAge && parseInt(ageGroup) < minAge) {
                continue;
            }

            if(maxAge && parseInt(ageGroup) > maxAge) {
                continue;
            }

            if(currentGame.populationDistribution[ageGroup] && currentGame.populationDistribution[ageGroup] > 0) {
                propsWithPops.push(ageGroup);

                
            }
        }

        if(amount) {
            propsWithPops = shuffle(propsWithPops);

            for(var i = 0; i < propsWithPops.length; i++) {
                ageGroup = propsWithPops[i];

                if(currentGame.populationDistribution[ageGroup] && currentGame.populationDistribution[ageGroup] > 0) {
                    if(currentGame.populationDistribution[ageGroup] >= amount) {
                        currentGame.populationDistribution[ageGroup] -= amount;
                        totalDeported = amount;
                        amount = 0;
                        break;
                    } else {
                        amount -= currentGame.populationDistribution[ageGroup];
                        totalDeported += currentGame.populationDistribution[ageGroup];
                        currentGame.populationDistribution[ageGroup] = 0;
                    }
                }
            }
        } else {
            while(propsWithPops > 0) {
                ageGroup = propsWithPops.pop();

                if(currentGame.populationDistribution[ageGroup] && currentGame.populationDistribution[ageGroup] > 0) {
                    totalDeported += parseInt(currentGame.populationDistribution[ageGroup]);
                    currentGame.populationDistribution[ageGroup] = 0;
                }
            }
        }

        
        webAppCore.showToast({
            message: numberWithCommas(totalDeported) + " Deported",
            image:   "images/" + ColonyGame.meta.indDeport
        });

        //updateHistoricStatistics();
    }

    function abbreviate(number, maxPlaces, forcePlaces, forceLetter) {
        number = Number(number);
        forceLetter = forceLetter || false;

        if(forceLetter !== false) {
            return annotate(number, maxPlaces, forcePlaces, forceLetter);
        }

        var abbr;

        if(number >= 1e12) {
            abbr = "T";
        }
        else if(number >= 1e9) {
            abbr = "B";
        }
        else if(number >= 1e6) {
            abbr = "M";
        }
        else if(number >= 1e3) {
            abbr = "K";
        }
        else {
            abbr = "";
        }

        return annotate(number, maxPlaces, forcePlaces, abbr);
    }

    function annotate(number, maxPlaces, forcePlaces, abbr) {
        // set places to false to not round
        var rounded = 0;

        switch(abbr) {
        case "T":
            rounded = number / 1e12;
            break;
        case "B":
            rounded = number / 1e9;
            break;
        case "M":
            rounded = number / 1e6;
            break;
        case "K":
            rounded = number / 1e3;
            break;
        case "":
            rounded = number;
            break;
        }

        if(maxPlaces !== false) {
            var test = new RegExp("\\.\\d{" + (maxPlaces + 1) + ",}$");

            if(test.test(("" + rounded))) {
                rounded = rounded.toFixed(maxPlaces);
            }
        }

        if(forcePlaces !== false) {
            rounded = Number(rounded).toFixed(forcePlaces);
        }

        return rounded + abbr;
    }

    function toggleShortNumbers() {
        shortNumbers = !shortNumbers;

        if(shortNumbers) {
            webAppCore.storeVar("use-short-nums","1");
        } else {
            webAppCore.storeVar("use-short-nums","0");
        }
    }

    function toggleResourceCapacity() {
        showCapacity = !showCapacity;

        if(showCapacity) {
            webAppCore.storeVar("show-res-capacity","1");
        } else {
            webAppCore.storeVar("show-res-capacity","0");
        }
    }

    function getAccountHolderTokens() {
        userTokenData = [];

        if(webAppCore.isApeAppsLoggedIn()) {
            var tokenSize = Math.ceil(ColonyGame.meta.gridSize * tokenScale);
            webAppCore.getTokens(webAppCore.getApeAppsProfile().un,tokenSize,"39,51,47,43",onUserTokensBack);
        }
    }

    function onUserTokensBack(result) {

        if(!result) {
            return;
        }

        for(var i = 0; i < result.length; i++) {
            userTokenData.push({
                "name": result[i].name,
                "url": result[i].url,
                "id": result[i].id,
                "isMine": true
            });
        }
    }

    function dismissBuildConfirm() {
        document.getElementById("gamepadBuildConfirm").style.display = "none";
        document.getElementById("touchBuildConfirm").style.display = "none";
        document.getElementById("desktopBuildConfirm").style.display = "none";
        selectedBuilding = null;
        selectedVehicle = [];
        queuedBuildings = null;
        queuedBuilding = null;
        selectedColonist = null;
        queuedMove = null;
        pendingBuildX = null;
        pendingBuildY = null;
        queuedPark = null;
        touchPossibleBuildPoints = [];
        flipChainedStructures = false;

        clearOutBuildMenu();
    }

    function askSwitchToOnlineMode() {
        webAppCore.showDialog({
            "title": getString("online-mode"),
            "message": getString("online-switch-warning"),
            "op1": {
                "text": getString("general-yes"),
                "func": doOnlineSwitch,
                "color": "#F44336"
            },
            "op2": {
                "text": getString("general-no"),
                "func": placeholder,
                "color": "#2196F3"
            }
        });
    }

    function doOnlineSwitch() {

        for(var prop in getGameResources()) {

            if(prop == "statResSaveTimestamp") {
                continue;
            }

            var rDef = getResourceByDefName(prop);

            if(rDef) {
                if(rDef.toxicRate == null || rDef.toxicRate == 0) {
                    modifyResourceAmount(prop,0,true,"Mode Change");
                }
            }
        }

        getRegionOrCity().offlineMode = false;

        connectToSocketsIfNecessary();
        registerColonyId();

        webAppCore.showToast({
            message: "Online Mode Activated",
            image:   "images/" + ColonyGame.meta.onlineModeInd
        });

        updateOnlineOfflineStatButtions();
    }

    function checkPathsSync(unit,type,paths) {
        while(paths.length > 0) {

            var dest = paths.shift();

            if(isNaN(dest.x) || isNaN(dest.y)) {
                continue;
            }

            var use = checkPathSync(unit,type,dest.x,dest.y);

            if(use && use.length > 0) {
                return use;
            }
        }

        return [];
    }

    function checkPathSync(unit,type,x2,y2) {

        if(isNaN(x2) || isNaN(y2)) {
            return [];
        }


        if(checkForPathSimulation(unit,type,x2,y2)) {
            return [];
        }

        if(syncColMap == null) {
            updateCollisionMap();
        }

        var x1 = unit.x;
        var y1 = unit.y;
        
        if(isNaN(x1) || isNaN(y1)) {
            return [];
        }

        var retainerName = x1.toString();
        retainerName += y1.toString();
        retainerName += x2.toString();
        retainerName += y2.toString();

        var retainedPath = getRetainedPath(x1,y1,x2,y2);

        if(retainedPath != null && retainedPath.length > 0) {
            return retainedPath;
        }

        var useMap = syncColMap;
        var isFlying = false;

        if(type == "vehicle") {
            var unitDef = getVehicleDefByName(unit.def);

            if(unitDef.isFlying) {
                useMap = new Graph(flyingCollisionReference);
                isFlying = true;
            }
        }

        if(!useMap || !useMap.grid || !useMap.grid[x2] || !useMap.grid[x2][y2]) {
            return [];
        }

        if(!useMap || !useMap.grid || !useMap.grid[x1]) {
            return [];
        }

        if(!useMap.grid[x2]) {
            return [];
        }

        if(!isTilePassable(x2,y2,false,isFlying,false,null)) {
            var alternateAreas = getFreeSpaceAroundTile(x2,y2,1,null);

            if(alternateAreas.length > 0) {
                var useThis = alternateAreas[randomIntFromInterval(0,alternateAreas.length - 1)];

                x2 = useThis[0];
                y2 = useThis[1];
            }
        }

        var start = useMap.grid[x1][y1];
        var end = useMap.grid[x2][y2];

        if(!start || !end) {
            return [];
        }

        var data = astar.search(useMap,start,end);
        var clean = [];

        while(data.length > 0) {
            clean.push(getCleanNode(data.pop()));
        }
    
        data = null;

        if(clean.length > 0 && type == "vehicle" && !isFlying) {
            retainedPaths[retainerName] = clonePathArray(clean);
            retainedUsage[retainerName] = 0;
        }

        return clean;
    }

    var syncNodeRecycling = [];

    function getCleanNode(old) {
        var fresh;

        if(syncNodeRecycling.length > 0) {
            try {
                fresh = syncNodeRecycling.pop();
                fresh.x = old.x;
                fresh.y = old.y;
                old = null;
                return fresh;
            } catch(ex) {
                fresh = new CleanNode(old);
            }
            
        } else {
            fresh = new CleanNode(old);
        }

        return fresh;
    }

    function CleanNode(old) {
        this.x = old.x;
        this.y = old.y;
        old = null;
    }

    function onFullMapBeforeCloseBack(data) {
        if(!data) {
            closeBackToRegionFinal();
            return;
        }

        if(currentSubcityRef) {
            var mapCanvas = document.createElement("canvas");
            var mapContext = mapCanvas.getContext("2d");
    
            var size = ColonyGame.meta.gridSize;
    
            if(currentGame.width == 100) {
                size = ColonyGame.meta.gridSize * 2;
            }   
    
            mapCanvas.width = size;
            mapCanvas.height = Math.ceil(size / 2);
    
            mapContext.drawImage(data,0,0,mapCanvas.width,mapCanvas.height);
            var rawData = mapCanvas.toDataURL();
    
            currentSubcityRef.previewImage = rawData;

            if(currentGame.mpRegionPlanetCharter) {
                var sendData = rawData.replace("data:image/png;base64,","");

                var sdata = [];

                sdata.push({
                    "key":      "img",
                    "value":    sendData
                });


                postSecuredCallToApi(sdata,67,closeBackToRegionFinal);
            } else {
                closeBackToRegionFinal();
            }
        }
        

        
    }

    function closeBackToRegionFinal() {

        if(!currentRegion) {
            showTitle();
            return;
        }

        if(currentRegion.isMpRegionHolder) {
            if(usingSockets) {
                webAppCore.socketEmit("closeconnection","");
            }
        }

        renderFullAtNextDraw = false;
        Scroll2d.deInit();

        runningBuildingCounts = {};
        syncColMap = null;
        syncNodeRecycling = [];

        getAccountHolderTokens();

        gooseUpPathWorker();
        clearDefaultColoredAssets();

        webAppCore.closeChat();

        lastColorFilter = null;
        pendingAutosales = [];
        currentGame = null;
        openJobsArray = [];
        currentJobOpprotunities = [];
        currentTemplate = null;
        templateVisible = false;
        currentGame = currentRegion;
        currentSubcityRef = null;
        currentRegion = null;
        overallShoreMap = null;
        opprotunityRecycleBox = [];
        curRegPreviewWorkQueue = [];
        curRegPreviewWorkItem = null;
        curRegRiverTemplateCanvas = null;
        curRegRiverTemplateContext = null;
        currentFileName = regionFileName;
        regionFileName = null;
        tmpNewGameCustomMapData = null;
        selectedBuilding = null;
        selectedVehicle = [];
        selectedResource = null;
        selectedColonist = null;
        selectedPassable = null;

        pendingBuildX = null;
        pendingBuildY = null;
        queuedBuildings = undefined;
        queuedBuilding = null;
        queuedBuildingBlocked = false;
        vehiclePathOrders = {};
        colonistPathOrders = {};

        for(var pX in currentGame.regionSquareTemplateImages) {
            for(var pY in currentGame.regionSquareTemplateImages[pX]) {
                currentGame.regionSquareTemplateImages[pX][pY].loading = false;
            }
        }

        if(autoloadSubcityAfterSave) {
            openSubCity(autoloadSubcityAfterSave);
            autoloadSubcityAfterSave = null;
            return;
        }

        initScroll2d();

        sizeElements();

        setupResourceLedger();

        createSidebar();
        drawSidebar();

        setupMenuOptions();
        
        initSoundtrack();

        Scroll2d.forceSceneChange();

        setWeather();

        

        setMapType();

        Scroll2d.setMapDims(50,50);

        
        
        createCollisionReference();

        updateUtilityGrid();


        Scroll2d.forceSceneChange();

        Scroll2d.setZoomLevel(2 / renderScaleFactor);

        Scroll2d.centerOnCoord(25,25);

        setCenterMapIcon();

        webAppCore.clearSplash();

        

        window.focus();

        


        if(isStreamingLive) {
            turnStreamingTracksBackOn();
        }

        syncRegionMetroAreas();

        generalSaveGame();

        setTimeout(Scroll2d.forceSceneChange(),500);

        if(currentGame.hasLoadedChat) {
            loadChat(true);
        }

        setColonyThemeColor();

        if(currentGame.isMpRegionHolder) {
            refreshMpRegionData();
        }
    }

    function openSubCity(subcity) {

        if(currentGame.isMpRegionHolder && !webAppCore.isApeAppsLoggedIn()) {
            return;
        }

        if(currentGame.isMpRegionHolder && subcity.apeAppsUsername != webAppCore.getApeAppsProfile().un) {
            showMpSubcityInfoWindow(subcity);
            return;
        }

        if(theNeverLoadedTimeout) {
            clearTimeout(theNeverLoadedTimeout);
            theNeverLoadedTimeout = null;
        }

        if(isStreamingLive) {
            shutDownStreamsForSwitch(true);
        }
        
        Scroll2d.deInit();

        webAppCore.closeChat();

        offlineGameServerId = "-1";
        connectedLocals = [];
        resourceStatTickCounter = 0;

        readyToLoadSubcities = true;
        currentRegion = currentGame;
        regionFileName = currentFileName;
        currentSubcityRef = subcity;

        for(var pX in currentRegion.regionSquareTemplateImages) {
            for(var pY in currentRegion.regionSquareTemplateImages[pX]) {
                currentRegion.regionSquareTemplateImages[pX][pY].loading = false;
            }
        }

        if(!currentSubcityRef.resourceCapacities) {
            currentSubcityRef.resourceCapacities = {};
        }

        if(!currentSubcityRef.utilityCapacities) {
            currentSubcityRef.utilityCapacities = {};
        }

        if(!currentSubcityRef.hasCapitol) {
            currentSubcityRef.hasCapitol = false;
        }

        if(!currentSubcityRef.statsColor) {
            currentSubcityRef.statsColor = randomHexColor(255,120);
        }

        if(!currentSubcityRef.subcityGuid) {
            currentSubcityRef.subcityGuid = guid();
        }

        pendingAutosales = [];
        currentJobOpprotunities = [];
        opprotunityRecycleBox = [];
        currentGame = null;
        openJobsArray = [];
        lastColorFilter = null;
        curRegPreviewWorkItem = null;
        curRegRiverTemplateCanvas = null;
        curRegRiverTemplateContext = null;
        curRegPreviewWorkQueue = [];
        currentTemplate = null;
        templateVisible = false;
        openGame(subcity.filename);
    }

    var tmpPendDozeCity = null;

    function dozeSelectedCity(city) {

        bulldozerMode = false;

        if(!city) {
            tmpPendDozeCity = null;
            return;
        }

        tmpPendDozeCity = city;

        if(currentGame.isMpRegionHolder) {
            

            if(tmpPendDozeCity.apeAppsUsername != webAppCore.getApeAppsProfile().un) {
                webAppCore.showToast("This is not your city!");
                return;
            }

            
        }

        webAppCore.showDialog({
            "title":    getString("header-delete-colony"),
            "message":  getString("delete-game-confirm"),
            "op1": {
                "text":     getString("general-delete"),
                "func":     deletePendingRegionCity,
                "color":    "#F44336"
            },
            "op2": {
                "text":     getString("general-cancel"),
                "func":     placeholder
            }
        });

    }

    function deletePendingRegionCity() {

        if(!tmpPendDozeCity) {
            return;
        }

        var deletePlaceholder = onRegionCityDeleted;

        if(currentGame && currentGame.isMpRegionHolder) {
            

            if(tmpPendDozeCity.apeAppsUsername == webAppCore.getApeAppsProfile().un) {
                deletePlaceholder = onMultiplayerRegionCityDeleted;
            }

            
        }
        

        webAppCore.deleteFile(tmpPendDozeCity.filename,deletePlaceholder);
    }

    function onMultiplayerRegionCityDeleted() {
        var keys = webAppCore.getApeAppsLoginKeys();

        if(!keys) {
            return;
        }

        webAppCore.postForResult(ColonyGame.meta.colonyServerApi, [
            {
                "key":      "f",
                "value":    26
            },
            {
                "key":      "relcd",
                "value":    ColonyGame.meta.releaseCode
            },
            {
                "key":      "g",
                "value":    ColonyGame.meta.colonyServerGameId
            },
            {
                "key":      "i",
                "value":    tmpPendDozeCity.mpId
            },
            {
                "key":      "aun",
                "value":    getRegionOrCity().apeAppsUsername
            },
            {
                "key":      "sa",
                "value":    keys.a
            },
            {
                "key":      "sb",
                "value":    keys.b
            },
            {
                "key":      "sc",
                "value":    keys.c
            }
        ], function(){
            if(currentGame) {
                removeFromArray(currentGame.subRegions,tmpPendDozeCity);
            }
            
        });
    }

    function onRegionCityDeleted() {

        if(!currentGame) {
            return;
        }

        removeFromArray(currentGame.subRegions,tmpPendDozeCity);
        postToColoniae(
            {
                "event": "regiondeleted", 
                "name": tmpPendDozeCity.name, 
                "charter": currentGame.charter
            }
        );
    }

    function showFederationMenu() {
        var roc = getRegionOrCity();

        if(!roc.isIndependent || roc.offlineMode || roc.governmentLevel < 7) {
            webAppCore.showToast("You cannot access federations.");
            return;
        }

        if(roc.federationId == 0) {
            showMenuForNonFederationMember();
            return;
        }

        showColonistsMenu("federation");

    }

    function showMenuForNonFederationMember() {
        var roc = getRegionOrCity();

        if(!roc.isIndependent || roc.offlineMode || roc.governmentLevel < 7) {
            webAppCore.showToast("You cannot access federations.");
            return;
        }

        var menuOptions = [];

        var i;

        var foundationCost = [];

        var foundTag = "foundnew";

        for(i = 0; i < ColonyGame.meta.federationFoundationCost.length; i++) {

            var costItem = ColonyGame.meta.federationFoundationCost[i];
            var costRes = getResourceByDefName(costItem.resource);
            var costColor = null;

            if(getGameResources()[costItem.resource].amount < costItem.amount) {
                costColor = "#F44336";
                foundTag = "foundcantafford";
            }

            foundationCost.push({
                "pre":      "Cost",
                "post":     numberWithCommas(costItem.amount),
                "color":    costColor,
                "icon":     "images/" + costRes.icon
            });
        }

        menuOptions.push({
            "title": getString("gen-found-federation"),
            "title-color": null,
            "description": getString("fed-founding-msg"),
            "status": null,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.federationsIndicator,
            "tag": foundTag,
            "overflow": foundationCost
        });

        menuOptions.push({
            "title": getString("join-federation"),
            "title-color": null,
            "description": getString("join-federation-desc"),
            "status": null,
            "status-color": null,
            "icon": "images/" + ColonyGame.meta.joinFederationIndicator,
            "tag": "joinfed"
        });

        showList(getString("gen-federation"),menuOptions,onFederationMenuItemSelected,getString("general-nevermind"));
    }

    function onFederationMenuItemSelected(tag) {
        if(tag == "foundnew") {
            var dialogOptions = {
                "title":    getString("gen-found-federation"),
                "message":  getString("found-fed-pick-name"),
                func: onFoundFedNamePicked
            };
    
            webAppCore.inputBox(dialogOptions);
        }

        if(tag == "joinfed") {
            postSecuredCallToApi([],53,onFedToJoinListingBack);
        }
    }

    function onFedToJoinListingBack(listing) {
        if(!listing || listing.trim().length == 0) {
            webAppCore.showToast("No federations found!");
            return;
        }


        try {
            var fedListingData = JSON.parse(listing);


            var menuOptions = [];

            for(var i = 0; i < fedListingData.length; i++) {

                var fed = fedListingData[i];

                menuOptions.push({
                    "title": fed.name,
                    "status": "Charter: " + fed.charter,
                    "tag": fed
                });
            }

            webAppCore.presentNativeList(getString("join-federation"),menuOptions,onSelectFedToJoinBack,"Dismiss");
        } catch(ex) {
            webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onFedToJoinListingBack",ex.message);
        }
    }

    var pendingJoinFederation = null;

    function onSelectFedToJoinBack(federation) {

        if(!federation) {
            return;
        }

        pendingJoinFederation = federation;

        webAppCore.showDialog({
            title: federation.name,
            message: getString("join-fed-confirm"),
            "op1": {
                "text":     getString("general-yes"),
                "func":     petitionPendingFederation
            },
            "op2": {
                "text":     getString("general-no"),
                "func":     placeholder
            }
        });

    }

    function petitionPendingFederation() {
        if(!pendingJoinFederation) {
            return;
        }

        postSecuredCallToApi([{
            "key": "fedcharter",
            "value": pendingJoinFederation.charter
        }],54,onFedPetitionResult);
    }

    function onFedPetitionResult(result) {
        if(!result || result.trim().length == 0) {
            return;
        }

        try {
            var resultData = JSON.parse(result);

            webAppCore.showDialog({
                title: pendingJoinFederation.name,
                message: resultData.reason
            });

            pendingJoinFederation = null;

        } catch(ex) {
            console.log(ex);
            webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onFedPetitionResult",ex.message);
        }
    }

    function onFoundFedNamePicked(name) {
        if(!name || name.trim().length == 0) {
            webAppCore.showToast("Invalid Name!");
            return;
        }

        // double check that they can afford it
        var i;

        var canAfford = true;

        for(i = 0; i < ColonyGame.meta.federationFoundationCost.length; i++) {
            var costItem = ColonyGame.meta.federationFoundationCost[i];

            if(getGameResources()[costItem.resource].amount < costItem.amount) {

                canAfford = false;
                break;
            }
        }

        if(!canAfford) {
            webAppCore.showToast("You cannot afford to start a Federation!");
            return;
        }

        // now, make the API call
        var data = [];

        data.push({
            "key":      "fedname",
            "value":    name.trim()
        });


        postSecuredCallToApi(data,50,onFederationCreationCallback);
        
    }

    function onFederationCreationCallback(data) {

        if(!data || data.trim().length == 0) {
            webAppCore.showToast("Error creating Federation!");
            return;
        }

        try {
            var fedCreatedData = JSON.parse(data);

            if(fedCreatedData.success) {
                var rOrC = getRegionOrCity();

                if(!rOrC) {
                    return;
                }

                rOrC.federationId = fedCreatedData.fedid;
                rOrC.federationName = fedCreatedData.fedname;
                rOrC.federationCharter = fedCreatedData.fedcharter;
            } else {
                webAppCore.showAlertWithTitle(fedCreatedData.reason,getString("gen-found-federation"));
                return;
            }
        } catch(ex) {
            webAppCore.showToast("Error creating Federation!!");
            return;
        }

        postGlobalSocketNewsItem({
            "code": "newfederation",
            "fedname": fedCreatedData.fedname
        });

        webAppCore.showAlertWithTitle("Congratulations!  You are the founding member of " + getRegionOrCity().federationName + "!",getString("gen-found-federation"));

        // if it worked, take their money
        for(var i = 0; i < ColonyGame.meta.federationFoundationCost.length; i++) {
            var costItem = ColonyGame.meta.federationFoundationCost[i];
            modifyResourceAmount(costItem.resource,-costItem.amount,false,"Federation");
        }

        updateColonyStats(false,generalSaveGame);
    }

    function turnOnStreaming() {

        webAppCore.closeChat();

        postSecuredCallToApi([
            {
                "key":      "sdat",
                "value":    1
            }
        ],51,placeholder);

        isStreamingLive = true;
        streamingIndicator.src = "images/" + ColonyGame.meta.streamingOnIndicator;

        turnStreamingTracksBackOn();

        loadChat(true);
    }

    function getPlaysonCode() {

        var retPOC = null;

        var platformRef = webAppCore.getPlatform();

        if(platformRef.market == "steam") {
            retPOC = platformRef.market + "." + platformRef.os;
        } else {
            if(platformRef.platform == "desktop") {
                retPOC = platformRef.platform + "." + platformRef.os;
            } else {
                retPOC = platformRef.platform + "." + platformRef.market;
            }
        }

        return retPOC;
    }

    function postVitalsToStreaming() {

        var displayName = currentGame.name;

        if(currentGame.isSubregion) {
            displayName += " (Subcity of " + currentRegion.name + ")";
        }

        webAppCore.broadcastExtraStreamData({
            extra: "colonygamevitals",
            data: {
                "name": displayName,
                "gdp": numberWithCommas(getTotalGDP()),
                "pop": numberWithCommas(getTotalPopulation()),
                "approval": currentGame.historicStats.approval[currentGame.historicStats.approval.length - 1] + "%",
                "playson": getPlaysonCode()
            }
        });
    }

    function onLivestreamEvent(event) {

        if(event && event.code) {
            if(event.code == "currentwatchcount") {
                document.getElementById("streamWatchingCountHold").innerHTML = event.count;
            }

            if(event.code == "userhasjoined") {
                displayInGameNotification(event.avatar,event.username + " is watching the livestream","#2196F3",function(){
                    showUserProfile(event.username);
                },event.username,true);
            }
        }
    }

    function updateStreamIndicatorStatusIcons() {
        var streamAud = false;
        var streamVid = false;

        var audDef = webAppCore.getVar("stream-audio-def","1");

        if(audDef && audDef == "1") {
            streamAud = true;
        }

        var vidDef = webAppCore.getVar("stream-video-def","1");

        if(vidDef && vidDef == "1") {
            streamVid = true;
        }

        if(streamAud) {
            document.getElementById("imStreamToggleMic").src = "images/" + ColonyGame.meta.micOnIndicator;
        } else {
            document.getElementById("imStreamToggleMic").src = "images/" + ColonyGame.meta.micOffIndicator;
        }

        if(streamVid) {
            document.getElementById("imStreamToggleCamera").src = "images/" + ColonyGame.meta.webcamOnIndicator;
        } else {
            document.getElementById("imStreamToggleCamera").src = "images/" + ColonyGame.meta.webcamOffIndicator;
        }
    }
    
    function turnStreamingTracksBackOn() {


        document.getElementById("streamControlsBar").style.display = "block";

        webAppCore.startStreaming(Scroll2d.getDrawCanvas());
        webAppCore.setStreamEventListener(onLivestreamEvent);

        var streamAud = false;
        var streamVid = false;

        var audDef = webAppCore.getVar("stream-audio-def","1");

        if(audDef && audDef == "1") {
            streamAud = true;
        }

        var vidDef = webAppCore.getVar("stream-video-def","1");

        if(vidDef && vidDef == "1") {
            streamVid = true;
        }

        webAppCore.setStreamWebcam(streamVid);
        webAppCore.setStreamAudio(streamAud);

        updateStreamIndicatorStatusIcons();
    }
    
    function randomHexColor(maxLightness,minLightness) {
        if(!maxLightness) {
            maxLightness = 255;
        }

        if(!minLightness) {
            minLightness = 0;
        }

        var r = randomIntFromInterval(minLightness,maxLightness);
        var g = randomIntFromInterval(minLightness,maxLightness);
        var b = randomIntFromInterval(minLightness,maxLightness);

        return "#" + componentToHex(r) + componentToHex(g) + componentToHex(b);
    }

    function componentToHex(c) {
        var hex = c.toString(16);
        return hex.length == 1 ? "0" + hex : hex;
    }

    function doOfflineCopy(game) {

        if(!game) {
            game = currentGame;
        }

        game.name = "Copy of " + game.name;
        currentFileName = cleanFileName(game.name) + "." + ColonyGame.meta.fileExtension;

        game.offlineMode = true;
        game.apeAppsUsername = null;
        game.hasCheated = true;

        if(game.isSubregion && !game.mpRegionPlanetCharter) {
            game.resources = currentRegion.resources;

            game.mapType = currentRegion.mapType;
            game.defaultRace = currentRegion.defaultRace;
            game.civilization = currentRegion.civilization;
        }

        currentRegion = null;

        game.mpRegionPlanetCharter = null;
        game.tradeNotifications = false;
        game.parentRegionFile = null;
        game.isRegion = false;
        game.isSubregion = false;
        game.colonies = 0;
        game.colonyId = 0;
        game.apiKey = 0;

        turnOffStreaming();
        streamingIndicator.style.display = "none";

        if(usingSockets) {
            webAppCore.socketEmit("closeconnection","");
        }
        
    }

    function doLeaveFederationConfirm() {
        webAppCore.showDialog({
            title: getString("gen-leave-fed"),
            message: getString("leave-fed-confirm"),
            op1: {
                text: getString("general-yes"),
                func: doLeaveFedEngage
            },
            op2: {
                text: getString("general-no"),
                func: placeholder
            }
        });
    }

    function doLeaveFedEngage() {
        postSecuredCallToApi([],60,onFederationLeft);
    }

    function onFederationLeft() {
        var game = getRegionOrCity();

        game.federationId = 0;
        game.federationName = null;
        game.federationCharter = null;

        closeStatsMenu();
        webAppCore.showToast("Federation Left");
    }

    function loadChat(doSilent,specificChannel) {

        if(webAppCore.getPlatform().market == "kongregate") {
            return;
        }

        if(!doSilent) {
            doSilent = false;
        }

        var roc = getRegionOrCity();

        if(!roc) {
            return;
        }

        var chatNametag = roc.name;

        if(roc.offlineMode) {
            chatNametag = "$offlinecolony$";
        }

        if(specificChannel) {
            currentChatChannel = specificChannel;
            webAppCore.loadChat(specificChannel,chatNametag,doSilent);
            return;
        }

        var possibleChannels = [];

        if(ColonyGame.meta.globalChatChannel) {
            possibleChannels.push({
                name: "Global " + ColonyGame.meta.name + " Chat",
                channel: ColonyGame.meta.globalChatChannel
            });
        }

        if(!roc.offlineMode && roc.isIndependent) {
            possibleChannels.push({
                name: "Commonwealth of " + roc.name,
                channel: ColonyGame.meta.onlineChatPrefix + roc.charter
            });
        } else {
            if(!roc.offlineMode && roc.motherlandid > 20 && roc.motherlandCharter != null) {
                possibleChannels.push({
                    name: "Commonwealth of " + roc.motherland,
                    channel: ColonyGame.meta.onlineChatPrefix + roc.motherlandCharter
                });
            }
        }

        if(isStreamingLive) {
            possibleChannels.push({
                name: "Livestream Chat",
                channel: ColonyGame.meta.streamingChatPrefix + roc.colonyId
            });
        }

        if(!roc.offlineMode && usingSockets && currentGame.isSubregion && currentRegion && currentRegion.isMpRegionHolder && currentSubcityRef) {
            possibleChannels.push({
                name: currentRegion.name + " Regional Chat",
                channel: ColonyGame.meta.onlineChatPrefix + "mpregion-" + currentRegion.charter
            });

            var metroAreaId = currentSubcityRef.metroAreaDistrict;
            var metroAreaName = currentRegion.metroAreaNameRef[metroAreaId];

            possibleChannels.push({
                name: metroAreaName.name + " Metro Area",
                channel: ColonyGame.meta.onlineChatPrefix + "mpregion-metro-" + metroAreaId
            });
        }

        roc.hasLoadedChat = true;

        if(possibleChannels.length == 0) {
            return;
        }

        if(possibleChannels.length == 1 || doSilent) {
            currentChatChannel = possibleChannels[0].channel;
            webAppCore.loadChat(possibleChannels[0].channel,chatNametag,doSilent);
            return;
        }

        var channelOptions = [];

        for(var i = 0; i < possibleChannels.length; i++) {
            channelOptions.push({
                title: possibleChannels[i].name,
                status: "#" + possibleChannels[i].channel,
                tag: possibleChannels[i].channel
            });
        }

        webAppCore.presentNativeList("Select Channel",channelOptions,function(tag) {

            if(!tag) {
                return;
            }

            currentChatChannel = tag;

            webAppCore.loadChat(tag,chatNametag,false);

        },"Dismiss");

    }

    function displayInGameNotification(icon,text,color,callback,tag,circleIcon) {

        if(!useOnlineNotifications) {
            return;
        }

        if(!circleIcon) {
            circleIcon = false;
        }

        var noTimeout = false;

        var useHolder = notificationArea;

        if(desktopMode) {
            noTimeout = true;
            useHolder = desktopNotificationAreaReadout;
            document.getElementById("imClearNotifications").style.display = null;
        }

        var notification = createNotification(icon,text,color,callback,tag,noTimeout,circleIcon);

        if(!notification) {
            return;
        }


        useHolder.appendChild(notification);
    }

    function onChatMessage(data) {

        if(!data) {
            return;
        }

        if(webAppCore.isChatOpen() && !desktopMode) {
            return;
        }


        var icon = "https://accounts.ape-apps.com/getavatar.php?u=" + data.username;

        var msg = data.username;

        var chatColor = "#4CAF50";

        

        if(data.nametag) {

            msg = data.username + " (" + data.nametag + ")";

            if(data.nametag == "$offlinecolony$") {
                msg = data.username + " (Offline Game)";
                chatColor = "#009688";
            }

            
        }


        if(data.userLevel) {
            if(data.userLevel == "D") {
                chatColor = "#FFC107";
            }

            if(data.userLevel == "M") {
                chatColor = "#2196F3";
            }
        }

        msg = msg + ": " + data.message;

        displayInGameNotification(icon,msg,chatColor,function(){

            if(getRegionOrCity().offlineMode) {
                if(webAppCore.isChatOpen()) {
                    webAppCore.closeChat();
                } else {
                    loadChat(false,data.channel);
                }
            } else {
                showUserProfile(data.username);
            }

        },null,true);
    }

    function postToColoniae(data) {
        if (currentGame.offlineMode) { 
            return;
        }

        var xhttp = new XMLHttpRequest();
        xhttp.open("POST", "https://coloniae.space/adu/adupost", true);
        xhttp.setRequestHeader("Content-type", "application/json");
        xhttp.onerror = function() {
            console.log(data);
            console.log("adu post error!");
        };
        xhttp.send(JSON.stringify(data));
    }

    function gatherForColoniae() {

        var roc = getRegionOrCity();

        if(!roc || !ColonyGame.meta.supportsColoniae || !currentGame || roc.offlineMode || !roc.allowColoniae) {
            return;
        }

        var data_to_send = {};
        var charter = null;

        if(currentGame.isSubregion){
            charter = currentRegion.charter;
        } else{
            charter = currentGame.charter;
        }

        var i;

        var techs = roc.unlockedTechs;
        data_to_send.techs = [];

        for (var tech in techs) {
            if (techs[tech]===true) {
                data_to_send.techs.push(tech);
            }
        }

        data_to_send.resources = {};
        data_to_send.resources.amounts = {};
        data_to_send.resources.storage = {};

        var resources = getGameResources();

        for(var res in resources) {
            data_to_send.resources.amounts[res] = resources[res].amount;
            data_to_send.resources.storage[res] = resources[res].storageCapacity;
        }

        data_to_send.stats = {};
        for (var st in currentGame.historicStats) {
            if (currentGame.historicStats[st].length > 0) {
                data_to_send.stats[st] = currentGame.historicStats[st][currentGame.historicStats[st].length -1];
            }
        }

        var subregionsfiles = [];
        for (i = 0; currentGame.subRegions.length > i;i++) {
            subregionsfiles.push(currentGame.subRegions[i].filename);
        }

        data_to_send.timereference = {
            "period":   currentGame.period, 
            "year":     currentGame.year
        };

        data_to_send.colonyidentifier = {
            "subregion":    currentGame.isSubregion,
            "charter":      charter,
            "account":      currentGame.apeAppsUsername,
            "name":         currentGame.name
        };

        data_to_send.misc = {
            "governmentLevel":  currentGame.governmentLevel,
            "width":            currentGame.width,
            "height":           currentGame.height,
            "privateCharter":   currentGame.privateCharter,
            "salaries":         currentGame.salaries,
            "workerPolicy":     currentGame.workerPolicy,
            "bandwidthusage":   0,
            "bandwidthtotal":   0,
            "powerusage":       0,
            "powertotal":       0
        };

        // This was split out because of the way the game engine is
        // built, there is no guarentee that there will always be a
        // utility in the game file called Power

        if(currentGame.isSubregion) {
            if(currentRegion) {
                if(currentRegion.utilities.Power) {
                    data_to_send.misc.powerusage = currentRegion.utilities.Power.usage;
                    data_to_send.misc.powertotal = currentRegion.utilities.Power.capacity;
                }
        
                if(currentRegion.utilities.Bandwidth) {
                    data_to_send.misc.bandwidthusage = currentRegion.utilities.Bandwidth.usage;
                    data_to_send.misc.bandwidthtotal = currentRegion.utilities.Bandwidth.capacity;
                }
            }
        } else {
            if(currentGame.utilities.Power) {
                data_to_send.misc.powerusage = currentGame.utilities.Power.usage;
                data_to_send.misc.powertotal = currentGame.utilities.Power.capacity;
            }
    
            if(currentGame.utilities.Bandwidth) {
                data_to_send.misc.bandwidthusage = currentGame.utilities.Bandwidth.usage;
                data_to_send.misc.bandwidthtotal = currentGame.utilities.Bandwidth.capacity;
            }
        }




        

        var vehicles = currentGame.vehicles;
        data_to_send.vehicles = {};

        for (i = 0; i < vehicles.length; i++) {
            if (data_to_send.vehicles.hasOwnProperty(vehicles[i].def)) {
                data_to_send.vehicles[vehicles[i].def] += 1;
            } else {
                data_to_send.vehicles[vehicles[i].def] = 1;
            }
        }

        var buildings = currentGame.buildings;
        data_to_send.buildings = {};

        for (i = 0; i < buildings.length; i++) {

            var bld = buildings[i];

            if(!bld) {
                continue;
            }

            if (data_to_send.buildings.hasOwnProperty(bld.def)) {
                data_to_send.buildings[bld.def] += 1;
            } else {
                data_to_send.buildings[bld.def] = 1;
            }
        }

        postToColoniae({"event":"adupost", "data":data_to_send});
    }

    function checkAutosells() {
        if(getRegionOrCity().offlineMode || getRegionOrCity().governmentLevel < 2) {
            return;
        }

        var gameRes = getGameResources();

        if(!gameRes) {
            return;
        }

        var depotCapacity = 0;
        var lowestCapacity = 9999999999999;
        var maxTradeSize = serverMaxTradeSize;
        
        if(maxTradeSize > getGiftCapacity()) {
            maxTradeSize = getGiftCapacity();
        }

        // check for trading depot 
        for(var i = 0; i < currentGame.buildings.length; i++) {
            var bld = currentGame.buildings[i];

            if(!bld) {
                continue;
            }

            var def = getBuildingDefByName(bld.def);

            if(!def) {
                continue;
            }

            if(def.onlineTradeDepot && def.tradeCapacity > depotCapacity) {
                depotCapacity = def.tradeCapacity;
            }

            if(def.tradeCapacity && def.tradeCapacity > 0 && def.tradeCapacity < lowestCapacity) {
                lowestCapacity = def.tradeCapacity;
            }
        }

        if(depotCapacity == 0) {
            return;
        }

        if(isNaN(depotCapacity) || isNaN(maxTradeSize)) {
            return;
        }

        for(var res in gameRes) {
            var resItem = gameRes[res];

            if(!resItem.autosell) {
                continue;
            }

            if(resItem.capacity == -1 && resItem.storageCapacity == 0) {
                continue;
            }
            

            var fullLevel = resItem.amount / resItem.storageCapacity;

            if(fullLevel > 0.99) {
                if(resItem.amount < depotCapacity) {
                    continue;
                }

                pendingAutosales.push({
                    resource: res,
                    amount: depotCapacity,
                    type: "sell"
                });

                var tenPer = Math.round(resItem.storageCapacity * 0.1);

                if(lowestCapacity < depotCapacity && lowestCapacity < tenPer) {
                    pendingAutosales.push({
                        resource: res,
                        amount: lowestCapacity,
                        type: "sell"
                    });
                }

                if(tenPer > depotCapacity) {
                    if(tenPer > maxTradeSize) {
                        tenPer = maxTradeSize;
                    }

                    pendingAutosales.push({
                        resource: res,
                        amount: tenPer,
                        type: "sell"
                    });
                }  
            }

            if(fullLevel < 0.25) {
                pendingAutosales.push({
                    resource: res,
                    amount: -1,
                    type: "buy"
                });
            }
        }
    }

    function processAutosells() {
        if(getRegionOrCity().offlineMode || getRegionOrCity().governmentLevel < 2) {
            return;
        }

        if(pendingAutosales.length == 0) {
            return;
        }

        var gameRes = getGameResources();

        if(!gameRes) {
            return;
        }

        var nextSell = pendingAutosales.shift();

        var resItem = gameRes[nextSell.resource];

        if(!resItem) {
            return;
        }


        var maxTradeSize = serverMaxTradeSize;
        
        if(maxTradeSize > getGiftCapacity()) {
            maxTradeSize = getGiftCapacity();
        }

        var data = [];
        var i,acceptableOffer,thisCon,availableStorage;

        data.push({
            "key":      "r",
            "value":    resItem.serverId
        });

        postSecuredCallToApi(data,58,function(result){
            if(result != null && result.trim().length > 0) {

                var currentContracts = null;

                try {
                    currentContracts = JSON.parse(result);
                } catch(ex) {
                    webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": processAutosells",ex.message);
                    return;
                }

                if(!currentContracts) {
                    return;
                }

                var unitPrice = resItem.price / 100;

                if(nextSell.type == "sell") {
                    

                    var lowPrice = unitPrice * 0.8;
                    acceptableOffer = null;

                    for(i = 0; i < currentContracts.contracts.length; i ++) {
                        thisCon = currentContracts.contracts[i];

                        if(thisCon.sellerid == getRegionOrCity().colonyId) {
                            continue;
                        }

                        if(thisCon.isoffer == "1") {
                            if(parseFloat(thisCon.perunit) > lowPrice && parseInt(thisCon.quantity) <= nextSell.amount) {
                                if(acceptableOffer) {
                                    if(parseFloat(acceptableOffer.perunit) > parseFloat(thisCon.perunit)) {
                                        acceptableOffer = thisCon;
                                    }
                                } else {
                                    acceptableOffer = thisCon;
                                }
                            }
                        }
                    }

                    if(acceptableOffer) {

                        purchaseNewGBTContract({
                            "fromTicker": false,
                            "silentTrade": true,
                            "resourceName": nextSell.resource,
                            "contractRef": acceptableOffer
                        });
                    } else {
                        var totalPrice = Math.ceil(unitPrice * nextSell.amount);
                        postTradeToGBT(nextSell.resource,resItem.serverId,nextSell.amount,totalPrice,0,true,function() {
                            //console.log("AUTO TRADE POSTED!");
                        });
                    }
                }

                if(nextSell.type == "buy" && resItem.capacity == -1) {
                    availableStorage = resItem.storageCapacity - resItem.amount;

                    if(availableStorage > maxTradeSize) {
                        availableStorage = maxTradeSize;
                    }

                    var maxPrice = unitPrice * 1.2;
                    acceptableOffer = null;

                    for(i = 0; i < currentContracts.contracts.length; i ++) {
                        thisCon = currentContracts.contracts[i];

                        if(thisCon.sellerid == getRegionOrCity().colonyId) {
                            continue;
                        }

                        if(parseInt(thisCon.price) > gameRes[ColonyGame.meta.tenderResource].amount * 0.1) {
                            continue;
                        }

                        if(thisCon.isoffer == "0") {
                            if(parseFloat(thisCon.perunit) <= maxPrice && parseInt(thisCon.quantity) <= availableStorage) {
                                if(acceptableOffer) {
                                    if(parseFloat(acceptableOffer.perunit) < parseFloat(thisCon.perunit)) {
                                        acceptableOffer = thisCon;
                                    }
                                } else {
                                    acceptableOffer = thisCon;
                                }
                            }
                        }
                    }

                    if(acceptableOffer) {


                        purchaseNewGBTContract({
                            "fromTicker": false,
                            "silentTrade": true,
                            "resourceName": nextSell.resource,
                            "contractRef": acceptableOffer
                        });
                    } else {

                        var tenthMonth = Math.floor(gameRes[ColonyGame.meta.tenderResource].amount * 0.025);
                        var maxAmtOffer = Math.floor(tenthMonth / unitPrice);

                        availableStorage = resItem.storageCapacity - resItem.amount;
                        var partialStorage = Math.round(availableStorage * 0.25);

                        if(maxAmtOffer > maxTradeSize) {
                            maxAmtOffer = maxTradeSize;
                        }

                        if(maxAmtOffer > partialStorage) {
                            maxAmtOffer = partialStorage;
                        }

                        if(maxAmtOffer < 100 && availableStorage > 100) {
                            maxAmtOffer = 100;
                        }

                        var maxOfferPrice = Math.floor(maxAmtOffer * unitPrice);

                        if(maxAmtOffer > 100 && maxOfferPrice > 0) {
                            postTradeToGBT(nextSell.resource,resItem.serverId,maxAmtOffer,maxOfferPrice,1,true,function() {
                                //console.log("OFFER AUTO TRADE POSTED! " + nextSell.resource);
                            });
                        }
                        
                    }
                }
                
            }
        });

        

    }

    function postTradeToGBT(resourceName,resourceId,quantity,price,type,silent,callback) {
        var theTimes = 0;

        if(ColonyGame.meta.transactionCostResource != null) {

            theTimes = quantity / 10;

            if(theTimes < 100) {
                theTimes = 100;
            }

            if(theTimes > getGameResources()[ColonyGame.meta.transactionCostResource].amount) {
                if(!silent) {
                    webAppCore.showToast("Not enough " + ColonyGame.meta.transactionCostResource + "!");
                }
                
                return;
            }

            theTimes = Math.round(theTimes);
        }

        // transaction cost
        if(theTimes > 0) {
            modifyResourceAmount(ColonyGame.meta.transactionCostResource,-theTimes,false,"Trade");
        }


        if(type == 0) {
            pendTradeTmpRevRes = resourceName;
            pendTradeTmpRevAmn = -quantity;

        } else {
            pendTradeTmpRevRes = ColonyGame.meta.tenderResource;
            pendTradeTmpRevAmn = -price;
        }

        modifyResourceAmount(pendTradeTmpRevRes,pendTradeTmpRevAmn,false,"Trade");

        contractPostTimeout = 20;

        var data = [];

        data.push({
            "key":      "r",
            "value":    resourceId
        });

        data.push({
            "key":      "q",
            "value":    quantity
        });

        data.push({
            "key":      "p",
            "value":    price
        });

        data.push({
            "key":      "c",
            "value":    type
        });

        postSecuredCallToApi(data,11,callback);

        if(!silent) {
            webAppCore.showToast("Trade Submitted");
        }
        

        if(!currentGame.cm) {
            if(ColonyGame.achievements.onlineTrade > 0) {
                webAppCore.reportAchievement(ColonyGame.achievements.onlineTrade);
            }

            checkDoKongStat("onlineTradeCounter",1);
        }

    }

    function generalSaveGameWithDialog(extraCallback,statusToSplash) {

        if(!extraCallback) {
            extraCallback = placeholder;
        }

        if(!statusToSplash) {
            statusToSplash = false;
        }

        if(!currentGame || currentFileName == "onlineregion") {
            extraCallback(false);
            return;
        }

        document.getElementById("savingDialog").style.display = "block";
        document.getElementById("savingHeader").innerHTML = "Saving " + currentFileName;

        if(statusToSplash) {
            webAppCore.showSplash("Saving " + currentFileName);
        }

        webAppCore.handleBackFunction(placeholder);

        var useExtension = ColonyGame.meta.fileExtension;

        if(currentGame.mem) {
            useExtension = ColonyGame.meta.customMapExtension;
        }

        if(!currentFileName) {
            currentFileName = cleanFileName(currentGame.name) + "." + useExtension;
        }

        currentFileName = currentFileName.replace("." + ColonyGame.meta.backupExtension,"." + useExtension);

        if(currentGame.firstSave) {
            checkSaveFileNameForDupes(function(){
                generalSaveGameWithDialog(extraCallback);
            });

            return;
        }

        updateSubregionData();
        saveCurrentGameStats();

        if(currentGame.mem) {
            saveCustomMapFile(function(){
                document.getElementById("savingProgressReadout").innerHTML = "";
                document.getElementById("savingDialog").style.display = "none";
                webAppCore.handleBackFunction(standardBack);
                extraCallback();
            });
            return;
        }

        saveGameNew(currentGame,currentFileName,function(result) {

            if(result) {
                if(result.progress == 1) {
                    if(result.success) {
                        if(currentGame && currentGame.isSubregion && currentRegion && regionFileName) {
                            document.getElementById("savingProgressReadout").innerHTML = "Saving Region...";

                            if(statusToSplash) {
                                webAppCore.showSplash("Saving Region...");
                            }
    
                            saveGameNew(currentRegion,regionFileName,function(regionResult) {
                                if(regionResult) {
                                    if(regionResult.progress == 1) {
                                        if(!regionResult.success) {
                                            if(regionResult.message) {
                                                webAppCore.showToast(regionResult.message);
                                            }
                                        }

                                        document.getElementById("savingProgressReadout").innerHTML = "";
                                        document.getElementById("savingDialog").style.display = "none";
                                        webAppCore.handleBackFunction(standardBack);
                                        extraCallback(regionResult.success);
                                    } else {
                                        if(regionResult.message) {
                                            document.getElementById("savingProgressReadout").innerHTML = regionResult.message;

                                            if(statusToSplash) {
                                                webAppCore.showSplash(regionResult.message);
                                            }
                                        }
                                    }
                                }
                            });
                        } else {
                            document.getElementById("savingProgressReadout").innerHTML = "";
                            document.getElementById("savingDialog").style.display = "none";
                            webAppCore.handleBackFunction(standardBack);
                            extraCallback(result.success);
                        }
                    } else {
                        if(result.message) {
                            webAppCore.showToast(result.message);
                        }

                        document.getElementById("savingProgressReadout").innerHTML = "";
                        document.getElementById("savingDialog").style.display = "none";
                        webAppCore.handleBackFunction(standardBack);
                        extraCallback(result.success);
                    }

                } else {
                    if(result.message) {
                        document.getElementById("savingProgressReadout").innerHTML = result.message;

                        if(statusToSplash) {
                            webAppCore.showSplash(result.message);
                        }
                    }
                }
            }

        });
    }

    function generalSaveGame(extraCallback) {
        if(!extraCallback) {
            extraCallback = placeholder;
        }

        if(!currentGame || currentFileName == "onlineregion") {
            extraCallback(false);
            return;
        }

        document.getElementById("autosavingReadout").innerHTML = "Saving Game...";
        document.getElementById("autosavingReadout").style.display = "inline-block";

        var useExtension = ColonyGame.meta.fileExtension;

        if(currentGame.mem) {
            useExtension = ColonyGame.meta.customMapExtension;
        }

        if(!currentFileName) {
            currentFileName = cleanFileName(currentGame.name) + "." + useExtension;
        }

        currentFileName = currentFileName.replace("." + ColonyGame.meta.backupExtension,"." + useExtension);

        if(currentGame.firstSave) {
            checkSaveFileNameForDupes(function(){
                generalSaveGame(extraCallback);
            });

            return;
        }

        updateSubregionData();
        saveCurrentGameStats();

        if(currentGame.mem) {
            saveCustomMapFile(function(){
                document.getElementById("savingProgressReadout").innerHTML = "";
                document.getElementById("autosavingReadout").style.display = "none";
                extraCallback();
            });
            return;
        }

        saveGameNew(currentGame,currentFileName,function(result) {

            if(result) {
                if(result.progress == 1) {

                    if(result.success) {
                        if(currentGame && currentGame.isSubregion && currentRegion && regionFileName) {
                            document.getElementById("autosavingReadout").innerHTML = "Saving Region...";
    
                            saveGameNew(currentRegion,regionFileName,function(regionResult) {
                                if(regionResult) {
                                    if(regionResult.progress == 1) {
                                        if(!regionResult.success) {
                                            if(regionResult.message) {
                                                webAppCore.showToast(regionResult.message);
                                            }
                                        }

                                        document.getElementById("savingProgressReadout").innerHTML = "";
                                        document.getElementById("autosavingReadout").style.display = "none";

                                        if(extraCallback) {
                                            extraCallback(regionResult.success);
                                        }
                                        
                                    } else {
                                        if(regionResult.message) {
                                            document.getElementById("autosavingReadout").innerHTML = regionResult.message;
                                        }
                                    }
                                }
                            });
                        } else {
                            document.getElementById("autosavingReadout").innerHTML = "";
                            document.getElementById("autosavingReadout").style.display = "none";

                            if(extraCallback) {
                                extraCallback(result.success);
                            }
                            
                        }
                    } else {
                        if(result.message) {
                            webAppCore.showToast(result.message);
                        }

                        document.getElementById("autosavingReadout").innerHTML = "";
                        document.getElementById("autosavingReadout").style.display = "none";

                        if(extraCallback) {
                            extraCallback(result.success);
                        }
                    }

                } else {
                    if(result.message) {
                        document.getElementById("autosavingReadout").innerHTML = result.message;
                    }
                }
            }

            
        });
    }

    function saveCurrentGameStats() {

        var roc = getRegionOrCity();

        if(!roc) {
            return;
        }

        if(currentGame && currentFileName) {
            if(!currentGame.isSubregion) {
                webAppCore.storeVar("mc-last-saved-game-name",currentGame.name);
                webAppCore.storeVar("mc-last-saved-game",currentFileName);
            } else {
                if(currentGame.mpRegionPlanetCharter && currentRegion) {
                    webAppCore.storeVar("mc-last-saved-game-name",currentRegion.name);
                    webAppCore.storeVar("mc-last-saved-game","##mp-r##" + currentGame.mpRegionPlanetCharter);
                }
            }
    
            var onlineflag = "1";

            if(roc.offlineMode) {
                onlineflag = "0";
            }
            
            webAppCore.storeVar("mc-ref-name-" + currentFileName,currentGame.name);
            webAppCore.storeVar("mc-ref-pop-" + currentFileName,getTotalPopulation());
            webAppCore.storeVar("mc-ref-online-" + currentFileName,onlineflag);
            webAppCore.storeVar("mc-ref-type-" + currentFileName,currentGame.mapType);
            webAppCore.storeVar("mc-ref-race-" + currentFileName,currentGame.defaultRace);
        }

        
    }

    function getGiftCapacity() {
        var baseCapacity = currentGame.giftCapacity;

        if(currentGame.isSubregion && currentRegion) {
            for(var i = 0; i < currentRegion.subRegions.length; i++) {
                if(currentRegion.subRegions[i].giftCapacity && currentRegion.subRegions[i].giftCapacity > baseCapacity) {
                    baseCapacity = currentRegion.subRegions[i].giftCapacity;
                }
                
            }
        }

        return baseCapacity;
    }

    function updateSubregionData() {
        if(currentGame.isSubregion && currentSubcityRef) {
            currentSubcityRef.population = parseInt(getTotalPopulation());
            currentSubcityRef.name = currentGame.name;
            currentSubcityRef.giftCapacity = currentGame.giftCapacity;

            var totalJobs = currentGame.historicStats.jobs[currentGame.historicStats.jobs.length - 1];
            var totalWorkers = currentGame.historicStats.workforce[currentGame.historicStats.workforce.length - 1];

            if(totalWorkers > totalJobs) {
                totalWorkers = totalJobs;
            }

            currentSubcityRef.availableJobs = totalJobs - totalWorkers;

            currentSubcityRef.edgeTiles = {
                "n": [],
                "s": [],
                "e": [],
                "w": []
            };

            // add map side connecting items 
            for(var passdef in currentGame.finishedPassableNonUpdatables) {
                var td = currentGame.finishedPassableNonUpdatables[passdef];
                for(var passX in td) {

                    if(isNaN(passX)) {
                        continue;
                    }

                    var tx = td[passX];
                    for(var ty = 0; ty < tx.length; ty++) {
                        var passY = tx[ty];

                        if(isNaN(passY)) {
                            continue;
                        }

                        if(passX == 0) {
                            currentSubcityRef.edgeTiles.w.push(new EdgeTile(passX,passY,currentSubcityRef.x,currentSubcityRef.y,passdef,"passable"));
                        }

                        if(passX == currentGame.width) {
                            currentSubcityRef.edgeTiles.e.push(new EdgeTile(passX,passY,currentSubcityRef.x,currentSubcityRef.y,passdef,"passable"));
                        }

                        if(passY == 0) {
                            currentSubcityRef.edgeTiles.n.push(new EdgeTile(passX,passY,currentSubcityRef.x,currentSubcityRef.y,passdef,"passable"));
                        }

                        if(passY == currentGame.height) {
                            currentSubcityRef.edgeTiles.s.push(new EdgeTile(passX,passY,currentSubcityRef.x,currentSubcityRef.y,passdef,"passable"));
                        }

                    }
                }
            }

            // sync natural resource levels 
            currentSubcityRef.naturalResources = {};
            currentSubcityRef.idleResourcesUsed = {};

            for(var i = 0, len = currentGame.mapResources.length; i < len; i++) {
                var res = currentGame.mapResources[i];
                var def = res.playDef;

                if(!def) {
                    res.playDef = getTerrainDefByName(res.def);
                    def = res.playDef;
                }
    
                if(def && def.provides && def.provides != null) {
                    var remainingIv = res.inventory;

                    if(!currentSubcityRef.naturalResources[def.provides]) {
                        currentSubcityRef.naturalResources[def.provides] = 0;
                        currentSubcityRef.idleResourcesUsed[def.provides] = 0;
                    }

                    currentSubcityRef.naturalResources[def.provides] += parseInt(remainingIv);
                }
                
            }

        }

    }

    function saveGameNew(data,name,callback) {

        if(!data || !name || !callback) {

            if(callback) {
                callback({
                    progress: 1,
                    success: false,
                    message: "Missing data or filename!"
                });
            }

            return;
        }

        if(data.isSaving || data.isCleaningForSave) {
            callback({
                progress: 1,
                success: false,
                message: "Save in Progress"
            });
            return;
        }

        callback({
            progress: 0,
            message: "Cleaning game data..."
        });

        var roc = getRegionOrCity();
        
        if(roc) {
            webAppCore.storeVar("pnd-trns-" + getRegionOrCity().colonyId + "-sve","0");
        }
        
        
        var curLastSave = data.lastSaveTime;
        data.lastSaveTime = Date.now();
        data.firstSave = false;

        var timeSinceLastSave = data.lastSaveTime - curLastSave;
        data.totalPlayTime += parseInt(timeSinceLastSave);

        data.saveRelCode = ColonyGame.meta.releaseCode;
        data.saveBuildVer = webAppCore.getAppVersion();

        cleanUpGameFile(data);

        var resHold = stripEmoji(JSON.stringify(getGameResources(data)));

        var ctx = new Checksum("fnv32", 0);
        ctx.updateStringly(resHold);
        var resourcesCheck = ctx.result.toString(16);

        data.rescs = resourcesCheck;

        var dataString = JSON.stringify(data);

        unCleanGameFile(data);
        
        data.isSaving = true;

        if(!dataString || dataString.trim().length == 0) {
            callback({
                progress: 1,
                success: false,
                message: "Unable to save!"
            });
            return;
        }

        var backupOption = webAppCore.getVar("mc-backup-option","1");

        if(backupOption == "1") {
            callback({
                progress: 0,
                message: "Saving backup..."
            });

            var backupName = currentFileName.replace("." + ColonyGame.meta.fileExtension,"." + ColonyGame.meta.backupExtension);
            backupName = backupName.replace("." + ColonyGame.meta.subCityExtension,"." + ColonyGame.meta.backupExtension);
            webAppCore.saveFile(backupName, dataString, function(){
                onNewBackupSaved(data,dataString,name,callback);
            }, true);
        } else {
            onNewBackupSaved(data,dataString,name,callback);
        }
    }

    function onNewBackupSaved(data,dataString,name,callback) {
        if(!data || !dataString || !name || !callback) {

            if(data) {
                data.isSaving = false;
            }

            if(callback) {
                callback({
                    progress: 1,
                    success: false,
                    message: "Unable to save!!"
                });
            }

            return;
        }

        var useCompression = data.useCompression;

        if(data.isSubregion) {
            if(getRegionOrCity()) {
                useCompression = getRegionOrCity().useCompression;
            }
        }

        if(!window || !window.Worker) {
            useCompression = false;
        }

        if(useCompression) {
            callback({
                progress: 0,
                message: "Compressing data..."
            });

            var worker;

            try {
                worker = new Worker("compression-worker.js");
            } catch(ex) {

                var usePlat = "unknown";

                if(webAppCore && webAppCore.getPlatform && webAppCore.getPlatform()) {
                    usePlat = webAppCore.getPlatform().platform;
                }

                webAppCore.logEvent("Caught Error",usePlat + ": onNewBackupSaved",ex.message);

                data.isSaving = false;
                callback({
                    progress: 1,
                    success: false,
                    message: "Save compression error!!"
                });

                return;
            }

            worker.addEventListener("message",function(e) {
                if(e.data.status == "complete") {
                    var compressedData = e.data.data;
                    onNewSaveDoFinalSave(data,compressedData,name,callback);
                } else {
                    data.isSaving = false;
                    callback({
                        progress: 1,
                        success: false,
                        message: "Save compression error!!"
                    });
                }
            });

            worker.addEventListener("error",function(e) {
                data.isSaving = false;
                callback({
                    progress: 1,
                    success: false,
                    message: "Save compression error!"
                });

                if(e.filename) {
                    var scrpt = e.filename.substr(e.filename.lastIndexOf("/") + 1);
                    webAppCore.logEvent("Game Compression Error",scrpt + ":" + e.lineno,e.message);
                } else {
                    webAppCore.logEvent("Game Compression Error","Unknown","Unknown");
                }
            });
            
            worker.postMessage({
                "method":   "compress",
                "data":     dataString
            });
        } else {
            onNewSaveDoFinalSave(data,dataString,name,callback);
        }
    }

    function onNewSaveDoFinalSave(data,dataString,name,callback) {
        if(!data || !dataString || !name || !callback) {

            if(data) {
                data.isSaving = false;
            }

            if(callback) {
                callback({
                    progress: 1,
                    success: false,
                    message: "Unable to save!!!"
                });
            }

            return;
        }

        var blockCloud = !data.useCloud;

        if(data.isSubregion) {
            if(getRegionOrCity()) {
                blockCloud = !getRegionOrCity().useCloud;
            }
        }

        if(blockCloud) {
            callback({
                progress: 0,
                message: "Saving data..."
            });
        } else {
            callback({
                progress: 0,
                message: "Syncing to cloud..."
            });
        }

        webAppCore.saveFile(name, dataString, function() {

            data.isSaving = false;
            
            if(currentGame && dataString && data == currentGame && data.isSubregion && currentSubcityRef) {
                currentSubcityRef.fileSize = parseInt(dataString.length);
            }

            callback({
                progress: 1,
                success: true,
                message: "Game Saved"
            });

            if(dataString) {
                data.currentFileSize = parseInt(dataString.length);
            }
            

            
        }, blockCloud);
    }

    function createMapLayout() {
        var layoutMap = {
            "width": currentGame.width,
            "height": currentGame.height,
            "buildings": [],
            "finishedPassableNonUpdatables": currentGame.finishedPassableNonUpdatables
        };

        for(var i = 0; i < currentGame.buildings.length; i++) {

            if(!currentGame.buildings[i]) {
                continue;
            }

            layoutMap.buildings.push({
                x: currentGame.buildings[i].x,
                y: currentGame.buildings[i].y,
                def: currentGame.buildings[i].def,
                flipped: currentGame.buildings[i].flipped
            });
        }

        return layoutMap;
    }

    function showLayoutTemplateMenu() {
        var templateOptions = [];

        templateOptions.push({
            title: getString("activate-template"),
            description: getString("activate-template-desc"),
            tag: "activate"
        });

        templateOptions.push({
            title: getString("save-template"),
            description: getString("save-template-desc"),
            tag: "save"
        });

        templateOptions.push({
            title: getString("export-template"),
            description: getString("export-template-desc"),
            tag: "export"
        });

        templateOptions.push({
            title: getString("import-template"),
            description: getString("import-template-desc"),
            tag: "import"
        });

        webAppCore.presentNativeList(getString("layout-template"),templateOptions,onTemplateOptionSelected,getString("general-dismiss"));
    }

    function onTemplateOptionSelected(tag) {
        if(!tag) {
            return;
        }

        if(tag == "import") {
            webAppCore.importFile(ColonyGame.meta.layoutFileExt,onLayoutFileImport);
        }

        if(tag == "export") {
            var templateObject = createMapLayout();
            var templateString = JSON.stringify(templateObject);
            var templateName = replaceAll(currentGame.name.toLowerCase().trim()," ","-") + "-template." + ColonyGame.meta.layoutFileExt;
            webAppCore.exportFile(templateName,templateString,false);
        }

        if(tag == "save") {
            saveTemplateFile();
        }

        if(tag == "activate") {
            webAppCore.openListing(showTemplateFiles);
        }
    }

    function saveTemplateFile() {
        webAppCore.inputBox({
            title: getString("save-template"),
            message: getString("pick-template-name"),
            func: function(text) {
                if(text && text.trim().length > 0) {
                    var templateObject = createMapLayout();
                    var templateString = JSON.stringify(templateObject);
                    var templateName = replaceAll(text.toLowerCase().trim()," ","-") + "." + ColonyGame.meta.layoutFileExt;

                    webAppCore.saveFile(templateName,templateString,function() {
                        webAppCore.showToast("Template Saved");
                        webAppCore.storeVar("template-" + templateName + "-width",templateObject.width);
                        webAppCore.storeVar("template-" + templateName + "-height",templateObject.height);
                    },false);

                    
                }
            }
        });
    }

    function showTemplateFiles(data) {
        var templateOptios = [];

        if(data) {
            for(var i = 0; i < data.length; i++) {
                var filename = data[i];

                var useStatus = "Unknown Size";
                var useStatusColor = "#FF9800";

                var retainedWidth = webAppCore.getVar("template-" + filename + "-width","-1");
                var retainedHeight = webAppCore.getVar("template-" + filename + "-height","-1");

                if(retainedWidth != "-1" && retainedHeight != "-1") {
                    useStatus = retainedWidth + "x" + retainedHeight;

                    if(parseInt(retainedWidth) == currentGame.width && parseInt(retainedHeight) == currentGame.height) {
                        useStatusColor = "#4CAF50";
                    } else {
                        useStatusColor = "#f44336";
                    }
                }

                if(endsWith(filename, "." + ColonyGame.meta.layoutFileExt)) {
                    templateOptios.push({
                        title: filename,
                        tag: filename,
                        status: useStatus,
                        "status-color": useStatusColor
                    });
                }
            }
        }

        if(templateOptios.length == 0) {
            webAppCore.showToast("No templates found!");
            return;
        }

        webAppCore.presentNativeList(getString("layout-template"),templateOptios,onTemplateToActivate,getString("general-dismiss"));
    }

    function onTemplateToActivate(filename) {
        if(!filename) {
            return;
        }

        webAppCore.openFile(filename, function(data){
            if(data) {
                try {
                    var checkTempalte = JSON.parse(data);

                    if(checkTempalte.height == currentGame.height && checkTempalte.width == currentGame.width) {
                        currentTemplate = checkTempalte;
                        templateVisible = true;
                    } else {
                        currentTemplate = null;
                        templateVisible = false;

                        webAppCore.showToast("Template size mismatch!");
                    }



                    webAppCore.storeVar("template-" + filename + "-width",checkTempalte.width);
                    webAppCore.storeVar("template-" + filename + "-height",checkTempalte.height);

                } catch(ex) {
                    console.log(ex);
                }
            }
        });
    }

    function onLayoutFileImport(name,content) {
        if(name && content) {

            try {
                var templateObject = JSON.parse(content);

                if(templateObject.height == templateObject.height && templateObject.width == templateObject.width) {
                    currentTemplate = templateObject;
                    templateVisible = true;
                    webAppCore.showToast("Template size mismatch!");
                } else {
                    currentTemplate = null;
                    templateVisible = false;
                }

                webAppCore.saveFile(name,content,function() {
                    webAppCore.showToast("Template Saved");
                    webAppCore.storeVar("template-" + name + "-width",templateObject.width);
                    webAppCore.storeVar("template-" + name + "-height",templateObject.height);
                },false);
            } catch(ex) {
                currentTemplate = null;
                templateVisible = false;

                webAppCore.showToast("Import error mismatch!");
            }

            
        }
    }

    function onContractItemClick() {
        if(this.badDeal) {
            showBadDealAlert(this);
            return;
        }

        purchaseNewGBTContract(this);
    }

    function onVehicleBuildItemContext(e) {
        e.preventDefault();

        if(!this.ref) {
            return;
        }

        if(ColonyGame.sounds.buildOptionSelect) {
            playInterfaceSoundEffect(ColonyGame.sounds.buildOptionSelect);
        }

        var theRef = this.ref;

        var dialogOptions = {
            title: theRef.name,
            message: "How many " + theRef.name + " to you want to build?  Warning - cannot currently be undone!",
            func: function(amt) {
                if(!amt) {
                    return;
                }

                var realAmt = parseInt(amt);

                if(isNaN(realAmt)) {
                    return;
                }

                var freeBuildings = getAvailableBuildingsForVehicleConstruction(theRef);

                if(freeBuildings.length > 0) {
                    while(realAmt > 0) {
                        doUnitConstruction(theRef,freeBuildings);
                        realAmt--;
                    }
                }

                
            }
        };

        webAppCore.inputBox(dialogOptions);
    }

    function onBuildingBuildItemContext(e) {
        e.preventDefault();

        showColonistsMenu("encyclopedia");
        showEncyclopediaSubsection("buildings");
        loadEncyclopediaArticle("buildings",this.ref.name);
    }

    function onBuildingBuildItemClick() {
        sidebarTypeFilter.value = "";
                
        if(!canIAffordThis(this.ref.cost)) {
            this.cantAffortThis = true;
            this.style.backgroundColor = "rgba(255, 0, 0, 0.3)";

            showInfoboxForSidebarItem(this.ref,80,this);
            return;
        }

        if(ColonyGame.sounds.buildOptionSelect) {
            playInterfaceSoundEffect(ColonyGame.sounds.buildOptionSelect);
        }

        bulldozerMode = false;

        if(queuedBuildings != null && queuedBuildings.length > 0) {
            engageBuildingQueue();
        }

        hideSidebarIfSmall();

        tmpBuildingRef = null;
        constructionFromSidebar = true;
        initConstruction(this.ref);
    }

    function onVehicleBuildItemClick() {
        sidebarTypeFilter.value = "";

        var freeBuildings = getAvailableBuildingsForVehicleConstruction(this.ref);

        if(freeBuildings.length == 0 || !canIAffordThis(this.ref.cost)) {
            this.cantAffortThis = true;
            this.style.backgroundColor = "rgba(255, 0, 0, 0.3)";
            return;
        }

        if(ColonyGame.sounds.buildOptionSelect) {
            playInterfaceSoundEffect(ColonyGame.sounds.buildOptionSelect);
        }

        doUnitConstruction(this.ref,freeBuildings);

        drawSidebar();
    }

    function doUnitConstruction(ref,freeBuildings) {

        if(!ref) {
            return;
        }

        if(!freeBuildings) {
            freeBuildings = getAvailableBuildingsForVehicleConstruction(ref);
        }


        bulldozerMode = false;

        var buildingToUse = null;

        if(selectedBuilding != null) {
            var bdef = getBuildingDefByName(selectedBuilding.def);

            if(bdef != null && bdef.produces != null) {
                for(var j = 0; j < bdef.produces.length; j++) {
                    if(bdef.produces[j] == ref.name) {
                        buildingToUse = selectedBuilding;
                        break;
                    }
                }
            }
        }

        if(buildingToUse == null) {
            var allFreeBuildings = getAvailableBuildingsForVehicleConstruction(ref);

            if(allFreeBuildings.length > 0) {
                buildingToUse = (allFreeBuildings[randomIntFromInterval(0,allFreeBuildings.length - 1)]);
            }
        }



        if(buildingToUse != null) {
            doConstruction(ref,buildingToUse);
        }
    }

    function updateBuildingEntertainmentAndMedical(bDef,building) {
        if(bDef.entertains > 0) {
            building.ofe = true;
        }

        if(bDef.takesTourists > 0) {
            building.oft = true;
        }

        if(bDef.heals > 0) {
            building.ofm = true;
        }

        if(building.iuc || building.lowPowerMode || building.ncm) {
            building.ofe = false;
            building.ofm = false;
            building.oft = false;
        }

        if(building.oft) {
            if(building.buT >= bDef.takesTourists) {
                building.oft = false;
            }
        }


        if(building.ofe || building.ofm) {
            if(bDef.requiresWorkers && !building.sw) {
                building.ofe = false;
                building.ofm = false;
            } else {
                if(building.ofe) {
                    entertainmentCoveragePoints.push(getCoveragePoint(building.x,building.y));
                }
            }
        }
    }

    var opprotunityRecycleBox = [];
    var coveragePointRecycler = [];

    function getCoveragePoint(x,y) {
        var cp = null;

        if(coveragePointRecycler.length > 0) {
            cp = coveragePointRecycler.pop();
            cp.x = x;
            cp.y = y;
        } else {
            cp = new CoveragePoint(x,y);
        }

        return cp;
    }

    function CoveragePoint(x,y) {
        this.x = x;
        this.y = y;
    }

    function getUserMultiplayerRegions() {
        userMultiplayerRegions = [];

        if(ColonyGame.meta.colonyServerApi == null) {
            return;
        }

        if(!webAppCore.isApeAppsLoggedIn()) {
            return;
        }

        var data = [];

        data.push({
            "key":      "f",
            "value":    64
        });

        data.push({
            "key":      "g",
            "value":    ColonyGame.meta.colonyServerGameId
        });

        data.push({
            "key":      "aun",
            "value":    webAppCore.getApeAppsProfile().un
        });

        data.push({
            "key":      "relcd",
            "value":    ColonyGame.meta.releaseCode
        });

        webAppCore.postForResult(ColonyGame.meta.colonyServerApi, data, onUserMpRegionsBack);
    }

    function onUserMpRegionsBack(data) {
        if(!data || data.trim().length == 0) {
            return;
        }

        try {
            userMultiplayerRegions = JSON.parse(data);
        } catch(ex) {
            userMultiplayerRegions = [];
        }

    }

    function showMpSubcityInfoWindow(subcity) {

        webAppCore.postForResult(ColonyGame.meta.colonyServerApi, [
            {
                "key":      "f",
                "value":    25
            },
            {
                "key":      "relcd",
                "value":    ColonyGame.meta.releaseCode
            },
            {
                "key":      "c",
                "value":    subcity.mpCharter
            },
            {
                "key":      "g",
                "value":    ColonyGame.meta.colonyServerGameId
            }
        ], onMpSubcityInfoBack);
    }

    function onMpSubcityInfoBack(data) {
        if(!data || data.trim().length == 0) {
            return;
        }

        try {
            var infoStuff = JSON.parse(data);

            if(infoStuff && infoStuff.length == 1) {
                launchColonyInfoScreen(infoStuff[0]);
            }
        } catch(ex) {
            // hrmmm
        }
    }

    function showShareRegionCharter() {
        if(!currentGame || !currentGame.isMpRegionHolder) {
            return;
        }

        webAppCore.showDialog({
            title: getString("share-region-charter"),
            message: getString("general-charter-code") + ": " + currentGame.charter,
            buttons: [
                {
                    text: getString("general-share"),
                    func: function(){
                        webAppCore.nativeShare(currentGame.name + ": " + currentGame.charter);
                    }
                },
                {
                    text: getString("general-dismiss"),
                    func: placeholder
                }
            ]
        });
    }

    function renameMetroArea() {
        if(currentGame.isSubregion && currentRegion && currentRegion.isMpRegionHolder && currentSubcityRef) {
            var metroAreaId = currentSubcityRef.metroAreaDistrict;
            var metroAreaName = currentRegion.metroAreaNameRef[metroAreaId];

            var dialogOptions = {
                "title":    getString("rename-district"),
                "message":  getString("rename-district-desc") + "\n\nCurrent: " + metroAreaName.name,
                func: function(text) {
                    if(text && text.trim().length > 0) {
                        var data = [];

                        data.push({
                            "key":      "di",
                            "value":    metroAreaId
                        });

                        data.push({
                            "key":      "n",
                            "value":    text.trim()
                        });

                        postSecuredCallToApi(data,68,function(){
                            metroAreaName.name = text.trim();
                            updateOverviewStatDisplay();
                            webAppCore.showToast("Success!");
                        });
                    }
                }
            };
    
            webAppCore.inputBox(dialogOptions);
        }
    }

    function openChatInputWindow() {

        if(!currentChatChannel) {
            return;
        }

        if(!webAppCore.isApeAppsLoggedIn()) {
            return;
        }

        document.getElementById("chatInputBoxHolder").style.display = "block";
        document.getElementById("chatInputBoxInput").value = "";
        document.getElementById("chatInputBoxInput").focus();

        document.getElementById("chatInputBoxChannelName").innerHTML = "#" + currentChatChannel;

    }

    function openResourceSearchBox() {
        document.getElementById("allResourceSearchHolder").style.display = "block";
        document.getElementById("allResourceSearchBox").value = "";
        document.getElementById("allResourceSearchBox").focus();
    }

    function processResourceSearch(query) {
        var isAResource = false;
        var valRes = null;

        for(var i = 0; i < ColonyGame.resources.length; i++) {
            if(ColonyGame.resources[i].name.toLowerCase() == query.toLowerCase()) {
                isAResource = true;
                valRes = ColonyGame.resources[i].name;
                break;
            }
        }

        if(isAResource) {
            document.getElementById("allResourceSearchHolder").style.display = "none";
            showChartsForResource(valRes);
        }
    }

    function playInterfaceSoundEffect(effect) {
        if(!effect) {
            return;
        }

        var volDefault = "100";

        if(!allowAudio) {
            volDefault = "0";
        }

        var soundEffectVolume = parseInt(webAppCore.getVar("effect-volume",volDefault));

        if(soundEffectVolume == 0) {
            return;
        }

        webAppCore.playSoundEffect(effect,soundEffectVolume);
    }

    var tmpAdjSfxSliderLvl = 0;

    function adjustSoundEffectsVolume() {

        var volDefault = "100";

        if(!allowAudio) {
            volDefault = "0";
        }

        tmpAdjSfxSliderLvl = parseInt(webAppCore.getVar("effect-volume",volDefault));
        var soundEffectStatus = getString("gen-volume") + ": " + tmpAdjSfxSliderLvl + "%";

        if(tmpAdjSfxSliderLvl == 0) {
            soundEffectStatus = getString("gen-disabled");
        }

        webAppCore.showDialog({
            title: getString("general-sound-xf"),
            message: getString("set-sfx-instruct"),
            icon: "images/" + ColonyGame.meta.soundIndicator,
            sliderMin: 0,
            sliderMax: 100,
            sliderValue: tmpAdjSfxSliderLvl,
            sliderStatusText: soundEffectStatus,
            sliderCallback: function(val,fun) {
                tmpAdjSfxSliderLvl = parseInt(val);

                var soundEffectStatus = getString("gen-volume") + ": " + tmpAdjSfxSliderLvl + "%";

                if(tmpAdjSfxSliderLvl == 0) {
                    soundEffectStatus = getString("gen-disabled");
                }

                fun(soundEffectStatus);
            },
            buttons: [
                {
                    text: getString("general-confirm"),
                    func: function(){
                        webAppCore.storeVar("effect-volume",tmpAdjSfxSliderLvl.toString());
                        showEngineSettings();
                    },
                    color: "#4CAF50"
                },
                {
                    text: getString("general-cancel"),
                    func: placeholder
                }
            ]
        });
    }

    function getAllEmbassies() {
        var embassies = [];

        for(var i = 0; i < currentGame.buildings.length; i++) {
            var bld = currentGame.buildings[i];

            if(!bld) {
                continue;
            }

            if(bld.embassyFor && bld.embassyFor != 0) {
                embassies.push(bld);
            }
        }

        return embassies;
    }

    var onlineEmbassiesToVeryfy = null;

    function verifyAllEmbassies() {
        onlineEmbassiesToVeryfy = getAllEmbassies();

        if(onlineEmbassiesToVeryfy.length > 0) {
            verifyNextEmbassy();
        } else {
            onlineEmbassiesToVeryfy = null;
        }
    }

    function verifyNextEmbassy() {

        if(!onlineEmbassiesToVeryfy || onlineEmbassiesToVeryfy.length == 0) {
            onlineEmbassiesToVeryfy = null;
            return;
        }

        var embassy = onlineEmbassiesToVeryfy.pop();

        var data = [];

        data.push({
            "key":      "cid",
            "value":    embassy.embassyFor
        });

        postSecuredCallToApi(data,39,function(result){

            var legitEmbassy = false;
            
            if(result != null && result.trim().length > 0) {
                try {
                    var colonyInfo = JSON.parse(result)[0];
    
                    if(colonyInfo) {
                        legitEmbassy = true;
                    }

                } catch(ex) {
                    // its a dead embassy
                }
            }

            if(!legitEmbassy) {
                embassy.isBeingRemoved = true;
                embassy.condition = 0;
            }

            setTimeout(verifyNextEmbassy,200);
        });
    }

    function handleAdministrativeAction(data) {

        var roc = getRegionOrCity();

        if(!data || data.charter != roc.charter) {
            return;
        }

        if(data.func == "modresources") {

            try {
                var resBase = data.data;
                var resDec = atob(resBase);
                var serverresjsondata = JSON.parse(resDec);

                var gameRes = getGameResources();

                for(var sRes in serverresjsondata) {

                    var rDef = getResourceByDefName(sRes);

                    if(!rDef) {
                        continue;
                    }

                    if(!gameRes[sRes]) {
                        gameRes[sRes] = {};
                        gameRes[sRes].amount = 0;
                        gameRes[sRes].previous = 0;
                        gameRes[sRes].capacity = rDef.max;
                        gameRes[sRes].price = rDef.basePrice;
                        gameRes[sRes].storageCapacity = 0;
                        gameRes[sRes].unlocked = false;
                        gameRes[sRes].serverId = 0;
                        gameRes[sRes].domesticCapacity = 0;
                        gameRes[sRes].domesticAmount = 0;
                        gameRes[sRes].lastTrade = 0;
                        gameRes[sRes].autosell = false;
                    }

                    gameRes[sRes].amount = parseInt(serverresjsondata[sRes]);
                }
            } catch(ex) {
                console.log(ex);
            }
        }
    }

    function defaultOutZoomLevel() {
        if(currentGame.isRegion) {
            Scroll2d.setZoomLevel(2 / renderScaleFactor);
        } else {
            Scroll2d.setZoomLevel(1 / renderScaleFactor);
        }
    }

    var flagAssetParts = {};

    function updateFlagStatSection() {
        var roc = getRegionOrCity();

        if(!roc) {
            return;
        }

        document.getElementById("btnAddPart").onclick = function(){
            roc.flag.parts.push(new ColonyFlagPart());
            updateFlagStatSection();
        };

        document.getElementById("btnAddLogo").onclick = function(){
            roc.flag.logos.push(new ColonyFlagLogo());
            updateFlagStatSection();
        };

        document.getElementById("flagBgPreviewHolder").style.backgroundColor = roc.flag.bg;
        document.getElementById("flagBgPreviewHolder").onclick = function(){
            webAppCore.pickColor(function(color){
                if(color && color.trim().length == 7) {
                    roc.flag.bg = color.trim();
                    updateFlagStatSection();
                }
            },roc.flag.bg);
        };

        document.getElementById("flagPartsHolder").innerHTML = "";
        document.getElementById("flagLogosHolder").innerHTML = "";

        var i;

        for(i = 0; i < roc.flag.parts.length; i++) {
            var part = roc.flag.parts[i];

            var flagPartItem = document.createElement("div");
            flagPartItem.className = "flagPartItem";
            flagPartItem.partRef = part;

            var removePart = document.createElement("img");
            removePart.draggable = false;
            removePart.className = "flagPartItemRemove";
            removePart.src = "images/" + ColonyGame.meta.indDestroy;
            removePart.partRef = part;
            removePart.onclick = doRemoveFlagMainPart;
            flagPartItem.appendChild(removePart);

            var partLeft = document.createElement("div");
            partLeft.className = "flagPartItemLeft";
            partLeft.innerHTML = "<";
            partLeft.partRef = part;
            partLeft.dirRef = -1;
            partLeft.onclick = flagPartPreviousOrNext;
            flagPartItem.appendChild(partLeft);

            var previewPart = document.createElement("img");
            previewPart.draggable = false;
            previewPart.className = "flagPartItemPreview";
            previewPart.src = "images/" + part.img;
            previewPart.partRef = part;
            flagPartItem.appendChild(previewPart);

            

            var partRight = document.createElement("div");
            partRight.className = "flagPartItemRight";
            partRight.innerHTML = ">";
            partRight.partRef = part;
            partRight.dirRef = 1;
            partRight.onclick = flagPartPreviousOrNext;
            flagPartItem.appendChild(partRight);

            var partColor = document.createElement("div");
            partColor.className = "flagPartItemColor";
            partColor.style.backgroundColor = part.color;
            partColor.partRef = part;
            partColor.onclick = flagPartColorPicl;
            flagPartItem.appendChild(partColor);

            document.getElementById("flagPartsHolder").appendChild(flagPartItem);
        }


        for(i = 0; i < roc.flag.logos.length; i++) {
            var item = roc.flag.logos[i];

            var flagItemItem = document.createElement("div");
            flagItemItem.className = "flagPartItem";
            flagItemItem.itemRef = item;

            var removeItem = document.createElement("img");
            removeItem.draggable = false;
            removeItem.className = "flagPartItemRemove";
            removeItem.src = "images/" + ColonyGame.meta.indDestroy;
            removeItem.itemRef = item;
            removeItem.onclick = doFlagItemRemove;
            flagItemItem.appendChild(removeItem);

            var itemLeft = document.createElement("div");
            itemLeft.className = "flagPartItemLeft";
            itemLeft.innerHTML = "<";
            itemLeft.itemRef = item;
            itemLeft.dirRef = -1;
            itemLeft.onclick = flagItemPreviousOrNext;
            flagItemItem.appendChild(itemLeft);

            var itemPreview = document.createElement("img");
            itemPreview.draggable = false;
            itemPreview.className = "flagItemItemPreview";
            itemPreview.src = "images/" + item.img;
            itemPreview.itemRef = item;
            flagItemItem.appendChild(itemPreview);

            

            var itemRight = document.createElement("div");
            itemRight.className = "flagPartItemRight";
            itemRight.innerHTML = ">";
            itemRight.itemRef = item;
            itemRight.dirRef = 1;
            itemRight.onclick = flagItemPreviousOrNext;
            flagItemItem.appendChild(itemRight);

            var itemColor = document.createElement("div");
            itemColor.className = "flagPartItemColor";
            itemColor.style.backgroundColor = item.color;
            itemColor.itemRef = item;
            itemColor.onclick = flagItemColorPick;
            flagItemItem.appendChild(itemColor);

            var itemPosition = document.createElement("select");
            itemPosition.onchange = onSelectionItemChangeEvent;
            itemPosition.className = "flagPartItemPositionSelectHolder";
            itemPosition.itemRef = item;
            var posItem;

            posItem = document.createElement("option");
            posItem.className = "flagPartItemPositionSelect";
            posItem.innerHTML = "Center";
            posItem.value = "C";
            if(item.pos == "C") {
                posItem.selected = true;
            }
            itemPosition.appendChild(posItem);

            

            posItem = document.createElement("option");
            posItem.className = "flagPartItemPositionSelect";
            posItem.innerHTML = "Top Left";
            posItem.value = "TL";
            if(item.pos == "TL") {
                posItem.selected = true;
            }
            itemPosition.appendChild(posItem);

            posItem = document.createElement("option");
            posItem.className = "flagPartItemPositionSelect";
            posItem.innerHTML = "Top Center";
            posItem.value = "TC";
            if(item.pos == "TC") {
                posItem.selected = true;
            }
            itemPosition.appendChild(posItem);

            posItem = document.createElement("option");
            posItem.className = "flagPartItemPositionSelect";
            posItem.innerHTML = "Top Right";
            posItem.value = "TR";
            if(item.pos == "TR") {
                posItem.selected = true;
            }
            itemPosition.appendChild(posItem);

            posItem = document.createElement("option");
            posItem.className = "flagPartItemPositionSelect";
            posItem.innerHTML = "Center Left";
            posItem.value = "CL";
            if(item.pos == "CL") {
                posItem.selected = true;
            }
            itemPosition.appendChild(posItem);

            posItem = document.createElement("option");
            posItem.className = "flagPartItemPositionSelect";
            posItem.innerHTML = "Center Right";
            posItem.value = "CR";
            if(item.pos == "CR") {
                posItem.selected = true;
            }
            itemPosition.appendChild(posItem);

            posItem = document.createElement("option");
            posItem.className = "flagPartItemPositionSelect";
            posItem.innerHTML = "Bottom Left";
            posItem.value = "BL";
            if(item.pos == "BL") {
                posItem.selected = true;
            }
            itemPosition.appendChild(posItem);

            posItem = document.createElement("option");
            posItem.className = "flagPartItemPositionSelect";
            posItem.innerHTML = "Bottom Center";
            posItem.value = "BC";
            if(item.pos == "BC") {
                posItem.selected = true;
            }
            itemPosition.appendChild(posItem);

            posItem = document.createElement("option");
            posItem.className = "flagPartItemPositionSelect";
            posItem.innerHTML = "Bottom Right";
            posItem.value = "BR";
            if(item.pos == "BR") {
                posItem.selected = true;
            }
            itemPosition.appendChild(posItem);

            

            flagItemItem.appendChild(itemPosition);


            var itemSize = document.createElement("input");
            itemSize.type = "range";
            itemSize.min = 10;
            itemSize.max = 500;
            itemSize.value = parseInt(item.scale * 100);
            itemSize.className = "flagPartItemSizeSlider";
            itemSize.itemRef = item;
            itemSize.onchange = onItemSliderSizeChange;
            flagItemItem.appendChild(itemSize);

            document.getElementById("flagLogosHolder").appendChild(flagItemItem);
        }

        renderFlagIntoCanvas(roc.flag,document.getElementById("flagEditorPreviewCanvas"),true);

        
    }

    function uploadPendingFlagData() {
        pendingFlagUploadTimer = null;

        if(!pendingUploadFlagData) {
            return;
        }

        if(currentGame == null || !getRegionOrCity().colonyId || getRegionOrCity().colonyId == 0  || getRegionOrCity().offlineMode) {
            return;
        }

        var data = [];

        data.push({
            "key":      "img",
            "value":    pendingUploadFlagData
        });


        postSecuredCallToApi(data,70,placeholder);

        pendingUploadFlagData = null;
    }

    var pendingUploadFlagData;
    var pendingFlagUploadTimer = null;

    function renderFlagIntoCanvas(flag,flagCanvas,uploadAfter) {

        if(!flag || !flagCanvas) {
            return;
        }

        var height = flagCanvas.height;
        var width = flagCanvas.width;
        var scale = width / 300;

        var flagContext = flagCanvas.getContext("2d");
        flagContext.fillStyle = flag.bg;

        flagContext.fillRect(0,0,width,height);

        var redrawNeeded = false;

        var i;

        for(i = 0; i < flag.parts.length; i++) {
            var flagPart = flag.parts[i];
            var partImg = getFlagAsset(flagPart.img,flagPart.color);

            if(partImg) {
                flagContext.drawImage(partImg,0,0,width,height);
            } else {
                redrawNeeded = true;
            }
        }

        for(i = 0; i < flag.logos.length; i++) {
            var flagLogo = flag.logos[i];
            var logoImg = getFlagAsset(flagLogo.img,flagLogo.color);

            var baseX = 50;
            var baseY = 50;
            var baseWidth = 50 * flagLogo.scale;
            var baseHeight = 50 * flagLogo.scale;

            // center
            if(flagLogo.pos == "C") {
                baseX = 150 - (baseWidth / 2);
                baseY = 100 - (baseHeight / 2);
            }

            // top left
            if(flagLogo.pos == "TL") {
                baseX = 75 - (baseWidth / 2);
                baseY = 50 - (baseHeight / 2);
            }

            // center left
            if(flagLogo.pos == "CL") {
                baseX = 75 - (baseWidth / 2);
                baseY = 100 - (baseHeight / 2);
            }

            // bottom left
            if(flagLogo.pos == "BL") {
                baseX = 75 - (baseWidth / 2);
                baseY = 150 - (baseHeight / 2);
            }

            // top right
            if(flagLogo.pos == "TR") {
                baseX = 225 - (baseWidth / 2);
                baseY = 50 - (baseHeight / 2);
            }

            // center right
            if(flagLogo.pos == "CR") {
                baseX = 225 - (baseWidth / 2);
                baseY = 100 - (baseHeight / 2);
            }

            // bottom right
            if(flagLogo.pos == "BR") {
                baseX = 225 - (baseWidth / 2);
                baseY = 150 - (baseHeight / 2);
            }

            // top center
            if(flagLogo.pos == "TC") {
                baseX = 150 - (baseWidth / 2);
                baseY = 50 - (baseHeight / 2);
            }

            // bottom center
            if(flagLogo.pos == "BC") {
                baseX = 150 - (baseWidth / 2);
                baseY = 150 - (baseHeight / 2);
            }

            if(logoImg) {
                flagContext.drawImage(logoImg,baseX * scale,baseY * scale,baseWidth * scale,baseHeight * scale);
            } else {
                redrawNeeded = true;
            }
        }

        if(redrawNeeded) {
            setTimeout(function(){
                renderFlagIntoCanvas(flag,flagCanvas,uploadAfter);
            },200);
        } else {
            if(uploadAfter) {
                if(pendingFlagUploadTimer) {
                    clearTimeout(pendingFlagUploadTimer);
                }

                pendingFlagUploadTimer = null;

                pendingUploadFlagData = flagCanvas.toDataURL("image/jpeg",0.75);
                pendingUploadFlagData = pendingUploadFlagData.replace("data:image/jpeg;base64,","");

                pendingFlagUploadTimer = setTimeout(uploadPendingFlagData,7000);
            }
        }
    }

    function getFlagAsset(svg,color) {

        var partName = svg + "-" + color;

        if(flagAssetParts[partName] && flagAssetParts[partName].loaded) {
            return flagAssetParts[partName].part;
        }

        if(flagAssetParts[partName] && !flagAssetParts[partName].loaded) {
            return null;
        }

        flagAssetParts[partName] = {
            loaded: false,
            part: null
        };

        var xhr = new XMLHttpRequest();
        xhr.onload = function() {
            var svgAsXml = xhr.responseXML;
            var svgAsString = new XMLSerializer().serializeToString(svgAsXml);
            svgAsString = replaceAll(svgAsString, "fill:#ff00ff;", "fill:" + color + ";");
            svgAsString = replaceAll(svgAsString, "stroke:#ff00ff;", "stroke:" + color + ";");

            var svgBlob = new Blob([svgAsString], {type: "image/svg+xml"});
            var url = window.URL.createObjectURL(svgBlob);
            var img = new Image();

            // copy it to the canvas
            img.onload = function() {
                flagAssetParts[partName].part = this;
                flagAssetParts[partName].loaded = true;
                window.URL.revokeObjectURL(svgBlob);
            };

            img.addEventListener("error",function(){
                delete flagAssetParts[partName];
            });

            img.src = url;
        };
        xhr.addEventListener("error",function(){
            delete flagAssetParts[partName];
        });
        xhr.open("GET", "images/" + svg);
        xhr.responseType = "document";
        xhr.send();

        return null;
    }

    function flagPartPreviousOrNext() {
        var dirRef = this.dirRef;
        var part = this.partRef;

        var curIndex = ColonyGame.flagParts.indexOf(part.img);

        curIndex += parseInt(dirRef);

        if(curIndex >= ColonyGame.flagParts.length) {
            curIndex = 0;
        }

        if(curIndex < 0) {
            curIndex = ColonyGame.flagParts.length - 1;
        }

        part.img = ColonyGame.flagParts[curIndex];

        updateFlagStatSection();
    }

    function flagPartColorPicl() {
        var part = this.partRef;

        webAppCore.pickColor(function(color){
            if(color && color.trim().length == 7) {
                part.color = color.trim();
                updateFlagStatSection();
            }
        },part.color);
    }

    function flagItemColorPick() {
        var part = this.itemRef;

        webAppCore.pickColor(function(color){
            if(color && color.trim().length == 7) {
                part.color = color.trim();
                updateFlagStatSection();
            }
        },part.color);
    }

    function flagItemPreviousOrNext() {
        var dirRef = this.dirRef;
        var part = this.itemRef;

        var curIndex = ColonyGame.flagLogos.indexOf(part.img);

        curIndex += parseInt(dirRef);

        if(curIndex >= ColonyGame.flagLogos.length) {
            curIndex = 0;
        }

        if(curIndex < 0) {
            curIndex = ColonyGame.flagLogos.length - 1;
        }

        part.img = ColonyGame.flagLogos[curIndex];

        updateFlagStatSection();
    }

    function onSelectionItemChangeEvent() {
        var part = this.itemRef;

        part.pos = this.options[this.selectedIndex].value;

        updateFlagStatSection();
    }

    function doFlagItemRemove() {
        var part = this.itemRef;
        var roc = getRegionOrCity();

        removeFromArray(roc.flag.logos,part);
        updateFlagStatSection();
    }

    function doRemoveFlagMainPart() {
        var part = this.partRef;
        var roc = getRegionOrCity();

        removeFromArray(roc.flag.parts,part);
        updateFlagStatSection();
    }

    function onItemSliderSizeChange() {
        var part = this.itemRef;
        var val = parseFloat((parseInt(this.value) / 100).toFixed(2));
        part.scale = val;

        updateFlagStatSection();
    }

    var userProfileWindowOpen = false;

    function onChatUsernameSelected(username) {
        if(titleShowing || !username || username.trim().length < 1) {
            return;
        }

        showUserProfile(username.trim());
    }

    function showUserProfile(username) {

        if(!getRegionOrCity() || getRegionOrCity().offlineMode) {
            return;
        }

        closeSomethingIfOpen();

        if(!username) {
            return;
        }

        userProfileWindowOpen = true;

        document.getElementById("userProfileWindow").style.display = "block";

        document.getElementById("userProfileWindowTitleName").innerHTML = username;


        var showAddFriend = true;
        var i;

        if(friendsList && friendsList.confirmed) {
            for(i = 0; i < friendsList.confirmed.length; i++) {
                if(friendsList.confirmed[i].un == username) {
                    showAddFriend = false;
                    break;
                }
            }
        }

        if(showAddFriend && friendsList && friendsList.outgoing) {
            for(i = 0; i < friendsList.outgoing.length; i++) {
                if(friendsList.outgoing[i].un == username) {
                    showAddFriend = false;
                    break;
                }
            }
        }

        if(username == webAppCore.getApeAppsProfile().un) {
            showAddFriend = false;
        }

        if(showAddFriend) {
            document.getElementById("userProfileWindowAddFriendButton").style.display = null;
            document.getElementById("userProfileWindowAddFriendButton").onclick = function(){
                addFriend(username);
            };
        } else {
            document.getElementById("userProfileWindowAddFriendButton").style.display = "none";
        }


        var icon = "https://accounts.ape-apps.com/getavatar.php?u=" + username;

        document.getElementById("userProfileWindowTitleIcon").src = icon;

        var data = [];

        data.push({
            "key":      "au",
            "value":    username
        });


        postSecuredCallToApi(data,71,onUserColoniesBack);
    }

    function closeUserProfileWindow() {
        userProfileWindowOpen = false;

        document.getElementById("userProfileWindow").style.display = "none";
    }

    function onUserColoniesBack(result) {
        if(result != null && result.trim().length > 0) {
            var userColoniesListing = document.getElementById("userColoniesListing");
            userColoniesListing.innerHTML = "";

            try {
                var colonyInfo = JSON.parse(result);

                if(colonyInfo == null) {
                    return;
                }

                for(var i = 0; i < colonyInfo.length; i++) {
                    addColonyCardToListing(colonyInfo[i],true,"userColoniesListing");
                }

            } catch(ex) {
                webAppCore.logEvent("Caught Error",webAppCore.getPlatform().platform + ": onUserColoniesBack",ex.message);
            }
        }
    }

    function refreshFriendsList(callback) {
        friendsList = {};

        webAppCore.getFriendsList(function(friends){
            
            friendsList = friends;

            if(callback) {
                callback(friendsList);
            }
            
            if(!friendsList || friendsList.incoming.length > 0) {
                document.getElementById("imFriends").style.display = null;
            } else {
                document.getElementById("imFriends").style.display = "none";
            }
        });
    }

    function updateFriendsListDisplay() {

        if(!friendsList) {
            return;
        }

        var i;

        if(friendsList.incoming.length > 0) {
            document.getElementById("overviewFriendsSectionIncoming").style.display = "block";

            var overviewFriendsSectionIncomingReadout = document.getElementById("overviewFriendsSectionIncomingReadout");
            overviewFriendsSectionIncomingReadout.innerHTML = "";

            for(i = 0; i < friendsList.incoming.length; i++) {
                var incUsr = friendsList.incoming[i];
                var incCard = createUserCard(incUsr.un,incUsr.la);
                overviewFriendsSectionIncomingReadout.appendChild(incCard);

                postToUserChannel("areyouonline",incUsr.un,null);
            }
        } else {
            document.getElementById("overviewFriendsSectionIncoming").style.display = "none";
        }

        var overviewFriendsSectionConfirmed = document.getElementById("overviewFriendsSectionConfirmed");
        overviewFriendsSectionConfirmed.innerHTML = "";

        for(i = 0; i < friendsList.confirmed.length; i++) {
            var conUsr = friendsList.confirmed[i];
            var conCard = createUserCard(conUsr.un,conUsr.la);
            overviewFriendsSectionConfirmed.appendChild(conCard);

            postToUserChannel("areyouonline",conUsr.un,null);
        }
    }

    function createUserCard(username,lastActive) {
        var usercard = document.createElement("div");
        usercard.className = "colonyCard";
        usercard.onclick = function(){
            showUserProfile(username.trim());
        };

        var userIcon = document.createElement("img");
        userIcon.draggable = false;
        userIcon.className = "colonyCardIcon";
        userIcon.src = "https://accounts.ape-apps.com/getavatar.php?u=" + username;
        usercard.appendChild(userIcon);

        var userNameItem = document.createElement("span");
        userNameItem.className = "colonyCardName";
        userNameItem.innerHTML = username;
        usercard.appendChild(userNameItem);

        var userActive = document.createElement("span");
        userActive.className = "colonyCardActive userNameCardStatus" + username;

        if(lastActive) {
            userActive.innerHTML = "Last Active: " + lastActive;
        } else {
            userActive.innerHTML = "Offline";
        }
        
        usercard.appendChild(userActive);

        

        return usercard;
    }

    function addFriend(username) {
        document.getElementById("userProfileWindowAddFriendButton").style.display = "none";

        if(username == webAppCore.getApeAppsProfile().un) {
            return;
        }

        webAppCore.addFriend(username,function(result){
            if(result == "requested") {
                webAppCore.showToast("Request Sent");
            }

            if(result == "accepted") {
                webAppCore.showToast("Friend Confirmed");
            }

            refreshFriendsList();
        });
    }

    function checkDoKongStat(stat,value) {
        if(webAppCore.getPlatform().market != "kongregate") {
            return;
        }

        if(!ColonyGame.kongregateStats || !ColonyGame.kongregateStats[stat]) {
            return;
        }

        webAppCore.sendKongregateStat(ColonyGame.kongregateStats[stat],value);
    }

    function checkMoveUnitToAnotherMap(unit,x,y) {

        if(!unit) {
            return;
        }

        if(currentGame && currentGame.isSubregion && currentRegion && !currentRegion.isMpRegionHolder) {
            if(x == -1 || x == (currentGame.width + 1) || y == -1 || y == (currentGame.height + 1)) {
                if(currentSubcityRef) {
                    var checkCity = null;
                    var useCitySize = 1;

                    if(currentSubcityRef.size == 100) {
                        useCitySize = 2;
                    }

                    if(x == -1) {
                        if(y <= 50) {
                            checkCity = getSubregionByCoord(currentSubcityRef.x - 1,currentSubcityRef.y);
                        } else {
                            checkCity = getSubregionByCoord(currentSubcityRef.x - 1,currentSubcityRef.y + 1);
                        }
                    }

                    if(x == (currentGame.width + 1)) {
                        if(y <= 50) {
                            checkCity = getSubregionByCoord(currentSubcityRef.x + useCitySize,currentSubcityRef.y);
                        } else {
                            checkCity = getSubregionByCoord(currentSubcityRef.x + useCitySize,currentSubcityRef.y + 1);
                        }
                    }

                    if(y == -1) {
                        if(x <= 50) {
                            checkCity = getSubregionByCoord(currentSubcityRef.x,currentSubcityRef.y - 1);
                        } else {
                            checkCity = getSubregionByCoord(currentSubcityRef.x + 1,currentSubcityRef.y - 1);
                        }
                    }

                    if(y == (currentGame.height + 1)) {
                        if(x <= 50) {
                            checkCity = getSubregionByCoord(currentSubcityRef.x,currentSubcityRef.y + useCitySize);
                        } else {
                            checkCity = getSubregionByCoord(currentSubcityRef.x + 1,currentSubcityRef.y + useCitySize);
                        }
                    }

                    if(checkCity) {

                        if(!checkCity.incomingUnits) {
                            checkCity.incomingUnits = [];
                        }

                        var xferItem = {
                            fromX: currentSubcityRef.x,
                            fromY: currentSubcityRef.y,
                            unit: unit
                        };

                        checkCity.incomingUnits.push(xferItem);

                        removeFromArray(currentGame.vehicles,unit);

                        var vdef = getVehicleDefByName(unit.def);

                        webAppCore.showToast({
                            message: unit.name + " moved to " + checkCity.name,
                            image: "images/" + vdef.indicator,
                            action: {
                                title: "Undo",
                                func: function() {
                                    removeFromArray(checkCity.incomingUnits,xferItem);
                                    currentGame.vehicles.push(unit);
                                }
                            }
                        });
                    } else {
                        console.log("found new city?!?!");
                    }
                }
            }
        }
    }

    function handleIncomingUnits() {
        if(!currentGame.isSubregion || !currentSubcityRef) {
            return;
        }

        var firstUnit = null;

        if(currentSubcityRef.incomingUnits && currentSubcityRef.incomingUnits.length > 0) {

            for(var i = 0; i < currentSubcityRef.incomingUnits.length; i++) {

                var incomingItem = currentSubcityRef.incomingUnits[i];

                var xDif = incomingItem.fromX - currentSubcityRef.x;
                var yDif = incomingItem.fromY - currentSubcityRef.y;

                var xTar = xDif * 50;
                var yTar = yDif * 50;

                var xAct = incomingItem.unit.x + xTar;
                var yAct = incomingItem.unit.y + yTar;

                var freshUnit = rebuildVehicleObject(incomingItem.unit);

                freshUnit.x = xAct;
                freshUnit.y = yAct;
                freshUnit.dX = xAct;
                freshUnit.dY = yAct;
                freshUnit.tX = xAct;
                freshUnit.tY = yAct;

                freshUnit.rdX = -1;
                freshUnit.rdY = -1;

                freshUnit.pX = null;
                freshUnit.pY = null;

                freshUnit.id = parseInt(currentGame.getId());
                freshUnit.owner = getRegionOrCity().localPlayerId;

                unstickUnit(freshUnit);

                currentGame.vehicles.push(freshUnit);

                if(!firstUnit) {
                    firstUnit = freshUnit;
                }

            }
        }

        if(firstUnit) {
            Scroll2d.centerOnCoord(firstUnit.x,firstUnit.y);
        }

        currentSubcityRef.incomingUnits = [];
    }

    function updateBuildingResidentialStats(building) {
        if(!building) {
            return;
        }

        if(building.bRC == 0) {
            setBuildingLandValue(building);
            return;
        }

        var continueChance,requiredIq,iqTryLimit,iqPercent,len,tries,jobChance,totalCommute;
        var totalResidents = building.bRC;

        var neededMedical = Math.round(totalResidents * DEF_POP_PERCENT_MEDICAL);
        var neededEntertainment = Math.ceil(totalResidents * DEF_POP_PERCENT_ENTERTAINMENT);
        var neededEducation = Math.ceil(totalResidents * DEF_POP_PERCENT_EDUCATION);

        var neededJobs = Math.ceil(totalResidents * currentWorkingAgePercentage);

        var gotMedical = 0;
        var gotEntertainment = 0;
        var gotEducation = 0;
        var gotJobs = 0;

        var killArray,i,cBld,nearbyBuildings;

        var totalIQprovided = 0;
        var totalSalaryEarned = 0;

        // medical
        if(neededMedical > 0) {
            nearbyBuildings = sortBuildingsByDistanceFromBuilding(openMedicalArray,building,DEF_MEDICAL_RANGE);

            killArray = [];
            

            for(i = 0, len = nearbyBuildings.length; i < len; i++) {
                cBld = nearbyBuildings[i].b;
                tries = neededMedical - gotMedical;

                if(tries > cBld.ocM) {
                    tries = cBld.ocM;
                }

                while(tries > 0 && gotMedical < neededMedical && cBld.ocM > 0) {
                    tries--;

                    if(len > 10 && i < 5) {
                        continueChance = randomIntFromInterval(0,5);

                        if(continueChance > 3) {
                            continue;
                        }
                    }

                    gotMedical++;
                    cBld.ocM--;
                    cBld.buM++;
                }

                if(cBld.ocM <= 0) {
                    killArray.push(cBld);
                }

                if(gotMedical >= neededMedical) {
                    break;
                }
            }

            while(killArray.length > 0) {
                removeFromArray(openMedicalArray,killArray.pop());
            }
        }

        // entertainment
        if(neededEntertainment > 0) {
            nearbyBuildings = sortBuildingsByDistanceFromBuilding(openVenuesArray,building,DEF_ENTERTAINMENT_RANGE);

            killArray = [];

            for(i = 0; i < nearbyBuildings.length; i++) {
                cBld = nearbyBuildings[i].b;
                tries = neededEntertainment - gotEntertainment;

                if(tries > cBld.ocE) {
                    tries = cBld.ocE;
                }

                while(tries > 0 && gotEntertainment < neededEntertainment && cBld.ocE > 0) {
                    tries--;

                    if(len > 10 && i < 5) {
                        continueChance = randomIntFromInterval(0,5);

                        if(continueChance > 3) {
                            continue;
                        }
                    }

                    gotEntertainment++;
                    cBld.ocE--;
                    cBld.buG++;
                }

                if(cBld.ocE <= 0) {
                    killArray.push(cBld);
                }

                if(gotEntertainment >= neededEntertainment) {
                    break;
                }
            }

            while(killArray.length > 0) {
                removeFromArray(openVenuesArray,killArray.pop());
            }
        }


        // education
        if(neededEducation > 0) {
            nearbyBuildings = sortBuildingsByDistanceFromBuilding(openSchoolsArray,building,DEF_SCHOOL_RANGE);

            killArray = [];

            for(i = 0, len = nearbyBuildings.length; i < len; i++) {
                cBld = nearbyBuildings[i].b;
                tries = neededEducation - gotEducation;

                if(tries > cBld.ocS) {
                    tries = cBld.ocS;
                }

                while(tries > 0 && gotEducation < neededEducation && cBld.ocS > 0) {
                    tries--;

                    if(len > 10 && i < 5) {
                        continueChance = randomIntFromInterval(0,5);

                        if(continueChance > 3) {
                            continue;
                        }
                    }

                    gotEducation++;
                    cBld.ocS--;
                    cBld.buS++;

                    if(cBld.md && cBld.md.pIQ) {
                        totalIQprovided += cBld.md.pIQ;
                    }
                }

                if(cBld.ocS <= 0) {
                    killArray.push(cBld);
                }

                if(gotEducation >= neededEducation) {
                    break;
                }
            }

            while(killArray.length > 0) {
                removeFromArray(openSchoolsArray,killArray.pop());
            }
        }

        

        building.brE = Math.ceil((gotEntertainment / neededEntertainment) * 100);
        if(building.brE > 100) {
            building.brE = 100;
        }

        if(isNaN(building.brE)) {
            building.brE = 0;
        }

        building.brM = Math.ceil((gotMedical / neededMedical) * 100);
        if(building.brM > 100) {
            building.brM = 100;
        }

        if(isNaN(building.brM)) {
            building.brM = 0;
        }

        building.brS = Math.ceil((gotEducation / neededEducation) * 100);
        if(building.brS > 100) {
            building.brS = 100;
        }

        if(isNaN(building.brS)) {
            building.brS = 0;
        }
        

        if(neededMedical == 0) {
            if(currentGame.historicStats.health && currentGame.historicStats.health.length > 0) {
                building.brM = currentGame.historicStats.health[currentGame.historicStats.health.length - 1];
            }

            if(building.brM == 0) {
                building.brM = 100;
            }
        }

        // overall building iq rating 
        var missingSchoole = neededEducation - gotEducation;
        totalIQprovided += (missingSchoole * 75); // give everyone a base iq of 75
        building.orIQ = Math.round(totalIQprovided / neededEducation);

        var thisSalary = 0;

        // update work stats
        nearbyBuildings = sortBuildingsByDistanceFromBuilding(openJobsArray,building,DEF_WORK_RANGE);

        killArray = [];
        
        totalCommute = 0;

        var buildingOccupationDef = null;

        for(i = 0, len = nearbyBuildings.length; i < len; i++) {
            cBld = nearbyBuildings[i].b;

            buildingOccupationDef = null;

            thisSalary = 1;

            if(currentGame.salaries.Unskilled != null) {
                thisSalary = currentGame.salaries.Unskilled;
            }

            if(cBld.md && cBld.md.occupation) {
                buildingOccupationDef = getOccupationDefByName(cBld.md.occupation);

                if(currentGame.salaries[cBld.md.occupation] != null) {
                    thisSalary = currentGame.salaries[cBld.md.occupation];
                } else {
                    thisSalary = buildingOccupationDef.salary;
                }
            }

            

            requiredIq = 75;
            tries = neededJobs - building.bER;

            if(tries > cBld.ocJ) {
                tries = cBld.ocJ;
            }

            if(cBld.md && cBld.md.rIQ) {
                requiredIq = cBld.md.rIQ;
            }

            while(tries > 0 && building.bER < neededJobs && cBld.ocJ > 0) {
                tries--;

                if(nearbyBuildings.length > 10 && i < 5) {
                    continueChance = randomIntFromInterval(0,5);

                    if(continueChance > 3) {
                        continue;
                    }
                }

                if(requiredIq > building.orIQ) {
                    iqPercent = building.orIQ / requiredIq;
                    iqTryLimit = Math.round(iqPercent * 100);
                    jobChance = randomIntFromInterval(0,100);

                    if(jobChance < iqTryLimit) {
                        continue;
                    }
                }

                

                totalCommute += nearbyBuildings[i].d;
                gotJobs++;
                cBld.ocJ--;
                cBld.buW++;
                building.bER++;
                totalSalaryEarned += thisSalary;

                if(cBld.md && cBld.md.occupation) {
                    if(!currentGame.currentOccupationStats[cBld.md.occupation]) {
                        currentGame.currentOccupationStats[cBld.md.occupation] = 0;
                    }

                    currentGame.currentOccupationStats[cBld.md.occupation]++;

                    
                }

                
            }

            if(cBld.ocJ <= 0) {
                killArray.push(cBld);
            }

            if(gotJobs >= neededJobs) {
                break;
            }
        }

        while(killArray.length > 0) {
            removeFromArray(openJobsArray,killArray.pop());
        }

        if(gotJobs > 0) {
            building.bAvC = Math.round(totalCommute / gotJobs);

            building.bsTS = totalSalaryEarned;
            building.bsAS = Math.round(totalSalaryEarned / gotJobs);
        } else {
            building.bAvC = 0;
        }

        var commutePercentage = Math.round((building.bAvC / DEF_WORK_RANGE) * 100);

        building.brCT = 100 - commutePercentage;

        if(building.brCT < 0) {
            building.brCT = 0;
        }

        if(building.brCT > 100) {
            building.brCT = 100;
        }

        // rough land value calculation for testing, make it better soon
        setBuildingLandValue(building);
    }

    function setBuildingLandValue(building) {

        

        var valueFactors = 0;
        var totalValue = 0;

        // building condition
        totalValue += building.condition;
        valueFactors++;

        // residential factors
        if(building.bRC > 0) {
            totalValue += building.brE;
            totalValue += building.brM;
            totalValue += building.brS;
            totalValue += building.brCT;

            valueFactors += 4;
        }

        // workplace factors 
        if(building.ocJ > 0 || building.buW > 0) {
            var availableJobs = building.ocJ + building.buW;
            var filledJobsRating = Math.round((building.buW / availableJobs) * 100);

            if(filledJobsRating > 100) {
                filledJobsRating = 100;
            }

            building.brWF = filledJobsRating;
            totalValue += building.brWF;
            valueFactors++;
        }

        // building accessability
        if(building.hOS) {
            totalValue += 100;
        }
        valueFactors++;

        // safety/crime
        totalValue += building.brSAF;
        valueFactors++;

        building.bRLV = Math.round((totalValue) / valueFactors);

        if(isNaN(building.bRLV)) {
            building.bRLV = 0;
        }

        if(building.bRLV < 0) {
            building.bRLV = 0;
        }

        if(building.bRLV > 100) {
            building.bRLV = 100;
        }


    }

    function selectDisplayMode() {
        var displayOptions = [];

        displayOptions.push({
            title: getString("gen-default"),
            tag: "0"
        });

        displayOptions.push({
            title: getString("disp-trans"),
            tag: "1"
        });

        displayOptions.push({
            title: getString("disp-bld-colors"),
            tag: "2"
        });

        displayOptions.push({
            title: getString("disp-ent-coverage"),
            tag: "3"
        });

        displayOptions.push({
            title: getString("disp-med-coverage"),
            tag: "4"
        });

        displayOptions.push({
            title: getString("disp-edu-coverage"),
            tag: "5"
        });

        displayOptions.push({
            title: getString("disp-cri-coverage"),
            tag: "6"
        });

        displayOptions.push({
            title: getString("disp-lnv-coverage"),
            tag: "7"
        });

        displayOptions.push({
            title: getString("prod-cap-heatmap"),
            tag: "8"
        });

        showList(getString("select-disp-mode"),displayOptions,onDisplayModeSelected,getString("general-nevermind"));
    }

    function onDisplayModeSelected(tag) {
        staticFrame = false;
        Scroll2d.forceSceneChange();

        if(!tag || isNaN(tag)) {
            transparencyMode = 0;
            return;
        }

        transparencyMode = parseInt(tag);

        if(transparencyMode < 0 || transparencyMode > 8) {
            transparencyMode = 0;
        }
    }

    function createNewPerson(age,count,useGame) {
        if(age == null || age == undefined || isNaN(age)) {
            age = randomIntFromInterval(DEF_ADULT_AGE,360);
        }

        if(!count) {
            count = 1;
        }

        if(!useGame) {
            useGame = currentGame;
        }

        if(!useGame.populationDistribution) {
            useGame.populationDistribution = {};
        }

        if(!useGame.populationDistribution[age]) {
            useGame.populationDistribution[age] = 0;
        }

        useGame.populationDistribution[age] += count;
    }

    function touristAndEntertainmentIncomePhase(building,def) {
        if(!building || !def) {
            return 0;
        }

        if(!def.entertains && !def.takesTourists) {
            return 0;
        }

        var touristIncome = building.buT * def.entertainmentCost;
        var patronIncome = building.buG * def.entertainmentCost;
        var totalIncome = touristIncome + patronIncome;

        currentGame.totalTourismIncome += touristIncome;
        currentGame.totalEntertainmentIncome += patronIncome;

        modifyResourceAmount(ColonyGame.meta.tenderResource,totalIncome,false,def.name);

        return totalIncome;
    }

    function ageAllColonists() {

        if(!currentGame.populationDistribution) {
            return;
        }

        var oldestAge = 0;

        var age,checkAge,ageDiff,survivors,survivePercent,ageSurvivors,femalePop,newBabies,roundOrCeil;

        for(age in currentGame.populationDistribution) {
            checkAge = parseInt(age);

            if(isNaN(checkAge)) {
                continue;
            }

            if(checkAge > oldestAge) {
                oldestAge = checkAge;
            }
        }

        var monthlyBirthRate = 0.0012;

        var totalPop = getTotalPopulation();
        
        var deaths = 0;
        var totalDeathAge = 0;
        var births = 0;
        
        var currentHealthLevel = 60;

        var totalAvailableMothers = 0;

        var accidentalDeathAge = currentHealthLevel / 3;

        var maxCeilChance = 30;
        var ageDeaths = 0;

        if(totalPop > 400) {
            maxCeilChance = 20;
        }

        if(totalPop > 1000) {
            maxCeilChance = 10;
        }

        if(totalPop > 5000) {
            maxCeilChance = 5;
        }

        if(totalPop > 10000) {
            maxCeilChance = 4;
        }

        if(totalPop > 20000) {
            maxCeilChance = 3;
        }

        if(totalPop > 30000) {
            maxCeilChance = 2;
        }

        if(currentGame.historicStats.health && currentGame.historicStats.health.length > 0) {
            currentHealthLevel = parseInt(currentGame.historicStats.health[currentGame.historicStats.health.length - 1]);
        }

        if(currentHealthLevel == 0 || isNaN(currentHealthLevel)) {
            if(currentGame.historicStats.health.length > 1) {
                currentHealthLevel = parseInt(currentGame.historicStats.health[currentGame.historicStats.health.length - 2]);
            }
        }

        if(totalPop < 100 && currentHealthLevel < 30) {
            currentHealthLevel = 30;
        }
        
        if(totalPop < 100) {
            if(currentHealthLevel < 65) {
                currentHealthLevel = 65;
            }
        }

        currentHealthLevel *= 12;

        for(age = oldestAge; age >= 0; age--) {

            ageDeaths = 0;

            if(!currentGame.populationDistribution[age]) {
                continue;
            }

            survivors = currentGame.populationDistribution[age];

            currentGame.populationDistribution[age] = 0;

            if(age > currentHealthLevel) {
                ageDiff = age - currentHealthLevel;
                ageDiff = Math.round(ageDiff / 2);

                survivePercent = 100 - ageDiff;

                if(survivePercent < 50 && age < 1020) {
                    survivePercent = 50;
                }

                
                if(survivePercent <= 0) {
                    ageDeaths += survivors;
                    continue;
                }
                

                // in super low health colonies, a chance for poor children to die
                if(currentHealthLevel < 25 && age < 60) {
                    survivePercent = Math.round(survivePercent / 2);
                }

                ageSurvivors = Math.round(survivors * (survivePercent / 100));

                ageDeaths += survivors - ageSurvivors;

                if(ageSurvivors > 0) {
                    survivors = ageSurvivors;
                }
            }

            // once a colony gets a bit larger, there is a slim natural death chance, accidents etc 
            if(totalPop > 500) {
                

                if(age > accidentalDeathAge) {
                    ageSurvivors = Math.round(survivors * 0.0005);

                    

                    if(ageSurvivors > 0) {
                        ageDeaths += ageSurvivors;
                        survivors = survivors - ageSurvivors;
                    }
                }

                // further death chance over the age of retirement 
                if(age > DEF_RETIREMENT_AGE) {
                    ageSurvivors = Math.round(survivors * 0.0005);

                    

                    if(ageSurvivors > 0) {
                        ageDeaths += ageSurvivors;
                        survivors = survivors - ageSurvivors;
                    }
                }
            }

            if(survivors > 0) {
                currentGame.populationDistribution[age + 1] = survivors;

                if(age >= 192 && age <= 540 && totalPop >= 50) {
                    if(totalPop > 250) {
                        femalePop = Math.round(survivors / 2);
                    } else {
                        femalePop = Math.floor(survivors / 2);
                    }
                    
                    totalAvailableMothers += femalePop;

                    if(femalePop > 0) {
                        roundOrCeil = randomIntFromInterval(0,maxCeilChance);

                        if(roundOrCeil == 1) {
                            newBabies = Math.ceil(femalePop * monthlyBirthRate);
                        } else {
                            newBabies = Math.round(femalePop * monthlyBirthRate);
                        }
                        
                        if(newBabies > 0) {
                            births += parseInt(newBabies);
                        }
                    }
                }
            }

            totalDeathAge += (ageDeaths * age);
            deaths += ageDeaths;
        }



        currentGame.totalDeaths += deaths;
        currentGame.totalBirths += births;

        var averageDeathAge = Math.round(totalDeathAge / deaths);

        if(isNaN(averageDeathAge)) {
            averageDeathAge = 0;
        }

        console.log("life expectancy: " + averageDeathAge);

        if(births > 0) {
            createNewPerson(0,births);

            addItemToNewsTicker(numberWithCommas(births) + " babies were born in " + currentGame.name + " this month!","#4FC3F7",function() {
                showColonistsMenu("population");
            },true,1,true);
        }

        if(deaths > 0) {
            addItemToNewsTicker(numberWithCommas(deaths) + " people died in " + currentGame.name + " this month.","#e53935",function() {
                showColonistsMenu("population");
            },true,1,true);
        }
    }

    function handleSpaceportTourismStats(building) {

        if(building.bTA == 0) {
            return;
        }

        var touristsToHandle = 0;
        var touristsHandled = 0;

        if(building.embassyFor == 0 && building.hOS && !building.iuc && !building.deactivated && !building.lowPowerMode) {
            touristsToHandle = building.bTA;
        }

        var nearbyBuildings = sortBuildingsByDistanceFromBuilding(openTourismArray,building,DEF_TOURISM_RANGE);


        var tVenue,killArray;

        killArray = [];

        for(var i = 0, len = nearbyBuildings.length; i < len; i++) {
            tVenue = nearbyBuildings[i].b;


            while(tVenue.ocT > 0 && touristsToHandle > 0) {
                tVenue.buT++;
                tVenue.ocT--;
                touristsToHandle--;
                touristsHandled++;
            }

            if(tVenue.ocT <= 0) {
                killArray.push(tVenue);
            }

            if(touristsToHandle <= 0) {
                break;
            }
        }

        while(killArray.length > 0) {
            removeFromArray(openTourismArray,killArray.pop());
        }



        var unhandledTourists = building.bTA - touristsHandled;

        if(unhandledTourists > 0) {
            building.bTA -= unhandledTourists;
            //currentGame.currentGame.touristCount -= unhandledTourists;

            
        }
    }

    function handleGlobalNewsMessage(message) {
        if(!message || !message.data || !message.data.code) {
            return;
        }

        console.log("GLOBAL NEWS MESSAGE");
        console.log(message);

        if(message.data.code == "newcolony") {
            var platformData = getNameAndColorByPlatformCode(message.data.platformcode);

            var sectorInfo = "";

            if(message.sectorX != undefined) {
                sectorInfo = " in sector " + message.sectorX + ":" + message.sectorY;
            }

            var alertMessage = "The colony of " + message.senderName + " has been founded" + sectorInfo + ".";

            addItemToNewsTicker(alertMessage,platformData.color,function() {
                postSecuredCallToApi([{
                    "key":      "c",
                    "value":    message.sendercharter
                }],25,launchLocalColonyInfoScreen);
            },true,1,true);
        }
    }
})();