(function(window, document){
    window.appStrings = {
        "en": {
            "app_name":    		        "My Colony",
            "new-game-message":         "Commander - we have just landed and are ready to start a new colony.  What should we name it?",
            "welcome-message":          "Welcome!  You have founded a new colony with a colonial charter from #motherland.  Your goal is to turn this dead planet into a thriving civilization.  To get started, select your Rover and order it to begin harvesting.  Once you have collected at least 5 Ore, select your Lander and construct a second Rover.",
            "rover-description":        "The rover is the basic work robot for the colony.  It can mine minerals and build basic structures.",
            "lander-description":       "You landed here in it.",
            "mine-description":         "Extract raw Ore from the ground.  Use your rovers to harvest the ore.",
            "pavement-description":     "Makes the colony look nicer.  Speeds up travel of wheeled vehicles.",
            "greenhouse-description":   "A basic structure for growing food for the colony.",
            "silo-description":         "Stores vital food needed for the colony.",
            "atmosgen-description":     "A small building that slowly generates trace amounts of atmosphere, to begin terraforming your planet.",
            "factory-description":      "A small factory that can product several mid sized vehicles.  Also slowly generates very minor amounts of atmosphere and Wheels.",
            "builder-description":      "This amazing little robot will help start building up your colony!",
            "beta-info":                "My Colony is a new colony building simulation and strategy game currently in the very early beta stages.  Currently there is not much point to the game, but please play around with it and then head to the forum community with feedback and suggestions on things I can add to make this a fully functional colonization game!",
            "lander-sell-warning":      "I'm not trying to tell you how to play the game here, but it's generally not a good idea to sell the lander until you are confident you no longer need it.  It is the only way to harvest ore at the beginning, and you cannot build another one!  Are you sure you want to sell?",
            "refinery-description":     "A facility that converts raw Ore into refined Steel which is needed to advanced construction projects.  Requires workers to operate.",
            "miner-description":        "This bot can harvest surface ore and transport it to a refinery.  It can also dig a new ore mine.",
            "small-panel-description":  "Generates a modest amount of electricity for the colony with no additional input needed.",
            "landing-pad-description":  "Once you build a landing pad, new colonists will periodically begin to arrive at your colony.",
            "small-shelter-description":"Basic colonist housing.  Provides shelter for 3 colonists.",
            "chop-shop-description":    "Takes old, unused Rovers and breaks them down into raw materials.",
            "goldminer-description":    "Extracts Gold from deposits and transports it back to a Gold Refinery.",
            "goldrefinery-description": "Converts rough gold extracted from the ground into pure gold.",
            "goldsmelter-description":  "Converts refined gold into cold hard cash.",
            "hire-button-change-job":   "Change Job",
            "hire-button-hire":         "Hire",
            "object-sell":              "Sell",
            "object-remove":            "Remove",
            "side-menu-game-data":      "Game Data",
            "delete-game-confirm":      "Are you sure you want to delete your colony?",
            "header-delete-colony":     "Delete Colony",
            "tax-window-header":        "#motherland Tax",
            "tax-window-content":       "The #motherland General Assembly is pleased to inform you that your successful colony owes tax to the people of #motherland.",
            "tax-window-owed-header":   "Tax Owed: ",
            "tax-window-pay":           "Pay",
            "tax-window-reject":        "Reject",
            "tax-window-pay-response":  "The people of #motherland thank you for your contribution to society.",
            "tax-window-reject-response": "The #motherland General Assembly would like to remind you that compliance with the law is mandatory.  We will revisit this later.",
            "adv-hydro-desc":           "Unlock advanced techniques for growing food hydroponically.",
            "hd-solar-desc":            "Upgraded solar panel technology that can generate more power over the same surface area.",
            "smalllab-description":     "Assemble a small team to conduct awesome experiments and unlock new technologies!",
            "advancedhydro-description":"High tech facility for growing large amounts of food.  Requires workers to operate.",
            "solar-tower-description":  "A tower with high density solar cells.  Provides a good amount of power with a minimal footprint.",
            "adv-ore-pur-desc":         "Discover advanced methods for refining raw Ore into solid steel.",
            "builder2-description":     "An upgraded builder bot for creating more advanced structures.",
            "construction-2-desc":      "Unlock advanced building methods for creating new structures and vehicles.",
            "pavement2-description":    "Extra hard pavement, hardened with steel.  Expensive, but allows for very fast vehicle travel.",
            "silo2-description":        "Large food storage silo that holds a lot of food for your colonists.",
            "finance-theory-desc":      "Research the theories and methods behind money and finance as it applies to space colonies.",
            "refinery2-description":    "Convert Ore into Steel faster and with nearly 5 times the efficiency as a regular Ore Refinery.  Requires workers to produce.",
            "adv-gold-desc":            "Allows the construction and digging of new gold mines.",
            "goldmine-description":     "Dig a new gold mine for extracting rough Gold resource from the ground.",
            "rescomplex-description":   "Provides medium sized housing for 26 colonists.",
            "greendome-description":    "A Green Dome provides free recreation and entertainment for your colonists, so they don't go crazy.",
            "massdriver-description":   "An advanced high-energy electromagnetic catapult that allows you to launch raw goods back to #motherland in exchange for money.  Requires workers, and also generates a small amount of money on its own.",
            "lg-manufacturing-desc":    "Unlock the ability to manufacture consumer goods in the harsh environments of your colony.",
            "chipfactory-description":  "The microchip factory employs 26 workers and converts raw Gold into Microchips.",
            "tax-payment-thankyou":     "#motherland thanks you for your obedience.",
            "tax-payment-insufficient": "Your tax payment to the #motherland General Assembly is insufficient.  The points on your balance are accruing.",
            "stage-1-intro":            "Planetary atmosphere is now thick enough to support basic microbial life!",
            "stage-2-intro":            "As the planetary atmosphere grows, small plants begin to sprout from the soil.",
            "stage-3-intro":            "Atmosphere levels are now similar to those on earth, allowing regular outdoor activity!",
            "col-civics-desc":          "Begin to form a colonial government, build civic structures, and enact laws for your people!",
            "atmosgen2-description":    "A more efficient and high powered atmosphere generator.",
            "civiccenter-description":  "Start building up your colonial governance with the civic center.  Costs money and requires workers to operate.  Generates Civic resource.",
            "statue1-description":      "Dedicated to the brave colonists who first stepped foot on this world.",
            "fracking-description":     "A high-tech high-energy method for extracting Ore out of the ground, without the need for an Ore Miner.  Requires workers and power.",
            "adv-chem-desc":            "Discover the secrets of turning things into other things through the science of Chemistry.",
            "gldsynth-description":     "A small science lab that can convert raw Ore into raw Gold!  Requires workers and a lot of energy.",
            "la-zoology-desc":          "Begin early development in raising wildlife in low atmospheric conditions.",
            "hatchery-description":     "Cultivate delicious fish for colonist consumption.  Les Poissons!",
            "icechipper-description":   "A small yet nimble rover that can harvest ice deposits and return water resource to the colony.",
            "waterbot-description":     "A small yet nimble rover that can harvest ice and water deposits and return water resource to the colony.",
            "atmoscondensor-description":"Extract atmosphere from the air and condense it into pure drinkable water.",
            "pet-expansion-desc":       "Purchase a colonial land grant from the #motherland General Assembly to expand your colony.",
            "pet-annex-desc":           "Expand your colonial territory without the consent of the #motherland General Assembly.  May trigger a hostile response.",
            "smalltank-description":    "Store and disburse fresh water to your colonists.",
            "waterpump-description":    "Pump and filter small amounts of fresh water from under the planet surface.",
            "aluminumrefinery-description":"Construct Aluminum Miners and harvest raw aluminum deposits.",
            "watertower-description":   "Store larger amounts of water to keep your colonists thirst well satisfied.",
            "adv-microbio-desc":        "Study the secrets of growing living organisms in a low atmospheric environment.",
            "new-game":                 "New Game",
            "new-game-col-name":        "Colony Name",
            "custom-map-name":          "Map Name",
            "map-size-header":          "Map Size",
            "map-size-small":           "Small",
            "map-size-medium":          "Medium",
            "map-size-large":           "Large",
            "resources-header":         "Resources",
            "resources-scarce":         "Scarce",
            "resources-normal":         "Normal",
            "resources-abundant":       "Abundant",
            "nuke-physics-desc":        "Learn how to harvest and refine Uranium for nuclear power in a low atmosphere environment.",
            "uraniumminer-description": "Harvest Uranium deposits and transport the radioactive materials to a Nuclear Power Plant.",
            "nuclearplant-description": "Convert and refine raw Uranium into electricity for your colony.",
            "bacteriafarm-description": "Start breeding microbial life forms which generate atmosphere for the colony.",
            "greenbot-description":     "A handy little builder that can construct agricultural related structures.",
            "firtrees-description":     "These noble fir trees grow fine in low atmosphere environments.  They can be decorative, or can be harvested for wood.",
            "engine-keyboard":          "Keyboard Controls",
            "engine-keyboard-meta":     "Customize keyboard shortcuts for the game.",
            "general-cancel":           "Cancel",
            "keyboard-clear-menus":     "Clear Active Dialogs",
            "keyboard-idle-unit":       "Find Idle Vehicle",
            "keyboard-sell-noconf":     "Sell Building Without Confirmation",
            "hold-and-click-tip":       "Hold key combination and select building.",
            "keyboard-upgrade-noconf":  "Upgrade Building Without Confirmation",
            "when-object-selected":     "Active when object is selected",
            "keyboard-move-unit":       "Move Active Unit",
            "keyboard-harvest-mode":    "Activate Harvest Mode",
            "keyboard-show-build":      "Show Build Options",
            "keyboard-show-export":     "Show Export Options",
            "keyboard-show-import":     "Show Import Options",
            "keyboard-sell":            "Sell Active Object",
            "keyboard-upgrade":         "Upgrade Active Object",
            "keyboard-defaults":        "Restore Defaults",
            "keyboard-defaults-warn":   "Will clear all custom bindings!",
            "keyboard-cancel-nocon":    "Cancel Construction Without Confirmation",
            "keyboard-cancel":          "Cancel Construction",
            "general-move":             "Move",
            "general-harvest":          "Harvest",
            "general-build":            "Build",
            "general-upgrade":          "Upgrade",
            "general-import":           "Import",
            "general-export":           "Export",
            "general-dismiss":          "Dismiss",
            "medicalclinic-description":"Provides colonists with health restoration services.",
            "general-park-unit":        "Park",
            "general-park-confirm":     "Parking Spot Designated",
            "engine-sidebar":           "Sidebar Interface",
            "tax-window-trade-embargo": "For continued failure to pay tax to the people of the #motherland, the #motherland General Assembly is imposing a trade embargo against your colony!",
            "tax-window-lift-embargo":  "The #motherland General Assembly has graciously lifted the trade embargo against your colony.",
            "tax-window-img-embargo":   "Due to deteriorating relations between your colony and the people of #motherland, the #motherland General Assembly is imposing a full immigration freeze against your colony!",
            "tax-window-img-lift":      "The #motherland General Assembly has tentatively restored immigration to your colony.",
            "wall-description":         "Wall off areas for decoration or to organize your colony and guide bot traffic.",
            "lumbermill-description":   "Process trees into the Wood resource.",
            "lumberbot-description":    "This handy harvester can both cut down trees and plant new ones!",
            "sfhouse-description":      "Grab the wife and kids and move on in to this nostalgic wooden single family home!",
            "megabot-description":      "A hardy builder for taking on large scale constructions projects.",
            "urenrich-description":     "Representing an awesome feat of engineering and science, this facility can double the potency of Uranium.  Requires a lot of power and a steady stream of Aluminum.",
            "lgwatertower-description": "A giant water tower that holds tons of water.  What more can be said?",
            "largeres-description":     "High density housing structure.  Not the most luxurious living, but cheaply houses a lot of people.",
            "indepence-noafford":       "You cannot afford independence from #motherland.",
            "independence-general":     "Independence",
            "general-united-earth":     "United Earth",
            "relations-header":         "#motherland Relations",
            "foundation-header":        "Founded",
            "foundation-charter":       "By colonial charter from #motherland on",
            "independence-ask":         "Do you wish to declare independence from #motherland for #cost?",
            "general-nevermind":        "Nevermind",
            "independence-declare":     "Declare",
            "independence-final":       "We have declared our independence from #motherland on #independenceday!",
            "independence-stat":        "From #motherland on",
            "selfgov-desc":             "Learn methods and procedures for running a self sustaining independent government.",
            "capitol-description":      "Build a big glorious capitol building for your new independent state!",
            "subtfood-description":     "A deep climate controlled subterranean facility for storing large amounts of food.",
            "empire-general":           "Commonwealth",
            "engine-zoom-buttons":      "Show Zoom Buttons",
            "lgcons-desc":              "Unlock the secrets of building things really big in a low gravity environment!",
            "treefarm-description":		"Raise trees and harvest them for lumber.",
            "aluminumminer-description":"A hardy and friendly bot that will harvest aluminum deposits.",
            "new-game-charter":         "Colonial Charter Code (optional)",
            "charter-warning":          "Starting a new game with a colonial charter will import some user generated game data that may not have been screened by Ape Apps.  This could include potentially offensive language.  Are you sure you want to start a new game with this charter?",
            "general-charter":          "Colonial Charter",
            "general-yes":              "Yes",
            "general-no":               "No",
            "charter-info":             "You may share your colonial charter id with friends and let them start a new game on their device using your charter.  You will collect income from the taxes they pay, and you may trade resources with players operating under your colonial charter.  Your charter id is #charterid",
            "charter-share":            "Play My Colony with charter id: #charterid #appurl",
            "general-share":            "Share",
            "charter-settings-desc":    "Distribute your charter and grow your commonwealth!",
            "tax-collection-message":   "You have new tax receipts from your chartered colonies!",
            "bank-description":         "A Bank, where your people go to store and manage their money.  Generates Money and Civics.",
            "gdp-general":              "Gross Domestic Product",
            "gdp-description":          "The total size of your economy.",
            "general-trade":            "Trade",
            "general-buy":              "Buy",
            "general-sell":             "Sell",
            "no-contracts":             "There are currently no contracts available for sale!",
            "select-resource":          "Select Resource",
            "available-contracts":      "Available Contracts",
            "multiples-notice":         "Must be multiple of 100.",
            "sell-amount":              "Amount to sell:",
            "buy-amount":               "Amount to buy:",
            "sell-price":               "Price per 100:",
            "boardoftrade-description": "Buy and sell resources on the intergalactic market!  Requires an internet connection.",
            "lrc-desc":                 "Unlock the ability to conduct real time interplanetary communications.",
            "galcom-desc":              "Expand your colony by unlocking economic opportunities from across the galaxy!",
            "pyramideye-description":   "This mystic megastructure can provide cheap entertainment and happiness for hundreds of colonists.  In thousands of years, archaeologists will uncover it and wonder what it was for.  A Tomb for kings and gods?  An ancient alien power plant?  Nope, just a neat looking tourist trap.",
            "stage-4-intro":            "Your people are beginning to complain about the buildup of smog in the air.",
            "general-multiple":         "Multiple Units",
            "deepexc-desc":             "Learn how to dig really, really deep holes in the ground.",
            "digsite-description":      "What secrets does this planet hold?  Dig a giant hole in the ground and find out!",
            "colonial-website":         "Colonial Website",
            "rename-colony":            "Rename Colony",
            "rename-desc":              "Did you pick a stupid name for your colony?  Pick a new one!",
            "aal-desc":                 "Once you unlock the secrets contained in Ancient Alien Artifacts, you will be able to harness their awesome unholy powers!",
            "aluminumgenerator-description":"The Ancient Aliens on this world discovered the secret method of turning Steel into Aluminum!  Expensive and requires a ton of power.  Also requires a steady stream of water to prevent overheating.",
            "etbuilder-description":    "A highly advanced builder bot, created using decoded Ancient Alien instructions.  Nobody knows how it works, but it does.",
            "giorgioinstitute-description":"You have to ask yourself - is it possible that this research institution provides storage for Alien Artifacts, and outputs the Research resource?",
            "cloud-save":               "Cloud Sync",
            "cloud-save-description":   "When signed in to your account, you can choose to sync your save file to the cloud.  It is a handy feature if you play on multiple devices, but uses data and has been known to cause save errors and data corruption on slower internet connections, such as mobile.",
            "consulate-description":    "The consulate is the hub which connects your colony to #motherland.  It is where you can manage all business related to your membership in the commonwealth.",
            "new-game-random-charter":  "Random Charter",
            "general-delete":           "Delete",
            "distillery-description":   "Converts food and water into Rum!  Rum makes people happy.",
            "brewing-desc":             "Learn how to produce Rum in a low gravity environment.",
            "rumcellar-description":    "A small climate controlled cellar for storing valuable Rum.",
            "general-approval":         "Approval Rating",
            "relaybooth-description":   "Provides free entertainment by letting colonists access a direct internet line back to #motherland so they can watch cat videos.  Also raises IQ, allowing colonists to take better jobs.",
            "general-policy":           "Policy",
            "general-payroll":          "Payroll",
            "payroll-notice":           "It is time to pay your workers.  Total payroll costs for this period are #payrollcost.",
            "payroll-motherland":       "Because you are a part of the Commonwealth of #motherland, #motherland will be billed #motheroffset for their portion of the payroll costs.",
            "payroll-reject":           "You have decided not to pay your workers!",
            "payroll-insufficient":     "You did not have enough money to pay everybody.  Some workers had to go hungry.",
            "payroll-motherland-collect":"Payroll assistance from #motherland.",
            "saving-dont-quit":         "Please do not quit the game until saving is complete!",
            "tax-pay":                  "Pay",
            "general-sound-xf":         "Sound Effects",
            "pub-description":          "Turn Rum into happiness!  For a modest fee, colonists can stop in at the pub and take their minds off of their daily troubles.",
            "general-destruct":         "Self Destruct",
            "general-labor":            "Labor",
            "labor-desc":               "Manage salaries for different occupations",
            "general-contine":          "Continue Playing",
            "general-new":              "New Colony",
            "general-load":             "Load Colony",
            "general-options":          "More Options",
            "general-execute":          "Execute",
            "execute-confirm":          "Are you sure you want to kill and take all money from #colonist?  Your people may frown on this behavior.",
            "general-destroy":          "Destroy",
            "decfirtrees-description":  "Why plant raw natural Fir Trees when you can plant nice trimmed decorative ones that are off-limits to your harvesters?",
            "cloning-desc":             "In the future, humans in space just don't breed like they used to.  That's where human cloning comes in handy.",
            "cloningfacility-description":"A high tech industrial facility for growing new colonists in a laboratory environment.",
            "claymine-description":     "When you have enough atmosphere, you can start working the soil with water to create and mine Clay for use in fine pottery.",
            "clayprod-desc":            "Use Chemistry, Hydroponics, and Microbiology to learn how to produce clay from the planets barren soil.",
            "general-activate":         "Activate",
            "general-deactivate":       "Deactivate",
            "general-activate-all":     "Activate All",
            "general-deactivate-all":   "Deactivate All",
            "claybot-description":      "A fun spirited rover designed for digging and harvesting Clay.",
            "potteryworks-description": "Refines Clay and converts it into fine pottery.  Requires a steady flow of Water to operate.",
            "warehouse-description":    "Provides extra storage for a range of durable and manufactured goods.",
            "subhousing-description":   "Some people just like to live underground.  This large subterranean complex can house many residents in a controlled environment.",
            "chipfactory2-description": "A larger and more efficient version of the Microchip Factory.  Faster production and more storage.",
            "chipfactory3-description": "An advanced factory built using ancient alien tech that can produce high numbers of Microchips.  Requires a steady stream of water to keep cool.  Uses Alien Artifacts during production.",
            "aam-desc":                 "Discover the ancient secrets that were used in manufacturing on this world millions of years ago.",
            "masonry-desc":             "Learn how to create solid Bricks from Clay in a low gravity environment.",
            "brickroad-description":    "Faster than normal pavement, a Brick Road is a nice way to spruce up your colony.",
            "brickfactory-description": "Convert Clay into solid Bricks to unlock additional construction options.  Requires a steady stream of Water to operate.",
            "ybrickroad-description":   "The ultimate in colonial style and class.  Let your colonists follow the yellow brick road to glory!",
            "warehouse2-description":   "This lovely warehouse built out of brick makes the perfect addition to any industrial based colony.",
            "brickhouse-description":   "You would have to be a fool not to want to live in this lovely brick home.",
            "husbandry-desc":           "Learn how to breed and raise large animals in a low gravity environment.",
            "sheepfarm-description":    "Breed and raise sheep for the production of Wool!  Requires a steady stream of water.",
            "textilemill-description":  "Convert raw Wool into durable Cloth, a fine item that your colonists will just love.",
            "sweatshop-description":    "Come work at the place where profits live and dreams die!  Workers at this clothing sweatshop will convert Cloth into raw profits under conditions of low pay and no benefits!",
            "luxtower-description":     "Where the high and mighty of society go to live, work, and play.  You must keep the Rum flowing to give these elites sustenance.",
            "aliencondensor-description":"The ancients on this world knew how to turn a lot of atmosphere into water.  I mean, a lot.  Watch that it doesn't eat up too much of your atmosphere.",
            "cst-desc":                 "97% of colonial scientists believe that the planet is going to be destroyed by global warming.  Research ways to solve it.",
            "hydropower-description":   "This amazingly powerful power plant can convert Water into raw power!  Imagine all of the possibilities!",
            "largepark-description":    "A giant park, providing free public entertainment for your colonists.  Reminds people of being back on #motherland.",
            "waterpool-description":    "A perfectly square shallow pool of water to make your colony look pretty.",
            "lol-description":          "Let the galaxy know that your colony is accepting their tired poor huddled masses with the Lander of Liberty!",
            "human-description":        "The dominant species from Earth.  If you are playing this game, you probably know what a human is.",
            "red-planet-desc":          "Your typical dead planet.  May have supported life millions of years ago, but there's nothing here now.  Diverse set of resources.",
            "ue-description":           "The proud planet of Earth is home to the Human species, governed by the United Earth General Assembly.  Although formed under the pretense of promoting peace and stability, they now control the Solar System with an iron fist.",
            "premium-notice":           "My Colony is free, but extra content and features are available to players who have supported the game financially.  There are #premiumcount unique structures and vehicles available only to users who have purchased the ad-free version of the game.  Premium users also get to flip the orientation of most buildings, unlock the ability to customize their game using mods, can play Regional and Creative mode, and more.  More exclusive premium content will be added on a regular basis also.  Do you wish to upgrade to the premium ad-free experience?",
            "statue2-description":      "This statue is a symbol of power and authority, showing all that you have claimed dominion over these lands!",
            "flowersred-description":   "Spruce up your colony with this lovely red flower garden!",
            "goldenshelter-description":"The high and mighty in your colony can't bring themselves down to living in a standard small shelter.  No, they want a gold plated shelter.",
            "general-offers":           "Offers",
            "general-new-offer":        "New Offer",
            "hipsterbar-description":   "When you are ready for live music from a band you've never heard of, admission prices that will max out your dad's credit card, and rum that costs seven times more than it should, you're ready to hang out at the Hipster Bar!",
            "alienquantum-desc":        "The Ancient Aliens were masters of Quantum Physics.  Now you too can unlock the secrets and usher in a technological revolution!",
            "warehouse3-description":   "A quantum leap in durable goods storage technology!  Requires a ton of power and a steady stream of water, but can harness the power of quantum mechanics to store a ton of goods in a tight space.",
            "quantumwater-description": "Harness ancient alien quantum tech to store massive amounts of water in a small area.  Requires power, and also uses up some of the water to keep from overheating...  But yeah, the water is totally safe to drink.",
            "brickwall-description":    "It's kind of like the normal wall, except its made out of bricks, which makes it better somehow.",
            "largeclinic-description":  "A larger and more epic version of the Medical Clinic.  Heals more people.  Saves more lives!",
            "rpbase-desc":              "The base knowledge that comes from starting on a Red Planet map.",
            "hbase-desc":               "The base knowledge that comes from playing as the Human race.",
            "uebase-desc":              "The base knowledge that comes from the United Earth civilization.",
            "lunbase-desc":             "The base knowledge that comes from starting on a Lunar map.",
            "lunar-planet-desc":        "A lifeless moon world with no atmosphere and relatively low early-game resources.  A difficult world to start out on, but can pay off later.",
            "lunarrover-description":   "A small and happy rover designed for extracting Regolith and constructing small structures in a lunar environment.",
            "heltank-description":      "A small storage tank for keeping Helium 3.",
            "regpath-description":      "Create a nice gravel-like path for your rovers to drive around on.",
            "waterextract-description": "Crush raw Regolith down to extract small ice crystals used to make drinking water.  Requires a steady stream of Helium 3 to operate.",
            "regcompact-description":   "Mechanically compact raw Regolith down into material Ore.",
            "helextractor-description": "Extract trace amounts of Helium 3 from crushed Regolith.",
            "regmine-description":      "Dig a hole in the ground and start pulling Regolith out of it!",
            "fwbase-desc":              "The base knowledge that comes from starting on a Forest World map.",
            "forest-planet-desc":       "Prepare to micromanage.  A hard map with few early resources.  Lots of trees.  Don't play this map your first time.",
            "woodhut-description":      "A small wood shelter for two.  Not the most comfortable place to live, but is cheap and gets the job done.",
            "forestrover-description":  "Somehow, science has figured out how to make a mechanical moving rover completely out of wood.  Does it make sense?  Does it matter?  It's a game!",
            "waterwell-description":    "Dig a hole, get water out of it, and drink it.  Pretty simple, really.",
            "potatopatch-description":  "Sips a constant flow of water and produces yummy potatoes for your colonists to eat.  Who doesn't love potatoes?",
            "charcoalhut-description":  "Burns Wood to produce Charcoal.  From there, the sky's the limit!",
            "coalburn-description":     "Burns Charcoal to produce vital electricity for the colony.",
            "coalcompact-description":  "Crush charcoal down so tight that it becomes raw Ore that you can use to build neat things!",
            "advcp-desc":               "Learn more efficient ways to burn wood into Charcoal.",
            "charfactory-description":  "Bring the charcoal hut into the modern age with the Charcoal Factory!  Same concept as the hut, except way better.",
            "oilref-desc":              "Learn the secrets of extracting crude oil in a low gravity environment!  Let the black gold flow!",
            "mulchpath-description":    "Give your rovers something nice to drive on by building this fine path made out of mulched wood chips!",
            "oiltank-description":      "Just a big tank that holds crude oil.",
            "crudebot-description":     "This fun little robot knows how to get dirty, working out in the oil fields all day.",
            "flowerswhite-description": "A white flower garden will put a smile on your face.  Unless you hate flowers.",
            "flowersblue-description":  "Is there anything in this universe better than a blue flower garden?",
            "flowerspurple-description":"Ah, the purple flower garden.  A must-have in any self respecting colony.",
            "adv-chemsyn-desc":         "Take chemistry to the next level!  Start creating new compounds out of old ones on an industrial scale.",
            "oilplant-description":     "Burn oil to make electricity!  Generates a modest amount of atmosphere in the process.",
            "grass-description":        "A nice grass lawn for your colony.  Can be walked on or driven over.  Create your own custom refreshing greenspace!",
            "quantumfood-description":  "A quantum food storage container for keeping tons of food.  Requires constant input of water to keep from overheating.",
            "pavement5-description":    "Very fast pavement that your rovers can zoom over.  You may need to visit the Galactic Board of Trade to source all of the materials though.",
            "oilsynthlab-description":  "Use the power of science to create Oil by mixing Charcoal and Food.",
            "plastfact-description":    "A shiny new factory that converts your dirty old oil into clean new plastic!",
            "sweatshop2-description":   "Here you can turn plastic into fun kids toys, all while paying your workers slave wages!",
            "livingwage-header":        "Living Wage",
            "livingwage-desc":          "Set a basic income level that all colonists will receive (on top of their regular salary), regardless of employment.",
            "firedrill-header":         "Fire Drill",
            "firedrill-desc":           "Fire all colonists from their jobs and kick all residents out of their homes.  Resets labor and housing stats and forces everybody to relocate.",
            "work-policy":              "Work Policy",
            "work-policy-desc":         "Set the overall work policy for your colony.",
            "work-policy-normal":       "Normal",
            "work-policy-normal-desc":  "Regular work policy.  Colonist are free to live out their day as they see fit.",
            "work-policy-light":        "Light",
            "work-policy-light-desc":   "Reduce the work day, giving colonists more time for rest and relaxation.",
            "work-policy-hard":         "Overtime",
            "work-policy-hard-desc":    "Extend the work day and require overtime for all workers to boost output.",
            "work-policy-extreme":      "Extreme",
            "work-policy-extreme-desc": "When times are tough and you really need to boost output.  Many colonists will die on the job.",
            "general-go-back":          "Go Back",
            "general-go-back-desc":     "Return to the previous menu",
            "money-shower-header":      "Stimulus Package",
            "money-shower-desc":        "Problems with your colonists?  Just throw money at them to make the problems go away!  Distribute free money across the population.",
            "tax-collection-header":    "Tax Collections",
            "tax-collection-desc":      "When you need a little extra cash, use this policy to impose a one time tax on every colonist amounting to 25% of their savings.",
            "spaceport-description":    "The Space Port is the transport hub for inbound and outbound tourists to and from the colony.  There is also a small chance of unsanctioned immigration.  Consumes Civics during operation.",
            "coltour-desc":             "Unlock the secrets of attracting (and extracting money from) interplanetary tourists.",
            "motel-description":        "A cheap motel is the perfect place for tourists to come and rest their heads while visiting your colony!",
            "general-tourism":          "Tourism",
            "touress-desc":             "Discover improved methods for attracting and taking care of tourists visiting the colony.",
            "hotel-description":        "A nice big hotel for your tourists to stay in.  Requires a steady flow of Cloth, since tourists like to take their towels home with them.",
            "smcasino-description":     "Bring the great past-time of gambling to your colony with this lovely Small Casino!  Attracts tourists and colonists, and extracts money from their wallets.  Also generates money on its own.",
            "giftshop-description":     "Wondering what you are going to do with all of the pottery you made?  Wonder no longer!  Open this gift shop and sell it to the tourists!",
            "tourtrap-desc":            "Learn how to do tourism in a big way with Tourist Traps!  Start milking the galaxy for all it's worth.",
            "zoo-description":          "What self respecting colony is complete without a zoo?  Provides entertainment to colonists and tourists alike.  Requires a steady stream of pottery during operation.",
            "bluehouse-description":    "A great place for a young colonial to start a family.  This blue house will lead to a lifetime of memories.",
            "pavement6-description":    "Spruce up the landscape with this fancy checkered pavement.  It's no faster than normal pavement, but it looks nicer.",
            "flowersyellow-description":"You've got that sad empty tile sitting there.  What would look better than a yellow flower garden?  Nothing!  So build it!",
            "obelisk-description":      "A tall shiny golden obelisk celebrating the power and independence of your colony.",
            "restaurant-description":   "A small hole in the wall restaurant with a friendly atmosphere and outdoor seating provides tourists with an authentic taste of your colony!",
            "resort-description":       "A large luxury resort for entertaining lots of tourists.  Requires a steady input of cloth during operation.",
            "mall-description":         "Large outdoor shopping mall designed for sucking the money out of tourists and colonists alike!  Requires a lot of power and workers, and a steady stream of Cloth and Toys.",
            "general-private-charter":  "Charter Privacy",
            "general-private-desc":     "Decide if your colonial charter will be private or public.  If set to public, it will show up on the list of random charters when players start a new colony.",
            "general-private":          "Private",
            "general-public":           "Public",
            "map-size-mega":            "Mega",
            "map-size-xlarge":          "Extra Large",
            "large-map-warning-title":  "Large Map Warning",
            "large-map-warning-content":"Please be aware that game performance may suffer on large map sizes.  Are you sure you want to play a map this big?",
            "new-game-size-notice":     "Notice: Map size may impact game performance.",
            "online-mode":              "Online Mode",
            "online-mode-desc":         "Enable Online Mode on this colony.  Allows access to online trading, commonwealths, and gives your colony a website.  Your game will require an internet connection.",
            "offline-mode":             "Local Mode",
            "offline-mode-desc":        "Switch this colony into Local mode.  You will lose access to online trading, and any commonwealth colonies you have will gain independence.  Your game will no longer require an internet connection, but you will be able to conduct trades and exchange messages with other local games on your network.",
            "offline-mode-warning":     "Are you sure you want to switch to local mode?  Online features such as global market trading, commonwealths, and colonial website will be disabled.  Any colonies created under your charter will be granted independence.  This cannot be undone.",
            "general-notice":           "Notice",
            "blacklist-notice":         "Your colony has been suspended from online play for cheating.  As a single player game, cheating in My Colony is not discouraged and is left up to the individual player.  However, to preserve the integrity of the online in-game marketplace, games with hacked resource levels must not be permitted to play online.  Thank you for your understanding.",
            "museum-description":       "Increase the stature of your colony with this fine museum.  Attracts tourism and consumes pottery during operation.",
            "resources-report":         "Production and usage statistics for resources moving in and out of the colony.",
            "galfreight-description":   "The Galactic Freight yard can both import and export larger quantities of goods to and from the colony, via large shipping container with thrusters attached.  Requires oil during operation.",
            "statue3-description":      "The most expensive item in the game, this statue will show your colonists how rich and powerful you are, while they anguish in poverty and despair.",
            "udexc-desc":               "Harness alien power to dig a hole bigger than any hole that has ever been dug before.  Who knows what you might find?",
            "digsite2-description":     "An extreme dig site which goes down miles into the ground.  Produces a greater amount of Alien Artifacts.  Requires water to run, and produces some clay as a byproduct of operations.",
            "general-rename":           "Rename",
            "rename-colonist":          "Pick a new name for #colonist.",
            "keyboard-open-stats":      "Open Statistics Window",
            "keyboard-open-tech":       "Show Tech Tree",
            "keyboard-open-encyclopedia":"Open Encyclopedia",
            "keyboard-open-unemployment":"Show Unemployed Colonists",
            "keyboard-park":            "Park Unit",
            "keyboard-zoom-in":         "Zoom In",
            "keyboard-zoom-out":        "Zoom Out",
            "charcoalpile-description": "Reserve a plot of land for charcoal storage.  Then just throw it all into a big pile.",
            "alienpower-description":   "This insane power plant built with ancient alien technology converts Helium 3 into epic amounts of raw energy.",
            "autosave-freq":            "Autosave Frequency",
            "autosave-freq-desc":       "Choose how often the game autosaves.  Game performance is impacted during saves.",
            "autosave-freq-often":      "Often",
            "autosave-freq-normal":     "Normal",
            "autosave-freq-rare":       "Rarely",
            "autosave-freq-never":      "Never",
            "autosave-often-warn":      "Frequent saving may degrade game performance.",
            "autosave-never-warn":      "Remember to save your game manually to avoid data loss!",
            "general-send-custom-msg":  "Send Message",
            "general-send-msg-warn":    "You may send a message to another colony, 120 characters max.  Warning - sending an inappropriate, threatening, or harassing message is grounds for having your colony banned from the online server without appeal.",
            "game-compression":         "Game Save Compression",
            "game-compression-desc":    "Compression greatly reduces the size of your save game files, but makes saving and loading operations slower.  Turn off compression to increase save and load times.  You cannot use Cloud Sync if compression is disabled.",
            "colony-sharing":           "Colony Sharing",
            "colony-sharing-desc":      "Colonies using Cloud Sync can generate a share URL, allowing other My Colony players read-only access to view their game save.",
            "general-upgrade-all":      "Upgrade All",
            "general-ugall-desc":       "Are you sure you want to upgrade all?  This can be expensive and time consuming...",
            "pavement7-description":    "Ultra fast pavement made out of colorful toys!  How fun is that?",
            "mound-description":        "The essential breeding ground and food processing station of the Insectoids.",
            "waterbug-description":     "This little blue guy specializes in transporting water form various sources back to the nest.",
            "workerdrone-description":  "This sturdy little helper can harvest sugar for the colony and build basic structures.",
            "insectoid-description":    "The Insectoids evolved on the planet Bouwland.  They reproduce rapidly and consume all in their path.",
            "zolargprime-description":  "The mighty Zolarg Empire, located on Zolarg Prime, is an empire of Insectoid creatures that specialize in rapid resource consumption and reproduction.",
            "sugarland-desc":           "The Sugarland planet is a lush warm climate with an advanced atmosphere where sugar is all over the place.",
            "orebug-description":       "This large insectoid has strong mandibles for extracting raw Ore from nearby deposits.",
            "feastingarea-description": "The feasting area is where Insectoids gather to partake in food and entertainment.  Converts sugar to food, and provides storage for both.",
            "watervats-description":    "Insectoids just love to hang out at the Communal Water Vats and talk about life.  Stores Water and offers entertainment.",
            "pastetank-description":    "A crude facility that mixes Water, Sugar,and Insectoid saliva to form Ant Paste, a strong building compound.",
            "pastepath-description":    "This lovely trail made of crushed Ore and Ant Paste will feel great on your workers' feet!",
            "broodcenter-description":  "Here at the Brood Training Center, young Insectoids learn how to become adults, generating research along the way.",
            "zgoldstorage-desc":        "Learn how to harvest gold and dig fancy burrows in the ground for storage.",
            "goldbug-description":      "This nifty little critter is able to extract raw Gold from the ground.",
            "goldburrow-description":   "It's a neat little hole in the ground that your Goldbugs can use for making gold deposits.",
            "sugarpower-res-desc":      "Uncover the secrets of burning sugar to generate electricity.",
            "sugarpower-description":   "Burn sugar to generate electricity for the colony!",
            "communialfin-desc":        "Insectoids learn to pool their resources and generate commerce for the common good.",
            "insectoidmint-description":"Use the Insectoid Mint to melt Gold and form it into snazzy Insect Coins.",
            "backupOption":             "Backup Saves",
            "backupOptionDesc":         "Save a local uncompressed copy of your game files for added protection.  Takes up more storage space.",
            "sugarcult-desc":           "Learn how to plant sugar cane so that you can grow your own!",
            "antanium-prod-desc":       "Learn how to produce Antanium, a strong insectoid alloy used for building construction.",
            "antaniumsmelter-description":"Combine Ore and Gold into Antanium, a solid building material used to take any insectoid colony to the next level.",
            "eldersmound-description":  "An insectoid Elders Mound is where the council of insectoid elders meets to discuss things of insectoid importance.  Generates civics.",
            "miningoperation-description":"Insectoids work together to dig a giant hole and extract a steady stream of Ore and Gold from the ground.",
            "zolargstatue-description":	"A fine statue honoring Emperor Zolarg, the insectoid who founded the Zolarg Empire by leading the insectoid race in a rebellion against the ancients, long, long ago.",
            "foodfortification-description":"Enrich food and fortify it with Ant Paste, making it much more nutritious.  Can be an upgrade to the Feasting Area, but loses entertainment and Sugar storage benefits.",
            "solgov-desc":              "Unlock technologies to foster a growing presence in a solar commonwealth.",
            "capitol2-description":     "A growing colony requires a growing capitol.  This larger capitol building offers more civics generation, more bureaucracy, and allows you to send larger gifts to subcolonies.",
            "galgov-desc":              "Help grow and foster a galactic government with the Galactic Governance tech.",
            "capitol3-description":     "Show your dominance over your underlings with this large capitol building.  Offers more gifting, civics and glory for your empire, but requires a steady stream of Rum to keep your politicians happy.",
            "consulate2-description":   "An upgraded consulate building that allows greater trade with the motherland.",
            "consulate3-description":   "Create an even better consulate and further expand your trade with your parent colony.",
            "sand-description":         "Snazz up your colony with this lovely sand.",
            "capitol4-description":     "This large patriotic capitol building will make your citizens proud to be a part of your strong and vibrant nation.  Makes even more civics and allows even more colonial gifting.",
            "nationalism-desc":         "Begin promoting the nationalistic ideals of your people, fostering pride and loyalty to your growing nation.",
            "general-flip":             "Flip",
            "flag-description":         "Display the pride and power of your nation with this decorative flag.  Your people will love it!",
            "capitol5-description":     "This large menacing capitol building will let your people know without a doubt that you have finally turned to the dark side.  Even more civics generation and gifting abilities (and rum consumption).",
            "imperialism-desc":         "Sometimes it is not enough to be a simple nation, you must turn to the dark side and become an empire.",
            "insregen-desc":            "Discover the secrets of insect medicine and healing.",
            "healingpods-description":  "This is how insectoids heal themselves.  They bury their bodies in mud, wait a while, and then BAM - health!",
            "rationing-header":         "Rationing",
            "rationing-desc":           "When times are tough, you can impose food and water rations on your people.  They will be limited to 1/3 the normal amount of food and water consumption.  May cause sickness.",
            "general-native-client":    "Native Client",
            "native-client-description":"As a web browser based game, My Colony has no access to your filesystem, and is therefore unable to save your game data outside of the context of your web browser.  This causes a higher risk of potential data loss.  It is suggested (but not required) that you download the native client application, which is able to save your game data locally to your device.  Do you wish to see the download options?",
            "sugarfarm-description":    "Who likes going out into the wilderness looking for sugar?  Nobody.  Why not plant a Sugar Farm instead and make the sugar come to you!  Requires steady input of Water.",
            "general-annex-land":       "Annex Land",
            "general-annex-desc":       "Expand your colony by annexing the surrounding land through eminent domain.",
            "gentelbugs-description":   "When male insectoids tell their wives they are working late, they are actually spending coins and drinking rum here at the Gentelbugs Club.  Consumes rum, provides entertainment, and offers jobs to young insectoid history majors.",
            "lghe3-description":        "A nice large sized storage tank for holding large amounts of Helium 3.",
            "plaque-description":       "Place these lovely plaques by special places around your colony to mark special places and historical events.",
            "general-set-text":         "Set Text",
            "galimp-desc":              "Learn the secrets of running an (evil?) empire on a galactic scale.",
            "capitol6-description":     "This imperial capitol will show your glory and power to all people of the galaxy.  Unlocks tons of trade, while politicians sip up tons of Rum.",
            "tallconst-desc":           "When you start running out of land, you have to start building upward.  Tall Construction techniques allow you to build tall buildings in a low gravity environment.",
            "elevator-description":     "The Space Elevator allows for the import and export of goods, and also facilitates colonist immigration.  Requires a slight amount of fuel, but a large amount of electricity.",
            "advrobo-desc":             "Learn the secrets of advanced AI and Robotics, possibly ushering in the rise of the machines!",
            "condrone-description":     "This happy little drone loves to fly around and build things for you.",
            "robofactory-description":  "This high tech factory pumps out Robots and other robotic drone vehicles.  Requires a constant stream of Aluminum and Microchips.",
            "advdig-desc":              "Unlock new structures by learning how to dig deeper holes in the ground.",
            "wetmound-description":     "The concept is simple.  Keep digging until you find water, then build a little mound at the top and let Insectoids come up and take a drink.",
            "moneypit-description":     "Spread the wealth around your Insectoid colony.  Citizens place their extra money in the pit, or take some out when needed.  From each according to his ability...  Generates Money and Civics.",
            "exportcannon-description": "The Export Cannon is a low cost and effective way to sell goods back to #motherland.  Also generates a small amount of income.",
            "general-live-prices":      "Live Prices",
            "lumberyard-description":   "Ah, the lumber yard.  Stores Wood, employs real men, and generates income.  An all around great building.",
            "general-repair":           "Repair",
            "general-condemn":          "Condemn",
            "lottery-header":           "Lottery",
            "lottery-message":          "Sell lottery tickets to the people.  One colonist will have their life changed forever!",
            "lottery-instruction":      "How much money do you want to sell the lottery tickets for?  Remember, if you charge too much, the people will not buy tickets!",
            "lottery-fail":             "Sorry, nobody bought any lottery tickets!",
            "regolithextractor-description":"This heavy duty industrial operation can extract large quantities of Regolith from the ground, without the need to rebuild new mines.",
            "horrorhouse-description":  "If you've got the night off, why not take the kids or your special someone to this scary House of Horror?  Attracts guests and tourists, and everybody goes home with a toy!",
            "general-bad-trade-notice": "Your economic advisor wishes to inform you that he believes this trade to be a bad deal for our people.  They might not approve of you wasting money like this.  Are you sure you wish to make this trade?",
            "general-bad-trade-header": "Economic Advisor",
            "general-declare-ind":      "Declare Independence",
            "general-declare-ind-desc": "Sever your ties to #motherland and strike it out on your own.",
            "galfi-desc":               "Learn how to start earning serious money on a galactic scale!",
            "bank2-description":        "Employ hundreds of paper pushers in this high rise bank and watch them extract money from pockets all over the galaxy!",
            "restower-description":     "High rise living on the cheap.  Stack people in and watch your population boom.",
            "steelyard-description":    "This facility is used to store mass amounts of steel for later use.  Generates a trace amount of income during operations.",
            "subtcharcoal-description": "Why keep that expensive charcoal out in the open in the damp planet atmosphere when it could be nice and dry and in larger amounts.  Uses Helium 3 during operation.",
            "general-gift-giver":       "Galactic Emperor",
            "general-gift-message":     "The evil Galactic Emperor is pleased to announce that the Imperial Department of Propaganda is offering a free gift in exchange for a small bit of your time.  Do you want to watch a video in exchange for a gift?",
            "general-watch-gift-vid":   "Watch",
            "general-gift-not-watched": "The Emperor must remind you that you need to watch the entire video to be worthy of his grace.",
            "general-reward-complete":  "The Imperial Department of Propaganda thanks you for your service.",
            "general-ticker-warn-head": "Ticker Trades Warning",
            "general-ticker-warn-info": "Heads Up - Selecting a trade from the 'news' ticker will automatically make a purchase.  This will be your only warning.",
            "general-mass-message":     "Commonwealth Edict",
            "general-mass-msg-desc":    "Send a mass mailing to all members of your Commonwealth.",
            "zolargcomm-desc":          "Unlock the latest in Zolarg technology, allowing for intergalactic communications!",
            "altarofcommerce-description":"The Altar of Commerce is where insectoids go to worship the gods of intergalactic trade, and to make amazing trade deals.",
            "sugarcane-description":    "Plant and cultivate Sugarcane.  Yum.",
            "enc-resources-desc":       "Information on the various resources you can collect in the game.",
            "enc-tech-header":          "Technologies",
            "enc-tech-desc":            "Find out what all techs can be unlocked, and what their requirements are.",
            "general-buildings":        "Buildings",
            "enc-buildings-desc":       "Check out all structures in the game, along with their building requirements.",
            "general-vehicles":         "Vehicles",
            "enc-vehicles-desc":        "Show all vehicles and workers available to build, their building costs, and their capabilities.",
            "enc-online-header":        "Online Reference",
            "enc-online-desc":          "Interactive reference guide.",
            "regminer-description":     "This trusty rover will harvest Regolith mines and return the bounty to your base.",
            "owners-manual-header":     "Owners Manual",
            "owners-manual-short-desc": "Everything you need to know...",
            "enc-print-header":         "Print",
            "enc-print-desc":           "WARNING: 200+ pages long (depending on printer).  For true My Colony junkies, you can print the full in-depth owners manual for the game, containing everything you need to know about gameplay, backstory, mechanics, and a full reference of everything in the game.  Duplex printing is highly recommended.",
            "general-encyclopedia":     "Encyclopedia",
            "owners-manual-intro":      "The owners manual is still in it's early stages.  Eventually it will be pretty awesome, but it's just not there yet.  Take a look at it, print it if you wish.  And keep checking back with each update, because it's just going to keep getting better and better as time goes on.  Be sure to leave feedback and suggestions in the forum or app store comments to make the manual as good as it can be.  Enjoy!",
            "general-civs":             "Civilizations",
            "general-maps-available":   "Available Planet Types",
            "general-starting-techs":   "Starting Techs",
            "general-starting-building":"Starting Building",
            "general-pin-colony":       "Create Shortcut",
            "general-pin-description":  "Pin a quick link to your colony directly on your homescreen or desktop.",
            "general-autobudget":       "Auto Budget",
            "general-autobudget-desc":  "Automatically process payroll and tax payments without notification.  Only applies when you have enough funds to cover the payments.",
            "general-online-pay-assis": "Payroll Assistance",
            "online-payass-desc":       "Set the rate at which you assist your chartered colonies in their payroll obligations.  You can pay anywhere from zero to double or more.  It's up to you.  Enter a whole number as the assistance percentage, like 25 for 25%.",
            "sugarlandbase-desc":       "The basic techs that come with starting on a Sugarland map.",
            "insectoidbase-desc":       "The basic techs that come from starting as the Insectoid race.",
            "zolargbase-desc":          "The basic techs that come from starting under the Zolarg Empire civilization.",
            "zolgov-desc":              "Learn how to govern a colony, Insectoid style.",
            "highcommand-description":  "The High Command is the center of government in an Insectoid commonwealth.  Allows you to manage child colonies and set colonial policies.",
            "supplypile-description":   "Just a small lightly protected pile where you can store all kinds of goods and materials.",
            "commandpost-description":  "Set up a communications link with #motherland and enact basic policies for the colony.",
            "consulate5-description":   "When your commonwealth turns to the dark side, you had better follow suit.  This consulate unlocks more resource trade and also brings in tourism.",
            "smstadium-description":    "Help your people take their minds off of the day to day drudgery of your colony by entertaining them with this small stadium!  Also accepts tourists.",
            "xenomat-desc":             "Learn how to work and build with materials and compounds from other worlds.",
            "synthtext-description":    "If you can get your hands on the mysterious and precious resource known as Ant Paste, it can be used to make amazing quality Cloth.",
            "pol-salespitch-header":    "Commonwealth Info",
            "pol-salespitch-desc":      "In 100 characters or less, give players an overview of your Commonwealth and why they should join.  Will show up on the Random Charters selection when players start a new game.",
            "lis-description":          "The LIS is a loosely aligned group of human colonies which have been fighting for independence from United Earth for decades.",
            "lisbase-desc":             "The base starting techs for the League of Independent States.",
            "lislander-description":    "This old lander is held together with spit and toothpicks.",
            "lisrover-description":     "These old rovers were discontinued by United Earth years ago, but the League of Independent States still gets some good use out of them.  Can be used to harvest regolith and build basic structures.",
            "abandonedbase-desc":       "The base technologies available to players starting on the Abandoned World.",
            "abandonedworld-planet-desc":"A planet containing scattered remnants of a long gone civilization.",
            "statue4-description":      "An old relic left over from days past.",
            "medstadium-description":   "A good sized stadium for entertaining tourists and guests.  Consumes food and rum and increases the honor of your people!",
            "grass2-description":       "A fine low decorative grass to spruce things up a bit.",
            "sand2-description":        "Sometimes you just need some yellow sand in your colony.  Build it.",
            "sand3-description":        "The perfect cure for those situations when your colony needs some orange sand.",
            "mailbox-description":      "This nice decorative mailbox looks great in any colonial neighborhood.",
            "hoops-description":        "If there were kids in My Colony, they would love this decorative basketball hoop.",
            "oiltank2-description":     "When you are serious about oil storage, you need this quantum oil tank.  Stores tons of oil, requires power and water to operate.",
            "flag5-description":        "Show your pride for the League of Independent States with this lovely flag.",
            "greenhome-description":    "This Green House doesn't generate any food, but it houses 7 colonists and blends in great with the front yard.",
            "sweatshop3-description":   "If you need to feed a large colony, this is the sweatshop for you.  Your workers will slave away all day for low wages, using Sugar to create Food on an industrial scale.",
            "sweetnerfactory-description":"Use science and awesomeness to turn Oil into artificial Sugar!  Don't mind the metallic taste, that's just aluminum.",
            "oreenrichtech-desc":       "Learn to clean and purify rough Ore mined from the ground.",
            "oreenrichmentfacility-description":"Clean up and enrich your existing Ore, making even more Ore.",
            "goldsign-description":     "When you want to say something that will last the ages, write it on this Golden Sign.",
            "cactus-description":       "Your colony will look great with this decorative cactus!  Stores water also.",
            "cactus3-description":      "This little cactus doesn't store any water, but your people will love the look of it.",
            "palm-description":         "This lovely tree offers shade and occasionally produces food.  Can also be sold for its Wood content.",
            "dune-description":         "If your colony is in need of a Sand Dune, we've got you covered.",
            "deckchairs-description":   "Nothing says 'fun in the sun' or 'relaxation' quite like these decorative deck chairs.",
            "desertskull-description":  "No desert or sand area will ever be complete without a skull.",
            "fountain-description":     "Your colony will look great once you place a few of these fountains around your map.",
            "vertfarm-description":     "Go tall with this vertical farming operation.  Also provides food storage.",
            "new-charter-desc":         "Start a new colony under the colonial charter of another real-life player.  You may receive in-game assistance from parent colony.  Player species inherited from parent colony.",
            "new-charter-req-online":   "Requires an Ape Apps Account to play.",
            "woodharvesting-desc":      "Learn how to produce the Lumber Bug and start harvesting and cultivating wood.",
            "lumberbug-description":    "This little termite-type bug specializes in all things wood related.",
            "lumbercamp-description":   "The Lumber Camp is a basic insectoid facility for processing and storing Wood.",
            "powerspire-description":   "Utilize Wood to burn Sugar even hotter, resulting in an even more efficient power source.",
            "asteroid-planet-desc":     "Life will be difficult starting out on an asteroid.  Expect hardships.",
            "statue5-description":      "An obscenely large statue of the President of United Earth, who is currently serving his 14th term in office, kept alive by artificial means.  The statue is said to have healing powers.",
            "blackmarkets-desc":        "Start producing things that have been generally outlawed or restricted in the dominion of United Earth.",
            "diamondmining-desc":       "Unlock the art of mining and refining Diamonds, a valuable resource.",
            "colonialassembly-description":"A civic structure allowing you to pass and enact policies to govern your colony.",
            "diamondrefinery-description":"Collect, refine, and store raw Diamond resources.",
            "diamondminer-description": "This handy bot can collect and harvest Diamonds for you.  How nice!",
            "bmbazzar-description":     "Just because LIS colonies are under a strict embargo from United Earth doesn't mean you can't conduct good honest trade.",
            "advmetalurgy-desc":        "Unlock improved techniques for working with different metals.",
            "alumibug-description":     "A fun loving insectoid specializing in all things Aluminum related.",
            "aluminumhive-description": "Drop off, processing, and storage facility for Aluminum.",
            "jewelrystore-description": "What better way to maker her say 'I do' than buying her diamonds from this Jewelry Store?  A nice way to bring in income for the colony.",
            "independencehall-description":"The center of power and government for an independent LIS colony.",
            "leaguetrade-description":  "Connect to the galactic commodities market using an intricate system of proxies to bypass the United Earth communications embargo.",
            "resai-desc":               "Utilizing advanced robotics and quantum computing techniques from the Ancients, discover the secrets of true Artificial Intelligence.",
            "antsynth-desc":            "Using Ancient technology and extreme amounts of research, learn how to convert Aluminum and Sugar into pure Antanium.",
            "antsynth-description":     "In a highly power intensive process, convert Aluminum and Sugar into pure Antanium.  Requires Robots to operate.",
            "quantumdistillery-description":"Harness Quantum tech to create an epic Rum distillery.  Most people can't taste the difference between Quantum Rum and classicly produced.",
            "yellowhouse-description":  "Experts say that this lovely Yellow house is the best place to raise a family in #cityname.",
            "centerai-description":     "State of the art AI powered research center.  Generates vast amounts of research while consuming Microchips and Robots.",
            "antcompound-desc":         "Discover how to manufacture Triantanium, an artificial radioactive Antanium compound known as one of the hardest metals in the universe.",
            "triantrefine-description": "This zero emissions, automated facility fuses Uranium and Antanium to produce Triantanium, an extremely durable metal.  Consumes Robots during operation.",
            "diplomacy-general":        "Diplomacy",
            "new-embassy-header":       "Establish Embassy",
            "new-embassy-desc-short":   "Start a new diplomatic mission.",
            "new-embassy-desc":         "If you know the charter code of another independent colony, you can establish an embassy in their colony to unlock bilateral diplomacy and trade.",
            "theshanty-description":    "A dirt cheap embassy for the leader who just doesn't care how their colony is represented on the international stage.",
            "thefunctional-description":"Just a good solid no-frills down to business embassy.  Has everything you need to conduct a successful diplomatic mission.",
            "thegoldman-description":   "This embassy gets the job done and shows your host colony that your government means business.",
            "general-pick-embassy":     "Select Embassy",
            "general-embassy-requests": "Pending Diplomatic Missions",
            "exomound-description":     "A cheap and easy to set up embassy.  Just arrive on your host planet and dig a big nest.  Boom.",
            "thecrystalline-description":"This embassy will show your host colony the splendor of your nation.",
            "thesunrise-description":   "Let all the galaxy know that the sun is rising on a new day in #cityname.",
            "diplomaticoutpost-description":"This fine diplomatic building will let everybody see your LIS pride.",
            "shrineoftruth-description":"This embassy lets your host nation know that you are conducting good, truthful, honest diplomacy.",
            "transmissionhub-description":"A high tech transmitter that will allow you and your people to send messages across the galaxy.  Generates a small amount of research from the knowledge that it brings in.",
            "comms-general":            "Communications",
            "robofactory2-description": "The worldwide headquarters of Advanced Robotics Incorporated.  Generates money and robots.  Requires Aluminum and Microchips to run.",
            "general-req-annex":        "Request Annexation",
            "req-anenx-desc":           "Petition to leave #motherland and join a new charter.  The new parent colony will need to approve the request and pay #motherland any back taxes you may owe.",
            "req-annex-enter-charter":  "Enter the charter code of the Commonwealth you wish to join.",
            "req-annex-final":          "If they accept, you will leave #motherland and join their commonwealth.",
            "general-annex":            "Annex",
            "alummine-description":     "Always the resourceful diggers, Insectoids are able to dig Aluminum Mines for increased Aluminum production.",
            "plantgen-desc":            "Discover how to alter the genes of plants to create even better plants!",
            "megatree-description":     "An ultra large fast growing GMO tree that produces a large amount of Wood.",
            "deeptrans-description":    "The Deep Space Transceiver allows you to send messages over a long range.  Generates Research from the epic information that it lets flow into your colony.",
            "pavement8-description":    "A somewhat expensive road made out of Aluminum.  Ultra fast for rovers to travel on.  Because it's slick.",
            "plastfact2-description":   "A bigger, faster, and stronger version of the Plastic Factory.  Is more efficient than the regular factory, and also uses Robots for production.",
            "oilsynthlab2-description": "When you need to make a larger amount of oil, consider building this advanced Synthetic Oil facility.  Converts Food, Regolith, and Charcoal into oil.  Uses Robots during production.",
            "rover-firstbuild-tut":     "Rovers can harvest Ore and build basic structures.  The more Rovers you have harvesting, the faster you will collect resources.  Select your new Rover and select Build to review construction options.  You should start with a Greenhouse and a Water Pump so your colonists do not die.",
            "greenhouse-firstbuild-tut":"Structures require power to operate.  When you have enough Ore, you should construct a Solar Panel to keep the lights on in #cityname.  If you run out of power, your buildings will become semi transparent and stop producing.  If you go too long without power, your people will die.  If you need to, you can select a building and temporarily deactivate it to free up power for other structures.",
            "solarpanel-firstbuild":    "If you have not yet done so, consider building a Small Vehicle Factory.  It will unlock new Rover classes which will give you even more building options.",
            "smveh-firstbuild-tut":     "Select your new Small Vehicle Factory and build a Builder Bot.",
            "builderbot-firstbuild-tut":"With the Builder Bot, you can really start to grow your colony.  You should start by building a few shelters and a Landing Pad.  The shelters provide housing for new colonists, and the Landing Pad allows new colonists to migrate to your colony.  Make sure to keep an eye on power, food, and water production as your population grows.",
            "landingpad-firstbuild-tut":"Your new colonists will need jobs to earn money and stay happy.  Building an Ore Refinery would give them a great place to work!",
            "orerefinery-firstbuild-tut":"The Ore Refinery provides jobs for your colonists and converts Ore into Steel, a new resource that allows you to build more structures.  Colonists work in shifts, and the refinery will only produce while there are colonists on duty.  The more Ore Refineries you have, the more Steel you will produce.  Remember that buildings require at least one side unblocked by other structures, so that colonists can access them.",
            "pavement-firstbuild-tut":  "Road tiles allow your units to travel more quickly across the map.  They will prefer moving on paved paths to plain dirt.  Use it strategically to reduce travel times to and from important resources.",
            "internetbooth-firstbuild": "Colonists need entertainment to keep from going crazy.  If their happiness gets too low, they will refuse to go to work, bringing your colony grinding to a halt.  Make sure to keep a fair amount of entertainment buildings near colonist housing to keep them happy!",
            "goldrefin-firstbuild":     "Select your new Gold Refinery to build a Gold Miner, which will allow you to begin collecting the valuable Gold resource.",
            "goldmienr-firstbuild":     "Like the Rover and Ore Miners, select your Gold Miner and order it to being harvesting to start collecting Gold.",
            "smresearch-firstbuild-tut":"Some structures generate valuable Research which can be used to unlock new techs, which lead to new construction options.  Click on the purple potion Research icon from time to time to see what all techs are available to unlock.",
            "atmosgen-firstbuild":      "One of the goals in My Colony is to terraform your planet by creating an atmosphere.  Once your atmosphere levels are high enough, you will unlock exciting new building options!",
            "chopshop-firstbuild-tut":  "When you no longer need a Rover, you can order it to move to the Chop Shop which will harvest the Rover for its raw materials.",
            "lunar-welcome-message":    "Welcome!  You have founded a new colony with a colonial charter from #motherland.  Your goal is to turn this desolate world into a thriving civilization.  To get started, select your Rover and order it to begin harvesting.  Once you have collected at least 10 Regolith, select your Lander and construct a second Rover.",
            "lunar-rover-firstbuild-tut":"Rovers can harvest Regolith and also build basic structures.  To start forming a colony, you will need to convert some of your Regolith into Helium 3, a vital resource.  When you can afford it, order a Rover to build a Helium 3 Extractor.  Remember, the more Rovers you have harvesting, the faster you will collect resources.",
            "he3-firstbuild-tut":       "In order to start producing food, you will need to convert some Regolith into Ore.  Ore is a vital construction resource which you will need to build most structures.  Once you have enough Helium 3, build one Regolith Compactor.",
            "reg-compactor-firstbuild": "Your colonists will need both food and water to survive.  Food is more pressing early on, as you should have enough Water to get by for a bit.  Once you have enough Ore, build a Greenhouse to start producing food for the colony.  Once you have enough power, build a Water Extractor to start generating vital Water.",
            "forest-welcome-message":   "Welcome!  You have founded a new colony with a colonial charter from #motherland.  Resources are scarce on this world, so you need to move quick in order to survive.  To get started, select your Rover and order it to begin harvesting.  Once you have collected at least 40 Wood, select your Lander and construct a second Rover.",
            "forestrover-firstbuild-tut":"Rovers can harvest wood as well as construct basic structures.  Your first order of business is to feed your colonists so they don't die.  When you have enough Wood, order one of your Rovers to build a Potato Patch.",
            "potpatch-firstbuild-tut":  "Now that you have basic food production going, your colonists will need some water.  Have one of your Rovers build a Water Well.",
            "waterwell-firstbuild-tut": "Constant Wood production is vital to keeping your colony alive.  Tree cultivation is critical early on.  Order a Rover to build a couple of Fir Trees near the base for faster harvesting.  After that, you should construct a Charcoal Hut to begin producing Charcoal.  Remember, the more Rovers you have harvesting, the faster you will gain resources!",
            "charchut-firstbuild-tut":  "Charcoal is a vital base resource, and can be used to create Ore.  Ore is the most important construction resource in the game.  When you have enough materials, order a rover to construct a Charcoal Compactor to start converting some of your Charcoal into vital Ore.",
            "charccompact-firstbuild-tut":"Before growing any further, your colony will need power.  For this you will need to build a Charcoal Burner, but you will first probably need at least one more Charcoal Hut to keep up with current Charcoal demands.  Remember, if you need extra Power, you can always select a building and temporarily deactivate it.  Try to build up enough resources to get a Charcoal Burner going.",
            "charcoalburn-firstbuild-tut":"With plenty of power, you should build a Small Vehicle Factory, which will unlock new construction options.",
            "insectoid-welcome-message":  "Welcome!  You have founded a new colony with a colonial charter from #motherland.  Your goal is to turn this desolate world into a thriving civilization.  First, find a good starting spot and deploy your Queen.  Then, select your Worker Drone and order him to begin harvesting Sugar Cane.  While he is harvesting, select your Mound and order the construction of an Ore Bug.",
            "orebug-firstbuilt-tut":    "The Orebug will collect vital Ore which will be used to build up your colony.  While your Orebug harvests, select your Mound to build a second Worker Drone.  You may have to wait a moment for more food to generate from your Mound.  Once you have collected at least 300 Ore, order a Worker Drone to build a Feasting Area to start generating food for the colony.",
            "feastarea-firstbuild-tut": "With food taken care of (for now), you should select your Mound again and build a couple of Waterbugs so that you can start collecting Water for the colony.",
            "waterbug-firstbuild-tut":  "Order your Waterbugs to begin harvesting Water.  Once you have enough Water and Ore build up, order a Worker Drone to build a Communal Water Vats so you can begin storing water reserves for the colony.",
            "communalvats-firstbuild-tut":"To continue the growth of your colony, you will need to produce Ant Paste, a vital construction material.  Once you have the needed supplies, order a Worker Drone to build a Paste Tank.",
            "wetcone-description":      "The Wet Cone is a technological improvement over the Wet Mound.  Using Aluminum and other metals, it is able to extract (and store) significantly more water.",
            "interdimtrav-desc":        "Expand your economy and your galactic reach by unlocking the secrets of Interdimensional Transportation.  Allows you to bring in goods, people, and even construction methods from distant worlds.",
            "stargate-description":     "Using plans from the Ancients, construct an amazing interdimensional teleporter that allows you to conduct business over insane galactic distances.  Also allows for the free movement of citizens between worlds.",
            "megahab-desc":             "Learn how to get colonists to live together by the thousands in cramped conditions.  It's good for the environment.",
            "arcology-description":     "After playing an ancient earth city building computer game on an emulator, one of our engineers came up with this design for a mega structure where people could live, work, and play, never having to go outside again.",
            "general-statistics":       "Statistics",
            "mysticism-desc":           "Rediscover the spiritual powers of the ancient Insectoid people that were commonplace before outlawed by Emperor Zolarg centuries ago.",
            "shrineofmystics-description":"These ancient Insectoid shrines were outlawed on Zolarg Prime centuries ago because of the unholy power they unlock.  Only independent colonies may experiment with their power.",
            "colony-plays-on":          "Plays on",
            "insbeu-desc":              "Learn how to grow your Insectoid government to be bigger and stronger.  Well, at least bigger.",
            "highercommand-description":"This upgraded capitol building will allow you to enact more policies and conduct expanded diplomatic operations.",
            "unholypowerspire-description":"Fueled by unholy Antaura, this upgraded power spire produces a large amount of electricity with no emissions.",
            "general-modding":          "Modding",
            "general-texture-mods":     "Texture Mods",
            "text-mods-desc":           "Modify the look of My Colony by replacing default assets with custom graphics.",
            "general-map-editor":       "Map Editor",
            "general-map-editor-desc":  "Create custom starting maps featuring any terrain features or resources you want.",
            "general-tex-mod-import":   "Import Texture Mod",
            "general-tex-mod-activate": "Activate Texture Mod",
            "general-tex-mod-deactivate":"Deactivate Texture Mod",
            "general-tex-mod-create":   "Create Texture Mod",
            "tex-mod-activate-desc":    "Activate and enable a previously installed texture mod file.",
            "tex-mod-deactivate-desc":  "Go back to using the default game texture set.",
            "tex-mod-import-desc":      "Import and install a My Colony Texture Mod (*.mct) file you have saved to your device.",
            "tex-mod-editor-desc":      "Launch the Texture Mod Editor and create your own My Colony Texture Mod (*.mct) files that you can export and share with others.",
            "general-make-center":      "Make Center",
            "iceworldbase-desc":        "The base starting techs for the Ice World map.",
            "iceworld-planet-desc":     "A desolate frozen wasteland where colonists go to die.  Contains some rare crystals that cannot be found anywhere else in the galaxy.",
            "monumentheroes-description":"A fine monument commemorating the exploits of Sarge and his team of Space Marines - living legends among the United Earth civilization.",
            "fantasyland-description":  "A mega residential habitat where dreams become reality, at least until reality sets in.  Robots take care of all manual tasks, so the residents can play all day.  Provides massive housing but no jobs, entertainment, or other services.  Consumes Toys, Rum, Cloth, and Robots.",
            "general-modding-community":"Modding Community",
            "general-mod-comm-desc":    "Online forum where users can share their mods or download mods created by others.",
            "general-vidtut-header":    "Video Tutorials",
            "general-vidtut-desc":      "Community-made video guides.",
            "general-vid-sumbit":       "Submissions",
            "general-vid-submit-desc":  "Submit your own video tutorial!",
            "oresynth-description":     "Using the power of science, chemically convert Regolith into Ore, much quicker than any old Regolith Compactor could do it.",
            "rescomplexblue-description":"The paint might be blue, but the neighbors will be green with envy when this Blue Residential Complex goes up next door.",
            "bigplayhouse-description": "If you were ever expecting the fun to end, you're going to be in for a disappointment.  Because it goes on forever in the Big Playhouse.",
            "crystalminer-description": "A specialized rover for working with Crystalline in a harsh environment.",
            "micromine-description":    "The hardened tundra surface is too hard for a small rover to break through very far, but using hardened Crystalline you extract some surface regolith.",
            "regfurnace-description":   "Utilize a chemical reaction between Regolith and Crystalline to generate electricity for the colony.",
            "compactedsnow-description":"A cheap path for helping your rovers and colonists move from point A to point B.",
            "nexgenpow-desc":           "With the power of AI, discover methods of electric generation beyond anything even the ancients could have imagined.",
            "diamondcrystalreactor-description":"Combine Diamonds and Crystalline with Uranium to produce an unholy amount of energy.",
            "alienenrichment-description":"You might have thought you were pretty good at enriching Uranium, but the ancients were way better.  So steal their methods with this facility!",
            "tundrabug-description":    "A hard working insectoid who doesn't mind the cold, and loves cutting crystals with his mighty jaws.",
            "crystalmound-description": "A cozy mound, where insectoids huddle around Crystalline and digest it into pure Sugar.",
            "oretunnel-description":    "Claw your way through the frozen surface to find trace amounts of Ore hidden underneath.",
            "syncrystaldeposit-description":"Using existing Crystalline and Rum, grow a synthetic varient of Crystalline which can be harvested.  Not as potent as the real thing, but be careful because it spreads.",
            "crysynth-desc":            "Learn how to grow your very own Crystalline Deposits, right from the comfort of your home!",
            "independencehall2-description":"Bigger hall, more independence!  Allows expanded policy and diplomatic options.  Produces more money, but politicians now consume Rum.",
            "microincinerator-description":"A basic low-tech way to reduce trash in the colony.  Produces a bit of power as long as there is enough trash to keep it running.",
            "microincinerator-firstbuild-tut":"Over time, your colonists will generate trash which will pollute the colony and cause sickness.  Be sure to keep an eye on your trash levels and build waste management structures accordingly.",
            "smrecyclingcenter-description":"Go green by taking the dirty trash in your colony and converting into usable plastic!",
            "smtrashpit-description":   "When trash starts to pile up, just dig a hole and drop it in.  Once in the pit, the trash will slowly decay over time.",
            "conferencehall-description":"Where great cultural, scientific, and economic minds from throughout the galaxy meet.  Provides money and research, while using Rum, Microchips, and Food.",
            "advancedmed-description":  "Heal a large amount of colonists while producing vital research for the colony.",
            "restowerblue-description": "The only thing better than a residential tower is a blue one.  Don't believe me?  Build it and see for yourself.",
            "incinerator-description":  "Burn large amounts of trash and turn it into energy for the colony.  Produces a lot of atmosphere.",
            "medrecyclingcenter-description":"A bigger and better recycling center.  Turns your old trash into plastic and a bit of aluminum!",
            "landfill-description":     "Dig a giant hole and dump all of your trash in it.  The trash will decay a bit faster than at the Small Trash Pit.",
            "unholybrewpit-description":"If you want an unholy amount of brew, you're going to need this unholy brewpit.  Uses the power of Antaura to really boost Rum production.",
            "offline-game-desc":        "Start a new game in offline local mode.  No connection required, and you get to pick your own civilization.  You can play together with other local games on your network.",
            "creative-mode-desc":       "Start a new Creative map.  Gameplay is offline and you cannot go online later.  All structures are unlocked and can be built instantly for free.",
            "unholypit-description":    "Store an unholy amount of supplies using the power of Antaura.",
            "unholymound-description":  "This mound provides shelter for 600 and generates Antaura.  Does not store any resources or serve as a drop-off point.",
            "coremine-description":     "Created and operated with the power of unholy Antaura, this deep mine will bring wondrous resources to your colony.  You never know what you may dig up...",
            "smlightpost-description":  "Provides a bit of light for your colony.",
            "smredlightpost-description":"Red light district in #cityname?  That's up to you.",
            "smgreenlightpost-description":"Your people are just going to love these green lights.",
            "glowgoo-description":      "When you eat Ant Paste and then throw it back up with a bunch of old food mixed in, the chemical reaction creates the disgusting yet illuminating Glow Goo.",
            "streetlight-description":  "Build a tall pole and put a light on top.  Now you can see at night!",
            "pasteboiler-description":  "Get Ant Paste ultra hot, which leaks atmosphere into the sky.  Requires a constant flow of Ant Paste.",
            "atmosscrubber-description":"Use the power of AI to scrub pollutants from the atmosphere.",
            "wall2-description":        "This big, beautiful, dark, menacing wall will make your people feel safe.",
            "wall2light-description":   "Obviously a security wall will need some lighting.",
            "general-start-construction":"Start Construction",
            "general-confirm":          "Confirm",
            "hire-worker-header":       "Select place of employment.",
            "general-overview":         "Overview",
            "general-population":       "Population",
            "general-government":       "Government",
            "general-economy":          "Economy",
            "general-charter-code":     "Charter Code",
            "general-col-location":     "Colony Location",
            "general-col-color":        "Colony Color",
            "general-col-screenshot":   "Colony Screenshot",
            "general-col-screenshot-desc":"Take or update your public screenshot.",
            "general-tot-death":        "Total Deaths",
            "general-demographics":     "Demographics",
            "general-avg-age":          "Average Age",
            "general-cant-afford":      "You cannot afford this!",
            "ancienttemple-description":"A Mysterious temple constructed by the ancients.",
            "diamondsolar-description": "A more efficient version of the Solar Tower, plated with diamonds.",
            "bureaucracy-description":  "Provides jobs and red tape for your government, creating Civics along the way.",
            "clothfarm-description":    "A little known fact about Insectoids is that they are able to produce a silky substance when they eat Aluminum.  This mound will take advantage of that to produce Cloth.",
            "cauldron-description":     "In an electric intensive process, break down Alien Relics into their individual artifact pieces using a super heated cauldron of Ant Paste.",
            "supermarket-description":  "When colonists get tired of their bland government rations, they can come spend their money on the good stuff at this supermarket.  Provides good low paying jobs and money while consuming food and water.",
            "megamart-description":     "Where colonists go to find great deals on everything from food to toys to booze to electronics!",
            "politheat-desc":           "When your people start figuring out that you are single handedly ruling them with an iron fist, it's time to put on a show and make them think they are in charge.",
            "uecongress-description":   "An insanely overpriced rubber stamping institution and symbol of government excess, where politicians gather to officially sign off on all of your decisions and to name landmarks after themselves.  If you have to ask what it costs, then you can't afford it.",
            "refinery3-description":    "Use Alien tech to turn Ore and Uranium into unholy amounts of Steel.  You will never run out of steel again!",
            "antpastesynth-desc":       "Learn how to artificially create Ant Paste in the lab.",
            "pastesynth-description":   "Combine Trash and Atmosphere under a high level of electricity to create a synthetic Ant Paste.  Almost as good as the real stuff!",
            "turbodrone-description":   "It can build anything that the regular Construction Drone can build.  Just 40 times faster.",
            "sugarrover-description":   "A good hard working rover dealing with all things Sugar related.",
            "smsugarprocessor-description":"A drop off and storage facility for Sugar.  Creates a small amount of food as a byproduct of operations.",
            "check-render-distance":    "Check Render Distance",
            "check-render-dist-desc":   "Draw buildings in segments based on their render distance from the camera.  Turning off speeds up the game, but introduces rendering glitches and misordered buildings.",
            "general-place":            "Place",
            "asteroidbase-desc":        "The base techs that come from the Asteroid world.",
            "text-backup-instruction":  "Copy this game data into a text editor and save as an .mcz file",
            "general-avg-health":       "Average Health",
            "general-avg-iq":           "Average IQ",
            "general-average-savings":  "Average Colonist Annual Salary",
            "general-median-savings":   "Median Colonist Savings",
            "general-trade-authority":  "Galactic Trade Authority",
            "general-trade-too-recent": "Your last trade was too recent.  Please wait before submitting another trade.",
            "bloodletting-description": "Come enjoy the latest advancement in modern insectoid medicine.  The Bloodletting Station provides health to the sick and even entertainment to the bored, as bloodletting is both healing and fashionable.",
            "spireknowledge-description":"When an insectoid enters into this spire crafted of Gold and Aluminum, his mind is so enamored with its metallic beauty that sheer knowledge is generated.",
            "sphrad-description":       "This electrified metallic orb provides good crisp light for the colony.",
            "general-trade-too-big":    "Due to warehouse constraints, the Galactic Trade Authority is currently not accepting lot sizes over #maxlotsize units.",
            "general-trade-gouging":    "The Galactic Trade Authority has rejected your trade, as the Imperial Trade Representative believes you are price gouging.  He is currently not accepting any lot prices above $#maxlotsize.  A strike has been added to your account.",
            "general-trade-undercut":   "The Galactic Trade Authority has rejected your trade, as the Imperial Trade Representative believes you are undercutting the market too steeply.  He is currently not accepting any lot prices under $#maxlotsize.  A strike has been added to your account.",
            "uraniumsilo-description":  "A hardened storage bin for housing Uranium.",
            "ancientbug-description":   "To create an Ancientbug, a young insectoid larvae must be injected with melted alien Relics and Artifacts, so that when they hatch they retain construction knowledge of the ancients.",
            "quantumsugarcloner-description":"Using the power of the ancients, convert one unit of Sugar into many.  Requires Water during operation.",
            "general-collect-all":      "Collect All",
            "general-collect-all-desc": "I hate unrwapping gifts, just collect everything at once!",
            "general-connection-error": "Connection Error",
            "connection-error-info":    "Unable to connect to the My Colony server.  Games in online mode require an internet connection to play.",
            "rawmatdepot-description":  "Drop off and storage area for raw construction materials.",
            "commandpost2-description": "An upgraded command post allowing for more trade and more civic edicts.",
            "unholycommand-description":"Solidify your power through the use of unholy Antaura and forbidden alien tech.",
            "object-options-dismiss-tip":"Close the object options dialog.",
            "object-options-stats-tip": "Display relevant statistics for the selected object.",
            "object-options-activation-tip":"Activate or Deactivate the selected structure to manage power and resource consumption.",
            "object-options-comms-tip": "Send messages and other communications across the galaxy.",
            "object-options-mkcenter-tip":"Make this structure the center focus point of your colony.",
            "object-options-flip-tip":  "Flip the orientation of the selected structure.",
            "object-options-empire-tip":"Manage and interact with your Commonwealth.",
            "object-options-policy-tip":"Set and review government policies for the colony.",
            "object-options-diplomacy-tip":"Conduct trade and diplomacy with other colonies.",
            "object-options-move-tip":  "Order the selected unit to move to a new location.",
            "object-options-harvest-tip":"Order the selected unit to begin gathering resources.",
            "object-options-park-tip":  "Assign the selected unit to a designated parking spot.",
            "object-options-repair-tip":"Repair the selected structure.",
            "object-options-destroy-tip":"Destroy the selected object.",
            "object-options-build-tip": "Display the construction options for the selected object.",
            "object-options-sell-tip":  "Sell the selected object.",
            "object-options-upgrade-tip":"Upgrade the selected object.",
            "object-options-import-tip":"Display the resource import options for the selected structure.",
            "object-options-export-tip":"Display the resource export options for the selected structure.",
            "object-options-trade-tip": "Buy and sell goods on the global online trading marketplace.",
            "helpful-tips-header":  "Helpful Tips",
            "customsprocessing-description":"A center of interstellar trade and commerce.  Allows for the import and export of goods and acts as a gateway for tourists and other visitors.",
            "opendoors-desc":       "Open the doors of your colony to the outside galaxy and gain access to new markets and new opportunities!",
            "pastespa-description": "Tourists from across the galaxy will flock to #cityname to relax at this Paste Treatement Spa, where Ant Paste is injected into the body, supposedly providing all kinds of health benefits.",
            "lavaworldbase-desc":   "The base starting techs of the Lava World map.",
            "lavaworld-planet-desc":    "Essentially the worst type of planet you can colonize.  Don't do it unless you hate yourself and your colonists.",
            "lava-world-intro":     "You step foot onto an unforgiving wasteland.  The lava will continually shift location, and new volcanic eruptions will wreak havoc on #cityname.  Collect Crystalline and Ore to get started.  If the lighting effects cause performance issues, you can turn them off in the Engine Settings menu.",
            "extremeobug-description":  "This tough little guy is built for working in the most unforgiving of environments.",
            "vaporizer-description":    "Use Crystalline and Atmosphere to create vital drinking water for the colony.",
            "queen-description":        "Queens are the backbone of any Insectoid colony.  They dig mounds and lay eggs, growing the population.",
            "general-deploy-loaded":    "Deploy Loaded Units",
            "rovertransport-description":"A flying transport that can carry up to five Rover units across any terrain.",
            "obsidiobug-description":   "The only insectoid in the galaxy capable of harvesting rare Obsidian.",
            "earthlike-planet-desc":    "Easy planet with ample resources and very little challenge.  Good for a beginner learning the basics or for a casual game.",
            "general-new-map":          "New Map",
            "general-new-map-desc":     "Create a new map from scratch.",
            "general-edit-existing":    "Edit Existing",
            "general-edit-existing-desc":"Modify an existing map.",
            "general-custom-map":       "Custom Map",
            "general-map-meta":         "Map Meta Data",
            "general-map-author":       "Creator",
            "general-map-description":  "Description",
            "general-map-version":      "Map Version",
            "general-custom-map-desc":  "Play using a custom map you downloaded or created.",
            "general-import-map":       "Import Custom Map",
            "general-import-map-desc":  "Import and install a custom map file (*.mcm) that you have saved to your device.",
            "desertworld-planet-desc":  "A warm arid landscape with little vegetation but scattered valuable resources.",
            "reptilian-description":    "The Reptilians are an ancient and highly advanced species, having originally migrated from outside of the galaxy many, many years ago.",
            "draconians-description":   "The Alpha Draconians are a high-tech evil and warlike civilization of Reptilians.  They operate by stripping planets of their natural resources and enslaving any pre-existing populations.",
            "constructionprobe-description":"The Construction Probe is an unmanned interstellar craft designed to prepare a new planet for Reptilian colonization.",
            "draconians-welcome-message":"After weeks of high speed interstellar travel, our Construction Probe arrives on #cityname.  Select the probe and use it to begin making the landing area suitable for colonization.",
            "poweredmatsilo-description":"As long as this structure maintains power, it will provide all kinds of storage space for a new colony.",
            "microreactor-description": "A small automated nuclear generator.  Slowly consumes Uranium during operation.",
            "slavegate-description":    "As the evil Alpha Draconians would never subject themselves to manual labor, they have been abducting and enslaving Insectoids for centuries.  Tap in to the galactic Draconian Slave Trade Star Gate Network and bring some free labor into your colony.",
            "antaniumimpactor-description":"An industrial strength high-impact crusher that quickly forms Ore and Gold into Antanium, a hardened construction alloy.  Requires large amounts of power.",
            "microcondenser-description":"A small basic condenser for turning atmosphere into pure drinking water.  Could be easily assembled by a Reptilian child in under 2 hours.  Obviously, it requires an atmosphere.",
            "pavement9-description":    "A special and snazzy tiled and tinted pavement that Reptilians just can't get enough of.",
            "desertworldbase-desc":     "The base starting tech for the Desert World map.",
            "draconianbase-desc":       "The base starting tech for the Alpha Draconian civilization.",
            "reptbase-desc":            "The base starting tech for the Reptilian race.",
            "fairwarning-description":  "To serve as a fair warning to any enslaved Insectoid who would presume to betray the Alpha Draconians and attempt escape.",
            "autohydro-description":    "A crude automated facility for basic low-level food production.",
            "basicden-description":     "A small basic housing unit for one Reptilian citizen.",
            "familyden-description":    "Reptilians who are able to get a waiver from #motherland to cohabitate may live together in a Family Den, as long as they do not violate the one-child policy.",
            "medstargate-description":  "Reptilians have been using Star Gate technology for centuries, and these Medium Range gates can transport goods and civilians approximately 3/4 of the way across the galaxy.",
            "natflag-description":      "This flag of your proud people will always fly your colony colors true.",
            "general-col-color-info":   "Set or change the official government and flag color of your colony.",
            "torturebooth-description": "This cheap entertainment facility will provide your Reptilians with hours of fun.  Not so much for the poor Insectoid who has to go inside.",
            "tut-medstargate":          "Because Reptilians use a lot of resources and their people refuse to work, you will need to make use of Star Gates to import and export goods needed to expand your colony and pay your taxes.",
            "dronepad-description":     "A small teleporter pad that allows you to buy or sell construction drones from #motherland with instant shipping.",
            "uraextract-description":   "This nimble probe can mine raw Uranium deposits!  Think of all the possibilities.",
            "goldgrower-description":   "The Gold Grower is a handy high tech heating pad of sorts that is able to reduce the matter of Ore and use it to grow Gold using the power of Crystalline.",
            "aluminumgrower-description":"The powerful Aluminum Grower is able to create pure Aluminum out of Ore and Uranium by harnessing the power of Crystalline.",
            "pavement1light-description":"Like regular pavement but with a small light post built in, so that your people can see while walking down the road.  Not quite as bright as a stand-alone light post, but you can walk on it.",
            "firstaid-description":     "A small and quick healing station where colonists can go to get some quick and dirty emergency care.",
            "trashtransporter-description":"Unlike many other species, the Reptilians discovered how to take care of their trash problem years ago.  You build an interstellar teleporter and beam it all to United Earth.",
            "pasteextractor-description":"Ant Paste is an important bonding agent in Antanium construction, and the real stuff can only be made by Insectoids.  Often though, Insectoids will not willfully make it for their Reptilian overlords, so other extraction methods had to be created.",
            "arbsquare-description":    "A small public square where an Arbiter lays out punishments and judgements against citizens as he sees fit.",
            "general-entertainment-cap":"Entertainment Capacity",
            "oreevaporator-description":"Using high amounts of energy and Crystalline, turn raw Ore into Helium-3, a valuable and powerful substance.",
            "pebbles-description":      "Reptilians absolutely adore the look of these River Pebbles, along with that feeling they get when they walk over them.",
            "prairieweed-description":  "Imported from the dry plains of Alpha Draconis, this decorative weed will make your Reptilian citizens feel right at home.",
            "regenchamber-description": "Eating right and getting exercise are for the birds.  Just hop into this Regeneration Chamber and see all of your medical woes melt away!",
            "coalconvert-description":  "If you ever find yourself in a situation where you have a lot of charcoal and not much Ore, build this ancient alien Charcoal Converter!  Way more efficient than the standard Charcoal Compactor.  Turns Charcoal into Ore, but uses up a bit of Water and Uranium during use.",
            "pavement2light-description":"Build this fine slab of hardened pavement so you can travel fast in the dark!",
            "pillaroflight-description":"Just a good bright light source so your insectoid slaves can keep working in the dark.",
            "crudeextract-description": "This fine and noble bot will 'slurp' up raw Oil with it's elongated golden hose and bring it back to your base for processing.",
            "brewmasterden-description":"For Reptilians, the Brewmaster is one of the highest members of society and one of the only classes to still perform manual labor, crafting the galactic-famous Draconian Rum out of Water, Ant Paste, and Oil.  It's strong stuff.",
            "councilarb-description":   "A Reptilian local governing structure where three Arbiters meet to impose regulations on the rest of the colony.",
            "realnews-description":     "Keep your subjects 'informed' and generate Civics by beaming in a direct feed of the 24 hour Reptilian News Network broadcast.  Real News for Real Reptilians.  Subscription fees apply.",
            "relicstudies-description": "There are strange Alien Relics out there in the universe.  Conduct research on them and see what they do.  Uses Robots while creating Research, Artifacts, and Aluminum during operation.",
            "general-deportations":     "Deportations",
            "gen-deportations-desc":    "Make #cityname Great Again by sending your problems somewhere else.  Review options for deporting unwanted aliens or even citizens.",
            "adultdaycare-description": "The Adult Daycare is a great facility for colonists with extremely low IQs.  In time, even the most remedial of students can be elevated to a semi-functional level of intellect.",
            "basiced-desc":             "Learn the basics so you can teach them to your colonists!",
            "smschool-description":     "A nice little school where you can introduce your citizens to the basics of reading, writing, and arithmetic.",
            "smschool2-description":    "A bigger better school for teaching bigger and better things.  Will give your people the skills they need to get ahead in the workforce.",
            "smschool3-description":    "The best of the basic education structures.  Will train and prepare your people for advanced technical jobs.",
            "deport-homeless":          "Deport the Homeless",
            "deport-homeless-desc":     "Have a homelessness problem?  Get rid of it by kicking them all out of #cityname.",
            "deportation-warning":      "Deportations may impact approval rating.",
            "deport-young":             "Deport Children",
            "deport-young-desc":        "Rip all children out of their parents' loving arms and kick them out of #cityname!",
            "deport-arbitrary":         "Deport Arbitrary",
            "deport-arbitrary-desc":    "Remove an arbitrary number of citizens from #cityname based on a random lottery.",
            "deport-arbitrary-ask":     "How many citizens would you like to deport today?",
            "bld-update-freq":          "Simulation Update Frequency",
            "bld-update-freq-desc":     "How often the engine updates the simulation statistics.  More frequent updates improves the accuracy of the simulation, at the expense of performance.",
            "bld-update-freq-def":      "Default",
            "bld-update-freq-def-desc": "The default simulation speed.",
            "bld-update-freq-12":       "Performance",
            "bld-update-freq-12-desc":  "A slightly less frequent update cycle for better performance.",
            "bld-update-freq-15":       "Infrequent",
            "bld-update-freq-15-desc":  "A good setting for slower devices, at the expense of game accuracy.",
            "bld-update-freq-30":       "Rare",
            "bld-update-freq-30-desc":  "The most performant setting.  May cause glaring inaccuracies, but may be needed if your device is unable to keep up.",
            "bld-update-freq-5":        "Accuracy",
            "bld-update-freq-5-desc":   "A more accurate, but possibly slower, simulation speed.",
            "bld-update-freq-1":        "Perfection",
            "bld-update-freq-1-desc":   "The most accurate simulation speed possible.  Requires a very high end device, particularly with a larger population.",
            "general-storage":          "Storage",
            "sweatshop4-description":   "Make tons of money at the expense of your people by pumping out tons of cheap clothes for export.",
            "techtransce-desc":         "Make the next quantum leap in evolution, combining humans and ai into.... super smart humans!",
            "transacademy-description": "The Transcendent Academy is where your government attaches microchips to your colonists brains and uploads all necessary information into their systems.  Greatly increases their IQ.",
            "ancientinc-description":   "Operating under the guise of an organic cupcake bakery, this top secret government facility consumes extreme amounts of power, artifacts, triantanium, and ancient instructions to create Alien Relics.  Also generates a small amount of food to keep up the appearance of a bakery for the public.",
            "aspentree-description":    "These are taller trees with lighter bark and leaves.  Provide the same amount of wood, just look different.",
            "engine-short-numbers":     "Short Numbers",
            "engine-short-numbers-desc":"Abbreviate large numbers on the resource display listing to reduce UI clutter.",
            "engine-storage-limits":    "Show Storage Limits",
            "engine-storage-limits-desc":"Show or hide resource storage limits on the main UI.  Useful information to have at a glance, but takes up more room.",
            "diamondsynth-description": "Use chemical synthesis and charcoal to create synthetic diamonds!  They look so real, she wont be able to tell the difference.",
            "unicomm-description":      "The Universal Commodities Exchange unlocks trade access to markets from across the galaxy.  Also, in true Reptilian fashion, allows your professional market hackers to steal resources undetected from far away worlds.",
            "statue6-description":      "Statue honoring the great Admiral Beuford P. Tots, leader of the LIS rebellion against the evil United Earth.",
            "independencehall3-description":"Imperial capitol headquarters, unlocking more trade, more policies, and sucking down even more Rum.",
            "obsidianfurnace-description":"An ultra hot chamber for creating rare Obsidian in a process that requires a lot of Power, Helium 3, and several base minerals.",
            "largerres-description":    "Upgraded Residential Complex is taller and holds more people.  Not the best living conditions, but it works.",
            "keyboard-flip":            "Flip active object",
            "object-options-clone-tip": "Begin construction for another object of this type.",
            "general-clone":            "Build Another",
            "cautionsign-description":  "A powered, blinking barrier to keep alert and keep colonists away from danger.",
            "gravcompress-description": "This highly advanced storage facility creates a contained, compressed gravitational field, allowing you to store massive amounts of materials in a small space.",
            "online-switch-warning":    "Warning: Because of gameplay and balancing differences between the online and offline modes, switching your game into online mode will cause you to lose all resources!  You will keep your structures and population, but every resource you have will be reset to zero.  This may cause short term chaos in your colony as you fight to build back up reserves.  Are you sure you want to switch to online mode?  This cannot be undone!",
            "galartsexpo-description":  "Reptilians are known throughout the galaxy for having the best collections of fine art, mostly stolen from other civilizations.  People will visit from all around the universe to view the collection.  Over time, drunk Reptilian artists will also come here to produce their own works.",
            "patriden-description":     "The finest single family housing unit in Reptilian culture.  Provides refined housing for a large upper class Reptilian family.",
            "obeliskofplenty-description":"The pillar of the communal way of life.  Come share your coins with brothers and friends at the Obelisk of Plenty.",
            "unholyobsidian-description":"Combine the power of the Ancients with the power of Antaura to smelt Antanium and Gold into hardened and rare Obsidian!",
            "crystalbot-description":   "This little guy specializes in working with Synthetic Crystalline, a rare element.",
            "darkpavementlit-description":"Similar to the regular Dark Pavement, except with a light attached.",
            "solarroad-description":    "It's not the cheapest Road, but it allows you to kill two birds with one stone by providing a path and generating some power.",
            "aliensolar-description":   "It's about the best you can do in terms of solar power generation.  Not the most powerful generator, but requires no fuel.",
            "thewheel-desc":            "It's hard to believe that the Insectoids got this far in life without ever having knowledge of the Wheel.  Once you unlock this secret, who knows what your Insectoids will come up with?",
            "ftltravel-desc":           "Uncover the secrets of constructing great starships which can travel faster than the speed of light!",
            "wheelfactory-description": "Put your people to work creating Wheels, a vital component of Rover production!",
            "statue7-description":      "This fine statue celebrates the two year anniversary of the release of My Colony!",
            "shipyard-description":     "Construction yard for massive Starships, capable of traveling faster than the speed of light.",
            "starport-description":     "Any colony with a Star Port becomes a major player on the galactic scene.  Host and facilitate intergalactic travel, commerce, and stellar mercantilism.",
            "taxcollection-description":"Whenever your government says they are paying $10,000 for a hammer, don't be fooled.  It's not top secret projects they are working on either.  They are paying tribute to their Reptilian overlords who put them into office, and the money flows in to this Tax Collection office.",
            "chiptransporter-description":"No, your computer did not crash.  The Reptilians just used this quantum teleporter to replace your Microchip with an old piece of swiss cheese.  Much easier than working in a chip factory.",
            "general-trade-notifications":"News Ticker",
            "wheellodge-description":   "Where the Guild of Wheelcrafts meet to produce high tech Wheels for the settlement.",
            "constructionmech-description":"The Mobile Construction Mech is a special class of unit that can deploy into a structure that builds other units.  It can also carry up to 8 additional units inside of its belly for transport.",
            "general-delete-all":       "Delete All",
            "gen-delete-all-confirm":   "Are you sure you want to delete all?  This cannot be undone!",
            "gen-delete-mod-q":         "This mod is already deactivated.  Do you wish to delete it from the game?",
            "gen-dl-tex-mod":           "Download Texture Mods",
            "gen-dl-mod-desc":          "Browse and download texture mods that other users have submitted to the My Colony server.",
            "hipsterlofts-description": "Hipsters will pay top dollar for trendy downtown housing, but only if that housing comes in the form of a reconstituted early 20th centry abandoned tire factory.  Residents will drink Rum and create Paintings of various quality.",
            "crystallineenrichment-description": "This small station uses Helium 3 to harness the power of Crystalline to create pure Uranium.",
            "advmicroreactor-description": "A more powerful version of the Microreactor, providing a good deal of energy for the settlement.",
            "diamondbot-description": "A basic Insectoid rover designed to deal with all things Diamond related.",
            "unholydiamondspawner-description": "This unholy structure will continually spit out harvestable and equally unholy Diamonds, which themselves will slowly spread over the map.",
            "coloredtile-description":  "Add a splash of color to the colony with these decorative tiles.",
            "hedgewall-description":    "Prove to your people that you love nature, while keeping them out of important areas.",
            "footpath-description":     "Your colonists will love taking a nice stroll on this stone foot path.",
            "aagoldgen-description":    "Use the power of the ancients to generate extreme amounts of gold!",
            "turboet-description":      "A super charged Extraterrestrial Builder, costing slightly more but building structures 40 times as fast.",
            "regzapper-description":    "Hit Ore with high amounts of electricity, breaking it down into Regolith.",
            "obsgen-description":       "Fry Ore and Ant Paste together using Crystalline to create pure Obsidian.",
            "multithreaded-pathfinding": "Multithreaded Pathfinding",
            "multithreaded-pathfinding-desc": "On large maps, Multithreaded Pathfinding can improve game speed and performance.  Depending on your device though, it can actually reduce performance due to increased RAM consumption.  Try both settings and see which works best for you.",
            "gen-sel-game-type":        "Select Game Type",
            "gen-single-city":          "Single City",
            "gen-single-city-desc":     "Start a new single-city game.  You pick what size map you want and the abundance of starting resources.",
            "gen-region-city":          "Region",
            "gen-region-city-desc":     "Start a new region.  A region consists of many small cities built next to each other.  Region cities share a common resource pool, including technologies, research, power, and atmospheric levels.",
            "new-region-info":          "Enter a name for your new region.",
            "transtri-description":     "So the thing is, nobody really knows how this building works.  It has no workers, uses no robots, but Triantanium keeps coming out of it.",
            "rawmatextract-description":"Using high amounts of electricity and teleportation technology, strip every ounce of raw materials from the ground extending for miles under this structure.",
            "plastfact3-description":   "Believe me, nobody knew how to make plastic like the ancient aliens.",
            "lawchamber-description":   "The basic seat of government for an independent Reptilian state.",
            "dracemb-description":      "A simple yet functional Draconian foreign embassy.",
            "clayden-description":      "Where the artisan potter spends his days with his small family creating fine pottery.",
            "homelessshelter-description":"Those who say Reptilians have no heart have never visited one of these fine public housing units.  Provide your people with high quality affordable housing, giving peace, dignity, and a basic education to those who have none.",
            "crystallinedrill-description": "Use a high powered crystalline laser to cut deep into the ground, extracting water for the colony, along with a few other base elements.",
            "bugsaw-description":       "The Bug Saw is like an automated Insectoid butcher shop.  Hacks Prime grade Insectoids into various cuts of meat for the colony, and turns the remaining parts into Ant Paste.  Also provides a bit of entertainment to any who wish to watch the fun.",
            "gen-federation":           "Federation",
            "federation-desc":          "Create, manage, or withdraw from a Federation, a multiplayer alliance of online colonies.",
            "fed-founding-msg":         "The Galactic Emperor is the supreme ruler of the galaxy, but he has seen fit to allow Commonwealths to band together into alliances, or Federations, as long as they are willing to purchase a charter from him for the appropriate fee.",
            "gen-found-federation":     "Found New Federation",
            "gen-streaming":            "Streaming",
            "gen-streaming-on":         "Live Streaming is now enabled.  You will be broadcasting a live feed of your gameplay to your colonial website on my-colony.com.  Your in-game chat channel will be switched over to the Stream channel.  Streaming uses data and may impact performance.",
            "gdp-growth":               "GDP Growth Rate",
            "found-fed-pick-name":      "So, you want to found a new Federation.  I can't blame you.  Founding a Federation in My Colony can be a fun and rewarding experience.  Choosing a Federation name is the most important and critical step in the process.  What do you want to call yours?",
            "join-federation":          "Join a Federation",
            "join-federation-desc":     "Petition to join an existing federation.  Current members will vote on your petition, and if approved, you will become a voting member of the Federation.",
            "atmosgen3-description":    "When you are ready to get serious about your atmosphere generation needs, you need the Large Atmosphere Generator.",
            "join-fed-confirm":         "Are you sure you want to petition to join this federation?",
            "gen-balloting":            "Balloting",
            "gen-balloting-desc":       "As a voting member of the Federation, you are entitled to participate in Balloting.  Here are the current balloting measures awaiting your attention.",
            "petropit-description":     "Produce raw Crude Oil using a combination of several different elements, including Ant Paste, Wood, Obsidian, Crystalline, and Food.",
            "insctoil-desc":            "Discover the secrets of producing oil!",
            "bugnukes-desc":            "Use unholy mystic power to create pure Uranium!",
            "unholyuraniumgenerator-description":"Harness Antaura to convert Aluminum into Uranium!",
            "chamberfathers-description":"A very special high-powered governing chamber.  Allows for vast control over the colony and opens a quantum communications link with the 'forefathers' of the Reptilians.",
            "manual-civs-intro":        "Each civilization in My Colony offers different structures, tech trees, units, and available starting worlds.  Each also offers it's own unique back story, play style, and set of challenges.  Each is fun to play in it's own right, but it is suggested that you play as United Earth to begin with, as it offers more balance and easier starting worlds for beginners.",
            "ue-extended-backstory":    "The year 2051 was a sad and dangerous time for the peoples of Earth.  Most developed nations were collapsing under the weight of a decades long global economic depression, and once great cities were falling under mob rule and anarchy.\n\nUnder the threat of bankruptcy, the once proud United Nations and all of its assets were auctioned off to a small yet powerful group of billionaires, who quickly rebranded the institution as United Earth.  Using weapons purchased from the black market or from government fire sales, the United Earth began annexing many of the previously independent nation states of the world, eventually coming to control the majority of the planet.  The General Assembly was formed in order to give the people of the Earth the illusion democracy and with the promise to promote peace and stability on the planet, although most real power was placed into the newly created office of the President of United Earth.\n\nUnder the thumb of the United Earth President and the General Assembly, economic conditions improved somewhat, but times were still tough.  It was during this period that mass numbers of disillusioned citizens began leaving Earth in droves, preferring to take their chances on barren desolate worlds rather than suffering under the tyranny and stagnation that their home planet had become.",
            "zolarg-extended-backstory":"For centuries, the Insectoid race lived in peace and harmony on the planet of Bouwland.  As a society built largely around breeding and sugar cultivation, the Insectoids had little desire to form a military or reach for the stars.\n\nEverything changed when the evil Alpha Draconian empire invaded Bouwland, enslaved most of the population, and left the planet a barren and uninhabitable wasteland.\n\nFor centuries, the poor Insectoids were forced into slave labor and shipped around the galaxy to work as slaves or military fodder for the Alpha Draconians.\n\nThen one day on the planet Draconis 12, a brave young Insectoid named Zolarg led a slave uprising that was eventually able to overthrow the Draconian planetary government.  The Insectoids promptly executed all Reptilians on world, took control of the planet, and renamed it to Zolarg Prime.  Zolarg was named emperor for life of the people of Zolarg Prime, which became the new homeworld of the Insectoid race.\n\nThe Zolarg now travel the stars attempting to free their brothers from Alpha Draconian slave camps.  The two civilizations remain locked in a brutal war.",
            "lis-extended-backstory":   "When the United Earth first began establishing itself on other planets and setting up colonial governments,  the people of Terra Nova were the first to tire of paying outrageous taxes to the U.E. General Assembly and so they simply stopped sending payments.  The General Assembly attempted to compel them pay up by first slapping the planet with a trade embargo.  When that failed, a full immigration embargo and blockade of the planet were implemented.\n\nAfter months of embargo, Terra Nova still refused to give in, so the President of United Earth sent in a detachment of Space Marines to occupy the capitol and bring the city back under Earth's control.\n\nAs a result of the occupation, a Terra Nova militia commander known as Admiral Beuford P. Tots led the people of Terra Nova in a rebellion against the U.E. Space Marine force, forcing the Marines to evacuate from the planet.  The Colonial Congress of Terra Nova then sent a formal declaration of independence to the United Earth General Assembly, and the planet was renamed to Independent State.\n\nInspired by the actions on Terra Nova and disillusioned with the extreme taxation imposed by the United Earth General Assembly, neighboring systems began to follow suit and soon the League of Independent States was born, a loose alliance of planets with a common defense treaty against United Earth aggression.\n\nThe independence of the LIS member states has not been formally recognized by the United Earth General Assembly, which still considers the planets to be in rebellion.",
            "draconian-extended-backstory":"One of the oldest surviving civilizations in the galaxy, the Alpha Draconians consider themselves to be the heirs of the Ancients, a mysterious old civilization which once covered most of the known galaxy, the traces of which can be found buried in most habitable planets.\n\nWhile it remains unknown what happened to the Ancients, the bulk of their technology was indeed inherited by the Alpha Draconians, giving them a brutal advantage in conflicts with neighboring systems.  Nowhere has this been more keenly felt than among the Insectoid race, which has been largely reduced to a secondary slave class throughout the Alpha Draconian's growing sphere of influence.\n\nWhere they don't use their technological advantage to conquer, they use it for control and exploitation.  Many governments throughout the galaxy are under direct control of the Draconians, with 'elected' officials serving as mere puppets of the Reptilians.  On many worlds, the sectors of banking, entertainment, education, and media are all controlled by the Alpha Draconian propaganda machine.\n\nThe results of this have been both positive and negative.  The Alpha Draconian elite have become extremely rich from exploitation and slave labor, but the combination of advanced technology and free labor have left most of the population poor and destitute.  Riots and uprisings are common among Draconian colonies, and generally once a planet has been stripped of it's resources, the Alpha Draconian elite will pack up shop and leave the common citizens behind to die.\n\nAnother threat to the Alpha Draconians comes from the growing technical abilities and military tactics of the few remaining Insectoid colonies in the Zolarg Empire, which have been growing more aggressive in their resistance of the Alpha Draconians.",
            "manual-controls-intro":    "My Colony offers several control methods, depending on the type and capabilities of your device, as well as your preferred style of play.  Although the game was designed with Keyboard and Mouse controls in mind, it has been adapted to support most common control setups.",
            "manual-keyboard-intro":    "The optimal control scheme for My Colony is the Keyboard and Mouse/Pen combo, as the game is designed with this interface in mind first and foremost.\n\nMouse or Pen controls are fairly intuitive.  You can select units and buildings with a single click.  You can click/hold and then drag the mouse to select all units in an area.  Double clicking on a unit will select all units of that kind.  When a unit is selected, right clicking will execute an action, depending on what you right clicked on, whether it is a harvest order, a move order, or a build order.  The map is scrolled by click/dragging, or in fullscreen mode you can also simply move the mouse cursor to the edge of the screen to scroll the viewport.  The mouse scroll wheel allows for zooming in and out.\n\nThe engine also supports a variety of keyboard shortcuts, all of which can be customized in the Engine Settings menu.  Below is a reference of the currently available keyboard bindings:",
            "manual-touch-intro":       "My Colony offers a fully developed touch interface that works on any device containing a touchscreen input.  Most touch actions are similar in nature to mouse click inputs, although there are minor differences.  Zooming in and out is done with the standard pinch gesture common on touch devices, and scrolling the map is also done in a common and intuitive manner.",
            "manual-gamepad-intro":     "In addition to keyboard and touch, My Colony is fully playable with a gamepad.  When using a gamepad, the UI will automatically transform to an optimized 'ten foot' interface, allowing for comfortable gameplay on a television or other large screen device.\n\nThe gamepad interface was designed around the Xbox 360/One controller layout, which has essentially become the standard gamepad layout for many PC and Android controllers.  The following controls are set with that layout in mind, although button names may differ depending on the brand and style of gamepad you are using:",
            "gen-local-mode":           "Local Game",
            "manual-local-mode":        "Playing a Local Game in My Colony requires no account or online connection.  In Local Mode, you will start the game as a sub colony of one of the base AI civilizations, and will be required to pay the standard tax rates until you gain independence.  The AI will offer no extra assistance to you while building up your colony.\n\nLocal games are able to play LAN/Wifi based multiplayer with other local mode players on the same network.  LAN/Wifi multiplayer is cross platform and supported on all devices except when played through the web browser (for security reasons), unless the Ape Apps Desktop Bridge (a part of the Ape Apps Launcher) has been installed and activated.  LAN players are able to send each other messages and trade resources.\n\nUnless using a custom map or playing in creative mode, a local game can be switched into online mode, although doing so will cost the colony all of its resources.\n\nWhen in local mode, the games built in anti-cheating mechanisms are half way disabled.  A colony found to have cheated will not be punished in any way while playing a local game, but the game will block that colony from ever switching into online mode.",
            "manual-online-mode":       "Players with a valid Ape Apps Account and internet connection can play My Colony in Online Mode.  An online game is mostly similar to a local game, but there are several key differences.\n\nFirstly, starting a game in online mode will place your colony under the control of another players colony.  The player controlling the parent colony may choose to alter your tax rate higher or lower, or to charge no taxes at all.  Online parent colonies will also usually send their child colonies gifts of resources to help them get started.",
            "manual-online-commonwealth":"In online play, the relationship between parent and child colonies is known as a commonwealth.  Once an online colony gains independence from it's parent, it is established as the leader of a new commonwealth, and any child colony that joins under the parent's charter becomes a member state of that commonwealth.  Players may choose to join any commonwealth they wish by the use of a charter code, which can be found in the statistics screen of the parent colony.  More information about charter codes and listings of the top online commonwealths can be found on https://www.my-colony.com\n\nThe benefits of joining any given commonwealth will vary widely based on the parent colony and the player who controls it.  If you are interested in playing online and finding a good active commonwealth, you are encouraged to check out the Commonwealth section of the My Colony forums.",
            "manual-online-fererations":"Federations are the next online organizational structure above Commonwealths, and are structured formal alliances of independent commonwealths.  The Federations feature is in its infancy and still under development.",
            "manual-online-embassy":    "Independent commonwealth leaders can request to establish an embassy in other independent colonies, provided they know the charter code of the other colony.  If an embassy request is accepted, then a new embassy building for your colony can be built in the other players colony.  Embassies allow for multiplayer diplomatic actions, including messaging, trading of resources, providing aide, and others.",
            "manual-online-trade-hdr":  "Resource Trading",
            "manual-online-trade-desc": "Online games also have access to the galactic resource exchange, an online global marketplace for buying and selling in-game resources.  Most players refer to this by the name of the United Earth building which unlocks it, the Galatic Board of Trade.\n\nWhen playing online, the current resources in the online marketplace have a large impact on each online colony, as all local prices are determined by the current global market value.  Depending on the resource production balance of any given colony, price swings on the global market can have wide ranging impacts on anything from the size and power of your economy, to the happiness (or willingness to continue working) of individual colonists.",
            "manual-creative-mode":     "Creative mode exists for players who just want to relax and build.  When playing in creative mode, all structures in the game are unlocked and can be built with no technology or resource requirements.  For obvious reasons, games in creative mode cannot be switched into online mode.",
            "manual-single-city":       "Whether you start a game in local, online, or creative mode, you are able to choose between a single city and a regional game.\n\nIn a single city game, your entire city is contained within one map and one file.  Upon starting the game, you are able to select what size of map you wish to play on, as well as the abundance of starting resources on that map.  Later on in the game as your government level increases, you are able to expand your map size by annexing new lands.  The downfall of this is that game performance degrades as the size of your map increases, particularly on slower devices.  For this reason, the Region mode was created.",
            "manual-regions":           "Regional mode was added to the game due to performance issues related to ever expanding single city maps.  A region caps map sizes at either the small or medium level, and the ability to expand maps using the annexation feature has been removed.  The trade off to this limitation is the fact that a single region may contain up to 2,500 individual map files in total, theoretically allowing for massive colonies.\n\nRegions work by splitting a city up into smaller chunks, with each chuck being processed separately, yet sharing a common resource and technology pool.  This setup increases the performance of ultra large cities dramatically, and allows a city to be built in specialized chunks.  Economic and population statistics are available for both the individual cities and the region as a whole, but for online reporting purposes, the stats for the entire region are used.",
            "gen-map-types":            "Planet Types",
            "manual-map-types":         "The type of world you choose to play on will have a large impact on the way you play and the difficulty of the game.  Review the details of each map type carefully before starting a new colony.",
            "gen-races":                "Races",
            "manual-races-desc":        "In My Colony, there are several principal species, each with distinctive starting bonuses.  The civilization you choose will determine the species of your initial colonists, but once your city grows in size and reach, other species from across the galaxy may well join your colony.",
            "manual-play-modes-desc":   "There are several way to play My Colony, offering variety and countless hours of playtime.  You can play online, offline, creatively, with a custom map, with a single city, or on a large regional landscape.  The game allows for countless save files, so you can try all styles to see which you like best!",
            "manual-res-desc":          "Resource management is a huge core component of My Colony, and proper handling of resource inflows, outflows, and storage is vital if you want your city to grow and prosper.  Resources allow you to build your colony, grow your population, and research new technologies.",
            "manual-tech-header":       "The research and discovery of technology allows you to unlock new buildings and vehicles, thus opening up new ways to grow your colony.\n\nThe tech hierarchy in My Colony is not linear.  For example, if you were trying to draw out the tech tree in a structured programmatic way (for this manual, for example), it would not be possible or practical, as each new technology is dependent on technologies from not only several different branches in the tree, but also on resources which may or may not have been unlocked by the player at any given time.  Therefore, in order to be easily readable, any visual tech tree would need to be manually created and updated by hand.  Such tech trees exist on the My Colony online reference website here: https://www.my-colony.com/reference/\n\nFor the purposes of this manual, all technologies are here listed in alphabetical order for easy lookup and reference, along with a description of each, their requirements, and what they may unlock.",
            "manual-buildings-desc":    "There are a lot of buildings available in My Colony, #gamebuildingcount in total.  For this reason, placing them in any order other than alphabetical in this manual would make lookup and reference extremely difficult.\n\nThe online My Colony reference at https://www.my-colony.com/reference/ provides interactive lookup tables for all structures in the game, including tech requirements, costs, and production output values.",
            "enc-print-status":         "Warning - Nearly 200 Pages Long.",
            "manual-vehicles-desc":     "Vehicles (or Units) are the primary workhorses in My Colony.  They allow you to build structures and harvest vital resources.  There are many different units for you to build and manage in the game.  Here they are listed in alphabetical order for your reference.",
            "manual-terms-header":      "Glossary of Terms",
            "manual-terms-desc":        "Throughout this manual, and within the game itself, there are several terms that you should be familiar with in order to fully understand what is going on.",
            "manual-concepts-header":   "Gameplay Concepts",
            "manual-concepts-desc":     "The section describes some of the key gameplay concepts in My Colony, including how to get up and running with your first colony and how to perform some of the basic tasks in the game.",
            "waterworld-base-tech":     "The base starting tech for the Water World map.",
            "water-world-desc":         "An ocean covered planet with small islands scattered about.  You will be micro managing wood at the beginning in order to survive.",
            "bridge1-description":      "When you just need to get across the water, you need this small wooden bridge.  Available in East/West or North/South orientations.  Must be built over water.",
            "goldreducer-description":  "For those strange times when gold is abundant yet ore is rare.  Uses an old Insectoid technique to slowly break Gold down into Ore by slowly burning Sugar.",
            "embridge-description":     "This high tech bridge will help you move citizens and slaves alike across water or lava.",
            "sandpath-description":     "When you have a lot of sand laying around, might as well make a path out of it.",
            "fisherbot-description":    "Typical, whenever you need something done around the colony, this bot is always out fishing.",
            "fisherbothut-description": "This neat little building can build and manager Fisherbots, setting them out to gather fish, and processing that fish into Food for the colony, in the form of delicious fish sticks.",
            "steelbridge-description":  "Stronger than a wooden bridge, allowing for faster travel and can even be built over Lava.",
            "alumbridge-description":   "The slick aluminum surface on this bridge allows for faster travel.",
            "goldbridge-description":   "Your subjects will know that you stand for gaudy excess as they travel across this fine golden bridge.",
            "fisherbug-description":    "Teach a bug to fish... and he'll go to the shore and get some fish, put it in their mouth, bring it back to the mound, and regurgitate it into Food and Sugar.  Yum.",
            "pastepontoon-description": "A primitive floating bridge consisting of rough cut logs bound together with Ant Paste.",
            "usedminer-description":    "Purchased second hand or pieced together from various chop shops, this old Ore Miner isn't quite as good as a brand new one, but still has a bit of life left in it.",
            "shipbuilding-desc":        "Because of the heavy use of Star Gates, research is required to design and produce Star Ships, which are needed to go anywhere that does not already have a Star Gate in place.",
            "shipworks-description":    "Manufacturing facility for producing the Draconian Sloop, a class of starship known throughout the galaxy for its speed and firepower.",
            "hereditaryrule-desc":      "Reptilians love being led by a strongman, so establish the new monarchy on this world and give the people what they want!",
            "chamberofkings-description":"With this ultimate Draconian governing structure, the height of your power will be matched only by the height of this building.",
            "general-trade-too-cheap":  "The Galactic Trade Authority is not accepting lot prices under #minlotprice per 100.",
            "general-trade-too-expensive":"The Galactic Trade Authority is not accepting lot prices over #maxlotprice per 100.",
            "norm-res-desc":            "A regular map with resources that you can collect and profit from.",
            "blank-res-desc":           "A flat empty map with no resources at all.  Probably not a good choice for your first city.",
            "bugships-desc":            "Discover how to build the Ruimteschip, a somewhat primitive yet still capable starship.",
            "scheepswerf-description":  "The Scheepswerf allows for the production of the Ruimteschip, a basic no-frills starship that gets the job done.",
            "large-map-warn-header":    "Large Map Warning",
            "large-map-warn-desc":      "You are selecting a large map size.  Playing on a large map may cause performance and game saving related issues on certain devices.  Are you sure you want to continue?",
            "offline-copy-gen":         "Offline Copy",
            "offline-copy-desc":        "Create an offline copy of this colony without impacting your online game or commonwealth.  Use this feature for personal testing, or for submitting your map to the developer for debugging purposes.  You should save before you do this.",
            "offline-copy-notice":      "You are now playing the offline copy version of this colony.  To return to the online copy, you will have to save and quit to the title screen and reload it.",
            "researchconvert-description":"At some point, your people get so smart that they can just turn research into raw goods.  Highly complicated process.  Don't worry about how it works.",
            "policy-tourism-desc":      "Whether or not to allow new tourists into the colony.",
            "general-allowed":          "Allowed",
            "general-blocked":          "Blocked",
            "gen-leave-fed":            "Leave Federation",
            "leave-fed-confirm":        "Are you sure you want to leave the federation?  If you want to rejoin later, you will have to go through the balloting process again.",
            "import-goods":             "Import Goods",
            "gen-importing":            "Importing",
            "export-goods":             "Export Goods",
            "gen-exporting":            "Exporting",
            "gen-error":                "Error",
            "subcity-mismatch":         "The game data associated with this subcity file does not match it's parent!  Your save file may have been corrupted.",
            "coloniae":                 "Coloniae Sync",
            "coloniae-desc":            "Keep your colony stats synced to Coloniae, a website that lets you access a variety of statistics and trends for your colony.  Coloniae is a free third party community driven service, not supported by Ape Apps.",
            "etherextractor-description": "Fly around collecting Ether.  What a fun existence!",
            "etherprocessor-description": "Ether is a substance created long ago by a runaway nuclear reaction.  This facility can reconstitute some of the inert Uranium that is still found inside of the Ether.",
            "etherbath-description": "After a long day, nothing feels better than spending time in the public therapeutic Ether Baths.  Loved by citizens and tourists alike!  May cause cancer.",
            "subcity-desc":             "Subcity Description",
            "subcity-desc-detail":      "Add a short note or description on this city to be displayed on the regional overview map.",
            "petroboiler-description":  "The quick and easy way to make Oil.  Use Ether to condense Wood down into crude oil in a highly sophisticated process.",
            "advcloning-description":   "It's a cloning facility on steroids, powered by Ether.  Requires a steady stream of Ether during the incubation process.",
            "gen-small-city":           "Small City",
            "small-city-desc":          "Create a small (50x50) city occupying one tile on the regional grid.",
            "gen-medium-city":          "Medium City",
            "medium-city-desc":         "Create a medium (100x100) city occupying four tiles on the regional grid.",
            "layout-template":          "Layout Templates",
            "layout-template-info":     "Save or export a simi-transparent template of your buildings and roads to share with others or use on other maps, or import and activate an existing map layout template (*.mcl file)",
            "save-template":            "Save Template",
            "save-template-desc":       "Save a template of your current map to your internal game directory, for personal use.",
            "export-template":          "Export Template",
            "export-template-desc":     "Export a template of your current map to the filesystem, for sharing with other players or for backup.",
            "import-template-desc":     "Import a template file (*.mcl) from your filesystem into your game directory so that you can use it.",
            "import-template":          "Import Template",
            "activate-template":        "Activate Template",
            "activate-template-desc":   "Load and activate a map template file to overlay onto your current map.  Template must match the size of your current map.",
            "pick-template-name":       "Choose a name for this template.",
            "gamepad-setting-desc":     "Choose whether or not to allow gamepad input to control the game.",
            "the-commonwealth-of":      "The Commonwealth Of",
            "edict-short-desc":         "Send to all members.",
            "tax-rate":                 "Tax Rate",
            "tax-rate-desc":            "Set your Commonwealth Tax Rate, as a percentage of the default building tax level.  100% is the normal level that an AI commonwealth leader would charge in an offline game.",
            "salepitch-info-short":     "Short welcome message.",
            "mp-region":                "Multiplayer Region",
            "mp-region-desc":           "Start or join an online multiplayer region, where multiple online players build in the same region map.  Requires an Ape Apps Account and an internet connection.",
            "new-mp-region":            "New Region",
            "new-mp-region-desc":       "Create a new multiplayer region.  You get to select the name, planet type, and charter privacy.  Other than that, you have no control over the region or the subcities who join it.",
            "region-name":              "Region Name",
            "region-name-desc":         "Pick a name for this new multiplayer region.  This is basically the name of the planet all players will be playing on.  It cannot be changed later.  Keep it clean to avoid strikes against your account!",
            "region-charter-private":   "The charter for this region can be either public or private.  If it is private, only players who know the charter code may join.  Otherwise, it will show up in the public charter listing when players start a new game.",
            "share-region-charter":     "Regional Charter",
            "mp-region-district":       "Regional Metro Area",
            "mp-region-district-open":  "Metro Area Open",
            "mp-region-district-open-desc":"If set to open, other players who build cities adjacent to this metro will share in the technology and resources of the metro area.  Otherwise, only you can add cities on to this metro.",
            "rename-district":          "Rename Metro Area",
            "rename-district-desc":     "Choose a new name for this online metro area.",
            "subsugar-description":     "Slowly grow Sugar in an underground farm.  Requires water and a bit of time.",
            "bni-desc":                 "Unlock the basics of deploying a networking infrastructure for the colony, in order to facilitate data transfer and communications.",
            "smsrvbld-description":     "Adds to the networking backbone of the colony by providing bandwidth capacity.  Also provides a small amount of storage for software.",
            "cybercoinmine-description":"A computer lab where engineers work all day mining Cybercoin, an illegal yet highly valuable black market cryptocurrency.",
            "smserverfarm-description": "Generates money by providing server hosting and data services to local businesses.",
            "galstockmarket-description":"Where local colonial businessmen go to get rich on the galactic equities market.  Trade commissions go straight into the colonial treasury.",
            "lisdataintercept-description":"A large communications array used by hackers to steal money and research from other colonies.",
            "smsoftwarestudio-description":"Set up a small indie development shop to churn out software.",
            "netschool-description":    "Teach people without teachers!  The NetSchool provides a professional grade education using software instead of teachers.",
            "smalllab2-description":    "Upgrade your old Small Research Labs with these shiny new network connected models.  Utilizes software and bandwidth to generate more research.",
            "onlineofficeofficebld-description":"Generate cash while providing high tech jobs for your highly educated workforce.  Requires bandwidth and software during operation.",
            "arcade-description":       "This retro arcade center will provide endless hours of overpriced entertainment for citizens and tourists alike!",
            "colonimulation-description":"Advanced high-tech entertainment of the future!  It's simulation entertainment that is more realistic than VR!",
            "civiccenter2-description": "It's still an inefficient government building, but utilizes advanced software to more efficently produce civics for the people.",
            "hfnode-description":       "Provides interstellar communications and networking bandwidth to the colony.",
            "dsinterceptor-description":"A deep space antenna that steals information and money from unsuspecting civilizations light years away.",
            "cirfoundry-description":   "Construct crude Microchips using an advanced fabrication process along with Gold, Aluminum, and Crystalline.",
            "slabofproc-description":   "Using crude microprocessors and high frequency waves, the Slab of Processing serves as a bandwidth node for data communications throughout the colony.",
            "intpadthought-description":"Plugging themselves into the interstellar communications grid, Insectoids phase into a brief transient state where they enter a realm of bliss with their fellow insectoids.  Trace amounts of Antaura are generated in the process.",
            "keyboard-open-res":        "Open Resources Window",
            "keyboard-search-res":      "Open Resource Searchbar",
            "save-file-loc":            "Save File Location",
            "save-file-loc-desc":       "Change the location where My Colony saves game data.  For experts only.  Don't change this unless you know what you are doing.",
            "save-file-loc-warn":       "WARNING - This does NOT move your current data.",
            "save-file-loc-confirm":    "Are you sure you want to change your My Colony data folder?  THIS DOES NOT TRANSFER YOUR CURRENT SAVES.  Games synced to the cloud are not impacted.",
            "gen-disabled":             "Disabled",
            "gen-volume":               "Volume",
            "set-sfx-instruct":         "Use the slider to set the desired sound effect volume level.  If you want to disable sound effects entirely, set the slider to 0.",
            "centerforautocoding-description":"Where insectoids come together in harmony to produce something called Software, which no individual insectoid understands, but the collective as a whole can utilize.",
            "thoughttower-description": "The latest in insectoid research generation.  Insects plug in and just think, and suddenly magic happens.  Also provides entertainment and some IQ to those who enter.",
            "hallofelders-description": "An upgraded meeting hall for an insectoid council of elders, generating a larger supply of Civics for the colony.",
            "support-community":        "Support Community",
            "merch-store-header":       "My Colony Store",
            "support-community-desc":   "Online forum community.",
            "merch-store-desc":         "Buy My Colony Swag!",
            "moundonlinebus-description":"Whoever said that Insectoids lack the skill and aptitude for commerce has never visited the Mound of Online Business, where dreams are made and the coins flow.",
            "aipainting-description":   "It's an automated robotic arm that produces Paintings out on the public square.  Citizens and tourists alike will be mesmerized while watching this robot create modern art which can then be sold to Human investors at inflated prices.",
            "antaniumimpactor2-description":"This is a high tech upgraded Antanium Impactor using advanced circuitry and networked communication with the colony infrastructure to greatly boost production rates.",
            "codersden-description":    "The residence and workplace of a Coder, whose important work helps foster automation and keeps the rest of the population from having to work.",
            "itstudiocomplex-description":"An advanced I.T. Studio where software developers work around the clock to create very important computer programs, such as Antiquitas.",
            "megabotdeluxe-description":"For those who like to build fast, or who just like a little extra bling on their Megabot, it's the Gold plated Megabot Deluxe!  Slightly more expensive, but with 30 times the build speed of the plain Megabot.",
            "general-flag":             "Flag",
            "flag-background":          "Flag Background Color",
            "gen-primary-parts":        "Primary Parts",
            "gen-logos":                "Logos",
            "add-part":                 "Add Part",
            "add-logo":                 "Add Logo",
            "ethertreefarm-description":"If you're able to find a good source of Ether, this souped up Tree Farm will really crank out the lumber.  So what if it's radioactive?",
            "aliennuclearplant-description":"Breathe new life into your aging Nuclear infrastructure with this Quantum Nuclear Plant, infused with the latest in alien technology!",
            "multimediainf-desc":       "Learn how to use internet utilities to establish a colony-wide multimedia broadcast system.",
            "newsstation-description":  "Keep your people informed with this official News Station!  Generates civics, as well as money from subscriber fees.  Costs Rum to operate, as alcoholism is rampant among the on-air personalities.",
            "imppropaganda-description":"Keep your subjects misinformed with this fancy 24 hour propaganda office.  Costs a bit of Money, Software, and Microchips to operate, but generates a large amound of Civics.",
            "onlinebmoffice-description":"An advanced Black Market operation where you can buy all sorts of goods from nefarious sources, and even re-route shipments from other colonies to yours.",
            "hackercamp-description":   "A fortified compound where hackers spend the day launching viral attacks on other colonies, stealing Research, Software, and Money.",
            "mindnetwork-desc":         "Make use of internet utilities to transfer... thoughts.  Allows more efficient communication, governance, and management.",
            "adv-networking-desc":      "Unlock improved networking and telecommunications methods.",
            "massdata-desc":            "Learn how to store and transmit data on a massive scale!",
            "largeserverbuilding-description": "When bandwidth demand in the colony grows, it's time to upgrade to this Large Server Building.",
            "proxyserverbld-description": "Generate bandwidth by running a large server operation, under the nose of United Earth intelligence agencies.",
            "electronicschopshop-description": "Recycles the Microchips out of old unused toys and other consumer electronics items.",
            "moundofscholars-description": "Create a well rounded and educated workforce of drones with this Insectoid educational institution!",
            "pastetank2-description":   "The smart way to make Ant Paste.  Link the tank to the hive network to boost output and efficiency.",
            "autopsyslab-description":  "Where a skilled arbiter dissects a random Insectoid and broadcasts it live over the galactic network!  The Draconians already know everything about Insectoid anatomy, so no scientific knowledge is gained.",
            "keyboard-chat-input":      "Open Chat Reply Mini-Window",
            "artwarehouse-description": "A specialized climate controlled version of the Durable Goods Warehouse for storing fine works of Paintings, Pottery, and Cloth.",
            "counterfeitmarket-description": "Offers a large amount of storage for Diamonds, Paintings, Pottery, and Cloth, while also dealing the same resources for cash.  Some of the resources sold may or may not be genuine...",
            "aluminumgenerator2-description": "Who says modern humans can't improve on the designs of the ancients?  Amp up your Aluminum production with this advanced generation facility.",
            "gen-kick-member":          "Kick Member",
            "shipyard2-description":    "This upgraded and integrated mega ship yard can produce Star Ships faster and more efficiently.",
            "deptfishstudies-description":"A typical bloated government jobs sink hole.  Provides nothing of real value to the economy, except a ton of jobs producing research papers that nobody will read.",
            "meshplatform-description": "These platforms can be cheaply built over water tiles and work great when a standard bridge will not suffice.",
            "saltwaterpump-description":"This small pump is built directly over the ocean and produces Salt Water.",
            "saltwatertank-description":"Basic storage tank for Salt Water.",
            "desalinationfacility-description":"Create large amounts of fresh Water by treating Salt Water.",
            "fishery-description":      "This salt water Fishery produces large amounts of Fish.  What are you going to do with all of these fish?  That's up to you.",
            "fishcannery-description":  "Nothing quite like canned fish!  Your colonists will love their new all-tuna diet after you start supplying food from this cannery!",
            "proxyservers-desc":        "Discover how to circumvent United Earth spying and firewalls by using advanced proxy server technology.",
            "general-friends":          "Friends",
            "gen-inc-friend-requests":  "Incoming Friend Requests",
            "gen-add-friend":           "Add Friend",
            "gen-group-units":          "Group Units",
            "gen-ungroup-units":        "Ungroup Units",
            "gen-group":                "Group",
            "ungroup-units-tip":        "Ungroups all stacked units.",
            "group-units-tip":          "Group or stack multiple units together of the same type (improves performance).",
            "aquaring-description":     "A small offshore ring made of dirt reinforced with Ore for extracting Salt Water.",
            "aquascrubber-description": "A crude gravity filtration system that converts Salt Water into pure drinking Water.",
            "seabeetfarm-description":  "A small offshore agricultural platform for growing Seabeets, a sugar-rich aquatic vegetable from Zolarg Prime.",
            "aquamound-description":    "Higher class off-shore housing for an Insectoid family who can afford to live on the water, and away from the common nest.",
            "claypit-description":      "It might be messy, but an Insectoid feels great about himself after spending a day working in these Clay Pits.",
            "smolderingpit-description":"Throw a bunch of Wood and Sugar into a pit and light it on fire!  There is a lot of waste, but eventually, some Charcoal comes out.",
            "quantumsupplypile-description":"A mid-grade alien-tech infused upgrade to the Supply Pile, good for non-independent colonies that cannot build the Unholy Pit of Stuff.",
            "petroplant-description":   "Without regard for the environment, burn large amounts of Oil to produce electricity!",
            "microdistiller-description":"It's an offshore Salt Water Pump and Distiller combined into one compact unit!",
            "online-play-req-not":      "Online play requires a free Ape Apps Account.  Please sign in from the slide-out menu.  To create an account, visit https://accounts.ape-apps.com"   ,
            "gen-must-sign-in":         "Must be signed in to play!",
            "watervats2-description":   "Dug deeper and adorned with polished clay, your citizens will love gathering around and storing excess water in these lovely vats.",
            "houserunningrum-description":"A large public house in which high quality Food is served and Rum flows endlessly.  Hours of entertainment for citizens and tourists alike!",
            "laborcamp-description":    "A complex subterranean labor camp which employs and houses large amounts of insectoids, growing sugar and trees in an advanced underground process, while also conducting mining operations for Ore, Clay, and Gold.",
            "quantumfoodfortification-description":"Make the Quantum Leap in food processing with this alien-tech infused food fortification facility!  Creates an epic amount of food for a large population.",
            "megamound-description":    "A gigantic tourism structure specialised for holding a wide range of events, from sports to grand meetings.  Consumes Cloth, Food, and Water while producing Money, Civics and Research.  Also provides a small amount of shelters for workers.",
            "potterbugmound-description":"The worksite of a master Potterbug and his workers, where clay is baked into Pottery.",
            "megaconst-desc":           "Learn advanced building practices to start building large and tall structures that seem to defy gravity!",
            "insectdomin-desc":         "Learn to establish an absolute Insectoid Monarchy and exert control over your subjects across the galaxy.",
            "deluxecommand-description":"State of the art government command post for administering a far reaching Commonwealth or conducting business on a Federation level.",
            "unholytower-description":  "The ultimate storage unit for the Insectoid hoarder.  The only question you have to ask yourself, is will you ever be able to find something that you stuffed down into this unholy tower?",
            "glazedmound-description":  "When you need some more housing in the colony, try building this lovely glazed and painted Mound!",
            "smartpowerspire-description":"When simple Antaura based power isn't enough, throw some networking, microchips, and software into the mix and REALLY crank out the electricity!",
            "quantumslabofproc-description":"Nobody knew how to produce Bandwidth like the Ancients, so why try to improve on something that they already figured out?",
            "quantumwetcone-description":"Representing the ultimate in Wet Cone technology, for when you have a LOT of thirsty Insectoids to take care of.",
            "quantumcirfoundry-description":"Utilize ancient alien tech to crank out Microchips at a much faster rate.",
            "new-city-dest":            "Select new city build site",
            "unholygoldgrower-description":"Using the unholy power of Antaura and Crystalline, convert Ore and Antanium into Gold.",
            "crystalgenerationchamber-description":"This advanced mound facility takes massive amounts of Oil, Sugar, Ant Paste, and some Uranium, mixed with large amounts of Power, to create Crystalline.",
            "toweroftruth-description": "Spread 'truth' to the people, keeping them entertained (distracted) and generating some civics to go along with it.",
            "antaniumblastfurnace-description":"This giant furnace hardened with Obsidian will pump amount mass amounts of Antanium!",
            "etherreactor-description": "If you can get your hands on some Ether, you can generate large amounts of Power in a relatively small space.",
            "designatedswimarea-description":"Just a nice, safe, and relaxing area where Insectoids can swim without fear of being eaten by frogs!",
            "regobug-description":      "A hardy bug who loves to mine and collect Regolith!",
            "regolithincinerator-description":"Use Sugar to heat up Regolith to such a high degree that it breaks down into raw Ore.",
            "potofether-description":   "From childhood, young Insectoids hear tales of the magical Pot of Ether at the end of the rainbow.  Those are just fairy tales, but you can build your own Pot of Ether with a bit of Gold and some Ore and Regolith!",
            "etherbug-description":     "The only class of Insectoid who does not instantly die after ingesting Ether, so he is forces to live his life harvesting it.",
            "move-building-tip":        "Move this building to a different location.",
            "gen-move-building":        "Move Building",
            "galacticstargate-description":"An upgraded Star Gate for transporting more goods at higher levels.",
            "radcrystalfarm-description":"When you're tired of dealing with synthetic Crystalline deposits, use this facility to automate the process!  Just don't get too close to the reactor chamber...",
            "advmatsilo-description":   "Beef up your storage capacity with the advanced version of the Powered Materials Silo.",
            "subslum-description":      "Sometimes you just have a lot of people in your colony and you don't know where to store them all.  While cheap, homeless shelters are unsightly.  Reptilians have come up with a great solution - dig a deep hole and throw the homeless down in it!",
            "rawfishdiner-description": "One of the hottest hangouts for bored Reptilian citizens and tourists.  Come enjoy the WiFi as you feast on raw Fish and Rum!",
            "deepdrilling-description": "An offshore platform for extracting pure Crude Oil from the depths of the sea!",
            "coralradiator-description":"This small platform exposes naturally forming sea coral with extreme doses of radiation, breaking it down into trace amounts of Ore, Gold, and Aluminum.",
            "offshoreslum-description": "In an ongoing effort to combat the issue of extreme Reptilian homelessness, throw an old rusted out Galactic Freight container off shore and resettle the homeless there, so you do not have to worry about the issue of extreme Reptilian homelessness.",
            "dracarus-description":     "The Dracarus Mint is where Draconian gold coins are minted.  Although they are guaranteed by the Reptilians to be .999 fine Gold, they are actually made mostly of Ore.",
            "diamondextractor-description":"A handy drone that can extract raw Diamonds from the ground.",
            "cobaltextractor-description":"Specialized drone for extracting Cobalt from extreme environments.",
            "diamondcobaltreactor-description":"Cobalt is rare in these parts of the galaxy, but if you can get your hands on some, you can generate awesome amounts of power with this reactor.",
            "basiccrystalfurnace-description":"Just a cheap low-yield reactor for when you are desperate for power and low on resources.",
            "suppertimearena-description":"The Rum and Food flow while spectators from all over the galaxy watch as a giant hungry plant devours helpless insectoids.",
            "turbomicroreactor-description":"This reactor utilizes Helium 3 to turbo charge the output of the standard Advanced Microreactor.",
            "primativeroboticslab-description":"Although basic Robots are considered by Reptilians to be a childs toy, there are still some instances where they are useful in industry, so it's good to be able to produce them from time to time.",
            "advchiptransporter-description":"Utilizing a high gain antenna, robots, and more power, you can steal way more Microchips from across the galaxy with this advanced transporter unit.",
            "autoswnode-description":   "It may look like just a large hockey puck connected to a WiFi antenna, but there is actually a robot in there rapidly churning out software.",
            "antradiator-description":  "A robot-operated plate that uses massive amounts of radiation to create Triantanium, but sometimes the process fails and creates steel.  Even though the process is done out in the open, Reptilian authorities promise that there is no health concern with the radiation...",
            "uhfnode-description":      "When you need serious bandwidth, you need to start building these large Ultra High Frequency nodes.",
            "nimatsilo-description":    "Built with rare materials and consuming Robots, Ether, Software and Uranium during operation, this is an expensive storage unit to built and maintain, but it will give you just about all of the storage you will ever need.",
            "river-template":           "River Template",
            "river-template-desc":      "This map type includes both land and river tiles.  Do you want the system to generate the river terrain for you, or would up like to import a template image?  A template image is a 250x250px black and white image (suggested), with white representing land and black representing river tiles.",
            "river-template-auto":      "Automatic",
            "river-template-image":     "Image File",
            "unexplored-territory":     "Unexplored Territory",
            "mail-not-available":       "No Longer Available",
            "mail-not-available-info":  "The message you selected is no longer available on the server.",
            "save-switch-city-ask":     "Do you want to switch to city: ",
            "gen-switch":               "Switch",
            "etherrover-description":   "A basic rover built for collecting and transporting Ether.",
            "etherstorage-description": "When you need to store Ether on the cheap, just set it out on the sidewalk.",
            "gen-utilities":            "Utilities",
            "select-disp-mode":         "Select Display Mode",
            "gen-default":              "Default",
            "disp-trans":               "Semi-Transparent",
            "disp-bld-colors":          "Building Colors Only",
            "disp-ent-coverage":        "Entertainment Coverage Heatmap",
            "disp-med-coverage":        "Medical Coverage Heatmap",
            "disp-edu-coverage":        "Education Coverage Heatmap",
            "disp-cri-coverage":        "Crime Heatmap",
            "disp-lnv-coverage":        "Land Value Heatmap",
            "intclinic-description":    "A more advanced small clinic, using AI and network technology to get patients in and out in just a few hours!",
            "gen-tot-births":           "Total Births",
            "gen-age-distro":           "Age Distribution",
            "prod-cap-heatmap":         "Production Capacity Heatmap",
            "total-play-time":          "Total Play Time",
            "colony-age":               "Colony Age (Game Time)",
            "gen-prop-value":           "Property Valuation",
            "gen-overall-value":        "Overall Value",
            "gen-entertainment-avail":  "Entertainment Access",
            "gen-education-avail":      "Education Access",
            "gen-medical-avail":        "Medical Access",
            "gen-building-condition":   "Structural Condition",
            "gen-factors":              "Factors",
            "gen-commute-rating":       "Daily Commute Rating",
            "gen-safety-rating":        "Safety Rating",
            "gen-accessability-rating": "Accessability Rating",
            "gen-workforce-rating":     "Workforce Rating",
            "health-crisis-warning":    "There is an ongoing health crisis in #cityname.  Will #governorname do anything about it?",
            "gen-city-leader-name":     "The Governor",
            "hospital-description":     "When you need to heal a lot of sick colonists, you need a hospital!  Take care of the sick and elderly, and charge up to $500 per asprin on their way out!",
            "university-description":   "A center of knowledge and research for the colony!  Train the next generation of high-tech workers.",
            "pasteclinic-description":  "In this state of the art clinic, a refined Ant Paste mixture is injected into the blood of the patient, somehow causing health.",
            "deport-elderly":           "Deport the Elderly",
            "deport-elderly-desc":      "Kick anybody over the age of 65 out of #cityname.  They can go and enjoy their golden years somewhere else!",
            "generating-terrain":       "Generating Terrain",
            "generating-terrain-desc":  "Please wait while the global terrain features for the region are generated.  This could take a minute.",
            "small-scr-new-reg-help":   "Welcome to your new region.  To get started, click on the Build icon to found your first city!"
        },
        "fr": {
            "new-game-message":         "Commandant, nous venons d'atterrir et nous sommes prêts à fonder une nouvelle colonie. Comment devrions nous la nommer?",
            "welcome-message":          "Bienvenue!  Vous avez fondé une nouvelle colonie sous la charte coloniale  de #motherland.  Votre but est de transformer cette planète déserte en une civilisation florissante. Pour commencer, sélectionnez votre Rover et faites le miner. Une fois que vous aurez au moins 5 Minerai, sélectionnez votre Atterrisseur et construisez un deuxième Rover.",
            "rover-description":        "Le Rover est le robot de base de la colonie. Il peut miner du minerai et construire des bâtiments de base.",
            "lander-description":       "Vous avez atterri ici, dedans.",
            "mine-description":        "Extrait du minerai brut du sol. Utilisez vos Rovers pour le récolter.",
            "pavement-description":        "Ajoute une touche de décoration et accélère le déplacement des véhicules.",
            "greenhouse-description":        "Une structure de base pour cultiver de la nourriture pour la colonie.",
            "silo-description":        "Stocke la nourriture vitale nécessaire à la colonie.",
            "atmosgen-description":        "Un petit bâtiment qui génère lentement de l’atmosphère, pour commencer à  terraformer votre planète.",
            "factory-description":        "Une petite usine capable de produire plusieurs véhicules de taille moyenne. Génère également des traces d’atmosphère et produit des roues.",
            "builder-description":        "Cet incroyable petit robot vous aidera à  commencer à  bâtir votre colonie!",
            "beta-info":        "My Colony est un nouveau jeu de stratégie et de simulation de construction de colonies actuellement en bêta. Pour le moment, il n’y a pas vraiment de but dans le jeu, mais jouez y, puis intégrez la communauté du forum avec vos commentaires et suggestions sur ce que je peux ajouter pour en faire un jeu de colonisation entièrement fonctionnel!",
            "lander-sell-warning":        "Sans vouloir dicter votre conduite, mais ce n'est généralement pas une bonne idée de vendre l’atterrisseur avant d'avoir la certitude que vous n'en avez plus besoin. C'est la seule façon de récolter le minerai au début du jeu, et vous ne pouvez pas en construire un autre! Confirmez vous la vente?",
            "refinery-description":        "Une installation qui convertit le minerai brut en acier raffiné, nécessaire aux projets de construction avancés. Requiert des travailleurs pour fonctionner.",
            "miner-description":        "Ce robot peut récolter du minerai en surface et le transporter vers une raffinerie. Il peut également creuser une nouvelle mine.",
            "small-panel-description":        "Génère une quantité modeste d'électricité pour la colonie de manière autonome.",
            "landing-pad-description":        "Une fois que vous avez construit un pod de débarquement, de nouveaux colons commencent périodiquement à arriver dans votre colonie.",
            "small-shelter-description":        "Logement de base des colons. Fournit un abri pour 3 colons.",
            "chop-shop-description":        "Recycle les vieux rovers inutilisés en matières premières.",
            "goldminer-description":        "Extrait l'or des dépôts et le transporte à une raffinerie d'or.",
            "goldrefinery-description":        "Convertit l’or brut extrait du sol en or pur.",
            "goldsmelter-description":        "Génère de la monnaie à partir d'or pur.",
            "hire-button-change-job":        "Changer d’emploi",
            "hire-button-hire":        "Employer",
            "object-sell":        "Vendre",
            "object-remove":        "Retirer",
            "side-menu-game-data":        "Données de jeu",
            "delete-game-confirm":        "Êtes-vous sûr de vouloir supprimer votre colonie?",
            "header-delete-colony":        "Supprimer la colonie",
            "tax-window-header":        "Taxe #motherland",
            "tax-window-content":        "L'Assemblée Générale de #motherland a le plaisir de vous informer que votre colonie prospère doit payer des impôts au peuple de #motherland.",
            "tax-window-owed-header":        "Taxe dûe:",
            "tax-window-pay":        "Payer",
            "tax-window-reject":        "Rejeter",
            "tax-window-pay-response":        "Le peuple de #motherland vous remercie de votre contribution.",
            "tax-window-reject-response":        "l'Assemblée Générale de #motherland vous rappelle que le respect de la loi est obligatoire. Nous y reviendrons plus tard.",
            "adv-hydro-desc":        "Débloquez des techniques avancées pour la culture hydroponique de nourriture.",
            "hd-solar-desc":        "Technologie de panneaux solaires améliorée pouvant générer plus d’énergie sur une même surface.",
            "smalllab-description":        "Rassemblez une petite équipe pour mener d'excellentes expériences et déverrouiller de nouvelles technologies!",
            "advancedhydro-description":        "Installation de haute technologie pour cultiver de grandes quantités de nourriture. Requiert des travailleurs pour fonctionner.",
            "solar-tower-description":        "Une tour à cellules solaires haute densité. Fournit une bonne quantité d'énergie avec un encombrement minimal.",
            "adv-ore-pur-desc":        "Découvrez des méthodes avancées de raffinage du minerai brut en acier solide.",
            "builder2-description":        "Un robot de construction amélioré permettant de créer des structures plus avancées.",
            "construction-2-desc":        "Déverrouillez des méthodes de construction avancées pour bâtir de nouvelles structures et construire de nouveaux véhicules.",
            "pavement2-description":        "Chaussée très dure, consolidée à l’acier. Assez cher, mais permet un déplacement très rapide des véhicules.",
            "silo2-description":        "Grand silo de stockage de nourriture qui peut contenir beaucoup de nourriture pour vos colons.",
            "finance-theory-desc":        "Étudiez les théories et les méthodes autour de l'argent et des finances appliquées aux colonies spatiales.",
            "refinery2-description":        "Convertissez le minerai brut en acier plus rapidement et avec une efficacité presque cinq fois supérieure à  celle d'une raffinerie classique. Requiert des ouvriers pour fonctionner.",
            "adv-gold-desc":        "Permet la construction de nouvelles mines d'or.",
            "goldmine-description":        "Creusez une nouvelle mine d'or pour extraire l'or brut du sol.",
            "rescomplex-description":        "Une résidence de taille moyenne pour 26 colons.",
            "greendome-description":        "Un dôme vert permet des loisirs gratuits à vos colons, pour qu'ils ne deviennent pas fous.",
            "massdriver-description":        "Une catapulte électromagnétique avancée à haute énergie qui vous permet de renvoyer des produits bruts vers la colonie mère en échange d'argent. Nécessite des travailleurs et génère également un peu d’argent en plus.",
            "lg-manufacturing-desc":        "Débloquer les moyens de fabriquer des biens de consommation dans les environnements hostiles de votre colonie.",
            "chipfactory-description":        "L'usine de micropuces emploie 26 personnes et convertit l’'or brut en micropuces.",
            "tax-payment-thankyou":        "#motherland vous remercie pour votre obéissance.",
            "tax-payment-insufficient":        "Votre paiement d'impôt à l'Assemblée Générale de #motherland est insuffisant. L'argent dû s'accumule.",
            "stage-1-intro":        "L'atmosphère de la planète est maintenant assez épaisse pour permettre une vie microbienne de base!",
            "stage-2-intro":        "Au fur et à mesure que l'atmosphère de la planète grandit, de petites plantes commencent à sortir du sol.",
            "stage-3-intro":        "Le niveau d’atmosphère est maintenant similaire à celui sur Terre, permettant des activités en plein air régulières!",
            "col-civics-desc":        "Commencez à former un gouvernement colonial, à édifier des structures civiques et à adopter des lois pour votre peuple!",
            "atmosgen2-description":        "Un générateur d’atmosphère plus efficace et plus puissant.",
            "civiccenter-description":        "Commencez à construire votre gouvernance coloniale avec le centre civique. Nécessite de l'argent et des politiciens pour fonctionner. Génère du civisme.",
            "statue1-description":        "Dédié aux braves colons qui ont foulé pour la première fois ce sol.",
            "fracking-description":        "Une méthode de haute technologie et de haute énergie pour extraire le minerai du sol, sans avoir besoin d'un rover. Nécessite des ouvriers et de l'énergie.",
            "adv-chem-desc":        "Découvrez les secrets de la transformation de certains éléments en d'autres grâce à la science de la chimie.",
            "gldsynth-description":        "Un petit laboratoire scientifique capable de convertir du minerai brut en or! Nécessite des ouvriers et beaucoup d'énergie.",
            "la-zoology-desc":        "Commencer dès maintenant le développement de l'élevage d'animaux sauvages dans des conditions de basse atmosphère.",
            "hatchery-description":        "Cultivez de délicieux poissons pour la consommation des colons. Les Poissons!",
            "icechipper-description":        "Un rover petit et agile, capable de récupérer l’eau dans les dépôts de glace et de la restituer à la colonie.",
            "waterbot-description":        "Un rover petit et agile, capable de récupérer l’eau dans les dépôts de glace et d'eau et de la restituer à la colonie.",
            "atmoscondensor-description":        "Extrait l'atmosphère de l'air et la condense en eau potable pure.",
            "pet-expansion-desc":        "Achetez une concession de terre auprès de l'Assemblée générale de #motherland pour étendre votre colonie.",
            "pet-annex-desc":        "Développez votre territoire colonial sans le consentement de l'Assemblée générale de #motherland. Peut déclencher une réponse hostile.",
            "smalltank-description":        "Stockez et distribuez de l'eau fraîche à vos colons.",
            "waterpump-description":        "Pompez et filtrez de petites quantités d’eau douce sous la surface de la planète.",
            "aluminumrefinery-description":        "Construisez des rovers mineurs d'aluminium et récoltez de l'aluminium dans les gisements.",
            "watertower-description":        "Stockez de plus grandes quantités d’eau pour étancher la soif de vos colons",
            "adv-microbio-desc":        "Étudiez les secrets de la croissance des organismes vivants dans un environnement de faible atmosphère.",
            "new-game":        "Nouveau jeu",
            "new-game-col-name":        "Nom de la colonie",
            "custom-map-name":        "Nom de la carte",
            "map-size-header":        "Taille de la carte",
            "map-size-small":        "Petite",
            "map-size-medium":        "Moyenne",
            "map-size-large":        "Grande",
            "resources-header":        "Ressources",
            "resources-scarce":        "Rares",
            "resources-normal":        "Ordinaires",
            "resources-abundant":        "Abondantes",
            "nuke-physics-desc":        "Apprenez à récolter et à raffiner l’uranium pour la production d’énergie nucléaire sous une faible atmosphère",
            "uraniumminer-description":        "Récolte l'uranium des gisements et le transporte vers une centrale nucléaire.",
            "nuclearplant-description":        "Convertissez et raffinez l’uranium brut en électricité pour votre colonie.",
            "bacteriafarm-description":        "Commencez à cultiver des formes de vie microbiennes qui génèreront une atmosphère pour la planète.",
            "greenbot-description":        "Un petit rover bien pratique pouvant construire des structures liées à l'agriculture.",
            "firtrees-description":        "Ces nobles sapins poussent bien dans un environnements de faible atmosphère. Ils peuvent être décoratifs, ou récoltés pour le bois.",
            "engine-keyboard":        "Contrôles du clavier",
            "engine-keyboard-meta":        "Personnaliser les raccourcis clavier pour le jeu.",
            "general-cancel":        "Annuler",
            "keyboard-clear-menus":        "Effacer les dialogues actifs",
            "keyboard-idle-unit":        "Trouver un véhicule inactif",
            "keyboard-sell-noconf":        "Vendre un bâtiment sans confirmation",
            "hold-and-click-tip":        "Maintenez la combinaison de touches et cliquez sur le bâtiment.",
            "keyboard-upgrade-noconf":        "Amélioration du bâtiment sans confirmation",
            "when-object-selected":        "Actif quand l'objet est sélectionné",
            "keyboard-move-unit":        "Déplacer l'unité active",
            "keyboard-harvest-mode":        "Activer le mode de récolte",
            "keyboard-show-build":        "Afficher les options de construction",
            "keyboard-show-export":        "Afficher les options d'exportation",
            "keyboard-show-import":        "Afficher les options d'importation",
            "keyboard-sell":        "Vendre l'objet actif",
            "keyboard-upgrade":        "Mettre à jour l'objet actif",
            "keyboard-defaults":        "Réinitialiser",
            "keyboard-defaults-warn":        "Cela effacera toutes les affectations personnalisées!",
            "keyboard-cancel-nocon":        "Annuler la construction sans confirmation",
            "keyboard-cancel":        "Annuler la construction",
            "general-move":        "Déplacer",
            "general-harvest":        "Récolter",
            "general-build":        "Construire",
            "general-upgrade":        "Améliorer",
            "general-import":        "Importer",
            "general-export":        "Exporter",
            "general-dismiss":        "Fermer ce menu",
            "medicalclinic-description":        "Fournit aux colons des services de santé.",
            "general-park-unit":        "Stationner",
            "general-park-confirm":        "Emplacement de stationnement enregistré",
            "engine-sidebar":        "Interface de la barre latérale",
            "tax-window-trade-embargo":        "Suite au non-paiement répété des taxes aux habitants de #motherland, l’Assemblée Générale de #motherland impose un embargo commercial à votre colonie!",
            "tax-window-lift-embargo":        "L’Assemblée générale de #motherland a gracieusement levé l’embargo commercial à l'encontre de votre colonie.",
            "tax-window-img-embargo":        "En raison de la détérioration des relations avec les habitants de #motherland, l'Assemblée Générale de #motherland impose un gel complet de l'immigration dans votre colonie!",
            "tax-window-img-lift":        "L’Assemblée générale de #motherland a provisoirement rétabli l’immigration dans votre colonie.",
            "wall-description":        "Enmurez des zones de votre colonie pour décorer ou pour organiser et guider le trafic des véhicules.",
            "lumbermill-description":        "Transforme les arbres en bois utilisable.",
            "lumberbot-description":        "Ce récolteur peut couper les arbres et en planter de nouveaux!",
            "sfhouse-description":        "Emmenez votre femme et vos enfants dans cette chaleureuse  maison en bois pour une famille.",
            "megabot-description":    "Un robot de construction robuste pour entreprendre des projets de grande envergure.",
            "urenrich-description":        "Représentant un exploit d'ingénierie et de science, cette installation peut doubler la densité de l'uranium. Nécessite beaucoup d'énergie et un flux constant d'aluminium.",
            "lgwatertower-description":        "Un château d'eau géant qui contient des tonnes d'eau. Que demander de plus?",
            "largeres-description":        "Structure de logements à haute densité. Ce n'est pas la plus luxueuse, mais elle héberge beaucoup de monde à moindre coût.",
            "indepence-noafford":        "Vous ne pouvez pas vous permettre de déclarer votre indépendance de #motherland.",
            "independence-general":        "Indépendance",
            "general-united-earth":        "United Earth",
            "relations-header":        "Relations avec #motherland",
            "foundation-header":        "Fondation",
            "foundation-charter":        "Sous la charte coloniale de #motherland le",
            "independence-ask":        "Souhaitez-vous déclarer votre indépendance de #motherland pour #cost?",
            "general-nevermind":        "Annuler",
            "independence-declare":        "Déclarer",
            "independence-final":        "Nous avons déclaré notre indépendance de #motherland le #independenceday!",
            "independence-stat":        "De #motherland le",
            "selfgov-desc":        "Apprenez les méthodes et les procédures à suivre pour gérer un gouvernement indépendant et autonome.",
            "capitol-description":        "Construisez un grand Capitole pour votre nouvel État indépendant!",
            "subtfood-description":        "Une installation souterraine à climat contrôlé permettant de stocker de grandes quantités de nourriture.",
            "empire-general":        "Commonwealth",
            "engine-zoom-buttons":        "Afficher les boutons de zoom",
            "lgcons-desc":        "Découvrez les secrets de la très haute construction dans un environnement de faible gravité!",
            "treefarm-description":        "Fait pousser des arbres et les récolte pour leur bois.",
            "aluminumminer-description":        "Un robot robuste et pratique qui exploitera les gisements d'aluminium.",
            "new-game-charter":        "Code de la charte coloniale (facultatif)",
            "charter-warning":        "Le lancement d'un nouveau jeu sous une charte coloniale importera certaines données de jeu générées par des utilisateurs, qui ne sont pas forcément filtrées par Ape Apps. Cela pourrait inclure un langage potentiellement offensant. Êtes-vous sûr de vouloir commencer un nouveau jeu sous cette charte?",
            "general-charter":        "Charte coloniale",
            "general-yes":        "Oui",
            "general-no":        "Non",
            "charter-info":        "Vous pouvez partager votre identifiant de charte coloniale avec des amis et les laisser commencer un nouveau jeu sur leur appareil, en utilisant votre charte. Vous percevrez des revenus sur les impôts qu’ils paient et vous pourrez échanger des ressources avec eux. Votre identifiant de charte est #charterid",
            "charter-share":        "Joue à My Colony avec l’identifiant de charte #charterid #appurl",
            "general-share":        "Partager",
            "charter-settings-desc":        "Partagez votre charte et développez votre Commonwealth!",
            "tax-collection-message":        "Vous venez de percevoir un impôt des colonies de votre Commonwealth!",
            "bank-description":        "Une banque où votre population va stocker et gérer son argent. Génère de l'argent et de l'éducation civique.",
            "gdp-general":        "Produit intérieur brut",
            "gdp-description":        "La valeur totale de votre économie.",
            "general-trade":        "Commercer",
            "general-buy":        "Acheter",
            "general-sell":        "Vendre",
            "no-contracts":        "Il n'y a actuellement aucun contrat disponible à la vente!",
            "select-resource":        "Sélectionner une ressource",
            "available-contracts":        "Contrats disponibles",
            "multiples-notice":        "Doit être multiple de 100.",
            "sell-amount":        "Montant à vendre:",
            "buy-amount":        "Montant à acheter:",
            "sell-price":        "Prix par 100:",
            "boardoftrade-description":        "Achetez et vendez des ressources sur le marché intergalactique! Nécessite une connexion Internet.",
            "lrc-desc":        "Débloquez la technologie des communications interplanétaires en temps réel.",
            "galcom-desc":        "Développez votre colonie en ouvrant des opportunités économiques dans toute la galaxie!",
            "pyramideye-description":        "Cette mégastructure mystique peut procurer du divertissement bon marché à des centaines de colons. Dans des milliers d’années, des archéologues la découvriront et se demanderont à quoi elle servait. Une tombe pour les rois et les dieux? Une ancienne centrale électrique extraterrestre? Non, juste un piège à touristes bien fait.",
            "stage-4-intro":        "Votre peuple commence à se plaindre du smog dans l’air.",
            "general-multiple":        "Unités multiples",
            "deepexc-desc":        "Apprenez à creuser de très profonds trous dans le sol.",
            "digsite-description":        "Quels secrets cette planète cache-t-elle? Creusez un trou géant dans le sol pour le découvrir!",
            "colonial-website":        "Site colonial",
            "rename-colony":        "Renommer la colonie",
            "rename-desc":        "Vous aviez choisi un nom stupide pour votre colonie? Choisissez-en un nouveau!",
            "aal-desc":        "Une fois que vous aurez découvert les secrets contenus dans les anciens artefacts extraterrestres, vous serez en mesure d'exploiter leurs incroyables pouvoirs!",
            "aluminumgenerator-description":        "Les anciens extraterrestres de ce monde détenaient la méthode secrète pour transformer l'acier en aluminium! Le bâtiment est coûteux et nécessite beaucoup de puissance. Nécessite également un flux d’eau constant pour éviter la surchauffe.",
            "etbuilder-description":        "Un robot de construction très avancé, créé à l’aide des instructions décodées des anciens extraterrestres. Personne ne sait comment, mais ça fonctionne.",
            "giorgioinstitute-description":        "Vous pouvez vous demander: est-il possible que cette institution de recherche puisse stocker des artefacts extraterrestres et générer de la recherche?",
            "cloud-save":        "Synchronisation dans le nuage",
            "cloud-save-description":        "Une fois connecté à Facebook, vous pouvez choisir de synchroniser votre fichier de sauvegarde dans le nuage. Cette fonction est pratique si vous jouez sur plusieurs appareils, mais utilise des données et peut potentiellement provoquer des erreurs de sauvegarde et une corruption des données du jeu sur les connexions Internet lentes, telles que sur les appareils mobiles.",
            "consulate-description":        "Le consulat est la plaque tournante qui relie votre colonie à #motherland. C'est là que vous pouvez gérer toutes les affaires liées à votre statut au sien du Commonwealth.",
            "new-game-random-charter":        "Charte coloniale aléatoire",
            "general-delete":        "Effacer",
            "distillery-description":        "Convertit la nourriture et l'eau en rhum! Le rhum apporte du bonheur au sein de la population.",
            "brewing-desc":        "Apprenez à produire du rhum dans un environnement de faible gravité.",
            "rumcellar-description":        "Une petite cave climatisée pour le stocker le précieux rhum.",
            "general-approval":        "Popularité",
            "relaybooth-description":        "Permet aux colons d'accéder à une ligne Internet directe vers #motherland, pour qu'ils puissent se divertir en regardant des vidéos de chats. Augmente également le QI, permettant aux colons d’occuper de meilleurs emplois.",
            "general-policy":        "Politique",
            "general-payroll":        "Salaires",
            "payroll-notice":        "Il est temps de payer vos ouvriers. Les coûts salariaux totaux pour cette période sont de #payrollcost.",
            "payroll-motherland":        "Étant donné que que vous faites partie du Commonwealth de #motherland, #motheroffset sera facturé à #motherland dans le cadre de l’aide financière sur les coûts salariaux.",
            "payroll-reject":        "Vous avez décidé de ne pas payer vos ouvriers!",
            "payroll-insufficient":        "Vous n'aviez pas assez d'argent pour payer tout le monde. Certains travailleurs vont avoir faim.",
            "payroll-motherland-collect":        "Aide financière de #motherland.",
            "saving-dont-quit":        "Merci de ne pas quitter le jeu avant la fin de la sauvegarde!",
            "tax-pay":        "Payer",
            "general-sound-xf":        "Effets sonores",
            "pub-description":        "Transformez le rhum en bonheur! Pour une modique somme, les colons peuvent s'arrêter au pub et oublier leurs problèmes quotidiens.",
            "general-destruct":        "Auto-destruction",
            "general-labor":        "Main d'oeuvre",
            "labor-desc":        "Gérer les salaires des différentes professions",
            "general-contine":        "Retour au jeu",
            "general-new":        "Nouvelle colonie",
            "general-load":        "Chargement de la colonie",
            "general-options":        "Plus d'options",
            "general-execute":        "Exécuter",
            "execute-confirm":        "Êtes-vous sûr de vouloir exécuter et prendre tout l'argent de #colonist? Votre peuple peut désapprouver ce comportement.",
            "general-destroy":        "Détruire",
            "decfirtrees-description":        "Pourquoi planter de simples sapins naturels quand vous pouvez planter de jolies décorations, qui ne seront pas récoltées par les rovers?",
            "cloning-desc":        "À l'avenir, les humains dans l'espace ne se reproduiront plus de manière naturelle. C'est là que le clonage humain intervient.",
            "cloningfacility-description":        "Une installation industrielle de haute technologie pour la croissance de nouveaux colons dans un environnement de laboratoire.",
            "claymine-description":        "Lorsque vous avez une atmosphère assez dense, vous pouvez commencer à travailler le sol avec de l’eau pour créer et extraire de l’argile pour la transformer plus tard en poterie fine.",
            "clayprod-desc":        "Utilisez la chimie, la culture hydroponique et la microbiologie pour produire de l'argile à partir du sol stérile des planètes.",
            "general-activate":        "Activer",
            "general-deactivate":        "Désactiver",
            "general-activate-all":        "Activer tout",
            "general-deactivate-all":        "Désactiver tout",
            "claybot-description":        "Un rover amusant conçu pour creuser et récolter de l'argile.",
            "potteryworks-description":        "Raffine l'argile et en fait de la poterie. Nécessite un débit d'eau constant pour fonctionner.",
            "warehouse-description":        "Fournit un espace de stockage supplémentaire pour une toute une gamme de produits manufacturés durables.",
            "subhousing-description":        "Certaines personnes aiment simplement vivre sous terre. Ce grand complexe souterrain peut accueillir de nombreux résidents dans un environnement contrôlé.",
            "chipfactory2-description":        "Une version plus grande et plus efficace de l’usine de micropuces : production plus rapide et plus de stockage.",
            "chipfactory3-description":        "Une usine avancée construite à l'aide d'anciennes technologies extraterrestres pouvant produire un grand nombre de puces. Nécessite un flux d'eau constant pour rester au frais. Utilise des artefacts exotiques pendant la production.",
            "aam-desc":        "Découvrez les antiques secrets utilisés pour la construction sur cette planète il y a des millions d'années.",
            "masonry-desc":        "Apprenez à créer des briques solides à partir d’argile dans un environnement de faible gravité.",
            "brickroad-description":        "Plus rapide que la chaussée normale, une route de brique est un bon moyen d'agrémenter votre colonie.",
            "brickfactory-description":        "Convertissez l'argile en briques solides pour débloquer des options de construction supplémentaires. Nécessite un flux d'eau constant pour fonctionner.",
            "ybrickroad-description":        "Le nec plus ultra du style colonial. Laissez vos colons suivre le chemin de la brique jaune vers la gloire!",
            "warehouse2-description":        "Ce charmant entrepôt en brique constitue le complément idéal à toute colonie industrielle.",
            "brickhouse-description":        "Il faudrait être fou pour ne pas vouloir vivre dans cette jolie maison en briques.",
            "husbandry-desc":        "Apprenez à élever de gros animaux dans un environnement à faible gravité.",
            "sheepfarm-description":        "Élevez des moutons pour la production de laine! Nécessite un flux d'eau constant.",
            "textilemill-description":        "Convertissez la laine brute en tissu, un bien raffiné que vos colons adoreront.",
            "sweatshop-description":        "Venez travailler à l’endroit où vivent les profits et où meurent les rêves! Les travailleurs de cet atelier de confection transformeront le tissu en bénéfices bruts avec de bas salaires et aucun bénéfice!",
            "luxtower-description":        "Là où les puissants de la société vont vivre, travailler et se divertir. Le rhum doit couler à flots pour ces élites.",
            "aliencondensor-description":        "Les anciens de ce monde ont su transformer de grandes quantités d’atmosphère en eau. Attention, veillez à ce que votre atmosphère ne soit pas trop absorbée.",
            "cst-desc":        "97% des scientifiques de la colonie pensent que le réchauffement climatique va détruire la planète. Recherchez des moyens de le résoudre.",
            "hydropower-description":        "Cette centrale incroyablement puissante peut convertir l'eau en énergie brute! Imaginez toutes les possibilités!",
            "largepark-description":        "Un parc géant, offrant des divertissements publics et gratuits pour vos colons. Donne l’impression aux gens d'être de retour sur #motherland.",
            "waterpool-description":        "Un carré d'eau peu profond pour rendre votre colonie plus jolie.",
            "lol-description":        "Faites savoir à la galaxie que votre colonie accepte les travailleurs pauvres et fatigués avec l’Atterrisseur de la Liberté!",
            "human-description":        "L'espèce dominante sur Terre. Si vous jouez à ce jeu, vous savez probablement ce qu'est un humain.",
            "red-planet-desc":        "La planète déserte typique. Â peut-être soutenu la vie il y a des millions d'années, mais aujourd'hui il n'y a plus rien ici. Possède des ressources diversifiées.",
            "ue-description":        "La fière planète Terre abrite l'espèce humaine, gouvernée par l'Assemblée générale de la Terre Unifiée. Bien que créée sous prétexte de promouvoir la paix et la stabilité, elle contrôle maintenant le système solaire avec une main de fer.",
            "premium-notice":        "My Colony est gratuite, mais des fonctionnalités supplémentaires sont disponibles pour les joueurs qui ont soutenu le jeu financièrement. Il existe #premiumcount structures et des véhicules disponibles uniquement pour les utilisateurs ayant acheté la version sans publicité du jeu. Ces structures sont uniquement de nature décorative et n’ont pas d’impact significatif sur le gameplay. Les utilisateurs Premium peuvent également faire pivoter certains bâtiments. Les utilisateurs Premium débloquent également la possibilité de personnaliser leur jeu à l'aide de mods. Un contenu premium plus exclusif sera ajouté régulièrement. Souhaitez-vous passer à l'expérience premium sans publicité?",
            "statue2-description":        "Cette statue est un symbole de pouvoir et d'autorité, montrant à tous que vous avez déclaré ces terres comme votre propriété!",
            "flowersred-description":        "Embellissez votre colonie avec ce charmant jardin de fleurs rouges!",
            "goldenshelter-description":        "Les puissants de votre colonie ne peuvent se résigner à vivre dans un petit refuge standard. Non, ils veulent un abri plaqué or.",
            "general-offers":        "Offres",
            "general-new-offer":        "Nouvelle offre",
            "hipsterbar-description":        "Lorsque vous êtes prêt à écouter de la musique live d'un groupe dont vous n'avez jamais entendu parler, à payer des tarifs d'entrée qui draine la carte de crédit de votre père et un rhum qui coûte sept fois plus que prévu, vous êtes prêt à passer du temps au Bar Hipster !",
            "alienquantum-desc":        "Les anciens extraterrestres étaient des maîtres de la physique quantique. Maintenant, vous aussi pouvez déverrouiller leurs secrets et inaugurer une révolution technologique!",
            "warehouse3-description":        "Un bond en avant dans la technologie de stockage de biens durables! Requiert une tonne de puissance et un flux d'eau constant, mais peut exploiter la puissance de la mécanique quantique pour stocker énormément de marchandises dans un espace restreint.",
            "quantumwater-description":        "Exploitez l’ancienne technologie quantique extraterrestre pour stocker des quantités massives d’eau dans un petit volume. Nécessite de l'énergie et utilise également une partie de l'eau pour éviter la surchauffe ... Mais oui, l'eau est totalement potable.",
            "brickwall-description":        "C'est un mur normal, sauf qu'il est fait de briques, ce qui le rend en quelque sorte meilleur.",
            "largeclinic-description":        "Une version plus grande et plus importante de la clinique médicale. Soigne plus de gens, sauve plus de vies!",
            "rpbase-desc":        "La connaissance de base pour qui vient d’atterrir sur une planète rouge.",
            "hbase-desc":        "La connaissance de base pour qui commence à jouer avec la race humaine.",
            "uebase-desc":        "La connaissance de base qui vient avec la civilisation Terre Unie.",
            "lunbase-desc":        "La connaissance de base pour qui vient d’atterrir sur une planète lunaire",
            "lunar-planet-desc":        "Un monde lunaire sans vie, sans atmosphère et avec des ressources relativement faibles en début de partie. Un monde difficile sur lequel commencer, mais qui peut être avantageux plus tard.",
            "lunarrover-description":        "Un petit et joyeux rover conçu pour extraire de la régolithe et construire de petites structures dans un environnement lunaire.",
            "heltank-description":        "Un petit réservoir de stockage pour garder l’Hélium 3.",
            "regpath-description":        "Créez un joli chemin en gravier sur lequel vos rovers pourront circuler.",
            "waterextract-description":        "Écrase la régolithe brute pour extraire les petits cristaux de glace utilisés pour ensuite faire de l'eau potable. Nécessite un flux constant d’Hélium 3 pour fonctionner.",
            "regcompact-description":        "Broie de la régolithe brute en minerai.",
            "helextractor-description":        "Extraire des traces d'hélium 3 à partir de régolithe broyée.",
            "regmine-description":        "Creusez un trou dans le sol et commencez à en extraire de la régolithe!",
            "fwbase-desc":        "La connaissance de base pour qui vient d’atterrir sur une planète forestière.",
            "forest-planet-desc":        "Préparez-vous à la microgestion. Une planète difficile avec peu de ressources au début. Beaucoup d'arbres. Ne jouez pas cette carte pour la première fois.",
            "woodhut-description":        "Un petit abri en bois pour deux. Ce n’est pas l’endroit le plus confortable pour vivre, mais il est bon marché et fait son travail.",
            "forestrover-description":        "D'une manière ou d'une autre, la science a découvert comment fabriquer un rover mécanique complètement en bois. Comment est-ce possible ? Mais est-ce que ça importe? C'est un jeu!",
            "waterwell-description":        "Creusez un trou, extrayez-en de l'eau et buvez-la. Assez simple, en fait.",
            "potatopatch-description":        "Nécessite de l’eau et produit de délicieuses pommes de terre que vos colons pourront manger. Qui n'aime pas les pommes de terre?",
            "charcoalhut-description":        "Brûle du bois pour produire du charbon de bois. À partir de là, aucune limite!",
            "coalburn-description":        "Brûle du charbon de bois pour produire de l'électricité, vitale pour la colonie.",
            "coalcompact-description":        "Écrase tant le charbon de bois qu'il devient du minerai brut que vous pouvez utiliser comme matériau de construction!",
            "advcp-desc":        "Découvrez des moyens plus efficaces de brûler du bois en charbon de bois.",
            "charfactory-description":        "Amenez la cabane à charbon de bois dans l'âge moderne avec l'usine à charbon! Même concept que la cabane, mais en bien meilleur.",
            "oilref-desc":        "Apprenez les secrets de l'extraction du pétrole brut dans un environnement de faible gravité! Faites couler l'or noir!",
            "mulchpath-description":        "Obtenez pour vos rovers un terrain agréable en construisant ce beau chemin en copeaux de bois!",
            "oiltank-description":        "Un gros réservoir qui contient du pétrole brut.",
            "crudebot-description":        "Ce petit robot amusant sait se salir et travaille toute la journée dans les champs de pétrole.",
            "flowerswhite-description":        "Un jardin de fleurs blanches mettra un sourire sur votre visage. A moins que vous détestiez les fleurs.",
            "flowersblue-description":        "Y a-t-il quelque chose de meilleur dans cet univers qu'un jardin de fleurs bleues?",
            "flowerspurple-description":        "Ah, le jardin de fleurs pourpre. Un must-have dans n'importe quelle colonie qui se respecte.",
            "adv-chemsyn-desc":        "Passez à un niveau de connaissances chimiques supérieur! Créez de nouveaux composés à partir d’anciens, cela à une échelle industrielle.",
            "oilplant-description":        "Brûle du pétrole pour produire de l'électricité! Génère une petite quantité d’atmosphère durant le processus.",
            "grass-description":        "Une belle pelouse pour votre colonie. Peut se traverser à pied ou en rover. Créez votre propre espace vert rafraîchissant!",
            "quantumfood-description":        "Un structure de stockage quantique pour conserver des tonnes de nourriture. Requiert un apport constant d'eau pour éviter toute surchauffe.",
            "pavement5-description":        "Une chaussée très rapide sur laquelle vos rovers peuvent rouler. Vous devrez peut-être vous rendre au Marché Intergalactique pour obtenir toutes les ressources nécessaires.",
            "oilsynthlab-description":        "Utilisez le pouvoir de la science pour créer du pétrole en mélangeant du charbon de bois et de la nourriture.",
            "plastfact-description":        "Une nouvelle usine qui convertit votre vieux pétrole sale en un nouveau plastique propre!",
            "sweatshop2-description":        "Ici, vous pouvez transformer le plastique en jouets pour enfants tout en payant à vos travailleurs un salaire d’esclave!",
            "livingwage-header":        "Revenu minimum",
            "livingwage-desc":        "Fixez un revenu de base que tous les colons recevront (en plus de leur salaire normal), quel que soit leur emploi.",
            "firedrill-header":        "Exercice incendie",
            "firedrill-desc":        "Renvoye tous les colons de leur travail et expulse tous les résidents de leurs maisons. Réinitialise les statistiques de main d'œuvre et de logement et oblige tout le monde à se relocaliser.",
            "work-policy":        "Politique de travail",
            "work-policy-desc":        "Définissez la politique de travail globale de votre colonie.",
            "work-policy-normal":        "Ordinaire",
            "work-policy-normal-desc":        "Politique de travail régulière. Les colons sont libres de vivre leur journée comme ils l'entendent.",
            "work-policy-light":        "Légère",
            "work-policy-light-desc":        "Réduisez la journée de travail en donnant aux colons plus de temps pour se reposer et se détendre.",
            "work-policy-hard":        "Heures supplémentaires",
            "work-policy-hard-desc":        "Prolongez la journée de travail et imposez des heures supplémentaires à tous les travailleurs pour augmenter la production",
            "work-policy-extreme":        "Extrême",
            "work-policy-extreme-desc":        "Quand les temps sont durs et qu'il faut vraiment augmenter le rendement. Beaucoup de colons mourront au travail.",
            "general-go-back":        "Retour",
            "general-go-back-desc":        "Retour au menu précédent",
            "money-shower-header":        "Douche de billets",
            "money-shower-desc":        "Des problèmes avec vos colons? Jetez-leur de l'argent pour faire disparaître les problèmes! Distribuez de l'argent gratuitement à la population.",
            "tax-collection-header":        "Perception des taxes",
            "tax-collection-desc":        "Lorsque les caisses de l’État sont vides, utilisez ce décret pour imposer une taxe exceptionnelle de 25% de ses économies à chaque colon.",
            "spaceport-description":        "Le port spatial est la plaque tournante des transports de touristes de et vers la colonie. Cela amène une petite chance d'immigration clandestine. Consomme du civisme pendant le fonctionnement.",
            "coltour-desc":        "Découvrez les secrets pour attirer (et extraire de l’argent) des touristes interplanétaires.",
            "motel-description":        "Ce motel bon marché est l'endroit idéal pour les touristes venant se reposer en visitant votre colonie!",
            "general-tourism":        "Tourisme",
            "touress-desc":        "Découvrez des méthodes avancées pour attirer et prendre en charge les touristes visitant votre colonie.",
            "hotel-description":        "Un grand hôtel agréable où vos touristes séjournent. Nécessite un ravitaillement de tissu régulier, car les touristes aiment emporter les serviettes chez eux.",
            "smcasino-description":        "Faites entrer le grand passé du jeu dans votre colonie avec ce charmant petit casino! Attire les touristes et les colons et extrait de l’argent de leur portefeuille. Génère aussi de l'argent en plus par ses propres moyens.",
            "giftshop-description":        "Vous vous demandez ce que vous allez faire de toutes les poteries que vous avez fabriquées? Ne posez plus de questions! Ouvrez cette boutique de cadeaux et vendez-en aux touristes!",
            "tourtrap-desc":        "Apprenez à faire du tourisme de façon efficace avec les pièges à touristes!",
            "zoo-description":        "Toute colonie qui se respecte n’est pas complète sans un zoo! Donne accès à du divertissement pour les colons et touristes. Nécessite un flux constant de poterie pour son bon fonctionnement.",
            "bluehouse-description":        "L’endroit idéal pour un jeune couple pour fonder une famille. Cette maison bleue mènera à une vie pleine de souvenirs.",
            "pavement6-description":        "Embellissez le paysage avec ce pavé à carreaux fantaisistes. Elle n'est pas plus rapide qu’une chaussée normale, mais c'est certainement plus jolie.",
            "flowersyellow-description":        "Vous voyez ce carré de terre triste par ici? Pourquoi ne pas y construire un jardin de fleurs jaunes?",
            "obelisk-description":        "Un grand obélisque doré et brillant célébrant le pouvoir et l’indépendance de votre colonie.",
            "restaurant-description":        "Un petit trou dans le mur du restaurant avec une atmosphère agréable et une terrasse extérieure offre aux touristes un goût authentique de votre colonie!",
            "resort-description":        "Un grand complexe de luxe pour divertir beaucoup de touristes. Nécessite une approvisionnement de tissu régulier pendant le fonctionnement.",
            "mall-description":        "Grand centre commercial en plein air conçu pour aspirer l'argent des touristes et des colons! Nécessite beaucoup de puissance et de main d'œuvre, ainsi qu'un flux continu de tissu et de jouets.",
            "general-private-charter":        "Confidentialité de la charte",
            "general-private-desc":        "Décidez si votre charte coloniale est privée ou publique. Si définie sur public, votre colonie apparaîtra sur la liste des chartes aléatoires vue par les joueurs démarrant une nouvelle colonie.",
            "general-private":        "Privée",
            "general-public":        "Publique",
            "map-size-mega":        "Méga",
            "map-size-xlarge":        "Extra large",
            "large-map-warning-title":        "Avertissement : grande planète",
            "large-map-warning-content":        "Sachez que les performances de jeu peuvent être affectées en jouant sur des planètes de grande taille. Êtes-vous sûr de vouloir jouer une planète aussi grosse?",
            "new-game-size-notice":        "Remarque: la taille de la carte peut avoir un impact sur les performances du jeu.",
            "online-mode":        "Mode en ligne",
            "online-mode-desc":        "Active le mode en ligne sur cette colonie. Le mode en ligne permet d'accéder au commerce en ligne, aux planètes du Commonwealth et donne à votre colonie un site Web. Votre jeu nécessitera une connexion Internet.",
            "offline-mode":        "Mode local",
            "offline-mode-desc":        "Basculez cette colonie en mode local. Vous perdrez l'accès au commerce en ligne et toutes les colonies du Commonwealth deviendront indépendantes. Votre jeu ne nécessitera plus de connexion Internet, mais vous pourrez effectuer des transactions et échanger des messages avec d'autres joueurs sur votre réseau local.",
            "offline-mode-warning":        "Êtes-vous sûr de vouloir passer en mode local? Les fonctionnalités en ligne telles que le Marché Intergalactique, le Commonwealth et le site Web colonial seront désactivées. Toutes les colonies créées en vertu de votre charte bénéficieront de l'indépendance. Cela ne peut pas être annulé.",
            "general-notice":        "Remarque",
            "blacklist-notice":        "Votre colonie a été bannie du jeu en ligne pour avoir triché. En tant que joueur hors ligne, tricher dans My Colony n'est pas découragé et est laissé à la discrétion du joueur. Toutefois, pour préserver l’intégrité du marché en ligne du jeu, les colonies contenant des niveaux de ressources hackés ne doivent pas être autorisées à jouer en ligne. Merci de votre compréhension.",
            "museum-description":        "Augmentez la stature de votre colonie avec ce beau musée. Attire des touristes et consomme de la poterie durant son exploitation.",
            "resources-report":        "Statistiques de production et d'utilisation des ressources entrantes et sortantes de la colonie.",
            "galfreight-description":        "Le chantier de fret galactique peut importer et exporter de plus grandes quantités de marchandises vers et depuis la colonie, via un grand conteneur d'envoi avec des propulseurs. Nécessite du pétrole pendant le fonctionnement.",
            "statue3-description":        "L'objet le plus cher du jeu, cette statue montrera à vos colons à quel point vous êtes riche et puissant, alors qu'ils sont étranglés par la pauvreté et le désespoir.",
            "udexc-desc":        "Exploitez le savoir des anciens extraterrestres pour creuser un trou plus grand que n’importe quel trou jamais creusé auparavant. Qui sait ce que vous pourriez y trouver?",
            "digsite2-description":        "Un site de fouilles archéologiques extrême qui descend des kilomètres dans le sol. Produit une plus grande quantité d'artefacts exotiques. Nécessite de l'eau pour fonctionner et produit de l'argile comme sous-produit des opérations.",
            "general-rename":        "Renommer",
            "rename-colonist":        "Choisissez un nouveau nom pour #colonist.",
            "keyboard-open-stats":        "Fenêtre des statistiques",
            "keyboard-open-tech":        "Afficher l'arbre technologique",
            "keyboard-open-encyclopedia":        "Ouvrir l’encyclopédie",
            "keyboard-open-unemployment":        "Voir les colons sans emploi",
            "keyboard-park":        "Garer l’unité",
            "keyboard-zoom-in":        "Zoomer",
            "keyboard-zoom-out":        "Dézoomer",
            "charcoalpile-description":        "Réservez un morceau terrain pour le stockage du charbon de bois. Ensuite, il suffit de tout jeter dedans.",
            "alienpower-description":        "Cette centrale insensée construite avec une ancienne technologie extraterrestre convertit l'hélium 3 en grandes quantités d'énergie brute.",
            "autosave-freq":        "Fréquence de sauvegarde automatique",
            "autosave-freq-desc":        "Choisissez la fréquence à laquelle le jeu sauvegarde automatiquement. Les performances du jeu sont affectées lors des sauvegardes.",
            "autosave-freq-often":        "Souvent",
            "autosave-freq-normal":        "Normal",
            "autosave-freq-rare":        "Rarement",
            "autosave-freq-never":        "Jamais",
            "autosave-often-warn":        "Des sauvegardes fréquentes peuvent dégrader les performances du jeu.",
            "autosave-never-warn":        "N'oubliez pas de sauvegarder votre jeu manuellement pour éviter toute perte de données!",
            "general-send-custom-msg":        "Envoyer le message",
            "general-send-msg-warn":        "Vous pouvez envoyer un message à une autre colonie, de 120 caractères maximum. Avertissement : l'envoi d'un message inapproprié, menaçant ou harcelant est un motif d’exclusion permanente de votre colonie du serveur en ligne sans recours.",
            "game-compression":        "Compression des sauvegardes",
            "game-compression-desc":        "La compression réduit considérablement la taille de vos fichiers de sauvegarde mais ralentit les opérations de sauvegarde et de chargement. Désactivez la compression va augmenter les durées de sauvegarde et de chargement. Vous ne pouvez utiliser la synchronisation dans le nuage que si la compression est activée.",
            "colony-sharing":        "Partage de colonies",
            "colony-sharing-desc":        "Les colonies utilisant la synchronisation dans le nuage peuvent générer une URL de partage, permettant à d'autres joueurs de My Colony d'accéder en lecture seule à leur sauvegarde.",
            "general-upgrade-all":        "Améliorer tous les bâtiments du même type",
            "general-ugall-desc":        "Êtes-vous sûr de vouloir tous les améliorer? Cela peut être coûteux et prendre du temps ...",
            "pavement7-description":        "Une chaussée ultra rapide faite de jouets colorés! Amusant n’est-ce pas?",
            "mound-description":        "La station de fabrication et de transformation des aliments des insectoïdes.",
            "waterbug-description":        "Ce petit bonhomme bleu se spécialise dans le transport de l’eau de diverses sources jusqu’au nid.",
            "workerdrone-description":        "Ce petit assistant robuste peut récolter du sucre pour la colonie et construire des structures de base.",
            "insectoid-description":        "Les insectoïdes se sont développés sur la planète Zolarg Prime. Ils se reproduisent rapidement et consomment tout sur leur passage.",
            "zolargprime-description":        "Le puissant empire Zolarg, situé sur Zolarg Prime, est un empire de créatures insectoïdes spécialisées dans la consommation de ressources et la reproduction rapides.",
            "sugarland-desc":        "La planète de sucre a un climat chaud et une végétation luxuriante, avec une atmosphère avancée et une abondance de sucre.",
            "orebug-description":        "Ce grand insectoïde possède de fortes mandibules pour extraire le minerai brut des dépôts voisins.",
            "feastingarea-description":        "La zone de banquets est l'endroit où les insectoïdes se rassemblent pour prendre part à des repas et à des divertissements. Convertit le sucre en nourriture et fournit un stockage pour ces mêmes ressources.",
            "watervats-description":        "Les insectoïdes adorent passer du temps dans les bacs à eau communaux et parler de la vie. Ce bâtiment stocke de l'eau et propose des animations.",
            "pastetank-description":        "Une installation brute qui mélange de l'eau, du sucre et de la salive d'insectoïdes pour former de la pâte de fourmi, un composé important pour la construction.",
            "pastepath-description":        "Ce joli sentier fait de minerai et de fourmi broyée sera agréable sous les pieds de vos ouvriers!",
            "broodcenter-description":        "Ici, au centre de formation de géniteurs, les jeunes insectoïdes apprennent à devenir des adultes et font de la recherche en même temps.",
            "zgoldstorage-desc":        "Apprenez à récolter de l'or et à creuser des terriers dans le sol pour le stocker.",
            "goldbug-description":        "Cette petite créature astucieuse est capable d'extraire de l'or brut du sol.",
            "goldburrow-description":        "C'est un petit trou dans le sol que votre or-insecte peut utiliser pour implanter des gisements d'or.",
            "sugarpower-res-desc":        "Découvrez les secrets de la combustion du sucre pour générer de l'électricité.",
            "sugarpower-description":        "Brûlez du sucre pour générer de l'électricité pour la colonie!",
            "communialfin-desc":        "Les insectoïdes apprennent à mettre en commun leurs ressources et à générer du commerce pour le bien commun.",
            "insectoidmint-description":        "Utilisez la menthe insectoïde pour faire fondre l’or et la transformer en petite monnaie.",
            "backupOption":        "Sauvegarde de sécurité",
            "backupOptionDesc":        "Enregistrez une copie locale non compressée de vos fichiers de jeu pour une protection accrue. Prend plus d'espace de stockage.",
            "sugarcult-desc":        "Plantez de la canne à sucre et faites grossir vos cultures!",
            "antanium-prod-desc":        "Apprenez à produire de l’antanium, un puissant alliage insectoïde utilisé dans la construction de bâtiments.",
            "antaniumsmelter-description":        "Combinez le minerai et l’or en antanium, un matériau de construction solide et faites monter la colonie d’un cran.",
            "eldersmound-description":        "Ceci est l'endroit où le Conseil des Aînés insectoïdes se réunit pour discuter de questions d'importance… insectoïde. Génère du civisme.",
            "miningoperation-description":        "Ici, les insectes travaillent ensemble pour creuser un trou géant et en extraire un flux constant de minerai et d’or.",
            "zolargstatue-description":        "Une belle statue honorant l'empereur Zolarg, l’insectoïde qui a fondé l'empire Zolarg en menant la race insectoïde dans une rébellion contre les anciens, il y a très longtemps.",
            "foodfortification-description":        "Enrichissez les aliments de pâte à base de fourmi, ce qui les rendra beaucoup plus nutritifs. Peut éventuellement être une amélioration de la zone de banquets, mais perd les avantages liés au divertissement et au stockage du sucre.",
            "solgov-desc":        "Déverrouillez les technologies favorisant la prestance de la planète dans le Commonwealth solaire.",
            "capitol2-description":        "Une colonie qui s’améliore nécessite un capitole qui s’améliore. Cette plus grande version du capitole génère plus de civisme, plus de politiques et vous permet d'envoyer des cadeaux plus gros aux autres colonies.",
            "galgov-desc":        "Développez et promouvez un gouvernement galactique avec la découverte de la gouvernance galactique",
            "capitol3-description":        "Montrez votre pouvoir sur vos sujets avec ce grand capitol. Débloque une plus grande capacité de dons, génère plus de civisme et de gloire dans votre empire, mais nécessite un flux de rhum continu pour que vos politiciens soient heureux.",
            "consulate2-description":        "Un bâtiment consulaire amélioré qui permet plus de commerce avec la mère patrie.",
            "consulate3-description":        "Créez un consulat encore meilleur et développez le commerce avec votre colonie mère.",
            "sand-description":        "Diversifiez votre colonie avec ce charmant sable.",
            "capitol4-description":        "Ce grand capitole rendra vos citoyens fiers de faire partie de cette nation florissante. Produit encore plus de civisme et permet encore plus de dons entre colonies.",
            "nationalism-desc":        "Commencez à diffuser des idéaux nationalistes sur votre peuple, en suscitant fierté et loyauté envers votre pays en croissance.",
            "general-flip":        "Pivoter",
            "flag-description":        "Affichez la fierté et le pouvoir de votre nation avec ce drapeau décoratif. Votre peuple va l'adorer!",
            "capitol5-description":        "Ce grand et menaçant capitole fera savoir à votre peuple que vous êtes finalement passé du côté obscur. Encore plus de civisme et de capacité de dons (et de consommation de rhum).",
            "imperialism-desc":        "Parfois, il ne suffit pas d'être une simple nation, vous devez passer du côté obscur et devenir un empire.",
            "insregen-desc":        "Découvrez les secrets de la médecine et de la guérison comme on la pratique chez insectoïdes.",
            "healingpods-description":        "Voici comment les insectoïdes se guérissent eux-mêmes. Ils enterrent leurs corps dans la boue, attendent un moment, puis BAM - guéri!",
            "rationing-header":        "Rationnement",
            "rationing-desc":        "Lorsque les temps sont durs, vous pouvez imposer des rations de nourriture et d’eau à votre peuple. Ils seront limités à 1/3 de la quantité normale de nourriture et de d'eau. Peut causer des maladies chez les plus faibles.",
            "general-native-client":        "Client natif",
            "native-client-description":        "En tant que jeu de navigateur, My Colony n'a pas accès à votre système et ne peut donc pas enregistrer vos données de jeu en dehors de votre navigateur Web. Cela augmente le risque de perte de données. Il est suggéré (mais pas obligatoire) de télécharger le client natif, qui permet de sauvegarder vos données de jeu localement sur votre appareil. Souhaitez-vous voir les options de téléchargement?",
            "sugarfarm-description":        "Qui aime se risquer dans le désert à la recherche de sucre? Personne. Dans ce cas, pourquoi ne pas planter une ferme sucrière pour que le sucre vienne à vous? Nécessite un apport d'eau constant ",
            "general-annex-land":                "Étendre le terrain",
            "general-annex-desc":        "Développez votre colonie en annexant les terres voisines.",
            "gentelbugs-description":        "Quand les insectoïdes disent à leurs femmes qu’ils travaillent tard, ils sont en fait au Gentel-insectes Club en train de boire du rhum. Consomme du rhum, propose des divertissements et offre des emplois aux jeunes insectoïdes.",
            "lghe3-description":        "Un réservoir de grande taille pouvant contenir de grandes quantités d’Hélium 3.",
            "plaque-description":        "Placez ces belles plaques autour de votre colonie pour marquer les endroits spéciaux et les événements historiques.",
            "general-set-text":        "Définition du texte",
            "galimp-desc":        "Apprenez les secrets de la gestion d'un empire (diabolique?) à l'échelle galactique.",
            "capitol6-description":        "Ce capitole impérial montrera votre gloire et votre pouvoir à tous les habitants de la galaxie. Déverrouille de plus grandes capacités de commerce, tandis que les politiciens sirotent toujours plus de rhum.",
            "tallconst-desc":        "Lorsque vous commencez à manquer d'espace, vous devez commencer à construire vers le haut. Les techniques de construction en hauteur vous permettent de construire des gratte-ciel dans un environnement à faible gravité.",
            "elevator-description":        "L'ascenseur spatial permet l’importation et l'exportation de marchandises et facilite également l'immigration de nouveaux colons. Nécessite une petite quantité de carburant, mais une grande quantité d’électricité.",
            "advrobo-desc":        "Apprenez les secrets de l’intelligence artificielle et de la robotique, et inaugurez l'essor des machines!",
            "condrone-description":        "Ce joyeux petit drone vole et construit des bâtiments pour vous.",
            "robofactory-description":        "Cette usine de haute technologie fabrique des robots et autres véhicules robotisés. Nécessite un flux constant d'aluminium et de micropuces.",
            "advdig-desc":        "Déverrouillez de nouvelles structures en apprenant à creuser des trous plus profonds dans le sol.",
            "wetmound-description":        "Le concept est simple. Creusez jusqu'à ce que vous trouviez de l'eau, puis construisez un petit nid au sommet pour que les insectoïdes s’y abreuvent.",
            "moneypit-description":        "Répartissez la richesse au sein de votre colonie d'insectoïdes. Les citoyens placent leurs épargnes dans la fosse et retirent au besoin. Génère de l'argent et du civisme.",
            "exportcannon-description":        "Le canon d'exportation est un moyen peu coûteux et efficace de revendre des produits à #motherland. Génère également de petits revenus.",
            "general-live-prices":        "Prix ​​en direct",
            "lumberyard-description":        "Ah, la scierie. Stocke du bois, emploie de vrais hommes et génère des revenus. Un beau bâtiment en somme.",
            "general-repair":        "Réparer",
            "general-condemn":        "Condamner",
            "lottery-header":        "Loterie",
            "lottery-message":        "Vendez des billets de loterie à la population. Un colon verra sa vie changée pour toujours!",
            "lottery-instruction":        "Quel est le prix des billets de loterie? N'oubliez pas que si vous facturez trop, les gens n'achètent pas de billets!",
            "lottery-fail":        "Désolé, personne n'a acheté de billets de loterie!",
            "regolithextractor-description":        "Cette grosse structure industrielle peut extraire de grandes quantités de régolithe du sol, sans avoir à reconstruire de nouvelles mines.",
            "horrorhouse-description":        "Si vous avez une nuit de libre, pourquoi ne pas emmener les enfants ou quelqu’un de votre entourage à cette effrayante Maison de l'Horreur? Attire des visiteurs et des touristes et tout le monde rentre chez lui avec un jouet!",
            "general-bad-trade-notice":        "Votre conseiller économique souhaite vous informer que cet échange est selon lui une mauvaise affaire pour notre peuple. La population pourrait ne pas approuver que vous gaspilliez de l'argent comme ça. Êtes-vous sûr de vouloir faire cette transaction?",
            "general-bad-trade-header":        "Conseiller économique",
            "general-declare-ind":        "Déclarer l'indépendance",
            "general-declare-ind-desc":        "Détachez vous de #motherland et débrouillez vous tout seul.",
            "galfi-desc":        "Apprenez à gagner de l'argent à l’échelle galactique!",
            "bank2-description":        "Employez des centaines de commerciaux dans cette grande banque et regardez-les extraire de l'argent de tous les portefeuilles de la galaxie!",
            "restower-description":        "Un gratte-ciel bon marché. Empilez littéralement les gens et voyez votre population croître.",
            "steelyard-description":        "Cette structure est utilisée pour stocker des quantités importantes d’acier pour une utilisation ultérieure. Génère quelques revenus pendant les opérations.",
            "subtcharcoal-description":        "Pourquoi garder ce charbon de bois à l'air libre dans une atmosphère planétaire humide alors qu'il pourrait être bien au sec. Stocke également une plus grande quantité de charbon. Utilise de l'hélium 3 pendant le fonctionnement.",
            "general-gift-giver":        "Empereur Galactique",
            "general-gift-message":        "Le maléfique Empereur Galactique est heureux d’annoncer que le Département Impérial de la Propagande offre un cadeau en échange d’un peu de votre temps. Voulez-vous regarder une vidéo en échange de ressources?",
            "general-watch-gift-vid":        "Regarder",
            "general-gift-not-watched":        "L’empereur vous rappelle que vous devez visionner l’intégralité de la vidéo pour être digne de sa grâce.",
            "general-reward-complete":        "Le Département Impérial de la Propagande vous remercie pour votre service.",
            "general-ticker-warn-head":        "Avertissement sur les transactions dans la barre de défilement",
            "general-ticker-warn-info":        "Attention - La sélection d'un contrat dans la barre de défilement passera automatiquement un ordre d’achat. Il n’y aura pas d’autre avertissement.",
            "general-mass-message":        "Message général au Commonwealth",
            "general-mass-msg-desc":        "Envoyez un courrier à tous les membres de votre Commonwealth.",
            "zolargcomm-desc":        "Déverrouillez la dernière technologie Zolarg, permettant les communications intergalactiques!",
            "altarofcommerce-description":        "L'autel de commerce est l'endroit où les insectoïdes vont adorer les dieux du commerce intergalactique et conclure des accords commerciaux incroyables.",
            "sugarcane-description":        "Plantez et cultivez la canne à sucre. Miam.",
            "enc-resources-desc":        "Informations sur les différentes ressources que vous pouvez collecter dans le jeu.",
            "enc-tech-header":        "Technologies",
            "enc-tech-desc":        "Découvrez toutes les technologies qui peuvent être déverrouillées et quelles sont les exigences.",
            "general-buildings":        "Bâtiments",
            "enc-buildings-desc":        "Découvrez toutes les structures du jeu, ainsi que leur coût.",
            "general-vehicles":        "Véhicules",
            "enc-vehicles-desc":        "Découvrez tous les véhicules et rovers disponibles pour la construction, leurs coûts de construction et leurs capacités.",
            "enc-online-header":        "Référence en ligne",
            "enc-online-desc":        "Trouvez des informations plus détaillées dans le manuel de référence en ligne (en anglais uniquement).",
            "regminer-description":        "Ce fidèle rover exploite les mines régolithe et rapporte la récolte à votre base.",
            "owners-manual-header":        "Manuel de l’utilisateur",
            "enc-print-header":        "Imprimer le manuel de l’utilisateur",
            "enc-print-desc":        "Si vous avez toujours voulu un manuel de l’utilisateur physique pour My Colony, vous avez de la chance. Vous pouvez maintenant l'imprimer directement à partir de votre appareil! Encore en développement. Il est assez longs (quelques pages), alors imprimez-le au travail ou à l'école … (en anglais uniquement)",
            "general-encyclopedia":        "Encyclopédie",
            "owners-manual-intro":        "Le manuel de l’utilisateur en est encore à ses débuts. Une fois terminé, il sera génial, mais on n’en est pas encore là. Jetez-y un coup d'œil et imprimez-le si vous le souhaitez. Vérifiez régulièrement chaque mise à jour, car il ne cessera de s'améliorer au fil du temps. Assurez-vous de laisser des commentaires et des suggestions sur le forum ou sur l'App Store pour toujours l’améliorer.",
            "general-civs":        "Civilisations",
            "general-maps-available":        "Types de planètes disponibles",
            "general-starting-techs":        "Technologies de départ",
            "general-starting-building":        "Bâtiments de départ",
            "general-pin-colony":        "Créer un raccourci",
            "general-pin-description":        "Créez un raccourci vers votre colonie directement sur votre écran d’accueil ou votre bureau.",
            "general-autobudget":        "Paye automatique",
            "general-autobudget-desc":        "Traiter automatiquement les paiements des salaires et des taxes sans notification. Ne s'applique que lorsque vous avez suffisamment de fonds.",
            "general-online-pay-assis":        "Aide financière du Commonwealth",
            "online-payass-desc":        "Définissez à quel taux vous aidez les colonies sous votre Commonwealth dans le payement de leurs employés. Vous pouvez payer de zéro au double ou plus. C’est votre choix. Entrez un nombre entier comme pourcentage d'assistance, par exemple 25 pour 25%.",
            "sugarlandbase-desc":        "Les technologies de base fournies en démarrant sur une planète de sucre.",
            "insectoidbase-desc":        "Les technologies de base pour qui viennent de commencer avec la race insectoïde.",
            "zolargbase-desc":        "Les technologies de base qui proviennent de la civilisation de l'empire Zolarg.",
            "zolgov-desc":        "Apprenez à gouverner une colonie à la manière des insectes.",
            "highcommand-description":        "Le Haut Commandement est le centre du gouvernement dans un Commonwealth insectoïde. Il vous permet de gérer les colonies filles et de définir des politiques coloniales.",
            "supplypile-description":        "Juste un petit tas légèrement protégé où vous pouvez stocker toutes sortes de biens et matériaux.",
            "commandpost-description":        "Établissez des communications avec #motherland et mettez en place des politiques de base pour la colonie.",
            "consulate5-description":        "Lorsque votre Commonwealth passe du côté obscur, vous feriez mieux de faire de même. Ce consulat libère davantage de capacité de commerce et attire également des touristes.",
            "smstadium-description":        "Aidez votre peuple à oublier les corvées quotidiennes en les divertissant avec ce petit stade! Accepte également les touristes.",
            "xenomat-desc":        "Apprenez à travailler et à construire avec des matériaux et des composés d'autres mondes.",
            "synthtext-description":        "En mettant la main sur la précieuse et mystérieuse ressource connue sous le nom de pâte de fourmis, vous pourrez fabriquer un tissu de qualité incroyable.",
            "pol-salespitch-header":        "Description du Commonwealth",
            "pol-salespitch-desc":        "En 100 caractères maximum, donnez aux joueurs un aperçu de votre Commonwealth et expliquez-leur pourquoi ils devraient adhérer. Ce message s'affiche dans la liste aléatoire des chartes affichée lorsque les joueurs commencent une nouvelle partie.",
            "lis-description":        "La LIS (League of Independent States, League des États Indépendants) est un groupe de colonies humaines non alignées qui se battent depuis des décennies pour l'indépendance.",
            "lisbase-desc":        "Les technologies de base de la Ligue des États Indépendants.",
            "lislander-description":        "Vieil atterrisseur bringuebalant",
            "lisrover-description":        "Il y a quelques années, la Terre Unie a mis fin à ces vieux engins, mais la Ligue des États Indépendants en fait encore bon usage. Peut être utilisé pour récolter de la régolite et construire des structures de base.",
            "abandonedbase-desc":        "Les technologies de base disponibles pour les joueurs jouant sur un monde abandonné.",
            "abandonedworld-planet-desc":        "Une planète contenant des vestiges d'une civilisation éteinte.",
            "statue4-description":        "Une vieille relique, témoin des jours passés.",
            "medstadium-description":        "Un stade de taille moyenne pour divertir les touristes et les invités. Consomme de la nourriture et du rhum et augmente le bonheur de votre peuple!",
            "grass2-description":        "Une belle herbe décorative pour embellir l’endroit.",
            "sand2-description":        "Parfois, vous avez juste besoin de sable jaune dans votre colonie.",
            "sand3-description":        "Le remède parfait dans les situations où votre colonie a besoin de sable orange.",
            "mailbox-description":        "Cette jolie boîte aux lettres décorative a fière allure dans tous les quartiers coloniaux.",
            "hoops-description":        "S'il y avait des enfants dans My Colony, ils adoreraient ce panier de basket décoratif.",
            "oiltank2-description":        "Si vous prenez au sérieux le stockage du pétrole, vous avez besoin de ce réservoir d'huile quantique. Stocke des tonnes d'huile, nécessite de l'électricité et de l'eau pour fonctionner.",
            "flag5-description":        "Montrez allégeance à la Ligue des États Indépendants avec ce magnifique drapeau.",
            "greenhome-description":        "Cette serre ne génère pas de nourriture, mais elle abrite 7 colons et se fond parfaitement dans la colonie.",
            "sweatshop3-description":        "Si vous avez besoin de nourrir une grande colonie, voici ce qu’il vous faut. Dans le sweatshop, vos travailleurs resteront esclaves toute la journée et pour des salaires bas, en utilisant du sucre pour créer des aliments à l'échelle industrielle.",
            "sweetnerfactory-description":        "Utilisez la science pour transformer le pétrole en sucre artificiel! Ne faites pas attention au goût métallique, c'est juste de l'aluminium.",
            "oreenrichtech-desc":        "Apprenez à nettoyer et à purifier le minerai brut extrait du sol.",
            "oreenrichmentfacility-description":        "Nettoyez et enrichissez votre minerai pour créer encore plus de minerai.",
            "goldsign-description":        "Lorsque vous voulez écrire quelque chose qui durera des siècles, écrivez-le sur ce panneau d’or.",
            "cactus-description":        "Votre colonie aura fière allure avec ce cactus décoratif! Stocke aussi de l’eau.",
            "cactus3-description":        "Ce petit cactus ne stocke aucune eau, mais votre peuple adorera cette touche de désert.",
            "palm-description":        "Ce bel arbre offre de l'ombre et produit occasionnellement des fruits. Peut aussi être vendu pour son bois.",
            "dune-description":        "Au cas où votre colonie aurait besoin d'une dune de sable, nous avons ce qu’il vous faut.",
            "deckchairs-description":        "Rien ne dit &quot;plaisir au soleil&quot; ou &quot;détente&quot; aussi bien que ces chaises longues décoratives.",
            "desertskull-description":        "Aucune zone de désert ou de sable ne sera jamais complète sans un crâne.",
            "fountain-description":        "Votre colonie aura fière allure une fois que vous aurez placé plusieurs de ces fontaines dans différents quartiers.",
            "vertfarm-description":        "Voyez plus grand avec cette exploitation agricole verticale. Fournit également du stockage pour la nourriture.",
            "new-charter-desc":        "Commencez une nouvelle colonie sous la charte coloniale d'un autre joueur de la vie réelle. Vous pourrez recevoir une assistance dans le jeu de la part de la colonie mère. La race du joueur est héritée de la colonie mère.",
            "new-charter-req-online":        "Un compte Ape Apps est nécessaire pour jouer.",
            "woodharvesting-desc":        "Apprenez à produire un insecte forestier et commencez à récolter et à cultiver le bois",
            "lumberbug-description":        "Ce petit insecte de type termite est spécialisé dans tout ce qui a touche au bois.",
            "lumbercamp-description":        "La scierie est une installation insectoïde de base pour le traitement et le stockage du bois.",
            "powerspire-description":        "Utilisez le bois pour brûler du sucre à des températures encore plus élevées, ce qui rend la source d’énergie encore plus efficace.",
            "asteroid-planet-desc":        "La vie sera difficile sur un astéroïde. Attendez-vous à des difficultés.",
            "statue5-description":        "Une statue d'une taille injustifiée du président de la Terre Unie, qui est actuellement en fonction pour son 14e mandat, est maintenu en vie par des moyens artificiels. On raconte que la statue a des pouvoirs de guérison.",
            "blackmarkets-desc":        "Commencez à produire des objets généralement interdits ou restreints dans la Terre Unie.",
            "diamondmining-desc":        "Découvrez l'art de l'extraction et du raffinage des diamants, une ressource précieuse.",
            "colonialassembly-description":        "Une structure civique vous permettant d’adopter des décrets régissant votre colonie.",
            "diamondrefinery-description":        "Recueille, raffine et stocke les diamants bruts.",
            "diamondminer-description":        "Ce robot pratique peut collecter et récolter des diamants pour vous. Comme c'est pratique!",
            "bmbazzar-description":        "Ce n’est pas parce que les colonies de la LIS sont sous embargo strict de la Terre Unie que vous ne pouvez pas mener un honnête commerce.",
            "advmetalurgy-desc":        "Débloquez des techniques améliorées pour travailler avec différents métaux.",
            "alumibug-description":        "Un insectoïde aimant s'amuser, spécialisé dans tout ce qui concerne l'aluminium",
            "aluminumhive-description":        "Une installation de dépôt, de traitement et de stockage de l'aluminium.",
            "jewelrystore-description":        "Quelle meilleure façon de la convaincre de dire « oui » que d'acheter ses diamants dans ce magasin de bijoux? Un bon moyen de générer des revenus pour la colonie.",
            "independencehall-description":        "Le centre du pouvoir et du gouvernement dans une colonie indépendante de la LIS.",
            "leaguetrade-description":        "Accédez au marché intergalactique en utilisant un système complexe de mandataires pour contourner l'embargo sur les communications de la Terre Unie.",
            "resai-desc":        "En utilisant la robotique avancée et les techniques informatiques quantiques des Anciens, découvrez les secrets de la véritable intelligence artificielle.",
            "antsynth-desc":        "À l'aide de technologies anciennes et au bout de maintes recherches, découvrez comment convertir l'aluminium et le sucre en antanium pur",
            "antsynth-description":        "Dans un processus très gourmand en énergie, convertissez l'aluminium et le sucre en antanium pur. Nécessite des robots pour fonctionner.",
            "quantumdistillery-description":        "Exploitez la technologie quantique pour créer une distillerie de rhum épique. La plupart des gens ne sentent pas la différence entre le rhum quantique et le classique.",
            "yellowhouse-description":        "Les experts s’accordent sur le fait que cette belle maison jaune est le meilleur endroit pour élever une famille dans #cityname.",
            "centerai-description":        "Centre de recherche à la pointe de la technologie. Génère de beaucoup de recherche tout en consommant des micropuces et des robots.",
            "antcompound-desc":        "Découvrez comment fabriquer le triantanium, un composé d’antanium radioactif artificiel, considéré comme l’un des métaux les plus durs de l’univers.",
            "triantrefine-description":        "Cette installation automatisée à zéro émission fusionne l'uranium et l'antanium pour produire du triantanium, un métal extrêmement durable. Consomme des robots pendant le fonctionnement.",
            "diplomacy-general":        "Diplomatie",
            "new-embassy-header":        "Établir une ambassade",
            "new-embassy-desc-short":        "Démarrer une nouvelle mission diplomatique.",
            "new-embassy-desc":        "Si vous connaissez le code de la charte d'une autre colonie indépendante, vous pouvez établir une ambassade dans leur colonie pour développer la diplomatie et le commerce bilatéraux.",
            "theshanty-description":        "Une ambassade très bon marché pour le chef de colonie qui se fiche de son image sur la scène internationale.",
            "thefunctional-description":        "Un bon bâtiment sans fioritures. Tout ce dont vous avez besoin pour mener une mission diplomatique avec succès.",
            "thegoldman-description":        "Cette ambassade fait son travail et montre à votre colonie hôte que votre gouvernement est sérieux.",
            "general-pick-embassy":        "Sélectionnez l'ambassade",
            "general-embassy-requests":        "Missions diplomatiques en attente",
            "exomound-description":        "Une ambassade pas chère et facile à mettre en place. Il suffit d’arriver sur votre planète hôte et de creuser un grand nid. Boom.",
            "thecrystalline-description":        "Cette ambassade montrera à votre colonie hôte la splendeur de votre nation.",
            "thesunrise-description":        "Faites savoir à toute la galaxie que le soleil se lève sur un jour nouveau dans #cityname.",
            "diplomaticoutpost-description":        "Ce bel édifice diplomatique laissera tout le monde voir votre fierté d'appartenir à la LIS.",
            "shrineoftruth-description":        "Cette ambassade indique à votre pays hôte que vous menez une diplomatie honnête, honnête et honnête.",
            "transmissionhub-description":        "Un émetteur de haute technologie qui vous permettra, à vous et à votre peuple, d’envoyer des messages à travers la galaxie. Génère une petite quantité de recherche à partir des connaissances qu’il apporte.",
            "comms-general":        "Communications",
            "robofactory2-description":        "Le siège social de Advanced Robotics Incorporated. Génère de l'argent et des robots. Nécessite de l'aluminium et des micropuces pour fonctionner.",
            "general-req-annex":        "Demande d'annexion",
            "req-anenx-desc":        "Demandez à quitter #motherland et à rejoindre une nouvelle charte. La nouvelle colonie mère devra approuver la demande et payer à l’ancien Commonwealth les éventuelles dettes.",
            "req-annex-enter-charter":        "Entrez le code de charte du Commonwealth que vous souhaitez rejoindre.",
            "req-annex-final":        "Si votre demande est écoutée, vous quitterez #motherland et rejoindrez ce Commonwealth.",
            "general-annex":        "Annexer",
            "alummine-description":        "Les insectoïdes sont toujours capable de creuser des mines d’aluminium pour accroître leur production.",
            "plantgen-desc":        "Découvrez comment modifier les gènes des plantes pour créer des plantes encore meilleures!",
            "megatree-description":        "Un très grand arbre OGM à croissance rapide qui produit une grande quantité de bois.",
            "deeptrans-description":    "L'émetteur-récepteur à champ profond vous permet d'envoyer des messages sur une longue distance. Génère de la recherche à partir des connaissances qu’il apporte dans votre colonie.",
            "pavement8-description":        "Une route quelque peu chère en aluminium. Ultra rapide pour les rovers sur laquelle ils peuvent voyager.",
            "plastfact2-description":        "Une version plus grande, plus rapide et plus puissante de l'usine de plastique. Elle est plus efficace que l’usine normale et utilise également des robots pour la production.",
            "oilsynthlab2-description":        "Lorsque vous avez besoin de produire une plus grande quantité de pétrole, envisagez cette installation avancée de pétrole synthétique. Convertit la nourriture, le régolithe et le charbon de bois en pétrole. Utilise des robots pendant la production.",
            "rover-firstbuild-tut":        "Les rovers peuvent récolter du minerai et construire des structures de base. Plus vous construirez de rovers, plus vite vous collecterez des ressources. Sélectionnez votre nouveau véhicule et sélectionnez 'Construction' pour voir les options de construction. Vous devriez commencer avec une serre et une pompe à eau pour que vos colons ne meurent pas.",
            "greenhouse-firstbuild-tut":        "Les structures ont besoin d’électricité pour fonctionner. Lorsque vous aurez suffisamment de minerai, vous devriez construire un panneau solaire pour que les voyants restent au vert dans #cityname. Si vous êtes ammené à manquer d'électricité, vos bâtiments deviendront semi-transparents et cesseront de produire. Si vous restez trop longtemps sans électricité, votre peuple tombera malade et mourra. Si avez besoin, vous pouvez sélectionner un bâtiment et le désactiver temporairement pour libérer de l'énergie pour d'autres structures.",
            "solarpanel-firstbuild":        "Si vous ne l'avez pas encore fait, envisagez de construire une petite usine de véhicules. Cela débloquera de nouveaux rovers qui vous donneront encore plus d'options de construction.",
            "smveh-firstbuild-tut":        "Sélectionnez votre petite usine de véhicules et créez un robot constructeur.",
            "builderbot-firstbuild-tut":        "Avec le robot constructeur, vous pouvez vraiment commencer à développer votre colonie. Vous devriez commencer par construire quelques abris et un pod de débarquement. Les abris fournissent un logement aux nouveaux colons, et le pod de débarquement permet aux nouveaux colons d'immigrer vers votre colonie. Assurez-vous de garder un œil sur l’énergie, la nourriture et la production d'eau à mesure que votre population grandit.",
            "landingpad-firstbuild-tut":        "Vos nouveaux colons auront besoin d'emplois pour gagner de l'argent et rester heureux. Construire une raffinerie de minerai leur donnerait un excellent lieu de travail!",
            "orerefinery-firstbuild-tut":        "La raffinerie de minerai fournit des emplois à vos colons et convertit le minerai en acier, une nouvelle ressource qui vous permet de construire davantage de structures. Les colons travaillent par équipes et la raffinerie ne produira que pendant qu'il y a des travailleurs en poste. Plus vous avez de raffineries de minerai, plus vous produirez d’acier. Rappelez-vous que les bâtiments requièrent au moins un côté dégagé afin que les colons puissent y accéder.",
            "pavement-firstbuild-tut":        "Les cases de route permettent à vos unités de voyager plus rapidement sur la carte. les rovers préféreront se déplacer sur des chemins pavés par rapport à de la terre. Utilisez-le de manière stratégique pour réduire les temps de déplacement vers les ressources importantes.",
            "internetbooth-firstbuild":        "Les colons ont besoin de divertissements pour ne pas devenir fous. Si leur bonheur tombe trop bas, ils refuseront d'aller travailler, ce qui entraînera l'arrêt brutal de votre colonie. Assurez-vous de garder suffisamment d’immeubles de divertissement à proximité des habitations des colons pour les rendre heureux!",
            "goldrefin-firstbuild":        "Sélectionnez votre nouvelle raffinerie d'or pour construire un robot orpailleur, ce qui vous permettra de commencer à collecter la précieuse ressource.",
            "goldmienr-firstbuild":        "Comme pour le minerai, sélectionnez votre robot orpailleur et ordonnez-lui de récolter pour commencer à obtenir de l'or.",
            "smresearch-firstbuild-tut":        "Certaines structures génèrent de la précieuse recherche pouvant être utilisée pour débloquer de nouvelles technologies, ce qui conduit à de nouvelles options de construction. Cliquez de temps à autre sur l'icône de recherche (en forme de potion violette) pour voir les technologies déverrouillables disponibles.",
            "atmosgen-firstbuild":        "Un des objectifs de My Colony est de terraformer votre planète en créant une atmosphère. Une fois que vos niveaux d’atmosphère seront suffisamment élevés, vous débloquerez de nouvelles options de construction encore plus intéressantes!",
            "chopshop-firstbuild-tut":        "Lorsque vous n’avez plus besoin d’un rover, vous pouvez l’emmener à la casse qui récoltera ses matières premières.",
            "lunar-welcome-message":        "Bienvenue! Vous avez fondé une nouvelle colonie sous la charte coloniale de #motherland. Votre objectif est de transformer ce monde désolé en une civilisation florissante. Pour commencer, sélectionnez votre rover et ordonnez-lui de commencer la récolte. Une fois que vous avez collecté au moins 10 de régolithe, sélectionnez votre atterrisseur et construisez un second rover.",
            "lunar-rover-firstbuild-tut":        "Les rovers peuvent récolter du régolite et également construire des structures de base. Pour développer votre colonie, vous devrez convertir une partie de votre régolithe en hélium 3, une ressource vitale. Quand vous en aurez les moyens, demandez à un rover de construire un extracteur à l'hélium 3. N'oubliez pas que plus vous construirez de rovers, plus vous collecterez rapidement des ressources.",
            "he3-firstbuild-tut":        "Pour pouvoir produire de la nourriture, vous devez convertir une partie du régolithe en minerai. Le minerai est une ressource vitale pour la construction dont vous aurez besoin pour construire la plupart des structures. Une fois que vous avez suffisamment d’Hélium 3, construisez un compacteur de régolithe.",
            "reg-compactor-firstbuild":        "Vos colons auront besoin de nourriture et d'eau pour survivre. La nourriture est plus pressante dès le début, car vous devriez avoir assez d'eau pour durer un peu de temps. Une fois que vous aurez assez de minerai, construisez une serre afin de commencer à produire de la nourriture pour la colonie. Une fois que vous aurez assez de puissance, construisez un extracteur d’eau pour commencer à récupérer de l’eau.",
            "forest-welcome-message":        "Bienvenue! Vous avez fondé une nouvelle colonie sous la charte coloniale de #motherland. Les ressources sont rares sur ce monde, vous devez donc agir rapidement pour survivre. Pour commencer, sélectionnez votre rover et ordonnez-lui de commencer la récolte. Une fois que vous aurez collecté au moins 40 bois, sélectionnez votre atterrisseur et construisez un second rover.",
            "forestrover-firstbuild-tut":        "Les rovers peuvent récolter du bois et construire des structures de base. Votre objectif premier est de nourrir vos colons pour qu’ils ne meurent pas. Lorsque vous aurez suffisamment de bois, demandez à l’un de vos rovers de construire une culture de pommes de terre.",
            "potpatch-firstbuild-tut":        "Maintenant que la production alimentaire de base est lancée, vos colons auront besoin d’eau. Demandez à l'un de vos rovers de construire un puits d'eau.",
            "waterwell-firstbuild-tut":        "La production constante de bois est essentielle à la survie de votre colonie. La culture des arbres est essentielle dès le début. Commandez à un rover de construire deux sapins près de la base pour une récolte plus rapide. Après cela, vous devriez construire une hutte de charbon de bois pour commencer à produire du charbon de bois. N'oubliez pas que plus vous récolterez de rovers, plus vite vous engrangerez des ressources!",
            "charchut-firstbuild-tut":        "Le charbon de bois est une ressource de base essentielle et peut être utilisé pour créer du minerai. Le minerai est la ressource de construction la plus importante du jeu. Lorsque vous aurez suffisamment de matériaux, demandez à un rover de construire un compacteur à charbon pour convertir une partie de votre charbon en minerai.",
            "charccompact-firstbuild-tut":        "Avant de grandir, votre colonie aura besoin d'électricité. Pour cela, vous aurez besoin de construire un brûleur de charbon de bois, mais vous aurez probablement besoin d’au moins une autre cabane à charbon de bois pour répondre aux demandes en charbon de bois. N'oubliez pas que si vous avez besoin de plus de puissance, vous pouvez toujours sélectionner un bâtiment et le désactiver temporairement. Essayez de produire suffisamment de ressources pour faire fonctionner un brûleur à charbon.",
            "charcoalburn-firstbuild-tut":        "Avec beaucoup d’énergie, vous devriez construire une petite usine de véhicules, ce qui débloquera de nouvelles options de construction.",
            "insectoid-welcome-message":        "Bienvenue! Vous avez fondé une nouvelle colonie sous la charte coloniale de #motherland. Votre objectif est de transformer ce monde désolé en une civilisation florissante. Tout d’abord, trouvez un bon point de départ et déployez votre reine. Ensuite, sélectionnez votre drone de travail et ordonnez-lui de commencer à récolter la canne à sucre. Pendant la récolte, sélectionnez votre nid et commandez la construction d’un Orebug.",
            "orebug-firstbuilt-tut":        "Le Orebug collectera du minerai essentiel qui servira à bâtir votre colonie. Pendant que votre minerai-insecte récolte, sélectionnez votre nid et construisez un deuxième drone de travail. Vous devrez peut-être attendre un moment pour obtenir plus de nourriture de votre nid. Une fois que vous aurez collecté au moins 300 minerai, demandez à un drone de travail de créer une zone de banquet pour commencer à générer de la nourriture pour la colonie.",
            "feastarea-firstbuild-tut":        "En ayant fini avec la nourriture (pour le moment), vous devez sélectionner à nouveau votre nid et construire deux ou trois bacs d’eau communaux pour que vous puissiez commencer à collecter de l'eau pour la colonie.",
            "waterbug-firstbuild-tut":        "Ordonnez à vos Waterbugs de récolter de l'eau. Une fois que vous avez suffisamment d'eau et de minerai accumulé, demandez à un drone de travail de construire un bac d'eau communal afin de pouvoir commencer à remplir des réserves d'eau pour la colonie.",
            "communalvats-firstbuild-tut":        "Pour poursuivre la croissance de votre colonie, vous aurez besoin de produire de la pâte de fourmi, un matériau de construction essentiel. Une fois que vous aurez les ingrédients nécessaires, ordonnez à un drone de travail de construire un réservoir pour la pâte.",
            "wetcone-description":        "Le cône humide est une amélioration technologique par rapport au monticule humide. En utilisant de l'aluminium et d'autres métaux, il est capable d'extraire (et de stocker) beaucoup plus d'eau.",
            "interdimtrav-desc":        "Développez votre économie et votre influence au sein de la galaxie en dévoilant les secrets du transport interdimensionnel. Vous permet d'importer des biens, des personnes et même des méthodes de construction venant de mondes lointains.",
            "stargate-description":        "En utilisant les plans des Anciens, construisez un téléporteur interdimensionnel incroyable vous permettant de mener votre business sur des distances galactiques insensées. Permet également la libre circulation des citoyens entre les mondes.",
            "megahab-desc":        "Apprenez à faire vivre vos colons par milliers dans des conditions exiguës. C'est bon pour l'environnement.",
            "arcology-description":        "Après avoir joué à un vieux jeu de construction de ville de la Terre sur un émulateur, l'un de nos ingénieurs a conçu ce projet de structure gigantesque dans laquelle les gens pourraient vivre, travailler et se divertir sans jamais avoir à sortir.",
            "general-statistics":        "Statistiques",
            "mysticism-desc":        "Redécouvrez les pouvoirs spirituels des anciens peuples insectoïdes qui étaient monnaie courante avant leur interdiction par l'empereur Zolarg il y a plusieurs siècles.",
            "shrineofmystics-description":        "Ces anciens sanctuaires insectoïdes ont été interdits sur Zolarg Prime il y a plusieurs siècles à cause du pouvoir impie qu'ils libèrent. Seules les colonies indépendantes peuvent expérimenter ce pouvoir.",
            "colony-plays-on":        "Joue sur",
            "insbeu-desc":        "Apprenez à développer votre gouvernement insectoïde pour qu'il soit plus grand et plus fort. Ou à la limite plus gros.",
            "highercommand-description":        "Ce capitole amélioré vous permettra d’adopter plus de décrets et de mener des opérations diplomatiques plus larges.",
            "unholypowerspire-description":        "Alimentée par de l’antaura, ce générateur amélioré produit une grande quantité d’électricité sans aucune émission.",
            "general-modding":        "Modding",
            "general-texture-mods":        "Packs de texture",
            "text-mods-desc":        "Modifiez l'apparence de My Colony en remplaçant les textures par défaut par des graphiques personnalisés.",
            "general-map-editor":        "Éditeur de monde",
            "general-map-editor-desc":        "Créez des mondes de départ personnalisés présentant des caractéristiques de terrain ou des ressources de votre choix.",
            "general-tex-mod-import":        "Importer un pack de textures",
            "general-tex-mod-activate":        "Activer le pack de textures",
            "general-tex-mod-deactivate":        "Désactiver le pack de textures",
            "general-tex-mod-create":        "Créer un pack de textures",
            "tex-mod-activate-desc":        "Activer et activer un fichier pack de textures précédemment installé.",
            "tex-mod-deactivate-desc":        "Réinitialiser le pack de textures du jeu par défaut.",
            "tex-mod-import-desc":        "Importez et installez un fichier My Colony Texture Mod (*.mct) que vous avez enregistré sur votre appareil.",
            "tex-mod-editor-desc":        "Lancez l'éditeur de pack de textures et créez vos propres fichiers My Colony Texture Mod (* .mct) que vous pouvez exporter et partager avec la communauté.",
            "general-make-center":        "Définir comme centre",
            "iceworldbase-desc":        "Les technologies de base du monde de glace.",
            "iceworld-planet-desc":        "Une planète désolée et glacée où les colons vont pour mourir. Contient des cristaux rares qui ne peuvent être trouvés nulle part ailleurs dans la galaxie.",
            "monumentheroes-description":        "Un beau monument commémorant les exploits de Sarge et de son équipe de Space Marines, légendes vivantes de la civilisation de la Terre Unie",
            "fantasyland-description":        "Une méga résidence où les rêves deviennent réalité, du moins jusqu'à ce que la réalité s'installe. Les robots s'occupent de toutes les tâches manuelles, afin que les résidents puissent jouer toute la journée. Fournit des logements massifs mais pas d’emploi, de divertissement ou d’autres services. Consomme des jouets, du rhum, du tissu et des robots.",
            "general-modding-community":        "Communauté de Modding",
            "general-mod-comm-desc":        "Forum en ligne où les utilisateurs peuvent partager leurs mods ou télécharger des mods créés par d'autres joueurs.",
            "general-vidtut-header":        "Tutoriels vidéo",
            "general-vidtut-desc":        "Regardez des tutoriels vidéo en ligne sur My Colony créés par la communauté",
            "general-vid-sumbit":        "Soumission de vidéo",
            "general-vid-submit-desc":        "Soumettez vos propres didacticiels vidéo pour les avoir directement liés au jeu. Aidez les autres joueurs en développant votre chaîne!",
            "oresynth-description":        "En utilisant le pouvoir de la science, convertissez chimiquement le régolithe en minerai, bien plus rapidement que ne le ferait tout vieux compacteur de régolithe.",
            "rescomplexblue-description":        "La peinture sera peut-être bleue, mais les voisins seront verts quand ce complexe résidentiel bleu sortira du sol.",
            "bigplayhouse-description":        "Si vous vous attendiez à ce que la fête se termine, vous serez déçu. Parce que ça ne s’arrête jamais dans la Maison de Jeu.",
            "crystalminer-description":        "Un rover spécialisé pour miner de la cristalline dans un environnement hostile.",
            "micromine-description":        "La surface dure de la toundra est trop épaisse pour un petit rover, mais en utilisant de la cristalline, vous pouvez extraire du régolithe de la surface.",
            "regfurnace-description":        "Utilisez une réaction chimique entre le régolithe et la cristalline pour générer de l’électricité pour la colonie.",
            "compactedsnow-description":        "Un chemin peu coûteux pour aider vos rovers et vos colons à se déplacer d'un point A à un point B.",
            "nexgenpow-desc":        "Grâce à la puissance de l'intelligence artificielle, découvrez des méthodes de production d'électricité bien au-delà de tout ce que les anciens auraient pu imaginer.",
            "diamondcrystalreactor-description":        "Combinez diamants et cristalline avec de l'uranium pour produire une quantité d'énergie exceptionnelle.",
            "alienenrichment-description":        "Vous pensiez peut-être être au top en terme d’enrichissement de l’uranium, mais les anciens étaient bien meilleurs. Alors volez-leur leurs méthodes avec cette installation!",
            "tundrabug-description":        "Un insectoïde qui travaille dur, qui ne craint pas le froid et qui aime tailler les cristaux avec sa puissante pince.",
            "crystalmound-description":        "Un nid confortable, où les insectoïdes se blottissent autour de la cristalline et la digèrent en sucre pur.",
            "oretunnel-description":        "Frayez-vous un chemin à travers la surface gelée pour trouver du minerai caché en dessous.",
            "syncrystaldeposit-description":        "En utilisant la cristalline et le rhum existants, cultivez une variante synthétique de cristalline pouvant être récoltée. Pas aussi puissante que la vraie, mais soyez prudent car elle se propage.",
            "crysynth-desc":        "Apprenez à exploiter vos propres dépôts de cristalline dans le confort de votre base!",
            "independencehall2-description":        "Une plus grande salle pour encore plus d'indépendance! Permet d'élargir les options politiques et diplomatiques. Génère plus d'argent, mais les politiciens consomment maintenant du rhum.",
            "microincinerator-description":        "Un moyen simple et peu technique de réduire les déchets dans la colonie. Produit un peu de l'énergie tant qu'il y a assez de détritus pour la faire fonctionner.",
            "microincinerator-firstbuild-tut":        "Au fil du temps, vos colons vont générer des déchets qui polluent la colonie et provoquent des maladies. Veillez à surveiller votre niveau de déchets et à mettre en place des structures de gestion des déchets en conséquence.",
            "smrecyclingcenter-description":        "Effectuez votre transition écologique en recyclant les ordures sales de votre colonie en plastique utilisable!",
            "smtrashpit-description":        "Lorsque les déchets commencent à s'accumuler, creusez un trou et déposez-les-y. Une fois dans la fosse, les déchets se décomposeront lentement avec le temps.",
            "conferencehall-description":        "Là où les grands esprits culturels, scientifiques et économiques de toute la galaxie se rencontrent. Génère de l'argent et de la recherche en utilisant du rhum, des micropuces et de la nourriture.",
            "advancedmed-description":        "Soigne un grand nombre de colons tout en effectuant des recherches vitales pour la colonie.",
            "restowerblue-description":        "La seule meilleure chose qu'une tour résidentielle est une tour résidentielle bleue. Pas convaincu? Construisez-la et voyez par vous-même.",
            "incinerator-description":        "Brûlez de grandes quantités de déchets et transformez-les en énergie pour la colonie. Produit beaucoup d'atmosphère.",
            "medrecyclingcenter-description":        "Un centre de recyclage plus grand et plus efficace. Transforme vos poubelles en plastique et un peu d'aluminium!",
            "landfill-description":        "Creusez un trou géant et jetez toutes vos ordures dedans. Les déchets se décomposeront un peu plus vite que dans la petite fosse à ordures.",
            "unholybrewpit-description":        "Si vous souhaitez produire une quantité d’alcool, vous aurez besoin de cette fosse de brassage. Utilise le pouvoir de l’antaura pour vraiment augmenter la production de rhum.",
            "offline-game-desc":        "Commencer une nouvelle partie en mode local hors ligne. Aucune connexion requise, et vous devez choisir votre propre civilisation. Vous pouvez jouer avec d'autres joueurs sur votre réseau local.",
            "creative-mode-desc":        "Démarrer une nouvelle carte en mode créatif. Le jeu est hors ligne et vous ne pourrez pas le changer plus tard. Toutes les structures sont déverrouillées et peuvent être construites instantanément et gratuitement.",
            "unholypit-description":        "Stockez une grande quantité de marchandises en utilisant la puissance de l’antaura.",
            "unholymound-description":        "Ce nid fournit un abri pour 600 personnes et génère de l’antaura.",
            "coremine-description":        "Créée et exploitée avec le pouvoir extraordinaire de l’antaura, cette mine profonde apportera des ressources merveilleuses à votre colonie. Vous ne savez jamais ce que vous pourriez trouver...",
            "smlightpost-description":        "Fournit un peu de lumière à votre colonie.",
            "smredlightpost-description":        "Un quartier rouge dans #cityname? C'est à vous de voir.",
            "smgreenlightpost-description":        "Vos colons vont juste adorer ces feux verts.",
            "glowgoo-description":        "Lorsque vous mangez de la pâte de fourmi et que vous la recrachez dans un mélange de vieux aliments, la réaction chimique crée de la Glow Goo, à la fois dégoûtante et éclairante.",
            "streetlight-description":        "Construisez un grand poteau et placez une lumière dessus. Maintenant, vous pouvez voir la nuit!",
            "pasteboiler-description":        "Obtenez de la pâte de fourmi ultra chaude, qui rejette de l'atmosphère dans le ciel. Nécessite un flux constant de pâte de fourmi.",
            "atmosscrubber-description":        "Utilisez le pouvoir de l'IA pour éliminer les polluants de l'atmosphère.",
            "wall2-description":        "Ce grand, beau et sombre mur menaçant permettra à votre peuple de se sentir en sécurité.",
            "wall2light-description":        "De toute évidence, un mur de sécurité nécessitera un éclairage.",
            "general-start-construction":        "Démarrer la construction",
            "general-confirm":        "Confirmer",
            "hire-worker-header":        "Sélectionnez un lieu de travail.",
            "general-overview":        "Vue d'ensemble",
            "general-population":        "Population",
            "general-government":        "Gouvernement",
            "general-economy":        "Économie",
            "general-charter-code":        "Code de la charte",
            "general-col-location":        "Localisation de la colonie",
            "general-col-color":        "Couleur de la colonie",
            "general-col-screenshot":        "Capture d'écran de la colonie",
            "general-col-screenshot-desc":        "Prenez ou mettez à jour votre la capture d’écran affichée sur votre site web.",
            "general-tot-death":        "Nombre total de morts",
            "general-demographics":        "Démographie",
            "general-avg-age":        "Âge moyen",
            "general-cant-afford":        "Vos fonds sont insuffisants!",
            "ancienttemple-description":        "Un mystérieux temple construit par les anciens.",
            "diamondsolar-description":        "Une version plus efficace de la tour solaire, plaquée de diamants.",
            "bureaucracy-description":        "Fournit des emplois et des démarches administratives pour le gouvernement, créant ainsi du civisme.",
            "clothfarm-description":        "Un fait peu connu sur les insectoïdes est qu'ils sont capables de produire une substance soyeuse lorsqu'ils mangent de l’aluminium. Cette dépendance en profitera pour produire du tissu.",
            "cauldron-description":        "Décomposez des reliques alien en leurs artefacts individuels à l'aide d'un chaudron de pâtes de fourmis très chaud. Ceci est un processus coûteux en énergie",
            "supermarket-description":        "Lorsque les colons sont fatigués des rations fades de leur gouvernement, ils peuvent venir dépenser leur argent dans ce supermarché pour acheter les bonnes choses. Fournit de bons emplois peu rémunérés et de produit de l'argent tout en consommant de la nourriture et de l'eau.",
            "megamart-description":        "L’endroit où les colons vont trouver des offres intéressantes sur tout, de la nourriture aux jouets en passant par l'alcool et l'électronique!",
            "politheat-desc":        "Alors que votre population commence à comprendre que vous les dirigez d'une main de fer, il est temps de s'organiser et de leur faire croire qu'ils sont aux commandes.",
            "uecongress-description":        "Une institution inutile, incroyablement surévaluée, et symbole de l'excès gouvernemental, où les politiciens se rassemblent pour valider officiellement toutes vos décisions et nommer leurs repères. Si vous devez demander ce que cela coûte, c'est que vous ne pouvez pas vous l’offrir.",
            "refinery3-description":        "Utilisez la technologie alien pour transformer le minerai et l'uranium en quantités d'incroyables quantités d’acier. Vous ne serez plus jamais à court!",
            "antpastesynth-desc":        "Apprenez à créer artificiellement de la pâte de fourmi en laboratoire.",
            "pastesynth-description":        "Combinez les déchets et l'atmosphère sous un niveau élevé d'énergie pour créer une pâte de fourmi synthétique. Presque aussi bonne que la vraie!",
            "turbodrone-description":        "Ce drone peut construire tout ce que peut construire le drone de construction habituel. Juste 40 fois plus vite.",
            "sugarrover-description":        "Un bon rover travaillant dur pour traiter tout ce qui touche au sucre.",
            "smsugarprocessor-description":        "Une installation de stockage pour le sucre. Crée une petite quantité de nourriture en tant que sous-produit des opérations.",
            "check-render-distance":        "Vérifier la distance de rendu",
            "check-render-dist-desc":        "Dessine les bâtiments par segments en fonction de leur distance de rendu par rapport à la caméra. La désactivation accélère le jeu, mais produit des problèmes de rendu et des bâtiments mal ordonnés.",
            "general-place":        "Emplacement",
            "asteroidbase-desc":        "Les technologies de base issues du monde astéroïde.",
            "text-backup-instruction":        "Copiez ces données de jeu dans un éditeur de texte et enregistrez-les en tant que fichier .mcz",
            "general-avg-health":        "Santé moyenne",
            "general-avg-iq":        "QI moyen",
            "general-average-savings":        "Épargne moyenne des colons",
            "general-median-savings":        "Épargne médiane des colons",
            "general-trade-authority":        "Autorité du Commerce Galactique",
            "general-trade-too-recent":        "Votre dernier contrat est trop récent. Veuillez patienter avant d’en soumettre un nouveau.",
            "bloodletting-description":        "Profitez des dernières avancées de la médecine insectoïde moderne. La station de saignée assure la santé des malades et même le divertissement des personnes en bonne santé, car les saignées sont à la fois curatives et à la mode.",
            "spireknowledge-description":        "Lorsqu'un insectoïde pénètre dans cette flèche dorée, son esprit est tellement épris de sa beauté métallique que de la connaissance pure est générée.",
            "sphrad-description":        "Cet orbe métallique électrifié fournit une bonne lumière vive à la colonie.",
            "general-trade-too-big":        "En raison de contraintes d’entrepôt, l’Autorité du Commerce Galactique n’accepte pas les lots de taille supérieure à #maxaxots",
            "general-trade-gouging":        "L’Autorité du Commerce Galactique a rejeté votre transaction, car le Ministre de l’économie de l’Empire estime que vous êtes en train d’essayer de moduler les prix. Il n'accepte actuellement aucun prix de lot supérieur à $ #maxlotsize. Cette tentative a été enregistrée sur votre compte.",
            "general-trade-undercut":        "L’Autorité du Commerce Galactique a rejeté votre transaction, car le Ministre de l’économie de l’Empire estime que vous réduisez trop le marché. Il n'accepte actuellement aucun prix de lot supérieur à $ #maxlotsize. Cette tentative a été enregistrée sur votre compte.",
            "uraniumsilo-description":        "Un bac de stockage renforcé pour contenir de l'uranium.",
            "ancientbug-description":        "Pour créer une Ancientbug, il faut injecter à une jeune larve insectoïde des reliques et des artefacts extraterrestres, de manière à conserver, lors de son éclosion, toutes les connaissances des anciens.",
            "quantumsugarcloner-description":        "En utilisant le pouvoir des anciens, convertissez une unité de sucre en plusieurs. Nécessite de l'eau pendant le fonctionnement.",
            "general-collect-all":        "Tout collecter",
            "general-collect-all-desc":        "Donnez-moi tout en une fois!",
            "general-connection-error":        "Erreur de connexion",
            "connection-error-info":        "Impossible de se connecter au serveur My Colony. Les jeux en mode en ligne nécessitent une connexion Internet pour jouer.",
            "rawmatdepot-description":        "Dépôt et espace de stockage pour les matériaux de construction bruts.",
            "commandpost2-description":        "Un poste de commandement amélioré permettant plus de commerce et plus de possibilités décrets.",
            "unholycommand-description":        "Solidifiez votre pouvoir en utilisant l’antaura et des technologies extraterrestres interdites.",
            "object-options-dismiss-tip":        "Fermer la boîte de dialogue des options d'objet.",
            "object-options-stats-tip":        "Afficher des statistiques pertinentes pour l'objet sélectionné.",
            "object-options-activation-tip":        "Activer ou désactiver la structure sélectionnée pour gérer la consommation d'énergie et de ressources.",
            "object-options-comms-tip":        "Envoyer des messages et autres communications à travers la galaxie.",
            "object-options-mkcenter-tip":        "Faire de cette structure le point central de la colonie.",
            "object-options-flip-tip":        "Retourner l'orientation de la structure sélectionnée.",
            "object-options-empire-tip":        "Gérer et interagir avec votre Commonwealth.",
            "object-options-policy-tip":        "Définir et examiner les politiques gouvernementales de la colonie.",
            "object-options-diplomacy-tip":        "Faire du commerce et gérez la diplomatie avec les autres colonies.",
            "object-options-move-tip":        "Ordonner à l'unité sélectionnée de se déplacer vers un nouvel emplacement.",
            "object-options-harvest-tip":        "Ordonner à l'unité sélectionnée de commencer à collecter des ressources.",
            "object-options-park-tip":        "Attribuer à l'unité sélectionnée un emplacement de stationnement.",
            "object-options-repair-tip":        "Réparer la structure sélectionnée.",
            "object-options-destroy-tip":        "Détruire l'objet sélectionné.",
            "object-options-build-tip":        "Afficher les options de construction pour l'objet sélectionné.",
            "object-options-sell-tip":        "Vendre l'objet sélectionné.",
            "object-options-upgrade-tip":        "Mettre à niveau l'objet sélectionné.",
            "object-options-import-tip":        "Afficher les options d'importation de ressources pour la structure sélectionnée.",
            "object-options-export-tip":        "Afficher les options d’exportation de ressources pour la structure sélectionnée.",
            "object-options-trade-tip":        "Acheter et vendre des produits sur le marché mondial en ligne.",
            "helpful-tips-header":        "Conseils",
            "customsprocessing-description":        "Un centre de commerce interstellaire. Permet l'importation et l'exportation de marchandises et est un point de passage pour les touristes et autres visiteurs.",
            "opendoors-desc":        "Ouvrez les portes de votre colonie à la galaxie et accédez à de nouveaux marchés et de nouvelles opportunités!",
            "pastespa-description":        "Les touristes de toute la galaxie viendront se rassembler à #cityname pour se détendre dans ce spa à traitement par pâte, où la pâte de fourmi est injectée dans le corps, apportant soi-disant de nombreux bienfaits pour la santé.",
            "lavaworldbase-desc":        "Les techniques de base du monde de la lave.",
            "lavaworld-planet-desc":        "C’est pour ainsi dire le pire type de planète que vous puissiez coloniser. Ne le faites pas à moins de vous détester et de détester vos colons.",
            "lava-world-intro":        "Vous marchez sur un terrain vague impitoyable. La lave changera continuellement d'emplacement et de nouvelles éruptions volcaniques feront des ravages sur #cityname. Récupérez de la cristalline et du minerai pour commencer. Si les effets de lumière posent des problèmes de performances, vous pouvez les désactiver dans les paramètres.",
            "extremeobug-description":        "Ce petit gars robuste est conçu pour travailler dans les environnements les plus impitoyables.",
            "vaporizer-description":        "Utilisez la cristalline et l’atmosphère ambiant pour créer de l’eau vitale pour la colonie.",
            "queen-description":        "Les reines sont la colonne vertébrale de toute colonie d'insectoïdes. Elles creusent des nids et pondent des œufs, augmentant ainsi la population.",
            "general-deploy-loaded":        "Déployer des unités",
            "rovertransport-description":        "Transporteur aérien pouvant transporter jusqu'à cinq unités mobiles sur n'importe quel terrain.",
            "obsidiobug-description":        "Le seul insectoïde de la galaxie capable de récolter l’obsidienne, une pierre rare.",
            "earthlike-planet-desc":        "Planète facile avec beaucoup de ressources et très peu de défi. Idéal pour un débutant apprenant les bases ou pour un jeu occasionnel.",
            "general-new-map":        "Nouveau monde",
            "general-new-map-desc":        "Créez un nouveau monde à partir de zéro.",
            "general-edit-existing":        "Éditer existant",
            "general-edit-existing-desc":        "Modifier un monde existant.",
            "general-custom-map":        "Monde personnalisé",
            "general-map-meta":        "Metadata",
            "general-map-author":        "Créateur",
            "general-map-description":        "Description",
            "general-map-version":        "Version",
            "general-custom-map-desc":        "Jouez sur un monde personnalisé que vous avez téléchargé ou créé.",
            "general-import-map":        "Importer un monde personnalisé",
            "general-import-map-desc":        "Importez et installez un fichier de monde personnalisé (*.mcm) que vous avez enregistré sur votre appareil.",
            "desertworld-planet-desc":        "Un paysage chaud et aride avec peu de végétation mais de précieuses ressources dispersées.",
            "reptilian-description":        "Les reptiliens sont une espèce ancienne et très avancée, ayant migré il y a de nombreuses années hors de la galaxie.",
            "draconians-description":        "Les Alpha Draconians sont une civilisation reptilienne diabolique et très avancée technologiquement. Ils agissent en dépouillant les planètes de leurs ressources naturelles et en asservissant les populations indigènes.",
            "constructionprobe-description":        "La sonde de construction est un engin interstellaire sans équipage conçu pour préparer un nouveau monde avant sa colonisation par les reptiliens.",
            "draconians-welcome-message":        "Après des semaines de voyages interstellaires à grande vitesse, notre sonde de construction arrive sur #cityname. Sélectionnez la sonde et déplacez-la afin d’avoir une bonne zone d'atterrissage pour y fonder la colonie.",
            "poweredmatsilo-description":        "Tant que cette structure sera alimentée, elle fournira tout type d’espace de stockage pour une nouvelle colonie.",
            "microreactor-description":        "Un petit générateur nucléaire automatisé. Consomme petit à petit de l'uranium pendant le fonctionnement.",
            "slavegate-description":        "Comme les Alpha Draconians ne se soumettent et se soumetteront jamais au travail manuel, ils réduisent en esclavage des Insectoïdes depuis des siècles. Accédez au réseau galactique des esclaves insectoïdes et apportez de la main-d'œuvre gratuite dans votre colonie.",
            "antaniumimpactor-description":        "Broyeur industriel puissant qui transforme rapidement le minerai et l'or en antanium, un alliage utilisé pour la construction. Nécessite de grandes quantités d’énergie.",
            "microcondenser-description":        "Un petit condensateur de base pour transformer l'atmosphère en eau potable. Peut être assemblé par un enfant reptilien en moins de 2 heures.",
            "pavement9-description":        "Un élégant trottoir en mosaïque que les reptiliens adorent.",
            "desertworldbase-desc":        "La technologie de départ dans un monde désert.",
            "draconianbase-desc":        "La technologie de base pour la civilisation Alpha Draconians.",
            "reptbase-desc":        "La technologie de base pour la race reptilienne.",
            "fairwarning-description":        "Pour servir d'avertissement à tout Insectoïde asservi qui voudrait trahir les Alpha Draconians en tentant de s'échapper.",
            "autohydro-description":        "Une installation automatisée pour une production alimentaire de base.",
            "basicden-description":        "Un logement de base pour un citoyen reptilien.",
            "familyden-description":        "Les reptiliens obtiennent une dérogation de cohabitation de la part de #motherland peuvent cohabiter dans un repaire de famille, à condition de ne pas enfreindre la politique de l'enfant unique.",
            "medstargate-description":        "Les Reptiliens utilisent la technologie de la Porte des Étoiles depuis des siècles. Ces portes de moyenne portée peuvent transporter des marchandises et des civils à environ 3/4 de distance de l’autre côté de la galaxie.",
            "natflag-description":        "Ce drapeau montre que votre peuple arborera toujours fidèlement les couleurs de votre colonie.",
            "general-col-color-info":        "Définissez ou modifiez votre gouvernement et la couleur du drapeau de votre colonie.",
            "torturebooth-description":        "Cette installation de divertissement bon marché offrira à vos reptiliens des heures de divertissement. Pas comme pour le pauvre Insectoïde qui doit aller à l'intérieur.",
            "tut-medstargate":        "Étant donné que les Reptiliens utilisent beaucoup de ressources et que leurs employés refusent de travailler, vous devrez utiliser des Porte des Étoiles pour importer et exporter les produits nécessaires à l'expansion de votre colonie et au paiement de vos impôts.",
            "dronepad-description":        "Un petit tapis téléporteur qui vous permet d'acheter ou de vendre des drones de construction de #motherland de manière instantanée.",
            "uraextract-description":        "Cette sonde agile peut exploiter des gisements d'uranium brut! Imaginez toutes les possibilités!",
            "goldgrower-description":        "Ce producteur d’or est une sorte de coussin chauffant de haute technologie, capable de changer le minerai en or en utilisant la puissance de la cristalline.",
            "aluminumgrower-description":        "Ce puissant producteur d’aluminium peut créer de l’aluminium pur à partir de minerai et d’uranium en exploitant la puissance de la cristalline.",
            "pavement1light-description":        "Un trottoir ordinaire, mais avec un petit poteau lumineux intégré, afin que votre peuple puisse voir en marchant sur la route. Pas tout à fait aussi lumineux qu'un poteau d'éclairage seul, mais on peut marcher dessus.",
            "firstaid-description":        "Une petite station de guérison efficace où les colons peuvent aller se faire soigner rapidement.",
            "trashtransporter-description":        "Contrairement à de nombreuses autres espèces, les Reptiliens ont découvert comment s’occuper de leur problème de déchets, il ya plusieurs années. Vous construisez un téléporteur interstellaire et envoyez tout à la Terre Unie.",
            "pasteextractor-description":        "La pâte de fourmi est un agent de liaison important dans la construction avec l’antanium, et le véritable matériau ne peut être fabriqué que par les insectoïdes. Cependant, les insectes le font parfois contre leur gré pour leurs seigneurs reptiliens. Il a donc fallu créer d'autres méthodes d'extraction.",
            "arbsquare-description":        "Une petite place publique où un arbitre expose des peines et jugements qu’il juge appropriés à l’encontre des citoyens.",
            "general-entertainment-cap":        "Capacité des lieux de divertissement",
            "oreevaporator-description":        "En utilisant de grandes quantités d’énergie et de cristaux, transformez le minerai brut en hélium-3, une substance précieuse et puissante.",
            "pebbles-description":        "Les reptiliens adorent le look de ces galets de rivière, ainsi que le sentiment qu’ils éprouvent en marchant dessus.",
            "prairieweed-description":        "Importée des plaines sèches d'Alpha Draconis, cette herbe décorative fera sentir vos citoyens reptiliens comme à la maison.",
            "regenchamber-description":        "Bien manger et faire de l'exercice, c’est pour les oiseaux. Sautez juste dans cette chambre de régénération et voyez tous vos problèmes de santé disparaître!",
            "coalconvert-description":        "Si vous vous retrouvez dans une situation où vous avez beaucoup de charbon et pas beaucoup de minerai, construisez ce convertisseur de charbon de bois extraterrestre! Bien plus efficace que le compacteur à charbon standard. Transforme le charbon en minerai, mais consomme un peu d’eau et d’uranium lors du processus.",
            "pavement2light-description":        "Construisez cette bonne chaussée durcie afin de pouvoir voyager rapidement dans le noir!",
            "pillaroflight-description":        "Une bonne source de lumière vive pour que vos esclaves insectoïdes puissent continuer à travailler dans le noir.",
            "crudeextract-description":        "Ce noble robot va extraire du pétrole brut avec son tuyau allongé doré et le ramener à votre base pour traitement.",
            "brewmasterden-description":        "Pour les Reptiliens, le maître brasseur est l’un des membres les plus influents de la société et l’une des seules classes à encore effectuer des travaux manuels, en élaborant le rhum draconien, célèbre dans le domaine galactique, à partir d’eau, Ant Paste et de pétrole. C'est fort.",
            "councilarb-description":        "Une structure gouvernementale locale reptilienne où trois arbitres se rencontrent pour imposer une réglementation au reste de la colonie.",
            "realnews-description":        "Gardez vos sujets «informés» et générez du civisme en diffusant en direct les informations diffusées 24 heures sur 24 par Reptilian News Network. De vraies informations pour les vrais reptiliens. Des frais d'abonnement s'appliquent.",
            "relicstudies-description":        "Il y a d'étranges reliques extraterrestres dans l'univers. Effectuer des recherches sur ces objets et découvrez leur utilité. Utilise des robots tout en générant de la recherches, des artefacts et de l'aluminium au cours de d'exploitation.",
            "general-deportations":        "Déportations",
            "gen-deportations-desc":        "&quot;Make #cityname Great Again&quot; en envoyant vos problèmes ailleurs. Passez en revue les options d'expulsion des étrangersindésirables, voire des citoyens.",
            "adultdaycare-description":        "La garderie pour adultes est une excellente installation pour les colons avec un QI extrêmement bas. Avec le temps, même les élèves les plus simples peuvent atteindre un niveau d'intellect semi-fonctionnel.",
            "basiced-desc":        "Apprenez les bases pour les enseigner à vos colons!",
            "smschool-description":        "Une jolie petite école où vous pourrez initier vos citoyens aux bases de la lecture, de l'écriture et du calcul",
            "smschool2-description":        "Une école plus grande et de plus haut niveau pour enseigner des choses plus intéressantes. Donnera à vos étudiants les compétences dont ils ont besoin pour progresser sur le marché du travail.",
            "smschool3-description":        "Le meilleur des structures d'éducation de base. Entraînera et préparera votre personnel pour des travaux techniques avancés.",
            "deport-homeless":        "Déporter les sans-abri",
            "deport-homeless-desc":        "Vous avez un problème de SDF? Résolvez-le en les éliminant tous de #cityname.",
            "deportation-warning":        "Les déportations peuvent avoir une incidence sur votre côte de popularité.",
            "deport-poor":        "Déporter les pauvres",
            "deport-poor-desc":        "Déporter tous les citoyens qui ont moins de la moitié du taux d’épargne moyen.",
            "deport-arbitrary":        "Déporter arbitrairement",
            "deport-arbitrary-desc":        "Supprimez un nombre arbitraire de citoyens de #cityname aléatoirement.",
            "deport-arbitrary-ask":        "Combien de citoyens voudriez-vous déporter?",
            "bld-update-freq":        "Fréquence de mise à jour de la simulation",
            "bld-update-freq-desc":        "Choisissez à quelle fréquence le moteur met à jour la simulation. Des mises à jour plus fréquentes améliorent la précision de la simulation, au détriment des performances.",
            "bld-update-freq-def":        "Par défaut",
            "bld-update-freq-def-desc":        "La vitesse de simulation par défaut.",
            "bld-update-freq-12":        "Performance",
            "bld-update-freq-12-desc":        "Un cycle de mise à jour légèrement moins fréquent pour de meilleures performances.",
            "bld-update-freq-15":        "Rare",
            "bld-update-freq-15-desc":        "Un réglage adapté aux appareils plus lents, au détriment de la précision du jeu.",
            "bld-update-freq-30":        "Rare",
            "bld-update-freq-30-desc":        "Le réglage le plus performant. Peut causer des inexactitudes dans les statistiques, mais peut être nécessaire si votre appareil n'arrive pas à suivre.",
            "bld-update-freq-5":        "Précision",
            "bld-update-freq-5-desc":        "Une vitesse de simulation plus précise, mais peut-être plus lente.",
            "bld-update-freq-1":        "Perfection",
            "bld-update-freq-1-desc":        "La vitesse de simulation la plus précise possible. Nécessite un appareil haut de gamme, en particulier avec une population élevée.",
            "general-storage":        "Espace de stockage",
            "sweatshop4-description":        "Gagnez de l’argent aux dépens de votre peuple en produisant des tonnes de vêtements bon marché pour l’exportation.",
            "techtransce-desc":        "Faites le prochain saut quantique dans l'évolution, en combinant des êtres humains et des êtres artificiels en… êtres humains super intelligents!",
            "transacademy-description":        "L’Académie Transcendante est l’endroit où votre gouvernement implante des puces dans cerveau des colons et télécharge toutes les informations nécessaires dans leurs systèmes. Augmente considérablement leur QI.",
            "ancientinc-description":        "Opérant sous l'apparence d'une boulangerie de petits gâteaux bio, cette installation gouvernementale secrète consomme des quantités extrêmes d'énergie, d'artefacts, de triantanium et d'instructions anciennes pour créer des reliques extraterrestres. Génère également une petite quantité de nourriture pour maintenir sa couverture.",
            "aspentree-description":        "Des arbres plus grands avec une écorce et des feuilles plus claires. Fournit la même quantité de bois, mais change de look.",
            "engine-short-numbers":        "Nombres abrégés",
            "engine-short-numbers-desc":        "Abréger les grands nombres dans la barre d'affichage des ressources pour réduire l'encombrement de l'interface.",
            "engine-storage-limits":        "Afficher les limites de stockage",
            "engine-storage-limits-desc":        "Afficher ou masquer les limites de stockage des ressources sur l'interface principale. Informations utiles, mais prend plus de place.",
            "diamondsynth-description":        "Utilisez les connaissances en chimie et le charbon pour créer des diamants synthétiques! Ils ont l'air si réels, elle ne verra pas la différence.",
            "unicomm-description":        "La Bourse Universelle de Matières Premières permet l’accès aux marchés de toute la galaxie. En outre, suivant la tradition reptilienne, elle permet à vos pirates professionnels de voler des ressources sans être détectés par les planètes lointaines.",
            "statue6-description":        "Statue honorant le grand amiral Beuford P. Tots, chef de la rébellion de la LIS contre la Terre Unie.",
            "independencehall3-description":        "Le capitol impérial permet plus de commerce, plus de décrets et utilise encore plus de rhum.",
            "obsidianfurnace-description":        "Une chambre ultra-chaude pour créer une obsidienne rare dans un processus nécessitant beaucoup d’énergie, d'hélium 3 et plusieurs minéraux de base.",
            "largerres-description":        "Ce complexe résidentiel amélioré est plus grand et accueille plus de personnes. Il n’offre pas les meilleures conditions de vie, mais fonctionne.",
            "keyboard-flip":        "Pivoter l’objet actif",
            "object-options-clone-tip":        "Construire un autre objet de ce type.",
            "general-clone":        "Construire un autre",
            "cautionsign-description":        "Une barrière motorisée clignotante pour rester en alerte et tenir les colons à l’écart du danger.",
            "gravcompress-description":        "Cette installation de stockage hautement avancée crée un champ gravitationnel contenu et compressé, vous permettant de stocker d’énormes quantités de matériaux dans un espace réduit.",
            "online-switch-warning":        "Avertissement: dans un souci d’équilibre entre les modes en ligne et hors ligne, passer de votre jeu en mode en ligne vous fera perdre toutes vos ressources! Vous conserverez vos structures et votre population, mais les montants de chaque ressource que vous possédez sera remis à zéro. Cela peut entraîner une période instable dans votre colonie pendant que vous reconstituez vos réserves. Êtes-vous sûr de vouloir passer en mode en ligne? Vous ne pourrez pas revenir en arrière!",
            "galartsexpo-description":        "Les reptiliens sont connus dans toute la galaxie pour posséder les meilleures collections de beaux-arts, principalement dérobés à d'autres civilisations. Les gens viendront de partout dans l'univers pour voir la collection. Au fil du temps, des artistes saouls viendront également produire leurs propres œuvres.",
            "patriden-description":        "Le meilleur logement unifamilial de la culture reptilienne. Fournit des logements raffinés à une grande famille de reptiles de la classe supérieure.",
            "obeliskofplenty-description":        "Le pilier du mode de vie communautaire. Venez partager vos pièces avec vos frères et amis à l'Obélisque d'Abondance.",
            "unholyobsidian-description":        "Combinez le pouvoir des Anciens avec le pouvoir de l’Antaura pour fondre l'Antanium et l'or en une obsidienne durcie et rare!",
            "crystalbot-description":        "Ce petit bonhomme est spécialisé dans le travail avec les cristaux synthétiques, un élément rare.",
            "darkpavementlit-description":        "Semblable à la chaussée normale, mais continent une source de lumière.",
            "solarroad-description":        "Ce n'est certainement pas la route la moins chère, mais elle vous permet de faire d'une pierre deux coups en fournissant un chemin et en générant de l'énergie.",
            "aliensolar-description":        "C'est ce que vous pouvez faire de mieux en termes de production d'énergie solaire. Ce n’est le générateur le plus puissant, mais au moins il ne nécessite pas de carburant.",
            "thewheel-desc":        "Il est difficile de croire que les Insectoïdes soient allés aussi loin dans la vie sans jamais avoir connaissance de la roue. Une fois qu’ils découvrent ce secret, qui sait ce qu’ils peuvent inventer?",
            "ftltravel-desc":        "Découvrez les secrets de la construction d'un grand vaisseau spatial capable de voyager plus vite que la vitesse de la lumière!",
            "wheelfactory-description":        "Mettez votre personnel au travail en créant tout simplement des roues, un élément essentiel dans la fabrication des rovers!",
            "statue7-description":        "Cette belle statue fête les deux ans de la sortie de My Colony!",
            "shipyard-description":        "Un chantier de construction pour des vaisseaux massifs capables de voyager plus vite que la vitesse de la lumière.",
            "starport-description":        "Toute colonie avec un port stellaire devient un acteur majeur sur la scène galactique. Accueillez et facilitez les voyages intergalactiques, le commerce et le mercantilisme stellaire.",
            "taxcollection-description":        "Chaque fois que votre gouvernement dit qu'il paie 10 000 $ pour un marteau, ne vous y trompez pas. Ce ne sont pas non plus des projets top secrets sur lesquels ils travaillent. Ils rendent hommage aux seigneurs reptiliens qui les ont nommés et l'argent collecté est versé dans ce bureau de perception des impôts.",
            "chiptransporter-description":        "Non, votre ordinateur n'est pas tombé en panne. Les Reptiliens viennent d'utiliser ce téléporteur quantique pour remplacer votre puce électronique par un vieux morceau de fromage suisse. Beaucoup plus facile que de réellement produre des micropuces.",
            "general-trade-notifications":        "Notifications commerciales",
            "wheellodge-description":        "Là où la coopérative des fabricants de roues se réunit pour produire des roues de haute technologie pour la colonie",
            "constructionmech-description":        "Cette machine de construction mobile est une classe spéciale d'unités pouvant être déployée dans une structure qui construit d'autres unités. Elle peut également transporter jusqu'à 8 unités supplémentaires à l'intérieur de son cargo pour le transport.",
            "general-delete-all":        "Supprimer tout",
            "gen-delete-all-confirm":        "Êtes-vous sûr de vouloir supprimer tous ces bâtiments? Ça ne peut pas être annulé!",
            "gen-delete-mod-q":        "Ce mod est déjà désactivé. Souhaitez-vous le supprimer du jeu?",
            "gen-dl-tex-mod":        "Télécharger des packs de textures",
            "gen-dl-mod-desc":        "Parcourez et téléchargez les packs de texture que d'autres utilisateurs ont créé.",
            "hipsterlofts-description":        "Les hipsters vont payer le prix fort pour un logement branché au centre-ville, mais seulement si ce logement se présente sous la forme d’une usine de pneus reconstituée du début du XXe siècle et abandonnée. Les résidents boiront du rhum et créeront des peintures de différentes qualités.",
            "crystallineenrichment-description":        "Cette petite station utilise l'hélium 3 pour exploiter la puissance de la crystalline afin de créer de l'uranium pur.",
            "advmicroreactor-description":        "Une version plus puissante du microréacteur, fournissant beaucoup d'énergie pour la colonie.",
            "diamondbot-description":        "Un rover Insectoïde de base conçu pour traiter tout ce qui concerne le diamond.",
            "unholydiamondspawner-description":        "Cette structure épique produira continuellement des diamants, qui eux-mêmes pourront se répandre lentement dans un certain rayon.",
            "coloredtile-description":        "Ajoutez une touche de couleur à la colonie avec ces carreaux décoratifs.",
            "hedgewall-description":        "Prouvez à votre peuple que vous aimez la nature tout en le protégeant des zones importantes.",
            "footpath-description":        "Vos colons adoreront se promener sur ce sentier pavé.",
            "aagoldgen-description":        "Utilisez le pouvoir des anciens pour générer des quantités extrêmes d'or!",
            "turboet-description":        "Un constructeur extraterrestre boosté, coûtant un peu plus cher mais construisant des structures 40 fois plus rapidement.",
            "regzapper-description":        "Stimulez le minerai avec de grandes quantités d'électricité, le décomposant en régolithe.",
            "obsgen-description":        "Faites frire le minerai et la fourmi en utilisant de la cristalline pour créer de l'obsidienne pure",
            "multithreaded-pathfinding":        "Recherche de chemins multi threadé",
            "multithreaded-pathfinding-desc":        "Sur de grandes cartes, la recherche multi threadée peut améliorer la vitesse et les performances du jeu. Toutefois, en fonction de votre appareil, cela peut réduire les performances en raison d’une consommation accrue de RAM. Essayez les deux réglages et voyez ce qui vous convient le mieux.",
            "gen-sel-game-type":        "Sélectionnez le type de jeu",
            "gen-single-city":        "Ville unique",
            "gen-single-city-desc":        "Commencez une nouvelle partie dans une seule ville. Vous choisissez la taille du monde souhaitée et l’abondance des ressources au départ.",
            "gen-region-city":        "Région",
            "gen-region-city-desc":        "Commencer une nouvelle région. Une région est composée de nombreuses petites villes construites les unes à côté des autres. Les villes de la région partagent leurs ressources et les technologies, la recherche, l'électricité et les niveaux atmosphériques.",
            "new-region-info":        "Entrez un nom pour votre nouvelle région.",
            "transtri-description":        "Le problème est que personne ne sait vraiment comment fonctionne ce bâtiment. Il n’a pas de travailleurs, n’utilise pas de robots, mais du triantanium en sort.",
            "rawmatextract-description":        "En utilisant de grandes quantités d’électricité et des technologies de téléportation, extrayez chaque once de matière première du sol sous des kilomètres.",
            "plastfact3-description":        "Croyez-moi, personne ne savait fabriquer du plastique comme les anciens extraterrestres.",
            "lawchamber-description":        "Le siège du gouvernement de base pour un État indépendant reptilien.",
            "dracemb-description":        "Une ambassade draconienne simple mais fonctionnelle.",
            "clayden-description":        "Là où l'artisan potier passe ses journées avec sa petite famille à créer de belles poteries.",
            "homelessshelter-description":        "Ceux qui disent que les Reptiliens n’ont pas de cœur n’ont jamais visité l’un de ces beaux logements sociaux. Fournit à votre population un logement abordable de haute qualité, amenant paix, dignité et éducation de base à ceux qui n'en ont pas.",
            "crystallinedrill-description":        "Utilisez un laser de cristalline de haute puissance pour creuser profondément dans le sol et extraire de l'eau pour la colonie, ainsi que quelques autres éléments de base.",
            "bugsaw-description":        "La scie à insectes est comme une boucherie automatisée pour insectoïdes. Hache les Insectoïdes dans diverses coupes de viande pour la colonie, et transforme les parties restantes en pâte de fourmi. Fournit également un peu de divertissement à tous ceux qui souhaitent regarder le plaisir.",
            "gen-federation": "Fédération",
            "federation-desc": "Créer, gérer ou se retirer d’une fédération, une alliance multijoueur de colonies en ligne.",
            "fed-founding-msg": "L'empereur galactique est le souverain suprême de la galaxie, mais il a jugé bon de permettre aux Commonwealths de se regrouper en alliances, ou Fédérations, à condition qu'elles soient prêtes à lui acheter une charte. ",
            "gen-found-federation": "Fonder une nouvelle Fédération",
            "gen-streaming": "Streaming",
            "gen-streaming-on": "La diffusion en direct est maintenant activée. Vous diffusez un flux en direct de votre jeu sur votre site web colonial sur my-colony.com. Le son est également diffusé. Le streaming utilise des données et peut avoir un impact sur les performances. ",
            "pib-croissance": "Taux de croissance du PIB",
            "found-fed-pick-name": "Vous souhaitez donc fonder une fédération. On ne peux pas vous en vouloir. Fonder une fédération dans My Colony peut être une expérience amusante et enrichissante. Choisir le nom d'une fédération est l’étape la plus importante. Comment voulez-vous appeler la vôtre? ",
            "join-federation": "Rejoindre une fédération",
            "join-federation-desc": "Demandez à rejoindre une fédération existante. Les membres actuels voteront votre requête et, si elle est approuvée, vous deviendrez membre votant de la Fédération.",
            "atmosgen3-description": "Lorsque vous vous sentez prêt à prendre au sérieux vos besoins en matière de génération d'atmosphère, vous avez besoin du grand générateur d’atmosphère.",
            "join-fed-confirm": "Êtes-vous sûr de vouloir faire une demande d'adhésion à cette fédération?",
            "gen-balloting": "Vote",
            "gen-balloting-desc": "En tant que membre votant de la Fédération, vous avez le droit de participer au vote. Voici les votes en cours qui requièrent votre attention.",
            "description de petropit": "Produit du pétrole brut en utilisant une combinaison de plusieurs éléments différents, notamment de la pâte de fourmi, du bois, de l'obsidienne, de la cristalline et de la nourriture.",
            "insctoil-desc": "Découvrez les secrets de la production de pétrole!",
            "bugnukes-desc": "Utilisez un pouvoir mystique épique pour créer de l'uranium pur!",
            "unholyuraniumgenerator-description": "Exploitez l’antaura pour convertir l'aluminium en uranium!",
            "chamberfathers-description": "Une institution du gouvernement très spéciale et très puissante. Elle permet un vaste contrôle sur la colonie et ouvre un lien de communication quantique avec les ''ancêtres'' des Reptiliens.",
            "manual-civs-intro": "Chaque civilisation de My Colony propose différents bâtiments, arbres technologiques, unités et planètes de départ disponibles. Chacune offre également son propre scénario, son style de jeu et son ensemble de défis. Elles valent toutes la peine d’être jouées. Cela dit, nous suggérons aux débutants de commencer à jouer avec la Terre Unie (United Earth), car c’est la civilisation la plus polyvalente et offrant des planètes de départ relativement faciles. ",
            "ue-extended-backstory": "L'année 2051 fut une période faste pour les peuples de la Terre. La plupart des pays développés s'effondrent sous le poids d'une longue dépression économique mondiale, et ce qui étaient autrefois des grandes villes sont sous la domination de la l’anarchie. \n\nSous la menace de faillite, les Nations Unies ont été vendues aux enchères à un groupe, petit mais puissant, de milliardaires, qui ont rapidement rebaptisé l’institution sous le nom de Terre unie. En utilisant les armes ou en versant des pots de vins, la Terre Unie a commencé à annexer de nombreux États-nations autrefois indépendants, pour finalement contrôler la majorité de la planète. L’Assemblée Générale a été créée dans le but de donner à la population de la Terre l’illusion de la démocratie et la promesse de promouvoir la paix et la stabilité sur la planète, bien que le pouvoir réel ait été confié au nouveau président de la Terre Unie. \n\nSous le Président de la Terre Unie et de l'Assemblée Générale, la situation économique s'est quelque peu améliorée, mais les temps étaient encore difficiles. C’est au cours de cette période que de nombreux citoyens désillusionnés ont commencé à quitter la Terre en masse, préférant tenter leur chance sur des mondes désolés et stériles plutôt que de souffrir de la tyrannie et de la stagnation sur leur planète. ",
            "zolarg-extended-backstory": "Pendant des siècles, la race Insectoïde a vécu en paix et en harmonie sur la planète Bouwland. En tant que société essentiellement fondée sur l'élevage et la culture du sucre, les Insectoïdes ne souhaitaient guère former une armée ou atteindre le étoiles.\n\nTout a changé lorsque l’armée du diabolique empire Alpha Draconian a envahi Bouwland, réduit en esclavage la plus grande partie de la population et laissée derrière elle un désert stérile et inhabitable. \n\nPendant des siècles, les pauvres Insectoïdes ont été contraints à des travaux forcés et envoyés aux quatre coins de la galaxie pour servir d’esclave ou de fourrage militaire aux Alpha Draconians. \n\nAlors un jour sur la planète Draconis 12, un jeune insecte courageux nommé Zolarg a mené une révolution des esclaves qui a finalement réussi à renverser le gouvernement draconien. Les Insectoïdes ont rapidement exécuté tous les reptiliens, ont pris le contrôle de la planète et l'ont renommée Zolarg Prime, en l’honneur de l’empereur à la vie du nouveau peuple dela planète, qui est devenu le nouveau monde natal de la race des insectes . \n\nLes Zolarg parcourent maintenant les étoiles pour tenter de libérer leurs frères des camps d’esclaves Alpha Draconians. Les deux civilisations restent bloquées dans une guerre sans fin. ",
            "lis-extended-backstory": "Lorsque la diaspora de la Terre Unie a commencé à s'établir sur d'autres planètes et à mettre en place des gouvernements coloniaux, les habitants de Terra Nova ont été les premiers à se lasser de payer des taxes scandaleuses à l'Assemblée Générale de l'UE (la Terre Unie). L’Assemblée Générale a tenté de les contraindre à payer en commençant par un embargo sur les biens de commerce. En vain. Un embargo sur l’immigration et un blocus de la planète ont donc été mis en place. \n\nAprès des mois d’embargo, Terra Nova a toujours refusé. Pour les faire céder, le président de la Terre Unie a envoyé un détachement de Space Marines pour occuper la capitale et ramener la ville sous le contrôle de la Terre. \n\nEn réponse à cette opération, un commandant de la milice de Terra Nova, connu sous le nom de l'amiral Beuford P Tots mena les habitants de Terra Nova dans une rébellion obligeant les Marines à évacuer la planète. Le Congrès Colonial de Terra Nova envoya alors une déclaration officielle d'indépendance à l'Assemblée Générale de la Terre Unie, et la planète fut renommée État Indépendant. \n\nInspirés par les actions menées sur Terra Nova et submergés par la taxation extrême imposée par l'Assemblée Générale de la Terre Unie, les systèmes solaires voisins ont commencé à faire de même et bientôt la Ligue des États Indépendants était née, une alliance de planètes avec un traité de défense commun contre une éventuelle agression de la Terre Unie. \n\nL'indépendance des États membres de la LIS n'a pas été officiellement reconnue par l'Assemblée Générale de la Terre Unie, qui considère toujours ces planètes en rébellion. ",
            "draconian-extended-backstory": "Il s’agit d'une des plus anciennes civilisations de la galaxie : les Alpha Draconians se considèrent comme les héritiers des Anciens, une ancienne et mystérieuse civilisation qui recouvrait la plus grande partie de la galaxie connue, dont les traces être retrouvés enterrés dans la plupart des planètes habitables.\n\nSi on ignore ce qu'il est advenu des Anciens, les Alpha Draconiens ont bien hérité de la plus grande partie de leurs technologies, ce qui leur confère un avantage brutal dans les conflits avec les systèmes voisins. Cet avantage a notemment été ressenti par la race Insectoïde, qui a été réduite à l’esclavage dans toute la sphère d'influence de l'empire Alpha Draconian.\n\nLorsqu'ils n'utilisent pas leur avantage technologique pour conquérir, ils l'utilisent pour le contrôle et l'exploitation. De nombreux gouvernements à travers la galaxie sont sous le contrôle direct des Draconiens, leurs représentants «élus» étant de simples marionnettes au service des Reptiliens. Les divertissements, l’éducation et les médias sont tous contrôlés par la propagande draconienne.\n\nLes réactions sont à la fois positives et négatives. L’élite draconienne est devenue extrêmement riche grâce à l’exploitation et au travail forcé, mais la combinaison de la technologie de pointe et du travail forcé a laissé la majorité de la population pauvre et démunie. Les émeutes et les soulèvements sont courants dans les colonies draconiennes et, généralement, une fois qu'une planète est privée de ses ressources, l'élite draconienne fait ses bagages et laisse les citoyens ordinaires derrière elle se débrouiller.\n\nUne autre grande menace pour les Alpha Draconians sont les capacités technologiques et militaires croissantes des dernières colonies d'insectoïdes de l'empire de Zolarg, qui se sont montrées de plus en plus agressives dans leur résistance contre l’empire. ",
            "manual-controls-intro": "My Colony propose plusieurs modes de contrôles, en fonction du type et des capacités de votre appareil, ainsi que de votre style de jeu préféré. Bien que le jeu ait été conçu pour des commandes de clavier et de souris, il a été adapté pour prendre en charge les configurations les plus courantes. ",
            "manual-keyboard-intro": "Le schéma de contrôle optimal pour My Colony est le combo clavier et souris/stylo, car le jeu est conçu pour cette interface en premier lieu.\n\n Les contrôles de souris ou de stylo sont assez intuitifs. Vous pouvez sélectionner des unités et des bâtiments en un seul clic. Vous pouvez cliquer et maintenir enfoncé, puis faire glisser la souris pour sélectionner toutes les unités d'une zone. Un double-clic sur une unité sélectionne toutes les unités de ce type. Lorsqu'une unité est sélectionnée, un clic droit exécutera une action en fonction de ce que vous avez précédemment cliqué avec le bouton droit de la souris, qu'il s'agisse d'un ordre de récolte, d'un ordre de déplacement ou d'un ordre de construction. La carte défile par un cliquer/glisser ou en mode plein écran, vous pouvez également simplement déplacer le curseur de la souris. La molette de la souris permet d'effectuer un zoom avant ou arrière.\n\nLe moteur prend également en charge divers raccourcis clavier, qui peuvent tous être personnalisés dans le menu Paramètres. Ci-dessous est une référence des raccourcis clavier actuellement disponibles: ",
            "manual-touch-intro": "My Colony offre une interface tactile fonctionnelle sur tout périphérique contenant un écran tactile. La plupart des actions tactiles sont de nature similaire aux entrées à clic de souris, bien qu'il existe des différences mineures. Le zoom avant et arrière ce fait avec le geste de pincement standard, et le défilement de la carte est également fait de manière intuitive. ",
            "manual-gamepad-intro": "En plus du clavier et des fonctions tactiles, My Colony est entièrement jouable avec une manette de jeu. Lorsque vous utilisez une manette de jeu, l'interface utilisateur se transforme automatiquement en une interface optimisée pour les télévisions ou autres périphériques grand écran.\n\nL'interface de la manette de jeu a été conçue avec la disposition des contrôleurs Xbox 360/One, car elle est devenue la disposition standard des manettes de jeu pour de nombreux contrôleurs PC et Android. Les commandes suivantes ont été configurées dans cet esprit, bien que les noms des boutons puissent différer selon la marque et le style de la manette que vous utilisez: ",
            "gen-local-mode": "Jeu local",
            "manual-local-mode": "Jouer à un jeu local dans My Colony ne nécessite ni compte ni connexion en ligne. En mode local, vous démarrez le jeu en tant que sous-colonie de l'une des civilisations IA, et vous devrez payer un taux d'imposition par défaut jusqu'à votre indépendance. L'intelligence artificielle ne vous offrira aucune aide supplémentaire lors de la constitution de votre colonie.\n\nLes jeux locaux peuvent néanmoins être joués en mode multijoueur via LAN/Wifi avec d'autres joueurs en mode local sur le même réseau. Ce mode est multi-plateformes et compatible avec tous les appareils, sauf lorsqu'il est utilisé via un navigateur Web (pour des raisons de sécurité), à moins que le logiciel Ape Apps Desktop Bridge (faisant partie du programme Ape Apps Launcher) n’aie été installé et activé. Les joueurs peuvent échanger des messages et des ressources entre eux.\n\nA moins d’utiliser un monde customisé ou un monde en mode créatif, une colonie en mode local pourra être changée en mode en ligne (cela coûtera à la colonie toutes ses ressources).\n\nEn mode local, la détection de triche est à moitié désactivée : une colonie ayant triché ne sera pas punie, mais le jeu empêchera cette colonie de passer en mode en ligne.",
            "manual-online-mode": "Les joueurs disposant d'un compte Ape Apps valide et d'une connexion Internet peuvent jouer à My Colony en mode en ligne. Un jeu en ligne est généralement similaire à un jeu local, mais il existe plusieurs différences essentielles.\n\nSi vous démarrez une partie en mode en ligne, votre colonie sera sous le contrôle de la colonie d’un autre joueur. Le joueur contrôlant la colonie parentale pourra choisir d’augmenter ou diminuer votre taux d'imposition, voire de ne facturer aucun impôt. Les colonies mères envoient généralement des dons à leurs colonies filles pour les aider à démarrer. ",
            "manual-online-commonwealth": "Dans le jeu en ligne, la colonie mère d’une colonie fille est appelée le Commonwealth. Une fois qu'une colonie en ligne devient indépendante, elle devient le chef d'un nouveau Commonwealth. Toute colonie qui adhère à la charte d’un Commonwealth devient un État membre de ce Commonwealth. Les joueurs peuvent choisir de rejoindre n'importe quel Commonwealth en utilisant un code de charte, qui se trouve sur l'écran des statistiques de celui-ci. Plus d'informations sur les codes de charte et la liste des principaux Commonwealths en ligne sont disponibles à l’adresse https://www.my-colony.com\n\nLes avantages de l’adhésion à un Commonwealth varient largement en fonction de la colonie mère et du joueur qui la contrôle. Si vous êtes intéressés à l’idée de jouer en ligne trouver un Commonwealth actif, nous vous invitons à consulter la section Commonwealth sur le forum de My Colony. ",
            "manual-online-fererations": "Les fédérations sont la structure organisationnelle au-dessus du Commonwealth et sont des alliances formelles de Commonwealth indépendants. Les fonctionnalités des fédérations en est à ses balbutiements et est encore en développement.",
            "manual-online-ambassy": "Les chefs d’un Commonwealth indépendant peuvent demander la création d'une ambassade dans d'autres colonies indépendantes, à condition de connaître le code de charte de l'autre colonie. Si la demande d'ambassade est acceptée, une nouvelle ambassade de votre colonie peut être construit dans la colonie destinataire. Les ambassades permettent diverses actions diplomatiques, y compris la messagerie, le commerce des ressources, la fourniture d’aide, etc.",
            "manual-online-trade-hdr": "Commerce de ressources",
            "manual-online-trade-desc" :" Les colonies en ligne ont également accès à l'échange de ressources sur le marché galactique. La plupart des joueurs y font référence sous le nom du bâtiment de la Terre Unie qui y donne accès, le Galatic Board of Trade.\n\nLorsquevous jouez en ligne, les ressources actuellement sur le marché ont un impact important dans chaque colonie en ligne, car tous les prix locaux sont déterminés par leur valeur sur le marché. Dans une colonie donnée, les fluctuations de ces prix peuvent avoir des conséquences très diverses, allant de la taille et de la puissance de votre économie au bonheur (ou à la volonté de continuer à travailler) de chaque colon. ",
            "manual-creative-mode": "Le mode créatif existe pour les joueurs qui souhaitent simplement se détendre et construire. En mode créatif, toutes les structures du jeu sont déverrouillées et peuvent être construites sans nécessiter de technologie ni de ressources. Pour des raisons évidentes, les jeux en mode créatif ne peuvent pas être changés en mode en ligne. ",
            "manual-single-city": "Que vous commenciez un jeu en mode local, en ligne ou créatif, vous pouvez choisir entre une seule ville et un jeu régional.\n\nDans un jeu de ville seule, votre colonie entière est contenue dans un seul fichier. Au démarrage du jeu, vous êtes en mesure de choisir la taille du monde sur laquelle vous souhaitez jouer, ainsi que l'abondance des ressources de départ sur cette carte. Plus tard dans le jeu, au fur et à mesure que votre niveau de gouvernement augmente, vous pouvez augmenter la taille de votre monde en annexant de nouveaux terrains. Les performances du jeu se dégradent à mesure que la taille de votre monde augmente, en particulier sur les appareils plus lents. Pour cette raison, le mode régional a été créé. ",
            "manual-regions": "Le mode régional a été ajouté au jeu en raison de problèmes de performances liés aux mondes en constante expansion. Une région limite la taille des villes au niveau petit ou moyen, et la possibilité d'étendre les mondes à l'aide de la fonction d'annexion est désactivée. Le point positif dans cette limitation réside dans le fait qu’une seule région peut contenir jusqu’à 2 500 fichiers de villes au total, ce qui permet théoriquement des colonies énormes.\n\nLes régions fonctionnent en scindant une colonie en petits morceaux, chaque groupe étant traité séparément tout en partageant les mêmes ressources et technologies. Cette configuration augmente considérablement les performances des très grandes colonies et permet de construire une colonie en blocs spécialisés. Les statistiques économiques et démographiques sont disponibles pour les villes individuelles et pour la région dans son ensemble, mais pour les statistiques en ligne, les statistiques de la région entière sont utilisées. ",
            "gen-map-types": "Types de mondes",
            "manual-map-types": "Le type de monde sur lequel vous choisissez de jouer aura un impact important sur le gameplay et la difficulté du jeu. Passez en revue les détails de chaque type de carte avant de créer une nouvelle colonie." ,
            "gen-races": "Espèces",
            "manual-races-desc": "Dans My Colony, il existe plusieurs espèces, chacune avec des bonus de départ spécifiques. La civilisation que vous choisirez détermine l’espèce de vos premiers colons, mais au fur et à mesure que votre colonie s’agrandit et s'étend, d'autres espèces de la galaxie peuvent immigrer. ",
            "manual-play-modes-desc": "Il existe diverses façons de jouer à My Colony, ce qui offre d'innombrables heures de jeu. Vous pouvez jouer en ligne, hors ligne, en mode créatif, avec un monde personnalisé, avec une seule ville ou une grande région. Le jeu permet d'innombrables fichiers de sauvegarde, de sorte que vous pouvez essayer tous les styles pour voir celui que vous préférez!",
            "manual-res-desc": "La gestion des ressources est une composante essentielle de My Colony, et il est essentiel de gérer correctement les entrées, les sorties et le stockage des ressources si vous souhaitez que votre ville se développe et prospère. Les ressources vous permettent de construire votre colonie, augmenter votre population et rechercher de nouvelles technologies. ",
            "manual-tech-header": "La recherche et la découverte de technologies vous permet de déverrouiller de nouveaux bâtiments et véhicules, ouvrant ainsi de nouvelles possibilités de croissance pour votre colonie.\n\nLa hiérarchie technologique de My Colony n'est pas linéaire. Par exemple, si vous tentiez de faire dessiner l'arbre technologique par un programme (pour ce manuel, par exemple), cela ne serait ni possible ni pratique, car chaque nouvelle technologie dépend de technologies issues non seulement de plusieurs branches différentes de l'arbre, mais aussi sur des ressources qui peuvent ou non avoir été déverrouillées par le joueur à un moment donné. Par conséquent, pour être facilement lisible, tout arbre technologique visuel doit être créé et mis à jour manuellement. Un tel arbre technologique existe sur le site de référence en ligne de My Colony: https://www.my-colony.com/reference/\n\nToutes les technologies sont énumérées ici par ordre alphabétique pour une recherche et des références faciles, avec une description de chacun, leurs exigences, et ce qu'ils peuvent déverrouiller. ",
            "manual-buildings-desc": "De nombreux bâtiments sont disponibles dans My Colony: #gamebuildingcount au total. Pour cette raison, les placer dans un ordre autre que l'ordre alphabétique dans ce manuel rendrait la recherche extrêmement difficile.\n\nLa référence en ligne de My Colony est disponible à l'adresse https://www.my-colony.com/reference/ et fournit des tableaux de recherche interactifs pour toutes les structures du jeu, y compris leurs exigences technologiques, leurs coûts et leur production. ",
            "enc-print-status": "Avertissement - Environ 200 pages de long.",
            "manual-vehicle-desc": "Les véhicules (ou unités) sont les principaux outils de travail dans My Colony. Ils vous permettent de construire des structures et de récolter des ressources vitales. Il existe de nombreuses unités différentes que vous pouvez construire et gérer dans le jeu. Les voici ici énumérés par ordre alphabétique. ",
            "manual-terms-header": "Glossaire des termes",
            "manual-terms-desc": "Tout au long de ce manuel, et dans le jeu en lui-même, vous devez connaître plusieurs termes qui vous permettront de savoir parfaitement de quoi il est question.",
            "manual-concepts-header": "Concepts de jeu",
            "manual-concepts-desc": "Cette section décrit certains des concepts de jeu clés de My Colony, notamment comment se familiariser avec votre première colonie et effectuer certaines actions de base du jeu.",
            "waterworld-base-tech": "La technologie de départ pour le monde maritime.",
            "water-world-desc": "Une planète recouverte d'un océan avec de petites îles éparses. Vous allez devoir micro-gérer le bois au début afin survivre.",
            "bridge1-description": "Lorsque vous avez juste besoin de traverser un plan d’eau, vous avez besoin de ce petit pont en bois. Disponible en orientation Est/Ouest ou Nord/Sud et doit être construit sur l'eau.",
            "goldreducer-description": "Pour les temps étranges où l'or est abondant et où le minerai se fait rare. Utilise une ancienne technique Insectoïde pour décomposer lentement l'or en minerai,cela en brûlant lentement du sucre.",
            "embridge-description": "Ce pont de haute technologie vous aidera à déplacer les citoyens et les esclaves de la même façon sur l'eau et sur la lave.",
            "sandpath-description": "Quitte à avoir beaucoup de sable qui traîne, autant en faire un chemin.",
            "fisherbot-description": "À chaque fois que vous avez besoin de faire quelque chose dans votre colonie, ce robot est toujours à la pêche. Typique.",
            "fisherbothut-description": "Ce petit bâtiment soigné peut construire et gérer des robots-pêcheurs, leur permettant de collecter du poisson et de le transformer en nourriture pour la colonie, sous la forme de délicieux bâtonnets de poisson.",
            "steelbridge-description": "Plus fort qu'un pont en bois, ce pont permet un déplacement plus rapide et peut même être construit sur la lave.",
            "alumbridge-description": "La surface en aluminium lisse de ce pont permet un déplacement plus rapide.",
            "goldbridge-description": "Vos sujets sauront que vous aimez l’excès lorsqu'ils traverseront ce beau pont en or.",
            "fisherbug-description": "Apprenez à un insecte à pêcher ... et il ira chercher du poisson sur le rivage, le mettra dans sa bouche, le ramènera au nid et le régurgitera sous la forme de nourriture et du sucre. Miam.",
            "pastepontoon-description": "Un pont flottant primitif constitué de billes coupées grossièrement liées ensemble avec de la pâte à fourmi.",
            "usedminer-description": "Achetée d'occasion ou reconstituée dans divers ateliers, cette vieille minière n'est pas aussi bonne qu'une nouvelle, mais elle peut encore servir.",
            "shipbuilding-desc": "En raison de l'utilisation intensive de Portes des Étoiles, des recherches sont nécessaires pour concevoir et produire des vaisseaux spaciaux, qui sont nécessaires pour aller partout où il n'y a pas déjà de Porte des Étoiles en place.",
            "shipworks-description": "Installation pour la fabrication du Sloop draconien, une classe de vaisseau spatial connue dans toute la galaxie pour sa vitesse et sa puissance de feu.",
            "héreditaryrule-desc": "Les Reptiliens aiment être dirigés par un homme fort, alors faites régner une nouvelle monarchie sur ce monde et donnez aux gens ce qu'ils veulent!",
            "chamberofkings-description": "Cette ultime structure de gouvernance draconienne est enfin à la hauteur de votre puissance.",
            "general-trade-too-cheap": "L'Autorité Galactique du Commerce n'accepte pas les prix de lot inférieurs à #minlotprice sur 100.",
            "général-trade-trop-cher": "L'Autorité Galactique du Commerce n'accepte pas les prix de lots supérieurs à #maxlotprice sur 100.",
            "norm-res-desc": "Un monde normal avec des ressources que vous pouvez collecter et exploiter.",
            "blank-res-desc": "Un monde vide et sans ressources. Ce n'est probablement pas un bon choix pour votre première ville.",
            "bugships-desc": "Découvrez comment construire le Ruimteschip, un vaisseau spatial quelque peu primitif mais qui est malgré tout fonctionnel.",
            "scheepswerf-description": "Le Scheepswerf permet la production du Ruimteschip, un vaisseau de base sans fioritures qui fait le travail.",
            "large-map-warn-header": "Avertissement de grand monde",
            "large-map-warn-desc": "Vous venez sélectionnez un grand monde. Jouer sur un grand monde peut entraîner des problèmes de performances et de sauvegarde du jeu sur certains appareils. Voulez-vous vraiment continuer?",
            "offline-copy-gen": "Copie hors ligne",
            "offline-copy-desc": "Créez une copie hors ligne de cette colonie sans affecter votre jeu en ligne ni votre Commonwealth. Utilisez cette fonctionnalité pour des tests personnels ou pour soumettre votre monde au développeur à des fins de débogage. Vous devriez d'abord sauvegarder avant d’effectuer cette manipulation... ",
            "offline-copy-notice": "Vous jouez maintenant la version de copie hors ligne de cette colonie. Pour revenir à la copie en ligne, vous devez enregistrer, quitter en revenant au menu ('return to title'), puis recharger votre colonie.",
            "researchconvert-description": "Il arrive un moment où vos employés deviennent si intelligents qu'ils peuvent tout simplement transformer la recherche en produits bruts. Processus très compliqué. Ne vous souciez pas de la façon dont cela fonctionne.",
            "policy-tourism-desc":      "Entrée des touristes dans la colonie.",
            "general-allowed":          "Autorisée",
            "general-blocked":          "Bloquée",
            "gen-leave-fed":            "Quitter la fédération",
            "leave-fed-confirm":        "Êtes vous sûr de vouloir quitter la fédération? Si vous voudrez la rejoindre plus tard, vous devrez vous conformer au processus de vote une nouvelle fois."
        },
        "ru": {
            "app_name":    		        "My Colony",
            "new-game-message":         "Коммандир! Мы только что приземлились и готовы построить новую колонию. Как мы её назовём?",
            "welcome-message":          "Привет!  Ты создал колонию с колониальным героем из #motherland.  Твоя цель превратить эту планету в процветающую цивилизацию.  Чтобы начать, выбери твой будущий 'Rover' и закажи его, для начала добычи Руды.  Когда ты добудешь мин. 5 Руды, выбери твой Корабль и построй второй Ровер.",
            "rover-description":        "'Ровер' - это основной робот для основных нужд колонии.  Он может добывать минералы и строить простые здания.",
            "lander-description":       "На этом ты сюда приземлился.",
            "mine-description":         "Добывает необработанную руду из породы. Используйте Роверы, чтобы добывать руду.",
            "pavement-description":     "Улучшает внешний вид колонии.  Увеличивает скорость наземных средств передвижения.",
            "greenhouse-description":   "Простое здание для выращивания пищи для колонии.",
            "silo-description":         "Сохраняет выращенную еду свежей для колонии.",
            "atmosgen-description":     "Небольшое здание, которое медленно генерирует ничтожное количество атмосферы, чтобы начать терраформировать вашу планету.",
            "factory-description":      "Небольшая фабрика, которая может производить несколько автомобилей среднего размера. Также медленно генерируется очень незначительное количество атмосферы и колес.",
            "builder-description":      "Этот удивительный маленький робот поможет начать строительство вашей колонии!",
            "beta-info":                "My Colony - это новая симуляционная и стратегическая игра по строительству колоний, которая находится на ранней стадии бета-тестирования. В настоящее время в игре нет особого смысла, но, пожалуйста, поиграйте с ней, а затем отправляйтесь в сообщество форумов с отзывами и предложениями о том, что я могу добавить, чтобы сделать эту игру полностью функциональной!",
            "lander-sell-warning":      "Я не пытаюсь рассказать тебе, как играть в эту игру, но, как правило, не стоит продавать спускаемый аппарат, пока вы не уверены, что он вам больше не нужен. Это единственный способ собрать руду в начале, и ты не можешь построить другой! Ты уверен(а), что хочешь продать?",
            "refinery-description":     "Комплекс по переработке руды в рафинированную сталь, которая необходима для передовых строительных проектов. Требуются рабочие для работы.",
            "miner-description":        "Этот бот может собирать поверхностную руду и транспортировать ее на нефтеперерабатывающий завод. Он может также вырыть новый рудник.",
            "small-panel-description":  "Вырабатывает небольшое количество электричества для колонии без дополнительных затрат.",
            "landing-pad-description":  "Как только вы построите посадочный порт, новые колонисты будут периодически прибывать в вашу колонию.",
            "small-shelter-description":"Основное колонистическое жилье. Предоставляет убежище для 3 колонистов.",
            "chop-shop-description":    "Принимает старые, неиспользованные роверы и разбивает их на сырье.",
            "goldminer-description":    "Извлекает золото из месторождений и транспортирует его на Золотоперерабатываюший завод.",
            "goldrefinery-description": "Преобразует добытое из земли необработанное золото в чистое золото.",
            "goldsmelter-description":  "Преобразует чистое золото в наличные.",
            "hire-button-change-job":   "Сменить работу",
            "hire-button-hire":         "Нанять",
            "object-sell":              "Продать",
            "object-remove":            "Удалить",
            "side-menu-game-data":      "Игровая дата",
            "delete-game-confirm":      "Ты уверен, что хочешь удалить свою колонию?",
            "header-delete-colony":     "Удалить колонию",
            "tax-window-header":        "#motherland налог",
            "tax-window-content":       "Генеральная Ассамблея #motherland должна сообщить тебе, что твоя успешная колония должна налог людям #motherland.",
            "tax-window-owed-header":   "Задолжали налога: ",
            "tax-window-pay":           "Оплатить",
            "tax-window-reject":        "Отклонить",
            "tax-window-pay-response":  "Жители #motherland благодарят вас за ваш вклад в общество.",
            "tax-window-reject-response": "Генеральная Ассамблея #motherland хотела бы напомнить вам, что соблюдение закона является обязательным. Мы вернемся к этому позже.",
            "adv-hydro-desc":           "Разблокируйте передовые методы выращивания пищи на гидропонике.",
            "hd-solar-desc":            "Модернизированная технология солнечных батарей, которая может генерировать больше энергии на том же размере поверхности.",
            "smalllab-description":     "Соберите небольшую команду, чтобы проводить удивительные эксперименты и открывать новые технологии!",
            "advancedhydro-description":"Высокотехнологичное оборудование для выращивания большого количества продуктов питания. Требуются рабочие для работы.",
            "solar-tower-description":  "Башня с высокой плотностью солнечных элементов. Обеспечивает хорошее количество энергии при минимальной занимаемой площади.",
            "adv-ore-pur-desc":         "Откройте для себя передовые методы переработки сырой руды в твердую сталь.",
            "builder2-description":     "Модернизированный бот-строитель для создания более продвинутых структур.",
            "construction-2-desc":      "Разблокировать передовые методы строительства для создания новых конструкций и транспортных средств.",
            "pavement2-description":    "Особо твердое покрытие, закаленное сталью. Дорого, но позволяет очень быстро путешествовать на автомобиле.",
            "silo2-description":        "Большой бункер для хранения продуктов, который вмещает много еды для ваших колонистов.",
            "finance-theory-desc":      "Изучите теории и методы денег и финансов применительных к космическим колониям.",
            "refinery2-description":    "Преобразуйте руду в сталь быстрее и с эффективностью, почти в 5 раз превышающей эффективность обычного рудного завода. Требуются рабочие для производства.",
            "adv-gold-desc":            "Позволяет строительство и рытье новых золотых рудников.",
            "goldmine-description":     "Выкопайте новый золотой рудник для добычи грубого золотого ресурса из земли.",
            "rescomplex-description":   "Обеспечивает жилье среднего размера для 26 колонистов.",
            "greendome-description":    "Green Dome обеспечивает бесплатный отдых и развлечения для ваших колонистов, чтобы они не сходили с ума.",
            "massdriver-description":   "Усовершенствованная высокоэнергетическая электромагнитная катапульта, которая позволяет вам отправлять сырье обратно в #motherland в обмен на деньги. Требуются рабочие, а также генерирует небольшую сумму денег самостоятельно.",
            "lg-manufacturing-desc":    "Разблокируйте возможность производить потребительские товары в суровых условиях вашей колонии.",
            "chipfactory-description":  "На заводе по производству микрочипов работают 26 рабочих, которые превращают сырое золото в микрочипы.",
            "tax-payment-thankyou":     "#motherland благодарит вас за послушание.",
            "tax-payment-insufficient": "Ваш налоговый платеж Генеральной Ассамблее #motherland недостаточен. Баллы на вашем балансе накапливаются.",
            "stage-1-intro":            "Атмосфера планеты теперь достаточно толстая, чтобы поддерживать основную микробную жизнь!",
            "stage-2-intro":            "По мере роста планетарной атмосферы маленькие растения начинают прорастать из почвы.",
            "stage-3-intro":            "Атмосферные уровни теперь похожи на те, что на Земле, что позволяет регулярно проводить время на свежем воздухе!",
            "col-civics-desc":          "Начните формировать колониальное правительство, строить гражданские структуры и принимать законы для своего народа!",
            "atmosgen2-description":    "Более эффективный и мощный генератор атмосферы.",
            "civiccenter-description":  "Начните строить свое колониальное управление с гражданским центром. Стоит денег и требует, чтобы работники работали. Создает гражданский ресурс.",
            "statue1-description":      "Посвящается смелым колонистам, которые первыми ступили на этот мир.",
            "fracking-description":     "Высокотехнологичный высокоэнергетический метод извлечения руды из земли без необходимости добычи руды. Требуются рабочие и власть.",
            "adv-chem-desc":            "Откройте для себя секреты превращения вещей в другие вещи с помощью науки - химии.",
            "gldsynth-description":     "Небольшая научная лаборатория, которая может конвертировать сырую руду в сырое золото! Требуются рабочие и много энергии.",
            "la-zoology-desc":          "Начните раннее развитие в выращивании диких животных в условиях низкой атмосферы.",
            "hatchery-description":     "Выращивайте вкусную рыбу для потребления колонистами. Les Poissons!",
            "icechipper-description":   "Маленький, но шустрый ровер, который может собирать ледяные отложения и возвращать водные ресурсы в колонию.",
            "waterbot-description":     "Небольшой, но шустрый ровер, который может собирать лед и водные отложения и возвращать водные ресурсы в колонию.",
            "atmoscondensor-description":"Извлеките атмосферу из воздуха и сконденсируйте ее в чистую питьевую воду.",
            "pet-expansion-desc":       "Купите колониальный грант от Генеральной Ассамблеи #motherland, чтобы расширить свою колонию.",
            "pet-annex-desc":           "Расширьте свою колониальную территорию без согласия Генеральной Ассамблеи #motherland. Может вызвать враждебный ответ.",
            "smalltank-description":    "Храните и распределяйте пресную воду своим колонистам.",
            "waterpump-description":    "Засасывает и фильтрует небольшое количество пресной воды из-под поверхности планеты.",
            "aluminumrefinery-description":"Строит Алюминиевые Шахтеры и собирает сырые залежи алюминия.",
            "watertower-description":   "Храните большее количество воды, чтобы удовлетворить жажду колонистов.",
            "adv-microbio-desc":        "Изучите секреты выращивания живых организмов в условиях низкой атмосферы.",
            "new-game":                 "Новая игра",
            "new-game-col-name":        "Имя колонии",
            "custom-map-name":          "Имя карты",
            "map-size-header":          "Размер карты",
            "map-size-small":           "Маленькая",
            "map-size-medium":          "Средняя",
            "map-size-large":           "Большая",
            "resources-header":         "Ресурсы",
            "resources-scarce":         "Мало",
            "resources-normal":         "Средне",
            "resources-abundant":       "Много",
            "nuke-physics-desc":        "Узнайте, как собирать и очищать уран для ядерной энергетики в условиях низкой атмосферы.",
            "uraniumminer-description": "Собери урановые месторождения и транспортируй радиоактивные материалы на АЭС.",
            "nuclearplant-description": "Преобразуйте и переработайте сырой уран в электричество для вашей колонии.",
            "bacteriafarm-description": "Начните разводить микробные формы жизни, которые создают атмосферу для колонии.",
            "greenbot-description":     "Удобный маленький строитель, который может строить сельскохозяйственные структуры.",
            "firtrees-description":     "Эти благородные ели прекрасно растут в условиях низкой атмосферы. Они могут быть декоративными или могут быть собраны для дерева.",
            "engine-keyboard":          "Управление клавиатурой",
            "engine-keyboard-meta":     "Настройка управления с клавиатуры.",
            "general-cancel":           "Отмена",
            "keyboard-clear-menus":     "Очистить активные диалоги",
            "keyboard-idle-unit":       "Найти бездействующую машину",
            "keyboard-sell-noconf":     "Продать здания без подтверждения",
            "hold-and-click-tip":       "Держи и выбери здания.",
            "keyboard-upgrade-noconf":  "Улучши здания без подтверждения",
            "when-object-selected":     "Активен, когда объект выбран",
            "keyboard-move-unit":       "Переместить активный юнит",
            "keyboard-harvest-mode":    "Активировать режим сбора урожая/добычи руды",
            "keyboard-show-build":      "Показать параметры сборки",
            "keyboard-show-export":     "Показать параметры экспорта",
            "keyboard-show-import":     "Показать параметры импорта",
            "keyboard-sell":            "Продать активный объект",
            "keyboard-upgrade":         "Улучшить активный объект",
            "keyboard-defaults":        "Сбросить всё",
            "keyboard-defaults-warn":   "Будут удалены все постройки!",
            "keyboard-cancel-nocon":    "Отменить строительство без подтверждения",
            "keyboard-cancel":          "Отменить строительство",
            "general-move":             "Передвинуть",
            "general-harvest":          "Добыть",
            "general-build":            "Построить",
            "general-upgrade":          "Улучшить",
            "general-import":           "Импорт",
            "general-export":           "Экспорт",
            "general-dismiss":          "Отклонить",
            "medicalclinic-description":"Предоставляет колонистам услуги по восстановлению здоровья.",
            "general-park-unit":        "Парковать",
            "general-park-confirm":     "Места для парковки",
            "engine-sidebar":           "Интерфейс боковой панели",
            "tax-window-trade-embargo": "За продолжающуюся неуплату налогов населению #motherland Генеральная Ассамблея #motherland вводит торговое эмбарго против вашей колонии!",
            "tax-window-lift-embargo":      "Генеральная Ассамблея #motherland любезно сняла торговое эмбарго против вашей колонии.",
            "tax-window-img-embargo": 		"Из-за ухудшения отношений между вашей колонией и населением #motherland Генеральная Ассамблея #motherland вводит полный запрет на иммиграцию против вашей колонии!",
            "tax-window-img-lift": 			"Генеральная Ассамблея #motherland предварительно восстановила иммиграцию в вашу колонию.",
            "wall-description": 			"Отгородите места для украшения или организации своей колонии и управления движением ботов.",
            "lumbermill-description": 		"Перерабатывать деревья в лесной ресурс.",
            "lumberbot-description": 		"Этот удобный комбайн может и рубить деревья, и сажать новые!",
            "sfhouse-description": 			"Хватай жену и детей и переезжай в этот ностальгический деревянный дом для одной семьи!",
            "megabot-description": 			"Выносливый строитель для масштабных строительных проектов.",
            "urenrich-description": 		"Представляя собой удивительный подвиг инженерии и науки, эта установка может удвоить силу урана. Требуется много энергии и постоянный поток алюминия.",
            "lgwatertower-description": 	"Гигантская водонапорная башня, в которой хранятся тонны воды. Что еще можно сказать?",
            "largeres-description": 		"Жилой дом высокой плотности. Не самое роскошное жилье, но дешевое жилье для многих людей.",
            "Indepence-Noafford": 			"Вы не можете позволить себе независимость от #motherland.",
            "independence-general":     "Независимость",
            "general-united-earth":     "Объединённая Земля",
            "relations-header":         "#motherland Отношения",
            "foundation-header":        "Найдено/основано",
            "foundation-charter":       "По колониальной грамоте из #motherland",
            "independence-ask":         "Вы хотите объявить независимость от #motherland за #cost?",
            "general-nevermind":        "Не важно",
            "independence-declare":     "Декларировать",
            "independence-final":       "Мы объявили нашу независимость от #motherland в #independenceday!",
            "independence-stat":        "Из #motherland на ",
            "selfgov-desc":             "Изучите методы и процедуры для управления независимым правительством.",
            "capitol-description":      "Постройте большое славное здание Капитолия для вашего нового независимого государства!",
            "subtfood-description":     "Подземный объект с глубоким климатическим контролем для хранения большого количества пищи.",
            "empire-general":           "содружество",
            "engine-zoom-buttons":      "Показать кнопки увеличения",
            "lgcons-desc":              "Раскройте секреты создания действительно больших вещей в условиях низкой гравитации!",
            "treefarm-description":		"Поднимите деревья и соберите их для пиломатериалов.",
            "aluminumminer-description":"Выносливый и дружелюбный бот, который будет собирать отложения алюминия.",
            "new-game-charter":         "Кодекс колониальной хартии (необязательно)",
            "charter-warning":          "При запуске новой игры с колониальным уставом будут импортированы некоторые пользовательские игровые данные, которые, возможно, не были проверены Ape Apps. Это может включать потенциально оскорбительные выражения. Вы уверены, что хотите начать новую игру с этим чартером?",
            "general-charter":          "Колониальный герой",
            "general-yes":              "Да",
            "general-no":               "Нет",
            "charter-info":             "Вы можете поделиться своим колониальным уставом с друзьями и позволить им начать новую игру на своем устройстве, используя ваш устав. Вы будете получать доход от налогов, которые они платят, и вы можете торговать ресурсами с игроками, действующими в соответствии с вашим колониальным уставом. Ваш чартерный идентификатор #charterid",
            "charter-share":            "Играть в My Colony с чартерным идентификатором: #charterid #appurl",
            "general-share":            "Поделиться",
            "charter-settings-desc":    "Раздайте свой чартер и развивайте свое содружество!",
            "tax-collection-message":   "У вас есть новые налоговые поступления от ваших дипломированных колоний!",
            "bank-description":         "Банк, куда ваши люди ходят, чтобы хранить и управлять своими деньгами. Генерирует деньги и гражданское право.",
            "gdp-general":              "Валовый Внутренний Продукт",
            "gdp-description":          "Общий размер вашей экономики.",
            "general-trade":            "Торговать",
            "general-buy":              "Купить",
            "general-sell":             "Продать",
            "no-contracts":             "Сейчас нету доступных контрактов!",
            "select-resource":          "Выбери ресурс",
            "available-contracts":      "Доступных контрактов:",
            "multiples-notice":         "Должно быть кратным 100.",
            "sell-amount":              "Количество для продажи:",
            "buy-amount":               "Количество для покупки:",
            "sell-price":               "Цена за 100:",
            "boardoftrade-description": "Покупайте и продавайте ресурсы на межгалактическом рынке! Требуется подключение к интернету.",
            "lrc-desc":                 "Разблокируйте возможность вести в реальном времени межпланетную связь.",
            "galcom-desc":              "Расширяйте свою колонию, открывая экономические возможности со всей галактики!",
            "pyramideye-description":   "Эта мистическая мегаструктура может обеспечить дешевое развлечение и счастье для сотен колонистов. Через тысячи лет археологи раскроют это и зададутся вопросом, для чего это было. Могила для королей и богов? Древняя инопланетная электростанция? Нет, просто аккуратная туристическая ловушка.",
            "stage-4-intro":            "Ваши люди начинают жаловаться на накопление смога в воздухе.",
            "general-multiple":         "Несколько юнитов",
            "deepexc-desc":             "Узнайте, как копать действительно, действительно глубокие дыры в земле.",
            "digsite-description":      "Какими секретами обладает эта планета? Выкопайте гигантскую яму в земле и узнайте!",
            "colonial-website":         "Колониальный сайт",
            "rename-colony":            "Переименовать колонию",
            "rename-desc":              "Ты выбрал глупое имя для колонии?  Выбери другое!",
            "aal-desc":                 "Как только вы откроете секреты, содержащиеся в древних инопланетных артефактах, вы сможете использовать их удивительные нечестивые силы!",
            "aluminumgenerator-description":"Древние инопланетяне в этом мире открыли секретный метод превращения стали в алюминий! Дорого и требует тонны энергии. Также требуется постоянный поток воды для предотвращения перегрева.",
            "etbuilder-description":    "Высокотехнологичный бот-строитель, созданный с использованием декодированных инструкций древних инопланетян. Никто не знает, как он работает, но он дейтсвует.",
            "giorgioinstitute-description":"Вы должны спросить себя - возможно ли, что это исследовательское учреждение предоставляет хранилище для Чужих Артефактов и выводит ресурс Исследования?",
            "cloud-save":               "Облачное сохранение",
            "cloud-save-description":   "При входе в Facebook вы можете синхронизировать сохраненный файл с облаком. Это удобная функция, если вы играете на нескольких устройствах, но используете данные и, как известно, вызывают ошибки сохранения и повреждение данных на медленных интернет-соединениях, таких как мобильные.",
            "consulate-description":    "Консульство является центром, который соединяет вашу колонию с #motherland. Здесь вы можете управлять всем бизнесом, связанным с вашим членством в Содружестве.",
            "new-game-random-charter":  "Случайный герой",
            "general-delete":           "Удалить",
            "distillery-description":   "Преобразует еду и воду в ром! Ром делает людей счастливыми.",
            "brewing-desc":             "Узнайте, как производить ром в условиях низкой гравитации.",
            "rumcellar-description":    "Небольшой погреб с климат-контролем для хранения ценного рома.",
            "general-approval":         "Рейтинг одобрения",
            "relaybooth-description":   "Обеспечивает бесплатное развлечение, предоставляя колонистам доступ к прямой интернет-линии обратно в #motherland, чтобы они могли смотреть видео с кошками. Также повышает IQ, позволяя колонистам брать лучшую работу.",
            "general-policy":           "Политика",
            "general-payroll":          "Платежная ведомость",
            "payroll-notice":           "Пора платить вашим работникам. Общая стоимость заработной платы за этот период составляет #payrollcost.",
            "payroll-motherland":       "Поскольку вы являетесь частью Содружества #motherland, #motherland будет выставлен счет #motheroffset за их часть расходов на заработную плату.",
            "payroll-reject":           "Вы решили не платить своим работникам!",
            "payroll-insufficient":     "У вас не было достаточно денег, чтобы заплатить всем. Некоторым работникам пришлось остаться голодными.",
            "payroll-motherland-collect":"Помощь в оплате труда из #motherland.",
            "saving-dont-quit":         "Пожалуйста, не выходите из игры до оканчания сохранения!",
            "tax-pay":                  "Оплатить",
            "general-sound-xf":         "Эффекты",
            "pub-description":          "Преврати Ром в счастье! За скромную плату колонисты могут зайти в паб и отвлечься от повседневных забот.",
            "general-destruct":         "Самоуничтожение",
            "general-labor":            "Труд",
            "labor-desc":               "Управление зарплатами по разным профессиям",
            "general-contine":          "Продолжить игру",
            "general-new":              "Новая колония",
            "general-load":             "Загрузить колонию",
            "general-options":          "Больше опций",
            "general-execute":          "Убить",
            "execute-confirm":          "Ты точно хочешь убить и ограбить #colonist?  Люди могут разозлится от этого.",
            "general-destroy":          "Уничтожить",
            "decfirtrees-description":  "Зачем сажать сырые натуральные ели, когда вы можете посадить красивые обрезанные декоративные, которые запрещены для ваших комбайнов?",
            "cloning-desc":             "В будущем люди в космосе просто не размножаются, как раньше. Вот где клонирование человека пригодится.",
            "cloningfacility-description":"Высокотехнологичное промышленное предприятие для выращивания новых колонистов в лабораторных условиях.",
            "claymine-description":     "Когда у вас будет достаточно атмосферы, вы можете начать обрабатывать почву водой и добывать глину для использования в мелкой керамике.",
            "clayprod-desc":            "Используйте химию, гидропонику и микробиологию, чтобы научиться добывать глину из бесплодной почвы планет.",
            "general-activate":         "Активировать",
            "general-deactivate":       "Деактивировать",
            "general-activate-all":     "Активировать все",
            "general-deactivate-all":   "Деактивировать все",
            "claybot-description":      "Веселый резвый ровер, предназначенный для копания и сбора глины.",
            "potteryworks-description": "Очищает глину и превращает ее в мелкую керамику. Требует постоянного потока воды для работы.",
            "warehouse-description":    "Обеспечивает дополнительное хранение для ассортимента товаров длительного и промышленного назначения.",
            "subhousing-description":   "Некоторые люди просто любят жить под землей. Этот большой подземный комплекс может вместить многих жителей в контролируемой среде.",
            "chipfactory2-description": "Более крупная и эффективная версия фабрики микрочипов. Более быстрое производство и больше хранения.",
            "chipfactory3-description": "Усовершенствованная фабрика, построенная с использованием древних технологий пришельцев, которая может производить большое количество микрочипов. Требуется устойчивый поток воды, чтобы сохранить прохладу. Использует Чужие Артефакты во время производства.",
            "aam-desc":                 "Откройте для себя древние секреты, которые использовались при изготовлении в этом мире миллионы лет назад.",
            "masonry-desc":             "Узнайте, как создавать твердые кирпичи из глины в условиях низкой гравитации.",
            "brickroad-description":    "Кирпичная дорога быстрее обычного тротуара - хороший способ привести в порядок вашу колонию.",
            "brickfactory-description": "Преобразование глины в твердые кирпичи, чтобы разблокировать дополнительные варианты строительства. Для работы требуется постоянный поток воды.",
            "ybrickroad-description":   "Последняя в колониальном стиле и классе. Пусть ваши колонисты идут по дороге из желтого кирпича к славе!",
            "warehouse2-description":   "Этот прекрасный склад, построенный из кирпича, является прекрасным дополнением к любой промышленной колонии.",
            "brickhouse-description":   "Вы должны быть дураком, чтобы не хотеть жить в этом прекрасном кирпичном доме.",
            "husbandry-desc":           "Узнайте, как разводить и разводить крупных животных в условиях низкой гравитации.",
            "sheepfarm-description":    "Разводить и разводить овец для производства шерсти! Требуется устойчивый поток воды.",
            "textilemill-description":  "Convert raw Wool into durable Cloth, a fine item that your colonists will just love.",
            "sweatshop-description":    "Приходите работать на место, где живет прибыль, а мечты умирают! Работники этого магазина одежды превратят Ткань в чистую прибыль в условиях низкой заработной платы и без каких-либо льгот!",
            "luxtower-description":     "Куда люди из мира и общества приходят, чтобы жить, работать и играть. Вы должны поддерживать поток Рома, чтобы поддержать этих элит.",
            "aliencondensor-description":"Древние в этом мире знали, как превратить много атмосферы в воду. Я имею в виду, много. Следите за тем, чтобы он не слишком поглощал вашу атмосферу.",
            "cst-desc":                 "97% колониальных ученых считают, что планета будет разрушена глобальным потеплением. Исследуйте способы ее решения.",
            "hydropower-description":   "Эта удивительно мощная электростанция может превращать воду в сырую энергию! Представьте себе все возможности!",
            "largepark-description":    "Гигантский парк, предоставляющий бесплатное общественное развлечение для ваших колонистов. Напоминает людям вернуться в #motherland.",
            "waterpool-description":    "Совершенно квадратный неглубокий бассейн с водой, чтобы ваша колония выглядела красиво.",
            "lol-description":          "Пусть галактика знает, что ваша колония принимает свои уставшие бедные толпы с Землей Свободы!",
            "human-description":        "Доминирующий вид с Земли. Если вы играете в эту игру, вы, вероятно, знаете, что такое человек.",
            "red-planet-desc":          "Ваша типичная мертвая планета. Возможно, жизнь поддерживалась миллионы лет назад, но сейчас здесь ничего нет. Разнообразный набор ресурсов.",
            "ue-description":           "Гордая планета Земля является домом для Человеческих видов, управляемых Генеральной Ассамблеей Объединенной Земли. Хотя они сформировались под предлогом содействия миру и стабильности, они теперь контролируют Солнечную систему железным кулаком.",
            "premium-notice":           "Моя колония бесплатна, но дополнительные функции доступны игрокам, которые поддержали игру в финансовом отношении. Существуют уникальные конструкции #premiumcount и транспортные средства, доступные только пользователям, которые приобрели бесплатную версию игры. Эти структуры носят исключительно декоративный характер и не оказывают существенного влияния на игровой процесс. Премиум-пользователи также могут изменить ориентацию некоторых зданий, и это еще не все. Премиум-пользователи также открывают возможность настраивать свою игру, используя моды. Более эксклюзивный премиум-контент будет добавляться на регулярной основе. Хотите обновить до премиум-класса без рекламы?",
            "statue2-description":      "Эта статуя является символом власти и власти, показывая все, что вы претендовали на господство над этими землями!",
            "flowersred-description":   "Украсьте свою колонию с этим прекрасным красным цветником!",
            "goldenshelter-description":"Высокий и могучий в вашей колонии не может позволить себе жить в стандартном маленьком приюте. Нет, они хотят укрытия с позолотой.",
            "general-offers":           "Предложения",
            "general-new-offer":        "Новое предложение",
            "hipsterbar-description":   "Когда вы будете готовы к живой музыке от группы, о которой вы никогда не слышали, цен на вход, которые превысят кредитную карту вашего отца, и рома, который стоит в семь раз больше, чем должен, вы готовы потусоваться в баре Hipster!",
            "alienquantum-desc":        "Древние пришельцы были мастерами квантовой физики. Теперь вы тоже можете открыть секреты и совершить технологическую революцию!",
            "warehouse3-description":   "Квантовый скачок в технологии хранения товаров длительного пользования! Требует тонны энергии и постоянного потока воды, но может использовать силу квантовой механики для хранения тонны товаров в ограниченном пространстве.",
            "quantumwater-description": "Используйте древнюю инопланетную квантовую технологию для хранения огромного количества воды на небольшой территории. Требует энергии, а также расходует часть воды, чтобы не перегреваться ... Но да, воду совершенно безопасно пить.",
            "brickwall-description":    "Это похоже на нормальную стену, за исключением того, что она сделана из кирпича, что делает ее лучше.",
            "largeclinic-description":  "Большая и более эпическая версия Медицинской Клиники. Лечит больше людей. Спасает больше жизней!",
            "rpbase-desc":              "Базовые знания, которые начинаются с карты Красной планеты.",
            "hbase-desc":               "Базовое знание, которое приходит от игры за Человеческую расу.",
            "uebase-desc":              "Базовые знания, которые исходит от цивилизации Объединенной Земли.",
            "lunbase-desc":             "Базовые знания, исходящие от запуска на Лунной карте.",
            "lunar-planet-desc":        "Безжизненный лунный мир без атмосферы и сравнительно небольших ресурсов ранней игры. Трудный мир, чтобы начать, но может окупиться позже.",
            "lunarrover-description":   "Небольшой и счастливый ровер, предназначенный для извлечения Реголита и строительства небольших структур в лунной среде.",
            "heltank-description":      "Небольшой резервуар для хранения гелия 3.",
            "regpath-description":      "Создайте красивый гравийный путь для ваших роверов.",
            "waterextract-description": "Сокрушите сырой Реголит, чтобы извлечь маленькие ледяные кристаллы, используемые для приготовления питьевой воды. Требуется устойчивый поток гелия 3 для работы.",
            "regcompact-description":   "Механически упаковывай сырьевой реголит в руду.",
            "helextractor-description": "Извлеките следовые количества гелия 3 из измельченного реголита.",
            "regmine-description":      "Выкопайте яму в земле и начните вытаскивать из нее Реголит!",
            "fwbase-desc":              "Базовые знания, которые начинаются с карты мира леса.",
            "forest-planet-desc":       "Приготовьтесь к микроуправлению. Жесткая карта с небольшим количеством ранних ресурсов. Много деревьев. Не играйте на этой карте в первый раз.",
            "woodhut-description":      "Небольшое деревянное укрытие на двоих. Не самое удобное место для жизни, но оно дешевое и выполняет свою работу.",
            "forestrover-description":  "Каким-то образом наука выяснила, как сделать из дерева механический движущийся вездеход. Имеет ли это смысл? Это имеет значение? Это игра!",
            "waterwell-description":    "Выкопай яму, достань из нее воду и выпей. Довольно просто, правда.",
            "potatopatch-description":  "Глотает постоянный поток воды и производит вкусную картошку для ваших колонистов, чтобы поесть. Кто не любит картошку?",
            "charcoalhut-description":  "Сжигает Дерево для производства древесного угля. Оттуда, с небесного предела!",
            "coalburn-description":     "Сжигает уголь и производит электричество для колонии",
            "coalcompact-description":  "Сокрушите древесный уголь настолько сильно, что он станет сырой рудой, которую вы сможете использовать для создания изящных вещей!",
            "advcp-desc":               "Узнайте более эффективные способы сжигать древесину в древесный уголь.",
            "charfactory-description":  "Приведите угольную хижину в современную эпоху вместе с угольной фабрикой! Та же концепция, что и в хижине, только лучше.",
            "oilref-desc":              "Узнайте секреты добычи сырой нефти в условиях низкой гравитации! Пусть черное золото течет!",
            "mulchpath-description":    "Дайте своим роверам что-нибудь приятное для езды, построив этот прекрасный путь из мульчированной древесной щепы!",
            "oiltank-description":      "Просто большой резервуар с сырой нефтью.",
            "crudebot-description":     "Этот забавный маленький робот знает, как запачкаться, работая целый день на нефтяных месторождениях.",
            "flowerswhite-description": "Белый цветник вызовет улыбку на вашем лице. Если только ты не ненавидишь цветы.",
            "flowersblue-description":  "Есть ли в этой вселенной что-нибудь лучше, чем синий цветник?",
            "flowerspurple-description":"Ах, фиолетовый цветник. Обязательно иметь в любой уважающей себя колонии.",
            "adv-chemsyn-desc":         "Возьмите химию на новый уровень! Начните создавать новые соединения из старых в промышленном масштабе.",
            "oilplant-description":     "Сжигать масло, чтобы сделать электричество! Создает скромное количество атмосферы в процессе.",
            "grass-description":        "Хороший газон для вашей колонии. Можно ходить или ехать. Создайте свою собственную освежающую зеленую зону!",
            "quantumfood-description":  "Квантовый контейнер для хранения продуктов для хранения тонны продуктов. Требуется постоянный ввод воды, чтобы избежать перегрева.",
            "pavement5-description":    "Очень быстрое покрытие, которое может увеличивать ваши роверы. Возможно, вам придется посетить Галактический совет по торговле, чтобы найти все материалы.",
            "oilsynthlab-description":  "Используйте силу науки для создания Нефти, смешивая Древесный уголь и Пищу.",
            "plastfact-description":    "Новая блестящая фабрика, которая превращает ваше грязное старое масло в чистый новый пластик!",
            "sweatshop2-description":   "Здесь вы можете превратить пластик в забавную детскую игрушку, платя зарплату своим работникам!",
            "livingwage-header":        "Прожиточный минимум",
            "livingwage-desc":          "Установите базовый уровень дохода, который будут получать все колонисты (сверх их обычной зарплаты), независимо от занятости.",
            "firedrill-header":         "Огненная дрель",
            "firedrill-desc":           "Уволить всех колонистов с их рабочих мест и выгнать всех жителей из их домов. Сбрасывает статистику труда и жилья и заставляет всех переезжать.",
            "work-policy":              "Политика работы",
            "work-policy-desc":         "Установите общую политику работы для вашей колонии.",
            "work-policy-normal":       "Нормальный",
            "work-policy-normal-desc":  "Регулярная политика работы. Колонисты могут прожить свой день так, как считают нужным.",
            "work-policy-light":        "Лёгкий",
            "work-policy-light-desc":   "Сократите рабочий день, предоставив колонистам больше времени для отдыха и релаксации.",
            "work-policy-hard":         "Перегруз",
            "work-policy-hard-desc":    "Продлите рабочий день и потребуйте сверхурочных для всех работников, чтобы повысить производительность.",
            "work-policy-extreme":      "Экстримальный",
            "work-policy-extreme-desc": "Когда наступают тяжелые времена, и вам действительно нужно повысить производительность. Многие колонисты умрут на работе.",
            "general-go-back":          "Назад",
            "general-go-back-desc":     "Вернуться к пред. меню",
            "money-shower-header":      "Стимул Пакет",
            "money-shower-desc":        "Проблемы с вашими колонистами? Просто бросьте деньги на них, чтобы проблемы ушли! Распределите свободные деньги среди населения.",
            "tax-collection-header":    "Налоговые сборы",
            "tax-collection-desc":      "Если вам нужно немного больше денег, используйте эту политику, чтобы ввести единовременный налог на каждого колониста, составляющий 25% их сбережений.",
            "spaceport-description":    "Космический порт является транспортным узлом для входящих и исходящих туристов в колонию и из нее. Существует также небольшая вероятность несанкционированной иммиграции. Расходует Civics во время эксплуатации.",
            "coltour-desc":             "Раскройте секреты привлечения (и извлечения денег) межпланетных туристов.",
            "motel-description":        "Дешевый мотель - идеальное место для туристов, которые приезжают и отдыхают, посещая вашу колонию!",
            "general-tourism":          "туризм",
            "touress-desc":             "Откройте для себя улучшенные методы привлечения и ухода за туристами, посещающими колонию.",
            "hotel-description":        "Хороший большой отель для размещения ваших туристов. Требуется постоянный поток ткани, так как туристы любят брать с собой свои полотенца.",
            "smcasino-description":     "Принесите великое прошлое азартных игр в вашу колонию с этим прекрасным Маленьким Казино! Привлекает туристов и колонистов, а также извлекает деньги из своих кошельков. Также генерирует деньги самостоятельно.",
            "giftshop-description":     "Хотите знать, что вы собираетесь делать со всей керамикой, которую вы сделали? Чудеса больше нет! Откройте этот магазин подарков и продайте его туристам!",
            "tourtrap-desc":            "Узнайте, как сделать туризм широко с туристическими ловушками! Начните доить галактику, сколько бы она ни стояла.",
            "zoo-description":          "Какая уважающая себя колония обходится без зоопарка? Обеспечивает развлечения для колонистов и туристов. Требуется устойчивый поток керамики во время работы.",
            "bluehouse-description":    "Отличное место для молодой колониальной семьи. Этот синий дом приведет к целой жизни воспоминаний.",
            "pavement6-description":    "Украсьте ландшафт этой причудливой клетчатой мостовой. Это не быстрее, чем обычный тротуар, но выглядит лучше.",
            "flowersyellow-description":"У вас там эта печальная пустая плитка. Что будет выглядеть лучше, чем желтый цветник? Ничего такого! Так что построй!",
            "obelisk-description":      "Высокий блестящий золотой обелиск, празднующий силу и независимость вашей колонии.",
            "restaurant-description":   "Небольшая дыра в настенном ресторане с дружеской атмосферой и местами на свежем воздухе обеспечивает туристам подлинный вкус вашей колонии!",
            "resort-description":       "Большой роскошный курорт для развлечения большого количества туристов. Требуется устойчивый ввод ткани во время работы.",
            "mall-description":         "Большой открытый торговый центр, предназначенный для высасывания денег из туристов и колонистов! Требуется много силы и рабочих, а также постоянный поток Ткани и Игрушек.",
            "general-private-charter":  "Конфиденциальность героя",
            "general-private-desc":     "Решите, будет ли ваш колониальный устав частным или публичным. Если установлено значение public, оно будет отображаться в списке случайных чартеров, когда игроки начинают новую колонию.",
            "general-private":          "Приватный",
            "general-public":           "Публичный",
            "map-size-mega":            "Огромная",
            "map-size-xlarge":          "Гигантская",
            "large-map-warning-title":  "Предупреждение о размере карты",
            "large-map-warning-content":"Пожалуйста помните, что производительность игры моржет ухудшиться на больших картах. Ты уверен, что хочешь играть на такой большой карте?",
            "new-game-size-notice":     "Внимание: Размер карты может повлиять на производительность игры.",
            "online-mode":              "Онлайн режим",
            "online-mode-desc":         "Включить онлайн-режим в этой колонии. Предоставляет доступ к онлайн-торговле, содружеству и дает вашей колонии веб-сайт. Ваша игра потребует подключения к интернету.",
            "offline-mode":             "Локальный режим",
            "offline-mode-desc":        "Переключите эту колонию в локальный режим. Вы потеряете доступ к онлайн-торговле, и любые ваши колонии содружества получат независимость. Ваша игра больше не требует подключения к Интернету, но вы сможете проводить сделки и обмениваться сообщениями с другими локальными играми в вашей сети.",
            "offline-mode-warning":     "Вы уверены, что хотите переключиться в локальный режим? Онлайн функции, такие как торговля на мировом рынке, содружество и колониальный веб-сайт, будут отключены. Любые колонии, созданные в соответствии с вашим уставом, получат независимость. Это не может быть отменено.",
            "general-notice":           "Внимание",
            "blacklist-notice":         "Ваша колония была отстранена от онлайн-игры за мошенничество. Как одиночная игра, читерство в My Colony не поощряется и остается на усмотрение отдельного игрока. Однако для сохранения целостности онлайн-игрового рынка нельзя разрешать играть в игры с взломанными уровнями ресурсов. Спасибо за Ваше понимание.",
            "museum-description":       "Увеличьте рост вашей колонии с этим прекрасным музеем. Привлекает туризм и потребляет керамику во время эксплуатации.",
            "resources-report":         "Статистика производства и использования ресурсов, перемещаемых в колонию и из нее.",
            "galfreight-description":   "Галактическая грузовая верфь может импортировать и экспортировать большие количества товаров в колонию и из нее через большой транспортный контейнер с прикрепленными к нему подруливающими устройствами. Требуется масло во время эксплуатации.",
            "statue3-description":      "Эта статуя, самая дорогая вещь в игре, покажет вашим колонистам, насколько вы богаты и могущественны, пока они страдают от нищеты и отчаяния.",
            "udexc-desc":               "Используйте инопланетную силу, чтобы вырыть яму больше, чем любая яма, которую когда-либо выкапывали. Кто знает, что вы можете найти?",
            "digsite2-description":     "Экстремальный полигон, который спускается на многие мили в землю. Создает большее количество чужих артефактов. Требуется вода, чтобы бежать, и производит немного глины как побочный продукт операций.",
            "general-rename":           "Переименовать",		
            "rename-colonist":          "Выбери новое имя для #colonist.",
            "keyboard-open-stats":      "Открыть окно статистики",
            "keyboard-open-tech":       "Показать Tech Tree",
            "keyboard-open-encyclopedia":"Открытая энциклопедия",
            "keyboard-open-unemployment":"Показать безработных колонистов",
            "keyboard-park":            "Припарковать Юнит",
            "keyboard-zoom-in":         "Приблизить",
            "keyboard-zoom-out":        "Отдалить",
            "charcoalpile-description": "Зарезервировать участок земли для хранения древесного угля. Тогда просто бросьте все это в большую кучу.",
            "alienpower-description":   "Эта безумная электростанция, построенная по древней инопланетной технологии, превращает Гелий 3 в грандиозное количество сырой энергии.",
            "autosave-freq":            "Частота автосохранения",
            "autosave-freq-desc":       "Выберите, как часто игра автоматически сохраняется. На производительность игры влияет сохранение.",
            "autosave-freq-often":      "Часто",
            "autosave-freq-normal":     "Нормально",
            "autosave-freq-rare":       "Редко",
            "autosave-freq-never":      "Никогда",
            "autosave-often-warn":      "Частота автосохранения может повлиять на производительность.",
            "autosave-never-warn":      "Не забудьте сохранить игру вручную, чтобы избежать потери данных!",
            "general-send-custom-msg":  "Отправить сообщение",
            "general-send-msg-warn":    "Вы можете отправить сообщение в другую колонию, не более 120 символов. Предупреждение - отправка неуместного, угрожающего или преследующего сообщения является основанием для запрета вашей колонии на онлайн-сервере без апелляции.",
            "game-compression":         "Сжатие сохранения игры",
            "game-compression-desc":    "Сжатие значительно уменьшает размер сохраняемых игровых файлов, но замедляет операции сохранения и загрузки. Отключите сжатие, чтобы увеличить время сохранения и загрузки. Вы не можете использовать Cloud Sync, если сжатие отключено.",
            "colony-sharing":           "Поделится колонией",
            "colony-sharing-desc":      "Колонии, использующие Cloud Sync, могут генерировать URL-адрес общего ресурса, предоставляя другим игрокам My Colony доступ только для чтения для просмотра сохраненных игр.",
            "general-upgrade-all":      "Улучшить все",
            "general-ugall-desc":       "Вы уверены, что хотите улучшить все? Это может быть дорого и отнимет много времени ...",
            "pavement7-description":    "Сверхбыстрый тротуар из разноцветных игрушек! Как весело это?",
            "mound-description":        "Основные места размножения и пищевой промышленности инсектоидов.",
            "waterbug-description":     "Этот маленький синий парень специализируется на транспортировке воды из различных источников обратно в гнездо.",
            "workerdrone-description":  "Этот крепкий маленький помощник может собирать сахар для колонии и строить основные структуры.",
            "insectoid-description":    "Инсектоиды развивались на планете Боуленд. Они быстро размножаются и потребляют все на своем пути.",
            "zolargprime-description":  "Могущественная Империя Золарг, расположенная на Золарг Прайм, является империей насекомых, которые специализируются на быстром потреблении и воспроизводстве ресурсов.",
            "sugarland-desc":           "Планета Шугарленд - это пышный теплый климат с развитой атмосферой, где повсюду сахар.",
            "orebug-description":       "Этот крупный инсектоид имеет сильные челюсти для извлечения сырой руды из близлежащих месторождений.",
            "feastingarea-description": "Зона пиршества - это место, где инсектоиды собираются, чтобы принять участие в еде и развлечениях. Преобразует сахар в пищу и обеспечивает хранение для обоих.",
            "watervats-description":    "Инсектоиды просто любят тусоваться в коммунальных чанах и рассказывать о жизни. Магазины воды и предлагает развлечения.",
            "pastetank-description":    "Неочищенное средство, которое смешивает воду, сахар и слюну насекомого с образованием муравьиной пасты, сильного строительного компаунда.",
            "pastepath-description":    "Эта прекрасная тропа, сделанная из измельченной руды и муравьиной пасты, прекрасно подойдет вашим рабочим ногам!",
            "broodcenter-description":  "Здесь, в учебном центре Brood, молодые инсектоиды учатся тому, как стать взрослыми, и на этом пути проводят исследования.",
            "zgoldstorage-desc":        "Узнайте, как собирать золото и выкапывать причудливые норы в земле для хранения.",
            "goldbug-description":      "Этот изящный маленький зверь способен добывать сырое золото из земли.",
            "goldburrow-description":   "Это маленькая дыра в земле, которую ваши золотые жуки могут использовать для внесения золотых депозитов.",
            "sugarpower-res-desc":      "Раскройте секреты сжигания сахара для выработки электроэнергии.",
            "sugarpower-description":   "Сжигай сахар для производства электроэнергии для колонии!",
            "communialfin-desc":        "Инсектоиды учатся объединять свои ресурсы и генерировать коммерцию для общего блага.",
            "insectoidmint-description":"Используйте мятное насекомое, чтобы растопить золото и превратить его в притягательные монеты насекомых.",
            "backupOption":             "Опции резервной копии",
            "backupOptionDesc":         "Сохраните локальную несжатую копию ваших игровых файлов для дополнительной защиты. Занимает больше места для хранения.",
            "sugarcult-desc":           "Узнайте, как сажать сахарный тростник, чтобы вы могли выращивать свой собственный!",
            "antanium-prod-desc":       "Узнайте, как производить Antanium, сильный сплав от насекомых, используемый для строительства зданий.",
            "antaniumsmelter-description":"Комбинируйте руду и золото в Antanium, твердый строительный материал, используемый для перехода любой колонии насекомых на следующий уровень.",
            "eldersmound-description":  "Куча старейшин насекомых - это то место, где собирается совет старейшин насекомых, чтобы обсудить вопросы, имеющие значение для насекомых. Создает гражданское право.",
            "miningoperation-description":"Инсектоиды работают вместе, чтобы вырыть гигантскую яму и извлечь устойчивый поток руды и золота из земли.",
            "zolargstatue-description":	"Прекрасная статуя в честь императора Золарга, насекомого, основавшего империю Золарга, давным-давно возглавлявшего расу насекомых в восстании против древних.",
            "foodfortification-description":"Обогащите пищу и добавьте в нее муравьиную пасту, что сделает ее гораздо более питательной. Может быть улучшена до зоны приема пищи, но теряет преимущества развлечения и хранения сахара",
            "solgov-desc":              "Разблокируйте технологии, чтобы способствовать росту присутствия в солнечном содружестве",
            "capitol2-description":     "Растущая колония требует растущей столицы. Это более крупное здание Капитолия предлагает больше гражданского общества, больше бюрократии и позволяет отправлять большие подарки в субколонии",
            "galgov-desc":              "Помогите вырастить и укрепить галактическое правительство с технологией Галактического Управления",
            "capitol3-description":     "Покажите свое господство над подчиненными в этом большом здании Капитолия. Предлагает больше подарков, гражданственности и славы для вашей империи, но требует постоянного потока Рома, чтобы ваши политики были счастливы.",
            "consulate2-description":   "Модернизированное здание консульства, которое позволяет расширить торговлю с родиной",
            "consulate3-description":   "Создайте еще лучшее консульство и расширьте свою торговлю с вашей родительской колонией",
            "sand-description":         "Подгоните свою колонию этим прекрасным песком",
            "capitol4-description":     "Это большое патриотическое здание Капитолия заставит ваших граждан гордиться тем, что они являются частью вашей сильной и энергичной нации. Делает еще больше гражданственности и позволяет еще больше колониальных подарков",
            "nationalism-desc":         "Начните продвигать националистические идеалы своего народа, воспитывать гордость и верность растущей нации",
            "general-flip":             "Перевернуть",
            "flag-description":         "Покажите гордость и силу своей нации с этим декоративным флагом. Твоим людям это понравится",
            "capitol5-description":     "Это большое угрожающее здание Капитолия позволит вашим людям без сомнения узнать, что вы наконец-то обратились к темной стороне. Еще больше способностей генерации и дарения гражданских навыков (и потребления рома)",
            "imperialism-desc":         "Иногда недостаточно быть простой нацией, нужно перейти на темную сторону и стать империей",
            "insregen-desc":            "Раскройте секреты медицины и лечения насекомых",
            "healingpods-description":  "Вот как насекомые излечивают себя. Они хоронят свои тела в грязи, подождите немного, а потом БАМ - здоровье",
            "rationing-header":         "Нормирование",
            "rationing-desc":           "Когда наступают тяжелые времена, вы можете навязывать людям еду и воду. Они будут ограничены до 1/3 от нормального количества еды и потребления воды. Может вызвать болезнь",
            "general-native-client":    "Родной клиен",
            "native-client-description":"Как игра, основанная на веб-браузере, My Colony не имеет доступа к вашей файловой системе и поэтому не может сохранять ваши игровые данные вне контекста вашего веб-браузера. Это вызывает более высокий риск потенциальной потери данных. Рекомендуется (но не обязательно), чтобы вы загрузили нативное клиентское приложение, которое может сохранять ваши игровые данные локально на ваше устройство. Хотите увидеть варианты загрузки?",
            "sugarfarm-description":    "Кому нравится выходить в пустыню в поисках сахара? Никто. Почему бы не посадить сахарную ферму и заставить сахар прийти к вам! Требуется постоянный ввод воды",
            "general-annex-land":       "Приложение Земля",
            "general-annex-desc":       "Расширьте свою колонию, аннексировав окружающие земли через выдающийся домен",
            "gentelbugs-description":   "Когда мужские насекомые говорят своим женам, что они работают допоздна, они на самом деле тратят монеты и пьют ром здесь, в клубе Gentelbugs. Потребляет ром, обеспечивает развлечения и предлагает рабочие места молодым специалистам по истории насекомых",
            "lghe3-description":        "Хороший резервуар для хранения большого количества гелия 3",
            "plaque-description":       "Разместите эти милые таблички в специальных местах вокруг вашей колонии, чтобы отметить специальные места и исторические события",
            "general-set-text":         "Измени текст",
            "galimp-desc":              "Узнайте секреты управления (злой?) Империей в галактическом масштабе",
            "capitol6-description":     "Эта имперская столица покажет вашу славу и силу всем людям галактики. Открывает тонны торговли, а политики потягивают тонны рома",
            "tallconst-desc":           "Когда вы начнете выбегать из земли, вы должны начать строить вверх. Высокие методы строительства позволяют вам строить высокие здания в условиях низкой гравитации",
            "elevator-description":     "Космический Лифт позволяет импортировать и экспортировать товары, а также облегчает иммиграцию колонистов. Требуется небольшое количество топлива, но большое количество электричества",
            "advrobo-desc":             "Познайте секреты передового искусственного интеллекта и робототехники, возможно, открывая новые машины",
            "condrone-description":     "Этот счастливый маленький дрон любит летать и строить вещи для вас",
            "robofactory-description":  "Этот высокотехнологичный завод производит роботы и другие беспилотные летательные аппараты. Требуется постоянный поток алюминия и микрочипов",
            "advdig-desc":              "Разблокируйте новые сооружения, научившись копать глубокие ямы в земле",
            "wetmound-description":     "Концепция проста. Продолжайте копать, пока не найдете воду, а затем возведите небольшую насыпь на вершине и дайте инсектоидам подойти и выпить",
            "moneypit-description":     "Распространите богатство вокруг вашей колонии насекомых. Граждане кладут свои дополнительные деньги в яму или вынимают их, когда это необходимо. Из каждого в соответствии с его способностями ... Генерирует деньги и гражданские",
            "exportcannon-description": "Экспортная пушка - это недорогой и эффективный способ продать товары в #motherland. Также генерирует небольшую сумму дохода",
            "general-live-prices":      "Текущие цены",
            "lumberyard-description":   "Ах, лесной склад. Хранит древесину, нанимает настоящих мужчин и приносит доход. Вокруг большое здание",
            "general-repair":           "Починить",
            "general-condemn":          "Осудить",
            "lottery-header":           "Лотерея",
            "lottery-message":          "Продавайте лотерейные билеты людям. У одного колониста жизнь изменится навсегда",
            "lottery-instruction":      "За сколько денег вы хотите продать лотерейные билеты? Помните, если вы будете брать слишком большую плату, люди не будут покупать билеты",
            "lottery-fail":             "Извини, но никто не купил твоих лотерейных билетов",
            "regolithextractor-description":"Эта тяжелая промышленная операция может извлечь большое количество Regolith из земли, без необходимости восстанавливать новые шахты",
            "horrorhouse-description":  "Если у вас выходной, почему бы не отвезти детей или кого-то особенного в этот страшный Дом ужасов? Привлекает гостей и туристов, и каждый идет домой с игрушкой",
            "general-bad-trade-notice": "Твой советчик желает сообщить, что эта сделка - плохая идея и она может не понравится людям.  Ты точно хочешь совершить её?",
            "general-bad-trade-header": "Советчик по экономике",
            "general-declare-ind":      "Объявить независимост",
            "general-declare-ind-desc": "Разорвите свои связи с #motherland и покончите с этим самостоятельно",
            "galfi-desc":               "Узнайте, как начать зарабатывать серьезные деньги в галактическом масштабе",
            "bank2-description":        "Нанимайте сотни продавцов бумаги в этом высшем банке и наблюдайте, как они извлекают деньги из карманов по всей галактике",
            "restower-description":     "Высотное проживание по дешевке. Собирайте людей и наблюдайте за ростом населения",
            "steelyard-description":    "Этот объект используется для хранения массового количества стали для последующего использования. Создает следовую сумму дохода во время операций",
            "subtcharcoal-description": "Зачем хранить этот дорогой уголь на открытом воздухе во влажной атмосфере планеты, когда он может быть красивым, сухим и в больших количествах. Использует Гелий 3 во время работы",
            "general-gift-giver":       "Галактический император",
            "general-gift-message":     "Дьявольский Галактический Император был приглашён, чтобы сообщить, что  Имперский Отдел Пропаганды предлагает бесплатный подарок в обмен на немного твоего времени.  Хотите посмотреть видео в обмен на подарок?",
            "general-watch-gift-vid":   "Смотреть",
            "general-gift-not-watched": "Император должен напомнить, что тебе нужно посмотреть всё видео, чтобы быть достойным его милости.",
            "general-reward-complete":  "Имперский департамент пропаганды благодарит тебя за твою службу.",
            "general-ticker-warn-head": "Предупреждение о тикерах",
            "general-ticker-warn-info": "Heads Up - Выбор сделки из тикера «новости» автоматически совершит покупку. Это будет ваше единственное предупреждение",
            "general-mass-message":     "Указ Содружеств",
            "general-mass-msg-desc":    "Рассылка массовой рассылки всем членам вашего Содружества",
            "zolargcomm-desc":          "Разблокируйте новейшие технологии Zolarg, обеспечивающие межгалактическую связь",
            "altarofcommerce-description":"Алтарь Торговли - это место, где насекомые отправляются поклоняться богам межгалактической торговли и заключать удивительные торговые сделки",
            "sugarcane-description":    "Посадить и выращивать сахарный тростник. Yum",
            "enc-resources-desc":       "Информация о различных ресурсах вы можете собирать в игре",
            "enc-tech-header":          "технологии",
            "enc-tech-desc":            "Узнайте, какие все технологии могут быть разблокированы, и каковы их требования",
            "general-buildings":        "здания",
            "enc-buildings-desc":       "Проверьте все структуры в игре, а также их строительные требования",
            "general-vehicles":         "Транспортные средств",
            "enc-vehicles-desc":        "Показать все транспортные средства и рабочие, доступные для сборки, их стоимость строительства и их возможности.",
            "enc-online-header":        "Интернет Ссылка",
            "enc-online-desc":          "Interactive reference guide.",
            "regminer-description":     "Этот верный марсоход будет собирать мины Реголита и возвращать награду на вашу базу",
            "owners-manual-header":     "Руководство пользователя",
            "owners-manual-short-desc": "Все, что Вам нужно знать..",
            "enc-print-header":         "Печать",
            "enc-print-desc":           "ВНИМАНИЕ: более 200 страниц (в зависимости от принтера). Для настоящих наркоманов My Colony ты можешь распечатать полное подробное руководство для владельцев игры, содержащее все, что тебе нужно знать об игровом процессе, предыстории, механике и полное описание всего, что есть в игре. Двусторонняя печать настоятельно рекомендуется.",
            "general-encyclopedia":     "Энциклопедия",
            "owners-manual-intro":      "Руководство по эксплуатации все еще находится на ранней стадии. В конце концов, это будет довольно круто, но этого пока нет. Посмотрите на это, распечатайте, если хотите. И продолжайте проверять каждое обновление, потому что со временем оно будет становиться все лучше и лучше. Обязательно оставляйте отзывы и предложения в комментариях на форуме или в магазине приложений, чтобы сделать руководство как можно лучше. Наслаждайтесь",
            "general-civs":             "Цивилизация",
            "general-maps-available":   "Доступные типы плане",
            "general-starting-techs":   "Начальные Техники",
            "general-starting-building":"Начальные Строительств",
            "general-pin-colony":       "Создать ярлык",
            "general-pin-description":  "Прикрепите быструю ссылку на вашу колонию прямо на рабочем столе или на рабочем столе",
            "general-autobudget":       "Авто Бюджет",
            "general-autobudget-desc":  "Автоматически обрабатывать платежные ведомости и налоговые платежи без уведомления. Применяется только тогда, когда у вас достаточно средств для покрытия платежей.",
            "general-online-pay-assis": "Содружество помощи по заработной плате",
            "online-payass-desc":       "Установите скорость, с которой вы помогаете своим зафрахтованным колониям выполнять свои обязательства по выплате заработной платы. Вы можете заплатить где угодно от нуля до двойного или более. Тебе решать. Введите целое число в качестве процента помощи, например, 25 или 25%.",
            "sugarlandbase-desc":       "Основные технологии, которые идут с началом на карте Sugarland.",
            "insectoidbase-desc":       "Основные технологии, которые начинаются с расы насекомых.",
            "zolargbase-desc":          "Основные технологии, которые приходят из цивилизации Империи Золарг.",
            "zolgov-desc":              "Узнайте, как управлять колонией, стиль Insectoid.",
            "highcommand-description":  "Верховное командование является центром правительства в сообществе насекомых. Позволяет управлять дочерними колониями и устанавливать колониальные политики.",
            "supplypile-description":   "Просто небольшая, слегка защищенная стопка, где можно хранить все виды товаров и материалов.",
            "commandpost-description":  "Установите связь с #motherland и примите основные правила для колонии.",
            "consulate5-description":   "Когда ваше содружество переходит на темную сторону, вам лучше последовать его примеру. Это консульство открывает больше торговли ресурсами, а также привлекает туризм.",
            "smstadium-description":    "Помогите своим людям отвлечься от повседневной рутины вашей колонии, развлекая их на этом небольшом стадионе! Также принимает туристов.",
            "xenomat-desc":             "Узнайте, как работать и строить с материалами и соединениями из других миров.",
            "synthtext-description":    "Если вы можете получить в свое распоряжение таинственный и драгоценный ресурс, известный как «Муравьиная паста», его можно использовать для создания удивительной качественной ткани.",
            "pol-salespitch-header":    "Информация Содружества",
            "pol-salespitch-desc":      "Из 100 символов или менее, дайте игрокам обзор вашего Содружества и почему они должны присоединиться. Появится в списке Случайных Чартеров, когда игроки начнут новую игру.",
            "lis-description":          "ЛИС - это свободно выстроенная группа человеческих колоний, которые десятилетиями борются за независимость от Объединенной Земли.",
            "lisbase-desc":             "База стартовых техник для Лиги Независимых Государств.",
            "lislander-description":    "Этот старый спускаемый аппарат удерживается вместе со слюной и зубочистками.",
            "lisrover-description":     "Эти старые вездеходы были сняты с производства «Объединенной Землей» несколько лет назад, но Лига Независимых Государств все еще пользуется ими. Может использоваться для сбора реголита и создания основных конструкций.",
            "abandonedbase-desc":       "Базовые технологии доступны игрокам начиная с Заброшенного мира.",
            "abandonedworld-planet-desc":"Планета, содержащая рассеянные остатки давно ушедшей цивилизации.",
            "statue4-description":      "Старая реликвия, оставшаяся с прошлых дней.",
            "medstadium-description":   "Стадион хорошего размера для развлечения туристов и гостей. Потребляет еду и ром и увеличивает честь вашего народа!",
            "grass2-description":       "Прекрасная низкая декоративная трава, чтобы немного украсить вещи.",
            "sand2-description":        "Иногда вам просто нужно немного желтого песка в вашей колонии. Построить это.",
            "sand3-description":        "Идеальное лекарство для тех ситуаций, когда вашей колонии нужен апельсиновый песок.",
            "mailbox-description":      "Этот красивый декоративный почтовый ящик отлично смотрится в любом колониальном районе.",
            "hoops-description":        "Если бы в моей колонии были дети, им бы понравился этот декоративный баскетбольный обруч.",
            "oiltank2-description":     "Когда вы серьезно относитесь к хранению нефти, вам нужен этот квантовый масляный бак. Хранит тонны нефти, требует электричества и воды для работы.",
            "flag5-description":        "Покажите свою гордость за Лигу Независимых Государств с этим прекрасным флагом.",
            "greenhome-description":    "Этот Зеленый Дом не производит никакой еды, но в нем размещаются 7 колонистов и прекрасно вписывается в передний двор.",
            "sweatshop3-description":   "Если вам нужно накормить большую колонию, это потогонный магазин для вас. Ваши работники целый день будут рабами за низкую заработную плату, используя сахар для производства продуктов питания в промышленных масштабах.",
            "sweetnerfactory-description":"Используйте науку и удивительность, чтобы превратить масло в искусственный сахар! Не обращайте внимания на металлический вкус, это просто алюминий.",
            "oreenrichtech-desc":       "Научитесь чистить и очищать грубую руду, добываемую с земли.",
            "oreenrichmentfacility-description":"Очистите и обогатите свою существующую руду, сделав еще больше руды.",
            "goldsign-description":     "Если вы хотите сказать что-то, что будет длиться веками, напишите это на этом Золотом Знаке.",
            "cactus-description":       "Ваша колония будет отлично смотреться с этим декоративным кактусом! Магазины воды тоже.",
            "cactus3-description":      "Этот маленький кактус не хранит воды, но ваши люди будут любить его.",
            "palm-description":         "Это прекрасное дерево предлагает тень и иногда производит еду. Может также продаваться за содержание древесины.",
            "dune-description":         "Если ваша колония нуждается в песчаной дюне, мы вас обеспечим.",
            "deckchairs-description":   "Ничто не говорит «веселье на солнце» или «расслабление» так, как эти декоративные шезлонги.",
            "desertskull-description":  "Ни одна пустынная или песчаная область никогда не будет полной без черепа.",
            "fountain-description":     "Ваша колония будет отлично выглядеть, когда вы разместите несколько таких фонтанов вокруг своей карты.",
            "vertfarm-description":     "Поднимитесь с этой вертикальной сельскохозяйственной операцией. Также обеспечивает хранение продуктов.",
            "new-charter-desc":         "Начните новую колонию в соответствии с колониальным уставом другого реального игрока. Вы можете получить внутриигровую помощь от родительской колонии. Вид игрока, унаследованный от родительской колонии.",
            "new-charter-req-online":   "Для игры требуется учетная запись Ape Apps.",
            "woodharvesting-desc":      "Узнайте, как производить древесных жуков и начать заготовку и выращивание древесины.",
            "lumberbug-description":    "Эта маленькая ошибка типа термитов специализируется на всех вещах, связанных с древесиной.",
            "lumbercamp-description":   "Древесный лагерь является основным средством от насекомых для обработки и хранения древесины.",
            "powerspire-description":   "Используйте дрова, чтобы сжигать сахар еще жарче, что приводит к еще более эффективному источнику энергии.",
            "asteroid-planet-desc":     "Жизнь будет трудно начинать с астероида. Ожидайте трудности.",
            "statue5-description":      "Непристойно большая статуя Президента Объединенной Земли, который в настоящее время отбывает свой 14-й срок пребывания в должности, поддерживается искусственно. Говорят, что статуя обладает целительной силой.",
            "blackmarkets-desc":        "Начните производить вещи, которые, как правило, были запрещены или ограничены во владении Объединенной Земли.",
            "diamondmining-desc":       "Разблокируйте искусство добычи и переработки алмазов, ценного ресурса.",
            "colonialassembly-description":"Гражданская структура позволяет передать и принять политику, регулирующие вашу колонию.",
            "diamondrefinery-description":"Собирайте, улучшайте и храните сырые алмазные ресурсы.",
            "diamondminer-description": "Этот удобный бот может собирать и собирать алмазы для вас. Как мило!",
            "bmbazzar-description":     "То, что колонии LIS находятся под строгим эмбарго со стороны United Earth, не означает, что вы не можете вести хорошую честную торговлю.",
            "advmetalurgy-desc":        "Разблокируйте улучшенные приемы работы с разными металлами.",
            "alumibug-description":     "Веселый, любящий жук, специализирующийся на всем, что связано с алюминием.",
            "aluminumhive-description": "Склад, обработка и хранение алюминия.",
            "jewelrystore-description": "Какой лучший способ заставить ее сказать «я делаю», чем покупать ее бриллианты в этом ювелирном магазине? Хороший способ приносить доход для колонии.",
            "independencehall-description":"Центр власти и власти для независимой колонии ЛИС.",
            "leaguetrade-description":  "Соединитесь с галактическим товарным рынком, используя сложную систему прокси, чтобы обойти эмбарго на коммуникацию United Earth.",
            "resai-desc":               "Используя передовые технологии робототехники и квантовых вычислений Древних, откройте секреты истинного искусственного интеллекта.",
            "antsynth-desc":            "Используя древние технологии и огромное количество исследований, вы узнаете, как преобразовать алюминий и сахар в чистый антаниум.",
            "antsynth-description":     "В процессе с высокой энергоемкостью превратите алюминий и сахар в чистый антан. Требуются роботы для работы.",
            "quantumdistillery-description":"Используйте технологию Quantum для создания эпического рома. Большинство людей не могут почувствовать разницу между Quantum Rum и классически произведенным.",
            "yellowhouse-description":  "Эксперты говорят, что этот прекрасный желтый дом - лучшее место для воспитания семьи в #cityname.",
            "centerai-description":     "Современный искусственный исследовательский центр с искусственным интеллектом. Генерирует огромное количество исследований, потребляя микрочипы и роботов.",
            "antcompound-desc":         "Узнайте, как изготовить Triantanium, искусственное радиоактивное соединение Антания, известное как один из самых твердых металлов во вселенной.",
            "triantrefine-description": "Это автоматическое оборудование с нулевым уровнем выбросов, которое сплавляет уран и антаниум для производства триантана, чрезвычайно прочного металла. Расходует роботов во время работы.",
            "diplomacy-general":        "Дипломатия",
            "new-embassy-header":       "Учредить посольство",
            "new-embassy-desc-short":   "Начните новую дипломатическую миссию.",
            "new-embassy-desc":         "Если вы знаете чартерный кодекс другой независимой колонии, вы можете создать посольство в их колонии, чтобы разблокировать двустороннюю дипломатию и торговлю.",
            "theshanty-description":    "Дешевое посольство для лидера, которому просто все равно, как их колония представлена на международной арене.",
            "thefunctional-description":"Просто хорошее солидное без излишеств в деловое посольство. Есть все необходимое для успешного проведения дипломатической миссии.",
            "thegoldman-description":   "Это посольство выполняет свою работу и показывает вашей принимающей колонии, что ваше правительство означает бизнес.",
            "general-pick-embassy":     "Выберите Посольство",
            "general-embassy-requests": "В ожидании дипломатических миссий",
            "exomound-description":     "Дешевое и простое в настройке посольство. Просто прибыть на свою планету и выкопать большое гнездо. Boom.",
            "thecrystalline-description":"Это посольство покажет вашей принимающей колонии великолепие вашей нации.",
            "thesunrise-description":   "Пусть вся галактика знает, что солнце встает в новый день в #cityname.",
            "diplomaticoutpost-description":"Это прекрасное дипломатическое здание позволит всем увидеть вашу гордость LIS.",
            "shrineoftruth-description":"Это посольство сообщает вашей принимающей стране, что вы ведете хорошую, правдивую и честную дипломатию.",
            "transmissionhub-description":"Высокотехнологичный передатчик, который позволит вам и вашим людям отправлять сообщения по всей галактике. Генерирует небольшое количество исследований на основе полученных знаний.",
            "comms-general":            "коммуникации",
            "robofactory2-description": "Всемирная штаб-квартира корпорации Advanced Robotics. Генерирует деньги и роботов. Требуется алюминий и микрочипы для запуска.",
            "general-req-annex":        "Запрос аннексии",
            "req-anenx-desc":           "Петиция покинуть #motherland и присоединиться к новому уставу. Новая родительская колония должна будет утвердить запрос и заплатить #motherland все налоги, которые вы можете заплатить.",
            "req-annex-enter-charter":  "Введите кодекс Содружества, к которому вы хотите присоединиться.",
            "req-annex-final":          "Если они примут, вы покинете #motherland и присоединитесь к их сообществу.",
            "general-annex":            "Аннексировать",
            "alummine-description":     "Инсектоиды всегда находчивые копатели, способные копать Алюминиевые копи для увеличения производства алюминия.",
            "plantgen-desc":            "Узнайте, как изменить гены растений, чтобы создать еще лучшие растения!",
            "megatree-description":     "Сверхбольшое быстрорастущее дерево ГМО, производящее большое количество древесины.",
            "deeptrans-description":    "Deep Space Transceiver позволяет отправлять сообщения на большие расстояния. Генерирует исследования на основе эпической информации, которую он пропускает в вашу колонию.",
            "pavement8-description":    "Несколько дорогая дорога из алюминия. Сверхбыстрое движение для роверов. Потому что это гладко.",
            "plastfact2-description":   "Более крупная, быстрая и прочная версия фабрики пластмасс. Работает эффективнее обычной фабрики, а также использует роботов для производства.",
            "oilsynthlab2-description": "Когда вам нужно сделать больше нефти, подумайте о строительстве этого современного завода по производству синтетического масла. Преобразует продукты питания, реголит и древесный уголь в масло. Использует роботов во время производства.",
            "rover-firstbuild-tut":     "Ровер может добывать руду и строить основные конструкции. Чем больше у вас роверов, тем быстрее вы будете собирать ресурсы. Выберите новый Rover и выберите Build, чтобы просмотреть варианты строительства. Вы должны начать с теплицы и водяного насоса, чтобы ваши колонисты не умерли.",
            "greenhouse-firstbuild-tut":"Структуры требуют питания для работы. Когда у вас будет достаточно руды, вы должны построить панель солнечных батарей, чтобы свет горел в #cityname. Если у вас кончится власть, ваши здания станут полупрозрачными и перестанут производить. Если вы будете слишком долго без власти, ваши люди умрут. Если вам нужно, вы можете выбрать здание и временно отключить его, чтобы высвободить энергию для других сооружений.",
            "solarpanel-firstbuild":    "Если вы еще этого не сделали, подумайте о строительстве завода по производству малых транспортных средств. Это откроет новые классы Rover, которые предоставят вам еще больше возможностей для строительства.",
            "smveh-firstbuild-tut":     "Выберите свой новый завод по производству малолитражных автомобилей и постройте бот-конструктор.",
            "builderbot-firstbuild-tut":"С ботом Builder вы действительно можете начать выращивать свою колонию. Вы должны начать с строительства нескольких укрытий и посадочной площадки. Приюты обеспечивают жильем новых колонистов, а посадочная площадка позволяет новым колонистам мигрировать в вашу колонию. Обязательно следите за производительностью электроэнергии, пищи и воды по мере роста вашего населения.",
            "landingpad-firstbuild-tut":"Вашим новым колонистам понадобится работа, чтобы зарабатывать деньги и оставаться счастливыми. Строительство рудного завода даст им отличное место для работы!",
            "orerefinery-firstbuild-tut":"Рудный завод предоставляет рабочие места для ваших колонистов и превращает руду в сталь, новый ресурс, который позволяет вам строить больше структур. Колонисты работают посменно, и нефтеперерабатывающий завод будет производить только тогда, когда колонисты дежурят. Чем больше у вас рудных заводов, тем больше стали вы будете производить. Помните, что здания требуют, чтобы по крайней мере одна сторона была разблокирована другими структурами, чтобы колонисты могли получить к ним доступ.",
            "pavement-firstbuild-tut":  "Дорожные плитки позволяют вашим юнитам быстрее перемещаться по карте. Они предпочтут двигаться по асфальтированным дорожкам к простой грязи. Используйте его стратегически, чтобы сократить время в пути до и из важных ресурсов.",
            "internetbooth-firstbuild": "Колонисты нуждаются в развлечениях, чтобы не сойти с ума. Если их счастье станет слишком низким, они откажутся идти на работу, что приведет к остановке вашей колонии. Обязательно держите достаточное количество развлекательных зданий рядом с колониальными домами, чтобы они были довольны!",
            "goldrefin-firstbuild":     "Выберите свой новый ЗПЗ, чтобы построить золотодобытчика, который позволит вам начать сбор ценного золотого ресурса.",
            "goldmienr-firstbuild":     "Как Rover и Ore Miners, выберите своего Gold Miner и назначьте его на сбор урожая, чтобы начать собирать Gold.",
            "smresearch-firstbuild-tut":"Некоторые структуры производят ценные исследования, которые могут быть использованы для открытия новых технологий, которые приводят к новым вариантам строительства. Время от времени нажимайте на фиолетовый значок исследования зелья, чтобы узнать, какие технологии доступны для разблокировки.",
            "atmosgen-firstbuild":      "Одна из целей моей колонии - терраформировать вашу планету, создав атмосферу. Как только ваш уровень атмосферы станет достаточно высоким, вы откроете для себя новые захватывающие варианты строительства!",
            "chopshop-firstbuild-tut":  "Когда вам больше не нужен Ровер, вы можете заказать его в Чоп-шоп, который будет собирать Ровер для его сырья.",
            "lunar-welcome-message":    "Добро пожаловать! Вы основали новую колонию с колониальным уставом из #motherland. Ваша цель - превратить этот пустынный мир в процветающую цивилизацию. Чтобы начать, выберите свой Ровер и закажите его, чтобы начать сбор урожая. Как только вы соберете не менее 10 реголитов, выберите своего ландера и постройте второй ровер.",
            "lunar-rover-firstbuild-tut":"Роверс может собирать реголиты, а также строить основные конструкции. Чтобы начать формировать колонию, вам нужно будет преобразовать часть своего Реголита в Гелий 3, жизненно важный ресурс. Когда вы можете себе это позволить, закажите Ровер, чтобы построить экстрактор гелия 3. Помните, чем больше у вас роверов, тем быстрее вы будете собирать ресурсы.",
            "he3-firstbuild-tut":       "Для того, чтобы начать производить еду, вам нужно будет преобразовать некоторое количество Реголита в Руду. Руда является жизненно важным строительным ресурсом, который вам понадобится для строительства большинства сооружений. Как только у вас будет достаточно Гелия 3, постройте один компактор Regolith.",
            "reg-compactor-firstbuild": "Вашим колонистам понадобятся и еда, и вода, чтобы выжить. Пища становится более неотложной на раннем этапе, так как у вас должно быть достаточно воды, чтобы немного продержаться. Когда у вас будет достаточно руды, постройте оранжерею, чтобы начать производить еду для колонии. Когда у вас будет достаточно энергии, постройте экстрактор воды, чтобы начать производить жизненно важную воду.",
            "forest-welcome-message":   "Добро пожаловать! Вы основали новую колонию с колониальным уставом из #motherland. В этом мире не хватает ресурсов, поэтому вам нужно быстро двигаться, чтобы выжить. Чтобы начать, выберите свой Ровер и закажите его, чтобы начать сбор урожая. Как только вы соберете как минимум 40 Вуд, выберите своего Lander и постройте второй Rover.",
            "forestrover-firstbuild-tut":"Роверс может собирать древесину, а также строить основные конструкции. Ваш первый заказ - кормить колонистов, чтобы они не умирали. Когда у вас будет достаточно дерева, закажите один из ваших роверов, чтобы собрать картофельное поле.",
            "potpatch-firstbuild-tut":  "Теперь, когда у вас началось производство основных продуктов питания, вашим колонистам понадобится немного воды. Пусть один из ваших роверов построит колодец с водой.",
            "waterwell-firstbuild-tut": "Постоянное производство древесины жизненно важно для поддержания вашей колонии в живых. Выращивание деревьев имеет решающее значение на раннем этапе. Закажите ровер, чтобы построить пару елок возле базы для более быстрой уборки. После этого вы должны построить Хижину из древесного угля, чтобы начать производство древесного угля. Помните, чем больше у вас роверов, тем быстрее вы получите ресурсы!",
            "charchut-firstbuild-tut":  "Древесный уголь является жизненно важным базовым ресурсом и может быть использован для создания руды. Руда является наиболее важным строительным ресурсом в игре. Когда у вас будет достаточно материалов, закажите ровер, чтобы сконструировать компактор для угля, чтобы начать превращать часть вашего угля в жизненно важную руду.",
            "charccompact-firstbuild-tut":"Прежде чем расти дальше, вашей колонии понадобится сила. Для этого вам нужно будет построить угольную горелку, но сначала вам, вероятно, понадобится как минимум еще одна угольная хижина, чтобы удовлетворить текущие потребности в древесном угле. Помните, что если вам нужна дополнительная мощность, вы всегда можете выбрать здание и временно отключить его. Постарайтесь собрать достаточно ресурсов, чтобы запустить угольную горелку.",
            "charcoalburn-firstbuild-tut":"Обладая достаточной мощностью, вы должны построить небольшую автомобильную фабрику, которая откроет новые варианты строительства.",
            "insectoid-welcome-message":  "Добро пожаловать! Вы основали новую колонию с колониальным уставом из #motherland. Ваша цель - превратить этот пустынный мир в процветающую цивилизацию. Сначала найдите хорошее начальное место и разверните свою Королеву. Затем выберите рабочего дрона и прикажите ему начать собирать сахарный тростник. Пока он собирает урожай, выберите свой Курган и заказать строительство руды.",
            "orebug-firstbuilt-tut":    "Orebug будет собирать жизненно важную руду, которая будет использоваться для создания вашей колонии. В то время как ваши урожаи Orebug, выберите ваш Курган, чтобы построить второй рабочий Drone. Возможно, вам придется немного подождать, пока из вашего кургана будет добыто больше пищи. Как только вы соберете не менее 300 руд, закажите рабочему дрону, чтобы построить зону пиршества, чтобы начать производить еду для колонии.",
            "feastarea-firstbuild-tut": "С пищей, заботящейся (пока), вы должны снова выбрать своего Кургана и собрать пару водяных жуков, чтобы начать собирать воду для колонии.",
            "waterbug-firstbuild-tut":  "Закажи своих клопов, чтобы начать собирать воду. Когда у вас будет достаточно воды и руды, закажите рабочего дрона, чтобы построить коммунальные чаны для воды, чтобы вы могли начать запасать воду для колонии.",
            "communalvats-firstbuild-tut":"Чтобы продолжить рост вашей колонии, вам понадобится муравьиная паста, жизненно важный строительный материал. Как только у вас появятся необходимые материалы, закажите рабочего дрона, чтобы построить бак для пасты.",
            "wetcone-description":      "Мокрый конус - это технологическое улучшение по сравнению с влажным курганом. Используя алюминий и другие металлы, он способен извлекать (и хранить) значительно больше воды.",
            "interdimtrav-desc":        "Расширьте свою экономику и свой галактический охват, открыв секреты Межпространственного Транспорта. Позволяет приносить товары, людей и даже методы строительства из далеких миров.",
            "stargate-description":     "Используя планы Древних, создайте удивительный межпространственный телепорт, который позволит вам вести дела на безумных галактических расстояниях. Также допускает свободное перемещение граждан между мирами.",
            "megahab-desc":             "Узнайте, как заставить колонистов жить вместе тысячами в стесненных условиях. Это хорошо для окружающей среды.",
            "arcology-description":     "После игры в компьютерную игру по строительству древнего земного города на эмуляторе один из наших инженеров придумал этот дизайн для мегаструктуры, где люди могли бы жить, работать и играть, и больше никогда не выходить на улицу.",
            "general-statistics":       "Статистика",
            "mysticism-desc":           "Откройте для себя духовные силы древних насекомых, которые были обычным явлением до того, как император Золарг объявил их вне закона несколько веков назад.",
            "shrineofmystics-description":"Эти древние инсектоидные святыни были объявлены вне закона на Золарге Прайме много веков назад из-за нечестивой силы, которую они открывают. Только независимые колонии могут экспериментировать с их силой.",
            "colony-plays-on":          "Играет на",
            "insbeu-desc":              "Узнайте, как вырастить свое правительство насекомых, чтобы оно было больше и сильнее. Ну, по крайней мере, больше.",
            "highercommand-description":"Это модернизированное здание Капитолия позволит вам проводить больше политик и проводить расширенные дипломатические операции.",
            "unholypowerspire-description":"Этот модернизированный энергетический шпиль, питаемый нечестивой Антаурой, производит большое количество электроэнергии без вредных выбросов.",
            "general-modding":          "Моддинг",
            "general-texture-mods":     "Текстурные Моды",
            "text-mods-desc":           "Измените внешний вид My Colony, заменив ресурсы по умолчанию пользовательской графикой.",
            "general-map-editor":       "Редактор карт",
            "general-map-editor-desc":  "Создавайте собственные стартовые карты, показывающие любые особенности местности или ресурсы, которые вы хотите.",
            "general-tex-mod-import":   "Импортировать текстуру мод",
            "general-tex-mod-activate": "Активировать текстурный мод",
            "general-tex-mod-deactivate":"Деактивировать текстуру мод",
            "general-tex-mod-create":   "Создать текстуру мод",
            "tex-mod-activate-desc":    "Активируйте и включите ранее установленный файл текстурного мода.",
            "tex-mod-deactivate-desc":  "Вернитесь к использованию набора текстур игры по умолчанию.",
            "tex-mod-import-desc":      "Импортируйте и установите файл My Colony Texture Mod (* .mct), который вы сохранили на своем устройстве.",
            "tex-mod-editor-desc":      "Запустите Редактор текстурного мода и создайте свои собственные файлы My Colony Texture Mod (* .mct), которые вы можете экспортировать и поделиться с другими.",
            "general-make-center":      "Сделать Центр",
            "iceworldbase-desc":        "Базовые стартовые технологии для карты Ice World.",
            "iceworld-planet-desc":     "Пустынная замерзшая пустошь, куда умирают колонисты. Содержит некоторые редкие кристаллы, которые нельзя найти где-либо еще в галактике.",
            "monumentheroes-description":"Прекрасный памятник в память о подвигах Сарджа и его команды космических десантников - живых легенд цивилизации Объединенной Земли.",
            "fantasyland-description":  "Мега жилое место обитания, где мечты становятся реальностью, по крайней мере, до тех пор, пока реальность не наступит. Роботы позаботятся обо всех ручных задачах, чтобы жители могли играть весь день. Обеспечивает массовое жилье, но не рабочие места, развлечения или другие услуги. Потребляет игрушки, ром, одежду и роботов.",
            "general-modding-community":"Сообщество моддинга",
            "general-mod-comm-desc":    "Онлайн форум, где пользователи могут делиться своими модами или загружать моды, созданные другими.",
            "general-vidtut-header":    "Видео уроки",
            "general-vidtut-desc":      "Общественные видео-гиды.",
            "general-vid-sumbit":       "Материалы",
            "general-vid-submit-desc":  "Отправить свой собственный видео-учебник!",
            "oresynth-description":     "Используя силу науки, химически превращайте Реголит в Руду, гораздо быстрее, чем это мог бы сделать любой старый Реголит.",
            "rescomplexblue-description":"Краска может быть синей, но соседи будут завидовать зеленому, когда этот Голубой жилой комплекс поднимется по соседству.",
            "bigplayhouse-description": "Если вы когда-нибудь ожидали, что веселье закончится, вас ждет разочарование. Потому что это продолжается вечно в Большом Театре.",
            "crystalminer-description": "Специализированный ровер для работы с Crystalline в суровых условиях.",
            "micromine-description":    "Закаленная поверхность тундры слишком мала, чтобы маленький ровер мог прорваться очень далеко, но с помощью закаленной кристаллической поверхности вы извлекаете некоторый поверхностный реголит.",
            "regfurnace-description":   "Используйте химическую реакцию между Реголитом и Кристаллической, чтобы произвести электричество для колонии.",
            "compactedsnow-description":"Дешевый путь для помощи вашим роверам и колонистам из точки А в точку Б.",
            "nexgenpow-desc":           "С силой ИИ, откройте для себя методы генерации электричества сверх того, что могли себе представить даже древние.",
            "diamondcrystalreactor-description":"Объедините Алмазы и Кристаллический с Ураном, чтобы произвести нечестивое количество энергии.",
            "alienenrichment-description":"Возможно, вы думали, что у вас довольно хорошо получается обогащать уран, но древние были намного лучше. Так что укради их методы с этим средством!",
            "tundrabug-description":    "Трудолюбивый насекомое, которое не возражает против холода и любит резать кристаллы своими могучими челюстями.",
            "crystalmound-description": "Уютная насыпь, где насекомые сплавляются вокруг Кристаллического и переваривают его в чистый Сахар.",
            "oretunnel-description":    "Проберитесь сквозь замерзшую поверхность, чтобы найти следы руды, спрятанные под ней.",
            "syncrystaldeposit-description":"Используя существующие Crystalline и Rum, вырастите синтетический вариант Crystalline, который можно собрать. Не так сильно, как настоящая вещь, но будьте осторожны, потому что она распространяется.",
            "crysynth-desc":            "Узнайте, как вырастить свои собственные кристаллические депозиты, не выходя из дома!",
            "independencehall2-description":"Больше зал, больше независимости! Позволяет расширить политические и дипломатические возможности. Производит больше денег, но политики теперь потребляют ром.",
            "microincinerator-description":"Основной низкотехнологичный способ уменьшить количество мусора в колонии. Вырабатывает немного энергии, пока мусора достаточно для его работы.",
            "microincinerator-firstbuild-tut":"Со временем ваши колонисты будут создавать мусор, который загрязнит колонию и вызовет болезни. Обязательно следите за уровнем мусора и соответствующим образом выстраивайте структуры управления отходами.",
            "smrecyclingcenter-description":"Займите зеленый цвет, взяв грязный мусор в вашей колонии и превратив его в пригодный для использования пластик!",
            "smtrashpit-description":   "Когда мусор начнет накапливаться, просто выкопайте яму и бросьте ее внутрь. Попав в яму, мусор будет постепенно разлагаться со временем.",
            "conferencehall-description":"Там, где встречаются великие культурные, научные и экономические умы со всей галактики. Обеспечивает деньги и исследования при использовании рома, микрочипов и продуктов питания.",
            "advancedmed-description":  "Исцелите большое количество колонистов, производя жизненно важные исследования для колонии.",
            "restowerblue-description": "Единственное, что лучше жилой башни - это голубая. Не веришь мне? Постройте его и убедитесь сами.",
            "incinerator-description":  "Сжигайте большое количество мусора и превращайте его в энергию для колонии. Создает много атмосферы.",
            "medrecyclingcenter-description":"Большой и лучший центр переработки. Превращает ваш старый мусор в пластик и немного алюминия!",
            "landfill-description":     "Выкопайте гигантскую яму и выбросьте в нее весь свой мусор. Мусор будет разлагаться немного быстрее, чем в Малой Яме для Мусора.",
            "unholybrewpit-description":"Если вам нужно нечестивое количество варева, вам понадобится это нечестивое варенье. Использует силу Антауры, чтобы действительно увеличить производство Рома.",
            "offline-game-desc":        "Запустите новую игру в автономном локальном режиме. Соединение не требуется, и вы можете выбрать свою собственную цивилизацию. Вы можете играть вместе с другими локальными играми в вашей сети.",
            "creative-mode-desc":       "Начать новую креативную карту. Геймплей оффлайн, и вы не можете выйти в интернет позже. Все сооружения разблокированы и могут быть построены мгновенно бесплатно.",
            "unholypit-description":    "Храните нечестивое количество припасов, используя силу Антауры.",
            "unholymound-description":  "Этот курган обеспечивает кров для 600 и генерирует Антауру. Не хранит какие-либо ресурсы и не служит точкой высадки.",
            "coremine-description":     "Эта глубокая шахта, созданная и управляемая силой нечестивой Антауры, принесет в вашу колонию чудесные ресурсы. Вы никогда не знаете, что вы можете выкопать ...",
            "smlightpost-description":  "Обеспечивает немного света для вашей колонии.",
            "smredlightpost-description":"Район красных фонарей в #cityname? Это зависит от вас.",
            "smgreenlightpost-description":"Твои люди просто полюбят эти зеленые огни.",
            "glowgoo-description":      "Когда вы едите муравьиную пасту, а затем подбрасываете ее обратно с кучей старой пищи, смешанной, химическая реакция создает отвратительное, но все же освещающее Glow Goo.",
            "streetlight-description":  "Постройте высокий столб и поместите свет сверху. Теперь вы можете видеть ночью!",
            "pasteboiler-description":  "Получите Ant Paste очень горячий, который пропускает атмосферу в небо. Требуется постоянный поток муравьиной пасты.",
            "atmosscrubber-description":"Используйте силу ИИ, чтобы убрать загрязняющие вещества из атмосферы.",
            "wall2-description":        "Эта большая, красивая, темная, грозная стена заставит ваших людей чувствовать себя в безопасности.",
            "wall2light-description":   "Очевидно, что для стены безопасности потребуется освещение.",
            "general-start-construction":"Начать строительство",
            "general-confirm":          "подтвердить",
            "hire-worker-header":       "Выберите место работы.",
            "general-overview":         "обзор",
            "general-population":       "Население",
            "general-government":       "Правительство",
            "general-economy":          "экономика",
            "general-charter-code":     "Код колониста",
            "general-col-location":     "Расположение колонии",
            "general-col-color":        "Цвет Колонии",
            "general-col-screenshot":   "Скриншот колонии",
            "general-col-screenshot-desc":"Возьмите или обновите свой общедоступный скриншот.",
            "general-tot-death":        "Всего смертей",
            "general-demographics":     "Демография",
            "general-avg-age":          "Средний возраст",
            "general-cant-afford":      "Вы не можете себе этого позволить!",
            "ancienttemple-description":"Таинственный храм, построенный древними.",
            "diamondsolar-description": "Более эффективный вариант Солнечной Башни, покрытый бриллиантами.",
            "bureaucracy-description":  "Обеспечивает рабочие места и бюрократизм для вашего правительства, создавая гражданские по пути.",
            "clothfarm-description":    "Малоизвестный факт об инсектоидах заключается в том, что они способны производить шелковистое вещество, когда едят алюминий. Этот курган будет использовать это для производства ткани.",
            "cauldron-description":     "В интенсивном электрическом процессе разбейте Реликвии Чужих на отдельные артефактные предметы, используя перегретый котел Муравьиной Пасты.",
            "supermarket-description":  "Когда колонисты устают от своего скудного государственного рациона, они могут потратить свои деньги на хорошие вещи в этом супермаркете. Обеспечивает хорошую низкооплачиваемую работу и деньги, потребляя еду и воду.",
            "megamart-description":     "Куда колонисты ходят, чтобы найти отличные цены на все, от еды до игрушек, от алкоголя до электроники!",
            "politheat-desc":           "Когда ваши люди начинают выяснять, что вы в одиночку управляете им железным кулаком, пора устраивать шоу и заставлять их думать, что они ответственны.",
            "uecongress-description":   "Безумно завышенная цена на штамповочное учреждение и символ правительственного переизбытка, где политики собираются, чтобы официально подписать все ваши решения и назвать достопримечательности в честь себя. Если вам нужно спросить, сколько это стоит, то вы не можете себе этого позволить.",
            "refinery3-description":    "Используйте технологию пришельцев, чтобы превратить руду и уран в нечистое количество стали. Вы никогда не закончите из стали снова!",
            "antpastesynth-desc":       "Узнайте, как искусственно создать муравьиную пасту в лаборатории.",
            "pastesynth-description":   "Комбинируйте мусор и атмосферу под высоким уровнем электричества, чтобы создать синтетическую пасту для муравьев. Почти так же хорошо, как реальные вещи!",
            "turbodrone-description":   "Он может построить все, что может построить обычный Строительный Дрон. Всего в 40 раз быстрее.",
            "sugarrover-description":   "Хороший трудолюбивый вездеход, имеющий дело со всем, что связано с сахаром.",
            "smsugarprocessor-description":"Склад и хранилище для сахара. Создает небольшое количество пищи как побочный продукт операций.",
            "check-render-distance":    "Проверьте расстояние рендеринга",
            "check-render-dist-desc":   "Нарисуйте здания в сегментах, основываясь на расстоянии рендеринга от камеры. Выключение ускоряет игру, но вводит глюки рендеринга и неупорядоченные здания.",
            "general-place":            "Место",
            "asteroidbase-desc":        "Базовые технологии, которые приходят из мира астероидов.",
            "text-backup-instruction":  "Скопируйте данные игры в текстовый редактор и сохраните в виде файла .mcz",
            "general-avg-health":       "Среднее здоровье",
            "general-avg-iq":           "Средний IQ",
            "general-average-savings":  "Средняя колония сбережений",
            "general-median-savings":   "Средние сбережения колонистов",
            "general-trade-authority":  "Управление Галактической Торговли",
            "general-trade-too-recent": "Ваша последняя сделка была слишком недавней. Пожалуйста, подождите, прежде чем отправлять другую сделку.",
            "bloodletting-description": "Приходите насладиться последними достижениями в современной медицине насекомых. Станция кровопускания обеспечивает здоровье больных и даже развлечения для скучающих, поскольку кровопускание является одновременно целительным и модным.",
            "spireknowledge-description":"Когда в этот шпиль, сделанный из золота и алюминия, входит инсектоид, его разум настолько очарован своей металлической красотой, что рождается чистое знание.",
            "sphrad-description":       "Этот наэлектризованный металлический шар обеспечивает хороший свежий свет для колонии.",
            "general-trade-too-big":    "Из-за складских ограничений, Галактическое Торговое Управление в настоящее время не принимает размеры лотов, превышающие единицы #maxlotsize.",
            "general-trade-gouging":    "Торговое управление Галактики отклонило вашу сделку, так как торговый представитель Империи считает, что вы взвинчиваете цену. В настоящее время он не принимает цены лотов выше $#maxlotsize. Забастовка была добавлена в ваш аккаунт.",
            "general-trade-undercut":   "Торговое управление Галактики отклонило вашу сделку, так как торговый представитель Империи считает, что вы слишком сильно подрезаете рынок. В настоящее время он не принимает цены лота ниже $#maxlotsize. Забастовка была добавлена в ваш аккаунт.",
            "uraniumsilo-description":  "Закаленный контейнер для хранения урана.",
            "ancientbug-description":   "Чтобы создать Древнего клопа, молодым личинкам насекомых необходимо ввести расплавленные инородные реликвии и артефакты, чтобы при выводе они сохраняли строительные знания древних.",
            "quantumsugarcloner-description":"Используя силу древних, превратите одну единицу сахара во многие. Требуется вода во время работы.",
            "general-collect-all":      "Собрать все",
            "general-collect-all-desc": "Я ненавижу распаковывать подарки, просто собираю все сразу!",
            "general-connection-error": "Ошибка соединения",
            "connection-error-info":    "Невозможно подключиться к серверу My Colony. Игры в режиме онлайн требуют подключения к Интернету, чтобы играть.",
            "rawmatdepot-description":  "Место высадки и складирования сырья для строительных материалов.",
            "commandpost2-description": "Модернизированный командный пункт, позволяющий увеличить количество торговых и гражданских указов.",
            "unholycommand-description":"Укрепите свою силу с помощью нечестивой Антауры и запрещенных технологий пришельцев.",
            "object-options-dismiss-tip":"Закройте диалоговое окно параметров объекта.",
            "object-options-stats-tip": "Отобразить соответствующую статистику для выбранного объекта.",
            "object-options-activation-tip":"Активируйте или деактивируйте выбранную структуру для управления потреблением энергии и ресурсов.",
            "object-options-comms-tip": "Отправляйте сообщения и другие сообщения по всей галактике.",
            "object-options-mkcenter-tip":"Сделайте эту структуру центром фокуса вашей колонии.",
            "object-options-flip-tip":  "Отразить ориентацию выбранной структуры.",
            "object-options-empire-tip":"Управляйте и взаимодействуйте со своим Содружеством.",
            "object-options-policy-tip":"Установите и пересмотрите правительственную политику для колонии.",
            "object-options-diplomacy-tip":"Вести торговлю и дипломатию с другими колониями.",
            "object-options-move-tip":  "Заказывайте выбранную единицу, чтобы переехать в новое место.",
            "object-options-harvest-tip":"Заказывайте выбранную единицу, чтобы начать сбор ресурсов.",
            "object-options-park-tip":  "Присвоение выбранного устройства в назначенное место для парковки.",
            "object-options-repair-tip":"Восстановить выбранную структуру.",
            "object-options-destroy-tip":"Уничтожить выбранный объект.",
            "object-options-build-tip": "Показать параметры конструкции для выбранного объекта.",
            "object-options-sell-tip":  "Продать выбранный объект.",
            "object-options-upgrade-tip":"Обновите выбранный объект.",
            "object-options-import-tip":"Показать параметры импорта ресурса для выбранной структуры.",
            "object-options-export-tip":"Показать параметры экспорта ресурса для выбранной структуры.",
            "object-options-trade-tip": "Покупайте и продавайте товары на мировой торговой площадке.",
            "helpful-tips-header":  "Полезные советы",
            "customsprocessing-description":"Центр межзвездной торговли и коммерции. Позволяет ввозить и вывозить товары и выступает в качестве шлюза для туристов и других посетителей.",
            "opendoors-desc":       "Откройте двери своей колонии во внешнюю галактику и получите доступ к новым рынкам и новым возможностям!",
            "pastespa-description": "Туристы со всей галактики отправятся в #cityname, чтобы расслабиться в этом спа-салоне Paste Treatment, где муравьиная паста вводится в организм, предположительно обеспечивая все виды пользы для здоровья.",
            "lavaworldbase-desc":   "Базовые стартовые технологии карты мира лавы.",
            "lavaworld-planet-desc":    "По сути, худший тип планеты, которую вы можете колонизировать. Не делай этого, если не ненавидишь себя и своих колонистов.",
            "lava-world-intro":     "Вы ступаете на беспощадную пустошь. Лава будет постоянно менять местоположение, и новые вулканические извержения будут разрушать #cityname. Соберите Кристаллический и Рудный, чтобы начать. Если эффекты освещения вызывают проблемы с производительностью, их можно отключить в меню «Настройки движка».",
            "extremeobug-description":  "Этот крепкий маленький парень создан для работы в самых непростительных условиях.",
            "vaporizer-description":    "Используйте Кристаллический и Атмосфера, чтобы создать жизненно важную питьевую воду для колонии.",
            "queen-description":        "Королевы являются основой любой колонии насекомых. Они копают курганы и откладывают яйца, выращивая население.",
            "general-deploy-loaded":    "Развернуть загруженные юниты",
            "rovertransport-description":"Летательный транспорт, который может перевозить до пяти единиц Rover по любой местности.",
            "obsidiobug-description":   "Единственный в галактике инсектоид, способный собирать редкий обсидиан.",
            "earthlike-planet-desc":    "Легкая планета с достаточно ресурсов и очень мало проблем. Хорошо для начинающих, изучающих основы или для казуальной игры.",
            "general-new-map":          "Новая карта",
            "general-new-map-desc":     "Создать новую карту с нуля.",
            "general-edit-existing":    "Изменить существующий",
            "general-edit-existing-desc":"Изменить существующую карту.",
            "general-custom-map":       "Пользовательская карта",
            "general-map-meta":         "Метаданные карты",
            "general-map-author":       "Создатель",
            "general-map-description":  "Описание",
            "general-map-version":      "Версия карты",
            "general-custom-map-desc":  "Играйте, используя пользовательскую карту, которую вы скачали или создали.",
            "general-import-map":       "Импорт пользовательской карты",
            "general-import-map-desc":  "Импортируйте и установите файл пользовательской карты (* .mcm), который вы сохранили на своем устройстве.",
            "desertworld-planet-desc":  "Теплый засушливый ландшафт с небольшим количеством растительности, но рассеянными ценными ресурсами.",
            "reptilian-description":    "Рептилии - древний и высокоразвитый вид, первоначально мигрировавший из-за пределов галактики много-много лет назад.",
            "draconians-description":   "Альфа-драконианцы - высокотехнологичная злая и воинственная цивилизация рептилий. Они действуют, лишая планеты своих природных ресурсов и порабощая любое ранее существовавшее население.",
            "constructionprobe-description":"Строительный зонд - беспилотный межзвездный корабль, предназначенный для подготовки новой планеты к колонизации рептилий.",
            "draconians-welcome-message":"После нескольких недель высокоскоростного межзвездного путешествия наш Строительный зонд прибывает на #cityname. Выберите зонд и используйте его, чтобы начать делать посадочную площадку пригодной для колонизации.",
            "poweredmatsilo-description":"Пока эта структура поддерживает мощность, она будет предоставлять все виды пространства для хранения новой колонии.",
            "microreactor-description": "Небольшой автоматизированный ядерный генератор. Медленно потребляет уран во время работы.",
            "slavegate-description":    "Поскольку злые Альфа-драконианцы никогда не подвергнут себя ручному труду, они веками похищали и порабощали инсектоидов. Подключитесь к галактической драконовской сети рабских торговых звездных ворот и принесите в свою колонию немного свободного труда.",
            "antaniumimpactor-description":"Ударопрочная дробилка промышленного класса, которая быстро превращает руду и золото в титан, закаленный конструкционный сплав. Требует большого количества энергии.",
            "microcondenser-description":"Небольшой основной конденсатор для превращения атмосферы в чистую питьевую воду. Может быть легко собран ребенком-рептилией в течении 2 часов. Очевидно, это требует атмосферы.",
            "pavement9-description":    "Особый и шикарный плиточный и тонированный тротуар, от которого рептилии просто не могут насытиться.",
            "desertworldbase-desc":     "Базовая стартовая технология для карты мира пустыни.",
            "draconianbase-desc":       "Базовая стартовая технология для альфа-драконовской цивилизации.",
            "reptbase-desc":            "Базовая стартовая технология для расы рептилий.",
            "fairwarning-description":  "Чтобы служить справедливым предупреждением для любого порабощенного насекомого, который мог бы предать Альфа-драконианцев и попытаться сбежать.",
            "autohydro-description":    "Необработанная автоматизированная установка для производства основных пищевых продуктов низкого уровня.",
            "basicden-description":     "Небольшая базовая единица жилья для одного гражданина Рептилии.",
            "familyden-description":    "Рептилии, которые могут получить отказ от #motherland для совместного проживания, могут жить вместе в Семейном Логове, если они не нарушают политику в отношении одного ребенка.",
            "medstargate-description":  "Рептилии веками использовали технологию «Звездные ворота», и эти ворота средней дальности могут перевозить грузы и мирных жителей примерно на 3/4 пути через галактику.",
            "natflag-description":      "Этот флаг твоих гордых людей всегда будет летать в твоих цветах колонии.",
            "general-col-color-info":   "Установите или измените официальное правительство и цвет флага вашей колонии.",
            "torturebooth-description": "Этот дешевый развлекательный центр обеспечит вашим рептилий часами веселья. Не так много для бедного инсектоида, который должен войти внутрь.",
            "tut-medstargate":          "Поскольку рептилии используют много ресурсов, а их люди отказываются работать, вам нужно будет использовать Star Gates для импорта и экспорта товаров, необходимых для расширения вашей колонии и уплаты налогов.",
            "dronepad-description":     "Небольшая панель телепорта, которая позволяет вам покупать или продавать строительные дроны из #motherland с мгновенной доставкой.",
            "uraextract-description":   "Этот ловкий зонд может добывать сырые урановые месторождения! Подумайте обо всех возможностях.",
            "goldgrower-description":   "Gold Grower - это удобная в своем роде высокотехнологичная электрогрелка, которая способна уменьшить содержание руды и использовать ее для выращивания золота, используя мощь кристаллов.",
            "aluminumgrower-description":"Мощный производитель алюминия способен создавать чистый алюминий из руды и урана, используя мощь кристаллов.",
            "pavement1light-description":"Как обычный тротуар, но со встроенным небольшим световым столбом, чтобы ваши люди могли видеть во время прогулки по дороге. Не такой яркий, как автономный световой столб, но по нему можно ходить.",
            "firstaid-description":     "Небольшое и быстрое лечебное учреждение, куда колонисты могут обратиться за неотложной медицинской помощью.",
            "trashtransporter-description":"В отличие от многих других видов, рептилии открыли, как позаботиться о проблеме мусора много лет назад. Вы строите межзвездный телепорт и посылаете все это на Объединенную Землю.",
            "pasteextractor-description":"Муравьиная паста является важным связующим веществом в строительстве Antanium, а настоящие вещи могут быть сделаны только Инсектоидами. Однако, часто Инсектоиды не умышленно делают это для своих Повелителей Рептилий, поэтому должны были быть созданы другие методы извлечения.",
            "arbsquare-description":    "Небольшая общественная площадь, где Арбитр излагает наказания и суждения против граждан, как он считает нужным.",
            "general-entertainment-cap":"Вместимость Развлечений",
            "oreevaporator-description":"Используя большое количество энергии и Кристаллов, превратите сырую руду в Гелий-3, ценное и мощное вещество.",
            "pebbles-description":      "Рептилии абсолютно обожают внешний вид этих речных камешков, вместе с тем чувством, которое они испытывают, когда идут по ним.",
            "prairieweed-description":  "Этот декоративный сорняк, привезенный с сухих равнин Альфы Дракона, заставит ваших рептилий чувствовать себя как дома.",
            "regenchamber-description": "Правильно питаться и выполнять упражнения для птиц. Просто прыгайте в эту Регенерационную палату и увидите, как все ваши медицинские проблемы растают!",
            "coalconvert-description":  "Если вы когда-нибудь окажетесь в ситуации, когда у вас много угля и мало руды, постройте этот древний инопланетный конвертер угля! Способ эффективнее стандартного угольного уплотнителя. Превращает древесный уголь в руду, но расходует немного воды и урана во время использования",
            "pavement2light-description":"Постройте эту прекрасную плиту из закаленной мостовой, чтобы вы могли быстро путешествовать в темноте!",
            "pillaroflight-description":"Просто хороший источник яркого света, чтобы рабы-насекомые могли продолжать работать в темноте.",
            "crudeextract-description": "Этот прекрасный и благородный бот \"вытянет\" сырое масло своим удлиненным золотым шлангом и вернет его на базу для переработки.",
            "brewmasterden-description":"Для Рептилий, Мастер Пивоваров - один из самых высоких членов общества и один из единственных классов, которые все еще выполняют ручной труд, производя знаменитый галактический Драконианский Ром из Воды, Гелия 3 и Нефти. Это сильные вещи",
            "councilarb-description":   "Рептилийская структура местного управления, где три арбитра встречаются, чтобы навязать правила остальной части колонии.",
            "realnews-description":     "Держите своих субъектов «в курсе» и генерируйте Civics с помощью прямой трансляции 24-часовой трансляции Reptilian News Network. Настоящие новости для настоящих рептилий. Абонентская плата применяется.",
            "relicstudies-description": "Во вселенной есть странные Реликвии Чужих. Проведите исследование на них и посмотрите, что они делают. Использует роботов при создании исследований, артефактов и алюминия во время работы.",
            "general-deportations":     "Депортация",
            "gen-deportations-desc":    "Снова сделайте #cityname отличным, отправив свои проблемы куда-нибудь еще. Просмотрите варианты депортации нежелательных иностранцев или даже граждан.",
            "adultdaycare-description": "Дневной уход для взрослых - отличное средство для колонистов с чрезвычайно низким IQ. Со временем даже самый способный ученик может подняться до полуфункционального уровня интеллекта.",
            "basiced-desc":             "Изучите основы, чтобы научить их своим колонистам!",
            "smschool-description":     "Отличная маленькая школа, где вы можете познакомить своих граждан с основами чтения, письма и арифметики.",
            "smschool2-description":    "Большая лучшая школа для обучения большему и лучшему. Дадут вашим людям навыки, необходимые для продвижения вперед в рабочей силе.",
            "smschool3-description":    "Лучшие из базовых образовательных структур. Будем обучать и готовить своих людей к продвинутым техническим работам.",
            "deport-homeless":          "Депортировать бездомных",
            "deport-homeless-desc":     "Есть проблема бездомности? Избавьтесь от этого, выбив их всех из #cityname.",
            "deportation-warning":      "Депортации могут повлиять на рейтинг одобрения.",
            "deport-poor":              "Депортировать бедных",
            "deport-poor-desc":         "Выслать всех граждан, у которых меньше половины среднего уровня сбережений.",
            "deport-arbitrary":         "Депортировать произвольно",
            "deport-arbitrary-desc":    "Удалите произвольное количество граждан из #cityname на основе случайной лотереи.",
            "deport-arbitrary-ask":     "Сколько граждан вы хотели бы выслать сегодня?",
            "bld-update-freq":          "Частота обновления симуляции",
            "bld-update-freq-desc":     "Как часто движок обновляет статистику симуляции. Более частые обновления повышают точность симуляции за счет производительности.",
            "bld-update-freq-def":      "По умолчанию",
            "bld-update-freq-def-desc": "Скорость симуляции по умолчанию.",
            "bld-update-freq-12":       "Производительность",
            "bld-update-freq-12-desc":  "Чуть менее частый цикл обновления для лучшей производительности.",
            "bld-update-freq-15":       "Не точно",
            "bld-update-freq-15-desc":  "Хорошая настройка для медленных устройств, за счет игровой точности.",
            "bld-update-freq-30":       "Редко",
            "bld-update-freq-30-desc":  "Наиболее производительная настройка. Может привести к вопиющим неточностям, но может понадобиться, если ваше устройство не справляется.",
            "bld-update-freq-5":        "Точность",
            "bld-update-freq-5-desc":   "Более точная, но, возможно, более медленная, скорость симуляции.",
            "bld-update-freq-1":        "совершенство",
            "bld-update-freq-1-desc":   "Максимально возможная скорость симуляции. Требует устройства очень высокого класса, особенно с большим населением.",
            "general-storage":          "Место хранения",
            "sweatshop4-description":   "Делайте тонны денег за счет своих людей, выкачивая тонны дешевой одежды на экспорт.",
            "techtransce-desc":         "Сделайте следующий качественный скачок в эволюции, объединив людей и Ай в ... супер-умных людей!",
            "transacademy-description": "В Трансцендентальной Академии ваше правительство прикрепляет микрочипы к мозгу колонистов и загружает всю необходимую информацию в их системы. Значительно повышает их IQ.",
            "ancientinc-description":   "Работая под видом пекарни с органическими капкейками, это сверхсекретное правительственное учреждение потребляет огромное количество энергии, артефактов, триантаниума и древних инструкций по созданию Реликвий Чужих. Также генерирует небольшое количество пищи, чтобы поддерживать внешний вид пекарни для публики.",
            "aspentree-description":    "Это более высокие деревья с более легкой корой и листьями. Обеспечьте такое же количество древесины, просто посмотрите по-другому.",
            "engine-short-numbers":     "Короткие номера",
            "engine-short-numbers-desc":"Сокращайте большие цифры в списке отображения ресурсов, чтобы уменьшить беспорядок в пользовательском интерфейсе.",
            "engine-storage-limits":    "Показать ограничения хранения",
            "engine-storage-limits-desc":"Показать или скрыть ограничения хранилища ресурсов в основном интерфейсе. Полезная информация, чтобы иметь, с первого взгляда, но занимает больше места.",
            "diamondsynth-description": "Используйте химический синтез и древесный уголь для создания синтетических алмазов! Они выглядят так реально, что она не сможет заметить разницу.",
            "unicomm-description":      "Универсальная товарная биржа открывает торговому доступу к рынкам со всей галактики. Кроме того, в настоящей манере рептилий, ваши профессиональные хакеры могут украсть ресурсы, не обнаруженные в далеких мирах.",
            "statue6-description":      "Статуя в честь великого адмирала Бьюфорда П. Тотса, лидера восстания ЛИС против зла Объединенной Земли.",
            "independencehall3-description":"Штаб-квартира Имперского Капитолия, открывающая больше торговли, больше политики и еще больше поглощающая Ром.",
            "obsidianfurnace-description":"Сверхгорячая камера для создания редкого обсидиана в процессе, который требует много энергии, гелия 3 и нескольких базовых минералов.",
            "largerres-description":    "Модернизированный жилой комплекс выше и вмещает больше людей. Не лучшие условия жизни, но это работает.",
            "keyboard-flip":            "Перевернуть активный объект",
            "object-options-clone-tip": "Начните строительство для другого объекта этого типа.",
            "general-clone":            "Построить другой",
            "cautionsign-description":  "Мощный, мигающий барьер, чтобы быть начеку и держать колонистов от опасности.",
            "gravcompress-description": "Это высокотехнологичное хранилище создает замкнутое гравитационное поле, позволяющее хранить огромное количество материалов в небольшом пространстве.",
            "online-switch-warning":    "Предупреждение: из-за различий в игровом процессе и балансировке между онлайн и оффлайн режимами, переключение вашей игры в онлайн режим приведет к потере всех ресурсов! Вы сохраните свои структуры и население, но каждый ваш ресурс будет сброшен на ноль. Это может вызвать кратковременный хаос в вашей колонии, когда вы боретесь за создание резервов. Вы уверены, что хотите перейти в онлайн-режим? Это не может быть отменено!",
            "galartsexpo-description":  "Рептилии известны во всей галактике тем, что имеют лучшие коллекции изобразительного искусства, в основном украденные у других цивилизаций. Люди будут посещать со всей вселенной, чтобы посмотреть коллекцию. Со временем сюда приезжают пьяные рептилийские художники, чтобы создавать свои собственные произведения.",
            "patriden-description":     "Лучшее жилье для одной семьи в культуре рептилий. Обеспечивает изысканное жилье для большой семьи рептилий высшего сословия.",
            "obeliskofplenty-description":"Столп общинного образа жизни. Поделитесь своими монетами с братьями и друзьями на Обелиске Изобилия.",
            "unholyobsidian-description":"Объедините силу Древних с силой Антауры, чтобы расплавить Антаниум и Золото в затвердевший и редкий Обсидиан!",
            "crystalbot-description":   "Этот маленький парень специализируется на работе с Synthetic Crystalline, редким элементом.",
            "darkpavementlit-description":"Похож на обычный Темный тротуар, за исключением прикрепленного света.",
            "solarroad-description":    "Это не самая дешевая Дорога, но она позволяет вам убить двух зайцев одним выстрелом, предоставляя путь и генерируя немного энергии.",
            "aliensolar-description":   "Это лучшее, что вы можете сделать с точки зрения производства солнечной энергии. Не самый мощный генератор, но не требует топлива.",
            "thewheel-desc":            "Трудно поверить, что Инсектоиды продвинулись так далеко в жизни, даже не зная Колеса. Когда вы откроете этот секрет, кто знает, что придумают ваши инсектоиды?",
            "ftltravel-desc":           "Раскройте секреты создания великих космических кораблей, которые могут путешествовать быстрее скорости света!",
            "wheelfactory-description": "Заставьте своих людей работать над созданием Колес, жизненно важной составляющей производства Rover!",
            "statue7-description":      "Эта прекрасная статуя празднует двухлетнюю годовщину освобождения My Colony!",
            "shipyard-description":     "Строительство двора для массивных звездолетов, способных путешествовать быстрее скорости света.",
            "starport-description":     "Любая колония со звездным портом становится главным игроком на галактической сцене. Размещать и содействовать межгалактическим путешествиям, торговле и звездному меркантилизму.",
            "taxcollection-description":"Всякий раз, когда ваше правительство говорит, что платит 10 000 долларов за молоток, не обманывайте себя. Это не сверхсекретные проекты, над которыми они работают. Они отдают дань своим повелителям-рептилиям, которые отправили их в офис, и деньги поступают в этот офис по сбору налогов.",
            "chiptransporter-description":"Нет, ваш компьютер не сломался. Рептилии просто использовали этот квантовый телепорт, чтобы заменить ваш микрочип старым кусочком швейцарского сыра. Гораздо проще, чем работать на заводе по производству чипов.",
            "general-trade-notifications":"Новостная лента",
            "wheellodge-description":   "Там, где собирается Гильдия колесных кораблей, чтобы производить высокотехнологичные колеса для поселения.",
            "constructionmech-description":"Mobile Construction Mech - это особый класс юнитов, который может развертываться в структуре, которая строит другие юниты. Он также может нести до 8 дополнительных единиц внутри живота для транспортировки.",
            "general-delete-all":       "Удалить все",
            "gen-delete-all-confirm":   "Вы уверены, что хотите удалить все? Это не может быть отменено!",
            "gen-delete-mod-q":         "Этот мод уже деактивирован. Вы хотите удалить его из игры?",
            "gen-dl-tex-mod":           "Скачать текстурные моды",
            "gen-dl-mod-desc":          "Просмотрите и загрузите моды текстур, которые другие пользователи отправили на сервер My Colony.",
            "hipsterlofts-description": "Хипстеры будут платить самый высокий доллар за модное жилье в центре города, но только в том случае, если это жилье придет в виде восстановленной заброшенной шинной фабрики начала 20-го века. Жители будут пить ром и создавать картины различного качества.",
            "crystallineenrichment-description": "Эта небольшая станция использует Гелий 3, чтобы использовать силу Кристаллического для создания чистого Урана.",
            "advmicroreactor-description": "Более мощный вариант микрореактора, обеспечивающий много энергии для поселения.",
            "diamondbot-description": "Базовый марсоход Insectoid, разработанный для работы со всеми вещами, связанными с Diamond",
            "unholydiamondspawner-description": "Эта нечестивая структура будет постоянно выплевывать добываемые и одинаково нечестивые Алмазы, которые сами будут медленно распространяться по карте.",
            "coloredtile-description":  "Добавьте всплеск цвета в колонию с этими декоративными плитками.",
            "hedgewall-description":    "Докажите своим людям, что вы любите природу, не пуская их в важные области.",
            "footpath-description":     "Ваши колонисты будут любить прогуляться по этой каменной тропинке.",
            "aagoldgen-description":    "Используйте силу древних, чтобы получить огромное количество золота!",
            "turboet-description":      "Супер заряженный Внеземной Строитель, стоит немного дороже, но строит строения в 40 раз быстрее.",
            "regzapper-description":    "Ударьте Руду большим количеством электричества, разбив его на Реголит.",
            "obsgen-description":       "Жарить руду и муравьиную пасту вместе, используя Crystalline, чтобы создать чистый обсидиан.",
            "multithreaded-pathfinding": "Многопоточный поиск пути",
            "multithreaded-pathfinding-desc": "На больших картах Multithreaded Pathfinding может улучшить скорость и производительность игры. Однако, в зависимости от вашего устройства, оно может снизить производительность из-за увеличения потребления оперативной памяти. Попробуйте обе настройки и посмотрите, какая из них лучше для вас.",
            "gen-sel-game-type":        "Выберите тип игры",
            "gen-single-city":          "Единый Город",
            "gen-single-city-desc":     "Начните новую игру в одном городе. Вы выбираете, какой размер карты вы хотите, и обилие стартовых ресурсов.",
            "gen-region-city":          "Область",
            "gen-region-city-desc":     "Начать новый регион. Регион состоит из множества небольших городов, построенных рядом друг с другом. Города региона имеют общий пул ресурсов, включая технологии, исследования, мощность и атмосферный уровень.",
            "new-region-info":          "Введите имя для вашего нового региона.",
            "transtri-description":     "Дело в том, что никто не знает, как работает это здание. У него нет рабочих, нет роботов, но Triantanium продолжает выходить из него.",
            "rawmatextract-description":"Используя большое количество электричества и технологии телепортации, убирайте каждую унцию сырья с земли, простираясь на несколько миль под этой структурой.",
            "plastfact3-description":   "Поверьте мне, никто не знал, как сделать пластик, как древние пришельцы.",
            "lawchamber-description":   "Основное место правительства для независимого рептилийского государства.",
            "dracemb-description":      "Простое, но функциональное иноземное посольство.",
            "clayden-description":      "Где ремесленник поттер проводит свои дни с его маленькой семьей, создавая прекрасную глиняную посуду.",
            "homelessshelter-description":"Те, кто говорит, что Рептилии не имеют сердца, никогда не посещали одну из этих прекрасных единиц общественного жилья. Обеспечьте своих людей высококачественным доступным жильем, дайте мир, достоинство и начальное образование тем, у кого их нет.",
            "crystallinedrill-description": "Используйте мощный кристаллический лазер, чтобы глубоко врезаться в землю, добывая воду для колонии, а также несколько других базовых элементов.",
            "bugsaw-description":       "Bug Saw похожа на автоматизированную мясную лавку Insectoid. Взламывает Инсектоиды высшего сорта на различные кусочки мяса для колонии и превращает оставшиеся части в Муравьиную Пасту. Также предоставляет немного развлечений для тех, кто хочет посмотреть веселье.",
            "gen-federation":           "федерация",
            "federation-desc":          "Создание, управление или выход из федерации многопользовательского альянса онлайн-колоний.",
            "fed-founding-msg":         "Галактический Император является верховным правителем галактики, но он посчитал целесообразным позволить Содружествам объединяться в альянсы или федерации, если они готовы купить у него чартер за соответствующую плату.",
            "gen-found-federation":     "Создать новую федерацию",
            "gen-streaming":            "Streaming",
            "gen-streaming-on":         "Прямая трансляция теперь включена. Вы будете транслировать прямую трансляцию своего игрового процесса на свой колониальный сайт на my-colony.com. Ваш внутриигровой чат-канал будет переключен на канал Stream. Потоковое использование данных и может повлиять на производительность.",
            "gdp-growth":               "Темпы роста ВВП",
            "found-fed-pick-name":      "Итак, вы хотите основать новую Федерацию. Я не могу винить тебя. Создание Федерации в моей колонии может быть веселым и полезным опытом. Выбор имени федерации является наиболее важным и важным шагом в этом процессе. Что ты хочешь назвать своим?",
            "join-federation":          "Вступить в федерацию",
            "join-federation-desc":     "Петиция присоединиться к существующей федерации. Текущие члены будут голосовать по вашей петиции, и если она будет одобрена, вы станете голосующим членом Федерации.",
            "atmosgen3-description":    "Когда вы готовы серьезно отнестись к своим потребностям в создании атмосферы, вам нужен генератор большой атмосферы.",
            "join-fed-confirm":         "Вы уверены, что хотите подать петицию о вступлении в эту федерацию?",
            "gen-balloting":            "Тайное голосование",
            "gen-balloting-desc":       "Как голосующий член Федерации, вы имеете право участвовать в голосовании. Вот текущие меры голосования, ожидающие вашего внимания.",
            "petropit-description":     "Производите сырую нефть, используя комбинацию нескольких различных элементов, включая муравьиную пасту, древесину, обсидиан, кристаллы и пищю.",
            "insctoil-desc":            "Раскройте секреты производства масла!",
            "bugnukes-desc":            "Используйте нечестивую мистическую силу, чтобы создать чистый уран!",
            "unholyuraniumgenerator-description":"Используйте Антауру, чтобы превратить Алюминий в Уран!",
            "chamberfathers-description":"Особая мощная управляющая камера. Позволяет осуществлять обширный контроль над колонией и открывает квантовую коммуникационную связь с «предками» рептилий.",
            "manual-civs-intro":        "Каждая цивилизация в My Colony предлагает различные структуры, технологические деревья, юниты и доступные стартовые миры. Каждый из них также предлагает свою уникальную историю, стиль игры и множество задач. Каждому весело играть по-своему, но предлагается начать с United Earth, поскольку он предлагает больший баланс и более легкие стартовые миры для начинающих.",
            "ue-extended-backstory":    "2051 год был печальным и опасным временем для народов Земли. Большинство развитых стран рухнули под тяжестью глобальной экономической депрессии, продолжавшейся несколько десятилетий, и когда великие города оказались под властью толпы и анархии. \n Под угрозой банкротства некогда гордая Организация Объединенных Наций и все ее активы были проданы с аукциона. небольшой, но влиятельной группе миллиардеров, которые быстро переименовали учреждение в объединенную Землю. Используя оружие, купленное на черном рынке или у правительственных распродаж, «Объединенная земля» начала аннексировать многие ранее независимые национальные государства мира, в конечном итоге перейдя к контролю над большей частью планеты. Генеральная Ассамблея была сформирована для того, чтобы дать народу Земли иллюзию демократии и с обещанием содействовать миру и стабильности на планете, хотя большая часть реальной власти была возложена на недавно созданную должность Президента Объединенной Земли. \n Под большим пальцем Президента «Единой Земли» и Генеральной Ассамблеи экономические условия несколько улучшились, но времена все еще были тяжелыми. Именно в этот период массовое число разочарованных граждан начало массово покидать Землю, предпочитая рисковать своими шансами в бесплодных пустынных мирах, а не страдать от тирании и застоя, в которые превратилась их родная планета.",
            "zolarg-extended-backstory":"На протяжении веков раса насекомых жили в мире и согласии на планете Боуленд. Поскольку общество, построенное в основном на разведении и выращивании сахара, у инсектоидов не было особого желания создавать войска или стремиться к звездам. \n \n Все изменилось, когда злая Альфа-драконовская империя вторглась в Боулэнд, поработила большую часть населения и покинула планету. бесплодная и необитаемая пустошь. \n \n Веках бедных инсектоидов заставляли рабский труд и отправляли по всей галактике, чтобы они стали рабами или военным кормом для альфа-драконианцев. \n \n Тогда однажды на планете Драконис 12, a храбрый молодой инсектоид по имени Золарг возглавил восстание рабов, которое в итоге смогло свергнуть драконовское планетарное правительство. Инсектоиды быстро уничтожили всех рептилий в мире, взяли под контроль планету и переименовали ее в Золарга Прайма. Zolarg был назван императором на всю жизнь народа Zolarg Prime, который стал новым родным миром расы насекомых. \n \n Золарг теперь путешествует по звездам, пытаясь освободить своих братьев из альфа-драконовских лагерей рабов. Обе цивилизации остаются запертыми в жестокой войне.",
            "lis-extended-backstory":   "Когда «Единая Земля» впервые утвердилась на других планетах и ​​создала колониальные правительства, жители Терра-Новы первыми устали платить огромные налоги США. Генеральная Ассамблея и так просто перестали отправлять платежи. Генеральная Ассамблея попыталась заставить их заплатить, сначала ударив по планете торговым эмбарго. Когда это не удалось, было введено полное иммиграционное эмбарго и блокада планеты. \n \nПосле месяцев эмбарго Терра Нова все еще отказывалась сдаваться, поэтому президент Объединенной Земли направил отряд космических десантников, чтобы занять столицу и вернуть город под контроль Земли. \n \nВ результате оккупации командир ополчения Терра-Нова, известный как адмирал Бьюфорд П. Тоц, привел жителей Терра-Новы в восстание против ЕС. Космические морские силы, вынуждающие морских пехотинцев эвакуироваться с планеты. Колониальный Конгресс Terra Nova затем направил официальную декларацию независимости Генеральной Ассамблее Объединенной Земли, и планета была переименована в Независимое Государство. \n \nВдохновленные действиями на Terra Nova и разочарованные чрезвычайным налогообложением, наложенным Объединенной Землей Генеральная Ассамблея, соседние системы начали следовать этому примеру, и вскоре родилась Лига независимых государств, свободный союз планет с общим договором об обороне против агрессии Объединенной Земли. \n \nНезависимость государств-членов ЛИС официально не была признана Генеральная Ассамблея Объединенной Земли, которая все еще считает, что планеты находятся в восстании.",
            "draconian-extended-backstory":"Альфа-драконианы, одна из древнейших выживших цивилизаций в галактике, считают себя наследниками Древних, загадочной старой цивилизации, которая когда-то охватывала большую часть известной галактики, следы которой можно найти в самых обитаемых планетах. \n \n Пока неизвестно, что случилось с Древними, основная часть их технологий действительно была унаследована альфа-драконианцами, что дало им грубое преимущество в конфликтах с соседними системами. Нигде это не ощущалось так остро, как среди расы инсектоидов, которая в значительной степени превратилась во вторичный рабский класс в растущей сфере влияния Альфа-Дракона. \n \nГде они не используют свое технологическое преимущество для завоевания, они используют его для контроля и эксплуатации. Многие правительства по всей галактике находятся под прямым контролем драконианцев, а «избранные» чиновники выступают в роли марионеток рептилий. Во многих мирах секторы банковского дела, развлечений, образования и СМИ контролируются альфа-драконовской пропагандистской машиной. \n \nРезультаты этого были как положительными, так и отрицательными. Альфа-драконовская элита стала чрезвычайно богатой от эксплуатации и рабского труда, но сочетание передовых технологий и бесплатного труда сделало большую часть населения бедной и нищей. Бунты и восстания являются обычным явлением среди драконианских колоний, и, как правило, после того, как планета была лишена своих ресурсов, альфа-драконианская элита собирает запасы и оставляет простых граждан позади, чтобы умереть. \n \nДругая угроза альфа-драконианцам исходит от растущие технические возможности и военная тактика нескольких оставшихся колоний инсектоидов в империи Золарг, которые становятся все более агрессивными в своем сопротивлении альфа-драконианцам.",
            "manual-controls-intro":    "My Colony предлагает несколько методов управления, в зависимости от типа и возможностей вашего устройства, а также вашего предпочтительного стиля игры. Хотя игра была разработана с учетом управления клавиатурой и мышью, она была адаптирована для поддержки наиболее распространенных настроек управления.",
            "manual-keyboard-intro":    "Оптимальной схемой управления My Colony является комбинация «Клавиатура и мышь / перо», так как игра спроектирована с учетом этого интерфейса в первую очередь. \n \nМышь или ручка управляют довольно интуитивно. Вы можете выбрать юниты и здания одним щелчком мыши. Вы можете нажать / удерживать, а затем перетащить мышь, чтобы выбрать все единицы в области. Двойной щелчок по единице выберет все единицы такого рода. Когда выбран юнит, щелчок правой кнопкой мыши выполнит действие, в зависимости от того, на что вы щелкнули правой кнопкой мыши, будь то заказ на сбор, заказ на перемещение или заказ на сборку. Карта прокручивается с помощью щелчка / перетаскивания, или в полноэкранном режиме вы также можете просто переместить курсор мыши к краю экрана, чтобы прокрутить окно просмотра. Колесо прокрутки мыши позволяет увеличивать и уменьшать масштаб. \n \nДвижок также поддерживает различные сочетания клавиш, которые можно настроить в меню «Настройки двигателя». Ниже приведена ссылка на доступные в настоящее время привязки клавиатуры:",
            "manual-touch-intro":       "My Colony предлагает полностью разработанный сенсорный интерфейс, который работает на любом устройстве с сенсорным вводом. Большинство действий касания по своей природе аналогичны вводу с помощью щелчка мышью, хотя есть и небольшие отличия. Увеличение и уменьшение масштаба выполняется стандартным жестом сжатия, обычным для сенсорных устройств, а прокрутка карты также выполняется обычным и интуитивно понятным способом.",
            "manual-gamepad-intro":     "В дополнение к клавиатуре и сенсорному, My Colony полностью играбелен с геймпадом. При использовании геймпада пользовательский интерфейс автоматически преобразуется в оптимизированный интерфейс «десять футов», что обеспечивает комфортный игровой процесс на телевизоре или другом устройстве с большим экраном. \n \nИнтерфейс геймпада был разработан на основе компоновки контроллера Xbox 360 / One, которая по сути стал стандартным макетом геймпада для многих контроллеров ПК и Android. Следующие элементы управления установлены с учетом этого макета, хотя названия кнопок могут различаться в зависимости от марки и стиля используемого вами геймпада:",
            "gen-local-mode":           "Локальная игра",
            "manual-local-mode":        "Для игры в локальную игру в My Colony не требуется учетная запись или подключение к Интернету. В локальном режиме вы начнете игру как подколония одной из базовых цивилизаций ИИ, и вам придется платить стандартные налоговые ставки до тех пор, пока вы не обретете независимость. ИИ не окажет вам никакой дополнительной помощи при создании вашей колонии. \n \nМестные игры могут играть в многопользовательский режим на основе LAN / Wifi с другими игроками локального режима в той же сети. Мультиплеер LAN / Wifi является кроссплатформенным и поддерживается на всех устройствах, за исключением случаев, когда он воспроизводится через веб-браузер (из соображений безопасности), если только не установлен и не активирован Ape Apps Desktop Bridge (часть Ape Apps Launcher). Игроки в локальной сети могут отправлять друг другу сообщения и торговые ресурсы. \n \nЕсли использовать пользовательскую карту или играть в творческом режиме, локальная игра может быть переведена в онлайн-режим, хотя это будет стоить колонии всех ее ресурсов. \n \nВ локальном режиме игры, встроенные в механизмы защиты от мошенничества, отключаются наполовину. Колония, уличенная в мошенничестве, не будет наказана во время игры в локальную игру, но игра не позволит этой колонии перейти в онлайн-режим.",
            "manual-online-mode":       "Игроки с действующей учетной записью Ape Apps и подключением к Интернету могут играть в My Colony в онлайн-режиме. Онлайн-игра в основном похожа на локальную игру, но есть несколько ключевых отличий. \n \nПервый запуск игры в онлайн-режиме поставит вашу колонию под контроль колонии других игроков. Игрок, контролирующий родительскую колонию, может изменить налоговую ставку выше или ниже или вообще не взимать налоги. Родительские колонии онлайн также обычно посылают своим дочерним колониям подарки ресурсов, чтобы помочь им начать.",
            "manual-online-commonwealth":"В онлайн-игре отношения между родительскими и детскими колониями известны как содружество. Как только онлайн-колония обретает независимость от своего родителя, она становится лидером нового содружества, и любая детская колония, которая присоединяется в соответствии с уставом родителя, становится государством-членом этого содружества. Игроки могут присоединиться к любому сообществу, которое они пожелают, используя чартерный код, который можно найти на экране статистики родительской колонии. Дополнительную информацию о чартерных кодах и списках лучших онлайн-сообществ можно найти по адресу https: //www.my-colony.com \n \n. Преимущества присоединения к любому конкретному сообществу будут широко варьироваться в зависимости от родительской колонии и игрока, который контролирует Это. Если вы заинтересованы в том, чтобы играть в онлайн и находить хорошее активное содружество, рекомендуем вам посетить раздел Содружество на форумах My Colony.",
            "manual-online-fererations":"Федерации являются следующей онлайн-структурой, которая превосходит Содружества, и являются структурированными формальными альянсами независимых государств. Функция Федерации находится в зачаточном состоянии и все еще находится в стадии разработки.",
            "manual-online-embassy":    "Независимые лидеры стран Содружества могут обратиться с просьбой об учреждении посольства в других независимых колониях при условии, что они знают кодекс другой колонии. Если запрос посольства принят, то в колонии других игроков может быть построено новое здание посольства для вашей колонии. Посольства допускают многопользовательские дипломатические действия, включая обмен сообщениями, обмен ресурсами, предоставление помощи и другие.",
            "manual-online-trade-hdr":  "Торговля ресурсами",
            "manual-online-trade-desc": "Онлайн-игры также имеют доступ к галактической бирже ресурсов, онлайн-рынку для покупки и продажи внутриигровых ресурсов. Большинство игроков называют это названием здания United Earth, которое открывает его, - Торговый совет Galatic. \n \nПри игре в Интернете текущие ресурсы онлайн-рынка оказывают большое влияние на каждую онлайн-колонию, так как все местные цены определяются текущей глобальной рыночной стоимостью. В зависимости от баланса производства ресурсов какой-либо конкретной колонии колебания цен на мировом рынке могут иметь самые разные последствия - от размера и мощи вашей экономики до счастья (или готовности продолжать работать) отдельных колонистов.",
            "manual-creative-mode":     "Творческий режим существует для игроков, которые просто хотят отдыхать и строить. При игре в творческом режиме все структуры в игре разблокированы и могут быть построены без каких-либо технологических или ресурсных требований. По понятным причинам игры в творческом режиме нельзя переключить в онлайн-режим.",
            "manual-single-city":       "Независимо от того, запускаете ли вы игру в локальном, онлайн или творческом режиме, вы можете выбирать между отдельным городом и региональной игрой. \n \nВ одной игре с городским освещением весь ваш город содержится в одной карте и одном файле. После запуска игры вы можете выбрать размер карты, на которой хотите играть, а также количество стартовых ресурсов на этой карте. Позже в игре, когда ваш правительственный уровень увеличивается, вы можете увеличить размер своей карты, аннексируя новые земли. Недостатком этого является то, что производительность игры снижается с увеличением размера вашей карты, особенно на медленных устройствах. По этой причине был создан режим Region.",
            "manual-regions":           "Региональный режим был добавлен в игру из-за проблем с производительностью, связанных с постоянно расширяющимися картами одного города. Регион ограничивает размеры карты на малом или среднем уровне, а возможность расширения карт с помощью функции аннексии была удалена. Компромисс к этому ограничению заключается в том, что один регион может содержать в общей сложности до 2500 отдельных файлов карт, теоретически позволяя создавать огромные колонии. \n \nРегионы работают, разбивая город на более мелкие куски, причем каждый кусок обрабатывается отдельно , но разделяя общий ресурсный и технологический пул. Эта настройка значительно повышает производительность сверхбольших городов и позволяет строить города на специализированных кусках. Статистика по экономике и населению доступна как для отдельных городов, так и для региона в целом, но для целей онлайн-отчетности используется статистика по всему региону.",
            "gen-map-types":            "Типы Планет",
            "manual-map-types":         "Тип мира, в котором вы решите играть, будет сильно влиять на ваш стиль игры и сложность игры. Внимательно изучите детали каждого типа карт перед началом новой колонии.",
            "gen-races":                "Гонки",
            "manual-races-desc":        "В моей колонии есть несколько основных видов, каждый с отличительными стартовыми бонусами. Выбранная вами цивилизация определит виды ваших первоначальных колонистов, но как только ваш город увеличится в размерах и достигнет, другие виды со всей галактики вполне могут присоединиться к вашей колонии.",
            "manual-play-modes-desc":   "Есть несколько способов играть в My Colony, предлагая разнообразие и бесчисленное количество часов игрового времени. Вы можете играть онлайн, офлайн, творчески, с пользовательской картой, с одним городом или в большом региональном ландшафте. Игра позволяет сохранять множество файлов, поэтому вы можете попробовать все стили, чтобы увидеть, какой вам больше нравится!",
            "manual-res-desc":          "Управление ресурсами является огромным ключевым компонентом My Colony, и правильная обработка притока, оттока и хранения ресурсов имеет жизненно важное значение, если вы хотите, чтобы ваш город рос и процветал. Ресурсы позволяют вам построить свою колонию, увеличить численность населения и исследовать новые технологии.",
            "manual-tech-header":       "Исследования и открытия технологий позволяют разблокировать новые здания и транспортные средства, открывая, таким образом, новые способы развития вашей колонии. \n \nТехническая иерархия в моей колонии не является линейной. Например, если вы пытались нарисовать дерево технологий структурированным программным способом (например, для данного руководства), это было бы невозможно или практически невозможно, поскольку каждая новая технология зависит от технологий не только нескольких разных ветвей в дерево, но также и на ресурсах, которые могут быть или не быть разблокированы игроком в любой момент времени. Поэтому, чтобы быть легко читаемым, любое дерево визуальных технологий должно было быть создано вручную и обновлено вручную. Такие технологические деревья существуют на онлайн-справочном веб-сайте My Colony здесь: https://www.my-colony.com/reference/\n\n. В целях данного руководства все технологии перечислены здесь в алфавитном порядке для упрощения поиска и ознакомления. вместе с описанием каждого, их требованиями и тем, что они могут разблокировать.",
            "manual-buildings-desc":    "В My Colony доступно много зданий, всего #gamebuildingcount. По этой причине размещение их в любом порядке, отличном от алфавитного, в этом руководстве сделает поиск и ссылки чрезвычайно сложными. \n \nИнтернет-ссылка «Моя колония» по адресу https://www.my-colony.com/reference/ содержит интерактивные таблицы поиска. для всех структур в игре, включая технологические требования, затраты и производственную стоимость.",
            "enc-print-status":         "Предупреждение - около 200 страниц.",
            "manual-vehicles-desc":     "Транспортные средства (или единицы) являются основными рабочими лошадками в моей колонии. Они позволяют вам строить структуры и собирать жизненно важные ресурсы. В игре есть много разных юнитов, которые вы можете создавать и управлять ими. Здесь они перечислены в алфавитном порядке для вашей справки.",
            "manual-terms-header":      "Словарь терминов",
            "manual-terms-desc":        "В этом руководстве и в самой игре есть несколько терминов, с которыми вы должны ознакомиться, чтобы полностью понять, что происходит.",
            "manual-concepts-header":   "Концепции геймплея",
            "manual-concepts-desc":     "В этом разделе описываются некоторые основные концепции игрового процесса в My Colony, в том числе как настроить свою первую колонию и как выполнить некоторые из основных задач в игре.",
            "waterworld-base-tech":     "Базовая стартовая технология для карты Водного Мира.",
            "water-world-desc":         "Планета, покрытая океаном, с разбросанными островками. Вначале вы будете микроуправлять древесиной, чтобы выжить.",
            "bridge1-description":      "Когда вам просто нужно пересечь воду, вам нужен этот маленький деревянный мост. Доступно в восточной / западной или северной / южной ориентациях. Должен быть построен над водой.",
            "goldreducer-description":  "В те странные времена, когда золота много, руда редка. Использует старую технику насекомых, чтобы медленно разбивать золото в руду, медленно сжигая сахар.",
            "embridge-description":     "Этот высокотехнологичный мост поможет вам перемещать граждан и рабов по воде или лаве.",
            "sandpath-description":     "Когда у вас много песка, вы можете сделать из него путь.",
            "fisherbot-description":    "Как правило, когда вам нужно что-то сделать в колонии, этот бот всегда ловит рыбу.",
            "fisherbothut-description": "Это аккуратное маленькое здание может строить и управлять ботами-рыболовами, отправляя их собирать рыбу и перерабатывая эту рыбу в пищу для колонии в виде восхитительных рыбных палочек.",
            "steelbridge-description":  "Сильнее деревянного моста, что позволяет быстрее путешествовать и даже может быть построено над лавой.",
            "alumbridge-description":   "Гладкая алюминиевая поверхность на этом мосту позволяет быстрее путешествовать.",
            "goldbridge-description":   "Ваши подданные будут знать, что вы стоите за безвкусный избыток, когда они путешествуют по этому прекрасному золотому мосту.",
            "fisherbug-description":    "Научите жука ловить рыбу ... и он пойдет на берег и заберет рыбу, положит ее в рот, принесет обратно в курган и извергнет в пищу и сахар. Ням.",
            "pastepontoon-description": "Примитивный плавучий мостик, состоящий из необработанных бревен, скрепленных муравьиной пастой",
            "usedminer-description":    "Этот старый рудник, купленный в секонд-хенд или собранный в разных магазинах, не так хорош, как новенький, но в нем все еще остается немного жизни.",
            "shipbuilding-desc":        "Из-за интенсивного использования Звездных Врат требуются исследования для проектирования и производства Звездных Кораблей, которые необходимы для того, чтобы отправиться туда, где еще нет Звездных Ворот.",
            "shipworks-description":    "Завод по производству Draconian Sloop, класса звездолетов, известных по всей галактике.",
            "hereditaryrule-desc":      "Рептилии любят, когда ими руководит сильный человек, поэтому создайте новую монархию в этом мире и дайте людям то, что они хотят!",
            "chamberofkings-description":"С этой окончательной драконианской управляющей структурой, высота вашей власти будет соответствовать только высоте этого здания.",
            "general-trade-too-cheap":  "Галактическое Торговое Управление не принимает цены лотов ниже #minlotprice за 100.",
            "general-trade-too-expensive":"Торговое управление Галактики не принимает цены лотов сверх #maxlotprice за 100.",
            "norm-res-desc":            "Обычная карта с ресурсами, которые вы можете собирать и получать прибыль.",
            "blank-res-desc":           "Плоская пустая карта без ресурсов вообще. Вероятно, не лучший выбор для вашего первого города.",
            "bugships-desc":            "Узнайте, как построить Ruimteschip, несколько примитивный, но все еще способный звездолет.",
            "scheepswerf-description":  "Scheepswerf позволяет производить Ruimteschip, базовый корабль без излишеств, который выполняет свою работу."
        }
    };
})(window, document);
